!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.0D]
!                     NEB works with PAW
!
! =============================================================

subroutine do_neb()
  use m_Files,                only : nfneb
  use m_Const_Parameters, only : OFF,ON
  use m_IterationNumbers, only : iteration,iteration_electronic,iteration_ionic
  use m_Replica
  use m_Parallelization, only : mpi_comm_group, mype

! ======================== KT_add ================= 13.0D
  use m_Files,         only :  m_Files_open_nfcntn_bin_paw, nfout, nfcntn_bin_paw
  use m_PseudoPotential,  only : flg_paw, m_PP_rd_PAW_parameters
  use m_Charge_Density,    only :  m_CD_alloc_chgsoft
! ================================================= 13.0D

  use m_Control_Parameters, only : sw_fcp
  use m_Fcp, only :  m_Fcp_set_neb_replica_totch, &
     m_Fcp_set_neb_replica_force, m_Fcp_update_neb, m_Fcp_set_neb_parameter, &
     m_Fcp_allreduce_neb_force, m_Fcp_initialize_neb_totch

  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Positron_bulk
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Ending_Time2, Force_errors_are_tolerable
  logical  :: replica_converged

  integer i, j, itr
  integer mpi_err
  logical all_conv_flag

  integer prepare_communicator
  logical :: pp_generated

  include 'mpif.h'

  call initialize_neb

  !call Initialization(OFF)
  !call InputData_Analysis(OFF) ! rd_cntn_data = ON

  call set_neb_condition
  call create_replica

  itr = 0
  all_conv_flag = all(neb%image(:)%scf_convergence)  ! for restart
  prepare_communicator = ON
  pp_generated=.false.

  NEBIteration: do

     itr = itr + 1
     if(all(neb%image(:)%scf_convergence)) then
        neb%step = neb%step + 1
     end if
     call set_neb_parameter(itr)
     if( sw_fcp == ON ) call m_Fcp_set_neb_parameter(itr)

     MultiReplica: do i = 1, neb%number_of_images

        if(mod(i-1,nrank_r) /= mype_r) then
           neb%image(i)%scf_convergence = .true. 
           cycle
        end if

        if(neb%cond%condition == 1) then
           if(itr == 1 .and. (.not. all_conv_flag)) then
              if(neb%image(i)%scf_convergence) then
                 !neb%image(i)%energy = neb%image(i)%energy0
                 !neb%image(i)%force = neb%image(i)%force0
                 !neb%image(i)%force_org = neb%image(i)%force0
                 cycle
              end if
           end if
        end if

        if(itr > 1 .and. (i==1 .or. i==neb%number_of_images)) then
           neb%image(i)%energy = neb%image(i)%energy0
           neb%image(i)%force = neb%image(i)%force0
           neb%image(i)%force_org = neb%image(i)%force0
           cycle
        end if

!        write(nfneb,*) 'neb: ', neb%step, i, mype
        if (mype==0) write(nfneb,*) 'neb: ', neb%step, i

        call set_neb_replica_parameter(i)
        call set_neb_replica_coordinate(i)

        if(.not.neb%image(i)%scf_convergence) then
           call InputData_Analysis_neb()
        end if

        call Preparation                   ! Basis set, symmetry check etc.
        call Preparation_for_mpi(prepare_communicator)           ! mpi

! ======================== KT_mod ================= 13.0D
!        if (.not.pp_generated) then
!          call PseudoPotential_Construction
!          pp_generated = .true.
!        endif

        if (.not.pp_generated) then
           call PseudoPotential_Construction
           pp_generated = .true.
#ifdef ENABLE_ESM_PACK
           call Preparation_for_ESM()
#endif
        else
           if ( flg_paw ) then
              if ( itr > 1 .or. neb%cond%condition == 1 ) then
                 call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
              endif
              call m_CD_alloc_chgsoft
           endif
        endif
! ================================================= 13.0D

        call Ewald_and_Structure_Factor
        call Initial_Electronic_Structure
        call Initial_MD_Condition

        if( sw_fcp == ON ) then
           call m_Fcp_initialize_neb_totch()
           call m_Fcp_set_neb_replica_totch(i)
        end if

        if(neb%cond%condition == 1 .and. neb%image(i)%scf_convergence) then 
           iteration = 0
           iteration_electronic = 0
           iteration_ionic = 0
        end if
        neb%image(i)%scf_convergence = .true.

        if(.not.Already_Converged()) then
           AtomicConfiguration: do
              ChargeDensity:    do
                 call IterationNumber_Setting
                 call Renewal_of_WaveFunctions
                 call ChargeDensity_Construction(1)
                 call ChargeDensity_Mixing
                 call Renewal_of_Potential
                 if(Hubbard_model()) then
                    call Renewal_of_Hubbard_Potential
                 end if
!                 if(Ending_Time())                 exit ChargeDensity
                 if(Ending_Time()) then
                    neb%image(i)%scf_convergence = .false.
                    exit AtomicConfiguration
                 end if
                 if(TotalEnergy_is_Divergent())    exit ChargeDensity                    
                 if(ChargeDensity_is_Converged())  exit ChargeDensity
              enddo ChargeDensity
              call Forces
!              if(Forces_are_Converged()) exit AtomicConfiguration
              exit AtomicConfiguration
!!$              if(Force_errors_are_tolerable()) then
!!$                 call Move_Ions
!!$                 call Ewald_and_Structure_Factor
!!$                 call MDIterationNumber_Setting
!!$              end if

           enddo AtomicConfiguration

        end if

!        if(.not.Ending_Time2()) call set_neb_replica_energy_force(i)
        call set_neb_replica_energy_force(i)
        if( sw_fcp == ON ) call m_Fcp_set_neb_replica_force(i)

!!$        if(Positron_bulk()) then
!!$           call Renewal_of_pPotential()
!!$           call Solve_pWaveFunctions()
!!$        end if

!!$        call Postprocessing
        call WriteDownData_onto_Files(.true.)

        call deallocate_array

        if (mype==0) write(nfneb,*) 'scf convergence: ', i, neb%image(i)%scf_convergence

!!        prepare_communicator=OFF
        first_replica_done = .true.
     end do MultiReplica

     call allreduce_scf_convergence
     call allreduce_neb_energy_force
     if( sw_fcp == ON ) call m_Fcp_allreduce_neb_force(nrank_r)

     if(.not. all(neb%image(:)%scf_convergence)) then
        if( mype==0) write(nfneb,*) 'scf not convergence...'
        exit NEBIteration
     end if

!     call allreduce_neb_energy_force

     call force_neb
     call atom_update_neb
     if( sw_fcp == ON ) call m_Fcp_update_neb(neb%dt, neb%cond%time_integral)
!     call atom_update_pos_neb

     if(replica_converged()) then
        exit NEBIteration
     end if
     if(neb%step >= neb%max_iteration) then
        exit NEBIteration
     end if
        
  end do NEBIteration

  call write_down_data_replica

  call finalize_neb()
  call mpi_finalize(mpi_err)
end subroutine do_neb

!   Nudged Elastic Band Method
!   Nobutaka Nishikawa

subroutine initialize_neb

  use m_Parallelization,      only : mpi_comm_group, nrank_e, nrank_k, nrank_conf, mype_conf
  use m_Files,                only : nfneb, F_NEB_OUT
  use m_Replica

  implicit none
  integer i, j
  integer npes,mype,icolor,ikey,mpi_err
  integer, allocatable ::  new_comm_world(:)
!  integer nrank_r, mype_r
  integer mype_e, npes_e
  integer iargc
  character(100) arg
  character(4) image_name

  include 'mpif.h'

  nrank_r = nrank_conf
  mype_r  = mype_conf
  neb%step = 0

!  write(6,*) 'program start...'
!  write(6,*)
!
!  call mpi_init(mpi_err)
!
!  call mpi_comm_size(mpi_comm_world,npes,mpi_err)
!!  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)
!
!  nrank_r = 0
!  if(mype==0) then
!     do i = 1, iargc()
!        call getarg(i,arg)
!        if( arg(1:3) == 'nr=' ) then
!           read(arg(4:),*) nrank_r
!        end if
!     end do
!  end if
!  if(nrank_r == 0) nrank_r = npes
!  call mpi_bcast(nrank_r,1,mpi_integer,0,mpi_comm_world,mpi_err)
!
!  allocate(new_comm_world(0:nrank_r-1))
!  do i=0,nrank_r-1
!     icolor = 0
!     ikey = 0
!     do j=0, npes/nrank_r-1
!        if(mype == j + (npes/nrank_r)*i ) then
!           icolor = 1
!           ikey = i
!        end if
!     end do
!     call mpi_comm_split( mpi_comm_world, icolor, ikey, new_comm_world(i), mpi_err )
!  end do
!
!  mype_r = mype/(npes/nrank_r)
!  mpi_comm_group = new_comm_world(mype_r)
!
!  call mpi_comm_size(mpi_comm_group,npes_e,mpi_err)
!  call mpi_comm_rank(mpi_comm_group,mype_e,mpi_err)
!
!  write(6,'("mpi: pe=",i4,",  npes=",i4,",  comm=",i20)') mype, npes, mpi_comm_world
!  write(6,'("   neb: ",i4,",  nr=",i4,"    energy: ",i4,",  ne*nk=",i4,",  comm=",i20)') &
!       mype_r, nrank_r, mype_e, npes_e, mpi_comm_group
!  write(6,*)
!
!  neb%step = 0

end subroutine initialize_neb

subroutine initialize_neb_ep

  use m_Parallelization,      only : mpi_comm_group
  use m_Files,                only : nfneb, F_NEB_OUT
  use m_Replica

  implicit none

  integer mype, npes, mpi_err

  include 'mpif.h'

  call mpi_init(mpi_err)

  call mpi_comm_size(mpi_comm_world,npes,mpi_err)
  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)

  mpi_comm_group = mpi_comm_world

  neb%step = 0

  write(6,'(a6,4i5)') ' mpi: ', mype, npes, mpi_comm_world, mpi_comm_group

end subroutine initialize_neb_ep

subroutine set_neb_condition

  use m_Control_Parameters, only : icond, multiple_replica_max_iteration
  use m_Ionic_System,  only : neb_max_iteration, neb_dt, ci_neb &
                            , sp_k_init, sp_k_min, sp_k_max, sp_k_variable &
                            , penalty_function &
                            , neb_convergence_condition, neb_convergence_threshold &
                            , neb_time_integral
  use m_Files,         only : F_OUT, F_DYNM, F_ENF, F_CHGT, F_CNTN, F_CNTN_BIN &
                            , F_ZAJ, F_CHR, nfneb, F_NEB_OUT &
                            , nfnebenf, F_NEB_ENF, nfnebdynm, F_NEB_DYNM &
                            , nfdynm, nfenf, nfout
  use m_Parallelization,      only : mpi_comm_group
  use m_Replica

! ======================== KT_add ================= 13.0D
  use m_PseudoPotential,  only : flg_paw
  use m_Files,         only : F_CNTN_BIN_PAW
! ================================================= 13.0D

! ====== KT_add === 2014/07/20
  use m_Control_parameters, only : ipriparadeb, reuse_nfout_for_nfneb
  use m_Files,         only : F_OUT_BASE, F_CONF_EXTENSION, F_Para_EXTENSION
! ================= 2014/07/20

  implicit none

  integer mype, npes, mpi_err
  integer mype_e, npes_e
  character(4) image_name

  logical :: existence

  include 'mpif.h'

  call mpi_comm_size(mpi_comm_world,npes,mpi_err)
  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)
  call mpi_comm_size(mpi_comm_group,npes_e,mpi_err)
  call mpi_comm_rank(mpi_comm_group,mype_e,mpi_err)

! ====== KT_add ======== 2014/07/20
  if ( mype_e == 0 ) then
     close(nfout)
  else if(ipriparadeb == 0) then
     close(nfout, status='delete')
  else
     close(nfout, status='keep')
  end if
! ===================== 2014/07/20

! === KT_mod ========== 2014/07/20
#ifdef NEB_NEW_FILENAMES
  if ( reuse_nfout_for_nfneb == 1 ) then
     neb%file%F_NEB_OUT = trim(F_OUT_BASE) // trim(adjustl(F_CONF_EXTENSION)) &
          &                                // trim(adjustl(F_PARA_EXTENSION))
     if (mype_e==0) then
        open(nfneb,file=neb%file%F_NEB_OUT,status='unknown',position='append')
     endif
  else
!     neb%file%F_NEB_OUT = trim(F_NEB_OUT) // trim(adjustl(F_CONF_EXTENSION)) &
!          &                               // trim(adjustl(F_PARA_EXTENSION))
     neb%file%F_NEB_OUT = trim(F_OUT_BASE) // '_neb' &
          &                                // trim(adjustl(F_CONF_EXTENSION)) &
          &                                // trim(adjustl(F_PARA_EXTENSION))
     if (mype_e==0) open(nfneb,file=neb%file%F_NEB_OUT)
  endif
#else
  if(npes > 1) then
     write(image_name,'(a1,i3.3)') 'p', mype
     neb%file%F_NEB_OUT = trim(F_NEB_OUT)//'_'//image_name
  else
     neb%file%F_NEB_OUT = trim(F_NEB_OUT)
  end if
  open(nfneb,file=neb%file%F_NEB_OUT)
#endif
! ===================== 2014/07/20

  !write(nfneb,'(a6,4i5)') ' mpi: ', mype, npes, mpi_comm_world, mpi_comm_group
  !write(nfneb,'(a6,8i8)') ' mpi: ', mype, npes, mpi_comm_world, &
  !     mype_r, nrank_r, &
  !     mype_e, npes_e, mpi_comm_group

  neb%cond%condition = icond
  if (mype_e==0) write(nfneb,*) 'neb_condition: ', neb%cond%condition

  !neb%max_iteration = neb_max_iteration
  neb%max_iteration = multiple_replica_max_iteration
  if (mype_e==0) write(nfneb,*) 'max_iteration: ', neb%max_iteration

  neb%dt = neb_dt
  if (mype_e==0) write(nfneb,*) 'dt: ', neb%dt

  neb%cond%k_spring_init = sp_k_init
  neb%cond%k_spring_min = sp_k_min
  neb%cond%k_spring_max = sp_k_max
  if (mype_e==0) write(nfneb,'(a11,3f10.5)') 'k_spring: ', &
       neb%cond%k_spring_init,neb%cond%k_spring_min,neb%cond%k_spring_max

  select case(sp_k_variable)
  case(0)
     neb%cond%k_variable = .false.
  case(1)
     neb%cond%k_variable = .true.
  end select
  if (mype_e==0) write(nfneb,*) 'sp_k_variable: ', neb%cond%k_variable

  select case(ci_neb)
  case(0)
     neb%cond%climbing_image = .false.
  case(1)
     neb%cond%climbing_image = .true.
  end select
  if (mype_e==0) write(nfneb,*) 'ci_neb: ', neb%cond%climbing_image

  neb%cond%ci_neb_start = 0
  neb%cond%ci_neb_end = 0

  select case(penalty_function)
  case(0)
     neb%cond%penalty_function = .false.
  case(1)
     neb%cond%penalty_function = .true.
  end select
  if (mype_e==0) write(nfneb,*) 'penalty_function: ', neb%cond%penalty_function

  neb%cond%k_damping = .false.
  neb%cond%k_damping_factor = 1.0d0

  neb%cond%convergence_condition = neb_convergence_condition
  if (mype_e==0) write(nfneb,*) 'convergence_condition: ', neb%cond%convergence_condition
  neb%cond%convergence_threshold = neb_convergence_threshold
  if (mype_e==0) write(nfneb,*) 'convergence_threshold: ', neb%cond%convergence_threshold
  
  !neb%cond%time_integral = 'verlet'
  !neb%cond%time_integral = 'velocity_verlet'
  neb%cond%time_integral = 'steepest_descent'
  select case(neb_time_integral)
  case(2)
     neb%cond%time_integral = 'velocity_verlet'
  case(12)
     neb%cond%time_integral = 'steepest_descent'
  end select
  if (mype_e==0) write(nfneb,*) 'time_integral: ', neb%cond%time_integral

  neb%file%F_OUT = F_OUT
  !neb%file%F_DYNM = F_DYNM
  !neb%file%F_ENF = F_ENF
  neb%file%F_CHGT = F_CHGT
  neb%file%F_CNTN = F_CNTN
  neb%file%F_CNTN_BIN = F_CNTN_BIN
  neb%file%F_ZAJ = F_ZAJ
  neb%file%F_CHR = F_CHR

! ======================== KT_add ================= 13.0D
  neb%file%F_CNTN_BIN_PAW = F_CNTN_BIN_PAW
! ================================================= 13.0D

  if (mype_e==0) then
     write(nfneb,*) 'F_OUT: ', trim(neb%file%F_OUT)
  !write(nfneb,*) 'F_DYNM: ', trim(neb%file%F_DYNM)
  !write(nfneb,*) 'F_ENF: ', trim(neb%file%F_ENF)
     write(nfneb,*) 'F_CHGT: ', trim(neb%file%F_CHGT)
     write(nfneb,*) 'F_CNTN: ', trim(neb%file%F_CNTN)
     write(nfneb,*) 'F_CNTN_BIN: ', trim(neb%file%F_CNTN_BIN)
     write(nfneb,*) 'F_ZAJ: ', trim(neb%file%F_ZAJ)
     write(nfneb,*) 'F_CHR: ', trim(neb%file%F_CHR)

! ======================== KT_add ================= 13.0D
     if ( flg_paw ) then
        write(nfneb,*) 'F_CNTN_BIN_PAW: ', trim(neb%file%F_CNTN_BIN_PAW)
     endif
! ================================================= 13.0D
  end if

  if(mype == 0) then
     if(neb%cond%condition==1)then
       open(nfnebenf, file=F_NEB_ENF,access='append')
       open(nfnebdynm, file=F_NEB_DYNM,access='append')
     else
       open(nfnebenf, file=F_NEB_ENF)
       open(nfnebdynm, file=F_NEB_DYNM)

       write(nfnebenf,*) '#step  image  image_distance  energy   force_org  force_neb  force_normal'
       write(nfnebdynm,*) '#step  image  atom  cps'
     endif

  end if

end subroutine set_neb_condition

subroutine set_neb_parameter(itr)

  use m_Replica
  use m_Files, only : nfneb

  implicit none
  integer, intent(in) :: itr
  integer i

  do i = 1, neb%number_of_images
     if(itr==1.and.neb%image(i)%scf_convergence.and.neb%cond%condition==1) cycle
     neb%image(i)%energy0 = neb%image(i)%energy
     neb%image(i)%energy = 0.0d0
     neb%image(i)%force0 = neb%image(i)%force
     neb%image(i)%force = 0.0d0
     neb%image(i)%force_org = 0.0d0
!     neb%image(i)%scf_convergence = .true.
  end do

end subroutine set_neb_parameter

subroutine set_neb_replica_parameter(image_id)

  use m_Control_parameters, only : icond, ipriparadeb
  use m_IterationNumbers, only : iteration,iteration_electronic,iteration_ionic
  use m_Replica
  use m_Files
  use m_Parallelization,  only : mype

! ======================== KT_add ================= 13.0D
  use m_PseudoPotential,  only : flg_paw
! ================================================= 13.0D

  implicit none

  integer image_id
  character(4) image_name

  character(100) :: F_OUT_NEW

  if( neb%step > 1 .and. icond == 0) then
     icond = 1
  end if

  write(image_name,'(a1,i3.3)') 'r', image_id
  
  F_OUT = trim(neb%file%F_OUT)//'_'//image_name

! ===== KT_add === 2014/07/20
#ifdef NEB_NEW_FILENAMES
!  F_OUT = trim(F_OUT_BASE)//'_'//image_name &
!       &              //trim(F_CONF_EXTENSION)//trim(F_PARA_EXTENSION)
  F_OUT = trim(adjustl(F_OUT_BASE)) // '_' //image_name &
       &                             // trim(adjustl(F_PARA_EXTENSION))
! ================ 2014/07/20
#endif

  !F_DYNM = trim(neb%file%F_DYNM)//'_'//image_name
  !F_ENF = trim(neb%file%F_ENF)//'_'//image_name
  F_CHGT = trim(neb%file%F_CHGT)//'_'//image_name
  F_CNTN = trim(neb%file%F_CNTN)//'_'//image_name
  F_CNTN_BIN = trim(neb%file%F_CNTN_BIN)//'_'//image_name
  F_ZAJ = trim(neb%file%F_ZAJ)//'_'//image_name
  F_CHR = trim(neb%file%F_CHR)//'_'//image_name

! ======================== KT_add ================= 13.0D
  F_CNTN_BIN_PAW = trim(neb%file%F_CNTN_BIN_PAW)//'_'//image_name
! ================================================= 13.0D

  F_ZAJ_in      = F_ZAJ
  F_CHGT_in     = F_CHGT
  F_CNTN_BIN_in = F_CNTN_BIN
  F_CNTN_in     = F_CNTN

! ======================== KT_add ================= 13.0D
  F_CNTN_BIN_PAW_in = F_CNTN_BIN_PAW
! ================================================= 13.0D

  if ( mype == 0 ) then
     write(nfneb,*) 'F_OUT: ', trim(F_OUT)
  !write(nfneb,*) 'F_DYNM: ', trim(F_DYNM)
  !write(nfneb,*) 'F_ENF: ', trim(F_ENF)
     write(nfneb,*) 'F_CHGT: ', trim(F_CHGT)
     write(nfneb,*) 'F_CNTN: ', trim(F_CNTN)
     write(nfneb,*) 'F_CNTN_BIN: ', trim(F_CNTN_BIN)
     write(nfneb,*) 'F_ZAJ: ', trim(F_ZAJ)
     write(nfneb,*) 'F_CHR: ', trim(F_CHR)
     
! ======================== KT_add ================= 13.0D
     if ( flg_paw ) write(nfneb,*) 'F_CNTN_BIN_PAW: ', trim(F_CNTN_BIN_PAW)
! ================================================= 13.0D
  endif

  if( neb%step == 1) then
     close(nfout)
     !close(nfdynm)
     !close(nfenf)
     open(nfout,file=trim(F_OUT))
     !open(nfdynm,file=trim(F_DYNM))
     !open(nfenf,file=trim(F_ENF))
  else
     close(nfout)
     !close(nfdynm)
     !close(nfenf)
     open(nfout,file=trim(F_OUT),position='append')
     !open(nfdynm,file=trim(F_DYNM),position='append')
     !open(nfenf,file=trim(F_ENF),position='append')
  end if

  close(nfcntn)
  close(nfcntn_bin)
  open(nfcntn,file=trim(F_CNTN))
  open(nfcntn_bin,file=trim(F_CNTN_BIN),form='unformatted')

! ======================== KT_add ================= 13.0D
  if ( flg_paw ) then
!     close(nfcntn_bin_paw)
!     open(nfcntn_bin_paw,file=trim(F_CNTN_BIN_PAW),form='unformatted')

     call m_Files_close_nfcntn_bin_paw()
     call m_Files_open_nfcntn_bin_paw()
  endif
! ================================================= 13.0D

  iteration = 0
  iteration_electronic = 0
  iteration_ionic = 0

end subroutine set_neb_replica_parameter

subroutine create_replica

  use m_Ionic_System,  only : number_of_replicas, natm &
                            , pos_end0, pos_end1, cps_end0, cps_end1 &
                            , replica_howtogive_coordinates, replica_endpoints &
                            , pos_image, cps_image &
                            , imdtyp
  use m_Files,         only : nfneb, nfnebcntn, F_NEB_CNTN
  use m_Const_Parameters,  only : FILE, PROPORTIONAL, ON
  use m_Replica
  use m_Parallelization,  only : mype
  use m_Control_Parameters, only : sw_fcp
  use m_Fcp,                only : m_Fcp_create_replica, m_Fcp_read_totch_replica

  implicit none

  integer i, j
  integer end0, end1
  character token

  neb%number_of_images = number_of_replicas + 2
  if (mype==0) write(nfneb,*) 'number_of_images: ', neb%number_of_images

  ! temporary
  allocate(neb%energy(neb%max_iteration,neb%number_of_images))  
  neb%energy = 0.0d0

  allocate(neb%image(neb%number_of_images))
  do i = 1, neb%number_of_images
     neb%image(i)%num_atom = natm

     neb%image(i)%energy = 0.0d0
     neb%image(i)%energy0 = 0.0d0

     allocate(neb%image(i)%pos(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%pos0(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%cps(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%cps0(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%tau(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%force(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%force0(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%force_org(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%spring_force(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%true_force(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%fix_flag(neb%image(i)%num_atom))
     allocate(neb%image(i)%velocity(neb%image(i)%num_atom,3))
     allocate(neb%image(i)%velocity0(neb%image(i)%num_atom,3))
     neb%image(i)%pos = 0.0d0
     neb%image(i)%pos0 = 0.0d0
     neb%image(i)%cps = 0.0d0
     neb%image(i)%cps0 = 0.0d0
     neb%image(i)%tau = 0.0d0
     neb%image(i)%force = 0.0d0
     neb%image(i)%force0 = 0.0d0
     neb%image(i)%force_org = 0.0d0
     neb%image(i)%spring_force = 0.0d0
     neb%image(i)%true_force = 0.0d0
     neb%image(i)%fix_flag = 0
     neb%image(i)%velocity = 0.0d0
     neb%image(i)%velocity0 = 0.0d0

     neb%image(i)%scf_convergence = .true.
  end do

  end0 = 1
  end1 = neb%number_of_images

  neb%image(end0)%pos = pos_end0
  neb%image(end0)%cps = cps_end0
  neb%image(end1)%pos = pos_end1
  neb%image(end1)%cps = cps_end1

  do i = 2, neb%number_of_images-1
     do j = 1, neb%image(i)%num_atom
        neb%image(i)%cps(j,:) = neb%image(end0)%cps(j,:) &
             + real(i-1) * (neb%image(end1)%cps(j,:) - neb%image(end0)%cps(j,:)) &
             / real(end1-end0)
        neb%image(i)%pos(j,:) = neb%image(end0)%pos(j,:) &
             + real(i-1) * (neb%image(end1)%pos(j,:) - neb%image(end0)%pos(j,:)) &
             / real(end1-end0)
     end do
  end do
        
  do i = 2, neb%number_of_images-1
     if(replica_howtogive_coordinates(i-1) == FILE) then
        neb%image(i)%pos = pos_image(i-1,:,:)
        neb%image(i)%cps = cps_image(i-1,:,:)
     end if
  end do

  neb%image(1)%fix_flag(:) = 0
  neb%image(neb%number_of_images)%fix_flag(:) = 0
  do i = 2, neb%number_of_images-1
        neb%image(i)%fix_flag(:) = imdtyp(:)
  end do
  imdtyp = 0

  if( sw_fcp == ON ) call m_Fcp_create_replica(neb%number_of_images)

  if(neb%cond%condition == 1) then
     if (mype==0) write(nfneb,*) 'read data replica...'

     open(nfnebcntn,file=F_NEB_CNTN)
     read(nfnebcntn,*) 
     read(nfnebcntn,*) neb%step
     read(nfnebcntn,*) 
     read(nfnebcntn,*) 

     do i = 1, neb%number_of_images
        read(nfnebcntn,*) 
        read(nfnebcntn,*)
        read(nfnebcntn,*) 
        read(nfnebcntn,*)
        read(nfnebcntn,*)
        do j = 1, neb%image(i)%num_atom
           read(nfnebcntn,*) neb%image(i)%pos(j,1:3)
        end do
        read(nfnebcntn,*) 
        do j = 1, neb%image(i)%num_atom
           read(nfnebcntn,*) neb%image(i)%cps(j,1:3)
        end do
        read(nfnebcntn,*) 
        read(nfnebcntn,*) neb%image(i)%energy
        read(nfnebcntn,*) 
        do j = 1, neb%image(i)%num_atom
           read(nfnebcntn,*) neb%image(i)%force_org(j,1:3)
        end do
        read(nfnebcntn,*) 
        read(nfnebcntn,*) token
        select case(token)
        case('0')
           if (mype==0) write(nfneb,*) 'image: ', i, '  scf not convegence'
           neb%image(i)%scf_convergence = .false.
        case('1')
           if (mype==0) write(nfneb,*) 'image: ', i, '  scf convegence'
           neb%image(i)%scf_convergence = .true.
        end select
        if( sw_fcp == ON ) call m_Fcp_read_totch_replica(i)
     end do

     close(nfnebcntn)
  end if

  if (mype==0) then
     write(nfneb,*) 'create replica...'
     do i = 1, neb%number_of_images
        write(nfneb,*) 'image: ', i, ' pos, cps'
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(6f10.5,i3)') neb%image(i)%pos(j,1:3), neb%image(i)%cps(j,1:3), &
                neb%image(i)%fix_flag(j)
        end do
     end do
  endif

  if(neb%cond%condition==0) call write_result(.false.)

end subroutine create_replica

subroutine set_neb_replica_coordinate(image_id)

  use m_Ionic_System, only : pos, cps
  use m_Replica

  implicit none
  integer image_id

  cps = neb%image(image_id)%cps
  pos = neb%image(image_id)%pos

end subroutine set_neb_replica_coordinate

subroutine allreduce_neb_energy_force

  use m_Replica
  use m_Parallelization,      only : mpi_comm_group

  implicit none

  integer i
  integer mype, npes, mpi_err
  real(8),allocatable :: work1(:)
  real(8),allocatable :: work2(:,:)

  include 'mpif.h'

  if (nrank_r.lt.1) return

!  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)
  call mpi_comm_size(mpi_comm_group,npes,mpi_err)

!  write(220+mype,'(i5,5e20.10)') mype, neb%image(:)%energy

  allocate(work1(neb%number_of_images));work1=0.d0
  call mpi_allreduce(neb%image(:)%energy,work1,neb%number_of_images, &
       mpi_double_precision,mpi_sum,mpi_comm_world,mpi_err)
  neb%image(:)%energy = work1
  deallocate(work1)
  do i=1, neb%number_of_images
    allocate(work2(neb%image(i)%num_atom,3))
     work2=0.d0
     call mpi_allreduce(neb%image(i)%force,work2,neb%image(i)%num_atom*3, &
          mpi_double_precision,mpi_sum,mpi_comm_world,mpi_err)
     neb%image(i)%force = work2
     work2=0.d0
     call mpi_allreduce(neb%image(i)%force_org,work2,neb%image(i)%num_atom*3, &
          mpi_double_precision,mpi_sum,mpi_comm_world,mpi_err)
     neb%image(i)%force_org = work2
     deallocate(work2)
  end do

  ! temporary    npes = ne*nk
  neb%image(:)%energy = neb%image(:)%energy/npes
  do i=1, neb%number_of_images
     neb%image(i)%force = neb%image(i)%force/npes
     neb%image(i)%force_org = neb%image(i)%force_org/npes
  end do
  
!  write(230+mype,'(i5,5e20.10)') mype, neb%image(:)%energy
  
end subroutine allreduce_neb_energy_force

subroutine set_neb_replica_energy_force(image_id)

  use m_Force, only : forc_l
  use m_Total_Energy, only : etotal
  use m_Replica
  use m_Files, only : nfneb

  implicit none

  integer image_id

  integer :: i

  neb%image(image_id)%energy = etotal
  neb%image(image_id)%force = forc_l
  neb%image(image_id)%force_org = forc_l

end subroutine set_neb_replica_energy_force

subroutine force_neb

  use m_Files,                only : nfneb
  use m_Replica
  use m_Parallelization,  only : mype

  implicit none

  integer i, j

  if ( mype==0 ) then
     write(nfneb,*) 'force neb...'

     do i = 1, neb%number_of_images
        write(nfneb,*) 'image: ', i, neb%image(i)%energy, &
             neb%image(i)%energy-neb%image(i)%energy0
        write(nfneb,*) ' cps, force '
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(3f10.5,3e11.3)') neb%image(i)%cps(j,1:3), neb%image(i)%force(j,1:3)
        end do
     end do
  endif

!  do i = 1, neb%number_of_images
!     neb%image(i)%force_org = neb%image(i)%force
!  end do
  
  call elastic_constant
  call local_tangent
  call neb_force

  if ( mype==0 ) then
     do i = 1, neb%number_of_images
        write(nfneb,*) 'image: ', i, neb%image(i)%energy, &
             neb%image(i)%energy-neb%image(i)%energy0
!     write(nfneb,*) ' cps, pos '
!     do j = 1, neb%image(i)%num_atom
!        write(nfneb,'(6f10.5)') neb%image(i)%cps(j,1:3), neb%image(i)%pos(j,1:3)
!     end do
        write(nfneb,*) ' force(neb), force(org), force(neb-org) '
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(9e11.3)') neb%image(i)%force(j,1:3), neb%image(i)%force_org(j,1:3), &
                neb%image(i)%force(j,1:3)-neb%image(i)%force_org(j,1:3)
        end do
     end do
  endif
end subroutine force_neb

subroutine elastic_constant

  ! elastic constant between images

  use m_Files,                only : nfneb
  use m_Replica
  use m_Parallelization,     only : mype

  implicit none

  integer  i

  real(8)  max_energy, ref_energy, energy

  real(8)  k_spring, k_spring0
  real(8)  k_spring_init, k_spring_max, k_spring_min, k_spring_delta

  if (mype==0) write(nfneb,*) 'elastic constant...'

  max_energy = maxval( neb%image(:)%energy )
  ref_energy = max( neb%image(1)%energy, neb%image(neb%number_of_images)%energy )

  do i = 2, neb%number_of_images

    if( .not. neb%cond%k_variable ) then
       k_spring = neb%cond%k_spring_init
       k_spring0= neb%cond%k_spring_init
    elseif( neb%cond%k_variable ) then
       k_spring_max = neb%cond%k_spring_max
       k_spring_min = neb%cond%k_spring_min
       energy = max( neb%image(i-1)%energy, neb%image(i)%energy )
       k_spring_delta = k_spring_max - k_spring_min
       if( energy > ref_energy ) then
          k_spring = k_spring_max - k_spring_delta &
               * ( max_energy - energy ) / ( max_energy - ref_energy )
          k_spring0 = k_spring
       elseif( energy <= ref_energy ) then
          k_spring = k_spring_max - k_spring_delta
          k_spring0 = k_spring
       end if
    end if

    if( neb%cond%k_damping ) then
       k_spring0 = k_spring
       k_spring = k_spring * neb%cond%k_damping_factor ** ( ( neb%step-1) )
    end if

    neb%image(i-1)%k_spring = k_spring
    neb%image(i-1)%k_spring0= k_spring0

    if (mype==0) write(nfneb,'(i5,a10,2e20.12)') i, '-th spring',  k_spring, k_spring0

 end do
 
 return
end subroutine elastic_constant

subroutine local_tangent

  ! local tangent of minimum energy path

  use m_Files,                only : nfneb
  use m_Replica
  use m_Parallelization,     only : mype

  implicit none

  integer i, j
  integer num_atom
  real(8) distance21
  real(8) distance01, distance20
  real(8) abs_tau2, abs_tau3
  real(8) angle12, angle23, angle31
  real(8) energy0, energy1, energy2
  real(8),allocatable :: tau(:,:)
  real(8),allocatable :: tau1(:,:), tau2(:,:), tau3(:,:)
  real(8) phi
  real(8),allocatable ::  rx0(:), ry0(:), rz0(:)
  real(8),allocatable ::  rx1(:), ry1(:), rz1(:)
  real(8),allocatable ::  rx2(:), ry2(:), rz2(:)
  real(8) :: eps

  if (mype==0) write(nfneb,*) 'local tangent...'

  eps = 1.d-10
  do j = 2, neb%number_of_images-1

     num_atom = neb%image(j)%num_atom

     allocate( tau(num_atom,3) )
     allocate( tau1(num_atom,3) )
     allocate( tau2(num_atom,3) )
     allocate( tau3(num_atom,3) )

     allocate( rx0(num_atom) )
     allocate( ry0(num_atom) )
     allocate( rz0(num_atom) )
     allocate( rx1(num_atom) )
     allocate( ry1(num_atom) )
     allocate( rz1(num_atom) )
     allocate( rx2(num_atom) )
     allocate( ry2(num_atom) )
     allocate( rz2(num_atom) )

     tau1(:,:) = 0.0d0
     tau2(:,:) = 0.0d0
     tau3(:,:) = 0.0d0

     rx0 = neb%image(j)%cps(:,1)
     ry0 = neb%image(j)%cps(:,2)
     rz0 = neb%image(j)%cps(:,3)
     rx1 = neb%image(j-1)%cps(:,1)
     ry1 = neb%image(j-1)%cps(:,2)
     rz1 = neb%image(j-1)%cps(:,3)
     rx2 = neb%image(j+1)%cps(:,1)
     ry2 = neb%image(j+1)%cps(:,2)
     rz2 = neb%image(j+1)%cps(:,3)

     energy0 = neb%image(j)%energy
     energy1 = neb%image(j-1)%energy
     energy2 = neb%image(j+1)%energy

     distance21 = sqrt ( dot_product( rx2 - rx1, rx2 - rx1 ) &
          + dot_product( ry2 - ry1, ry2 - ry1 ) &
          + dot_product( rz2 - rz1, rz2 - rz1 ) )
     distance01 = sqrt ( dot_product( rx0 - rx1, rx0 - rx1 ) &
          + dot_product( ry0 - ry1, ry0 - ry1 ) &
          + dot_product( rz0 - rz1, rz0 - rz1 ) )
     distance20 = sqrt ( dot_product( rx2 - rx0, rx2 - rx0 ) &
          + dot_product( ry2 - ry0, ry2 - ry0 ) &
          + dot_product( rz2 - rz0, rz2 - rz0 ) )

     if( distance21.lt.eps .or. distance01.lt.eps .or. distance20.lt.eps ) cycle

     phi = ( dot_product( rx2 - rx0, rx0 - rx1 ) &
          + dot_product( ry2 - ry0, ry0 - ry1 ) &
          + dot_product( rz2 - rz0, rz0 - rz1 ) ) / ( distance20 * distance01 )

     ! for regure NEB

     do i = 1, num_atom
        tau1(i, 1) = ( rx2(i) - rx1(i)) / distance21
        tau1(i, 2) = ( ry2(i) - ry1(i)) / distance21
        tau1(i, 3) = ( rz2(i) - rz1(i)) / distance21
        tau2(i, 1) = ( rx0(i) - rx1(i)) / distance01 &
             + ( rx2(i) - rx0(i) ) / distance20
        tau2(i, 2) = ( ry0(i) - ry1(i)) / distance01 &
             + ( ry2(i) - ry0(i) ) / distance20
        tau2(i, 3) = ( rz0(i) - rz1(i)) / distance01 &
             + ( rz2(i) - rz0(i) ) / distance20
     end do

     abs_tau2 = sqrt( dot_product(tau2(:,1), tau2(:,1)) &
          + dot_product(tau2(:,2), tau2(:,2)) &
          + dot_product(tau2(:,3), tau2(:,3)))
     if( abs_tau2 /= 0.0d0 ) then
        tau2(:, 1) = tau2(:, 1) /  abs_tau2
        tau2(:, 2) = tau2(:, 2) /  abs_tau2
        tau2(:, 3) = tau2(:, 3) /  abs_tau2
     end if

!       tau(:,:) = tau1(:,:)
!       tau(:,:) = tau2(:,:)

     ! for CI-NEB  ( method of python )

     if( energy2 > energy0 ) then
        if( energy0 > energy1 ) then
           do i = 1, num_atom
              tau3(i, 1) = ( rx2(i) - rx0(i) )
              tau3(i, 2) = ( ry2(i) - ry0(i) )
              tau3(i, 3) = ( rz2(i) - rz0(i) )
           end do
        elseif ( energy0 <= energy1 ) then
           if( energy2 > energy1 ) then
              do i = 1, num_atom
                 tau3(i, 1) = ( rx2(i) - rx0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rx0(i) - rx1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 2) = ( ry2(i) - ry0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( ry0(i) - ry1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 3) = ( rz2(i) - rz0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rz0(i) - rz1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
              end do
           else if( energy2 <= energy1 ) then
              do i = 1, num_atom
                 tau3(i, 1) = ( rx2(i) - rx0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rx0(i) - rx1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 2) = ( ry2(i) - ry0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( ry0(i) - ry1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 3) = ( rz2(i) - rz0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rz0(i) - rz1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
              end do
           end if
        end if
     elseif( energy2 <= energy0 ) then
        if( energy0 < energy1 ) then
           do i = 1, num_atom
              tau3(i, 1) = ( rx0(i) - rx1(i) )
              tau3(i, 2) = ( ry0(i) - ry1(i) )
              tau3(i, 3) = ( rz0(i) - rz1(i) )
           end do
        elseif( energy0 >= energy1 ) then
           if( energy2 > energy1 ) then
              do i = 1, num_atom
                 tau3(i, 1) = ( rx2(i) - rx0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rx0(i) - rx1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 2) = ( ry2(i) - ry0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( ry0(i) - ry1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 3) = ( rz2(i) - rz0(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rz0(i) - rz1(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
              end do
           elseif( energy2 <= energy1 ) then
              do i = 1, num_atom
                 tau3(i, 1) = ( rx2(i) - rx0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rx0(i) - rx1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 2) = ( ry2(i) - ry0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( ry0(i) - ry1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
                 tau3(i, 3) = ( rz2(i) - rz0(i) ) &
                      * min( abs( energy2-energy0 ), abs( energy1 -energy0 ) ) &
                      + ( rz0(i) - rz1(i) ) &
                      * max( abs( energy2-energy0 ), abs( energy1 -energy0 ) )
              end do
           end if
        end if
     end if
       
     abs_tau3 = sqrt( dot_product(tau3(:,1), tau3(:,1)) &
          + dot_product(tau3(:,2), tau3(:,2)) &
          + dot_product(tau3(:,3), tau3(:,3)))
     if( abs_tau3 /= 0.0d0 ) then
        tau3(:, 1) = tau3(:, 1) /  abs_tau3
        tau3(:, 2) = tau3(:, 2) /  abs_tau3
        tau3(:, 3) = tau3(:, 3) /  abs_tau3
     end if

     tau(:,:) = tau3(:,:)

     angle12 = ( dot_product( tau1(:,1), tau2(:,1) ) &
          + dot_product( tau1(:,2), tau2(:,2) ) &
          + dot_product( tau1(:,3), tau2(:,3) ) )
     angle23 = ( dot_product( tau2(:,1), tau3(:,1) ) &
          + dot_product( tau2(:,2), tau3(:,2) ) &
          + dot_product( tau2(:,3), tau3(:,3) ) )

     angle31 = ( dot_product( tau3(:,1), tau1(:,1) ) &
          + dot_product( tau3(:,2), tau1(:,2) ) &
          + dot_product( tau3(:,3), tau1(:,3) ) )

     ! output coordinate and local tangent
    
     if (mype==0) then
        write(nfneb,*) 'image : ', j
        write(nfneb,*) 'angle between local tangent'
        write(nfneb,'(a11,e12.5)') ' angle12 : ', angle12
        write(nfneb,'(a11,e12.5)') ' angle23 : ', angle23
        write(nfneb,'(a11,e12.5)') ' angle31 : ', angle31
        write(nfneb,*) ' cps '
        do i = 1, num_atom
           write(nfneb,'(3f10.5)') rx0(i), ry0(i), rz0(i)
        end do
        write(nfneb,*) ' local tangent : tau1, tau2, tau3'
        do i = 1, num_atom
           write(nfneb,'(9e11.3)') tau1(i,1), tau1(i,2), tau1(i,3), &
                tau2(i,1), tau2(i,2), tau2(i,3), &
                tau3(i,1), tau3(i,2), tau3(i,3)
        end do
!     write(nfneb,'(a19,3f15.5)') ' phi, dis01, dis20 ', phi, distance01, distance20
        write(nfneb,*) ''
     endif

     do i = 1, num_atom
        neb%image(j)%tau(i,:) = tau(i,:)
     end do

     deallocate( tau, tau1, tau2, tau3 )
     deallocate( rx0, ry0, rz0, rx1, ry1, rz1, rx2, ry2, rz2 )

  end do

  return
end subroutine local_tangent

subroutine neb_force

  ! constrain force of atoms of CI-NEB method

  use m_Files,                only : nfneb
  use m_Replica
  use m_Const_Parameters, only : PAI
  use m_Parallelization,     only : mype

  implicit none

  integer  num_atom
!  integer, intent(in) :: num_image
  integer  image_id

  real(8) energy
  real(8) max_energy

  real(8),allocatable :: tau(:,:)
  real(8),allocatable :: k_spring(:), k_spring0(:)

  integer i, k, iat

!  integer :: mype
!  integer :: energy_index(num_image)
  integer,allocatable :: update_id(:)
  real(8) :: distance01, distance20
  real(8) :: dot_product_f0_tau
  real(8) :: f_spring_abs
  real(8) :: f_spring_para_sum = 0.0d0
  real(8) :: f_spring_perp_sum = 0.0d0
  real(8) :: f_true_perp_sum = 0.0d0
  real(8) :: f0_perp_sum = 0.0d0, f0_para_sum = 0.0d0, f_sum = 0.0d0
  real(8) :: cosphi, switch = 0.0d0
  real(8), allocatable :: fx_spring(:), fy_spring(:), fz_spring(:)
  real(8), allocatable :: fx0_para(:), fy0_para(:), fz0_para(:)
  real(8), allocatable :: fx0_perp(:), fy0_perp(:), fz0_perp(:)
  real(8), allocatable :: fx_spring_para(:), fy_spring_para(:), fz_spring_para(:)
  real(8), allocatable :: fx_spring_perp(:), fy_spring_perp(:), fz_spring_perp(:)
  real(8), allocatable :: rx0(:), ry0(:), rz0(:)
  real(8), allocatable :: rx1(:), ry1(:), rz1(:)
  real(8), allocatable :: rx2(:), ry2(:), rz2(:)
  real(8), allocatable :: fx0(:), fy0(:), fz0(:)
  real(8), allocatable :: fx1(:), fy1(:), fz1(:)

  integer :: ci_target

  if (mype==0) write(nfneb,*) 'neb force...'

  allocate( k_spring(neb%number_of_images-1) )
  allocate( k_spring0(neb%number_of_images-1) )

  do k = 1, neb%number_of_images-1
     k_spring(k) = neb%image(k)%k_spring
     k_spring0(k) = neb%image(k)%k_spring0
  end do

  max_energy = maxval( neb%image(:)%energy )
  ci_target=0
  if( ( neb%step >= neb%cond%ci_neb_start) .and. ( neb%cond%climbing_image ) ) then
     do k=2,neb%number_of_images-1
        if (neb%image(k)%energy==max_energy) then
           ci_target=k
           if(mype==0) write(nfneb,*) 'climbing image : ',ci_target
           exit
        endif
     enddo
  endif



  do k = 2, neb%number_of_images-1

     num_atom = neb%image(k)%num_atom
     image_id = k

     allocate( tau(num_atom,3) )
     allocate( update_id(num_atom) )

     allocate( rx0(num_atom) )
     allocate( ry0(num_atom) )
     allocate( rz0(num_atom) )
     allocate( rx1(num_atom) )
     allocate( ry1(num_atom) )
     allocate( rz1(num_atom) )
     allocate( rx2(num_atom) )
     allocate( ry2(num_atom) )
     allocate( rz2(num_atom) )
     allocate( fx0(num_atom) )
     allocate( fy0(num_atom) )
     allocate( fz0(num_atom) )
     allocate( fx1(num_atom) )
     allocate( fy1(num_atom) )
     allocate( fz1(num_atom) )
     allocate( fx_spring(num_atom) )
     allocate( fy_spring(num_atom) )
     allocate( fz_spring(num_atom) )
     allocate( fx0_para(num_atom) )
     allocate( fy0_para(num_atom) )
     allocate( fz0_para(num_atom) )

     allocate( fx0_perp(num_atom) )
     allocate( fy0_perp(num_atom) )
     allocate( fz0_perp(num_atom) )

     allocate( fx_spring_para(num_atom) )
     allocate( fy_spring_para(num_atom) )
     allocate( fz_spring_para(num_atom) )

     allocate( fx_spring_perp(num_atom) )
     allocate( fy_spring_perp(num_atom) )
     allocate( fz_spring_perp(num_atom) )

     rx0 = neb%image(image_id)%cps(:,1)
     ry0 = neb%image(image_id)%cps(:,2)
     rz0 = neb%image(image_id)%cps(:,3)
     rx1 = neb%image(image_id-1)%cps(:,1)
     ry1 = neb%image(image_id-1)%cps(:,2)
     rz1 = neb%image(image_id-1)%cps(:,3)
     rx2 = neb%image(image_id+1)%cps(:,1)
     ry2 = neb%image(image_id+1)%cps(:,2)
     rz2 = neb%image(image_id+1)%cps(:,3)

     fx0 = neb%image(image_id)%force(:,1)
     fy0 = neb%image(image_id)%force(:,2)
     fz0 = neb%image(image_id)%force(:,3)
     
     tau(:,1) = neb%image(image_id)%tau(:,1)
     tau(:,2) = neb%image(image_id)%tau(:,2)
     tau(:,3) = neb%image(image_id)%tau(:,3)

     update_id = neb%image(image_id)%fix_flag(:)

!    call get_energy_index( energy_index, num_image )

     ! spring force for penalty function

     fx_spring(:) = k_spring0(image_id) * ( rx2(:) - rx0(:) ) &
          + k_spring0(image_id - 1 ) * ( rx1(:) - rx0(:) )
     fy_spring(:) = k_spring0(image_id) * ( ry2(:) - ry0(:) ) &
          + k_spring0(image_id - 1 ) * ( ry1(:) - ry0(:) )
     fz_spring(:) = k_spring0(image_id) * ( rz2(:) - rz0(:) ) &
          + k_spring0(image_id - 1 ) * ( rz1(:) - rz0(:) )

     if(k/=ci_target)then

        ! get true force perpendicular to local tangent 
          
        dot_product_f0_tau &
             = dot_product( fx0(:),  tau(:,1) ) &
             + dot_product( fy0(:),  tau(:,2) ) &
             + dot_product( fz0(:),  tau(:,3) ) 
       
        fx0_perp(:) = fx0(:) - dot_product_f0_tau * tau(:,1)
        fy0_perp(:) = fy0(:) - dot_product_f0_tau * tau(:,2)
        fz0_perp(:) = fz0(:) - dot_product_f0_tau * tau(:,3)

        ! get spring force along local tangent 
          
        distance20 = sqrt( dot_product( rx2 - rx0, rx2 - rx0 ) &
             + dot_product( ry2 - ry0, ry2 - ry0 ) &
             + dot_product( rz2 - rz0, rz2 - rz0 ) )
        distance01 = sqrt( dot_product( rx0 - rx1, rx0 - rx1 ) &
             + dot_product( ry0 - ry1, ry0 - ry1 ) &
             + dot_product( rz0 - rz1, rz0 - rz1 ) )
        f_spring_abs = k_spring0(image_id) *  distance20 &
             - k_spring0(image_id - 1) * distance01 

        fx_spring_para(:) = ( dot_product(fx_spring, tau(:,1)) &
             + dot_product(fy_spring, tau(:,2)) &
             + dot_product(fz_spring, tau(:,3)) ) * tau(:,1)
        fy_spring_para(:) = ( dot_product(fx_spring, tau(:,1)) &
             + dot_product(fy_spring, tau(:,2)) &
             + dot_product(fz_spring, tau(:,3)) ) * tau(:,2)
        fz_spring_para(:) = ( dot_product(fx_spring, tau(:,1)) &
             + dot_product(fy_spring, tau(:,2)) &
             + dot_product(fz_spring, tau(:,3)) ) * tau(:,3)
       
        ! penalty function

        switch=0.d0
        fx_spring_perp=0;fy_spring_perp=0;fz_spring_perp=0;cosphi=0
        if( neb%cond%penalty_function )  then
           fx_spring_perp(:) = ( fx_spring(:) - ( dot_product(fx_spring, tau(:,1)) &
                + dot_product(fy_spring, tau(:,2)) &
                + dot_product(fz_spring, tau(:,3)) ) * tau(:,1) ) &
                * k_spring(image_id-1) / k_spring0(image_id-1)
           fy_spring_perp(:) = ( fy_spring(:) - ( dot_product(fx_spring, tau(:,1)) &
                + dot_product(fy_spring, tau(:,2)) &
                + dot_product(fz_spring, tau(:,3)) ) * tau(:,2) ) &
                * k_spring(image_id-1) / k_spring0(image_id-1)
           fz_spring_perp(:) = ( fz_spring(:) - ( dot_product(fx_spring, tau(:,1)) &
                + dot_product(fy_spring, tau(:,2)) &
                + dot_product(fz_spring, tau(:,3)) ) * tau(:,3) ) &
                * k_spring(image_id-1) / k_spring0(image_id-1)
           cosphi = ( dot_product( rx2 - rx0, rx0 - rx1 ) &
                + dot_product( ry2 - ry0, ry0 - ry1 ) &
                + dot_product( rz2 - rz0, rz0 - rz1 ) ) &
                / ( distance20 * distance01 )

           if( cosphi > 0.0d0 ) then
              switch =  0.5d0 * ( 1.0d0 + cos(PAI*cosphi) )
           else
              switch = 1.0d0
           end if
        end if

        ! for debug 
        f_spring_para_sum = 0.0d0
        f_spring_perp_sum = 0.0d0
        f_true_perp_sum = 0.0d0
        do i = 1, num_atom
           if( update_id(i) ==  1 ) then
              f_spring_para_sum = f_spring_para_sum + fx_spring_para(i) * fx_spring_para(i) & 
                   + fy_spring_para(i) * fy_spring_para(i) + fz_spring_para(i) * fz_spring_para(i)
              f_spring_perp_sum = f_spring_perp_sum + fx_spring_perp(i) * fx_spring_perp(i) &
                   + fy_spring_perp(i) * fy_spring_perp(i) + fz_spring_perp(i) * fz_spring_perp(i)
              f_true_perp_sum = f_true_perp_sum + fx0_perp(i) * fx0_perp(i) &
                   + fy0_perp(i) * fy0_perp(i) + fz0_perp(i) * fz0_perp(i)
           end if
        end do

        ! get constained force

        fx1(:) = fx_spring_para(:) + fx0_perp(:) + switch * fx_spring_perp(:)
        fy1(:) = fy_spring_para(:) + fy0_perp(:) + switch * fy_spring_perp(:)
        fz1(:) = fz_spring_para(:) + fz0_perp(:) + switch * fz_spring_perp(:)

        do i = 1, num_atom
           neb%image(image_id)%spring_force(i,1) = fx_spring_para(i)
           neb%image(image_id)%spring_force(i,2) = fy_spring_para(i)
           neb%image(image_id)%spring_force(i,3) = fz_spring_para(i)

           neb%image(image_id)%true_force(i,1) = fx0_perp(i)
           neb%image(image_id)%true_force(i,2) = fy0_perp(i)
           neb%image(image_id)%true_force(i,3) = fz0_perp(i)
        end do

        f0_perp_sum = 0.0d0
        f_sum = 0.0d0
        do i = 1, num_atom
           if( update_id(i) == 1  ) then
              f0_perp_sum = f0_perp_sum &
                   +  ( fx0_perp(i)+switch*fx_spring_perp(i) ) ** 2 &
                   +  ( fy0_perp(i)+switch*fy_spring_perp(i) ) ** 2 &
                   +  ( fz0_perp(i)+switch*fz_spring_perp(i) ) ** 2 
              f_sum = f_sum +  fx1(i)*fx1(i) +  fy1(i)*fy1(i) + fz1(i)*fz1(i)
           end if
        end do

        f_sum = sqrt( f_sum )
        f_spring_para_sum = sqrt( f_spring_para_sum )
        f_spring_perp_sum = sqrt( f_spring_perp_sum )
        f_true_perp_sum = sqrt( f_true_perp_sum )
        f0_perp_sum = sqrt( f0_perp_sum )


        energy = neb%image(image_id)%energy

        if ( mype==0 ) then
           write(nfneb,*) 'image: ', image_id
           write(nfneb,*) ' energy: ', neb%step, energy
           write(nfneb,'(a31,e20.12)') ' sum of force (neb)         : ', f_sum
           write(nfneb,'(a31,e20.12)') ' sum of spring force (para) : ', f_spring_para_sum
           write(nfneb,'(a31,e20.12)') ' sum of true force (perp)   : ', f0_perp_sum
           write(nfneb,'(a31,3e11.3)') ' max force                  : ', &
                maxval( abs( fx1 ) ), maxval( abs( fy1 ) ), maxval( abs( fz1 ) )
        endif
     else
           
        ! get true force along local tangent 
          
        dot_product_f0_tau &
             = dot_product(fx0(:), tau(:,1)) + dot_product(fy0(:), tau(:,2))&
             + dot_product(fz0(:), tau(:,3))
          
        fx0_para(:) = dot_product_f0_tau * tau(:,1)
        fy0_para(:) = dot_product_f0_tau * tau(:,2)
        fz0_para(:) = dot_product_f0_tau * tau(:,3)
       
        ! get true force perpendicular to local tangent 
       
        fx0_perp(:) = fx0(:) - dot_product_f0_tau * tau(:,1)
        fy0_perp(:) = fy0(:) - dot_product_f0_tau * tau(:,2)
        fz0_perp(:) = fz0(:) - dot_product_f0_tau * tau(:,3)
       
        ! get constained force
       
        fx1(:) = fx0_perp(:) - fx0_para(:)
        fy1(:) = fy0_perp(:) - fy0_para(:)
        fz1(:) = fz0_perp(:) - fz0_para(:)
       
        do i = 1, num_atom
           neb%image(image_id)%spring_force(i,1) = fx0_para(i)
           neb%image(image_id)%spring_force(i,2) = fy0_para(i)
           neb%image(image_id)%spring_force(i,3) = fz0_para(i)

           neb%image(image_id)%true_force(i,1) = fx0_perp(i)
           neb%image(image_id)%true_force(i,2) = fy0_perp(i)
           neb%image(image_id)%true_force(i,3) = fz0_perp(i)
        end do

        f0_para_sum = 0.0d0
        f0_perp_sum = 0.0d0
        f_sum = 0.0d0
        do i = 1, num_atom
           if( update_id(i) == 1 ) then
              f0_para_sum = f0_para_sum +  fx0_para(i) * fx0_para(i) &
                   + fy0_para(i) * fy0_para(i) + fz0_para(i) * fz0_para(i)
              f0_perp_sum = f0_perp_sum +  fx0_perp(i) * fx0_perp(i) &
                   + fy0_perp(i) * fy0_perp(i) + fz0_perp(i) * fz0_perp(i)
              f_sum = fx1(i) * fx1(i) + fy1(i) * fy1(i) + fz1(i) * fz1(i) 
           end if
        end do

        f_sum = sqrt( f_sum )
        f0_para_sum = sqrt( f0_para_sum )
        f0_perp_sum = sqrt( f0_perp_sum )

        energy = neb%image(image_id)%energy

        if ( mype==0 ) then
           write(nfneb,*) 'image: ', image_id
           write(nfneb,*) ' energy: ', neb%step, energy
           write(nfneb,'(a31,e20.12)') ' sum of force (neb)         : ', f_sum
           write(nfneb,'(a31,e20.12)') ' sum of true force (para)   : ', f0_para_sum
           write(nfneb,'(a31,e20.12)') ' sum of true force (perp)   : ', f0_perp_sum
           write(nfneb,'(a31,3e11.3)') ' max force                  : ', &
                maxval( abs( fx1 ) ), maxval( abs( fy1 ) ), maxval( abs( fz1 ) )
        endif
     end if

     ! set force to module

     do i = 1, num_atom
        neb%image(image_id)%force(i,1) = fx1(i)
        neb%image(image_id)%force(i,2) = fy1(i)
        neb%image(image_id)%force(i,3) = fz1(i)
     end do

     deallocate( tau )
     deallocate( update_id )
     deallocate( rx0, ry0, rz0, rx1, ry1, rz1, rx2, ry2, rz2, &
          fx0, fy0, fz0, fx1, fy1, fz1, fx_spring, fy_spring, fz_spring, &
          fx0_para, fy0_para, fz0_para, fx0_perp, fy0_perp, fz0_perp, &
          fx_spring_para, fy_spring_para, fz_spring_para, &
          fx_spring_perp, fy_spring_perp, fz_spring_perp)

  end do

  deallocate( k_spring, k_spring0 )

  return

end subroutine neb_force

subroutine atom_update_neb

  use m_Crystal_Structure,  only : altv, rltv
  use m_Ionic_System,  only : ionic_mass
  use m_Files,                only : nfneb
  use m_Const_Parameters,      only : PAI2

  use m_Replica
  use m_Parallelization,  only : mype

  implicit none

  integer i, j, k
  real(8) mass
  real(8) dt
  real(8) r(3), r0(3), r1(3), v(3), v1(3), f(3), f0(3) , unitf(3)
  real(8), allocatable ::  rltv_t(:,:)

  if (mype==0) write(nfneb,*) 'atom coordinate update...'

  dt = neb%dt

  allocate(rltv_t(3,3))
  rltv_t = transpose(rltv)/PAI2

  do i = 2, neb%number_of_images-1

     neb%image(i)%pos0 = neb%image(i)%pos
     neb%image(i)%cps0 = neb%image(i)%cps

     do j = 1, neb%image(i)%num_atom

        if(neb%image(i)%fix_flag(j) == 1) then

           r = neb%image(i)%cps(j,:)
           r0 = neb%image(i)%cps0(j,:)
           v = neb%image(i)%velocity(j,:)
           f = neb%image(i)%force(j,:)
           f0 = neb%image(i)%force0(j,:)
           mass = ionic_mass(j)

           select case(neb%cond%time_integral)
           case('steepest_descent')
              r1 = r + dt*f
              v = 0.0d0
           case('verlet')
              r1 = 2.0d0*r - r0 + dt*dt*f/mass
              v1 = (r1-r)/(2.0d0*dt)
              v = 0.0d0
              if( dot_product(v1,f) >= 0.0d0) then
                 if( dot_product(f,f) /= 0.0d0 ) then
                    v = f * dot_product(v1,f)/dot_product(f,f)
                 end if
              end if
           case('velocity_verlet')
              v1 = v + 0.5d0*dt*(f0+f)/mass
              v = 0.0d0
              unitf=0.d0
              if(dot_product(f,f)/=0) unitf=f/dsqrt(dot_product(f,f))
              if( dot_product(v1,unitf) >= 0.0d0) then
                v = unitf * dot_product(v1,unitf)
              else
                 if (mype==0) write(nfneb,'(a,i6)') 'quenched velocity of atom : ',j
              end if
              r1 = r + v*dt + f*dt**2/mass
           end select

           neb%image(i)%cps(j,:) = r1
           neb%image(i)%velocity(j,:) = v

        end if

        ! cps -> pos
        do k = 1, 3
           neb%image(i)%pos(j,k) = rltv_t(k,1)*neb%image(i)%cps(j,1) &
                + rltv_t(k,2)*neb%image(i)%cps(j,2) &
                + rltv_t(k,3)*neb%image(i)%cps(j,3)
        enddo

        ! periodic tranformation
        !do k = 1, 3
        !   if( neb%image(i)%pos(j,k) < 0 ) then
        !      neb%image(i)%pos(j,k) = neb%image(i)%pos(j,k) + 1.d0
        !   else if( neb%image(i)%pos(j,k) > 1.d0 ) then
        !      neb%image(i)%pos(j,k) = neb%image(i)%pos(j,k) - 1.d0
        !   end if
        !enddo

        ! pos -> cps
        !do k = 1, 3
        !   neb%image(i)%cps(j,k) = altv(k,1)*neb%image(i)%pos(j,1) &
        !        + altv(k,2)*neb%image(i)%pos(j,2) &
        !        + altv(k,3)*neb%image(i)%pos(j,3)
        !enddo

     end do

     if ( mype==0 ) then
        write(nfneb,*) ' image: ', i
        write(nfneb,*) '  cps, cps0, cps-cps0 '
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(6f10.5,3e11.3)') neb%image(i)%cps(j,1:3), neb%image(i)%cps0(j,1:3), &
                neb%image(i)%cps(j,1:3)-neb%image(i)%cps0(j,1:3)
        end do
     endif

  end do

  deallocate(rltv_t)

end subroutine atom_update_neb

subroutine atom_update_pos_neb

  use m_Crystal_Structure,  only : altv, rltv
  use m_Ionic_System,  only : ionic_mass
  use m_Files,                only : nfneb
  use m_Const_Parameters,      only : PAI2
  use m_Parallelization,     only : mype

  use m_Replica

  implicit none

  integer i, j, k
  real(8) mass
  real(8) dt
  real(8) r(3), r0(3), r1(3), v(3), v1(3), f(3), f0(3) 

  if (mype==0) write(nfneb,*) 'atom coordinate update... (pos)'

  dt = neb%dt

  do i = 2, neb%number_of_images-1

     neb%image(i)%pos0 = neb%image(i)%pos
     neb%image(i)%cps0 = neb%image(i)%cps

     do j = 1, neb%image(i)%num_atom

        if(neb%image(i)%fix_flag(j) == 1) then

           r = neb%image(i)%pos(j,:)
           r0 = neb%image(i)%pos0(j,:)
           v = neb%image(i)%velocity(j,:)
           f = neb%image(i)%force(j,:)
           f0 = neb%image(i)%force0(j,:)
           mass = ionic_mass(j)

           select case(neb%cond%time_integral)
           case('steepest_descent')
              r1 = r + dt*f
              v = 0.0d0
           case('verlet')
              r1 = 2.0d0*r - r0 + dt*dt*f/mass
              v1 = (r1-r)/(2.0d0*dt)
              v = 0.0d0
              if( dot_product(v1,f) >= 0.0d0) then
                 if( dot_product(f,f) /= 0.0d0 ) then
                    v = f * dot_product(v1,f)/dot_product(f,f)
                 end if
              end if
           case('velocity_verlet')
              v1 = v + 0.5d0*dt*(f0+f)/mass
              v = 0.0d0
              if( dot_product(v1,f) >= 0.0d0) then
                 if( dot_product(f,f) /= 0.0d0 ) then
                    v = f * dot_product(v1,f)/dot_product(f,f)
                 end if
              end if
              r1 = r + v*dt + f*dt**2/mass
           end select

           neb%image(i)%pos(j,:) = r1
           neb%image(i)%velocity(j,:) = v

        end if

        ! periodic tranformation
        !do k = 1, 3
        !   if( neb%image(i)%pos(j,k) < 0 ) then
        !      neb%image(i)%pos(j,k) = neb%image(i)%pos(j,k) + 1.d0
        !   else if( neb%image(i)%pos(j,k) > 1.d0 ) then
        !      neb%image(i)%pos(j,k) = neb%image(i)%pos(j,k) - 1.d0
        !   end if
        !enddo

        ! pos -> cps
        do k = 1, 3
           neb%image(i)%cps(j,k) = altv(k,1)*neb%image(i)%pos(j,1) &
                + altv(k,2)*neb%image(i)%pos(j,2) &
                + altv(k,3)*neb%image(i)%pos(j,3)
        enddo

     end do

     if ( mype==0 ) then
        write(nfneb,*) ' image: ', i
        write(nfneb,*) '  cps, cps0, cps-cps0, velocity '
        do j = 1, neb%image(i)%num_atom
           write(nfneb,'(6f10.5,3e11.3,3f10.5)') neb%image(i)%cps(j,1:3), neb%image(i)%cps0(j,1:3), &
                neb%image(i)%cps(j,1:3)-neb%image(i)%cps0(j,1:3), &
                neb%image(i)%velocity(j,1:3)
        end do
     endif

  end do

end subroutine atom_update_pos_neb

subroutine write_down_data_replica

  use m_Files,                only : nfneb, nfnebcntn, F_NEB_CNTN, nfstop, F_STOP
  use m_Replica
  use m_Parallelization,    only : mype
  use m_Control_Parameters, only : sw_fcp
  use m_Const_Parameters,   only : ON
  use m_Fcp,                only : m_Fcp_write_down_totch_replica

  implicit none
  integer i,j

  if (mype==0) write(nfneb,*) 'write down data replica...'

!  if(mype_r == 0) then
  if(mype == 0) then

  open(nfnebcntn,file=F_NEB_CNTN)
  write(nfnebcntn,*) 'iteration_neb'
  write(nfnebcntn,*) neb%step
  write(nfnebcntn,*) 'number_of_images'
  write(nfnebcntn,*) neb%number_of_images

  do i = 1, neb%number_of_images
     write(nfnebcntn,*) 'image'
     write(nfnebcntn,*) i
     write(nfnebcntn,*) '(natm)'
     write(nfnebcntn,*) neb%image(i)%num_atom
     write(nfnebcntn,*) '(pos)'
     do j = 1, neb%image(i)%num_atom
        write(nfnebcntn,'(3d24.16)') neb%image(i)%pos(j,1:3)
     end do
     write(nfnebcntn,*) '(cps)'
     do j = 1, neb%image(i)%num_atom
        write(nfnebcntn,'(3d24.16)') neb%image(i)%cps(j,1:3)
     end do
     write(nfnebcntn,*) '(energy)'
     write(nfnebcntn,'(d24.16)') neb%image(i)%energy
     write(nfnebcntn,*) '(force_org)'
     do j = 1, neb%image(i)%num_atom
        write(nfnebcntn,'(3d24.16)') neb%image(i)%force_org(j,1:3)
     end do
     write(nfnebcntn,*) '(convergence)'
     if(neb%image(i)%scf_convergence) then
        write(nfnebcntn,'(i3)')  1
     else 
        write(nfnebcntn,'(i3)')  0
     end if
     if( sw_fcp == ON ) call m_Fcp_write_down_totch_replica(i)
  end do
  
  close(nfnebcntn)

  open(nfstop, file=F_STOP, status='replace', form='formatted')
  close(nfstop, status='keep')

  end if
end subroutine write_down_data_replica

subroutine allreduce_scf_convergence

  use m_Files,   only : nfneb
  use m_Replica
  use m_Parallelization,  only : mype

  implicit none

  integer i, mpi_err
  logical,allocatable :: work(:)

  include 'mpif.h'

  if(nrank_r.ge.1)then
    allocate(work(neb%number_of_images))
    call mpi_allreduce(neb%image(:)%scf_convergence,work,neb%number_of_images, &
         mpi_logical,mpi_land,mpi_comm_world,mpi_err)
    neb%image(:)%scf_convergence = work
    deallocate(work)
  endif

  if ( mype==0 ) then
     write(nfneb,*) 'neb: ', neb%step
     do i=1, neb%number_of_images
        write(nfneb,*) ' image: ', i, ' scf convergence: ', neb%image(i)%scf_convergence
     end do
  endif
end subroutine allreduce_scf_convergence

logical function replica_converged()

  use m_Files,                only : nfneb, nfnebstop, F_NEB_STOP
  use m_Replica
  use m_Parallelization, only : mype
  use m_Control_Parameters, only : sw_fcp
  use m_Const_Parameters, only : ON
  use m_Fcp, only : m_Fcp_replica_Converged

  implicit none

  logical conv
  real(8), allocatable :: force(:)
  integer i, j, istop, id(1)
  real(8) :: fmax, ftmp

  if ( mype==0 ) write(nfneb,*) 'convergence check...', neb%step

  conv = .false.
  select case(neb%cond%convergence_condition)
  
  case(1) ! energy
     if( maxval(abs(neb%image(:)%energy-neb%image(:)%energy0)) &
          < neb%cond%convergence_threshold ) then
        conv = .true.
     end if
     if ( mype==0) then
        write(nfneb,*) ' energy: ', maxval(abs(neb%image(:)%energy-neb%image(:)%energy0)), &
             neb%cond%convergence_threshold, conv
     endif
  case(2) ! force(org)
     fmax = 0
     do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom
         if(neb%image(i)%fix_flag(j)==0)cycle
         ftmp = dsqrt(dot_product(neb%image(i)%force_org(j,:),neb%image(i)%force_org(j,:)))
         if(ftmp<fmax) fmax=ftmp
       enddo
     enddo
     if(fmax<neb%cond%convergence_threshold) conv = .true.
     if ( mype==0 ) then
        write(nfneb,*) ' force (org): ', fmax, neb%cond%convergence_threshold, conv
     endif
  case(3) ! force(neb)
     fmax = 0
     do i=2, neb%number_of_images-1
       do j=1, neb%image(i)%num_atom
         if(neb%image(i)%fix_flag(j)==0)cycle
         ftmp = dsqrt(dot_product(neb%image(i)%force(j,:),neb%image(i)%force(j,:)))
         if(fmax < ftmp) fmax=ftmp
       enddo
     enddo
     if( fmax < neb%cond%convergence_threshold ) conv = .true.
     if ( mype==0 ) then
        write(nfneb,*) ' force (neb): ', fmax, neb%cond%convergence_threshold, conv
     endif
  case(4) ! force(org) of max energy image
     id = maxloc(neb%image(:)%energy);
     fmax = 0
     do i=1,neb%image(id(1))%num_atom
       if(neb%image(id(1))%fix_flag(i)==0)cycle
       ftmp = dsqrt(dot_product(neb%image(id(1))%force(i,:),neb%image(id(1))%force(i,:)))
       if(fmax<ftmp)fmax=ftmp
     enddo
     if(fmax<neb%cond%convergence_threshold) conv=.true.
     if ( mype==0 ) then
        write(nfneb,*) ' force (transition state): ', fmax, &
             neb%cond%convergence_threshold, conv
     endif
  case(5) ! true force (normal force)
     fmax=0
     do i=2,neb%number_of_images-1
       do j=1,neb%image(i)%num_atom
         if(neb%image(i)%fix_flag(j)==0)cycle
         ftmp=dsqrt(dot_product(neb%image(i)%true_force(j,:),neb%image(i)%true_force(j,:)))
         if(fmax<ftmp)fmax=ftmp
       enddo
     enddo
     if(fmax<neb%cond%convergence_threshold) conv=.true.
     if ( mype==0 ) then
        write(nfneb,*) ' force (normal): ', fmax, neb%cond%convergence_threshold, conv
     endif
  end select

  ! check nfnebstop.data
  istop = -1
  open(nfnebstop,file=F_NEB_STOP)
  rewind(nfnebstop)
  read(nfnebstop,*,end=1,err=1) istop
1 continue
  close(nfnebstop,status='keep')
  if(0 <= istop .and. neb%step >= istop) then
     conv = .true.
     if (mype==0) write(nfneb,*) ' nfnebstop.data: ', istop     
  end if

  if( (sw_fcp == ON) .and. .not. m_Fcp_replica_Converged() ) then
     conv = .false.
  end if

  replica_converged = conv

  call write_result(.true.)

end function replica_converged

subroutine write_result(inc_energy)

  use m_Files,                only : nfnebenf, nfnebdynm, nfenf, nfdynm, F_DYNM, F_ENF
  use m_Replica
  use m_Ionic_System,         only : m_IS_wd_speciesname_etc
  use m_IterationNumbers,     only : iteration

  implicit none

  logical, intent(in) :: inc_energy
  integer i, j
  character(20) form
  real(8) d, sum_d
  integer npes,mype,mpi_err

  include 'mpif.h'

  call mpi_comm_rank(mpi_comm_world,mype,mpi_err)

  if(mype /= 0) return

  ! write energy, force, cps

  open(nfdynm,file=F_DYNM)
  open(nfenf,file=F_ENF)
  call m_IS_wd_speciesname_etc(nfdynm)
  call m_IS_wd_speciesname_etc(nfnebdynm)
  write(nfenf,*) '#step  image  image_distance  energy   force_org  force_neb  force_normal'
  sum_d = 0.0d0
  do i=1, neb%number_of_images
     if(inc_energy)then
     d = 0.0d0
     if(i>1) then
        d = 0.0d0
        do j=1, neb%image(i)%num_atom
           d = d + dot_product(neb%image(i-1)%cps(j,:)-neb%image(i)%cps(j,:), &
                neb%image(i-1)%cps(j,:)-neb%image(i)%cps(j,:))
        end do
        d = sqrt(d)
     end if
     sum_d = sum_d + d
     write(nfnebenf,'(2i5,5e20.10)')  neb%step, i, sum_d, neb%image(i)%energy, &
          maxval(abs(neb%image(i)%force_org(:,:))), &
          maxval(abs(neb%image(i)%force(:,:))), &
          maxval(abs(neb%image(i)%true_force(:,:)))
     write(nfenf,'(2i5,5e20.10)')  neb%step, i, sum_d, neb%image(i)%energy, &
          maxval(abs(neb%image(i)%force_org(:,:))), &
          maxval(abs(neb%image(i)%force(:,:))), &
          maxval(abs(neb%image(i)%true_force(:,:)))
     endif
     write(nfnebdynm,'(a,i5,i8,a)') ' cps and forc at (nebstep, iter_total=',neb%step,iteration,')'
     write(nfdynm,'(a,i5,i8,a)') ' cps and forc at (nebstep, iter_total=',neb%step,iteration,')'
     do j = 1, neb%image(i)%num_atom
!        write(nfnebdynm,'(3i5,3f20.10)') neb%step, i, j, neb%image(i)%cps(j,1:3)
        write(nfnebdynm,'(" ",i4,3f15.9,3f12.6)') j &
        &, neb%image(i)%cps(j,1),neb%image(i)%cps(j,2),neb%image(i)%cps(j,3) &
        &, neb%image(i)%force(j,1), neb%image(i)%force(j,2), neb%image(i)%force(j,3)
        write(nfdynm,'(" ",i4,3f15.9,3f12.6)') j &
        &, neb%image(i)%cps(j,1),neb%image(i)%cps(j,2),neb%image(i)%cps(j,3) &
        &, neb%image(i)%force(j,1), neb%image(i)%force(j,2), neb%image(i)%force(j,3)
     end do
  end do

  if(inc_energy) write(nfnebenf,*)

  close(nfdynm)
  close(nfenf)
  ! temporary
  !!write(form,'(a4,i5,a7)') '(i5,',neb%number_of_images,'e20.10)'
  !!write(212,form) neb%step, neb%image(:)%energy

  !!neb%energy(neb%step,:) = neb%image(:)%energy
  !!open(213)
  !!write(form,'(a4,i5,a7)') '(i5,',neb%step,'e20.10)'
  !!do i=1, neb%number_of_images
  !!   write(213,form) i, neb%energy(1:neb%step,i)
  !!end do
  !!close(213)

end subroutine write_result

subroutine finalize_neb()
  use m_Replica, only : m_Replica_finalize, nrank_r
  use m_Files, only : nfnebstop, F_NEB_STOP, nfneb, m_Files_close_and_clear_nfstop
  use m_Control_Parameters,  only : ipriparadeb
  use m_Parallelization, only : mype

  implicit none
  include 'mpif.h'

  integer :: mpi_err
  call m_Replica_finalize()

  if(nrank_r.gt.1) call mpi_barrier(mpi_comm_world, mpi_err)
  open(nfnebstop, file=F_NEB_STOP, status='replace', form='formatted')
  close(nfnebstop, status='keep')

! ==== KT_add ===== 2014/07/20
#ifdef NEB_NEW_FILENAMES
  if ( mype == 0 ) close(nfneb)
#else
  if ( mype == 0 ) then
     close(nfneb)
  else if(ipriparadeb == 0) then
     close(nfneb, status='delete')
  else
     close(nfneb, status='keep')
  end if
#endif
! ================= 2014/07/20

  call m_Files_close_and_clear_nfstop()
end subroutine finalize_neb

subroutine deallocate_array

  use m_Control_Parameters
  use m_Crystal_Structure
  use m_Ionic_System
  use m_PlaneWaveBasisSet
  use m_Parallelization
  use m_Kpoints
  use m_Force
  use m_Charge_Density
  use m_XC_Potential
  use m_PseudoPotential
  use m_NonLocal_Potential
  use m_Electronic_Structure
  use m_ES_WF_by_SDorCG
  use m_ES_wf_extrpl

!  call m_CtrlP_dealloc

  call m_CS_dealloc(neb_mode=.true.)
  call m_IS_dealloc(neb_mode=.true.)
  call m_pwBS_dealloc
  call m_Parallel_dealloc(neb_mode=.true.)
  call m_Kp_dealloc
  call m_Force_dealloc
  call m_CD_dealloc
  call m_XC_dealloc_vxc
  !call m_PP_dealloc
  !call m_NLP_dealloc
  call m_ES_dealloc
  call m_ESsd_dealloc
  call m_ES_wf_extrpl_dealloc()
  call m_CtrlP_set_init_status(.true.)

end subroutine deallocate_array

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE: m_Total_Energy
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
module m_Total_Energy
! $Id: m_Total_Energy_ep.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Force,            only : etotal
  use m_Const_Parameters, only : tag_total_energy
  implicit none

contains
  subroutine m_TE_rd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    read(nfcntn,*)
    read(nfcntn,*) etotal
  end subroutine m_TE_rd_total_energy

  subroutine m_TE_wd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    print *,' tag_total_energy'
    write(nfcntn,*) tag_total_energy
    write(nfcntn,'(2d24.16)') etotal
  end subroutine m_TE_wd_total_energy
end module m_Total_Energy

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: Initialization_Epsilon
!
!  AUTHOR(S): T. Hamada   November/24/2004
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!
!
! $Id: Initialization_Epsilon.f90 570 2017-04-21 20:34:50Z yamasaki $
   subroutine Initialization_Epsilon(mode)
    use m_Epsilon_ek,            only : initialization_eps_ek
    use m_Control_Parameters,    only : m_CtrlP_set_uvsormode_ON
    use m_Files,                 only : m_Files_open_nfeps, m_Files_open_nfepscont
    implicit none
    integer, intent(in) :: mode
     call m_Files_open_nfeps
     call m_Files_open_nfepscont
     call initialization_eps_ek(mode)
     call m_CtrlP_set_uvsormode_ON()
   end subroutine Initialization_Epsilon

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE: m_CS_SpaceGroup
!
!  AUTHORS: T. Yamamoto,    October/16/2005
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!
module m_CS_SpaceGroup
!      (m_CS_SG)
! $Id: m_CS_SpaceGroup.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters,   only : DP, PAI, PAI2, BUCS, CARTS, ANTIFERRO &
       &                         , oh=>oh_symbol, d6h=>d6h_symbol
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : ipri, af, m_CtrlP_set_af &
       &                         , ipriinputfile, ipri_spg, printable
  use m_Crystal_Structure,  only : altv,rltv,nopr,op,tau,imag &
       &                         , ngen,igen,jgen,iaf,jaf &
       &                         , alloc_igen_jgen,dealloc_igen_jgen &
       &                         , b2pmat,ig01,il,pg_symbol_system &
       &                         , misalignment, p2bmat &
       &                         , m_CS_put_Bravais_lattice
  use m_Ionic_System,       only : natm,natm2,ntyp,ityp,pos,iatomn,iwei &
       &                         , m_IS_put_lattice_system &
       &                         , m_IS_put_latconst_len_angle
!!$       &                         , latconst_len,latconst_angle

! ============================ added by K. Tagami ================== 11.0
  use m_Const_Parameters,   only : NONCOLLINEAR, DELTA10, ON
! ================================================================== 11.0

! ============================ added by K. Tagami ================== 11.0
  use m_Control_Parameters,   only : noncol
  use m_Ionic_System,       only : magmom_local_now
  use m_Crystal_Structure,  only : sw_use_magnetic_symmetry
! ================================================================== 11.0

  implicit none
 
  character(len=9), public :: lattice_system

! ========= Added by K. Tagami ========================
   real(kind=DP), dimension(3,3), public :: kt_b2pmat
   real(kind=DP), dimension(3,3), public :: kt_p2bmat
! =========

   real(kind=DP),dimension(3) :: Bravais_lattice_length, Bravais_lattice_angle

contains
  subroutine set_lattice_system(system)
    character(len=9), intent(in) :: system
    lattice_system = system
    call m_IS_put_lattice_system(lattice_system)
    pg_symbol_system = system
  end subroutine set_lattice_system

  subroutine set_ig01(iopr,nopr)
    integer, intent(in) :: iopr
    integer, intent(in) :: nopr(49)
    
    ig01(1:iopr) = nopr(1:iopr)
    if(imag==ANTIFERRO) then
       iaf = nopr(iopr+af)
    end if
  end subroutine set_ig01

  subroutine m_CS_SG_auto_gnrt_sym_op(paramset,nfout)
    logical, intent(in) :: paramset
    integer, intent(in) :: nfout
    integer ::             i, j, iopr, ip
    integer ::             af_t
    integer ::             id_sname = -1
    call tstatc0_begin('m_CS_SG_gnrt_symmetry_operations ',id_sname)
! ----- iopr, op, tau

    call autogen_space_group(nfout,ipri_spg,iopr,af_t,paramset) !! defined in this file

    if(printable) write(nfout,'(" !! af_t = ",i10)') af_t
    if(af_t > 1) stop ' ! illegal af_t value'
    call m_CtrlP_set_af(af_t)
    if(printable) write(nfout,'(" !! af_t (after m_CtrlP_set_af) = " ,i6)') af_t

    if(ipri >= 0 .and. printable) then
       write(nfout,*) ' << rltv, altv >>'
       write(nfout,'(3f8.4,11x,3f8.4)') &
            & ((rltv(i,j),j=1,3),(altv(i,j),j=1,3),i=1,3)
    endif
    if(paramset) then
       nopr = iopr
       goto 1001
    end if

    call tau_in_CARTS()

1001 continue

    call tstatc0_end(id_sname)
  contains
    subroutine tau_in_CARTS
      integer i, no
      do i = 1, 3
         do no = 1, iopr + af
            tau(i,no,CARTS) = altv(i,1)*tau(1,no,BUCS) &
                 &     +      altv(i,2)*tau(2,no,BUCS) &
                 &     +      altv(i,3)*tau(3,no,BUCS)
         enddo
      enddo
    end subroutine tau_in_CARTS
  end subroutine m_CS_SG_auto_gnrt_sym_op

  subroutine autogen_space_group(nfout,ipri,iopr,af,paramset)
    implicit none
    integer, intent(in) :: nfout,ipri
    integer, intent(out) :: iopr,af
    logical, intent(in) :: paramset

    real(kind=DP) :: r(3,3,49),t(3,49)
    real(kind=DP) :: r_af(3,3,49),t_af(3,49)
    real(kind=DP) :: pos2(natm2,3)
    real(kind=DP) :: tprim(3,natm2),tprim_af(3,natm2)
    integer :: nopr(49),nopr_af(49)
    integer :: i,ia
    integer :: ipri_t
    integer :: ityp2(natm2)
    integer :: ityp_af(natm2)
    integer :: iopr_af
    integer :: nprim,nprim_af
    integer, parameter :: DEBUGPRINTLEVEL = 2
    character(len=9) :: system
! =================================== Added by K. Tagami ==========
    integer j,k,l,m,n
    real(kind=DP) :: tmp
!!!!    real(kind=DP) :: bmat(3,3), binv(3,3), p2bmat(3,3)
    real(kind=DP) :: bmat(3,3), binv(3,3)

! ============================== added by K. Tagami ================ 11.0
    real(kind=DP) :: mag_loc(natm2,3)
! ==================================================================== 11.0

! ============================== Added by K. Tagami ==== patch 0.9 =========
       Do j=1, 3
          Do k=1, 3
             kt_b2pmat(j,k) = b2pmat(k,j)
             kt_p2bmat(j,k) = p2bmat(k,j)
          End Do
       End do
!       Call mat3inv( kt_b2pmat, kt_p2bmat )
! =========================================================

    if(ipri>2) then
       ipri_t = 2 
    else if(paramset) then
       ipri_t = 0
    else
       ipri_t = ipri
    endif

    pos2(1:natm,1:3) = pos(1:natm,1:3)
    ityp2(1:natm) = ityp(1:natm)
    i=natm
    do ia=1,natm
       if(iwei(ia)/=1) then
          i = i+1
          pos2(i,1:3) = -pos(ia,1:3)
          ityp2(i) = ityp(ia)
       end if
    end do

    iopr = 48
    call space_group(nfout,ipri_t,altv(1,1),altv(1,2),altv(1,3), &
         &           ntyp,natm2,ityp2,pos2,system,iopr,nopr,r,t, &
         &           nprim,tprim)

!!!!!!    write(*,*) 'iopr a =', iopr

    if(ipri>=DEBUGPRINTLEVEL) then
       write(nfout,'(" number of symmetry = ",i4)') iopr
       write(nfout,'(" system = ",a)') system
       call wd_operations(nfout,r,t,nopr,iopr)
    end if

    if(imag==ANTIFERRO) then
      do ia=1,natm2
        ityp_af(ia) = nint(iatomn(ityp2(ia)))
      end do
      iopr_af = 48
      call space_group(nfout,0,altv(1,1),altv(1,2),altv(1,3), &
                     & ntyp,natm2,ityp_af,pos2,system,iopr_af,nopr_af,r_af,t_af, &
                     & nprim_af,tprim_af)
      if(ipri>=DEBUGPRINTLEVEL) then
         write(nfout,'(" number of symmetry when imag=ANTIFERRO = ",i8)') iopr_af
         write(nfout,'(" system = ",a)') system
         call wd_operations(nfout,r_af,t_af,nopr_af,iopr_af)
         write(nfout,'(" nprim_af, nprim = ",2i8)') nprim_af, nprim
      end if
      if(iopr_af.ne.2*iopr.and.nprim_af.le.nprim) then
         write(nfout,*) 'iopr_af=',iopr_af
         write(nfout,*) 'iopr   =',iopr
         write(nfout,*) 'nprim_af=',nprim_af
         write(nfout,*) 'nprim=',nprim
         stop 'iopr_af .ne. 2*iopr and nprim_af .le. nprim'
      end if
!=========================== Modified by K. Tagami ======= 1.0 ===
!      call set_af_operator(nfout,ipri_t,system,iopr_af,nopr_af,r_af,t_af,nprim_af,tprim_af,iopr,nopr,r,t,nprim,tprim)
      call set_af_operator_kt(nfout,ipri_t,system,iopr_af,nopr_af,r_af,t_af,nprim_af,tprim_af,iopr,nopr,r,t,nprim,tprim)
! =================================================================
      af = 1
    else
      af = 0
    end if

    call print_prim_trans(nfout,ipri_t,nprim,tprim)

! ========================== added by K. Tagami =============================== 11.0
!    if ( noncol .and. sw_use_magnetic_symmetry == ON ) then
!       i = natm
!       mag_loc(1:natm,:) = magmom_local_now(1:natm,:)
!       do ia=1,natm
!          if (iwei(ia)/=1) then
!             i = i+1
!             mag_loc(i,1:3) = magmom_local_now(ia,1:3)
!          end if
!       end do
!       call set_magnetic_symm( natm2, pos2, iopr, nopr, r, t, mag_loc )
!    endif
! ============================================================================ 11.0

    if(.not.paramset) then
! =================================== Added by K. Tagami ==========
!!!!!!!!!!!!!!      op(:,:,:) = r(:,:,1:iopr+af)
! 
!       Call mat3inv( b2pmat, p2bmat )
!       bmat = matmul( altv, p2bmat )
!       Call mat3inv( bmat, binv )

       bmat = matmul( altv, kt_p2bmat )
       Call mat3inv( bmat, binv )
! =============================================================
!
       do i=1, iopr+af
          do n=1,3
            do m=1,3
               tmp = 0.d0
                do k=1,3
                  do l=1,3
                     tmp = tmp  + bmat(m,k) * r(k,l,i) *binv(l,n)
                  end do
               end do
               op(m,n,i) = tmp
            end do
         end do
      end do
! ========================================================================
      do i=1,iopr+af
        tau(1:3,i,BUCS) = t(1:3,i)
      end do
    end if

    call set_tspace_generators(nfout,ipri_t,iopr,nopr,r,t,natm2,nprim,tprim)
    if(ipri_t>0) call write_tspace_generators(nfout,system,nprim)

    call set_lattice_system(system)

    call set_ig01(iopr,nopr)

  end subroutine autogen_space_group

! ================================ added by K. Tagami ================= 11.0
  subroutine set_magnetic_symm( natom, apos, nsym,  nopr, rot, tau, mag_loc )
    implicit none

    integer, intent(in) :: natom
    integer, intent(inout) :: nsym
    integer, intent(out) :: nopr(48)
    real(kind=DP), intent(inout) :: rot(3,3,48), tau(3,48)
    real(kind=DP), intent(in) :: apos(natom,3)
    real(kind=DP), intent(in) :: mag_loc(natom,3)

    real(kind=DP) :: ktrot_pr(3,3,48), ktrot_carts(3,3,48)
    real(kind=DP) :: bmat(3,3), binv(3,3)
    logical :: mag_sym_flag(48)

    integer :: i, ia, ja, ja_found
    integer :: isym, count
    real(kind=DP) :: coord_tmp(3), dcoord(3), dist
    real(kind=DP) :: mag_tmp(3), dmag_p(3), dmag_m(3)
    real(kind=DP) :: c1, c2
!
    real(kind=DP), parameter :: criterion = 1.0D-5
!
    real(kind=DP), allocatable :: apos_t(:,:)
!
    integer :: it
! -- init --
    call set_drot( kt_b2pmat, kt_p2bmat, nsym, rot, ktrot_pr )
    
    Call matrix_product( altv, kt_p2bmat, bmat )
    Call mat3inv( bmat, binv )
    call set_drot( binv, bmat, nsym, rot, ktrot_carts )
    
    mag_sym_flag = .false.
    
    allocate(apos_t(natom,3))
    apos_t(1:natm,1:3) = apos(1:natom,1:3)
    do ia = 1, natom
       do i = 1, 3
          apos_t(ia,i) = apos_t(ia,i) - floor(apos_t(ia,i))
       end do
    end do

! ---
!    Do ia=1, natom
!       write(*,*) 'ia ', ia
!       write(*,*) apos_t(ia,1), apos_t(ia,2), apos_t(ia,3)
!    End do
! ---
!    Do isym=1, nsym
!       write(*,*) 'isym ', isym
!       write(*,*) ktrot_carts(1,1,isym), ktrot_carts(1,2,isym), ktrot_carts(1,3,isym)
!       write(*,*) ktrot_carts(2,1,isym), ktrot_carts(2,2,isym), ktrot_carts(2,3,isym)
!       write(*,*) ktrot_carts(3,1,isym), ktrot_carts(3,2,isym), ktrot_carts(3,3,isym)
!    End do

! -- begin --  
    Do isym=1, nsym
       
       Do it=1, ntyp
          Do ia=1, natom
             if ( ityp(ia) /=it ) cycle

             coord_tmp(1:3) = matmul( ktrot_pr(:,:,isym), apos_t(ia,1:3) ) &
                  &         + tau(1:3,isym)
             coord_tmp(1:3) = coord_tmp(1:3) - floor(coord_tmp(1:3))
          
             ja_found = 0
             Do ja=1, natom
                dcoord(:) = apos_t(ja,1:3) - coord_tmp(:)
                
                dist = dcoord(1)**2 + dcoord(2)**2 + dcoord(3)**2
                dist = sqrt(dist)
                dist = dist - floor( dist +DELTA10 )

!!             write(*,*) 'isym, ia ja, dist =', isym, ia, ja, dist
                if ( dist < criterion ) then
                   ja_found = ja
!                goto 100
                   exit
                endif
             End do

100          continue
!
             if ( ja_found ==0 ) then
                write(*,*) 'kt: Not found symmetry', isym, ia
                stop
             endif
          
             mag_tmp(1:3) = matmul( ktrot_carts(:,:,isym), mag_loc(ia,1:3) )
          !
             dmag_m(1:3) = mag_tmp(1:3) - mag_loc(ja_found,1:3)
             dmag_p(1:3) = mag_tmp(1:3) + mag_loc(ja_found,1:3)
          !
             c1 = abs( dmag_m(1) ) +abs( dmag_m(2) ) +abs( dmag_m(3) )
             c2 = abs( dmag_p(1) ) +abs( dmag_p(2) ) +abs( dmag_p(3) )
          !
!!!          if ( c1 < criterion .or. c2 < criterion ) then
             if ( c1 < criterion ) then
                mag_sym_flag(isym) = .true.
                exit
             endif
!
             if ( mag_sym_flag(isym) ) then
                if ( c1 > criterion ) then
                   mag_sym_flag(isym) = .false.
                endif
             endif
          End do
       End do
    End do
! -----
    count = 0
    Do isym=1, nsym
       if ( mag_sym_flag(isym) ) then
          count = count + 1
          nopr(count) = nopr(isym)
          rot(:,:,count) = rot(:,:,isym)
          tau(:,count) = tau(:,isym)
       endif
    End do
    
    nsym = count

    deallocate( apos_t )

  contains

    subroutine set_drot( a,ainv,nsym,rot,drot )
      real(kind=DP), intent(in) :: a(3,3),ainv(3,3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      real(kind=DP), intent(out) :: drot(3,3,nsym)

      integer :: n
      do n=1,nsym
         drot(1:3,1:3,n) = matmul(ainv,matmul(rot(:,:,n),a))
      end do
    end subroutine set_drot
    
    subroutine matrix_product(a,b,c)
      real(kind=DP), intent(in) :: a(3,3),b(3,3)
      real(kind=DP), intent(out) :: c(3,3)
      
      ! local variables
      integer :: i,j

      do j=1,3
         do i=1,3
            c(i,j) = sum(a(i,1:3)*b(1:3,j))
         end do
      end do

    end subroutine matrix_product

  end subroutine set_magnetic_symm
!=========================================================================== 11.0

  subroutine wd_operations(nfout,r,t,nopr,iopr)
    integer, intent(in) :: nfout, iopr, nopr(iopr)
    real(kind=DP), intent(in) :: r(3,3,iopr),t(3,iopr)
    integer :: n,j, i

    write(nfout,'(" iopr = ",i8," at <<autogen_space_group>> in m_CS_spaceGroup")') iopr
    do n = 1, iopr
       write(nfout,'(" #op = ", i8)') nopr(n)
       do i = 1, 3
          write(nfout,'(4f8.4)') (r(i,j,n),j=1,3),t(i,n)
       end do
    end do
  end subroutine wd_operations

! ================================== Added by K. Tagami ============
    subroutine mat3inv(mat,matinv)
    implicit none

    real(kind=DP), intent(in)  :: mat(3,3)
    real(kind=DP), intent(out) :: matinv(3,3)

    ! local variables
    real(kind=DP) :: det
    integer :: i,j,i1,i2,j1,j2

    det=0.d0
    do i=1,3
      do j=1,3
        i1=mod(i,3)+1
        i2=mod(i+1,3)+1
        j1=mod(j,3)+1
        j2=mod(j+1,3)+1
        matinv(j,i)=mat(i1,j1)*mat(i2,j2)-mat(i1,j2)*mat(i2,j1)
      end do
      det=det+mat(i,1)*matinv(1,i)
    end do
    do i=1,3
      do j=1,3
        matinv(i,j)=matinv(i,j)/det
      end do
    end do

    return
    end subroutine mat3inv
! =========================================================

  subroutine space_group(nfout,ipri,a1,a2,a3,ntype,natom &
                      & ,itype,apos,system,nsym,nopr,rot,tau &
                      & ,nprim,tprim)
    implicit none

    integer, intent(in) :: nfout,ipri
    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    integer, intent(in) :: ntype,natom,itype(natom)
    real(kind=DP), intent(in) :: apos(natom,3)
    character(len=9), intent(out) :: system
    integer, intent(out) :: nsym
    integer, intent(out) :: nopr(48)
    real(kind=DP), intent(out) :: rot(3,3,48),tau(3,48)
    integer, intent(out) :: nprim
    real(kind=DP), intent(out) :: tprim(3,natom)

    logical :: flat(48)
    integer :: nlat
    character(len=3) :: pg_name
    character(len=5) :: pg_name_i
    character(len=2) :: bl_name
    character(len=10) :: sg_name_i

    integer :: i,j
    flat = .true.

    call determine_crystal_system(a1,a2,a3,system)
    if(system=='cubic')then
       kt_b2pmat=0.d0
       kt_p2bmat=0.d0
       do i=1,3
          kt_b2pmat(i,i) = 1.0d0
          kt_p2bmat(i,i) = 1.0d0
       enddo
    endif
10  continue ! changing system for a monoclinic crystal with a hexagonal cell
    call generate_point_group(system,nsym,rot)
    ! debug
    if(ipri>1) call print_rot(nsym,rot,flat)
    ! end debug
    call determine_lattice_point_group(system,a1,a2,a3,nsym,nlat,nopr,rot,flat)
    call get_point_group_name(nfout,system,nlat,nopr,pg_name,pg_name_i)
    call get_bravais_lattice(nfout,0,a1,a2,a3,system,nopr,pg_name_i,bl_name) ! ipri = 0
    ! debug
    if(ipri>1) then
       write(nfout,'(9x,"Lattice point group: ",a,1x,a)') pg_name,pg_name_i
       write(nfout,'(13x,"Bravais lattice: ",a,1x,a)') bl_name
       write(nfout,'("Elements of the lattice point group:")') 
       call print_rot(nsym,rot,flat)
    end if
    ! end debug
    call determine_space_group(a1,a2,a3,ntype,natom,itype,apos,nsym,nopr,rot,tau,flat,nprim,tprim)
    if(system_is_wrong(system,nsym,nopr)) go to 10
    !!$call get_point_group_name(nfout,system,nsym,nopr,pg_name,pg_name_i)
    !!$call get_bravais_lattice(nfout,ipri,a1,a2,a3,system,nopr,pg_name_i,bl_name)
    !!$call get_space_group_name(nfout,system,nsym,nopr,tau,.false.,bl_name,pg_name_i,sg_name_i)
    if(ipri>1) then
   !!$    write(nfout,'(13x,"Bravais lattice: ",a,1x,a)') bl_name
   !!$    write(nfout,'("Crystallographic point group: ",a,1x,a)') pg_name,pg_name_i
   !!$    write(nfout,'(17x,"Space group: ",a)') sg_name_i
   !!$    write(nfout,'("Elements of the space group:")')
       call print_space_group(nfout,system,nsym,nopr,rot,tau)
    end if

  contains

    logical function system_is_wrong(system,nsym,nopr)
      character(len=9), intent(inout) :: system
      integer, intent(in) :: nsym
      integer, intent(in) :: nopr(48)

      logical :: fexist(48)
      integer :: i

      fexist=.false.
      do i=1,nsym
         fexist(nopr(i)) = .true.
      end do
      
      system_is_wrong = .false.
      if(system == 'hexagonal'.and.il>0) then
         if(.not.fexist(3)) then
            ! lattice system is monoclinic if C3+ doesn't exist.
            system_is_wrong = .true.
            system = 'cubic'     
            if(ipri>0) then
               write(nfout,*) 'The lattice system was found monoclinic or orthorhombic, and'
               write(nfout,*) 'system was changed from hexagonal to cubic.'
            end if
         end if
      end if
    end function system_is_wrong

    subroutine determine_crystal_system(a1,a2,a3,system)
    implicit none

    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    character(len=9), intent(out) :: system

    ! local variables
    real(kind=DP) :: length(3),angle(3)
    real(kind=DP) :: eps = 1.d-6
    real(kind=DP) :: pi2,pi3,pi4
    real(kind=DP) :: axis(3),axis_angle
    integer :: i

    pi2 = atan(1.d0)*2.d0
    pi3 = pi2*4.d0/3.d0
    pi4 = pi3*0.5d0
    do i=1,3
       axis(i) = a1(i)+a2(i)+a3(i)
    end do

    call vectors_length_angle(a1,a2,a3,length,angle)
    call get_axis_angle(axis,axis_angle)

    if(ipri>0) then
      write(nfout,'("a1=",f10.5," a2=",f10.5," a3=",f10.5,1x," a.u.")') length(1:3)
      write(nfout,'("a =",f10.5," b =",f10.5," g =",f10.5,1x," deg.")') angle(1:3)/(2.d0*pi2)*180
      write(nfout,'("axis angle",f10.5,1x," deg.")') axis_angle/(2.d0*pi2)*180
    end if

    if(il==0) then
       system = 'hexagonal'
       if(ipri>0) write(nfout,'("System is hexagonal (manual)")')
       return
    else if(il==-1) then
       system = 'hexagonal'
       if(ipri>0) write(nfout,'("System is rhombohedral (manual)")')
       return
    end if

    if(abs(length(1)-length(2)) < eps .and. &
     & abs(angle(1)-angle(2)) < eps) then

      if(abs(length(2)-length(3)) > eps .and. &
       & abs(angle(2)-pi2) < eps .and. &
       & abs(angle(3)-pi3) < eps) then
        system = 'hexagonal'
        if(ipri>0) write(nfout,'("System is hexagonal")')
        return
      else if(abs(length(2)-length(3)) < eps .and. &
            & abs(angle(2)-angle(3)) < eps .and. &
            & abs(angle(3)-pi2) > eps .and. &
            & abs(angle(3)-pi4) > eps .and. &
            & abs(axis_angle) < eps ) then
        system = 'hexagonal'
        if(ipri>0) write(nfout,'("System is rhombohedral")')
        return
      end if

    end if

    system = 'cubic'
    if(ipri>0) write(nfout,'("System is not hexagonal nor rhombohedral")')

    end subroutine determine_crystal_system


    subroutine get_axis_angle(axis,axis_angle)
    implicit none
    real(kind=DP), intent(in) :: axis(3) 
    real(kind=DP), intent(out) :: axis_angle

    axis_angle = sqrt(sum(axis(1:3)**2))
    axis_angle = axis(3)/axis_angle
    axis_angle = acos(axis_angle)

    end subroutine get_axis_angle

    subroutine determine_lattice_point_group(system,a1,a2,a3,nsym,nlat,nopr,rot,flat)
      implicit none
      character(len=9), intent(in) :: system
      integer, intent(in) :: nsym
      integer, intent(out) :: nlat
      integer, intent(out) :: nopr(48)
      real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
      real(kind=DP), intent(in) :: rot(3,3,48)
      logical, intent(out) :: flat(48)

      ! local variables
      real(kind=DP) :: grid(3,16)
      real(kind=DP) :: x(3) 
      integer :: i,j,n,isum
      real(kind=DP), parameter :: eps = 1.d-6
!============================== Added by K. Tagami ==============
      real(kind=DP) :: ktrot(3,3,48)
      real(kind=DP) :: a(3,3),ainv(3,3)
!!!!!!!!!      real(kind=DP) :: bmat(3,3), binv(3,3), p2bmat(3,3)
      real(kind=DP) :: bmat(3,3), binv(3,3)
      integer k, l
!
      a(1:3,1) = a1(1:3)
      a(1:3,2) = a2(1:3)
      a(1:3,3) = a3(1:3)

!      Call mat3inv( b2pmat, p2bmat )
!      Call matrix_product( altv, p2bmat, bmat )
!      Call mat3inv( bmat, binv )
!      call set_drot( binv, bmat, nsym,rot,ktrot )

      Call matrix_product( altv, kt_p2bmat, bmat )
      Call mat3inv( bmat, binv )
      call set_drot( binv, bmat, nsym,rot,ktrot )
!=======================================================================

!      write(900,*) 'DEBUG a =='
!      write(900,*) ktrot(1,1,4), ktrot(1,2,4), ktrot(1,3,4)
!      write(900,*) ktrot(2,1,4), ktrot(2,2,4), ktrot(2,3,4)
!      write(900,*) ktrot(3,1,4), ktrot(3,2,4), ktrot(3,3,4)

! --

      flat = .true.

      grid(1:3,1) = a1(1:3)
      grid(1:3,2) = a2(1:3)
      grid(1:3,3) = a3(1:3)
      do i=1,3
         grid(1:3,i+3) = -grid(1:3,i)
      end do
      grid(1:3,7) = a1(1:3)-a2(1:3)
      grid(1:3,8) = a2(1:3)-a3(1:3)
      grid(1:3,9) = a3(1:3)-a1(1:3)
      do i=7,9
         grid(1:3,i+3) = -grid(1:3,i)
      end do
      grid(1:3,13) = a1(1:3)+a2(1:3)+a3(1:3)
      grid(1:3,14) = -grid(1:3,13)
      grid(1:3,15) = a1(1:3)+a2(1:3)
      grid(1:3,16) = -grid(1:3,15)

      do n=1,nsym
         isum = 0
         LOOP: do i=1,3
! ================================ added by K. Tagami ================
!!            x(1:3) = rot(1:3,1,n)*grid(1,i) &
!!                 & + rot(1:3,2,n)*grid(2,i) &
!!                 & + rot(1:3,3,n)*grid(3,i)
            if ( system == "cubic" ) then
!               x(1:3) = nint(ktrot(1:3,1,n)) *grid(1,i) &
!                    & + nint(ktrot(1:3,2,n)) *grid(2,i) &
!                    & + nint(ktrot(1:3,3,n)) *grid(3,i)
               x(1:3) = ktrot(1:3,1,n) *grid(1,i) &
                    & + ktrot(1:3,2,n) *grid(2,i) &
                    & + ktrot(1:3,3,n) *grid(3,i)
            else               ! hexagonal
               x(1:3) = ktrot(1:3,1,n) *grid(1,i) &
                    & + ktrot(1:3,2,n) *grid(2,i) &
                    & + ktrot(1:3,3,n) *grid(3,i)
            endif
! ====================================================================
            do j=1,16
               if(abs(x(1)-grid(1,j)) < eps .and. &
               &  abs(x(2)-grid(2,j)) < eps .and. &
               &  abs(x(3)-grid(3,j)) < eps ) then
                  isum = isum + i
                  cycle LOOP
! debug
!!               else
!!                 write(*,'("n=",i2,"i=",i2,"j=",i2," X=",3f10.5," G=",3f10.5)') n,i,j,x,grid(1:3,j)
! end debug
               end if
            end do
         end do LOOP
         if(isum/=6) flat(n) = .false.
      end do

      nlat=0
      do n=1,nsym
         if(flat(n)) then
            nlat = nlat+1
            nopr(nlat) = n
         end if
      end do
      
    end subroutine determine_lattice_point_group

    subroutine generate_point_group(system,nsym,rot)
    implicit none

    character(len=9), intent(in) :: system
    integer, intent(out) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,48)

    if(system .eq. 'cubic') then
      call cubic_point_group(nsym,rot)
    else if(system .eq. 'hexagonal') then
! ================================= added by K. Tagami ===
!      call hexagonal_point_group(nsym,rot)
      call hexagonal_point_group_bravais(nsym,rot)
! =======================================================
    else
      if(ipri>0) write(nfout,*) 'generate_point_group: system must be cubic or hexagonal.'
    end if

    end subroutine generate_point_group

    subroutine cubic_point_group(nsym,rot)
    implicit none

    integer, intent(out) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,48)
    real(kind=DP) :: tmprot(3,3,48),ainv(3,3)

    ! local variables
    real(kind=DP) :: one=1.d0, zero=0.d0
    integer :: i,j

    nsym=48

    rot(1:3,1:3,1:nsym)=zero

    ! C31+ = O5
    rot(1,3,5) = one
    rot(2,1,5) = one
    rot(3,2,5) = one

    ! C4x+ = O19
    rot(1,1,19) =  one
    rot(2,3,19) = -one
    rot(3,2,19) =  one

    do i=1,3
      rot(i,i,1) = one  ! E = O1
    end do
    do j=1,3
      do i=1,3
        rot(i,j,22) = rot(j,i,19)  ! C4x- = O22 = O19^t
        rot(i,j,9)  = rot(j,i,5)  ! C31- = O9 = O5^t
      end do
    end do

    call matrix_product(rot(1,1,19),rot(1,1,19),rot(1,1,2)) ! C2x = O2 = O19*O19
    call matrix_product(rot(1,1,5),rot(1,1,19),rot(1,1,13)) ! C2a = O13 = O5*O19
    call matrix_product(rot(1,1,19),rot(1,1,5),rot(1,1,15)) ! C2c = O15 = O19*O5

    call matrix_product(rot(1,1,2),rot(1,1,9),rot(1,1,10))  ! C32- = O10 = O2*O9
    call matrix_product(rot(1,1,13),rot(1,1,15),rot(1,1,11))! C33- = O11 = O13*O15
    call matrix_product(rot(1,1,9),rot(1,1,2),rot(1,1,12))  ! C34- = O12 = O9*O2
    call matrix_product(rot(1,1,2),rot(1,1,5),rot(1,1,8))   ! C34+ = O8 = O2*O5
    call matrix_product(rot(1,1,5),rot(1,1,2),rot(1,1,6))   ! C32+ = O6 = O5*O2
    call matrix_product(rot(1,1,15),rot(1,1,13),rot(1,1,7)) ! C31+ = O7 = O15*O13
    call matrix_product(rot(1,1,13),rot(1,1,2),rot(1,1,21)) ! C4z+ = O21 = O13*O2
    call matrix_product(rot(1,1,2),rot(1,1,13),rot(1,1,24)) ! C4z- = O24 = O2*O13
    call matrix_product(rot(1,1,15),rot(1,1,2),rot(1,1,23)) ! C4y- = O23 = O15*O2
    call matrix_product(rot(1,1,2),rot(1,1,15),rot(1,1,20)) ! C4y+ = O20 = O2*O15

    call matrix_product(rot(1,1,9),rot(1,1,7),rot(1,1,3))  ! C2y = O3 = O9*O7
    call matrix_product(rot(1,1,9),rot(1,1,8),rot(1,1,4))  ! C2z = O4 = O9*O8
    call matrix_product(rot(1,1,15),rot(1,1,6),rot(1,1,14)) ! C2b = O14 = O15*O6
    call matrix_product(rot(1,1,13),rot(1,1,7),rot(1,1,18)) ! C2f = O18 = O13*O7
    call matrix_product(rot(1,1,13),rot(1,1,8),rot(1,1,16)) ! C2d = O16 = O13*O8
    call matrix_product(rot(1,1,7),rot(1,1,24),rot(1,1,17)) ! C2e = O17 = O7*O24

    do i=1,24
      rot(1:3,1:3,i+24) = -rot(1:3,1:3,i) ! add inversion
    end do

!!  to fractional
    call mat3inv(altv,ainv)
    call set_drot(altv,ainv,nsym,rot,tmprot)
    rot = tmprot
    end subroutine cubic_point_group

    subroutine hexagonal_point_group(nsym,rot)
    implicit none

    integer, intent(out) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,48)

    ! local variables
    real(kind=DP) :: one=1.d0, zero=0.d0, half=0.5d0, r32
    integer :: i,j

    r32=sqrt(3.d0)*0.5d0

    nsym=24

    rot(1:3,1:3,1:nsym)=zero

    ! C6+ = O2
    rot(1,1,2) =  half
    rot(1,2,2) = -r32
    rot(2,1,2) =  r32
    rot(2,2,2) =  half
    rot(3,3,2) =  one

    ! C222 = O11
    rot(1,1,11) = -half
    rot(1,2,11) = -r32
    rot(2,1,11) = -r32
    rot(2,2,11) =  half
    rot(3,3,11) = -one


    do i=1,3
      rot(i,i,1) = one  ! E = O1
    end do

    do j=1,3
      do i=1,3
        rot(i,j,6) = rot(j,i,2)  ! C6- = O6 = O2^t
      end do
    end do
    call matrix_product(rot(1,1,2),rot(1,1,2),rot(1,1,3))   ! C3+ = O3 = O2*O2
    call matrix_product(rot(1,1,2),rot(1,1,11),rot(1,1,9))  ! C231 = O9 = O2*O11
    call matrix_product(rot(1,1,11),rot(1,1,2),rot(1,1,7))  ! C211 = O7 = O11*O2

    do j=1,3
      do i=1,3
        rot(i,j,5) = rot(j,i,3)  ! C3- = O5 = O3^t
      end do
    end do
    call matrix_product(rot(1,1,2),rot(1,1,3),rot(1,1,4))  ! C2 = O4 = O2*O3
    call matrix_product(rot(1,1,2),rot(1,1,9),rot(1,1,10)) ! C212 = O10 = O2*O9
    call matrix_product(rot(1,1,7),rot(1,1,3),rot(1,1,8))  ! C221 = O8 = O7*O3
    call matrix_product(rot(1,1,7),rot(1,1,2),rot(1,1,12)) ! C232 = O12 = O7*O2

    do i=1,12
      rot(1:3,1:3,i+12) = -rot(1:3,1:3,i) ! add inversion
    end do

    end subroutine hexagonal_point_group

! ============================== Added by K. Tagami ============
    subroutine hexagonal_point_group_bravais(nsym,rot)  ! in Bravais Lattice
    implicit none

    integer, intent(out) :: nsym
    real(kind=DP), intent(out) :: rot(3,3,48)

    ! local variables
    real(kind=DP) :: one=1.d0, zero=0.d0
    integer :: i,j

    nsym=24

    rot(1:3,1:3,1:nsym)=zero

    do i=1,3
      rot(i,i,1) = one  ! E = O1
    end do

    ! C6+ = O2
    rot(1,1,2) =  one;    rot(1,2,2) = -one
    rot(2,1,2) =  one;    rot(3,3,2) = one

    !C3+ = O3
    rot(1,2,3) = -one;     rot(2,1,3) = one;
    rot(2,2,3) = -one;     rot(3,3,3) = one

    !C2 = O4
    rot(1,1,4) = -one;     rot(2,2,4) = -one;   rot(3,3,4) = one

    !C3- = O5
    rot(1,1,5) = -one;     rot(1,2,5) = one;
    rot(2,1,5) = -one;     rot(3,3,5) = one

    !C6- = O6
    rot(1,2,6) = one;   rot(2,1,6) = -one;
    rot(2,2,6) = one;    rot(3,3,6) = one

    !C211 = O7
    rot(1,1,7) = -one;   rot(1,2,7) = one
    rot(2,2,7) =  one;   rot(3,3,7) = -one

    !C221 = O8
    rot(1,1,8) = one;  rot(2,1,8) = one
    rot(2,2,8) = -one;  rot(3,3,8) = -one

    !C231 = O9
    rot(1,2,9) = -one;  rot(2,1,9) = -one;  rot(3,3,9) = -one

    !C212 = C10
    rot(1,1,10) = one;  rot(1,2,10) = -one
    rot(2,2,10) = -one;  rot(3,3,10) = -one

    !C222 = C11
    rot(1,1,11) = -one;  rot(2,1,11) = -one
    rot(2,2,11) = one;   rot(3,3,11) = -one

    !C232 = C12
    rot(1,2,12) = one;   rot(2,1,12) = one;     rot(3,3,12) = -one

    do i=1,12
      rot(1:3,1:3,i+12) = -rot(1:3,1:3,i) ! add inversion
    end do

    end subroutine hexagonal_point_group_bravais
! ===============================================================

    subroutine matrix_product(a,b,c)
    implicit none

    real(kind=DP), intent(in) :: a(3,3),b(3,3)
    real(kind=DP), intent(out) :: c(3,3)

    ! local variables
    integer :: i,j

    do j=1,3
      do i=1,3
        c(i,j) = sum(a(i,1:3)*b(1:3,j))
      end do
    end do

    return
    end subroutine matrix_product


    subroutine print_rot(nsym,rot,flat)
    implicit none

    integer, intent(in) :: nsym
    real(kind=DP), intent(in) :: rot(3,3,nsym)
    logical, intent(in) :: flat(48)

    !local variables
    integer :: i, n

    n = 0
    do i=1,nsym
      if(.not.flat(i)) cycle
      n = n+1
      write(nfout,'(5x,3(f10.5,1x))')             rot(1,1:3,i)
      write(nfout,'("n=",i2,1x,3(f10.5,1x))') n, rot(2,1:3,i)
      write(nfout,'(5x,3(f10.5,1x))')             rot(3,1:3,i)
      write(nfout,*)
    end do

    end subroutine print_rot

    subroutine determine_space_group(a1,a2,a3,ntype,natom,itype,apos,nsym,nopr,rot,tau,flat,nprim,tprim)
    implicit none

    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    integer, intent(in) :: ntype,natom,itype(natom)
    real(kind=DP), intent(in) :: apos(natom,3)
    integer, intent(inout) :: nsym
    integer, intent(out) :: nopr(48)
    real(kind=DP), intent(inout) :: rot(3,3,48)
    real(kind=DP), intent(out) :: tau(3,48)
    logical, intent(in) :: flat(48)
    integer, intent(out) :: nprim
    real(kind=DP), intent(out) :: tprim(3,natom)

    ! local variables
! ================================= Usami ===========
!    real(kind=DP) :: ft(3,natom,natom,48)  ! fractional trnsformations
!    integer       :: lp(3,natom,natom,48)  ! lattice point vectors
!    integer :: f(natom,48),fi(natom,48),fp0(natom),fp1(natom) ! atom transformations
    real(kind=DP), allocatable :: ft(:,:,:,:)
    integer      , allocatable :: lp(:,:,:,:)
    integer, allocatable ::   f(:,:),fi(:,:), fp0(:), fp1(:)
! ===================================================
    real(kind=DP) :: sympos(natom,3)
    integer :: i,j,k,l,n,m,npg
    real(kind=DP) :: x(3),y(3),z(3)
    real(kind=DP) :: a(3,3),ainv(3,3)
    real(kind=DP) :: trans(3)
    real(kind=DP) :: r(3,3),t(3),tmp
    real(kind=DP) :: tt(3)
    integer :: ir(3,3)
    integer :: ntrans(3)
    integer :: isum
    logical :: fsym(48)
    integer :: icount
    integer :: iptab(48,48)
    integer :: mpos, isym
    logical :: fpos(48)
    integer :: irot(3,3,48)
    
    real(kind=DP) :: eps=1.d-8
    real(kind=DP) :: eps2=1.d-6
    real(kind=DP) :: mis2,d(3)
! ============================ added by K. Tagami ==========
!!!!!!    real(kind=DP) :: ktrot(3,3,48) , p2bmat(3,3)
    real(kind=DP) :: ktrot(3,3,48) 
    real(kind=DP) :: d1
    real(kind=DP) :: c1, c2, c3
    integer :: ierr1, ierr2, ierr3
! ============================ Usami ============
    allocate( ft(3,natom,natom,48), lp(3,natom,natom,48) )
    allocate( f(natom,48), fi(natom,48),fp0(natom),fp1(natom) )
! =============================================================

    mis2 = misalignment**2

    a(1:3,1) = a1(1:3)
    a(1:3,2) = a2(1:3)
    a(1:3,3) = a3(1:3)
    call mat3inv(a,ainv)

!================================ added by Katunori Tagami =========
!!    call set_irot(a,ainv,nsym,rot,irot)
!!!!!!!!!!!!!    Call mat3inv( b2pmat, p2bmat )
!!!!!!    call set_drot( b2pmat, p2bmat, nsym,rot,ktrot )
    call set_drot( kt_b2pmat, kt_p2bmat, nsym,rot,ktrot )
!    if ( system == "cubic" ) then
!       ktrot(:,:,:) = nint(ktrot(:,:,:))
!    endif
! ==================================================================

!    write(910,*) 'DEBUG a =='
!    write(910,*) ktrot(1,1,4), ktrot(1,2,4), ktrot(1,3,4)
!    write(910,*) ktrot(2,1,4), ktrot(2,2,4), ktrot(2,3,4)
!    write(910,*) ktrot(3,1,4), ktrot(3,2,4), ktrot(3,3,4)

    ! make fractional trnsformations, ft(), and lattice point vectors, lp()
    do j=1,natom
      !!$y(1:3) = a1(1:3)*apos(j,1) + a2(1:3)*apos(j,2) + a3(1:3)*apos(j,3)
      y = apos(j,1:3)
      do i=1,natom
        !!$x(1:3) = a1(1:3)*apos(i,1) + a2(1:3)*apos(i,2) + a3(1:3)*apos(i,3)
        x = apos(i,1:3)
        do n=1,nsym
          if(.not.flat(n)) cycle

          !!z(1:3) = rot(1:3,1,n)*x(1)+rot(1:3,2,n)*x(2)+rot(1:3,3,n)*x(3)

!================================ added by Katunori Tagami =========
!!          z(1:3) = matmul(irot(:,:,n),x)
          z(1:3) = matmul( ktrot(:,:,n),x)
! ==================================================================
          !!z(1:3) = y(1:3)-z(1:3)

          ! remove primitive transformation
          !!trans(1:3) = ainv(1:3,1)*z(1)+ainv(1:3,2)*z(2)+ainv(1:3,3)*z(3)

          trans(1:3) = y(1:3)-z(1:3)
          ft(1:3,i,j,n) = trans(1:3) ! in the system a1,a2,a3
          call mod1(ft(1,i,j,n))
          lp(1:3,i,j,n) = nint(trans(1:3)-ft(1:3,i,j,n))
        end do
      end do
    end do

    ! debug
    !!write(nfout,*) 'fractional trasformations and lattice point vectors:'
    !!do j=1,natom
    !!  do i=1,natom
    !!    do n=1,nsym
    !!      if(.not.flat(n)) cycle
    !!      write(nfout,'(3(1x,i2),3(1x,f10.5),3(1x,3i))') i,j,n,ft(1:3,i,j,n),lp(1:3,i,j,n)
    !!    end do
    !!  end do
    !!end do
    ! end debug

    !!$write(*,'("max of isum=",i4)') natom*(natom+1)/2

    npg=0
    fsym(1:nsym)=.false.
    f(1:natom,1:nsym) = 0
    tau(1:3,1:nsym) = 0.d0
    do n=1,nsym
      if(.not.flat(n)) cycle
      loop_l: do l=1,natom
        loop_k: do k=1,natom
          if(itype(k).ne.itype(l)) cycle loop_k
          isum=0
          loop_j: do j=1,natom
            loop_i: do i=1,natom
              if(itype(i).ne.itype(j)) cycle loop_i
              if(abs(ft(1,i,j,n)-ft(1,k,l,n)) > eps2 .or. &
               & abs(ft(2,i,j,n)-ft(2,k,l,n)) > eps2 .or. &
               & abs(ft(3,i,j,n)-ft(3,k,l,n)) > eps2 ) then
              ! experimental 
              !!$d = matmul(altv,ft(1:3,i,j,n)-ft(1:3,k,l,n))
              !!$if(sum(d(1:3)**2) > mis2) then
              ! end experimental
                 cycle loop_i
              end if
              f(k,n) = l
              fi(l,n) = k
              isum = isum + i
              if(isum .eq. natom*(natom+1)/2) then
                if(fsym(n).and.n==1) then
                   do m=1,nprim
                      if(sum(abs(ft(1:3,k,l,n)-tprim(1:3,m)))<eps2) then
                      ! experimental 
                      !!$d = matmul(altv,ft(1:3,k,l,n)-tprim(1:3,m))
                      !!$if(sum(d(1:3)**2) < mis2) then
                      ! end experimental
                         go to 100 
                      end if
                   end do
                   nprim = nprim + 1
                   tprim(1:3,nprim) = ft(1:3,k,l,n)
                   fp0(nprim) = k
                   fp1(nprim) = l
100                continue
                else
                   fsym(n) = .true.
                   npg = npg + 1
                   tau(1:3,n) = ft(1:3,k,l,n)
                   if(n==1) then
                      nprim = 1
                      tprim(1:3,nprim) = ft(1:3,k,l,n)
                      fp0(nprim) = k
                      fp1(nprim) = l
                   else
                      exit loop_l
                   end if
                end if
                exit loop_j
              end if
            end do loop_i
          end do loop_j
          !!$write(*,'("n=",i2,"l=",i2,"k=",i2,"isum=",i4,"d=",3f10.5)') n,l,k,isum,ft(1:3,k,l,n)
        end do loop_k
      end do loop_l
    end do
! debug
!!    do i=1,nsym
!!       write(*,'(i2,2l)') i,flat(i),fsym(i)
!!    end do
! end debug

    ! debug
    !!$write(nfout,*) 'atom trasformation table:'
    !!$do i=1,natom
    !!$  do n=1,nsym
    !!$    !!$if(.not.flat(n)) cycle
    !!$    if(.not.fsym(n)) cycle
    !!$    write(nfout,'(1x,i2,":",1x,i2,"->",1x,i2," : ",3(1x,f10.5),3(1x,i3))') n,i,f(i,n),tau(1:3,n),lp(1:3,i,f(i,n),n)
    !!$  end do
    !!$end do
    ! end debug

    do i=1,nprim
       do j=1,3
          tprim(j,i) = rational(tprim(j,i))
       end do
    end do

    if(ipri>1.and.nprim > 1) then
       write(nfout,'("=== Primitive translations ===")')
       do i=2,nprim
          write(nfout,'(i4,3(1x,f10.5),1x,a)') i-1,tprim(1:3,i),get_lattice_point_name(tprim(1,i))
       end do
    end if


    i=0
! =================================== Modified by K. Tagami =========
!    do n=1,nsym
!       if(.not.fsym(n)) cycle
!       i=i+1
!       nopr(i) = n
!       rot(1:3,1:3,i) = rot(1:3,1:3,n)
!       !!$tau(1:3,i) = tau(1:3,n)
!       do j=1,3
!          tau(j,i) = rational(tau(j,n))
!       end do
!    end do
! ================================
    do n=1,nsym
       if(.not.fsym(n)) cycle
!
       call ktrational( tau(1,n), c1, ierr1 )
       call ktrational( tau(2,n), c2, ierr2 )
       call ktrational( tau(3,n), c3, ierr3 )
!
       if ( ierr1+ierr2+ierr3 < 0 ) then
          fsym(n) = .false.
          cycle
       endif
!
       i=i+1
       nopr(i) = n
       rot(1:3,1:3,i) = rot(1:3,1:3,n)

       tau(1,i) = c1;        tau(2,i) = c2;        tau(3,i) = c3
    end do
! =========================================================================
    nsym = i
    if(nsym == 1) return

    call set_product_table(iptab,nprim,tprim)

    loop_0: do i=2,nsym
       fsym(1:nsym) = .false.
       do n=1,nsym
          if(iptab(n,i) > 0) fsym(n) = .true.
       end do
       do n=2,nsym
          if(.not.fsym(n)) cycle
          loop_2: do m=2,nsym
             if(.not.fsym(m)) cycle
             do l=1,nsym
                if(.not.fsym(l)) cycle
                if(l == iptab(n,m)) exit loop_2
             end do
             cycle loop_0
          end do loop_2
       end do
       fpos(i) = .true.
    end do loop_0

    mpos = 0
    do i=2,nsym            
       if(.not.fpos(i)) cycle
       m = 0
       do n=1,nsym
          if(iptab(n,i)>0) m = m + 1
       end do
       if(m>mpos) isym = i
    end do
       
    i=0
    do n=1,nsym
       if(iptab(n,isym)<1) cycle
       i=i+1
       nopr(i) = nopr(n)
       rot(1:3,1:3,i) = rot(1:3,1:3,n)
       do m=1,nprim
          tt(1:3) = tau(1:3,n)-tprim(1:3,m)
          call mod1(tt)
          if(sum(abs(tt(1:3))) < eps2) then
          ! experimental
          !!$d = matmul(altv,tt)
          !!$if(sum(d(1:3)**2) < mis2) then
          ! end experimental
            tau(1:3,i) = 0.d0
          else
            tau(1:3,i) = tau(1:3,n)
          end if
       end do
    end do
    nsym = i

    !!$call set_product_table(iptab,nprim,tprim)
    !!$stop 'determine_space_group: debug'
! =============================================== Usami ==========
    deallocate( ft,lp )
    deallocate( f, fi, fp0, fp1 )
! ==============================================================
    end subroutine determine_space_group

    subroutine mat3inv(mat,matinv)
    implicit none

    real(kind=DP), intent(in)  :: mat(3,3)
    real(kind=DP), intent(out) :: matinv(3,3)

    ! local variables
    real(kind=DP) :: det
    integer :: i,j,i1,i2,j1,j2

    det=0.d0
    do i=1,3
      do j=1,3
        i1=mod(i,3)+1
        i2=mod(i+1,3)+1
        j1=mod(j,3)+1
        j2=mod(j+1,3)+1
        matinv(j,i)=mat(i1,j1)*mat(i2,j2)-mat(i1,j2)*mat(i2,j1)
      end do
      det=det+mat(i,1)*matinv(1,i)
    end do
    do i=1,3
      do j=1,3
        matinv(i,j)=matinv(i,j)/det
      end do
    end do

    return
    end subroutine mat3inv
    
    subroutine set_irot(a,ainv,nsym,rot,irot)
      real(kind=DP), intent(in) :: a(3,3),ainv(3,3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      integer, intent(out) :: irot(3,3,nsym)

      integer :: n
      do n=1,nsym
         irot(1:3,1:3,n) = nint(matmul(ainv,matmul(rot(:,:,n),a)))
      end do
    end subroutine set_irot

! ================================ Added by K. Tagami =========
    subroutine set_drot( a,ainv,nsym,rot,drot )
      real(kind=DP), intent(in) :: a(3,3),ainv(3,3)
      integer, intent(in) :: nsym
      real(kind=DP), intent(in) :: rot(3,3,nsym)
      real(kind=DP), intent(out) :: drot(3,3,nsym)

      integer :: n
      do n=1,nsym
         drot(1:3,1:3,n) = matmul(ainv,matmul(rot(:,:,n),a))
      end do
    end subroutine set_drot
! ==============================================================

    subroutine set_product_table(iptab,nprim,tprim)
      integer, intent(out) :: iptab(48,48)
      integer, intent(in)  :: nprim
      real(kind=DP), intent(in) :: tprim(3,natom)

      integer :: i,j,k,l,m,n
! ============================= Added by K. Tagami ==============
!      integer :: irot(3,3,48),ir(3,3)
!!!!!!!!      real(kind=DP) :: drot(3,3,48), dr(3,3),  p2bmat(3,3)
      real(kind=DP) :: drot(3,3,48), dr(3,3)
! ===============================================================
      real(kind=DP) :: t(3),tt(3),tmp

      real(kind=DP), parameter :: eps  = 1.d-8
      real(kind=DP), parameter :: eps2 = 1.d-6
      real(kind=DP) :: mis2,d(3)

      mis2 = misalignment**2

      if(ipri>1) then
! =================================== Added by K. Tagami ======
!         write(nfout,'("irot:")')
         write(nfout,'("drot:")')
! ====================================================================
      end if
! ================================ Added by K. Tagami =========
!!!!!!!!      Call mat3inv( b2pmat, p2bmat )
!!!      call set_drot( b2pmat, p2bmat, nsym,rot, drot )
      call set_drot( kt_b2pmat, kt_p2bmat, nsym,rot, drot )
! ============================================================
      do i=1,nsym
!         do n=1,3
!            do m=1,3
!               tmp = 0.d0
!               do k=1,3
!                  do l=1,3
!                     tmp = tmp + rltv(k,m)*rot(k,l,i)*altv(l,n)
!                  end do
!               end do
!!!               irot(m,n,i) = nint(tmp/PAI2)
!            end do
!         end do
         if(ipri>1) then
! =================================== Added by K. Tagami ======
!            write(nfout,'(10(1x,i2))') i,irot(1:3,1:3,i)
             write(nfout,'(i2,9F8.4)') i, drot(1:3,1:3,i)
! ====================================================================
         end if
      end do

      do j=1,nsym
         LOOP: do i=1,nsym
            do k=1,3
! =================================== Added by K. Tagami ======
!!!!!               t(k) = sum(irot(k,1:3,i)*tau(1:3,j)) + tau(k,i)
               t(k) = sum( drot(k,1:3,i)*tau(1:3,j) ) + tau(k,i)
! ====================================================================
               do l=1,3
! =================================== Added by K. Tagami ======
!!!                  ir(k,l) = sum(irot(k,1:3,i)*irot(1:3,l,j))
                  dr(k,l) = sum( drot(k,1:3,i)*drot(1:3,l,j) )
! ====================================================================
               end do
            end do
            call mod1(t)
            ! debug
            !write(nfout,'(11(1x,i2),3(1x,f10.5))') i,j,ir(1:3,1:3),t(1:3)
            ! end debug
            do k=1,nsym
! =================================== Added by K. Tagami ======
!!!               if(sum(abs(ir(1:3,1:3)-irot(1:3,1:3,k))) < eps2) then
               if ( sum(abs(dr(1:3,1:3)-drot(1:3,1:3,k))) < eps2) then
! ====================================================================
                do l=1,nprim
                   tt(1:3) = t(1:3)-tau(1:3,k)-tprim(1:3,l)
                   call mod1(tt)
                   if(sum(abs(tt(1:3))) < eps2) then
                   ! experimental
                   !!$d = matmul(altv,tt)
                   !!$if(sum(d(1:3)**2) < mis2) then
                   ! end experimental
                      iptab(i,j) = k
                      cycle LOOP
                   end if
                 end do
               end if
            end do
            !!$write(nfout,'("Missing operation?")')
            !!$write(nfout,'(11(1x,i2),3(1x,f10.5))') i,j,ir(1:3,1:3),t(1:3)
            !!$stop 'set_product_table: missing operation'
            iptab(i,j) = 0
         end do LOOP
      end do

      if(ipri>1) then
         write(nfout,'("Product table:")')
         do i=1,nsym
            write(nfout,'(48(1x,i2))') iptab(i,1:nsym)
         end do
      end if
            !!$stop 'set_product_table: debug'
            
    end subroutine set_product_table

    function get_lattice_point_name(tprim) result(name)
      real(kind=DP), intent(in) :: tprim(3)
      character(15) :: name

      real(kind=DP) :: eps = 1.d-6
      real(kind=DP) :: mis2,d(3)

      mis2 = misalignment**2
 
      name = ''
      if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)) < eps ) then 
         name = 'c-face centered'
      else if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'b-face centered'
      else if(abs(tprim(1)) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'a-face centered'
      else if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'body centered'
      end if

      ! experimental
      !!$name = 'c-face centered'
      !!$d = (/ 0.5d0, 0.5d0, 0.d0 /)
      !!$d = matmul(altv,tprim-d)
      !!$if(sum(d(1:3)**2) < mis2) return
      !!$name = 'b-face centered'
      !!$d = (/ 0.5d0, 0.d0, 0.5d0 /)
      !!$d = matmul(altv,tprim-d)
      !!$if(sum(d(1:3)**2) < mis2) return
      !!$name = 'a-face centered'
      !!$d = (/ 0.d0, 0.5d0, 0.5d0 /)
      !!$d = matmul(altv,tprim-d)
      !!$if(sum(d(1:3)**2) < mis2) return
      !!$name = 'body centered'
      !!$d = (/ 0.5d0, 0.5d0, 0.5d0 /)
      !!$d = matmul(altv,tprim-d)
      !!$if(sum(d(1:3)**2) < mis2) return
      !!$name = ''
      ! end experimental
         
    end function get_lattice_point_name

  end subroutine space_group

  subroutine print_prim_trans(nfout,ipri,nprim,tprim)
    integer, intent(in) :: nfout,ipri,nprim
    real(kind=DP) :: tprim(3,nprim)

    integer :: i

    if(ipri>0 .and. nprim > 1) then
       write(nfout,'("=== Primitive translations ===")')
       do i=2,nprim
          write(nfout,'(i4,3(1x,f10.5),1x,a)') i-1,tprim(1:3,i),get_lattice_point_name(tprim(1,i))
       end do
    end if 
  contains
    function get_lattice_point_name(tprim) result(name)
      real(kind=DP), intent(in) :: tprim(3)
      character(15) :: name

      real(kind=DP) :: eps = 1.d-6
 
      name = ''
      if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)) < eps ) then 
         name = 'c-face centered'
      else if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'b-face centered'
      else if(abs(tprim(1)) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'a-face centered'
      else if(abs(tprim(1)-0.5d0) < eps .and. &
       & abs(tprim(2)-0.5d0) < eps .and. &
       & abs(tprim(3)-0.5d0) < eps ) then
         name = 'body centered'
      end if

    end function get_lattice_point_name

  end subroutine print_prim_trans

  subroutine print_space_group(nfout,system,nsym,nopr,rot,tau)
    implicit none

    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(nsym)
    real(kind=DP), intent(in) :: rot(3,3,nsym)
    real(kind=DP), intent(in) :: tau(3,nsym)
! ============================ added by K. Tagami =======
    real(kind=DP) :: taub(3,nsym), p2bmat(3,3), c1
! ============================================================

    ! local variables
    integer :: i

    if(.not.printable) return
! ===================================== added by K. Tagami ======
!!!!!!!!!!!!!!    taub = matmul( b2pmat, tau )
    taub = matmul( kt_b2pmat, tau )
! ~==============================================================
    if(system .eq. 'cubic') then
      do i=1,nsym
! ===================================== added by K. Tagami ======
!        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(1,1:3,i),tau(1,i)
!        write(nfout,'(i2,1x,a5,3(1x,f10.5),2x,f10.5)') i,oh(nopr(i)),rot(2,1:3,i),tau(2,i)
!        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(3,1:3,i),tau(3,i)
! ==
        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(1,1:3,i),taub(1,i)
        write(nfout,'(i2,1x,a5,3(1x,f10.5),2x,f10.5)') i,oh(nopr(i)),rot(2,1:3,i),taub(2,i)
        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(3,1:3,i),taub(3,i)
! ========================================================
        write(nfout,*)
      end do
    else
      do i=1,nsym
! ===================================== added by K. Tagami ======
!        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(1,1:3,i),tau(1,i)
!        write(nfout,'(i2,1x,a5,3(1x,f10.5),2x,f10.5)') i,d6h(nopr(i)),rot(2,1:3,i),tau(2,i)
!        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(3,1:3,i),tau(3,i)
!
        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(1,1:3,i),taub(1,i)
        write(nfout,'(i2,1x,a5,3(1x,f10.5),2x,f10.5)') i,d6h(nopr(i)),rot(2,1:3,i),taub(2,i)
        write(nfout,'(8x,3(1x,f10.5),2x,f10.5)') rot(3,1:3,i),taub(3,i)
! ===============================================================
        write(nfout,*)
      end do
    end if
  end subroutine print_space_group


  subroutine set_af_operator(nfout,ipri,system &
                            & ,nsym_af,nopr_af,rot_af,tau_af,nprim_af,tprim_af &
                            & ,nsym,nopr,rot,tau,nprim,tprim)
    implicit none
    integer, intent(in) :: nfout,ipri
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym_af,nsym,nprim_af,nprim
    integer, intent(in) :: nopr_af(48)
    real(kind=DP), intent(in) :: rot_af(3,3,49),tau_af(3,49)
    real(kind=DP), intent(in) :: tprim_af(3,nprim_af),tprim(3,nprim)
    real(kind=DP), intent(inout) :: rot(3,3,48),tau(3,48)
    integer, intent(out) :: nopr(48)

    integer :: i,j,k,iaf,n
    real(kind=DP) :: r(3,3,24),t(3,24)
    logical :: faf(nsym_af),flag(nsym_af)
    real(kind=DP), parameter :: eps=1.d-8

    faf(1:nsym_af) = .true.
    n=0
    do iaf=1,nsym_af
      do i=1,nsym
         if(sum(abs(rot_af(1:3,1:3,iaf)-rot(1:3,1:3,i))) < eps &
           & .and. sum(abs(tau_af(1:3,iaf)-tau(1:3,i))) < eps) then
           n = n + 1
           faf(iaf) = .false.
         end if
      end do
    end do
    if(nsym_af .ne. 2*n) then
       if(nprim_af .gt. nprim) then
          iaf = 1
          do i=1,nprim
             do j=1,nprim_af
                if(sum(abs(tprim(1:3,i)-tprim_af(1:3,j))) > eps) then
                   nopr(nsym+1) = nopr_af(iaf)
                   rot(:,:,nsym+1) = rot_af(:,:,iaf)
                   tau(:,nsym+1) = tprim_af(:,j)
                   go to 1000
                end if
             end do
          end do
          stop 'AF translation was not found.'
       else
          stop 'nsym_af .ne. 2*n and nprim_af .le. nprim'
       end if
1000   continue
    else
       LOOP: do iaf=1,nsym_af
          if(faf(iaf)) then
             do i=1,nsym
                do j=1,3
                   do k=1,3
                      r(j,k,i) = sum(rot_af(j,:,iaf)*rot(:,k,i))
                   end do
                   t(j,i) = sum(rot_af(j,:,iaf)*tau(:,i)) + tau_af(j,iaf)
                end do
             end do
             flag(1:nsym_af) = .true.
             do i=1,nsym
                do j=1,nsym_af
                   if(faf(j)) then
                      if(sum(abs(rot_af(1:3,1:3,iaf)-r(1:3,1:3,i))) < eps &
                   & .and. sum(abs(tau_af(1:3,iaf)-t(1:3,i))) < eps) then
                         flag(j) = .false.
                      end if
                   end if
                end do
             end do
             do j=1,nsym_af
                if(faf(j).and.flag(j)) cycle LOOP
             end do
             nopr(nsym+1) = nopr_af(iaf)
             rot(:,:,nsym+1) = rot_af(:,:,iaf)
             tau(:,nsym+1) = tau_af(:,iaf)
             if(ipri>0) then
                write(nfout,'(" af operator is found. iaf = ",i8)') iaf
             end if
             exit LOOP
          end if
       end do LOOP
    end if

    if(ipri>0) then
      write(nfout,'("AF operator:")')
      call print_space_group(nfout,system,1,nopr(nsym+1),rot(1,1,nsym+1),tau(1,nsym+1))
    end if

  end subroutine set_af_operator

! =============================== Added by K. Tagami ==== 1.0 ==
  subroutine set_af_operator_kt(nfout,ipri,system &
                       & ,nsym_af,nopr_af,rot_af,tau_af,nprim_af,tprim_af &
                       & ,nsym,nopr,rot,tau,nprim,tprim )
    implicit none
    integer, intent(in) :: nfout,ipri
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym_af,nsym,nprim_af,nprim
    integer, intent(in) :: nopr_af(49)
    real(kind=DP), intent(in) :: rot_af(3,3,49),tau_af(3,49)
    real(kind=DP), intent(in) :: tprim_af(3,nprim_af),tprim(3,nprim)
    real(kind=DP), intent(inout) :: rot(3,3,49),tau(3,49)
    integer, intent(out) :: nopr(49)
    integer, parameter :: DEBUGPRINTLEVEL = 2

    integer :: i,j,k,iaf,n
    real(kind=DP) :: r(3,3,24),t(3,24)
    logical :: faf(nsym_af),flag(nsym_af)
    real(kind=DP), parameter :: eps=1.d-8
! ------------------
    integer :: jfound
!!$    real(kind=DP) :: c1, kt_i, kt_j
    integer ::  kt_i, kt_j
! -------------------

    faf(1:nsym_af) = .true.
    n=0
    do iaf=1,nsym_af
      do i=1,nsym
         if(sum(abs(rot_af(1:3,1:3,iaf)-rot(1:3,1:3,i))) < eps &
           & .and. sum(abs(tau_af(1:3,iaf)-tau(1:3,i))) < eps) then
           n = n + 1
           faf(iaf) = .false.
         end if
      end do
    end do
    if(ipri>=DEBUGPRINTLEVEL) then
       do iaf = 1, nsym_af
          if(faf(iaf)) then
             write(nfout,'(" faf(",i3,") = .true.")') iaf
          else
             write(nfout,'(" faf(",i3,") = .false.")') iaf
          end if
       end do
    end if
    if(nsym_af .ne. 2*n) then
       if(nprim_af .gt. nprim) then
          iaf = 1
! ------------------------------------------
          do j=1,nprim_af
             jfound = 0
             do i=1,nprim
                if( abs(tprim(1,i)-tprim_af(1,j)) < eps &
                   .and.abs(tprim(2,i)-tprim_af(2,j)) < eps &
                   .and.abs(tprim(3,i)-tprim_af(3,j)) < eps ) then
                   jfound = 1
                endif
             end do
             if ( jfound == 0 ) then
                nopr(nsym+1) = nopr_af(iaf)
                rot(:,:,nsym+1) = rot_af(:,:,iaf)
                tau(:,nsym+1) = tprim_af(:,j)
                go to 1000
             end if
          end do
! ------------------------------------------
          stop 'AF translation was not found.'
       else
          stop 'nsym_af .ne. 2*n and nprim_af .le. nprim'
       end if
1000   continue
    else
! --------------------- first try : E-symmetry ----
      iaf = 1
      do kt_j=1,nprim_af
        jfound = 0
        do kt_i=1,nprim
          if( abs(tprim(1,kt_i)-tprim_af(1,kt_j)) < eps &
              .and.abs(tprim(2,kt_i)-tprim_af(2,kt_j)) < eps &
              .and.abs(tprim(3,kt_i)-tprim_af(3,kt_j)) < eps ) then
            jfound = 1
          endif
        end do
        if ( jfound == 0 ) then
          nopr(nsym+1) = nopr_af(iaf)
          rot(:,:,nsym+1) = rot_af(:,:,iaf)
          tau(:,nsym+1) = tprim_af(:,kt_j)
          goto 2000
        end if
      end do
! ------------------------- next try --------
       LOOP: do iaf=1, nsym_af
          if(faf(iaf)) then
             do i=1, nsym
                do j=1,3
                   do k=1,3
                      r(j,k,i) = sum(rot_af(j,:,iaf)*rot(:,k,i))
                   end do
                   t(j,i) = sum(rot_af(j,:,iaf)*tau(:,i)) + tau_af(j,iaf)
                end do
             end do
             flag(1:nsym_af) = .true.
             do i=1, nsym
                do j=1, nsym_af
                   if(faf(j)) then
                      if(sum(abs(rot_af(1:3,1:3,iaf)-r(1:3,1:3,i))) < eps &
                   & .and. sum(abs(tau_af(1:3,iaf)-t(1:3,i))) < eps) then
                         flag(j) = .false.
                      end if
                   end if
                end do
             end do
             do j=1, nsym_af
                if(faf(j).and.flag(j)) cycle LOOP
             end do
             nopr(nsym+1) = nopr_af(iaf)
             rot(:,:,nsym+1) = rot_af(:,:,iaf)
             tau(:,nsym+1) = tau_af(:,iaf)
             exit LOOP
          end if
       end do LOOP
! ----------------------------------------------
2000  continue
    end if
    if(ipri>0) then
      write(nfout,'("AF operator:")')

      call print_space_group(nfout,system,1,nopr(nsym+1),rot(1,1,nsym+1),tau(1,nsym+1))
    end if

  end subroutine set_af_operator_kt
! =================================================================


  subroutine set_tspace_generators(nfout,ipri,nsym,nopr,rot,tau,natom,nprim,tprim)
    implicit none
    integer, intent(in) :: nfout,ipri
    integer, intent(in) :: nsym,nopr(49)
    real(kind=DP), intent(in) :: rot(3,3,49),tau(3,49)
    integer, intent(in) :: natom,nprim
    real(kind=DP), intent(in) :: tprim(3,natom)

    integer :: iptab(nsym,nsym)
    integer :: ng,ig(3)

    call set_product_table
    call search_generators
    call set_generators
! ============================ K. Tagami ==== Unknown ============
!!!!!    if(nprim>1) call set_translations_zero
! ===========================================================

  contains
    subroutine set_product_table
      integer :: i,j,k,l,m,n
! =============================== Added by K. Tagami ========
!      integer :: irot(3,3,48),ir(3,3)
!!!!!!!!!      real(kind=DP) :: drot(3,3,48),dr(3,3), p2bmat(3,3)
      real(kind=DP) :: drot(3,3,48),dr(3,3)
! ===========================================================
      real(kind=DP) :: t(3),tt(3),tmp
      real(kind=DP), parameter :: eps = 1.d-6

      if(ipri>1) then
! =============================== Added by K. Tagami ========
!         write(nfout,'("irot:")')
         write(nfout,'("drot2:")')
! ===========================================================
      end if
! ============================== Added by K. Tagami ========
!!!!!!!!!!      Call mat3inv( b2pmat, p2bmat )
! =========================================================
      do i=1,nsym
         do n=1,3
            do m=1,3
               tmp = 0.d0
               do k=1,3
                  do l=1,3
! ============================== Added by K. Tagami ===============
!                     tmp = tmp + rltv(k,m)*rot(k,l,i)*altv(l,n)
!!!!!!!!                      tmp = tmp + p2bmat(m,k)*rot(k,l,i)*b2pmat(l,n)
                      tmp = tmp + kt_p2bmat(m,k)*rot(k,l,i)*kt_b2pmat(l,n)
! ================================================================
                  end do
               end do
! ============================== Added by K. Tagami ===============
!!               irot(m,n,i) = nint(tmp/PAI2)
               drot(m,n,i) = tmp
! ================================================================
            end do
         end do
         if(ipri>1) then
! ============================== Added by K. Tagami ===============
!            write(nfout,'(10(1x,i2))') i,irot(1:3,1:3,i)
            write(nfout,'(i2,9F8.4)') i, drot(1:3,1:3,i)
! ================================================================
         end if
      end do

      do j=1,nsym
         LOOP: do i=1,nsym
            do k=1,3
! =============================== Added by K. Tagami ======
!!!               t(k) = sum(irot(k,1:3,i)*tau(1:3,j)) + tau(k,i)
               t(k) = sum( drot(k,1:3,i)*tau(1:3,j) ) + tau(k,i)
! =========================================================
               do l=1,3
! =============================== Added by K. Tagami ======
!!!                  ir(k,l) = sum(irot(k,1:3,i)*irot(1:3,l,j))
                  dr(k,l) = sum( drot(k,1:3,i)*drot(1:3,l,j) )
! =========================================================
               end do
            end do
            call mod1(t)
            ! debug
            !write(nfout,'(11(1x,i2),3(1x,f10.5))') i,j,ir(1:3,1:3),t(1:3)
            ! end debug
            do k=1,nsym
! =============================== Added by K. Tagami ======
!!!               if(sum(abs(ir(1:3,1:3)-irot(1:3,1:3,k))) < eps) then
               if(sum(abs( dr(1:3,1:3)-drot(1:3,1:3,k))) < eps) then
! =========================================================
                do l=1,nprim
                   tt(1:3) = t(1:3)-tau(1:3,k)-tprim(1:3,l)
                   call mod1(tt)
                   if(sum(abs(tt(1:3))) < eps) then
                      iptab(i,j) = k
                      cycle LOOP
                   end if
                 end do
               end if
            end do
            write(nfout,'("Missing operation?")')
! =============================== Added by K. Tagami ======
!            write(nfout,'(11(1x,i2),3(1x,f10.5))') i,j,ir(1:3,1:3),t(1:3)
            write(nfout,'(2(1x,i2),12F8.4)') i,j, dr(1:3,1:3),t(1:3)
! =========================================================
            stop 'set_product_table: missing operation'
            !!$iptab(i,j) = 0
         end do LOOP
      end do

      if(ipri>1) then
         write(nfout,'("Product table:")')
         do i=1,nsym
            write(nfout,'(48(1x,i2))') iptab(i,1:nsym)
         end do
      end if
            !!$stop 'set_product_table: debug'
            
    end subroutine set_product_table

    subroutine search_generators
      integer :: i,j,k
      logical :: fexist(1:nsym)
      integer :: ii
               ! debug for the function `group_is_the_same'
               !!fexist(1:nsym) = .false.
               !!fexist(5) = .true.
               !!fexist(19) = .true.
               !!fexist(25) = .true.
               !!if(group_is_the_same(fexist)) then
               !!end if
               !!  do ii=1,nsym 
               !!    write(nfout,*) ii,fexist(ii)
               !!  end do
               ! end debug
      ng = 1
      do i=1,nsym
         fexist(1:nsym) = .false.
         fexist(i) = .true.
         if(group_is_the_same(fexist)) then
            ig(ng) = i
            return
         end if
         ! debug
         !!write(nfout,'(3(i2,1x),48l)') i,fexist(1:nsym)
         ! end  debug
      end do
      ng = 2
      do i=2,nsym
         do j=i+1,nsym
            fexist(1:nsym) = .false.
            fexist(i) = .true.
            fexist(j) = .true.
            if(group_is_the_same(fexist)) then
               ig(1)  = i
               ig(ng) = j
               return
            end if
            ! debug
            !!write(nfout,'(3(i2,1x),48l)') i,j,fexist(1:nsym)
            ! end  debug
         end do
      end do
      ng = 3
      do i=2,nsym
         do j=i+1,nsym
            do k=j+1,nsym
               fexist(1:nsym) = .false.
               fexist(i) = .true.
               fexist(j) = .true.
               fexist(k) = .true.
               if(group_is_the_same(fexist)) then
                  ig(1)  = i
                  ig(2)  = j
                  ig(ng) = k
                  return
               end if
               ! debug
               !!!$write(nfout,'(3(i2,1x),48l)') i,j,k,fexist(1:nsym)
               ! end  debug
            end do
         end do
      end do
      stop 'Set of generators of the space group was not found.'
    end subroutine search_generators

    logical function group_is_the_same(fexist)
      logical, intent(inout) :: fexist(nsym)

      integer :: i,j
      integer :: n,no
      logical :: flag(nsym)

      n=0
      no=-1 
      do while(n > no)
         flag(1:nsym) = .false.
         do j=1,nsym
            do i=1,nsym
               if(fexist(i).and.fexist(j)) flag(iptab(i,j)) = .true.
            end do
         end do
         do i=1,nsym
            if(flag(i)) fexist(i) = .true.
         end do
         no = n
         n = 0
         do i=1,nsym
            if(fexist(i)) n=n+1
         end do
      end do
      if(n==nsym) then
         group_is_the_same = .true.
      else
         group_is_the_same = .false.
      end if

    end function group_is_the_same

    subroutine set_generators
      integer :: i,j,k,n
      real(kind=DP) :: t,r,tb(3)
      real(kind=DP), parameter :: eps = 1.d-4
      ngen = ng
      call dealloc_igen_jgen
      call alloc_igen_jgen
      do i=1,ngen
         igen(i) = nopr(ig(i))
         do j=1,3
           tb(j) = sum(tau(1:3,ig(i))*b2pmat(1:3,j))
         end do
         do j=1,3
            t = tb(j)
            do k=1,20
               r=t*k
               if(abs(nint(r)-r)<eps) then
                  jgen(1,j,i) = nint(r)
                  jgen(2,j,i) = k
                  exit
               end if
            end do
         end do
      end do
      if(af>0) then
         iaf = nopr(nsym+af)
         do j=1,3
           tb(j) = sum(tau(1:3,nsym+af)*b2pmat(1:3,j))
         end do
         do j=1,3
            t = tb(j)
            do k=1,20
               r=t*k
               if(abs(nint(r)-r)<eps) then
                  jaf(1,j) = nint(r)
                  jaf(2,j) = k
                  exit
               end if
            end do
         end do
      end if
      
    end subroutine set_generators

    subroutine set_translations_zero
      integer :: i,j
      do i=1,ngen
         do j=1,3
            jgen(1,j,i) = 0
            jgen(2,j,i) = 1
         end do
      end do
    end subroutine set_translations_zero

  end subroutine set_tspace_generators

  subroutine write_tspace_generators(nfout,system,nprim)
    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nprim

    integer :: i

    write(nfout,'("TSPACE Generators:")')
    if(nprim>1) write(nfout,'("Translations are invalid.")')
!============================= Modified by K. Tagami =============
!    if(system == 'cubic') then
!      do i=1,ngen
!         write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(1x,i1,"/",i1))') igen(i),oh(igen(i)),jgen(:,:,i)
!      end do
!      if(af>0) then
!         write(nfout,'("iaf ,jaf (2,3)=",i2,"(",a5,")",3(1x,i1,"/",i1))') iaf,oh(iaf),jaf(:,:)
!      end if
!    else
!      do i=1,ngen
!         write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(1x,i1,"/",i1))') igen(i),d6h(igen(i)),jgen(:,:,i)
!      end do
!      if(af>0) then
!         write(nfout,'("iaf ,jaf (2,3)=",i2,"(",a5,")",3(1x,i1,"/",i1))') iaf,d6h(iaf),jaf(:,:)
!      end if
!    end if
    if(system == 'cubic') then
      do i=1,ngen
         write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') igen(i),oh(igen(i)),jgen(:,:,i)
      end do
      if(af>0) then
         write(nfout,'("iaf ,jaf (2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') iaf,oh(iaf),jaf(:,:)
      end if
    else
      do i=1,ngen
         write(nfout,'("igen,jgen(2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') igen(i),d6h(igen(i)),jgen(:,:,i)
      end do
      if(af>0) then
         write(nfout,'("iaf ,jaf (2,3)=",i2,"(",a5,")",3(3x,i2,"/",i2))') iaf,d6h(iaf),jaf(:,:)
      end if
    end if
! ==================================================
  end subroutine write_tspace_generators

  subroutine mod1(t)
    real(kind=DP), intent(inout) :: t(3)
    real(kind=DP), parameter :: eps = 1.d-6
    integer :: k
    t(1:3) = mod(t(1:3),1.d0)
    do k=1,3
       if(t(k) < -eps) t(k) = t(k) + 1.d0
       if(t(k) > 1.d0 - eps) t(k) = t(k) - 1.d0
    end do
  end subroutine mod1

  subroutine get_point_group_name(nfout,system,nsym,nopr,pg_name,pg_name_i)
    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(nsym)
    character(len=3), intent(out) :: pg_name
    character(len=5), intent(out) :: pg_name_i

    logical :: fexist(48)
    integer :: g,i

    fexist(1:48) = .false.
    do i=1,nsym
       fexist(nopr(i)) = .true.
    end do

    pg_name = 'C1 '
    pg_name_i = '1    '
    g = nsym
    if(system == 'cubic') then
       if(fexist(25)) then
       ! IE
          g = g/2
       end if
       if(g==1) then
          if(fexist(25)) then
          ! IE
             pg_name = 'Ci '
             pg_name_i = '-1   '
          else
             pg_name = 'C1 '
             pg_name_i = '1    '
          end if
       else if(g==2) then
          if(fexist(2).or.fexist(3).or.fexist(4).or. &
           & fexist(13).or.fexist(14).or.fexist(15).or. &
           & fexist(16).or.fexist(17).or.fexist(18)) then
          ! C2x or C2y or C2z or
          ! C2a or C2b or C2c or
          ! C2d or C2e or C2f
             if(fexist(25)) then
                ! IE
                pg_name = 'C2h'
                pg_name_i = '2/m  '
             else
                pg_name = 'C2 '
                pg_name_i = '2    '
             end if
          else if(fexist(26).or.fexist(27).or.fexist(28).or. &
                & fexist(37).or.fexist(38).or.fexist(39).or. &
                & fexist(40).or.fexist(41).or.fexist(42)) then
          ! IC2x or IC2y or IC2z or
          ! IC2a or IC2b or IC2c or
          ! IC2d or IC2e or IC2f
             pg_name = 'Cs '
             pg_name_i = 'm    '
          end if
       else if(g==3) then
          if(fexist(25)) then
             ! IE
             pg_name = 'S6 '
             pg_name_i = '-3   '
          else
             pg_name = 'C3 '
             pg_name_i = '3    '
          end if
       else if(g==4) then
          if((fexist(2).and.fexist(3).and.fexist(4)).or.&
           & (fexist(2).and.fexist(16).and.fexist(18)).or.&
           & (fexist(3).and.fexist(15).and.fexist(17)).or.&
           & (fexist(4).and.fexist(13).and.fexist(14))) then
          ! C2x and C2y and C2z or
          ! C2x and C2d and C2f or
          ! C2y and C2c and C2e or
          ! C2z and C2a and C2b
             if(fexist(25)) then
                ! IE
                pg_name = 'D2h'
                pg_name_i = 'mmm  '
             else
                pg_name = 'D2 '
                pg_name_i = '222  '
             end if
          else if(fexist(26).or.fexist(27).or.fexist(28).or. &
                & fexist(37).or.fexist(38).or.fexist(39).or. &
                & fexist(40).or.fexist(41).or.fexist(42).and.&
                & .not.(fexist(19).or.fexist(20).or.fexist(21))) then
                ! IC2x or IC2y or IC2z or
                ! IC2a or IC2b or IC2c or
                ! IC2d or IC2e or IC2f
             pg_name = 'C2v'
             pg_name_i = 'mm2  '
          else if((fexist(19).and.fexist(22)).or. &
                & (fexist(20).and.fexist(23)).or. &
                & (fexist(21).and.fexist(24))) then
                ! (C4x+ and C4x-) or (C4y+ and C4y-) or (C4z+ and C4z-)
             if(fexist(25)) then
                ! IE
                pg_name = 'C4h'
                pg_name_i = '4/m'
             else
                pg_name = 'C4 '
                pg_name_i = '4    '
             end if
          else if((fexist(43).and.fexist(46)).or. &
                & (fexist(44).and.fexist(47)).or. &
                & (fexist(45).and.fexist(48))) then
                ! (IC4x+ and IC4x-) or (IC4y+ and IC4y-) or (IC4z+ and IC4z-)
             pg_name = 'S4 '
             pg_name_i = '-4   '
          end if
       else if(g==6) then
          if((fexist(5).and.fexist(14).and.fexist(17).and.fexist(18)) .or. &
           & (fexist(6).and.fexist(14).and.fexist(15).and.fexist(16)) .or. &
           & (fexist(7).and.fexist(13).and.fexist(15).and.fexist(18)) .or. &
           & (fexist(8).and.fexist(13).and.fexist(16).and.fexist(17))) then
           ! C31+ and C2b and C2e and C2f
           ! C32+ and C2b and C2c and C2d
           ! C33+ and C2a and C2c and C2f
           ! C34+ and C2a and C2d and C2e
             if(fexist(25)) then
             ! IE
                pg_name = 'D3d'
                pg_name_i = '-3m  '
             else
                pg_name = 'D3 '
                pg_name_i = '32   '
             end if
          else
             pg_name = 'C3v'
             pg_name_i = '3m   '
          end if
       else if(g==8) then
          if((fexist(19).and.fexist(22)).or. &
           & (fexist(20).and.fexist(23)).or. &
           & (fexist(21).and.fexist(24))) then
           ! (C4x+ and C4x-) or (C4y+ and C4y-) or (C4z+ and C4z-)
             if(fexist(37).or.fexist(38).or.fexist(39).or. &
              & fexist(40).or.fexist(41).or.fexist(42)) then
              ! IC2a or IC2b or IC2c or IC2d or IC2e or IC2f
                if(fexist(25)) then
                ! IE
                   pg_name = 'D4h'
                   pg_name_i = '4/mmm'
                else
                   pg_name = 'C4v'
                   pg_name_i = '4mm  '
                end if
             else
                pg_name = 'D4 '
                pg_name_i = '422  '
             end if
          else
             pg_name = 'D2d'
             pg_name_i = '-42m '
          end if
       else if(g==12) then
          if(fexist(25)) then
          ! IE
             pg_name = 'Th '
             pg_name_i = 'm-3   '
          else
             pg_name = 'T  '
             pg_name_i = '23   '
          end if
       else if(g==24) then
          if(fexist(19).and.fexist(22).and. &
           & fexist(20).and.fexist(23).and. &
           & fexist(21).and.fexist(24)) then
           ! C4x+ and C4x- and C4y+ and C4y- and C4z+ and C4z-
             if(fexist(25)) then
             ! IE
                pg_name = 'Oh '
                pg_name_i = 'm-3m  '
             else
                pg_name = 'O  '
                pg_name_i = '432  '
             end if
          else
             pg_name = 'Td '
             pg_name_i = '-43m '
          end if
       end if
    else ! hexagonal
       if(fexist(13)) then
       ! IE
          g = g/2
       else if(fexist(16)) then
       ! IC2
          g = g/2
       end if
       if(g==2) then
           if(fexist(7).or.fexist(8).or.fexist(9).or. &
           & fexist(10).or.fexist(11).or.fexist(12).or.fexist(4)) then
           ! C211 or C221 or C231 or C212 or C222 or C232 or C2
             if(fexist(13)) then
                ! IE
                pg_name = 'C2h'
                pg_name_i = '2/m  '
             else
                pg_name = 'C2 '
                pg_name_i = '2    '
             end if
          else if(fexist(19).or.fexist(20).or.fexist(21).or. &
                & fexist(22).or.fexist(23).or.fexist(24).or.fexist(16)) then
                 ! IC211 or IC221 or IC231 or IC212 or IC222 or IC232 or IC2
             pg_name = 'Cs '
             pg_name_i = 'm    '
          end if
       else if(g==3) then
          if(fexist(13)) then
          ! IE
             pg_name = 'S6 '
             pg_name_i = '-3   '
          else if(fexist(16)) then
          ! IC2
             pg_name = 'C3h'
             pg_name_i = '-6   '
          else
             pg_name = 'C3 '
             pg_name_i = '3    '
          end if
       else if(g==4) then
          if(fexist(4).and.( &
            & (fexist(7).and.fexist(10)).or. &
            & (fexist(8).and.fexist(11)).or. &
            & (fexist(9).and.fexist(12)))) then
          ! C2 and ( C211 and C212 ) or ( C221 and C222 ) or ( C231 and C232 ) 
             if(fexist(13)) then
                ! IE
                pg_name = 'D2h'
                pg_name_i = 'mmm  '
             else
                pg_name = 'D2 '
                pg_name_i = '222  '
             end if
          else if( (fexist(4).and.( &
            & (fexist(19).and.fexist(22)).or. &
            & (fexist(20).and.fexist(23)).or. &
            & (fexist(21).and.fexist(24))) ) .or. &
            & (fexist(16).and.( &
            & (fexist(7).and.fexist(22)).or. &
            & (fexist(8).and.fexist(23)).or. &
            & (fexist(9).and.fexist(24)).or. &
            & (fexist(19).and.fexist(10)).or. &
            & (fexist(20).and.fexist(11)).or. &
            & (fexist(21).and.fexist(12))) ) ) then
          ! C2 and (IC211 and IC212) or (IC221 and IC222) or (IC231 and IC232) 
          ! or IC2 and (C211 and IC212) or (C221 and IC222) or (C231 and IC232)
          !         or (IC211 and C212) or (IC221 and C222) or (IC231 and C232)
             pg_name = 'C2v'
             pg_name_i = 'mm2  '
          end if
       else if(g==6) then
          if(fexist(2).and.fexist(6)) then
          ! C6+ and C6-
             if(fexist(13)) then
             ! IE
                pg_name = 'C6h'
                pg_name_i = '6/m  '
             else
                pg_name = 'C6 '
                pg_name_i = '6    '
             end if
          else if((fexist(7).and.fexist(8).and.fexist(9)) .or. &
                & (fexist(10).and.fexist(11).and.fexist(12))) then
                 ! (C211 and C221 and C231) or (C212 and C222 and C232)
             if(fexist(13)) then
             ! IE
                pg_name = 'D3d'
                pg_name_i = '-3m  '
             else if(fexist(16)) then
             ! IC2
                pg_name = 'D3h'
                pg_name_i = '-6m2 '
             else
                pg_name = 'D3 '
                pg_name_i = '32   '
             end if
          else if((fexist(19).and.fexist(20).and.fexist(21)) .or. &
                & (fexist(22).and.fexist(23).and.fexist(24))) then
                 ! (IC211 and IC221 and IC231) or (IC212 and IC222 and IC232)
             pg_name = 'C3v'
             pg_name_i = '3m   '
          end if
       else if(g==12) then
          if(fexist(7).and.fexist(8).and.fexist(9).and. &
           & fexist(10).and.fexist(11).and.fexist(12)) then
          ! C211 and C221 and C231 and C212 and C222 and C232
             if(fexist(13)) then
             ! IE
                pg_name = 'D6h'
                pg_name_i = '6/mmm'
             else
                pg_name = 'D6 '
                pg_name_i = '622  '
             end if
          else if(fexist(19).and.fexist(20).and.fexist(21).and. &
                & fexist(22).and.fexist(23).and.fexist(24)) then
                 ! IC211 and IC221 and IC231 and IC212 and IC222 and IC232
             pg_name = 'C6v'
             pg_name_i = '6mm  '
          end if
       end if
    end if
    if(g>1.and.pg_name=='C1 ') then
      write(nfout,*) 'get_point_group_name: error'
      write(nfout,*) 'system=',system
      write(nfout,*) 'nsym=',nsym
      write(nfout,*) 'g=',g
      write(nfout,*) 'fexist=',fexist
      stop 'get_point_group_name: error'
    end if
  end subroutine get_point_group_name

  subroutine get_bravais_lattice(nfout,ipri,a1,a2,a3,system,nopr,pg_name_i,bl_name)
    integer, intent(in) :: nfout,ipri
    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    character(len=9), intent(in) :: system
    integer, intent(in) :: nopr(48)
    character(len=5), intent(in) :: pg_name_i
    character(len=2), intent(out) :: bl_name

    real(kind=DP) :: length(3),angle(3)
    real(kind=DP), parameter :: eps = 1.d-3
    real(kind=DP) :: a(3,3),b(3,3)

    a(1:3,1) = a1(1:3)
    a(1:3,2) = a2(1:3)
    a(1:3,3) = a3(1:3)

    call vectors_length_angle(a1,a2,a3,length,angle)
    angle(1:3) = angle(1:3)/PAI*180.d0

    bl_name = 'No'
    select case(pg_name_i)
    case('-1','1') ! Trigonal
       bl_name = 'aP'
    case('2/m','m','2') ! Monoclinic
       if(cell_is_monoclinic(a,length,angle)) then
          bl_name = 'mP'
          go to 100
       end if

       call change_primitive_to_bravais('I',a,b)
       if(cell_is_monoclinic(b,length,angle)) then
          bl_name = 'mI'
          go to 100
       end if

! --- ad hoc ----
       goto 1000

       if(nopr(2)==2 .or. nopr(2)==26) then
          call change_primitive_to_bravais('A',a,b)
          if(cell_is_monoclinic(b,length,angle)) then
             bl_name = 'mA'
             go to 100
          end if

       else if(nopr(2)==3 .or. nopr(2)==27) then
          call change_primitive_to_bravais('B',a,b)
          if(cell_is_monoclinic(b,length,angle)) then
             bl_name = 'mB'
             go to 100
          end if

       else if(nopr(2)==4 .or. nopr(2)==28) then
          call change_primitive_to_bravais('C',a,b)

          if(cell_is_monoclinic(b,length,angle)) then
             bl_name = 'mC'
             go to 100
          end if
       end if
! -----------------------

1000   continue
       call change_primitive_to_bravais('A',a,b)
       if(cell_is_monoclinic(b,length,angle)) then
          bl_name = 'mA'
          go to 100
       end if

       call change_primitive_to_bravais('B',a,b)
       if(cell_is_monoclinic(b,length,angle)) then
          bl_name = 'mB'
          go to 100
       end if
       call change_primitive_to_bravais('C',a,b)
       if(cell_is_monoclinic(b,length,angle)) then
          bl_name = 'mC'
          go to 100
       end if
! ----

       ! Hexagonal or Rhombohedral
       bl_name = 'mP'
       call vectors_length_angle(a1,a2,a3,length,angle)
       angle(1:3) = angle(1:3)/PAI*180.d0
       if(cell_is_rhombohedral(length,angle)) then
          length(1) = sqrt(sum((a2-a1)**2))
          length(2) = sqrt(sum((a3-a2)**2))
          length(3) = sqrt(sum((a1+a2+a3)**2))
       end if
       angle(1:2) = 90.d0
       angle(3) = 120.d0

    case('mmm','mm2','222') ! Orthorhombic
       if(cell_is_orthorhombic(a,length,angle)) then
          bl_name = 'oP'
          go to 100
       end if
       call change_primitive_to_bravais('A',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oA'
          go to 100
       end if
       call change_primitive_to_bravais('B',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oB'
          go to 100
       end if
       call change_primitive_to_bravais('C',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oC'
          go to 100
       end if
       call change_primitive_to_bravais('F',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oF'
          go to 100
       end if
       call change_primitive_to_bravais('I',a,b)
       if(cell_is_orthorhombic(b,length,angle)) then
          bl_name = 'oI'
          go to 100
       end if
       ! Hexagonal or Rhombohedral
       bl_name = 'oP'
       call vectors_length_angle(a1,a2,a3,length,angle)
       angle(1:3) = angle(1:3)/PAI*180.d0
       if(cell_is_rhombohedral(length,angle)) then
          length(1) = sqrt(sum((a2-a1)**2))
          length(2) = sqrt(sum((a3-a2)**2))
          length(3) = sqrt(sum((a1+a2+a3)**2))
       end if
       length(2) = 0.5d0*sqrt(3.d0)*length(2)
       angle(1:3) = 90.d0
    case('4/mmm','-42m','4mm','422','4/m','-4','4') ! Tetragonal
       if(cell_is_tetragonal(a,length,angle)) then
          bl_name = 'tP'
          go to 100
       end if
       call change_primitive_to_bravais('I',a,b)
       if(cell_is_tetragonal(b,length,angle)) then
          bl_name = 'tI'
          go to 100
       end if
    case('-3m','3m','32','-3','3') ! Trigonal
       bl_name = 'hP'
       !!$if(abs(length(1)-length(2)) < eps .and. &
       !!$ & abs(length(2)-length(3)) < eps .and. &
       !!$ & abs(angle(1)-angle(2)) < eps .and. &
       !!$ & abs(angle(2)-angle(3)) < eps ) then ! cell is Rhombohedral
       if(cell_is_rhombohedral(length,angle)) then
          bl_name = 'hR'
       end if
    case('6/mmm','-6m2','6mm','622','6/m','-6','6') ! Hexagonal
       bl_name = 'hP'
    case('m-3m','-43m','432','m-3','23') ! Cubic
       if(cell_is_cubic(a,length,angle)) then
          bl_name = 'cP'
          go to 100
       end if
       call change_primitive_to_bravais('F',a,b)
       if(cell_is_cubic(b,length,angle)) then
          bl_name = 'cF'
          go to 100
       end if
       call change_primitive_to_bravais('I',a,b)
       if(cell_is_cubic(b,length,angle)) then
          bl_name = 'cI'
          go to 100
       end if
    case default
       bl_name = 'No'
    end select
100 continue
    if(ipri > 0) then
       write(nfout,'("=== Lattice parameters ===")')
       write(nfout,'("a    ,b   ,c     = ",3f15.8," Bohr")') length
       write(nfout,'("alpha,beta,gamma = ",3f15.8," degree")') angle
    end if
    call m_IS_put_latconst_len_angle(length,angle)
    call m_CS_put_Bravais_lattice(length,angle)
!!$    latconst_len = length
!!$    latconst_angle = angle
  contains
    subroutine change_primitive_to_bravais(l,a,b)
      character(len=1), intent(in) :: l
      real(kind=DP), intent(in)    :: a(3,3) ! primitive
      real(kind=DP), intent(out)   :: b(3,3) ! bravais

      integer :: i,j
      real(kind=DP) :: p2b(3,3),tt(3)
      
      p2b = 0.d0
      if(l=='R' .or. l=='P') then
         ! Hexagonal or primitive
         do i=1,3
            p2b(i,i)=1.d0
         end do
      else if(l=='A') then
         ! A-face centered
         p2b(1,1) =  1.d0
         p2b(2,2) =  1.d0
         p2b(3,3) =  1.d0
         p2b(3,2) = -1.d0
         p2b(2,3) =  1.d0
      else if(l=='B') then
         ! B-face centered
         p2b(2,2) =  1.d0
         p2b(1,1) =  1.d0
         p2b(3,3) =  1.d0
         p2b(3,1) = -1.d0
         p2b(1,3) =  1.d0
      else if(l=='C') then
         ! C-face centered
         p2b(3,3) =  1.d0
         p2b(1,1) =  1.d0
         p2b(2,2) =  1.d0
         p2b(2,1) = -1.d0
         p2b(1,2) =  1.d0
      else if(l=='F') then
         ! All-face centered
         p2b(1:3,1:3) =  1.d0
         do i=1,3
            p2b(i,i)=-1.d0
         end do
      else if(l=='I') then
         ! Body centered
         p2b(1:3,1:3) =  1.d0
         do i=1,3
            p2b(i,i)=0.d0
         end do
      end if

      do i=1,3
         b(1:3,i) = 0.d0
         do j=1,3
            b(1:3,i) = b(1:3,i) + p2b(i,j)*a(1:3,j)
         end do
      end do
    end subroutine change_primitive_to_bravais

    logical function cell_is_cubic(b,length,angle)
      real(kind=DP), intent(in) :: b(3,3)
      real(kind=DP), intent(out) :: length(3),angle(3)
      cell_is_cubic = .false.
      call vectors_length_angle(b(1,1),b(1,2),b(1,3),length,angle)
      angle(1:3) = angle(1:3)/PAI*180.d0
      if( abs(length(1)-length(2)) < eps .and. &
        & abs(length(2)-length(3)) < eps .and. &
        & abs(angle(1) - 90.d0) < eps .and. &
        & abs(angle(2) - 90.d0) < eps .and. &
        & abs(angle(3) - 90.d0) < eps) then
        cell_is_cubic = .true.
      end if
    end function cell_is_cubic

    logical function cell_is_tetragonal(b,length,angle)
      real(kind=DP), intent(in) :: b(3,3)
      real(kind=DP), intent(out) :: length(3),angle(3)
      cell_is_tetragonal = .false.
      call vectors_length_angle(b(1,1),b(1,2),b(1,3),length,angle)
      angle(1:3) = angle(1:3)/PAI*180.d0
      if((abs(length(1)-length(2)) < eps .or. &
        & abs(length(2)-length(3)) < eps .or. &
        & abs(length(3)-length(1)) < eps ) .and. &
        & abs(angle(1) - 90.d0) < eps .and. &
        & abs(angle(2) - 90.d0) < eps .and. &
        & abs(angle(3) - 90.d0) < eps) then
        cell_is_tetragonal = .true.
      end if
    end function cell_is_tetragonal

    logical function cell_is_orthorhombic(b,length,angle)
      real(kind=DP), intent(in) :: b(3,3)
      real(kind=DP), intent(out) :: length(3),angle(3)
      cell_is_orthorhombic = .false.
      call vectors_length_angle(b(1,1),b(1,2),b(1,3),length,angle)
      angle(1:3) = angle(1:3)/PAI*180.d0
      !!$if(abs(angle(1) - 90.d0) < eps .and. &
      !!$  & abs(angle(2) - 90.d0) < eps .and. &
      !!$  & abs(angle(3) - 90.d0) < eps ) then
      if(abs(b(1,1))>eps.and.abs(b(2,1))<eps.and.abs(b(3,1))<eps.and.&
       & abs(b(1,2))<eps.and.abs(b(2,2))>eps.and.abs(b(3,2))<eps.and.&
       & abs(b(1,3))<eps.and.abs(b(2,3))<eps.and.abs(b(3,3))>eps) then
        cell_is_orthorhombic = .true.
      end if
    end function cell_is_orthorhombic

    logical function cell_is_monoclinic(b,length,angle)
      real(kind=DP), intent(in) :: b(3,3)
      real(kind=DP), intent(out) :: length(3),angle(3)
      cell_is_monoclinic = .false.
      call vectors_length_angle(b(1,1),b(1,2),b(1,3),length,angle)
      angle(1:3) = angle(1:3)/PAI*180.d0
      if((abs(angle(1) - 90.d0) < eps .and. &
        & abs(angle(1) - angle(2)) < eps) .or. &
        &(abs(angle(2) - 90.d0) < eps .and. &
        & abs(angle(2) - angle(3)) < eps) .or. &
        &(abs(angle(3) - 90.d0) < eps .and. &
        & abs(angle(3) - angle(1)) < eps) ) then
        cell_is_monoclinic = .true.
      end if
    end function cell_is_monoclinic

    logical function cell_is_rhombohedral(length,angle)
      real(kind=DP), intent(in) :: length(3),angle(3)
      cell_is_rhombohedral = .false.
      if(abs(length(1)-length(2)) < eps .and. &
        & abs(length(2)-length(3)) < eps .and. &
        & abs(angle(1)-angle(2)) < eps .and. &
        & abs(angle(2)-angle(3)) < eps ) then ! cell is Rhombohedral
          cell_is_rhombohedral = .true.
       end if
    end function cell_is_rhombohedral

  end subroutine get_bravais_lattice


  subroutine get_bravais_lattice_old(nfout,a1,a2,a3,system,nopr,pg_name_i,bl_name)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    character(len=9), intent(in) :: system
    integer, intent(in) :: nopr(48)
    character(len=5), intent(in) :: pg_name_i
    character(len=2), intent(out) :: bl_name

    real(kind=DP) :: length(3),angle(3)
    real(kind=DP), parameter :: eps = 1.d-3

    length(1) = sqrt(sum(a1(1:3)*a1(1:3)))
    length(2) = sqrt(sum(a2(1:3)*a2(1:3)))
    length(3) = sqrt(sum(a3(1:3)*a3(1:3)))
    angle(1) = acos(sum(a2(1:3)*a3(1:3))/(length(2)*length(3)))
    angle(2) = acos(sum(a3(1:3)*a1(1:3))/(length(3)*length(1)))
    angle(3) = acos(sum(a1(1:3)*a2(1:3))/(length(1)*length(2)))

    angle(1:3) = angle(1:3)*180/PAI

    select case(pg_name_i)
    case('-1','1') ! Trigonal
       bl_name = 'aP'
    case('2/m','m','2') ! Monoclinic
       bl_name = 'mP'
       if(nopr(2) == 2) then
       ! C2x -> a-unique setting
          if(abs(angle(3)-90.d0) > eps) then
             if(abs(angle(2)-90.d0) > eps) then
                bl_name = 'mI'
             else
                bl_name = 'mB'
             end if
          else if(abs(angle(1)-90.d0) > eps) then
             bl_name = 'mA'
          end if
       else if(nopr(2) == 3) then
       ! C2y -> b-unique setting
          if(abs(angle(1)-90.d0) > eps) then
             if(abs(angle(3)-90.d0) > eps) then
                bl_name = 'mI'
             else
                bl_name = 'mA'
             end if
          else if(abs(angle(3)-90.d0) > eps) then
             bl_name = 'mC'
          end if
       else if(nopr(2) == 4) then
       ! C2z -> c-unique setting
          if(abs(angle(2)-90.d0) > eps) then
             if(abs(angle(1)-90.d0) > eps) then
                bl_name = 'mI'
             else
                bl_name = 'mC'
             end if
          else if(abs(angle(2)-90.d0) > eps) then
             bl_name = 'mB'
          end if
       end if
    case('mmm','mm2','222') ! Orthorhombic
       bl_name = 'oP'
       if(abs(angle(1)-90.d0) > eps .and. &
        & abs(angle(2)-90.d0) < eps .and. &
        & abs(angle(3)-90.d0) < eps ) then
          if(abs(a1(1))>eps) then
             bl_name = 'oA'
          else if(abs(a1(2))>eps) then
             bl_name = 'oB'
          else if(abs(a1(3))>eps) then
             bl_name = 'oC'
          end if
       else if(abs(angle(2)-90.d0) > eps .and. &
        & abs(angle(3)-90.d0) < eps .and. &
        & abs(angle(1)-90.d0) < eps ) then
          if(abs(a2(1))>eps) then
             bl_name = 'oA'
          else if(abs(a2(2))>eps) then
             bl_name = 'oB'
          else if(abs(a2(3))>eps) then
             bl_name = 'oC'
          end if
       else if(abs(angle(3)-90.d0) > eps .and. &
          & abs(angle(1)-90.d0) < eps .and. &
          & abs(angle(2)-90.d0) < eps ) then
          if(abs(a3(1))>eps) then
             bl_name = 'oA'
          else if(abs(a3(2))>eps) then
             bl_name = 'oB'
          else if(abs(a3(3))>eps) then
             bl_name = 'oC'
          end if
       else if((abs(a1(1)) < eps .and. &
          &  abs(a1(2)) > eps .and. &
          &  abs(a1(3)) > eps) .or. &
          & (abs(a1(2)) < eps .and. &
          &  abs(a1(3)) > eps .and. &
          &  abs(a1(1)) > eps) .or. &
          & (abs(a1(3)) < eps .and. &
          &  abs(a1(1)) > eps .and. &
          &  abs(a1(2)) > eps) ) then
          bl_name = 'oF'
       else if(abs(length(1)-length(2)) < eps .and. &
          & abs(length(2)-length(3)) < eps .and. &
          & ( abs(angle(1)-90.d0) > eps .or. &
          &   abs(angle(2)-90.d0) > eps .or. &
          &   abs(angle(3)-90.d0) > eps ) ) then
          bl_name = 'oI'
       end if
    case('4/mmm','-42m','4mm','422','4/m','-4','4') ! Tetragonal
       bl_name = 'tP'
       if(abs(angle(1)-angle(2)) > eps .or. &
        & abs(angle(2)-angle(3)) > eps ) then
          bl_name = 'tI'
       end if
    case('-3m','3m','32','-3','3') ! Trigonal
       bl_name = 'hP'
       if(abs(length(1)-length(2)) < eps .and. &
        & abs(length(2)-length(3)) < eps .and. &
        & abs(angle(1)-angle(2)) < eps .and. &
        & abs(angle(2)-angle(3)) < eps ) then
          bl_name = 'hR'
       end if
    case('6/mmm','-6m2','6mm','622','6/m','-6','6') ! Hexagonal
       bl_name = 'hP'
    case('m-3m','-43m','432','m-3','23') ! Cubic
       bl_name = 'cP'
       if(abs(angle(1) - 60.d0) < eps) then
          bl_name = 'cF'
       else if(abs(angle(1) - 109.47122d0) < eps) then
          bl_name = 'cI'
       end if
    case default
       bl_name = 'No'
    end select

  end subroutine get_bravais_lattice_old

  subroutine get_space_group_name(nfout,system,nsym,nopr,tau,fbravais,bl_name,pg_name_i,sg_name_i)
    integer, intent(in) :: nfout
    character(len=9), intent(in) :: system
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(48)
    real(kind=DP), intent(in) :: tau(3,*)
    logical, intent(in) :: fbravais
    character(len=2), intent(in) :: bl_name
    character(len=5), intent(in) :: pg_name_i
    character(len=10), intent(out) :: sg_name_i

    character(len=1) :: s,l,sp
    character(len=2) :: sub
    character(len=9) :: sg_name0
    integer :: i,j
    logical :: fexist(48)
    real(kind=DP) :: t(3,48)
    real(kind=DP), parameter :: eps = 1.d-6

    fexist(1:48) = .false.
    t(1:3,1:48) = 0.d0
    do i=1,nsym
       fexist(nopr(i)) = .true. 
       t(1:3,nopr(i)) = tau(1:3,i)
    end do

    sp=''
    s(1:1) = bl_name(1:1)
    l(1:1) = bl_name(2:2)

    if(.not.fbravais) call get_trans_in_bravais_system(l,t)

    select case(pg_name_i)
    case('1','-1')     ! Triclinic
       sg_name_i = l // trim(pg_name_i)
    case('2')     ! Monoclinic
       sg_name0= trim(pg_name_i)
       if(system == 'cubic') then
          if(fexist(2)) then
          ! C2x
             if(abs(t(1,2)) > eps) sg_name0= trim(pg_name_i) // '_1'
          else if(fexist(3)) then
          ! C2y
             if(abs(t(2,3)) > eps) sg_name0= trim(pg_name_i) // '_1'
          else if(fexist(4)) then
          ! C2z
             if(abs(t(3,4)) > eps) sg_name0= trim(pg_name_i) // '_1'
          end if
       else ! hexagonal
          if(fexist(4)) then
             ! C2
             if(sum(abs(t(1:3,i))) > eps) sg_name0= trim(pg_name_i) // '_1'
          else
             do i=7,12
                if(fexist(i)) then
             ! C211 or C221 or C231 or C212 or C222 or C232
                   if(sum(abs(t(1:3,i))) > eps) sg_name0= trim(pg_name_i) // '_1'
                end if
             end do
          end if
       end if
       sg_name_i = l // trim(sg_name0)
    case('m')     ! Monoclinic
       if(system == 'cubic') then
          do i=0,2
             if(fexist(26+i)) then
             ! IC2x or IC2y or IC2z
               call get_symbol_of_sym_plane(t(1,26+i),sp)
             end if
          end do
       else ! hexagonal
          if(fexist(16)) then
             ! IC2
             call get_symbol_of_sym_plane(t(1,i),sp)
          else
             do i=19,24
                if(fexist(i)) then
             ! IC211 or IC221 or IC231 or IC212 or IC222 or IC232
                   call get_symbol_of_sym_plane(t(1,i),sp)
                end if
             end do
          end if
       end if
       if(sp=='a' .or. sp=='b' .or. sp=='n') then
          sp = 'c'
       end if
       sg_name_i = l // trim(sp)
    case('2/m')   ! Monoclinic
       sg_name0 = '2'
       if(system == 'cubic') then
          do i=0,2
             if(fexist(2+i)) then
             ! C2x or C2y or C2z
                if(sum(abs(t(1:3,2+i))) > eps) sg_name0= trim(sg_name0) // '_1'
                ! IC2x or IC2y or IC2z
                call get_symbol_of_sym_plane(t(1,26+i),sp)
             end if
          end do
          do i=0,5
             if(fexist(13+i)) then
             ! C2a or C2b or C2c or C2d or C2e or C2f
                if(sum(abs(t(1:3,13+i))) > eps) sg_name0= trim(sg_name0) // '_1'
                ! IC2a or IC2b or IC2c or IC2d or IC2e or IC2f
                call get_symbol_of_sym_plane(t(1,37+i),sp)
             end if
          end do
       else ! hexagonal
          if(fexist(4)) then
             ! C2
             if(sum(abs(t(1:3,4))) > eps) sg_name0= trim(pg_name_i) // '_1'
             ! IC2
             call get_symbol_of_sym_plane(t(1,16),sp)
          else
             do i=7,12
                if(fexist(i)) then
                ! C211 or C221 or C231 or C212 or C222 or C232
                   if(sum(abs(t(1:3,i))) > eps) sg_name0= trim(pg_name_i) // '_1'
                ! IC211 or IC221 or IC231 or IC212 or IC222 or IC232
                   call get_symbol_of_sym_plane(t(1,i+12),sp)
                end if
             end do
          end if
       end if
       if(sp=='a' .or. sp=='b' .or. sp=='n') sp = 'c'
       sg_name0= trim(sg_name0) // '/' // sp
       sg_name_i = l // trim(sg_name0)
    case('222')   ! Orthorhombic
       if(system == 'cubic') then
          ! C2x
          sg_name0 = '2'
          if(abs(t(1,2)) > eps) sg_name0= trim(sg_name0) // '_1'
          ! C2y
          sg_name0 = trim(sg_name0) // '2'
          if(abs(t(2,3)) > eps) sg_name0= trim(sg_name0) // '_1'
          ! C2z
          sg_name0 = trim(sg_name0) // '2'
          if(abs(t(3,4)) > eps) sg_name0= trim(sg_name0) // '_1'
          sg_name_i = l // trim(sg_name0)
       else ! hexagonal
          do i=0,2
             if(fexist(10+i)) then
                ! C212 or C222 or C232 (C2x)
                sg_name0 = '2'
                if(sum(abs(t(1:3,10+i))) > eps) sg_name0= trim(sg_name0) // '_1'
                ! C211 or C221 or C231 (C2y)
                sg_name0 = trim(sg_name0) // '2'
                if(sum(abs(t(1:3,7+i))) > eps) sg_name0= trim(sg_name0) // '_1'
                exit
             end if
          end do
          ! C2 (C2z)
          sg_name0 = trim(sg_name0) // '2'
          if(sum(abs(t(1:3,4))) > eps) sg_name0= trim(sg_name0) // '_1'
          sg_name_i = l // trim(sg_name0)
       end if
    case('mm2')   ! Orthorhombic
       sg_name0 = ''
       if(system == 'cubic') then
          do i=0,2
             if(fexist(2+i)) then
             ! C2x or C2y or C2z
                j = mod(i+1,3)
                if(fexist(26+j)) then
                ! IC2y or IC2z or IC2x
                   call get_symbol_of_sym_plane(t(1,26+j),sp)
                   sg_name0= trim(sg_name0) // sp
                end if
                j = mod(i+2,3)
                if(fexist(26+j)) then
                ! IC2z or IC2x or IC2y
                   call get_symbol_of_sym_plane(t(1,26+j),sp)
                   sg_name0= trim(sg_name0) // sp
                end if
                if(fexist(40-i)) then
                ! IC2d or IC2c or IC2b
                   call get_symbol_of_sym_plane(t(1,40-i),sp)
                   sg_name0= trim(sg_name0) // sp
                   if(40-i==38.and.fexist(37)) then
                   ! IC2f
                      call get_symbol_of_sym_plane(t(1,37),sp)
                   else if(40-i==39.and.fexist(41)) then
                   ! IC2e
                      call get_symbol_of_sym_plane(t(1,41),sp)
                   else if(40-i==40.and.fexist(42)) then
                   ! IC2a
                      call get_symbol_of_sym_plane(t(1,42),sp)
                   end if
                   sg_name0= trim(sg_name0) // sp
                end if
                sg_name0 = trim(sg_name0) // '2'
                if(abs(t(1+i,2+i)) > eps) sg_name0= trim(sg_name0) // '_1'
             end if
          end do
       else ! hexagonal
          if(fexist(4)) then
          ! c2 (C2z)
             do i=0,2
                if(fexist(22+i)) then
                   ! IC212 or IC222 or IC232 (IC2x)
                   call get_symbol_of_sym_plane(t(1,22+i),sp)
                   sg_name0= trim(sg_name0) // sp
                   ! IC211 or IC221 or IC231 (IC2y)
                   call get_symbol_of_sym_plane(t(1,19+i),sp)
                   sg_name0= trim(sg_name0) // sp
                end if
             end do
             sg_name0 = trim(sg_name0) // '2'
             if(sum(abs(t(1:3,4))) > eps) sg_name0= trim(sg_name0) // '_1'
          else
             do i=0,5
                if(fexist(7+i)) then
                ! C211 or C221 or C231 (C2y)
                ! or C212 or C222 or C232 (C2x)
                   if(i<3) then
                      j=i+3+19
                   else
                      j=i-3+19
                   end if
                   ! IC212 or IC222 or IC232 (IC2x)
                   ! or IC211 or IC221 or IC231 (IC2y)
                   call get_symbol_of_sym_plane(t(1,j),sp)
                   sg_name0= trim(sg_name0) // sp
                   ! IC2 (IC2z)
                   call get_symbol_of_sym_plane(t(1,16),sp)
                   sg_name0= trim(sg_name0) // sp

                   sg_name0 = trim(sg_name0) // '2'
                   if(sum(abs(t(1:3,7+i))) > eps) &
                      & sg_name0= trim(sg_name0) // '_1'
                   exit
                end if
             end do
          end if
       end if
       sg_name_i = l // trim(sg_name0)
    case('mmm')   ! Orthorhombic
       sg_name0 = ''
       if(system == 'cubic') then
          do i=0,2
             ! IC2x or IC2y or IC2z
             call get_symbol_of_sym_plane(t(1,26+i),sp)
             sg_name0= trim(sg_name0) // sp
          end do
       else ! hexagonal
          do i=0,2
             if(fexist(22+i)) then
                ! IC212 or IC222 or IC232 (IC2x)
                call get_symbol_of_sym_plane(t(1,22+i),sp)
                sg_name0= trim(sg_name0) // sp
                ! IC211 or IC221 or IC231 (IC2y)
                call get_symbol_of_sym_plane(t(1,19+i),sp)
                sg_name0= trim(sg_name0) // sp
                exit
             end if
          end do
          ! IC2 (IC2z)
          call get_symbol_of_sym_plane(t(1,16),sp)
          sg_name0= trim(sg_name0) // sp
       end if
       sg_name_i = l // trim(sg_name0)
    case('4')     ! Tetragonal
       do i=0,2
         if(fexist(19+i)) then
          ! C4x+ or C4y+ or C4z+
            call get_screw_sub(t(1+i,19+i),4,sub)
            sg_name0= '4' // trim(sub)
            exit
         end if
       end do
       sg_name_i = l // trim(sg_name0)
    case('-4')    ! Tetragonal
       sg_name_i = l // trim(pg_name_i)
    case('4/m')   ! Tetragonal
       do i=0,2
         if(fexist(19+i)) then
          ! C4x+ or C4y+ or C4z+
            call get_screw_sub(t(1+i,19+i),4,sub)
            sg_name0= '4' // trim(sub)
          ! IC2x or IC2y or IC2z
            call get_symbol_of_sym_plane(t(1,26+i),sp)
            sg_name0= trim(sg_name0) // "/" // sp
            exit
         end if
       end do
       sg_name_i = l // trim(sg_name0)
    case('422')   ! Tetragonal
       do i=0,2
          if(fexist(19+i)) then
           ! C4x+ or C4y+ or C4z+
             call get_screw_sub(t(1+i,19+i),4,sub)
             sg_name0= '4' // trim(sub)
           ! C2x or C2y or C2z
             j = mod(i+1,3)
             call get_screw_sub(t(1+j,2+j),2,sub)
             sg_name0= trim(sg_name0) // '2' // trim(sub) // '2'
             exit
          end if
       end do
       sg_name_i = l // sg_name0
    case('4mm')   ! Tetragonal
       do i=0,2
          if(fexist(19+i)) then
           ! C4x+ or C4y+ or C4z+
             call get_screw_sub(t(1+i,19+i),4,sub)
             sg_name0= '4' // trim(sub)
           ! IC2x or IC2y or IC2z
             j = mod(i+1,3)
             call get_symbol_of_sym_plane(t(1,26+j),sp)
             sg_name0= trim(sg_name0) // sp
           ! IC2d(40) or IC2c(39) or IC2b(38)
             call get_symbol_of_sym_plane(t(1,40-i),sp)
             sg_name0= trim(sg_name0) // sp
             exit
          end if
       end do
       sg_name_i = l // sg_name0
    case('-42m') ! Tetragonal
       do i=0,2
          if(fexist(43+i)) then
           ! C4x+ or C4y+ or C4z+
             sg_name0= '-4'
             j = mod(i+1,3)
             if(fexist(2+i)) then
              ! C2x or C2y or C2z
                call get_screw_sub(t(1+j,2+j),2,sub)
                sg_name0= trim(sg_name0) // '2' // trim(sub)
              ! IC2d(40) or IC2c(39) or IC2b(38)
                call get_symbol_of_sym_plane(t(1,40-i),sp)
                sg_name0= trim(sg_name0) // sp
             else
              ! IC2x or IC2y or IC2z
                call get_symbol_of_sym_plane(t(1,26+i),sp)
                sg_name0= trim(sg_name0) // sp
              ! C2d(16) or C2c(15) or C2b(14)
                sg_name0= trim(sg_name0) // '2'
             end if
             exit
          end if
       end do
       sg_name_i = l // sg_name0
    case('4/mmm') ! Tetragonal
       do i=0,2
          if(fexist(19+i)) then
           ! C4x+ or C4y+ or C4z+
             call get_screw_sub(t(1+i,19+i),4,sub)
             sg_name0= '4' // trim(sub)
           ! IC2x+ or IC2y+ or IC2z+
             call get_symbol_of_sym_plane(t(1,26+i),sp)
             sg_name0= trim(sg_name0) // "/" // sp
           ! IC2x or IC2y or IC2z
             j = mod(i+1,3)
             call get_symbol_of_sym_plane(t(1,26+j),sp)
             sg_name0= trim(sg_name0) // sp
           ! IC2d(40) or IC2c(39) or IC2b(38)
             call get_symbol_of_sym_plane(t(1,40-i),sp)
             sg_name0= trim(sg_name0) // sp
             exit
          end if
       end do
       sg_name_i = l // sg_name0
    case('3')     ! Trigonal
       if(l=='R') then
          sg_name_i = l // pg_name_i
       else
          ! C3+
          call get_screw_sub(t(3,3),3,sub)
          sg_name_i = l // '3' // trim(sub)
       end if
    case('-3')    ! Trigonal
       sg_name_i = l // '-3'
    case('32')    ! Trigonal
       if(l=='R') then
          sg_name_i = l // pg_name_i
       else
          ! C3+
          call get_screw_sub(t(3,3),3,sub)
          sg_name0 = '3' // trim(sub)
          if(fexist(10)) then
          ! C212
             sg_name0 = trim(sg_name0) // '2'
          else
             sg_name0 = trim(sg_name0) // '1'
          end if
          if(fexist(7)) then
          ! C211
             sg_name0 = trim(sg_name0) // '2'
          else
             sg_name0 = trim(sg_name0) // '1'
          end if
          sg_name_i = l // trim(sg_name0)
       end if
    case('3m','-3m')    ! Trigonal
       if(pg_name_i == '3m') then
          sg_name0 = '3'
       else
          sg_name0 = '-3'
       end if
       if(system == 'cubic') then
          ! C31+ or C32+ or C33+ or C34+
          do i=0,4
             if(fexist(5+i)) then
                j=0
                if(i>1) j=1
                ! C2b for C31+ and C32+, or C2a for C33+ and C34+
                call get_symbol_of_sym_plane(t(1,38-j),sp)
                exit
             end if
          end do      
          sg_name0 = trim(sg_name0) // sp
       else
          if(fexist(22)) then
          ! IC212
             call get_symbol_of_sym_plane(t(1,22),sp)
             sg_name0 = trim(sg_name0) // sp
          else if(l == 'P') then
             sg_name0 = trim(sg_name0) // '1'
          end if
          if(fexist(19)) then
          ! IC211
             call get_symbol_of_sym_plane(t(1,19),sp)
             sg_name0 = trim(sg_name0) // sp
          else if(l == 'P') then
             sg_name0 = trim(sg_name0) // '1'
          end if
       end if
       sg_name_i = l // trim(sg_name0)
    case('6')     ! Hexagonal
       call get_screw_sub(t(3,2),6,sub)
       sg_name_i = l // '6' // trim(sub)
    case('-6')    ! Hexagonal
       sg_name_i = l // pg_name_i
    case('6/m')   ! Hexagonal
       call get_screw_sub(t(3,2),6,sub)
       sg_name_i = l // '6' // trim(sub) // "/m"
    case('622')   ! Hexagonal
       call get_screw_sub(t(3,2),6,sub)
       sg_name_i = l // '6' // trim(sub) // "22"
    case('6mm','6/mmm')   ! Hexagonal
       call get_screw_sub(t(3,2),6,sub)
       sg_name0 = '6' // trim(sub)
       if(pg_name_i == '6/mmm') then
          sg_name0 = trim(sg_name0) // "/m"
       end if
       ! IC212
       call get_symbol_of_sym_plane(t(1,22),sp)
       sg_name0 = trim(sg_name0) // sp
       ! IC211
       call get_symbol_of_sym_plane(t(1,19),sp)
       sg_name0 = trim(sg_name0) // sp
       sg_name_i = l // trim(sg_name0)
    case('-6m2')  ! Hexagonal
       sg_name0 = '-6'
       if(fexist(10)) then
        ! C212
          sg_name0 = trim(sg_name0) // '2'
       else
        ! IC212
          call get_symbol_of_sym_plane(t(1,22),sp)
          sg_name0 = trim(sg_name0) // sp
       end if
       if(fexist(7)) then
         ! C211
          sg_name0 = trim(sg_name0) // '2'
       else
       ! IC211
          call get_symbol_of_sym_plane(t(1,19),sp)
          sg_name0 = trim(sg_name0) // sp
       end if
       sg_name_i = l // trim(sg_name0)
    case('23')    ! Cubic
       ! C2x
       call get_screw_sub(t(1,2),2,sub)
       if(sub=='') call get_screw_sub(t(2,2),2,sub)
       if(sub=='') call get_screw_sub(t(3,2),2,sub)
       sg_name0= '2' // trim(sub) // '3'
       sg_name_i = l // trim(sg_name0)
    case('m-3','m-3m')   ! Cubic
       ! IC2x
       call get_symbol_of_sym_plane(t(1,26),sp)
       sg_name0= sp // '-3'
       if(pg_name_i == 'm-3m') then
         ! IC2a
         call get_symbol_of_sym_plane(t(1,37),sp)
         sg_name0= trim(sg_name0) // sp
       end if
       sg_name_i = l // trim(sg_name0)
    case('432')   ! Cubic
       ! C4x+
       call get_screw_sub(t(1,19),4,sub)
       sg_name0= '4' // trim(sub) // '32'
       sg_name_i = l // trim(sg_name0)
    case('-43m')  ! Cubic
       sg_name0= '-43'
       ! IC2a
       if(sum(abs(t(1:3,37))) < eps) then
          sp = 'm'
       else if(l == 'P') then
          sp = 'n'
       else if(l == 'F') then
          sp = 'c'
       else if(l == 'I') then
          sp = 'd'
       end if
       sg_name0= trim(sg_name0) // sp
       sg_name_i = l // trim(sg_name0)
    case default
    end select

  contains
    subroutine get_trans_in_bravais_system(l,t)
      character(len=1), intent(in) :: l
      real(kind=DP), intent(inout) :: t(3,48)

      integer :: i,j
      real(kind=DP) :: p2b(3,3),tt(3)
      
      p2b = 0.d0
      if(l=='R' .or. l=='P') then
         ! Hexagonal or primitive
         do i=1,3
            p2b(i,i)=1.d0
         end do
      else if(l=='A') then
         ! A-face centered
         p2b(1,1) =  1.d0
         p2b(2,2) =  0.5d0
         p2b(3,3) =  0.5d0
         p2b(2,3) =  0.5d0
         p2b(3,2) = -0.5d0
      else if(l=='B') then
         ! B-face centered
         p2b(2,2) =  1.d0
         p2b(1,1) =  0.5d0
         p2b(3,3) =  0.5d0
         p2b(3,1) =  0.5d0
         p2b(1,3) = -0.5d0
      else if(l=='C') then
         ! C-face centered
         p2b(3,3) =  1.d0
         p2b(1,1) =  0.5d0
         p2b(2,2) =  0.5d0
         p2b(1,2) =  0.5d0
         p2b(2,1) = -0.5d0
      else if(l=='F') then
         ! All-face centered
         p2b(1:3,1:3) =  0.5d0
         do i=1,3
            p2b(i,i)=0.d0
         end do
      else if(l=='I') then
         ! Body centered
         p2b(1:3,1:3) =  0.5d0
         do i=1,3
            p2b(i,i)=-0.5d0
         end do
      end if

      do j=1,48
         do i=1,3
            tt(i) = sum(p2b(i,1:3)*t(1:3,j))
         end do
         t(1:3,j) = tt(1:3)
      end do
    end subroutine get_trans_in_bravais_system

    subroutine get_symbol_of_sym_plane(t,sp)
      real(kind=DP), intent(in) :: t(3)
      character(len=1), intent(out) :: sp

      real(kind=DP), parameter :: eps = 1.d-6
      integer :: i

      if(sum(abs(t(1:3))) < eps) then
         sp = 'm'
      else if(abs(t(1))>eps.and.abs(t(2))<eps.and.abs(t(3))<eps) then
         sp = 'a'
      else if(abs(t(1))<eps.and.abs(t(2))>eps.and.abs(t(3))<eps) then
         sp = 'b'
      else if(abs(t(1))<eps.and.abs(t(2))<eps.and.abs(t(3))>eps) then
         sp = 'c'
      else
         do i=1,3
            if(abs(t(i))>eps) then
               if(abs(abs(t(i))-0.5d0) < eps) then
                  sp = 'n'
               else ! if(abs(abs(t(i))-0.25d0) < eps) then
                  sp = 'd'
               end if
               exit
           end if
        end do
      end if

    end subroutine get_symbol_of_sym_plane

    subroutine get_screw_sub(t,nr,sub)
      real(kind=DP), intent(in) :: t
      integer, intent(in) :: nr
      character(len=2), intent(out) :: sub

      real(kind=DP), parameter :: eps = 1.d-6
      integer :: ns
      ns = int(t*dble(nr)+eps)
      sub = ''
      if(ns == 1) then
        sub = '_1'
      else if(ns == 2) then
        sub = '_2'
      else if(ns == 3) then
        sub = '_3'
      else if(ns == 4) then
        sub = '_4'
      else if(ns == 5) then
        sub = '_5'
      end if
    end subroutine get_screw_sub

  end subroutine get_space_group_name

  subroutine m_CS_SG_print_space_group_name(nfout)
    integer, intent(in) :: nfout

    character(len=3) :: pg_name
    character(len=5) :: pg_name_i
    character(len=2) :: bl_name
    character(len=10) :: sg_name_i
    character(len=9) :: system
    integer :: ipri_t

    if(il>0) then
       system = 'cubic'
    else
       system = 'hexagonal'
    end if
    if(printable) then
      ipri_t = 1
    else
      ipri_t = 0
    end if

    call get_point_group_name(nfout,system,nopr,ig01,pg_name,pg_name_i)
    call get_bravais_lattice(nfout,ipri_t,altv(1,1),altv(1,2),altv(1,3),system,ig01,pg_name_i,bl_name)
    !!$call get_space_group_name(nfout,system,nopr,ig01,tau(1,1,BUCS),.true.,bl_name,pg_name_i,sg_name_i)
!!$       call get_space_group_name(nfout,system,nsym,nopr,tau(1,1,BUCS),.false.,bl_name,pg_name_i,sg_name_i)
!!$    if(.not.allocated(tau)) then
!!$       write(nfout,'(" tau is not allocated")')
!!$    else
       call get_space_group_name(nfout,system,nopr,ig01,tau(1,1,BUCS),.false.,bl_name,pg_name_i,sg_name_i)
!!$    end if

    if(printable) then
       write(nfout,'(13x,"Bravais lattice: ",a,1x,a)') bl_name
       write(nfout,'("Crystallographic point group: ",a,1x,a)') pg_name,pg_name_i
       write(nfout,'(17x,"Space group: ",a)') sg_name_i
    end if
  end subroutine m_CS_SG_print_space_group_name

  subroutine get_kpoint_symmetry(nsym,nopr,rot,kvec,nsymo,nopro,nsymo2,nopro2)
    integer, intent(in) :: nsym
    integer, intent(in) :: nopr(nsym)
    real(kind=DP), intent(in) :: rot(3,3,nsym)
    real(kind=DP), intent(in) :: kvec(3)
    integer, intent(out) :: nsymo
    integer, intent(out) :: nopro(nsym)
    integer, intent(out) :: nsymo2
    integer, intent(out) :: nopro2(nsym)

    real(kind=DP) :: rkv(3),dk(3)
    integer :: i,j
    real(kind=DP) :: eps = 1.d-6
    
    nsymo = 0
    nsymo2 = 0
    do i=1,nsym
       do j=1,3
          rkv(j) = sum(rot(j,1:3,i)*kvec(1:3))
       end do
       do j=1,3
          dk(j) = sum(altv(1:3,j)*(rkv(1:3)-kvec(1:3)))/PAI2 
       end do
       if(sum(abs(dk(1:3))) < eps) then
          nsymo2 = nsymo2 + 1
! ================================= ASMS DEBUG ================= 2013/10/03
!          nopro2(nsymo2) = nopr(i)
          nopro2(nsymo2) = i
! ================================= ASMS DEBUG ================= 2013/10/03
       end if
       call mod1(dk)
       if(sum(abs(dk(1:3))) < eps) then
          nsymo = nsymo + 1
          nopro(nsymo) = nopr(i) 
       end if
    end do

  end subroutine get_kpoint_symmetry

  subroutine vectors_length_angle(a1,a2,a3,length,angle)
    implicit none

    real(kind=DP), intent(in) :: a1(3),a2(3),a3(3)
    real(kind=DP), intent(out) :: length(3),angle(3)

    length(1) = sqrt(sum(a1(1:3)**2))
    length(2) = sqrt(sum(a2(1:3)**2))
    length(3) = sqrt(sum(a3(1:3)**2))

    angle(1) = acos(sum(a2(1:3)*a3(1:3))/(length(2)*length(3)))
    angle(2) = acos(sum(a3(1:3)*a1(1:3))/(length(3)*length(1)))
    angle(3) = acos(sum(a1(1:3)*a2(1:3))/(length(1)*length(2)))

  end subroutine vectors_length_angle

  function rational(a) result(b)
    real(kind=DP), intent(in) :: a
    real(kind=DP) :: b

    integer :: i,r
    real(kind=DP) :: eps = 1.d-4
    do i=1,20
       r = nint(a*i)
       b = dble(r)/dble(i)
       if(abs(a-b) < eps) exit
    end do
  end function rational

! ================================== Added by K. Tagami =========
  subroutine ktrational( a,b,ifound )
    real(kind=DP), intent(in) :: a
    real(kind=DP), intent(out) ::b
    integer, intent(inout) :: ifound

    integer :: i,r
    real(kind=DP) :: eps = 1.d-4
    ifound  = -1
    do i=1,20
       r = nint(a*i)
       b = dble(r)/dble(i)
       if(abs(a-b) < eps) then
          ifound = 0
          exit
       endif
    end do

  end subroutine ktrational
! ==================================================================

end module m_CS_SpaceGroup

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE: m_Force
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!    Further modification by T. Yamasaki   Apr/10/2007
!    Further modification by T. Yamasaki   Aug/31/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#ifdef VPP
#define _VECTOR_TUNING_
#endif
#ifdef SX
#define _VECTOR_TUNING_
#endif
#ifdef HIUX
#define _VECTOR_TUNING_
#endif

#ifndef NO_FORCE_DGEMM
#define FORCE_DGEMM
#endif

module m_Force
! $Id: m_Force.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_IterationNumbers,     only : iteration_ionic
  use m_Charge_Density,       only : chgq_l, hsr
  use m_Electronic_Structure, only : zaj_l,vlhxcQ,occup_l,eko_l &
       &                           , fsr_l,fsi_l,vlhxc_l
  use m_Realspace,            only : nmesh_rs_max
  use m_NonLocal_Potential,   only : snl,snld_rs
  use m_XC_Potential,         only : vxc_l, vxcpc_l
  use m_XC_Potential,         only : m_XC_cal_potential
  use m_Kpoints,              only : k_symmetry
  use m_PlaneWaveBasisSet,    only : ngabc, nbmx, nbase, iba, kgp, kg1, ylm_l &
       &                           , m_pwBS_sphrp2,igfp_l
  use m_PseudoPotential,      only : nlmta,q,ilmt,lmtt,lmta,ltp,mtp,isph,dl2p,modnrm&
       &                           , dion,taup,il2p,iqitg,qitg_l, psc_l, rhpcg_l, itpcc &
       &                           , ival, nqitg, nlmtt &
       &                           , m_PP_find_maximum_l,m_PP_include_vanderbilt_pot &
       &                           , m_PP_set_index_arrays1,m_PP_set_index_arrays2 &
       &                           , ipaw, dion_paw
  use m_Crystal_Structure,    only : rltv, nopr, op, univol, altv, sw_supercell_symmetry
  use m_Ionic_System,         only : natm,natm2,iwei,imdtyp,ityp,ntyp,nfcatm,cps &
       &                           , ntyp_vdw,fxyzvdw_l,imdtypxyz,iatomn &
       &                           , nopr_supercell, napt_supercell, iop_supercell
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : nspin, ipriforce, forccr, kimg, neg, af, nel_Ylm &
       &                           , f_tolerable_norm_error, f_tolerable_angle_error, f_tolerable_hyper_angle_error &
       &                           , sw_dipole_correction, sw_screening_correction, elec_field, sw_fef, sw_rspace &
#ifdef ENABLE_ESM_PACK
       &                           , m_CtrlP_cachesize, sw_hybrid_functional,sw_esm
#else
       &                           , m_CtrlP_cachesize, sw_hybrid_functional
#endif
  use m_Const_Parameters,     only : DP, zi, EXECUT, SKIP, PAI, PAI2, PAI4, DELTA, ON&
       &                           , Partial_Core_Charge, SIMPLE_CUBIC, GDIIS&
       &                           , RELAX, BONDLENGTH_FIX, BONDLENGTH_FIX_1 &
       &                           , BONDLENGTH_FIX_2, COG_FIX, HEAT_BATH, VXC_AND_EXC &
       &                           , WITHOUTTAG, WITHTAG, GAMMA
  use m_Parallelization,      only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype,ierr &
       &                           , map_k,myrank_k,np_e, ista_fs, iend_fs, ista_k, iend_k
  use m_Dipole,               only : dipole,field
  use m_Screening,            only : screening
#ifdef FORCE_DGEMM
! <-- T.Kokubo & D.Fukata, Feb. 2010
  use m_Control_Parameters,   only : nblocksize_force_is_given, nblocksize_force, nb_force_default
! -->
#endif

! =============================== added by K. Tagami ======================== 11.0
  use m_Control_Parameters,     only : noncol, ndim_spinor, ndim_magmom
  use m_PseudoPotential,        only : dion_scr_noncl, q_noncl
  use m_Const_Parameters,       only : CMPLDP
! ============================================================================ 11.0

  use m_FFT,                  only : fft_box_size_CD,nfftps
  use m_ES_nonlocal,          only : betar_dot_Psi_4_each_k_in_rs0

! === Positron ==== 2015/11/28
  use m_Control_Parameters,  only : sw_positron, positron_method
  use m_Const_Parameters,    only : Positron_GGGC, OFF
  use  m_Positron_Wave_Functions,  only : pchg_l
! ================= 2015/11/28

  implicit none
  include 'mpif.h'

  real(kind=DP), allocatable, dimension(:,:)       :: forc_l
  real(kind=DP)                                    :: forcmx
  real(kind=DP), private,allocatable, dimension(:,:)   :: fnlxyz_l, flhxcq_l
  real(kind=DP), private,allocatable, dimension(:,:)   :: force_previous
  integer, private ::                                 force_error_check_counter = 0
!  real(kind=DP), private,pointer, dimension(:,:)   :: fdip_l,fext_l
!  real(kind=DP), private,pointer, dimension(:,:)   :: ffef_l
  real(kind=DP), private,allocatable, dimension(:,:)   :: fdip_l,fext_l
  real(kind=DP), private,allocatable, dimension(:,:)   :: ffef_l
  real(kind=DP), allocatable, dimension(:,:)   :: fexx_l

!!$  real(kind=DP), private,allocatable,target,dimension(:):: zfcos, zfsin
  integer,       private,pointer, dimension(:)     :: il3
  real(kind=DP), private,pointer, dimension(:,:)   :: work
  real(kind=DP), private,pointer, dimension(:)     :: ylm
  real(kind=DP), private,pointer, dimension(:)     :: ar, ai
  real(kind=DP), private,pointer, dimension(:,:,:) :: gr,gi ! derivative of (fsr,fsi)
  real(kind=DP), private,pointer, dimension(:,:)   :: forc_up, forc_down, forcw
  integer,       private,pointer, dimension(:)     :: ipfrc
  integer,       private  :: iteration_ionic_wd_forcmx = 0
contains
  subroutine m_Force_alloc
    if(allocated(forc_l)) deallocate(forc_l)
    allocate(forc_l(natm,3));forc_l=0.d0
    allocate(fnlxyz_l(natm,3))
    allocate(flhxcq_l(natm,3))
    if(sw_dipole_correction==ON) then
      allocate(fdip_l(natm,3))
      allocate(fext_l(natm,3))
    end if
    if(sw_fef == ON) allocate(ffef_l(natm,3))
    if(sw_hybrid_functional == ON) allocate(fexx_l(natm,3))
  end subroutine m_Force_alloc

  subroutine m_Force_sumup_and_symmetrize(nfout,fxyzew_l,napt)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in), dimension(natm,3) :: fxyzew_l
    integer,intent(in), dimension(natm,nopr+af)     :: napt
    
    integer :: ia, j
    integer,save :: id_sname = -1

    call tstatc0_begin('m_Force_sumup_and_symmetrize ',id_sname)
#ifdef __TIMER_SUB__
    call timer_sta(1506)
#endif
    if(ipriforce >= 2) then
       write(nfout,'(" force elements ")')
       write(nfout,'(" -- forc_l (local+pcc) --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(forc_l(ia,j),j=1,3)
       end do
       write(nfout,'(" -- fnlxyz_l --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(fnlxyz_l(ia,j),j=1,3)
       end do
       write(nfout,'(" -- fxyzew_l --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(fxyzew_l(ia,j),j=1,3)
       end do
       write(nfout,'(" -- flhxcq_l --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(flhxcq_l(ia,j),j=1,3)
       end do
       if(sw_dipole_correction==ON) then
          write(nfout,'(" -- fdip_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(fdip_l(ia,j),j=1,3)
          end do
          write(nfout,'(" -- fext_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(fext_l(ia,j),j=1,3)
          end do
       end if
       if(sw_fef == ON) then
          write(nfout,'(" -- ffef_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(ffef_l(ia,j),j=1,3)
          end do
       end if
       if(ntyp_vdw>0) then
          write(nfout,'(" -- fxyzvdw_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(fxyzvdw_l(ia,j),j=1,3)
          end do
       end if
       if(sw_hybrid_functional == ON) then
          write(nfout,'(" -- fexx_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(fexx_l(ia,j),j=1,3)
          end do
       end if
    end if

    forc_l = forc_l + fnlxyz_l + fxyzew_l + flhxcq_l
    if(sw_dipole_correction==ON) then
       forc_l = forc_l + fdip_l + fext_l
    end if
    if(sw_fef==ON) forc_l = forc_l + ffef_l
    if(sw_hybrid_functional==ON) forc_l = forc_l + fexx_l
    if(ntyp_vdw>0) then
       forc_l = forc_l + fxyzvdw_l
    end if

    if(ipriforce >= 2) then
       write(nfout,'(" -- total forc_l --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(forc_l(ia,j),j=1,3)
          call flush(nfout)
       end do
    end if
!!$    if(nbztyp >= SIMPLE_CUBIC) then
    if(nopr >= 2) then
       allocate(forcw(natm,3)); allocate(ipfrc(natm2))
!!$       write(6,'(" sw_supercell_symmetry = ",i8)') sw_supercell_symmetry
       call flush(6)
       if(nopr_supercell <= nopr .or. sw_supercell_symmetry /= ON) then
          call fd_symmetrize(natm2,natm,natm,napt,nopr+af,nopr,op,iwei &
               &, forc_l, forcw, ipfrc) ! -(bottom_Subroutines_para)
!!$          call fd_symmetrize(natm2,natm,natm,napt,nopr+af,op,nopr+af,nopr &
!!$               & ,iwei, forc_l, forcw, ipfrc) ! -(bottom_Subroutines_para)
       else
!!$          call fd_symmetrize(natm2,natm,natm,napt_supercell,nopr_supercell,op,nopr+af,nopr_supercell &
!!$               & ,iwei, forc_l, forcw, ipfrc, iop_supercell)
          call fd_supercell_symmetrize(natm2,natm,natm,napt_supercell,nopr_supercell,op,nopr+af,iwei &
               & ,forc_l, forcw, ipfrc, iop_supercell)
       end if
       deallocate(forcw); deallocate(ipfrc)
       if(ipriforce >= 2) then
          write(nfout,'(" -- total forc_l symmetrized --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(forc_l(ia,j),j=1,3)
          end do
       end if
    end if
#ifdef __TIMER_SUB__
    call timer_end(1506)
#endif

  end subroutine m_Force_sumup_and_symmetrize

  subroutine m_Force_term_Elocal_and_Epc(nfout,pos)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in), dimension(natm,3) :: pos 
    real(kind=DP), allocatable,dimension(:):: zfcos, zfsin
    integer :: ia, it, ipc
    integer :: id_sname = -1
    complex(kind=CMPLDP),allocatable,dimension(:) :: aux
    integer :: ig,ikm,kimgtmp
    real(kind=DP), allocatable, dimension(:,:) :: forc_l_esm
    real(kind=DP), allocatable, dimension(:,:) :: agauss,bgauss
    real(kind=DP), dimension(2) :: alp,cc
    real(kind=DP) :: ivaltmp
    integer :: i,j,itpcctmp,nfftcd
    call tstatc0_begin('m_Force_term_Elocal_and_Epc ', id_sname,1)
    allocate(forcw(natm,3))
    allocate(zfsin(ista_kngp:iend_kngp))
    allocate(zfcos(ista_kngp:iend_kngp))
#ifndef REMOVE_PC_FROM_FORCE
    call m_XC_cal_potential(nfout,Partial_Core_Charge,chgq_l,VXC_AND_EXC)
                                               !  -> vxcpc_l
#endif
    forcw = 0.d0
    do ia = 1, natm
       it = ityp(ia); ipc = itpcc(it)
       call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
       call force_from_Elocal_4_each_atom ! -(contained here) ->forcw
       if(ipc /= 0 ) call force_from_Epc_for_each_atom    ! -> forcw
    end do

    do ia = 1, natm
       call pucv2cart(rltv,forcw(ia,1),forcw(ia,2),forcw(ia,3))
       forc_l(ia,1:3) = forc_l(ia,1:3) + forcw(ia,1:3)
    end do

    deallocate(zfcos,zfsin)
    deallocate(forcw)

#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON)then
       nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
       allocate(aux(nfftcd));aux(:) = (0.d0,0.d0)
       allocate(agauss(natm,2))
       allocate(bgauss(natm,2))
       do i=1,natm
          call psbhs0(nfout,nint(iatomn(ityp(i))),ivaltmp,itpcctmp,alp,cc)  ! -(b_PseudoPotential)
          agauss(i,1) = alp(1)
          agauss(i,2) = alp(2)
          bgauss(i,1) = cc(1)
          bgauss(i,2) = cc(2)
       enddo
       do ig=ista_kngp,iend_kngp
         if(kimg==1)then
           if(nspin==1)then
             aux(igfp_l(ig)) = dcmplx(chgq_l(ig,1,1),0.0d0)
           else
             aux(igfp_l(ig)) = dcmplx(chgq_l(ig,1,1)+chgq_l(ig,1,2),0.0d0)
           endif
         else
           if(nspin==1)then
             aux(igfp_l(ig)) = dcmplx(chgq_l(ig,1,1),chgq_l(ig,2,1))
           else
             aux(igfp_l(ig)) = dcmplx(chgq_l(ig,1,1)+chgq_l(ig,1,2),chgq_l(ig,2,1)+chgq_l(ig,2,2))
           endif
         endif
       enddo
       allocate(forc_l_esm(3,natm));forc_l_esm=0.d0
       call mpi_allreduce(MPI_IN_PLACE,aux,nfftps/kimg,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
       call esm_force_lc_(nfftcd,aux,natm,forc_l_esm,2,agauss,bgauss)
       do i=1,natm
          do j=1,3
             forc_l(i,j) = forc_l(i,j) + forc_l_esm(j,i)*0.5d0
          enddo
       enddo
       deallocate(aux)
       deallocate(forc_l_esm)
       deallocate(agauss,bgauss)
    endif
#endif

    call tstatc0_end(id_sname)
  contains
    subroutine force_from_Epc_for_each_atom
      integer :: is, i
      real(kind=DP) :: tp
      real(kind=DP), dimension(3) :: f1, f2
      real(kind=DP), dimension(3) :: f1_mpi, f2_mpi ! MPI

! ============================ added by K. Tagami ===================== 11.0
      integer :: is_max
! ===================================================================== 11.0

      f1 = 0.d0
      f2 = 0.d0
      f1_mpi = 0.d0
      f2_mpi = 0.d0

#ifdef NEC_TUNE_SMP
!CDIR NOCONCUR
#endif

! =============================== added by K. Tagami ==================== 11.0
      if ( noncol ) then
         is_max = 1
      else
         is_max = nspin
      endif
! ======================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!      do is = 1, nspin
      do is = 1, is_max
! ======================================================================== 11.0

         if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               tp  = zfsin(i)*vxc_l(i,1,is)*rhpcg_l(i,ipc)
               f1_mpi(1) = f1_mpi(1) + tp*ngabc(i,1)
               f1_mpi(2) = f1_mpi(2) + tp*ngabc(i,2)
               f1_mpi(3) = f1_mpi(3) + tp*ngabc(i,3)
            end do
         else if(kimg == 2) then
!!$#ifdef NEC_TUNE_SMP
!!$!CDIR INNER
!!$#endif
            do i = ista_kngp, iend_kngp  !for mpi
               tp  = (zfsin(i)*vxc_l(i,1,is)+zfcos(i)*vxc_l(i,2,is))&
                    &*rhpcg_l(i,ipc)
               f1_mpi(1) = f1_mpi(1) + tp*ngabc(i,1)
               f1_mpi(2) = f1_mpi(2) + tp*ngabc(i,2)
               f1_mpi(3) = f1_mpi(3) + tp*ngabc(i,3)
            end do
         end if
      end do
      call mpi_allreduce(f1_mpi,f1,3 &
           &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

! ================================ modified by K. Tagami =================== 11.0
!!      if(nspin == 2) f1 = f1/2.d0
!
      if ( noncol ) then
      else
         if(nspin == 2) f1 = f1/2.d0
      endif
! =========================================================================== 11.0

#ifndef REMOVE_PC_FROM_FORCE
      if(kimg == 1) then
         do i = ista_kngp, iend_kngp  !for mpi
            tp  = zfsin(i)*vxcpc_l(i,1)*rhpcg_l(i,ipc)
            f2_mpi(1) = f2_mpi(1) + tp*ngabc(i,1)
            f2_mpi(2) = f2_mpi(2) + tp*ngabc(i,2)
            f2_mpi(3) = f2_mpi(3) + tp*ngabc(i,3)
         end do
      else if(kimg == 2) then
         do i = ista_kngp, iend_kngp  !for mpi
            tp  = (zfsin(i)*vxcpc_l(i,1)+zfcos(i)*vxcpc_l(i,2))*rhpcg_l(i,ipc)
            f2_mpi(1) = f2_mpi(1) + tp*ngabc(i,1)
            f2_mpi(2) = f2_mpi(2) + tp*ngabc(i,2)
            f2_mpi(3) = f2_mpi(3) + tp*ngabc(i,3)
         end do
!xocl end spread
      end if
      call mpi_allreduce(f2_mpi,f2,3 &
           &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
!!$      forcw(ia,1) = forcw(ia,1) + (f1(1)/nspin - f2(1))*univol
!!$      forcw(ia,2) = forcw(ia,2) + (f1(2)/nspin - f2(2))*univol
!!$      forcw(ia,3) = forcw(ia,3) + (f1(3)/nspin - f2(3))*univol
      forcw(ia,1) = forcw(ia,1) + (f1(1) - f2(1))*univol
      forcw(ia,2) = forcw(ia,2) + (f1(2) - f2(2))*univol
      forcw(ia,3) = forcw(ia,3) + (f1(3) - f2(3))*univol
#else
!!$      forcw(ia,1) = forcw(ia,1) + (f1(1)/nspin)*univol
!!$      forcw(ia,2) = forcw(ia,2) + (f1(2)/nspin)*univol
!!$      forcw(ia,3) = forcw(ia,3) + (f1(3)/nspin)*univol
      forcw(ia,1) = forcw(ia,1) + f1(1)*univol
      forcw(ia,2) = forcw(ia,2) + f1(2)*univol
      forcw(ia,3) = forcw(ia,3) + f1(3)*univol
#endif

    end subroutine force_from_Epc_for_each_atom

    subroutine force_from_Elocal_4_each_atom
      integer :: is, i
      real(kind=DP) :: tmp
      real(kind=DP) :: fx,fy,fz
      real(kind=DP), pointer, dimension(:) :: f1_mpi,f2_mpi ! MPI

! ============================ added by K. Tagami ===================== 11.0
      integer :: is_max
! ===================================================================== 11.0

      fx = 0.d0; fy = 0.d0; fz = 0.d0
      allocate(f1_mpi(3)); allocate(f2_mpi(3))              ! MPI

#ifdef NEC_TUNE_SMP
!CDIR NOCONCUR
#endif

! =============================== added by K. Tagami ==================== 11.0
      if ( noncol ) then
         is_max = 1
      else
         is_max = nspin
      endif
! ======================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!      do is = 1, nspin
      do is = 1, is_max
! ======================================================================== 11.0

         if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               tmp = zfsin(i)*chgq_l(i,1,is)*psc_l(i,it)
               if(sw_screening_correction==ON) then
                 tmp = zfsin(i)*chgq_l(i,1,is)*(psc_l(i,it)-ival(it)*screening%phik(i)/univol)
               end if
               fx = fx + tmp*ngabc(i,1)
               fy = fy + tmp*ngabc(i,2)
               fz = fz + tmp*ngabc(i,3)
            end do
         else if(kimg == 2) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               tmp = (zfsin(i)*chgq_l(i,1,is)+zfcos(i)*chgq_l(i,2,is))&
                    &*psc_l(i,it)
               if(sw_screening_correction==ON) then
                 tmp = (zfsin(i)*chgq_l(i,1,is)+zfcos(i)*chgq_l(i,2,is))&
                      &*(psc_l(i,it)-ival(it)*Screening%phik(i)/univol)
               end if
               fx = fx + tmp*ngabc(i,1)
               fy = fy + tmp*ngabc(i,2)
               fz = fz + tmp*ngabc(i,3)
            end do
         end if
      end do

! == POSITRON SCF === 2015/11/28
      if ( sw_positron /= OFF ) then
         if ( positron_method == Positron_GGGC ) then
            if(kimg == 1) then
               do i = ista_kngp, iend_kngp  !for mpi
                  tmp = -zfsin(i) *pchg_l(i,1) *psc_l(i,it)
                  fx = fx + tmp*ngabc(i,1)
                  fy = fy + tmp*ngabc(i,2)
                  fz = fz + tmp*ngabc(i,3)
               end do
            else
               do i = ista_kngp, iend_kngp  !for mpi
                  tmp = -( zfsin(i) *pchg_l(i,1) +zfcos(i)*pchg_l(i,2) )&
                       &  *psc_l(i,it)
                  fx = fx + tmp*ngabc(i,1)
                  fy = fy + tmp*ngabc(i,2)
                  fz = fz + tmp*ngabc(i,3)
               end do
            endif
         endif
      endif
! ============= 2015/11/28

      f1_mpi(1) = fx; f1_mpi(2) = fy; f1_mpi(3) = fz
      call mpi_allreduce(f1_mpi,f2_mpi,3 &
           &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
      forcw(ia,1:3) = f2_mpi(1:3)*univol
      deallocate(f2_mpi); deallocate(f1_mpi)
    end subroutine force_from_Elocal_4_each_atom
  end subroutine m_Force_term_Elocal_and_Epc

  subroutine m_Force_initialize
#ifdef __TIMER_SUB__
    call timer_sta(1501)
#endif
    forc_l = 0.d0
#ifdef __TIMER_SUB__
    call timer_end(1501)
#endif
  end subroutine m_Force_initialize

  subroutine m_Force_term_drv_of_vlhxcQ(nfout,pos,napt)
    !  ----
    ! (Rev) T. Yamaskai, 31, Aug, 2007
    !     1. 'call set_index_arrays1' that included a bug is replaced
    !       by 'call m_PP_set_index_arrays1', whose bug is fixed.
    !     2. 'call set_index_arrays2' is also replaced by 'call
    !       m_PP_set_index_arrays2' that can be referred from other modules.
    !     3. contained subroutines, set_index_arrays1 and set_index_arrays2 were
    !       deleted.
    integer,intent(in)                           :: nfout
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)  :: napt

    real(kind=DP), allocatable, dimension(:)                  :: ylm_t
    real(kind=DP), allocatable, target, dimension(:,:)        :: ylm_ext
    real(kind=DP), allocatable, dimension(:):: zfcos, zfsin

#ifndef _VECTOR_TUNING_
    real(kind=DP), allocatable, dimension(:,:) :: flhxcq_mpi
    real(kind=DP), allocatable, dimension(:) :: ylm_sum
    integer :: ncache, ibsize, iwidth, ibl1, ibl2, iwidthmax
#endif

#ifndef _m_Force_no_loop_exchange_
    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
#endif
    
! ============================ added by K. Tagami ===================== 11.0
    integer :: is_max
! ===================================================================== 11.0

    integer :: is,it,lmt1,lmt2,n,ia,mdvdb,il1,tau1,il2,tau2,ilm3,l3,iiqitg
    real(kind=DP) :: fx,fy,fz,shdg_x
    integer       :: id_sname = -1
    call tstatc0_begin('m_Force_term_drv_of_vlhxcQ ',id_sname,1)

    call m_PP_find_maximum_l(n)
    n = (n-1) + (n-1) + 1

    if(modnrm == EXECUT) then
       allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
       if(n**2 > nel_Ylm) then
          allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2)); ylm_ext = 0.d0
       end if
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
       deallocate(ylm_t)

#ifndef _m_Force_no_loop_exchange_
       allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
       allocate(iq2l3(nqitg))
       allocate(nc(mcritical,nqitg));nc=0
       call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
            & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)  ! -> nqitg_sp, nqitg_sp0, iq2l3,nc, maxm, mc
       allocate(nc2lmt1(mc,maxm,nqitg))
       allocate(nc2lmt2(mc,maxm,nqitg))
       allocate(nc2n(mc,maxm,nqitg))
       call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
            & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc
#endif
       
    end if

! =============================== added by K. Tagami ==================== 11.0
    if ( noncol ) then 
       is_max = ndim_magmom
    else
       is_max = nspin
    endif
! ======================================================================== 11.0

    flhxcq_l = 0.d0
#ifdef _VECTOR_TUNING_
    allocate(zfcos(ista_kngp:iend_kngp))
    allocate(zfsin(ista_kngp:iend_kngp))
    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle

       do ia= 1,natm
          if(ityp(ia) /= it) cycle
          fx = 0.d0; fy = 0.d0; fz = 0.d0
          call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)

! ========================================= modified by K. Tagami ========= 11.0
!          do is = 1, nspin, af+1
          do is = 1, is_max, af+1
! ========================================================================= 11.0

#ifndef _m_Force_no_loop_exchange_
             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
                   call sum_hsr_dot_gauntc(is,it,ia,iq,m)
                   if(ilm3 <= nel_Ylm) then
                      ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
                   else
                      ylm => ylm_ext(ista_kngp:iend_kngp,ilm3)
                   end if
                   call add_hardpart_to_flhxcq_l_core(iq,ista_kngp,iend_kngp)
                   !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                   !   --> fx,fy,fz
                end do
             end do
#else
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it); tau1 = taup(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it); tau2 = taup(lmt2,it)
                   do n = 1, il2p(lmt1,lmt2,it)
                      ilm3 = isph(lmt1,lmt2,n,it);    l3   =  il3(ilm3)
                      iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                      if(iiqitg == 0) cycle
                      call hsr_dot_gaunt(is,it,ia,lmt1,lmt2,n) 
                      if(ilm3 <= nel_Ylm) then
                         ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
                      else
                         ylm => ylm_ext(ista_kngp:iend_kngp,ilm3)
                      end if
                      call add_hardpart_to_flhxcq_l_core(iiqitg,ista_kngp,iend_kngp)
                      !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                      !   --> fx,fy,fz
                   end do ! n
                end do ! lmt2
             end do
#endif
          end do
          call pucv2cart(rltv,fx,fy,fz)
!!$       call fxyz_gsum(fx,fy,fz)
          flhxcq_l(ia,1) = fx; flhxcq_l(ia,2) = fy; flhxcq_l(ia,3) = fz
       end do
    end do
    deallocate(zfsin, zfcos)
#else

#ifndef _m_Force_no_loop_exchange_
    ncache = (m_CtrlP_cachesize()*1024)*3/4
    if(ncache == 0) ibsize = iend_kngp - ista_kngp + 1

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       if(ipriforce >= 2) write(nfout,'(" !mForce: it = ",i8)') it
       
       if(ncache/=0) then
          iwidth = nqitg_sp(it) - nqitg_sp0(it) + 1
          if(kimg == 1) then ! qitg_l(i,iq)*ylm(iy)*zfsc1_1(iy)
             ibsize=ncache/(8*(iwidth + 1))
          else ! qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc2_1(iy)
             ibsize=ncache/(8*(iwidth + 2))
          endif
          if(ipriforce >= 2) write(nfout,'(" !mForce: ibsize, iwidth, ncache = ",3i8)') ibsize, iwidth, ncache
       end if

       IBLOCK: do ibl1=ista_kngp,iend_kngp,ibsize
          ibl2=ibl1+ibsize-1
          if(ibl2.gt.iend_kngp) ibl2=iend_kngp
          if(ibl2.gt.kgp) ibl2 = kgp
          allocate(ylm_sum(ibl1:ibl2))
          allocate(zfcos(ibl1:ibl2)); allocate(zfsin(ibl1:ibl2))

       do ia= 1,natm
          if(ityp(ia) /= it) cycle
          fx = 0.d0; fy = 0.d0; fz = 0.d0
          call calc_phase_div(ia)  ! -> zfsin, zfcos

! ========================================= modified by K. Tagami ========= 11.0
!          do is = 1, nspin, af+1
             do is = 1, is_max, af+1
! ========================================================================= 11.0

             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
                ylm_sum = 0.d0
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
                   call sum_hsr_dot_gauntc(is,it,ia,iq,m)
                   if(ilm3 <= nel_Ylm) then
                      ylm_sum(ibl1:ibl2) = ylm_sum(ibl1:ibl2) + shdg_x*ylm_l(ibl1:ibl2,ilm3)
!!!$                      ylm => ylm_l(:,ilm3)
                   else
                      ylm_sum(ibl1:ibl2) = ylm_sum(ibl1:ibl2) + shdg_x*ylm_ext(ibl1:ibl2,ilm3)
!!!$                      ylm => ylm_ext(:,ilm3)
                   end if
!!!$                   call add_hardpart_to_flhxcq_l_core(iq,ibl1,ibl2)
!!!$                   !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!!!$                   !   --> fx,fy,fz
                end do
                call add_hardpart_to_flhxcq_l_div(iq,ibl1,ibl2)
             end do
          end do
          call pucv2cart(rltv,fx,fy,fz)
          flhxcq_l(ia,1)=flhxcq_l(ia,1)+fx; flhxcq_l(ia,2)=flhxcq_l(ia,2)+fy; flhxcq_l(ia,3)=flhxcq_l(ia,3)+fz
       end do
       deallocate(zfsin,zfcos)
       deallocate(ylm_sum)
       end do IBLOCK
    end do
    if(npes>1) then
       allocate(flhxcq_mpi(natm,3)); flhxcq_mpi = 0.d0
       call mpi_allreduce(flhxcq_l,flhxcq_mpi,3*natm,mpi_double_precision &
            & , mpi_sum, mpi_comm_group,ierr)
       flhxcq_l = flhxcq_mpi
       deallocate(flhxcq_mpi)
    end if
#else
    stop ' you cannot define _m_Force_no_loop_exchange_'
#endif
#endif

!!$!xocl spread do/ind_natm
!!$    do ia = 1, natm
!!$       fx = flhxcq_l(ia,1); fy = flhxcq_l(ia,2); fz = flhxcq_l(ia,3)
!!$       call pucv2cart(rltv,fx,fy,fz)
!!$       flhxcq_l(ia,1) = fx; flhxcq_l(ia,2) = fy; flhxcq_l(ia,3) = fz
!!$    end do
!!$!xocl end spread

    if(af /= 0) then
       allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
       call forcaf2(natm,natm2,nopr+af,natm,nopr,napt&
            &, iwei,op,ipriforce,af,flhxcq_l,forc_up,forc_down)
       deallocate(forc_up); deallocate(forc_down)
    endif
    if(modnrm == EXECUT) then
       if(allocated(ylm_ext)) deallocate(ylm_ext)
       deallocate(il3)
#ifndef _m_Force_no_loop_exchange_
       deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
#endif
    end if

    call tstatc0_end(id_sname)
  contains
#ifndef SX
    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: ig
      real(kind=DP) :: fx,fy,fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do ig = ibl1, ibl2
         ph = ngabc(ig,1)*fx + ngabc(ig,2)*fy + ngabc(ig,3)*fz
         zfcos(ig) = dcos(ph)
         zfsin(ig) = dsin(ph)
      end do
    end subroutine calc_phase_div
#endif

#ifndef _m_Force_no_loop_exchange_
    subroutine sum_hsr_dot_gauntc(is,it,ia,iq,m)
      integer, intent(in) :: is,it,ia,iq,m
      integer :: ip, lmt1, lmt2, np
      real(kind=DP) :: fac
      shdg_x = 0.d0
      do ip = 1, nc(m,iq)
         lmt1 = nc2lmt1(ip,m,iq)
         lmt2 = nc2lmt2(ip,m,iq)
         np = nc2n(ip,m,iq)
         fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
         shdg_x = shdg_x + &
              & fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,np,it)
      end do
    end subroutine sum_hsr_dot_gauntc
#else
    subroutine hsr_dot_gaunt(is,it,ia,lmt1,lmt2,n)
      integer, intent(in) :: is, it, ia, lmt1,lmt2,n
      real(kind=DP) :: fac
      
      fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
      shdg_x = fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
    end subroutine hsr_dot_gaunt

#endif
    subroutine add_hardpart_to_flhxcq_l_core(iq,ibl1,ibl2)
      integer, intent(in) :: iq,ibl1,ibl2
      integer       :: i, iy
      real(kind=DP) :: flchgq, f, tx,ty,tz, f2
      real(kind=DP),pointer,dimension(:) :: f1_mpi, f2_mpi
!!$      real(kind=DP),pointer,dimension(:) :: zfsc1, zfsc2

!!$      if(mod(l3,2) == 0) then
!!$         flchgq = fac*real(zi**(-l3))*dga*hsr(ia,lmt1,lmt2,is)
!!$         flchgq = real(zi**(-l3))*shdg_x
!!$         if(kimg == 1) then
!!$            zfsc1 => zfsin
!!$         else
!!$            f2 = 1;  zfsc1 => zfsin; zfsc2 => zfcos
!!$         end if
!!$      else
!!$         flchgq = - aimag(zi**(-l3))*shdg_x
!!$         if(kimg == 1) then
!!$            zfsc1 => zfcos
!!$         else
!!$            f2 = -1; zfsc1 => zfcos; zfsc2 => zfsin
!!$         end if
!!$      end if

      tx = 0.d0; ty = 0.d0; tz = 0.d0
      if(mod(l3,2) == 0) then
         flchgq = real(zi**(-l3))*shdg_x
         if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ibl1, ibl2  !for mpi
               iy = i-ista_kngp+1
!!$               f  = qitg_l(i,iq)*ylm(iy)*vlhxc_l(i,1,is)*zfsc1(iy)
               f  = qitg_l(i,iq)*ylm(iy)*vlhxc_l(i,1,is)*zfsin(i)
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         else if(kimg == 2) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ibl1, ibl2  !for mpi
               iy = i-ista_kngp+1
               f = qitg_l(i,iq)*ylm(iy)*&
                    &(vlhxc_l(i,1,is)*zfsin(i)+vlhxc_l(i,2,is)*zfcos(i))
!!$                    &(vlhxc_l(i,1,is)*zfsc1(iy)+vlhxc_l(i,2,is)*zfsc2(iy))
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         end if
      else
         flchgq = - aimag(zi**(-l3))*shdg_x
         if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ibl1, ibl2  !for mpi
               iy = i-ista_kngp+1
!!$               f  = qitg_l(i,iq)*ylm(iy)*vlhxc_l(i,1,is)*zfsc1(iy)
               f  = qitg_l(i,iq)*ylm(iy)*vlhxc_l(i,1,is)*zfcos(i)
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         else if(kimg == 2) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ibl1, ibl2  !for mpi
               iy = i-ista_kngp+1
               f = qitg_l(i,iq)*ylm(iy)*&
                    &(vlhxc_l(i,1,is)*zfcos(i)-vlhxc_l(i,2,is)*zfsin(i))
!!$                    &(vlhxc_l(i,1,is)*zfsc1(iy)-vlhxc_l(i,2,is)*zfsc2(iy))
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         end if
      end if

      if(npes > 1) then
         allocate(f1_mpi(3)); allocate(f2_mpi(3))
         f1_mpi(1) = tx; f1_mpi(2) = ty; f1_mpi(3) = tz  ! MPI
         call mpi_allreduce(f1_mpi,f2_mpi,3 &
              &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) ! MPI
         tx = f2_mpi(1); ty = f2_mpi(2); tz = f2_mpi(3)
         deallocate(f2_mpi); deallocate(f1_mpi)
      end if
      fx = fx + flchgq*tx*univol
      fy = fy + flchgq*ty*univol
      fz = fz + flchgq*tz*univol

    end subroutine add_hardpart_to_flhxcq_l_core

#ifndef SX
    subroutine add_hardpart_to_flhxcq_l_div(iq,ibl1,ibl2)
      integer, intent(in) :: iq,ibl1,ibl2
      integer       :: i
      real(kind=DP) :: flchgq, f, tx,ty,tz, f2
      real(kind=DP),pointer,dimension(:) :: f1_mpi, f2_mpi

      tx = 0.d0; ty = 0.d0; tz = 0.d0
      if(mod(l3,2) == 0) then
         flchgq = real(zi**(-l3))
         if(kimg == 1) then
            do i = ibl1, ibl2  !for mpi
               f  = qitg_l(i,iq)*ylm_sum(i)*vlhxc_l(i,1,is)*zfsin(i)
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         else if(kimg == 2) then
            do i = ibl1, ibl2  !for mpi
               f = qitg_l(i,iq)*ylm_sum(i)*&
                    &(vlhxc_l(i,1,is)*zfsin(i)+vlhxc_l(i,2,is)*zfcos(i))
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         end if
      else
         flchgq = - aimag(zi**(-l3))
         if(kimg == 1) then
            do i = ibl1, ibl2  !for mpi
               f  = qitg_l(i,iq)*ylm_sum(i)*vlhxc_l(i,1,is)*zfcos(i)
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         else if(kimg == 2) then
            do i = ibl1, ibl2  !for mpi
               f = qitg_l(i,iq)*ylm_sum(i)*&
                    &(vlhxc_l(i,1,is)*zfcos(i)-vlhxc_l(i,2,is)*zfsin(i))
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         end if
      end if

!!$      if(npes > 1) then
!!$         allocate(f1_mpi(3)); allocate(f2_mpi(3))
!!$         f1_mpi(1) = tx; f1_mpi(2) = ty; f1_mpi(3) = tz  ! MPI
!!$         call mpi_allreduce(f1_mpi,f2_mpi,3 &
!!$              &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) ! MPI
!!$         tx = f2_mpi(1); ty = f2_mpi(2); tz = f2_mpi(3)
!!$         deallocate(f2_mpi); deallocate(f1_mpi)
!!$      end if
      fx = fx + flchgq*tx*univol
      fy = fy + flchgq*ty*univol
      fz = fz + flchgq*tz*univol

    end subroutine add_hardpart_to_flhxcq_l_div
#endif
  end subroutine m_Force_term_drv_of_vlhxcQ

#ifdef FORCE_DGEMM
! <-- T.Kokubo & D.Fukata, Feb. 2010
  subroutine m_Force_term_drv_of_flmt(kv3,pos,napt)
    integer, intent(in)                          :: kv3
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)     :: napt

    integer       :: id_sname = -1
    integer :: ibsize,ibl1,ibl2, is,ik,iksnl,ia,it,mdvdb,aoffset
    real(kind=DP) :: fac, fx, fy, fz

    integer, allocatable, dimension(:)       :: mil_tmp
    integer, allocatable, dimension(:,:)     :: ngabc_red
    real(kind=DP),allocatable,dimension(:,:) :: zfsin,  zfcos   ! MPI
    real(kind=DP),allocatable,dimension(:,:,:) :: ar_tmp, ai_tmp  ! MPI
    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi
    real(kind=DP),allocatable,dimension(:,:,:) :: fr,fi
    real(kind=DP),dimension(3) :: tmpsum
    integer :: ii,ncount

      call tstatc0_begin('m_Force_term_drv_of_flmt ',id_sname,1)
      allocate( gr(np_e,nlmta,3) )    ! MPI
      allocate( gi(np_e,nlmta,3) )    ! MPI
      fac = 2.d0/kv3
      fnlxyz_l = 0.d0

      if(nblocksize_force_is_given) then
         ibsize = nblocksize_force
      else
         ibsize= nb_force_default
      end if
      if(ipriforce >=2) write(6,'(" ! ibsize = ",i8," <<m_Force_term_drv_of_flmt>>")') ibsize
      allocate(   mil_tmp(nlmta)    );   mil_tmp = 0
      allocate( ngabc_red(ibsize,3) ); ngabc_red = 0
      allocate(     zfcos(ibsize,natm),      zfsin(ibsize,natm)    )
      allocate(    ar_tmp(ibsize,nlmta,3),  ai_tmp(ibsize,nlmta,3) )
      if(sw_rspace==ON)then
         allocate(fr(np_e,nlmta,ista_k:iend_k));fr=0.d0
         allocate(fi(np_e,nlmta,ista_k:iend_k));fi=0.d0
      endif
      do is = 1, nspin, af+1
         do ik = is, kv3+is-nspin,nspin
            if(map_k(ik) /= myrank_k) cycle
            iksnl = (ik-1)/nspin+1

            if(sw_rspace==ON)then
               do ii=1,3
                  fr=0.d0;fi=0.d0
                  call betar_dot_Psi_4_each_k_in_rs0(6,ista_k,iend_k,ik,zaj_l, &
               &  fr,fi,nmesh_rs_max,snld_rs(1:nmesh_rs_max,1:nlmta,ii))
                  gr(1:np_e,1:nlmta,ii) = fr(1:np_e,1:nlmta,ik)
                  gi(1:np_e,1:nlmta,ii) = fi(1:np_e,1:nlmta,ik)
               enddo
               aoffset = 0
               do ia = 1, natm
                  it = ityp(ia)
                  fx = 0.d0; fy = 0.d0; fz = 0.d0
                  mdvdb = m_PP_include_vanderbilt_pot(it)
                  if(mdvdb == EXECUT) then
                     call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
                  else if(mdvdb == SKIP) then
                     call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
                  end if
                  aoffset = aoffset + ilmt(it)
                  fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
                  fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
                  fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
               end do
            else
            do ibl1 = 1, iba(ik), ibsize
               ibl2 = ibl1+ibsize-1
               if(ibl2 .gt. iba(ik)) ibl2 = iba(ik)
               gr=0.d0
               gi=0.d0

               call substitute_ngabcred(ik)         ! ngabc,nbase                   --> ngabc_red
               call calc_phase_div()                ! pos, ngabc_red                --> zfcos, zfsin
               call pre_drv_of_betar_dot_WFs_div()  ! zfsin,zfcos,snl               --> ar_tmp,ai_tmp
               call drv_of_betar_dot_WFs_div(gr,gi) ! ar_tmp,ai_tmp,zaj_l,ngabc_red --> gr,gi

               aoffset = 0
               do ia = 1, natm
                  it = ityp(ia)
                  fx = 0.d0; fy = 0.d0; fz = 0.d0
                  mdvdb = m_PP_include_vanderbilt_pot(it)
                  if(mdvdb == EXECUT) then
                     call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
                  else if(mdvdb == SKIP) then
                     call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
                  end if
                  aoffset = aoffset + ilmt(it)
                  call pucv2cart(rltv,fx,fy,fz)
                  fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
                  fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
                  fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
                end do
            end do
            endif
         end do
      end do

      deallocate( mil_tmp, ngabc_red, zfcos, zfsin, ar_tmp, ai_tmp )
      if(sw_rspace==ON)then
         deallocate(fr)
         deallocate(fi)
      endif

      if(npes>1) then
         allocate(fnlxyz_mpi(natm,3)); fnlxyz_mpi = 0.d0
         call mpi_allreduce(fnlxyz_l,fnlxyz_mpi,3*natm,mpi_double_precision &
             & , mpi_sum, mpi_comm_group,ierr)
         fnlxyz_l = fnlxyz_mpi
      end if
      if(npes>1)deallocate(fnlxyz_mpi)

      if(af /= 0) then
         allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
         call forcaf2(natm,natm2,nopr+af,natm,nopr,napt &
           & ,iwei,op,ipriforce,af,fnlxyz_l ,forc_up,forc_down)
         deallocate(forc_down);deallocate(forc_up)
      end if

      deallocate(gi); deallocate(gr)

      if(ipriforce >= 2)  then
         write(6,'(" --- fnlxyz_l ->>")')
         do ia = 1, natm
            write(6,'(i8,3f20.8)') ia, fnlxyz_l(ia,1:3)
         end do
         write(6,'(" <<- fnlxyz_l ---")')
      end if

      call tstatc0_end(id_sname)

    contains
      subroutine term_related_to_drv_of_flmt_NC
        integer :: lmt1, lmta1, lmt2, lmta2, l1,m1,l2,m2, i, lmt11, lmt22
        real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2

        do lmt1 = 1, ilmt(it)
           lmt11 = lmt1 + aoffset
           lmta1 = lmta(lmt1,ia); l1 = ltp(lmt1,it); m1 = mtp(lmt1,it)
           do lmt2 = lmt1, ilmt(it)
               lmt22 = lmt2 + aoffset
              l2 = ltp(lmt2,it); m2 = mtp(lmt2,it); lmta2 = lmta(lmt2,ia)
              if(l1 /= l2 .or. m1 /= m2) cycle
              fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
              a = dion(lmt1,lmt2,it)
              if(k_symmetry(ik) == GAMMA) then
                 do i = 1, np_e                                 ! MPI
                    a_n = fac_n * a *occup_l(i,ik)
                    fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                    fx  = fx - a_n * (gr(i,lmt11,1)*fr2 + fr1*gr(i,lmt22,1))
                    fy  = fy - a_n * (gr(i,lmt11,2)*fr2 + fr1*gr(i,lmt22,2))
                    fz  = fz - a_n * (gr(i,lmt11,3)*fr2 + fr1*gr(i,lmt22,3))
                 end do
              else
                 do i = 1, np_e                                 ! MPI
                    a_n = fac_n * a *occup_l(i,ik)
                    fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                    fi1 = fsi_l(i,lmta1,ik); fi2 = fsi_l(i,lmta2,ik)
                    fx  = fx - a_n * (gr(i,lmt11,1)*fr2+gi(i,lmt11,1)*fi2&
             +fr1*gr(i,lmt22,1)+fi1*gi(i,lmt22,1))
                    fy  = fy - a_n * (gr(i,lmt11,2)*fr2+gi(i,lmt11,2)*fi2&
             +fr1*gr(i,lmt22,2)+fi1*gi(i,lmt22,2))
                    fz  = fz - a_n * (gr(i,lmt11,3)*fr2+gi(i,lmt11,3)*fi2&
             +fr1*gr(i,lmt22,3)+fi1*gi(i,lmt22,3))
                    end do
                 end if
           end do
        end do
      end subroutine term_related_to_drv_of_flmt_NC

      subroutine term_related_to_drv_of_flmt_VDB
        integer :: lmt1, lmta1, lmt2, lmta2, i, lmt11, lmt22
        real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2
        integer       :: id_sname = -1
        call tstatc0_begin('term_related_to_drv_of_flmt_VDB ',id_sname)

        do lmt1 = 1, ilmt(it)
           lmt11 = lmt1 + aoffset
           lmta1 = lmta(lmt1,ia)
           do lmt2 = lmt1, ilmt(it)
              lmt22 = lmt2 + aoffset
              lmta2 = lmta(lmt2,ia)
              fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
              if(ipaw(it)==0) then
                  a = vlhxcq(lmt1,lmt2,ia,is)+dion(lmt1,lmt2,it)
              else
                  a = vlhxcq(lmt1,lmt2,ia,is)+dion_paw(lmt1,lmt2,is,ia)
              end if
              if(k_symmetry(ik) == GAMMA) then
                 do i = 1, np_e                                 ! MPI
                    a_n = fac_n*(a - eko_l(i,ik)*q(lmt1,lmt2,it))*occup_l(i,ik)
                    fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                    fx  = fx - a_n * (gr(i,lmt11,1)*fr2 + fr1*gr(i,lmt22,1))
                    fy  = fy - a_n * (gr(i,lmt11,2)*fr2 + fr1*gr(i,lmt22,2))
                    fz  = fz - a_n * (gr(i,lmt11,3)*fr2 + fr1*gr(i,lmt22,3))
                 end do
              else
                 do i = 1, np_e                                 ! MPI
                    a_n = fac_n*(a - eko_l(i,ik)*q(lmt1,lmt2,it))*occup_l(i,ik)
                    fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                    fi1 = fsi_l(i,lmta1,ik); fi2 = fsi_l(i,lmta2,ik)
                    fx  = fx - a_n * (gr(i,lmt11,1)*fr2+gi(i,lmt11,1)*fi2&
             +fr1*gr(i,lmt22,1)+fi1*gi(i,lmt22,1))
                    fy  = fy - a_n * (gr(i,lmt11,2)*fr2+gi(i,lmt11,2)*fi2&
             +fr1*gr(i,lmt22,2)+fi1*gi(i,lmt22,2))
                    fz  = fz - a_n * (gr(i,lmt11,3)*fr2+gi(i,lmt11,3)*fi2&
             +fr1*gr(i,lmt22,3)+fi1*gi(i,lmt22,3))
                 end do
              end if
           end do
        end do
        call tstatc0_end(id_sname)
      end subroutine term_related_to_drv_of_flmt_VDB

      subroutine substitute_ngabcred(ik)
        integer, intent(in) :: ik
        integer :: ig, i1
        if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
           do ig = 1, ibl2-ibl1+1
              i1 = nbase(ig+ibl1-1,ik)
              ngabc_red(ig,1) = ngabc(i1,1)
              ngabc_red(ig,2) = ngabc(i1,2)
              ngabc_red(ig,3) = ngabc(i1,3)
           end do
      end subroutine substitute_ngabcred

      subroutine calc_phase_div()
          integer :: ia, ig
          real(kind=DP) :: fx,fy,fz, ph

          do ia = 1, natm
             fx = pos(ia,1)*PAI2
             fy = pos(ia,2)*PAI2
             fz = pos(ia,3)*PAI2
             do ig = 1, ibl2-ibl1+1
                ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
                zfcos(ig,ia) = dcos(ph)
                zfsin(ig,ia) = dsin(ph)
             end do
          end do
      end subroutine calc_phase_div

      subroutine pre_drv_of_betar_dot_WFs_div()
          integer :: ia, i, t, lmt1, lmtt1, icnt, mil, fac_tmp

          icnt = 0
          if(k_symmetry(ik) == GAMMA) then
             if(kimg == 1) then   ! only ar
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     icnt = icnt + 1
                     lmtt1 = lmtt(lmt1,it)
                     do i = ibl1, ibl2
                        ar_tmp(i-ibl1+1,icnt,1) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ar_tmp(i-ibl1+1,icnt,2) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ar_tmp(i-ibl1+1,icnt,3) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                     end do
                  enddo
               enddo
             else if(kimg == 2) then
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     icnt = icnt + 1
                     lmtt1 = lmtt(lmt1,it)
                     mil = mod( ltp(lmt1,it),4 )
                     if( mil.eq.1 .or. mil.eq.2 ) then
                       fac_tmp= -2.d0
                     else if( mil.eq.0 .or. mil.eq.3 ) then
                       fac_tmp=  2.d0
                     endif

                     if( mil.eq.1 .or. mil.eq.3 ) then
                         do i = ibl1, ibl2
                            ar_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                            ar_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                            ar_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                            ai_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                            ai_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                            ai_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                         end do
                     else if( mil.eq.0 .or. mil.eq.2 ) then
                         do i = ibl1, ibl2
                            ar_tmp(i-ibl1+1,icnt,1) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                            ar_tmp(i-ibl1+1,icnt,2) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                            ar_tmp(i-ibl1+1,icnt,3) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                            ai_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                            ai_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                            ai_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                         end do
                     endif
                  enddo
                enddo
             endif
          else
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     icnt = icnt + 1
                     lmtt1 = lmtt(lmt1,it)
                     mil_tmp(icnt) = mod( ltp(lmt1,it),4 )
                      do i = ibl1, ibl2
                         ar_tmp(i-ibl1+1,icnt,1) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                         ar_tmp(i-ibl1+1,icnt,2) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                         ar_tmp(i-ibl1+1,icnt,3) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                         ai_tmp(i-ibl1+1,icnt,1) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                         ai_tmp(i-ibl1+1,icnt,2) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                         ai_tmp(i-ibl1+1,icnt,3) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                      end do
                  enddo
                enddo
          endif
      end subroutine pre_drv_of_betar_dot_WFs_div

      subroutine drv_of_betar_dot_WFs_div(gr,gi)
        real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
        integer :: lmt1, ib, i, mil, ibl1_2
        real(kind=DP) :: br, bi, tmp1, tmp2, tmp3
        integer :: id_sname = -1
        call tstatc0_begin('drv_of_betar_dot_WFs_div ',id_sname)

         if(k_symmetry(ik) == GAMMA) then
            if(kimg == 1) then
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
            else if(kimg == 2) then
               ibl1_2 = max(2,ibl1)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,1),ibsize, &
              &           0.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,1),ibsize, &
              &           1.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,2),ibsize, &
              &           0.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,2),ibsize, &
              &           1.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,3),ibsize, &
              &           0.d0,gr(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,3),ibsize, &
              &           1.d0,gr(1,1,3),np_e)
            endif
         else
            if(kimg == 1) then
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,1),ibsize, 0.d0,gi(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,2),ibsize, 0.d0,gi(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,3),ibsize, 0.d0,gi(1,1,3),np_e)
            else if(kimg == 2) then
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,1),ibsize, 1.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,2),ibsize, 1.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,3),ibsize, 1.d0,gr(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,1),ibsize, 0.d0,gi(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,1),ibsize, 1.d0,gi(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,2),ibsize, 0.d0,gi(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,2),ibsize, 1.d0,gi(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,3),ibsize, 0.d0,gi(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,3),ibsize, 1.d0,gi(1,1,3),np_e)
            end if
            do lmt1 = 1, nlmta
               mil = mil_tmp(lmt1)
               if( mil == 1 ) then
                  do ib = 1, np_e                              ! MPI
                     tmp1 = gr(ib,lmt1,1)
                     tmp2 = gr(ib,lmt1,2)
                     tmp3 = gr(ib,lmt1,3)
                     gr(ib,lmt1,1) = -gi(ib,lmt1,1)
                     gr(ib,lmt1,2) = -gi(ib,lmt1,2)
                     gr(ib,lmt1,3) = -gi(ib,lmt1,3)
                     gi(ib,lmt1,1) = tmp1
                     gi(ib,lmt1,2) = tmp2
                     gi(ib,lmt1,3) = tmp3
                  end do
               elseif (mil == 2 ) then
                  do ib = 1, np_e                              ! MPI
                     gr(ib,lmt1,1) = - gr(ib,lmt1,1)
                     gr(ib,lmt1,2) = - gr(ib,lmt1,2)
                     gr(ib,lmt1,3) = - gr(ib,lmt1,3)
                     gi(ib,lmt1,1) = - gi(ib,lmt1,1)
                     gi(ib,lmt1,2) = - gi(ib,lmt1,2)
                     gi(ib,lmt1,3) = - gi(ib,lmt1,3)
                  end do
               elseif (mil == 3 ) then
                  do ib = 1, np_e                              ! MPI
                     tmp1 = gr(ib,lmt1,1)
                     tmp2 = gr(ib,lmt1,2)
                     tmp3 = gr(ib,lmt1,3)
                     gr(ib,lmt1,1) = gi(ib,lmt1,1)
                     gr(ib,lmt1,2) = gi(ib,lmt1,2)
                     gr(ib,lmt1,3) = gi(ib,lmt1,3)
                     gi(ib,lmt1,1) = -tmp1
                     gi(ib,lmt1,2) = -tmp2
                     gi(ib,lmt1,3) = -tmp3
                  end do
               endif
            enddo
         end if
         call tstatc0_end(id_sname)
      end subroutine drv_of_betar_dot_WFs_div
  end subroutine m_Force_term_drv_of_flmt
! -->

! ============================ added by K. Tagami ==================== 11.0
  subroutine m_Force_term_drv_of_flmt_noncl( kv3,pos,napt )
    integer, intent(in)                          :: kv3
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)     :: napt

    integer       :: id_sname = -1
    integer :: ibsize,ibl1,ibl2, is,ik,iksnl,ia,it,mdvdb,aoffset
    real(kind=DP) :: fac, fx, fy, fz

    integer, allocatable, dimension(:)       :: mil_tmp
    integer, allocatable, dimension(:,:)     :: ngabc_red
    real(kind=DP),allocatable,dimension(:,:) :: zfsin,  zfcos   ! MPI
    real(kind=DP),allocatable,dimension(:,:,:) :: ar_tmp, ai_tmp  ! MPI
    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi

    real(kind=DP), allocatable :: gr_noncl( :,:,:,: )
    real(kind=DP), allocatable :: gi_noncl( :,:,:,: )

    call tstatc0_begin('m_Force_term_drv_of_flmt_noncl ',id_sname,1)

    allocate( gr_noncl(np_e,nlmta,3, ndim_spinor ) )    ! MPI
    allocate( gi_noncl(np_e,nlmta,3, ndim_spinor ) )    ! MPI

!!!!!!!!!!!    fac = 2.d0 / (kv3 /ndim_spinor) 
    fac = 1.d0 / (kv3 /ndim_spinor) 

    fnlxyz_l = 0.d0
    
    if(nblocksize_force_is_given) then
       ibsize = nblocksize_force
    else
       ibsize= nb_force_default
    end if
    write(6,'(" ! ibsize = ",i8," <<m_Force_term_drv_of_flmt_noncl>>")') ibsize
    allocate(   mil_tmp(nlmta)    );   mil_tmp = 0
    allocate( ngabc_red(ibsize,3) ); ngabc_red = 0
    allocate(     zfcos(ibsize,natm),      zfsin(ibsize,natm)    )
    allocate(    ar_tmp(ibsize,nlmta,3),  ai_tmp(ibsize,nlmta,3) )
    
    do ik = 1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/nspin+1
          
       do ibl1 = 1, iba(ik), ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iba(ik)) ibl2 = iba(ik)

          gr_noncl = 0.d0;     gi_noncl = 0.d0
             
          call substitute_ngabcred(ik)         ! ngabc,nbase      --> ngabc_red
          call calc_phase_div()                ! pos, ngabc_red  --> zfcos, zfsin
          call pre_drv_of_betar_dot_WFs_div()  ! zfsin,zfcos,snl               --> ar_tmp,ai_tmp
          Do is=1, ndim_spinor
             call drv_of_betar_dot_WFs_div( ik+is-1, gr_noncl(:,:,:,is), &
                  &                                  gi_noncl(:,:,:,is) )
                            ! ar_tmp,ai_tmp,zaj_l,ngabc_red --> gr,gi
          End do
             
          aoffset = 0
          do ia = 1, natm
             it = ityp(ia)
             fx = 0.d0; fy = 0.d0; fz = 0.d0
             mdvdb = m_PP_include_vanderbilt_pot(it)

             if(mdvdb == EXECUT) then
                call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
             else if(mdvdb == SKIP) then
                call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
             end if

             aoffset = aoffset + ilmt(it)
             call pucv2cart(rltv,fx,fy,fz)
             fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
             fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
             fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
          end do

       end do
    end do
    
    deallocate( mil_tmp, ngabc_red, zfcos, zfsin, ar_tmp, ai_tmp )
    
    if(npes>1) then
       allocate(fnlxyz_mpi(natm,3)); fnlxyz_mpi = 0.d0
       call mpi_allreduce(fnlxyz_l,fnlxyz_mpi,3*natm,mpi_double_precision &
            & , mpi_sum, mpi_comm_group,ierr)
       fnlxyz_l = fnlxyz_mpi
    end if
    if(npes>1)deallocate(fnlxyz_mpi)
    
    if(af /= 0) then
       allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
       call forcaf2(natm,natm2,nopr+af,natm,nopr,napt &
            & ,iwei,op,ipriforce,af,fnlxyz_l ,forc_up,forc_down)
       deallocate(forc_down);deallocate(forc_up)
    end if
      
    deallocate(gi_noncl); deallocate(gr_noncl)
    
    if(ipriforce >= 2)  then
       write(6,'(" --- fnlxyz_l ->>")')
       do ia = 1, natm
          write(6,'(i8,3f20.8)') ia, fnlxyz_l(ia,1:3)
       end do
       write(6,'(" <<- fnlxyz_l ---")')
    end if
    
    call tstatc0_end(id_sname)

  contains

    subroutine term_related_to_drv_of_flmt_NC
      integer :: lmt1, lmta1, lmt2, lmta2, l1,m1,l2,m2, i, lmt11, lmt22
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2

      integer :: is1, is2, istmp
      complex(kind=CMPLDP) :: z1, z2, z3
      complex(kind=CMPLDP) :: zg1(3), zg2(3), zsum(3)

      do lmt1 = 1, ilmt(it)
         lmt11 = lmt1 + aoffset
         lmta1 = lmta(lmt1,ia); 

         l1 = ltp(lmt1,it); m1 = mtp(lmt1,it)

! ==== KT_mod ======================== 2013/10/31
!!!!!!!!         do lmt2 = lmt1, ilmt(it)
         do lmt2 = 1, ilmt(it)
! ==================================== 2013/10/31

            lmt22 = lmt2 + aoffset
            lmta2 = lmta(lmt2,ia)

            l2 = ltp(lmt2,it); m2 = mtp(lmt2,it); 

!!!!!!            if(l1 /= l2 .or. m1 /= m2) cycle

! ==== KT_mod ======================== 2013/10/31
!!!            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            fac_n = fac
! ==================================== 2013/10/31

            if (k_symmetry(ik) == GAMMA) then
               stop 'Not supported : Gamma symmetry in non-collinear system'

            else

               do i = 1, np_e                                 ! MPI
                  zsum = 0.0d0
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2

                        z1 = dcmplx( fsr_l(i,lmta1,ik+is1-1), &
                             &       fsi_l(i,lmta1,ik+is1-1 ) )
                        z2 = dcmplx( fsr_l(i,lmta2,ik+is2-1), &
                             &       fsi_l(i,lmta2,ik+is2-1 ) )
                        zg1(:) = dcmplx( gr_noncl(i,lmt11,:,is1), &
                             &           gi_noncl(i,lmt11,:,is1) )
                        zg2(:) = dcmplx( gr_noncl(i,lmt22,:,is2), &
                             &           gi_noncl(i,lmt22,:,is2) )

                        zsum(:) = zsum(:) + (conjg(z1)*zg2(:) + conjg(zg1(:))*z2 )&
                             &              *dion_scr_noncl( lmt1,lmt2,istmp,ia )
                     End do
                  End Do

                  zsum = zsum *fac_n *occup_l(i,ik)
                        
                  fx  = fx - real( zsum(1) )
                  fy  = fy - real( zsum(2) )
                  fz  = fz - real( zsum(3) )
               end do
            end if
         end do
      end do
    end subroutine term_related_to_drv_of_flmt_NC

    subroutine term_related_to_drv_of_flmt_VDB
      integer :: lmt1, lmta1, lmt2, lmta2, i, lmt11, lmt22
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2

      integer :: is1, is2, istmp
      complex(kind=CMPLDP) :: z1, z2, z3
      complex(kind=CMPLDP) :: zg1(3), zg2(3), zsum(3)
      integer       :: id_sname = -1
      
      call tstatc0_begin('term_related_to_drv_of_flmt_VDB ',id_sname)
      
      do lmt1 = 1, ilmt(it)
         lmt11 = lmt1 + aoffset
         lmta1 = lmta(lmt1,ia)

! ==== KT_mod ======================== 2013/10/31
!!!         do lmt2 = lmt1, ilmt(it)
         do lmt2 = 1, ilmt(it)
! ==================================== 2013/10/31

            lmt22 = lmt2 + aoffset
            lmta2 = lmta(lmt2,ia)

! ==== KT_mod ======================== 2013/10/31
!!!            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            fac_n = fac
! ==================================== 2013/10/31

            if(k_symmetry(ik) == GAMMA) then
               stop 'Not supported : Gamma symmetry in non-collinear system'
            else

               do i = 1, np_e                                 ! MPI
                  zsum = 0.0d0
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2

                        z1 = dcmplx( fsr_l(i,lmta1,ik+is1-1), &
                             &       fsi_l(i,lmta1,ik+is1-1 ) )
                        z2 = dcmplx( fsr_l(i,lmta2,ik+is2-1), &
                             &       fsi_l(i,lmta2,ik+is2-1) )
                        zg1(:) = dcmplx( gr_noncl(i,lmt11,:,is1), &
                             &           gi_noncl(i,lmt11,:,is1) )
                        zg2(:) = dcmplx( gr_noncl(i,lmt22,:,is2), &
                             &           gi_noncl(i,lmt22,:,is2) )

                        z3 = dion_scr_noncl( lmt1,lmt2,istmp,ia ) &
                             &  -eko_l(i,ik) *q_noncl(lmt1,lmt2,istmp,it )

                        zsum(:) = zsum(:) + (conjg(z1)*zg2(:) + conjg(zg1(:))*z2 ) *z3
                     End do
                  End Do

                  zsum = zsum *fac_n *occup_l(i,ik)
                        
                  fx  = fx - real( zsum(1) )
                  fy  = fy - real( zsum(2) )
                  fz  = fz - real( zsum(3) )
               end do

            end if
         end do
      end do
      call tstatc0_end(id_sname)
    end subroutine term_related_to_drv_of_flmt_VDB
    
    subroutine substitute_ngabcred(ik)
      integer, intent(in) :: ik
      integer :: ig, i1
      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
      do ig = 1, ibl2-ibl1+1
         i1 = nbase(ig+ibl1-1,ik)
         ngabc_red(ig,1) = ngabc(i1,1)
         ngabc_red(ig,2) = ngabc(i1,2)
         ngabc_red(ig,3) = ngabc(i1,3)
      end do
    end subroutine substitute_ngabcred
    
    subroutine calc_phase_div()
      integer :: ia, ig
      real(kind=DP) :: fx,fy,fz, ph
      
      do ia = 1, natm
         fx = pos(ia,1)*PAI2
         fy = pos(ia,2)*PAI2
         fz = pos(ia,3)*PAI2
         do ig = 1, ibl2-ibl1+1
            ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
            zfcos(ig,ia) = dcos(ph)
            zfsin(ig,ia) = dsin(ph)
         end do
      end do
    end subroutine calc_phase_div
    
    subroutine pre_drv_of_betar_dot_WFs_div()
      integer :: ia, i, t, lmt1, lmtt1, icnt, mil, fac_tmp
      
      icnt = 0
      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then   ! only ar
            do ia = 1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  icnt = icnt + 1
                  lmtt1 = lmtt(lmt1,it)
                  do i = ibl1, ibl2
                     ar_tmp(i-ibl1+1,icnt,1) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                     ar_tmp(i-ibl1+1,icnt,2) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                     ar_tmp(i-ibl1+1,icnt,3) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                  end do
               enddo
            enddo
         else if(kimg == 2) then
            do ia = 1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  icnt = icnt + 1
                  lmtt1 = lmtt(lmt1,it)
                  mil = mod( ltp(lmt1,it),4 )
                  if( mil.eq.1 .or. mil.eq.2 ) then
                     fac_tmp= -2.d0
                  else if( mil.eq.0 .or. mil.eq.3 ) then
                     fac_tmp=  2.d0
                  endif
                  
                  if( mil.eq.1 .or. mil.eq.3 ) then
                     do i = ibl1, ibl2
                        ar_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ar_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ar_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                        ai_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ai_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ai_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                     end do
                  else if( mil.eq.0 .or. mil.eq.2 ) then
                     do i = ibl1, ibl2
                        ar_tmp(i-ibl1+1,icnt,1) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ar_tmp(i-ibl1+1,icnt,2) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ar_tmp(i-ibl1+1,icnt,3) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                        ai_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ai_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ai_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                     end do
                  endif
               enddo
            enddo
         endif
      else
         do ia = 1, natm
            it = ityp(ia)
            do lmt1 = 1, ilmt(it)
               icnt = icnt + 1
               lmtt1 = lmtt(lmt1,it)
               mil_tmp(icnt) = mod( ltp(lmt1,it),4 )
               do i = ibl1, ibl2
                  ar_tmp(i-ibl1+1,icnt,1) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                  ar_tmp(i-ibl1+1,icnt,2) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                  ar_tmp(i-ibl1+1,icnt,3) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                  ai_tmp(i-ibl1+1,icnt,1) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                  ai_tmp(i-ibl1+1,icnt,2) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                  ai_tmp(i-ibl1+1,icnt,3) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
               end do
            enddo
         enddo
      endif
    end subroutine pre_drv_of_betar_dot_WFs_div

    subroutine drv_of_betar_dot_WFs_div( ik, gr, gi )
      integer, intent(in) :: ik

      real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: lmt1, ib, i, mil, ibl1_2
      real(kind=DP) :: br, bi, tmp1, tmp2, tmp3
      integer :: id_sname = -1

      call tstatc0_begin('drv_of_betar_dot_WFs_div ',id_sname)
      
      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
         else if(kimg == 2) then
            ibl1_2 = max(2,ibl1)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,1),ibsize, &
                 &           0.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,1),ibsize, &
                 &           1.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,2),ibsize, &
                 &           0.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,2),ibsize, &
                 &           1.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,3),ibsize, &
                 &           0.d0,gr(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,3),ibsize, &
                 &           1.d0,gr(1,1,3),np_e)
         endif
      else
         if(kimg == 1) then
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,1),ibsize, 0.d0,gi(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,2),ibsize, 0.d0,gi(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,3),ibsize, 0.d0,gi(1,1,3),np_e)
         else if(kimg == 2) then
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,1),ibsize, 1.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,2),ibsize, 1.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,3),ibsize, 1.d0,gr(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,1),ibsize, 0.d0,gi(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,1),ibsize, 1.d0,gi(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,2),ibsize, 0.d0,gi(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,2),ibsize, 1.d0,gi(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,3),ibsize, 0.d0,gi(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,3),ibsize, 1.d0,gi(1,1,3),np_e)
         end if
         do lmt1 = 1, nlmta
            mil = mil_tmp(lmt1)
            if( mil == 1 ) then
               do ib = 1, np_e                              ! MPI
                  tmp1 = gr(ib,lmt1,1)
                  tmp2 = gr(ib,lmt1,2)
                  tmp3 = gr(ib,lmt1,3)
                  gr(ib,lmt1,1) = -gi(ib,lmt1,1)
                  gr(ib,lmt1,2) = -gi(ib,lmt1,2)
                  gr(ib,lmt1,3) = -gi(ib,lmt1,3)
                  gi(ib,lmt1,1) = tmp1
                  gi(ib,lmt1,2) = tmp2
                  gi(ib,lmt1,3) = tmp3
               end do
            elseif (mil == 2 ) then
               do ib = 1, np_e                              ! MPI
                  gr(ib,lmt1,1) = - gr(ib,lmt1,1)
                  gr(ib,lmt1,2) = - gr(ib,lmt1,2)
                  gr(ib,lmt1,3) = - gr(ib,lmt1,3)
                  gi(ib,lmt1,1) = - gi(ib,lmt1,1)
                  gi(ib,lmt1,2) = - gi(ib,lmt1,2)
                  gi(ib,lmt1,3) = - gi(ib,lmt1,3)
               end do
            elseif (mil == 3 ) then
               do ib = 1, np_e                              ! MPI
                  tmp1 = gr(ib,lmt1,1)
                  tmp2 = gr(ib,lmt1,2)
                  tmp3 = gr(ib,lmt1,3)
                  gr(ib,lmt1,1) = gi(ib,lmt1,1)
                  gr(ib,lmt1,2) = gi(ib,lmt1,2)
                  gr(ib,lmt1,3) = gi(ib,lmt1,3)
                  gi(ib,lmt1,1) = -tmp1
                  gi(ib,lmt1,2) = -tmp2
                  gi(ib,lmt1,3) = -tmp3
               end do
            endif
         enddo
      end if
      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs_div

  end subroutine m_Force_term_drv_of_flmt_noncl
! ========================================================================= 11.0

#else
  subroutine m_Force_term_drv_of_flmt(kv3,pos,napt)
    integer, intent(in)                          :: kv3
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)     :: napt

    integer  :: ia,is,ik,iksnl,it,lmt1,lmtt1,il,mdvdb
    real(kind=DP) :: fac, fx, fy, fz
#ifdef SX
    real(kind=DP),allocatable,dimension(:) :: fxyz_mpi1,fxyz_mpi2  ! MPI
    real(kind=DP),allocatable,dimension(:) :: zfsin, zfcos  ! MPI
#else
    real(kind=DP),allocatable,dimension(:) :: zfsin, zfcos  ! MPI
    integer :: ibl1,ibl2,ibsize,ncache
!!$    real(kind=DP),allocatable,dimension(:,:,:) :: zaj_red ! d(ibsize,np_e,kimg)
!!$    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi, snl_red
    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi
    real(kind=DP),allocatable,dimension(:) :: zfsin_red,zfcos_red  ! MPI
    integer, allocatable, dimension(:,:) :: ngabc_red
#endif
    integer       :: id_sname = -1
    call tstatc0_begin('m_Force_term_drv_of_flmt ',id_sname,1)

    allocate(gr(np_e,nlmta,3));allocate(gi(np_e,nlmta,3))  ! MPI

    fac = 2.d0/kv3
#ifdef SX
    allocate(ar(kg1))        ;allocate(ai(kg1))
    allocate(zfsin(nbmx)); zfsin = 0.d0
    allocate(zfcos(nbmx)); zfcos = 0.d0
    if(npes>1) then
       allocate(fxyz_mpi1(3));    allocate(fxyz_mpi2(3))      ! MPI
    end if
    do ia = 1, natm
       fx = 0.d0; fy = 0.d0; fz = 0.d0
!!$       call calc_phase2(natm,pos,ia,kgp,nbmx,ngabc,nbmx,zfcos,zfsin)
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       do is = 1, nspin, af+1
          do ik = is, kv3+is-nspin,nspin
             if(map_k(ik) /= myrank_k) cycle        ! MPI
             call calc_phase(ia,natm,pos,kgp,iba(ik),ngabc,kg1 &
                  & ,nbase(1,ik), nbmx, zfcos,zfsin) !-(b_Elec.) ->(zfcos,zfsin)
             iksnl = (ik-1)/nspin+1
             do lmt1 = 1, ilmt(it)
                lmtt1=lmtt(lmt1,it); il=ltp(lmt1,it)
                call drv_of_betar_dot_WFs(gr,gi) !(sumset)
                ! --> gr,gi : derivatives of fsr, fsi
             end do
             if(mdvdb == EXECUT) then
                call term_related_to_drv_of_flmt_VDB
                ! gr,gi,fsr,fsi,vlhxcq,dion,eko_l,q,occup_l --> fx,fy,fz
             else if(mdvdb == SKIP) then
                call term_related_to_drv_of_flmt_NC
                ! gr,gi,fsr,fsi,dion,occup_l --> fx,fy,fz
             end if
          end do
       end do
       call pucv2cart(rltv,fx,fy,fz)
       if(npes >1) then
          fxyz_mpi1(1) = fx; fxyz_mpi1(2) = fy; fxyz_mpi1(3) = fz  ! MPI
          call mpi_allreduce(fxyz_mpi1,fxyz_mpi2,3,mpi_double_precision &
               & ,mpi_sum,mpi_comm_group,ierr)          ! MPI
          fx = fxyz_mpi2(1); fy = fxyz_mpi2(2); fz = fxyz_mpi2(3)  ! MPI
       end if
       fnlxyz_l(ia,1) = fx; fnlxyz_l(ia,2) = fy; fnlxyz_l(ia,3) = fz
    end do
    if(npes>1) deallocate(fxyz_mpi2,fxyz_mpi1)
    deallocate(zfcos,zfsin)
    deallocate(ai,ar)
#else
    ncache = (m_CtrlP_cachesize()*1024)*3/4

    fnlxyz_l = 0.d0
    do is = 1, nspin, af+1
       do ik = is, kv3+is-nspin,nspin
          if(ncache == 0) then
             ibsize = iba(ik)
          else
             if(k_symmetry(ik) == GAMMA) then ! core2
                if(kimg == 1) then ! ar(i):1,zaj_l(i,ib,ik,1):np_e, ngabc(i,1:3):3
                   ibsize=ncache/(8*(np_e+1) + 4*3)
                else !  ar(i),ai(i):2,zaj_l(i,ib,ik,1),zaj_l(i,ib,ik,2):np_e*2,ngabc(i,1:3):3
                   ibsize=ncache/(8*(2+np_e*2) + 4*3)
                endif
             else
                if(kimg==1) then ! ar(i),ai(i):2,zaj_l(i,ib,ik,1):np_e,ngabc(i,1:3):3
                   ibsize = ncache/(8*(2+np_e) + 4*3)
                else if(kimg == 2) then ! ar(i),ai(i):2,zaj_l(i,ib,ik,1:2):np_e*2,ngabc(i,1:3):3
                   ibsize = ncache/(8*(2+np_e*2)+4*3)
                end if
             end if
          end if
          if(ipriforce>= 2) write(6,'(" ! ibsize = ",i8," <<m_Force_term_drv_of_flmt>>")') ibsize
!!$          allocate(zaj_red(ibsize,np_e,kimg))
!!$          allocate(ngabc_red(ibsize,3))
!!$          allocate(snl_red(ibsize,nlmtt))
!!$          allocate(zfcos_red(ibsize)); zfcos_red = 0.d0
!!$          allocate(zfsin_red(ibsize)); zfsin_red = 0.d0

          if(map_k(ik) /= myrank_k) cycle
          iksnl = (ik-1)/nspin+1
          IBLOCK: do ibl1 = 1, iba(ik), ibsize
             ibl2 = ibl1+ibsize-1
             if(ibl2 .gt. iba(ik)) ibl2 = iba(ik)
             if(ipriforce>= 2) write(6,'(" ! ibl1, ibl2 = ",2i8," <<m_Force_term_drv_of_flmt>>")') ibl1,ibl2

             allocate(ngabc_red(ibl1:ibl2,3)); ngabc_red = 0
             allocate(zfcos(ibl1:ibl2))
             allocate(zfsin(ibl1:ibl2))
             allocate(ar(ibl1:ibl2))        ;allocate(ai(ibl1:ibl2))
!!$             call substitute_zajred(ik)    ! zaj_l -> zaj_red
             call substitute_ngabcred(ik)  ! ngabc,nbase -> ngabc_red
!!$             call substitute_snlred(iksnl) ! snl -> snl_red

             do ia = 1, natm
                it = ityp(ia)
                call calc_phase_div(ia) ! pos, ngabc_red -> zfcos, zfsin

                do lmt1 = 1, ilmt(it)
                   lmtt1 = lmtt(lmt1,it); il = ltp(lmt1,it)
                   call drv_of_betar_dot_WFs_div(gr,gi)
                end do

                fx = 0.d0; fy = 0.d0; fz = 0.d0
                mdvdb = m_PP_include_vanderbilt_pot(it)
                if(mdvdb == EXECUT) then
                   call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
                else if(mdvdb == SKIP) then
                   call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
                end if
                call pucv2cart(rltv,fx,fy,fz)
                fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
                fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
                fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
             end do
          deallocate(ai,ar)
          deallocate(zfsin,zfcos)
          deallocate(ngabc_red)
          end do IBLOCK
!!$          deallocate(snl_red)
!!$          deallocate(zaj_red)
       end do
    end do
    if(npes>1) then
       allocate(fnlxyz_mpi(natm,3)); fnlxyz_mpi = 0.d0
       call mpi_allreduce(fnlxyz_l,fnlxyz_mpi,3*natm,mpi_double_precision &
            & , mpi_sum, mpi_comm_group,ierr)
       fnlxyz_l = fnlxyz_mpi
    end if
    if(npes>1)deallocate(fnlxyz_mpi)
#endif


    if(af /= 0) then
       allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
       call forcaf2(natm,natm2,nopr+af,natm,nopr,napt &
         & ,iwei,op,ipriforce,af,fnlxyz_l ,forc_up,forc_down)
       deallocate(forc_down);deallocate(forc_up)
    end if

    deallocate(gi); deallocate(gr)

    if(ipriforce >= 2)  then
       write(6,'(" --- fnlxyz_l ->>")')
       do ia = 1, natm
          write(6,'(i8,3f20.8)') ia, fnlxyz_l(ia,1:3)
       end do
       write(6,'(" <<- fnlxyz_l ---")')
    end if

    call tstatc0_end(id_sname)
  contains

    subroutine term_related_to_drv_of_flmt_NC
      integer :: lmt1, lmta1, lmt2, lmta2, l1,m1,l2,m2, i
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2
      do lmt1 = 1, ilmt(it)
         lmta1 = lmta(lmt1,ia); l1 = ltp(lmt1,it); m1 = mtp(lmt1,it)
         do lmt2 = lmt1, ilmt(it)
            l2 = ltp(lmt2,it); m2 = mtp(lmt2,it); lmta2 = lmta(lmt2,ia)
            if(l1 /= l2 .or. m1 /= m2) cycle
            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            a = dion(lmt1,lmt2,it)
            if(k_symmetry(ik) == GAMMA) then
               do i = 1, np_e                                 ! MPI
                  a_n = fac_n * a *occup_l(i,ik)
                  fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                  fx  = fx - a_n * (gr(i,lmt1,1)*fr2 + fr1*gr(i,lmt2,1))
                  fy  = fy - a_n * (gr(i,lmt1,2)*fr2 + fr1*gr(i,lmt2,2))
                  fz  = fz - a_n * (gr(i,lmt1,3)*fr2 + fr1*gr(i,lmt2,3))
               end do
            else
               do i = 1, np_e                                 ! MPI
                  a_n = fac_n * a *occup_l(i,ik)
                  fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                  fi1 = fsi_l(i,lmta1,ik); fi2 = fsi_l(i,lmta2,ik)
                  fx  = fx - a_n * (gr(i,lmt1,1)*fr2+gi(i,lmt1,1)*fi2&
                       &           +fr1*gr(i,lmt2,1)+fi1*gi(i,lmt2,1))
                  fy  = fy - a_n * (gr(i,lmt1,2)*fr2+gi(i,lmt1,2)*fi2&
                       &           +fr1*gr(i,lmt2,2)+fi1*gi(i,lmt2,2))
                  fz  = fz - a_n * (gr(i,lmt1,3)*fr2+gi(i,lmt1,3)*fi2&
                       &           +fr1*gr(i,lmt2,3)+fi1*gi(i,lmt2,3))
               end do
            end if
         end do
      end do
    end subroutine term_related_to_drv_of_flmt_NC

    subroutine term_related_to_drv_of_flmt_VDB
      integer :: lmt1, lmta1, lmt2, lmta2, i
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2
      integer       :: id_sname = -1
      call tstatc0_begin('term_related_to_drv_of_flmt_VDB ',id_sname)

      do lmt1 = 1, ilmt(it)
         lmta1 = lmta(lmt1,ia)
         do lmt2 = lmt1, ilmt(it)
            lmta2 = lmta(lmt2,ia)
            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
!!$            a = vlhxcq(lmt1,lmt2,ia,is)+dion(lmt1,lmt2,it)
            if(ipaw(it)==0) then
                a = vlhxcq(lmt1,lmt2,ia,is)+dion(lmt1,lmt2,it)
            else
                a = vlhxcq(lmt1,lmt2,ia,is)+dion_paw(lmt1,lmt2,is,ia)
            end if
            if(k_symmetry(ik) == GAMMA) then
               do i = 1, np_e                                 ! MPI
                  a_n = fac_n*(a - eko_l(i,ik)*q(lmt1,lmt2,it))*occup_l(i,ik)
                  fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                  fx  = fx - a_n * (gr(i,lmt1,1)*fr2 + fr1*gr(i,lmt2,1))
                  fy  = fy - a_n * (gr(i,lmt1,2)*fr2 + fr1*gr(i,lmt2,2))
                  fz  = fz - a_n * (gr(i,lmt1,3)*fr2 + fr1*gr(i,lmt2,3))
               end do
            else
               do i = 1, np_e                                 ! MPI
                  a_n = fac_n*(a - eko_l(i,ik)*q(lmt1,lmt2,it))*occup_l(i,ik)
                  fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                  fi1 = fsi_l(i,lmta1,ik); fi2 = fsi_l(i,lmta2,ik)
                  fx  = fx - a_n * (gr(i,lmt1,1)*fr2+gi(i,lmt1,1)*fi2&
                       &           +fr1*gr(i,lmt2,1)+fi1*gi(i,lmt2,1))
                  fy  = fy - a_n * (gr(i,lmt1,2)*fr2+gi(i,lmt1,2)*fi2&
                       &           +fr1*gr(i,lmt2,2)+fi1*gi(i,lmt2,2))
                  fz  = fz - a_n * (gr(i,lmt1,3)*fr2+gi(i,lmt1,3)*fi2&
                       &           +fr1*gr(i,lmt2,3)+fi1*gi(i,lmt2,3))
               end do
            end if
         end do
      end do
      call tstatc0_end(id_sname)
    end subroutine term_related_to_drv_of_flmt_VDB

#ifdef SX
    subroutine drv_of_betar_dot_WFs(gr,gi)
    real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: ib, i, i1, id3, mil
      real(kind=DP) :: br, bi, tmp, fac
      integer :: id_sname = -1
      call tstatc0_begin('drv_of_betar_dot_WFs ',id_sname)
#ifdef HIUX
*poption parallel
#endif
      do i = 1, iba(ik)
!!$         i1 = nbase(i,ik)
!!$         ar(i) = zfcos(i1)*snl(i,lmtt1,iksnl)
!!$         ai(i) = zfsin(i1)*snl(i,lmtt1,iksnl)
         ar(i) = zfcos(i)*snl(i,lmtt1,iksnl)
         ai(i) = zfsin(i)*snl(i,lmtt1,iksnl)
      end do

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
!!$                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
!!$                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
!!$                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         else if(kimg == 2) then
            mil = mod(il,4)
            if(mil == 1 .or. mil == 3) then ! l: even
               if(mil == 1) fac = -2.d0; if(mil == 3) fac = 2.d0
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
!CDIR OUTERUNROLL=4
!CDIR NOLOOPCHG
               do ib = 1, np_e                                    ! MPI
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = 2, iba(ik)
                     i1 = nbase(i,ik)
                     bi = (ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + bi*ngabc(i1,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + bi*ngabc(i1,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + bi*ngabc(i1,3)
                  end do
               end do
            else if(mil == 0 .or. mil == 2) then ! l: odd
               if(mil == 0) fac = 2.d0; if(mil == 2) fac = -2.d0;
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
               do ib = 1, np_e
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = 2, iba(ik)
                     i1 = nbase(i,ik)
                     br = (ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  end do
               end do
            end if
         end if
      else
         if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1); bi = ai(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         else if(kimg == 2) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2)
                  bi = ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         end if
         mil = mod(il,4)
         do id3 = 1, 3
            if(mil == 1 .or. mil == 3) then
               if(mil == 1) fac = 1.d0;  if(mil == 3) fac = -1.d0
#ifdef HIUX
*poption parallel
#endif
               do ib = 1, np_e                              ! MPI
                  tmp = gr(ib,lmt1,id3)
                  gr(ib,lmt1,id3) = -fac*gi(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = fac*tmp
               end do
            else if(mil == 2) then
#ifdef HIUX
*poption parallel
#endif
               do ib = 1, np_e                       ! MPI
                  gr(ib,lmt1,id3) = - gr(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = - gi(ib,lmt1,id3)
               end do
            end if
         end do
      end if

      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs
#else
!!$    subroutine substitute_zajred(ik)
!!$      integer, intent(in) :: ik
!!$      integer :: ie, ig
!!$      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      if(kimg==1) then
!!$         do ie = 1, np_e
!!$            do ig = 1, ibl2-ibl1+1
!!$               zaj_red(ig,ie,1) = zaj_l(ig+ibl1-1,ie,ik,1)
!!$            end do
!!$         end do
!!$      else if(kimg==2) then
!!$         do ie = 1, np_e
!!$            do ig = 1, ibl2-ibl1+1
!!$               zaj_red(ig,ie,1)    = zaj_l(ig+ibl1-1,ie,ik,1)
!!$               zaj_red(ig,ie,kimg) = zaj_l(ig+ibl1-1,ie,ik,kimg)
!!$            end do
!!$         end do
!!$      end if
!!$    end subroutine substitute_zajred

    subroutine substitute_ngabcred(ik)
      integer, intent(in) :: ik
      integer :: ig, i1
      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      if(ipriforce >= 1) write(6,'(" ibl1, ibl2 = ",2i8)') ibl1, ibl2
      do ig = ibl1, ibl2
         i1 = nbase(ig,ik)
         ngabc_red(ig,1) = ngabc(i1,1)
         ngabc_red(ig,2) = ngabc(i1,2)
         ngabc_red(ig,3) = ngabc(i1,3)
      end do
!!$      do ig = 1, ibl2-ibl1+1
!!$         i1 = nbase(ig+ibl1-1,ik)
!!$         ngabc_red(ig,1) = ngabc(i1,1)
!!$         ngabc_red(ig,2) = ngabc(i1,2)
!!$         ngabc_red(ig,3) = ngabc(i1,3)
!!$      end do
    end subroutine substitute_ngabcred

!!$    subroutine substitute_snlred(iksnl)
!!$      integer, intent(in) :: iksnl
!!$      integer :: ig, lmt1
!!$      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      do lmt1 = 1, nlmtt
!!$         do ig = 1, ibl2-ibl1+1
!!$            snl_red(ig,lmt1) = snl(ig+ibl1-1,lmt1,iksnl)
!!$         end do
!!$      end do
!!$    end subroutine substitute_snlred

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: ig
      real(kind=DP) :: fx,fy,fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do ig = ibl1, ibl2
         ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
         zfcos(ig) = dcos(ph)
         zfsin(ig) = dsin(ph)
      end do
!!$      do ig = 1, ibl2-ibl1+1
!!$         ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
!!$         zfcos_red(ig) = dcos(ph)
!!$         zfsin_red(ig) = dsin(ph)
!!$      end do
    end subroutine calc_phase_div

    subroutine drv_of_betar_dot_WFs_div(gr,gi)
      real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: ib, i, i1, id3, mil, ibl1_2
      real(kind=DP) :: br, bi, tmp, fac
      integer :: id_sname = -1
      call tstatc0_begin('drv_of_betar_dot_WFs_div ',id_sname)

      do i = ibl1, ibl2
         ar(i) = zfcos(i)*snl(i,lmtt1,iksnl)
         ai(i) = zfsin(i)*snl(i,lmtt1,iksnl)
      end do

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
               end do
            end do
         else if(kimg == 2) then
            ibl1_2 = max(2,ibl1)
            mil = mod(il,4)
            if(mil == 1 .or. mil == 3) then ! l: even
               if(mil == 1) fac = -2.d0; if(mil == 3) fac = 2.d0
               do ib = 1, np_e                                    ! MPI
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = ibl1_2, ibl2
                     bi = (ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + bi*ngabc_red(i,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + bi*ngabc_red(i,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + bi*ngabc_red(i,3)
                  end do
               end do
            else if(mil == 0 .or. mil == 2) then ! l: odd
               if(mil == 0) fac = 2.d0; if(mil == 2) fac = -2.d0;
               do ib = 1, np_e
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = ibl1_2, ibl2
                     br = (ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  end do
               end do
            end if
         end if
      else
         if(kimg == 1) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1); bi = ai(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc_red(i,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc_red(i,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc_red(i,3)
               end do
            end do
         else if(kimg == 2) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2)
                  bi = ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc_red(i,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc_red(i,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc_red(i,3)
               end do
            end do
         end if
         mil = mod(il,4)
         do id3 = 1, 3
            if(mil == 1 .or. mil == 3) then
               if(mil == 1) fac = 1.d0;  if(mil == 3) fac = -1.d0
               do ib = 1, np_e                              ! MPI
                  tmp = gr(ib,lmt1,id3)
                  gr(ib,lmt1,id3) = -fac*gi(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = fac*tmp
               end do
            else if(mil == 2) then
               do ib = 1, np_e                       ! MPI
                  gr(ib,lmt1,id3) = - gr(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = - gi(ib,lmt1,id3)
               end do
            end if
         end do
      end if

      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs_div
#endif
  end subroutine m_Force_term_drv_of_flmt

! ============================== added by K. Tagami ===================== 11.0
  subroutine m_Force_term_drv_of_flmt_noncl(kv3,pos,napt)
    integer, intent(in)                          :: kv3
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)     :: napt

    integer  :: ia,is,ik,iksnl,it,lmt1,lmtt1,il,mdvdb
    integer  :: is1
    real(kind=DP) :: fac, fx, fy, fz
#ifdef SX
    real(kind=DP),allocatable,dimension(:) :: fxyz_mpi1,fxyz_mpi2  ! MPI
    real(kind=DP),allocatable,dimension(:) :: zfsin, zfcos  ! MPI
#else
    real(kind=DP),allocatable,dimension(:) :: zfsin, zfcos  ! MPI
    integer :: ibl1,ibl2,ibsize,ncache
!!$    real(kind=DP),allocatable,dimension(:,:,:) :: zaj_red ! d(ibsize,np_e,kimg)
!!$    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi, snl_red
    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi
    real(kind=DP),allocatable,dimension(:) :: zfsin_red,zfcos_red  ! MPI
    integer, allocatable, dimension(:,:) :: ngabc_red
#endif
   
    real(kind=DP), allocatable :: gr_noncl( :,:,:,: )
    real(kind=DP), allocatable :: gi_noncl( :,:,:,: )

    integer       :: id_sname = -1
    call tstatc0_begin('m_Force_term_drv_of_flmt ',id_sname,1)

    allocate(gr_noncl(np_e,nlmta,3,ndim_spinor)); gr_noncl = 0.0d0
    allocate(gi_noncl(np_e,nlmta,3,ndim_spinor)); gi_noncl = 0.0d0

!!!!!!!!    fac = 2.d0 / (kv3/ndim_spinor )
    fac = 1.d0 / (kv3/ndim_spinor )

#ifdef SX
    allocate(ar(kg1))        ;allocate(ai(kg1))
    allocate(zfsin(nbmx)); zfsin = 0.d0
    allocate(zfcos(nbmx)); zfcos = 0.d0
    if(npes>1) then
       allocate(fxyz_mpi1(3));    allocate(fxyz_mpi2(3))      ! MPI
    end if

    do ia = 1, natm
       fx = 0.d0; fy = 0.d0; fz = 0.d0
!!$       call calc_phase2(natm,pos,ia,kgp,nbmx,ngabc,nbmx,zfcos,zfsin)
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)

       do ik = 1, kv3, ndim_spinor
          if(map_k(ik) /= myrank_k) cycle        ! MPI
          call calc_phase(ia,natm,pos,kgp,iba(ik),ngabc,kg1 &
               & ,nbase(1,ik), nbmx, zfcos,zfsin) !-(b_Elec.) ->(zfcos,zfsin)
          iksnl = (ik-1)/nspin+1

          do lmt1 = 1, ilmt(it)
             lmtt1=lmtt(lmt1,it); il=ltp(lmt1,it)

             Do is1=1, ndim_spinor
                call drv_of_betar_dot_WFs( ik+is1-1, gr_noncl(:,:,:,is1), &
                     &                               gi_noncl(:,:,:,is1) ) 
                                       ! --> gr,gi : derivatives of fsr, fsi
             End do
          end do
          if(mdvdb == EXECUT) then
             call term_related_to_drv_of_flmt_VDB
                  ! gr,gi,fsr,fsi,vlhxcq,dion,eko_l,q,occup_l --> fx,fy,fz
          else if(mdvdb == SKIP) then
             call term_related_to_drv_of_flmt_NC
                   ! gr,gi,fsr,fsi,dion,occup_l --> fx,fy,fz
          end if
       end do

       call pucv2cart(rltv,fx,fy,fz)
       if(npes >1) then
          fxyz_mpi1(1) = fx; fxyz_mpi1(2) = fy; fxyz_mpi1(3) = fz  ! MPI
          call mpi_allreduce(fxyz_mpi1,fxyz_mpi2,3,mpi_double_precision &
               & ,mpi_sum,mpi_comm_group,ierr)          ! MPI
          fx = fxyz_mpi2(1); fy = fxyz_mpi2(2); fz = fxyz_mpi2(3)  ! MPI
       end if
       fnlxyz_l(ia,1) = fx; fnlxyz_l(ia,2) = fy; fnlxyz_l(ia,3) = fz
    end do
    if(npes>1) deallocate(fxyz_mpi2,fxyz_mpi1)
    deallocate(zfcos,zfsin)
    deallocate(ai,ar)
#else
    ncache = (m_CtrlP_cachesize()*1024)*3/4

    fnlxyz_l = 0.d0

    do ik = 1, kv3, ndim_spinor
       if(ncache == 0) then
          ibsize = iba(ik)
       else
          if(k_symmetry(ik) == GAMMA) then ! core2
             if(kimg == 1) then ! ar(i):1,zaj_l(i,ib,ik,1):np_e, ngabc(i,1:3):3
                ibsize=ncache/(8*(np_e+1) + 4*3)
             else !  ar(i),ai(i):2,zaj_l(i,ib,ik,1),zaj_l(i,ib,ik,2):np_e*2,ngabc(i,1:3):3
                ibsize=ncache/(8*(2+np_e*2) + 4*3)
             endif
          else
             if(kimg==1) then ! ar(i),ai(i):2,zaj_l(i,ib,ik,1):np_e,ngabc(i,1:3):3
                ibsize = ncache/(8*(2+np_e) + 4*3)
             else if(kimg == 2) then ! ar(i),ai(i):2,zaj_l(i,ib,ik,1:2):np_e*2,ngabc(i,1:3):3
                ibsize = ncache/(8*(2+np_e*2)+4*3)
             end if
          end if
       end if

       if(ipriforce>= 2) write(6,'(" ! ibsize = ",i8," <<m_Force_term_drv_of_flmt>>")') ibsize
!!$          allocate(zaj_red(ibsize,np_e,kimg))
!!$          allocate(ngabc_red(ibsize,3))
!!$          allocate(snl_red(ibsize,nlmtt))
!!$          allocate(zfcos_red(ibsize)); zfcos_red = 0.d0
!!$          allocate(zfsin_red(ibsize)); zfsin_red = 0.d0

       if(map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/nspin+1

       IBLOCK: do ibl1 = 1, iba(ik), ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iba(ik)) ibl2 = iba(ik)
          if(ipriforce>= 2) write(6,'(" ! ibl1, ibl2 = ",2i8," <<m_Force_term_drv_of_flmt>>")') ibl1,ibl2

          allocate(ngabc_red(ibl1:ibl2,3)); ngabc_red = 0
          allocate(zfcos(ibl1:ibl2))
          allocate(zfsin(ibl1:ibl2))
          allocate(ar(ibl1:ibl2))        ;allocate(ai(ibl1:ibl2))
!!$             call substitute_zajred(ik)    ! zaj_l -> zaj_red
          call substitute_ngabcred(ik)  ! ngabc,nbase -> ngabc_red
!!$             call substitute_snlred(iksnl) ! snl -> snl_red

          do ia = 1, natm
             it = ityp(ia)
             call calc_phase_div(ia) ! pos, ngabc_red -> zfcos, zfsin

             do lmt1 = 1, ilmt(it)
                lmtt1 = lmtt(lmt1,it); il = ltp(lmt1,it)

                Do is1=1, ndim_spinor
                   call drv_of_betar_dot_WFs_div( ik+is1-1, gr_noncl(:,:,:,is1), &
                        &                                   gi_noncl(:,:,:,is1) ) 
                End do

             end do

             fx = 0.d0; fy = 0.d0; fz = 0.d0
             mdvdb = m_PP_include_vanderbilt_pot(it)
             if(mdvdb == EXECUT) then
                call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
             else if(mdvdb == SKIP) then
                call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
             end if

             call pucv2cart(rltv,fx,fy,fz)
             fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
             fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
             fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
          end do
          deallocate(ai,ar)
          deallocate(zfsin,zfcos)
          deallocate(ngabc_red)
       end do IBLOCK
!!$          deallocate(snl_red)
!!$          deallocate(zaj_red)
    end do
    if(npes>1) then
       allocate(fnlxyz_mpi(natm,3)); fnlxyz_mpi = 0.d0
       call mpi_allreduce(fnlxyz_l,fnlxyz_mpi,3*natm,mpi_double_precision &
            & , mpi_sum, mpi_comm_group,ierr)
       fnlxyz_l = fnlxyz_mpi
    end if
    if(npes>1)deallocate(fnlxyz_mpi)
#endif


    if(af /= 0) then
       allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
       call forcaf2(natm,natm2,nopr+af,natm,nopr,napt &
         & ,iwei,op,ipriforce,af,fnlxyz_l ,forc_up,forc_down)
       deallocate(forc_down);deallocate(forc_up)
    end if

    deallocate(gi); deallocate(gr)

    if(ipriforce >= 2)  then
       write(6,'(" --- fnlxyz_l ->>")')
       do ia = 1, natm
          write(6,'(i8,3f20.8)') ia, fnlxyz_l(ia,1:3)
       end do
       write(6,'(" <<- fnlxyz_l ---")')
    end if

    call tstatc0_end(id_sname)
  contains

    subroutine term_related_to_drv_of_flmt_NC
      integer :: lmt1, lmta1, lmt2, lmta2, l1,m1,l2,m2, i
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2

      integer :: is1, is2, istmp
      complex(kind=CMPLDP) :: z1, z2, z3, zg1(3), zg2(3), zsum(3)

      do lmt1 = 1, ilmt(it)
         lmta1 = lmta(lmt1,ia); l1 = ltp(lmt1,it); m1 = mtp(lmt1,it)

! === KT_mod ================= 2013/10/31
!!!         do lmt2 = lmt1, ilmt(it)
         do lmt2 = 1, ilmt(it)
! ============================ 2013/10/31

            l2 = ltp(lmt2,it); m2 = mtp(lmt2,it); lmta2 = lmta(lmt2,ia)

!!!!            if(l1 /= l2 .or. m1 /= m2) cycle

! === KT_mod ================= 2013/10/31
!!!            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            fac_n = fac
! ============================ 2013/10/31

            if(k_symmetry(ik) == GAMMA) then
               stop 'Not supported : Gamma symmetry in non-collinear system'
            else

               do i = 1, np_e                                 ! MPI
                  zsum = 0.0d0
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2

                        z1 = cmplx( fsr_l(i,lmta1,ik+is1-1), fsi_l(i,lmta1,ik+is1-1 ) )
                        z2 = cmplx( fsr_l(i,lmta2,ik+is2-1), fsi_l(i,lmta2,ik+is2-1 ) )
                        zg1(:) = cmplx( gr_noncl(i,lmt1,:,is1), gi_noncl(i,lmt1,:,is1) )
                        zg2(:) = cmplx( gr_noncl(i,lmt2,:,is2), gi_noncl(i,lmt2,:,is2) )

                        zsum(:) = zsum(:) + (conjg(z1)*zg2(:) + conjg(zg1(:))*z2 )&
                             &              *dion_scr_noncl( lmt1,lmt2,istmp,ia )
                     End do
                  End Do

                  zsum = zsum *fac_n *occup_l(i,ik)

                  fx  = fx - real( zsum(1) )
                  fy  = fy - real( zsum(2) )
                  fz  = fz - real( zsum(3) )

               end do
            end if
         end do
      end do
    end subroutine term_related_to_drv_of_flmt_NC

    subroutine term_related_to_drv_of_flmt_VDB
      integer :: lmt1, lmta1, lmt2, lmta2, i
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2
      integer :: is1, is2, istmp
      complex(kind=CMPLDP) :: z1, z2, z3, zg1(3), zg2(3), zsum(3)

      integer       :: id_sname = -1
      call tstatc0_begin('term_related_to_drv_of_flmt_VDB ',id_sname)

      do lmt1 = 1, ilmt(it)
         lmta1 = lmta(lmt1,ia)

! ============ KT_mod ================= 2013/10/31
!!!         do lmt2 = lmt1, ilmt(it)
         do lmt2 = 1, ilmt(it)
! ===================================== 2013/10/31

            lmta2 = lmta(lmt2,ia)

! ============ KT_mod ================= 2013/10/31
!!!            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            fac_n = fac
! ===================================== 2013/10/31

            if(k_symmetry(ik) == GAMMA) then
               stop 'Not supported : Gamma symmetry in non-collinear system'
            else

              do i = 1, np_e                                 ! MPI
                  zsum = 0.0d0
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2

                        z1 = cmplx( fsr_l(i,lmta1,ik+is1-1), fsi_l(i,lmta1,ik+is1-1 ) )
                        z2 = cmplx( fsr_l(i,lmta2,ik+is2-1), fsi_l(i,lmta2,ik+is2-1 ) )
                        zg1(:) = cmplx( gr_noncl(i,lmt1,:,is1), gi_noncl(i,lmt1,:,is1) )
                        zg2(:) = cmplx( gr_noncl(i,lmt2,:,is2), gi_noncl(i,lmt2,:,is2) )

                        z3 = dion_scr_noncl( lmt1,lmt2,istmp,ia ) &
                             &  -eko_l(i,ik) *q_noncl(lmt1,lmt2,istmp,it )

                        zsum(:) = zsum(:) + (conjg(z1)*zg2(:) + conjg(zg1(:))*z2 ) *z3
                     End do
                  End Do

                  zsum = zsum *fac_n *occup_l(i,ik)

                  fx  = fx - real( zsum(1) )
                  fy  = fy - real( zsum(2) )
                  fz  = fz - real( zsum(3) )
               end do

            end if
         end do
      end do
      call tstatc0_end(id_sname)
    end subroutine term_related_to_drv_of_flmt_VDB

#ifdef SX
    subroutine drv_of_betar_dot_WFs(ik,gr,gi)
      integer, intent(in) :: ik

      real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: ib, i, i1, id3, mil
      real(kind=DP) :: br, bi, tmp, fac
      integer :: id_sname = -1
      call tstatc0_begin('drv_of_betar_dot_WFs ',id_sname)
#ifdef HIUX
*poption parallel
#endif
      do i = 1, iba(ik)
!!$         i1 = nbase(i,ik)
!!$         ar(i) = zfcos(i1)*snl(i,lmtt1,iksnl)
!!$         ai(i) = zfsin(i1)*snl(i,lmtt1,iksnl)
         ar(i) = zfcos(i)*snl(i,lmtt1,iksnl)
         ai(i) = zfsin(i)*snl(i,lmtt1,iksnl)
      end do

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
!!$                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
!!$                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
!!$                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         else if(kimg == 2) then
            mil = mod(il,4)
            if(mil == 1 .or. mil == 3) then ! l: even
               if(mil == 1) fac = -2.d0; if(mil == 3) fac = 2.d0
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
!CDIR OUTERUNROLL=4
!CDIR NOLOOPCHG
               do ib = 1, np_e                                    ! MPI
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = 2, iba(ik)
                     i1 = nbase(i,ik)
                     bi = (ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + bi*ngabc(i1,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + bi*ngabc(i1,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + bi*ngabc(i1,3)
                  end do
               end do
            else if(mil == 0 .or. mil == 2) then ! l: odd
               if(mil == 0) fac = 2.d0; if(mil == 2) fac = -2.d0;
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
               do ib = 1, np_e
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = 2, iba(ik)
                     i1 = nbase(i,ik)
                     br = (ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  end do
               end do
            end if
         end if
      else
         if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1); bi = ai(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         else if(kimg == 2) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2)
                  bi = ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         end if
         mil = mod(il,4)
         do id3 = 1, 3
            if(mil == 1 .or. mil == 3) then
               if(mil == 1) fac = 1.d0;  if(mil == 3) fac = -1.d0
#ifdef HIUX
*poption parallel
#endif
               do ib = 1, np_e                              ! MPI
                  tmp = gr(ib,lmt1,id3)
                  gr(ib,lmt1,id3) = -fac*gi(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = fac*tmp
               end do
            else if(mil == 2) then
#ifdef HIUX
*poption parallel
#endif
               do ib = 1, np_e                       ! MPI
                  gr(ib,lmt1,id3) = - gr(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = - gi(ib,lmt1,id3)
               end do
            end if
         end do
      end if

      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs
#else
!!$    subroutine substitute_zajred(ik)
!!$      integer, intent(in) :: ik
!!$      integer :: ie, ig
!!$      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      if(kimg==1) then
!!$         do ie = 1, np_e
!!$            do ig = 1, ibl2-ibl1+1
!!$               zaj_red(ig,ie,1) = zaj_l(ig+ibl1-1,ie,ik,1)
!!$            end do
!!$         end do
!!$      else if(kimg==2) then
!!$         do ie = 1, np_e
!!$            do ig = 1, ibl2-ibl1+1
!!$               zaj_red(ig,ie,1)    = zaj_l(ig+ibl1-1,ie,ik,1)
!!$               zaj_red(ig,ie,kimg) = zaj_l(ig+ibl1-1,ie,ik,kimg)
!!$            end do
!!$         end do
!!$      end if
!!$    end subroutine substitute_zajred

    subroutine substitute_ngabcred(ik)
      integer, intent(in) :: ik
      integer :: ig, i1
      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      if(ipriforce >= 1) write(6,'(" ibl1, ibl2 = ",2i8)') ibl1, ibl2
      do ig = ibl1, ibl2
         i1 = nbase(ig,ik)
         ngabc_red(ig,1) = ngabc(i1,1)
         ngabc_red(ig,2) = ngabc(i1,2)
         ngabc_red(ig,3) = ngabc(i1,3)
      end do
!!$      do ig = 1, ibl2-ibl1+1
!!$         i1 = nbase(ig+ibl1-1,ik)
!!$         ngabc_red(ig,1) = ngabc(i1,1)
!!$         ngabc_red(ig,2) = ngabc(i1,2)
!!$         ngabc_red(ig,3) = ngabc(i1,3)
!!$      end do
    end subroutine substitute_ngabcred

!!$    subroutine substitute_snlred(iksnl)
!!$      integer, intent(in) :: iksnl
!!$      integer :: ig, lmt1
!!$      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      do lmt1 = 1, nlmtt
!!$         do ig = 1, ibl2-ibl1+1
!!$            snl_red(ig,lmt1) = snl(ig+ibl1-1,lmt1,iksnl)
!!$         end do
!!$      end do
!!$    end subroutine substitute_snlred

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: ig
      real(kind=DP) :: fx,fy,fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do ig = ibl1, ibl2
         ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
         zfcos(ig) = dcos(ph)
         zfsin(ig) = dsin(ph)
      end do
!!$      do ig = 1, ibl2-ibl1+1
!!$         ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
!!$         zfcos_red(ig) = dcos(ph)
!!$         zfsin_red(ig) = dsin(ph)
!!$      end do
    end subroutine calc_phase_div

    subroutine drv_of_betar_dot_WFs_div(ik,gr,gi)
      integer, intent(in) :: ik

      real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: ib, i, i1, id3, mil, ibl1_2
      real(kind=DP) :: br, bi, tmp, fac
      integer :: id_sname = -1
      call tstatc0_begin('drv_of_betar_dot_WFs_div ',id_sname)

      do i = ibl1, ibl2
         ar(i) = zfcos(i)*snl(i,lmtt1,iksnl)
         ai(i) = zfsin(i)*snl(i,lmtt1,iksnl)
      end do

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
               end do
            end do
         else if(kimg == 2) then
            ibl1_2 = max(2,ibl1)
            mil = mod(il,4)
            if(mil == 1 .or. mil == 3) then ! l: even
               if(mil == 1) fac = -2.d0; if(mil == 3) fac = 2.d0
               do ib = 1, np_e                                    ! MPI
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = ibl1_2, ibl2
                     bi = (ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + bi*ngabc_red(i,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + bi*ngabc_red(i,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + bi*ngabc_red(i,3)
                  end do
               end do
            else if(mil == 0 .or. mil == 2) then ! l: odd
               if(mil == 0) fac = 2.d0; if(mil == 2) fac = -2.d0;
               do ib = 1, np_e
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = ibl1_2, ibl2
                     br = (ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  end do
               end do
            end if
         end if
      else
         if(kimg == 1) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1); bi = ai(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc_red(i,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc_red(i,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc_red(i,3)
               end do
            end do
         else if(kimg == 2) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2)
                  bi = ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc_red(i,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc_red(i,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc_red(i,3)
               end do
            end do
         end if
         mil = mod(il,4)
         do id3 = 1, 3
            if(mil == 1 .or. mil == 3) then
               if(mil == 1) fac = 1.d0;  if(mil == 3) fac = -1.d0
               do ib = 1, np_e                              ! MPI
                  tmp = gr(ib,lmt1,id3)
                  gr(ib,lmt1,id3) = -fac*gi(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = fac*tmp
               end do
            else if(mil == 2) then
               do ib = 1, np_e                       ! MPI
                  gr(ib,lmt1,id3) = - gr(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = - gi(ib,lmt1,id3)
               end do
            end if
         end do
      end if

      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs_div
#endif
  end subroutine m_Force_term_drv_of_flmt_noncl
! ========================================================================= 11.0

#endif

  subroutine m_Force_term_dipole()
    integer :: i,ia
    real(kind=DP) :: ed(3),ef(3),a2
#ifdef __TIMER_SUB__
    call timer_sta(1505)
#endif
    ed = 0.d0
    do i=1,3
       a2 = dot_product(altv(1:3,i),altv(1:3,i))
       ed(1:3) = ed(1:3)-PAI4*dipole(i)*altv(1:3,i)/a2
    end do
    ef = 0.d0
    do i=1,3
       ef(1:3) = ef(1:3)-2.d0*field(i)*rltv(1:3,i)
    end do
    do ia=1,natm
       fdip_l(ia,1:3) = ival(ityp(ia))*ed(1:3)
       fext_l(ia,1:3) = ival(ityp(ia))*ef(1:3)
    end do 
#ifdef __TIMER_SUB__
    call timer_end(1505)
#endif
  end subroutine m_Force_term_dipole

  subroutine m_Force_term_fef()
    integer :: ia
    do ia=1,natm
       ffef_l(ia,1:3) = ival(ityp(ia))*elec_field(1:3)
    end do
  end subroutine m_Force_term_fef


!!$  subroutine m_Force_alloc_zfsin_zfcos
!!$    allocate(zfcos(ista_kngp:iend_kngp))
!!$    allocate(zfsin(ista_kngp:iend_kngp))
!!$  end subroutine m_Force_alloc_zfsin_zfcos

!!$  subroutine m_Force_dealloc_zfsin_zfcos
!!$    deallocate(zfsin); deallocate(zfcos)
!!$  end subroutine m_Force_dealloc_zfsin_zfcos

  subroutine m_Force_cal_forcmx()
    integer       :: ia,j
    real(kind=DP) :: fca
    real(kind=DP) :: fcatmp
#ifdef __TIMER_SUB__
    call timer_sta(1507)
#endif
    forcmx = 0.d0
    if(nfcatm <= 0) then
!xocl spread do/ind_natm
!!       do ia = 1, natm
!!          if(imdtyp(ia) == RELAX .or. imdtyp(ia) > HEAT_BATH) then
!!             fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
!!             if(forcmx < fca) forcmx = fca
!!          end if
!!       end do
       do ia = 1, natm
          fcatmp = 0.d0
          if(imdtypxyz(ia,1) ==0 .and. imdtypxyz(ia,2)==0 .and. imdtypxyz(ia,3)==0) cycle
          do j=1,3
             if(imdtypxyz(ia,j) == RELAX .or. imdtypxyz(ia,j) > HEAT_BATH) fcatmp = fcatmp + forc_l(ia,j)**2
          enddo
          fca = dsqrt(fcatmp)
          if(forcmx < fca) forcmx = fca
       end do
!xocl end spread sum(forcmx)
    else if(nfcatm > 0) then
!xocl spread do/ind_natm
       do ia = 1, natm
          if(imdtyp(ia) == RELAX .or. imdtyp(ia) > HEAT_BATH) then
             fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
             if(forcmx < fca) forcmx = fca
          else if(imdtyp(ia) == BONDLENGTH_FIX .or. imdtyp(ia) == BONDLENGTH_FIX_1 &
               & .or. imdtyp(ia) == BONDLENGTH_FIX_2 .or. imdtyp(ia) == COG_FIX) then
             fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
             if(forcmx < fca) forcmx = fca
          end if
       end do
!xocl end spread sum(forcmx)
    end if
    if(ipriforce >= 1) then
       if(iteration_ionic_wd_forcmx /= iteration_ionic) &
            & write(6,'(" !D forcmx = ",d20.12, " at the iteration_ionic of ",i8)') &
            & forcmx, iteration_ionic
       call flush(6)
       iteration_ionic_wd_forcmx = iteration_ionic
    end if
#ifdef __TIMER_SUB__
    call timer_end(1507)
#endif
  end subroutine m_Force_cal_forcmx

  logical function m_Forces_are_Converged_core()
    call m_Force_cal_forcmx()
    if(forcmx < forccr) then
       m_Forces_are_Converged_core = .true.
    else
       m_Forces_are_Converged_core = .false.
    end if
  end function m_Forces_are_Converged_core

  subroutine extract_largerforce_atoms(nforc, ndim, iatom_larger)
    integer, intent(in) :: nforc, ndim
    integer, intent(out), dimension(ndim) :: iatom_larger
    integer :: ia, ia2, ic,ic2, it
    real(kind=DP) :: sqr_forc, sqrforc_lower, tmp
    real(kind=DP), allocatable, dimension(:) :: dforce
    
    allocate(dforce(natm)); dforce = 0.d0
    do ia = 1, natm
       dforce(ia) = forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3)
    end do
    do ia = 1, natm-1
       do ia2 = ia+1, natm
          if(dforce(ia) < dforce(ia2)) then
             sqr_forc = dforce(ia)
             dforce(ia) = dforce(ia2)
             dforce(ia2) = sqr_forc
          end if
       end do
    end do
    sqrforc_lower = dforce(min(nforc,natm))
    deallocate(dforce)
    allocate(dforce(ndim)); dforce = 0.d0
    ic = 0
    do ia = 1, natm
       sqr_forc = forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3)
       if(sqr_forc >= sqrforc_lower) then
          ic = ic + 1
          if(ic > ndim) exit
          iatom_larger(ic) = ia
          dforce(ic) = sqr_forc
       end if
    end do
    do ia = 1, ndim-1
       do ia2 = ia+1, ndim
          if(dforce(ia) < dforce(ia2)) then
             tmp = dforce(ia)
             dforce(ia) = dforce(ia2)
             dforce(ia2) = tmp
             it = iatom_larger(ia)
             iatom_larger(ia) = iatom_larger(ia2)
             iatom_larger(ia2)  = it
          end if
       end do
    end do
    deallocate(dforce)
  end subroutine extract_largerforce_atoms

  subroutine m_Force_cal_absforc(nforc, forc_lower)
    integer, intent(in) :: nforc
    real(kind=DP), intent(out) :: forc_lower
    real(kind=DP), allocatable, dimension(:) :: dforce
!!$    integer*2 compar
    real(kind=DP) :: tmp
    integer :: ia, ia2
    allocate(dforce(natm)); dforce = 0.d0
    do ia = 1, natm
       dforce(ia) = forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3)
    end do
    do ia = 1, natm-1
       do ia2 = ia+1, natm
          if(dforce(ia) < dforce(ia2)) then
             tmp = dforce(ia)
             dforce(ia) = dforce(ia2)
             dforce(ia2) = tmp
          end if
       end do
    end do
!!$    call qsort( dforce, natm, DP, compar)
    if(nforc < natm) then
       forc_lower = sqrt(dforce(nforc))
    else
       forc_lower = sqrt(dforce(natm))
    end if
    deallocate(dforce)
  end subroutine m_Force_cal_absforc

!!$  integer*2 function compar(a,b)
!!$    real(kind=DP) :: a,b
!!$    if(a  > b) compar = -1
!!$    if(a == b) compar = 0
!!$    if(a  < b) compar = 1
!!$    return
!!$  end function compar

  subroutine m_Force_wd_force_and_cps(nf, withorwithout, cps, ndim)
    integer, intent(in) :: nf, withorwithout,ndim
    real(kind=DP), intent(in) :: cps(ndim,3)
    integer :: ia

    if(mype==0) then
       if(withorwithout == WITHOUTTAG) then
          do ia = 1, natm
             write(nf,'(" ",i4,3f15.9,3f12.6)') ia &
                  &, cps(ia,1),cps(ia,2),cps(ia,3) &
                  &, forc_l(ia,1), forc_l(ia,2), forc_l(ia,3)
          end do
       else if(withorwithout == WITHTAG) then
          do ia = 1, natm
             write(nf,'(" !forc ",i4,3f12.6,3f12.6)') ia &
                  &, cps(ia,1),cps(ia,2),cps(ia,3) &
                  &, forc_l(ia,1), forc_l(ia,2), forc_l(ia,3)
          end do
       else
          write(nf,'(" keyword in the argument list of m_Force_wd_force_and_cps is invalid")')
       end if
    end if
  end subroutine m_Force_wd_force_and_cps

  subroutine m_Force_wd_force_and_cps_lim(nf, withorwithout, cps, ndim, N_FORC)
    integer, intent(in) :: nf, withorwithout,ndim, N_FORC
    real(kind=DP), intent(in) :: cps(ndim,3)
!!$    real(kind=DP), intent(in) :: forc_lower
!!$    real(kind=DP) :: sqr_forc, dforce, forc_lower
    real(kind=DP) :: dforce, forc_lower
    integer,       allocatable, dimension(:) :: iatm_larger ! d(min(ndim,N_FORC))
!!$    real(kind=DP), allocatable, dimension(:) :: dforce
    integer :: ia,ic

    if(withorwithout /= WITHOUTTAG .and. withorwithout /= WITHTAG) then
       if(mype == 0) write(nf,'(" keyword in the argument list of m_Force_wd_force_and_cps is invalid")')
       return
    end if
    if(mype==0) then
       allocate(iatm_larger(min(natm,n_forc))); iatm_larger = 0
       call extract_largerforce_atoms(n_forc,min(natm,n_forc),iatm_larger)
!!$       sqr_forc = forc_lower*forc_lower
       write(nf,'(" !forc *** ",i4," largest-force atoms ***")') min(n_forc,natm)
!!$       write(nf,'(" !forc   no    iatm     cps(1)      cps(2)      cps(3)    forc_l(1)   forc_l(2)   forc_l(3)  abs(forc_l)")')
       write(nf,'(" !forc   no    iatm",3(6x,"cps(",i1,")"),3(3x,"forc_l(",i1,")"),"  abs(forc_l)")') &
            & 1,2,3,1,2,3
       do ic = 1, min(natm,n_forc)
          ia = iatm_larger(ic)
          dforce = sqrt(forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3))
          if(withorwithout == WITHOUTTAG) then
             write(nf,'(" ",i4,i8,3f15.9,4f12.6)') ic,ia,cps(ia,1:3),forc_l(ia,1:3),dforce
          else if(withorwithout == WITHTAG) then
             write(nf,'(" !forc ",i4,i8,3f12.6,4f12.6)') ic,ia,cps(ia,1:3),forc_l(ia,1:3),dforce
          end if
       end do
!!$       do ia = 1, natm
!!$          if(dforce > sqr_forc) then
!!$             ic = ic + 1
!!$             if(withorwithout == WITHOUTTAG) then
!!$                write(nf,'(" ",i4,i8,3f15.9,4f12.6)') ic,ia,cps(ia,1:3),forc_l(ia,1:3),sqrt(dforce)
!!$             else if(withorwithout == WITHTAG) then
!!$                write(nf,'(" !forc ",i4,i8,3f12.6,4f12.6)') ic,ia,cps(ia,1:3),forc_l(ia,1:3),sqrt(dforce)
!!$             end if
!!$          end if
!!$       end do
    end if
  end subroutine m_Force_wd_force_and_cps_lim

  subroutine m_Force_wd_force_cps_cpd(nf, withorwithout, cps, cpd,ndim)
    integer, intent(in) :: nf, withorwithout,ndim
    real(kind=DP), intent(in) :: cps(ndim,3), cpd(ndim,3)
    integer :: ia

    if(mype==0) then
       if(withorwithout == WITHOUTTAG) then
          do ia = 1, natm
             write(nf,'(" ",i4,3f15.9,3f12.6, 3f12.6)') ia &
                  &, cps(ia,1:3), cpd(ia,1:3), forc_l(ia,1:3)
          end do
       else if(withorwithout == WITHTAG) then
          do ia = 1, natm
             write(nf,'(" !forc ",i4,3f12.6,3f12.6,3f12.6)') ia &
                  &, cps(ia,1:3),cpd(ia,1:3),forc_l(ia,1:3)
          end do
       else
          write(nf,'(" keyword in the argument list of m_Force_wd_force_cps_cpd is invalid")')
       end if
    end if
  end subroutine m_Force_wd_force_cps_cpd

!!$  subroutine m_Force_wd_force_cps_cpd_lim(nf, withorwithout, cps, cpd,ndim, forc_lower)
  subroutine m_Force_wd_force_cps_cpd_lim(nf, withorwithout, cps, cpd,ndim, N_FORC)
    integer, intent(in) :: nf, withorwithout,ndim, N_FORC
    real(kind=DP), intent(in) :: cps(ndim,3), cpd(ndim,3)
!!$    real(kind=DP), intent(in) :: forc_lower
!!$    real(kind=DP) :: sqr_forc, dforce, forc_lower
    real(kind=DP) :: dforce, forc_lower
    integer,       allocatable, dimension(:) :: iatm_larger ! d(min(ndim,N_FORC))
!!$    real(kind=DP), allocatable, dimension(:) :: dforce
    integer :: ia, ic

    if(withorwithout /= WITHOUTTAG .and. withorwithout /= WITHTAG) then
       if(mype == 0) write(nf,'(" keyword in the argument list of m_Force_wd_force_and_cps is invalid")')
       return
    end if
    if(mype==0) then
       allocate(iatm_larger(min(natm,n_forc))); iatm_larger = 0
       call extract_largerforce_atoms(n_forc,min(natm,n_forc),iatm_larger)
!!$       sqr_forc = forc_lower*forc_lower
       write(nf,'(" !forc ",i4," largest force atoms")') min(n_forc,natm)
!!$       write(nf,'(" !forc no iatm  cps(1)  cps(2)  cps(3)   forc_l(1)  forc_l(2)  forc_l(3) abs(forc_l)")')
       write(nf,'(" !forc   no    iatm",3(6x,"cps(",i1,")"),3(6x,"cpd(",i1,")") &
            & , 3(3x,"forc_l(",i1,")"),"  abs(forc_l)")') 1,2,3,1,2,3,1,2,3
!!$       ic = 0
       do ic = 1, min(natm,n_forc)
          ia = iatm_larger(ic)
          dforce = sqrt(forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3))
          if(withorwithout == WITHOUTTAG) then
             write(nf,'(" ",i4,i8,3f15.9,3f12.6, 4f12.6)') ic,ia,cps(ia,1:3) &
                  & ,cpd(ia,1:3), forc_l(ia,1:3),dforce
          else if(withorwithout == WITHTAG) then
             write(nf,'(" !forc ",i4,i8,3f12.6,3f12.6,4f12.6)') ic,ia,cps(ia,1:3) &
                  & ,cpd(ia,1:3), forc_l(ia,1:3),dforce
          end if
       end do
!!$       do ia = 1, natm
!!$          dforce = forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3)
!!$          if(dforce > sqr_forc) then
!!$             ic = ic + 1
!!$             if(withorwithout == WITHOUTTAG) then
!!$                write(nf,'(" ",2i4,3f15.9,3f12.6, 4f12.6)') ic,ia,cps(ia,1:3),cpd(ia,1:3),forc_l(ia,1:3), sqrt(dforce)
!!$             else if(withorwithout == WITHTAG) then
!!$                write(nf,'(" !forc ",2i4,3f12.6,3f12.6,4f12.6)') ic,ia &
!!$                     &, cps(ia,1:3),cpd(ia,1:3),forc_l(ia,1:3), sqrt(dforce)
!!$             end if
!!$          end if
!!$       end do
    end if
  end subroutine m_Force_wd_force_cps_cpd_lim

  subroutine m_Force_wd_force_sum(nf)
    integer, intent(in) :: nf
    real(kind=DP) :: force_sum(3)
    integer :: ia,j
    do j=1,3
       force_sum(j) = 0.d0
       do ia=1,natm
          force_sum(j) = force_sum(j) + forc_l(ia,j)
       end do
    end do
    write(nf,'(" !forc Sum of forces =",3(1x,f12.6))') force_sum(1:3)
  end subroutine m_Force_wd_force_sum

  subroutine alloc_force_previous()
!!$    if(.not.allocated(force_error)) then
!!$       allocate(force_error(natm,3)); force_error = 0.d0
!!$    end if
    if(.not.allocated(force_previous)) then
       allocate(force_previous(natm,3)); force_previous = 0.d0
    end if
  end subroutine alloc_force_previous

  subroutine dealloc_force_previous()
    if(allocated(force_previous)) deallocate(force_previous)
  end subroutine dealloc_force_previous
    
  subroutine m_Force_get_fec_count(fec_counter)
    integer, intent(out) :: fec_counter
    fec_counter = force_error_check_counter
  end subroutine m_Force_get_fec_count

  subroutine m_Force_clear_fec_counter()
    force_error_check_counter = 0
  end subroutine m_Force_clear_fec_counter

  logical function m_Force_error_tolerable(nfout)
    integer, intent(in) :: nfout
    real(kind=DP) ::       max_norm_error, max_angle_error, force_hyper_angle_error
    if(ipriforce >= 2)  write(nfout,'("!fec  force_error_check_counter = ",i5," forcmx = ",f16.8)') &
         & force_error_check_counter, forcmx

    if(force_error_check_counter == 0) then
       call alloc_force_previous()
       m_Force_error_tolerable = .false.
    else
       call diff_force(max_norm_error,max_angle_error,force_hyper_angle_error,forccr)
       if(          max_norm_error          <= f_tolerable_norm_error &
            & .and. max_angle_error         <= f_tolerable_angle_error &
            & .and. force_hyper_angle_error <= f_tolerable_hyper_angle_error) then
          m_Force_error_tolerable = .true.
       else
          m_Force_error_tolerable = .false.
       end if
    end if

    if(m_Force_error_tolerable) then
       call dealloc_force_previous()
       force_error_check_counter = 0
    else
       call cp_to_force_previous()
       force_error_check_counter = force_error_check_counter+1
    end if
    if(ipriforce == 1)  write(nfout,'("!fec  force_error_check_counter = ",i5," forcmx = ",f16.8)') &
         & force_error_check_counter, forcmx
  contains
    subroutine cp_to_force_previous()
      force_previous = forc_l
    end subroutine cp_to_force_previous

    subroutine diff_force(max_norm_error,max_angle_error,hyper_angle_error,f_critical)
      real(kind=DP), intent(out) :: max_norm_error,max_angle_error,hyper_angle_error
      real(kind=DP), intent(in)  :: f_critical
      real(kind=DP) :: fca, f_diff, f_error,f_angle_error,f_angle_error_deg
      real(kind=DP) :: f1,f2,f3, fnrom, fnorm_p, fprod0, fprod, fnorm_p0, fnorm, fnorm0
      real(kind=DP) :: farg
      integer :: ia, j
      max_norm_error = 0.d0
      max_angle_error = 0.d0
      hyper_angle_error = 0.d0
      if(ipriforce >= 2) write(nfout,'("!fec  natom, ",9x,"  fca, ",3x," f_diff,",3x &
           & ," f_error",3x,"angle_error((rad), (deg))")')
      fprod = 0.d0; fnrom = 0.d0; fnorm_p = 0.d0
      do ia = 1, natm
         if(imdtyp(ia) == RELAX .or. imdtyp(ia) == BONDLENGTH_FIX .or. imdtyp(ia) > HEAT_BATH) then
            fnorm0 = forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2
            fca = dsqrt(fnorm0)
            f_error = 0.d0; f_diff = 0.d0; f_angle_error = 0.d0; f_angle_error_deg = 0.d0
            if(f_critical > DELTA .and. fca > f_critical ) then
               f1 = force_previous(ia,1) - forc_l(ia,1)
               f2 = force_previous(ia,2) - forc_l(ia,2)
               f3 = force_previous(ia,3) - forc_l(ia,3)
               f_diff  = dsqrt(f1*f1 + f2*f2 + f3*f3)
               f_error = f_diff/fca
               if(max_norm_error < f_error) max_norm_error = f_error

               fprod0 = force_previous(ia,1)*forc_l(ia,1) &
                    &  + force_previous(ia,2)*forc_l(ia,2) + force_previous(ia,3)*forc_l(ia,3)
               fnorm_p0 = force_previous(ia,1)**2 + force_previous(ia,2)**2 + force_previous(ia,3)**2
               fnorm_p  = fnorm_p + fnorm_p0
               fnorm    = fnorm   + fnorm0
               if(fnorm_p0 > DELTA) then
                  fnorm_p0 = dsqrt(fnorm_p0)
                  farg = min(fprod0/(fca*fnorm_p0),1.d0)
!!$                  f_angle_error = dacos(fprod0/(fca*fnorm_p0))
                  f_angle_error = dacos(farg)
                  f_angle_error_deg = f_angle_error*180.d0/PAI
                  if(max_angle_error < abs(f_angle_error)) max_angle_error = abs(f_angle_error)
               end if
               fprod = fprod + fprod0
            end if
            if(ipriforce >= 2) then
               if(f_critical > DELTA .and. fca > f_critical ) then
                  if(f_error > f_tolerable_norm_error .or. abs(f_angle_error) > f_tolerable_angle_error) then
                     write(nfout,'("!fec  ",i5,f16.8,4f12.4)') &
                          & ia, fca, f_diff, f_error, f_angle_error, f_angle_error_deg
                  else
                     write(nfout,'("!fec  ",i5,f16.8,4f12.4,"   clear")') &
                          & ia, fca, f_diff, f_error, f_angle_error, f_angle_error_deg
                  end if
               else
                  write(nfout,'("!fec  ",i5,f16.8," ****    **** : fca < f_critical")') ia,fca
               end if
            end if
         end if
      end do
      if(fnorm > DELTA .and. fnorm_p > DELTA) then
         hyper_angle_error = abs(dacos(fprod/(dsqrt(fnorm)*dsqrt(fnorm_p))))
      else
         hyper_angle_error = 0.d0
      end if
      if(ipriforce >= 2) write(nfout,'("!fec  hyper_angle_error = ",f12.4," (radian) = " &
           &                  ,f12.4," (degree)")') hyper_angle_error, hyper_angle_error*180.00/PAI
    end subroutine diff_force

  end function m_Force_error_tolerable

  subroutine m_Force_dealloc
!    if(allocated(forc_l)) deallocate(forc_l)
    if(allocated(fnlxyz_l)) deallocate(fnlxyz_l)
    if(allocated(flhxcq_l)) deallocate(flhxcq_l)
    if(allocated(fdip_l)) deallocate(fdip_l)
    if(allocated(fext_l)) deallocate(fext_l)
    if(allocated(ffef_l)) deallocate(ffef_l)
    if(allocated(fexx_l)) deallocate(fexx_l)
  end subroutine m_Force_dealloc

end module m_Force

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE: m_ES_occup
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki,  April/27/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! *************************************************************
!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.0E]
!                    Fermi-Dirac smearing method is added
!
! =============================================================
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

module m_ES_occup
!     (m_ESoc)
! $Id: m_ES_occup.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Electronic_Structure, only : efermi, efermi_spin, occup_l, eko_l, totch, neordr, eko_ek &
       &                            , vbm, metalic_system, check_if_metalic_flag &
       &                            , band_entropy
  use m_Kpoints,              only : kv3, kv3_ek, qwgt, qwgt_ek, vkxyz &
       &                            ,np0,np2,ip20,iwt,ip2cub,nxyz_tetra
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : ipri, iprioccup, width, nspin, neg, af, ekmode, idimtetra &
       &                            ,partial_charge_Emin, partial_charge_Emax, partial_charge_deltaE &
       &                            ,fixed_charge_k_parallel, icond &
       &                            ,m_CtrlP_way_of_smearing, printable, width_tetra
!!$       &                            ,deltaE_dos_Gaussdistrib, variance_dos_Gaussdistrib
  use m_Crystal_Structure,    only : sw_fix_total_spin, total_spin, imag
  use m_Const_Parameters,     only : DP, DELTA_FermiSearchRange, ON, OFF, NO, YES, HARTREE, DELTA10 &
       &                            ,PARABOLIC, TETRAHEDRON, COLD, FERRO, FIXED_CHARGE, ONE_BY_ONE, BUCS
  use m_Parallelization,      only : mpi_comm_group,npes,map_ek,mype,map_e,map_k,myrank_e,myrank_k &
       &                            ,ierr,np_e,map_z,ista_e,ista_k,iend_k, nrank_k, nrank_e &
       &                            ,mp_e, nel_e, nie_e, nis_e
! ==== DEBUG by tkato 2012/04/03 ===============================================
  use m_Parallelization,      only : mpi_ge_world
! ==============================================================================

! ======================================= added by K. Tagami ============= 11.0
   use m_Control_Parameters,   only : noncol, ndim_spinor
! ========================================================================= 11.0

! ====== KT_add ================================= 13.0E
  use m_Const_Parameters,     only : Fermi_Dirac
! =============================================== 13.0E

  implicit none
!   1. m_ESoc_fermi_parabolic       <-(ChargeDensity_Construction) ->(3)
!      - get_occup_l_and_tot, - get_entropic_term, - get_entropy, - find_eko_minimum_and_maximum
!   2. m_ESoc_fermi_tetrahedron     <-(ChargeDensity_Construction) ->(3)
!   3. check_totch           <-(1),(2)
!   4. m_ESoc_check_num_bands
!   5. m_ESoc_fermi_parabolic_ek
!      - get_tot
!   6. m_ESoc_fermi_tetra_ek
!   7. m_ESoc_check_if_metalic
!   8. check_if_metalic
!   9. m_ESoc_fermi_ColdSmearing
!      - get_occup_l_and_tot, - coldsmearing, - get_entropic_term, - get_entropy
!  10. m_ESoc_set_nEwindows_pc
!  11. find_emin_emax
!  12. m_ESoc_keep_occup
!  13. m_ESoc_retrieve_occup
!  14. m_ESoc_substitute_occup
!  15. m_ESoc_free_nEwindows
!  16. m_ESoc_if_elec_state
!
!    The subroutine "m_ESoc_fermi_parabolic" was originally coded by
!   Noriaki Hamada, 1984.05.17
!
  integer :: nEwindows_pc
  real(kind=DP), private, allocatable, dimension(:,:) :: Ewindows_partial_charge  ! d(nEwindows_pc,2)
  real(kind=DP), private, allocatable, dimension(:,:) :: occup_tmp  ! d(np_e, ista_k:iend_k)
  integer, private, allocatable, dimension(:) ::         if_elec_state ! d(nEwindows_pc)
  real(kind=DP), private ::                              e_origin, total_spin0
  logical, private, save :: efermi_is_defined = .false.

! parameters for manual occupation
  character(len("sw_manual_occupation")),private,parameter :: tag_sw_manual_occupation="sw_manual_occupation"
  integer :: sw_manual_occupation = OFF

  real(kind=DP),allocatable,dimension(:,:) :: occ_ext
  integer,allocatable,dimension(:) :: band_index
  character(len("occupation")),private,parameter :: tag_occupation = "occupation"
  character(len("band_index")),private,parameter :: tag_band_index = "band_index"
  character(len("occ")),private,parameter :: tag_occ = "occ"
  character(len("occ_up")),private,parameter :: tag_occ_up = "occ_up"
  character(len("occ_down")),private,parameter :: tag_occ_down = "occ_down"

  integer, private,parameter :: PRINTOUTLEVEL_TOTCH_SPIN = 2

  include 'mpif.h'
contains
! --> T. Yamasaki, 06 Aug. 2009
  real(kind=DP) function m_ESoc_efermi_diff()
! ============================================= modified by K. Tagami ========= 11.0
!!    if(nspin == 1) then
    if ( nspin == 1 .or. noncol ) then
! ============================================================================= 11.0
       m_ESoc_efermi_diff = 0.d0
       return
    else
       m_ESoc_efermi_diff = efermi_spin(1) - efermi_spin(2)
    end if
  end function m_ESoc_efermi_diff

  real(kind=DP) function m_ESoc_new_total_spin()
    m_ESoc_new_total_spin = (total_spin + total_spin0)*0.50
  end function m_ESoc_new_total_spin

  real(kind=DP) function m_ESoc_total_spin0()
    m_ESoc_total_spin0 =  total_spin0
  end function m_ESoc_total_spin0


  subroutine check_totch(nfout)
    integer, intent(in) :: nfout
    real(kind=DP), parameter :: minimum_critical = 1.d-14
    if(totch <= minimum_critical ) then
       write(nfout,*) '!D totch is too small: totch = ', totch
       stop
    endif
  end subroutine check_totch

!!$  subroutine m_ESoc_dos_with_GaussDistrib()
!!$
!!$  end subroutine m_ESoc_dos_with_GaussDistrib

  logical function m_ESoc_check_num_bands()
    real(kind=DP) :: c

! =========================== modified by K. Tagami ================ 11.0
!    c = neg*2.d0
!
    if ( noncol ) then
       c = neg
    else
       c = neg*2.d0
    endif
! ================================================================== 11.0

    if( c > totch) then
       m_ESoc_check_num_bands = .true.
    else
       m_ESoc_check_num_bands = .false.
    end if
  end function m_ESoc_check_num_bands

  subroutine m_ESoc_fermi_parabolic_ek(nfout)
!
!   Coded from <m_ESoc_fermi_parabolic> 
!                      by T. Yamasaki (FUJITSU LABORATORIES Ltd.), 28th Jun. 2003
    integer, intent(in) :: nfout

    integer             :: jcount
    real(kind=DP)       :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000

! ================================ added by K. Tagami ================ 11.0
    integer :: ik, is, iksnl
    real(kind=DP), allocatable :: eko_tmp(:,:)
! ==================================================================== 11.0

    integer :: id_sname = -1

    call tstatc0_begin('m_ESoc_fermi_parabolic_ek ', id_sname)

    call check_totch(nfout)

! ============================ modified by K. Tagami =================  11.0
!    emin = minval(eko_ek)
!    emax = maxval(eko_ek)
!
     if ( noncol ) then
       allocate( eko_tmp( neg, kv3_ek/ndim_spinor ) ); eko_tmp = 0.0d0
       Do ik=1, kv3_ek, ndim_spinor
         iksnl = ( ik -1 )/ndim_spinor + 1
         eko_tmp( :,iksnl ) = eko_ek( :,ik )
       End do
       emin = minval(eko_tmp);   emax = maxval(eko_tmp)
       deallocate( eko_tmp )
     else
       emin = minval(eko_ek)
       emax = maxval(eko_ek)
     endif
! ===================================================================== 11.0

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

! ======================================== modified by K. Tagami ========== 11.0
!!       call get_tot()             ! -(contained here) ->tot
!
       if ( noncol ) then
         call get_tot_noncl()         
       else
         call get_tot()         
       endif
! ========================================================================== 11.0

!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot


! ===================================== modified by K. Tagami ========== 11.0
!    call check_if_metalic(nfout,metalic_system)

    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif
! ======================================================================= 11.0

    if(iprioccup >= 2 .and. .not.metalic_system) then
       if(dabs(vbm) < 1.d6) then
          write(nfout,'( " The highest occupied band energy = ", f10.4)') vbm
       else
          write(nfout,'( " The highest occupied band energy is not calculated")')
       end if
    end if

    call tstatc0_end(id_sname)
  contains
    subroutine get_tot
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw
      tot = 0.d0
      do k = 1, kv3_ek, af+1
         do i = 1, neg
            e = eko_ek(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight*wspin*kv3_ek*qwgt_ek(k)
            tot = tot + 2*totw
         end do
      end do
      tot = tot/kv3_ek * (af+1)
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount
    end subroutine get_tot

! ======================================== added by K. Tagami ============ 11.0
    subroutine get_tot_noncl
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw, wktmp

      tot = 0.d0
      wktmp = kv3_ek / ndim_spinor

      do k = 1, kv3_ek, ndim_spinor
         do i = 1, neg
            e = eko_ek(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight *wspin *wktmp *qwgt_ek(k)
            tot = tot + totw
         end do
      end do
      tot = tot /wktmp
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount

    end subroutine get_tot_noncl
! ======================================================================= 11.0

  end subroutine m_ESoc_fermi_parabolic_ek

  subroutine m_ESoc_fermi_tetra_ek(nfout)
!  Coded from <m_ESoc_fermi_tetrahedron>
!          by Takahiro Yamasaki(FUJITSU LABORATORIES Ltd.), 28th Jun. 2003
!
    integer, intent(in) :: nfout
#ifndef NO_TETRAHEDRON
    real(kind=DP), parameter :: delta = 1.d-12
    integer, parameter       :: idim = 3
    integer        :: neig,nengy,ispin,ip2,ik,instts1,ikee,nxx,nyy,nzz, ib, jb
    real(kind=DP)  :: efermi2,eval,totind, et
    real(kind=DP), pointer, dimension(:,:,:) :: eig2
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,cdos,cind,valud
    integer             :: id_sname = -1

! =================================== added by K. Tagami ==============- 11.0
    integer :: is
! ====================================================================== 11.0

    call tstatc0_begin('m_ESoc_fermi_tetra_ek ', id_sname)

! ================================= modified by K. Tagami ============= 11.0
!    allocate(eig2(np2,neg,nspin)); eig2 = 0.d0
    if ( noncol ) then
      allocate(eig2(np2,neg,1)); eig2 = 0.d0
    else
      allocate(eig2(np2,neg,nspin)); eig2 = 0.d0
    endif
! ===================================================================== 11.0

    allocate(eawk(np0)); eawk = 0.d0
    allocate(cdwk(np0)); cdwk = 0.d0
    allocate(cswk(np0)); cswk = 0.d0
    allocate(cdos(np2*neg)); cdos = 0.d0
    allocate(cind(np2*neg)); cind = 0.d0
! ================================= modified by K. Tagami ============= 11.0
!    allocate(valud(nspin)); valud = 0.d0
    if ( noncol ) then
      allocate(valud(1)); valud = 0.d0
    else
      allocate(valud(nspin)); valud = 0.d0
    endif
! ====================================================================== 11.0

    call check_totch(nfout)           ! totch is checked

    nxx = nxyz_tetra(1)
    nyy = nxyz_tetra(2)
    nzz = nxyz_tetra(3)
    neig=neg
    nengy=0

! ======================================= modified by K. Tagami ======== 11.0
!    do ispin=1,nspin
!       do ip2=1,np2
!          ik=nspin*(ip2-1)+ispin
!          do ib=1,neg
!             eig2(ip2,ib,ispin)=eko_ek(ib,ik)
!          enddo
!          do ib = 1,neg-1
!             do jb = ib+1, neg
!                if(eig2(ip2,jb,ispin) < eig2(ip2,ib,ispin)-delta) then
!                   et = eig2(ip2,ib,ispin)
!                   eig2(ip2,ib,ispin) = eig2(ip2,jb,ispin)
!                   eig2(ip2,jb,ispin) = et
!                end if
!             end do
!          end do
!       enddo
!    enddo
    if ( noncol ) then
      do is=1, 1
         do ip2=1,np2
            ik = ndim_spinor *(ip2-1)+is
            do ib=1,neg
               eig2(ip2,ib,is)=eko_ek(ib,ik)
            enddo
            do ib = 1,neg-1
               do jb = ib+1, neg
                  if(eig2(ip2,jb,is) < eig2(ip2,ib,is)-delta) then
                     et = eig2(ip2,ib,is)
                     eig2(ip2,ib,is) = eig2(ip2,jb,is)
                     eig2(ip2,jb,is) = et
                  end if
               end do
            end do
         enddo
      enddo
    else
      do ispin=1,nspin
         do ip2=1,np2
            ik=nspin*(ip2-1)+ispin
            do ib=1,neg
               eig2(ip2,ib,ispin)=eko_ek(ib,ik)
            enddo
            do ib = 1,neg-1
               do jb = ib+1, neg
                  if(eig2(ip2,jb,ispin) < eig2(ip2,ib,ispin)-delta) then
                     et = eig2(ip2,ib,ispin)
                     eig2(ip2,ib,ispin) = eig2(ip2,jb,ispin)
                     eig2(ip2,jb,ispin) = et
                  end if
               end do
            end do
         enddo
      enddo
    endif
! ==================================================================== 11.0

    if(iprioccup>=2) then
       write(nfout,'(" --- eko_ek --- <<m_ESoc_fermi_tetra_ek>>")')
! ================================== modified by K. Tagami =========== 11.0
!       do ik = 1, kv3_ek
       do ik = 1, kv3_ek, ndim_spinor
! ===================================================================== 11.0
          write(nfout,'(" ik = ",i8)') ik
          write(nfout,'(10f8.4)') (eko_ek(ib,ik),ib=1,neg)
       end do
    end if

    if(iprioccup>=2) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration ==='
    efermi2 = efermi

! ============================= modified by K. Tagami ============== 11.0
!    call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
!             &  eig2,ip20,np0,totch, efermi2,eval,valud, &
!             &  iwt,ip2cub,iprioccup)
    if ( noncol ) then
      call fermi1( nxx, nyy, nzz, np2, np2, neig, neg, 1, &
               &   eig2, ip20, np0, totch, efermi2, eval, valud, &
               &   iwt, ip2cub, iprioccup, .true. )
    else
      call fermi1( nxx, nyy, nzz, np2, np2, neig, neg, nspin, &
               &   eig2, ip20, np0, totch, efermi2, eval, valud, &
               &   iwt, ip2cub, iprioccup, .false. )
    endif 
! ================================================================== 11.0

    if(iprioccup>=2) write(nfout,*) 'eval=',eval

! ============================= modified by K. Tagami ============== 11.0
!    do ispin=1,nspin
!!!$      write(nfout,*) ' ispin=',ispin
!      instts1 = 0
!      call nsdos3(nfout,idim,efermi2,nxx,nyy,nzz,np2,1,neig, &
!               &  eig2(1,1,ispin),ip20,np0,eawk,instts1,np2,iwt,ip2cub,iprioccup)
!      call nstt3i(idim,nengy,efermi2,nxx,nyy,nzz, &
!               &  np2,np2,neig,eig2(1,1,ispin), &
!               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind )
!      efermi=efermi2
!
!      totind=0.d0
!      do ip2=1,np2
!         do ib=1,neig
!            ikee=ip2+np2*(ib-1)
!            totind=totind+cind(ikee)
!         enddo
!      enddo
!      if(iprioccup>=2) write(nfout,*) 'for spin=',ispin, &
!                  &  ' ** TOTAL CHARGE after fermi1 = ',totind
!   enddo
!
   if ( noncol ) then    
      do is=1,1
        instts1 = 0
        call nsdos3( nfout, idim, efermi2, nxx, nyy, nzz, np2, 1, neig, &
                 &  eig2(1,1,is), ip20, np0, eawk, instts1, np2, &
 	         &  iwt, ip2cub, iprioccup )
        call nstt3i( idim, nengy, efermi2, nxx, nyy, nzz, &
                 &   np2, np2, neig, eig2(1,1,is), &
                 &   ip20, np0, eawk, cdwk, cswk, np2, neig, cdos, cind, width_tetra )
        efermi=efermi2

        totind=0.d0
        do ip2=1,np2
           do ib=1,neig
              ikee=ip2+np2*(ib-1)
              totind=totind+cind(ikee)
           enddo
        enddo
        if(iprioccup>=2) write(nfout,*) 'for spin=',is, &
                    &  ' ** TOTAL CHARGE after fermi1 = ',totind
     enddo
   else
      do ispin=1,nspin
        instts1 = 0
        call nsdos3( nfout, idim, efermi2, nxx, nyy, nzz, np2, 1, neig, &
                 &  eig2(1,1,ispin), ip20, np0, eawk, instts1, np2, &
 	         &  iwt, ip2cub, iprioccup )
        call nstt3i( idim, nengy, efermi2, nxx, nyy, nzz, &
                 &   np2, np2, neig, eig2(1,1,ispin), &
                 &   ip20, np0, eawk, cdwk, cswk, np2, neig, cdos, cind, width_tetra )
        efermi=efermi2

        totind=0.d0
        do ip2=1,np2
           do ib=1,neig
              ikee=ip2+np2*(ib-1)
              totind=totind+cind(ikee)
           enddo
        enddo
        if(iprioccup>=2) write(nfout,*) 'for spin=',ispin, &
                    &  ' ** TOTAL CHARGE after fermi1 = ',totind
     enddo
    endif
! =================================================================== 11.0

    deallocate(valud); deallocate(cind); deallocate(cdos); deallocate(cswk)
    deallocate(cdwk);  deallocate(eawk)
    deallocate(eig2)
    
! ========================================= modified by K. Tagami ====== 11.0
!    call check_if_metalic(nfout,metalic_system)
    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif
! ===================================================================== 11.0

    if(iprioccup >= 2 .and. .not.metalic_system) &
         &write(nfout,'( " The highest occupied band energy = ", f10.4)') vbm

    call tstatc0_end(id_sname)
#endif
  end subroutine m_ESoc_fermi_tetra_ek

! ============================== KT_add ====================== 13.0E
  subroutine m_ESoc_fermi_dirac_ek(nfout)
    integer, intent(in) :: nfout

    integer             :: jcount
    real(kind=DP)       :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000

    integer :: ik, is, iksnl
    real(kind=DP), allocatable :: eko_tmp(:,:)

    integer :: id_sname = -1

    call tstatc0_begin('m_ESoc_fermi_dirac_ek ', id_sname)

    call check_totch(nfout)

    if ( noncol ) then
       allocate( eko_tmp( neg, kv3_ek/ndim_spinor ) ); eko_tmp = 0.0d0
       Do ik=1, kv3_ek, ndim_spinor
          iksnl = ( ik -1 )/ndim_spinor + 1
          eko_tmp( :,iksnl ) = eko_ek( :,ik )
       End do
       emin = minval(eko_tmp);   emax = maxval(eko_tmp)
       deallocate( eko_tmp )
    else
       emin = minval(eko_ek)
       emax = maxval(eko_ek)
    endif

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1

! --------------------------------------------
    occupied_ch_equals_totch : do

       if ( noncol ) then
          call get_tot_noncl()         
       else
         call get_tot()         
       endif

!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot


    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif

    if(iprioccup >= 2 .and. .not.metalic_system) then
       if(dabs(vbm) < 1.d6) then
          write(nfout,'( " The highest occupied band energy = ", f10.4)') vbm
       else
          write(nfout,'( " The highest occupied band energy is not calculated")')
       end if
    end if

    call tstatc0_end(id_sname)
  contains
    subroutine get_tot
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw
      tot = 0.d0
      do k = 1, kv3_ek, af+1
         do i = 1, neg
            e = eko_ek(i,k)
            call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight*wspin*kv3_ek*qwgt_ek(k)
            tot = tot + 2*totw
         end do
      end do
      tot = tot/kv3_ek * (af+1)
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount
    end subroutine get_tot

    subroutine get_tot_noncl
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw, wktmp

      tot = 0.d0
      wktmp = kv3_ek / ndim_spinor

      do k = 1, kv3_ek, ndim_spinor
         do i = 1, neg
            e = eko_ek(i,k)
            call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight *wspin *wktmp *qwgt_ek(k)
            tot = tot + totw
         end do
      end do
      tot = tot /wktmp
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount

    end subroutine get_tot_noncl

  end subroutine m_ESoc_fermi_dirac_ek
! ========================================================== 13.0E

  subroutine m_ESoc_check_if_metalic(nfout)
!
!    Modified by T. Yamasaki   April/27/2007
!
    integer, intent(in) :: nfout
    integer :: way_of_smearing

    if(ekmode == ON .or. &
         & (icond>=FIXED_CHARGE .and. ekmode==OFF .and. fixed_charge_k_parallel == ONE_BY_ONE)) then
       way_of_smearing = m_CtrlP_way_of_smearing()
       if(way_of_smearing == PARABOLIC) then
          call m_ESoc_fermi_parabolic_ek(nfout)  ! -> efermi, metalic_system
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
       else if(way_of_smearing == TETRAHEDRON) then
          call m_ESoc_fermi_tetra_ek(nfout)     ! -> efermi, metalic_system

! ============================ KT_add ===================== 13.0E
       else if(way_of_smearing == Fermi_Dirac) then
          call m_ESoc_fermi_dirac_ek(nfout)   
! ========================================================= 13.0E
       end if
    else
       way_of_smearing = m_CtrlP_way_of_smearing()
       if(way_of_smearing == PARABOLIC) then
          call m_ESoc_fermi_parabolic_3D(nfout)
!!$  else if(way_of_smearing == MP) then
!!$     call fermi_mesfessel_paxton(nfout)
       else if(way_of_smearing == TETRAHEDRON) then
          call m_ESoc_fermi_tetrahedron_3D(nfout)
       else if(way_of_smearing == COLD) then
          call m_ESoc_fermi_ColdSmearing_3D(nfout)


       end if
    end if

! ====================================== modified by K. Tagami ========== 11.0
!    call check_if_metalic(nfout,metalic_system)
    if ( noncol ) then
      call check_if_metalic_noncl(nfout,metalic_system)
    else
      call check_if_metalic(nfout,metalic_system)
    endif
! ====================================================================== 11.0

  end subroutine m_ESoc_check_if_metalic

  subroutine check_if_metalic(nfout,metalic)
    use m_Parallelization, only : mpi_kg_world
!
!     Modified by T. Yamasaki   May/08/2007
!
    integer, intent(in) :: nfout
    logical, intent(out) :: metalic
    integer :: ieig, ie, ik, ihob0, kv3_t, way_of_smearing, is
    real(kind=DP) :: totw, emax, cbm, vbm0, weight0
    real(kind=DP), allocatable, dimension(:) :: ehob
    real(kind=DP), allocatable, dimension(:,:) :: eko_t, eko_mpi     ! d(neg,kv3|kv3_ek)
    real(kind=DP), allocatable, dimension(:,:) :: occup_t, occup_mpi ! d(neg,kv3|kv3_ek)
    integer, allocatable, dimension(:) :: ihob ! d(kv3|kv3_ek)

    if(ekmode == ON) then
       kv3_t = kv3_ek
    else
       kv3_t = kv3
    end if

    allocate(eko_t(neg,kv3_t))

    if(ekmode == ON) then
       eko_t = eko_ek
    else
       eko_t = 0.d0
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             eko_t(ie,ik) = eko_l(map_z(ie),ik)
          end do
       end do
       if(npes > 1) then
          allocate(eko_mpi(neg,kv3_t))
          call mpi_allreduce(eko_t,eko_mpi,neg*kv3,mpi_double_precision &
               &               ,mpi_sum,mpi_kg_world,ierr)
          eko_t = eko_mpi
          call mpi_allreduce(eko_t,eko_mpi,neg*kv3,mpi_double_precision &
               &               ,mpi_sum,mpi_ge_world,ierr)
          eko_t = eko_mpi
          deallocate(eko_mpi)
       end if
    end if
          
    metalic = .false.

    allocate(ehob(kv3_t)); ehob = -999.d+20

    if(kv3_t/nspin >= 2) then
       allocate(ihob(kv3_t)); ihob = 0
       do is = 1, nspin
          do ik = is, kv3_t, nspin
             totw = 0.d0
             ihob(ik) = 0
             firstKpoint: do ieig = 1, neg
!!$                if(eko_t(ieig,is) < efermi) then
                if(eko_t(ieig,ik) < efermi) then
                   totw = totw + 1.d0
                   ihob(ik) = ihob(ik) + 1
                   if(ehob(ik) < eko_t(ieig,ik)) ehob(ik) = eko_t(ieig,ik)
                end if
             end do firstKpoint
             totw = totw*2.d0
             if(iprioccup >= 2) write(nfout,'(" ---  ik = ",i3," ihob = ",i6," totw = ",f12.4," totch = ",f12.4)') &
                  & ik,ihob(ik),totw,totch
          end do
          do ik = nspin+is ,kv3_t, nspin
             if(ihob(ik) /= ihob(is)) then
                metalic = .true.
                exit
             end if
          end do
       end do
       deallocate(ihob)
    else
       do is = 1, nspin
          totw = 0.d0
          do ieig=1,neg
             if(eko_t(ieig,is) < efermi) then
                if(ehob(is) < eko_t(ieig,is)) ehob(is) = eko_t(ieig,is)
             end if
          end do
       end do
    end if

    if(.not.metalic .and. ekmode == OFF) then
       allocate(occup_t(neg,kv3_t))

       occup_t = 0.d0
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             occup_t(ie,ik) = occup_l(map_z(ie),ik)
          end do
       end do
       if(npes > 1) then
          allocate(occup_mpi(neg,kv3_t))
          call mpi_allreduce(occup_t,occup_mpi,neg*kv3,mpi_double_precision &
               &               ,mpi_sum,mpi_kg_world,ierr)
          occup_t = occup_mpi
          call mpi_allreduce(occup_t,occup_mpi,neg*kv3,mpi_double_precision &
               &               ,mpi_sum,mpi_ge_world,ierr)
          occup_t = occup_mpi
          deallocate(occup_mpi)
       end if

       Kpoint2: do ik = 1 ,kv3_t
          ihob0 = 0; vbm0 = -999.d+20
          findvbm: do ieig=1, neg   ! finding Valence Band Maximum
             if(occup_t(ieig,ik) > DELTA10) then
                if(vbm0 < eko_t(ieig,ik)) then
                   vbm0 = eko_t(ieig,ik)
                   ihob0 = ieig
                end if
             end if
          end do findvbm
          weight0 = kv3*qwgt(ik)
          if(iprioccup >= 2) then
             write(nfout,'(" --- ihob0 = ",i8)') ik,ihob0
             if(ihob0 >= 1) write(nfout,'(" --- ik = ",i4," ihob0 = ",i8," vbm0, occup = "&
                  & ,2f10.5," weight0=",f8.4)') ik,ihob0,vbm0,occup_t(ihob0,ik),weight0
          end if
          if(ihob0 >= 1 .and. ihob0 <= neg) then
             if(occup_t(ihob0,ik) > DELTA10 .and. occup_t(ihob0,ik) < weight0-DELTA10) then
                metalic = .true.
                exit Kpoint2
             end if
          end if
       end do Kpoint2
       deallocate(occup_t)
    end if

    if(.not.metalic) then
       way_of_smearing = m_CtrlP_way_of_smearing()
       Kpoint: do ik=1,kv3_t
          findcbm: do ieig = 1, neg
             if(eko_t(ieig,ik) > efermi) then
                cbm = eko_t(ieig,ik)
                exit findcbm
             end if
          end do findcbm
          if((way_of_smearing==PARABOLIC .and. cbm < efermi + width/2) &
               & .or. (way_of_smearing==TETRAHEDRON .and. cbm < efermi+DELTA10) &
! ========== KT_add================================= 13.0E
               & .or. (way_of_smearing==Fermi_Dirac .and. cbm < efermi +width/2) &
! ================================================== 13.0E
               & .or. (way_of_smearing==COLD .and. cbm < efermi + width/2)) then

             metalic = .true.
             if(iprioccup >= 2) then
                write(nfout,'(" --- cbm = ",f8.4," ik = ",i8)') cbm,ik
             end if
             exit Kpoint
          end if
       end do Kpoint
    end if

    if(metalic) then
       if(iprioccup>=1) write(nfout,'(" --- The system is metalic ---")')
    else
       if(iprioccup>=1) write(nfout,'(" --- The system is insulating or semiconducting ---")')
       emax = maxval(ehob)
       if(iprioccup>=1) write(nfout,'(" --- The highest occupied band energy (=vbm) = ",f12.8)') emax
       vbm = emax
    end if

    check_if_metalic_flag = .true.

    deallocate(ehob)
    deallocate(eko_t)

  end subroutine check_if_metalic

! ======================================= added by K. Tagami ========= 11.0
  subroutine check_if_metalic_noncl( nfout, metalic )
!
!     Modified by T. Yamasaki   May/08/2007
!
    integer, intent(in) :: nfout
    logical, intent(out) :: metalic
    integer :: ieig, ie, ik, ihob0, kv3_t, way_of_smearing, is

    integer  :: iksnl, iktmp

    real(kind=DP) :: totw, emax, cbm, vbm0, weight0
    real(kind=DP), allocatable, dimension(:) :: ehob
    real(kind=DP), allocatable, dimension(:,:) :: eko_t, eko_mpi     ! d(neg,kv3|kv3_ek)
    real(kind=DP), allocatable, dimension(:,:) :: occup_t, occup_mpi ! d(neg,kv3|kv3_ek)
    integer, allocatable, dimension(:) :: ihob ! d(kv3|kv3_ek)

    if(ekmode == ON) then
       kv3_t = kv3_ek
    else
       kv3_t = kv3
    end if

    allocate(eko_t(neg,kv3_t/ndim_spinor));  eko_t = 0.0d0

    if(ekmode == ON) then
! -------------------------- ktDEBUG ---------------------- 20121025
!       eko_t = eko_ek
!
       Do ik=1, kv3_t, ndim_spinor
          iksnl = ( ik -1 ) /ndim_spinor + 1
          eko_t(:,iksnl) = eko_ek(:,ik)
       End do
! -------------------------- ktDEBUG ---------------------- 20121025
    else
       eko_t = 0.d0
       do ik = 1, kv3, ndim_spinor
          if(map_k(ik) /= myrank_k) cycle
 	  iksnl = ( ik -1 )/ndim_spinor + 1
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             eko_t(ie,iksnl) = eko_l(map_z(ie),ik)
          end do
       end do
       if(npes > 1) then
          allocate(eko_mpi(neg,kv3_t/ndim_spinor))
          call mpi_allreduce( eko_t, eko_mpi, neg*kv3/ndim_spinor, &	
	       &              mpi_double_precision, mpi_sum,mpi_comm_group, ierr )
          eko_t = eko_mpi
          deallocate(eko_mpi)
       end if
    end if
          
    metalic = .false.

    allocate(ehob(kv3_t/ndim_spinor)); ehob = -999.d+20

    if ( kv3_t/ndim_spinor >= 2 ) then
       allocate(ihob(kv3_t/ndim_spinor)); ihob = 0

       do is = 1, 1
          do ik = 1, kv3_t /ndim_spinor
             totw = 0.d0
             ihob(ik) = 0
             firstKpoint: do ieig = 1, neg
!!$                if(eko_t(ieig,is) < efermi) then
                if(eko_t(ieig,ik) < efermi) then
                   totw = totw + 1.d0
                   ihob(ik) = ihob(ik) + 1
                   if(ehob(ik) < eko_t(ieig,ik)) ehob(ik) = eko_t(ieig,ik)
                end if
             end do firstKpoint

             if(iprioccup >= 2) write(nfout,'(" ---  ik = ",i3," ihob = ",i6," totw = ",f12.4," totch = ",f12.4)') &
                  & ik,ihob(ik),totw,totch
          end do
          do ik = 1+is, kv3_t/ndim_spinor
             if(ihob(ik) /= ihob(is)) then
                metalic = .true.
                exit
             end if
          end do
       end do
       deallocate(ihob)
    else
       do is = 1, 1
          totw = 0.d0
          do ieig=1,neg
             if(eko_t(ieig,is) < efermi) then
                if(ehob(is) < eko_t(ieig,is)) ehob(is) = eko_t(ieig,is)
             end if
          end do
       end do
    end if

    if(.not.metalic .and. ekmode == OFF) then
       allocate(occup_t(neg,kv3_t/ndim_spinor))

       occup_t = 0.d0
       do ik = 1, kv3, ndim_spinor
          if(map_k(ik) /= myrank_k) cycle
	  iksnl = ( ik -1 )/ndim_spinor + 1
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             occup_t(ie,iksnl) = occup_l(map_z(ie),ik)
          end do
       end do
       if(npes > 1) then
          allocate(occup_mpi( neg, kv3_t/ndim_spinor ))
          call mpi_allreduce( occup_t, occup_mpi, neg*kv3/ndim_spinor, &
	       &              mpi_double_precision, mpi_sum,mpi_comm_group, ierr )
          occup_t = occup_mpi
          deallocate(occup_mpi)
       end if

       Kpoint2: do ik = 1 ,kv3_t /ndim_spinor
          ihob0 = 0; vbm0 = -999.d+20
          findvbm: do ieig=1, neg   ! finding Valence Band Maximum
             if(occup_t(ieig,ik) > DELTA10) then
                if(vbm0 < eko_t(ieig,ik)) then
                   vbm0 = eko_t(ieig,ik)
                   ihob0 = ieig
                end if
             end if
          end do findvbm

! -------------------------- ktDEBUG ---------------------- 20121027
!          weight0 = kv3 /ndim_spinor *qwgt(ik)
!
          iktmp = ndim_spinor*(ik-1) +1
          weight0 = kv3 /ndim_spinor *qwgt( iktmp )     
! -------------------------- ktDEBUG ---------------------- 20121027
!
          if(iprioccup >= 2) then
             write(nfout,'(" --- ihob0 = ",i8)') ik,ihob0
             if(ihob0 >= 1) write(nfout,'(" --- ik = ",i4," ihob0 = ",i8, &
	   &              " vbm0, occup = " ,2f10.5," weight0=",f8.4)') &
	   &                ndim_spinor *ik -1, ihob0, vbm0, &
	   &                occup_t(ihob0,ik), weight0
          end if
          if(ihob0 >= 1 .and. ihob0 <= neg) then
             if(occup_t(ihob0,ik) > DELTA10 .and. occup_t(ihob0,ik) < weight0-DELTA10) then
                metalic = .true.
                exit Kpoint2
             end if
          end if
       end do Kpoint2
       deallocate(occup_t)
    end if

    if(.not.metalic) then
       way_of_smearing = m_CtrlP_way_of_smearing()
       Kpoint: do ik= 1, kv3_t /ndim_spinor 
          findcbm: do ieig = 1, neg
             if(eko_t(ieig,ik) > efermi) then
                cbm = eko_t(ieig,ik)
                exit findcbm
             end if
          end do findcbm
          if((way_of_smearing==PARABOLIC .and. cbm < efermi + width/2) &
               & .or. (way_of_smearing==TETRAHEDRON .and. cbm < efermi+DELTA10) &
! =================== KT_add ================ 13.0E
               & .or. (way_of_smearing==Fermi_Dirac .and. cbm < efermi +width/2 ) &
! =========================================== 13.0E
               & .or. (way_of_smearing==COLD .and. cbm < efermi + width/2)) then

             metalic = .true.
             if(iprioccup >= 2) then
                write(nfout,'(" --- cbm = ",f8.4," ik = ",i8)') cbm, ndim_spinor *ik -1
             end if
             exit Kpoint
          end if
       end do Kpoint
    end if

    if(metalic) then
       if(iprioccup>=1) write(nfout,'(" --- The system is metalic ---")')
    else
       if(iprioccup>=1) write(nfout,'(" --- The system is insulating or semiconducting ---")')
       emax = maxval(ehob)
       if(iprioccup>=1) write(nfout,'(" --- The highest occupied band energy (=vbm) = ",f12.8)') emax
       vbm = emax
    end if

    check_if_metalic_flag = .true.

    deallocate(ehob)
    deallocate(eko_t)

  end subroutine check_if_metalic_noncl
!================================================================ 11.0


  subroutine m_ESoc_set_nEwindows_pc(nfout,nEwindows)
    integer, intent(in) :: nfout 
    integer, intent(out) :: nEwindows
    real(kind=DP) :: emin, emax, emin_rev, emax_rev, e0
    integer :: nvb_windows, ncb_windows, iw, ie, ik
    real(kind=DP),allocatable, dimension(:,:) :: eko_tmp

! ================================ modified by K. Tagami ============ 11.0
!    allocate(eko_tmp(neg,kv3)); eko_tmp = 0.d0
!    call find_emin_emax(emin,emax,eko_tmp)

    if ( noncol ) then
      allocate(eko_tmp(neg,kv3/ndim_spinor)); eko_tmp = 0.d0
      call find_emin_emax_noncl( emin,emax,eko_tmp )
    else
      allocate(eko_tmp(neg,kv3)); eko_tmp = 0.d0
      call find_emin_emax(emin,emax,eko_tmp)
    endif
! ================================================================== 11.0

    if(metalic_system)  e_origin = efermi
    if(.not.metalic_system) e_origin = vbm + 1.d-10
    if(ipri >= 1) then
       write(nfout,'(" !pc e_origin = ",f9.6," <<m_ESoc_set_nEwindows_pc>>")') e_origin
       write(nfout,'(" !pc emin, emax = ",2f9.6)') emin, emax
    end if

    emin_rev = emin - e_origin
    emax_rev = emax - e_origin
    if(partial_charge_Emin > emin_rev) emin_rev = partial_charge_Emin
    if(partial_charge_Emax < emax_rev) emax_rev = partial_charge_Emax

    e0 = 0.d0
    if(emax_rev < 0.0) e0 = emax_rev
    nvb_windows = (e0-emin_rev)/partial_charge_deltaE + 1
    if(nvb_windows < 0) nvb_windows = 0
    emin_rev = e0 - nvb_windows*partial_charge_deltaE

    e0 = 0.d0
    if(emin_rev > 0.0) e0 = emin_rev
    ncb_windows = (emax_rev - e0)/partial_charge_deltaE + 1
    if(ncb_windows < 0) ncb_windows = 0

    nEwindows_pc = nvb_windows + ncb_windows
    nEwindows = nEwindows_pc
    allocate(Ewindows_partial_charge(nEwindows_pc,2))
    Ewindows_partial_charge(1,1) = emin_rev + e_origin
    do iw = 2, nEwindows_pc
       Ewindows_partial_charge(iw,1) = Ewindows_partial_charge(iw-1,1) + partial_charge_deltaE
       Ewindows_partial_charge(iw-1,2) = Ewindows_partial_charge(iw,1)
    end do
    Ewindows_partial_charge(nEwindows_pc,2) = Ewindows_partial_charge(nEwindows_pc,1) + partial_charge_deltaE

    allocate(if_elec_state(nEwindows_pc)); if_elec_state = NO

    do iw = 1, nEwindows_pc
       emin = Ewindows_partial_charge(iw,1); emax = Ewindows_partial_charge(iw,2)

! ========================================== modified by K. Tagami ========== 11.0
!       Kloop: do ik = 1, kv3
!          do ie = 1, neg
!             if(emin < eko_tmp(ie,ik) .and. eko_tmp(ie,ik) < emax) then
!                if_elec_state(iw) = YES
!                exit Kloop
!             end if
!          end do
!       end do Kloop
!
       if ( noncol ) then
         Kloop: do ik = 1, kv3/ndim_spinor
            do ie = 1, neg
               if(emin < eko_tmp(ie,ik) .and. eko_tmp(ie,ik) < emax) then
                  if_elec_state(iw) = YES
                  exit Kloop
               end if
            end do
         end do Kloop
       else
         Kloop2: do ik = 1, kv3
            do ie = 1, neg
               if(emin < eko_tmp(ie,ik) .and. eko_tmp(ie,ik) < emax) then
                  if_elec_state(iw) = YES
                  exit Kloop2
               end if
            end do
         end do Kloop2
      endif
! =========================================================================== 11.0
    end do

    if(ipri >= 1) then
    nEwindows_pc = nvb_windows + ncb_windows
       write(nfout,'(" !pc nEwindows = ",i4,", nvb_windows = ",i4,", ncb_windows = ",i4 &
            & ," <<m_ESoc_set_nEwindows_pc>>")') nEwindows_pc, nvb_windows, ncb_windows
       write(nfout,'(" !pc",4x,"iw",2x,"if_elec_state",16x,"erange(hartree)",24x,"erange(eV)")')
       write(nfout,'(" !pc",29x,"(asis)",18x,"(shifted)",13x,"(shifted)")')
       do iw = 1, nEwindows_pc
          write(nfout,'(" !pc ",i5,7x,i1,7x,"(",2f10.6," )",1x,"(",2f10.6," )",1x,"(",2f10.6," )")') &
               &   iw, if_elec_state(iw) &
               & , Ewindows_partial_charge(iw,1),Ewindows_partial_charge(iw,2) &
               & , Ewindows_partial_charge(iw,1)-e_origin &
               & , Ewindows_partial_charge(iw,2)-e_origin &
               & , (Ewindows_partial_charge(iw,1)-e_origin)*HARTREE &
               & , (Ewindows_partial_charge(iw,2)-e_origin)*HARTREE
       end do
    end if

    deallocate(eko_tmp)

  end subroutine m_ESoc_set_nEwindows_pc

  subroutine find_emin_emax(emin,emax,eko_tmp)
     use m_Parallelization, only : mpi_kg_world
     real(kind=DP), intent(out) :: emin, emax
     real(kind=DP), intent(out), dimension(neg,kv3) :: eko_tmp

     integer :: ik, ie
     real(kind=DP),allocatable, dimension(:,:) :: temp_mpi ! MPI

     if(npes >=2 ) then
        allocate(temp_mpi(neg,kv3)); temp_mpi = 0.d0
        do ik = 1, kv3

          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             temp_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
          end do                                          ! MPI
        end do                                             ! MPI
        call mpi_allreduce(temp_mpi,eko_tmp,neg*kv3,mpi_double_precision &  ! MPI
             &            ,mpi_sum,mpi_kg_world,ierr)                     ! MPI
        temp_mpi = eko_tmp
        call mpi_allreduce(temp_mpi,eko_tmp,neg*kv3,mpi_double_precision &  ! MPI
             &            ,mpi_sum,mpi_ge_world,ierr)                     ! MPI
        deallocate(temp_mpi )
     else
        eko_tmp = eko_l
     end if
     emin = minval(eko_tmp)
     emax = maxval(eko_tmp)
  end subroutine find_emin_emax

! ======================================= added by K. Tagami ============== 11.0
  subroutine find_emin_emax_noncl( emin,emax,eko_tmp )
     real(kind=DP), intent(out) :: emin, emax
     real(kind=DP), intent(out), dimension(neg,kv3/ndim_spinor) :: eko_tmp

     integer :: ik, ie, iksnl
     real(kind=DP),allocatable, dimension(:,:) :: temp_mpi ! MPI

     if(npes >=2 ) then
        allocate(temp_mpi(neg,kv3/ndim_spinor)); temp_mpi = 0.d0

        do ik = 1, kv3, ndim_spinor
          if(map_k(ik) /= myrank_k) cycle               
	  iksnl = ( ik - 1 )/ndim_spinor + 1
          do ie = 1, neg                                
             if(map_e(ie) /= myrank_e) cycle            
             temp_mpi(ie,iksnl) = eko_l(map_z(ie),ik)      
          end do                                        
        end do                                          
        call mpi_allreduce( temp_mpi, eko_tmp, neg*kv3/ndim_spinor, &
	  &                 mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
        deallocate(temp_mpi )
     else
        do ik = 1, kv3, ndim_spinor
	  iksnl = ( ik -1 )/ndim_spinor + 1
          eko_tmp(:,iksnl) = eko_l(:,ik)
	end do
     end if
     emin = minval(eko_tmp);   emax = maxval(eko_tmp)
  end subroutine find_emin_emax_noncl
! ========================================================================= 11.0

  subroutine m_ESoc_keep_occup()
     integer :: ie, ik

     allocate(occup_tmp(np_e, ista_k:iend_k))
     do ik = ista_k, iend_k
        do ie = 1, np_e
           occup_tmp(ie,ik) = occup_l(ie,ik)
        end do
     end do
  end subroutine m_ESoc_keep_occup

  subroutine m_ESoc_retrieve_occup()
     integer :: ie, ik

     do ik = ista_k, iend_k
        do ie = 1, np_e
           occup_l(ie,ik) = occup_tmp(ie,ik)
        end do
     end do
     deallocate(occup_tmp)
  end subroutine m_ESoc_retrieve_occup

  subroutine m_ESoc_substitute_occup(nfout,iw)
    use m_Parallelization, only : mpi_kg_world
    integer, intent(in) :: nfout,iw

    integer :: ie, ik, ipripe0, is, i, iset, j, is0, ie0
    integer, parameter :: NCLMN = 8
    real(kind=DP) :: wspin = 1.d0, weight, emin, emax, e
    real(kind=DP), allocatable, dimension(:,:) :: occup_mpi, temp_mpi, eko_mpi

    emin = Ewindows_partial_charge(iw,1)
    emax = Ewindows_partial_charge(iw,2)

    do ik = ista_k, iend_k    ! MPI
       do ie = 1, np_e        ! MPI
          e = eko_l(ie,ik)
          if(e > emin .and. e < emax) then
             weight = 1.d0
          else
             weight = 0.d0
          end if
! =========================================== modified by K. Tagami =========== 11.0
!         occup_l(ie,ik) = weight*wspin*kv3*qwgt(ik)
!
          if ( noncol ) then
            occup_l(ie,ik) = weight *wspin *kv3/ndim_spinor *qwgt(ik)
          else
            occup_l(ie,ik) = weight *wspin *kv3 *qwgt(ik)
          endif
! ============================================================================ 11.0

       end do
    end do

    if(npes > 1) then
       if(mype == 0) ipripe0 = iprioccup
       call mpi_bcast(ipripe0, 1,mpi_integer,0,mpi_comm_group,ierr)
    else
       ipripe0 = iprioccup
    end if
       
    if(ipripe0 >=1 ) then
       allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
       if(npes >= 2) then
          allocate(temp_mpi(neg,kv3)); temp_mpi = 0.d0
          do ik = 1, kv3
             if(map_k(ik) /= myrank_k) cycle
             do ie = 1, neg
                if(map_e(ie) /= myrank_e) cycle
                temp_mpi(ie,ik) = occup_l(map_z(ie),ik)
             end do
          end do
          call mpi_allreduce(temp_mpi,occup_mpi,neg*kv3,mpi_double_precision &
               &            ,mpi_sum, mpi_kg_world, ierr)
          temp_mpi = occup_mpi
          call mpi_allreduce(temp_mpi,occup_mpi,neg*kv3,mpi_double_precision &
               &            ,mpi_sum, mpi_ge_world, ierr)
          deallocate(temp_mpi)
       else
          occup_mpi = occup_l
       end if

       allocate(eko_mpi(neg,kv3)); eko_mpi = 0.d0
       if(npes >= 2) then
          allocate(temp_mpi(neg,kv3)); temp_mpi = 0.d0
          do ik = 1, kv3
             if(map_k(ik) /= myrank_k) cycle
             do ie = 1, neg
                if(map_e(ie) /= myrank_e) cycle
                temp_mpi(ie,ik) = eko_l(map_z(ie),ik)
             end do
          end do
          call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &
               &            ,mpi_sum, mpi_kg_world, ierr)
          temp_mpi = eko_mpi
          call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &
               &            ,mpi_sum, mpi_ge_world, ierr)
          deallocate(temp_mpi)
       else
          eko_mpi = eko_l
       end if

    end if
    if(iprioccup >= 1) then
       write(nfout,'(" !pc iw = ",i5," <<m_ESoc_substitute_occup>>")') iw

! ======================================== modified by K. Tagami ========= 11.0
!       do ik = 1, kv3
       do ik = 1, kv3, ndim_spinor
! ======================================================================= 11.0

          is = neg+1; ie = 1-1
          Isloop: do i = 1, neg
             if(occup_mpi(i,ik) > 1.d-20) then
                is = i
                exit Isloop
             end if
          end do Isloop
          Ieloop: do i = neg, 1, -1
             if(occup_mpi(i,ik) > 1.d-20) then
                ie = i
                exit Ieloop
             end if
          end do Ieloop
          if(is > 0 .and. is <= neg .and. ie > 0 .and. ie <= neg .and. is <= ie) then
             iset = (ie-is+1+(NCLMN-1))/NCLMN
             is0 = is
             write(nfout,'(" !pc ( ik = ",i5," )")') ik
             do j = 1, iset
                ie0 = min(ie,is0+NCLMN-1)
                write(nfout,'(" !pc nband ",4x,8i10)') (i,i=is0,ie0)
                write(nfout,'(" !pc eko  ",5x,8f10.6)') (eko_mpi(i,ik),i=is0, ie0)
                write(nfout,'(" !pc eko(eV)",3x,8f10.6)') ((eko_mpi(i,ik)-e_origin)*HARTREE,i=is0, ie0)
                write(nfout,'(" !pc occup",5x,8f10.6)') (occup_mpi(i,ik),i=is0, ie0)
                is0 = is0 + NCLMN
             end do
          end if
       end do
    end if
    if(ipripe0 >=1 ) then
       deallocate(occup_mpi)
       deallocate(eko_mpi)
    end if
       
  end subroutine m_ESoc_substitute_occup

  subroutine m_ESoc_free_nEwindows()
    if(allocated(Ewindows_partial_charge)) deallocate(Ewindows_partial_charge)
    if(allocated(if_elec_state)) deallocate(if_elec_state)
  end subroutine m_ESoc_free_nEwindows

  integer function m_ESoc_if_elec_state(nfout,iw,emin,emax)
    integer, intent(in) :: nfout,iw
    real(kind=DP), intent(out) :: emin, emax

    if(iw < 0 .or. iw > nEwindows_pc) then
       write(nfout,'(" iw is out of the proper range. iw = ",i5," <<m_ESoc_if_elec_state>>")') iw
       m_ESoc_if_elec_state = NO
       return
    else
       emin = Ewindows_partial_charge(iw,1)
       emax = Ewindows_partial_charge(iw,2)
       m_ESoc_if_elec_state = if_elec_state(iw)
    end if
  end function m_ESoc_if_elec_state

  subroutine check_occupation(nfout,ispin,totch)
    integer, intent(in) :: nfout,ispin
    real(kind=DP),intent(in),dimension(*) :: totch
    integer  :: i
#ifdef _CHECK_OCCUPATION_STOP_
    integer :: ierror, errorcode
#endif

    if(mype==0) then
       do i =1, ispin
          if(dble(neg)-totch(i)*0.5d0 < 1.0) then
             if(iprioccup>=1) &
     &       write(nfout,'(" WARNING! neg may not be sufficient : &
     &    (neg = ",i8," ) - (totch(",i2,")*0.5 = ",f12.4,") < 1.0")') neg,i,totch(i)*0.5
          end if
       end do
    end if
#ifdef _CHECK_OCCUPATION_STOP_
    do i = 1, ispin
       if(dble(neg)-totch(i)*0.5d0 < 0.0) then
          if(iprioccup>=1) write(nfout,'(" STOP! neg is not sufficient : &
        & (neg = ",i8," ) - (totch(",i2,")*0.5 = ",f12.4,") < 0.0")') neg,i,totch(i)*0.5
          call mpi_abort(mpi_comm_group,errorcode,ierror)
          call mpi_finalize(ierror)
       end if
    end do
#endif
  end subroutine check_occupation

! =========================== added by K. Tagami ================= 11.0
  subroutine check_occupation_noncl( nfout, totch )
    integer, intent(in) :: nfout
    real(kind=DP),intent(in),dimension(*) :: totch
    integer  :: i
#ifdef _CHECK_OCCUPATION_STOP_
    integer :: ierror, errorcode
#endif

    if(mype==0) then
       do i =1, 1
          if(dble(neg)-totch(i) < 1.0) then
             if(iprioccup>=1) &
     &       write(nfout,'(" WARNING! neg may not be sufficient : &
     &    (neg = ",i8," ) - (totch(",i2,") = ",f12.4,") < 1.0")') neg,i,totch(i)
          end if
       end do
    end if
#ifdef _CHECK_OCCUPATION_STOP_
    do i = 1, 1
       if(dble(neg)-totch(i) < 0.0) then
          if(iprioccup>=1) write(nfout,'(" STOP! neg is not sufficient : &
        & (neg = ",i8," ) - (totch(",i2,") = ",f12.4,") < 0.0")') neg,i,totch(i)
          call mpi_abort(mpi_comm_group,errorcode,ierror)
          call mpi_finalize(ierror)
       end if
    end do
#endif
  end subroutine check_occupation_noncl
! ========================================================================= 11.0

  subroutine m_ESoc_occup_fix(nfout)
    integer, intent(in) :: nfout
    real(kind=DP),allocatable, dimension(:,:) :: eko_mpi  ! MPI
    real(kind=DP),allocatable, dimension(:) :: occup_mpi
    integer :: ik, ie, jcount, nb
    real(kind=DP) :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 10000
    integer, allocatable, dimension(:,:) :: n2_mpi  ! MPI
    real(DP),allocatable, dimension(:,:) :: e2_mpi  ! MPI

    allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
    allocate(occup_mpi(neg)); occup_mpi = 0.d0

    !  MPI Gather eko_l
    if(npes >= 2) then                                 ! MPI
       do ik = 1, kv3                                     ! MPI
          if(map_k(ik) /= myrank_k) cycle                 ! MPI
          do ie = 1, neg                                  ! MPI
             if(map_e(ie) /= myrank_e) cycle              ! MPI
             eko_mpi(ie,ik) = eko_l(map_z(ie),ik)        ! MPI
          end do                                          ! MPI
       end do                                             ! MPI
       call mpi_allreduce(MPI_IN_PLACE,eko_mpi,neg*kv3,mpi_double_precision &  ! MPI
            &            ,mpi_sum,mpi_comm_group,ierr)                     ! MPI
    else                                               ! MPI
       eko_mpi = eko_l                                 ! MPI
    end if                                             ! MPI

! =================================== modified by K. Tagami ============ 11.0
!    do ik = ista_k, iend_k
    do ik = ista_k, iend_k, ndim_spinor
! ====================================================================== 11.0

       emin = minval(eko_mpi(:,ik))
       emax = maxval(eko_mpi(:,ik))
       efermi = emax
       e1 = emin - dabs(DELTA_FermiSearchRange)
       e2 = emax + dabs(DELTA_FermiSearchRange)
       jcount = 1
       occupied_ch_equals_totch : do

! ================================== modiifed by K. tagami ============= 11.0
!          call get_occup_l_and_tot(efermi)       ! -(contained here) ->(occup_l,tot)
!
          if ( noncol ) then
            call get_occup_l_and_tot_noncl_fix(efermi)     
          else
            call get_occup_l_and_tot(efermi)     
          endif
! ======================================================================= 11.0

          if(jcount == 1 .and. tot < totch) &
               call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
          if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
          if( tot < totch) then
             e1 = efermi; efermi = efermi + (e2-efermi)/2
          else
             e2 = efermi; efermi = efermi + (e1-efermi)/2
          end if
          jcount = jcount + 1
          if(jcount > MAXITR) then
             stop ' jcount > MAXITR'
          end if
       end do occupied_ch_equals_totch
       do ie = 1, neg                             
          if(map_e(ie) == myrank_e) then          
             occup_l(map_z(ie),ik) = occup_mpi(ie)
          end if                                  
       end do
    end do

    allocate(n2_mpi(neg,kv3)); n2_mpi = 0.d0
    allocate(e2_mpi(neg,kv3)); e2_mpi = 0.d0
    do ik = 1, kv3                                     ! MPI
       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       do ie = 1, neg                                  ! MPI
          if(map_e(ie) /= myrank_e) cycle              ! MPI
          e2_mpi(ie,ik) = occup_l(map_z(ie),ik)         ! MPI
       end do                                          ! MPI
    end do                                             ! MPI
    if(npes >= 2) then
       call mpi_allreduce(MPI_IN_PLACE,e2_mpi,neg*kv3,mpi_double_precision &
            &                  ,mpi_sum,mpi_comm_group,ierr) ! MPI
    end if
    n2_mpi = 0                                          ! MPI
    do ik = 1, kv3                                     ! MPI
       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       n2_mpi(1:neg,ik) = neordr(1:neg,ik)              ! MPI
    end do! MPI

    if(npes >= 2) then
       call mpi_allreduce(MPI_IN_PLACE,n2_mpi,neg*kv3,mpi_integer,mpi_sum &
            &                      ,mpi_comm_group,ierr)  ! MPI
       n2_mpi = n2_mpi/nrank_e
    end if
    if(iprioccup>=1) then
       write(nfout,'(" ======  Occupations ====== (fix)")')
       
! =================================== modified by K. Tagami ========= 11.0
!       do ik = 1, kv3
!          call wd_k_points ! -(c.h.)
!          write(nfout,'(5f16.8)') (e2_mpi(n2_mpi(nb,ik),ik),nb = 1, neg)
!          !                                     =occup_l(neordr(nb,ik),ik)
!       end do
       if ( noncol ) then
         do ik = 1, kv3, ndim_spinor
            call wd_k_points_noncl
            write(nfout,'(5f16.8)') (e2_mpi(n2_mpi(nb,ik),ik),nb = 1, neg)
              !                                     =occup_l(neordr(nb,ik),ik)
         end do
       else
         do ik = 1, kv3
            call wd_k_points
            write(nfout,'(5f16.8)') (e2_mpi(n2_mpi(nb,ik),ik),nb = 1, neg)
              !                                     =occup_l(neordr(nb,ik),ik)
         end do
       endif
! ==================================================================== 11.0

    end if
    deallocate(e2_mpi)
    deallocate(eko_mpi,occup_mpi)
    deallocate(n2_mpi)
  contains
    subroutine wd_k_points
      if(nspin == 1) then
         write(nfout,'(i6,3f16.8)') ik,(vkxyz(ik,1:3,BUCS))
      else
         if(mod(ik,2) == 1) then
            write(nfout,'(i6,"    UP ",3f16.8)') ik,(vkxyz(ik,1:3,BUCS))
         else
            write(nfout,'(i6,"  DOWN ",3f16.8)') ik,(vkxyz(ik,1:3,BUCS))
         end if
      end if
    end subroutine wd_k_points

! =================================== added by K. Tagami =========== 11.0
    subroutine wd_k_points_noncl
      write(nfout,'(i6,3f16.8)') ik,(vkxyz(ik,1:3,BUCS))
    end subroutine wd_k_points_noncl
! ================================================================== 110

    subroutine get_occup_l_and_tot(efermi)
      real(kind=DP), intent(in) :: efermi
      integer       :: i
      real(kind=DP) :: wspin = 1.d0, e, weight,tmp
      tot = 0.d0

      do i = 1, neg
         e = eko_mpi(i,ik)
         if(e < efermi) then
            weight = 1.d0
         else
            weight = 0.d0
         end if
!!$         call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
         tmp = weight*wspin
         occup_mpi(i) = weight*wspin*qwgt(ik)*kv3
            !tot = tot + 2*occup_mpi(i,k)
         tot = tot + 2*tmp
      end do
      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot

! ================================ added by K. Tagami ================= 11.0
    subroutine get_occup_l_and_tot_noncl_fix(efermi)
      real(kind=DP), intent(in) :: efermi
      integer       :: i
      real(kind=DP) :: wspin = 1.d0, e, weight,tmp, wktmp, ctmp

      tot = 0.d0; wktmp = kv3 /ndim_spinor

      do i = 1, neg
         e = eko_mpi(i,ik)
         if(e < efermi) then
            weight = 1.d0
         else
            weight = 0.d0
         end if
         ctmp = weight *wspin
         occup_mpi(i) = weight *wspin *qwgt(ik) *wktmp
         tot = tot + tmp
      end do

      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot_noncl_fix
! ========================================================================= 11.0

  end subroutine m_ESoc_occup_fix

!$$#ifdef PARA3D

!===============================================================================

  subroutine m_ESoc_fermi_parabolic_3D(nfout)
!
!  An if-block of "if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then",
! which defines efermi_spin and occup_l with fixing total spin, is coded.
!                        by T. Yamasaki   April/10/2007
!
    use m_Parallelization,      only : mpi_kg_world, mpi_ke_world, neg_g
    use m_Electronic_Structure, only : nrvf_ordr


    integer, intent(in) :: nfout

    integer             :: jcount, ik, ie, is, lrank, iadd
    Real(kind=DP)       :: emin, emax, e1, e2, tot, totch_spin(2), totch_spin0(2)
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    real(kind=DP),allocatable, dimension(:,:) :: temp_mpi, eko_mpi, occup_mpi  ! MPI

    integer :: id_sname = -1, id_sname2 = -1

!   call tstatc0_begin('barrier(m_Eoc_fermi_parabolic) ',id_sname2)
!   if(npes > 1) call mpi_barrier(mpi_comm_group,ierr)
!   call tstatc0_end(id_sname2)
                                                  __TIMER_SUB_START(703)

    call tstatc0_begin('m_ESoc_fermi_parabolic_3D ', id_sname)

    call check_totch(nfout)           ! -(m_ES_occup) totch will be checked

! === DEBUG by tkato 2011/12/07 ================================================
! === Initialization with zero is necessary when af = 1 or nspin = 2! ==========
    allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
    allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0
! ==============================================================================

    !  MPI Gather eko_l
    if(npes > 1) then
!       if(nrank_k > 1) then
          allocate(temp_mpi (neg,kv3)); temp_mpi = 0.d0
                                                  __TIMER_DO_START(800)
          do ik = 1, kv3
             if(map_k(ik) /= myrank_k) cycle
!            do ie = 1, neg
!               if(map_e(ie) /= myrank_e) cycle
!               temp_mpi(ie,ik) = eko_l(map_z(ie),ik)
!            end do
             do ie = 1, np_e
                temp_mpi(ista_e-1+ie,ik) = eko_l(ie,ik)
             end do
          end do
                                                  __TIMER_DO_STOP(800)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,801)
          call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &  ! MPI
         &                   ,mpi_sum,mpi_kg_world,ierr)                     ! MPI
! ==== DEBUG by tkato 2012/04/04 ===============================================
          temp_mpi = eko_mpi
          call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision & ! MPI
         &                   ,mpi_sum,mpi_ge_world,ierr)                     ! MPI
! ==============================================================================
                                                  __TIMER_COMM_STOP(801)
          deallocate(temp_mpi )
!       else 
!          allocate(temp_mpi(mp_e*kv3,0:nrank_e-1))                        ! MPI
!                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,802)
!          call mpi_allgather(eko_l, np_e*kv3, mpi_double_precision &
!         &                 , temp_mpi,  mp_e*kv3, mpi_double_precision, mpi_kg_world, ierr)
!                                                  __TIMER_COMM_STOP(802)
!                                                  __TIMER_DO_START(803)
!          do lrank = 0, nrank_e-1
!             do ik = 1, kv3
!                iadd = nel_e(lrank)*(ik-1)-nis_e(lrank)+1
!                do is = nis_e(lrank), nie_e(lrank)
!                   eko_mpi(is,ik) = temp_mpi(iadd+is,lrank)
!                end do
!             end do
!          end do
!                                                  __TIMER_DO_STOP(803)
!          deallocate(temp_mpi)
!       end if
    else
       eko_mpi = eko_l
    end if

    emin = minval(eko_mpi)
    emax = maxval(eko_mpi)

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)
    
    jcount = 1
    occupied_ch_equals_totch : do

       call get_occup_l_and_tot(1,1,efermi)      ! -(contained here) ->(occup_l,tot)
!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( "== Parabolic Broadening Method ==")')
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot
    call get_entropic_term(band_entropy)
    if(iprioccup >= 2) &
         &write(nfout,'( " band_entropy = ", f20.14)') band_entropy

    if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then
       if(total_spin > totch) then
          write(nfout,'( " !WARNING total_spin should be smaller than totch <<m_ESoc_fermi_parabolic>>")')

          totch_spin(1) = totch
          totch_spin(2) = totch
       else
          totch_spin(1) = (totch + total_spin)*1.0d0
          totch_spin(2) = (totch - total_spin)*1.0d0
       end if

       do is = 1, nspin
          emin = minval(eko_mpi)
          emax = maxval(eko_mpi)

          efermi_spin(is) = emax
          e1 = emin - dabs(DELTA_FermiSearchRange)
          e2 = emax + dabs(DELTA_FermiSearchRange)
    
          jcount = 1
          occupied_ch_equals_totch2 : do

             call get_occup_l_and_tot(nspin,is,efermi_spin(is))     ! -(contained here) ->(occup_l,tot)
             !    ~~~~~~~~~~~~~~~~~~~
             if(jcount == 1 .and. tot < totch_spin(is)) &
                  call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
             if(dabs(tot - totch_spin(is)) < DELTA_TOTCH) exit occupied_ch_equals_totch2
             if( tot < totch_spin(is)) then
                e1 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e2)/2
             else
                e2 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e1)/2
             end if
             jcount = jcount + 1
             if(jcount > MAXITR) then
                call wd_fermi_error2 &   !-(b_Fermi)
                     & (nfout,e1,e2,efermi_spin(is),emin,emax,tot,totch_spin(is),neg,MAXITR)
             end if
          end do occupied_ch_equals_totch2
          if(iprioccup >= 2) &
               &write(nfout,'( "== Parabolic Broadening Method ==")')
          if(iprioccup >= 2) &
               &write(nfout,'( " efermi_spin(",i2," ) = ", f10.4, ", tot/2 = ", f10.4)') &
               & is,efermi_spin(is), tot/2.0
       end do
       call get_total_spin0
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) &
            & call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
       efermi = (efermi_spin(1)+efermi_spin(2))*0.5d0
    else if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
       call get_total_spin0
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
    end if

!   do ik = ista_k, iend_k                              ! MPI
!      do ie = 1, neg                                   ! MPI
!         if(map_e(ie) == myrank_e) then                ! MPI
!            occup_l(map_z(ie),ik) = occup_mpi(ie,ik)   ! MPI
!         end if                                        ! MPI
!      end do                                           ! MPI
!   end do                                              ! MPI
    do ik = ista_k, iend_k                              ! MPI
!      do ie = 1, np_e                                  ! MPI
!         occup_l(ie,ik) = occup_mpi(neg_g(ie),ik)      ! MPI
       do ie = 1, np_e                                  ! MPI
          occup_l(ie,ik) = occup_mpi(ista_e-1+ie,ik)    ! MPI
       end do                                           ! MPI
    end do                                              ! MPI

    deallocate(eko_mpi  )
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(703)
  contains
    subroutine get_total_spin0
                                                  __TIMER_SUB_START(708)
      do is = 1, nspin
         call get_occup_l_and_tot(nspin,is,efermi)
         totch_spin0(is) = tot
      end do
      total_spin0 = totch_spin0(1) - totch_spin0(2)
      if(iprioccup >= 1) then
         if(sw_fix_total_spin == YES ) then
            call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
         else
            call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
         end if
      end if
                                                  __TIMER_SUB_STOP(708)
    end subroutine get_total_spin0

    subroutine get_occup_l_and_tot(nspin,is,efermi)
      integer, intent(in) :: nspin, is
      real(kind=DP), intent(in) :: efermi
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight
                                                  __TIMER_SUB_START(704)
      tot = 0.d0
                                                  __TIMER_SUB_START(705)
                                                  __TIMER_SUB_STOP(705)

                                                  __TIMER_DO_START(804)
      do k = is, kv3, max(nspin,af+1)
         do i = 1, neg
            e = eko_mpi(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            occup_mpi(i,k) = weight*wspin*kv3*qwgt(k)
            tot = tot + 2*occup_mpi(i,k)
         end do
      end do
                                                  __TIMER_DO_STOP(804)
      if(af == 1) then
         tot = tot/kv3 * (af+1)
      else
         tot = tot/(kv3/nspin)
      end if
      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
                                                  __TIMER_SUB_STOP(704)
    end subroutine get_occup_l_and_tot


    subroutine get_entropic_term(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i
      real(kind=DP) :: e, entropy
                                                  __TIMER_SUB_START(706)
      s = 0.d0
                                                  __TIMER_DO_START(805)
      do k = 1, kv3, af+1
         do i = 1, neg
            e = eko_mpi(i,k)
            call get_entropy(e,efermi,width,entropy)
            s = s + 2.d0*entropy*qwgt(k)
         end do
      end do
                                                  __TIMER_DO_STOP(805)
      s = s * (af+1)
                                                  __TIMER_SUB_STOP(706)
    end subroutine get_entropic_term

    subroutine get_entropy(e,efermi,width,entropy)
      real(kind=DP), intent(in) :: e,efermi,width
      real(kind=DP), intent(out) :: entropy

      real(kind=DP) :: xi,xj,xx
      real(kind=DP), parameter :: d16 = 1.d0/16.d0
      real(kind=DP), parameter :: d6 = 1.d0/6.d0
      real(kind=DP), parameter :: sd24 = 7.d0/24.d0
                                                  __TIMER_SUB_START(707)
      xi = (efermi-e)/width

      if(xi < -2.d0) then
         entropy = 0.d0
      else if(xi < -1.d0) then
         xj = xi+2.d0
         xx = xj*xj
         entropy = -xx**2*d16+xx*xj*d6
      else if(xi < 1.d0) then
         xx = 0.25d0*xi*xi
         entropy = -xx*(1.d0-xx) + sd24
      else if(xi < 2.d0) then
         xj = xi-2.d0
         xx = xj*xj
         entropy = -xx**2*d16-xx*xj*d6
      else
         entropy = 0.d0
      end if
                                                  __TIMER_SUB_STOP(707)
    end subroutine get_entropy

  end subroutine m_ESoc_fermi_parabolic_3D

!===============================================================================
  subroutine m_ESoc_fermi_tetrahedron_3D(nfout)
! tetra hedron method (Dr.Hamada-san's code)
!                        by Tsuyoshi Miyazaki '94.8.9
!
!  An if-block of "if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then",
! which defines efermi_spin and occup_l with fixing total spin, is coded.
!                        by T. Yamasaki   April/10/2007
!
    use m_Parallelization,      only : mpi_kg_world, mpi_ke_world 

    integer, intent(in) :: nfout
#ifndef NO_TETRAHEDRON
    !!$integer, parameter       :: idim = 3
    integer        :: neig,nengy,ispin,ip2,ik,ieig,ikee,nxx,nyy,nzz, ip, ip_mpi
    real(kind=DP)  :: efermi2,eval,totind
    real(kind=DP), pointer, dimension(:,:,:) :: eig2,occup2,eig2_mpi,occup2_mpi
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,cdos,cind,valud
    real(kind=DP) :: totch_spin(2), totch_spin0(2)
    integer             :: id_sname = -1
                                                  __TIMER_SUB_START(709)
    call tstatc0_begin('m_ESoc_fermi_tetrahedron_3D ', id_sname)

    allocate(eig2(np2,neg,nspin)); eig2 = 0.d0
    allocate(eig2_mpi(np2,neg,nspin)); eig2_mpi = 0.d0     ! MPI
    allocate(occup2(neg,np2,nspin)); occup2 = 0.d0
    allocate(occup2_mpi(neg,np2,nspin)); occup2_mpi = 0.d0 ! MPI
    allocate(eawk(np0)); eawk = 0.d0
    allocate(cdwk(np0)); cdwk = 0.d0
    allocate(cswk(np0)); cswk = 0.d0
    allocate(cdos(np2*neg)); cdos = 0.d0
    allocate(cind(np2*neg)); cind = 0.d0
    allocate(valud(nspin)); valud = 0.d0

    call check_totch(nfout)           ! totch will be checked

    nxx = nxyz_tetra(1)
    nyy = nxyz_tetra(2)
    nzz = nxyz_tetra(3)
    neig=neg
    nengy=0
                                                  __TIMER_DO_START(806)
    do ispin=1,nspin
       do ip2=1,np2
          ik=nspin*(ip2-1)+ispin
          if(map_k(ik) /= myrank_k) cycle               ! MPI
          do ieig=1,neig
! === DEBUG by tkato 2011/10/05 ================================================
!            ip = neordr(ieig,ik)
!            if(map_e(ip) == myrank_e) then             ! MPI
!               eig2(ip2,ieig,ispin)=eko_l(map_z(ip),ik)! MPI
             if(map_e(ieig) == myrank_e) then             ! MPI
                eig2(ip2,ieig,ispin)=eko_l(map_z(ieig),ik)! MPI
! ==============================================================================
             end if
          enddo
       enddo
    enddo
                                                  __TIMER_DO_STOP(806)

                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,807)
    call mpi_allreduce(eig2,eig2_mpi,np2*neg*nspin,mpi_double_precision,mpi_sum,mpi_kg_world,ierr) ! MPI
! ==== DEBUG by tkato 2012/12/19 ===============================================
    eig2 = eig2_mpi
    call mpi_allreduce(eig2,eig2_mpi,np2*neg*nspin,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
! ==============================================================================
                                                  __TIMER_COMM_STOP(807)
    eig2 = eig2_mpi                                   ! MPI

    if(iprioccup>=2 ) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration ==='

    if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then
       if(total_spin > totch) then
          write(nfout,'( " !WARNING total_spin should be smaller than totch <<m_ESoc_fermi_tetrahedron>>")')

          totch_spin(1) = totch
          totch_spin(2) = totch
       else
          totch_spin(1) = (totch + total_spin)*1.0d0
          totch_spin(2) = (totch - total_spin)*1.0d0
       end if
       
       do ispin = 1, nspin
          efermi2 = (minval(eig2(:,:,ispin))+maxval(eig2(:,:,ispin)))*0.5d0

          call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,1, &
               &  eig2(1,1,ispin),ip20,np0,totch_spin(ispin), efermi2,eval,valud, &
               &  iwt,ip2cub,iprioccup )    ! -> efermi_spin
          efermi_spin(ispin) = efermi2
       end do
! --> T. Yamasaki 06th Aug. 2009
       efermi2 = efermi
       call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
            &  eig2,ip20,np0,totch, efermi2,eval,valud, &
            &  iwt,ip2cub,iprioccup)
       if(iprioccup >=2 ) write(nfout,*) 'eval=',eval
       efermi = efermi2
       do ispin=1, nspin
          call nstt3i(idimtetra,nengy,efermi,nxx,nyy,nzz, &
               &  np2,np2,neig,eig2(1,1,ispin), &
               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra )
          totind=0.d0
                                                  __TIMER_DO_START(808)
          do ip2=1,np2
             do ieig=1,neig
                ikee=ip2+np2*(ieig-1)
                ik=nspin*(ip2-1)+ispin
                if(map_k(ik) == myrank_k) then            ! MPI
                   ip_mpi = neordr(ieig,ik)
                   if(map_e(ip_mpi) == myrank_e) &        ! MPI
                        & occup2(ip_mpi,ip2,ispin)=cind(ikee)*dble(np2) ! MPI
                end if
                totind=totind+cind(ikee)
             enddo
          enddo
                                                  __TIMER_DO_STOP(808)
          totch_spin0(ispin)= totind
       end do
       total_spin0 = totch_spin0(1) - totch_spin0(2)
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) &
            & call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
       efermi = (efermi_spin(1)+efermi_spin(2))*0.5d0
       if(iprioccup>=2) &
            & write(nfout,'(" ! efermi_spin(1:2) = ",2f16.8," efermi = ",f16.8)') efermi_spin(1:2),efermi
    else
! modified by H.Sawada on May 2, 1997
       efermi2 = efermi
! modified by H.Sawada on May 2, 1997
       call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
            &  eig2,ip20,np0,totch, efermi2,eval,valud, &
            &  iwt,ip2cub,iprioccup)
       if(iprioccup >=2 ) write(nfout,*) 'eval=',eval
       efermi = efermi2
       efermi_spin(1) = efermi2
       if(nspin == 2) efermi_spin(2) = efermi2
    end if

    do ispin=1,nspin
      call nstt3i(idimtetra,nengy,efermi_spin(ispin),nxx,nyy,nzz, &
               &  np2,np2,neig,eig2(1,1,ispin), &
               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra )

      totind=0.d0
                                                  __TIMER_DO_START(809)
      do ip2=1,np2
         do ieig=1,neig
            ikee=ip2+np2*(ieig-1)
            ik=nspin*(ip2-1)+ispin
            if(map_k(ik) == myrank_k) then
               ip_mpi = neordr(ieig,ik)
               if(map_e(ip_mpi) == myrank_e) &
                    & occup2(ip_mpi,ip2,ispin)=cind(ikee)*dble(np2)
            end if
            totind=totind+cind(ikee)
         enddo
      enddo
                                                  __TIMER_DO_STOP(809)
      if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2)  totch_spin0(ispin) = totind
      if(iprioccup>=2) write(nfout,'(" for spin=",i1," ** TOTAL CHARGE after fermi1 = ",f12.4)') ispin,totind
    enddo
! === DEBUG by tkato 2011/10/05 ================================================
    call mpi_allreduce(occup2,occup2_mpi,neg*np2*nspin,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
    occup2 = occup2_mpi
! ==============================================================================
    if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
       total_spin0 = totch_spin0(1) - totch_spin0(2)
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
    end if

                                                  __TIMER_DO_START(810)
    do ieig = 1, neg
       if(map_e(ieig) /= myrank_e) cycle
       do ispin=1,nspin
          do ip2=1,np2
             ik=nspin*(ip2-1)+ispin
             if(map_k(ik) == myrank_k) then
! === DEBUG by tkato 2011/10/05 ================================================
!               occup_l(map_z(ieig),ik)=occup2(ieig,ip2,ispin) ! MPI
                occup_l(map_z(ieig),ik)=occup2(neordr(ieig,ik),ip2,ispin) ! MPI
! ==============================================================================
             end if
          enddo
       enddo
    enddo
                                                  __TIMER_DO_STOP(810)
    deallocate(valud); deallocate(cind); deallocate(cdos); deallocate(cswk)
    deallocate(cdwk);  deallocate(eawk); deallocate(occup2_mpi); deallocate(occup2)
    deallocate(eig2_mpi); deallocate(eig2)
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(709)
#endif
  end subroutine m_ESoc_fermi_tetrahedron_3D

!===============================================================================
  subroutine m_ESoc_fermi_ColdSmearing_3D(nfout)
!
!  An if-block of "if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then",
! which defines efermi_spin and occup_l with fixing total spin, is coded.
!                        by T. Yamasaki   April/10/2007
!
    use m_Parallelization,      only : mpi_kg_world, mpi_ke_world 

    integer, intent(in) :: nfout

    integer             :: jcount, ik, ie, is
    real(kind=DP)       :: emin, emax, e1, e2, tot, totch_spin(2), totch_spin0(2)
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    real(kind=DP),allocatable, dimension(:,:) :: temp_mpi, eko_mpi, occup_mpi  ! MPI

    integer :: id_sname = -1, id_sname2 = -1
                                                  __TIMER_SUB_START(715)
    call tstatc0_begin('barrier(m_Eoc_fermi_ColdSmearing) ',id_sname2)
    if(npes > 1) call mpi_barrier(mpi_comm_group,ierr)
    call tstatc0_end(id_sname2)

    call tstatc0_begin('m_ESoc_fermi_ColdSmearing_3D ', id_sname)

    call check_totch(nfout)           ! -(m_ES_occup) totch will be checked

    allocate(eko_mpi  (neg,kv3)); eko_mpi = 0.d0
    allocate(occup_mpi(neg,kv3)); occup_mpi = 0.d0

    !  MPI Gather eko_l
    if(nrank_e >= 2) then
                                                  __TIMER_DO_START(821)
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             if(map_e(ie) /= myrank_e) cycle
             eko_mpi(ie,ik) = eko_l(map_z(ie),ik)
          end do
       end do
                                                  __TIMER_DO_STOP(821)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,821)
       call mpi_allreduce(MPI_IN_PLACE,eko_mpi,neg*kv3,mpi_double_precision &
            &            ,mpi_sum,mpi_kg_world,ierr)
                                                  __TIMER_COMM_STOP(821)
    else
       eko_mpi = eko_l
    end if
! ==== DEBUG by tkato 2012/12/19 ===============================================
    if(nrank_k >= 2) then
       allocate(temp_mpi(neg,kv3)); temp_mpi = 0.0d0
       temp_mpi = eko_mpi
       call mpi_allreduce(temp_mpi,eko_mpi,neg*kv3,mpi_double_precision &
                         ,mpi_sum,mpi_ge_world,ierr)
       deallocate(temp_mpi)
    end if
! ==============================================================================

    emin = minval(eko_mpi)
    emax = maxval(eko_mpi)

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

       call get_occup_l_and_tot(1,1,efermi)       ! -(contained here) ->(occup_l,tot)
!          ~~~~~~~~~~~~~~~~~~~~
       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( "== Cold Smearing Method ==")')
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot

    call get_entropic_term(band_entropy)
    if(iprioccup >= 2) &
         &write(nfout,'( " band_entropy = ", f20.14)') band_entropy


    if(imag == FERRO .and. sw_fix_total_spin == YES .and. nspin == 2) then
       if(total_spin > totch) then
          write(nfout,'( " !WARNING total_spin should be smaller than totch <<m_ESoc_fermi_parabolic>>")')

          totch_spin(1) = totch
          totch_spin(2) = totch
       else
          totch_spin(1) = (totch + total_spin)*1.0d0
          totch_spin(2) = (totch - total_spin)*1.0d0
       end if
                                                  __TIMER_DO_START(823)
       do is = 1, nspin
          emin = minval(eko_mpi)
          emax = maxval(eko_mpi)

          efermi_spin(is) = emax
          e1 = emin - dabs(DELTA_FermiSearchRange)
          e2 = emax + dabs(DELTA_FermiSearchRange)
    
          jcount = 1
          occupied_ch_equals_totch2 : do

             call get_occup_l_and_tot(nspin,is,efermi_spin(is))      ! -(contained here) ->(occup_l,tot)
!                ~~~~~~~~~~~~~~~~~~~~
             if(jcount == 1 .and. tot < totch_spin(is)) &
                  call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
             if(dabs(tot - totch_spin(is)) < DELTA_TOTCH) exit occupied_ch_equals_totch2
             if( tot < totch_spin(is)) then
                e1 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e2)*0.5d0
             else
                e2 = efermi_spin(is); efermi_spin(is) = (efermi_spin(is) + e1)*0.5d0
             end if
             jcount = jcount + 1
             if(jcount > MAXITR) then
                call wd_fermi_error2 &   !-(b_Fermi)
                     & (nfout,e1,e2,efermi_spin(is),emin,emax,tot,totch_spin(is),neg,MAXITR)
             end if
          end do occupied_ch_equals_totch2
          if(iprioccup >= 2) &
               &write(nfout,'( "== Cold smearing Method ==")')
          if(iprioccup >= 2) &
               &write(nfout,'( " efermi_spin(",i2," ) = ", f10.4, ", tot/2 = ", f10.4)') &
               & is,efermi_spin(is), tot/2
       end do
                                                  __TIMER_DO_STOP(823)
       call get_total_spin0
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) &
            & call wd_efermi_and_total_spin0_Plus(nfout,total_spin0,totch_spin0,totch_spin)
       efermi = (efermi_spin(1)+efermi_spin(2))*0.5d0
    else if(imag == FERRO .and. sw_fix_total_spin == NO .and. nspin == 2) then
       call get_total_spin0
       if(iprioccup >= PRINTOUTLEVEL_TOTCH_SPIN) call wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
    end if

                                                  __TIMER_DO_START(824)
    do ik = ista_k, iend_k
       do ie = 1, neg
          if(map_e(ie) == myrank_e) then
             occup_l(map_z(ie),ik) = occup_mpi(ie,ik)
          end if
       end do
    end do
                                                  __TIMER_DO_STOP(824)

    deallocate(eko_mpi  )
    deallocate(occup_mpi)

    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(715)
  contains
    subroutine get_total_spin0
      do is = 1, nspin
         call get_occup_l_and_tot(nspin,is,efermi)
         totch_spin0(is) = tot
      end do
      total_spin0 = totch_spin0(1) - totch_spin0(2)
    end subroutine get_total_spin0

    subroutine get_occup_l_and_tot(nspin,is,efermi)
      integer, intent(in) :: nspin, is
      real(kind=DP), intent(in) :: efermi
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight
      tot = 0.d0

      do k = is, kv3, max(nspin,af+1)   !$      do k = 1, kv3, af+1
         do i = 1, neg
            e = eko_mpi(i,k)
            call coldsmearing(e,efermi,width,dos,weight)
            occup_mpi(i,k) = weight*wspin*kv3*qwgt(k)
            tot = tot + 2*occup_mpi(i,k)
         end do
      end do
      if(af == 1) then
         tot = tot/kv3 * (af+1)
      else
         tot = tot/(kv3/nspin)
      end if
      if(ipri >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12)') efermi,tot
    end subroutine get_occup_l_and_tot

    subroutine coldsmearing(e,efermi,width,dos,weight)
      real(kind=DP), intent(in) :: e,efermi,width
      real(kind=DP), intent(out) :: dos,weight

      real(kind=DP) :: xi,xx,xf,ex
      real(kind=DP), parameter :: msq2 = -1.4142135623730950488d0 ! -sqrt(2)
      real(kind=DP), parameter :: msq2i = -0.7071067811865475244d0  ! -1/sqrt(2)
      real(kind=DP), parameter :: sqpii = 0.56418958354775628695d0 ! 1/sqrt(pi)
      real(kind=DP), parameter :: sq2pii = 0.39894228040143267794d0 ! 1/sqrt(2pi)

      real(kind=DP) :: derfc

      xi = (efermi-e)/width
      xx = xi+msq2i
      ex = exp(-xx*xx)
      xf = (2.d0+msq2*xi)

      dos = sqpii*ex*xf/width
      weight = sq2pii*ex+0.5d0*derfc(-xx)

    end subroutine coldsmearing

    subroutine get_entropic_term(s)
      real(kind=DP), intent(out) :: s

      integer       :: k, i
      real(kind=DP) :: e, entropy
      s = 0.d0
      do k = 1, kv3, af+1
         do i = 1, neg
            e = eko_mpi(i,k)
            call get_entropy(e,efermi,width,entropy)
            s = s + 2.d0*entropy*qwgt(k)
         end do
      end do
      s = s * (af+1)
    end subroutine get_entropic_term

    subroutine get_entropy(e,efermi,width,entropy)
      real(kind=DP), intent(in) :: e,efermi,width
      real(kind=DP), intent(out) :: entropy

      real(kind=DP) :: xi,xx,xf,ex
      real(kind=DP), parameter :: msq2 = -1.4142135623730950488d0 ! -sqrt(2)
      real(kind=DP), parameter :: msq2i = -0.7071067811865475244d0  ! -1/sqrt(2)
      real(kind=DP), parameter :: sqpi2i = 0.28209479177387814347d0 ! 1/(2*sqrt(pi))

      xi = (efermi-e)/width
      xx = xi+msq2i
      ex = exp(-xx*xx)
      xf = (1.d0+msq2*xi)

      entropy = sqpi2i*ex*xf

    end subroutine get_entropy

  end subroutine m_ESoc_fermi_ColdSmearing_3D
!===============================================================================
!$$#endif

! ==================== KT_add ============================ 13.0E
! ======================================================== 13.0E

  subroutine m_ES_rd_occ_ext(nfout)
    integer, intent(in) :: nfout
    integer :: f_getIntValue,f_selectBlock, f_selectParentBlock,f_getRealValue
    integer :: iret
    if(f_selectBlock('accuracy')==0)then
       if(f_getIntValue(tag_sw_manual_occupation,iret)==0)then
          sw_manual_occupation = iret
       endif
       if(sw_manual_occupation==ON)then
          call set_external_occupation()
       endif
       iret = f_selectParentBlock()
    endif
  contains
    subroutine set_external_occupation()
      integer :: f_selectFirstTableLine, f_selectNextTableLine,f_getRealValue
      integer :: iocc,io,iret
      real(kind=DP) :: dret
      if(f_selectBlock(tag_occupation)==0)then
         iocc = 1
         do 
           if(iocc==1)then  
              if(f_selectFirstTableLine() /= 0 ) then
                 exit
              endif
           else
              if(f_selectNextTableLine() /= 0 )then
                 exit
              endif
           endif
           iocc = iocc+1
         enddo
         iocc = iocc-1
         allocate(occ_ext(iocc,nspin));occ_ext=0.d0
         allocate(band_index(neg));band_index=0
         iret = f_selectFirstTableLine()
         do io=1,iocc
            if(f_getIntValue(tag_band_index,iret)==0) band_index(iret) = io
            if(f_getRealValue(tag_occ,dret,'')==0) occ_ext(io,1) = dret
            if(f_getRealValue(tag_occ_up,dret,'')==0) occ_ext(io,1) = dret
            if(nspin>1)then
               if(f_getRealValue(tag_occ_down,dret,'')==0) occ_ext(io,2) = dret
            endif
            iret = f_selectNextTableLine()
         enddo
         if(printable.and.sw_manual_occupation==ON)then
            write(nfout,'(a)') ' !** manual occupation given in the input'
            do io=1,neg
               if(band_index(io)<1) cycle
               if(nspin==1) then
               write(nfout,'(a,i8,a,f10.5)') ' !** band : ',io,' occ : ',occ_ext(band_index(io),1)
               else
               write(nfout,'(a,i8,a,f10.5,a,f10.5)') ' !** band : ',io,' occ (up) : ', &
            &          occ_ext(band_index(io),1),' occ (down) : ',occ_ext(band_index(io),2)
               endif
            enddo
         endif
         iret = f_selectParentBlock()
      endif
    end subroutine set_external_occupation
  end subroutine m_ES_rd_occ_ext

  subroutine wd_efermi_and_total_spin0(nfout,total_spin0,totch_spin0)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: total_spin0, totch_spin0(2)
    write(nfout,'(" == efermi = ",f10.4, ", total_spin0 = ",f12.6, ", totch_spin0(1:2) = ",2f12.6)') &
         & efermi, total_spin0, totch_spin0(1:2)
  end subroutine wd_efermi_and_total_spin0

  subroutine wd_efermi_and_total_spin0_plus(nfout,total_spin0,totch_spin0,totch_spin)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: total_spin0, totch_spin0(2),totch_spin(2)
    write(nfout,'(" == efermi_spin(1:2) = ",2f10.4, ", total_spin  = ",f12.6,", totch_spin(1:2) = ",2f12.6)') &
         & efermi_spin(1:2),total_spin, totch_spin(1:2)*0.5d0
    write(nfout,'(" == efermi = ",f10.4, 20x,", total_spin0 = ",f12.6, ", totch_spin0(1:2) = ",2f12.6)') &
         & efermi, total_spin0, totch_spin0(1:2)
  end subroutine wd_efermi_and_total_spin0_plus

! =============== KT_add ========================== 13.0E
  subroutine m_ESoc_count_charge_belowEF( nfout )
    integer, intent(in) :: nfout

    integer       :: ik, ie
    real(kind=DP) :: wspin = 1.d0, e, dos, weight
    real(kind=DP) :: wktmp, ctmp, csum, csum_mpi
!
    csum = 0.0d0

    if ( noncol ) then
       wktmp = kv3 / ndim_spinor
       
       do ik = 1, kv3, ndim_spinor
          if ( map_k(ik) /= myrank_k ) cycle

          do ie = 1, neg
             if ( map_e(ie) /= myrank_e ) cycle

             e = eko_l(map_z(ie),ik)
             if ( e > efermi ) cycle
             
             call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
             ctmp = weight *wspin *wktmp *qwgt(ik)
             csum = csum +ctmp
          end do
       end do

       if ( npes > 2 ) then
          call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, &
               &              mpi_sum, mpi_comm_group, ierr )
          csum = csum_mpi
       endif

       csum = csum /dble(wktmp)

    else
       do ik=1, kv3                                   
          if (map_k(ik) /= myrank_k) cycle               
          do ie=1, neg                                
             if (map_e(ie) /= myrank_e) cycle           

             e = eko_l(map_z(ie),ik)
             if ( e > efermi ) cycle
             
             call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
             
             ctmp = weight *wspin *kv3 *qwgt(ik)
             csum = csum + 2*ctmp
          end do
       end do

       if ( npes > 2 ) then
          call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, &
               &              mpi_sum, mpi_comm_group, ierr )
          csum = csum_mpi
       endif
       csum = csum/dble(kv3)/dble(nspin)

    endif

    write(nfout,'(A,F20.12)') " !! Number of Charge below Fermi level = ", csum
    
  end subroutine m_ESoc_count_charge_belowEF

  subroutine m_ESoc_count_charge_belowEF_ek( nfout )
    integer, intent(in) :: nfout

    integer       :: k, i
    real(kind=DP) :: wspin = 1.d0, e, dos, weight
    real(kind=DP) :: totw, ctmp, csum, wktmp

    csum = 0.0d0

    if ( noncol ) then
       wktmp = kv3_ek /ndim_spinor

       do k=1, kv3_ek, ndim_spinor
          do i=1, neg
             e = eko_ek(i,k)
             if ( e > efermi ) cycle

             call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
             totw = weight *wspin *wktmp *qwgt_ek(k)
             csum = csum + totw
          end do
       end do
       csum = csum /wktmp
    else
       do k = 1, kv3_ek, af+1
          do i = 1, neg
             e = eko_ek(i,k)
             if ( e > efermi ) cycle

             call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)
             totw = weight*wspin*kv3_ek*qwgt_ek(k)
             csum = csum + 2*totw
          end do
       end do
       csum = csum /kv3_ek *(af+1)
    endif

    write(nfout,'(A,F20.12,A,F20.12)') &
         &     "Total Chargeum of Charge below Fermi level = ", totch, &
         &     " Num of Charge below EF = ", csum

  end subroutine m_ESoc_count_charge_belowEF_ek
! ==================================================== 13.0E

end module m_ES_occup

      subroutine dcx(n, d, e, lde, z, ldz, INFO)

      integer, intent(in)           :: n, ldz
      real(8), intent(inout)        :: d(1:n), e(1:2*lde)
      real(8), intent(out)          :: z(1:ldz,*)

! Parameters BLACS array descritor(the position of entry tags), etc
      INTEGER, PARAMETER            :: BLOCK_CYCLIC_2D = 1
      INTEGER, PARAMETER            :: DLEN_  = 9
      INTEGER, PARAMETER            :: DTYPE_ = 1
      INTEGER, PARAMETER            :: CTXT_  = 2
      INTEGER, PARAMETER            :: M_     = 3
      INTEGER, PARAMETER            :: N_     = 4
      INTEGER, PARAMETER            :: MB_    = 5
      INTEGER, PARAMETER            :: NB_    = 6
      INTEGER, PARAMETER            :: RSRC_  = 7
      INTEGER, PARAMETER            :: CSRC_  = 8
      INTEGER, PARAMETER            :: LLD_   = 9

      integer                       :: DESCZ( DLEN_ )
      integer                       :: DESCW( DLEN_ )
 
      integer                       :: world_size, my_rank
      integer                       :: TRILWMIN, LWORK, LIWORK
 
      real(8), pointer              :: work(:)
      integer, pointer              :: iwork(:)

      real(8)  :: d1,d2

      include 'mpif.h'
      include 'trd.h'
 
 
      d1 = MPI_Wtime()

#ifdef PHASE
      CALL BLACS_PINFO( IAM, NPROCS )
      call datacast_init(2)
      NPROW = x_nnod
      NPCOL = y_nnod
      ICTXT = ICTXTtoDC
      MYROW = MYROWtoDC
      MYCOL = MYCOLtoDC
!     call BLACS_GET( -1, 0, ICTXT )
!     call BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
#else
! BLACS/PBLAS/SCALAPACK initialization
      CALL BLACS_PINFO( IAM, NPROCS )
      if ( NPROCS < 1 ) then
!  MPI group setup
         call MPI_COMM_SIZE( MPI_COMM_EIGEN, NPROCS, ierr )
         call MPI_COMM_RANK( MPI_COMM_EIGEN, IAM, ierr )
         CALL BLACS_SETUP( IAM, NPROCS )
      end if
      call BLACS_GET( -1, 0, ICTXT )
!     call BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      call datacast_init(2)
      NPROW = x_nnod
      NPCOL = y_nnod
!     if (myrow<0.or.myrow>nprow.or.mycol<0.or.mycol>npcol)then
         call BLACS_GRIDINIT( ICTXT, 'Column-major', nprow, npcol)
         call BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
!     endif
#endif

      d2 = MPI_Wtime()


! BLACS array registration
!      NB = 48
      NB = 64+32
!      NB = 1
!      NB = 4
      NP = NUMROC( n, NB, MYROW, 0, NPROW )
      NQ = NUMROC( n, NB, MYCOL, 0, NPCOL )
      lddz = (n-1)/NPROW+1
      lddz = ((lddz-1)/NB+1)*NB
      lddw = (n-1)/NPCOL+1
      lddw = ((lddw-1)/NB+1)*NB
      call DESCINIT( DESCZ, n, n, NB, NB, 0, 0, ICTXT, lddz, INFO )

!
! preparing working arrays
      nx     = (N-1)/NPCOL+1
      LWORK  = MAX(1+6*N+2*NP*(NQ+MAX(NQ,NB)), lddz*lddw, ldz*nx)
      LIWORK = 2+7*n+8*NPCOL
      allocate(work(lwork), iwork(liwork), stat=istat)
      if(istat.ne.0) then
           print*,"Memory exhausted"
           call flush(6)
           call MPI_Abort( MPI_COMM_EIGEN, 1, ierr )
      end if


! Somehow, Z must be nullified (Originally next loop is not required.)
      z(1:lddz*lddw,1) = 0.0D+00


!     MKL_MODE = MKL_GET_DYNAMIC()
!     call MKL_SET_DYNAMIC(0)

      d2 = MPI_Wtime()
      IF(IAM==0)print*,"before PDSTEDC",d2-d1



      d1 = MPI_Wtime ()
      CALL MY_PDSXEDC('I',2, n, d(1), e(1), lde, z(1,1), 1, 1, DESCZ,
     $               WORK(1), LWORK, IWORK(1), LIWORK, INFO)

      d2 = MPI_Wtime()
!     call MKL_SET_DYNAMIC(MKL_MODE)

      IF(IAM==0)print*,"PDSTEDC",d2-d1

      IF(NB==1)THEN
         do i=nx,1,-1
            work(1:lddz)=z(1+(i-1)*lddz:lddz+(i-1)*lddz,1)
            z(1:lddz,i)=work(1:lddz)
         enddo
         do i=1,nx
            z(lddz+1:ldz,i)=0.0D0
         enddo
      ELSE
         call DESCINIT( DESCW, n, n, 1, 1, 0, 0, ICTXT, ldz, INFO )
         call PDGEMR2D( n, n, z, 1, 1, DESCZ, work, 1, 1, DESCW, ICTXT )
         z(1:ldz*nx,1)=work(1:ldz*nx)
      ENDIF

      call bcast_dbl( d(1), n, 1, TRD_COMM_WORLD )
      call datacast_free(1)

! freeing working arrays
      deallocate(work)
      deallocate(iwork)

 
! BLACS/PBLAS/SCALAPACK finalize
!      call BLACS_GRIDEXIT( ICTXT )

      return
      end subroutine

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: hitachi_z3fft, set_length
!
!  AUTHOR(S): O. Sugino  December/22/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef SRFFT
      subroutine hitachi_z3fft(afft,ftw, id,nl,nm,nn, ip1,ip2,ip3,
     & cw1,cw2,cw3, inverse_or_direct, itable_flag)
! $Id: srfft.F 570 2017-04-21 20:34:50Z yamasaki $
      implicit none
      complex*16 afft(*), ftw(*)
      integer id, nl, nm, nn
      integer ip1(3), ip2(3), ip3(3)
      complex*16 cw1(*), cw2(*), cw3(*)
      integer inverse_or_direct, itable_flag
      integer ier, nwkw
      integer ndim1, ndim2
#ifndef SRFTOUTSMP
      integer iopt(2)
      integer i
#else
      integer iopt(3)
      integer i,itop,nloops
#endif

      ndim1 = id
      ndim2 = nm
      iopt(1) = inverse_or_direct
      iopt(2) = itable_flag
      nwkw = 1
#ifndef SRFTOUTSMP
      call hzft7m(afft,ndim1,ndim2,nl,nm,nn,ip1,ip2,ip3,
     & iopt,cw1,cw2,cw3,ftw,nwkw,ier)
#else
      if(itable_flag.eq.0)then
        nloops=1
      else
        nloops=nn
      endif

*poption parallel
      do i=1,nloops
        itop=(ndim1*ndim2)*(i-1)+1
        call hzft9m(afft(itop),ndim1,ndim2,nl,nm,ip1,ip2,
     &         iopt,cw1,cw2,ftw(itop),nwkw,ier)
      enddo

      call trans_axis(ftw,afft,nl,nm,nn,nwkw)

      iopt(3)=2
      if(itable_flag.eq.0)then
        nloops=1
      else
        nloops=nm
      endif

*poption parallel
      do i=1,nloops
        itop=((nl+nwkw)*nn)*(i-1)+1
        call hzft5m(ftw(itop),nl+nwkw,nn,ip3,nl,
     &         iopt,cw3,afft(itop),ier)
      enddo

      call trans_axis(afft,ftw,nl,nn,nm,nwkw)
#endif

!ccc This loop is redundant.
      do i = 1, nm*nn
          afft(i*id) = (0.Q0,0.Q0)
      end do

      return
      end

      subroutine set_length(n, ip)
      implicit none
      integer n, ip(3)
      integer nn, lp2, lp3, lp5

      nn =n
      lp5=0
      lp3=0
      lp2=0
      do while(mod(nn,5).eq.0)
          lp5=lp5+1
          nn=nn/5
      end do
      do while(mod(nn,3).eq.0)
          lp3=lp3+1
          nn=nn/3
      end do
      do while(mod(nn,2).eq.0)
          lp2=lp2+1
          nn=nn/2
      end do
      ip(1) = lp2
      ip(2) = lp3
      ip(3) = lp5

      if(nn.ne.1) stop 'n is an improper number.'

      return
      end
#ifdef SRFTOUTSMP
      subroutine trans_axis(c1,c2,n1,n2,n3,nwkw)
      complex*16 c1(n1+nwkw,n3,n2),c2(n1+nwkw,n2,n3)

      do k=1,n3
      do j=1,n2
      do i=1,n1
        c1(i,k,j)=c2(i,j,k) 
      enddo
      enddo
      enddo

      return
      end
#endif
#endif

!#undef NEC_TIMER
!#ifdef NEC_TIMER
!#  define START_TIMER(a) call start_timer(a)
!#  define STOP_TIMER(a)  call stop_timer(a)
#ifdef FJ_TIMER_RMM
#  define START_TIMER(a) call timer_sta(a)
#  define STOP_TIMER(a)  call timer_end(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 577 $)
!
!  MODULE: m_ES_WF_by_RMM
!
!  AUTHOR(S): T. Yamasaki, T. Uda   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, June/04/2005
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_NONLOCAL_RMM_DGEMM
#define NONLOCAL_RMM_DGEMM
#endif

module m_ES_WF_by_RMM
! This module was coded by T. Yamasaki and T. Uda, 1998-2003
!
! previous Id: m_ES_WF_by_RMM.f90,v 1.6 2003/09/16 03:15:32 yamasaki Exp
! $Id: m_ES_WF_by_RMM.F90 577 2017-12-15 05:26:08Z jkoga $
!
  use m_Electronic_Structure,only : zaj_l, afft,bfft, eko_l,vnlph_l,vlhxcQ &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
       &                          , m_ES_alloc_fft_related &
       &                          , m_ES_dealloc_fft_related &
       &                          , m_ES_wd_zaj_small_portion_3D &
       &                          , m_ES_WF_2D
  use m_ES_nonlocal,         only : m_ES_Vnonlocal_W_3D,m_ES_betar_dot_WFs_4_each_k_3D
  use m_ES_ortho            ,only : m_ES_MGS_4_each_k
  use m_ES_WF_by_SDorCG,     only : m_ESsd_diff_WFs_to_zaj_old
  use m_NonLocal_Potential,  only : snl
  use m_PlaneWaveBasisSet,   only : kg1,kgp,nbmx,iba, igf, nbase, ngabc &
       &                          , m_pwBS_find_min_max_G, m_pwBS_kinetic_energies
  use m_PseudoPotential,     only : ilmt, lmtt, lmta, ltp, mtp &
       &                          , q, dion, nlmta1, nlmta2, modnrm, nac, fqwei, nlmta &
       &                          , m_PP_include_vanderbilt_pot &
       &                          , ipaw,dion_paw
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_Ionic_System,        only : ntyp,natm,ityp,iwei,pos
  use m_FFT,                 only : fft_box_size_WF
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,iprirmm,imGSrmm, rr_Critical_Value, printable &
       &                          , rmm_save_memory_mode, rmm_precal_phase_matm,kimg,neg,af &
       &                          , sw_retard_eigval_evaluation,sw_precalculate, potential_update &
       &                          , sw_serial_fft &
       &                          , sw_gep &
#ifdef SAVE_FFT_TIMES
       &                          , sw_hybrid_functional, sw_fef, sw_fft_xzy, sw_save_fft
#else
       &                          , sw_hybrid_functional, sw_fef, sw_fft_xzy
#endif
  use m_IterationNumbers,    only : iteration_electronic, iteration_rmm_start, iteration, nk_in_the_process
  use m_Const_Parameters,    only : DP,CMPLDP,DIRECT,ON,OFF,SKIP,EXECUT,RMM2,RMM2P,RMM3,PAI2 &
       &                          , ORTHONORMALIZATION, NORMALIZATION, OVER,UNDER, GAMMA &
       &                          , SmallestPositiveNumber, ELECTRON, OLD
  use m_Parallelization,     only : mpi_comm_group &
       &                          , myrank_k,map_k,ista_e,iend_e,istep_e,np_e,map_z,ierr,npes &
       &                          , ista_k,iend_k
  use m_Electronic_Structure,only : neordr, nrvf_ordr, m_ES_decide_precon_factor_3D
  use m_Parallelization,     only : np_g1k, ista_g1k, iend_g1k, neg_g, mpi_ke_world &
                                  , ista_k, iend_k, mpi_kg_world
! === This should be modified after zaj_old is 3D-decomposed!!! by T.Kato ======
  use m_ES_WF_by_SDorCG,     only : zaj_old  &
                                  , m_ESsd_copy_zaj_old_to_zaj, m_ESsd_copy_phi_to_zaj_old
! ==============================================================================
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l, kg
#ifdef NEC_TIMER
  use nec_timer
#endif
! === FFT Marge. by T.Kato ===============================================================
  use m_Parallelization,     only : nel_fft_x , nel_fft_y, nel_fft_z &
                                  , fft_X_x_nel, fft_X_y_nel, fft_X_z_nel &
                                  , mp_g1k, myrank_g
  use m_Electronic_Structure,only : m_ES_Vlocal_in_Rspace_3D, m_ES_WF_in_Rspace_3D &
                                  , vlhxc_l
  use m_FFT,                 only : m_FFT_Vlocal_W_3D, m_FFT_Direct_3D           &
#ifdef FFT_3D_DIVISION
 &                                , m_FFT_Vlocal_W_3DIV_3D, m_FFT_Direct_3DIV_3D &
#endif
 &                                , m_FFT_Direct_XYZ_3D
  use m_ES_WF_by_SDorCG,     only : map_fft_to_WF_3D
! ========================================================================================
! === Marge to Riken Source by T.Kato ====================================================
  use m_Electronic_Structure,only : m_ES_decide_precon_factor_3D &
                                  , m_ES_eigen_values_for_each_k_3D &
                                  , fsr_l, fsi_l, zaj_ball, fsr_l_2D, fsi_l_2D &
                                  , nblocksize_mgs_default
! ========================================================================================
  use m_ES_ExactExchange,    only : m_ES_EXX_eigenvalue_for_each_k &
       &                          , m_ES_EXX_gather_valence_states, m_ES_EXX_cp_eigenvalue &
       &                          , m_ES_Vexx_add_vexx &
       &                          , m_ES_Vexx_W
  use m_FiniteElectricField, only : m_FEF_build_grad, m_FEF_add_grad_to_vnlph &
       &                          , m_FEF_add_grad_to_vnlph_RMM


! ====================================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,  only : noncol, ndim_spinor, ndim_chgpot, SpinOrbit_mode, &
       &                            sw_hubbard
  use m_Const_Parameters,    only : Neglected, BuiltIn
  use m_PseudoPotential,     only : q_noncl, dion_scr_noncl, fqwei_noncl
! ======================================================================= 11.0

  implicit none

  real(kind=DP), private,allocatable,dimension(:,:)     :: zfc1,zfc2,zfc3
  real(kind=DP), private,allocatable,dimension(:,:)     :: zfs1,zfs2,zfs3
  real(kind=DP), private,allocatable,dimension(:,:)     :: phasec,phases
  integer,       private,allocatable,dimension(:,:,:)   :: nglist
  integer,       private,pointer,dimension(:,:)     :: nngabc
  integer,       private,pointer,dimension(:)       :: newp
  real(kind=DP), private,allocatable,dimension(:,:,:) :: bWr, bWi
  real(kind=DP), private,pointer,dimension(:)       :: ekin0
  real(kind=DP), private,pointer,dimension(:,:,:,:) ::      phi  ! d(kg1,kimg,n,0:nrmm-2)
  real(kind=DP), private,allocatable,dimension(:,:,:,:) ::  Rphi ! d(kg1,kimg,n,0:nrmm-2)
  real(kind=DP), private,allocatable,dimension(:,:,:,:) ::  rr_e, psp_e  ! d(0:nrmm-1,0:nrmm-1,n,kimg),
  !                                                      ( n={1(rmm_save_memory_mode)|np_e(otherwise)})

! ============================== added by K. Tagami ===================== 11.0
  real(kind=DP), private,pointer,dimension(:,:,:,:,:) ::      phi_noncl 
                                                 ! d(kg1,kimg,n,0:nrmm-2,ndim_spinor)
  real(kind=DP), private,allocatable,dimension(:,:,:,:,:) ::  Rphi_noncl 
                                                 ! d(kg1,kimg,n,0:nrmm-2,ndim_spinor)
  real(kind=DP), private,allocatable,dimension(:,:,:,:) :: bWr_noncl, bWi_noncl
! ======================================================================= 11.0

  integer,       private,        dimension(2)       :: pm = (/1,-1/)

  real(kind=DP), private                            :: rr_avr = 0.d0
  integer, private,allocatable,dimension(:,:)     :: rr_is_over_or_under

  integer,       private,save                       :: ng_max = 0, ng_min = 0 ! 

!   1. m_ESrmm_reset_ng_maxmin     <-(Renewal_of_WaveFunctions)
!   2. m_ESrmm_reset_r_norm_flag    <-(Renewal_of_WaveFunctions)
!   3. alloc_zfc_zfs     <-(9)
!   4. dealloc_zfc_zfs   <-(9)
!   5. alloc_phasecs_bW_phi_Rphi   <-(9)
!   6. dealloc_phasecs_bW_phi_Rphi <-(9)
!   7. alloc_bW_phi_Rphi           <-(9)
!      - sub_error1, - sub_error2
!   8. dealloc_bW_phi_Rphi         <-(9)
!      - sub_error1
!   9. m_ESrmm_renew_WF             <-(Renewal_of_WaveFunctions)
!      - orthonorm_or_norm, - zajold2zaj_phi2zaj_old_all, - zajold2zaj_phi2zaj_old
!      - rr_avr_final,
!      - what_is_the_dimension_of_rmm, - rmm1, - rmm_n, - evolve_WF_using_Residuals,
!      - wd_rr_and_psp, - wd_alpha, - rmm_n_uda, - rg_or_cg,
!      - solveAYB, - LUdecomp, - rr_and_psp_from_Rphi_and_phi, - phsphn,
!      - normalization_of_rr_and_psp, - set_phase_pointer, - zf_listing
!  10. Vnonlocal_W_RMM       <-(9)
!      - alloc_zfsincos_arai, - dealloc_zfsincos_arai, - alloc_scssqcqs,
!      - dealloc_scssqcqs,    - calc_phase_RMM,  - Vnonlocal_W_part_sum_over_lmt1
!      - sumset_rmm,   - add_vnlph_l_without_eko_part1, - add_vnlph_l_with_eko_part1
!  11. Vnonlocal_W_RMMn      <-(9)
!      - alloc_scssqcqs_x, - dealloc_scssqcqs_x, - find_max_n_ialist0, - sumset_rmm_all3
!      - add_vnlph_l_without_eko_part3, -add_vnlph_l_with_eko_part3
!      - Vnonlocal_W_part_sum_over_lmt1b

  include 'mpif.h'

contains

  subroutine m_ESrmm_reset_ng_maxmin()
    ! this subroutine is called when 
    ! (icond == FIXED_CHARGE or icond == FIXED_CHARGE_CONTINUATION)
    ! and iteration_rmm_start is set.
    ng_max = 0; ng_min = 0
  end subroutine m_ESrmm_reset_ng_maxmin

  subroutine m_ESrmm_dealloc_r_norm_flag
     if(allocated(rr_is_over_or_under)) deallocate(rr_is_over_or_under)
  end subroutine m_ESrmm_dealloc_r_norm_flag

  subroutine m_ESrmm_reset_r_norm_flag
    if(.not.allocated(rr_is_over_or_under)) allocate(rr_is_over_or_under(np_e,ista_k:iend_k))
    rr_is_over_or_under = OVER
  end subroutine m_ESrmm_reset_r_norm_flag

  subroutine alloc_zfc_zfs(nfout,n_min,n_max,matm_t,natm,nrmm,matm)
    integer, intent(inout), dimension(3) :: n_min, n_max
    integer, intent(in)                  :: nfout, matm_t, natm,nrmm
    integer, intent(out) :: matm

    matm = matm_t
    if(matm > natm) matm = natm
    if(matm < 0) matm = 0

! ========================================== modified by K. Tagami =========== 11.0
!    call m_pwBS_find_min_max_G(nfout,nspin,ng_max,ng_min,n_max,n_min)
!
    if ( noncol ) then
       call m_pwBS_find_min_max_G(nfout,ndim_spinor,ng_max,ng_min,n_max,n_min)
    else
       call m_pwBS_find_min_max_G(nfout,nspin,ng_max,ng_min,n_max,n_min)
    endif
! ============================================================================ 11.0

    if(iprirmm >= 2) then
       write(nfout,'(" !!rmm kg1, matm = ",2i6)') kg1,matm
       write(nfout,'(" !! matm+1, natm = ",2i8," <<alloc_zfc_zfs>>")') matm+1,natm
    end if

    if(matm+1 <= natm) then
       allocate(zfc1(n_min(1):n_max(1),matm+1:natm))
       allocate(zfc2(n_min(2):n_max(2),matm+1:natm))
       allocate(zfc3(n_min(3):n_max(3),matm+1:natm))
       allocate(zfs1(n_min(1):n_max(1),matm+1:natm))
       allocate(zfs2(n_min(2):n_max(2),matm+1:natm))
       allocate(zfs3(n_min(3):n_max(3),matm+1:natm))
    end if
  end subroutine alloc_zfc_zfs

  subroutine dealloc_zfc_zfs()
    if(iprirmm >= 2) write(6,'(" rmm_save_memory_mode = ",i6," <<dealloc_zfc_zfs>>")') rmm_save_memory_mode
    if(allocated(zfs1)) then
       deallocate(zfs1);    deallocate(zfs2);    deallocate(zfs3)
       deallocate(zfc1);    deallocate(zfc2);    deallocate(zfc3)
    end if
  end subroutine dealloc_zfc_zfs

  subroutine alloc_phasecs_bW_phi_Rphi_3D(nrmm,n_min,n_max,matm)
    integer, intent(in) :: nrmm
    integer, intent(in) :: n_min(3),n_max(3),matm

    allocate(nngabc(kg1,3))
    allocate(newp(kg1))
    allocate(phi(maxval(np_g1k),kimg,1,0:nrmm-2));  phi  = 0.d0
    allocate(Rphi(maxval(np_g1k),kimg,1,0:nrmm-2)); Rphi = 0.d0
    allocate(rr_e(0:nrmm-1,0:nrmm-1,1,kimg))
    allocate(psp_e(0:nrmm-1,0:nrmm-1,1,kimg))
    allocate(phasec(kg1,matm)); allocate(phases(kg1,matm))
    allocate(nglist(n_min(1):n_max(1),n_min(2):n_max(2),n_min(3):n_max(3)))
    allocate(bWr(nlmta,0:nrmm-1,1)); allocate(bWi(nlmta,0:nrmm-1,1))
  end subroutine alloc_phasecs_bW_phi_Rphi_3D

  subroutine dealloc_phasecs_bW_phi_Rphi_3D()
    deallocate(bWi); deallocate(bWr)
    deallocate(nglist)
    deallocate(phasec); deallocate(phases)
    deallocate(psp_e)
    deallocate(rr_e)
    deallocate(Rphi)
    deallocate(phi)
    deallocate(newp)
    deallocate(nngabc)
  end subroutine dealloc_phasecs_bW_phi_Rphi_3D

  subroutine alloc_bW_phi_Rphi_3D(nrmm)
    integer, intent(in) :: nrmm
    integer :: istat
    character*4 :: name
    if(iprirmm >= 3) then
       write(6,'(" !! nlmta,             nrmm, np_e = ",3i10," <<alloc_bW_phi_Rphi>>")') nlmta,nrmm,np_e
       write(6,'(" !! maxval(np_g1k), kimg, np_e = ",3i10," <<alloc_bW_phi_Rphi>>")') maxval(np_g1k),kimg,np_e
    end if

    allocate(bWr(nlmta,0:nrmm-1,np_e),stat=istat)
    if(istat /= 0) then
       name = "bWr "
       call sub_error1
    end if
    bWr = 0.d0

    allocate(bWi(nlmta,0:nrmm-1,np_e),stat=istat)
    if(istat /= 0) then
       name = "bWi"
       call sub_error1
    end if
    bWi = 0.d0

    allocate(Rphi(maxval(np_g1k),kimg,np_e,0:nrmm-2),stat=istat)
    if(istat /= 0) then
       name = "Rphi"
       call sub_error2
       call sub_error1
    else
       if(iprirmm >= 2) write(6,*) 'Allocation success for Rphi <<alloc_bW_phi_Rphi>>'
    end if
    Rphi = 0.d0

    allocate(phi(maxval(np_g1k),kimg,np_e,0:nrmm-2),stat=istat)
    if(istat /= 0) then
       name = "phi "
       call sub_error2
       call sub_error1
    else
       if(iprirmm >= 2) write(6,*) 'Allocation success for phi <<alloc_bW_phi_Rphi>>'
    end if
    phi = 0.d0

    allocate(rr_e(0:nrmm-1,0:nrmm-1,np_e,kimg));    rr_e = 0.d0
    allocate(psp_e(0:nrmm-1,0:nrmm-1,np_e,kimg));   psp_e = 0.d0
  contains
    subroutine sub_error1
      write(6,'(" Allocation error for ",a4," <<m_ES_WF_by_RMM.alloc_bW_phi_Rphi>>")') name
      write(6,*) 'stat = ',istat
      stop  'Allocation error <<m_ES_WF_by_RMM.alloc_bW_phi_Rphi>>'
    end subroutine sub_error1
    subroutine sub_error2
      write(6,'(" required allocation size = ",i10," maxval(np_g1k),kimg,np_e,nrmm = ",4i8)') &
         maxval(np_g1k)*kimg*np_e*nrmm,maxval(np_g1k),kimg,np_e,nrmm
    end subroutine sub_error2

  end subroutine alloc_bW_phi_Rphi_3D

  subroutine dealloc_bW_phi_Rphi_3D()
    integer :: istat
    character*4 :: name
    deallocate(psp_e)
    deallocate(rr_e)
    deallocate(phi, stat=istat)
    if(istat /= 0) then
       name = "phi "
       call sub_error1
    end if
    deallocate(Rphi, stat=istat)
    if(istat /= 0) then
       name = "Rphi"
       call sub_error1
    end if
    deallocate(bWi, stat=istat)
    if(istat /= 0) then
       name = "bWi "
       call sub_error1
    end if
    deallocate(bWr, stat=istat)
    if(istat /= 0) then
       name = "bWr "
       call sub_error1
    end if
  contains
    subroutine sub_error1
      write(6,'(" Deallocation error for ",a4,"<<m_ES_WF_by_RMM.dealloc_bW_phi_Rphi>>")') name
      write(6,*) 'stat =', istat
      stop 'Deallocation error <<m_ES_WF_by_RMM.dealloc_bW_phi_Rphi>>'
    end subroutine sub_error1
  end subroutine dealloc_bW_phi_Rphi_3D

  subroutine m_ESrmm_renew_WF(nfout,isolver,precon,dtim)
    integer,       intent(in) :: nfout,isolver,precon
    real(kind=DP), intent(in) :: dtim

    !  R   := -(H-eS)
    !  zaj_l(:,i,k,1:kimg) :=  | \Phi_{k,i} >
    !  phi (:,1:kimg,0)    :=  | \Phi_{k,i} >
    !  Rphi(:,1:kimg,0)    := R|\Phi_{k,i}>
    !  phi (:,1:kimg,1)    := KR |\Phi_{k,i}>
    !  Rphi(:,1:kimg,1)    := RKR|\Phi_{k,i}>
    ! when isolver == RMM3,
    !  phi (:,1:kimg,2)    := KRKR |\Phi_{k,i}>
    !  Rphi(:,1:kimg,2)    := RKRKR|\Phi_{k,i}>
    ! when isolver == RMM2P,
    !  phi (:,1:kimg,2)    := |\Phi^{-1}_{k,i}> = |\Phi^{m}_{k,i}> - |\Phi^{m-1}_{k,i}>
    !  Rphi(:,1:kimg,2)    := R|\Phi^{-1}_{k,i}>
    !
    ! output
    !  zaj_l := |\Psi^{m+1}_{k,i}>
    !         = \alpha_0 phi(:,:,0) + \alpha_1 phi(:,:,1) + \alpha_2 phi(:,:,2)
    ! where,
    !  K is preconditioning operator,
    !  alpha_0,alpha_1, and alpha_2 are decided from <Rphi_i|Rphi_j> and <phi_i|S|phi_j>
    !
    ! For details, refer to G. Kresse and J. Furthmuller, PRB54,11169,(1996)
    ! The procedure in a case of isolver == RMM2P has been developped originally by T. Uda.
    !

! === Debug!!! These arrays should be saved for alloc_zfc_zfs call!!! by T.Kato ==========
!   integer :: n_max(3), n_min(3)
    integer, save :: n_max(3) = 0, n_min(3) = 0
! ========================================================================================
    integer :: ispin,ik,ib,iter_rmm, nrmm, matm,iilmt
    real(kind=DP), pointer, dimension(:)   :: ekin
    real(kind=DP), pointer, dimension(:,:) :: phi0
    real(kind=DP), allocatable,dimension(:,:,:) :: vxw_exx
    integer :: id_sname = -1
    real(kind=DP) :: exx
    integer :: ng
    integer :: iup
    logical :: store_e
! === FFT Marge. by T.Kato ===============================================================
    integer :: lsize, ibsize, isrsize, fft_l_size
    real(kind=DP), allocatable, dimension(:) :: afft_l
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: bfft_l
! ========================================================================================
! === Marge to Riken Source by T.Kato ====================================================
    real(kind=DP), pointer, dimension(:) :: ekin_l
! ========================================================================================
!!$    call tstatc0_begin('m_ESrmm_renew_WF ', id_sname,1)

    rr_avr = 0.d0
    call what_is_the_dimension_of_rmm() ! -(contained here) ->nrmm(= 2 or 3)

    if(potential_update>0) sw_retard_eigval_evaluation = OFF

! === DEBUG by tkato 2011/07/12 ================================================
!   allocate(rr_is_over_or_under(np_e,ista_k:iend_k))
    if(.not.allocated(rr_is_over_or_under)) then
       allocate(rr_is_over_or_under(np_e,ista_k:iend_k))
       rr_is_over_or_under = OVER
    endif
! ==============================================================================
    call m_ES_alloc_fft_related()  ! afft, bfft, m_FFT_alloc_WF_work
    if(isolver==RMM2P.and.nrmm==3) call m_ESsd_diff_WFs_to_zaj_old(1.d0) !->zaj_old

    if(rmm_save_memory_mode == ON) then
       call alloc_zfc_zfs(nfout,n_min,n_max,rmm_precal_phase_matm,natm,nrmm,matm) ! -(m_ES_WF_by_RMM)
       call zf_listing()                     ! -(contained here) -> zfc1,zfc2,zfc3,zfs1,zfs2,zfs3
    end if

! ==============================================================================
START_TIMER(1601)
!fj$$F    do ispin = 1, nspin, af+1
! === FFT Marge. by T.Kato ===============================================================
!fj$$F       call decomp_vlhxc_l_3D(vlhxc_l,vlhxc_l_3D,ispin)
! ========================================================================================
!fj$$F       do ik = ispin, kv3-nspin+ispin, nspin
!fj$$F          if(map_k(ik) /= myrank_k) cycle
!fj$$F          call decomp_zaj_l_3D_ik(zaj_l,zaj_l_3D,ik,nrvf_ordr,"sort")
!fj$$F          call decomp_eko_l_3D_new(eko_l,eko_l_3D,ik,nrvf_ordr,"sort")
!fj$$F          call decomp_rr_is_over_or_under_3D(rr_is_over_or_under,rr_is_over_or_under_3D,ik,nrvf_ordr,"sort")
!fj$$F          call decomp_fsr_l_3D_ik(fsr_l,fsr_l_3D,ik,nrvf_ordr,"sort")
!fj$$F          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!fj$$F             call decomp_fsr_l_3D_ik(fsi_l,fsi_l_3D,ik,nrvf_ordr,"sort")
!fj$$F          endif
! === This should be modified after zaj_old is 3D-decomposed!!! by T.Kato ======
!fj$$F          call decomp_zaj_l_3D_ik(zaj_old,zaj_old_3D,ik,nrvf_ordr,"sort")
! ==============================================================================
!fj$$F       enddo
!fj$$F    enddo
STOP_TIMER(1601)
! ==============================================================================
! === Marge to Riken Source by T.Kato ====================================================
    allocate(ekin0(maxval(np_g1k)))
    ekin_l => ekin0
! ========================================================================================
! === FFT Marge. by T.Kato ===============================================================
#ifdef FFT_3D_DIVISION
    lsize = fft_X_x_nel*fft_X_y_nel*fft_X_z_nel
    allocate(afft_l(lsize*2), stat=ierr)
#else
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
    allocate(afft_l(lsize*kimg), stat=ierr)
#endif
    if(ierr /= 0) then
       write(nfout,*)' m_ESrmm_renew_WF : Not allocated afft_l array'
       call flush(nfout)
       call mpi_abort(mpi_comm_world, 201, ierr)
    endif
    ibsize = 1
!   if (nblocksize_fftw_is_given) then
!      ibsize = nblocksize_fftw
!      if (ibsize < 1) ibsize = 1
!   endif
! ========================================================================================
    Loop_spin: do ispin = 1, nspin, af+1
! === FFT Marge. by T.Kato ===============================================================
       call m_ES_Vlocal_in_Rspace_3D(ispin,afft_l,lsize,1,OFF) ! (ptfft1) ->afft
! ========================================================================================
       Loop_kpoints: do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle              ! MPI
! === DEBUG by tkato 2011/09/12=================================================
          if (allocated(vnlph_l)) then
             if (size(vnlph_l,1) .ne. np_g1k(ik)) then
                deallocate(vnlph_l)
                allocate(vnlph_l(np_g1k(ik),np_e,kimg))
             endif
          else
             allocate(vnlph_l(np_g1k(ik),np_e,kimg))
          endif
! ==============================================================================
! === FFT Marge. by T.Kato ===============================================================
          isrsize = min(lsize,mp_g1k(ik))
          fft_l_size  = nel_fft_x(myrank_g)
#ifdef FFT_3D_DIVISION
          allocate(wk_bfft_l(lsize*2   ,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*2   ,ibsize) ,stat=ierr)
#else
          allocate(wk_bfft_l(lsize*kimg,ibsize) ,stat=ierr)
          allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
#endif
          if (ierr /= 0) then
             write(nfout,*)' m_ESrmm_renew_WF :  Not allocate '
             call flush(nfout)
             call mpi_abort(mpi_comm_world, 205, ierr)
          endif
! ========================================================================================

          if(iprirmm >= 3 .and. printable) then
             call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- rmm --",10)
          endif

          call m_pwBS_kinetic_energies(ik,vkxyz,ekin_l)! (diakin) ->ekin

          if(rmm_save_memory_mode == ON) then
             call alloc_phasecs_bW_phi_Rphi_3D(nrmm,n_min,n_max,matm) ! allocations of bWr, bWi, phi and Rphi. (bWr,bWi) = <\beta |WF=zaj_l>
             call pre_calc_phase !-(contained here) -> phasec,phases,newp

             Loop_band: do ib = 1, np_e ! MPI
                if(rr_is_over_or_under(ib,ik) == UNDER.and.sw_precalculate==OFF) cycle
                Loop_res_dim: do iter_rmm = 0, nrmm-1
START_TIMER(1602)
                   if(isolver == RMM2P .and. iter_rmm == nrmm-1) &
                        & call zajold2zaj_phi2zaj_old_3D !-(contained here) zaj_old->zaj, phi0 ->zaj_old
STOP_TIMER(1602)

START_TIMER(1603)
                   call Vnonlocal_W_RMM_3D(ik,ib,ispin,rmm_precal_phase_matm,iter_rmm)! ->vnlph_l,bWr,bWi
STOP_TIMER(1603)
! === Support Hybrid on 3D_Parallel by tkato 2013/02/10 ========================
!                   if(sw_hybrid_functional==ON) call m_ES_Vexx_W_RMM(ik,ib)
! ==============================================================================
START_TIMER(1604)
#ifdef __TIMER_COMM__
                   call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
                   call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
#ifdef FFT_3D_DIVISION
                   call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
                   call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
                   if (sw_fft_xzy > 0) then
                      call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
                      call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
                   else
                      call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
                      if(sw_serial_fft == ON) then
                         call m_ES_WF_2D(ik,wk_bfft_l,ib,ib,ibsize,lsize,DIRECT)
                      else
                         call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
                      endif
                   endif
#endif
                   call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
STOP_TIMER(1604)
START_TIMER(1605)
!                  call rmm1_3D(ib,iter_rmm,nrmm)     ! -(contained here)
                   call rmm1_3D(ib,iter_rmm,nrmm,bfft_l,lsize)     ! -(contained here)
STOP_TIMER(1605)
                   !          zaj_l,vnlph_l,ekin,eko_l,bfft -> zaj_l,phi,Rphi
                end do Loop_res_dim
START_TIMER(1606)
                call rmm_n_uda_3D(ik,ib,nrmm)       ! -(contained here) phi,Rphi ->zaj_l, nrmm = 2 or 3
STOP_TIMER(1606)
                !                       Residual norm is also checked (->rr_is_oever_or_under)
             end do Loop_band

             call dealloc_phasecs_bW_phi_Rphi_3D()
          else
             call alloc_bW_phi_Rphi_3D(nrmm) ! allocations of bWr, bWi, phi and Rphi. (bWr,bWi) = <\beta |WF=zaj_l>
             Loop_res_dim_b: do iter_rmm = 0, nrmm-1
START_TIMER(1607)
                if(isolver == RMM2P .and. iter_rmm == nrmm-1) &
                     & call zajold2zaj_phi2zaj_old_all_3D !-(contained here) zaj_old->zaj, phi0 ->zaj_old, if rr_is_over_or_under /= UNDER
STOP_TIMER(1607)

#ifdef RMM_NONLOCAL_NEW
                call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik,.false.)
                do ib=1,np_e
                  do iilmt=1,nlmta
                    bWr(iilmt,iter_rmm,ib) = fsr_l_2D(ib,iilmt)
                    if( k_symmetry(ik) /= GAMMA) bWi(iilmt,iter_rmm,ib) = fsi_l_2D(ib,iilmt)
                  enddo
                enddo
                call m_ES_Vnonlocal_W_3D(ik,(ik-1)/nspin+1,ispin,ON)
#else
START_TIMER(1608)
                call Vnonlocal_W_RMMn_3D(nfout,ik,ispin,iter_rmm)! ->vnlph_l,bWr,bWi
STOP_TIMER(1608)
#endif
                if(sw_hybrid_functional==ON) &
                &  call m_ES_Vexx_W(ik,2,store_exxp=iter_rmm==0)
                do ib = 1, np_e
                   if(rr_is_over_or_under(ib,ik) == UNDER.and.sw_precalculate==OFF) cycle
START_TIMER(1609)
#ifdef __TIMER_COMM__
                   call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l,0)
#else
                   call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
#endif
#ifdef FFT_3D_DIVISION
                   call m_FFT_Vlocal_W_3DIV_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_x(myrank_g))
                   call m_FFT_Direct_3DIV_3D(nfout,wk_bfft_l,lsize,ibsize)
#else
                   if (sw_fft_xzy > 0) then
                      call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
                      call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
                   else
                      call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_z(myrank_g))
                      if(sw_serial_fft == ON) then
                         call m_ES_WF_2D(ik,wk_bfft_l,ib,ib,ibsize,lsize,DIRECT)
                      else
                         call m_FFT_Direct_XYZ_3D(nfout,wk_bfft_l,lsize,ibsize)
                      endif
                   endif
#endif
                   call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
STOP_TIMER(1609)
START_TIMER(1610)
!                  call rmm1_3D(ib,iter_rmm,nrmm)     ! -(contained here)
                   call rmm1_3D(ib,iter_rmm,nrmm,bfft_l,lsize)     ! -(contained here)
STOP_TIMER(1610)
                      !          zaj_l,vnlph_l,ekin,eko_l,bfft -> zaj_l,phi,Rphi
                end do
             end do Loop_res_dim_b

             Loop_band_b: do ib = 1, np_e
                !!$if(rr_is_over_or_under(map_z(ib),ik) == UNDER) cycle
                !! rewrote for ifort on em64t 2006/4/19 T.Yamamoto
START_TIMER(1611)
                if(rr_is_over_or_under(ib,ik) /= UNDER) &
                   & call rmm_n_uda_3D(ik,ib,nrmm)       ! -(contained here) phi,Rphi ->zaj_l, nrmm = 2 or 3
STOP_TIMER(1611)
                !                       Residual norm is also checked (->rr_is_oever_or_under)
             end do Loop_band_b

             call dealloc_bW_phi_Rphi_3D()
          end if

!!$#ifdef SAVE_FFT_TIMES
!!$          do ib = 1, np_e
!!$             status_saved_phifftr(ib,ik) = OLD
!!$          end do
!!$#endif


!!$          call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   !  -> fsr_l,fsi_l

!!$          call orthonorm_or_norm_3D(imGSrmm)  !-(contained here)
          call orthonorm_or_norm(imGSrmm)  !-(contained here)

          if(sw_hybrid_functional==ON) then
             if(sw_retard_eigval_evaluation==ON) then
                call m_ES_EXX_cp_eigenvalue(ik)
             else
                call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,iupdate=0)
             endif
          endif
          call m_ES_eigen_values_for_each_k_3D(ispin,ik,ekin_l,afft_l,lsize)

! === FFT Marge. by T.Kato ===============================================================
          deallocate(wk_bfft_l)
          deallocate(bfft_l)
! ========================================================================================
       end do Loop_kpoints
    end do Loop_spin
    if(sw_hybrid_functional==ON.and.sw_retard_eigval_evaluation==ON)then
       call m_ES_EXX_gather_valence_states(nfout)
       do ispin=1,nspin,af+1
          do ik=ispin, kv3+ispin-nspin, nspin
             if(map_k(ik) /= myrank_k) cycle ! MPI
             call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,update_eko=.false.,iupdate=2)
          enddo
       enddo
    endif
! === FFT Marge. by T.Kato ===============================================================
    deallocate(afft_l)
! ==============================================================================
START_TIMER(1612)
!fj$$F    do ispin = 1, nspin, af+1
!fj$$F       do ik = ispin, kv3-nspin+ispin, nspin
!fj$$F          if(map_k(ik) /= myrank_k) cycle
!fj$$F          call decomp_zaj_l_r_3D_ik(zaj_l,zaj_l_3D,ik,neordr,"sort")
!fj$$F          call decomp_rr_is_over_or_under_r_3D(rr_is_over_or_under,rr_is_over_or_under_3D,ik,neordr,"sort")
!fj$$F          call decomp_eko_l_r_3D_new(eko_l,eko_l_3D,ik,neordr,"sort")
!fj$$F          call decomp_fsr_l_r_3D_ik(fsr_l,fsr_l_3D,ik,neordr,"sort",0)
!fj$$F          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!fj$$F             call decomp_fsr_l_r_3D_ik(fsi_l,fsi_l_3D,ik,neordr,"sort",0)
!fj$$F          endif
!fj$$F          call replacement_zaj_ball_sequence(zaj_ball,ik,neordr,nblocksize_mgs_default)
! === This should be modified after zaj_old is 3D-decomposed!!! by T.Kato ======
!fj$$F          call decomp_zaj_l_r_3D_ik(zaj_old,zaj_old_3D,ik,neordr,"sort")
! ==============================================================================
!fj$$F       enddo
!fj$$F    enddo
STOP_TIMER(1612)
! ==============================================================================

    if(rmm_save_memory_mode == ON) call dealloc_zfc_zfs()

    call rr_avr_final_3D !-(c.h.)  rr_avr = rr_avr/(kv3*neg)

    deallocate(ekin0)

    call m_ES_dealloc_fft_related()

    deallocate(rr_is_over_or_under)
!!$    call tstatc0_end(id_sname)
#ifdef fj_dump
  call dump_zaj(zaj_l)
#endif
  contains
    subroutine orthonorm_or_norm(imGSrmm_t)
      integer, intent(in) :: imGSrmm_t
      if(mod(iteration_electronic - iteration_rmm_start, imGSrmm_t) == 0) then
         if(sw_gep == ON)then
            if(iprirmm >= 2 .and. ik == 1) write(nfout,'(" -- NORMALIZATION --")')
            call m_ES_MGS_4_each_k(nfout,ik,mode=NORMALIZATION)
         else
            if(iprirmm >= 2 .and. ik == 1) write(nfout,'(" -- ORTHONORMALIZATION --")')
            call m_ES_MGS_4_each_k(nfout,ik,mode=ORTHONORMALIZATION)
         endif
      else
         if(iprirmm >= 2 .and. ik == 1) write(nfout,'(" -- NORMALIZATION --")')
         call m_ES_MGS_4_each_k(nfout,ik,mode=NORMALIZATION)
      end if
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
    end subroutine orthonorm_or_norm
!!$!BRANCH_P_END ORG_Parallel

    subroutine zajold2zaj_phi2zaj_old_all_3D
      integer :: ib, ibto
      do ib = 1, np_e
         if(rr_is_over_or_under(ib,ik) == UNDER.and.sw_precalculate==OFF) cycle
         if(nrmm == 3) call m_ESsd_copy_zaj_old_to_zaj(ik,ib)
         ibto = ib
         phi0 => phi(:,:,ibto,0)
         call m_ESsd_copy_phi_to_zaj_old(ik,ib,phi0)  ! phi->zaj_old
      end do
    end subroutine zajold2zaj_phi2zaj_old_all_3D

    subroutine zajold2zaj_phi2zaj_old_3D
      if(nrmm == 3) call m_ESsd_copy_zaj_old_to_zaj(ik,ib)
      phi0 => phi(:,:,1,0)
      call m_ESsd_copy_phi_to_zaj_old(ik,ib,phi0)  ! phi->zaj_old
    end subroutine zajold2zaj_phi2zaj_old_3D

    subroutine rr_avr_final_3D
      integer       :: i,j, n_rr_under, n_mpi
      real(kind=DP) :: rr_avr_mpi

      if(npes >= 2) then
                                                  __TIMER_COMM_START(1621)
         call mpi_allreduce(rr_avr, rr_avr_mpi,1,mpi_double_precision &
              & , mpi_sum,mpi_kg_world,ierr)
                                                  __TIMER_COMM_STOP(1621)
      else
         rr_avr_mpi = rr_avr
      end if
      rr_avr = rr_avr_mpi/(kv3*neg)
      if(iprirmm >= 2) &
           & write(nfout,'(" Residual Norm (sum_i <R_i|R_i>/sum_i) ( " &
           & ,i6," -th iter (electronic)) = ",d19.7)') iteration_electronic, rr_avr

      n_rr_under = 0
      do j = ista_k, iend_k
         do i = 1, np_e
            if(rr_is_over_or_under(map_z(i),j) == UNDER) n_rr_under = n_rr_under + 1
         end do
      end do
      if(npes >= 2) then
                                                  __TIMER_COMM_START(1621)
         call mpi_allreduce(n_rr_under,n_mpi, 1, mpi_integer,mpi_sum,mpi_comm_group,ierr)
                                                  __TIMER_COMM_STOP(1621)
      else
         n_mpi = n_rr_under
      end if
      if(n_mpi > 0 .and. iprirmm >= 1) write(nfout,'(" Number of rr_under = ",i5)') n_mpi
    end subroutine rr_avr_final_3D

    subroutine what_is_the_dimension_of_rmm
      if(isolver == RMM2 ) then
         nrmm = 2
      else if(isolver == RMM2p) then
         if(iteration_electronic == iteration_rmm_start) then
            nrmm = 2
         else
            nrmm = 3
         end if
      else if(isolver == RMM3) then
         nrmm = 3
      else
         if(printable) write(nfout,'(" !isolver",i3," is illegal ( m_ESrmm_renew_WF )")') isolver
         stop
      endif
    end subroutine what_is_the_dimension_of_rmm

    subroutine rmm1_3D(ibo,iter_rmm,nrmm,bfft_l,lsize)
      ! Revised by T. Yamasaki, 18th Sep. 2004
      !    <R_i|R_j> and <Phi_i|S|Phi_j> are calculated, then are substituted to
      !   rr_e and psp_e, respectively with not using
      integer, intent(in) :: ibo,iter_rmm,nrmm  ! nrmm = {2|3}
      !               iter_rmm = {0|1} (when nrmm == 2)}, {0|1|2} (when nrmm == 3)
      real(kind=DP) :: evr,devr,dnm,evi,e1,devi
      real(kind=DP) :: rrr, rri, pspr, pspi

      real(kind=DP), pointer, dimension(:,:) :: phi_t, Rphi_t !d(iba(ik),kimg)
      real(kind=DP), allocatable, dimension(:) :: p
      integer       :: i, i1, ib, ibt, ir, ii, j, iadd
      integer       :: iend
      integer, intent(in) :: lsize
!     real(kind=DP), intent(in), dimension(lsize*kimg,ibesize) :: bfft_l
#ifdef FFT_3D_DIVISION
      real(kind=DP), intent(in), dimension(lsize*2   ,1) :: bfft_l
#else
      real(kind=DP), intent(in), dimension(lsize*kimg,1) :: bfft_l
#endif
      allocate(p(maxval(np_g1k)))

      if(iter_rmm == nrmm-1) then
         allocate(phi_t(np_g1k(ik),kimg))
         allocate(Rphi_t(np_g1k(ik),kimg))
      end if

      ib = ibo                  ! MPI
      if(rmm_save_memory_mode == ON) then
         ibt = 1
      else
         ibt = ib
      end if
      dnm = 1.d0/product(fft_box_size_WF(1:3,1))
      call m_ES_decide_precon_factor_3D(precon,ik,ibo,ibo,1,ekin_l,p) ! ->p(1:iba(ik)) 

      if(kimg == 1) then
! ==============================================================================
         iend = iend_g1k(ik) - ista_g1k(ik) + 1
! ==============================================================================
         if(iter_rmm <= nrmm-2) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1    = igf(nbase(i,ik))
               evr   = zaj_l(iadd,ib,ik,1)
               devr  = (ekin_l(iadd)-eko_l(ib,ik))*evr + bfft_l(iadd,1)*dnm+vnlph_l(iadd,ib,1)
               zaj_l(iadd,ib,ik,1)    = -p(iadd)*devr
#ifdef SAVE_FFT_TIMES
               if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
               phi (iadd,1,ibt,iter_rmm)  =  evr
               Rphi(iadd,1,ibt,iter_rmm)  = -devr
            end do
            if(k_symmetry(ik) == GAMMA) then
               do i1 = 0, iter_rmm
                  if(ista_g1k(ik) == 1) then
                     rrr  = Rphi(1,1,ibt,i1)*Rphi(1,1,ibt,iter_rmm) + &
                          & 2.d0*dot_product(Rphi(2:iend,1,ibt,i1),Rphi(2:iend,1,ibt,iter_rmm))
                     pspr = phi (1,1,ibt,i1)*phi (1,1,ibt,iter_rmm) + &
                          & 2.d0*dot_product(phi (2:iend,1,ibt,i1),phi (2:iend,1,ibt,iter_rmm))
                  else
                     rrr  = 2.d0*dot_product(Rphi(1:iend,1,ibt,i1),Rphi(1:iend,1,ibt,iter_rmm))
                     pspr = 2.d0*dot_product(phi (1:iend,1,ibt,i1),phi (1:iend,1,ibt,iter_rmm))
                  endif
                                                  __TIMER_COMM_START(1622)
                  call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                  call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
                  rr_e (i1,iter_rmm,ibt,1) = rrr
                  psp_e(i1,iter_rmm,ibt,1) = pspr
               end do
            else
               do i1 = 0, iter_rmm
                  rrr  = dot_product(Rphi(1:iend,1,ibt,i1),Rphi(1:iend,1,ibt,iter_rmm))
                  pspr = dot_product(phi (1:iend,1,ibt,i1),phi (1:iend,1,ibt,iter_rmm))
                                                  __TIMER_COMM_START(1622)
                  call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                  call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
                  rr_e (i1,iter_rmm,ibt,1) = rrr
                  psp_e(i1,iter_rmm,ibt,1) = pspr
               end do
            end if
         else if(iter_rmm == nrmm-1) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1    = igf(nbase(i,ik))
               phi_t (iadd,1)  = zaj_l(iadd,ib,ik,1)
               Rphi_t(iadd,1)  = - ((ekin_l(iadd)-eko_l(ib,ik))*phi_t(iadd,1) + bfft_l(iadd,1)*dnm+vnlph_l(iadd,ib,1))
!!$               zaj_l(i,ib,ik,1) = evr
               !   when iter_rmm == nrmm-1, zaj_l (to which KR|Psi> is stored) is not
               !   going to be used recursively, so we do not need to store evr to zaj_l,
               !   instead we ues zaj_l as |phi_{iter_rmm}>.
            end do
            if(k_symmetry(ik) == GAMMA) then
               do i1 = 0, iter_rmm-1
                  if(ista_g1k(ik) == 1) then
                     rrr  = Rphi(1,1,ibt,i1)*Rphi_t(1,1) &
                        & + 2.d0*dot_product(Rphi(2:iend,ibt,1,i1),Rphi_t(2:iend,1))
                     pspr = phi (1,1,ibt,i1)*phi_t (1,1) &
                        & + 2.d0*dot_product(phi (2:iend,ibt,1,i1),phi_t (2:iend,1))
                  else
                     rrr  = 2.d0*dot_product(Rphi(1:iend,ibt,1,i1),Rphi_t(1:iend,1))
                     pspr = 2.d0*dot_product(phi (1:iend,ibt,1,i1),phi_t (1:iend,1))
                  endif
                                                  __TIMER_COMM_START(1622)
                  call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                  call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
                  rr_e (i1,iter_rmm,ibt,1) = rrr
                  psp_e(i1,iter_rmm,ibt,1) = pspr
               end do
               if(ista_g1k(ik) == 1) then
                  rrr  = Rphi_t(1,1)*Rphi_t(1,1) &
                     & + 2.d0*dot_product(Rphi_t(2:iend,1),Rphi_t(2:iend,1))
                  pspr = phi_t (1,1)*phi_t (1,1) &
                     & + 2.d0*dot_product(phi_t (2:iend,1),phi_t (2:iend,1))
               else
                  rrr =  2.d0*dot_product(Rphi_t(1:iend,1),Rphi_t(1:iend,1))
                  pspr = 2.d0*dot_product(phi_t (1:iend,1),phi_t (1:iend,1))
               endif
                                                  __TIMER_COMM_START(1622)
               call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)

               rr_e (iter_rmm,iter_rmm,ibt,1) = rrr
               psp_e(iter_rmm,iter_rmm,ibt,1) = pspr
            else
               do i1 = 0, iter_rmm-1
                  rrr  = dot_product(Rphi(1:iend,1,ibt,i1),Rphi_t(1:iend,1))
                  pspr = dot_product(phi (1:iend,1,ibt,i1),phi_t (1:iend,1))
                                                  __TIMER_COMM_START(1622)
                  call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                  call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
                  rr_e (i1,iter_rmm,ibt,1) = rrr
                  psp_e(i1,iter_rmm,ibt,1) = pspr
               end do
               rrr  = dot_product(Rphi_t(1:iend,1),Rphi_t(1:iend,1))
               pspr = dot_product(phi_t (1:iend,1),phi_t (1:iend,1))
                                                  __TIMER_COMM_START(1622)
               call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
               rr_e (iter_rmm,iter_rmm,ibt,1) = rrr
               psp_e(iter_rmm,iter_rmm,ibt,1) = pspr
            end if
         else
            if(printable) write(nfout,'("  iter_rmm > nrmm-1 ( illegal relation) <<m_ES_WF_by_RMM.rmm1_3D>>")')
            stop '   iter_rmm > nrmm-1 ( illegal relation) <<m_ES_WF_by_RMM.rmm1_3D>>'
         end if
      else if(kimg == 2) then
         ir = iter_rmm
         if(iter_rmm <= nrmm-2) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1    = igf(nbase(i,ik))
               evr   = zaj_l(iadd,ib,ik,1);    evi   = zaj_l(iadd,ib,ik,2)
               e1    = ekin_l(iadd) - eko_l(ib,ik)
               devr  = e1*evr+bfft_l(2*iadd-1,1)*dnm+vnlph_l(iadd,ib,1)
               devi  = e1*evi+bfft_l(2*iadd  ,1)*dnm+vnlph_l(iadd,ib,2)
               zaj_l(iadd,ib,ik,1)   = -p(iadd)*devr
               zaj_l(iadd,ib,ik,2)   = -p(iadd)*devi
               phi (iadd,  1,ibt,iter_rmm) = evr;   phi (iadd, 2,ibt,iter_rmm) = evi
               Rphi(iadd,  1,ibt,iter_rmm) = -devr; Rphi(iadd, 2,ibt,iter_rmm) = -devi
            end do
#ifdef SAVE_FFT_TIMES
            if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
            do i1 = 0, iter_rmm
               rrr = 0.d0; rri = 0.d0; pspr = 0.d0; pspi = 0.d0
               if(k_symmetry(ik) == GAMMA) then
                  do i = max(ista_g1k(ik),2), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     rrr  = rrr  + Rphi(iadd,1,ibt,i1)*Rphi(iadd,1,ibt,iter_rmm) + Rphi(iadd,2,ibt,i1)*Rphi(iadd,2,ibt,iter_rmm)
                     pspr = pspr + phi (iadd,1,ibt,i1)*phi (iadd,1,ibt,iter_rmm) + phi (iadd,2,ibt,i1)*phi (iadd,2,ibt,iter_rmm)
                  end do
                  if(ista_g1k(ik) == 1) then
                     rrr  = 2.d0*rrr  + Rphi(1,1,ibt,i1)*Rphi(1,1,ibt,iter_rmm)
                     pspr = 2.d0*pspr + phi (1,1,ibt,i1)*phi (1,1,ibt,iter_rmm)
                  else
                     rrr  = 2.d0*rrr
                     pspr = 2.d0*pspr
                  endif
               else
                  do i = ista_g1k(ik), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     rrr  = rrr  + Rphi(iadd,1,ibt,i1)*Rphi(iadd,1,ibt,iter_rmm) + Rphi(iadd,2,ibt,i1)*Rphi(iadd,2,ibt,iter_rmm)
                     rri  = rri  + Rphi(iadd,1,ibt,i1)*Rphi(iadd,2,ibt,iter_rmm) - Rphi(iadd,2,ibt,i1)*Rphi(iadd,1,ibt,iter_rmm)
                     pspr = pspr + phi (iadd,1,ibt,i1)*phi (iadd,1,ibt,iter_rmm) + phi (iadd,2,ibt,i1)*phi (iadd,2,ibt,iter_rmm)
                     pspi = pspi + phi (iadd,1,ibt,i1)*phi (iadd,2,ibt,iter_rmm) - phi (iadd,2,ibt,i1)*phi (iadd,1,ibt,iter_rmm)
                  end do
               end if
                                                  __TIMER_COMM_START(1622)
               call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,rri, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspi,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
               rr_e (i1,iter_rmm,ibt,1) = rrr;  rr_e (i1,iter_rmm,ibt,2) = rri
               psp_e(i1,iter_rmm,ibt,1) = pspr; psp_e(i1,iter_rmm,ibt,2) = pspi
            end do
         else if(iter_rmm == nrmm-1) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1    = igf(nbase(i,ik))
               phi_t(iadd,1) = zaj_l(iadd,ib,ik,1);    phi_t(iadd,2) = zaj_l(iadd,ib,ik,2)
               e1    = ekin_l(iadd) - eko_l(ib,ik)
               Rphi_t(iadd,1) = - (e1*phi_t(iadd,1)+bfft_l(2*iadd-1,1)*dnm+vnlph_l(iadd,ib,1))
               Rphi_t(iadd,2) = - (e1*phi_t(iadd,2)+bfft_l(2*iadd  ,1)*dnm+vnlph_l(iadd,ib,2))
            end do
            do i1 = 0, iter_rmm-1
               rrr = 0.d0; rri = 0.d0; pspr = 0.d0; pspi = 0.d0
               if(k_symmetry(ik) == GAMMA) then
                  do i = max(ista_g1k(ik),2), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     rrr  = rrr  + Rphi(iadd,1,ibt,i1)*Rphi_t(iadd,1) + Rphi(iadd,2,ibt,i1)*Rphi_t(iadd,2)
                     pspr = pspr + phi (iadd,1,ibt,i1)*phi_t (iadd,1) + phi (iadd,2,ibt,i1)*phi_t (iadd,2)
                  end do
                  if(ista_g1k(ik) == 1) then
                     rrr  = 2.d0*rrr  + Rphi(1,1,ibt,i1)*Rphi_t(1,1)
                     pspr = 2.d0*pspr + phi (1,1,ibt,i1)*phi_t (1,1)
                  else
                     rrr  = 2.d0*rrr
                     pspr = 2.d0*pspr
                  endif
               else
                  do i = ista_g1k(ik), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     rrr  = rrr  + Rphi(iadd,1,ibt,i1)*Rphi_t(iadd,1) + Rphi(iadd,2,ibt,i1)*Rphi_t(iadd,2)
                     rri  = rri  + Rphi(iadd,1,ibt,i1)*Rphi_t(iadd,2) - Rphi(iadd,2,ibt,i1)*Rphi_t(iadd,1)
                     pspr = pspr + phi (iadd,1,ibt,i1)*phi_t (iadd,1) + phi (iadd,2,ibt,i1)*phi_t (iadd,2)
                     pspi = pspi + phi (iadd,1,ibt,i1)*phi_t (iadd,2) - phi (iadd,2,ibt,i1)*phi_t (iadd,1)
                  end do
               end if
                                                  __TIMER_COMM_START(1622)
               call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,rri, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,pspi,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
               rr_e (i1,iter_rmm,ibt,1) = rrr;  rr_e (i1,iter_rmm,ibt,2) = rri
               psp_e(i1,iter_rmm,ibt,1) = pspr; psp_e(i1,iter_rmm,ibt,2) = pspi
            end do
            rrr = 0.d0; rri = 0.d0; pspr = 0.d0; pspi = 0.d0
            if(k_symmetry(ik) == GAMMA) then
               do i = max(ista_g1k(ik),2), iend_g1k(ik)
                  iadd = i - ista_g1k(ik) + 1
                  rrr  = rrr  + Rphi_t(iadd,1)*Rphi_t(iadd,1) + Rphi_t(iadd,2)*Rphi_t(iadd,2)
                  pspr = pspr + phi_t (iadd,1)*phi_t (iadd,1) + phi_t (iadd,2)*phi_t (iadd,2)
               end do
               if(ista_g1k(ik) == 1) then
                  rrr  = 2.d0*rrr  + Rphi_t(1,1)*Rphi_t(1,1)
                  pspr = 2.d0*pspr + phi_t (1,1)*phi_t (1,1)
               else
                  rrr  = 2.d0*rrr
                  pspr = 2.d0*pspr
               endif
            else
               do i = ista_g1k(ik), iend_g1k(ik)
                  iadd = i - ista_g1k(ik) + 1
                  rrr  = rrr  + Rphi_t(iadd,1)*Rphi_t(iadd,1) + Rphi_t(iadd,2)*Rphi_t(iadd,2)
                  rri  = rri  + Rphi_t(iadd,1)*Rphi_t(iadd,2) - Rphi_t(iadd,2)*Rphi_t(iadd,1)
                  pspr = pspr + phi_t (iadd,1)*phi_t (iadd,1) + phi_t (iadd,2)*phi_t (iadd,2)
                  pspi = pspi + phi_t (iadd,1)*phi_t (iadd,2) - phi_t (iadd,2)*phi_t (iadd,1)
               end do
            end if
                                                  __TIMER_COMM_START(1622)
            call mpi_allreduce(MPI_IN_PLACE,rrr, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,pspr,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,rri, 1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,pspi,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1622)
            rr_e (iter_rmm,iter_rmm,ibt,1) = rrr;  rr_e (iter_rmm,iter_rmm,ibt,2) = rri
            psp_e(iter_rmm,iter_rmm,ibt,1) = pspr; psp_e(iter_rmm,iter_rmm,ibt,2) = pspi
         else
            if(printable) write(nfout,'("  iter_rmm > nrmm-1 ( illegal relation) <<m_ES_WF_by_RMM.rmm1_3D>>")')
            stop '   iter_rmm > nrmm-1 ( illegal relation) <<m_ES_WF_by_RMM.rmm1_3D>>'
         end if
      end if

      if(iter_rmm == nrmm-1) then
         deallocate(Rphi_t)
         deallocate(phi_t)
      end if
      deallocate(p)
    end subroutine rmm1_3D



    subroutine evolve_WF_using_Residuals_3D(ib,nrmm,alpha)
!
!  * Rewritten by T. Uda and T. Yamasaki, 19th Mar. 2003
!      + alpha(nrmm-1) -> alpha(nrmm-1,kimg)
!
!  * Revised by T. Yamasaki, 18th Sep. 2004
!      + being changed not to use phi(:,:,:,nrmm-1) for saving the memory allocation area.
!      + phi(:,:,:,nrmm-1) is substituted to zaj_l before the program reached to this
!       subroutine.
! 
      integer, intent(in) ::                             ib, nrmm
      real(kind=DP),intent(in),dimension(nrmm-1,kimg) :: alpha
      integer ::                                         i, ibt, nr, ir, ii, j, ig, iadd
      real(kind=DP) ::                                   zr,zi

      if(rmm_save_memory_mode == ON) then
         ibt = 1
      else
         ibt = ib
      end if

      if(kimg==1) then
         ! previously in sub. rmm1, zaj_l(:,ib,ik,:) <= phi(:,:,ibt,nrmm-1)
         ! Following calculation is equivalent to
         !  zaj_l = phi(:,:,ibt,0) + alpha(nrmm-1)*phi(:,:,ibt,nrmm-1)
         !    |WF> = |phi_0> + alpha(nrmm-1)|phi_{nrmm-1}>
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            zaj_l(iadd,ib,ik,1) = phi(iadd,1,ibt,0) + alpha(nrmm-1,1)*zaj_l(iadd,ib,ik,1)
         end do
         do ir = 1, nrmm-2
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               zaj_l(iadd,ib,ik,1) = zaj_l(iadd,ib,ik,1) + alpha(ir,1)*phi(iadd,1,ibt,ir)
            end do
         end do
      else if(kimg==2) then
         ! previously in <sub. rmm1>, zaj_l(:,ib,ik,:) <-- phi(:,:,ibt,nrmm-1)
         nr = nrmm-1
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            !   Calculation in this do-loop is equivalent to 
            !  zaj_l(:,ib,ik,:) = phi(:,:,ibt,0) + alpha(nrmm-1)*phi(:,:,ibt,nrmm-1),
            !  namely, |WF> = |phi_0> + alpha(nrmm-1)|phi_{nrmm-1}>
            zr = zaj_l(iadd,ib,ik,1)
            zi = zaj_l(iadd,ib,ik,2)
            zaj_l(iadd,ib,ik,1) = phi(iadd,1,ibt,0) + alpha(nr,1)*zr - alpha(nr,2)*zi
            zaj_l(iadd,ib,ik,2) = phi(iadd,2,ibt,0) + alpha(nr,1)*zi + alpha(nr,2)*zr
         end do

         do i = 1, nrmm-2
            do ig = ista_g1k(ik), iend_g1k(ik)
               iadd = ig - ista_g1k(ik) + 1
               zaj_l(iadd,ib,ik,1) = zaj_l(iadd,ib,ik,1) + alpha(i,1)*phi(iadd,1,ibt,i) - alpha(i,2)*phi(iadd,2,ibt,i)
               zaj_l(iadd,ib,ik,2) = zaj_l(iadd,ib,ik,2) + alpha(i,1)*phi(iadd,2,ibt,i) + alpha(i,2)*phi(iadd,1,ibt,i)
            end do
         end do
      else
         stop ' kimg is illegal (evolve_WF_using_Residuals_3D)'
      end if
#ifdef SAVE_FFT_TIMES
      if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif

      if(iprirmm >= 3) then
         ibt = 100
         if(ista_g1k(ik) == 1) then
            if(ibt > iend_g1k(ik)) ibt = iend_g1k(ik)
            if(ik <= 2 .or. ik >= kv3-1) then
               write(nfout,'(" !rmm  zaj_l in <<evolve_WF_using_Residuals_3D>>")')
               write(nfout,'(" !rmm  ik, ib = ",2i8)') ik, ib
               if(kimg == 2) write(nfout,'(" !rmm -- real part --")')
               write(nfout,'(" !rmm  ",8f8.4)') (zaj_l(i,ib,ik,1),i=1,ibt)
               if(kimg == 2) write(nfout,'(" !rmm -- imaginary part --")')
               write(nfout,'(" !rmm  ",8f8.4)') (zaj_l(i,ib,ik,2),i=1,ibt)
            end if
         end if
      end if

    end subroutine evolve_WF_using_Residuals_3D

    subroutine wd_rr_and_psp(nrmm,rr,psp)
      integer, intent(in)                                        :: nrmm
      real(kind=DP),intent(in),dimension(0:nrmm-1,0:nrmm-1,kimg) :: rr,psp
      integer :: i, j
      write(nfout,'("!rr =",6d15.7)') ((rr(i,j,1),j=i,nrmm-1),i=0,nrmm-1)
      write(nfout,'("!psp=",6d15.7)') ((psp(i,j,1),j=i,nrmm-1),i=0,nrmm-1)
    end subroutine wd_rr_and_psp

    subroutine wd_alpha(nrmm,alpha)
      integer, intent(in)                          :: nrmm
      real(kind=DP), intent(in), dimension(nrmm-1,kimg) :: alpha

      write(nfout,'(" ! alpha(1) = ", f20.10)') alpha(1,1)
      if(nrmm == 3) write(nfout,'(" ! alpha(2) = ", f20.10)') alpha(2,1)
    end subroutine wd_alpha

    subroutine rmm_n_uda_3D(ik,ibo,nrmm)
      integer,       intent(in) :: ik,ibo, nrmm

      real(DP) :: rr(0:nrmm-1,0:nrmm-1,kimg),psp(0:nrmm-1,0:nrmm-1,kimg)
      real(DP) :: alpha(nrmm-1,kimg)
      integer  :: ib
      integer :: id_sname = -1
      call tstatc0_begin('rmm_n_uda_3D ', id_sname)

      ib = ibo
!!$      call rr_and_psp_from_Rphi_and_phi(ib,nrmm,rr,psp) !-(m_ES_WF_by_RMM)
      call rr_and_psp_from_rr_e_and_psp_e_3D(ib,nrmm,rr,psp) ! -(m_ES_WF_by_RMM)
      !   rr(i,j) = <R_i|R_j>; psp(i,j) = <Phi_i|S|Phi_j>
      !                            S = 1 + \sum_{ij}q_{ij}|b_i><b_j|
      rr_avr = rr_avr + rr(0,0,1)
      if(rr(0,0,1) <= rr_Critical_Value) rr_is_over_or_under(ib,ik) = UNDER

    !!$  call normalization_of_rr_and_psp(nrmm,rr,psp)
      !   rr(i,j) = rr(i,j)/rr(0,0), psp(i,j) = psp(i,j)/psp(0,0)

      if(iprirmm >= 2) call wd_rr_and_psp(nrmm,rr,psp)

      if(kimg == 1) then
         if(nrmm == 2) then
            call rmm2_uda(iprirmm,nrmm,rr,psp,alpha)
         else
            call rmm3_uda(iprirmm,nrmm,rr,psp,alpha)
         end if
      else
         if(nrmm == 2) then
            call crmm2_uda(iprirmm,nrmm,rr,psp,alpha)
         else
            call crmm3_uda(iprirmm,nrmm,rr,psp,alpha)
         end if
      end if

      if(iprirmm >= 2) call wd_alpha(nrmm,alpha)
      call evolve_WF_using_Residuals_3D(ib,nrmm,alpha) ! -(contained subr. m_ESrmm_renew_WF)
      if(iprirmm>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
      !   phi,alpha ->zaj_l(:,ib,ik,:)
      !   |WF> = |phi_0> + alpha(1)|phi_1> + alpha(2)|phi_2> , when nrmm == 3
      call tstatc0_end(id_sname)
    end subroutine rmm_n_uda_3D

    subroutine rg_or_cg(nrmm,ymat,eigenr,eigeni,vector,ww1,ww2,ww3)
      integer, intent(in) :: nrmm
      real(DP), dimension(0:nrmm-1,0:nrmm-1,kimg):: ymat
      real(DP), intent(out),dimension(0:nrmm-1)  :: eigenr, eigeni
      real(DP), intent(out),dimension(0:nrmm-1,0:nrmm-1,kimg):: vector
      real(DP), intent(out),dimension(nrmm*kimg) :: ww1,ww2,ww3
      integer                                    :: ier
      if(kimg == 1) then
         call rg_eispack(nrmm,nrmm,ymat,eigenr,eigeni,1,vector,ww1,ww2,ier)
      else if(kimg == 2) then
         call cg_eispack(nrmm,nrmm,ymat(0,0,1),ymat(0,0,kimg),eigenr,eigeni,1 &
              &, vector(0,0,1),vector(0,0,kimg),ww1,ww2,ww3,ier)
      end if
      if(ier /= 0 .and. printable) write(nfout,*) 'ier(rg_or_cg) = ',ier
    end subroutine rg_or_cg
      
    subroutine solveAYB(nrmm,psp,rr,ymat,ip)
      integer, intent(in) :: nrmm
      real(DP),intent(in), dimension(0:nrmm-1,0:nrmm-1,kimg):: psp,rr
      real(DP),intent(out),dimension(0:nrmm-1,0:nrmm-1,kimg):: ymat
      integer, intent(out),dimension(nrmm) :: ip(nrmm)
      
      if(kimg == 1) then
         call rsolve(nrmm,nrmm,psp,rr,ymat,ip)
      else
         call csolve2(nrmm,nrmm,psp,rr,ymat,ip)
      end if
    end subroutine solveAYB

    subroutine LUdecomp(nrmm,psp,ww1,ip,ier)
      integer, intent(in) :: nrmm
      real(DP),intent(inout), dimension(0:nrmm-1,0:nrmm-1,kimg):: psp
      real(DP),intent(out),dimension(nrmm*kimg)                :: ww1
      integer, intent(out)                 :: ip(nrmm), ier

      complex(CMPLDP)                      :: cpsp(nrmm*nrmm)
      integer i, j, n
      if(kimg == 1) then
         call rdecomp(nrmm,psp,ww1,ip,ier)
      else
         n = 0
         do j = 0, nrmm-1
            do i = 0, nrmm-1
               n = n + 1 
               cpsp(n) = cmplx(psp(i,j,1),psp(i,j,2))
            end do
         end do
         call cdecomp(nrmm,cpsp,ww1,ip,ier)
      end if
    end subroutine LUdecomp


    subroutine rr_and_psp_from_rr_e_and_psp_e_3D(ib_t,nrmm,rr,psp)
      integer, intent(in)       :: ib_t,nrmm
      real(DP),intent(out),dimension(0:nrmm-1,0:nrmm-1,kimg)::rr,psp
      real(DP), dimension(kimg) :: sumqff
      integer  ::                  j,i,m,ri, ib

      if(rmm_save_memory_mode == ON) then
         ib = 1
      else
         ib = ib_t
      end if

      rr = 0.d0; psp = 0.d0
      do j = 0, nrmm-1
         do i = 0,j
            call phsphn_3D(i,j,ib,kimg,sumqff)  ! ->sumqff (= \sum_{n1,n2}q_{n1,n2}<W|b_{nl}><b_{n2}|W>
            do ri = 1, kimg
               rr(i,j,ri)  = rr_e(i,j,ib,ri)
               psp(i,j,ri) = psp_e(i,j,ib,ri)
               rr( j,i,ri) = pm(ri) * rr(i,j,ri)      ! pm=1,-1 (ri==1,2)
               psp(i,j,ri) = psp(i,j,ri) + sumqff(ri)
               psp(j,i,ri) = pm(ri) * psp(i,j,ri)
            end do
         end do
      end do

    end subroutine rr_and_psp_from_rr_e_and_psp_e_3D

    subroutine phsphn_3D(i,j,ib,nimg,sumqff)
      integer, intent(in)        :: i, j, ib, nimg  ! ib = 1 when save_memory_mode == ON
      real(kind=DP), intent(out) :: sumqff(nimg)
      integer         :: ia,m,n

      sumqff = 0.d0
      if(modnrm == EXECUT) then
         do ia = 1, nac
            m = nlmta1(ia); n = nlmta2(ia)
            sumqff(1) = sumqff(1) + fqwei(ia)*(bWr(m,i,ib)*bWr(n,j,ib)+bWi(m,i,ib)*bWi(n,j,ib))
         end do
         if(nimg == 2) then
            do ia = 1, nac
               m = nlmta1(ia); n = nlmta2(ia)
               sumqff(2) = sumqff(2) + fqwei(ia)*(bWr(m,i,ib)*bWi(n,j,ib)-bWi(m,i,ib)*bWr(n,j,ib))
            end do
         end if
      end if
    end subroutine phsphn_3D

    subroutine normalization_of_rr_and_psp(nrmm,rr,psp)
      integer, intent(in) :: nrmm
      real(DP),intent(out),dimension(0:nrmm-1,0:nrmm-1,kimg)::rr,psp
      real(DP) :: divrr,divpsp

      divrr = 1.d0/rr(0,0,1); divpsp = 1.d0/psp(0,0,1)
      rr    =  rr*divrr
      psp   = psp*divpsp

      if(iprirmm >= 2) call wd_rr_and_psp(nrmm,rr,psp)
    end subroutine normalization_of_rr_and_psp

    subroutine pre_calc_phase
!f      call mltpha4(natm,rmm_precal_phase_matm,pos,PAI2,kgp,ngabc,kg1,nbase(1,ik),iba(ik) &
!f           &     ,phasec,phases)
      call mltpha4(natm,rmm_precal_phase_matm,pos,PAI2,kg,ngabc,kg1,nbase(1,ik),iba(ik) &
           &     ,phasec,phases)
      if(rmm_precal_phase_matm < natm) then
!f         call setglist4(n_min(1),n_max(1),n_min(2),n_max(2) &  ! -(b_E.S.)
!f              &, n_min(3),n_max(3),nbase(1,ik),ngabc,kgp,iba(ik),nglist)
         call setglist4(n_min(1),n_max(1),n_min(2),n_max(2) &  ! -(b_E.S.)
              &, n_min(3),n_max(3),nbase(1,ik),ngabc,kg,iba(ik),nglist)
         call crngabc4(n_min(1),n_max(1),n_min(2),n_max(2) &   ! -(b_E.S.)
              &, n_min(3),n_max(3),nglist,kg1,nngabc,newp)
      end if

      if(iprirmm >= 2) then
         if(allocated(nglist)) then
            write(nfout,'(" !!rmm nglist is allocated <<pre_calc_phase>>")')
         else
            write(nfout,'(" !!rmm nglist is not allocated <<pre_calc_phase>>")')
         end if
      end if

    end subroutine pre_calc_phase

    subroutine zf_listing
      integer       :: ia
      real(kind=DP) :: f(3)

      integer :: id_sname = -1
      call tstatc0_begin('zf_listing ',id_sname)
      do ia = rmm_precal_phase_matm+1, natm
         f = pos(ia,1:3)*PAI2
         call zf_list_s(n_min(1),n_max(1),rmm_precal_phase_matm,natm,f(1),ia,zfc1,zfs1)
         call zf_list_s(n_min(2),n_max(2),rmm_precal_phase_matm,natm,f(2),ia,zfc2,zfs2)
         call zf_list_s(n_min(3),n_max(3),rmm_precal_phase_matm,natm,f(3),ia,zfc3,zfs3)
         !                 -(b_Electronic_Structure)
      end do
      call tstatc0_end(id_sname)

    end subroutine zf_listing
  end subroutine m_ESrmm_renew_WF


  subroutine Vnonlocal_W_RMM_3D(ik,ibo,ispin,matm,iter_rmm)
    integer, intent(in) :: ik,ibo,ispin,matm,iter_rmm
    integer :: mdvdb, it, ia, lmt2, lmta2, ib
    real(kind=DP), allocatable,dimension(:)        :: ar, ai               ! d(kg1)
    real(kind=DP), allocatable,dimension(:)        :: zfcos, zfsin               ! d(nbmx)
    real(kind=DP), allocatable,target,dimension(:) :: sc, ss, qc, qs ! d(kg1)

    integer :: id_sname = -1
    call tstatc0_begin('Vnonlocal_W_RMM_3D ',id_sname)

    ib = ibo        ! MPI
    vnlph_l(:,ib,:) = 0.d0
    call alloc_zfsincos_arai()
    call alloc_scssqcqs()

    Loop_ntyp: do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       Loop_natm : do ia = 1, natm
          if(ityp(ia) /= it) cycle
          call calc_phase_RMM(ik,ia,matm)  ! (zfc1,2,3,zfs1,2,3)-> zfcos,zfsin
          call sumset_rmm(ik,ib,iter_rmm,it,ia) ! zfcos,zfsin,sc,ss,zaj,snl -> bWr,bWi
          do lmt2 = 1, ilmt(it)
             lmta2 = lmta(lmt2,ia)
             call Vnonlocal_W_part_sum_over_lmt1(ispin,ik,it,ia,lmt2,mdvdb)
             if(mdvdb == SKIP) then
                call add_vnlph_l_without_eko_part1(ik,ib,lmta2,iter_rmm)
             else if(mdvdb == EXECUT) then
                call add_vnlph_l_with_eko_part1(ik,ib,lmta2,iter_rmm)
             endif
          end do
       end do Loop_natm
    end do Loop_ntyp
    call dealloc_scssqcqs()
    call dealloc_zfsincos_arai()
    call tstatc0_end(id_sname)
  contains
    subroutine alloc_zfsincos_arai()
      allocate(zfsin(nbmx)); allocate(zfcos(nbmx))
      allocate(ar(maxval(np_g1k))); allocate(ai(maxval(np_g1k)))
    end subroutine alloc_zfsincos_arai

    subroutine dealloc_zfsincos_arai()
      deallocate(ai,ar,zfcos,zfsin)
    end subroutine dealloc_zfsincos_arai

    subroutine alloc_scssqcqs()
      allocate(sc(maxval(np_g1k)))
      allocate(ss(maxval(np_g1k)))
      allocate(qc(maxval(np_g1k)))
      allocate(qs(maxval(np_g1k)))
    end subroutine alloc_scssqcqs

    subroutine dealloc_scssqcqs()
      deallocate(qs,qc,ss,sc)
    end subroutine dealloc_scssqcqs

    subroutine calc_phase_RMM(ik,ia,matm)
      integer, intent(in) :: ik,ia,matm

      integer  :: i, nb, n1,n2,n3
      real(DP) :: z12r,z12i
      integer :: id_sname = -1
      call tstatc0_begin('calc_phase_RMM ',id_sname)

      if(ia <= matm) then
         do i = 1, iba(ik)
            zfcos(i) = phasec(i,ia)
            zfsin(i) = phases(i,ia)
         end do
      else
         do i = 1, iba(ik)
            nb = newp(i)
            n1=nngabc(i,1); n2=nngabc(i,2); n3=nngabc(i,3)
            z12r = zfc1(n1,ia)*zfc2(n2,ia)-zfs1(n1,ia)*zfs2(n2,ia)
            z12i = zfs1(n1,ia)*zfc2(n2,ia)+zfc1(n1,ia)*zfs2(n2,ia)
            zfcos(nb) = zfc3(n3,ia)*z12r - zfs3(n3,ia)*z12i
            zfsin(nb) = zfs3(n3,ia)*z12r + zfc3(n3,ia)*z12i
         end do
      end if
      call tstatc0_end(id_sname)
    end subroutine calc_phase_RMM

    subroutine Vnonlocal_W_part_sum_over_lmt1(ispin,ik,it,ia,lmt2,mdvdb)
      integer, intent(in) :: ispin,ik,it,ia,lmt2,mdvdb
      integer             :: lmt1, lmtt1, il1, im1, il11, mdl, iksnl,il2,im2, ii, i, iadd
      real(kind=DP)       :: tmp

      integer :: id_sname = -1
      call tstatc0_begin('Vnonlocal_W_part_sum_over_lmt1 ',id_sname)

      iksnl = (ik-1)/nspin + 1
      il2   = ltp(lmt2,it)
      im2   = mtp(lmt2,it)

      sc = 0.d0; ss = 0.d0
      if(mdvdb == EXECUT) then
         qc = 0.d0; qs = 0.d0
      endif

      do lmt1 = 1,ilmt(it)
         lmtt1 = lmtt(lmt1,it)
         il1   = ltp(lmt1,it)
         im1   = mtp(lmt1,it)
         il11  = il1 - 1
         mdl   = mod(il11,4)
         if(il1 == il2 .and. im1 == im2) then
!!$            tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
          if(ipaw(it)==0) then
              tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
          else
              tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
          end if
         else
!!$            tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
          if(ipaw(it)==0) then
              tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
          else
              tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
          end if
         endif
         tmp = tmp * iwei(ia)
         if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
         if(mdl == 0 .or. mdl == 2) then
            do ii = ista_g1k(ik), iend_g1k(ik)
               iadd = ii - ista_g1k(ik) + 1
               sc(iadd) = sc(iadd) + tmp*zfcos(ii)*snl(ii,lmtt1,iksnl)
               ss(iadd) = ss(iadd) - tmp*zfsin(ii)*snl(ii,lmtt1,iksnl)
            end do
         else if(mdl == 1 .or. mdl == 3) then
            do ii = ista_g1k(ik), iend_g1k(ik)
               iadd = ii - ista_g1k(ik) + 1
               sc(iadd) = sc(iadd) - tmp*zfsin(ii)*snl(ii,lmtt1,iksnl)
               ss(iadd) = ss(iadd) - tmp*zfcos(ii)*snl(ii,lmtt1,iksnl)
            end do
         end if
         if(mdvdb == EXECUT .and. il1 == il2 .and. im1 == im2) then
            tmp = q(lmt1,lmt2,it)*iwei(ia)
            if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
            if(mdl == 0 .or. mdl == 2) then
               do ii = ista_g1k(ik), iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  qc(iadd) = qc(iadd) + tmp*zfcos(ii)*snl(ii,lmtt1,iksnl)
                  qs(iadd) = qs(iadd) - tmp*zfsin(ii)*snl(ii,lmtt1,iksnl)
               end do
            else if(mdl == 1 .or. mdl == 3) then
               do ii = ista_g1k(ik), iend_g1k(ik)
                  iadd = ii - ista_g1k(ik) + 1
                  qc(iadd) = qc(iadd) - tmp*zfsin(ii)*snl(ii,lmtt1,iksnl)
                  qs(iadd) = qs(iadd) - tmp*zfcos(ii)*snl(ii,lmtt1,iksnl)
               end do
            end if
         end if
      end do
      call tstatc0_end(id_sname)
    end subroutine Vnonlocal_W_part_sum_over_lmt1

    subroutine sumset_rmm(ik,ib,iter_rmm,it,ia)
      integer, intent(in) :: ik,ib,iter_rmm,it,ia

      integer  :: lmt1, lmtt1, lmta1, il1, i, iksnl, il2, iadd
      real(DP) :: temp, fsrt,fsit,ar,ai,crt1,cit1

      iksnl = (ik-1)/nspin + 1
      do lmt1 = 1, ilmt(it)
         lmtt1 = lmtt(lmt1,it)
         lmta1 = lmta(lmt1,ia)
         il1   = ltp(lmt1,it)
         fsrt = 0.d0; fsit = 0.d0
         if(kimg == 1) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               temp = snl(i,lmtt1,iksnl)*zaj_l(iadd,ib,ik,1)
               fsrt = fsrt + zfcos(i)*temp
               fsit = fsit + zfsin(i)*temp
            end do
                                                  __TIMER_COMM_START(1623)
            call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1623)
         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               il2 = mod(il1,2) ! il2 = 1 -> l=0,2,4,..,: il2 = 0 -> l=1,3,5,7,...
               if(il2 == 1) then
                  do i = max(2,ista_g1k(ik)), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     ar = zfcos(i)*snl(i,lmtt1,iksnl)
                     ai = zfsin(i)*snl(i,lmtt1,iksnl)
                     crt1 = zaj_l(iadd,ib,ik,1)
                     cit1 = zaj_l(iadd,ib,ik,2)
                     fsrt = fsrt + ar*crt1 - ai*cit1
                  end do
                  if(ista_g1k(ik) == 1) then
                     fsrt = 2.d0*fsrt + zaj_l(1,ib,ik,1)*snl(1,lmtt1,iksnl)
                  else
                     fsrt = 2.d0*fsrt
                  endif
               else
                  do i = max(2,ista_g1k(ik)), iend_g1k(ik)
                     iadd = i - ista_g1k(ik) + 1
                     ar = zfcos(i)*snl(i,lmtt1,iksnl)
                     ai = zfsin(i)*snl(i,lmtt1,iksnl)
                     crt1 = zaj_l(iadd,ib,ik,1)
                     cit1 = zaj_l(iadd,ib,ik,2)
                     fsit = fsit + ai*crt1 + ar*cit1
                  end do
                  fsit = 2.d0*fsit
               end if
                                                  __TIMER_COMM_START(1623)
               call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1623)
            else
               do i = ista_g1k(ik), iend_g1k(ik)
                  iadd = i - ista_g1k(ik) + 1
                  ar = zfcos(i)*snl(i,lmtt1,iksnl)
                  ai = zfsin(i)*snl(i,lmtt1,iksnl)
                  crt1     = zaj_l(iadd,ib,ik,1)
                  cit1     = zaj_l(iadd,ib,ik,2)
                  fsrt = fsrt + ar*crt1-ai*cit1
                  fsit = fsit + ai*crt1+ar*cit1
               end do
                                                  __TIMER_COMM_START(1623)
               call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1623)
            end if
         end if

         i = mod(il1,4)
         if(i == 2) then
            temp =  fsit;         fsit =  fsrt;         fsrt = -temp
         else if(i == 3) then
            fsrt = -fsrt;         fsit = -fsit;
         else if(i == 0) then
            temp =  fsit;         fsit = -fsrt;         fsrt = temp
         end if
         bWr(lmta1,iter_rmm,1) = fsrt; bWi(lmta1,iter_rmm,1) = fsit
      end do
    end subroutine sumset_rmm

    subroutine add_vnlph_l_without_eko_part1(ik,ib,lmta2,iter_rmm)
      integer, intent(in) :: ik,ib,lmta2,iter_rmm
      real(kind=DP) :: bWFr, bWFi
      integer       :: i, iadd

      bWFr = bWr(lmta2,iter_rmm,1); bWFi = bWi(lmta2,iter_rmm,1)

      if(kimg == 1) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sc(iadd)-bWFi*ss(iadd)
         enddo
      else if(kimg == 2) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sc(iadd)-bWFi*ss(iadd)
            vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sc(iadd)+bWFr*ss(iadd)
         enddo
      endif
    end subroutine add_vnlph_l_without_eko_part1

    subroutine add_vnlph_l_with_eko_part1(ik,ib,lmta2,iter_rmm)
      integer, intent(in) :: ik,ib,lmta2,iter_rmm
      real(kind=DP) :: bWFr, bWFi, e
      integer       :: i, iadd

      integer :: id_sname = -1
      call tstatc0_begin('add_vnlph_l_with_eko_part1 ',id_sname)

      bWFr = bWr(lmta2,iter_rmm,1); bWFi = bWi(lmta2,iter_rmm,1); e = eko_l(ib,ik)

      if(kimg == 1) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc(iadd)-e*qc(iadd)) &
                                                      - bWFi*(ss(iadd)-e*qs(iadd))
         enddo
      else if(kimg == 2) then
         do i = ista_g1k(ik), iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc(iadd)-e*qc(iadd)) &
                                                      - bWFi*(ss(iadd)-e*qs(iadd))
            vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*(sc(iadd)-e*qc(iadd)) &
                                                      + bWFr*(ss(iadd)-e*qs(iadd))
         enddo
      endif
      call tstatc0_end(id_sname)
    end subroutine add_vnlph_l_with_eko_part1
  end subroutine Vnonlocal_W_RMM_3D

  subroutine Vnonlocal_W_RMMn_3D(nfout,ik,ispin,iter_rmm)
    integer, intent(in) :: nfout,ik,ispin,iter_rmm
    integer :: mdvdb, it, ia, lmt2, lmta2
#ifdef NONLOCAL_RMM_DGEMM
    integer :: ia_p, iap, lmta1
#endif
    integer :: n_ialist, n_ialist0, ia_start, n_iagroup, n_ia, ia_g, max_n_ialist0 ,nbmx_adj, kg1_adj
    real(kind=DP), allocatable,dimension(:,:) ::  ar_x, ai_x                      ! d(kg1_adj,n_ialist0)
    real(kind=DP), allocatable,dimension(:,:) ::  zfcos_x, zfsin_x                ! d(nbmx,n_ialist0)
    real(kind=DP), allocatable,target,dimension(:,:) :: sc_x,ss_x,qc_x,qs_x ! d(kg1+,n_ialist))
#ifdef NONLOCAL_RMM_DGEMM
    real(kind=DP), allocatable,target,dimension(:,:) :: sc_lmt, ss_lmt, qc_lmt, qs_lmt  ! d(kg1+,n_ialist))
#endif
    integer, allocatable, dimension(:) :: ia_list
    real(kind=DP), allocatable, dimension(:,:) :: fq
#ifdef NONLOCAL_RMM_DGEMM
    real(kind=DP), allocatable, dimension(:,:) :: bWr_lmt, bWi_lmt
#endif
    integer :: id_sname = -1
    call tstatc0_begin('Vnonlocal_W_RMMn_3D ',id_sname,1)

#ifdef NONLOCAL_RMM_DGEMM
    n_ialist = 16
#else
    n_ialist = 1
#ifdef HIUX
    n_ialist = 16
#endif
#ifdef VPP
    n_ialist = 1
#endif
#ifdef SX
    n_ialist = 8
#endif
#endif
    if(n_ialist <=0) stop 'n_ialist is illegal <<Vnonlocal_W_RMMn_3D>>'
    call find_max_n_ialist0(max_n_ialist0)
    if(iprirmm >= 2) write(nfout,'(" !Vnonlocal_W_RMMn_3D: max_n_ialist0 = ",i8)') max_n_ialist0
    nbmx_adj = nbmx
    if(mod(nbmx_adj,2) == 0) nbmx_adj = nbmx_adj+1
    kg1_adj = kg1
    if(mod(kg1_adj,2) == 0) kg1_adj = kg1_adj+1

    allocate(zfsin_x(maxval(np_g1k),max_n_ialist0))
    allocate(zfcos_x(maxval(np_g1k),max_n_ialist0))
    allocate(ar_x(maxval(np_g1k),max_n_ialist0))
    allocate(ai_x(maxval(np_g1k),max_n_ialist0))
    allocate(ia_list(n_ialist)); ia_list = 0
    allocate(fq(n_ialist,2)); fq = 0.d0

    vnlph_l(:,:,:) = 0.d0
    Loop_ntyp: do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
#ifdef NONLOCAL_RMM_DGEMM
       call alloc_scssqcqs_lmt(maxval(np_g1k),max_n_ialist0*ilmt(it),mdvdb)
#endif
       call alloc_scssqcqs_x(maxval(np_g1k),max_n_ialist0,mdvdb)

       n_ia = 0
       do ia = 1, natm
          if(ityp(ia) == it) n_ia = n_ia + 1
       end do

       n_iagroup = n_ia/n_ialist + 1
       ia_start = 1
       if(iprirmm >= 2) write(nfout,'(" !Vnonlocal_W_RMMn_3D: n_iagroup = ",i8, " ityp = ",i8)') n_iagroup,it
       Loop_ia_group: do ia_g = 1, n_iagroup
          n_ialist0 = 0
          ia_list = 0
          AtomcountLoop: do ia = ia_start, natm
             if(ityp(ia) == it) then
                n_ialist0 = n_ialist0 + 1
                ia_list(n_ialist0) = ia
             end if
              if(n_ialist0 >= n_ialist) exit AtomcountLoop
          end do AtomcountLoop
          ia_start = ia+1
          if(n_ialist0 >= 1 )then
             if(iprirmm >= 2) write(nfout,'(" !m_ES_WF_by_RMM.Vnonlocal_W_RMMn_3D: ia_list = ",8i8)') (ia_list(ia),ia=1,n_ialist0)

START_TIMER(1613)
!f             call calc_phasek_b_3D(natm,pos,n_ialist0,ia_list,kgp,ista_g1k(ik),iend_g1k(ik) &
!f                  & ,ngabc,kg1,nbase(1,ik),maxval(np_g1k),zfcos_x,zfsin_x) ! b_E.S.
             call calc_phasek_b_3D(natm,pos,n_ialist0,ia_list,kg,ista_g1k(ik),iend_g1k(ik) &
                  & ,ngabc,kg1,nbase(1,ik),maxval(np_g1k),zfcos_x,zfsin_x) ! b_E.S.
STOP_TIMER(1613)
#ifdef NONLOCAL_RMM_DGEMM
             call alloc_bW_lmt(it)                ! alloc bWr_lmt, bWi_lmp (np_e, n_ialist0*ilmt(it))
START_TIMER(1614)
             call sumset_rmm_all4()               ! zfcos,zfsin,sc,ss,zaj,snl -> bWr_tmp,bWi_tmp, bWr, bWi
STOP_TIMER(1614)

START_TIMER(1615)
             call Vnonlocal_W_part_sum_ovr_lmt4() ! -> sc_x,ss_x,qc_x,qs_x
STOP_TIMER(1615)
START_TIMER(1616)
             call add_vnlph_l_part4(mdvdb)
STOP_TIMER(1616)

             call dealloc_bW_lmt                  ! alloc bWr_lmt, bWi_lmp (np_e, n_ialist0*ilmt(it))
#else
START_TIMER(1617)
             call sumset_rmm_all3()                         ! zfcos,zfsin,sc,ss,zaj,snl -> bWr,bWi
STOP_TIMER(1617)
             do lmt2 = 1, ilmt(it)
START_TIMER(1618)
                call Vnonlocal_W_part_sum_over_lmt1b()      ! -> sc_x,ss_x,qc_x,qs_x
STOP_TIMER(1618)
                if(mdvdb == SKIP) then
START_TIMER(1619)
                   call add_vnlph_l_without_eko_part3()     ! -> vnlph_l
STOP_TIMER(1619)
                else if(mdvdb == EXECUT) then
START_TIMER(1620)
                   call add_vnlph_l_with_eko_part3()        ! -> vnlph_l
STOP_TIMER(1620)
                endif
             end do
#endif
          end if
       end do Loop_ia_group
       call dealloc_scssqcqs_x()
#ifdef NONLOCAL_RMM_DGEMM
       call dealloc_scssqcqs_lmt()
#endif
    end do Loop_ntyp

    deallocate(fq)
    deallocate(ai_x,ar_x)
    deallocate(ia_list)
    deallocate(zfsin_x,zfcos_x)
    call tstatc0_end(id_sname)
  contains
#ifdef NONLOCAL_RMM_DGEMM
    subroutine alloc_scssqcqs_lmt(kg1_adj,m,mdvdb)
      integer, intent(in) :: kg1_adj,m,mdvdb
      allocate(sc_lmt(kg1_adj,m))
      allocate(ss_lmt(kg1_adj,m))
      if(mdvdb == EXECUT) then
         allocate(qc_lmt(kg1_adj,m))
         allocate(qs_lmt(kg1_adj,m))
      end if
    end subroutine alloc_scssqcqs_lmt

    subroutine dealloc_scssqcqs_lmt()
      deallocate(sc_lmt,ss_lmt)
      if(mdvdb == EXECUT) deallocate(qc_lmt,qs_lmt)
    end subroutine dealloc_scssqcqs_lmt
#endif
    subroutine alloc_scssqcqs_x(kg1_adj,m,mdvdb)
      integer, intent(in) :: kg1_adj,m,mdvdb
      allocate(sc_x(kg1_adj,m))
      allocate(ss_x(kg1_adj,m))
      if(mdvdb == EXECUT) then
         allocate(qc_x(kg1_adj,m))
         allocate(qs_x(kg1_adj,m))
      end if
    end subroutine alloc_scssqcqs_x

    subroutine dealloc_scssqcqs_x()
      if(allocated(qs_x)) deallocate(qs_x)
      if(allocated(qc_x)) deallocate(qc_x)
      deallocate(ss_x,sc_x)
    end subroutine dealloc_scssqcqs_x

    subroutine find_max_n_ialist0(n)
       integer, intent(out) :: n

       n = 0
       do it = 1, ntyp

          n_ia = 0
          do ia = 1, natm
             if(ityp(ia) == it) n_ia = n_ia + 1
          end do

          n_iagroup = n_ia/n_ialist + 1
          ia_start = 1
          if(iprirmm >= 2) write(nfout,'(" !m_ES_WF_by_RMM.Vnonlocal_W_RMMn_3D: n_iagroup = ",i8, " ityp = ",i8)') n_iagroup,it
          do ia_g = 1, n_iagroup
             n_ialist0 = 0
             AtomcountLoop: do ia = ia_start, natm
                if(ityp(ia) == it)  n_ialist0 = n_ialist0 + 1
                if(n_ialist0 >= n_ialist) exit AtomcountLoop
             end do AtomcountLoop
             if(n < n_ialist0) n = n_ialist0
             ia_start = ia+1
           end do
        end do

     end subroutine find_max_n_ialist0

#ifdef NONLOCAL_RMM_DGEMM
    subroutine alloc_bW_lmt(it)
      integer, intent(in) :: it
      integer :: nsize1
      nsize1 = n_ialist0 * ilmt(it)
      allocate(bWr_lmt(nsize1,np_e))
      allocate(bWi_lmt(nsize1,np_e))
    end subroutine alloc_bW_lmt

    subroutine dealloc_bW_lmt()
      deallocate(bWr_lmt)
      deallocate(bWi_lmt)
    end subroutine dealloc_bW_lmt

    subroutine sumset_rmm_all4()
      integer  :: lmt1, lmtt1, lmta1, i, iksnl, ib, il1, ia, iap, il2, iadd
      integer :: M, N, K
      real(kind=DP) :: fsrt, fsit
      real(kind=DP), allocatable, dimension(:,:) :: bWr_tmp, bWi_tmp
      integer :: id_sname = -1
      call tstatc0_begin('sumset_rmm_all4 ',id_sname)

      allocate(bWr_tmp(n_ialist0,np_e)); bWr_tmp = 0.d0
      allocate(bWi_tmp(n_ialist0,np_e)); bWi_tmp = 0.d0

      iksnl = (ik-1)/nspin + 1
      do lmt1 = 1, ilmt(it)
         lmtt1 = lmtt(lmt1,it)
         il1   = ltp(lmt1,it)
         do iap = 1, n_ialist0
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!              ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(i,lmtt1,iksnl)
!              ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(i,lmtt1,iksnl)
               ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
               ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         end do


         M = n_ialist0; N = np_e; K = iend_g1k(ik) - ista_g1k(ik) + 1
         if(kimg == 1) then
            call DGEMM__('T','N',M,N,K,1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWr_tmp,M)
            call DGEMM__('T','N',M,N,K,1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWi_tmp,M)

         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               il2 = mod(il1,2) ! il2 = 1 -> l=0,2,4,6,...: il2 = 0 -> l=1,3,5,7,...
               if(il2 == 1) then
                  if(ista_g1k(ik) == 1) then
                     ai_x(1,1:n_ialist0) = 0.d0;  ar_x(1,1:n_ialist0) = ar_x(1,1:n_ialist0)*0.5d0
                  endif
                  call DGEMM__('T','N',M,N,K, 1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWr_tmp,M)
                  call DGEMM__('T','N',M,N,K,-1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,2),maxval(np_g1k),1.d0,bWr_tmp,M)
                  bWr_tmp = bWr_tmp*2.d0;   bWi_tmp = 0.d0
               else
                  if(ista_g1k(ik) == 1) then
                     ar_x(1,1:n_ialist0) = 0.d0; ai_x(1,1:n_ialist0) = 0.d0
                  endif
                  call DGEMM__('T','N',M,N,K, 1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWi_tmp,M)
                  call DGEMM__('T','N',M,N,K, 1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,2),maxval(np_g1k),1.d0,bWi_tmp,M)
                  bWr_tmp = 0.d0;           bWi_tmp = bWi_tmp*2.d0
               end if
            else
               call DGEMM__('T','N',M,N,K, 1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWr_tmp,M)
               call DGEMM__('T','N',M,N,K,-1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,2),maxval(np_g1k),1.d0,bWr_tmp,M)
               call DGEMM__('T','N',M,N,K, 1.d0,ai_x,maxval(np_g1k),zaj_l(1,1,ik,1),maxval(np_g1k),0.d0,bWi_tmp,M)
               call DGEMM__('T','N',M,N,K, 1.d0,ar_x,maxval(np_g1k),zaj_l(1,1,ik,2),maxval(np_g1k),1.d0,bWi_tmp,M)
            end if
         end if
                                                  __TIMER_COMM_START(1624)
         call mpi_allreduce(MPI_IN_PLACE,bWr_tmp,n_ialist0*np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
         call mpi_allreduce(MPI_IN_PLACE,bWi_tmp,n_ialist0*np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1624)

         i = mod(il1,4)
!$omp parallel private(iap, ib, fsrt, fsit, ia, lmta1)
         do iap = 1, n_ialist0
            if(i==2) then
!$omp do
               do ib = 1, np_e
                  fsrt = bWr_tmp(iap,ib); fsit = bWi_tmp(iap,ib)
                  bWr_tmp(iap,ib) = -fsit; bWi_tmp(iap,ib) = fsrt
               end do
!$omp end do nowait
            else if(i==3) then
!$omp do
               do ib = 1, np_e
                  fsrt = bWr_tmp(iap,ib); fsit = bWi_tmp(iap,ib)
                  bWr_tmp(iap,ib) = -fsrt; bWi_tmp(iap,ib) = -fsit
               end do
!$omp end do nowait
            else if(i==0) then
!$omp do
               do ib = 1, np_e
                  fsrt = bWr_tmp(iap,ib); fsit = bWi_tmp(iap,ib)
                  bWr_tmp(iap,ib) = fsit; bWi_tmp(iap,ib) = -fsrt
               end do
!$omp end do nowait
            end if
         end do

         do ib = 1, np_e
            do iap = 1, n_ialist0
               ia = n_ialist0*(lmt1-1) + iap
               bWr_lmt(ia,ib) = bWr_tmp(iap,ib)
               bWi_lmt(ia,ib) = bWi_tmp(iap,ib)
            end do
         end do

         do iap = 1, n_ialist0
            ia = ia_list(iap)
            lmta1 = lmta(lmt1,ia)
!$omp do
            do ib = 1, np_e
               bWr(lmta1,iter_rmm,ib) =  bWr_tmp(iap,ib)
               bWi(lmta1,iter_rmm,ib) =  bWi_tmp(iap,ib)
            end do
!$omp end do
         end do
!$omp end parallel 

      end do

      deallocate(bWr_tmp, bWi_tmp)

      call tstatc0_end(id_sname)

    end subroutine sumset_rmm_all4

    subroutine Vnonlocal_W_part_sum_ovr_lmt4()
      integer             :: lmt1, lmtt1, il1, im1, il11, mdl, iksnl,il2,im2, ia_p, ia, i, lmt2, iap, iadd
      real(kind=DP)       :: tmp

      integer :: id_sname = -1
      call tstatc0_begin('Vnonlocal_W_part_sum_ovr_lmt4 ',id_sname)

      sc_lmt = 0.d0; ss_lmt = 0.d0
      if(mdvdb == EXECUT) then
         qc_lmt = 0.d0; qs_lmt = 0.d0
      endif

      iksnl = (ik-1)/nspin + 1
      do lmt2 = 1, ilmt(it)
         il2   = ltp(lmt2,it)
         im2   = mtp(lmt2,it)


         do lmt1 = 1,ilmt(it)
            lmtt1 = lmtt(lmt1,it)
            il1   = ltp(lmt1,it)
            im1   = mtp(lmt1,it)
            il11  = il1 - 1
            mdl   = mod(il11,4)

!OCL NOFLTLD
            do ia_p = 1, n_ialist0
               ia = ia_list(ia_p)
               if(il1 == il2 .and. im1 == im2) then
                  if(ipaw(it)==0) then
                     tmp = (dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                  else
                     tmp = (dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                  end if
               else
                  if(ipaw(it)==0) then
                     tmp = vlhxcQ(lmt1,lmt2,ia,ispin) * iwei(ia)
                  else
                     tmp = (dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                  end if
               endif
               if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
               fq(ia_p,1) = tmp
            end do

            if(mdvdb == EXECUT .and. il1 == il2 .and. im1 == im2) then
               do ia_p = 1, n_ialist0
                  ia = ia_list(ia_p)
                  tmp = q(lmt1,lmt2,it)*iwei(ia)
                  if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
                  fq(ia_p,2) = tmp
               end do

               if(mdl == 0 .or. mdl == 2) then
                  do ia_p = 1, n_ialist0
                     iap = n_ialist0*(lmt2-1) + ia_p
                     do i = ista_g1k(ik), iend_g1k(ik)
                        iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!                       sc_lmt(iadd,iap) = sc_lmt(iadd,iap) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       qc_lmt(iadd,iap) = qc_lmt(iadd,iap) + fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       qs_lmt(iadd,iap) = qs_lmt(iadd,iap) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                        sc_lmt(iadd,iap) = sc_lmt(iadd,iap) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        qc_lmt(iadd,iap) = qc_lmt(iadd,iap) + fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        qs_lmt(iadd,iap) = qs_lmt(iadd,iap) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                     end do
                  end do
               else if(mdl == 1 .or. mdl == 3) then
                  do ia_p = 1, n_ialist0
                     iap = n_ialist0*(lmt2-1) + ia_p
                     do i = ista_g1k(ik), iend_g1k(ik)
                        iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!                       sc_lmt(iadd,iap) = sc_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       qc_lmt(iadd,iap) = qc_lmt(iadd,iap) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       qs_lmt(iadd,iap) = qs_lmt(iadd,iap) - fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                        sc_lmt(iadd,iap) = sc_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        qc_lmt(iadd,iap) = qc_lmt(iadd,iap) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        qs_lmt(iadd,iap) = qs_lmt(iadd,iap) - fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                     end do
                  end do
               end if
            else
               if(mdl == 0 .or. mdl == 2) then
                  do ia_p = 1, n_ialist0
                     iap = n_ialist0*(lmt2-1) + ia_p
                     do i = ista_g1k(ik), iend_g1k(ik)
                        iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!                       sc_lmt(iadd,iap) = sc_lmt(iadd,iap) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                        sc_lmt(iadd,iap) = sc_lmt(iadd,iap) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                     end do
                  end do
               else if(mdl == 1 .or. mdl == 3) then
                  do ia_p = 1, n_ialist0
                     iap = n_ialist0*(lmt2-1) + ia_p
                     do i = ista_g1k(ik), iend_g1k(ik)
                        iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/09/13 ================================================
!                       sc_lmt(iadd,iap) = sc_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                       ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                        sc_lmt(iadd,iap) = sc_lmt(iadd,iap) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                        ss_lmt(iadd,iap) = ss_lmt(iadd,iap) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                     end do
                  end do
               end if
            end if
         end do
      end do

      call tstatc0_end(id_sname)
    end subroutine Vnonlocal_W_part_sum_ovr_lmt4

    subroutine add_vnlph_l_part4(mdvdb)
       integer, intent(in) :: mdvdb
       integer       :: ib, iap,  M, N, K
       real(kind=DP), allocatable, dimension(:,:) :: bWer, bWei

       integer :: id_sname = -1
       call tstatc0_begin('add_vnlph_l_part4 ',id_sname)

       if(mdvdb == EXECUT) then
          allocate(bWer(ilmt(it)*n_ialist0,np_e))
          allocate(bWei(ilmt(it)*n_ialist0,np_e))
          do iap = 1, ilmt(it)*n_ialist0
             do ib = 1, np_e
                bWer(iap,ib) = bWr_lmt(iap,ib)*eko_l(ib,ik)
                bWei(iap,ib) = bWi_lmt(iap,ib)*eko_l(ib,ik)
             end do
          end do
       end if

       M =iend_g1k(ik) - ista_g1k(ik) + 1; N = np_e ; K = ilmt(it)*n_ialist0
       if(kimg == 1) then
! === DEBUG by tkato 2011/10/20 ================================================
!         call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K,-1.d0,ss_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
          call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K,-1.d0,ss_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
! ==============================================================================

          if(mdvdb == EXECUT) then
! === DEBUG by tkato 2011/10/20 ================================================
!         call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K, 1.d0,qs_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
          call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K, 1.d0,qs_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
! ==============================================================================
          end if
       else if(kimg == 2) then
! === DEBUG by tkato 2011/10/20 ================================================
!         call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K,-1.d0,ss_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,2),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K, 1.d0,ss_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,2),maxval(np_g1k)) 
          call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K,-1.d0,ss_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K, 1.d0,sc_lmt,maxval(np_g1k),bWi_lmt,K,1.d0,vnlph_l(1,1,2),np_g1k(ik))
          call DGEMM__('N','N',M,N,K, 1.d0,ss_lmt,maxval(np_g1k),bWr_lmt,K,1.d0,vnlph_l(1,1,2),np_g1k(ik))
! ==============================================================================

          if(mdvdb == EXECUT) then
! === DEBUG by tkato 2011/10/20 ================================================
!         call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K, 1.d0,qs_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,1),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,2),maxval(np_g1k))
!         call DGEMM__('N','N',M,N,K,-1.d0,qs_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,2),maxval(np_g1k))
          call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K, 1.d0,qs_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,1),np_g1k(ik))
          call DGEMM__('N','N',M,N,K,-1.d0,qc_lmt,maxval(np_g1k),bWei,   K,1.d0,vnlph_l(1,1,2),np_g1k(ik))
          call DGEMM__('N','N',M,N,K,-1.d0,qs_lmt,maxval(np_g1k),bWer,   K,1.d0,vnlph_l(1,1,2),np_g1k(ik))
! ==============================================================================
          end if
       end if
       
       if(mdvdb == EXECUT) deallocate(bWer,bWei)
       call tstatc0_end(id_sname)
    end subroutine add_vnlph_l_part4
#else
     subroutine sumset_rmm_all3()

       integer  :: lmt1, lmtt1, lmta1, i, iksnl, ib, il1, ia, iap, il2, iadd
       real(kind=DP) :: fsrt,fsit
       integer :: id_sname = -1
       call tstatc0_begin('sumset_rmm_all3 ',id_sname)

       iksnl = (ik-1)/nspin + 1
       do lmt1 = 1, ilmt(it)
          lmtt1 = lmtt(lmt1,it)
          il1   = ltp(lmt1,it)
          if(kimg == 1) then

#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do iap = 1, n_ialist0
                ia = ia_list(iap)
!               lmta1 = lmta(lmt1,ia)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                  ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(i,lmtt1,iksnl)
!                  ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(i,lmtt1,iksnl)
                   ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
                   ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                end do
             end do
          else if(kimg == 2) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do iap = 1,n_ialist0
                ia = ia_list(iap)
!               lmta1 = lmta(lmt1,ia)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                  ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(i,lmtt1,iksnl)
!                  ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(i,lmtt1,iksnl)
                   ar_x(iadd,iap) = zfcos_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
                   ai_x(iadd,iap) = zfsin_x(iadd,iap)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                end do
             end do
          end if

          if(kimg == 1) then
#ifdef HIUX
*poption indep
*poption parallel
#endif
             do iap = 1, n_ialist0
                ia = ia_list(iap)
                lmta1 = lmta(lmt1,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ib = 1, np_e
                   fsrt = 0.d0; fsit = 0.d0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
                      fsrt = fsrt + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,1)
                      fsit = fsit + ai_x(iadd,iap)*zaj_l(iadd,ib,ik,1)
                   end do
                                                  __TIMER_COMM_START(1625)
                   call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                   call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1625)
                   bWr(lmta1,iter_rmm,ib) = fsrt; bWi(lmta1,iter_rmm,ib) = fsit
                end do
             end do
          else if(kimg == 2) then
             if(k_symmetry(ik) == GAMMA) then
                il2 = mod(il1,2) ! il2 = 1 -> l=0,2,4,6,...: il2 = 0 -> l=1,3,5,7,...
#ifdef HIUX
*poption indep
*poption parallel
#endif
                do iap = 1, n_ialist0
                   ia = ia_list(iap)
                   lmta1 = lmta(lmt1,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
                   do ib = 1, np_e
                      fsrt = 0.d0; fsit = 0.d0
                      if(il2 == 1) then
                         do i = max(2,ista_g1k(ik)), iend_g1k(ik)
                            iadd = i - ista_g1k(ik) + 1
                            fsrt = fsrt + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,1) &
                                        - ai_x(iadd,iap)*zaj_l(iadd,ib,ik,2)
                         end do
                         if(ista_g1k(ik) == 1) then
                            fsrt = 2.d0*fsrt + zaj_l(1,ib,ik,1)*ar_x(1,iap)
                         else
                            fsrt = 2.d0*fsrt
                         endif
                                                  __TIMER_COMM_START(1625)
                         call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1625)
                      else
                         do i = max(2,ista_g1k(ik)), iend_g1k(ik)
                            iadd = i - ista_g1k(ik) + 1
                            fsit = fsit + ai_x(iadd,iap)*zaj_l(iadd,ib,ik,1) &
                                        + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,2)
                         end do
                         fsit = 2.d0*fsit
                                                  __TIMER_COMM_START(1625)
                         call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1625)
                      end if
                      bWr(lmta1,iter_rmm,ib) = fsrt; bWi(lmta1,iter_rmm,ib) = fsit
                   end do
                end do
             else
#ifdef HIUX
*poption indep
*poption parallel
#endif
                do iap = 1, n_ialist0
                   ia = ia_list(iap)
                   lmta1 = lmta(lmt1,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
                   do ib = 1, np_e
                      fsrt = 0.d0; fsit = 0.d0
                      do i = ista_g1k(ik), iend_g1k(ik)
                         iadd = i - ista_g1k(ik) + 1
                         fsrt = fsrt + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,1) &
                                     - ai_x(iadd,iap)*zaj_l(iadd,ib,ik,2)
                         fsit = fsit + ai_x(iadd,iap)*zaj_l(iadd,ib,ik,1) &
                                     + ar_x(iadd,iap)*zaj_l(iadd,ib,ik,2)
                      end do
                                                  __TIMER_COMM_START(1625)
                      call mpi_allreduce(MPI_IN_PLACE,fsrt,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                      call mpi_allreduce(MPI_IN_PLACE,fsit,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(1625) 
                      bWr(lmta1,iter_rmm,ib) = fsrt; bWi(lmta1,iter_rmm,ib) = fsit
                   end do
                end do
             end if
          end if

          i = mod(il1,4)
          do iap = 1, n_ialist0
             ia = ia_list(iap)
             lmta1 = lmta(lmt1,ia)
             if(i == 2) then
                do ib = 1, np_e
                   fsrt = bWr(lmta1,iter_rmm,ib); fsit = bWi(lmta1,iter_rmm,ib)
                   bWr(lmta1,iter_rmm,ib) = -fsit; bWi(lmta1,iter_rmm,ib) = fsrt
                end do
             else if(i == 3) then
                do ib = 1, np_e
                   fsrt = bWr(lmta1,iter_rmm,ib); fsit = bWi(lmta1,iter_rmm,ib)
                   bWr(lmta1,iter_rmm,ib) = -fsrt; bWi(lmta1,iter_rmm,ib) = -fsit
                end do
             else if(i == 0) then
                do ib = 1, np_e
                   fsrt = bWr(lmta1,iter_rmm,ib); fsit = bWi(lmta1,iter_rmm,ib)
                   bWr(lmta1,iter_rmm,ib) =  fsit; bWi(lmta1,iter_rmm,ib) = -fsrt
                end do
             end if
          end do
       end do
       call tstatc0_end(id_sname)
     end subroutine sumset_rmm_all3

     subroutine add_vnlph_l_without_eko_part3()
        real(kind=DP) :: bWFr, bWFi
        integer       :: i, ib, ia, iap, lmta2, iadd

        if(kimg == 1) then
!!$#ifdef HIUX
!!$*poption parallel
!!$#endif
           do iap = 1, n_ialist0
              ia = ia_list(iap)
              lmta2 = lmta(lmt2,ia)
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sc_x(iadd,iap)-bWFi*ss_x(iadd,iap)
                enddo
             end do
          end do
       else if(kimg == 2) then
!!$#ifdef HIUX
!!$*poption parallel
!!$#endif
          do iap = 1, n_ialist0
             ia = ia_list(iap)
             lmta2 = lmta(lmt2,ia)
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sc_x(iadd,iap)-bWFi*ss_x(iadd,iap)
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sc_x(iadd,iap)+bWFr*ss_x(iadd,iap)
                enddo
             end do
          end do
       endif
     end subroutine add_vnlph_l_without_eko_part3

     subroutine add_vnlph_l_with_eko_part3()
        real(kind=DP) :: bWFr, bWFi, e, sceqc, sseqs
        integer       :: i, ib, ia, iap, lmta2, iadd
#ifdef HIUX
        integer       :: lmta2_1, lmta2_2, lmta2_3, lmta2_4, lmta2_5, lmta2_6, lmta2_7, lmta2_8
        real(kind=DP) :: bWFr_1, bWFr_2, bWFr_3, bWFr_4, bWFr_5, bWFr_6, bWFr_7, bWFr_8
        real(kind=DP) :: bWFi_1, bWFi_2, bWFi_3, bWFi_4, bWFi_5, bWFi_6, bWFi_7, bWFi_8
        real(kind=DP) :: sceqc_1, sseqs_1, sceqc_2, sseqs_2, sceqc_3, sseqs_3, sceqc_4, sseqs_4 &
            &         , sceqc_5, sseqs_5, sceqc_6, sseqs_6, sceqc_7, sseqs_7, sceqc_8, sseqs_8
#endif

       integer :: id_sname = -1
       call tstatc0_begin('add_vnlph_l_with_eko_part3 ',id_sname)

#ifdef HIUX
       if(kimg == 1) then
          if(n_ialist0 == 1) then
             lmta2 = lmta(lmt2,ia_list(1))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc_x(iadd,1)-e*qc_x(iadd,1)) &
                                                             - bWFi*(ss_x(iadd,1)-e*qs_x(iadd,1))
                enddo
             end do
          else if(n_ialist0 == 2) then
             lmta2_1 = lmta(lmt2,ia_list(1)); lmta2_2 = lmta(lmt2,ia_list(2))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib =1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*(sc_x(iadd,1)-e*qc_x(iadd,1)) &
                                                             - bWFi_1*(ss_x(iadd,1)-e*qs_x(iadd,1)) &
                                                             + bWFr_2*(sc_x(iadd,2)-e*qc_x(iadd,2)) &
                                                             - bWFi_2*(ss_x(iadd,2)-e*qs_x(iadd,2))
                end do
             end do
          else if(n_ialist0 == 3) then
             lmta2_1 = lmta(lmt2,ia_list(1)); lmta2_2 = lmta(lmt2,ia_list(2)); lmta2_3 = lmta(lmt2,ia_list(3))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib =1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*(sc_x(iadd,1)-e*qc_x(iadd,1)) &
                                                             - bWFi_1*(ss_x(iadd,1)-e*qs_x(iadd,1)) &
                                                             + bWFr_2*(sc_x(iadd,2)-e*qc_x(iadd,2)) &
                                                             - bWFi_2*(ss_x(iadd,2)-e*qs_x(iadd,2)) &
                                                             + bWFr_3*(sc_x(iadd,3)-e*qc_x(iadd,3)) &
                                                             - bWFi_3*(ss_x(iadd,3)-e*qs_x(iadd,3))
                end do
             end do
          else if(n_ialist0 >= 4) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3)); lmta2_4=lmta(lmt2,ia_list(4))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib =1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*(sc_x(iadd,1)-e*qc_x(iadd,1)) &
                                                             - bWFi_1*(ss_x(iadd,1)-e*qs_x(iadd,1)) &
                                                             + bWFr_2*(sc_x(iadd,2)-e*qc_x(iadd,2)) &
                                                             - bWFi_2*(ss_x(iadd,2)-e*qs_x(iadd,2)) &
                                                             + bWFr_3*(sc_x(iadd,3)-e*qc_x(iadd,3)) &
                                                             - bWFi_3*(ss_x(iadd,3)-e*qs_x(iadd,3)) &
                                                             + bWFr_4*(sc_x(iadd,4)-e*qc_x(iadd,4)) &
                                                             - bWFi_4*(ss_x(iadd,4)-e*qs_x(iadd,4))
                end do
             end do
          end if
          if(n_ialist0 > 4) then
             do iap = 5, n_ialist0
                ia = ia_list(iap)
                lmta2 = lmta(lmt2,ia)
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ib = 1, np_e
                   bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
                      vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc_x(iadd,iap)-e*qc_x(iadd,iap)) &
                                                                - bWFi*(ss_x(iadd,iap)-e*qs_x(iadd,iap))
                   enddo
                end do
             end do
          end if
       else if(kimg == 2) then
         if(n_ialist0 == 1) then
             lmta2 = lmta(lmt2,ia_list(1))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs = ss_x(iadd,1)-e*qs_x(iadd,1)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sceqc-bWFi*sseqs
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sceqc+bWFr*sseqs
                end do
             end do
          else if(n_ialist0 == 2) then
             lmta2_1 = lmta(lmt2,ia_list(1)); lmta2_2 = lmta(lmt2,ia_list(2))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2
                end do
             end do
          else if(n_ialist0 == 3) then
             lmta2_1 = lmta(lmt2,ia_list(1)); lmta2_2 = lmta(lmt2,ia_list(2)); lmta2_3 = lmta(lmt2,ia_list(3))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3
                end do
             end do
          else if(n_ialist0 == 4) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4
                end do
             end do
          else if(n_ialist0 == 5) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
             lmta2_5=lmta(lmt2,ia_list(5))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib)
                bWFr_5 = bWr(lmta2_5,iter_rmm,ib); bWFi_5 = bWi(lmta2_5,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   sceqc_5 = sc_x(iadd,5)-e*qc_x(iadd,5);  sseqs_5 = ss_x(iadd,5)-e*qs_x(iadd,5)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4 &
                                                             + bWFr_5*sceqc_5-bWFi_5*sseqs_5
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4 &
                                                             + bWFi_5*sceqc_5+bWFr_3*sseqs_5
                end do
             end do
          else if(n_ialist0 == 6) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
             lmta2_5=lmta(lmt2,ia_list(5)); lmta2_6=lmta(lmt2,ia_list(6))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib)
                bWFr_5 = bWr(lmta2_5,iter_rmm,ib); bWFi_5 = bWi(lmta2_5,iter_rmm,ib)
                bWFr_6 = bWr(lmta2_6,iter_rmm,ib); bWFi_6 = bWi(lmta2_6,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   sceqc_5 = sc_x(iadd,5)-e*qc_x(iadd,5);  sseqs_5 = ss_x(iadd,5)-e*qs_x(iadd,5)
                   sceqc_6 = sc_x(iadd,6)-e*qc_x(iadd,6);  sseqs_6 = ss_x(iadd,6)-e*qs_x(iadd,6)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4 &
                                                             + bWFr_5*sceqc_5-bWFi_5*sseqs_5 + bWFr_6*sceqc_6-bWFi_6*sseqs_6
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4 &
                                                             + bWFi_5*sceqc_5+bWFr_5*sseqs_5 + bWFi_6*sceqc_6+bWFr_6*sseqs_6
                end do
             end do
          else if(n_ialist0 == 7) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
             lmta2_5=lmta(lmt2,ia_list(5)); lmta2_6=lmta(lmt2,ia_list(6)); lmta2_7=lmta(lmt2,ia_list(7))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib)
                bWFr_5 = bWr(lmta2_5,iter_rmm,ib); bWFi_5 = bWi(lmta2_5,iter_rmm,ib)
                bWFr_6 = bWr(lmta2_6,iter_rmm,ib); bWFi_6 = bWi(lmta2_6,iter_rmm,ib)
                bWFr_7 = bWr(lmta2_7,iter_rmm,ib); bWFi_7 = bWi(lmta2_7,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   sceqc_5 = sc_x(iadd,5)-e*qc_x(iadd,5);  sseqs_5 = ss_x(iadd,5)-e*qs_x(iadd,5)
                   sceqc_6 = sc_x(iadd,6)-e*qc_x(iadd,6);  sseqs_6 = ss_x(iadd,6)-e*qs_x(iadd,6)
                   sceqc_7 = sc_x(iadd,7)-e*qc_x(iadd,7);  sseqs_7 = ss_x(iadd,7)-e*qs_x(iadd,7)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4 &
                                                             + bWFr_5*sceqc_5-bWFi_5*sseqs_5 + bWFr_6*sceqc_6-bWFi_6*sseqs_6 &
                                                             + bWFr_7*sceqc_7-bWFi_7*sseqs_7
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4 &
                                                             + bWFi_5*sceqc_5+bWFr_5*sseqs_5 + bWFi_6*sceqc_6+bWFr_6*sseqs_6 &
                                                             + bWFi_7*sceqc_7+bWFr_7*sseqs_7
                end do
             end do
          else if(n_ialist0 >= 8) then
             lmta2_1=lmta(lmt2,ia_list(1)); lmta2_2=lmta(lmt2,ia_list(2)); lmta2_3=lmta(lmt2,ia_list(3));lmta2_4=lmta(lmt2,ia_list(4))
             lmta2_5=lmta(lmt2,ia_list(5)); lmta2_6=lmta(lmt2,ia_list(6)); lmta2_7=lmta(lmt2,ia_list(7));lmta2_8=lmta(lmt2,ia_list(8))
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr_1 = bWr(lmta2_1,iter_rmm,ib); bWFi_1 = bWi(lmta2_1,iter_rmm,ib)
                bWFr_2 = bWr(lmta2_2,iter_rmm,ib); bWFi_2 = bWi(lmta2_2,iter_rmm,ib)
                bWFr_3 = bWr(lmta2_3,iter_rmm,ib); bWFi_3 = bWi(lmta2_3,iter_rmm,ib)
                bWFr_4 = bWr(lmta2_4,iter_rmm,ib); bWFi_4 = bWi(lmta2_4,iter_rmm,ib)
                bWFr_5 = bWr(lmta2_5,iter_rmm,ib); bWFi_5 = bWi(lmta2_5,iter_rmm,ib)
                bWFr_6 = bWr(lmta2_6,iter_rmm,ib); bWFi_6 = bWi(lmta2_6,iter_rmm,ib)
                bWFr_7 = bWr(lmta2_7,iter_rmm,ib); bWFi_7 = bWi(lmta2_7,iter_rmm,ib)
                bWFr_8 = bWr(lmta2_8,iter_rmm,ib); bWFi_8 = bWi(lmta2_8,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc_1 = sc_x(iadd,1)-e*qc_x(iadd,1);  sseqs_1 = ss_x(iadd,1)-e*qs_x(iadd,1)
                   sceqc_2 = sc_x(iadd,2)-e*qc_x(iadd,2);  sseqs_2 = ss_x(iadd,2)-e*qs_x(iadd,2)
                   sceqc_3 = sc_x(iadd,3)-e*qc_x(iadd,3);  sseqs_3 = ss_x(iadd,3)-e*qs_x(iadd,3)
                   sceqc_4 = sc_x(iadd,4)-e*qc_x(iadd,4);  sseqs_4 = ss_x(iadd,4)-e*qs_x(iadd,4)
                   sceqc_5 = sc_x(iadd,5)-e*qc_x(iadd,5);  sseqs_5 = ss_x(iadd,5)-e*qs_x(iadd,5)
                   sceqc_6 = sc_x(iadd,6)-e*qc_x(iadd,6);  sseqs_6 = ss_x(iadd,6)-e*qs_x(iadd,6)
                   sceqc_7 = sc_x(iadd,7)-e*qc_x(iadd,7);  sseqs_7 = ss_x(iadd,7)-e*qs_x(iadd,7)
                   sceqc_8 = sc_x(iadd,8)-e*qc_x(iadd,8);  sseqs_8 = ss_x(iadd,8)-e*qs_x(iadd,8)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr_1*sceqc_1-bWFi_1*sseqs_1 + bWFr_2*sceqc_2-bWFi_2*sseqs_2 &
                                                             + bWFr_3*sceqc_3-bWFi_3*sseqs_3 + bWFr_4*sceqc_4-bWFi_4*sseqs_4 &
                                                             + bWFr_5*sceqc_5-bWFi_5*sseqs_5 + bWFr_6*sceqc_6-bWFi_6*sseqs_6 &
                                                             + bWFr_7*sceqc_7-bWFi_7*sseqs_7 + bWFr_8*sceqc_8-bWFi_8*sseqs_8
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi_1*sceqc_1+bWFr_1*sseqs_1 + bWFi_2*sceqc_2+bWFr_2*sseqs_2 &
                                                             + bWFi_3*sceqc_3+bWFr_3*sseqs_3 + bWFi_4*sceqc_4+bWFr_4*sseqs_4 &
                                                             + bWFi_5*sceqc_5+bWFr_5*sseqs_5 + bWFi_6*sceqc_6+bWFr_6*sseqs_6 &
                                                             + bWFi_7*sceqc_7+bWFr_7*sseqs_7 + bWFi_8*sceqc_8+bWFr_8*sseqs_8
                end do
             end do
          end if
          if(n_ialist0 > 8) then
             do iap = 9, n_ialist0
                ia = ia_list(iap)
                lmta2 = lmta(lmt2,ia)
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ib = 1, np_e
                   bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
                      sceqc = sc_x(iadd,iap)-e*qc_x(iadd,iap)
                      sseqs = ss_x(iadd,iap)-e*qs_x(iadd,iap)
                      vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sceqc-bWFi*sseqs
                      vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sceqc+bWFr*sseqs
                   end do
                enddo
            end do
         end if
       end if

#else
!  --> for ordinary scaler and vector machines but HIUX
!  = #ifndef HIUX

       if(kimg == 1) then
          do iap = 1, n_ialist0
             ia = ia_list(iap)
             lmta2 = lmta(lmt2,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*(sc_x(iadd,iap)-e*qc_x(iadd,iap)) &
                                                             - bWFi*(ss_x(iadd,iap)-e*qs_x(iadd,iap))
                enddo
             end do
          end do
       else if(kimg == 2) then
          do iap = 1, n_ialist0
             ia = ia_list(iap)
             lmta2 = lmta(lmt2,ia)
#ifdef VPP
*vocl loop, unroll(4)
#endif
             do ib = 1, np_e
                bWFr = bWr(lmta2,iter_rmm,ib); bWFi = bWi(lmta2,iter_rmm,ib); e = eko_l(ib,ik)
                do i = ista_g1k(ik), iend_g1k(ik)
                   iadd = i - ista_g1k(ik) + 1
                   sceqc = sc_x(iadd,iap)-e*qc_x(iadd,iap)
                   sseqs = ss_x(iadd,iap)-e*qs_x(iadd,iap)
                   vnlph_l(iadd,ib,1) = vnlph_l(iadd,ib,1) + bWFr*sceqc-bWFi*sseqs
                   vnlph_l(iadd,ib,2) = vnlph_l(iadd,ib,2) + bWFi*sceqc+bWFr*sseqs
                end do
             enddo
          end do
       endif
#endif
       call tstatc0_end(id_sname)
     end subroutine add_vnlph_l_with_eko_part3

     subroutine Vnonlocal_W_part_sum_over_lmt1b()
       integer             :: lmt1, lmtt1, il1, im1, il11, mdl, iksnl,il2,im2, ia_p, ia, i, ii, iadd
       real(kind=DP)       :: tmp

       integer :: id_sname = -1
       call tstatc0_begin('Vnonlocal_W_part_sum_over_lmt1 ',id_sname)

       iksnl = (ik-1)/nspin + 1
       il2   = ltp(lmt2,it)
       im2   = mtp(lmt2,it)

       sc_x = 0.d0; ss_x = 0.d0
       if(mdvdb == EXECUT) then
          qc_x = 0.d0; qs_x = 0.d0
       endif

       do lmt1 = 1,ilmt(it)
          lmtt1 = lmtt(lmt1,it)
          il1   = ltp(lmt1,it)
          im1   = mtp(lmt1,it)
          il11  = il1 - 1
          mdl   = mod(il11,4)

          do ia_p = 1, n_ialist0
             ia = ia_list(ia_p)
             if(il1 == il2 .and. im1 == im2) then
!!$                tmp = (dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                if(ipaw(it)==0) then
                    tmp = (dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                else
                    tmp = (dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                end if
             else
!!$                tmp = vlhxcQ(lmt1,lmt2,ia,ispin) * iwei(ia)
                if(ipaw(it)==0) then
                    tmp = vlhxcQ(lmt1,lmt2,ia,ispin) * iwei(ia)
                else
                    tmp = (dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)) * iwei(ia)
                end if
             endif
             if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
             fq(ia_p,1) = tmp
          end do

          if(mdvdb == EXECUT .and. il1 == il2 .and. im1 == im2) then
             do ia_p = 1, n_ialist0
                ia = ia_list(ia_p)
                tmp = q(lmt1,lmt2,it)*iwei(ia)
                if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
                fq(ia_p,2) = tmp
             end do

             if(mdl == 0 .or. mdl == 2) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ia_p = 1, n_ialist0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                     sc_x(iadd,ia_p) = sc_x(iadd,ia_p) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     qc_x(iadd,ia_p) = qc_x(iadd,ia_p) + fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     qs_x(iadd,ia_p) = qs_x(iadd,ia_p) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                      sc_x(iadd,ia_p) = sc_x(iadd,ia_p) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      qc_x(iadd,ia_p) = qc_x(iadd,ia_p) + fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      qs_x(iadd,ia_p) = qs_x(iadd,ia_p) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                   end do
                end do
             else if(mdl == 1 .or. mdl == 3) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ia_p = 1, n_ialist0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                     sc_x(iadd,ia_p) = sc_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     qc_x(iadd,ia_p) = qc_x(iadd,ia_p) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     qs_x(iadd,ia_p) = qs_x(iadd,ia_p) - fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                      sc_x(iadd,ia_p) = sc_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      qc_x(iadd,ia_p) = qc_x(iadd,ia_p) - fq(ia_p,2)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      qs_x(iadd,ia_p) = qs_x(iadd,ia_p) - fq(ia_p,2)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                   end do
                end do
             end if
          else
             if(mdl == 0 .or. mdl == 2) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ia_p = 1, n_ialist0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                     sc_x(iadd,ia_p) = sc_x(iadd,ia_p) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                      sc_x(iadd,ia_p) = sc_x(iadd,ia_p) + fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                   end do
                end do
             else if(mdl == 1 .or. mdl == 3) then
#ifdef HIUX
*poption parallel
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
                do ia_p = 1, n_ialist0
                   do i = ista_g1k(ik), iend_g1k(ik)
                      iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/07/12 ================================================
!                     sc_x(iadd,ia_p) = sc_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
!                     ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(i,lmtt1,iksnl)
                      sc_x(iadd,ia_p) = sc_x(iadd,ia_p) - fq(ia_p,1)*zfsin_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
                      ss_x(iadd,ia_p) = ss_x(iadd,ia_p) - fq(ia_p,1)*zfcos_x(iadd,ia_p)*snl(iadd,lmtt1,iksnl)
! ==============================================================================
                   end do
                end do
             end if
          end if
       end do

       call tstatc0_end(id_sname)
     end subroutine Vnonlocal_W_part_sum_over_lmt1b
#endif
  end subroutine Vnonlocal_W_RMMn_3D

end module m_ES_WF_by_RMM

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 552 $)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: vdW-Soler
!
!  AUTHOR(S): Y. Ono
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
!********************************** Note ******************************************
! This program calculates the non-local correlation energy (Ecnl) and 
! the local correlation energy (EcLDA) as the post calculation by utilizing
! the output files from the PHASE. By adding these correlation terms as
!    E_total = E_total(GGAx) + EcLDA + Ecnl,
! the van der Waals interaction will be included into the total energy.
!
! This program follows the Dion et al's 1-shot method (so called vdW-DF), and 
! the Roman-Perez et al's convolution algorithm. Because of this convolution,
! the CPU cost in this program is reduced to O(NlogN) from the original O(N**2).
!                                 (Reference; M.Dion et al. PRL 92 (2004) 246401.)
!                         (Reference; G.Roman-Perez et al. PRL 103 (2009) 096102.)
!
!
! Periodic systems are assumed.
! The atomic units (Hartree) are used.
!
! ======= modification =====
!
!  2016/06/06 : by asms
!         The FFT normalization parameters are changed in order to be consistent
!         with the other subroutines.
!
!         rho(G) = 1/V *Int rho(r) exp(-iGr);   rho(r) = sum_{G} rho(G) exp(iGr)
!        
!         In the dicretized grids, rho(G) = FFT[rho(r)] /(na*nb*nc);
!                                  rho(r) = FFT[rho(G)]
!
!         By this, the nonlocal vdW energy is written as
!             Encl = V**2 /2 sum_{ij} sum_{G} conjg(theta(i,G))*phi(i,j,G)*theta(i,G)
!         and 
!             phi(i,j,G) = 1/V Int phi(i,j,r) exp(-iGr)
!
! =========================
!
! ++++++++ List of subroutines ++++++
! All subroutine files listed below are included in this file.
! In addition to the below list, it is necessary to link to a FFT library, for example FFTW3.
!
! CPU_TIME             : Check the calculation time.
! derivation           : Calculate the derivations of the electron density distribution.
! d_q0                 : Obtain q(rho(r)) from the electron density rho(r) and its derivations.
! spline               : Determine the function 'p(q)' for bi-cubic spline interpolation. 
!                        Here p(r) is defined as, phi(q1,q2,r12) = SUM_ab(p(qa)*p(qb)*phi(qa,qb,r12)).
! theta_ab             : Multiply theta(r) = p(r)*rho(r) by use of the given parameter qa or qb.
! RtoG                 : Calculate the Fourier transform of theta(r) within the FFT algorithm.
! phiab                : Calculate the Fourier transform of the kernel phi(r) by use of the given 
!                        parameter qa and qb. phi(r) does not depends on angular components,
!                        so that it can be done within the radial mesh.
! convolution_3d       : Calculate the integral SUM(dk*theta_a(k)*theta_b(k)*phi(k)).
! piDphi               : Calculate the local part of dr**2*rho(r1)*rho(r2)*phi(r1,r2,r12) directory.
!                        The local part includes the singular point, thus it is necessary to execute
!                        the 3D space integral directory.
! cLDA                 : Obtain the LDA version of correlation term EcLDA.
! outputs              : Output the results.
! kernel_phi           : Calculate the value of kernel phi(d1,d2).
! gauleg               : Prepare the grid points for the Gauss-Legendre integral.
!
!
!
! ++++++++ Input & Output +++++++++++
! Input files  (Both of the input files will be output by PHASE.)
!   nfchr.cube        : An electron density distribution file given by
!                       GGA(exchange only) calculation
!   nfefn.data        : The total energy given by GGA(exchange only) calculation
!
! Output   E_total(vdW-DF) = E_total(GGAx) + EcLDA + Ecnl
!   E_total(GGAx)     : Total energy given by GGA(exchange only) calculation
!   Ecnl              : Non-local Correlation energy
!   EcLDA             : LDA Correlation energy
!
!
!
! ++++++ Internal parameters ++++++++
! dq      (       )   : The smallest distance between the grid points for bi-cubic 
!                       spline interpolation. The grid points are plotted in logarithmic manner.
! lambda   (       )   : The power of dq
! nr12    (       )   : The number of the grid points for the kernel phi(r12)
! phi0    (       )   : One of the coefficients in the 'soft' function, 
!                       phi_s(r12) = phi0 + phi2*d**2 + phi4*d**4. phi2 and phi4 will be 
!                       eventually determined to match the value and the slope of phi_s and 
!                       those of phi at d=d_s, in the program.
! ds      (       )   : The connection point of phi_s and phi
! r12max  (       )   : The cutoff for r12
! rhomin  (       )   : Minimum value of electron density. 
!                       If the electron density was smaller than rhomin, then the program 
!                       will read as this minimum value in order to avoid a divergence.
! nk      (       )   : The number of the grid points plotted for the Fourier 
!                       transformed kernel phi(k)
! maxk    (       )   : The cutoff for k
!
!
!                                              Written by Youky Ono in June/2013
!**********************************************************************************
#ifndef DISABLE_VDWDF
module progress_bar
  implicit none
  logical,private :: printable = .false.
  integer,private :: iend=10
  integer,private :: uni=6
  integer,private :: j=0
  logical, dimension(0:9),private :: done

contains

  subroutine set_printable(pri)
    logical, intent(in) :: pri
    printable = pri
  end subroutine set_printable

  subroutine reset_progress()
    j = 0
    done = .false.
    if(printable) write(unit=uni,fmt="(a10)") "0%    100%"
  end subroutine reset_progress

  subroutine set_unit(un)
    integer, intent(in) :: un
    uni = un
  end subroutine set_unit

  subroutine set_end(en)
    integer, intent(in) :: en
    iend = en
  end subroutine set_end

  subroutine progress()
    use m_Const_Parameters, only : DP
    implicit none
    integer(kind=4)::k
    character(len=17)::bar="???% |          |"
    integer :: jj
    real(kind=DP) :: jjj
    j = j+1
    if(j.gt.iend) j=iend
    jj = int(10*(dble(j)/dble(iend))*0.999999d0)
    if(.not.done(jj).and.j<=iend) then
       if(printable) write(unit=uni,fmt="(a1,$)") '*'
       call flush(uni)
       done(jj) = .true.
    endif
    if(j==iend.and.printable) write(unit=uni,fmt=*)
    !     jjj = (dble(j)/dble(iend))
    !     write(unit=bar(1:3),fmt="(i3)") int(100*jjj)
    !     do k=1, jj
    !       bar(6+k:6+k)="*"
    !     enddo
    !     ! print the progress bar.
    !     write(unit=uni,fmt="(a1,a17,$)") char(13), bar
    !!     write(unit=uni,fmt="(a1,a17)") char(13), bar
    !     if (j/=iend) then
    !       flush(unit=6)
    !     else
    !       write(unit=6,fmt=*)
    !       do k=1,jj
    !          bar(6+k:6+k) = ""
    !       enddo
    !     endif
    return
  end subroutine progress

end module progress_bar


module m_vdWDF
  use m_Const_Parameters, only : DP, ON, PAI, FMAXVALLEN, LOWER, CMPLDP, DIRECT, INVERSE
  use m_Control_Parameters, only : printable,nspin,eval_kernel_by_interpolation, &
       &                           na_gl,a1,a2,dq_vdw,lambda,q0cut,ds,ndel,nphiD, &
       &                           nr12,nk,maxk, r12max,oneshot, ipri, &
       &                           sw_save_memory_vdw, kimg, iprixc, &
       &                           q0min, sw_use_WuGygi_method, sw_fft_xzy
  use m_Files, only : nfout
  use m_Charge_Density, only : m_CD_get_rspace_charge

  use m_FFT, only : fft_box_size_CD,fft_box_size_CD_nonpara, m_FFT_CD0,nfftp_nonpara, fft_box_size_CD_3D
  use m_Crystal_Structure, only : altv,univol, rltv

  use m_Parallelization, only : npes,mype,mpi_comm_group,m_Parallel_init_mpi_nq,  &
       &                        ista_nq,iend_nq,np_nq,mp_nq,is_nq,ie_nq,nel_nq, &
       &                        map_z_nq, np_fftcd_y, np_fftcd_z, mp_fftcd_y, mp_fftcd_z, &
       &                        mpi_g_world, nrank_ke,myrank_ke, nel_fftcd_x, nel_fftcd_y, nel_fftcd_z, &
       &                        mpi_ke_world, nrank_g, myrank_g
  use m_Timing, only : tstatc0_begin,tstatc0_end

  implicit none
  include 'mpif.h'

  real(kind=DP),parameter :: pi=PAI

  ! Physical values
  Real(kind=DP) ExGGA,Ecnl,Ecnl_12,Ecnl_12_ab,Ecnl_3,Ecnl_3s,EcLDA

  real(kind=DP) :: phi0=2.77d0 

  Integer na,nb,nc,nabc
  Real(kind=DP) :: aa(3,3),dv
  Real(kind=DP), Allocatable :: rho(:),grad(:), cgrad(:,:)
  real(kind=DP),allocatable,dimension(:) :: phi_ab

  ! Grid points
!!!! Spline curves
  Integer nq0
  real(kind=DP) :: qa,qb,q0max

!!!! The table of phidD
  real(kind=DP), allocatable, dimension(:,:) :: phidD

  ! Internal parameters
  Real(kind=DP),parameter :: rhomin=1.d-9

  ! Real-space and reciprocal-space Functions

  Complex*16, Allocatable :: theta_G(:),     &
       &                            theta_G_ab(:,:),theta_G_a(:),theta_G_b(:)
  Real(kind=DP), Allocatable :: theta_R(:),dtheta_R(:,:),ddtheta_R(:,:)

  complex(kind=DP), allocatable, dimension(:,:) :: ualpha_g1,ualpha_r1

  real(kind=DP) :: etai = 1.3d0,eta1 = 8.d0

  real(kind=DP), allocatable, dimension(:)   :: qar
  real(kind=DP), allocatable, dimension(:,:) :: q2ar

  real(kind=DP) :: rinplw
  logical :: firstcall = .true.

  integer, parameter :: FFTW_ESTIMATE = 64
  integer, parameter :: FFTW_FORWARD  = -1
  integer, parameter :: FFTW_BACKWARD = +1

  real(kind=DP), allocatable, dimension(:) :: dFdrho, dFddrho
  real(kind=DP), allocatable, dimension(:) :: rkar

  real(kind=DP) :: s_cnl1(3,3), s_cnl2(3,3), ecnl_vdwdf
  real(kind=DP) :: s_cnl1_pc(3,3), s_cnl2_pc(3,3)

  !  logical :: grad_rho_eq_0 = .true.
  logical :: grad_rho_eq_0 = .false.

! ---- extension to vdWDF2 ----
  integer :: version_no_vdwdf = 1

  real(kind=DP) :: Zab
  real(kind=DP), parameter :: Zab_0 = -0.8491d0
! ---------------------------

  integer :: nfft_div_size
  integer, allocatable, dimension(:) :: mp_fftcd, imp_fftcd

  integer, allocatable, dimension(:) :: ica,icb,icc

  logical :: lprog = .false.
contains

  integer function get_index_1D_kimg(cix,ciy,ciz,ignore_kimg)
    integer, intent(in) :: cix,ciy,ciz
    logical, intent(in), optional :: ignore_kimg
    integer :: cix2,ciy2,ciz2
    integer :: idp,mmp,nlphf
    logical :: ig
    ig = .false.
    if(present(ignore_kimg)) ig = ignore_kimg

    idp = fft_box_size_CD_nonpara(1,0)
    mmp = fft_box_size_CD_nonpara(2,0)
    if(kimg == 1 .and. .not.ig) then
       nlphf = idp/2
    else
       nlphf = idp
    end if
    if ( cix > nlphf ) then
       cix2 = idp -cix
       ciy2 = nb +2 -ciy
       ciz2 = nc +2 -ciz
       if ( ciy2 > nb ) ciy2 = ciy2 -nb
       if ( ciz2 > nc ) ciz2 = ciz2 -nc
    else
       cix2 = cix;  ciy2 = ciy; ciz2 = ciz
    endif
    get_index_1D_kimg = (ciz2-1)*mmp*nlphf +(ciy2-1)*nlphf +cix2
  end function get_index_1D_kimg

  integer function get_index_1D(cix,ciy,ciz)
    integer, intent(in) :: cix,ciy,ciz
    integer :: cix2,ciy2,ciz2
    integer :: idp,mmp,nlphf
    get_index_1D = (ciz-1)*nb*na + (ciy-1)*na + cix
  end function get_index_1D

  function get_index_3D(cir) result(ret)
    integer, intent(in) :: cir
    integer :: ret(3)
    integer :: cix,ciy,ciz
    cix = 1+(cir-1-MOD(cir-1+nb*nc,nb*nc))/(nb*nc)
    ciy = 1+(cir-nb*nc*(cix-1)-1-MOD(cir-1+nc,nc))/nc
    ciz = cir-nc*(nb*(cix-1)-1+ciy)
    ret(1) = cix
    ret(2) = ciy
    ret(3) = ciz
  end function get_index_3D

  subroutine print_vdw_parameters()
    if(printable)then
       write(nfout,'(a)')            '-- parameters for the vdW-DF calculations --'
       write(nfout,'(a,2f15.10,i8)') '   rmax, kmax, nmesh     : ',r12max,maxk,nr12
       write(nfout,'(a,3f15.10)')    '   dq, lambda, and q0cut : ',dq_vdw,lambda,q0cut
       write(nfout,'(a,2f15.10,i5)') '   q0min, q0max, nq0     : ',q0min,q0max,nq0
       write(nfout,'(a,f15.10)' )    '   ds                    : ',ds
       write(nfout,'(a,i5,2f15.10)') '   na_gl, a1, a2         : ',na_gl,a1,a2
       if(eval_kernel_by_interpolation)then
          write(nfout,'(a)')            '   kernel evaluation     : by interpolation'
          write(nfout,'(a,2i8)')        '   ndel, nphiD           : ',ndel,nphiD
       else
          write(nfout,'(a)')            '   kernel evaluation     : direct'
       endif
       write(nfout,'(A,I3)') '   sw_use_WuGygi_method : ', sw_use_WuGygi_method
    endif
  end subroutine print_vdw_parameters

  subroutine initialize_vdwdf_scf(nspin,ispin,nfft_div_size, na, nb, nc, chgr,grad_rho,version_no)
    use progress_bar, only : set_printable

    integer, intent(in) :: nspin,ispin,nfft_div_size,na,nb,nc, version_no
    real(kind=DP), dimension(nfft_div_size), intent(in) :: chgr,grad_rho

    integer :: i,cix,ciy,ciz,nrxyz,cir,cir2
    integer :: idp, mmp, nlphf, cix2, ciy2, ciz2
    real(kind=DP) :: q

    lprog = .false.
    if ( version_no == 1 ) then
       Zab = Zab_0
    else if ( version_no == 2 ) then
       Zab = Zab_0 *2.222d0
    endif

    call set_printable(printable)
    call do_cell_params()

    rinplw = 1.d0/(dble(na*nb*nc))
    q0max = q0cut*1.01d0
!!!    q0min = 0.09d0
    nq0 = DINT(dLOG((q0max-q0min)*(lambda-1.d0)/dq_vdw+1.d0)/dLOG(lambda))+1
    maxk = dble(nr12)/r12max

    if(firstcall) call m_Parallel_init_mpi_nq(nfout,ipri,printable,nq0)
    if(firstcall) call print_vdw_parameters()
    call alloc_vdw()

    rho(:) = chgr(:)
    grad(:) = grad_rho(:)
!    do cix = 1,na
!       do ciy = 1,nb
!          do ciz = 1,nc
!             cir = get_index_1D_kimg(cix,ciy,ciz)
!             cir2 = get_index_1D(cix,ciy,ciz)
!             rho(cir2) = chgr(cir)
!             grad(cir2) = grad_rho(cir)
!          enddo
!       enddo
!    enddo

    do i=1,nq0
       q = q0min + dq_vdw*(lambda**DBLE(i-1)-1.d0)/(lambda-1.d0)
       qar(i) = q
    enddo
    call spline0(nq0,qar,q2ar)

    if (eval_kernel_by_interpolation.and.firstcall) then
       call build_lookup_table(ndel,nphiD,phidD)
    endif
    firstcall = .false.
  end subroutine initialize_vdwdf_scf

  subroutine initialize_vdwdf_oneshot(is)
    use progress_bar, only : set_printable
    integer, intent(in) :: is
    integer :: i,cir,cix,ciy,ciz,nrxyz
    real(kind=DP) :: q
    lprog = .true.
    call set_printable(printable)
    if(printable) write(nfout,'(a)') 'initialization ...'

    call do_cell_params()

    rinplw = 1.d0/(dble(na*nb*nc))
    q0max = q0cut*1.01d0
!!!    q0min = 0.09d0
    nq0 = DINT(dLOG((q0max-q0min)*(lambda-1.d0)/dq_vdw+1.d0)/dLOG(lambda))+1
    maxk = dble(nr12)/r12max
    if(firstcall) call m_Parallel_init_mpi_nq(nfout,ipri,printable,nq0)

    call alloc_vdw()
    call m_CD_get_rspace_charge(nfout,na,nb,nc,rho,is)
    call print_vdw_parameters()
    call derivation(na,nb,nc,aa,rho,dv,grad)

    do i=1,nq0
       q = q0min + dq_vdw*(lambda**DBLE(i-1)-1.d0)/(lambda-1.d0)
       qar(i) = q
    enddo

    call spline0(nq0,qar,q2ar)

    if(eval_kernel_by_interpolation)then
       if(printable) write(nfout,'(a)') 'building the lookup table for the kernel function ...'
       call build_lookup_table(ndel,nphiD,phidD) 
       if(printable) write(nfout,'(a)') '... done'
    endif
    if(printable) write(nfout,'(a)') '... done initialization'

  end subroutine initialize_vdwdf_oneshot

  subroutine do_cell_params()
    integer :: i
    na = fft_box_size_CD_3D(1,1)
    nb = fft_box_size_CD_3D(2,1)
    nc = fft_box_size_CD_3D(3,1)
    nabc = na * nb * nc
    do i=1,3
       aa(i,1:3) = altv(1:3,i)/dble(fft_box_size_CD(i,1))
    enddo
    dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
         &      + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
         &      + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))
  end subroutine do_cell_params

  function real_index(iq,pe) result(res)
    integer, intent(in) :: iq
    integer, intent(in),optional :: pe
    integer :: res
    integer :: ii,mpe
    mpe = myrank_ke
    if(present(pe))then
       mpe = pe
    endif
    if(mpe==0)then
       res = iq
       return
    endif
    res = 0
    do ii=0,mpe-1
       res = res+nel_nq(ii) 
    enddo
    res = res+iq
    return
  end function real_index

  subroutine alloc_vdw()
    integer :: i,cix,ciy,ciz,itmp,c1,c2,c3,ca,cb,cc
    real(kind=DP) :: Ta,Tb,Tc, vec(3), bb(3,3)

    allocate(imp_fftcd(nabc));imp_fftcd=0
#ifdef FFT_3D_DIVISION_CD
    nfft_div_size = np_fftcd_x
    allocate(mp_fftcd(nfft_div_size));mp_fftcd=0
    mp_fftcd(:) = mp_fftcd_x(:)
#else
    if (sw_fft_xzy > 0) then
       if (kimg == 1) then
          nfft_div_size = np_fftcd_y / 2
       else
          nfft_div_size = np_fftcd_y
       end if
       allocate(mp_fftcd(nfft_div_size));mp_fftcd=0
       mp_fftcd(:) = mp_fftcd_y(:)
    else
       if (kimg == 1) then
          nfft_div_size = np_fftcd_z / 2
       else
          nfft_div_size = np_fftcd_z
       end if
       allocate(mp_fftcd(nfft_div_size));mp_fftcd=0
       mp_fftcd(:) = mp_fftcd_z(:)
    end if
    do i=1,nfft_div_size
       imp_fftcd(mp_fftcd(i)) = i
    enddo
#endif
    allocate(ica(nfft_div_size));ica=0
    allocate(icb(nfft_div_size));icb=0
    allocate(icc(nfft_div_size));icc=0
    call build_icaicbicc()
    Allocate(rho(nfft_div_size));rho=0.d0
    allocate(grad(nfft_div_size));grad=0.d0
    Allocate(theta_G(nfft_div_size))
    Allocate(theta_R(nfft_div_size))
    if(.not.oneshot)then
       Allocate(dtheta_R(np_nq,nfft_div_size))
       Allocate(ddtheta_R(np_nq,nfft_div_size))
    endif
    Allocate(theta_G_a(nfft_div_size))
    Allocate(theta_G_b(nfft_div_size))
    allocate(phi_ab(0:nr12))
    if(eval_kernel_by_interpolation.and.firstcall) allocate(phidD(0:ndel,-1:nphiD+1))
    allocate(qar(nq0));qar = 0.d0
    allocate(q2ar(nq0,nq0));q2ar = 0.d0
    !    allocate(theta_G_ab(nq0,-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2))
    if(sw_save_memory_vdw) then
       allocate(theta_G_ab(np_nq,nfft_div_size))
    else
       allocate(theta_G_ab(nq0,nfft_div_size))
    endif
    if(.not.oneshot)then
       !       allocate(ualpha_g(nq0,-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2))
       !       allocate(ualpha_r(nq0,na,nb,nc))
       allocate(dFdrho(nfft_div_size))
       allocate(dFddrho(nfft_div_size))
    endif

    allocate(rkar(nfft_div_size))
!    allocate(rkar(nabc))

#if 0
    Ta = na*DSQRT(aa(1,1)**2 + aa(1,2)**2 + aa(1,3)**2)
    Tb = nb*DSQRT(aa(2,1)**2 + aa(2,2)**2 + aa(2,3)**2)
    Tc = nc*DSQRT(aa(3,1)**2 + aa(3,2)**2 + aa(3,3)**2)
    Do ciz = -(nc/2-1),nc/2
       Do ciy = -(nb/2-1),nb/2
          Do cix = -(na/2-1),na/2
             i = get_index_1D(cix+na/2,ciy+nb/2,ciz+nc/2)
             rkar(i) = &
                  &    DSQRT((dble(cix)/Ta)**2 + (dble(ciy)/Tb)**2 + (dble(ciz)/Tc)**2)
          Enddo
       Enddo
    Enddo
#else
    Do i=1, 3
       bb(1,i) = rltv(i,1) /PAI /2.0d0
       bb(2,i) = rltv(i,2) /PAI /2.0d0
       bb(3,i) = rltv(i,3) /PAI /2.0d0
    End Do

    do i=1,nfft_div_size
       c1 = ica(i) 
       c2 = icb(i) 
       c3 = icc(i) 
       ca = c1-na/2
       cb = c2-nb/2
       cc = c3-nc/2
       !cix = MOD(ca+na,na)+1
       !ciy = MOD(cb+nb,nb)+1
       !ciz = MOD(cc+nc,nc)+1
       !cir = get_index_1D(ca+na/2,cb+nb/2,cc+nc/2)
       vec(1:3) = dble(ca) *bb(1,1:3) &
            &    +dble(cb) *bb(2,1:3) &
            &    +dble(cc) *bb(3,1:3)
       rkar(i) = DSQRT( vec(1)**2 +vec(2)**2 +vec(3)**2 )
    enddo
!    Do ciz = -(nc/2-1),nc/2
!       Do ciy = -(nb/2-1),nb/2
!          Do cix = -(na/2-1),na/2
!             vec(1:3) = dble(cix) *bb(1,1:3) &
!                  &    +dble(ciy) *bb(2,1:3) &
!                  &    +dble(ciz) *bb(3,1:3)
!             i = get_index_1D(cix+na/2,ciy+nb/2,ciz+nc/2)
!             rkar(i) = DSQRT( vec(1)**2 +vec(2)**2 +vec(3)**2 )
!          End Do
!       End Do
!    End Do
#endif

  end subroutine alloc_vdw

  subroutine build_icaicbicc()
    integer :: i,j
    integer :: ind(3)
    do i=1,nfft_div_size
       j = mp_fftcd(i) 
       ind = get_index_3D(j)
       ica(i) = ind(1)
       icb(i) = ind(2)
       icc(i) = ind(3)
    enddo
  end subroutine build_icaicbicc

  subroutine finalize_vdwdf()
    call dealloc()

  contains
    subroutine dealloc()
      deallocate(ica)
      deallocate(icb)
      deallocate(icc)
      deallocate(mp_fftcd)
      deallocate(imp_fftcd)
      deallocate(rho)
      deallocate(grad)
      deallocate(theta_G)
      deallocate(theta_R)
      if(.not.oneshot)then
         deallocate(dtheta_R)
         deallocate(ddtheta_R)
      endif
      deallocate(theta_G_a)
      deallocate(theta_G_b)
      deallocate(phi_ab)
      if(eval_kernel_by_interpolation.and.oneshot) deallocate(phidD)
      deallocate(qar)
      deallocate(q2ar)
      deallocate(theta_G_ab)
      if(.not.oneshot)then
         !         deallocate(ualpha_g)
         !         deallocate(ualpha_r)
         deallocate(dFdrho)
         deallocate(dFddrho)
      endif
      deallocate(rkar)
      !
      if ( allocated( cgrad ) ) deallocate( cgrad )
    end subroutine dealloc
  end subroutine finalize_vdwdf

  subroutine build_lookup_table(ndel,nphiD,phidD)
    use progress_bar
    implicit none
    integer, intent(in) :: ndel,nphiD
    real(kind=DP), intent(out), dimension(0:ndel,-1:nphiD+1) :: phidD
    integer cdel,cphiD
    real(kind=DP) :: del,phiD,di,dk,tmp
    real(kind=DP) :: ddel,dphiD
    integer :: ierr
    integer :: id_sname=-1

    call tstatc0_begin('build_lookup_table ',id_sname,1)

    phidD = 0.d0
    ddel = 1.d0 /dble(ndel)
    dphiD = (q0max*eta1-q0min*etai)/(dble(nphiD))

    if(lprog) then
       call reset_progress()
       call set_end(int(floor(dble(ndel+1)/dble(npes))))
    endif

    do cdel=0,ndel
       if(mod(cdel,npes)/=mype) cycle
       if(lprog) call progress()
       do cphiD = -1,nphiD+1
          del = dble(cdel)*ddel
          phiD = q0min*etai + dble(cphiD)*dphiD
          di = phiD*(1.d0+del)
          dk = phiD*(1.d0-del)
          Call kernel_phi(di,dk,tmp)
          phidD(cdel,cphiD) = tmp
       enddo
    enddo
    if(npes>1) &
         & call mpi_allreduce(MPI_IN_PLACE,phidD,(ndel+1)*(nphiD+2),mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    call tstatc0_end(id_sname)
  end subroutine build_lookup_table

  subroutine build_theta()
    use progress_bar, only : reset_progress,progress,set_end
    integer :: cqa,ierr
    integer :: id_sname = -1
    real(kind=DP),allocatable,dimension(:) :: tmpdr,tmpddr

    call tstatc0_begin('build_theta ',id_sname,1)

    !+++++++++++++++ Execute FFT for theta_R_ab ++++++++++++++++++++
    if(printable.and.lprog) &
         & write(nfout,'(a)') 'building theta (spline coefficient x rho) and their Fourier transforms ...'
    if(lprog)then
       call reset_progress()
       call set_end(int(floor(dble(nq0)/dble(nrank_ke))))
    endif
    theta_G_ab(:,:) = (0.d0,0.d0)

    if(.not.oneshot)then
       allocate(tmpdr(nfft_div_size));tmpdr=0.d0
       allocate(tmpddr(nfft_div_size));tmpddr=0.d0
       dtheta_R=0.d0;ddtheta_R=0.d0
    else
       allocate(tmpdr(1))
       allocate(tmpddr(1))
    endif
    Do cqa = ista_nq,iend_nq
       if(lprog) call progress()
       Call theta_ab(nfft_div_size,cqa,nq0,q0min,q0max,rho,grad,rhomin,theta_R,tmpdr,tmpddr)
       Call RtoG(na,nb,nc,theta_R,theta_G)
       if(sw_save_memory_vdw)then
          theta_G_ab(map_z_nq(cqa),:) = theta_G(:)
       else
          theta_G_ab(cqa,:) = theta_G(:)
       endif
       if(.not.oneshot)then
          dtheta_R  (map_z_nq(cqa),:) = tmpdr  (:)
          ddtheta_R (map_z_nq(cqa),:) = tmpddr (:)
       endif
    Enddo

    if(.not.sw_save_memory_vdw)then
       call mpi_allreduce(MPI_IN_PLACE,theta_G_ab,nq0*nfft_div_size,mpi_double_complex, &
            &    mpi_sum,mpi_g_world,ierr) 
    endif
    deallocate(tmpdr)
    deallocate(tmpddr)

    if(printable.and.lprog) write(nfout,'(a)') '... done'
    call tstatc0_end(id_sname)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  end subroutine build_theta

  subroutine phiab_by_interpl(ca,cb,nr12,phi_ab)
    Implicit none
    integer, intent(in) :: ca,cb,nr12
    real(kind=DP), intent(out), dimension(0:nr12) :: phi_ab

    integer :: i,cr12,ierr
    real(kind=DP) :: r12,dr12,qa,qb,qab,phiD,del,ddel,phix,phiy
    integer :: cdel,cphiD

    real(kind=DP) :: rs,di,dk,phid_s,phid_s1,d_phid_s,phi2,phi4
    real(kind=DP) :: dr=0.001d0

    real(kind=DP) :: phi1u
    integer :: id_sname=-1

    call tstatc0_begin('phiab ',id_sname,1)

    phi_ab = 0.d0
    dr12 = r12max/DBLE(nr12)
    qa = qar(ca)
    qb = qar(cb)
    qab = DSQRT(qa**2+qb**2)

    ! Coefficients phi2 and phi4 in the local part is determined to
    ! match the non-local part in value and slope at d=d_s.

    rs = ds/qab

    di = qa*rs
    dk = qb*rs
    Call kernel_phi(di,dk,phid_s)

    di = qa*(rs+dr)
    dk = qb*(rs+dr)
    Call kernel_phi(di,dk,phid_s1)

    d_phid_s = (phid_s1 - phid_s)/dr

    phi2 = ( 2.d0/ds**2)*(phid_s-phi0) - (rs/(2.d0*ds**2))*d_phid_s
    phi4 = (-1.d0/ds**4)*(phid_s-phi0) + (rs/(2.d0*ds**4))*d_phid_s

    i = DINT((ds/qab)/dr12)
    ! Non-local part of phi_ab(r12)
    if(i.ge.nr12)return
    ddel = 1/dble(ndel)
    do cr12 = i+1,nr12
       if(mod(cr12,nrank_g) /= myrank_g ) cycle
       r12 = DBLE(cr12)*dr12

       di = qa*r12
       dk = qb*r12

       del  = dabs(di-dk)/(di+dk)
       phiD = 0.5d0*(di+dk)
       cdel = DINT(del/ddel)
       cphiD = DINT(DBLE(nphiD)*(phiD-q0min*etai)/(q0max*eta1-q0min*etai))
       !     write(6,*) 'cdel, cphiD: ',cdel,cphiD
       if(cdel.ge.ndel.or.cphiD.ge.nphiD.or.cdel.lt.0.or.cphiD.lt.-1)cycle
       phix = del/ddel - dble(cdel)
       phiy = dble(nphiD)*(phiD-q0min*etai)/(q0max*eta1-q0min*etai) - dble(cphiD)
       phi1u =  (1.d0-phix)*(1.d0-phiy) * phidD(cdel  ,cphiD  ) &
            &              +       phix *(1.d0-phiy) * phidD(cdel+1,cphiD  ) &
            &              +(1.d0-phix)*   phiy  * phidD(cdel  ,cphiD+1) &
            &              +      phix *   phiy  * phidD(cdel+1,cphiD+1)
       phi_ab(cr12) = phi1u
    enddo

    ! Local part of phi_ab(r12)
    Do cr12 = 0,i
       if(mod(cr12,nrank_g) /= myrank_g ) cycle
       r12 = DBLE(cr12)*dr12

       !d1 = qa*r12
       !d2 = qb*r12
       phiD = qab*r12
       phi_ab(cr12) = phi0 + phi2*phiD**2 + phi4*phiD**4
    Enddo

    if(nrank_g>1) &
    & call mpi_allreduce(MPI_IN_PLACE,phi_ab,nr12+1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    call tstatc0_end(id_sname)
  end subroutine phiab_by_interpl

  !** SUBROUTINE phiab **************************************************************************
  Subroutine phiab(ca,cb,nr12,phi_ab)
    Implicit none

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    Integer,intent(in) :: ca,cb,nr12
    Real(kind=DP),intent(out) :: phi_ab(0:nr12)

    ! Internal valuables
    Integer cr12,i,ierr
    Real(kind=DP) qab,qa,qb,r12,rs,phiD,dr12,phi2,phi4,phid_s,phid_s1,d_phid_s,d1,d2,abs_d
    Real(kind=DP) di,dk,tmp,dr
    Parameter(dr=0.001d0)
    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
    integer :: id_sname=-1
    call tstatc0_begin('phiab ',id_sname,1)

    dr12 = r12max/DBLE(nr12)
    qa = qar(ca)
    qb = qar(cb)
    qab = DSQRT(qa**2+qb**2)

    ! Coefficients phi2 and phi4 in the local part is determined to
    ! match the non-local part in value and slope at d=d_s.

    rs = ds/qab

    di = qa*rs
    dk = qb*rs
    Call kernel_phi(di,dk,phid_s)

    di = qa*(rs+dr)
    dk = qb*(rs+dr)
    Call kernel_phi(di,dk,phid_s1)

    d_phid_s = (phid_s1 - phid_s)/dr

    phi2 = ( 2.d0/ds**2)*(phid_s-phi0) - (rs/(2.d0*ds**2))*d_phid_s
    phi4 = (-1.d0/ds**4)*(phid_s-phi0) + (rs/(2.d0*ds**4))*d_phid_s

    i = DINT((ds/qab)/dr12)
    ! Non-local part of phi_ab(r12)
    if(i.ge.nr12)return

    Do cr12 = i+1,nr12
       if(mod(cr12,nrank_g) /= myrank_g) cycle
       r12 = DBLE(cr12)*dr12

       di = qa*r12
       dk = qb*r12

       Call kernel_phi(di,dk,tmp)
       phi_ab(cr12) = tmp

    Enddo

    ! Local part of phi_ab(r12)
    Do cr12 = 0,i
       if(mod(cr12,nrank_g) /= myrank_g) cycle
       r12 = DBLE(cr12)*dr12

       d1 = qa*r12
       d2 = qb*r12
       phiD = qab*r12
       phi_ab(cr12) = phi0 + phi2*phiD**2 + phi4*phiD**4
    Enddo
    if(nrank_g>1) &
    & call mpi_allreduce(MPI_IN_PLACE,phi_ab,1+nr12,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    call tstatc0_end(id_sname) 
  End subroutine phiab
  !** End SUBROUTINE phiab **********************************************************************

  subroutine vdWdf()
    if(sw_save_memory_vdw) then
       call vdWdf_core()
       !call vdWdf_core2()
    else
       call vdWdf_core_org()
    endif
  end subroutine vdWdf

  subroutine vdWdf_core_org()
    use progress_bar
    real(kind=DP) :: fac
    integer :: cqaa,cqa,cqb,ierr
    integer :: i,ic,i2,i3
    complex(kind=DP), allocatable, dimension(:) :: tmpug,tmpur
    integer :: id_sname = -1
    integer :: id_sname3 = -1

    call tstatc0_begin('vdWdf_core ',id_sname,1)
    Ecnl_12 = 0.0d0
    if(printable.and.lprog) &
         & write(nfout,'(a)') 'performing the core operation : Ecnl = sum theta_a x phi_ab x theta_b ...'
    if(lprog)then
       call reset_progress()
       call set_end(int(floor(dble(nq0)/dble(nrank_ke))))
    endif
    if(.not.oneshot)then
       allocate(tmpug(nfft_div_size));tmpug=0.d0
       allocate(tmpur(nfft_div_size));tmpur=0.d0
       !       ualpha_g = (0.d0,0.d0)
    else
       allocate(tmpug(1))
    endif
    if(.not.oneshot)then
       dFdrho=0.d0;dFddrho=0.d0
    endif

    do cqaa=1,np_nq
       cqa = real_index(cqaa)
       theta_G_a(:) = theta_G_ab(cqa,:)
       if (.not.oneshot)  tmpug=(0.d0,0.d0)
       if (lprog) call progress()
       call tstatc0_begin('vdw_core_core ',id_sname3,1)
       do cqb=1,nq0
          theta_G_b(:) = theta_G_ab(cqb,:)
          fac = 1.d0
          if(eval_kernel_by_interpolation) then
             call phiab_by_interpl(cqa,cqb,nr12,phi_ab)
          else
             Call phiab(cqa,cqb,nr12,phi_ab)
          endif
          Call convolution_3d_by_fft(&
               &    na,nb,nc,cqa,cqb,nr12,phi_ab,theta_G_a,theta_G_b,fac,Ecnl_12_ab,tmpug)
          Ecnl_12 = Ecnl_12 + Ecnl_12_ab
       enddo
       call tstatc0_end(id_sname3)
       if(.not.oneshot)then
          call GtoR(na,nb,nc,tmpur,tmpug)
          dFdrho(:) = dFdrho(:) + dble(tmpur(:))*dtheta_R(cqaa,:)
          dFddrho(:) = dFddrho(:) + dble(tmpur(:))*ddtheta_R(cqaa,:)
       endif
    enddo

    if(.not.oneshot)then
       if(nrank_ke>1) then
          call mpi_allreduce(MPI_IN_PLACE,dFdrho, &
               &             nfft_div_size,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
          call mpi_allreduce(MPI_IN_PLACE,dFddrho, &
               &             nfft_div_size,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
          deallocate(tmpur)
       endif
       deallocate(tmpug)
    endif

    if(npes>1) then
       call mpi_allreduce(MPI_IN_PLACE,Ecnl_12,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    endif
    if(printable.and.lprog) write(nfout,'(a)') '... done'
    call tstatc0_end(id_sname)

  end subroutine vdWdf_core_org

  subroutine vdWdf_core()
    use progress_bar
    real(kind=DP) :: fac, grho, rtmp, esum
    integer :: cqaa,cqa,cqb,ierr
    integer :: i,ic,i2,i3, cir, cix, ciy ,ciz
    complex(kind=DP), allocatable, dimension(:) :: tmpug,tmpur
    complex(kind=DP), allocatable, dimension(:,:) :: theta_buf_s,theta_buf_r
    integer :: ipos,i0,i1,isend,irecv,ireq,ireqr
    integer, allocatable, dimension(:) :: ista
    integer :: id_sname = -1, id_sname2 = -1, id_sname3 = -1

    Ecnl_12 = 0.0d0
    esum = 0.0d0

    call tstatc0_begin('vdWdf_core ',id_sname,1)
    if(printable.and.lprog) &
         & write(nfout,'(a)') 'performing the core operation : Ecnl = sum theta_a x phi_ab x theta_b ...'

    if(lprog)then
       call reset_progress()
       call set_end(int(floor(dble(nq0)/dble(nrank_ke))))
    endif

    if(nrank_ke>1)then
       allocate(ista(MPI_STATUS_SIZE))
       allocate(theta_buf_r(1:mp_nq,nfft_div_size));theta_buf_r=(0.d0,0.d0)
    endif

    if(.not.oneshot)then
       allocate(tmpug(nfft_div_size));tmpug=0.d0
       allocate(tmpur(nfft_div_size));tmpur=0.d0
       !       ualpha_g = (0.d0,0.d0)
    else
       allocate(tmpug(1))
       allocate(tmpur(1))
    endif
    if(.not.oneshot)then
       dFdrho=0.d0;dFddrho=0.d0
    endif

    irecv = myrank_ke+1
    if(irecv.ge.nrank_ke) irecv = irecv-nrank_ke
    isend = myrank_ke-1
    if(isend.lt.0)        isend = isend+nrank_ke

    do cqaa=1,mp_nq
       cqa = real_index(cqaa)
       if (nrank_ke>1)        theta_buf_r(1:np_nq,:) = theta_G_ab(1:np_nq,:)
       if (cqaa.le.np_nq) theta_G_a(:) = theta_G_ab(cqaa,:)

       if (.not.oneshot)  tmpug=(0.d0,0.d0)
       if (lprog)       call progress()

       call tstatc0_begin('vdw_core_core ',id_sname3,1)

       do i0=0,nrank_ke-1
          ipos = i0+myrank_ke
          if(ipos.ge.nrank_ke) ipos = ipos-nrank_ke
          if(ipos.lt.0)        ipos = ipos+nrank_ke

          if(cqaa.le.np_nq)then
             do i1=1,nel_nq(ipos)
                cqb = real_index(i1,ipos)
                if(nrank_ke>1)then
                   theta_G_b(:) = theta_buf_r(i1,:)
                else
                   theta_G_b(:) = theta_G_ab(i1,:)
                endif

                fac = 1.d0
                if(eval_kernel_by_interpolation) then
                   call phiab_by_interpl(cqa,cqb,nr12,phi_ab)
                else
                   Call phiab(cqa,cqb,nr12,phi_ab)
                endif
                Call convolution_3d_by_fft( na,nb,nc,cqa,cqb,nr12,phi_ab, &
                     &                      theta_G_a,theta_G_b,fac,Ecnl_12_ab,tmpug)
                Ecnl_12 = Ecnl_12 + Ecnl_12_ab
             enddo
          endif
          if(nrank_ke>1.and.i0.ne.nrank_ke-1)then
             call tstatc0_begin('vdWdf_core (comm) ',id_sname2,1)
             allocate(theta_buf_s(1:mp_nq,nfft_div_size))
             theta_buf_s = theta_buf_r
             call mpi_sendrecv(theta_buf_s,mp_nq*nfft_div_size,mpi_double_complex,isend,0, &
                  &            theta_buf_r,mp_nq*nfft_div_size,mpi_double_complex,irecv,0, &
                  &            mpi_g_world,ista,ierr)
             deallocate(theta_buf_s)
             call tstatc0_end(id_sname2)
          endif
       enddo
       call tstatc0_end(id_sname3)
       if(.not.oneshot) call GtoR(na,nb,nc,tmpur,tmpug)
       if(.not.oneshot.and.cqaa.le.np_nq)then
#if 1
          dFdrho(:) = dFdrho(:) + dble(tmpur(:))*dtheta_R(cqaa,:)
          if ( .not. grad_rho_eq_0 ) then
             do cir = 1,nfft_div_size
                grho = grad(cir)
                rtmp = rho(cir)
                if ( grho > 1.0d-6 ) then
                   dFddrho(cir) = dFddrho(cir) &
                        &                + dble(tmpur(cir)) &
                        &                 *ddtheta_R(cqaa,cir) /grho
                endif
             end do
          endif
#else
          dFdrho(:) = dFdrho(:) + dble(tmpur(:))*dtheta_R(cqaa,:)
          if ( .not. grad_rho_eq_0 ) then
             dFddrho(:) = dFddrho(:) + dble(tmpur(:))*ddtheta_R(cqaa,:)
          endif
#endif

          if ( iprixc >= 2 ) then
             do cir = 1,nabc
                esum = esum +dble(tmpur(cir)) *theta_R(cir)
             end do
          endif
       endif
    enddo

    if(.not.oneshot)then
       if(nrank_ke>1) then
          call mpi_allreduce(MPI_IN_PLACE,dFdrho, &
               &             nfft_div_size,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
          call mpi_allreduce(MPI_IN_PLACE,dFddrho, &
               &             nfft_div_size,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
          deallocate(tmpur)
       endif
       deallocate(tmpug)
    endif

    if(npes>1) then
       call mpi_allreduce(MPI_IN_PLACE,Ecnl_12,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    endif

    if ( iprixc >=2 ) then
       esum = esum *univol *rinplw /2.0d0
       call mpi_allreduce(MPI_IN_PLACE,Esum,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       write(nfout,*) "vdw nonolocal E12 "
       write(nfout,*) "evaluation in real       space : ", esum
       write(nfout,*) "           in reciprocal space : ", ecnl_12
    endif

    if(nrank_ke>1)then
       deallocate(ista)
       deallocate(theta_buf_r)
    endif
    if(printable.and.lprog) write(nfout,'(a)') '... done'
    call tstatc0_end(id_sname)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  end subroutine vdWdf_core

  subroutine vdWdf_core2()
    use progress_bar
    real(kind=DP) :: fac
    integer :: cqbb,cqa,cqb,ierr
    integer :: i,ic,i2,i3
    complex(kind=DP), allocatable, dimension(:) :: tmpug,tmpur
    complex(kind=DP), allocatable, dimension(:,:) :: theta_buf_s,theta_buf_r
    real(kind=DP), allocatable, dimension(:,:) :: dtheta_buf
    integer :: ipos,i0,i1,isend,irecv,ireq,ireqr
    integer, allocatable, dimension(:) :: ista
    integer :: id_sname = -1
    integer :: id_sname2 = -1

    call tstatc0_begin('vdWdf_core2 ',id_sname,1)
    Ecnl_12 = 0.0d0
    if(printable.and.lprog) &
         & write(nfout,'(a)') 'performing the core operation : Ecnl = sum theta_a x phi_ab x theta_b ...'
    if(lprog)then
       call reset_progress()
       call set_end(int(floor(dble(nq0)/dble(nrank_ke))))
    endif
    if(nrank_ke>1)then
       allocate(ista(MPI_STATUS_SIZE))
       allocate(theta_buf_r(1:mp_nq,nfft_div_size));theta_buf_r=(0.d0,0.d0)
       if(.not.oneshot)then
          allocate(dtheta_buf(mp_nq,nfft_div_size));dtheta_buf=0.d0
       endif
    endif
    if(.not.oneshot)then
       allocate(tmpug(nfft_div_size));tmpug=0.d0
       allocate(tmpur(nfft_div_size));tmpur=0.d0
       !       ualpha_g = (0.d0,0.d0)
    else
       allocate(tmpug(1))
    endif
    if(.not.oneshot)then
       dFdrho=0.d0;dFddrho=0.d0
    endif

    irecv = myrank_ke+1
    if(irecv.ge.nrank_ke) irecv = irecv-nrank_ke
    isend = myrank_ke-1
    if(isend.lt.0)        isend = isend+nrank_ke

    if (nrank_ke>1) theta_buf_r(1:np_nq,:) = theta_G_ab(1:np_nq,:)
    do i0=0,nrank_ke-1
       ipos = i0+myrank_ke
       if(ipos.ge.nrank_ke) ipos = ipos-nrank_ke
       if(ipos.lt.0)        ipos = ipos+nrank_ke
       do i1=1,nel_nq(ipos)
          cqa = real_index(i1,ipos)
          if(nrank_ke>1)then
             theta_G_a(:) = theta_buf_r(i1,:)
          else
             theta_G_a(:) = theta_G_ab(i1,:)
          endif
          do cqbb=1,np_nq
             theta_G_b(:) = theta_G_ab(cqbb,:)
             fac = 1.d0
             cqb = real_index(cqbb)
             if(eval_kernel_by_interpolation) then
                call phiab_by_interpl(cqa,cqb,nr12,phi_ab)
             else
                Call phiab(cqa,cqb,nr12,phi_ab)
             endif
             Call convolution_3d_by_fft(&
                  &    na,nb,nc,cqa,cqb,nr12,phi_ab,theta_G_a,theta_G_b,fac,Ecnl_12_ab,tmpug)
             Ecnl_12 = Ecnl_12 + Ecnl_12_ab
          enddo
          if(.not.oneshot)then
             !             call mpi_allreduce(MPI_IN_PLACE,tmpug,na*nb*nc,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
             call GtoR(na,nb,nc,tmpur,tmpug)
             dFdrho(:) = dFdrho(:) + dble(tmpur(:))*dtheta_R(i1,:)
             dFddrho(:) = dFddrho(:) + dble(tmpur(:))*ddtheta_R(i1,:)
          endif
       enddo
       if(nrank_ke>1)then
          call tstatc0_begin('vdWdf_core (comm) ',id_sname2,1)
          allocate(theta_buf_s(1:mp_nq,nfft_div_size))
          theta_buf_s = theta_buf_r
          call mpi_sendrecv(theta_buf_s,mp_nq*nfft_div_size,mpi_double_complex,isend,0, &
               &            theta_buf_r,mp_nq*nfft_div_size,mpi_double_complex,irecv,0, &
               &            mpi_g_world,ista,ierr)
          if(.not.oneshot)then
             dtheta_buf = dtheta_R
             call mpi_sendrecv(dtheta_buf,mp_nq*nfft_div_size,mpi_double_precision,isend,0, &
                  &            dtheta_R,  mp_nq*nfft_div_size,mpi_double_precision,irecv,0, &
                  &            mpi_g_world,ista,ierr)
             dtheta_buf = ddtheta_R
             call mpi_sendrecv(dtheta_buf,mp_nq*nfft_div_size,mpi_double_precision,isend,0, &
                  &            ddtheta_R, mp_nq*nfft_div_size,mpi_double_precision,irecv,0, &
                  &            mpi_g_world,ista,ierr)
          endif
          deallocate(theta_buf_s)
          call tstatc0_end(id_sname2)
       endif
    enddo

    if(.not.oneshot)then
       if(nrank_ke>1) then
          call mpi_allreduce(MPI_IN_PLACE,dFdrho, &
               &             nfft_div_size,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
          call mpi_allreduce(MPI_IN_PLACE,dFddrho, &
               &             nfft_div_size,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
          deallocate(tmpur)
       endif
       deallocate(tmpug)
    endif

    if(npes>1) then
       call mpi_allreduce(MPI_IN_PLACE,Ecnl_12,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    endif
    if(nrank_ke>1)then
       deallocate(ista)
       deallocate(theta_buf_r)
       if(.not.oneshot) deallocate(dtheta_buf)
    endif
    if(printable.and.lprog) write(nfout,'(a)') '... done'
    call tstatc0_end(id_sname)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  end subroutine vdWdf_core2

  subroutine corrections()
!!$if(printable) write(nfout,'(a)') 'calculating correction terms and contribution from the LDA ...'
    if(printable.and.lprog) write(nfout,'(a)') 'calculating correction terms ...'
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    Call piDphi(Ecnl_3,Ecnl_3s)
!!$    Call cLDA(na,nb,nc,rho,rhomin,dv,EcLDA)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    if(printable.and.lprog) write(nfout,'(a)') '... done'
  end subroutine corrections

  subroutine theta_ab(nxyz,ca,nq0,q0min,q0max,rho,grad,rhomin,theta_R,dtheta_R,ddtheta_R)
    Implicit none

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    Integer, intent(in) :: nxyz,ca,nq0
    Real(kind=DP), intent(in)  :: q0min,q0max,rhomin
    Real(kind=DP), intent(in)  :: rho(nxyz),grad(nxyz)
    real(kind=DP), intent(out) :: theta_R(nxyz),dtheta_R(nxyz),ddtheta_R(nxyz)

    ! Internal valuables
    Integer cir
    Real(kind=DP) ni,dni,q0,dqdn,dqddn

    real(kind=DP),allocatable,dimension(:) :: y,y2tmp
    real(kind=DP) :: yout,y1out
    integer :: id_sname = -1

    call tstatc0_begin('theta_ab ',id_sname,1)
    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
    allocate(y(nq0));y=0.d0;y(ca)=1.d0
    allocate(y2tmp(nq0));y2tmp(:) = q2ar(ca,:)
    ! For the functions theta_R
    Do cir = 1,nxyz
       q0 = q0max
       ni = MAX(rho(cir),rhomin)
       dni = grad(cir)
       Call d_q0(ni,dni,q0min,q0max,q0,dqdn,dqddn)

       call cubic_spline(nq0,qar,y,y2tmp,q0,yout,y1out)
       theta_R  (cir) = yout*ni
       if(.not.oneshot)then
          dtheta_R (cir) = yout+ni*y1out*dqdn
          ddtheta_R(cir) = ni*y1out*dqddn
       endif
! ----
       if ( sw_use_WuGygi_method == ON ) then
          theta_R(cir) = theta_R(cir) *qar(ca) /q0
          if ( .not. oneshot ) then
             dtheta_R(cir) = dtheta_R(cir) *qar(ca) /q0 &
                  &                -theta_R(cir) *dqdn /q0
             ddtheta_R(cir) = ddtheta_R(cir) *qar(ca) /q0 &
                  &                -theta_R(cir) *dqddn /q0
          endif
       endif
! ----
    End do
    deallocate(y);   deallocate(y2tmp)
    call tstatc0_end(id_sname)
  end subroutine theta_ab

  !** SUBROUTINE piDphi **********************************************************************************
  Subroutine piDphi(Ecii,Ecii_s)
    implicit none


    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    real(kind=DP), intent(out) :: Ecii,Ecii_s

    Real(kind=DP) da,db,a1,a2,dr
    Parameter (dr = 0.001d0)
    Integer  ci,cj,ck,ca,cb

    ! Gauss-Legendre integration
    Integer cD,nD
    Parameter (nD=10)
    Real(kind=DP) maxD,minD,dD,LD,PLD,LDxi(nD),LDwi(nD)
    Parameter (minD=0.d0)

    Integer  cix,ciy,ciz,cir,cjx,cjy,cjz,cjr
    Real(kind=DP)  di,dj,dk,d_di,d_dj,d_dk,eta,dx,dy,dz,n,ni,nj,nk
    Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm
    Parameter (eta=0.00000001)

    Real(kind=DP) x,nnx,nny,nnz,nn2,r
    Real(kind=DP) nxp,nxm,nyp,nym,nzp,nzm
    Real(kind=DP) zx(-3:3),zy(-3:3),zz(-3:3),rn(3,-3:3)

    Real(kind=DP) phi

    Real(kind=DP) temp,rs,phid_s,phid_s1,d_phid_s,phi2,phi4

    ! The table of phi1D
    Integer c1D,n1D,ierr
    Parameter(n1D = 1000)
    Real(kind=DP) d1D,max1D,D,phix,phiy
    Real(kind=DP) phi1D(0:n1D+1)
    real(kind=DP) :: q0,dqdn,dqddn
    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



    !---------------------- Calculation Start ----------------------
    ! Make the table of phi1D
    max1D = ds
    d1D = max1D/DBLE(n1D)
    Do c1D = 0,n1D+1
       D = DBLE(c1D)*d1D
       Call kernel_phi(D,D,phi)
       phi1D(c1D) = phi
    Enddo


    Ecii = 0
    Do cjr = 1,nfft_div_size
!       if(mod(cjr,npes)/=mype) cycle
!       cjx = 1+(cjr-1-MOD(cjr-1+nb*nc,nb*nc))/(nb*nc)
!       cjy = 1+(cjr-nb*nc*(cjx-1)-1-MOD(cjr-1+nc,nc))/nc
!       cjz = cjr-nc*(nb*(cjx-1)-1+cjy)

       n = MAX(rho(cjr),rhomin)

       Call d_q0(n,grad(cjr),q0min,q0max,q0,dqdn,dqddn)
       maxD=ds

       Call gauleg(minD,maxD,nD,LDxi,LDwi)

       temp = 0.d0
       Do cD=1,nD
          LD = LDxi(cD)

          c1D = DINT(LD/d1D)
          phix = (LD - d1D*DBLE(c1D))/d1D
          phiy = 1.d0 - phix
          temp = temp + LDwi(cD)*4.d0*pi*(LD**2) * (phiy*phi1D(c1D) + phix*phi1D(c1D+1))

       Enddo
       Ecii = Ecii + dv*0.5d0*(n**2)*temp/(q0**3)
    Enddo
    call mpi_allreduce(MPI_IN_PLACE,Ecii,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)

    Ecii_s = 0.d0
    Do cjr = 1,nfft_div_size
!       if(mod(cjr,npes)/=mype) cycle

       n = MAX(rho(cjr),rhomin)

       Call d_q0(n,grad(cjr),q0min,q0max,q0,dqdn,dqddn)
       rs = ds/DSQRT(q0**2+q0**2)
       di = q0*rs
       dk = q0*rs
       c1D = DINT(di/d1D)
       phix = (di - d1D*DBLE(c1D))/d1D
       phiy = 1.d0 - phix
       phid_s = phiy*phi1D(c1D) + phix*phi1D(c1D+1)

       di = q0*(rs+dr)
       dk = q0*(rs+dr)
       c1D = DINT(di/d1D)
       phix = (di - d1D*DBLE(c1D))/d1D
       phiy = 1.d0 - phix
       phid_s1 = phiy*phi1D(c1D) + phix*phi1D(c1D+1)

       d_phid_s = (phid_s1- phid_s)/dr

       phi2 = ( 2.d0/ds**2)*(phid_s-phi0) - (rs/(2.d0*ds**2))*d_phid_s
       phi4 = (-1.d0/ds**4)*(phid_s-phi0) + (rs/(2.d0*ds**4))*d_phid_s

       Ecii_s = Ecii_s + 0.5d0*4.d0*pi*dv*(n**2)*            &
            &                    (phi0*(rs**3)*(q0**0)/3.d0 +            &
            &                     phi2*(rs**5)*(q0**2)/5.d0 +            &
            &                     phi4*(rs**7)*(q0**4)/7.d0)


    Enddo
    call mpi_allreduce(MPI_IN_PLACE,Ecii_s,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
  End Subroutine piDphi
  !** End SUBROUTINE piDphi **********************

  !** SUBROUTINE cLDA ****************************
  Subroutine cLDA(na,nb,nc,rho,rhomin,dv,EcLDA)
    Implicit none

    !************************ Note *********************************
    ! This Algorism follows Dion's 1-shot method.
    !
    ! This program is a subroutine.
    ! This program calculates the correlation energy from LDA.
    ! The formula is given at Eq.(58) (p.93) of 'Theory of the
    !   Inhomogeneous Electron Gas' Lundqvist, March.
    !
    !
    ! Input
    !   rho(nrxyz,nsipn) : Total density
    !
    ! Output
    !   EcLDA : Correlation energy from LDA.
    !
    !
    !                            Written by Youky Ono in 2009/Jul.
    !***************************************************************

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    integer,intent(in)  :: na,nb,nc
    real(kind=DP),intent(in)  :: rho(nabc)
    real(kind=DP),intent(in)  :: rhomin
    real(kind=DP),intent(in)  :: dv
    real(kind=DP),intent(out) :: EcLDA
    integer  cjx,cjy,cjz,cjr,ierr
    integer  i,j,k

    real(kind=DP) rs,x,aB,ec,n
    parameter (aB=1.d0) ! aB=1[a.u.]

    real(kind=DP)  e,m
    parameter (e=1.d0,m=1.d0) ! Hatree atomic unit
    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++

    !---------------------- Calculation Start ----------------------
    EcLDA=0
    Do cjr = 1,nfft_div_size
!       if(mod(cjr,npes)/=mype) cycle
       n = MAX(rho(cjr),rhomin)

       rs = ((3.d0/(4.d0*pi*n))**(1.d0/3.d0))/aB
       x = rs/11.4d0
       ec = -0.0666d0*0.5d0*((1.d0+x**3)*DLOG(1.d0+1.d0/x)-x**2+x/2.d0-1.d0/3.d0)

       EcLDA = EcLDA + dv*n*ec
    Enddo
    if(npes>1) call mpi_allreduce(MPI_IN_PLACE,EcLDA,1,mpi_double_precision,mpi_sum,mpi_g_world,ierr)
  End Subroutine cLDA
  !** End SUBROUTINE cLDA **********************

  ! Execute FFT and transform theta_R to theta_G
  Subroutine RtoG(na,nb,nc,theta_R,theta_G)
    Implicit none

    !!include "fftw3.f"


    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    Integer, intent(in) ::   na,nb,nc
    Integer :: cir
    Real(kind=DP) rx,ry,rz,kx,ky,kz,ra,rb,rc,ka,kb,kc,rk,r12,x,y,z,term,term1

    integer :: ca,cb,cc,cix,ciy,ciz,i,i2,c1,c2,c3,ierr
    integer :: m
    Real(kind=DP) theta_R(nfft_div_size)
    Complex(kind=DP) theta_G(nfft_div_size)

    ! FFTW3 !!!
    integer(kind=DP) :: plan
    Complex(kind=DP),allocatable :: temp_R(:),temp_G(:)

    real(kind=DP), allocatable, dimension(:) :: afft

    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
    allocate(temp_R(nabc));temp_R=(0.d0,0.d0)
    allocate(temp_G(nabc));temp_G=(0.d0,0.d0)
    !***** FFT **************************************************
    do ca=1,nfft_div_size
       temp_R(mp_fftcd(ca)) = DCMPLX(theta_R(ca))
    enddo
    call mpi_allreduce(MPI_IN_PLACE,temp_R,nabc,mpi_double_complex,mpi_sum,mpi_ke_world,ierr)

    allocate(afft(nfftp_nonpara));afft=0.d0
    call map_rho_to_afft(temp_R,afft)
    call m_FFT_CD0(nfout,afft,DIRECT)
    call map_afft_to_rho(afft,temp_G)

    ! FFTW3 !!!
!    call dfftw_plan_dft_3d(plan,na,nb,nc,temp_R(1),temp_G(1),FFTW_FORWARD,FFTW_ESTIMATE)
!    call dfftw_execute(plan)
!    call dfftw_destroy_plan(plan)
    do i=1,nfft_div_size
       c1 = ica(i) 
       c2 = icb(i) 
       c3 = icc(i) 
       ca = c1-na/2
       cb = c2-nb/2
       cc = c3-nc/2
       cix = MOD(ca+na,na)+1
       ciy = MOD(cb+nb,nb)+1
       ciz = MOD(cc+nc,nc)+1
       theta_G(i) = temp_G(get_index_1D(cix,ciy,ciz))/dble(nabc)
    enddo

!    do ca = -(na/2-1),na/2
!       do cb = -(nb/2-1),nb/2
!          do cc = -(nc/2-1),nc/2
!             cix = MOD(ca+na,na)+1
!             ciy = MOD(cb+nb,nb)+1
!             ciz = MOD(cc+nc,nc)+1
!             i = get_index_1D(cix,ciy,ciz) 
!             i2 = get_index_1D(ca+na/2,cb+nb/2,cc+nc/2)
!             if(imp_fftcd(i2)>0) theta_G(imp_fftcd(i2)) = temp_G(i) / DBLE(nabc)
!          enddo
!       enddo
!    enddo
    !***** END of FFT ******************************************

    deallocate(temp_R);   deallocate(temp_G)
    deallocate(afft)
  End subroutine RtoG
  !** End SUBROUTINE RtoG ***********************************************************************

  subroutine GtoR(na,nb,nc,theta_R,theta_G)
    !    include "fftw3.f"
    integer,intent(in) :: na,nb,nc
    complex(kind=DP), dimension(nfft_div_size), intent(in) :: theta_G
    complex(kind=DP), dimension(nfft_div_size), intent(out) :: theta_R

    integer :: cir,ca,cb,cc,cix,ciy,ciz,i,i2,c1,c2,c3,ierr
    integer(kind=DP) :: plan
    complex(kind=DP),allocatable :: temp_R(:),temp_G(:)
    real(kind=DP),allocatable,dimension(:) :: afft
    integer :: id_sname=-1
    call tstatc0_begin('GtoR ',id_sname,1)

    allocate(temp_R(nabc))
    allocate(temp_G(nabc));temp_G = (0.d0,0.d0)
    do i=1,nfft_div_size
       c1 = ica(i) 
       c2 = icb(i) 
       c3 = icc(i) 
       ca = c1-na/2
       cb = c2-nb/2
       cc = c3-nc/2
       cix = MOD(ca+na,na)+1
       ciy = MOD(cb+nb,nb)+1
       ciz = MOD(cc+nc,nc)+1
       temp_G(get_index_1D(cix,ciy,ciz)) = theta_G(i)
    enddo
    call mpi_allreduce(MPI_IN_PLACE,temp_G,nabc,mpi_double_complex,mpi_sum,mpi_ke_world,ierr)
    
!    Do ca = -(na/2-1),na/2
!       Do cb = -(nb/2-1),nb/2
!          Do cc = -(nc/2-1),nc/2
!             cix = MOD(ca+na,na)+1
!             ciy = MOD(cb+nb,nb)+1
!             ciz = MOD(cc+nc,nc)+1
!             i = get_index_1D(cix,ciy,ciz)
!             i2 = get_index_1D(ca+na/2,cb+nb/2,cc+nc/2)
!             temp_G(get_index_1D(cix,ciy,ciz)) = theta_G(get_index_1D(ca+na/2,cb+nb/2,cc+nc/2))
!          Enddo
!       Enddo
!    Enddo

    allocate(afft(nfftp_nonpara));afft = 0.d0
    call map_rhog_to_afft(temp_G,afft)
    call m_FFT_CD0(nfout,afft,INVERSE)
    call map_afft_to_rhog(afft,temp_R)
    do ca=1,nfft_div_size
       theta_R(ca) = temp_R(mp_fftcd(ca))
    enddo

    ! FFTW3 !!!
!    call dfftw_plan_dft_3d(plan,na,nb,nc,temp_G(1),temp_R(1),FFTW_BACKWARD,FFTW_ESTIMATE)
!    call dfftw_execute(plan)
!    call dfftw_destroy_plan(plan)
    !***** END of FFT ******************************************

    !    theta_R = temp_R/dble(na*nb*nc)
!    theta_R = temp_R

    deallocate(temp_R)
    deallocate(temp_G)
    deallocate(afft)
    call tstatc0_end(id_sname)
  end subroutine GtoR

  subroutine get_phi_ab_g(nr12,phi_ab,phi_ab_g)
    !    include "fftw3.f"
    integer, intent(in) :: nr12
    real(kind=DP), dimension(0:nr12), intent(in)  :: phi_ab
    real(kind=DP), dimension(0:nr12), intent(out) :: phi_ab_g
    complex(kind=DP), allocatable, dimension(:) :: cphiab_r
    complex(kind=DP), allocatable, dimension(:) :: cphiab_g
    integer :: cr,ck
    integer(kind=DP) :: plan
    real(kind=DP) :: dd,r12,term,rk
    real(kind=DP) :: rr
    complex(kind=DP) :: zsum
    complex(kind=DP), parameter :: zi = ( 0.0d0, 1.0d0 )

    integer :: id_sname = -1
    call tstatc0_begin('get_phi_ab_g ',id_sname,1)
    allocate(cphiab_r(0:nr12));cphiab_r=0.d0
    allocate(cphiab_g(0:nr12));cphiab_g=0.d0

    dd = r12max/dble(nr12)

    do cr=0,nr12
       rr = dble(cr) *dd
       cphiab_r(cr) = dcmplx( phi_ab(cr)*rr, 0.d0 )
    enddo

#if 0
    call dfftw_plan_dft_1d(plan,nr12+1,cphiab_r,cphiab_g,FFTW_BACKWARD,FFTW_ESTIMATE)
#else
    call dfftw_plan_dft_1d( plan, nr12, cphiab_r(0:nr12-1), cphiab_g(0:nr12-1), &
         &                  FFTW_BACKWARD, FFTW_ESTIMATE )
#endif
    call dfftw_execute(plan)
    call dfftw_destroy_plan(plan)

    do ck=1,nr12
       rk = dble(ck)/r12max
       phi_ab_g(ck) = 2.d0 *dd *dimag(cphiab_g(ck))/(dble(rk))
    enddo

    Do ck = 0,0
       rk = dd * dble(ck)
       term = 0.0d0
       Do cr = 0,nr12
          r12 = dd*dble(cr)
          term = term + phi_ab(cr) * (r12**2)
       Enddo
       phi_ab_g(ck) = 4.0d0*pi*dd * term
    End do

    deallocate(cphiab_r);   deallocate(cphiab_g)

    phi_ab_g = phi_ab_g / univol

    call tstatc0_end(id_sname)

  end Subroutine get_phi_ab_g

! ===============- For stress tensor =================
  subroutine initialize_vdwdf_stress( nspin, ispin, nfft_div_size, na, nb, nc, chgr, &
       &                              grad_rho, cgrad_rho, version_no )
    use progress_bar, only : set_printable

    integer, intent(in) :: nspin,ispin,nfft_div_size, na,nb,nc, version_no
    real(kind=DP), intent(in) :: chgr(nfft_div_size), grad_rho(nfft_div_size)
    real(kind=DP), intent(in) :: cgrad_rho(nfft_div_size,3)

    integer :: i,cir,cix,ciy,ciz,nrxyz,cir2
    real(kind=DP) :: q

    if ( version_no == 1 ) then
       Zab = Zab_0
    else if ( version_no == 2 ) then
       Zab = Zab_0 *2.222d0
    endif

    call set_printable(printable)
    call do_cell_params()

    rinplw = 1.d0/(dble(nabc))
    q0max = q0cut*1.01d0
!!!    q0min = 0.09d0
    nq0 = DINT(dLOG((q0max-q0min)*(lambda-1.d0)/dq_vdw+1.d0)/dLOG(lambda))+1
    maxk = dble(nr12)/r12max

    if(firstcall) call m_Parallel_init_mpi_nq(nfout,ipri,printable,nq0)
    if(firstcall) call print_vdw_parameters()

    call alloc_vdw()
    allocate( cgrad(nfft_div_size,3)); cgrad=0.d0
    rho(:) = chgr(:)
    grad(:) = grad_rho(:)
    cgrad(:,1:3) = cgrad_rho(:,1:3)

    if ( grad_rho_eq_0 )  grad = 0.0d0

    do i=1,nq0
       q = q0min + dq_vdw*(lambda**DBLE(i-1)-1.d0)/(lambda-1.d0)
       qar(i) = q
    enddo
    call spline0(nq0,qar,q2ar)

    if(eval_kernel_by_interpolation.and.firstcall) &
         &             call build_lookup_table(ndel,nphiD,phidD)
    firstcall = .false.
  end subroutine initialize_vdwdf_stress

  subroutine calc_stress_contrib2( na, nb, nc, cqa, cqb, nr12, phi_ab, &
       &                           theta_G_a, theta_G_b, fac, s_tensor, tmpug )
    Implicit none

    integer, intent(in) :: na,nb,nc,cqa,cqb,nr12
    complex(kind=DP), intent(in)  :: theta_G_a(nfft_div_size)
    complex(kind=DP), intent(in)  :: theta_G_b(nfft_div_size)
    real(kind=DP),    intent(in)  :: phi_ab(0:nr12)
    real(kind=DP),    intent(in)  :: fac
    real(kind=DP), intent(inout) :: s_tensor(3,3)
    complex(kind=DP), intent(inout) :: tmpug(nfft_div_size)

    Integer  i, u, v
    Integer cir,cix,ciy,ciz,cr,ck,c1,c2,c3

    Real(kind=DP) phix, phiy, Ta, Tb, Tc, bb(3,3), vec(3)
    Real(kind=DP) dk,rk,r12,term1, term2
    real(kind=DP) :: pi2rk, g1

    Real(kind=DP),allocatable :: core_G1(:), core_G2(:)
    Real(kind=DP),allocatable :: wk_x(:), wk_y(:)
    real(kind=DP) :: ctmp, z1

    integer :: id_sname = -1

    call tstatc0_begin('calc_stress_contrib2 ',id_sname,1)

    allocate(core_G1(0:nr12)); core_G1 = 0.d0
    allocate(core_G2(0:nr12)); core_G2 = 0.d0

    call get_phi_ab_g( nr12, phi_ab, core_G1 )

! ----
    dk = 1.0d0 /r12max

!    Do i=1, nr12 -1
!       z1 = ( core_G1(i) -core_G1(i-1) ) /dk
!       z2 = ( core_G1(i+1) -core_G1(i) ) /dk
!       core_G2(i) = ( z1 +z2 )/2.0d0
!    End Do

    allocate( wk_x(0:nr12) );     allocate( wk_y(0:nr12) )
    Do i=0, nr12
       wk_x(i) = dk *i
    End Do
    call init_cubic_spline( nr12+1, wk_x(0:nr12), core_G1(0:nr12), wk_y(0:nr12) )

    Do i=0, nr12
       call cubic_spline( nr12+1, wk_x(0:nr12), core_G1(0:nr12), wk_y(0:nr12), &
            &             wk_x(i), ctmp, core_G2(i) )
    End Do
    deallocate( wk_x ); deallocate( wk_y )

! ----
    s_tensor = 0.0d0

    Do i=1, 3
       bb(1,i) = rltv(i,1) /PAI /2.0d0
       bb(2,i) = rltv(i,2) /PAI /2.0d0
       bb(3,i) = rltv(i,3) /PAI /2.0d0
    End Do

    do i=1,nfft_div_size
       c1 = ica(i) 
       c2 = icb(i) 
       c3 = icc(i) 
       cix = c1-na/2
       ciy = c2-nb/2
       ciz = c3-nc/2
       rk   = rkar(i)
       ck   = dint(rk/dk)
       phix = (rk - dk*DBLE(ck))/dk
       phiy = 1.0d0 - phix

       term1 = phiy*core_G1(ck) + phix*core_G1(ck+1)
       term2 = phiy*core_G2(ck) + phix*core_G2(ck+1)

       vec(1:3) = dble(cix) *bb(1,1:3) &
            &    +dble(ciy) *bb(2,1:3) &
            &    +dble(ciz) *bb(3,1:3)

       if ( ck > 0 ) then
          z1 = DCONJG( theta_G_a(i) ) *theta_G_b(i)  & 
               &                                *term2 /rkar(i)
          Do v=1, 3
             Do u=1, 3
                s_tensor(u,v) = s_tensor(u,v) +z1 *vec(u) *vec(v)
             End Do
          End Do
       endif
       tmpug(i) = tmpug(i) &
            &              +theta_G_b(i) *term1 *univol
    enddo

    s_tensor = s_tensor *univol

    deallocate(core_G1);    deallocate(core_G2)
    call tstatc0_end(id_sname)

  end subroutine calc_stress_contrib2

  subroutine vdWdf_stress_tensor_core()
    use progress_bar

    real(kind=DP) :: fac
    integer :: cqaa,cqa,cqb,ierr
    integer :: i,ic,i2,i3
    complex(kind=DP), allocatable, dimension(:) :: tmpug,tmpur
    complex(kind=DP), allocatable, dimension(:,:) :: theta_buf_s,theta_buf_r

    real(kind=DP) :: s_tmp(3,3), grho, rtmp

    integer :: u, v, cix, ciy, ciz,cir
    integer :: ipos,i0,i1,isend,irecv,ireq,ireqr
    integer, allocatable, dimension(:) :: ista
    integer :: id_sname = -1
    integer :: id_sname2 = -1
    integer :: id_sname3 = -1

    call tstatc0_begin('vdWdf_stres_core ',id_sname,1)

    s_cnl1 = 0.0d0;  s_cnl2 = 0.0d0

    if(nrank_ke>1)then
       allocate(ista(MPI_STATUS_SIZE))
       allocate(theta_buf_r(1:mp_nq,nfft_div_size));
       theta_buf_r=(0.d0,0.d0)
    endif

    allocate(tmpug(nfft_div_size));tmpug=0.d0
    allocate(tmpur(nfft_div_size));tmpur=0.d0
    dFdrho=0.d0;dFddrho=0.d0

    irecv = myrank_ke+1
    if(irecv.ge.nrank_ke) irecv = irecv-nrank_ke
    isend = myrank_ke-1
    if(isend.lt.0)        isend = isend+nrank_ke

    do cqaa=1,mp_nq
       cqa = real_index(cqaa)
       if (nrank_ke>1)    theta_buf_r(1:np_nq,:) = theta_G_ab(1:np_nq,:)
       if (cqaa.le.np_nq) theta_G_a(:) = theta_G_ab(cqaa,:)

       if (.not.oneshot)  tmpug=(0.d0,0.d0)

       call tstatc0_begin('vdw_stress_core_core ',id_sname3,1)

       do i0=0,nrank_ke-1
          ipos = i0+myrank_ke
          if(ipos.ge.nrank_ke) ipos = ipos-nrank_ke
          if(ipos.lt.0)        ipos = ipos+nrank_ke

          if(cqaa.le.np_nq)then
             do i1=1,nel_nq(ipos)
                cqb = real_index(i1,ipos)
                if(nrank_ke>1)then
                   theta_G_b(:) = theta_buf_r(i1,:)
                else
                   theta_G_b(:) = theta_G_ab(i1,:)
                endif
                fac = 1.d0
                if(eval_kernel_by_interpolation) then
                  call phiab_by_interpl(cqa,cqb,nr12,phi_ab)
                else
                  Call phiab(cqa,cqb,nr12,phi_ab)
                endif
                Call calc_stress_contrib2( na, nb, nc, cqa, cqb, nr12, phi_ab, &
                     &                     theta_G_a, theta_G_b, fac, s_tmp, &
                     &                     tmpug )
                s_cnl2 = s_cnl2 +s_tmp
             enddo
          endif
          if(nrank_ke>1.and.i0.ne.nrank_ke-1)then
             call tstatc0_begin('vdWdf_stress_core (comm) ',id_sname2,1)
             allocate(theta_buf_s(1:mp_nq,nfft_div_size))
             theta_buf_s = theta_buf_r
             call mpi_sendrecv(theta_buf_s,mp_nq*nfft_div_size,mpi_double_complex,isend,0, &
                 &             theta_buf_r,mp_nq*nfft_div_size,mpi_double_complex,irecv,0, &
                 &             mpi_g_world,ista,ierr)
             deallocate(theta_buf_s)
             call tstatc0_end(id_sname2)
          endif
       enddo
       call tstatc0_end(id_sname3)
       if(.not.oneshot) call GtoR(na,nb,nc,tmpur,tmpug)
       if(.not.oneshot.and.cqaa.le.np_nq)then
          s_tmp = 0.0d0
          Do v=1, 3
             Do u=1, 3
                Do cir = 1,nfft_div_size
                   grho = grad(cir)
                   rtmp = rho(cir)
!                         if ( rtmp > 1.0d-6 .and. grho > 1.0d-6 ) then
                   if ( grho > 1.0d-6 ) then
                      s_tmp(u,v) = s_tmp(u,v) &
                           &      +dble(tmpur(cir)) &
                           &       *ddtheta_R(cqaa,cir) &
                           &       *cgrad(cir,u) &
                           &       *cgrad(cir,v) /grad(cir)
                   endif
                End Do
             End Do
          End Do
          s_cnl1(:,:) = s_cnl1(:,:) +s_tmp(:,:)
       endif
    enddo

    if(npes>1) then
       call mpi_allreduce( MPI_IN_PLACE, s_cnl1, 3*3, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       call mpi_allreduce( MPI_IN_PLACE, s_cnl2, 3*3, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       deallocate(tmpur)
    endif
    deallocate(tmpug)

    if(nrank_ke>1)then
       deallocate(ista);    deallocate(theta_buf_r)
    endif

    s_cnl1 = s_cnl1 *( univol *rinplw ) /univol
    s_cnl2 = s_cnl2 /2.0d0

    call tstatc0_end(id_sname)

  end subroutine vdWdf_stress_tensor_core
! ==== end for stress

  Subroutine convolution_3d_by_fft(na,nb,nc,cqa,cqb,nr12,phi_ab,theta_G_a,theta_G_b,fac,Ecnl_12_ab,tmpug)

    Implicit none

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    integer, intent(in) :: na,nb,nc,cqa,cqb,nr12
    complex(kind=DP), intent(in)  :: theta_G_a(nfft_div_size)
    complex(kind=DP), intent(in)  :: theta_G_b(nfft_div_size)
    real(kind=DP),    intent(in)  :: phi_ab(0:nr12)
    real(kind=DP),    intent(in)  :: fac
    real(kind=DP),    intent(out) :: Ecnl_12_ab
    complex(kind=DP), intent(inout) :: tmpug(nfft_div_size)
    complex(kind=DP) temp_c

    Real(kind=DP)  phix,phiy,Ta,Tb,Tc

    Integer cir,ck,i
    Integer :: c1,c2,c3,ca,cb,cc,cix,ciy,ciz
    Real(kind=DP) dk,rk,r12,term

    Real(kind=DP),allocatable :: core_G(:)

    real*8 :: dd

    real(kind=DP) :: pi2rk
    integer :: id_sname = -1

    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
    call tstatc0_begin('convolution_3d_by_fft ',id_sname,1)
    allocate(core_G(0:nr12));core_G=0.d0

    !      dd = r12max/dble(nr12)

    call get_phi_ab_g(nr12,phi_ab,core_G)

    dk = 1.d0/r12max
    temp_c = (0.0d0,0.0d0)
    !tmpug = 0.d0

    if(oneshot)then
       do i = 1,nfft_div_size
          rk   = rkar(i)
          ck   = dint(rk/dk)

          phix = (rk - dk*DBLE(ck))/dk
          phiy = 1.0d0 -phix
          term = phiy*core_G(ck) + phix*core_G(ck+1)

          temp_c = temp_c + term *DCONJG(theta_G_a(i))   &
               &          *              theta_G_b(i)
       enddo
    else
       do i = 1,nfft_div_size
          rk   = rkar(i)
          ck   = dint(rk/dk)

          phix = (rk - dk*DBLE(ck))/dk
          phiy = 1.0d0 - phix
          term = phiy*core_G(ck) + phix*core_G(ck+1)

          temp_c = temp_c + term *DCONJG(theta_G_a(i))   &
               &           *             theta_G_b(i)

          tmpug(i) = tmpug(i) &
               &              +theta_G_b(i)*term *univol
       enddo
    endif

    temp_c = temp_c * univol**2
    Ecnl_12_ab = 0.5d0*DBLE(temp_c)*fac

    !***** End Calculate 'theta_G_a*core_G*theta_G_b'  ***********

    deallocate(core_G)

    call tstatc0_end(id_sname)

  End subroutine convolution_3d_by_fft
  !** End SUBROUTINE convolution_3d *************************************************************

!  Subroutine convolution_3d(na,nb,nc,cqa,cqb,nr12,phi_ab,theta_G_a,theta_G_b,Ecnl_12_ab)
!
!    Implicit none
!
!    !    include "fftw3.f"
!
!    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
!    integer, intent(in) :: na,nb,nc,cqa,cqb,nr12
!    complex(kind=DP), intent(in)  :: theta_G_a(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2)
!    complex(kind=DP), intent(in)  :: theta_G_b(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2)
!    real(kind=DP),    intent(in)  :: phi_ab(0:nr12)
!    real(kind=DP),    intent(out) :: Ecnl_12_ab
!    real(kind=DP) :: dr12
!    complex(kind=DP) temp_c
!
!    Integer  nabc
!    Real(kind=DP)  phix,phiy,Ta,Tb,Tc
!
!    Integer cix,ciy,ciz,cr,ck
!    Real(kind=DP) dk,rk,r12,term
!
!    Real(kind=DP),allocatable :: core_G(:)
!    Real(kind=DP),allocatable :: phiab_r(:)
!
!    real(kind=DP) :: pi2rk
!    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
!
!    allocate(core_G(0:nk-1))
!    allocate(phiab_r(0:nr12));phiab_r=0.d0
!    nabc = na*nb*nc
!
!    !    dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
!    !&      + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
!    !&      + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))
!!
!    !    Ta = na*DSQRT(aa(1,1)**2 + aa(1,2)**2 + aa(1,3)**2)
!    !    Tb = nb*DSQRT(aa(2,1)**2 + aa(2,2)**2 + aa(2,3)**2)
!    !    Tc = nc*DSQRT(aa(3,1)**2 + aa(3,2)**2 + aa(3,3)**2)
!
!    !***** Make the core function and execute 3d-FFT by hand *****
!    dr12 = r12max/dble(nr12)
!    dk = maxk/dble(nk-1)
!
!    do cr=0,nr12
!       r12 = dr12*dble(cr)
!       phiab_r(cr) = phi_ab(cr)*r12
!    enddo
!
!    Do ck = 0,0
!       rk = dk * dble(ck)
!       term = 0
!       Do cr = 0,nr12
!          r12 = dr12*dble(cr)
!          term = term + phi_ab(cr) * (r12**2)
!       Enddo
!       core_G(ck) = 4.0d0*pi*dr12 * term
!    End do
!
!    Do ck = 1,nk-1
!       rk = dk * dble(ck)
!       pi2rk = 2.0*pi*rk
!       term = 0
!       Do cr = 0,nr12
!          r12 = dr12*dble(cr)
!          term = term + phiab_r(cr) * DSIN(pi2rk*r12)
!       Enddo
!       core_G(ck) = 2.d0 * dr12 * term / rk
!    End do
!    !***** END of Make the core function *************************
!
!    !    if(cqa==1)then
!    !       do ck=0,nr12
!    !          rk = dk * dble(ck)
!    !          write((cqa+1)*35+cqb,*) rk,core_G(ck)
!    !       enddo
!    !    endif
!    !***** Calculate 'theta_G_a*core_G*theta_G_b'  ***************
!    dk = maxk/dble(nk-1)
!    temp_c = (0.0,0.0)
!    Do cix = -(na/2-1),na/2
!       Do ciy = -(nb/2-1),nb/2
!          Do ciz = -(nc/2-1),nc/2
!
!             !rk = DSQRT((dble(cix)/Ta)**2 + (dble(ciy)/Tb)**2 + (dble(ciz)/Tc)**2)
!             rk = rkar(cix,ciy,ciz)
!             If(rk.LT.maxk) Then
!                ck = DINT(rk/dk)
!                phix = (rk - dk*DBLE(ck))/dk
!                phiy = 1.0 - phix
!                term = phiy*core_G(ck) + phix*core_G(ck+1)
!             Else
!                term = 0.0d0
!             Endif
!
!             temp_c = temp_c +                        &
!                  &             DCONJG(theta_G_a(cix,ciy,ciz)) *  &
!                  &                    theta_G_b(cix,ciy,ciz)  *  &
!                  &                  term
!          Enddo
!       Enddo
!    Enddo
!
!    temp_c = temp_c * dv*nabc
!    Ecnl_12_ab = 0.5d0*DBLE(temp_c)
!    !***** End Calculate 'theta_G_a*core_G*theta_G_b'  ***********
!
!    deallocate(core_G)
!    deallocate(phiab_r)
!
!
!  End subroutine convolution_3d
!  !** End SUBROUTINE convolution_3d *************************************************************

  Subroutine d_q0(n,dn,q0min,q0max,q0,dqdn,dqddn)
    Implicit None


    !************************ Note *********************************
    ! This program calculates q0.
    !
    ! Input
    !   rho(nrxyz,nsipn) : Total density
    !
    ! Output
    !   q0               : 
    !
    !
    !
    !                            Written by Youky Ono
    !***************************************************************



    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    real(kind=DP), intent(in)  :: n,dn,q0min,q0max
    real(kind=DP), intent(out) :: q0,dqdn,dqddn
    Double Precision rs,x,nn2,r,term1,term2,term3,rnn2

!    Double precision  kF,exc0,exLDA,excLDA,Zab,m,h,e,GxcLDA,eta,dq
!    Parameter (Zab=-0.8491d0)

    Double precision  kF,exc0,exLDA,excLDA,m,h,e,GxcLDA,eta,dq
    Parameter (e=1.0d0,m=1.0d0)

    integer :: i
    real(kind=DP) :: s2,s,qq
    real(kind=DP) :: drsdn,dxdn,dexcdn,dsdn,dkFdn
    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



    !---------------------- Calculation Start ----------------------
    nn2 = dn*dn
    rnn2 = dsqrt(nn2)
    rs = (3.d0/(4.d0*pi*n))**(1.d0/3.d0)

    ! Eq.(58), (59) (p.93-94) of Theory of the Inhomogeneous Electron gas.
    ! S.Lundqvist and N.H.March 1983 Plenum Press, NY
    x = rs/11.4d0
    GxcLDA = 0.5d0*((1.d0+x**3)*DLog(1.d0+1.d0/x)-x**2+x/2.d0-1.d0/3.d0)
    excLDA = -0.458d0/rs-0.0666d0*GxcLDA

    kF = (3.d0*pi*pi*n)**(1.d0/3.d0)

    s2 = nn2/((2.d0*kF*n)**2);s=dsqrt(s2)
    qq = -(4.d0*pi/3.d0)*excLDA-(Zab/9.d0)*s2*kF

    call hxxc(qq,q0max,q0,dq)
    q0 = max(q0,q0min)

    if(q0.eq.q0min)then
       dqdn = 0.d0;dqddn=0.d0
    else
#if 0
       drsdn  = -(3.d0/(4.d0*PAI))**(1.d0/3.d0)/3.d0*n**(-4.d0/3.d0)
       dxdn   = drsdn/11.4d0
       dexcdn = (0.458d0/(rs*rs))*drsdn &
            &   -0.0333d0*(3*x*x*dlog(1+1.d0/x)-(1+x**3)/(x*(x+1))-2*x+0.5d0)*dxdn
       dkFdn  = (pi/kF)**2
!!!       dsdn   = -(rnn2/(4*kF*n*kF*n))*(dkFdn*n+kF)
       dsdn   = -(rnn2/(2*kF*n*kF*n))*(dkFdn*n+kF)
       dqdn   = -(4.d0*pi/3.d0)*dexcdn-(Zab/9.d0)*(2*s*dsdn*kF+s2*dkFdn)
       dqddn  = -(Zab/9.d0)*s/n

#else
       drsdn  = -rs /3.0d0 /n
       dxdn   = drsdn/11.4d0
       dexcdn = (0.458d0/(rs*rs))*drsdn &
            &   -0.0333d0*(3*x*x*dlog(1+1.d0/x)-(1+x**3)/(x*(x+1))-2*x+0.5d0)*dxdn
       dkFdn  = kF /3.0d0 /n
       dsdn   = -s /(kF*n) *(dkFdn*n+kF)
       dqdn   = -(4.d0*pi/3.d0)*dexcdn-(Zab/9.d0)*(2*s*dsdn*kF+s2*dkFdn)
!       dqddn  = -(Zab/9.d0)*s2 *2.0 /dn *KF
       dqddn  = -(Zab/9.d0)*s/n
#endif
       dqdn   = dqdn*dq
       dqddn  = dqddn*dq
    endif
  End Subroutine d_q0
  !** End SUBROUTINE d_q0 ***********************************************************************

  subroutine hxxc(x,xc,hx,dhx)
    real(kind=DP), intent(in)  :: x,xc
    real(kind=DP), intent(out) :: hx,dhx
    integer :: i
    integer :: mc = 12
    real(kind=DP) :: summ,dsumm
    hx = 0.d0;dhx = 0.d0
    summ=0.d0;dsumm=0.d0
    do i=1,mc
       summ = summ+(x/xc)**i/dble(i)
       dsumm = dsumm+x**(i-1)/xc**i
    enddo
    hx = xc*(1.d0-dexp(-summ))
    dhx = xc*dexp(-summ)*dsumm
  end subroutine hxxc

  !** SUBROUTINE derivation *********************************************************************
  Subroutine derivation(na,nb,nc,aa,rho,dv,grad)
    Implicit none

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++

    ! The unit cell and the electron density information
    integer,intent(in) :: na,nb,nc
    real(kind=DP), intent(in) :: rho(nabc)
    Real(kind=DP), intent(in) :: aa(3,3)
    real(kind=DP), intent(in) :: dv
    real(kind=DP), intent(out) :: grad(nabc)

    ! Integers
    Integer i,j,k,cx,cy,cz,cr

    ! Internal valuables
    Integer zx(-3:3),zy(-3:3),zz(-3:3)
    Real(kind=DP) rn(3,-3:3),detr,bb(3,3)
    Real(kind=DP),allocatable ::  darho(:),dbrho(:),dcrho(:)
    real(kind=DP) :: dx,dy,dz
    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++

    allocate(darho(nabc));darho=0.d0
    allocate(dbrho(nabc));dbrho=0.d0
    allocate(dcrho(nabc));dcrho=0.d0
    !    dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
    !&      + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
    !&      + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))


    Do cx = 1,na
       Do cy = 1,nb
          Do cz = 1,nc
             cr = get_index_1D(cx,cy,cz)
             Do j = -3,3
                zx(j) = MOD(2*na+(cx+j)-1,na)+1
                zy(j) = MOD(2*nb+(cy+j)-1,nb)+1
                zz(j) = MOD(2*nc+(cz+j)-1,nc)+1
                rn(1,j) = rho(get_index_1D(zx(j),cy,cz))
                rn(2,j) = rho(get_index_1D(cx,zy(j),cz))
                rn(3,j) = rho(get_index_1D(cx,cy,zz(j)))
             Enddo
             darho(cr) = (rn(1,3)-9.d0*rn(1,2)+45.d0*rn(1,1)-45.d0*rn(1,-1)+9.d0*rn(1,-2)-rn(1,-3))/(60.d0)
             dbrho(cr) = (rn(2,3)-9.d0*rn(2,2)+45.d0*rn(2,1)-45.d0*rn(2,-1)+9.d0*rn(2,-2)-rn(2,-3))/(60.d0)
             dcrho(cr) = (rn(3,3)-9.d0*rn(3,2)+45.d0*rn(3,1)-45.d0*rn(3,-1)+9.d0*rn(3,-2)-rn(3,-3))/(60.d0)
          Enddo
       Enddo
    Enddo

    detr = (aa(1,1)*aa(2,2)*aa(3,3)+aa(1,2)*aa(2,3)*aa(3,1)+aa(1,3)*aa(2,1)*aa(3,2)) &
         &- (aa(1,1)*aa(2,3)*aa(3,2)+aa(1,2)*aa(2,1)*aa(3,3)+aa(1,3)*aa(2,2)*aa(3,1))

    bb(1,1) =  (aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2))/detr
    bb(2,1) = -(aa(2,1)*aa(3,3)-aa(2,3)*aa(3,1))/detr
    bb(3,1) =  (aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))/detr
    bb(1,2) = -(aa(1,2)*aa(3,3)-aa(1,3)*aa(3,2))/detr
    bb(2,2) =  (aa(1,1)*aa(3,3)-aa(1,3)*aa(3,1))/detr
    bb(3,2) = -(aa(1,1)*aa(3,2)-aa(1,2)*aa(3,1))/detr
    bb(1,3) =  (aa(1,2)*aa(2,3)-aa(1,3)*aa(2,2))/detr
    bb(2,3) = -(aa(1,1)*aa(2,3)-aa(1,3)*aa(2,1))/detr
    bb(3,3) =  (aa(1,1)*aa(2,2)-aa(1,2)*aa(2,1))/detr

    Do cr = 1,nabc
       dx = (bb(1,1)*darho(cr) + bb(1,2)*dbrho(cr) + bb(1,3)*dcrho(cr))
       dy = (bb(2,1)*darho(cr) + bb(2,2)*dbrho(cr) + bb(2,3)*dcrho(cr))
       dz = (bb(3,1)*darho(cr) + bb(3,2)*dbrho(cr) + bb(3,3)*dcrho(cr))
       grad(cr) = dsqrt(dx**2+dy**2+dz**2)
    Enddo

!    deallocate(darho)
!    deallocate(dbrho)
!    deallocate(dcrho)

  End subroutine derivation
  !** End SUBROUTINE derivation *****************************************************************

  subroutine spline0(nq0,x,y2)
    integer, intent(in) :: nq0
    real(kind=DP), intent(in),  dimension(nq0) :: x
    real(kind=DP), intent(out), dimension(nq0,nq0) :: y2
    real(kind=DP), allocatable,dimension(:) :: y,y2tmp
    integer :: i
    allocate(y(nq0));y=0.d0
    allocate(y2tmp(nq0));y2tmp=0.d0
    y2 = 0.d0
    do i=1,nq0
       y(:) = 0.d0;y(i) = 1.d0 
       call init_cubic_spline(nq0,x,y,y2tmp)
       y2(i,:) = y2tmp(:)
    enddo
    deallocate(y)
    deallocate(y2tmp)
  end subroutine spline0

  function hofy(num,denom) result(res)
    Implicit none
    real(kind=DP), intent(in) :: num,denom
    real(kind=DP) :: res
    real(kind=DP) :: gam=1.396263402d0 ! 4pi/9
    if(abs(denom)<epsilon(denom))then
       res = 1.d0
    else
       res = 1.d0-dexp(-gam*((num/denom)**2))
    endif
  end function hofy

  function Wab(a,b) result (res)
    Implicit none
    real(kind=DP), intent(in) :: a,b
    real(kind=DP) :: res
    res = 2.d0*((3.d0-a*a)*b*DCOS(b)*DSIN(a) + (3.d0-b*b)*a*DCOS(a)*DSIN(b) &
         &       + (a*a+b*b-3.d0)*DSIN(a)*DSIN(b) &
         &       - 3.d0*a*b*DCOS(a)*DCOS(b))/((a*b)**3)
  end function Wab

  function Twxyz(w,x,y,z) result (res)
    Implicit none
    real(kind=DP),intent(in) :: w,x,y,z
    real(kind=DP) :: res
    res = 0.5d0*(1.d0/(w+x)+1.d0/(y+z))*(1.d0/((w+y)*(x+z))+1.d0/((w+z)*(y+x)))
  end function Twxyz

  !** SUBROUTINE kernel_phi *********************************************************************
  Subroutine kernel_phi(di,dk,phi)
    implicit none

    !************************ Note *********************************
    ! This Algorism follows Dion's 1-shot method.
    !
    ! This program is a subroutine.
    ! This program calculates the kernel function phi.
    !
    ! Input
    !
    !
    ! Output
    !   phi              : 
    !                      
    !
    !
    !                            Written by Youky Ono in 2013/Jan.
    !***************************************************************



    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    real(kind=DP), intent(in)  :: di,dk
    real(kind=DP), intent(out) :: phi
    Integer ca,cb,nb
    Real(kind=DP) a,b,h,v1,v2,v3,v4,W,T
    Real(kind=DP) e,m
    parameter (e=1.d0,m=1.d0)
    real(kind=DP) :: dr


    ! Gauss-Legendre integration
    Real(kind=DP),allocatable, dimension(:) :: xi,wi
    Real(kind=DP) :: fac
    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++

    !---------------------- Calculation Start ----------------------
    ! Call gauleg for Gauss-Legendre integral
    allocate(xi(na_gl));xi=0.d0
    allocate(wi(na_gl));wi=0.d0
    Call gauleg(a1,a2,na_gl,xi,wi)

    phi = 0.d0
    Do ca=1,na_gl
       Do cb=1,ca
          fac=2.d0
          if(ca.eq.cb) fac=1.d0
          a = xi(ca)
          b = xi(cb)

          v1 = (a**2)/(2.d0*hofy(a,di))
          v2 = (b**2)/(2.d0*hofy(b,di))
          v3 = (a**2)/(2.d0*hofy(a,dk))
          v4 = (b**2)/(2.d0*hofy(b,dk))
          phi = phi + fac*wi(ca)*wi(cb)*(a*a*b*b)*Wab(a,b)*Twxyz(v1,v2,v3,v4)
       End Do
    End Do

    phi = phi * 2.d0 *m *(e**4)/(pi**2)
    deallocate(xi)
    deallocate(wi)
  end Subroutine kernel_phi
  !** End SUBROUTINE kernel_phi *****************************************************************

  !** SUBROUTINE gauleg **********************************************************************************
  Subroutine gauleg(x1,x2,n,xi,wi)
    Implicit none
    real(kind=DP), intent(in) :: x1,x2
    integer, intent(in) :: n
    real(kind=DP), intent(out)  ::  xi(n),wi(n)

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    Integer  m,j,i
    REAL(kind=DP)  z1,z,xm,xl,pp,p3,p2,p1,eta
    Parameter (eta=0.0000000001d0)

    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



    !---------------------- Calculation Start ----------------------
    m=(n+1)/2
    xm=0.5d0*(x2+x1)
    xl=0.5d0*(x2-x1)

    ! === DEBUG by tkato 2014/04/22 ================================================
    z1 = 0.0d0
    ! ==============================================================================
    Do i=1,m
       z=DCOS(pi*(i-0.25d0)/(n+0.5d0))
       Do While (ABS(z-z1).GT.eta)
          p1=1.0d0
          p2=0.0d0

          Do j=1,n
             p3=p2
             P2=p1
             p1=((2.0d0*j-1.d0)*z*p2-(j-1.d0)*p3)/dble(j)
          Enddo

          pp=n*(z*p1-p2)/(z*z-1.d0)
          z1=z
          z=z1-p1/pp

       Enddo
       xi(i) = xm-xl*z
       xi(n+1-i) = xm+xl*z
       wi(i) = 2.d0*xl/((1.d0-z*z)*pp*pp)
       wi(n+1-i) = wi(i)
    Enddo
  End Subroutine gauleg
  !** End SUBROUTINE gauleg ******************************************************************************

  !** SUBROUTINE outputs ************************************************************************
  Subroutine outputs()
    Implicit none

    Ecnl = Ecnl_12 + Ecnl_3 - Ecnl_3s

    if(printable)then
       write(nfout,'(a)')  'Here are the results : '
       Write(nfout,*)  ' '
       Write(nfout,11) ExGGA
       Write(nfout,*)  ' '
       Write(nfout,12) EcLDA
       Write(nfout,13) Ecnl
       Write(nfout,14) EcLDA + Ecnl
       Write(nfout,*)  ' '
       Write(nfout,15) EcLDA + Ecnl + ExGGA
       Write(nfout,*)  ' '
11     Format('E_total(GGA exchange)      = ',F19.13)

12     Format('Ec(LDA)                    = ',F19.13)
13     Format('Ec(nl)                     = ',F19.13)
14     Format('Ec (= Ec(LDA) + Ec(nl) )   = ',F19.13)

15     Format('E_total(vdW-DF)            = ',F19.13)

       Write(nfout,*)  '                  Given in Hartree atomic units'
       Write(nfout,*)  ' '
    endif

  End Subroutine outputs
  !** End SUBROUTINE outputs ********************************************************************

  subroutine get_dFdrho_dFddrho(dFdrho_,dFddrho_)
    real(kind=DP), dimension(nfft_div_size), intent(out) :: dFdrho_,dFddrho_
    integer :: i,i1,i2,i3
    dFdrho_(:) = dFdrho(:)
    dFddrho_(:) = dFddrho(:)
    !    dFdrho = 0.0d0;dFddrho = 0.0d0 ! this can be calculated on the fly!!
    !    do i=1,nq0
    !       dFdrho (:,:,:) = dFdrho (:,:,:) + dble(ualpha_r(i,:,:,:))*dtheta_R (i,:,:,:)/(univol*rinplw)
    !       dFddrho(:,:,:) = dFddrho(:,:,:) + dble(ualpha_r(i,:,:,:))*ddtheta_R(i,:,:,:)/(univol*rinplw)
    !    enddo

  end subroutine get_dFdrho_dFddrho

  subroutine map_rho_to_afft(rho,afft)
    complex(kind=DP), intent(in),  dimension(nabc) :: rho
    real(kind=DP), intent(out), dimension(nfftp_nonpara) :: afft
    integer :: i,cix,ciy,ciz,cir,cir2
    afft = 0.d0
    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz)
             cir2 = get_index_1D(cix,ciy,ciz)
             if(kimg == 1)then
                afft(2*cir-1) = real(rho(cir2))
             else
                afft(2*cir-1) = real(rho(cir2))
                afft(2*cir)   = aimag(rho(cir2))
             endif
          enddo
       enddo
    enddo
  end subroutine map_rho_to_afft

  subroutine map_rhog_to_afft(rho,afft)
    complex(kind=DP), intent(in),  dimension(nabc) :: rho
    real(kind=DP), intent(out), dimension(nfftp_nonpara) :: afft
    integer :: i,cix,ciy,ciz,cir,cir2
    afft = 0.d0
    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz,.true.)
             cir2 = get_index_1D(cix,ciy,ciz)
             if(kimg == 1)then
                afft(cir) = real(rho(cir2))
             else
                afft(2*cir-1) = real(rho(cir2))
                afft(2*cir)   = aimag(rho(cir2))
             endif
          enddo
       enddo
    enddo
  end subroutine map_rhog_to_afft

  subroutine map_afft_to_rho(afft,rho)
    real(kind=DP), intent(in), dimension(nfftp_nonpara) :: afft
    complex(kind=DP), intent(out),  dimension(nabc) :: rho
    integer :: i,cix,ciy,ciz,cir,cir2
    integer :: m
    rho = (0.d0,0.d0)

    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz,.true.)
             cir2 = get_index_1D(cix,ciy,ciz)
             if(kimg == 1)then
                rho(cir2) = DCMPLX(afft(cir))
             else
                rho(cir2) = DCMPLX(afft(2*cir-1),afft(2*cir))
             endif
          enddo
       enddo
    enddo
  end subroutine map_afft_to_rho

  subroutine map_afft_to_rhog(afft,rho)
    real(kind=DP), intent(in), dimension(nfftp_nonpara) :: afft
    complex(kind=DP), intent(out),  dimension(nabc) :: rho
    integer :: i,cix,ciy,ciz,cir,cir2
    rho = (0.d0,0.d0)
    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz)
             cir2 = get_index_1D(cix,ciy,ciz)
             if(kimg == 1)then
                rho(cir2) = DCMPLX(afft(2*cir-1))
             else
                rho(cir2) = DCMPLX(afft(2*cir-1),afft(2*cir))
             endif
          enddo
       enddo
    enddo
  end subroutine map_afft_to_rhog

end module m_vdWDF
#endif

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.01                                       #
!#                                                                       #
!#      Sub Routine : WriteDownData_onto_Files_Eps                       #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: WriteDownData_onto_Files_Epsilon.f90 376 2014-06-17 07:48:31Z jkoga $
   subroutine WriteDownData_onto_Files_Eps
     use m_Epsilon_ek,               only : nlo, wd_eps, dealloc_m_Epsilon &
                                        & , kv3_in_the_ek_process
     use m_Files,                    only : m_Files_close_nfeps, m_Files_close_nfepscont, m_Files_close_nfnlo
     use m_Kpoints,                  only : kv3
     call wd_eps
     call dealloc_m_Epsilon
     call m_Files_close_nfeps
     call m_Files_close_nfepscont
     if(nlo/=0) call m_Files_close_nfnlo
   end subroutine WriteDownData_onto_Files_Eps

! =================================== added by K. Tagami =========== 5.0
subroutine Renewal_of_Chg_Ctrl_Param

  use m_Const_Parameters,    only  : DP, ON, OFF, YES, WHOLE
  use m_Total_Energy,         only : m_TE_what_is_edeltb_now
  use m_Ionic_System,        only : natm
  use m_Control_Parameters,  only : sw_eval_energy_before_charge, &
       &                            sw_update_charge_total, spin_density_mixfactor
!
  use m_Const_Parameters,  only : MSD, CG, SD, LMSD, LMCG,lmeazyCG, lmmsd
  use m_Control_Parameters,  only :  m_CtrlP_solver_for_WFs_now, intzaj

  use  m_IterationNumbers,    only : iteration, iteration_ionic, iteration_electronic, &
       &                             iteration_unit_cell

  use m_Control_Parameters,       only : sw_update_charge_hsr, eval_energy_before_charge
  use m_Control_Parameters,     only : sw_recomposing, sw_force_simple_mixing
  use m_Control_Parameters,     only : sw_recomposing_hsr, sw_force_simple_mixing_hsr

  use m_Files,               only : nfout
  use m_Control_Parameters,   only : printable

! =========================== KT_Test ============================== 12.5Exp
  use m_Control_Parameters,   only : sw_hybrid_functional, &
       &                             truncate_vxw_updating, sw_update_vxw, &
       &                             edelta_for_hyb_chgfix, edelta_for_hyb_convgd
! ================================================================== 12.5Exp

! ================= KT_add =================== 13.0F
  use m_Control_Parameters,   only : use_hybrid_functional, &
       &                             hybrid_calc_is_active, edelta_change_to_hybrid
! ============================================ 13.0F

  use m_CD_Mag_Moment,   only : sw_monitor_atomcharge,  m_CD_set_rad_cov_default, &
       &                        m_CD_set_rad_cov_now

  use m_Const_Parameters,  only : LINEAR, ABRUPT, STEPWISE

  use m_Crystal_Structure,  only : sw_magnetic_constraint, mag_constraint_lambda, &
       &                           damping_method_mag_constraint, &
       &                           num_intermid_lambda, &
       &                           nmax_intermid_lambda, &
       &                           edelta_change_lambda_first, &
       &                           edelta_change_lambda_last, &
       &                           max_iter_elec_mag_constraint, &
       &                           max_iter_ion_mag_constraint, &
       &                           max_iter_cell_mag_constraint, &
       &                           sw_fix_charge_after_constraint

! ================= KT_add =================== 13.0XX
  use m_Control_Parameters,   only : sw_calc_ekin_density, &
       &                             ekin_density_is_active
! ============================================ 13.0XX

! ===== KT_add ============== 13.0U3
  use m_Control_Parameters,   only : smearing_width => width, &
       &                             smearing_width_initial => width_initial, &
       &                             method_change_smearing_width, &
       &                             nmax_intermid_width, num_intermid_width, &
       &                             edelta_change_width_first, &
       &                             edelta_change_width_last, &
       &                             sw_wf_mixing, wf_mixing_is_active, &
       &                             edelta_start_wf_mixing
! =========================== 13.0U3

  use m_Parallelization,  only : mype

  implicit none

  real(kind=DP) :: edeltab_per_atom, edeltb_per_atom, edelta

! -----------------------
!  if ( sw_monitor_atomcharge == ON ) then
!     if ( iteration_ionic >1 .and. iteration_electronic ==1 ) then
!        call m_CD_set_rad_cov_default
!        call m_CD_set_rad_cov_now
!     endif
!  endif

! ------------------
  edelta = m_TE_what_is_edeltb_now()

  edeltab_per_atom = m_TE_what_is_edeltb_now() / natm
  edeltab_per_atom = abs(edeltab_per_atom )
!
!  call update_or_fix_charge
!  call update_or_fix_charge_hardpart
!

  if ( sw_magnetic_constraint == ON ) then
     call update_lambda_mag_constraint
  endif

! =========================== KT_Test ============================== 12.5Exp
  if ( sw_hybrid_functional == ON ) then
     if ( truncate_vxw_updating ) call update_or_fix_charge_hybrid
  endif
! ================================================================== 12.5Exp
    
! ================= KT_add =================== 13.0F
  if ( use_hybrid_functional ) then

     if ( sw_hybrid_functional == ON .and. (.not. hybrid_calc_is_active) ) then
        sw_hybrid_functional = off
     endif
     if ( sw_hybrid_functional == OFF ) then
        if ( edeltab_per_atom < edelta_change_to_hybrid ) then
           sw_hybrid_functional = on
           hybrid_calc_is_active = .true.

           write(nfout,*) '****************'
           write(nfout,*) ' hybrid_calc is turned active now'
           write(nfout,*) '****************'
        endif
     endif
  end if
! ============================================ 13.0F

  if ( eval_energy_before_charge == YES ) then
    call order_energy_chg_construction
  endif

!  call update_spin_density_mixfactor
!   call update_spin_recomposing

! === KT_add ==== 13.0XX
  if ( sw_calc_ekin_density == ON ) then
     if ( edeltab_per_atom < 1.0D-2 ) then
!     if ( iteration_electronic > 1 ) then

        if ( .not. ekin_density_is_active ) then
           ekin_density_is_active = .true.
           write(nfout,*) "** ekin_density_is turned active"
        endif
     endif
  endif
! =============== 13.0XX

! ====== KT_add ======= 13.0U3
  if ( sw_wf_mixing == ON ) call checkif_wf_mixig_active
!
  call update_smearing_width
! ===================== 13.0U3

contains

  subroutine update_spin_recomposing
    logical, save :: first = .true.
    integer :: nstep_threshold = 15 

    integer :: sw_recomposing0 = OFF
    integer :: sw_force_simple_mixing0 = OFF
!
    if ( first ) then
       sw_recomposing0 = sw_recomposing
       sw_force_simple_mixing0 = sw_force_simple_mixing
       first = .false.
    endif
!
    if ( sw_recomposing0 == ON ) then
       if ( iteration <= nstep_threshold ) then
          sw_recomposing = ON
          sw_force_simple_mixing = ON
          sw_recomposing_hsr = ON
          sw_force_simple_mixing_hsr = ON
       else
          sw_recomposing = OFF
          sw_force_simple_mixing = OFF
          sw_recomposing_hsr = OFF
          sw_force_simple_mixing_hsr = OFF
       endif
    end if
  end subroutine update_spin_recomposing

  subroutine update_spin_density_mixfactor
    logical, save :: first = .true.
    real(kind=DP),save ::  spin_dens_mixfactor_0

    if ( first ) then
       spin_dens_mixfactor_0 = spin_density_mixfactor
       first = .false.
    endif
!
    if ( iteration <= 5 ) then
       spin_density_mixfactor = 4.0
    else
       spin_density_mixfactor = spin_dens_mixfactor_0
    endif
!
    if ( printable ) then
       write(nfout,*) '*** spin_density_mixfacotr now = ', &
            & iteration, spin_density_mixfactor
    end if
! --------------------------------------
  end subroutine update_spin_density_mixfactor

  subroutine order_energy_chg_construction
!
    real(kind=DP) :: edeltb_now
    integer :: isolver, sw_submat
    
    integer :: nsteps_for_transition = 3
    
    edeltb_now = edeltab_per_atom
    isolver = m_CtrlP_solver_for_WFs_now(iteration_electronic,iteration_ionic,intzaj &
         &                              ,edeltb_now, sw_submat)
!
    select case(isolver)
    case (SD,MSD)       
       sw_eval_energy_before_charge = OFF
    case (lmSD, lmMSD, lmCG, lmeazyCG)
       sw_eval_energy_before_charge = OFF
    case default
       if ( iteration <= nsteps_for_transition ) then
          sw_eval_energy_before_charge = OFF
       else
          sw_eval_energy_before_charge = ON
       endif
    end select
!    
    if ( printable ) then
       write(nfout,*) '*-- sw_eval_ene_before_charge now = ',  &
            &               iteration, sw_eval_energy_before_charge
    endif
  end subroutine order_energy_chg_construction

  subroutine update_or_fix_charge
    integer, save :: counter = 0

    real(kind=DP) :: ene_threshold1
    integer :: nsteps_for_fixing_charge = -2

    ene_threshold1 = 1.0E-3
    if ( iteration_electronic == 0 &
         & .or. iteration_electronic <= nsteps_for_fixing_charge ) then
       sw_update_charge_total = ON
    else
       if ( edeltab_per_atom > ene_threshold1 ) then
          sw_update_charge_total = OFF
       else
          sw_update_charge_total = ON
       endif
    endif
!
    if ( iteration <= 1 ) then
       sw_update_charge_total = ON
    else if ( iteration_electronic <= nsteps_for_fixing_charge ) then
       sw_update_charge_total = OFF
    else
       sw_update_charge_total = ON
    endif
! 
  end subroutine update_or_fix_charge

  subroutine update_or_fix_charge_hardpart
    if ( sw_update_charge_total == OFF ) then
       sw_update_charge_hsr = OFF
    else

    endif

  end subroutine update_or_fix_charge_hardpart

! =========================  KT_Test ===================== 12.5Exp
  subroutine update_or_fix_charge_hybrid
    integer :: count1 = 0
    integer :: count2 = 0

    if ( abs(edelta) < edelta_for_hyb_chgfix ) then
       count1 = count1 + 1
       if ( count1 == 3 ) then
          sw_update_charge_total = OFF
          if ( printable ) write(nfout,*) '*----- sw_update_charge_total is set OFF --'
       endif
    endif
       !
    if ( abs(edelta) < edelta_for_hyb_convgd ) then
       count2 = count2 + 1
       if ( count2 == 3 ) then
          sw_update_vxw = OFF
          if ( printable ) write(nfout,*) '*----- sw_update_vxw is set OFF --'
       endif
    endif

!
  end subroutine update_or_fix_charge_hybrid
! ========================================================= 12.5Exp

  subroutine update_lambda_mag_constraint

    integer, parameter :: succession = 3
    real(kind=DP) :: threshold( nmax_intermid_lambda +1 )
!
    integer, save :: count = 0, istep = 1

    logical, save :: First = .true.
    logical, save :: mag_constraint_is_over = .false.
    logical, save :: lambda_is_changed 
    integer, save :: sw_fix_charge_after_constr_org

    real(kind=DP), save :: lambda_org, lambda_old, lambda_00

    integer :: i, nn
    real(kind=DP) :: c1, ratio

    if ( First ) then
       lambda_org = mag_constraint_lambda; 
       lambda_old = mag_constraint_lambda
       sw_fix_charge_after_constr_org = sw_fix_charge_after_constraint
       istep = 1
       First = .false.
    else 
!       if ( iteration_unit_cell > 1 .and. iteration_ionic == 1 &
!            &                       .and. iteration_electronic == 1 ) then
!          mag_constraint_is_over = .false.
!          mag_constraint_lambda = lambda_org
!!          istep = 1;  count = 0
!       endif
       if ( iteration_electronic == 1 ) then
          mag_constraint_is_over = .false.
          mag_constraint_lambda = lambda_org
          sw_fix_charge_after_constraint = sw_fix_charge_after_constr_org
          istep = 1;  count = 0
       endif
    endif

    if ( damping_method_mag_constraint == 0 )  return

    if ( iteration_ionic > max_iter_ion_mag_constraint ) then
       mag_constraint_is_over = .true.
       mag_constraint_lambda = 0.0d0;  
    endif
    if ( iteration_unit_cell > max_iter_cell_mag_constraint ) then
       mag_constraint_is_over = .true.
       mag_constraint_lambda = 0.0d0;  
    endif

    if ( mag_constraint_is_over ) then
       if ( sw_fix_charge_after_constraint == ON ) then
          sw_update_charge_total = OFF
       endif
       return
    endif

    lambda_is_changed = .false.

! ------------------
    select case( damping_method_mag_constraint )

    case( STEPWISE )
       nn = num_intermid_lambda +1
       threshold(1)  = edelta_change_lambda_first
       threshold(nn) = edelta_change_lambda_last

       Do i=2, nn-1
          c1 = threshold(nn) *(i-1) + threshold(1) *(nn-i)
          c1 = c1 /dble(nn-1)
          threshold(i) = c1
       End do

       c1 = abs( edeltab_per_atom )
!    c1 = abs( edelta )
!
       if ( c1 < threshold( istep ) ) then
          count = count + 1
          if ( count == succession *istep ) then
             ratio = 1.0D0 - dble(istep) /dble(nn)
             mag_constraint_lambda = lambda_org *ratio

             istep = istep +1
             lambda_is_changed = .true.
          endif
       endif

       if ( istep > nn ) then
          mag_constraint_is_over = .true.
       endif

    case (ABRUPT)
       if ( iteration_electronic > max_iter_elec_mag_constraint ) then
          mag_constraint_lambda = 0.0d0
          lambda_is_changed = .true.
          mag_constraint_is_over = .true.
       endif

       c1 = abs( edeltab_per_atom )

       if ( c1 <  edelta_change_lambda_last ) then
          count = count + 1
          if ( count == succession ) then
             mag_constraint_lambda = 0.0d0
             mag_constraint_is_over = .true.
             lambda_is_changed = .true.
          endif
       endif

    case (LINEAR)
       ratio = dble( iteration_electronic ) / dble(max_iter_elec_mag_constraint)
       ratio = 1.0D0 -ratio

       if ( iteration_electronic <= max_iter_elec_mag_constraint ) then
          mag_constraint_lambda = lambda_org *ratio
          lambda_is_changed = .true.
       else
          mag_constraint_lambda = 0.0d0
          mag_constraint_is_over = .true.
       endif

       c1 = abs( edeltab_per_atom )
       if ( c1 <  edelta_change_lambda_first ) then
          count = count + 1
          if ( count == succession ) then
             mag_constraint_is_over = .true.
             lambda_is_changed = .true.
          endif
       endif
    end select

    if ( lambda_is_changed ) then
       write(nfout,*) "------ mag_constraint_lambda is changed to ", &
            &                       mag_constraint_lambda
!       write(nfout,*) 'lambda_old = ', lambda_old
    endif

    lambda_old = mag_constraint_lambda
!
  end subroutine update_lambda_mag_constraint

! === KT_add === 13.0U3
  subroutine update_smearing_width

    integer, parameter :: ntimes = 3
    real(kind=DP) :: threshold( nmax_intermid_width +1 )
!
    integer, save :: count = 0, istep = 1

    logical, save :: First = .true.
    logical, save :: width_is_changed 
    real(kind=DP), save :: width_initial, width_final, width_old

    integer :: i, nn
    real(kind=DP) :: c1, ratio

    if ( method_change_smearing_width == 0 )  return
    if ( iteration_ionic > 1 ) return

    if ( First ) then
       width_initial = smearing_width_initial
       width_final = smearing_width

       width_old = smearing_width_initial
       smearing_width = width_initial

       istep = 1
       First = .false.
    endif

    width_is_changed = .false.

! ------------------
    select case( method_change_smearing_width )

    case( STEPWISE )
       nn = num_intermid_width +1
       threshold(1)  = edelta_change_width_first
       threshold(nn) = edelta_change_width_last

       Do i=2, nn-1
          c1 = threshold(nn) *(i-1) + threshold(1) *(nn-i)
          c1 = c1 /dble(nn-1)
          threshold(i) = c1
       End do

       c1 = abs( edeltab_per_atom )
!    c1 = abs( edelta )
!
       if ( c1 < threshold( istep ) ) then
          count = count + 1
          if ( count == ntimes *istep ) then
             ratio = 1.0D0 - dble(istep) /dble(nn)
             smearing_width = width_initial *ratio &
                  &          +width_final *( 1.0d0 -ratio )

             istep = istep +1
             width_is_changed = .true.
          endif
       endif
       if ( istep > nn )  method_change_smearing_width = 0

    end select

    if ( width_is_changed ) then
       write(nfout,*) "------ smearing_width is changed to ", &
            &                       smearing_width
    endif

    width_old = smearing_width

  end subroutine update_smearing_width

  subroutine checkif_wf_mixig_active
    integer, parameter :: ntimes = 3
    real(kind=DP), parameter :: threshold1 = 1.0D1

    integer, save :: count = 0
    logical, save :: GoFlag = .false.

    if ( edelta_start_wf_mixing > threshold1 )  then
       wf_mixing_is_active = .true.
       return
    endif

    if ( .not. GoFlag ) then
       if ( edeltab_per_atom < edelta_start_wf_mixing ) then
          count = count +1
          if ( count == ntimes ) then
             GoFlag = .true.
             write(nfout,*) "** wf_mixing is trurned active"
          endif
       endif
    endif

    if ( GoFlag ) then
       wf_mixing_is_active = .true.
    else
       wf_mixing_is_active = .false.
    endif
    
  end subroutine checkif_wf_mixig_active

end subroutine Renewal_of_Chg_Ctrl_Param

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 577 $)
!
!  MODULE: m_Stress
!
!  AUTHOR(S): H. Sawada   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! *************************************************************
!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.0B]
!                 stress terms are avaiable in the case of DFT-D2 calculations
!
! =============================================================

module m_Stress
  use m_Const_Parameters,     only : DP, PAI, PAI2, PAI4, SKIP, zi &
                                  &, Valence_plus_PC_Charge &
!!$ASASASASAS
!!$                                  &, EXC_ONLY,STRESS_, CRDTYP, GAMMA
                                  &, EXC_ONLY,STRESS_, CRDTYP, GAMMA &
                                  &, MAPPED,NOTMAPPED, ON
  use m_Kpoints,              only : k_symmetry
  use m_PseudoPotential,      only : nlmt,nlmta,lmta,ilmt,lmtt,ltp,mtp,il2p,isph &
                                  &, iqitg,taup,dl2p &
                                  &, q,dion,psc_l,psc_diff_l &
                                  &, qitg_l,qitg_diff_l, modnrm &
                                  &, itpcc,rhpcg_l,rhpcg_diff_l,epc,etot1,ival &
                                  &, m_PP_find_maximum_l, m_PP_include_vanderbilt_pot &
                                  &, ipaw,dion_paw, flg_paw

  use m_NonLocal_Potential,   only : snld
  use m_XC_Potential,         only : vxc_l, vxcpc_l, exc, s_gga1, s_gga2

#ifndef DISABLE_VDWDF
  use m_vdWDF,  only : s_cnl1, s_cnl2, s_cnl1_pc, s_cnl2_pc, ecnl_vdwdf
#endif

  use m_Charge_Density,       only : chgq_l, hsr, chgsoft
  use m_Crystal_Structure,    only : altv,rltv,univol,nopr,op, p2bmat, b2pmat
  use m_Ionic_System,         only : ntyp, natm,ityp,iwei,pos,zfm3_l,s_ew
  use m_PlaneWaveBasisSet,    only : kg1,kg,kgp,ngabc,iba,nbase,nbmx,gr_l,ylm_l &
                                  &, m_pwBS_sphrp2_3D,m_pwBS_sphrp2_diff_3D &
                                  &, ngabc_kngp_l
  use m_Electronic_Structure, only : zaj_l,occup_l,eko_l,totch &
                                  &, fsr_l,fsi_l,fsr_l_2D,fsi_l_2D &
                                  &, m_ES_alloc_fsri_l_2D, m_ES_dealloc_fsri_l_2D &
                                  &, m_ES_gather_f_3d_to_2d, m_ES_alloc_fsr_l_2d &
                                  &, m_ES_alloc_fsi_l_2d, m_ES_gather_f_3d_to_2d_blk
  use m_ES_nonlocal,          only :                                            &
 &                                   m_ES_betar_dot_WFs_4_lmta_k_3D             &
 &                                 , G_dot_R                                    &
 &                                 , m_ES_alloc_zfsincos, m_ES_dealloc_zfsincos &
 &                                 , m_ES_alloc_arai_3D, m_ES_dealloc_arai_3D   &
 &                                 , alloc_zfsincos_mpi, dealloc_zfsincos_mpi   &
 &                                 , m_ES_betar_dot_WFs_4_each_k_3D

  use m_Control_Parameters,   only : nspin,ipri,kimg,af,nel_Ylm,sw_screening_correction,nhistory_stress, printable &
                                  &, sw_optimize_lattice,sw_uniform &
 &                                 , ke_e0,ke_sigma,ke_a, xctype, nblocksize_gather_f_is_given, nblocksize_gather_f
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Parallelization,      only : mpi_comm_group,map_k,myrank_k,np_e,ierr,ista_k,iend_k &
                                  &, ista_kngp,iend_kngp,ista_snl,iend_snl,npes,mype &
                                  &, ista_g1k, iend_g1k, np_g1k, mpi_ke_world, mpi_kg_world  &
                                  &, mpi_ge_world,nrank_g, mpi_chg_world
  use m_Screening,            only : screening


! =================================== Added by K. Tagami ============== p1100
  use m_Electronic_Structure,  only : dhub
  use m_Ionic_System,          only : ihubbard
  use m_Control_Parameters,    only : proj_attribute
! ===================================================================== p1100

  use m_Control_Parameters,   only : noncol
  use m_Control_Parameters,    only : external_stress, &
       &                              sw_fix_lattice_angles, sw_vdw_correction, &
       &                              sw_fix_lattice_lengths, &
       &                              fix_angle_alpha, fix_angle_beta, fix_angle_gamma, &
       &                              fix_length_a, fix_length_b, fix_length_c, &
       &                              sw_neglect_stress_offdiagonal
  use m_Ionic_System,          only : s_vdw

  implicit none
  include 'mpif.h'

  integer,      private,pointer, dimension(:)   :: il3
  real(kind=DP),private,pointer, dimension(:)   :: vlength,wkc
  real(kind=DP),private,pointer, dimension(:)   :: grinv,zfsin_tmp,zfcos_tmp
  real(kind=DP),private,pointer, dimension(:)   :: flchgq
  real(kind=DP),private,pointer, dimension(:,:) :: g,alinvt,vloc
  real(kind=DP),private,pointer, dimension(:,:) :: s_ke,s_or,s_nl
  real(kind=DP),private,pointer, dimension(:,:) :: s_h1,s_h2,s_loc1,s_loc2
  real(kind=DP),private,pointer, dimension(:,:) :: s_xc1,s_xc2
  real(kind=DP),private,pointer, dimension(:,:) :: s_pc
  real(kind=DP),private,allocatable, dimension(:,:,:) :: fsr_diff_l,fsi_diff_l,ylmd
  real(kind=DP),private,pointer, dimension(:)   :: ylm
  real(kind=DP),private,pointer, dimension(:,:,:) :: flchgqd
  real(kind=DP),public, pointer, dimension(:,:,:,:,:,:) :: hsrd,esrd

! ========================= added by K. Tagami =========================== 11.0
  real(kind=DP),public, allocatable, dimension(:,:,:,:,:,:) :: hsid, esid
! ======================================================================== 11.0

  real(kind=DP),private,pointer, dimension(:,:) :: s_0,s_1,s_2
  real(kind=DP),private,pointer, dimension(:,:) :: s_tmp,s_up,s_dn,s
  character(len=2) ,private                     :: stress_name

! ====================== Added by K. Tagami ========================= p1100
  real(kind=DP),private,allocatable, dimension(:,:) :: s_hub
! =================================================================== p1100
  real(kind=DP),private,allocatable, dimension(:,:) :: s_vdwdf

  real(kind=DP),private :: stressmx=-1
  real(kind=DP),dimension(3,3),private :: currstress

contains
  subroutine m_Stress_alloc
    allocate(s_ke(3,3)); s_ke = 0.d0
    allocate(s_or(3,3)); s_or = 0.d0
    allocate(s_nl(3,3)); s_nl = 0.d0
    allocate(s_xc1(3,3)); s_xc1 = 0.d0
    allocate(s_xc2(3,3)); s_xc2 = 0.d0
    allocate(s_h1 (3,3)); s_h1  = 0.d0
    allocate(s_h2 (3,3)); s_h2  = 0.d0
    allocate(s_loc1(3,3)); s_loc1 = 0.d0
    allocate(s_loc2(3,3)); s_loc2 = 0.d0
    allocate(s_pc(3,3)); s_pc = 0.d0

    allocate(hsrd(natm,nlmt,nlmt,nspin,3,3)); hsrd = 0.d0
    allocate(esrd(natm,nlmt,nlmt,nspin,3,3)); esrd = 0.d0

    allocate(s_0(3,3)); s_0 = 0.d0
    allocate(s_1(3,3)); s_1 = 0.d0
    allocate(s_2(3,3)); s_2 = 0.d0
    allocate(s_tmp(3,3)); s_tmp = 0.d0
    allocate(s_up(3,3)); s_up = 0.d0
    allocate(s_dn(3,3)); s_dn = 0.d0
    allocate(s(3,3)); s = 0.d0
    allocate(alinvt(3,3)); alinvt = rltv / PAI2

! =========================================== Added by K.Tagami ==== p1100
    allocate(s_hub(3,3)); s_hub = 0.d0
! ================================================================== p1100
    allocate(s_vdwdf(3,3)); s_vdwdf = 0.d0

  end subroutine m_Stress_alloc

  subroutine m_Stress_dealloc
    deallocate(s_ke)
    deallocate(s_or)
    deallocate(s_nl)
    deallocate(s_xc1)
    deallocate(s_xc2)
    deallocate(s_h1)
    deallocate(s_h2)
    deallocate(s_loc1)
    deallocate(s_loc2)
    deallocate(s_pc)
    deallocate(hsrd)
    deallocate(esrd)

! ============================== added by K. Tagami ============= 11.0
    if ( allocated(hsid) ) deallocate(hsid)
    if ( allocated(esid) ) deallocate(esid)
! =============================================================== 11.0

    deallocate(s_0)
    deallocate(s_1)
    deallocate(s_2)
    deallocate(s_tmp)
    deallocate(s_up)
    deallocate(s_dn)
    deallocate(s)
    deallocate(alinvt)

! =========================================== Added by K.Tagami ==== p1100
    deallocate(s_hub)
! ================================================================== p1100
    deallocate(s_vdwdf)

  end subroutine m_Stress_dealloc

  subroutine m_Stress_alloc_grinv_g
    integer :: i
    real(kind=DP) :: ga,gb,gc
    allocate(grinv(ista_kngp:iend_kngp)); grinv = 0.d0
    allocate(g(ista_kngp:iend_kngp,3)); g = 0.d0
    do i = ista_kngp, iend_kngp  !for mpi
      if(gr_l(i).lt.1.0d-20) then
        grinv(i)=0.d0
      else
        grinv(i)=1.d0/gr_l(i)
      endif
    enddo
    do i = ista_kngp, iend_kngp  !for mpi
      ga = ngabc_kngp_l(i,1)
      gb = ngabc_kngp_l(i,2)
      gc = ngabc_kngp_l(i,3)
      g(i,1) = rltv(1,1)*ga+rltv(1,2)*gb+rltv(1,3)*gc
      g(i,2) = rltv(2,1)*ga+rltv(2,2)*gb+rltv(2,3)*gc
      g(i,3) = rltv(3,1)*ga+rltv(3,2)*gb+rltv(3,3)*gc
    enddo
  end subroutine m_Stress_alloc_grinv_g

  subroutine m_Stress_dealloc_grinv_g
    deallocate(grinv)
    deallocate(g)
  end subroutine m_Stress_dealloc_grinv_g

  subroutine m_Stress_ke(nfout,kv3,kp_crdtyp,vkxyz)
    integer, intent(in) :: nfout, kv3, kp_crdtyp
    real(kind=DP), intent(in), dimension(kv3,3,kp_crdtyp) :: vkxyz
    real(kind=DP)       :: fac
    integer             :: ik,i,j,ib,ig
    real(kind=DP),pointer,dimension(:,:) :: s_ke_mpi   ! MPI
    integer :: is,ie
    integer             :: id_sname = -1

    call tstatc0_begin('m_Stress_ke ',id_sname)

    allocate(s_ke_mpi(3,3))
    allocate(g(maxval(np_g1k),3)); g = 0.d0
    allocate(vlength(maxval(np_g1k))); vlength = 0.d0
    allocate(wkc(maxval(np_g1k)));  wkc  = 0.d0
    s_ke = 0.d0
    do ik = 1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle               ! MPI  
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,g(1,1),g(1,2),g(1,3),vlength)                            ! ->(bottom_Subr.)
       do ig = 1,np_g1k(ik)
          wkc(ig) = 1.d0 &
               &  + 2.d0*ke_a/sqrt(PAI)/ke_sigma  &
               &  * exp(-((vlength(ig)**2/2.d0-ke_e0)/ke_sigma)**2)
       end do
       if(k_symmetry(ik) == GAMMA) then
          is = 1
          if (ista_g1k(ik) == 1) is = 2
          
          do ig = is,np_g1k(ik)
             wkc(ig) = wkc(ig)*2.d0
          end do
       end if

       do i = 1, 3
       do j = 1, 3
       if(kimg.eq.1) then
          do ib = 1, np_e                           ! MPI
             do ig =1,np_g1k(ik)
                fac = wkc(ig)*g(ig,i)*(g(ig,1)*alinvt(1,j) &
                     &                +g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                s_ke(i,j) = s_ke(i,j) &
                     &        - fac*occup_l(ib,ik)*zaj_l(ig,ib,ik,1)**2
             end do
          end do
       elseif(kimg.eq.2) then
          do ib = 1, np_e                           ! MPI
             do ig =1,np_g1k(ik)
                fac = wkc(ig)*g(ig,i)*(g(ig,1)*alinvt(1,j) &
                     &       +g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                s_ke(i,j) = s_ke(i,j) &
                     &        - fac*occup_l(ib,ik) &
                     &        *(zaj_l(ig,ib,ik,1)**2+zaj_l(ig,ib,ik,2)**2)
             end do
          end do
       endif
       enddo
       enddo
    enddo

    call mpi_allreduce(s_ke,s_ke_mpi,3*3,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) !MPI
    s_ke = s_ke_mpi  ! MPI

    s_ke=s_ke/dble(kv3)*2.d0

    stress_name = 'KI'
    if(af == 0) then
       s_0 = s_ke
       call check_stress(nfout)
    else
       s_up = s_ke
       call check_af(nfout)
    endif

    deallocate(s_ke_mpi)
    deallocate(g)
    deallocate(vlength)
    deallocate(wkc)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_ke

  subroutine m_Stress_hsr_diff(nfout,kv3)
    integer, intent(in) :: nfout,kv3
!!$ASASASASAS
    !!$integer    :: i1,i2,ia,it,ispin,ik,i,lmt1,lmt2,lmta1,lmta2,iksnl
    integer    :: i1,i2,ia,it,ispin,ik,i,lmt1,lmt2,lmta1,lmta2,iksnl,mapmode
!!$ASASASASAS
    integer    :: id_sname = -1
    real(kind=DP) :: fac, w_n, ek_n, c
    real(kind=DP),pointer,dimension(:,:,:,:,:,:) :: hsrd_mpi, esrd_mpi  ! MPI
    real(kind=DP),pointer,dimension(:,:,:)       :: snld_mpi            ! MPI
!!$ASASASASAS
    real(kind=DP) :: dtmp1=0.d0
    real(kind=DP) :: dtmp2=0.d0
!!$ASASASASAS
    integer         :: lnblck, lnb1, lnb2, lnsize,ib

    call tstatc0_begin('m_Stress_hsr_diff ',id_sname)

    allocate(hsrd_mpi(natm,nlmt,nlmt,nspin,3,3))   ! MPI
    allocate(esrd_mpi(natm,nlmt,nlmt,nspin,3,3))   ! MPI

    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai_3D(0)
!!$ASASASASAS
    call alloc_zfsincos_mpi()
!!$ASASASASAS
    allocate(fsr_diff_l(np_e,nlmta,ista_k:iend_k)); fsr_diff_l = 0.d0
    allocate(fsi_diff_l(np_e,nlmta,ista_k:iend_k)); fsi_diff_l = 0.d0

    fac = 2.d0/dble(kv3)
    hsrd = 0.d0
    esrd = 0.d0
    do i1 = 1, 3
    do i2 = 1, 3
      do ia = 1, natm
        it = ityp(ia)
!!$ASASASASAS
!!$        call G_dot_R(natm,ia,pos,kgp,nbmx,ngabc,zfcos,zfsin)
        if ( kv3/nspin == 1 ) then
          call G_dot_R(ia,mapmode,1)
          mapmode = MAPPED
        else
          call G_dot_R(ia,mapmode)
          mapmode = NOTMAPPED
        endif
!!$ASASASASAS
        do ispin = 1, nspin, af+1
        do ik = ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle         ! MPI
!          call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik,.false.)

!          if(.not. allocated(fsr_l_2D)) allocate(fsr_l_2D(np_e, nlmta))
!          call m_ES_gather_f_3d_to_2d(fsr_l, fsr_l_2D, ik)
!          if(.not. (kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!             if(.not. allocated(fsi_l_2D)) allocate(fsi_l_2D(np_e, nlmta))
!             call m_ES_gather_f_3d_to_2d(fsi_l, fsi_l_2D, ik)
!          endif
          if(nblocksize_gather_f_is_given) then
             lnblck = nblocksize_gather_f
             if(np_e < lnblck) then
                lnblck = np_e
             end if
             if(1 > lnblck) then
                lnblck = np_e
             end if
          else
             lnblck = np_e
          end if
          call m_ES_alloc_fsr_l_2d(lnblck, nlmta)
          if(k_symmetry(ik) /= GAMMA) then
             call m_ES_alloc_fsi_l_2d(lnblck, nlmta)
          end if
          iksnl = (ik-1)/nspin + 1
          snld_mpi => snld(:,:,ista_snl:iend_snl,i1,i2)   ! MPI
          call m_ES_betar_dot_WFs_4_lmta_k_3D &
!!$ASASASASAS
!!$           & (ista_k,iend_k,ik,zaj_l,ia,iksnl,snld_mpi,fsr_diff_l,fsi_diff_l,0)  ! MPI
           & (ista_k,iend_k,ik,zaj_l,ia,iksnl,snld_mpi,fsr_diff_l,fsi_diff_l,mapmode)  ! MPI
!!$ASASASASAS
!!$           & (ista_k,iend_k,ik,zaj_l,ia,snld(1,1,ista_snl,i1,i2),fsr_diff_l,fsi_diff_l)  ! MPI
          do lnb1 = 1, np_e, lnblck                          ! MPI
             lnb2=min( lnb1+lnblck-1,np_e )
             lnsize = lnb2-lnb1 + 1
             call m_ES_gather_f_3d_to_2d_blk(fsr_l, fsr_l_2D, ik, lnblck, lnb1, lnsize)
             if( k_symmetry(ik) /= GAMMA ) then
                call m_ES_gather_f_3d_to_2d_blk(fsi_l, fsi_l_2D, ik, lnblck, lnb1, lnsize)
             endif
             do ib=lnb1,lnb2
             w_n = occup_l(ib,ik) * fac
             ek_n = eko_l(ib,ik)
             do lmt1 = 1,ilmt(it)
               lmta1    = lmta(lmt1,ia)
               do lmt2 = lmt1,ilmt(it)
                 lmta2    = lmta(lmt2,ia)
!!$ASASASASAS
!          if(.not. allocated(fsr_l_2D)) allocate(fsr_l_2D(np_e, nlmta))
                 if (k_symmetry(ik) /= GAMMA) then
                   dtmp1 = fsi_l_2D(ib,lmta2)
                   dtmp2 = fsi_l_2D(ib,lmta1)
                 else
                   dtmp1 = 0.d0
                   dtmp2 = 0.d0
                 endif
!!$                 c= w_n * &
!!$                  &     (  fsr_diff_l(i,lmta1,ik)*fsr_l(i,lmta2,ik) &
!!$                  &     +  fsi_diff_l(i,lmta1,ik)*fsi_l(i,lmta2,ik) &
!!$                  &     +  fsr_diff_l(i,lmta2,ik)*fsr_l(i,lmta1,ik) &
!!$                  &     +  fsi_diff_l(i,lmta2,ik)*fsi_l(i,lmta1,ik) )
                 c= w_n * &
                  &     (  fsr_diff_l(ib,lmta1,ik)*fsr_l_2D(ib,lmta2) &
                  &     +  fsi_diff_l(ib,lmta1,ik)*dtmp1 &
                  &     +  fsr_diff_l(ib,lmta2,ik)*fsr_l_2D(ib,lmta1) &
                  &     +  fsi_diff_l(ib,lmta2,ik)*dtmp2 )
!!$ASASASASAS
                 hsrd(ia,lmt1,lmt2,ispin,i1,i2)=hsrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                  &     + c
                 esrd(ia,lmt1,lmt2,ispin,i1,i2)=esrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                  &     + ek_n * c
               enddo
             enddo    ! lmt2
             enddo    ! lmt1
          enddo    ! i
       enddo    ! ik
       enddo    ! ispin
    enddo    !ia
    enddo    !i2
    enddo    !i1

    call mpi_allreduce(hsrd,hsrd_mpi,natm*nlmt*nlmt*nspin*3*3,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    call mpi_allreduce(esrd,esrd_mpi,natm*nlmt*nlmt*nspin*3*3,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    hsrd = hsrd_mpi/dble(nrank_g)
    esrd = esrd_mpi/dble(nrank_g)

!!$ASASASASAS
    call dealloc_zfsincos_mpi()
!!$ASASASASAS
    call m_ES_dealloc_arai_3D()
    call m_ES_dealloc_zfsincos()
    deallocate(fsr_diff_l); deallocate(fsi_diff_l)
    deallocate(hsrd_mpi); deallocate(esrd_mpi)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_hsr_diff

  subroutine m_Stress_lclchg_diff(nfout)
    integer, intent(in) :: nfout
    integer    :: n,ilm3,i,it,ik,mdvdb,ia,is,mspin,i1,i2
    integer    :: lmt1,lmt2,il1,il2,tau1,tau2,l3,iiqitg
    real(kind=DP) :: fac,dga,c1,c2
    real(kind=DP), pointer, dimension(:)          :: drhodh
    real(kind=DP),allocatable,target,dimension(:) :: ylm_t
    real(kind=DP), pointer, dimension(:,:)        :: ylmd_mpi
    integer    :: id_sname = -1

    if(modnrm == SKIP) return

    call tstatc0_begin('m_Stress_lclchg_diff ',id_sname)

    allocate(drhodh(nspin))
    allocate(zfcos_tmp(ista_kngp:iend_kngp))
    allocate(zfsin_tmp(ista_kngp:iend_kngp))
    zfcos_tmp = 0.d0; zfsin_tmp = 0.d0
    allocate(vloc(ista_kngp:iend_kngp,kimg)); vloc = 0.d0

    allocate(flchgq(nspin)); flchgq = 0.d0
    allocate(flchgqd(3,3,nspin)); flchgqd = 0.d0

    do ik = 1, kimg
      do it = 1, ntyp
         do i = ista_kngp, iend_kngp  !for mpi
            vloc(i,ik)=vloc(i,ik)+psc_l(i,it)*zfm3_l(i,it,ik)
            if(sw_screening_correction==ON) then
               vloc(i,ik)=vloc(i,ik)-ival(it)*screening%phik(i)/univol*zfm3_l(i,it,ik)
            end if
        enddo
      enddo
    enddo

    call m_PP_find_maximum_l(n)   ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
    allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
    allocate(ylmd(ista_kngp:iend_kngp,3,n**2)); ylmd = 0.d0
    allocate(ylmd_mpi(ista_kngp:iend_kngp,3)); ylmd_mpi = 0.d0
    do ilm3 = 1, n**2
!mpi       call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm2(1,ilm3))
!!$       call m_pwBS_sphrp2(ilm3,rltv,ylm2_mpi)
!!$       do i = ista_kngp, iend_kngp  !for mpi
!!$          ylm2(i,ilm3) = ylm2_mpi(i)
!!$       enddo
!mpi       call m_pwBS_sphrp2_diff(ilm3,rltv,ylmd(1,1,ilm3))
       call m_pwBS_sphrp2_diff_3D(ilm3,rltv,ylmd_mpi)
       do i = ista_kngp, iend_kngp  !for mpi
          ylmd(i,1,ilm3) = ylmd_mpi(i,1)
          ylmd(i,2,ilm3) = ylmd_mpi(i,2)
          ylmd(i,3,ilm3) = ylmd_mpi(i,3)
       enddo
    end do
    deallocate(ylmd_mpi)

    do ia = 1, natm
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       call calc_phase2(natm,pos,ia,kgp,ngabc_kngp_l,ista_kngp,iend_kngp,zfcos_tmp,zfsin_tmp)
                         ! -(b_Elec.)  -> zfcos_tmp, zfsin_tmp
       do lmt1 = 1,ilmt(it)
          il1 = ltp(lmt1,it); tau1 = taup(lmt1,it)
          do lmt2 = lmt1, ilmt(it)
            il2 = ltp(lmt2,it); tau2 = taup(lmt2,it)
            fac = 2.d0 ; if(lmt1 == lmt2) fac = 1.d0
            do n = 1, il2p(lmt1,lmt2,it)
              ilm3 = isph(lmt1,lmt2,n,it)
              l3   =  il3(ilm3)
              iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
              if(iiqitg == 0) cycle
              if(ilm3 <= nel_Ylm) then
                 ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
              else
                 call m_pwBS_sphrp2_3D(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)
                 ylm => ylm_t(ista_kngp:iend_kngp)
              end if
              dga = dl2p(lmt1,lmt2,n,it)

              if (mod(il1+il2,2) == 0) then
                 call even_case
              else
                 call odd_case
              endif

            enddo
          enddo
       enddo
    enddo

    s_xc1  = s_xc1  * univol
    s_h1   = s_h1   * univol * PAI4
    s_loc1 = s_loc1 * univol

    if(af == 0) then
       s_0 = s_xc1
       stress_name = 'X1'
       call check_stress(nfout)
       s_0 = s_h1
       stress_name = 'H1'
       call check_stress(nfout)
       s_0 = s_loc1
       stress_name = 'L1'
       call check_stress(nfout)
    else
       s_up = s_xc1
       stress_name = 'X1'
       call check_af(nfout)
       s_up = s_h1
       stress_name = 'H1'
       call check_af(nfout)
       s_up = s_loc1
       stress_name = 'L1'
       call check_af(nfout)
    endif

    deallocate(zfsin_tmp); deallocate(zfcos_tmp)
    deallocate(vloc)
    deallocate(flchgq); deallocate(flchgqd)
    deallocate(il3)
    deallocate(ylm_t)
    deallocate(ylmd)
    deallocate(drhodh)

    call tstatc0_end(id_sname)

  contains

    subroutine even_case
      do is=1,nspin,af+1
         flchgq(is) = fac*real(zi**(-l3))*dga &
              & *hsr(ia,lmt1,lmt2,is)
         do i1=1,3
            do i2=1,3
               flchgqd(i1,i2,is) = fac*real(zi**(-l3))*dga &
                    & *hsrd(ia,lmt1,lmt2,is,i1,i2)
            enddo
         enddo
      enddo
      if(kimg == 1) then
         call real_case(ilm3,iiqitg,zfcos_tmp)
      else
         call complex_case(ilm3,iiqitg,zfcos_tmp,-zfsin_tmp)
      endif
    end subroutine even_case

    subroutine odd_case
      do is=1,nspin,af+1
         flchgq(is) = fac*aimag(zi**(-l3))*dga &
              & *hsr(ia,lmt1,lmt2,is)
         do i1=1,3
            do i2=1,3
               flchgqd(i1,i2,is) = fac*aimag(zi**(-l3))*dga &
                    & *hsrd(ia,lmt1,lmt2,is,i1,i2)
            enddo
         enddo
      enddo
      if(kimg == 1) then
         call real_case(ilm3,iiqitg,zfsin_tmp)
      else
         call complex_case(ilm3,iiqitg,zfsin_tmp,zfcos_tmp)
      endif
    end subroutine odd_case
    
    subroutine real_case(ilm3,iiqitg,zf)
      integer,       intent(in) :: ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ista_kngp:iend_kngp) :: zf
      real(kind=DP), pointer, dimension(:,:) :: s_xc1_mpi1, s_xc1_mpi2
      real(kind=DP), pointer, dimension(:,:) :: s_h1_mpi1, s_h1_mpi2
      real(kind=DP), pointer, dimension(:,:) :: s_loc1_mpi1, s_loc1_mpi2
      integer :: iy

      allocate(s_xc1_mpi1(3,3)); s_xc1_mpi1 = 0.d0
      allocate(s_h1_mpi1(3,3)); s_h1_mpi1 = 0.d0
      allocate(s_loc1_mpi1(3,3)); s_loc1_mpi1 = 0.d0
      allocate(s_xc1_mpi2(3,3)); s_xc1_mpi2 = 0.d0
      allocate(s_h1_mpi2(3,3)); s_h1_mpi2 = 0.d0
      allocate(s_loc1_mpi2(3,3)); s_loc1_mpi2 = 0.d0

      do is=1,nspin,af+1
        flchgq(is) = flchgq(is) * dble(iwei(ia))
        do i1=1,3
        do i2=1,3
          flchgqd(i1,i2,is) = flchgqd(i1,i2,is) * dble(iwei(ia))
        enddo
        enddo
      enddo

      do i1=1,3
      do i2=1,3
      if(nspin==1 .or. af==1) then
         mspin=(nspin+1)/nspin
         do i = ista_kngp, iend_kngp  !for mpi
            iy = i - ista_kngp+1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            drhodh(1) =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)

            s_xc1_mpi1(i1,i2)=s_xc1_mpi1(i1,i2) &
                 &  +drhodh(1)*vxc_l(i,1,1)*zf(i)
            s_h1_mpi1(i1,i2)=s_h1_mpi1(i1,i2) &
                 &  +grinv(i)**2*drhodh(1) &
                 &  *(chgq_l(i,1,1)+chgq_l(i,1,nspin))/mspin &
                 &  *zf(i)
            s_loc1_mpi1(i1,i2)=s_loc1_mpi1(i1,i2) &
                 &  +drhodh(1)*zf(i)*vloc(i,1)
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      else  ! nspin ==2 and af /= 1
         do i = ista_kngp, iend_kngp  !for mpi
            iy = i - ista_kngp + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            drhodh(1) =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            drhodh(nspin) = &
             &  - flchgq(nspin) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,nspin)*ylm(iy)*qitg_l(i,iiqitg)

            s_xc1_mpi1(i1,i2)=s_xc1_mpi1(i1,i2) &
                 &  +(drhodh(1)*vxc_l(i,1,1) &
                 &   +drhodh(nspin)*vxc_l(i,1,nspin)) &
                 &   *zf(i)
            s_h1_mpi1(i1,i2)=s_h1_mpi1(i1,i2) &
                 &  +grinv(i)**2*(drhodh(1)+drhodh(nspin)) &
                 &  *(chgq_l(i,1,1)+chgq_l(i,1,nspin))*zf(i)
            s_loc1_mpi1(i1,i2)=s_loc1_mpi1(i1,i2) &
                 &  +(drhodh(1)+drhodh(nspin)) &
                 &  *zf(i)*vloc(i,1)
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      endif
      enddo
      enddo
      call mpi_allreduce(s_xc1_mpi1,s_xc1_mpi2,9 &
                   &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
      call mpi_allreduce(s_h1_mpi1,s_h1_mpi2,9 &
                   &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
      call mpi_allreduce(s_loc1_mpi1,s_loc1_mpi2,9 &
                   &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
      s_xc1 = s_xc1 + s_xc1_mpi2
      s_h1 = s_h1 + s_h1_mpi2
      s_loc1 = s_loc1 + s_loc1_mpi2
      deallocate(s_xc1_mpi1); deallocate(s_xc1_mpi2)
      deallocate(s_h1_mpi1); deallocate(s_h1_mpi2)
      deallocate(s_loc1_mpi1); deallocate(s_loc1_mpi2)
    end subroutine real_case

    subroutine complex_case(ilm3,iiqitg,zf1,zf2)
      integer,       intent(in) :: ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ista_kngp:iend_kngp) &
           &  :: zf1,zf2
      real(kind=DP), pointer, dimension(:,:) :: s_xc1_mpi1, s_xc1_mpi2
      real(kind=DP), pointer, dimension(:,:) :: s_h1_mpi1, s_h1_mpi2
      real(kind=DP), pointer, dimension(:,:) :: s_loc1_mpi1, s_loc1_mpi2
      integer :: iy

      allocate(s_xc1_mpi1(3,3)); s_xc1_mpi1 = 0.d0
      allocate(s_h1_mpi1(3,3)); s_h1_mpi1 = 0.d0
      allocate(s_loc1_mpi1(3,3)); s_loc1_mpi1 = 0.d0
      allocate(s_xc1_mpi2(3,3)); s_xc1_mpi2 = 0.d0
      allocate(s_h1_mpi2(3,3)); s_h1_mpi2 = 0.d0
      allocate(s_loc1_mpi2(3,3)); s_loc1_mpi2 = 0.d0

      do i1=1,3
      do i2=1,3
      if(nspin.eq.1 .or. af.eq.1) then
         mspin=(nspin+1)/nspin
         do i = ista_kngp, iend_kngp  !for mpi
            iy = i - ista_kngp + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            drhodh(1) =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)

            s_xc1_mpi1(i1,i2)=s_xc1_mpi1(i1,i2) &
                 &  +drhodh(1) &
                 &  *(vxc_l(i,1,1)*zf1(i)+vxc_l(i,2,1)*zf2(i))
            s_h1_mpi1(i1,i2)=s_h1_mpi1(i1,i2) &
                 &  +grinv(i)**2*drhodh(1) &
                 &  *((chgq_l(i,1,1)+chgq_l(i,1,nspin))/mspin*zf1(i) &
                 &   +(chgq_l(i,2,1)+chgq_l(i,2,nspin))/mspin*zf2(i))
            s_loc1_mpi1(i1,i2)=s_loc1_mpi1(i1,i2) &
                 &  +drhodh(1) &
                 &  *(zf1(i)*vloc(i,1)+zf2(i)*vloc(i,2))
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      else  ! nspin ==2 and af /= 1
         do i = ista_kngp, iend_kngp  !for mpi
            iy = i - ista_kngp + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            drhodh(1) =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            drhodh(nspin) = &
             &  - flchgq(nspin) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,nspin)*ylm(iy)*qitg_l(i,iiqitg)

            s_xc1_mpi1(i1,i2)=s_xc1_mpi1(i1,i2) &
                 &  +drhodh(1) &
                 &  *(vxc_l(i,1,1)*zf1(i)+vxc_l(i,2,1)*zf2(i)) &
                 &  +drhodh(nspin) &
                 &  *(vxc_l(i,1,nspin)*zf1(i)+vxc_l(i,2,nspin)*zf2(i))
            s_h1_mpi1(i1,i2)=s_h1_mpi1(i1,i2) &
                 &  +grinv(i)**2*(drhodh(1)+drhodh(nspin)) &
                 &  *((chgq_l(i,1,1)+chgq_l(i,1,nspin))*zf1(i) &
                 &   +(chgq_l(i,2,1)+chgq_l(i,2,nspin))*zf2(i))
            s_loc1_mpi1(i1,i2)=s_loc1_mpi1(i1,i2) &
                 &  +(drhodh(1)+drhodh(nspin)) &
                 &  *(zf1(i)*vloc(i,1)+zf2(i)*vloc(i,2))
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      endif
      enddo
      enddo
      call mpi_allreduce(s_xc1_mpi1,s_xc1_mpi2,9 &
                   &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
      call mpi_allreduce(s_h1_mpi1,s_h1_mpi2,9 &
                   &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
      call mpi_allreduce(s_loc1_mpi1,s_loc1_mpi2,9 &
                   &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
      s_xc1 = s_xc1 + s_xc1_mpi2
      s_h1 = s_h1 + s_h1_mpi2
      s_loc1 = s_loc1 + s_loc1_mpi2
      deallocate(s_xc1_mpi1); deallocate(s_xc1_mpi2)
      deallocate(s_h1_mpi1); deallocate(s_h1_mpi2)
      deallocate(s_loc1_mpi1); deallocate(s_loc1_mpi2)
    end subroutine complex_case

  end subroutine m_Stress_lclchg_diff

  subroutine m_Stress_check_g12(nfout)
    integer, intent(in) :: nfout
    if(af == 0) then
       s_0 = s_gga1
       stress_name = 'G1'
       call check_stress(nfout)
       s_0 = s_gga2
       stress_name = 'G2'
       call check_stress(nfout)
    else
       s_up = s_gga1
       stress_name = 'G1'
       call check_af(nfout)
       s_up = s_gga2
       stress_name = 'G2'
       call check_af(nfout)
    endif
  end subroutine m_Stress_check_g12

  subroutine m_Stress_xc(nfout)
    integer, intent(in) :: nfout
    integer    :: is,ig,i,j,ia,it,ipc
    real(kind=DP) :: vxcp,pc
    integer    :: id_sname = -1
    integer       :: iend  !mpi
    real(kind=DP) :: vxcp_mpi
    real(kind=DP), pointer, dimension(:,:) :: s_xc2_mpi1, s_xc2_mpi2
    real(kind=DP), pointer, dimension(:,:) :: s_pc_mpi1, s_pc_mpi2

    call tstatc0_begin('m_Stress_xc ',id_sname)

    allocate(zfcos_tmp(ista_kngp:iend_kngp))
    allocate(zfsin_tmp(ista_kngp:iend_kngp))
    zfcos_tmp = 0.d0; zfsin_tmp = 0.d0

    vxcp_mpi = 0.d0
    vxcp=0.d0
    if(kimg==1) then
       do is=1,nspin
          iend = iend_kngp
          if( iend_kngp > kg ) iend = kg
          if( ista_kngp <= iend ) then
             do i = ista_kngp, iend  !for mpi
                vxcp_mpi=vxcp_mpi+vxc_l(i,1,is)*chgsoft(i,1,is)
             enddo
          endif
!xocl end spread sum(vxcp)
       enddo
    else
       do is=1,nspin
          iend = iend_kngp
          if( iend_kngp > kg ) iend = kg
          if( ista_kngp <= iend ) then
             do i = ista_kngp, iend  !for mpi
                vxcp_mpi=vxcp_mpi+vxc_l(i,1,is)*chgsoft(i,1,is) &
                     &    +vxc_l(i,2,is)*chgsoft(i,2,is)
             enddo
          endif
!xocl end spread sum(vxcp)
       enddo
    endif
    call mpi_allreduce(vxcp_mpi,vxcp,1 &
         &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)

!    s_xc2 = ( exc +ecnl_vdwdf -vxcp *univol ) *alinvt
#ifndef DISABLE_VDWDF
    s_xc2 = ( exc +ecnl_vdwdf -vxcp *univol ) *alinvt
#else
    s_xc2 = ( exc -vxcp *univol ) *alinvt
#endif

    allocate(s_xc2_mpi1(3,3)); s_xc2_mpi1 = 0.d0
    allocate(s_xc2_mpi2(3,3)); s_xc2_mpi2 = 0.d0
    allocate(s_pc_mpi1(3,3)); s_pc_mpi1 = 0.d0
    allocate(s_pc_mpi2(3,3)); s_pc_mpi2 = 0.d0

    do ia = 1, natm
    it=ityp(ia)
    if(itpcc(it).ne.0) then
       call calc_phase2(natm,pos,ia,kgp,ngabc_kngp_l,ista_kngp,iend_kngp,zfcos_tmp,zfsin_tmp)
                         ! -(b_Elec.)  -> zfcos_tmp, zfsin_tmp       
       ipc=itpcc(it)
       if(kimg==1) then
          do is=1,nspin
          do i=1,3
          do j=1,3
             do ig = ista_kngp, iend_kngp  !for mpi
                pc = (rhpcg_l(ig,ipc)*alinvt(i,j) &
                     &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i) &
                     &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                     &    +g(ig,3)*alinvt(3,j))) &
                     &   *univol &
                     &   * dble(iwei(ia))
                s_xc2_mpi1(i,j) = s_xc2_mpi1(i,j) &
                     &   - vxc_l(ig,1,is) * zfcos_tmp(ig) * pc / nspin
                s_pc_mpi1(i,j) = s_pc_mpi1(i,j) &
                     &   - vxcpc_l(ig,1) * zfcos_tmp(ig) * pc / nspin
             enddo
          enddo
          enddo
          enddo
!xocl end spread sum(s_xc2),sum(s_pc)
       else
          do is=1,nspin
          do i=1,3
          do j=1,3
             do ig = ista_kngp, iend_kngp  !for mpi
                pc = (rhpcg_l(ig,ipc)*alinvt(i,j) &
                     &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i) &
                     &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                     &    +g(ig,3)*alinvt(3,j))) &
                     &   *univol &
                     &   * dble(iwei(ia))
                s_xc2_mpi1(i,j) = s_xc2_mpi1(i,j) &
                     &   - (vxc_l(ig,1,is) * zfcos_tmp(ig) &
                     &    - vxc_l(ig,2,is) * zfsin_tmp(ig) ) * pc / nspin
                s_pc_mpi1(i,j) = s_pc_mpi1(i,j) &
                     &   - (vxcpc_l(ig,1) * zfcos_tmp(ig) &
                     &    - vxcpc_l(ig,2) * zfsin_tmp(ig) ) * pc / nspin
             enddo
          enddo
          enddo
          enddo
!xocl end spread sum(s_xc2),sum(s_pc)
       endif
    endif
    enddo

    call mpi_allreduce(s_xc2_mpi1,s_xc2_mpi2,9 &
         &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
    call mpi_allreduce(s_pc_mpi1,s_pc_mpi2,9 &
         &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)

    s_xc2 = s_xc2 + s_xc2_mpi2
    s_pc = s_pc + s_pc_mpi2 + epc * alinvt
    deallocate(s_xc2_mpi1); deallocate(s_xc2_mpi2)
    deallocate(s_pc_mpi1); deallocate(s_pc_mpi2)

    s_0 = s_pc
    stress_name = 'PC'
    call check_stress(nfout)
    s_0 = s_xc1
    stress_name = 'X1'
    call check_stress(nfout)
    s_0 = s_xc2
    stress_name = 'X2'
    call check_stress(nfout)
    if(af == 0) then
       s_0 = s_xc1 + s_xc2 + s_gga1 + s_gga2
       stress_name = 'XC'
       call check_stress(nfout)
    else
       s_0 = s_xc2
       stress_name = 'X2'
       call check_stress(nfout)
    endif

    deallocate(zfsin_tmp); deallocate(zfcos_tmp)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_xc

  subroutine m_Stress_loc(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,it,is,ik,ig
    real(kind=DP) :: rsv
    integer    :: id_sname = -1
    integer    :: ist  !mpi
    real(kind=DP), pointer, dimension(:,:) :: s_loc2_mpi
    real(kind=DP) :: rsv_mpi

! ========================= added by K. Tagami =========== 11.0
    integer :: ismax
! ======================================================== 11.0

    call tstatc0_begin('m_Stress_loc ',id_sname)

    allocate(s_loc2_mpi(3,3)); s_loc2_mpi = 0.d0

! ========================= added by K. Tagami =========== 11.0
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ======================================================== 11.0

! ======================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ismax
! ======================================================== 11.0
       do i=1,3
          do j=1,3
             do it=1,ntyp
                do ik=1,kimg
                   ist = ista_kngp
                   if(ista_kngp==1) ist = 2
                   do ig = ist, iend_kngp  !for mpi
                      s_loc2_mpi(i,j) = s_loc2_mpi(i,j) &
                           &  - univol  &
                           &    * chgq_l(ig,ik,is)*zfm3_l(ig,it,ik)*psc_diff_l(ig,it) &
                           &    * 2.d0 * g(ig,i) &
                           &    * (g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                           &      +g(ig,3)*alinvt(3,j))
                   enddo
!xocl end spread sum(s_loc2)
                enddo
             enddo
          enddo
       enddo
    enddo
    
    call mpi_allreduce( s_loc2_mpi, s_loc2, 9, &
         &              mpi_double_precision, mpi_sum, mpi_chg_world, ierr )
    deallocate(s_loc2_mpi)

    rsv_mpi = 0.d0
    rsv = 0.d0

    ist = ista_kngp
    if(ista_kngp==1) ist = 2

! ======================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ismax
! ======================================================== 11.0

      do it=1,ntyp
         do ik=1,kimg
            do ig = ist, iend_kngp  !for mpi
               rsv_mpi = rsv_mpi + chgsoft(ig,ik,is)*zfm3_l(ig,it,ik)*psc_l(ig,it)
              if(sw_screening_correction==ON) then
                  rsv_mpi = rsv_mpi - chgsoft(ig,ik,is)*zfm3_l(ig,it,ik)*ival(it)*Screening%phik(i)/univol
              end if
            enddo
         enddo
      enddo
    enddo

    call mpi_allreduce( rsv_mpi, rsv, 1, &
         &              mpi_double_precision, mpi_sum, mpi_chg_world, ierr )

    s_loc2 = s_loc2 - (etot1*totch + univol*rsv) * alinvt

    if(af == 0) then
       s_0 = s_loc1 + s_loc2
       stress_name = 'LO'
       call check_stress(nfout)
    else
       s_0 = s_loc2
       stress_name = 'L2'
       call check_stress(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_loc

  subroutine m_Stress_h(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ik,ig
    integer    :: id_sname = -1
    real(kind=DP) :: eh
    integer       :: ist  !mpi
    real(kind=DP) :: eh_mpi
    real(kind=DP), pointer, dimension(:,:) :: s_h2_mpi1, s_h2_mpi2

    call tstatc0_begin('m_Stress_h ',id_sname)

    ist = ista_kngp
    if(ista_kngp==1) ist = 2

    eh = 0.d0
    do ik = 1,kimg
! ========================== modified by K. Tagami ========== 11.0
!       if(nspin.eq.1) then
       if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
          do i = ist, iend_kngp  !for mpi
             eh = eh + (chgq_l(i,ik,1)*grinv(i))**2
          enddo
       else if(nspin.eq.2) then
          do i = ist, iend_kngp  !for mpi
             eh = eh + ((chgq_l(i,ik,1)+chgq_l(i,ik,nspin))*grinv(i))**2
          enddo
       endif
    enddo

    do ik = 1, kimg
! ========================== modified by K. Tagami ========== 11.0
!       if(nspin.eq.1) then
       if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
          do i = ist, iend_kngp  !for mpi
             eh = eh - 2 * chgq_l(i,ik,1)*chgsoft(i,ik,1)*grinv(i)**2
          enddo
       else if(nspin.eq.2) then
          do i = ist, iend_kngp  !for mpi
             eh = eh - 2 * (chgq_l(i,ik,1)+chgq_l(i,ik,nspin)) &
                  &  * (chgsoft(i,ik,1)+chgsoft(i,ik,nspin)) * grinv(i)**2
          enddo
      endif
    enddo

    if(npes > 1) then
       call mpi_allreduce(eh,eh_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
       eh = eh_mpi
    end if

    eh = univol*pai4*eh*0.5d0
    s_h2 = s_h2 + eh * alinvt

    allocate(s_h2_mpi1(3,3)); s_h2_mpi1 = 0.d0
    allocate(s_h2_mpi2(3,3)); s_h2_mpi2 = 0.d0

    do i=1,3
       do j=1,3
          do ik=1,kimg
! ========================== modified by K. Tagami ========== 11.0
!             if(nspin.eq.1) then
             if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
                do ig = ist, iend_kngp  !for mpi
                   s_h2_mpi1(i,j) = s_h2_mpi1(i,j) &
                        &   + univol*pai4 &
                        &   *chgq_l(ig,ik,1)**2*grinv(ig)**4 &
                        &   *g(ig,i) &
                        &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                enddo
             else if(nspin.eq.2) then
                do ig = ist, iend_kngp  !for mpi
                   s_h2_mpi1(i,j) = s_h2_mpi1(i,j) &
                        &   + univol*pai4 &
                        &   *(chgq_l(ig,ik,1)+chgq_l(ig,ik,nspin))**2*grinv(ig)**4 &
                        &   *g(ig,i) &
                        &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                enddo
             endif
          enddo
       enddo
    enddo

    if(npes > 1) then
       call mpi_allreduce(s_h2_mpi1,s_h2_mpi2,9 &
            &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
    else
       s_h2_mpi2 = s_h2_mpi1
    end if

    s_h2 = s_h2 + s_h2_mpi2
    deallocate(s_h2_mpi1); deallocate(s_h2_mpi2)

    if(af == 0) then
       s_0 = s_h1 +s_h2
       stress_name = 'HA'
       call check_stress(nfout)
       s_0 = s_h2
       stress_name = 'H2'
       call check_stress(nfout)
    else
       s_0 = s_h2
       stress_name = 'H2'
       call check_stress(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_h

  subroutine m_Stress_ew(nfout)
    integer, intent(in) :: nfout

    s_0 = s_ew
    stress_name = 'EW'
    call check_stress(nfout)

  end subroutine m_Stress_ew

! =================================== KT_add ====================== 13.0B
  subroutine m_Stress_vdw(nfout)
    integer, intent(in) :: nfout
    integer :: i, j

    s_0 = s_vdw
    stress_name = 'VDW'

!    call check_stress(nfout)
    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_0(i,j),j=1,3),i=1,3)

  end subroutine m_Stress_vdw
! ================================================================= 13.0B
#ifndef DISABLE_VDWDF
  subroutine m_Stress_vdwdf(nfout)
    integer, intent(in) :: nfout
    integer :: i, j

!    s_vdwdf = s_cnl1 +s_cnl2 -s_cnl1_pc -s_cnl2_pc
    s_vdwdf = s_cnl1 +s_cnl2
    s_0 = s_vdwdf
!
    stress_name = 'VDWDF'

!    call check_stress(nfout)
    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_0(i,j),j=1,3),i=1,3)

  end subroutine m_Stress_vdwdf
#endif

  subroutine m_Stress_nl(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_nl ',id_sname)

    do i = 1, 3
    do j = 1, 3
    do ispin = 1, nspin, af+1
    do it = 1, ntyp
    do lmt1 = 1, ilmt(it)
    il1 = ltp(lmt1,it)
    im1 = mtp(lmt1,it)
    do lmt2 = lmt1, ilmt(it)
    il2 = ltp(lmt2,it)
    im2 = mtp(lmt2,it)
    if(ipaw(it)==0) then
        if(il1==il2 .and. im1==im2) then
           do ia = 1, natm
           if(ityp(ia)==it) then
              fac = 2.d0*dble(iwei(ia))
              if(lmt1==lmt2) fac = fac*0.5d0
              s_nl(i,j) = s_nl(i,j) &
                & + fac * dion(lmt1,lmt2,it) * hsrd(ia,lmt1,lmt2,ispin,i,j)

!              write(980,*) 'i j it = ', i, j, it
!              write(980,*) 'lmt1 kmt2 ia = ', lmt1, lmt2, ia
!              write(980,*) 'dion= ', dion(lmt1,lmt2,it)
!              write(980,*) 'hsrd= ', hsrd(ia,lmt1,lmt2,1,i,j), &       
!                   &                 hsrd(ia,lmt1,lmt2,2,i,j)
           endif
           enddo
!
        endif
    else
! --- Check ---
       do ia = 1, natm
       if(ityp(ia)==it) then
          fac = 2.d0*dble(iwei(ia))
          if(lmt1==lmt2) fac = fac*0.5d0
          s_nl(i,j) = s_nl(i,j) &
            & + fac * dion_paw(lmt1,lmt2,ispin,ia) * hsrd(ia,lmt1,lmt2,ispin,i,j)
       endif
       enddo
    endif
    enddo  ! lmt2
    enddo  ! lmt1
    enddo  ! it
    enddo  ! ispin
    enddo  ! j
    enddo  ! i

    if(af == 0) then
       s_0 = s_nl
       stress_name = 'NL'
       call check_stress(nfout)
    else
       s_up = s_nl
       stress_name = 'NL'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_nl

  subroutine m_Stress_or(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_or ',id_sname)

    do i = 1, 3
    do j = 1, 3
    do ispin = 1, nspin, af+1
    do it = 1, ntyp
    do lmt1 = 1, ilmt(it)
    il1 = ltp(lmt1,it)
    im1 = mtp(lmt1,it)
    do lmt2 = lmt1, ilmt(it)
    il2 = ltp(lmt2,it)
    im2 = mtp(lmt2,it)
    if(il1==il2 .and. im1==im2) then
       do ia = 1, natm
       if(ityp(ia)==it) then
          fac = 2.d0*dble(iwei(ia))
          if(lmt1==lmt2) fac = fac*0.5d0
          s_or(i,j) = s_or(i,j) &
            & + fac * q(lmt1,lmt2,it) * esrd(ia,lmt1,lmt2,ispin,i,j)
       endif
       enddo
    endif
    enddo  ! lmt2
    enddo  ! lmt1
    enddo  ! it
    enddo  ! ispin
    enddo  ! j
    enddo  ! i

    if(af == 0) then
       s_0 = s_or
       stress_name = 'OR'
       call check_stress(nfout)
    else
       s_up = s_or
       stress_name = 'OR'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_or

! =========================== Added by K. Tagami =========== p1100
  subroutine m_Stress_Hub(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
!
    integer ih, l1p
!
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_Hub ',id_sname)

    do i = 1, 3
       do j = 1, 3
          do ispin = 1, nspin, af+1
             do ia = 1, natm
                ih = ihubbard(ia)
                if(ih == 0) cycle
                it = ityp(ia)
                l1p = proj_attribute(ih)%l+1
                do lmt1 = 1, ilmt(it)
                   il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                   if(il1 /= l1p) cycle
                   do lmt2 = lmt1, ilmt(it)
                      il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                      if(il2 /= l1p) cycle
      !!$if(im1 /= im2) cycle
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                      s_hub(i,j) = s_hub(i,j) &
                           & + fac * dhub(lmt1,lmt2,ia,ispin)  &
                           &       * hsrd(ia,lmt1,lmt2,ispin,i,j)
                   end do
                end do
             end do
          end do
       enddo
    enddo
! --
!    if ( nspin==1 ) then
!       s_hub =s_hub * 2.0d0
!    endif
!    s_hub = 0.0d0
    ! --
    if(af == 0) then
       s_0 = s_hub
       stress_name = 'HU'
       call check_stress(nfout)
    else
       s_up = s_hub
       stress_name = 'HU'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_Hub

  subroutine check_stress(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr

    s_1 = 0.d0
    s_2 = 0.d0
    do i=1,3
    do j=1,3
      do k=1,3
      s_1(i,j)=s_1(i,j)-s_0(i,k)*altv(j,k)/univol
      enddo
    enddo
    enddo

    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        do iopr=1,nopr
        s_2(i,j)=s_2(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
        enddo
      enddo
      enddo
    s_2(i,j)=s_2(i,j)/nopr
    enddo
    enddo

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_2(i,j),j=1,3),i=1,3)
  end subroutine check_stress

  subroutine check_af(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr

    s_1 = 0.d0
    s_2 = 0.d0
    s_dn = 0.d0

    do i=1,3
    do j=1,3
      do k=1,3
      s_1(i,j)=s_1(i,j)-s_up(i,k)*altv(j,k)/univol
      enddo
    enddo
    enddo

    iopr = nopr +af
    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        s_dn(i,j)=s_dn(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
      enddo
      enddo
    enddo
    enddo

    s_1 = s_1 + s_dn

    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        do iopr=1,nopr
        s_2(i,j)=s_2(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
        enddo
      enddo
      enddo
    s_2(i,j)=s_2(i,j)/nopr
    enddo
    enddo

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_2(i,j),j=1,3),i=1,3)
  end subroutine check_af

  subroutine m_Stress_sum(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr
    real(kind=DP) :: c1
    real(kind=DP) :: altv_brav(3,3)

    s_tmp=0.d0
    s=0.d0
    if(af==0) then
       s = s_ke + s_xc1 + s_xc2 + s_gga1 + s_gga2 + s_loc1 + s_loc2 &
         &  + s_h1 + s_h2 + s_nl - s_or + s_ew

! ================================== Added by K. Tagami ======= p1100
       s = s + s_hub
! ============================================================== p1100

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
    else
       s_up = s_ke + s_xc1 + s_gga1 + s_gga2 + s_loc1 &
         &  + s_h1 + s_nl - s_or

! ================================== Added by K. Tagami ======= p1100
       s_up = s_up + s_hub
! ============================================================= p1100

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s_up(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
       iopr = nopr + af
       s_dn = 0.d0
       do i=1,3
         do j=1,3
           do k=1,3
             do l=1,3
               s_dn(i,j) = s_dn(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_tmp(k,l)
             enddo
           enddo
         enddo
       enddo
       s_tmp = s_tmp + s_dn
       s = s_xc2 + s_loc2 + s_h2 + s_ew

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
    endif

! ================================== KT_add  =============== 13.0B
    if ( sw_vdw_correction == ON ) s_tmp = s_tmp +s_vdw
! ========================================================== 13.0B
!    if ( xctype == "vdwdf" ) s = s +s_vdwdf

    s = 0.d0
    do i=1,3
      do j=1,3
        do k=1,3
          do l=1,3
            do iopr=1,nopr
              s(i,j) = s(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_tmp(k,l)
            enddo
          enddo
        enddo
      enddo
    enddo
    s = s / nopr

    if ( xctype == "vdwdf" ) s = s +s_vdwdf

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',/,(3f20.10))') &
         &     ((s(i,j),j=1,3),i=1,3)

! ============================= KT_add ======================== 13.0B
    if (ipri >= 1) then
       write(nfout,*) '-------------------------- '
       write(nfout,'(''  External STRESS TENSOR'',/,(3f20.10))') &
            &            ( ( -external_stress(i,j),j=1,3),i=1,3)
       write(nfout,'(''  Total STRESS TENSOR'',/,(3f20.10))') &
            &            ( ( s(i,j)-external_stress(i,j),j=1,3),i=1,3)
       write(nfout,*) '-------------------------- '
    endif
! ============================================================= 13.0B

! ================================ KT_mod ================== 13.0B
!    stressmx = abs(s(1,1))
!    do i=1,3
!       do j=1,3
!          if(abs(s(j,i))>stressmx) stressmx = abs(s(j,i))
!       enddo
!    enddo
!    currstress(:,:) = s(:,:)
!    if(sw_uniform==ON)then
!       stressmx = abs(currstress(1,1)+currstress(2,2)+currstress(3,3))/3.0d0
!    endif

    currstress = s -external_stress
!
    stressmx = abs(currstress(1,1))
    do i=1,3
       do j=1,3
          if(abs(currstress(j,i))>stressmx) stressmx = abs(currstress(j,i))
       enddo
    enddo
    if ( sw_uniform == ON ) then
       stressmx = abs(currstress(1,1)+currstress(2,2)+currstress(3,3))/3.0d0
    endif

! === KT_add === 13.1AS
    if ( sw_neglect_stress_offdiagonal == ON ) then
       s_tmp = 0.0d0
       s_tmp(1,1) = currstress(1,1)
       s_tmp(2,2) = currstress(2,2)
       s_tmp(3,3) = currstress(3,3)

       stressmx = 0.0d0
       do i=1,3
          c1 = sqrt( s_tmp(i,1)**2 +s_tmp(i,2)**2 +s_tmp(i,3)**2 )
          if ( c1 > stressmx ) stressmx = c1
       enddo
    endif

    if ( sw_fix_lattice_angles == ON .or. sw_fix_lattice_lengths == ON ) then
       call get_latvec_from_prim_to_brav( p2bmat, altv, altv_brav )

       s_tmp = projected_stress_along_latvecs( altv_brav, currstress )
       stressmx = 0.0d0

       if ( sw_fix_lattice_angles == ON ) then
          s_tmp = constrain_on_stress_type1( altv_brav, s_tmp )
       endif
       if ( sw_fix_lattice_lengths == ON ) then
          s_tmp = constrain_on_stress_type2( altv_brav, s_tmp )
       endif

       do i=1,3
          c1 = sqrt( s_tmp(i,1)**2 +s_tmp(i,2)**2 +s_tmp(i,3)**2 )
          if ( c1 > stressmx ) stressmx = c1
       enddo
    endif
! ============= 13.1AS

! ================================================================= 13.0B

  end subroutine m_Stress_sum

  function m_Stress_get_stressmx() result(res)
     real(kind=DP) :: res
     res = stressmx
  end function m_Stress_get_stressmx

  subroutine m_Stress_set_stressmx(strmx)
    real(kind=DP), intent(in) :: strmx
    stressmx = strmx
  end subroutine m_Stress_set_stressmx

  function m_Stress_get_curr_stress() result(res)
     real(kind=DP), dimension(3,3) :: res
     res = currstress
  end function m_Stress_get_curr_stress

! === KT_add ==== 13.1AS
function projected_stress_along_latvecs(altv_in,stress) result(ret)
  real(kind=DP), dimension(3,3), intent(in) :: stress, altv_in
  real(kind=DP), dimension(3,3) :: ret

  integer :: i
  real(kind=DP) :: normalized_lat_vec(3,3), c1
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

  ret = 0.0d0

  do i=1,3
     ret(1,i) = dot_product(stress(i,:),normalized_lat_vec(:,1)) ! a-vec
     ret(2,i) = dot_product(stress(i,:),normalized_lat_vec(:,2)) ! b-vec
     ret(3,i) = dot_product(stress(i,:),normalized_lat_vec(:,3)) ! c-vec
  enddo
end function projected_stress_along_latvecs

function constrain_on_stress_type1(altv_in,s_in) result(s_out)
  real(kind=DP), intent(in) :: s_in(3,3), altv_in(3,3)
  real(kind=DP) :: s_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  s_out = s_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_angle_alpha .and. fix_angle_beta .and. fix_angle_gamma ) then
     Do i=1, 3
        c1 = dot_product( s_out(i,:), normalized_lat_vec(:,i) )
        s_out(i,:) = c1 *normalized_lat_vec(:,i)
     End do
     return
  endif

! -----------------------------------
  if ( fix_angle_alpha ) then
     vectmp(:) = normalized_lat_vec(:,2) + normalized_lat_vec(:,3)

     Do i=2, 3
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_beta ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,3)

     Do i=1, 3, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_gamma ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,2)

     Do i=1, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do

  endif

end function constrain_on_stress_type1

function constrain_on_stress_type2(altv_in,s_in) result(s_out)
  real(kind=DP), intent(in) :: s_in(3,3), altv_in(3,3)
  real(kind=DP) :: s_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  s_out = s_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_length_a ) then
     c1 = dot_product( s_out(1,:), normalized_lat_vec(:,1) )
     s_out(1,:) = s_out(1,:) -c1 *normalized_lat_vec(:,1)
  endif
  if ( fix_length_b ) then
     c1 = dot_product( s_out(2,:), normalized_lat_vec(:,2) )
     s_out(2,:) = s_out(2,:) -c1 *normalized_lat_vec(:,2)
  endif
  if ( fix_length_c ) then
     c1 = dot_product( s_out(3,:), normalized_lat_vec(:,3) )
     s_out(3,:) = s_out(3,:) -c1 *normalized_lat_vec(:,3)
  endif
end function constrain_on_stress_type2
! ====== 13.1AS

end module m_Stress

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE: m_Wannier
!
!  AUTHOR(S): T. Yamamoto   May/05/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Wannier
!! Maximally localized Wannier functions
!! Ref.
!! [1] N. Marzari and D. Vanderbilt, Phys. Rev. B 56 (1997) 12847.
!! [2] G. Berghold, et.al., Phys. Rev. B 61 (2000) 10040.
  use m_Const_Parameters,   only : DP,PAI2,SD,CG,CGPRC,BINARY,CUBE,VTK,DENSITY_ONLY &
       &                         , SKIP,EXECUT,GAMMA,ON
  use m_Control_Parameters, only : printable, kimg, neg, eps_wan, dt_wan &
       &                         , wannier_opt_method, max_iter_wan &
       &                         , wannier_filetype, ipri, sw_random_wannier &
       &                         , sw_potential_wannier, sw_continue_wannier
  use m_Crystal_Structure,  only : altv, rltv, univol
  use m_FFT,                only : nfft, fft_box_size_WF &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Ionic_System,       only : ntyp,natm,natm2,ityp,iatomn,m_IS_pack_all_ions_in_uc &
       &                         , iwei,pos
  use m_PseudoPotential,    only : ival,modnrm,dk_wan,qitg_wan &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , n_non0_lmtxlmt,index_lmt1_lmt2,lmta,nlmt,ilmt &
       &                         , ltp,taup,il2p,isph,iqitg,dl2p &
       &                         , m_PP_find_maximum_l
  use m_Files,              only : m_Files_open_nfwannier,nfwannier &
       &                         , m_Files_open_nfcntn_wannier &
       &                         , m_Files_open_nfpot_wannier &
       &                         , nfcntn_wannier,nfpot_wannier
  use m_Kpoints,            only : k_symmetry
  implicit none
  
  integer, public                     :: nwght
  real(kind=DP), private, allocatable :: wght(:) ! d(nwght)
  integer, public, allocatable        :: ghat(:,:) ! d(3,nwght) 

  integer, private                       :: nocc
  complex(kind=DP), private, allocatable :: zmat(:,:,:) ! d(nocc,nocc,nwght)
  complex(kind=DP), private, allocatable :: zn(:,:) ! d(nocc,nwght)

  real(kind=DP), private, allocatable :: umat(:,:) ! d(nocc,nocc)
  complex(kind=DP), private, allocatable :: bmat(:,:) ! d(nocc,nocc)
  real(kind=DP), private, allocatable :: mmat(:,:) ! d(nocc,nocc)

  integer, private                    :: ntri ! (nocc-1)*nocc/2
  real(kind=DP), private, allocatable :: amat(:) ! d(ntri)
  real(kind=DP), private, allocatable :: grad(:) ! d(ntri)
  real(kind=DP), private :: omega
  real(kind=DP), private :: gradmax

  complex(kind=DP), private, allocatable :: rmat(:,:) ! d(nocc,nocc)
  real(kind=DP), private, allocatable    :: lam(:) ! d(nocc)

  integer, private                    :: iteration

  complex(kind=DP), private, allocatable :: ftqe(:,:,:,:)!d(nlmt,nlmt,natm,nwght)

contains
  subroutine m_Wan_gen_weight(nfout)
    integer, intent(in) :: nfout
    integer :: i
    real(kind=DP) :: g(3,3),w
    real(kind=DP), parameter :: eps = 1.d-10

    nwght = 6
    allocate(wght(nwght),ghat(3,nwght))

    g = matmul(transpose(altv),altv)

    nwght = 0
    ! g^=(1,0,0)
    w = g(1,1)-g(1,2)-g(1,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/1,0,0/)
    ! g^=(0,1,0)
    w = g(2,2)-g(1,2)-g(2,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/0,1,0/)
    ! g^=(0,0,1)
    w = g(3,3)-g(1,3)-g(2,3)
    nwght = nwght + 1
    wght(nwght) = w
    ghat(1:3,nwght) = (/0,0,1/)
    ! g^=(1,1,0)
    w = g(1,2)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/1,1,0/)
    end if
    ! g^=(1,0,1)
    w = g(1,3)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/1,0,1/)
    end if
    ! g^=(1,1,0)
    w = g(2,3)
    if(abs(w) > eps) then
       nwght = nwght + 1
       wght(nwght) = w
       ghat(1:3,nwght) = (/0,1,1/)
    end if

    if(printable) then
       write(nfout,*) '!Wannier: nwght=',nwght
       do i=1,nwght
          write(nfout,'(" !Wannier: i=",i1," wght=",f18.5," g^=",3i2)') &
          & i,wght(i),ghat(1:3,i)
       end do
    end if

  end subroutine m_Wan_gen_weight


end module m_Wannier

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MAIN PROGRAM: PHASE
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: mdmain0.F90 570 2017-04-21 20:34:50Z yamasaki $
!
program PHASE
#ifdef NEC_TIMER
  use nec_timer
#endif
  use m_Const_Parameters, only : DRIVER_CONSTRAINT, DRIVER_NEB, DRIVER_MTD, DRIVER_SC_DFT
#ifdef PAW3D
  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm
  use m_PseudoPotential,      only : mmesh
  use m_Parallelization,      only : m_Parallel_init_mpi_paw_3D
#endif
  implicit none
  logical  :: ChargeDensity_is_Converged, TotalEnergy_is_Divergent
  logical  :: Already_Converged, Already_Converged2
  logical  :: Positron_scf, Positron_nonscf
  logical  :: Hubbard_model
  logical  :: Forces_are_Converged, Ending_Time, Force_errors_are_tolerable,UnitCell_Converged
!!$  logical  :: ChargeDensity_is_Fixed
#ifdef NEC_ITER_REG
  integer  :: count_for_ftrace
#endif

  integer :: initmpi
  logical :: confpara
  integer :: driver
  logical :: ending_t,force_conv,mpi_initialized,uconv
  logical :: initialization_required
  
#ifdef NEC_ITER_REG
     count_for_ftrace = 0
     call FTRACE_REGION_BEGIN("INITIAL")
#endif

  confpara = Resolve_Config_Parallel()
  initmpi=1
  if(confpara) initmpi=0
  mpi_initialized = .false.

  do

  ending_t = .false.
  if (mpi_initialized) initmpi=0
  call Initialization(initmpi)
  mpi_initialized = .true.
  call InputData_Analysis
  driver   = Resolve_Driver()

  if(ekmode()) call Initialization_set_ekmode_ON()

  if(driver == DRIVER_NEB) then
    call do_neb()
  else if(driver==DRIVER_CONSTRAINT) then
#ifndef DISABLE_CONSTRAINTS
    call constrained_dynamics()
#endif
  else if(driver==DRIVER_MTD) then
#ifndef DISABLE_CONSTRAINTS
    call meta_dynamics()
#endif
  else

  outer_loop:do
  if(driver==DRIVER_SC_DFT .and. .not.Initial_SCDFTLoop()) then
     call InputData_Analysis()
     if(ekmode()) call Initialization_set_ekmode_ON()
  end if

  call Preparation                          ! Basis set, symmetry check etc.
  if(initialization_required())then
     call Preparation_for_mpi(1)     ! mpi
  endif
  call PseudoPotential_Construction
#ifdef PAW3D
  call  m_Parallel_init_mpi_paw_3D(nfout,natm,mmesh)
#endif
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
     call Preparation_for_ESM
  endif
#endif

  call Ewald_and_Structure_Factor
  if ( Positron_scf() ) call Initial_pWaveFunctions()

  call Initial_Electronic_Structure

  if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
     call ekcal()  ! contained here
     exit outer_loop
  else
     call Initial_MD_Condition
#ifdef NEC_ITER_REG
     call FTRACE_REGION_END("INITIAL")
#endif
     force_conv = Already_Converged()
     if(.not.force_conv) then
#ifdef NEC_ITER_REG
        call FTRACE_REGION_BEGIN("SOLVE-FIRST")
#endif
        StressLoop: do
           AtomicConfiguration: do
              ChargeDensity:    do
                 force_conv=.false.
#ifdef NEC_ITER_REG
                 count_for_ftrace = count_for_ftrace + 1
                 if(count_for_ftrace .eq. 2) then
                    call FTRACE_REGION_END("SOLVE-FIRST")
                    call FTRACE_REGION_BEGIN("SOLVE-CORE")
                 end if
#endif
                 call IterationNumber_Setting

! ============================ added by K. Tagami ============- 5.0
                 call Renewal_of_Chg_Ctrl_Param
! ============================================================ 5.0

                 call Renewal_of_WaveFunctions
                 if ( Positron_scf() ) call Renewal_of_pWaveFunctions                 

                 call ChargeDensity_Construction(1)
                 call Potential_Construction

                 if ( PotentialMix() ) then
                    call Potential_Mixing
                 else
                    call ChargeDensity_Mixing
                 endif

                 ending_t = Ending_Time()
                 if(ending_t)                      exit StressLoop
                 if(TotalEnergy_is_Divergent())    exit StressLoop

                 if ( PotentialMix() ) then
                 else
                    call Renewal_of_Potential
                    if ( Positron_scf() ) call Renewal_of_pPotential
                    if (Hubbard_model() ) then
                       call Renewal_of_Hubbard_Parameters
                       call Renewal_of_Hubbard_Potential
                    end if
                 endif

                 if(ChargeDensity_is_Converged())  exit ChargeDensity
              enddo ChargeDensity
              call Forces
              if ( epsilon_post_scf() ) call Epsilon_PostScf

              force_conv = Forces_are_Converged()
              if(force_conv) exit AtomicConfiguration
              if(Force_errors_are_tolerable()) then
                 call Postprocessing_during_MD()
                 call Move_Ions
                 call MDIterationNumber_Setting
                 call Ewald_and_Structure_Factor
                 if ( Hubbard_model() ) then
                    call Renewal_of_Hubbard_Parameters
                    call Renewal_of_Hubbard_Potential
                 end if
!!$                 call MDIterationNumber_Setting
              end if
              if(BreakMD(force_conv))then
                 exit AtomicConfiguration
              endif
           enddo AtomicConfiguration
           if(driver==DRIVER_SC_DFT) exit StressLoop
           call Stress
           exit StressLoop
        end do StressLoop
#ifdef NEC_ITER_REG
        if(count_for_ftrace .eq. 1) then
           call FTRACE_REGION_END("SOLVE-FIRST")
        else
           call FTRACE_REGION_END("SOLVE-CORE")
        end if
#endif
     end if

     if (driver == DRIVER_SC_DFT .and. .not.ending_t) then
! * T.Hamada 2016.1.8 + T. Yamasaki 2016.02.21
        write(6,'(" driver = DRIVER_SC_DFT")')
        call flush(6)
        call Epsilon_Paramset
        call Epsilon_Postscf
        call setalpha_exx()
! * T.Hamada 2015.1.8
        if(Break_SC_DFT()) exit outer_loop
!!$! * T.Hamada 2015.11.4
        call SCDFTIterationNumber_Setting
        call Set_Icond
        call WriteDownData_onto_Files(.false.)
        if(.not.ending_t) call Array_Deallocate()
     else if ( Already_Converged2() ) then
        if ( Positron_nonscf() ) then
#ifdef NEC_ITER_REG
           call FTRACE_REGION_BEGIN("POSITRON")
#endif
           call Initial_pWaveFunctions()
           call Renewal_of_pPotential()
           call Solve_pWaveFunctions()
#ifdef NEC_ITER_REG
           call FTRACE_REGION_END("POSITRON")
#endif
        else if ( Positron_scf() ) then
           call Write_Positron_LifeTime
        end if
        exit outer_loop
     else
        exit outer_loop
     endif

#ifdef NEC_ITER_REG
     call FTRACE_REGION_BEGIN("FINAL")
#endif
  end if

  enddo outer_loop

  uconv = UnitCell_Converged(force_conv)
  if(.not.uconv.and..not.ending_t)then
     call MDIterationNumber_Setting2()
     call WriteDownData_onto_Files(.false.)
  else
     if(ChargeDensity_is_Fixed() .and. One_by_one_in_each_rank_k()) then ! icond=2, 3
        !call Postprocessing(.false.)
        !call WriteDownData_onto_Files_ek()
     else
        if(uconv) call Postprocessing(.false.)
        if ( uconv .and. epsilon_post_proc() ) call Epsilon_PostScf
        call WriteDownData_onto_Files(ending_t.or.uconv)
        if(uconv) exit
     end if
  endif

  if(.not.ending_t) then
     call Array_Deallocate()
     call Continuation_Mode()
  endif

  endif

  if (ending_t.or.OneShot()) exit

  enddo
#ifdef NEC_TIMER
  call print_timer()
#endif
  if(driver/=DRIVER_NEB) call Finalization_of_mpi           ! mpi
#ifdef NEC_ITER_REG
  call FTRACE_REGION_END("FINAL")
#endif
contains
  subroutine ekcal()
    use m_Epsilon_ek, only : sw_epsilon
    use m_Const_Parameters, only : ON
    logical :: AllKpoints_are_Calculated2,AllKpoints_are_Calculated, Already_Converged_for_Kgroup
    logical :: EigenValues_are_Converged, AllKpoints_are_Converged, Already_Converged
    integer :: nk
    logical :: all_conv = .true.
    nk = 0
    if(sw_epsilon == ON) then
       call Initialization_Epsilon        ! Epsilon
       call Shift_Kpoint
    endif
    KPOINT_GROUP: do
       call KpointNumber_Setting2()
       if(AllKpoints_are_Converged()) exit KPOINT_GROUP
       call Preparation_ek()
       call Preparation_for_mpi_ek
       if(sw_epsilon==ON)then
          call PseudoPotential_ek_Epsilon
       else
          call PseudoPotential_ek
       endif
       call Initial_WaveFunctions_ek
       if(.not.Already_Converged_for_kgroup()) then
          all_conv = .false.
          SolveWaveFunctions: do
             if(Ending_Time())                 exit KPOINT_GROUP
             call IterationNumber_Setting()
             call Renewal_of_WaveFunctions()
             if(EigenValues_are_Converged()) then
                if(sw_epsilon==ON)then
                   call Transition_moment_Epsilon                           ! Epsilon
                   call Dealloc_Radr_and_Wos_Epsilon                        ! Epsilon
                endif
                exit SolveWaveFunctions
             endif
          enddo SolveWaveFunctions
!!$          call Postprocessing_k()
          if(AllKpoints_are_Calculated2(nk)) then
             all_conv = .true.
             exit KPOINT_GROUP
          endif
       else
          exit KPOINT_GROUP
       end if
    enddo KPOINT_GROUP
    call Postprocessing(.false.)
    if(all_conv.and.sw_epsilon==ON) then
      call Reset_Kpoint                                                   ! Epsilon
      call Prep_for_Calc_Epsilon                                          ! Epsilon
      call Calc_Epsilon                                                   ! Epsilon
      call Calc_Nonlinear_optics                                          ! Epsilon
      call WriteDownData_onto_Files_Eps                                   ! Epsilon
    end if
    call WriteDownData_onto_Files_ek()
  end subroutine ekcal

  subroutine Continuation_Mode()
    use m_Const_Parameters,   only : COORDINATE_CONTINUATION,ON,OFF
    use m_Control_Parameters, only : icond, sw_optimize_lattice,sw_rebuild_pws
    implicit none
    logical :: unitcell_can_change
    if(unitcell_can_change() .and. sw_rebuild_pws==OFF) return
    icond = COORDINATE_CONTINUATION
  end subroutine continuation_mode

  subroutine Postprocessing_scf()
    use m_Const_Parameters,     only : ON
    use m_Control_Parameters,   only : sw_rsb,neg,damp,noncol
    use m_Files,                only : nfout
    use m_ES_WF_by_submat,      only : m_ESsubmat_alloc,m_ESsubmat_renew_WF,m_ESsubmat_renew_WF_noncl
    use m_Electronic_Structure, only : m_ES_energy_eigen_values
    use m_ES_occup,             only : m_ESoc_fermi_parabolic
    use m_ES_IO,                only : m_ESIO_wd_EigenValues
    implicit none
    if(sw_rsb==ON)then
       call m_ESsubmat_alloc()
          call m_ESsubmat_renew_WF(nfout,neg,damp)
       call ChargeDensity_Construction(1)
       call Renewal_of_Potential()
       call m_ES_energy_eigen_values(nfout,.true.)
       call m_ESoc_fermi_parabolic(nfout)
       call m_ESIO_wd_EigenValues(0,2,0)
    endif
  end subroutine Postprocessing_scf

  subroutine Postprocessing_during_MD()
    use m_IterationNumbers, only : iteration_ionic
    use m_Control_Parameters, only : postproc_frequency
    if(postproc_frequency<=0) return
    if(mod(iteration_ionic,postproc_frequency)==0)then
       call Postprocessing(.true.)
    endif
  end subroutine Postprocessing_during_MD

  logical function BreakMD(conv)
    use m_IterationNumbers, only : iteration_ionic
    use m_Ionic_System, only : addition_frequency,m_IS_natm_can_change
    logical, intent(in) :: conv
    if(.not.m_IS_natm_can_change())then
       BreakMD = conv
       return
    endif
    BreakMD = mod(iteration_ionic,addition_frequency)==0
  end function BreakMD

  logical function Break_SC_DFT()
    use m_IterationNumbers, only : iteration, first_iteration_of_this_job, iteration_scdft
    use m_Control_Parameters, only : delta_epsilon, max_scdft_iteration, epsilon0, epsilon0_previous
    if(iteration-first_iteration_of_this_job <= 0 .or. iteration_scdft<=1) then
       Break_SC_DFT = .false.
    else
       if(dabs(epsilon0 - epsilon0_previous) < max(0.0, delta_epsilon)) then
          Break_SC_DFT = .true.
       else
          if(iteration_scdft > max_scdft_iteration) then
             Break_SC_DFT = .true.
          else
             Break_SC_DFT = .false.
          end if
       end if
    end if
    write(6,'(" Break_SC_DFT = ",L3)') Break_SC_DFT
    call flush(6)
  end function Break_SC_DFT

  logical function Initial_SCDFTLoop()
    use m_IterationNumbers, only : iteration_scdft, iteration_scdft_initial
    Initial_SCDFTLoop = .true.
    if(Iteration_scdft > Iteration_scdft_initial) Initial_SCDFTLoop = .false.
!!$    if(mype==0) then
       write(6,*) ' ! Iteration_scdft, iteration_scdft_initial = ', iteration_scdft,iteration_scdft_initial
       write(6,*) ' I Initial_SCDFTLoop = ',Initial_SCDFTLoop
       call flush(6)
!!$    end if
  end function Initial_SCDFTLoop

  subroutine setalpha_exx()
    use m_Control_Parameters, only : m_CtrlP_set_alpha_exx, epsilon0
    use m_Files,              only : nfout
    use m_Const_Parameters,   only : DP
    real(kind=DP) :: alpha
    alpha = 1.d0/epsilon0
    call m_CtrlP_set_alpha_exx(nfout,alpha)
  end subroutine setalpha_exx

  logical function OneShot()
    use m_Ionic_System, only : m_IS_natm_can_change
    use m_Control_Parameters, only : sw_optimize_lattice
    use m_Const_Parameters, only : OFF
    logical :: unitcell_can_change
    OneShot = .not.m_IS_natm_can_change()
    if(OneShot) then
        OneShot = .not.unitcell_can_change()
    endif
  end function OneShot

! ======= KT_add ============ 13.0U2
  logical function PotentialMix()
    use m_Control_Parameters, only : sw_potential_mixing
    use m_Const_Parameters,   only : ON

    if ( sw_potential_mixing == ON ) then
       PotentialMix = .true.
    else
       PotentialMix = .false.
    endif
  end function PotentialMix
! =========================== 13.0U2

! === KT_add ==== 13.1R
  logical function epsilon_post_scf()
    use m_Const_Parameters,   only : ON, OFF
    use m_Epsilon_ek,  only : sw_epsilon, m_Eps_chkif_sw_epsilon
    use m_Control_Parameters, only : sw_phonon, sw_phonon_with_epsilon, &
         &                           sw_calc_dielectric_tensor, sw_excitation

    logical, save :: First = .true.

    epsilon_post_scf = .false.

    if ( First ) then
       call m_Eps_chkif_sw_epsilon;        First = .false.
    endif
    if ( sw_epsilon == OFF .and. sw_excitation == OFF ) return

    if ( sw_phonon == ON ) then
       if ( sw_phonon_with_epsilon == ON .and. sw_calc_dielectric_tensor == ON ) then
          epsilon_post_scf = .true.
       endif
    else
!       epsilon_post_scf = .true.
       epsilon_post_scf = .false.
    endif

  end function epsilon_post_scf

  logical function epsilon_post_proc()
    use m_Const_Parameters,   only : ON, OFF
    use m_Epsilon_ek,  only : sw_epsilon, m_Eps_chkif_sw_epsilon
    use m_Control_Parameters, only : sw_phonon, sw_phonon_with_epsilon, &
         &                           sw_calc_dielectric_tensor, sw_excitation

    logical, save :: First = .true.

    epsilon_post_proc = .false.

    if ( First ) then
       call m_Eps_chkif_sw_epsilon;        First = .false.
    endif
    if ( sw_epsilon == OFF .and. sw_excitation == OFF ) return

    if ( sw_phonon == ON ) then
       epsilon_post_proc = .false.
    else
       epsilon_post_proc = .true.
    endif

  end function epsilon_post_proc
! =============== 13.1R

  logical function ChargeDensity_is_Fixed()
    use m_Control_Parameters, only : icond
    use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       ChargeDensity_is_Fixed = .true.
    else
       ChargeDensity_is_Fixed = .false.
    end if
  end function ChargeDensity_is_Fixed

  logical function One_by_one_in_each_rank_k()
    use m_Control_Parameters, only : fixed_charge_k_parallel
    use m_Const_Parameters,   only : ONE_BY_ONE
    if(fixed_charge_k_parallel == ONE_BY_ONE) then
       One_by_one_in_each_rank_k = .true.
    else
       One_by_one_in_each_rank_k = .false.
    end if
  end function One_by_one_in_each_rank_k

  integer function Resolve_Driver()
    use m_Control_Parameters, only : driver
    Resolve_Driver = driver
  end function Resolve_Driver

  logical function ekmode()
    use m_Control_Parameters, only : icond,fixed_charge_k_parallel
    use m_Const_Parameters, only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,ONE_BY_ONE
    implicit none
    ekmode = .false.
    if((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION) .and. &
    &  fixed_charge_k_parallel .eq. ONE_BY_ONE) then
       ekmode = .true.
    endif
  end function ekmode

  logical function Resolve_Config_Parallel()
    use m_Parallelization, only : m_Parallel_resolve_conf_para
    implicit none
    Resolve_Config_Parallel = m_Parallel_resolve_conf_para()
  end function Resolve_Config_Parallel

   subroutine Set_Icond
     use m_Const_Parameters,   only : INITIAL
     use m_Control_Parameters, only : m_CtrlP_set_icond
     call m_CtrlP_set_icond(INITIAL)
   end subroutine Set_Icond

  subroutine Array_Deallocate()
     use m_ES_wf_extrpl, only : m_ES_wf_extrpl_dealloc
     implicit none
     call m_ES_wf_extrpl_dealloc()
#ifdef FFTW3
     call m_FFT_finalize()
#endif
     call m_CtrlP_set_init_status(.true.)
   end subroutine Array_Deallocate

   subroutine Write_Positron_LifeTime
     use m_Positron_Wave_Functions, only : m_pWF_wlifetime

     call m_pWF_wlifetime()
   end subroutine Write_Positron_LifeTime

end program PHASE

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 577 $)
!
!  SUBROUINE: Stress
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Stress
  use m_Stress,           only : hsrd &
         &                     , m_Stress_alloc,m_Stress_ke, m_Stress_dealloc, m_Stress_hsr_diff &
         &                     , m_Stress_alloc_grinv_g, m_Stress_lclchg_diff, m_Stress_dealloc_grinv_g &
         &                     , m_Stress_xc, m_Stress_loc, m_Stress_h, m_Stress_nl, m_Stress_ew &
         &                     , m_Stress_or, m_Stress_sum, m_Stress_Hub, m_Stress_vdw &
#ifndef DISABLE_VDWDF
         &                     , m_Stress_check_g12, m_Stress_vdwdf
#else
         &                     , m_Stress_check_g12
#endif
  use m_Const_Parameters, only : Valence_plus_PC_Charge,STRESS_, CRDTYP, ON
  use m_Kpoints,          only : kv3, vkxyz
  use m_Files,            only : nfout
  use m_Control_Parameters, only: istress, sw_vdw_correction, xctype, sw_hubbard
  use m_XC_Potential,     only : m_XC_alloc_s_gga, m_XC_dealloc_s_gga, m_XC_cal_potential_3D
  use m_Charge_Density,   only : chgsoft, chgq_l, hsr

  implicit none

  if (istress == 0) return

  call m_Stress_alloc()
  call m_XC_alloc_s_gga()
  call m_Stress_ke(nfout,kv3,CRDTYP,vkxyz)
  call m_Stress_hsr_diff(nfout,kv3)
  call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l,STRESS_ &
       &   ,chgsoft,hsr,hsrd)
  call m_Stress_check_g12(nfout)
  call m_Stress_alloc_grinv_g()
  call m_Stress_lclchg_diff(nfout)
  call m_Stress_xc(nfout)
  call m_Stress_loc(nfout)
  call m_Stress_h(nfout)
  call m_Stress_dealloc_grinv_g()
  call m_Stress_nl(nfout)
  call m_Stress_ew(nfout)
  call m_Stress_or(nfout)

! =============================== Added by K. Tagami ============ p1100
  if ( sw_hubbard == ON ) call m_Stress_Hub(nfout)
! =============================================================== p1100

! =================================== KT_add ============== 13.0B
  if ( sw_vdw_correction == ON ) call m_Stress_vdw(nfout)
! ========================================================= 13.0B

#ifndef DISABLE_VDWDF
  if ( xctype == "vdwdf" ) call m_Stress_vdwdf(nfout)
#endif

  call m_Stress_sum(nfout)
  call m_Stress_dealloc()
  call m_XC_dealloc_s_gga()
end subroutine Stress

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE:  m_Force
!
!  AUTHOR(S): T. Uchiyama, T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Force
! $Id: m_Force_ep.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters,     only : DP, RELAX, BONDLENGTH_FIX, HEAT_BATH &
       &                           , WITHOUTTAG, WITHTAG
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : forccr,printable
  use m_Crystal_Structure,    only : altv,univol
  use m_Ionic_System,         only : natm,natm2,iwei,imdtyp,pos

  implicit none

!-- For Si atom --
  real(kind=DP), parameter :: a_cut = 1.8d0,sigma = 3.959164919d0, eps = 7.968005097d-2
  real(kind=DP), parameter :: bmax = sigma*a_cut
!--
  real(kind=DP),allocatable,dimension(:,:) :: forc_l !d(natm,3)
  real(kind=DP)                            :: forcmx
  real(kind=DP)                            :: etotal

contains
  subroutine m_Force_alloc()
    allocate(forc_l(natm,3))
  end subroutine m_Force_alloc

  subroutine m_Force_stlweb()
! ** Stillinger-Weber potential **
!                          T. Uchiyama,  June 6, 1998
! ** Transfer from f77 to f90 **
!                      corded by k.iwata July 30,1998
! ** Revised by T. Yamasaki, Oct. 1998
    integer, parameter :: nbd = 24
    real(kind=DP), pointer, dimension(:,:) :: posb, forc   !d(natm2,3)
    integer,       pointer, dimension(:,:) :: ipar         !d(katm*nbd,3)
    real(kind=DP) :: r1(3),r2(3)
    integer       :: npar

    integer       :: id_sname = -1
    call tstatc0_begin('stlweb ',id_sname)

    allocate(posb(natm2,3));  allocate(forc(natm2,3)); forc = 0.d0
    allocate(ipar(natm*nbd,3))

    call full_ionic_coordinates    !-(contained here) pos -> posb
    call two_body_term(npar)       !-(contained here) -> forc
    call three_body_term(nbd,npar) !-(contained here) -> forc
    call copy_back_to_forc_l       !-(contained here) forc -> forc_l
    call get_forc_maximum          !-(contained here) forc_l -> forcmx

    deallocate(ipar)
    deallocate(forc); deallocate(posb)

    call tstatc0_end(id_sname)
  contains
    subroutine full_ionic_coordinates
      integer :: i,ia

      do i = 1, natm
         posb(i,1:3)= pos(i,1:3)
      end do

      ia= natm
      do i= 1, natm
         if(iwei(i) == 2) then
            ia= ia +1
            posb(ia,1:3)= -posb(i,1:3)
         end if
      end do

      do i = 1, natm2
         posb(i,1:3) = dmod( posb(i,1:3), 1.d0 )
      end do
    end subroutine full_ionic_coordinates

! ***** 2-body term ***********************************
    subroutine two_body_term(npar)
      integer, intent(out) :: npar
!     Interaction with self-images is not included,
!   where the cell size is assumed to be larger than
!   the cutoff radius.
!
      real(kind=DP),pointer,dimension(:,:) :: femp2   !d(3,2)
      integer       :: mm, m1, m2,lx,ly,lz, j
      real(kind=DP) :: b, eemp2, cp(3)

      allocate(femp2(3,2))

      etotal = 0.d0
      mm= 0
      do m1 = 1,    natm2-1
         do m2 = m1+1, natm2
            do lx= -1, 1
               do ly= -1, 1
                  do lz= -1, 1

                     cp(1) = posb(m2,1) - posb(m1,1) + lx
                     cp(2) = posb(m2,2) - posb(m1,2) + ly
                     cp(3) = posb(m2,3) - posb(m1,3) + lz

                     r1 = matmul(altv,cp)   ! pucv -> cartesian coordinates

                     b= dsqrt( pvec( r1, r1 ))

                     if(b < bmax) then
                        mm= mm +1
                        ipar(mm,1)= m1
                        ipar(mm,2)= m2
                        ipar(mm,3)= ( lx+1 )*9 +( ly+1 )*3 +lz+1
           !  ------------------------------------------------
                        call emp2(r1,eemp2,femp2)   !-(m_Force_ep)
                        etotal= etotal +eemp2
                        do j= 1, 3
                           forc(m1,j)= forc(m1,j) +femp2(j,1)
                           forc(m2,j)= forc(m2,j) +femp2(j,2)
                        end do
           !  ------------------------------------------------
                     end if

                  end do
               end do
            end do

         end do
      end do
      npar= mm
!!$      print *,' ! npar = ', npar
      deallocate(femp2)
    end subroutine two_body_term

! ***** 3-body term **********************************
    subroutine three_body_term(nbd,npar)
      integer, intent(in) :: nbd,npar
      real(kind=DP)       :: kb(nbd),t(3,nbd)
      real(kind=DP),pointer,dimension(:,:) :: femp3   ! d(3,3)
      integer             :: m, nb, k, m1, m2, lx,ly,lz,j1,j2,j
      real(kind=DP)       :: eemp3
      logical :: over
      allocate(femp3(3,3))

      over = .false.
      do m = 1, natm2

         nb= 0
         do k= 1, npar
            if(ipar(k,1) == m .or. ipar(k,2) == m) then
               nb= nb +1
               if(nb > nbd) then
                  if(printable) write(6,'(" !warning nbd, nb = ",i8,i8)') nbd,nb 
               end if
               m1= ipar(k,1)
               m2= ipar(k,2)

               lx= ipar(k,3)/9 -1
               ly= ( ipar(k,3) -lx*9 -9 )/3 -1
               lz= ipar(k,3) -lx*9 -ly*3 -13

               if(nb <= nbd) then

               t(1,nb)= posb(m2,1) -posb(m1,1) +lx
               t(2,nb)= posb(m2,2) -posb(m1,2) +ly
               t(3,nb)= posb(m2,3) -posb(m1,3) +lz

               if(m1 == m) kb(nb)= m2
               if(m2 == m) then
                  kb(nb)= m1 
                  t(1,nb)= -t(1,nb)
                  t(2,nb)= -t(2,nb)
                  t(3,nb)= -t(3,nb)
               end if

               end if
            end if
         end do

         if(nb > nbd) over = .true.

         do j1= 1,    nb-1
            do j2= j1+1, nb

               r1 = matmul(altv,t(1:3,j1))
               r2 = matmul(altv,t(1:3,j2))

         ! -------------------------------------------------
               call emp3(r1,r2,eemp3,femp3)
               etotal= etotal +eemp3

               m1 = kb(j1)
               m2 = kb(j2)
               do j= 1, 3
                  forc(m, j)= forc(m, j) +femp3(j,1)
                  forc(m1,j)= forc(m1,j) +femp3(j,2)
                  forc(m2,j)= forc(m2,j) +femp3(j,3)
               end do
         ! -------------------------------------------------

            end do
         end do
      end do

      if(over) stop ' stop at three_body_term'

!!$      print *,' ! etotal = ' , etotal
      deallocate(femp3)
    end subroutine three_body_term

    subroutine copy_back_to_forc_l
      integer :: i, j
      do i= 1, natm
         do j= 1,3
            forc_l(i,j)= forc(i,j)
         end do
      end do
    end subroutine copy_back_to_forc_l

    subroutine get_forc_maximum
      integer       :: i
      real(kind=DP) :: fca

      forcmx = 0.d0
      do i = 1, natm
         if(imdtyp(i) == RELAX .or. imdtyp(i) == BONDLENGTH_FIX &
              & .or. imdtyp(i) > HEAT_BATH) then
            fca = dsqrt(forc_l(i,1)**2+forc_l(i,2)**2+forc_l(i,3)**2)
            if(forcmx < fca) forcmx = fca
         end if
      end do
      write(6,'(" !!f forcmx = ", f8.4," <<m_Force_stlweb.get_forc_maximum>>")') forcmx
!!$      print *, ' !D forcmx = ', forcmx
    end subroutine get_forc_maximum

  end subroutine m_Force_stlweb

! ****************************
  function pvec( a, b )
! ****************************

    real(kind=DP) :: pvec
    real(kind=DP) :: a(3), b(3)

    pvec= a(1)*b(1) +a(2)*b(2) +a(3)*b(3)

  end function pvec

! **************************************************************
  subroutine emp2(r,eemp2,femp2)   
    !   Stillinger and Weber potential,    coded by T. Miyake

    real(kind=DP),intent(in), dimension(3)   :: r
    real(kind=DP),intent(out)                :: eemp2
    real(kind=DP),intent(out),dimension(3,2) :: femp2

    real(kind=DP) :: x,y,z, rad, femp2r
    x = r(1)
    y = r(2)
    z = r(3)
    rad = dsqrt(x**2 + y**2 + z**2)

    call vemp2SiSi(rad,eemp2,femp2r)

    femp2(1,1) = - femp2r * x / rad
    femp2(2,1) = - femp2r * y / rad
    femp2(3,1) = - femp2r * z / rad
    femp2(1,2) = - femp2(1,1)
    femp2(2,2) = - femp2(2,1)
    femp2(3,2) = - femp2(3,1)

  end subroutine emp2

! ***********************************************************************
  subroutine emp3(r12,r13,eemp3,femp3)
    real(kind=DP), intent(in), dimension(3)  :: r12,r13
    real(kind=DP), intent(out)               :: eemp3
    real(kind=DP), intent(out),dimension(3,3):: femp3

    real(kind=DP) :: x12,y12,z12,x13,y13,z13

    x12 = r12(1)
    y12 = r12(2)
    z12 = r12(3)
    x13 = r13(1)
    y13 = r13(2)
    z13 = r13(3)

    call vemp3SiSiSi(x12,y12,z12,x13,y13,z13, eemp3,femp3)
  end subroutine emp3

! ***********************************************************************
!  two body contributions to Si-Si interaction 
!  Stillinger and Weber, Phys.Rev.B31,5262(1985)
!  atomic unit
  subroutine vemp2SiSi(r,eemp2,femp2r)
    real(kind=DP),intent(in)  :: r
    real(kind=DP),intent(out) :: eemp2,femp2r

    real(kind=DP),parameter   :: A = 7.049556277d0, B = 0.6022245584d0
    integer, parameter        :: p = 4, q = 0

    real(kind=DP) :: r0, f2, df2

! =======================================================================
!  begin:

    r0 = r / sigma

    if (r0 >=  a_cut) then 

       eemp2 = 0d0
       femp2r = 0d0

    else 

       f2 = A * (B*r0**(-p) - r0**(-q)) * dexp(1d0/(r0-a_cut))
       df2 = A * (-p*B*r0**(-p-1) + q*r0**(-q-1)) * &
            &  dexp(1d0/(r0-a_cut)) - &
            &  A * (B*r0**(-p) - r0**(-q)) * &
            &  dexp(1d0/(r0-a_cut)) * (r0-a_cut)**(-2)

       eemp2 = eps * f2
       femp2r = - eps * df2 / sigma

    endif

  end subroutine vemp2SiSi

! ***********************************************************************
!  three body contributions to Si-Si-Si interaction 
!  Stillinger and Weber, Phys.Rev.B31,5262(1985)
!  atomic unit
  subroutine vemp3SiSiSi(x12,y12,z12,x13,y13,z13,eemp3,femp3)
    real(kind=DP), intent(inout) :: x12,y12,z12,x13,y13,z13
    real(kind=DP), intent(out)   :: eemp3,femp3(3,3)

    real(kind=DP) :: r12,r13
    real(kind=DP) :: h,dh(3,3)

    x12 = x12 / sigma
    y12 = y12 / sigma
    z12 = z12 / sigma
    x13 = x13 / sigma
    y13 = y13 / sigma
    z13 = z13 / sigma

    r12 = dsqrt(x12**2 + y12**2 + z12**2)
    r13 = dsqrt(x13**2 + y13**2 + z13**2)

    if ((r12 < a_cut).and.(r13 < a_cut)) then 

       call sw3body(a_cut,r12,r13,x12,x13,y12,y13,z12,z13,h,dh)
       eemp3 = eps * h
       femp3 = -eps/sigma * dh
    else

        eemp3 = 0.d0
        femp3 = 0.d0

    endif

  end subroutine vemp3SiSiSi

! ***********************************************************************
!  h and its derivatives in Stillinger-Weber potential
  subroutine sw3body(a_cut,r12,r13,x12,x13,y12,y13,z12,z13, &
       &  h,dh)
    implicit none

    real(kind=DP), parameter :: lamda=21.0d0
    real(kind=DP), parameter :: gamma=1.20d0

    real(kind=DP) ::  a_cut
    real(kind=DP) ::  r12,r13,x12,y12,z12,x13,y13,z13
    real(kind=DP) ::  h,dh(3,3)
    real(kind=DP) ::  b,c

! =======================================================================
!  begin:
    b = x12*x13 + y12*y13 + z12*z13
    c = b / (r12*r13) + 1d0 / 3d0
!
    if (c.eq.0d0) then 
       h = 0d0
       dh = 0.d0
    else
       h = lamda * dexp(gamma/(r12-a_cut) + gamma/(r13-a_cut)) & 
            &  * c**2

       dh(1,1) = h * (gamma*x12/r12/(r12-a_cut)**2 + &
            &  gamma*x13/r13/(r13-a_cut)**2) &
            &  + 2d0*h/c * (-(x12+x13)/(r12*r13) - b*(r12*(-x13/r13) &
            &   +r13*(-x12/r12)) / (r12*r13)**2)
       dh(2,1) = h * (gamma*y12/r12/(r12-a_cut)**2 + &
            &  gamma*y13/r13/(r13-a_cut)**2) &
            &  + 2d0*h/c * (-(y12+y13)/(r12*r13) - b*(r12*(-y13/r13) &
            &  +r13*(-y12/r12)) / (r12*r13)**2)
       dh(3,1) = h * (gamma*z12/r12/(r12-a_cut)**2 + &
            &  gamma*z13/r13/(r13-a_cut)**2) &
            &  + 2d0*h/c * (-(z12+z13)/(r12*r13) - b*(r12*(-z13/r13) &
            &  +r13*(-z12/r12)) / (r12*r13)**2)

       dh(1,2) = h * (gamma*(-x12/r12)/(r12-a_cut)**2) & 
            & + 2d0*h/c * (x13/(r12*r13) - b*(x12/r12)/(r12**2*r13))
       dh(2,2) = h * (gamma*(-y12/r12)/(r12-a_cut)**2) &
            & + 2d0*h/c * (y13/(r12*r13) - b*(y12/r12)/(r12**2*r13))
       dh(3,2) = h * (gamma*(-z12/r12)/(r12-a_cut)**2) &
            & + 2d0*h/c * (z13/(r12*r13) - b*(z12/r12)/(r12**2*r13))

       dh(1,3) = h * (gamma*(-x13/r13)/(r13-a_cut)**2) &
            & + 2d0*h/c * (x12/(r12*r13) - b*(x13/r13)/(r12*r13**2))
       dh(2,3) = h * (gamma*(-y13/r13)/(r13-a_cut)**2) &
            & + 2d0*h/c * (y12/(r12*r13) - b*(y13/r13)/(r12*r13**2))
       dh(3,3) = h * (gamma*(-z13/r13)/(r13-a_cut)**2) & 
            & + 2d0*h/c * (z12/(r12*r13) - b*(z13/r13)/(r12*r13**2))

    endif
!
!       if (ideb == 1) write(*,*)'sw3body in'
!
  end subroutine sw3body

  logical function m_Forces_are_Converged_core()
    if(forcmx < forccr) then
       m_Forces_are_Converged_core = .true.
    else
       m_Forces_are_Converged_core = .false.
    end if
!!$    write(6,'(" !!f forcmx, forccr = ",2f12.6)') forcmx, forccr
  end function m_Forces_are_Converged_core

  subroutine m_Force_wd_force_and_cps(nf, withorwithout, cps, ndim)
    integer, intent(in) :: nf, withorwithout,ndim
    real(kind=DP), intent(in) :: cps(ndim,3)
    real(kind=DP) :: fca
    integer :: ia

    if(withorwithout == WITHOUTTAG) then
       do ia = 1, natm
          fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
          write(nf,'(" ",i4,3f15.9,4f12.6)') ia &
               &, cps(ia,1),cps(ia,2),cps(ia,3) &
               &, forc_l(ia,1), forc_l(ia,2), forc_l(ia,3),fca
       end do
    else if(withorwithout == WITHTAG) then
       do ia = 1, natm
          fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
          write(nf,'(" !forc ",i4,3f12.6,4f12.6)') ia &
               &, cps(ia,1),cps(ia,2),cps(ia,3) &
               &, forc_l(ia,1), forc_l(ia,2), forc_l(ia,3), fca
       end do
    else
       write(nf,'(" keyword in the argument list of m_Force_wd_force_and_cps is invalid")')
    end if

  end subroutine m_Force_wd_force_and_cps

  subroutine m_Force_wd_force_cps_cpd(nf, withorwithout, cps, cpd,ndim)
    integer, intent(in) :: nf, withorwithout,ndim
    real(kind=DP), intent(in) :: cps(ndim,3), cpd(ndim,3)
    integer :: ia

    if(withorwithout == WITHOUTTAG) then
       do ia = 1, natm
          write(nf,'(" ",i4,3f15.9,3f12.6, 3f12.6)') ia &
               &, cps(ia,1:3), cpd(ia,1:3), forc_l(ia,1:3)
       end do
    else if(withorwithout == WITHTAG) then
       do ia = 1, natm
          write(nf,'(" !forc ",i4,3f12.6,3f12.6,3f12.6)') ia &
               &, cps(ia,1:3),cpd(ia,1:3),forc_l(ia,1:3)
       end do
    else
       write(nf,'(" keyword in the argument list of m_Force_wd_force_cps_cpd is invalid")')
    end if

  end subroutine m_Force_wd_force_cps_cpd

end module m_Force

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for calculating Chi0 for the non-intearcting system.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_NonInt

  use m_Kpoints,                    only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, &
       &                                   k_symmetry, np0, np2                
  use m_Const_Parameters,           only : DP, GAMMA, ELECTRON, DIRECT, & 
       &                                   INVERSE, ON, OFF, CMPLDP, DELTA, &
       &                                   BUCS, &
       &                                   Hartree, NO, YES, &
       &                                   TETRAHEDRON, PARABOLIC

  use m_Control_Parameters,         only : ipri, nspin, kimg, af, neg, printable, &
       &                                   way_of_smearing
  use m_LinearResponse_Control,     only  : nrd_efermi, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    scissor, eta, sw_LongWaveLimit

  use m_LinearResponse_Density,     only : RhoTilde, occup_lkt_ek

  use m_Control_Parameters,         only : Num_q_Points
  use m_Electronic_Structure,       only : eko_ek
  use m_Crystal_Structure,    only :  rltv, univol
  use m_Timing,                     only : tstatc0_begin, tstatc0_end

  use m_Parallelization,          only : map_e,  map_z, myrank_e, mpi_comm_group, &
       &                                 npes, ierr, mype

  use m_LinearResponse_Control,     only  : tddft_eqn_type, DYSON, BS

  Implicit None
  include 'mpif.h'

! ----------------------------- public -------------
  integer :: nband_LR, band_start_LR, band_end_LR
  Complex(kind=CMPLDP), allocatable :: Mat_Chi0(:,:,:)

contains

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc Chi0
!!
!-------------------------------------------------------------------
  subroutine m_LR_alloc_Mat_Chi0
    if ( tddft_eqn_type == DYSON ) then
       if ( mype == 0 ) then
          allocate( Mat_Chi0( nmax_G_LR, nmax_G_LR, nspin ) ); Mat_Chi0 = 0.0D0
       endif
    endif
    if ( tddft_eqn_type == BS ) then
       if ( mype == 0 ) then
          allocate( Mat_Chi0( 1,1,nspin ) ); Mat_Chi0 = 0.0D0
       endif
    endif
  end subroutine m_LR_alloc_Mat_Chi0

  subroutine m_LR_dealloc_Mat_Chi0
    if ( mype == 0 ) deallocate( Mat_Chi0 )
  end subroutine m_LR_dealloc_Mat_Chi0

!------------------------------------------------------------------
!!
!!!            Calc Chi0 in the case of Q > 0
!!
!-------------------------------------------------------------------
  subroutine Calc_Chi0_General( e_value )
    real(kind=DP), intent(in) :: e_value

    real(kind=DP)         :: weight
    real(kind=DP)         :: occ1, occ2
    complex(kind=CMPLDP)  :: ztmp, omega1, omega2
    integer               :: i,j, k, ispin
    integer               :: ik1, ik2, ik3
    integer               :: ib1, ib2
    
    integer               :: k_max, nq_max
    integer :: id_sname = -1
! ------------------------------ start ------------
    call tstatc0_begin('Calc_Chi0_General ', id_sname)
!
    nq_max = Num_q_points
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta ); 
! ---
    if ( mype==0 ) Mat_Chi0 = 0.0d0
! ------------------------------- main -----------
    Do i=1, nmax_G_LR
       Do j=1, nmax_G_LR

          Do ispin=1, nspin
             ztmp = 0.0d0
             
             Do k=1, k_max
                ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
                ik2 = ik1 + nspin
                ik3 =  nspin*(k-1) + ispin 

                weight = qwgt_ek(ik1) *nspin

                Do ib1=band_start_LR, band_end_LR           ! unoccpuied state
                   occ1 = Occup_lkt_ek( ib1, ik1 );  
                   if ( occ1 > DELTA ) cycle

                   Do ib2=band_start_LR, band_end_LR          ! occupied state
                      occ2 = Occup_lkt_ek( ib2, ik2 )  
                      if ( occ2 < DELTA ) cycle
!
                      if ( map_e(ib2) /= myrank_e ) cycle

                      call summation_ztmp
                   End do
                End do
             End do
             call add_ztmp_to_Chi0
          End do
       End do
    End do
! -------------------------------- end ----------
    if ( mype == 0 ) then
       if ( nspin==1 ) Mat_Chi0 = Mat_Chi0 *2.0d0
    endif
    call tstatc0_end(id_sname)

  contains 
    
    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine summation_ztmp
      integer :: jb2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      jb2 = map_z(ib2)

      ebi = Eko_ek( ib1,ik1 ); ebj = Eko_ek( ib2,ik2 )
      ediff = ebi - ebj + scissor
                      
      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2
!                      c1 = occ1 - occ2
      z1 = RhoTilde( i, ib1, jb2, ik3 ); z2 = RhoTilde( j, ib1, jb2, ik3 )
!
      c1 = ( 1.0D0 - occ1 ) *occ2
      ztmp = ztmp + c1 *conjg( z1 )* z2 *gfn *weight
    end subroutine summation_ztmp

    subroutine add_ztmp_to_Chi0
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         ztmp = zsum
      endif
      if ( mype == 0 ) Mat_Chi0( i,j,ispin ) = ztmp / univol
    end subroutine add_ztmp_to_Chi0

  end subroutine Calc_Chi0_General

!------------------------------------------------------------------
!!
!!!            Calc Chi0 in the case of LongWaveLimit
!!
!-------------------------------------------------------------------
  subroutine Calc_Chi0_LWLimit( e_value )
    real(kind=DP), intent(in) :: e_value

    real(kind=DP)         :: occ1, occ2
    real(kind=DP)         :: weight
    complex(kind=CMPLDP)  :: ztmp, omega1, omega2

    integer               :: i,j, k, ispin
    integer               :: ik1, ik2, ik3
    integer               :: ib1, ib2
    integer               :: k_max, nq_max
    integer :: id_sname = -1
! ------------------------------- start ------------
    call tstatc0_begin('Calc_Mat_Chi0_LWLimit ', id_sname)
!
    nq_max = 0
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta ); 
! --
    if ( mype==0 ) Mat_Chi0 = 0.0d0
! -------------------------------- main -------------
    Do i=1, nmax_G_LR
!       write(*,*) ' i = ', i
       Do j=1, nmax_G_LR
           
          Do ispin=1, nspin
             ztmp = 0.0d0

             Do k=1, k_max
                ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
                ik2 = ik1 + nspin
                ik3 =  nspin*(k-1) + ispin 
                !
                weight = qwgt_ek(ik1) *nspin

                Do ib1=band_start_LR, band_end_LR           ! unoccpuied state
                   occ1 = Occup_lkt_ek( ib1, ik1 );  
                   if ( occ1 > DELTA ) cycle
                     
                   Do ib2=band_start_LR, band_end_LR          ! occupied state
                      occ2 = Occup_lkt_ek( ib2, ik1 )  
                      if ( occ2 < DELTA ) cycle

                      if ( map_e(ib2) /= myrank_e ) cycle

                      call summation_ztmp
                   End do
                End do
             End do
             call add_ztmp_to_Chi0
          End do
       End do
    End do
! --------------------------------- end -------------
    if ( mype == 0 ) then
       if ( nspin==1 ) Mat_Chi0 = Mat_Chi0 *2.0d0
    endif
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine summation_ztmp
      integer :: jb2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      jb2 = map_z(ib2)

      ebi = Eko_ek( ib1,ik1 ); ebj = Eko_ek( ib2,ik1 )
      ediff = ebi - ebj + scissor

      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2
!
      z1 = RhoTilde( i, ib1,jb2, ik3 );  z2 = RhoTilde( j, ib1,jb2, ik3 )
!                      c1 = occ1 - occ2
      c1 = ( 1.0D0 - occ1 ) *occ2
      ztmp = ztmp + c1 *conjg( z1 )* z2 *gfn *weight
    end subroutine summation_ztmp

    subroutine add_ztmp_to_Chi0
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         ztmp = zsum
      endif
      if ( mype == 0 ) Mat_Chi0( i,j,ispin ) = ztmp / univol
    end subroutine add_ztmp_to_Chi0

  end subroutine Calc_Chi0_LWLimit

!------------------------------------------------------------------
!!
!!!            Calc Total Charge for DEBUG
!!
!-------------------------------------------------------------------
  subroutine Check_Total_Charge
    real(kind=DP)         :: occ1
    complex(kind=CMPLDP)  :: ztmp, z1

    integer               :: i,j, k, ispin
    integer               :: ik1, ik2, ik3
    integer               :: ib1, jb1
    integer               :: k_max, nq_max

    integer :: id_sname = -1
! ----------------------- start ----------------
    call set_value_nqmax
    call set_value_kmax
! ------------------------------ main ----------
    Do i=1, nmax_G_LR
       ztmp = 0.0d0
            
       Do ispin=1, nspin
          Do k=1, k_max
             ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
             ik2 = ik1 + nspin
             ik3 =  nspin*(k-1) + ispin 
             !
             Do ib1=1, neg           ! occpuied state
                occ1 = Occup_lkt_ek( ib1, ik1 );  
                if ( occ1 < 0.5 ) cycle
                
                if ( map_e(ib1) /= myrank_e ) cycle
                jb1 = map_z(ib1)

                z1 = RhoTilde( i, ib1, jb1, ik3 )
                ztmp = ztmp + occ1 * z1 *qwgt_ek(ik1) 
             End do
          End do
       End do
       if ( i==1 ) call print_total_charge
    End do

  contains

    subroutine set_value_nqmax
      if ( sw_LongWaveLimit==ON ) then
         nq_max = 0
      else
         nq_max = Num_Q_Points
      endif
    end subroutine set_value_nqmax

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax
    
    subroutine print_total_charge
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 1, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         ztmp = zsum
      endif
      write(*,*) 'Charge i ', i, ztmp / univol, ztmp
    end subroutine print_total_charge

  end subroutine Check_Total_Charge

end module m_LinearResponse_NonInt

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: gettod(x), dummy
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: miscellaneous.F90 570 2017-04-21 20:34:50Z yamasaki $
#ifndef VPP
#ifdef _USE_DATE_AND_TIME_
subroutine gettod(x)
  use m_Const_Parameters, only :DP
  real(kind=DP), parameter   :: milisec     = 1.d3
  real(kind=DP), parameter   :: t_mil2micro = 1.d3
  real(kind=DP), intent(out) :: x

  integer ipresent_time(8)
  real(kind=DP)       :: tstart
  real(kind=DP), save ::tstart0 = 0.d0
  data istart/0/
  data tstart/0.0/
  ! Month   1   2   3   4   5   6   7   8   9  10  11  12
  ! days   31  28  31  30  31  30  31  31  30  31  30  31
  !sumdays 31  59  90 120 151 181 212 243 273 304 334 365
  integer, dimension(12) :: sdays
  integer, parameter     :: days_to_1970 = 719460
  data sdays/0, 31, 59, 90,120,151,181,212,243,273,304,334/
  integer  :: days_from_January_1st, month, year, day, days_from_1970_to_this_year

  call date_and_time(values=ipresent_time)
  year = ipresent_time(1); month = ipresent_time(2); day = ipresent_time(3)
!!$  days_from_1970_to_this_year = year*365 + year/4 - year/100 + year/400 - days_to_1970
  days_from_January_1st = sdays(month) + day - 1
  if(month >= 3 .and. mod(year,4) == 0) &
       & days_from_January_1st = days_from_January_1st + 1
!!$  tstart =(((days_from_1970_to_this_year + days_from_January_1st*24 & !hours
  tstart =(((days_from_January_1st*24 & !hours
       & + ipresent_time(5))*60 &             !minutes
       & + ipresent_time(6))*60 &             !seconds
       & + ipresent_time(7))*milisec  &       !mili-seconds
       & + ipresent_time(8)
!!$  if(istart <= 3) then
!!$     write(6,'(" total_days_from_January_1st = ",i10)') total_days_from_January_1st
!!$     write(6,'(" ipresent_time(1-3) = ",3i10)') ipresent_time(1),ipresent_time(2),ipresent_time(3)
!!$     write(6,'(" ipresent_time(4-6) = ",3i10)') ipresent_time(4),ipresent_time(5),ipresent_time(6)
!!$     write(6,'(" ipresent_time(7-8) = ",3i10)') ipresent_time(7),ipresent_time(8)
!!$  end if

  if(istart.eq.0) tstart0 = tstart

  istart = istart + 1
  x = (tstart - tstart0)*t_mil2micro
  return
end subroutine gettod
#else
subroutine gettod(x)
  use m_Const_Parameters, only :DP
  real(kind=DP), intent(out) :: x
  integer :: count, count_rate, count_max
  integer, save :: count_prev = -1
  integer, save :: initialized = 0
  integer, save :: istart = 0
  real (kind=DP)       :: tstart
  real (kind=DP), save :: tstart0  = 0.d0
!------------------------------------------------------------------------
  character(len= 8) :: cdate
  character(len=10) :: ctime
  integer :: idate
  real(kind=DP)       :: rtime
  real(kind=DP), save :: rtime_prev = 0
  call date_and_time(date = cdate, time = ctime)
  read(cdate, '(i8)') idate
  read(ctime, '(f10.3)') rtime
  rtime = (idate - 20000000) * 1.d6 + rtime
!------------------------------------------------------------------------
  call system_clock(count, count_rate, count_max)
  if(count_prev > count) then
     if(rtime > rtime_prev) then
        initialized = initialized + 1
!        write(6,*) 'DEBUG:', count
     else
        write(6,*) 'Caution!  : Clock tamperring is detected'
        write(6,*) 'DEBUG:', count
     endif
  endif
  tstart = (count+initialized*real(count_max, kind = DP))/count_rate
!!$  if(istart <= 2) then
!!$     if(istart <= 1) write(6,'(" !@ -- system_clock check --")')
!!$     write(6,'(" !@ count, count_rate, count_max = ",3i12)') count, count_rate, count_max
!!$     write(6,'(" !@ tstart = ",d20.12)') tstart
!!$  end if
  if(istart == 0) tstart0 = tstart
  istart = istart + 1
  x  = (tstart-tstart0)*1.d6
  count_prev = count
  rtime_prev = rtime
  return
end subroutine gettod
#endif
#else
subroutine dummy
end subroutine dummy
#endif

#ifdef CRAY
function derf(x)
  implicit real*8(a-h,o-z)
  derf = erf(x)
  return
end function derf

function derfc(x)
  implicit real*8(a-h,o-z)
  derfc = erfc(x)
  return
end function derfc

#elif Linux

#ifdef _RPL_ERF_

function derf(x) result(y)
implicit none

real(kind=8) :: y
real(kind=8), intent(in) :: x

! local variables
real(kind=8), parameter :: pi   = 3.14159265358979323846d0 ! PI
real(kind=8), parameter :: pi4  = 4.d0*pi                  ! 4*PI                    
real(kind=8), parameter :: ipi  = 0.31830988618379067153d0 ! 1/PI
real(kind=8), parameter :: sipi = 0.56418958354775628694d0 ! 1/sqrt(PI)
real(kind=8), parameter :: sipi2 = 2.d0*sipi               ! 2/sqrt(PI)
real(kind=8) :: z

z = abs(x)
if(z <= 0.1d0) then
  y = derf1(z)
else if(z < 6) then
  y = derf2(z)
else if(z <= 100) then
  y = derf3(z)
else
!  y = derf4(z)
  y = 1.d0
end if

if(x < 0.d0) y = -y

return

contains
  ! for 0 <= x <= 0.1 
  function derf1(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: c1 = -1.d0/3.d0
  real(kind=8), parameter :: c2 =  0.1d0
  real(kind=8), parameter :: c3 = -1.d0/42.d0
  real(kind=8), parameter :: c4 =  1.d0/216.d0
  real(kind=8), parameter :: c5 = -1.d0/1320.d0
  real(kind=8) :: x2
  real(kind=8) :: z1,z2,z3,z4,z5
 
  x2 = x*x

  z1 = x2*x
  z2 = z1*x2
  z3 = z2*x2
  z4 = z3*x2
  z5 = z4*x2

  y = sipi2*( x + c1*z1 + c2*z2 + c3*z3 + c4*z4 + c5*z5 )

  return
  end function derf1

  ! for 0.1 <= x <= 6
  function derf2(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  y = derf3(x) + 2.d0/(exp(pi4*x)-1.d0)

  return
  end function derf2

  ! for 6 < x <= 100
  function derf3(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: h(13) = (/ 0.25d0, 1.d0, 2.25d0, 4.d0, 6.25d0, 9.d0, 12.25d0, 16.d0, &
                           & 20.25d0, 25.d0, 30.25d0, 36.d0, 42.25d0 /)
  real(kind=8), parameter :: e(13) = (/ 0.7788007830714049d0, &
                           & 0.3678794411714423d0, &
                           & 0.1053992245618643d0, &
                           & 0.1831563888873418d-1, &
                           & 0.1930454136227709d-2, &
                           & 0.1234098040866796d-3, &
                           & 0.4785117392129009d-5, &
                           & 0.1125351747192591d-6, &
                           & 0.1605228055185612d-8, &
                           & 0.1388794386496402d-10, &
                           & 0.7287724095819693d-13, &
                           & 0.2319522830243569d-15, & 
                           & 0.4477732441718302d-18 /)
  real(kind=8) :: x2

  x2 = x*x
  
  y = sum(e(1:13)/(h(1:13)+x2))
  y = ipi*exp(-x2)*(0.5d0/x+x*y)
  y = 1-y

  return
  end function derf3

  ! for 100 < x
  function derf4(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: c1 = -0.5d0
  real(kind=8), parameter :: c2 =  3.d0/4.d0
  real(kind=8), parameter :: c3 = -15.d0/8.d0
  real(kind=8), parameter :: c4 =  105.d0/16.d0
  real(kind=8), parameter :: c5 = -945.d0/32.d0
  real(kind=8) :: x2,xi
  real(kind=8) :: z1,z2,z3,z4,z5

  x2 = x*x
  xi = 1.d0/x
  
  z1 = xi*xi
  z2 = z1*z1
  z3 = z2*z1
  z4 = z3*z1
  z5 = z4*z1
  
  y = sipi*exp(-x2)*xi*( 1.d0 + c1*z1 + c2*z2 + c3*z3 + c4*z4 + c5*z5 )
  y = 1-y

  return
  end function derf4

end function derf
function derfc(x) result(y)
implicit none

real(kind=8) :: y
real(kind=8), intent(in) :: x

! local variables
real(kind=8), parameter :: pi   = 3.14159265358979323846d0 ! PI
real(kind=8), parameter :: pi4  = 4.d0*pi                  ! 4*PI                    
real(kind=8), parameter :: ipi  = 0.31830988618379067153d0 ! 1/PI
real(kind=8), parameter :: sipi = 0.56418958354775628694d0 ! 1/sqrt(PI)
real(kind=8), parameter :: sipi2 = 2.d0*sipi               ! 2/sqrt(PI)
real(kind=8) :: z

z = abs(x)
if(z <= 0.1d0) then
  y = derfc1(z)
else if(z < 6) then
  y = derfc2(z)
else if(z <= 100) then
  y = derfc3(z)
else
  !y = derfc4(z)
  y = 0.d0
end if

if(x < 0.d0) y = 2.d0-y

return

contains
  ! for 0 <= x <= 0.1 
  function derfc1(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: c1 = -1.d0/3.d0
  real(kind=8), parameter :: c2 =  0.1d0
  real(kind=8), parameter :: c3 = -1.d0/42.d0
  real(kind=8), parameter :: c4 =  1.d0/216.d0
  real(kind=8), parameter :: c5 = -1.d0/1320.d0
  real(kind=8) :: x2
  real(kind=8) :: z1,z2,z3,z4,z5
 
  x2 = x*x

  z1 = x2*x
  z2 = z1*x2
  z3 = z2*x2
  z4 = z3*x2
  z5 = z4*x2

  y = sipi2*( x + c1*z1 + c2*z2 + c3*z3 + c4*z4 + c5*z5 )
  y = 1-y

  return
  end function derfc1

  ! for 0.1 <= x <= 6
  function derfc2(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  y = derfc3(x) - 2.d0/(exp(pi4*x)-1.d0)

  return
  end function derfc2

  ! for 6 < x <= 100
  function derfc3(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: h(13) = (/ 0.25d0, 1.d0, 2.25d0, 4.d0, 6.25d0, 9.d0, 12.25d0, 16.d0, &
                           & 20.25d0, 25.d0, 30.25d0, 36.d0, 42.25d0 /)
  real(kind=8), parameter :: e(13) = (/ 0.7788007830714049d0, &
                           & 0.3678794411714423d0, &
                           & 0.1053992245618643d0, &
                           & 0.1831563888873418d-1, &
                           & 0.1930454136227709d-2, &
                           & 0.1234098040866796d-3, &
                           & 0.4785117392129009d-5, &
                           & 0.1125351747192591d-6, &
                           & 0.1605228055185612d-8, &
                           & 0.1388794386496402d-10, &
                           & 0.7287724095819693d-13, &
                           & 0.2319522830243569d-15, & 
                           & 0.4477732441718302d-18 /)
  real(kind=8) :: x2

  x2 = x*x
  
  y = sum(e(1:13)/(h(1:13)+x2))
  y = ipi*exp(-x2)*(0.5d0/x+x*y)

  return
  end function derfc3

  ! for 100 < x
  function derfc4(x) result(y)
  implicit none

  real(kind=8) :: y
  real(kind=8), intent(in) :: x

  ! local variables
  real(kind=8), parameter :: c1 = -0.5d0
  real(kind=8), parameter :: c2 =  3.d0/4.d0
  real(kind=8), parameter :: c3 = -15.d0/8.d0
  real(kind=8), parameter :: c4 =  105.d0/16.d0
  real(kind=8), parameter :: c5 = -945.d0/32.d0
  real(kind=8) :: x2,xi
  real(kind=8) :: z1,z2,z3,z4,z5

  x2 = x*x
  xi = 1.d0/x
  
  z1 = xi*xi
  z2 = z1*z1
  z3 = z2*z1
  z4 = z3*z1
  z5 = z4*z1
  
  y = sipi*exp(-x2)*xi*( 1.d0 + c1*z1 + c2*z2 + c3*z3 + c4*z4 + c5*z5 )

  return
  end function derfc4

end function derfc

#endif

#endif

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 574 $)
!
!  SUBROUINE:  fft_box_finding_way, Preparation, Preparation_ek
!
!  AUTHOR(S): T. Yamasaki and H. Mizouchi   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef JRCATFFT_WS
#define _INCLUDE_EXX_
#elif FFTW3
#define _INCLUDE_EXX_
#endif

#ifdef FJ_TIMER
#   define __TIMER_FJ_START_w_BARRIER(str,a)   call mpi_barrier(str,ierr) ;   call timer_sta(a)
#   define __TIMER_FJ_START(a)   call timer_sta(a)
#   define __TIMER_FJ_STOP(a)    call timer_end(a)
#else
#   define __TIMER_FJ_START(a)
#   define __TIMER_FJ_STOP(a)
#endif

subroutine Preparation()
! $Id: Preparation.F90 574 2017-05-31 03:00:48Z jkoga $
  use m_Const_Parameters,  only:DP,FILE,GENERAL,OUTER,INNER,SIMPLE_CUBIC &
       &                       ,HEXAGONAL,TETRAHEDRON &
       &                       ,INITIAL,CONTINUATION,FIXED_CHARGE &
       &                       ,FIXED_CHARGE_CONTINUATION, ON, OFF, GRID &
       &                       ,AUTOMATIC, MANUAL, PREPARATION_ONLY, LDA &
       &                       ,ALL_AT_ONCE, ONE_BY_ONE, DRIVER_NEB &
       &                       ,COORDINATE_CONTINUATION,by_matrix_diagon, MESH &
       &                       ,P_CONTROL, PT_CONTROL &
       &                       ,DRIVER_URAMP,DRIVER_SC_DFT
  use m_Parallelization,   only:mpi_comm_group &
       &                       ,m_Parallel_init_mpi_kngp_3D &
       &                       ,m_Parallel_init_mpi_kngp_B_3D &
!F       &                       ,m_Parallel_init_mpi_kngp &
       &                       ,m_Parallel_init_mpi_cdfft &
       &                       ,m_Parallel_end_mpi,   ierr &
       &                       ,ista_kngp,iend_kngp,mype
  use m_Control_Parameters,only:paramset, ipriparallel, ipri, icond, ekmode &
       &                       ,gmaxs_given,n_matrix_size, sw_positron &
       &                       ,sw_ldos, fixed_charge_k_parallel &
!!$       &                       ,m_CtrlP_set_wct_start &
       &                       ,m_CtrlP_set_kimg &
       &                       ,m_CtrlP_way_of_smearing &
       &                       ,sw_pdos, sw_berry_phase, sw_phonon &
       &                       ,num_projectors, ggacmp_parallel, sw_fef &
       &                       ,sw_wannier, numk_tmp, iconv_ek_tmp, driver &
       &                       ,m_CtrlP_rd_neg_previous &
       &                       ,m_CtrlP_rd_edelta_ontheway &
       &                       ,m_CtrlP_rd_iconvergence &
       &                       ,m_CtrlP_rd_corecharge_cntnbin &
       &                       ,sw_hybrid_functional, m_CntrlP_rst_submat_call_stat &
       &                       ,sw_optimize_lattice,nhistory_stress &
       &                       ,sw_optimize_coordinates_once &
       &                       ,m_CtrlP_reset_iconvergence &
       &                       ,gmaxp, sw_rebuild_pws, way_of_smearing &
       &                       ,m_CtrlP_in_initialization &
       &                       ,m_CtrlP_reset_optmode &
       &                       ,intzaj, imdalg &
       &                       ,sw_communicator_for_chg
  use m_Files,             only:nfinp,nfout,nfkpgn,nfcntn &
       &                       ,m_Files_open_kpoint_files &
       &                       ,m_Files_check_file_names &
       &                       ,m_Files_open_nfldos &
       &                       ,m_Files_close_files_initial0 &
       &                       ,m_Files_open_nfeng &
       &                       ,m_Files_open_nfcntn &
       &                       ,nfdynm
  use m_FFT,               only:m_FFT_set_box_sizes, m_FFT_setup,fft_box_size_CD, m_FFT_reset_firstcall
  use m_PlaneWaveBasisSet, only:n_rGv,n_rGpv,n_rGpv_reduced, n_rGv_pstrn,kgp &
       &                       ,m_pwBS_decide_cutoff_mix &
       &                       ,m_pwBS_assume_G_rhombohedron &
       &                       ,m_pwBS_for_each_WF &
       &                       ,m_pwBS_generate_G_vectors_3D &
       &                       ,m_pwBS_G_trans_functions_3D  &
       &                       ,m_pwBS_alloc_ngpt_igfp_gr_3D &
       &                       ,m_pwBS_calc_length_of_G_3D &
       &                       ,m_pwBS_setup_FFTmapfunctions_3D &
       &                      ,m_pwBS_set_ngabc_kngp_l_3D   &
       &                      ,pre_charge_average_3D &
       &                       ,m_pwBS_positronWF &
       &                       ,m_pwBS_cp_iba_to_iba_ek &
       &                       ,m_pwBS_rebuild_gr_l, ngabc
  use m_Crystal_Structure, only:nbztyp, inversion_symmetry &
       &                       ,nbztyp_spg &
       &                       ,symmetry_method &
       &                       ,univol,altv,rltv, &
       &                           check_if_sw_inversion_is_valid &
       &                       ,m_CS_gnrt_symmetry_operations &
       &                       ,m_CS_gnrt_symm_operators_tl &
       &                       ,m_CS_alloc_op_tau &
       &                       ,m_CS_alloc_op_tau_tl &
       &                       ,symmetry_method &
       &                       ,m_CS_set_altv_prim, m_CS_set_altv_super &
       &                       ,m_CS_supercell &
       &                       ,m_CS_rd_fix_spin_status,altv &
       &                       ,m_CS_wd_op_and_tau 

  use m_CS_SpaceGroup,     only:m_CS_SG_auto_gnrt_sym_op &
       &                       ,m_CS_SG_print_space_group_name
  use m_Ionic_System,      only:m_IS_alloc_napt,m_IS_symm_check_of_pos &
       &                       ,m_IS_phonon_initial_disp &
       &                       ,m_IS_phonon_initialization &
       &                       ,m_IS_phonon_set_displacement &
       &                       ,m_IS_set_napt_super, m_IS_supercell &
       &                       ,m_IS_inv_sym_off &
       &                       ,m_IS_symmetrize_atom_pos &
       &                       ,m_IS_rd_pos_and_v &
       &                       ,m_IS_natm_can_change &
       &                       ,m_IS_change_natm &
       &                       ,m_IS_wd_speciesname_etc &
       &                       ,m_IS_get_neg_incre,natm,cpd_l &
       &                       ,m_IS_gdiis_reset &
       &                       ,m_IS_CG_reset &
       &                       ,m_IS_freeze &
       &                       ,m_IS_gnrt_supercell_symmetry &
       &                       ,natm,ityp,iatomn,ntyp &
       &                       ,natm,ityp,iatomn,ntyp &
       &                       ,m_IS_reset_extrpl_status
  use m_PseudoPotential,   only:m_PP_input_xctype,ival,m_PP_renew_etot1
  use m_Kpoints,           only:way_ksample &
       &                       ,m_Kp_gnrt_or_rd_k_points &
       &                       ,m_Kp_alloc_kpoints &
       &                       ,m_Kp_cr_kpoints_table &
       &                       ,m_Kp_alloc_kpoints_ek &
       &                       ,m_Kp_cp_vkxyz_to_vkxyz_ek &
       &                       ,m_Kp_realloc_kpoints &
       &                       ,m_Kp_set_mesh_super &
       &                       ,m_Kp_set_ek_group, m_Kp_realloc_kpoints2
  use m_Ldos,              only:m_Ldos_preparation
  use m_BerryPhase,        only:m_BP_gen_Kpoints
  use m_Orbital_Population,only: m_OP_alloc
  use m_Phonon,            only:m_Phonon_alloc_qvec, m_Phonon_set_qvec
  use m_Electronic_Structure,only:m_ES_set_num_bands_super &
       &                       ,m_ES_cp_iconv, m_ES_add_neg
  use m_Wannier,           only:m_Wan_gen_weight
  use m_FiniteElectricField, only:m_FEF_init
  use m_IterationNumbers, only : m_Iter_rd_iteration_numbers,iteration_unit_cell,m_Iter_cmix_reset&
       &                       ,iteration_uramp,iteration_scdft
#ifdef _INCLUDE_EXX_
  use m_ES_ExactExchange,  only: m_ES_EXX_init
#endif
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
  use m_Control_Parameters, only: m_CtrlP_rd_dtim_previous
! ==============================================================================

  use m_UnitCell, only : m_UC_doit,m_UC_get_univol_old,m_UnitCell_md
  use m_XC_Potential, only : m_XC_rst_npsend
  use m_FFT, only : m_FFT_reset_CD_setup_stat
  use m_CD_mixing, only : m_CD_force_dealloc
  use m_ES_WF_by_RMM, only : m_ESrmm_dealloc_r_norm_flag
  use m_ES_WF_by_submat, only : m_ESsubmat_dealloc


  use m_CD_Mag_Moment,      only : m_CD_alloc_rad_cov, m_CD_set_rad_cov_default, &
       &                           m_CD_set_rad_cov_now, sw_monitor_atomcharge, &
       &                           m_CD_set_sw_monitor_atomcharge, &
       &                           m_CD_set_proj_radius
! ======================================================================== 11.0&13.0U

! ================================= added by K. Tagami =================== 11.0
  use m_Control_Parameters,   only : noncol
  use m_Ionic_System,         only : m_IS_alloc_magmom_local, m_IS_init_magmom_local
  use m_CS_Magnetic,     only : m_CS_set_Magnetic_Sym, m_CS_set_inverse_operation
  use m_Crystal_Structure,   only : sw_use_magnetic_symmetry
!
  use m_CD_Mag_Moment,      only : m_CD_alloc_rad_cov, m_CD_set_rad_cov_default, &
       &                           m_CD_set_rad_cov_now
! ======================================================================== 11.0

  use m_Charge_Density,       only : m_CD_cp_chgq_to_chgqo

  use m_UnitCell,             only : m_UC_rd_cntn_data

#ifdef _INCLUDE_EXX_
! ============== KT_add ======================================= 13.0F
  use m_Control_Parameters,  only : use_fft_exx
  use m_PlaneWaveBasisSet, only : n_rGv_exx, n_rGpv_exx, m_pwBS_exxWF, m_pwBS_exxCD, m_pwBS_store_prev_kg1_kgp
  use m_FFT, only : m_FFT_set_box_size_exx, m_FFT_set_box_size_cd_exx, m_FFT_setup_exx
! ============================================================= 13.0F
#endif

! ==== KT_add ==== 13.1R
  use m_Control_Parameters,  only : sw_keep_symmetry_strict
  use m_Ionic_System, only : m_IS_symmetrize_atom_pos
  use m_Crystal_Structure, only : m_CS_read_op_tau_previous, m_CS_dealloc_op_tau
! ================ 13.1R
! ==== KT_add ==== 13.2S
  use m_Crystal_Structure,  only : sw_spinorbit_force_theorem
! =================13.2S

  use m_ES_WF_by_MatDiagon, only : m_ESmat_set_reduced_basis_mode


  use m_Force,                only : forc_l

  implicit none
  integer :: outer_or_inner
  include 'mpif.h'
  integer :: ggacmp_parallel_rev, xctype_is
  integer :: ne,i
  
  real(kind=DP), dimension(3,3) :: stress_tensor
  logical :: ini,initialization_required

  ini = initialization_required()
  if(ini) then
  call m_Files_check_file_names()
!!$  call m_CtrlP_set_wct_start       ! (ckcput)

  if(ekmode /= GRID .and. sw_phonon == OFF) then
     ! setup supercell
     call m_CS_supercell(nfout)
     call m_IS_supercell(nfout)
  end if
  if (m_IS_natm_can_change())then
     if(m_IS_change_natm()) then
        call m_IS_wd_speciesname_etc(nfdynm)
        ne = m_IS_get_neg_incre()
        call m_ES_add_neg(ne)
     endif
  endif
  endif

  if ((((sw_optimize_lattice==ON .or. imdalg == P_CONTROL .or. imdalg == PT_CONTROL) &
       & .and. iteration_unit_cell>1) .or.  &
       & ((driver == DRIVER_URAMP)  .and. (iteration_uramp>1)) .or.  &
       & ((driver == DRIVER_SC_DFT) .and. (iteration_scdft>1)))      &
       & .and. &
       & .not.(icond==CONTINUATION.and.m_CtrlP_in_initialization()))then
     if(ini)then
        call m_XC_rst_npsend()
        call m_FFT_reset_CD_setup_stat()
        call m_CD_force_dealloc()
        call m_ESrmm_dealloc_r_norm_flag()
        call m_ESsubmat_dealloc()
        call m_pwBS_store_prev_kg1_kgp()
        call m_FFT_reset_firstcall()
     endif
     call m_IS_gdiis_reset()
     call m_IS_CG_reset()
     call m_IS_reset_extrpl_status()
     call m_CtrlP_reset_optmode()
     if(sw_optimize_lattice==ON .and. sw_optimize_coordinates_once==ON)then
        call m_IS_freeze()
     endif
     if(sw_optimize_lattice == ON) call m_UC_doit()
     if(imdalg == PT_CONTROL .or. imdalg == P_CONTROL) call m_UnitCell_md(forc_l)
     call m_IS_wd_speciesname_etc(nfdynm)
  endif
!  call m_CntrlP_rst_submat_call_stat()

  if(.not.ini) then
     call m_pwBS_rebuild_gr_l()
     call m_Kp_gnrt_or_rd_k_points(nfinp,preallocation=.true.) !(kstep) -> kv3
!!$     if( m_CtrlP_way_of_smearing() == TETRAHEDRON ) call m_Kp_cr_kpoints_table() 
     if( way_ksample == MESH ) call m_Kp_cr_kpoints_table() 
     if(ipri>=1) write(nfout,'(" !** smearing_method = ",i6)') way_of_smearing

     if(sw_berry_phase == OFF) then
        call m_Kp_alloc_kpoints    ! <- kv3  -> vkxyz, qwgt
     else
        call m_BP_gen_Kpoints(preallocation=.true.) ! -> kv3
     end if
     call m_Kp_alloc_kpoints    ! with using the given value of kv3, allocate vkxyz and qwgt
     if(sw_berry_phase == ON) then
        call m_BP_gen_Kpoints(preallocation=.false.) ! -> vkxyz, qwgt
     end if
     call m_Kp_gnrt_or_rd_k_points(nfinp,preallocation=.false.) !(kstep) -> kv3
     if(symmetry_method == AUTOMATIC) then
        call m_CS_SG_auto_gnrt_sym_op(paramset,nfout) ! paramset == .false.
        call m_IS_symmetrize_atom_pos(nfout) ! -> cps,pos
     else
        call m_CS_gnrt_symmetry_operations(paramset,nfout) ! paramset == .false.
        call m_CS_gnrt_symm_operators_tl(paramset,nfout) ! -(m_Crystal_Structure) -> op_tl, tau_tl
     end if

     if ( sw_phonon == OFF ) call m_IS_gnrt_supercell_symmetry(paramset,nfout)

     return
  endif

! === KT_add ==== 13.1R
  if (sw_optimize_lattice==ON.and.iteration_unit_cell>1.and. &
  &    .not.(icond==CONTINUATION.and.m_CtrlP_in_initialization()))then
     if (  sw_keep_symmetry_strict == ON ) then
        call m_CS_read_op_tau_previous
        call m_IS_symmetrize_atom_pos(nfout)
        call m_CS_dealloc_op_tau
     endif
  endif
! =============== 13.1R

! ============================== added by K. Tagami ===================== 11.0&13.0U
  if ( noncol .or. sw_spinorbit_force_theorem == ON ) then
     call m_IS_alloc_magmom_local
     call m_IS_init_magmom_local
  endif
!
  call m_CD_set_sw_monitor_atomcharge
  if ( sw_monitor_atomcharge == ON ) then
     call m_CD_alloc_rad_cov
     call m_CD_set_rad_cov_default
     call m_CD_set_rad_cov_now
  endif
! ======================================================================== 11.0&13.0U

  if(symmetry_method == AUTOMATIC) then
     call m_CS_SG_auto_gnrt_sym_op(.true.,nfout) ! -(m_CS_SpaceGroup) -> nopr,af
  else
                                                     __TIMER_FJ_START(31)
     call m_CS_gnrt_symmetry_operations(.true.,nfout) ! -(m_Crystal_Structure) -> nopr,af
!!$     call m_CS_gnrt_symm_operators_tl(.true.,nfout) ! -(m_Crystal_Structure) -> nopr,af
                                                     __TIMER_FJ_STOP(31)
  end if
  call m_CS_alloc_op_tau(nfout)
  call m_CS_alloc_op_tau_tl(nfout)
  if(symmetry_method == AUTOMATIC) then
     call m_CS_SG_auto_gnrt_sym_op(paramset,nfout) ! paramset == .false.
     call m_IS_symmetrize_atom_pos(nfout) ! -> cps,pos
  else
                                                     __TIMER_FJ_START(31)
     call m_CS_gnrt_symmetry_operations(paramset,nfout) ! paramset == .false.
     call m_CS_gnrt_symm_operators_tl(paramset,nfout) ! -(m_Crystal_Structure) -> nopr,af
                                                     __TIMER_FJ_STOP(31)
  end if

  call m_CS_SG_print_space_group_name(nfout)

! ============================== added by K. Tagami ===================== 11.0Ex
!  if ( noncol .and. symmetry_method /= AUTOMATIC &
!       &      .and. sw_use_magnetic_symmetry == ON ) then
!     call m_CS_set_Magnetic_Sym
!  endif
  if ( noncol ) then
     if ( sw_use_magnetic_symmetry == ON ) then
        call m_CS_set_Magnetic_Sym
     endif
     call m_CS_set_inverse_operation
  else
     call m_CS_set_Magnetic_Sym
  endif
! ======================================================================== 11.0Ex

! ============================== added by K. Tagami ===================== 12.0YAM
!  commented by T. Yamasaki 2012/12/06
!!$  call check_if_sw_inversion_is_valid( nfout )
! ======================================================================= 12.0YAM

  if(ekmode /= GRID .and. sw_phonon == ON) then
     call m_IS_inv_sym_off(nfout) ! -> inversion_symmetry
  end if
  call m_IS_alloc_napt()
                                                     __TIMER_FJ_START(31)
  call m_CS_wd_op_and_tau(nfout)
  call m_IS_symm_check_of_pos()
                                                     __TIMER_FJ_STOP(31)

  if(ekmode /= GRID .and. sw_phonon == ON) then
     call m_Phonon_alloc_qvec()
     call m_Phonon_set_qvec(nfout)
     call m_CS_supercell(nfout)
     call m_IS_supercell(nfout)
     call m_IS_phonon_initialization()
     call m_IS_set_napt_super
     call m_IS_phonon_initial_disp()
     call m_ES_set_num_bands_super
     call m_Kp_set_mesh_super
     if(driver .ne. DRIVER_NEB .and. icond == CONTINUATION) then
        call m_Files_open_nfcntn()
        call m_Iter_rd_iteration_numbers(nfcntn,icond)
	call m_IS_phonon_set_displacement()  ! asms
        call m_IS_rd_pos_and_v(nfcntn)
#ifndef _EMPIRICAL_
        call m_CtrlP_rd_neg_previous(nfcntn)
        call m_CtrlP_rd_edelta_ontheway(nfcntn)
#endif
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
        call m_CtrlP_rd_dtim_previous(nfcntn)
! ==============================================================================
        call m_CtrlP_rd_iconvergence(nfcntn)
        call m_CtrlP_rd_corecharge_cntnbin(nfcntn) ! -> status_cntnbin_positron
        call m_CS_rd_fix_spin_status(nfcntn,nfout)  ! <-- T. Yamasaki, 18th Aug. 2009
     end if
  end if

  call m_CtrlP_set_kimg(inversion_symmetry) ! ->kimg

  call m_pwBS_assume_G_rhombohedron() ! ->n_rGv,n_rGpv, n_rGv_pstrn
  call fft_box_finding_way(outer_or_inner)     ! -(contained here)
!!$  call m_FFT_set_box_sizes(n_rGv,n_rGpv,n_rGv_pstrn,outer_or_inner) ! ->fft_box_size_WF,CD
  call m_FFT_set_box_sizes(n_rGv,n_rGpv_reduced,n_rGv_pstrn,outer_or_inner) ! ->fft_box_size_WF,CD

#ifdef _INCLUDE_EXX_
! ================ KT_add ==================================== 13.0F
  if ( sw_hybrid_functional == ON .and. use_fft_exx ) then
     call m_FFT_set_box_size_exx( n_rGv_exx,outer_or_inner) ! ->fft_box_size_exx
  endif
  if(sw_hybrid_functional == ON ) call m_FFT_set_box_size_cd_exx( n_rGpv_exx, outer_or_inner)
! ============================================================ 13.0F
#endif

                                                     __TIMER_FJ_START(41)
  call m_pwBS_generate_G_vectors_3D()    ! ->n_rGv,n_rGpv ->kgp
                                                     __TIMER_FJ_STOP(41)
  call m_Parallel_init_mpi_kngp_3D(nfout,ipriparallel,kgp,sw_communicator_for_chg==ON)  ! -(m_Parallelization) ->ista_kngp,iend_kngp
  call m_pwBS_set_ngabc_kngp_l_3D

!!$  if(ipri>=1) write(nfout,'(" nbztyp (nbztyp_spg) = ", i3)') nbztyp_spg
  if(ekmode /= GRID .and. (nbztyp_spg >= GENERAL .or. way_ksample == FILE)) &
       & call m_Files_open_kpoint_files(way_ksample,nbztyp_spg)  

  call m_pwBS_alloc_ngpt_igfp_gr_3D()
                                                     __TIMER_FJ_START(28)
  call m_pwBS_calc_length_of_G_3D()         ! -> gr_l
                                                     __TIMER_FJ_STOP(28)
  call m_pwBS_G_trans_functions_3D()   ! -> ngpt_l: Set of G-vectors translated according to symmetry operations

  ggacmp_parallel_rev = ggacmp_parallel
  call m_PP_input_xctype(xctype_is) ; if(xctype_is == LDA) ggacmp_parallel_rev = OFF
!!$  if(ipri >= 1) write(nfout,'(" ggacmp_parallel_rev = ",i3)') ggacmp_parallel_rev
  call m_Parallel_init_mpi_cdfft(nfout,ipriparallel,ggacmp_parallel_rev)
                          ! -> nrank_ggacmp, npes_cdfft, and nrest_cdfft
  call m_FFT_setup(inversion_symmetry,paramset) ! paramset == .false.

#ifdef _INCLUDE_EXX_
#ifdef FFTW3
! ================ KT_add =================================== 13.0F
  if ( sw_hybrid_functional == ON .and. use_fft_exx ) then
     call m_FFT_setup_exx( inversion_symmetry,paramset ) ! paramset == .false.
  endif
! =========================================================== 13.0F
#endif
#endif

  call m_pwBS_setup_FFTmapfunctions_3D()

  if(num_projectors>0) call m_OP_alloc()

  if(ekmode /= GRID) then
     call m_Kp_gnrt_or_rd_k_points(nfinp,preallocation=.true.) !(kstep) -> kv3
!!$     if( m_CtrlP_way_of_smearing() == TETRAHEDRON ) call m_Kp_cr_kpoints_table() 
     if( way_ksample == MESH ) call m_Kp_cr_kpoints_table() 
     if(sw_berry_phase == OFF) then
        call m_Kp_alloc_kpoints    ! <- kv3  -> vkxyz, qwgt
     else
        call m_BP_gen_Kpoints(preallocation=.true.) ! -> kv3
     end if
     call m_Kp_alloc_kpoints    ! with using the given value of kv3, allocate vkxyz and qwgt
     if(sw_berry_phase == ON) then
        call m_BP_gen_Kpoints(preallocation=.false.) ! -> vkxyz, qwgt
     end if
     call m_Kp_gnrt_or_rd_k_points(nfinp,preallocation=.false.) ! -> vkxyz, qwgt (,tk_initial)

     if(icond == PREPARATION_ONLY .or. icond == INITIAL .or. icond == CONTINUATION .or. &
        & icond==COORDINATE_CONTINUATION) then
                                                     __TIMER_FJ_START(28)
        call m_pwBS_for_each_WF(preallocation=paramset) ! -> kg1, nbase,iba (when paramset==.false.)
                                                     __TIMER_FJ_STOP(28)
     else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
!!$        if(ekmode == OFF)&
!!$             & stop ' ! combination of ekmode and icond is illegal (Preparation)'
        call m_Files_close_files_initial0()
        call m_Files_open_nfeng(icond)
        if(ekmode == OFF .and. fixed_charge_k_parallel == ALL_AT_ONCE) then
                                                     __TIMER_FJ_START(28)
           call m_pwBS_for_each_WF(preallocation=paramset) ! -> kg1, nbase,iba (when paramset==.false.)
                                                     __TIMER_FJ_STOP(28)
        else 
                                                     __TIMER_FJ_START(28)
           call m_pwBS_for_each_WF(preallocation=.true.) ! -> kg1, iba
                                                     __TIMER_FJ_STOP(28)
           call m_Kp_alloc_kpoints_ek()  ! -> kv3_ek (=kv3), allocate(vkxyz_ek,qwgt_ek)
           call m_Kp_cp_vkxyz_to_vkxyz_ek()
           if(fixed_charge_k_parallel == ONE_BY_ONE) then
              call m_Kp_set_ek_group()
              call m_Kp_realloc_kpoints2()
           else
              call m_Kp_realloc_kpoints() 
           end if
           call m_pwBS_cp_iba_to_iba_ek()
           if(icond == FIXED_CHARGE_CONTINUATION) &
                & call m_ES_cp_iconv(numk_tmp,iconv_ek_tmp)
                                                     __TIMER_FJ_START(28)
           call m_pwBS_for_each_WF(preallocation=.false.) ! -> kg1, iba
                                                     __TIMER_FJ_STOP(28)
        end if
     else
        stop ' icond is illegal (Preparation)'
     end if
     call m_pwBS_decide_cutoff_mix()    ! ->kgpm

     if(sw_positron /= OFF) call m_pwBS_positronWF()

#ifdef _INCLUDE_EXX_
! ============= KT_add ============================= 13.0F
     if (sw_hybrid_functional == ON .and. use_fft_exx ) then
        call m_pwBS_exxWF()
        call m_pwBS_exxCD()
     endif
! ========== ======================================= 13.0F
     if(ipri>=1) write(nfout,'(" _INCLUDE_EXX_ is defined")')
#else
     if(ipri>=1) write(nfout,'(" _INCLUDE_EXX_ is not defined")')
#endif

     if(sw_ldos == ON) then
        call m_Ldos_preparation()
        call m_Files_open_nfldos()
     end if
    
     if(sw_wannier == ON) then
        call m_Wan_gen_weight(nfout)
     end if

     if(sw_fef == ON) call m_FEF_init(nfout)

#ifdef _INCLUDE_EXX_
     if(sw_hybrid_functional == ON) call m_ES_EXX_init()
#endif
  end if

  if(icond == PREPARATION_ONLY) then
     call mpi_barrier(mpi_comm_group,ierr)
     call m_Parallel_end_mpi()
     stop 'The preparation has been done.'
  end if
  call pre_charge_average_3D

  if(sw_optimize_lattice==ON.and.icond==CONTINUATION.and.sw_rebuild_pws==OFF) then
     call m_Files_open_nfcntn()
     call m_UC_rd_cntn_data(nfcntn)
  endif


  if ( sw_phonon == OFF ) call m_IS_gnrt_supercell_symmetry(paramset,nfout)

  call m_Iter_cmix_reset()

contains
  subroutine fft_box_finding_way(outer_or_inner)
    integer,intent(out)::  outer_or_inner
    if( nbztyp == GENERAL &
         & .or.(nbztyp >= 30 .and. nbztyp <= 32) &
         & .or.(nbztyp >= SIMPLE_CUBIC  .and. nbztyp <= HEXAGONAL)) then
       outer_or_inner = OUTER
    else
       outer_or_inner = INNER
    endif
  end subroutine fft_box_finding_way

end subroutine Preparation

subroutine Preparation_ek()
  use m_IterationNumbers, only : nk_in_the_process
  use m_PlaneWaveBasisSet,only : m_pwBS_for_each_WF, m_pwBS_cp_iba_ek_to_iba
  use m_Kpoints,          only : m_Kp_cp_vkxyz_ek_to_vkxyz

  call m_Kp_cp_vkxyz_ek_to_vkxyz(nk_in_the_process) !(kreset)
  call m_pwBS_cp_iba_ek_to_iba(nk_in_the_process)
  call m_pwBS_for_each_WF(preallocation=.false.)     !(basnum) ->(nbase)
end subroutine Preparation_ek

subroutine Preparation_grid(nk,kxyz)
  use m_Const_Parameters,only :   DP, GRID
  use m_Control_Parameters,only : ekmode 
  use m_Kpoints, only :           m_Kp_set_kv3 &
       &                        , m_Kp_alloc_kpoints &
       &                        , m_Kp_realloc_kpoints &
       &                        , m_Kp_cp_kxyz_to_vkxyz
  use m_PlaneWaveBasisSet, only : m_pwBS_for_each_WF &
       &                        , m_pwBS_increase_kg1
  implicit none
  integer, intent(in) :: nk
  real(kind=DP), dimension(3), intent(in) :: kxyz

  if(ekmode /= GRID)&
       & stop ' ! combination of ekmode and icond is illegal (Preparation_grid)'

  call m_Kp_set_kv3(nk)
  call m_Kp_alloc_kpoints()
  call m_Kp_cp_kxyz_to_vkxyz(nk,kxyz) ! kxyz -> vkxyz

  call m_pwBS_for_each_WF(preallocation=.true.) ! -> kg1
  call m_pwBS_increase_kg1(30)

  call m_Kp_realloc_kpoints()

end subroutine Preparation_grid

subroutine Preparation_ek_grid2(kxyz)
  use m_Const_Parameters, only : DP
  use m_PlaneWaveBasisSet,only : m_pwBS_for_each_WF
  use m_Kpoints,          only : m_Kp_cp_kxyz_to_vkxyz
  real(kind=DP),intent(in),dimension(3):: kxyz

  call m_Kp_cp_kxyz_to_vkxyz(1,kxyz)
  call m_pwBS_for_each_WF(preallocation=.false.)
end subroutine Preparation_ek_grid2

!================================================
!  Software name : STM
!  Subroutine(s) : Preparation
!  Author(s)     : Takahiro Yamasaki (June 7, 2004)
!
!  Contact address :  IIS,The University of Tokyo RSS21 project
!  
!  "Multiscale Simulation System for Function Analysis of Nanomaterials"  
!
!================================================
!
!     The original version of this program "STM" was developed in the
!  period 1998-2001 at JRCAT by Koichi Kato (Toshiba Corporate
!  Research and Development Center) and Takahiro Yamasaki (Fujitsu 
!  Laboratories Ltd.) through a joint research between JRCAT and
!  Toshiba Corporate Research and Development Center and another joint
!  research between JRCAT and FUJITSU Laboratories Ltd.
!     Since 2003, this program has been tuned and revised as it
!  matches to the first-principles molecular dynamics program "PHASE"
!  as a part of the national project "Frontier Simulation Software for
!  Industrial Science (FSIS)", which is supported by the IT program of
!  the Ministry of Education, Culture, Sports, Science and Technology
!  (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.

subroutine Preparation
! $Id: Preparation.f90,v 1.1.1.1 2004/06/26 11:21:36 yamasaki Exp $
  use m_Const_Parameters,   only : ON
  use m_Files,              only : nfout
  use m_Control_Parameters, only : m_CtrlP_set_wct_start
  use m_FFT,  only :               fft_box_size_WF, fft_box_size_CD, fft_box_size_fine &
       &                         , m_FFT_query_inversion_symmetry &
       &                         , m_FFT_setup, m_FFT_set_fft_box_size_fine
  use m_PlaneWaveBasisSet, only  : m_pwBS_set_FFT_mapfunctions

  implicit none
  integer :: inversion_symmetry = ON

  call m_CtrlP_set_wct_start()

  call m_FFT_query_inversion_symmetry(inversion_symmetry) !-(m_FFT)
  call m_FFT_set_fft_box_size_fine
  call m_FFT_setup(nfout,inversion_symmetry)
  call m_pwBS_set_FFT_mapfunctions&
       & (fft_box_size_WF, fft_box_size_CD, fft_box_size_fine)

end subroutine Preparation

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 574 $)
!
!  SUBROUINE: Renewal_of_Potential
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!


subroutine Renewal_of_Potential()
! $Id: Renewal_of_Potential.F90 574 2017-05-31 03:00:48Z jkoga $
  use m_Charge_Density,      only : chgq_l 
  use m_Const_Parameters,    only : Valence_plus_PC_Charge, VXC_AND_EXC &
       &                          , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ON, OFF
  use m_Control_Parameters,  only : nspin, af, kimg, icond, ekmode
  use m_Electronic_Structure,only : vlhxc_l,  vlhxcQ
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm_3D
  use m_ES_LHXC,             only : m_ESlhxc_potential_3D
  use m_ES_Mag_Constraint,    only : m_ES_add_MagConstraintPot_chgql, &
       &                             m_ES_add_MagConstraintPot_hsr
  use m_Files,               only : nfout
  use m_PAW_Hartree,         only : m_PAWH_get_dion_hartree
  use m_PAW_XC_Potential,    only : m_PAW_XC_cal_potential &
                                  , m_PAW_XC_get_dion_vxc &
! === DEBUG to make 3D_Parallel. by tkato 2011/07/18 ===========================
!                                 , m_PAW_XC_cal_potential_sym &
! ==============================================================================
                                  , m_PAW_XC_get_dion_vxc_dbg
  use m_PseudoPotential,     only : m_PP_get_dion_paw,flg_symmtry, flg_paw
  use m_XC_Potential,        only : vxc_l         &
 &                                , m_XC_cal_potential_3D
! === DEBUG by tkato 2011/10/05 ================================================
  use m_PAW_XC_Potential,    only : m_PAW_XC_cal_potential_sphex2
  use m_PAW_ChargeDensity,   only : calcGaussLegendreIntegration &
                                   ,calcSphericalHarmonicsExpansion
!===============================================================================
  use m_Crystal_Structure,   only : sw_magnetic_constraint
  implicit none

  call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l,VXC_AND_EXC)

! === DEBUG by tkato 2011/10/05 ================================================
! if(flg_paw) then
!===============================================================================

! === DEBUG by tkato 2011/10/05 ================================================
!    call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC,flg_symmtry)
  if(calcSphericalHarmonicsExpansion) then
     call m_PAW_XC_cal_potential_sphex2(nfout,VXC_AND_EXC)
  end if
  if(calcGaussLegendreIntegration)then
     call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC,flg_symmtry)
  end if
#ifdef _MEMORY_CONSUMPTION_CHECK_
     call memsize(nfout)
#endif
! ==============================================================================

! === DEBUG by tkato 2011/10/05 ================================================
  if(flg_paw) then
!===============================================================================
     call m_PAW_XC_get_dion_vxc(nfout)
     !call m_PAW_XC_get_dion_vxc_dbg(nfout)

  endif

  call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l) ! (stlhxc) -> vlhxc_l

! ================================ added by K. Tagami ============== 11.0&13.0U
!
  if ( sw_magnetic_constraint == ON .and. ekmode == OFF ) then
     call m_ES_add_MagConstraintPot_chgql
  endif
!
! ================================================================= 11.0&13.0U

  call m_ESiVQ_integrate_VlhxcQlm_3D(nfout) ! (lclchh) -> vlhxcQ

  if(flg_paw)then
     call m_PAWH_get_dion_hartree(nfout)
     call m_PP_get_dion_paw(nfout)
  endif

! ================================ added by K. Tagami ============== 11.0&13.0U
  if ( sw_magnetic_constraint == ON .and. ekmode == OFF ) then
     call m_ES_add_MagConstraintPot_hsr
  endif
! ================================================================= 11.0&13.0U
end subroutine Renewal_of_Potential

!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 565 $)
!
!  MODULE: m_Files
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!  patch 10.1 by K. Tagami @adv    2011/06/18
!
!  patch 10.1 : addition of output file for LinearResponse Spectrum
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Files
!  $Id: m_Files.F90 565 2017-03-29 02:17:06Z jkoga $
!
!  Operations concerning to files as "open", and "close",
!  should be done in this module.
!
  use m_Control_Parameters,only : paramset, ekmode, printable, iprijobstatus,jobstatus_series, ipriparadeb &
       &                        , multiple_replica_mode, icond, ppprinted, fixed_charge_k_parallel &
       &                        , sw_cif_output, imdalg
  use m_Const_Parameters,  only : OLD, NEW_, UNKNOWN, FORMATTED &
       &                        , UNFORMATTED, check_file_name_on &
       &                        , check_file_name_off, DP, ON, GENERAL, FILE &
       &                        , YES, NO, UNIFIED, PARTITIONED, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                        , ON, OFF, INITIAL, ALL_AT_ONCE, ONE_BY_ONE &
       &                        , P_CONTROL, PT_CONTROL
  use m_ErrorMessages,     only : F_POT_FILE_NOT_EXIST, FILE_NOT_EXIST, ERROR_IN_INPUTFILE_OPENING,FILENAMES_FORMAT_ERROR &
       &                        , FILENAMES_FORMAT_ERROR_NEB, FILENAMES_NOT_EXIST,m_EMsg_Warning
  use m_Parallelization, only   : mpi_comm_group,mype,npes,ierr,workdir,sw_wdir &
       &                        , mype_conf,conf_para, nrank_conf

  implicit none
  include 'mpif.h'
  integer istatus(mpi_status_size)

  logical, public ::  file_existance_contfiles = .false.
  logical, public ::  file_existance_3contfiles = .false.
  logical, private :: file_existance_nfcntn = .false.
  logical, private :: file_existance_nfcntn_bin = .false.
  logical, private :: file_existance_nfzaj =  .false.
  logical, private :: file_existance_nfchgt = .false.

  integer, parameter :: min_ext_length_mype = 3

  integer, parameter ::  MAXNSP = 16
  integer  nfinp,nfpot(MAXNSP)&  ! (1 + MAXNSP) files
       & ,nfpkb,nfpd,nfppc,nfstop,nfopgr,nfmatbp,nfkpoint,nfkindex & !8 files
       & ,nfvibrate,nfzak,nf_neord,nfcnst,nfotp,nfdynm,nfenf,nfgpt & !8 files
       & ,nfchgt,nfchgo,nfchgu,nfchgs,nfout,nfcps,nffor,nfcntn &     !8 files
       & ,nfcntn_bin,nfzaj,nfrsp,nfwf1,nfwf2,nfwf3,nfeng,nfvlc &     !8 files
       & ,nfcntn_bin_stm, nfstatus &                                 !2 files
       & ,nfspg,nfkpgn  &                                            !2 files
       & ,nfdos, nfchr, nfelf, nfegrid, nfldos &                     !5 files
       & ,nfberry,nfeffchg,nfforce,nfmode,nfepsilon &                !5 files
       & ,nfepsout,nfphdos,nfoccmat,nfwfk,nfstrfrc &                 !5 files
       & ,nfwannier,nfcntn_wannier,nfpot_wannier,nfefermi &          !4 files
       & ,nfnlo,nfmagopt,nfepscont   &                               !3 files UVSOR
       & ,nfpstrn, nfvelec, nfeppair, nfeppair2, nfvelec_grad &      !5 files Positron
       & ,nfpsicoef, nfbandsyminput &                                !2 file
! ============================= Added by K. Tagami =========== 10.1
!       & ,nfcntn_bin_paw                                            !1 file PAW
       & ,nfcntn_bin_paw              &                              !1 file PAW
       &, nf_LR_spectra               &                              !1 file LR
! ============================================================ 10.1
       &, nfcntn_berry &

! ====================== KT_add ======= 13.1R
       &, nfeps_ph &                                         ! 1 file EPS_Phonon
       &, nfoptical_coeff &                                  ! 1 file optical coeff
       &, nframan_spectra &                                  ! 1 file Raman spectra
! ===================================== 13.1R
! ===== KT_add ==== 13.1XI
       &, nf_excitation_spectra &                            ! 1 file Excitation
! ================= 13.1XI
! ====================== KT_add ======= 13.0S
       &, nfcore_energy_out, nfcore_energy_initial, nfcore_energy_final &
                                                             ! 3 files CoreLevel
! ===================================== 13.0S
       &, nfdynm_cif & ! CIF output
       &, nfwfk_sq   &   ! squared wf
       &, nfwfk_integ_mom  &  ! moment of wf ( integerated over space )
       &, nfwfk_orb_proj      &      ! orbital-projection of wf
       &, nfband_spectr_wght  &      ! spectral weight for band unfolding 
       &, nflatconst,nfmetric ! for pressurecontrol simulations

  data  &
       &   nfinp,nfpot &                                               ! 31,(37,38,39,40,45,46,11-19,36)
       &  ,nfpkb,nfpd,nfppc,nfstop,nfopgr,nfmatbp,nfkpoint,nfkindex &  ! 33,34,35,49,21,22,23,24
       &  ,nfvibrate,nfzak,nf_neord,nfcnst,nfotp,nfdynm,nfenf,nfgpt &  ! 47,48,50,61,51,52,53,54
       &  ,nfchgt,nfchgo,nfchgu,nfchgs,nfout,nfcps,nffor,nfcntn &      ! 55,56,57,58, 6, 6, 6,42
       &  ,nfcntn_bin,nfzaj,nfrsp,nfwf1,nfwf2,nfwf3,nfeng,nfvlc &      ! 43,44,90,95,96,97,59,60
       &  ,nfcntn_bin_stm, nfstatus &                                  ! 62,75
       &  ,nfspg,nfkpgn &                                              ! 63,64
       &  ,nfdos, nfchr, nfelf, nfegrid, nfldos &                      ! 5 files 65,66,67,68,69
       &  ,nfberry,nfeffchg,nfforce,nfmode,nfepsilon &                 ! 5 files 70,71,72,73,74
       &  ,nfepsout,nfphdos,nfoccmat,nfwfk,nfstrfrc &                  ! 5 files 20,41,76,77,78
       &  ,nfwannier,nfcntn_wannier,nfpot_wannier,nfefermi &           ! 4 files 79,80,81,82
       &  ,nfnlo,nfmagopt,nfepscont &                                  ! 3 files 10,30,83 UVSOR
       &  ,nfpstrn, nfvelec, nfeppair, nfeppair2, nfvelec_grad &       ! 5 files 300,310,320,322,330 Positron
       &  ,nfpsicoef, nfbandsyminput &                                 ! 2 file  340, 341
       &  ,nfcntn_bin_paw &                                            ! 1 file  321 PAW 
! ===================== Added by K. Tagami ================= 10.1
       &  ,nf_LR_spectra           &                     ! 1 file  400 Linear Response
! ========================================================== 10.1
       &  ,nfcntn_berry           &

! ======= KT_add === 13.1R
       &   , nfeps_ph &                                  ! 1 file 407 Eps_Phonon
       &   , nfoptical_coeff &                           ! 1 file 408 optical coeff
       &   , nframan_spectra  &                          ! 1 file 409 Raman spectra
! ================== 13.1R
! ===== KT_add ==== 13.1XI
       &   , nf_excitation_spectra  &                    ! 1 file 420 Excitation spectra
! ================= 13.1XI
! ============================== KT_add ========= 13.0S
       &  ,nfcore_energy_out, nfcore_energy_initial, nfcore_energy_final &
! =============================================== 13.0S
       &  ,nfdynm_cif &
       &  ,nfwfk_sq &
       &  ,nfwfk_integ_mom &
       &  ,nfwfk_orb_proj &
       &  ,nfband_spectr_wght &
! NPT, NPH-MD
       &  ,nflatconst &
       &  ,nfmetric &

       &    /31,37,38,39,40,45,46 &
       & ,11,12,13,14,15,16,17,18,19,36 &
       & ,33,34,35,49,21,22,23,24 &
       & ,47,48,50,61,51,52,53,54 &
       & ,55,56,57,58, 6, 6, 6,42 &
       & ,43,44,90,95,96,97,59,60 &
       & ,62,75,63,64,65,66,67,68,69 &
       & ,70,71,72,73,74,20,41,76,77,78 &
       & ,79,80,81,82 &
       & ,10,30,83, 300,310,320,322,330,340,341 &
! ================================ Added by K. Tagami ========== 10.1
       & ,321 &
       & ,400 & 
! ============================================================== 10.1
       & ,410 &
! =============== KT_add =========== 13.1R
       & ,407 &
       & ,408 &
       & ,409 &
! ================================== 13.1R
! =============== KT_add ====== 13.1XI
       & ,420 &
! ============================= 13.1XI
! =============== KT_add =========== 13.0S
       &, 370, 371, 372  &
! ================================== 13.0S
       &, 500 &
       &, 350 & 
       &, 351 &
       &, 352 &
       &, 345 &
       &, 100 &
       &, 101 /

  integer,private,parameter :: number_of_all_files = 80 + MAXNSP

  integer,private, dimension(number_of_all_files) :: n_file
  data n_file &
       &    /31,37,38,39,40,45,46 &
       & ,11,12,13,14,15,16,17,18,19,36 &
       & ,33,34,35,49,21,22,23,24 &
       & ,47,48,50,61,51,52,53,54 &
       & ,55,56,57,58, 6, 6, 6,42 &
       & ,43,44,90,95,96,97,59,60 &
       & ,62,75,63,64,65,66,67,68,69 &
       & ,70,71,72,73,74,20,41,76,77,78 &
       & ,79,80,81,82 &
       & ,10,30, 300,310,320,330,340 &
! ===================================== Added by K. Tagami ======= 10.1
!       & ,321/
       & ,321 &
       & ,400 &
! ================================================================ 10.1
       & ,410 &
! =============== KT_add =========== 13.1R
       & ,407 &
       & ,408 &
       & ,409 &
! ================================== 13.1R
! =============== KT_add ====== 13.1XI
       & ,420 &
! ============================= 13.1XI
! ================= KT_add ======== 13.0S
       & ,370, 371, 372 &
! ================================= 13.0S
       & ,500, 350, 351, 352, 345 &
       & ,100, 101 /

  integer,private,parameter :: stringlength_of_filenames = 260
  character(len=stringlength_of_filenames) ::  &
       &  F_INP,F_POT(MAXNSP),F_PKB,F_PD,F_PPC,F_STOP,F_OPGR &         ! 31,(37-40,45,46,11-19,36),33,34,35,49,21
       & ,F_MATBP,F_KPOINT,F_KINDEX, F_VIBRATE, F_ZAK,F_NEORD,F_CNST & ! 22,23,24,47,48,50,61
       & ,F_OTP, F_DYNM,F_ENF, F_GPT, F_CHGT, F_CHGO, F_CHGU, F_CHGS & ! 51,52,53,54,55,56,57,58
       & ,F_OUT, F_CNTN, F_CNTN_BIN, F_ZAJ, F_RSP, F_WF(3), F_ENERG  & ! 6, 42,43,44,90,95,96,97,59
       & ,F_VLC, F_CNTN_BIN_STM, F_STATUS, F_file_names_data &         ! 60,62,75
       & ,F_SPG, F_KPGN, F_DOS, F_CHR, F_ELF, F_EGRID, F_LDOS &        ! 63,64,65,66,67,68,69
       & ,F_BERRY,F_EFFCHG,F_FORCE,F_MODE,F_EPSILON &                  ! 70,71,72,73,74
       & ,F_EPSOUT,F_PHDOS,F_OCCMAT,F_WFk,F_STRFRC &                   ! 20,41,76,77,78
       & ,F_WANNIER,F_CNTN_WAN,F_POT_WAN,F_EFERMI &                    ! 79,80,81,82
       & ,F_NLO,F_MAGOPT,F_EPSCONT &                                   ! 10,30,83 UVSOR
       & ,F_PSTRN, F_VELEC, F_EPPAIR, F_EPPAIR2, F_VELEC_GRAD  &       ! 300,310,320,322,330 Positron
       & ,F_PSICOEF, F_BAND_SYM_INPUT       &                          ! 340,341 Psi_coef, Psi_coef2
! ================================== Added by K. Tagami ======= 10.1
!       & ,F_CNTN_BIN_PAW                                               ! 321 PAW
       & ,F_CNTN_BIN_PAW &                                              ! 321 PAW
       & ,F_LR_SPECTRA   &                                         ! 400 LinearResponse
! ============================================================= 10.1
       & ,F_CNTN_BERRY &

! ================= KT_add ====== 13.1R
       &, F_EPS_PHONON &                              ! 407 EPS_Phonon
       &, F_OPTICAL_COEFF &                           ! 408 Optical Coeff
       &, F_RAMAN_SPECTRA &                           ! 409 Raman spectra
! =============================== 13.1R

! ================= KT_add ====== 13.1XI
       &, F_EXCITATION_SPECTRA &                       ! 420 Excitation spectra
! =============================== 13.1XI

! ================= KT_add ====== 13.0S
       &, F_CORE_ENERGY_OUT, F_CORE_ENERGY_INITIAL,  F_CORE_ENERGY_FINAL &
! =============================== 13.0S
       &, F_DYNM_CIF, F_WFk_Squared, F_WFk_IntegMoment &
       &, F_WFK_ORB_PROJ, F_BAND_SPECTR_WGHT &
       &, F_LATCONST, F_METRIC

  namelist/fnames/ &
       &  F_INP, F_POT, F_PKB, F_PD, F_PPC, F_STOP, F_OPGR &
       & ,F_MATBP,F_KPOINT,F_KINDEX, F_VIBRATE, F_ZAK,F_NEORD,F_CNST &
       & ,F_OTP, F_DYNM,F_ENF, F_GPT, F_CHGT, F_CHGO, F_CHGU, F_CHGS &
       & ,F_OUT, F_CNTN, F_CNTN_BIN, F_ZAJ, F_RSP,  F_WF,   F_ENERG  &
       & ,F_VLC, F_CNTN_BIN_STM, F_STATUS &
       & ,F_SPG, F_KPGN, F_DOS, F_CHR, F_ELF, F_EGRID, F_LDOS & 
       & ,F_BERRY,F_EFFCHG,F_FORCE,F_MODE,F_EPSILON &
       & ,F_EPSOUT,F_PHDOS,F_OCCMAT,F_WFk,F_STRFRC &
       & ,F_WANNIER,F_CNTN_WAN,F_POT_WAN,F_EFERMI &
       & ,F_NLO,F_MAGOPT,F_EPSCONT  &                                  ! UVSOR
       & ,F_PSTRN, F_VELEC, F_EPPAIR, F_EPPAIR2, F_VELEC_GRAD &        ! Positron
       & ,F_PSICOEF, F_BAND_SYM_INPUT &
! ================================== Added by K. Tagami ======= 10.1
       & ,F_CNTN_BIN_PAW &
       & ,F_LR_SPECTRA   &
! ============================================================= 10.1
       & ,F_CNTN_BERRY &

! ================= KT_add ====== 13.1R
       &, F_EPS_PHONON &
       &, F_OPTICAL_COEFF &
       &, F_RAMAN_SPECTRA &
! =============================== 13.1R

! ================= KT_add === 13.1XI
       &, F_EXCITATION_SPECTRA &
! ============================ 13.1XI

! ================= KT_add ====== 13.0S
       &, F_CORE_ENERGY_OUT, F_CORE_ENERGY_INITIAL,  F_CORE_ENERGY_FINAL &
! =============================== 13.0S
       &, F_DYNM_CIF, F_WFk_Squared, F_Wfk_IntegMoment &
       &, F_WFK_ORB_PROJ, F_BAND_SPECTR_WGHT &
       &, F_LATCONST, F_METRIC


  logical ::             F_ZAJ_partitioned      = .false.
  logical ::             F_CHGT_partitioned     = .false.
  logical ::             F_CNTN_BIN_partitioned = .false.
  logical ::             F_CNTN_partitioned     = .false.
  logical ::             F_ZAJ_in_partitioned      = .false.
  logical ::             F_CHGT_in_partitioned     = .false.
  logical ::             F_CNTN_BIN_in_partitioned = .false.
  logical ::             F_CNTN_in_partitioned     = .false.

! ======================== KT_add ================= 13.0D
  logical ::             F_CNTN_BIN_PAW_partitioned = .false.
  logical ::             F_CNTN_BIN_PAW_in_partitioned  = .false.
! ================================================= 13.0D

  character(len=stringlength_of_filenames) &
       &  ::             F_ZAJ_filetype,      F_CHGT_filetype &
       &              ,  F_CNTN_BIN_filetype,    F_CNTN_filetype
  character(len=stringlength_of_filenames) &
       &  ::             F_ZAJ_in_filetype,   F_CHGT_in_filetype &
       &               , F_CNTN_BIN_in_filetype, F_CNTN_in_filetype

! ======================== KT_add ================= 13.0D
  character(len=stringlength_of_filenames) &
       &                 F_CNTN_BIN_PAW_filetype, F_CNTN_BIN_PAW_in_filetype
! ================================================= 13.0D

  namelist/mpifiletypes/ F_ZAJ_filetype,         F_CHGT_filetype &
       &               , F_CNTN_BIN_filetype,    F_CNTN_filetype &
       &               , F_ZAJ_in_filetype,      F_CHGT_in_filetype &
       &               , F_CNTN_BIN_in_filetype, F_CNTN_in_filetype &
! ======================== KT_add ================= 13.0D
       &               , F_CNTN_BIN_PAW_filetype, F_CNTN_BIN_PAW_in_filetype
! ================================================= 13.0D


  character(len=stringlength_of_filenames) &
       &  ::             F_ZAJ_in, F_CHGT_in, F_CNTN_BIN_in, F_CNTN_in
  character(len=stringlength_of_filenames) &
       &  ::             F_ZAJ_bak, F_CHGT_bak, F_CNTN_BIN_bak, F_CNTN_bak

! ======================== KT_add ================= 13.0D
  character(len=stringlength_of_filenames) :: F_CNTN_BIN_PAW_in
! ================================================= 13.0D

  logical, private :: fout_is_given = .false.
  character(len=stringlength_of_filenames+3) :: F_STATUS_ext
  integer, dimension(-1:1) :: nfstm

  integer nfprm
  data nfprm/93/
  character(len=stringlength_of_filenames) ::  F_PRM
  namelist/f_param_name/F_PRM

  character, private :: name_jobstep*3
  
  integer  nfimage, nfnebstop, nfneb, nfnebcntn, nfnebenf, nfnebdynm
  data  nfimage, nfnebstop, nfneb, nfnebcntn, nfnebenf, nfnebdynm &
	/201,202,203,204,205,206/
  character(len=100) :: F_IMAGE(-1:99), F_NEB_STOP, F_NEB_OUT, F_NEB_CNTN, F_NEB_ENF, F_NEB_DYNM
  namelist/nebfiles/ F_IMAGE, F_NEB_STOP, F_NEB_OUT, F_NEB_CNTN, F_NEB_ENF, F_NEB_DYNM

  character(len=5) :: prefix='_conf'

! === KT_add === 2014/07/20
  character(len=100) :: F_OUT_BASE, F_CONF_EXTENSION, F_PARA_EXTENSION
! ============== 2014/07/20

! ==== KT_add ==== 2014/07/14
  integer :: nfhypervec
  data nfhypervec /210/
  character(len=100) :: F_HYPERVEC
!
  namelist /constraints/ F_HYPERVEC
! ================ 2014/07/14
!   Following interface block is moved from subroutines of 'm_Files_open_ps_files' and 'm_Files_open_ps_file",
!  according to a report from ASMS Co.ltd, 10 March 2016.
    interface
       subroutine phase_error(ierror,nfout,nfpp,filename,line,file)
         integer,         intent(in)          :: ierror, nfout, nfpp
         character(len=*),intent(in)          :: filename
         integer,         intent(in),optional :: line
         character(len=*),intent(in),optional :: file
       end subroutine phase_error
    end interface

contains
  subroutine m_Files_open_standardout()
    character :: name_mype*12
    integer :: name_length
    integer ::   i, js, ls, imax
    logical ::   existance

    character(len=256) :: cid,cketa, f_tmp
    integer :: iketa=2
    integer :: itmp

    if(npes > 1) then
       name_length = 12
       imax = int(log10(dble(npes-1)))+1
       if(imax < min_ext_length_mype) imax = min_ext_length_mype
       if(imax > name_length) then
          stop ' number of pes (=npes) is larger than 1,000,000,000,000'
       end if
       write(name_mype,'(i12)') mype
       do i = 1+name_length-imax, name_length
          if(name_mype(i:i) == ' ') name_mype(i:i)='0'
       enddo
    end if

    ls = len(trim(F_OUT))

! === KT_add === 2014/07/20
    F_CONF_EXTENSION = "";    F_PARA_EXTENSION = ""

    if ( mype /= 0 ) then
       F_PARA_EXTENSION = '_'//name_mype(name_length-imax+1:name_length)
    endif
! ============== 2014/07/20

    if(.not.conf_para .or. conf_para.and.mype_conf==0) then

    if(ls < 1) then
       fout_is_given = .false.
       if(mype==0) then
          do js = 0, 999
             write(name_jobstep,'(i3)') js
             do i = 1, 3
                if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
             enddo
             F_OUT = "output"//name_jobstep
             if(sw_wdir == ON) then
                inquire(file=trim(workdir)//F_OUT, exist=existance)
             else
                inquire(file=F_OUT, exist=existance)
             end if
!!$             inquire(file=F_OUT, exist=existance)

! ==== KT_add ====== 2014/07/20
#ifdef NEB_NEW_FILENAMES
             if ( .not. existance ) then
                f_tmp = trim(F_OUT) //'_conf0'
                inquire(file=f_tmp, exist=existance)
             endif
             if ( .not. existance ) then
                f_tmp = trim(F_OUT) // '_conf00'
                inquire(file=f_tmp, exist=existance)
             endif
             if ( .not. existance ) then
                f_tmp = trim(F_OUT) // '_conf000'
                inquire(file=f_tmp, exist=existance)
             endif
#endif
! ================== 2014/07/20

             if(.not.existance) goto 1001
          end do
1001      if(js >=1000) js = 999
       end if
       if(npes > 1) call mpi_bcast(js,1,mpi_integer,0,mpi_comm_group,ierr)
       write(name_jobstep,'(i3)') js
       do i = 1, 3
          if(name_jobstep(i:i) == ' ') name_jobstep(i:i)='0'
       enddo
! =========== KT_mod ==== 2014/07/20
!       if(mype==0) then
!          F_OUT = "output"//name_jobstep
!       else
!          F_OUT = "output"//name_jobstep//'_'//name_mype(name_length-imax+1:name_length)
!       end if
!
       F_OUT_BASE = "output"//name_jobstep
       if(mype==0) then
          F_OUT = trim(F_OUT_BASE)
       else
          F_OUT = trim(F_OUT_BASE) // F_PARA_EXTENSION
       end if
! ======================= 2014/07/20
    else
       fout_is_given = .true.
       if(mype > 0) then
! =========== KT_mod ==== 2014/07/20
!          if(ls+imax+1 > stringlength_of_filenames) then
!             F_OUT = F_OUT(1:stringlength_of_filenames-(imax+1))//'_'//name_mype(name_length-imax+1:name_length)
!          else
!             F_OUT = F_OUT(1:ls)//'_'//name_mype(name_length-imax+1:name_length)
!          end if
!
          if(ls+imax+1 > stringlength_of_filenames) then
             F_OUT_BASE = F_OUT(1:stringlength_of_filenames-(imax+1))
          else
             F_OUT_BASE = F_OUT(1:ls)
          end if
          F_OUT = trim(F_OUT_BASE) // F_PARA_EXTENSION
! ======================= 2014/07/20
       end if
    end if

    endif

    if(conf_para)then
      call mpi_bcast(F_OUT,len(F_OUT),mpi_character,0,mpi_comm_world,ierr)
      call mpi_bcast(name_jobstep,len(name_jobstep),mpi_character,0,mpi_comm_world,ierr)

! === KT_add === 2014/07/20
      call mpi_bcast(F_OUT_BASE,len(F_OUT_BASE),mpi_character,0,mpi_comm_world,ierr)
! ============== 2014/07/20

!      if(mype_conf/=0.and.mype==0) then
#ifndef NEB_NEW_FILENAMES
      if(mype_conf/=0) then
#endif
        itmp=int(log10(real(nrank_conf)))+1
        if(itmp>2)iketa=itmp
        write(cketa,*) iketa
        write(cid,'(i'//trim(adjustl(cketa))//'.'//trim(adjustl(cketa))//')') mype_conf

! ==== KT_mod === 2014/07/20
!        F_OUT = trim(F_OUT)//trim(adjustl(prefix))//cid
!
        F_CONF_EXTENSION = trim(adjustl(prefix))//cid
        F_OUT = trim(F_OUT) // F_CONF_EXTENSION
! ============== 2014/07/20

#ifndef NEB_NEW_FILENAMES
      endif
#endif

! === KT_mod === 2014/07/20
!     if(mype/=0) F_OUT = trim(F_OUT)//'_'//name_mype(name_length-imax+1:name_length)
!
      if (mype/=0) F_OUT = trim(F_OUT) // F_PARA_EXTENSION
! ============== 2014/07/20

    endif

    if(sw_wdir == ON) then
       open(6, file=trim(workdir)//F_OUT, status='unknown', form='formatted')
    else
       open(6, file=F_OUT, status='unknown', form='formatted')
    end if

!!$    if(printable) write(nfout,'(" length of F_OUT = ",i8)') ls
!!$    if(printable) write(nfout,'(" F_OUT = ",a32)') F_OUT

  end subroutine m_Files_open_standardout

  subroutine m_Files_open_nfvlc
    if(mype == 0) &
         & call open0(nfvlc,F_VLC,'F_VLC     ',unknown,unformatted&
         &     , check_file_name_on)
  end subroutine m_Files_open_nfvlc

  subroutine m_Files_open_nfcntn
    logical open
    inquire(unit = nfcntn, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfcntn,F_CNTN,'F_CNTN    ',unknown,formatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfcntn

  subroutine m_Files_open_nfcntn_bin
    logical open
    inquire(unit = nfcntn_bin, opened = open)
    if(open .and. printable) write(nfout,'("! nfcntn_bin is alread open")')
    if(printable) &
         & write(nfout,'(" F_CNTN_BIN_in = ",a40," <<m_Files_open_nfcntn_bin>>")') F_CNTN_BIN_in

    if(F_CNTN_BIN_in_partitioned) then
       if(.not.open .and. mype == 0) then
          call open0(nfcntn_bin,F_CNTN_BIN_in,'F_CNTN_BIN',unknown,unformatted&
               &     ,check_file_name_on)
       else if(.not.open .and. mype /= 0) then
          call open0(nfcntn_bin,F_CNTN_BIN_in,'F_CNTN_BIN',unknown,unformatted&
               &     ,check_file_name_off)
       end if
    else
       if(.not.open .and. mype==0) &
            & call open0(nfcntn_bin,F_CNTN_BIN_in,'F_CNTN_BIN',unknown,unformatted&
            &     ,check_file_name_on)
    end if
  end subroutine m_Files_open_nfcntn_bin

  Subroutine m_Files_reopen_nfcntn
    logical open
    inquire(unit = nfcntn, opened = open)
    if(open .and. mype == 0) close(nfcntn)
    if(mype==0) &
         & call open0(nfcntn,F_CNTN,'F_CNTN    ',unknown,formatted&
         &     ,check_file_name_on)
  end subroutine m_Files_reopen_nfcntn

  subroutine m_Files_reopen_nfcntn_bin
    logical open
    inquire(unit = nfcntn_bin, opened = open)
!!$    if(open .and. printable) write(nfout,'("! nfcntn_bin is alread open")')
    if(open) close(nfcntn_bin)
    if(F_CNTN_BIN_partitioned) then
       if(mype == 0) then
          call open0(nfcntn_bin, F_CNTN_BIN, 'F_CNTN_BIN',unknown, unformatted,check_file_name_on)
       else
          call open0(nfcntn_bin, F_CNTN_BIN, 'F_CNTN_BIN',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype == 0) call open0(nfcntn_bin,F_CNTN_BIN,'F_CNTN_BIN',unknown &
            &                         ,unformatted,check_file_name_on)
    end if
  end subroutine m_Files_reopen_nfcntn_bin

  subroutine m_Files_open_nfcntn_bin_stm
    logical open
    inquire(unit = nfcntn_bin_stm, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfcntn_bin_stm,F_CNTN_BIN_STM,'F_CNTN_STM',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfcntn_bin_stm

  subroutine m_Files_open_nfcntn_berry()
    logical open 
    inquire(unit = nfcntn_berry, opened = open)
    if(open) write(6,'("! nfcntn_berry is already opened")')
    if(.not.open .and. mype==0) &
    & call open0(nfcntn_berry,F_CNTN_BERRY,'F_CNTN_BERRY',unknown,unformatted &
    &      ,check_file_name_off)
  end subroutine m_Files_open_nfcntn_berry

  subroutine m_Files_close_nfcntn_berry()
    if(mype==0) close(nfcntn_berry)
  end subroutine m_Files_close_nfcntn_berry

  logical function m_Files_nfcntn_bin_paw_exists()
    logical :: ex
    inquire(file=F_CNTN_BIN_PAW,exist=ex) 
    m_Files_nfcntn_bin_paw_exists = ex
  end function m_Files_nfcntn_bin_paw_exists

  subroutine m_Files_open_nfcntn_bin_paw
    logical open
    inquire(unit = nfcntn_bin_paw, opened = open)
    if(open) write(6,'("! nfcntn_bin_paw is alread open")')
    if(open) close(nfcntn_bin_paw)
    if(open) open=.false.
    if(.not.open .and. mype==0) &
         & call open0(nfcntn_bin_paw,F_CNTN_BIN_PAW,'F_CNTN_BIN_PAW',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfcntn_bin_paw

! ======================== KT_add ================= 13.0D
  subroutine m_Files_close_nfcntn_bin_paw()
    if(mype==0) close(nfcntn_bin_paw)
  end subroutine m_Files_close_nfcntn_bin_paw

  subroutine m_Files_reopen_nfcntn_bin_paw
    logical open
    inquire(unit = nfcntn_bin_paw, opened = open)
    if(open) close(nfcntn_bin_paw)

    if(.not.open .and. mype==0) &
         & call open0(nfcntn_bin_paw,F_CNTN_BIN_PAW,'F_CNTN_BIN_PAW',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_reopen_nfcntn_bin_paw
! ================================================= 13.0D

  subroutine m_Files_open_nfstop
    if(mype == 0) call open0(nfstop,F_STOP,'F_STOP    '&
         &                  ,unknown,formatted,check_file_name_off)       ! MPI
  end subroutine m_Files_open_nfstop

  subroutine m_Files_close_nfstop
    if(mype == 0) close(nfstop,status='keep')  ! MPI
  end subroutine m_Files_close_nfstop

  subroutine m_Files_open_nfstatus
    integer :: ls
    integer :: itmp,iketa
    character(len=256) :: suf,cketa
    integer :: ierr
    if(mype == 0) then
!!$       write(nfout,'(" !! name_jobstep = ",a3)') name_jobstep
!!$       write(nfout,*) ' !! fout_is_given = ', fout_is_given
       if(fout_is_given) then
       else
!!$          if(.not.conf_para .or. conf_para.and.mype_conf==0) then
          ls = len(trim(F_STATUS))
          if(ls+3 > stringlength_of_filenames) then
             F_STATUS = F_STATUS(1:stringlength_of_filenames-3-iketa)//name_jobstep
          else
             F_STATUS = F_STATUS(1:ls)//name_jobstep
          end if
!!$          endif
          fout_is_given = .true.
!!$ '09.11.11
          if(conf_para)then
!!$            call mpi_bcast(F_STATUS,len(F_STATUS),mpi_character,0,mpi_comm_world,ierr)

#ifndef NEB_NEW_FILENAMES
             if(mype_conf/=0) then
#endif
                iketa=2
                itmp = int(log10(real(nrank_conf)))+1
                if(itmp>2)iketa=itmp
                write(cketa,*) iketa
                write(suf,'(i'//trim(adjustl(cketa))//'.'//trim(adjustl(cketa))//')') mype_conf
                F_STATUS = trim(F_STATUS)//trim(adjustl(prefix))//trim(adjustl(suf))
#ifndef NEB_NEW_FILENAMES
             endif
#endif
          endif
!!$ '09.11.11
       end if
!!$       open(nfstatus, file=F_STATUS, status='unknown',form='formatted')
       if(sw_wdir == ON) then
          open(nfstatus, file=trim(workdir)//F_STATUS, status='unknown',form='formatted')
       else
          open(nfstatus, file=F_STATUS, status='unknown',form='formatted')
       end if
    end if
  end subroutine m_Files_open_nfstatus

  subroutine m_Files_close_nfstatus
    if(mype == 0) close(nfstatus,status='keep')  ! MPI
  end subroutine m_Files_close_nfstatus

  subroutine m_Files_open_kpoint_files(way_ksample,nbztyp)
    integer, intent(in) :: way_ksample,nbztyp
!!!!!!!! modified by mizouchi@adv 2003.2.21 !!!!!
!!    call open0(nfmatbp, F_MATBP, 'F_MATBP   ',unknown,formatted,check_file_name_on)
!!    call open0(nfkpoint,F_KPOINT,'F_KPOINT  ', old,   formatted,check_file_name_on)
    if(way_ksample == FILE .or. nbztyp < GENERAL) then
       call open0(nfkpoint,F_KPOINT,'F_KPOINT  ', old,   formatted,check_file_name_on)
!  <-- modified by T. Yamasaki 4th May 2003
    end if
!!!!!!!! modified by mizouchi@adv 2003.2.21 !!!!!
!!$    if(nbztyp >= GENERAL) then
!!!!!!!! modified by mizouchi@adv 2003.2.21 !!!!!
!!       call open0(nfopgr, F_OPGR, 'F_OPGR    ', old,   formatted,check_file_name_on)
!!$       call open0(nfspg,  F_SPG,  'F_SPG     ', old,   formatted,check_file_name_on)
!!$       call open0(nfkpgn, F_KPGN, 'F_KPGN    ', old,   formatted,check_file_name_on)
!!!!!!!! modified by mizouchi@adv 2003.2.21 !!!!!
!!$    end if
  end subroutine m_Files_open_kpoint_files

  subroutine m_Files_open_nfspg()
    call open0(nfspg,  F_SPG,  'F_SPG     ', old,   formatted,check_file_name_on)
  end subroutine m_Files_open_nfspg

  subroutine m_Files_open_nfkindex
    call open0(nfkindex, F_KINDEX, 'F_KINDEX  ',old,formatted,check_file_name_on)
  end subroutine m_Files_open_nfkindex

  subroutine set_filenumbers_of_NFSTM
    nfstm(-1) = nfchgu
    nfstm( 0) = nfchgs
    nfstm( 1) = nfchgo
  end subroutine set_filenumbers_of_NFSTM
      
  subroutine checkfilenumbers
    if(printable) then
       write(nfout,*) ' nfstm(-1) = ', nfstm(-1)
       write(nfout,*) ' nfstm( 0) = ', nfstm( 0)
       write(nfout,*) ' nfstm( 1) = ', nfstm( 1)
    end if
  end subroutine checkfilenumbers

!!$  subroutine m_Files_set_default_filenames_paramset
!!$    F_PRM       = './m_ArraySize_Parameters.f90'
!!$  end subroutine m_Files_set_default_filenames_paramset

  subroutine m_Files_set_default_filenames
    F_file_names_data   = "./file_names.data"
!c---------- Input files.
    call set_filenumbers_of_NFSTM
!!$    if(.not.paramset) call checkfilenumbers
    F_INP       = "./nfinp.data"
    F_POT(1)    = "./pot.01"   !  fort.37'
    F_POT(2)    = "./pot.02"   !  fort.38'
    F_POT(3)    = "./pot.03"   !  fort.39'
    F_POT(4)    = "./pot.04"   !  fort.40'
    F_POT(5)    = "./pot.05"   !  fort.45'
    F_POT(6)    = "./pot.06"   !  fort.46'
    F_POT(7)    = "./pot.07"   !  fort.11'
    F_POT(8)    = "./pot.08"   !  fort.12'
    F_POT(9)    = "./pot.09"   !  fort.13'
    F_POT(10)   = "./pot.10"   !  fort.14'
    F_POT(11)   = "./pot.11"   !  fort.15'
    F_POT(12)   = "./pot.12"   !  fort.16'
    F_POT(13)   = "./pot.13"   !  fort.17'
    F_POT(14)   = "./pot.14"   !  fort.18'
    F_POT(15)   = "./pot.15"   !  fort.19'
    F_POT(16)   = "./pot.16"   !  fort.36'
    F_PKB       = "./vkb.data"
    F_PD        = "./vd.data"
    F_PPC       = "./vpc.data"
    F_STOP      = "./nfstop.data"
    F_CNST      = "./nfcnst.data"
!c---------- nbztype >= 100
    F_OPGR      = "./opgr.data"
    F_MATBP     = "./matrix.BP"
    F_KPOINT    = "./kpoint.data"
    F_KINDEX    = "./f.kp0"
!!!!!!!! added by mizouchi@adv 2003.2.21 !!!!!
    F_SPG       = "./bnprp4.i5"
    F_KPGN      = "./bnkpgn.i5"
!!!!!!!! added by mizouchi@adv 2003.2.21 !!!!!
!c---------- Output files.
    F_OTP       = "./nfotp.data"
    F_DYNM      = "./nfdynm.data"
    F_DYNM_CIF  = "./nfdynm.cif"
!!$    F_FORCE     = "./nfforce.data"
    F_EGRID     = "./nfegrid.data"
    F_LDOS      = "./nfldos.data"
    F_ENF       = "./nfefn.data"
!!$    F_GPT       = "./nfgpt.data"
    F_CHGT      = "./nfchgt.data"
    F_CHGO      = "./nfchgo.data"
    F_CHGU      = "./nfchgu.data"
!#ifdef _STMIMG_EVERY_TIME_
    F_CHGS      = "./nfchgs.data"
!#endif
    F_ENERG     = "./nfenergy.data"
    F_OUT       = ""
    F_STATUS    = "./jobstatus"
!c----------- Information files
!c      F_IENG     = "./nfieng.data"
!c----------- Continue file
    F_CNTN      = "./continue.data"
    F_CNTN_BIN  = "./continue_bin.data"
    F_ZAJ       = "./zaj.data"
    F_VLC       = "./nfvlc.data"
    F_CNTN_BIN_STM = "./continue_bin_stm.data"

!c----------- Work files.
    F_WF(1)     = "./ftn95.data"
    F_WF(2)     = "./ftn96.data"
    F_WF(3)     = "./ftn97.data"
!c---------------------
    if(paramset) F_PRM       = "./m_ArraySize_Parameters.f90"
    F_DOS       = "./dos.data"
    F_CHR       = "./nfchr.data"
    F_WFk       = "./nfwfk.data"
    F_WANNIER   = "./nfwannier.data"
    F_CNTN_WAN  = "./nfcontinue_wannier.data"
    F_POT_WAN   = "./nfpotential_wannier.data"
    F_ELF       = "./nfelf.data"
    F_BERRY     = "./berry.data"
    F_EFFCHG    = "./effchg.data"
    F_FORCE     = "./force.data"
    F_MODE      = "./mode.data"
    F_EPSILON   = "./epsilon.data"
    F_EPSOUT    = "./eps.data"
    F_NLO       = "./nlo.data"         ! UVSOR
    F_MAGOPT    = "./magopt.data"      ! UVSOR
    F_EPSCONT   = "./eps_continue.data"! UVSOR
    F_PHDOS     = "./phdos.data"
    F_PHDOS     = "./phdos.data"
    F_OCCMAT    = "./occmat.data"
    F_STRFRC    = "./strfrc.data"
    F_PSTRN     = "./positron.cube"
    F_VELEC     = "./electron.cube"
    F_EPPAIR    = "./ep_pair.cube"
    F_EPPAIR2   = "./ep_pair2.cube"
    F_VELEC_GRAD= "./electron_grad.cube"
    F_PSICOEF   = "./psicoef.data"
    F_BAND_SYM_INPUT = "./band_sym_input.data"
    F_EFERMI    = "./nfefermi.data"
! ---------- mpifiletypes
    F_ZAJ_filetype = "unified"
    F_CHGT_filetype = "unified"
    F_CNTN_BIN_filetype = "unified"
    F_CNTN_filetype = "unified"
    F_CNTN_BIN_PAW_filetype = "unified"
 
    F_ZAJ_in      = F_ZAJ
    F_CNTN_in     = F_CNTN
    F_CNTN_BIN_in = F_CNTN_BIN
    F_CHGT_in     = F_CHGT

    F_ZAJ_bak      = F_ZAJ
    F_CNTN_bak     = F_CNTN
    F_CNTN_BIN_bak = F_CNTN_BIN
    F_CHGT_bak     = F_CHGT
 
    F_ZAJ_in_filetype = "nogiven"
    F_CHGT_in_filetype = "nogiven"
    F_CNTN_BIN_in_filetype = "nogiven"
    F_CNTN_in_filetype = "nogiven"   

! ---------- nebfiles
    F_NEB_OUT  = "./output_neb"
    F_IMAGE(0)  = "./endpoint0.data"
    F_IMAGE(-1) = "./endpoint1.data"
    F_NEB_STOP = "./nfnebstop.data"
    F_NEB_CNTN = "./neb_continue.data"
    F_NEB_ENF = "./nfnebenf.data"
    F_NEB_DYNM = "./nfnebdynm.data"

! ---------- PAW continuation file
    F_CNTN_BIN_PAW          = "./continue_bin_paw.data"

! ======================== KT_add ================= 13.0D
    F_CNTN_BIN_PAW_in = F_CNTN_BIN_PAW
    F_CNTN_BIN_PAW_in_filetype = 'nogiven'
! ================================================= 13.0D

! ============================== Added by K. Tagami ======== 10.1
    F_LR_SPECTRA = "./spectrum.data"
! ========================================================== 10.1

    F_CNTN_BERRY = './continue_bin_berry.data'

! ======== KT_add =========== 13.0S
    F_CORE_ENERGY_OUT = './core_energy.data'
    F_CORE_ENERGY_INITIAL = './core_energy.initial'
    F_CORE_ENERGY_FINAL   = './core_energy.final'
! =========================== 13.0S
    
! ====== KT_add === 13.1R
    F_EPS_PHONON = './nfeps_phonon.data'
    F_OPTICAL_COEFF = './nfoptical_coeff.data'
    F_RAMAN_SPECTRA = './raman_spectra.data'
! ================= 13.1R

! ====== KT_add ====== 13.1XI
    F_EXCITATION_SPECTRA = './excitation_spectra.data'
! ================= 13.1XI

! ====== KT_add === 2014/07/14/
    F_HYPERVEC = './hypervector.data'
! ================= 2014/07/14/

    F_WFk_Squared  = "./wfnsq.cube"
    F_WFk_IntegMoment   = "./wfn_integ_moment.data"
    F_WFK_ORB_PROJ    = "./wfn_orb_proj.data"

    F_BAND_SPECTR_WGHT = "./nfband_spectr_wght.data"

    F_LATCONST = "./nflatconst.data"
    F_METRIC   = "./nfmetric.data"

  end subroutine m_Files_set_default_filenames
      
  subroutine m_Files_rd_file_names_data
    integer, parameter ::  nffile = 99
    logical :: existance
    integer :: iwarning

    if(sw_wdir==ON)then
       inquire(file=trim(workdir)//F_file_names_data, exist = existance)
    else
       inquire(file=F_file_names_data, exist = existance)
    endif
    if(existance) then
       call open0(nffile, F_file_names_data, "FFILENAMES", old, formatted,check_file_name_off)
       !      open(nffile,file="./file_names.data",status='unknown')
       rewind nffile
       read(nffile,NML = fnames, err = 1007, end = 1004)
1004   continue
       rewind nffile
       read(nffile,NML = nebfiles, err = 1008, end = 1005)
1005   continue
       close(nffile,status='keep')
    else
       iwarning = FILENAMES_NOT_EXIST
       call m_EMsg_Warning(iwarning, nfout)
    end if

    F_ZAJ_bak      = F_ZAJ
    F_CHGT_bak     = F_CHGT
    F_CNTN_BIN_bak = F_CNTN_BIN
    F_CNTN_bak     = F_CNTN

    return
!1007 stop ' file_names.data fnames format error'
!1008 stop ' file_names.data nebfiles format error'
1007 call phase_execution_error(FILENAMES_FORMAT_ERROR)
1008 call phase_execution_error(FILENAMES_FORMAT_ERROR_NEB)
  end subroutine m_Files_rd_file_names_data

  logical function m_Files_check_nfcntn_existance()
    logical :: existance
    existance = .false.
!!$    if((.not.F_CNTN_in_partitioned .and. mype == 0) .or. F_CNTN_in_partitioned) then
    if(mype == 0) then
       if(sw_wdir == ON) then
          inquire(file=trim(workdir)//F_CNTN_in,exist = existance)
       else
          inquire(file=F_CNTN_in,exist = existance)
       end if
    end if
!!$    if(.not.F_CNTN_in_partitioned .and. npes >1) call mpi_bcast(existance,1,mpi_logical,0,mpi_comm_group,ierr)
    if(npes >1) call mpi_bcast(existance,1,mpi_logical,0,mpi_comm_group,ierr)
    m_Files_check_nfcntn_existance = existance
  end function m_Files_check_nfcntn_existance

  subroutine m_Files_check_file_existance
    integer, parameter ::  nffile = 99
    logical :: existance, existance_all
    integer, allocatable, dimension(:,:) :: file_existance !d(npes,cont files)
    integer, allocatable, dimension(:) :: file_existance_local !d(cont files)
    integer :: i, j, npartitioned_files
    character :: name_mype*12
!!!    logical :: existance
    integer :: name_length, imax

    if(sw_wdir==ON)then
       inquire(file=trim(workdir)//F_file_names_data, exist = existance)
    else
       inquire(file=F_file_names_data, exist = existance)
    endif
    if(existance) then
       call open0(nffile, F_file_names_data, "FFILENAMES", old, formatted,check_file_name_on)
       rewind nffile
       read(nffile,NML = mpifiletypes, err = 1005, end = 1005)
    end if

    if(F_ZAJ_in_filetype == "nogiven") F_ZAJ_in_filetype = F_ZAJ_filetype
    if(F_CHGT_in_filetype == "nogiven") F_CHGT_in_filetype = F_CHGT_filetype
    if(F_CNTN_BIN_in_filetype == "nogiven") F_CNTN_BIN_in_filetype = F_CNTN_BIN_filetype
    if(F_CNTN_in_filetype == "nogiven") F_CNTN_in_filetype = F_CNTN_filetype

! ======================== KT_add ================= 13.0D
    if(F_CNTN_BIN_PAW_in_filetype == 'nogiven') &
         &            F_CNTN_BIN_PAW_in_filetype = F_CNTN_BIN_PAW_filetype
! ================================================= 13.0D

    if(printable) then
       write(nfout,'(" !! mpifiletypes is read")')
       write(nfout,'(" !! F_ZAJ_filetype         = ",a12)') F_ZAJ_filetype
       write(nfout,'(" !! F_CHGT_filetype        = ",a12)') F_CHGT_filetype
       write(nfout,'(" !! F_CNTN_BIN_filetype    = ",a12)') F_CNTN_BIN_filetype
       write(nfout,'(" !! F_CNTN_filetype        = ",a12)') F_CNTN_filetype
       write(nfout,'(" !! F_ZAJ_in_filetype      = ",a12)') F_ZAJ_in_filetype
       write(nfout,'(" !! F_CHGT_in_filetype     = ",a12)') F_CHGT_in_filetype
       write(nfout,'(" !! F_CNTN_BIN_in_filetype = ",a12)') F_CNTN_BIN_in_filetype
       write(nfout,'(" !! F_CNTN_in_filetype     = ",a12)') F_CNTN_in_filetype

! ======================== KT_add ================= 13.0D
       write(nfout,'(" !! F_CNTN_BIN_PAW_in_filetype     = ",a12)') &
            &                            F_CNTN_BIN_PAW_in_filetype
! ================================================= 13.0D
    end if

    call strncmp0('partitioned',trim(F_ZAJ_filetype),     F_ZAJ_partitioned)
    call strncmp0('partitioned',trim(F_CHGT_filetype),    F_CHGT_partitioned)
    call strncmp0('partitioned',trim(F_CNTN_BIN_filetype),F_CNTN_BIN_partitioned)
    call strncmp0('partitioned',trim(F_CNTN_filetype),    F_CNTN_partitioned)
    call strncmp0('partitioned',trim(F_ZAJ_in_filetype),     F_ZAJ_in_partitioned)
    call strncmp0('partitioned',trim(F_CHGT_in_filetype),    F_CHGT_in_partitioned)
    call strncmp0('partitioned',trim(F_CNTN_BIN_in_filetype),F_CNTN_BIN_in_partitioned)
    call strncmp0('partitioned',trim(F_CNTN_in_filetype),    F_CNTN_in_partitioned)

! ======================== KT_add ================= 13.0D
    call strncmp0('partitioned',trim(F_CNTN_BIN_PAW_in_filetype),&
         &                                  F_CNTN_BIN_PAW_in_partitioned )
! ================================================= 13.0D

    if(npes > 1) then
       if(printable) then
          write(nfout,*) ' !! F_ZAJ_partitioned         = ',F_ZAJ_partitioned
          write(nfout,*) ' !! F_CHGT_partitioned        = ',F_CHGT_partitioned
          write(nfout,*) ' !! F_CNTN_BIN_partitioned    = ',F_CNTN_BIN_partitioned
          write(nfout,*) ' !! F_CNTN_partitioned        = ',F_CNTN_partitioned
          write(nfout,*) ' !! F_ZAJ_in_partitioned      = ',F_ZAJ_in_partitioned
          write(nfout,*) ' !! F_CHGT_in_partitioned     = ',F_CHGT_in_partitioned
          write(nfout,*) ' !! F_CNTN_BIN_in_partitioned = ',F_CNTN_BIN_in_partitioned
          write(nfout,*) ' !! F_CNTN_in_partitioned     = ',F_CNTN_in_partitioned
       end if
    end if

    goto 1006
1005 continue
    if(printable) write(nfout,'(" !! mpifiletypes is not read")')
1006 continue

    F_ZAJ_in      = F_ZAJ
    F_CHGT_in     = F_CHGT
    F_CNTN_BIN_in = F_CNTN_BIN
    F_CNTN_in     = F_CNTN

! ======================== KT_add ================= 13.0D
    F_CNTN_BIN_PAW_in = F_CNTN_BIN_PAW
! ================================================= 13.0D

    if(npes > 1) then
       name_length = 12
       imax = int(log10(dble(npes-1)))+1
       if(imax < min_ext_length_mype) imax = min_ext_length_mype
       if(imax > name_length) then
          stop ' number of pes (=npes) is larger than 1,000,000,000,000'
       end if
       write(name_mype,'(i12)') mype
       do i = 1+name_length-imax, name_length
          if(name_mype(i:i) == ' ') name_mype(i:i)='0'
       enddo
!!$       do i = 1, 4
!!$          if(name_mype(i:i) == ' ') name_mype(i:i) = '0'
!!$       end do
       if(F_ZAJ_partitioned)      call add_name_mype(F_ZAJ)
       if(F_CHGT_partitioned)     call add_name_mype(F_CHGT)
       if(F_CNTN_BIN_partitioned) call add_name_mype(F_CNTN_BIN)
       if(F_CNTN_partitioned)     call add_name_mype(F_CNTN)
       if(F_ZAJ_in_partitioned)      call add_name_mype(F_ZAJ_in)
       if(F_CHGT_in_partitioned)     call add_name_mype(F_CHGT_in)
       if(F_CNTN_BIN_in_partitioned) call add_name_mype(F_CNTN_BIN_in)
       if(F_CNTN_in_partitioned)     call add_name_mype(F_CNTN_in)

! ======================== KT_add ================= 13.0D
       if (F_CNTN_BIN_PAW_in_partitioned) call add_name_mype(F_CNTN_BIN_PAW_in)
! ================================================= 13.0D

    end if

    if(printable) write(nfout,'(" F_POT(1) = ",a60)') F_POT(1)
    !!$ print *, ' paramset = ',paramset

    if(paramset) call read_file_names_data_paramset

!!$    file_existance_contfiles = .true.
!!$    file_existance_3contfiles = .true.

!!$    inquire(file=F_CNTN_in,exist = existance)
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_CNTN_in,exist = existance)
    else
       inquire(file=F_CNTN_in,exist = existance)
    end if

    if(.not.F_CNTN_in_partitioned .and. npes >1) call mpi_bcast(existance,1,mpi_logical,0,mpi_comm_group,ierr)
!!345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
!!$    if(.not.existance) file_existance_contfiles = .false.
!!$    if(.not.existance) file_existance_3contfiles = .false.
    file_existance_nfcntn = existance

!!$    inquire(file=F_CNTN_BIN_in, exist = existance)
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_CNTN_BIN_in, exist = existance)
    else
       inquire(file=F_CNTN_BIN_in, exist = existance)
    end if
    if(.not.F_CNTN_BIN_in_partitioned .and. npes >1) call mpi_bcast(existance,1,mpi_logical,0,mpi_comm_group,ierr)
!!$    if(.not.existance) file_existance_contfiles = .false.
    file_existance_nfcntn_bin = existance

!!$    inquire(file=F_ZAJ_in, exist = existance)
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_ZAJ, exist = existance)
    else
       inquire(file=F_ZAJ_in, exist = existance)
    end if
    if(.not.F_ZAJ_in_partitioned .and. npes >1) call mpi_bcast(existance,1,mpi_logical,0,mpi_comm_group,ierr)
!!$    if(.not.existance) file_existance_contfiles = .false.
!!$    if(.not.existance) file_existance_3contfiles = .false.
    file_existance_nfzaj = existance

!!$    inquire(file=F_CHGT_in, exist = existance)
    if(sw_wdir == ON) then
       inquire(file=trim(workdir)//F_CHGT, exist = existance)
    else
       inquire(file=F_CHGT_in, exist = existance)
    end if
    if(.not.F_CHGT_in_partitioned .and. npes >1) call mpi_bcast(existance,1,mpi_logical,0,mpi_comm_group,ierr)
!!$    if(.not.existance) file_existance_contfiles = .false.
!!$    if(.not.existance) file_existance_3contfiles = .false.
    file_existance_nfchgt = existance

    
    if(npes > 1) then
       npartitioned_files = 0
       if(F_CNTN_in_partitioned)     npartitioned_files = npartitioned_files+1
       if(F_CNTN_BIN_in_partitioned) npartitioned_files = npartitioned_files+1
       if(F_ZAJ_in_partitioned)      npartitioned_files = npartitioned_files+1
       if(F_CHGT_in_partitioned)     npartitioned_files = npartitioned_files+1
       if(printable) write(nfout,'(" !! npartitioned_files = ",i5)') npartitioned_files
       if(npartitioned_files >=1) then
          allocate(file_existance(0:npes-1,npartitioned_files))
          allocate(file_existance_local(npartitioned_files))
          file_existance_local = 0
          j = 0
          if(F_CNTN_in_partitioned ) then
             j = j+1; if(file_existance_nfcntn)     file_existance_local(j) = 1
          end if
          if(F_CNTN_BIN_in_partitioned) then
             j = j+1; if(file_existance_nfcntn_bin) file_existance_local(j) = 1
          end if
          if(F_ZAJ_in_partitioned) then
             j = j+1; if(file_existance_nfzaj)      file_existance_local(j) = 1
          end if
          if(F_CHGT_in_partitioned) then
             j = j+1; if(file_existance_nfchgt)     file_existance_local(j) = 1
          end if

#ifdef FFT_ALLTOALL
          call mpi_gather(file_existance_local, npartitioned_files, mpi_integer, &
                          file_existance, npartitioned_files, mpi_integer, &
                          0, mpi_comm_group, ierr)
#else
          do i = 0, npes-1
             if(i >= 1) then
                if(mype == i ) then
                   call mpi_send(file_existance_local,npartitioned_files,mpi_integer,0,1,mpi_comm_group,ierr)
                else if(mype == 0) then
                   call mpi_recv(file_existance_local,npartitioned_files,mpi_integer,i,1,mpi_comm_group,istatus,ierr)
                end if
             end if
             if(mype == 0) file_existance(i,1:npartitioned_files) = file_existance_local(1:npartitioned_files)
         end do
#endif
       end if

       if(mype == 0) then
          j = 0
          if(F_CNTN_in_partitioned) then
             j = j+1; call check_file_existance_all(j,existance_all); file_existance_nfcntn = existance_all
          end if
          if(F_CNTN_BIN_in_partitioned) then
             j = j+1; call check_file_existance_all(j,existance_all); file_existance_nfcntn_bin = existance_all
          end if
          if(F_ZAJ_in_partitioned) then
             j = j+1; call check_file_existance_all(j,existance_all); file_existance_nfzaj = existance_all
          end if
          if(F_CHGT_in_partitioned) then
             j = j+1; call check_file_existance_all(j,existance_all); file_existance_nfchgt = existance_all
          end if
       end if

       if(npartitioned_files >= 1) then
          deallocate(file_existance_local)
          deallocate(file_existance)
       end if
    end if

    file_existance_contfiles = .true.
    if(.not.file_existance_nfcntn)     file_existance_contfiles = .false.
    if(printable) write(nfout,'(" file_existance_nfcntn     = ",L3," file_existance_contfiles = ",L3)') &
         & file_existance_nfcntn, file_existance_contfiles
    if(.not.file_existance_nfcntn_bin) file_existance_contfiles = .false.
    if(printable) write(nfout,'(" file_existance_nfcntn_bin = ",L3," file_existance_contfiles = ",L3)') &
         & file_existance_nfcntn_bin, file_existance_contfiles
    if(.not.file_existance_nfzaj)      file_existance_contfiles = .false.
    if(printable) write(nfout,'(" file_existance_nfzaj      = ",L3," file_existance_contfiles = ",L3)') &
         & file_existance_nfzaj, file_existance_contfiles
    if(.not.file_existance_nfchgt)     file_existance_contfiles = .false.
    if(printable) write(nfout,'(" file_existance_nfchgt     = ",L3," file_existance_contfiles = ",L3)') &
         & file_existance_nfchgt, file_existance_contfiles

    file_existance_3contfiles = .true.
    if(.not.file_existance_nfcntn)     file_existance_3contfiles = .false.
    if(.not.file_existance_nfzaj)      file_existance_3contfiles = .false.
    if(.not.file_existance_nfchgt)     file_existance_3contfiles = .false.

    if(printable) then
       write(nfout,'(" --- existance check of continue files ---")')
       call check_file_existance('F_CNTN    ',F_CNTN_in,file_existance_nfcntn)
       call check_file_existance('F_CNTN_BIN',F_CNTN_BIN_in,file_existance_nfcntn_bin)
       call check_file_existance('F_ZAJ     ',F_ZAJ_in,file_existance_nfzaj)
       call check_file_existance('F_CHGT    ',F_CHGT_in,file_existance_nfchgt)
       call check_file_existance('contfiles ','continue files',file_existance_contfiles)
       call check_file_existance('3contfiles','3continue files',file_existance_3contfiles)
       write(nfout,'(" -----------------------------------------")')
    end if
    if(existance) close(nffile,status='keep')
  contains
    subroutine add_name_mype(F)
      character(len=*), intent(inout) :: F
      integer :: ls
      ls = len(trim(F))
!!$      if(ls+5 > stringlength_of_filenames) then
      if(ls+imax+1 > stringlength_of_filenames) then
         F = F(1:stringlength_of_filenames-(imax+1))//'_'//name_mype(name_length-imax+1:name_length)
      else
         F = F(1:ls)//'_'//name_mype(name_length-imax+1:name_length)
      end if
    end subroutine add_name_mype

    subroutine check_file_existance_all(npfile,tf)
      integer, intent(in)  :: npfile
      logical, intent(out) :: tf
      integer :: i
      tf = .true.
      do i = 0, npes-1
         if(file_existance(i,npfile) == 0) then
            tf = .false.
            exit
         end if
      end do
    end subroutine check_file_existance_all

    subroutine check_file_existance(tagname,filename,torf)
      character(len=10),intent(in) :: tagname
      character(len=*), intent(in) :: filename
      logical, intent(in) ::          torf
      integer :: ls
      character(len=12) :: exist_or_not

      if(torf) then
         exist_or_not = 'existing'
      else
         exist_or_not = 'not existing'
      end if

      ls = len(trim(filename))
      write(nfout,*) tagname," (= ",trim(filename)," ) ", trim(exist_or_not)
    end subroutine check_file_existance
  end subroutine m_Files_check_file_existance

  function m_Files_check_nfzaj_existance()
    logical m_Files_check_nfzaj_existance
    m_Files_check_nfzaj_existance = file_existance_nfzaj
  end function m_Files_check_nfzaj_existance

  function m_Files_check_nfchgt_existance()
    logical m_Files_check_nfchgt_existance
    m_Files_check_nfchgt_existance = file_existance_nfchgt
  end function m_Files_check_nfchgt_existance
  subroutine m_Files_check_file_names()
    if(printable) then
       write(nfout,'(" --- check of file_names ---")')
       call repeat_filename('F_INP     ',F_INP)
       call repeat_filename('F_POT(1)  ',F_POT(1))
       call repeat_filename('F_POT(2)  ',F_POT(2))
       call repeat_filename('F_POT(3)  ',F_POT(3))
!!$       write(nfout,'(" F_INP      = ", a60)') F_INP
!!$       write(nfout,'(" F_POT(1)   = ", a60)') F_POT(1)
!!$       write(nfout,'(" F_POT(2)   = ", a60)') F_POT(2)
!!$       write(nfout,'(" F_POT(3)   = ", a60)') F_POT(3)
!!$       call repeat_filename('F_CNST    ',F_CNST)
       call repeat_filename('F_KPOINT  ',F_KPOINT)
       call repeat_filename('F_CHGT    ',F_CHGT_in)
       call repeat_filename('F_CNTN    ',F_CNTN_in)
       call repeat_filename('F_CNTN_BIN',F_CNTN_BIN_in)
       call repeat_filename('F_ZAJ     ',F_ZAJ_in)
       call repeat_filename('F_STOP    ',F_STOP)
!!$       write(nfout,'(" F_CNST     = ", a60)') F_CNST
!!$       write(nfout,'(" F_CHGT     = ", a60)') F_CHGT
!!$!!$    write(nfout,'(" F_MATBP    = ", a60)') F_MATBP
!!$       write(nfout,'(" F_KPOINT   = ", a60)') F_KPOINT
!!$!!$       write(nfout,'(" F_KINDEX   = ", a60)') F_KINDEX
!!$       write(nfout,'(" F_CNTN     = ", a60)') F_CNTN
!!$       write(nfout,'(" F_CNTN_BIN = ", a60)') F_CNTN_BIN
!!$       write(nfout,'(" F_ZAJ      = ", a60)') F_ZAJ

!!$       if(ekmode==ON) write(nfout,'(" F_ENERG    = ", a60)') F_ENERG
       if(ekmode==ON) call repeat_filename('F_ENERG   ',F_ENERG)

       write(nfout,'(" F_NEB_OUT   = ", a60)') F_NEB_OUT
       write(nfout,'(" F_IMAGE(0)  = ", a60)') F_IMAGE(0)
       write(nfout,'(" F_IMAGE(-1) = ", a60)') F_IMAGE(-1)

! ======================== KT_mod ================= 13.0D
!!       write(nfout,'(" F_CNTN_BIN_PAW = ", a60)') F_CNTN_BIN_PAW
       call repeat_filename('F_CNTN_BIN_PAW',F_CNTN_BIN_PAW_in)
! ================================================= 13.0D

    end if
  contains
    subroutine repeat_filename(tagname,filename)
      character(len=*), intent(in) :: tagname
      character(len=*),  intent(in) :: filename
      integer :: ls
      character(len=10) :: tagname2
      ls = len(trim(tagname))
      if(ls < 10) then
         tagname2 = "          "
         tagname2 = trim(tagname)
         write(nfout,'(1x,a10,a3,a)') tagname2, " = ", trim(filename)
      else
         write(nfout,*) trim(tagname)," = ", trim(filename)
      end if
    end subroutine repeat_filename
  end subroutine m_Files_check_file_names

  subroutine read_file_names_data_paramset
    logical ::   existance
    integer, parameter :: nffile = 5
    if(sw_wdir==ON)then
      inquire(file=trim(workdir)//F_file_names_data, exist = existance)
    else
      inquire(file=F_file_names_data, exist = existance)
    endif
    if(existance) then
       call open0(nffile,F_file_names_data,'FFILENAMES',old,formatted,check_file_name_off)
       rewind nffile
       read(nffile,NML = f_param_name, err = 1004, end = 1004)
1004   continue
       close(nffile,status='keep')
    end if

  end subroutine read_file_names_data_paramset

  subroutine m_Files_echo_nfinp()
     character(len=1024) :: buf
     if(printable)then
        write(nfout,'(a)') 
        write(nfout,'(a)') ' !** contents of the input parameter file : '//trim(F_INP)
        if(sw_wdir==ON)then
           open(nfinp,file=trim(workdir)//trim(F_INP),status='old')
        else
           open(nfinp,file=trim(F_INP),status='old')
        endif
        do
           read(nfinp,'(a)',end=1000,err=1000) buf
           write(nfout,'(a)') trim(buf)
        enddo
1000    continue
        write(nfout,'(a)') ' !**'
        close(nfinp)
     endif
  end subroutine m_Files_echo_nfinp

  subroutine m_Files_reopen_nfinp(mode)
    integer, intent(in) :: mode
    logical :: open
    integer :: iret, f_closeInputFile, f_openInputFile, ierror
    if(mode == 1) then
       inquire(unit = nfinp, opened = open)
       if(open) close(nfinp,status='keep')
       if(printable) write(nfout,'(" !!  F_INP = ",a32)') F_INP
!!$       iret = f_openInputFile('./testinp.data')
!!$       iret = f_openInputFile(F_INP)
       if(sw_wdir == ON) then
          iret = f_openInputFile(trim(workdir)//F_INP)
       else
          iret = f_openInputFile(F_INP)
       end if
       if( iret < 0) then
          if(printable) write(nfout,'(" !!! Error in opening of inputfile: ",a32)') F_INP
!!$          stop ' stop at << m_Files_reopen_nfinp >>'
       else if(iret > 0) then
          if(printable) write(nfout,'(" !!! There is something wrong in the input file: ",a32)') F_INP
       end if
       if(iret/=0) then
          ierror = ERROR_IN_INPUTFILE_OPENING
          if(sw_wdir == ON) then
             call phase_error(ierror,nfout,nfinp,trim(workdir)//F_INP)
          else
             call phase_error(ierror,nfout,nfinp,F_INP)
          end if
       end if
    else
       iret = f_closeInputFile()
       call open0(nfinp, F_INP, 'F_INP     ',    old,   formatted,check_file_name_on)
    end if
  end subroutine m_Files_reopen_nfinp

#ifndef _EMPIRICAL_
  subroutine m_Files_reopen_nfzaj
    logical :: open
    inquire(unit=nfzaj,opened=open)
    if(open) close(nfzaj,status='keep')

    if(F_ZAJ_partitioned) then
       if(mype == 0) then
          call open0(nfzaj, F_ZAJ, 'F_ZAJ     ',unknown, unformatted,check_file_name_on)
       else
          call open0(nfzaj, F_ZAJ, 'F_ZAJ     ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open0(nfzaj, F_ZAJ, 'F_ZAJ     ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_reopen_nfzaj

  subroutine m_Files_reopen_nfchgt()
    logical :: open
    inquire(unit=nfchgt,opened=open)
    if(open) close(nfchgt,status='keep')

    if(F_CHGT_partitioned) then
       if(mype == 0) then
          call open0(nfchgt, F_CHGT, 'F_CHGT    ',unknown, unformatted,check_file_name_on)
       else
          call open0(nfchgt, F_CHGT, 'F_CHGT    ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open0(nfchgt, F_CHGT, 'F_CHGT    ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_reopen_nfchgt
#endif

  subroutine m_Files_open_nfzaj()
    if(F_ZAJ_in_partitioned) then
       if(mype == 0) then
          call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
       else
          call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfzaj

  subroutine m_Files_open_nfzaj_with_check()
    logical :: open
    if(F_ZAJ_in_partitioned) then
       if(mype == 0) then
          inquire(unit=nfzaj,opened=open)
          if(.not.open) call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
       else
          inquire(unit=nfzaj,opened=open)
          if(.not.open) call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) then
          inquire(unit=nfzaj,opened=open)
          if(.not.open) call open0(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
       end if
    end if
! ================================ modified by K. Tagami =========== 11.0
!    if(open .and.mype==0) then
    if ( mype==0 .and. open ) then
! =================================================================== 11.0
       write(nfout,'(" nfzaj is opened")')
    end if
  end subroutine m_Files_open_nfzaj_with_check

  subroutine m_Files_open_nfzaj_append()
    if(F_ZAJ_in_partitioned) then
       if(mype == 0) then
          call open1(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
       else
          call open1(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open1(nfzaj, F_ZAJ_in, 'F_ZAJ_in  ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfzaj_append

  subroutine m_Files_open_nfchgt()
    if(F_CHGT_in_partitioned) then
       if(mype == 0) then
          call open0(nfchgt,F_CHGT_in,'F_CHGT_in ',unknown, unformatted,check_file_name_on)
       else
          call open0(nfchgt,F_CHGT_in,'F_CHGT_in ',unknown, unformatted,check_file_name_off)
       end if
    else
       if(mype==0) call open0(nfchgt,F_CHGT_in,'F_CHGT_in ',unknown, unformatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfchgt

  subroutine m_Files_open_files_initially
    call open0(nfinp, F_INP, 'F_INP     ',    old,   formatted,check_file_name_on)

    if(ekmode==ON) then
       if(mype==0) call open0(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
    else
       if(file_existance_contfiles) then
          if(mype==0) call open1(nfdynm,F_DYNM,'F_DYNM    ',unknown,   formatted,check_file_name_on)
          if(mype==0) call open1(nfenf, F_ENF, 'F_ENF     ',unknown,   formatted,check_file_name_on)
       else
          if(mype==0) call open0(nfdynm,F_DYNM,'F_DYNM    ',unknown,   formatted,check_file_name_on)
          if(mype==0) call open0(nfenf, F_ENF, 'F_ENF     ',unknown,   formatted,check_file_name_on)
       end if
    end if
!!$    if(mype == 0) then
!!$       if(iprijobstatus >= 1) then
!!$          F_STATUS = 'jobstatus'//name_jobstep
!!$          open(nfstatus, file=F_STATUS, status='unknown',form='formatted')
!!$       end if
!!$    end if
  end subroutine m_Files_open_files_initially

  subroutine m_Files_open_nfdynm_cif_initially
    if(.not.file_existance_contfiles) call m_Files_check_file_existance()
    if(file_existance_contfiles) then
       if(mype==0.and.sw_cif_output==ON) &
           &       call open1(nfdynm_cif,F_DYNM_CIF,'F_DYNM_CIF',unknown,formatted,check_file_name_on)
    else
       if(mype==0.and.sw_cif_output==ON) &
           &       call open0(nfdynm_cif,F_DYNM_CIF,'F_DYNM_CIF',unknown,formatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfdynm_cif_initially

  subroutine m_Files_open_pcont_files_ini()
    if(.not.file_existance_contfiles) call m_Files_check_file_existance()
    if(file_existance_contfiles) then 
       if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL .and. mype == 0) then
          call open1(nflatconst,F_LATCONST,'F_LATCONST',unknown,   formatted,check_file_name_on)
          call open1(nfmetric, F_METRIC,   'F_METRIC  ',unknown,   formatted,check_file_name_on)
       endif
    else
       if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL .and. mype == 0)then
          call open0(nflatconst,F_LATCONST,'F_LATCONST',unknown,   formatted,check_file_name_on)
          call open0(nfmetric, F_METRIC,   'F_METRIC  ',unknown,   formatted,check_file_name_on)
          write(nflatconst,*) '#iteration a b c alpha beta gamma vol'
          write(nfmetric,*) '#iteration'
          write(nfmetric,*) '#m11 m12 m13'
          write(nfmetric,*) '#m21 m22 m23'
          write(nfmetric,*) '#m31 m32 m33'
       endif
    endif
  end subroutine m_Files_open_pcont_files_ini

  subroutine m_Files_flush_nfdynm()
    if(mype==0) then
       close(nfdynm,status='keep')
       call open1(nfdynm,F_DYNM,'F_DYNM    ',unknown,   formatted,check_file_name_on)
       if(sw_cif_output==ON)then
          close(nfdynm_cif,status='keep')
          call open1(nfdynm_cif,F_DYNM_CIF,'F_DYNM_CIF',unknown,   formatted,check_file_name_on)
       endif
    end if
  end subroutine m_Files_flush_nfdynm

  subroutine m_Files_flush_pcontrol_files
    if(mype==0)then
       close(nflatconst,status='keep')
       call open1(nflatconst,F_LATCONST,'F_LATCONST',unknown,   formatted,check_file_name_on)
       close(nfmetric,status='keep')
       call open1(nfmetric,F_METRIC,  'F_METRIC  ',unknown,   formatted,check_file_name_on)
    endif
  end subroutine m_Files_flush_pcontrol_files

  subroutine m_Files_flush_nfenf()
    if(mype==0) then
       close(nfenf,status='keep')
       call open1(nfenf, F_ENF,'F_ENF     ',unknown,   formatted,check_file_name_on)
    end if
  end subroutine m_Files_flush_nfenf

  subroutine m_Files_close_files_initial0
    logical :: open
    if(ekmode==ON) then
       if(mype==0) then
          inquire(unit=nfeng, opened=open)
          if(open) close(nfeng,status='keep')
       end if
    else
       if(mype==0) then
          inquire(unit=nfdynm,opened=open)
          if(open) close(nfdynm,status='keep')
          inquire(unit=nfenf,opened=open)
          if(open) close(nfenf,status='keep')
          if(sw_cif_output==ON)then
            inquire(unit=nfdynm_cif,opened=open)
            if(open) close(nfdynm_cif,status='keep')
          endif
          if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL)then
            inquire(unit=nflatconst,opened=open)
            if(open) close(nflatconst,status='keep')
            inquire(unit=nfmetric,opened=open)
            if(open) close(nfmetric,status='keep')
          endif
       end if
    end if
  end subroutine m_Files_close_files_initial0

  subroutine m_Files_open_nfeng(icond)
    integer, intent(in) :: icond
    logical :: open
    if(mype==0) then
       inquire(unit = nfeng, opened = open)
       if(open) close(nfeng)
       if(icond == FIXED_CHARGE .or. &
            & (icond==FIXED_CHARGE_CONTINUATION .and. fixed_charge_k_parallel==ALL_AT_ONCE)) then
          call open0(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
       else if(icond==FIXED_CHARGE_CONTINUATION .and. fixed_charge_k_parallel==ONE_BY_ONE) then
          call open1(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
       else if(icond == INITIAL) then
          call open0(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
       else
          call open1(nfeng, F_ENERG,'F_ENERG   ',unknown,formatted,check_file_name_on)
       end if
    end if
  end subroutine m_Files_open_nfeng

  subroutine m_Files_close_nfeng()
    logical :: open
    if(mype==0) then
       inquire(unit=nfeng, opened = open)
       if(open) close(nfeng)
    end if
  end subroutine m_Files_close_nfeng

! ===
  subroutine m_Files_open_nfwfk_orb_proj(icond)
    integer, intent(in) :: icond
    logical :: open

    if (mype==0) then
       inquire(unit = nfwfk_orb_proj, opened = open)

       if (open) close(nfwfk_orb_proj)

       if (icond == FIXED_CHARGE .or. &
            & (icond==FIXED_CHARGE_CONTINUATION &
            &   .and. fixed_charge_k_parallel==ALL_AT_ONCE)) then
          call open0( nfwfk_orb_proj, F_WFK_ORB_PROJ, 'F_WFK_ORB_PROJ',&
               &      unknown, formatted, check_file_name_on )
       else if (icond==FIXED_CHARGE_CONTINUATION &
            &        .and. fixed_charge_k_parallel==ONE_BY_ONE) then
          call open1( nfwfk_orb_proj, F_WFK_ORB_PROJ, 'F_WFK_ORB_PROJ', &
               &      unknown,formatted, check_file_name_on )
       else
          call open1( nfwfk_orb_proj, F_WFK_ORB_PROJ, 'F_WFK_ORB_PROJ', &
               &      unknown,formatted, check_file_name_on )
       end if
    end if
  end subroutine m_Files_open_nfwfk_orb_proj

  subroutine m_Files_close_nfwfk_orb_proj()
    logical :: open

    if (mype==0) then
       inquire( unit=nfwfk_orb_proj, opened = open )
       if(open) close( nfwfk_orb_proj )
    end if
  end subroutine m_Files_close_nfwfk_orb_proj

  subroutine m_Files_open_nfband_spwt(icond)
    integer, intent(in) :: icond
    logical :: open

    if (mype==0) then
       inquire(unit = nfband_spectr_wght, opened = open)

       if (open) close(nfband_spectr_wght)

       if (icond == FIXED_CHARGE .or. &
            & (icond==FIXED_CHARGE_CONTINUATION &
            &   .and. fixed_charge_k_parallel==ALL_AT_ONCE)) then
          call open0( nfband_spectr_wght, F_BAND_SPECTR_WGHT, 'F_BAND_SPECTR_WGHT',&
               &      unknown, formatted, check_file_name_on )
       else if (icond==FIXED_CHARGE_CONTINUATION &
            &        .and. fixed_charge_k_parallel==ONE_BY_ONE) then
          call open1( nfband_spectr_wght, F_BAND_SPECTR_WGHT, 'F_BAND_SPECTR_WGHT ', &
               &      unknown,formatted, check_file_name_on )
       else
          call open1( nfband_spectr_wght, F_BAND_SPECTR_WGHT, 'F_BAND_SPECTR_WGHT', &
               &      unknown,formatted, check_file_name_on )
       end if
    end if
  end subroutine m_Files_open_nfband_spwt

  subroutine m_Files_close_nfband_spwt()
    logical :: open

    if (mype==0) then
       inquire( unit=nfband_spectr_wght, opened = open )
       if(open) close( nfband_spectr_wght )
    end if
  end subroutine m_Files_close_nfband_spwt
! ====
  logical function m_Files_nfinp_is_opened()
    logical :: op
    integer :: ierr
    op = .false.
    if(mype == 0) then
       inquire(unit = nfinp, opened = op)
    end if
    call mpi_bcast(op,1,mpi_logical,0,mpi_comm_group,ierr)
    m_Files_nfinp_is_opened = op
  end function m_Files_nfinp_is_opened

  subroutine m_Files_close_nfinp()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfinp, opened = op)
       if(op) close(nfinp)
    end if
  end subroutine m_Files_close_nfinp

  subroutine m_Files_close_nfcntn()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfcntn, opened = op)
       if(op) close(nfcntn)
    end if
  end subroutine m_Files_close_nfcntn

  subroutine m_Files_open_nfdos(iter,reacid)
    integer,intent(in),optional :: iter
    integer, intent(in), optional :: reacid
    character(len=256) :: striter
    character(len=105) :: retstr,retstr0
    logical :: op
    if(mype==0)then
       inquire(unit = nfdos, opened = op)
       if(op) close(nfdos)
       if(.not.present(iter))then
           call open0(nfdos,F_DOS,'F_DOS     ',unknown,formatted,check_file_name_on)
       else
           write(striter,*) iter
           call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_DOS,retstr)
           if(present(reacid))then
              write(striter,*) reacid
              call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
              retstr = retstr0
           endif
           call open0(nfdos,retstr,'F_DOS     ',unknown,formatted,check_file_name_on)
       endif
    endif
  end subroutine m_Files_open_nfdos

  subroutine m_Files_open_nfegrid()
    if(mype==0) call open0(nfegrid,F_EGRID,'F_EGRID   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfegrid

  subroutine m_Files_open_nfldos()
    if(mype==0) call open0(nfldos,F_LDOS,'F_LDOS    ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfldos

  subroutine m_Files_close_nfldos()
    logical :: open
    if(mype==0) then
       inquire(unit=nfldos,opened=open)
       if(open) close(nfldos,status='keep')
    end if
  end subroutine m_Files_close_nfldos
    

!!$  subroutine m_Files_close_nfdos()
!!$    logical :: open
!!$    if(mype==0) then
!!$       inquire(unit=nfdos,opened=open)
!!$       if(open) close(nfdos,status='keep')
!!$    end if
!!$  end subroutine m_Files_close_nfdos

  subroutine m_Files_skiptoend(nf)
    integer, intent(in) :: nf
    if(mype == 0) then
1      continue
       read(nf,*, err=2, end=2)
       goto 1
2      continue
       backspace nf
    end if
  end subroutine m_Files_skiptoend

  subroutine m_Files_open_files_initially_p
    call open0(nfinp, F_INP, 'F_INP     ',    old,   formatted,check_file_name_on)
    call open0(nfprm, F_PRM, 'F_PRM     ',unknown,   formatted,check_file_name_on)
  end subroutine m_Files_open_files_initially_p


  subroutine m_Files_close_all_paramset
    close(nfinp,status='keep')
    close(nfprm,status='keep')
  end subroutine m_Files_close_all_paramset

  subroutine open0(nfile,filename,tagname,status, form, write_or_no)
    integer, intent(in) :: nfile
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: tagname
    integer, intent(in) :: status, form, write_or_no
    logical             :: open
    character(len=5) ::    torf
    character(len=14) ::   filestatus
    integer ::             ls,ierror
    logical :: existance

    character(len=50) :: wd

    inquire(unit = nfile, opened = open)

    wd = workdir
!!$    write(6,'(" workdir = ",a)') workdir
    ls = min(max(index(filename,' ')-1,1),stringlength_of_filenames)

    if(.not.open) then
       inquire(file=trim(wd)//filename(1:ls), exist=existance)
       if(status==old .and. .not.existance) then
          ierror = FILE_NOT_EXIST
#ifdef DEBUG_ERRORS
          call phase_error(ierror,nfout,nfile,trim(wd)//filename(1:ls), &
               & __LINE__,__FILE__)
#else
          call phase_error(ierror,nfout,nfile,trim(wd)//filename(1:ls))
#endif
       else
          if(status==old .and. form==formatted) then
             open(nfile,file=trim(wd)//filename(1:ls), status='old', form='formatted')
          else if(status==old .and. form==unformatted) then
             open(nfile,file=trim(wd)//filename(1:ls), status='old', form='unformatted')
          else if(status==unknown .and. form==formatted) then
             open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='formatted')
          else if(status==unknown .and. form==unformatted) then
             open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='unformatted')
          endif
       end if
       torf = 'false'
       filestatus = 'newly opened'
    else
       torf = 'true '
       filestatus = 'already opened'
    end if

!!$    ls = len(trim(wd)//trim(filename))
    if(write_or_no == check_file_name_on .and. printable) then
       if(len(tagname) <= 10) then
          write(nfout,'(1x,a10,a3,a,a3,a)') tagname, " = ", trim(filename(1:ls))," , ",filestatus
       else
          write(nfout,'(1x,a,a3,a,a3,a)') trim(tagname), " = ", trim(filename(1:ls))," , ",filestatus
       end if
    endif
  end subroutine open0

  subroutine open1(nfile,filename,tagname,status, form, write_or_no)
    integer, intent(in) :: nfile
    character(len=*), intent(in) :: filename
    character(len=*), intent(in) :: tagname
    integer, intent(in) :: status, form, write_or_no
    logical             :: open
    character(len=5) ::    torf
    character(len=14) ::   filestatus
    integer ::             ls

    character(len=50) :: wd

    inquire(unit = nfile, opened = open)

    wd = workdir

!!$    ls = index(filename,' ')-1
!!$    ls = min(max(ls,1),stringlength_of_filenames)
    ls = min(max(index(filename,' ')-1,1),stringlength_of_filenames)

    if(.not.open) then
       if(status==old .and. form==formatted) then
          open(nfile,file=trim(wd)//filename(1:ls), status='old', form='formatted', position='append')
       else if(status==old .and. form==unformatted) then
          open(nfile,file=trim(wd)//filename(1:ls), status='old', form='unformatted', position='append')
       else if(status==unknown .and. form==formatted) then
          open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='formatted', position='append')
       else if(status==unknown .and. form==unformatted) then
          open(nfile,file=trim(wd)//filename(1:ls), status='unknown', form='unformatted', position='append')
       endif
       torf = 'false'
       filestatus = 'newly opened'
    else
       torf = 'true '
       filestatus = 'already opened'
    end if

!!$    ls = len(trim(wd)//trim(filename))
    if(write_or_no == check_file_name_on .and. printable) then
       if(len(tagname)<=10) then
          write(nfout,'(1x,a10,a3,a,a3,a)') tagname," = ",trim(filename(1:ls))," , ",filestatus
       else
          write(nfout,'(1x,a,a3,a,a3,a)') trim(tagname)," = ",trim(filename(1:ls))," , ",filestatus
       end if
    endif
  end subroutine open1

  subroutine m_Files_close_and_clear_nfstop()
    logical :: open
    inquire(unit = nfstop, opened = open)
    if(open) then
       if(sw_wdir==ON) then
          open(nfstop, file=trim(workdir)//F_STOP, status='replace', form='formatted')
       else
          open(nfstop, file=F_STOP, status='replace', form='formatted')
       end if
       close(nfstop, status='keep')
    endif
  end subroutine m_Files_close_and_clear_nfstop

  subroutine m_Files_close_all(final_call)
    logical, intent(in), optional :: final_call
    logical :: final_c
    integer :: i
    logical :: open
    final_c = .true.
    if (present(final_call)) final_c = final_call
    do i = 1, number_of_all_files
       if(n_file(i) == 6) cycle
       inquire(unit = n_file(i), opened = open)
       if(open) then
          close(n_file(i),status='keep')
          if(printable) write(nfout,*) ' closed filenumber = ', n_file(i)
	  if (multiple_replica_mode == OFF) then
            if (n_file(i) == nfstop) then
!!$               open(n_file(i), file=F_STOP, status='replace', form='formatted')
               if(sw_wdir==ON) then
                  open(n_file(i), file=trim(workdir)//F_STOP, status='replace', form='formatted')
               else
                  open(n_file(i), file=F_STOP, status='replace', form='formatted')
               end if
               close(n_file(i), status='keep')
            end if
          end if
       else
	  if (multiple_replica_mode == OFF) then
            if (n_file(i) == nfstop .and. mype == 0) then
               if(sw_wdir==ON) then
                  open(n_file(i), file=trim(workdir)//F_STOP, status='replace', form='formatted')
               else
                  open(n_file(i), file=F_STOP, status='replace', form='formatted')
               end if
               close(n_file(i), status='keep')
            end if
          end if
       endif
    enddo

    if(final_c)then
!!$    if(.not.conf_para .or. (conf_para .and. mype_conf==0))then
    if(mype == 0) then
       close(6, status='keep')
    else if(ipriparadeb == 0) then
       close(6, status='delete')
    else
       close(6, status='keep')
    end if

!!$    endif
    endif

  end subroutine m_Files_close_all

  subroutine open_newps_files(ntyp,ierror)
    integer, intent(in)                  :: ntyp
    integer, intent(out)                 :: ierror

    integer :: it, nfp
    logical :: existance

    ierror = 0
    do it = 1, ntyp
       nfp = nfpot(it)
       if(printable) write(nfout,*) ' F_POT(it) = ', F_POT(it)
       if(sw_wdir==ON) then
          inquire(file=workdir//trim(F_POT(it)), exist=existance)
       else
          inquire(file=trim(F_POT(it)), exist=existance)
       end if
       if(.not.existance) then
          ierror = F_POT_FILE_NOT_EXIST
#ifdef DEBUG_ERRORS
          call phase_error(ierror,nfout,nfp,F_POT(it),__LINE__, __FILE__)
#else
          call phase_error(ierror,nfout,nfp,F_POT(it))
#endif
!!$          if(printable) write(nfout,'(" file F_POT(",i3,") does not exist")') it
!!$          if(printable) write(nfout,'(a100)') F_POT(it)
          goto 1001
       end if
       call open0(nfp,F_POT(it),'F_POT     ',OLD,formatted,check_file_name_on)
    enddo
1001 return
  end subroutine open_newps_files

#ifndef _EMPIRICAL_
  subroutine m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
    integer, intent(in)                  :: ntyp
    integer, intent(in), dimension(ntyp) :: ivan
    real(kind=DP), intent(in), dimension(ntyp) :: iatomn
    integer, intent(out)                 :: ierror

    integer     :: nfpp, nfp, it, n_non_vanderbilt, n_pcc, itpcc, check_file_name
    real(kind=DP) :: ival
    real(kind=DP), dimension(2)   :: alp, cc
    logical :: existance

!!$    if(ppprinted) then
!!$       check_file_name = check_file_name_off
!!$    else
!!$       check_file_name = check_file_name_on
!!$    end if
    checK_file_name = check_file_name_off

    ierror = 0
    if(mype /= 0) return
    n_non_Vanderbilt = 0
    n_pcc            = 0
    nfpp             = 0
    do it = 1, ntyp
       if(ivan(it) /= OLD) then
          nfpp = nfpp + 1
          nfp = nfpot(nfpp)
          if(printable .and. .not.ppprinted ) write(nfout,*) ' F_POT(nfpp) = ', trim(F_POT(nfpp))
          if(sw_wdir==ON)then
             inquire(file=trim(workdir)//F_POT(nfpp), exist=existance)
          else
             inquire(file=F_POT(nfpp), exist=existance)
          endif
          if(.not.existance) then
             ierror = F_POT_FILE_NOT_EXIST
#ifdef DEBUG_ERRORS
             call phase_error(ierror,nfout,nfp,F_POT(nfpp),__LINE__, __FILE__)
#else
             call phase_error(ierror,nfout,nfp,(F_POT(nfpp)))
#endif
!!$             if(printable) write(nfout,'(" file F_POT(",i3,") does not exist")') nfpp
!!$             if(printable) write(nfout,'(a100)') F_POT(nfpp)
             goto 1001
          end if
          call open0(nfp,F_POT(nfpp),'F_POT     ',OLD,formatted,check_file_name)
       else if(ivan(it) == OLD) then
          n_non_Vanderbilt = n_non_Vanderbilt + 1
          call psbhs0(nfout,nint(iatomn(it)),ival,itpcc,alp,cc)  ! -(b_PseudoPotential)
          if(itpcc == ON) n_pcc = n_pcc + 1
       endif
    enddo
    if(n_non_Vanderbilt >= 1 ) then
       call open0(nfpkb,F_PKB,'F_PKB     ',OLD,formatted,check_file_name)
       call open0(nfpd, F_PD, 'F_PD      ',OLD,formatted,check_file_name)
       rewind nfpkb
       rewind nfpd
       if(n_pcc >= 1) then
          call open0(nfppc,F_PPC,'F_PPC     ',OLD,formatted,check_file_name)
          rewind nfppc
       endif
    endif
1001 return
  end subroutine m_Files_open_ps_files

  subroutine m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
    integer, intent(in)                  :: ntyp,it
    integer, intent(in), dimension(ntyp) :: ivan
    real(kind=DP), intent(in), dimension(ntyp) :: iatomn
    integer, intent(out)                 :: ierror

    integer     ::  nfp,  n_non_vanderbilt, n_pcc, itpcc, check_file_name
    integer, save :: nfpp=0
    real(kind=DP) :: ival
    real(kind=DP), dimension(2)   :: alp, cc
    logical :: existance

!!$    if(ppprinted) then
!!$       check_file_name = check_file_name_off
!!$    else
!!$       check_file_name = check_file_name_on
!!$    end if
    checK_file_name = check_file_name_off

    ierror = 0
    if(mype /= 0) return
    n_non_Vanderbilt = 0
    n_pcc            = 0
    if(ivan(it) /= OLD) then
       nfpp = nfpp + 1
       nfp = nfpot(nfpp)
       if(printable .and. .not.ppprinted ) write(nfout,*) ' F_POT(nfpp) = ', trim(F_POT(nfpp))
       if(sw_wdir==ON)then
          inquire(file=trim(workdir)//F_POT(nfpp), exist=existance)
       else
          inquire(file=F_POT(nfpp), exist=existance)
       endif
       if(.not.existance) then
          ierror = F_POT_FILE_NOT_EXIST
#ifdef DEBUG_ERRORS
          call phase_error(ierror,nfout,nfp,F_POT(nfpp),__LINE__, __FILE__)
#else
          call phase_error(ierror,nfout,nfp,(F_POT(nfpp)))
#endif
!!$             if(printable) write(nfout,'(" file F_POT(",i3,") does not exist")') nfpp
!!$             if(printable) write(nfout,'(a100)') F_POT(nfpp)
          goto 1001
       end if
       call open0(nfp,F_POT(nfpp),'F_POT     ',OLD,formatted,check_file_name)
    else if(ivan(it) == OLD) then
       n_non_Vanderbilt = n_non_Vanderbilt + 1
       call psbhs0(nfout,nint(iatomn(it)),ival,itpcc,alp,cc)  ! -(b_PseudoPotential)
       if(itpcc == ON) n_pcc = n_pcc + 1
    endif

    if(n_non_Vanderbilt >= 1 ) then
       call open0(nfpkb,F_PKB,'F_PKB     ',OLD,formatted,check_file_name)
       call open0(nfpd, F_PD, 'F_PD      ',OLD,formatted,check_file_name)
       rewind nfpkb
       rewind nfpd
       if(n_pcc >= 1) then
          call open0(nfppc,F_PPC,'F_PPC     ',OLD,formatted,check_file_name)
          rewind nfppc
       endif
    endif

    if(it==ntyp) nfpp = 0
1001 return
  end subroutine m_Files_open_ps_file

  subroutine m_Files_close_ps_files
    integer :: i
    logical :: open
    if(mype /= 0) return
    do i = 1, MAXNSP
       inquire(unit = nfpot(i), opened = open)
       if(open) close(nfpot(i),status='keep')
    enddo
    inquire(unit = nfpkb, opened = open)
    if(open) close(nfpkb,status='keep')
    inquire(unit = nfpd,  opened = open)
    if(open) close(nfpd, status='keep')
    inquire(unit = nfppc, opened = open)
    if(open) close(nfppc,status='keep')
  end subroutine m_Files_close_ps_files

  subroutine m_Files_close_ps_file(it)
    integer, intent(in) :: it
    logical :: open
    inquire(unit = nfpot(it), opened = open)
    if(open) close(nfpot(it),status='keep')
    inquire(unit = nfpkb, opened = open)
    if(open) close(nfpkb,status='keep')
    inquire(unit = nfpd,  opened = open)
    if(open) close(nfpd, status='keep')
    inquire(unit = nfppc, opened = open)
    if(open) close(nfppc,status='keep')
  end subroutine m_Files_close_ps_file
#endif


  subroutine insert_str_before_dot(pref,origstr,retstr)
    character(len=*),intent(in) :: pref
    character(len=*),intent(in) :: origstr
    character(len=105),intent(out) :: retstr
    integer :: lenstr, ip, i
    lenstr = len_trim(origstr)
    ip = lenstr+1
    findingdot: do i = lenstr, 1, -1
      if(origstr(i:i) == '/') then
         exit findingdot
      else if(origstr(i:i) == '.') then
         ip = i-1
         exit findingdot
      end if
    end do findingdot
         
    if(ip >= 1 .and. ip <= lenstr) then
       if(ip+1 <= lenstr) then
          retstr = origstr(1:ip)//trim(adjustl(pref))//origstr(ip+1:lenstr)
       else
          retstr = origstr(1:ip)//trim(adjustl(pref))
       end if
    else
       retstr = origstr(1:lenstr)//trim(adjustl(pref))
    end if
  end subroutine insert_str_before_dot

  subroutine m_Files_open_nfchr(nspin,ispin,iter,reacid)
    integer, intent(in) :: nspin, ispin
    integer, intent(in), optional :: iter
    integer, intent(in), optional :: reacid
    integer :: lenstr, ip, i
    character(len=105) :: F_CHRUD
    character(len=256) :: striter
    character(len=105) :: retstr,retstr0
    logical :: open

    if(mype == 0) then
       if(nspin == 1) then
          inquire(unit=nfchr,opened=open)
          if(open) close(nfchr,status='keep')
          if(.not.present(iter)) then
             call open0(nfchr,F_CHR,'F_CHR     ',unknown,formatted,check_file_name_on)
          else
             write(striter,*) iter
             call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHR,retstr)
             if(present(reacid))then
                write(striter,*) reacid
                call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                retstr = retstr0
             endif
             call open0(nfchr,retstr,'F_CHR     ',unknown,formatted,check_file_name_on)
          endif
       else if(nspin == 2) then
          lenstr = len_trim(F_CHR)
          ip = lenstr+1
          findingdot: do i = lenstr, 1, -1
             if(F_CHR(i:i) == '/') then
                exit findingdot
             else if(F_CHR(i:i) == '.') then
                ip = i
                exit findingdot
             end if
          end do findingdot
             
          if(ispin == 1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRUD = F_CHR(1:ip)//'up.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRUD = F_CHR(1:ip)//'up'
                end if
             else
                F_CHRUD = F_CHR(1:lenstr)//'.up'
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRUD (up) ---'
                write(nfout,*) F_CHRUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then 
                call open0(nfchr,F_CHRUD,'F_CHR.UP  ',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRUD,retstr)
                call open0(nfchr,retstr,'F_CHR.UP  ',unknown,formatted,check_file_name_on)
             endif
          else if(ispin == 2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRUD = F_CHR(1:ip)//'down.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRUD = F_CHR(1:ip)//'down'
                end if
             else
                F_CHRUD = F_CHR(1:lenstr)//'.down'
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRUD (down) ---'
                write(nfout,*) F_CHRUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                call open0(nfchr,F_CHRUD,'F_CHR.DOWN',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRUD,retstr)
                call open0(nfchr,retstr,'F_CHR.DOWN',unknown,formatted,check_file_name_on)
             endif
          end if

! ======= KT_add ========== 2014/06/07
          if (ispin == -1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRUD = F_CHR(1:ip)//'tot.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRUD = F_CHR(1:ip)//'tot'
                end if
             else
                F_CHRUD = F_CHR(1:lenstr)//'.tot'
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRUD (tot) ---'
                write(nfout,*) F_CHRUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then 
                call open0(nfchr,F_CHRUD,'F_CHR.TOT ',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRUD,retstr)
                call open0(nfchr,retstr,'F_CHR.TOT ',unknown,formatted,check_file_name_on)
             endif
          else if(ispin == -2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRUD = F_CHR(1:ip)//'mag.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRUD = F_CHR(1:ip)//'mag'
                end if
             else
                F_CHRUD = F_CHR(1:lenstr)//'.mag'
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRUD (mag) ---'
                write(nfout,*) F_CHRUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                call open0(nfchr,F_CHRUD,'F_CHR.MAG ',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRUD,retstr)
                call open0(nfchr,retstr,'F_CHR.MAG ',unknown,formatted,check_file_name_on)
             endif
          endif
! ========================= 2014/06/07

       end if
    end if
  end subroutine m_Files_open_nfchr

!====================================== added by K. Tagami =========== 11.0
  subroutine m_Files_open_nfchr_noncl( iloop, iter )
    integer, intent(in) :: iloop
    integer, intent(in), optional :: iter

    integer :: lenstr, ip, i
    character(len=105) :: F_CHRMAG
    logical :: open

    if(mype == 0) then

       lenstr = len_trim(F_CHR)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
         if(F_CHR(i:i) == '/') then
            exit findingdot
         else if(F_CHR(i:i) == '.') then
            ip = i
            exit findingdot
         end if
       end do findingdot
             
       select case (iloop)
       case(1)
           if(ip >= 1 .and. ip <= lenstr) then
              if(ip+1 <= lenstr) then
                 F_CHRMAG = F_CHR(1:ip)//'tot.'//F_CHR(ip+1:lenstr)
              else
                 F_CHRMAG = F_CHR(1:ip)//'tot'
              end if
           else
              F_CHRMAG = F_CHR(1:lenstr)//'.tot'
           end if
           if(printable) then
              write(nfout,*) ' --- F_CHRMAG (tot) ---'
              write(nfout,*) F_CHRMAG
           end if
           inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRMAG, 'F_CHR.TOT ',unknown, &
             &           formatted, check_file_name_on )

       case(2)
           if(ip >= 1 .and. ip <= lenstr) then
              if(ip+1 <= lenstr) then
                 F_CHRMAG = F_CHR(1:ip)//'mx.'//F_CHR(ip+1:lenstr)
              else
                 F_CHRMAG = F_CHR(1:ip)//'mx'
              end if
           else
              F_CHRMAG = F_CHR(1:lenstr)//'.mx'
           end if
           if(printable) then
              write(nfout,*) ' --- F_CHRMAG (mx) ---'
              write(nfout,*) F_CHRMAG
           end if
           inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRMAG, 'F_CHR.MX  ',unknown, &
             &           formatted, check_file_name_on )

       case(3)
           if(ip >= 1 .and. ip <= lenstr) then
              if(ip+1 <= lenstr) then
                 F_CHRMAG = F_CHR(1:ip)//'my.'//F_CHR(ip+1:lenstr)
              else
                 F_CHRMAG = F_CHR(1:ip)//'my'
              end if
           else
              F_CHRMAG = F_CHR(1:lenstr)//'.my'
           end if
           if(printable) then
              write(nfout,*) ' --- F_CHRMAG (my) ---'
              write(nfout,*) F_CHRMAG
           end if
           inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRMAG, 'F_CHR.MY  ',unknown, &
             &           formatted, check_file_name_on )

       case(4)
           if(ip >= 1 .and. ip <= lenstr) then
              if(ip+1 <= lenstr) then
                 F_CHRMAG = F_CHR(1:ip)//'mz.'//F_CHR(ip+1:lenstr)
              else
                 F_CHRMAG = F_CHR(1:ip)//'mz'
              end if
           else
              F_CHRMAG = F_CHR(1:lenstr)//'.mz'
           end if
           if(printable) then
              write(nfout,*) ' --- F_CHRMAG (mz) ---'
              write(nfout,*) F_CHRMAG
           end if
           inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRMAG, 'F_CHR.MZ  ',unknown, &
             &           formatted, check_file_name_on )
       end select
    end if
  end subroutine m_Files_open_nfchr_noncl
! ================================================================== 11.0

  subroutine m_Files_open_nfchr_pc(nspin,ispin,iw,iter,reacid)
    integer, intent(in) :: nspin, ispin, iw
    integer, intent(in),optional :: iter
    integer, intent(in),optional :: reacid
    integer :: lenstr, ip, i
    character(len=105) :: F_CHRpcUD, F_CHRpc
    character(len=256) :: striter
    character(len=105) :: retstr,retstr0
    integer, parameter :: len_nnumber = 4
    character(len=len_nnumber) :: nnumber
    logical :: open

    if(mype == 0) then
       write(nnumber,'(i4)') iw
       do i = 1, len_nnumber
          if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_CHR)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_CHR(i:i) == '/') then
             exit findingdot
          else if(F_CHR(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       if(nspin == 1) then
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_CHRpc = F_CHR(1:ip)//nnumber//'.'//F_CHR(ip+1:lenstr)
             else
                F_CHRpc = F_CHR(1:ip)//nnumber
             end if
          else
             F_CHRpc = F_CHR(1:lenstr)//nnumber
          end if
          inquire(unit=nfchr,opened=open)
          if(open) close(nfchr,status='keep')
          if(.not.present(iter)) then
             call open0(nfchr,F_CHRpc,'F_CHRpc   ',unknown,formatted,check_file_name_on)
          else
             write(striter,*) iter
             call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpc,retstr)
             if(present(reacid))then
                write(striter,*) reacid
                call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                retstr = retstr0
             endif
             call open0(nfchr,retstr,'F_CHRpc   ',unknown,formatted,check_file_name_on)
          endif

       else if(nspin == 2) then
          if(ispin == 1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcUD = F_CHR(1:ip)//'up.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcUD = F_CHR(1:ip)//'up.'//nnumber
                end if
             else
                F_CHRpcUD = F_CHR(1:lenstr)//'.up.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcUD (up) ---'
                write(nfout,*) F_CHRpcUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                call open0(nfchr,F_CHRpcUD,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpcUD,retstr)
                if(present(reacid))then
                  write(striter,*) reacid
                  call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                  retstr = retstr0
                endif
                call open0(nfchr,retstr,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             endif
          else if(ispin == 2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcUD = F_CHR(1:ip)//'down.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcUD = F_CHR(1:ip)//'down.'//nnumber
                end if
             else
                F_CHRpcUD = F_CHR(1:lenstr)//'.down.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcUD (down) ---'
                write(nfout,*) F_CHRpcUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                 call open0(nfchr,F_CHRpcUD,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             else
                 write(striter,*) iter
                 call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpcUD,retstr)
                 if(present(reacid))then
                   write(striter,*) reacid
                   call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                   retstr = retstr0
                 endif
                 call open0(nfchr,retstr,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             endif
          end if
! =========== KT_add ======== 2014/06/07
          if(ispin == -1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcUD = F_CHR(1:ip)//'tot.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcUD = F_CHR(1:ip)//'tot.'//nnumber
                end if
             else
                F_CHRpcUD = F_CHR(1:lenstr)//'.tot.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcUD (tot) ---'
                write(nfout,*) F_CHRpcUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                call open0(nfchr,F_CHRpcUD,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             else
                write(striter,*) iter
                call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpcUD,retstr)
                if(present(reacid))then
                  write(striter,*) reacid
                  call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                  retstr = retstr0
                endif
                call open0(nfchr,retstr,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             endif
          else if(ispin == -2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcUD = F_CHR(1:ip)//'mag.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcUD = F_CHR(1:ip)//'mag.'//nnumber
                end if
             else
                F_CHRpcUD = F_CHR(1:lenstr)//'.mag.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcUD (mag) ---'
                write(nfout,*) F_CHRpcUD
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             if(.not.present(iter)) then
                 call open0(nfchr,F_CHRpcUD,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             else
                 write(striter,*) iter
                 call insert_str_before_dot('_iter'//trim(adjustl(striter)),F_CHRpcUD,retstr)
                 if(present(reacid))then
                   write(striter,*) reacid
                   call insert_str_before_dot('_reac'//trim(adjustl(striter)),retstr,retstr0)
                   retstr = retstr0
                 endif
                 call open0(nfchr,retstr,'F_CHRpcUD ',unknown,formatted,check_file_name_on)
             endif
          end if
! =========================== 2014/06/07
       end if
    end if
  end subroutine m_Files_open_nfchr_pc

! ================================ added by K. Tagami ================== 11.0
  subroutine m_Files_open_nfchr_pc_noncl( iloop, iw, iter )
    integer, intent(in) :: iloop, iw
    integer, intent(in), optional :: iter

    integer :: lenstr, ip, i
    character(len=105) :: F_CHRpcMAG, F_CHRpc
    integer, parameter :: len_nnumber = 4
    character(len=len_nnumber) :: nnumber
    logical :: open

    if(mype == 0) then
       write(nnumber,'(i4)') iw
       do i = 1, len_nnumber
          if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_CHR)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_CHR(i:i) == '/') then
             exit findingdot
          else if(F_CHR(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       select case (iloop)
       case(1)
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcMAG = F_CHR(1:ip)//'tot.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcMAG = F_CHR(1:ip)//'tot.'//nnumber
                end if
             else
                F_CHRpcMAG = F_CHR(1:lenstr)//'.tot.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcMAG (tot) ---'
                write(nfout,*) F_CHRpcMAG
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRpcMAG, 'F_CHRpcMAG ', unknown, &
	&                formatted, check_file_name_on )

       case(2)
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcMAG = F_CHR(1:ip)//'mx.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcMAG = F_CHR(1:ip)//'mx.'//nnumber
                end if
             else
                F_CHRpcMAG = F_CHR(1:lenstr)//'.mx.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcMAG (mx) ---'
                write(nfout,*) F_CHRpcMAG
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRpcMAG, 'F_CHRpcMAGx ', unknown, &
	&                formatted, check_file_name_on )

       case(3)
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcMAG = F_CHR(1:ip)//'my.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcMAG = F_CHR(1:ip)//'my.'//nnumber
                end if
             else
                F_CHRpcMAG = F_CHR(1:lenstr)//'.my.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcMAG (my) ---'
                write(nfout,*) F_CHRpcMAG
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRpcMAG, 'F_CHRpcMAGy ', unknown, &
	&                formatted, check_file_name_on )

       case(4)
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_CHRpcMAG = F_CHR(1:ip)//'mz.'//nnumber//'.'//F_CHR(ip+1:lenstr)
                else
                   F_CHRpcMAG = F_CHR(1:ip)//'mz.'//nnumber
                end if
             else
                F_CHRpcMAG = F_CHR(1:lenstr)//'.mz.'//nnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_CHRpcMAG (tot) ---'
                write(nfout,*) F_CHRpcMAG
             end if
             inquire(unit=nfchr,opened=open)
             if(open) close(nfchr,status='keep')
             call open0( nfchr, F_CHRpcMAG, 'F_CHRpcMAGz ', unknown, &
	&                formatted, check_file_name_on )
       end select

    end if
  end subroutine m_Files_open_nfchr_pc_noncl
! ===================================================================== 11.0

  subroutine m_Files_open_nfwfk(nspin,ik,ib)
    integer, intent(in) :: nspin, ik, ib
    integer :: lenstr, ip, i, ispin, nk
    character(len=105) :: F_WFnUD, F_WFn
    integer, parameter :: len_nnumber = 4
    integer, parameter :: len_mnumber = 5
    character(len=len_nnumber) :: nnumber
    character(len=len_mnumber) :: mnumber
    logical :: open

    ispin = mod(ik-1,nspin)+1
    nk = (ik-1)/nspin+1

    if(mype == 0) then
       write(nnumber,'(i4)') nk
       do i = 1, len_nnumber
          if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
       end do
       write(mnumber,'(i5)') ib
       do i = 1, len_mnumber
          if(mnumber(i:i) == ' ') mnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_WFk)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_WFk(i:i) == '/') then
             exit findingdot
          else if(F_WFk(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       if(nspin == 1) then
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn = F_WFk(1:ip)//"k"//nnumber//"n"//mnumber//'.'//F_WFk(ip+1:lenstr)
             else
                F_WFn = F_WFk(1:ip)//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn = F_WFk(1:lenstr)//".k"//nnumber//"n"//mnumber
          end if
          inquire(unit=nfwfk,opened=open)
          if(open) close(nfwfk,status='keep')
          call open0(nfwfk,F_WFn,'F_WFn     ',unknown,formatted,check_file_name_on)

       else if(nspin == 2) then
          if(ispin == 1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_WFnUD = F_WFk(1:ip)//'up.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk(ip+1:lenstr)
                else
                   F_WFnUD = F_WFk(1:ip)//'up.'//"k"//nnumber//"n"//mnumber
                end if
             else
                F_WFnUD = F_WFk(1:lenstr)//'.up.'//"k"//nnumber//"n"//mnumber
             end if
              if(printable) then
                write(nfout,*) ' --- F_WFnUD (up) ---'
                write(nfout,*) F_WFnUD
             end if
             inquire(unit=nfwfk,opened=open)
             if(open) close(nfwfk,status='keep')
             call open0(nfwfk,F_WFnUD,'F_WFnUD   ',unknown,formatted,check_file_name_on)
          else if(ispin == 2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_WFnUD = F_WFk(1:ip)//'down.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk(ip+1:lenstr)
                else
                   F_WFnUD = F_WFk(1:ip)//'down.'//"k"//nnumber//"n"//mnumber
                end if
             else
                F_WFnUD = F_WFk(1:lenstr)//'.down.'//"k"//nnumber//"n"//mnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_WFnUD (down) ---'
                write(nfout,*) F_WFnUD
             end if
             inquire(unit=nfwfk,opened=open)
             if(open) close(nfwfk,status='keep')
             call open0(nfwfk,F_WFnUD,'F_WFnUD   ',unknown,formatted,check_file_name_on)
          end if
       end if
    end if
  end subroutine m_Files_open_nfwfk

! ==== 
  subroutine m_Files_open_nfwfksq_noncl(iloop,ik,ib)
    integer, intent(in) :: ik, ib, iloop
    integer :: lenstr, ip, i
    character(len=105) :: F_WFn_MAG
    integer, parameter :: len_nnumber = 4
    integer, parameter :: len_mnumber = 5
    character(len=len_nnumber) :: nnumber
    character(len=len_mnumber) :: mnumber
    logical :: open

    if(mype == 0) then
       write(nnumber,'(i4)') ik
       do i = 1, len_nnumber
          if(nnumber(i:i) == ' ') nnumber(i:i) = '0'
       end do
       write(mnumber,'(i5)') ib
       do i = 1, len_mnumber
          if(mnumber(i:i) == ' ') mnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_WFk_squared)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_WFk_squared(i:i) == '/') then
             exit findingdot
          else if(F_WFk_squared(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       select case (iloop)
       case (1)
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn_Mag = F_WFk_squared(1:ip)//'tot.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk_squared(ip+1:lenstr)
             else
                F_WFn_Mag = F_WFk_squared(1:ip)//'tot.'//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn_Mag = F_WFk_squared(1:lenstr)//'.tot.'//"k"//nnumber//"n"//mnumber
          end if
          if(printable) then
             write(nfout,*) ' --- F_WFn_Mag (tot) ---'
             write(nfout,*) F_WFn_Mag
          end if

          inquire(unit=nfwfk_sq,opened=open)
          if(open) close(nfwfk_sq,status='keep')

          call open0( nfwfk_sq, F_WFn_Mag, 'F_WFn_Mag  ', unknown, formatted, &
               &      check_file_name_on )

       case (2)
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn_Mag = F_WFk_squared(1:ip)//'mx.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk_squared(ip+1:lenstr)
             else
                F_WFn_Mag = F_WFk_squared(1:ip)//'mx.'//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn_Mag = F_WFk_squared(1:lenstr)//'.mx.'//"k"//nnumber//"n"//mnumber
          end if
          if(printable) then
             write(nfout,*) ' --- F_WFn_Mag (mx) ---'
             write(nfout,*) F_WFn_Mag
          end if

          inquire(unit=nfwfk_sq,opened=open)
          if(open) close(nfwfk_sq,status='keep')

          call open0(nfwfk_sq,F_WFn_Mag,'F_WFn_Mag  ',unknown,formatted,check_file_name_on)

       case (3)
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn_Mag = F_WFk_squared(1:ip)//'my.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk_squared(ip+1:lenstr)
             else
                F_WFn_Mag = F_WFk_squared(1:ip)//'my.'//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn_Mag = F_WFk_squared(1:lenstr)//'.my.'//"k"//nnumber//"n"//mnumber
          end if
          if(printable) then
             write(nfout,*) ' --- F_WFn_Mag (my) ---'
             write(nfout,*) F_WFn_Mag
          end if

          inquire(unit=nfwfk_sq,opened=open)
          if(open) close(nfwfk_sq,status='keep')

          call open0(nfwfk_sq,F_WFn_Mag,'F_WFn_Mag  ',unknown,formatted,check_file_name_on)

       case (4)
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn_Mag = F_WFk_squared(1:ip)//'mz.'//"k"//nnumber//"n"//mnumber//'.'//F_WFk_squared(ip+1:lenstr)
             else
                F_WFn_Mag = F_WFk_squared(1:ip)//'mz.'//"k"//nnumber//"n"//mnumber
             end if
          else
             F_WFn_Mag = F_WFk_squared(1:lenstr)//'.mz.'//"k"//nnumber//"n"//mnumber
          end if
          if(printable) then
             write(nfout,*) ' --- F_WFn_Mag (mz) ---'
             write(nfout,*) F_WFn_Mag
          end if

          inquire(unit=nfwfk_sq,opened=open)
          if(open) close(nfwfk_sq,status='keep')

          call open0(nfwfk_sq,F_WFn_Mag,'F_WFn_Mag  ',unknown,formatted,check_file_name_on)
       end select
    end if
  end subroutine m_Files_open_nfwfksq_noncl

  subroutine m_Files_open_nfwfk_integ_mom(icond)
    integer, intent(in) :: icond
    logical :: open
    if(mype==0) then
       inquire(unit = nfwfk_integ_mom, opened = open)
       if(open) close(nfwfk_integ_mom)
       if(icond == FIXED_CHARGE .or. &
            & ( icond==FIXED_CHARGE_CONTINUATION &
            &       .and. fixed_charge_k_parallel==ALL_AT_ONCE ) ) then
          call open0( nfwfk_integ_mom, F_WFk_IntegMoment, 'F_WFk_IntegMoment', &
               &     unknown, formatted, check_file_name_on )
       else if(icond==FIXED_CHARGE_CONTINUATION &
            &       .and. fixed_charge_k_parallel==ONE_BY_ONE) then
          call open1( nfwfk_integ_mom, F_WFk_IntegMoment, 'F_WFk_IntegMoment', &
               &      unknown,formatted, check_file_name_on )

       else if (icond == INITIAL) then
          call open0( nfwfk_integ_mom, F_WFk_IntegMoment, 'F_WFk_IntegMoment', &
               &     unknown,formatted, check_file_name_on )
       else
          call open1( nfwfk_integ_mom,  F_WFk_IntegMoment,'F_WFk_IntegMoment', &
               &     unknown,formatted, check_file_name_on )
       end if
    end if
  end subroutine m_Files_open_nfwfk_integ_mom

  subroutine m_Files_close_nfwfk_integ_mom()
    logical :: open
    if(mype==0) then
       inquire(unit= nfwfk_integ_mom, opened = open)
       if(open) close( nfwfk_integ_mom )
    end if
  end subroutine m_Files_close_nfwfk_integ_mom
! ====

  subroutine m_Files_open_nfwannier(nspin,ispin,ib)
    integer, intent(in) :: nspin, ispin, ib
    integer :: lenstr, ip, i
    character(len=105) :: F_WFnUD, F_WFn
    integer, parameter :: len_mnumber = 5
    character(len=len_mnumber) :: mnumber
    logical :: open

    if(mype == 0) then
       write(mnumber,'(i5)') ib
       do i = 1, len_mnumber
          if(mnumber(i:i) == ' ') mnumber(i:i) = '0'
       end do

       lenstr = len_trim(F_WANNIER)
       ip = lenstr+1
       findingdot: do i = lenstr, 1, -1
          if(F_WFk(i:i) == '/') then
             exit findingdot
          else if(F_WANNIER(i:i) == '.') then
             ip = i
             exit findingdot
          end if
       end do findingdot

       if(nspin == 1) then
          if(ip >= 1 .and. ip <= lenstr) then
             if(ip+1 <= lenstr) then
                F_WFn = F_WANNIER(1:ip)//mnumber//'.'//F_WANNIER(ip+1:lenstr)
             else
                F_WFn = F_WANNIER(1:ip)//mnumber
             end if
          else
             F_WFn = F_WANNIER(1:lenstr)//"."//mnumber
          end if
          inquire(unit=nfwannier,opened=open)
          if(open) close(nfwannier,status='keep')
          call open0(nfwannier,F_WFn,'F_WFn     ',unknown,formatted,check_file_name_on)

       else if(nspin == 2) then
          if(ispin == 1) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_WFnUD = F_WANNIER(1:ip)//'up.'//mnumber//'.'//F_WANNIER(ip+1:lenstr)
                else
                   F_WFnUD = F_WANNIER(1:ip)//'up.'//mnumber
                end if
             else
                F_WFnUD = F_WANNIER(1:lenstr)//'.up.'//mnumber
             end if
              if(printable) then
                write(nfout,*) ' --- F_WFnUD (up) ---'
                write(nfout,*) F_WFnUD
             end if
             inquire(unit=nfwannier,opened=open)
             if(open) close(nfwannier,status='keep')
             call open0(nfwannier,F_WFnUD,'F_WFnUD   ',unknown,formatted,check_file_name_on)
          else if(ispin == 2) then
             if(ip >= 1 .and. ip <= lenstr) then
                if(ip+1 <= lenstr) then
                   F_WFnUD = F_WANNIER(1:ip)//'down.'//mnumber//'.'//F_WANNIER(ip+1:lenstr)
                else
                   F_WFnUD = F_WANNIER(1:ip)//'down.'//mnumber
                end if
             else
                F_WFnUD = F_WANNIER(1:lenstr)//'.down.'//mnumber
             end if
             if(printable) then
                write(nfout,*) ' --- F_WFnUD (down) ---'
                write(nfout,*) F_WFnUD
             end if
             inquire(unit=nfwannier,opened=open)
             if(open) close(nfwannier,status='keep')
             call open0(nfwannier,F_WFnUD,'F_WFnUD   ',unknown,formatted,check_file_name_on)
          end if
       end if
    end if
  end subroutine m_Files_open_nfwannier

  subroutine m_Files_open_nfelf()
    if(mype==0) call open0(nfelf,F_ELF,'F_ELF     ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfelf

  subroutine m_Files_open_nfberry()
    if(mype==0) call open0(nfberry,F_BERRY,'F_BERRY   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfberry

  subroutine m_Files_open_nfeffchg()
    if(mype==0) call open0(nfeffchg,F_EFFCHG,'F_EFFCHG  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfeffchg

!  subroutine m_Files_open_nfforce()
!    if(mype==0) call open0(nfforce,F_FORCE,'F_FORCE   ',unknown,formatted,check_file_name_on)
!  end subroutine m_Files_open_nfforce
  subroutine m_Files_open_nfforce(append)
    logical, intent(in) :: append

    if(mype/=0) return

    if(append) then    
     call open1(nfforce,F_FORCE,'F_FORCE   ',unknown,formatted,check_file_name_on)
    else
     call open0(nfforce,F_FORCE,'F_FORCE   ',unknown,formatted,check_file_name_on)
    endif
  end subroutine m_Files_open_nfforce

! ==== KT_add === 13.1R
  subroutine m_Files_open_nfeps_phonon(append)
    logical, intent(in) :: append

    if(mype/=0) return

    if(append) then
       call open1(nfeps_ph,F_EPS_PHONON,'F_EPS_PHONON',unknown,formatted, &
            &     check_file_name_on)
    else
       call open0(nfeps_ph,F_EPS_PHONON,'F_EPS_PHONON',unknown,formatted,&
            &     check_file_name_on)
    endif
  end subroutine m_Files_open_nfeps_phonon

  subroutine m_Files_open_nfoptical_coeff(append)
    logical, intent(in) :: append

    if(mype/=0) return
    if(append) then
       call open1(nfoptical_coeff,F_OPTICAL_COEFF,'F_OPTICAL_Coeff',unknown,formatted,&
            &     check_file_name_on)
    else
       call open0(nfoptical_coeff,F_OPTICAL_COEFF,'F_OPTICAL_Coeff',unknown,formatted,&
            &     check_file_name_on)
    endif
  end subroutine m_Files_open_nfoptical_coeff

  subroutine m_Files_open_nframan_spectra()
    if (mype==0) call open0( nframan_spectra, F_RAMAN_SPECTRA, 'F_RAMAN_SPECTRA', &
         &                   unknown, formatted, check_file_name_on )
  end subroutine m_Files_open_nframan_spectra
! =============== 13.1R

! ==== KT_add ==== 13.1XI
  subroutine m_Files_open_nf_xi_spectra()
    if (mype==0) call open0( nf_excitation_spectra, F_EXCITATION_SPECTRA, &
         &                   'F_EXCITATION_SPECTRA', &
         &                   unknown, formatted, check_file_name_on )
  end subroutine m_Files_open_nf_xi_spectra

  subroutine m_Files_close_nf_xi_spectra
    close(nf_excitation_spectra, status = 'keep')
  end subroutine m_Files_close_nf_xi_spectra
! ================ 13.1XI

  subroutine m_Files_open_nfmode()
    if(mype==0) call open0(nfmode,F_MODE,'F_MODE    ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfmode

  subroutine m_Files_open_nfepsilon()
    if(mype==0) call open0(nfepsilon,F_EPSILON,'F_EPSILON ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfepsilon

  subroutine m_Files_open_nfoccmat()
    if(mype==0) call open0(nfoccmat,F_OCCMAT,'F_OCCMAT  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfoccmat

  subroutine m_Files_open_nfeps
    logical open
    inquire(unit = nfepsout, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfepsout,F_EPSOUT,'F_EPSOUT  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfeps

  subroutine m_Files_close_nfeps
    close(nfepsout, status = 'keep')
  end subroutine m_Files_close_nfeps

  subroutine m_Files_open_nfnlo
    logical open
    inquire(unit = nfnlo, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfnlo,F_NLO,'F_NLO     ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfnlo

  subroutine m_Files_close_nfnlo
    close(nfnlo, status = 'keep')
  end subroutine m_Files_close_nfnlo

  subroutine m_Files_open_nfmagopt
    logical open
    inquire(unit = nfmagopt, opened = open)
    if(.not.open.and.mype==0) &
         & call open0(nfmagopt,F_MAGOPT,'F_MAGOPT  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfmagopt

  subroutine m_Files_close_nfmagopt
    close(nfmagopt, status = 'keep')
  end subroutine m_Files_close_nfmagopt

  subroutine m_Files_open_nfepscont
    logical open
    inquire(unit = nfepscont, opened = open)
    if(.not.open.and.mype==0) &
         & call open0(nfepscont,F_EPSCONT,'F_EPSCONT     ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfepscont

  subroutine m_Files_close_nfepscont
    close(nfepscont, status = 'keep')
  end subroutine m_Files_close_nfepscont

  subroutine m_Files_open_nfphdos()
    if(mype==0) call open0(nfphdos,F_PHDOS,'F_PHDOS   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfphdos
  
  subroutine m_Files_open_nfstrfrc()
    if(mype==0) call open0(nfstrfrc,F_STRFRC,'F_STRFRC  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfstrfrc

  subroutine m_Files_open_nfcntn_wannier
    logical open
    inquire(unit = nfcntn_wannier, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfcntn_wannier,F_CNTN_WAN,'F_CNTN_WAN',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfcntn_wannier

  subroutine m_Files_open_nfpot_wannier
    logical open
    inquire(unit = nfpot_wannier, opened = open)
    if(.not.open .and. mype==0) &
         & call open0(nfpot_wannier,F_POT_WAN,'F_POT_WAN ',unknown,unformatted&
         &     ,check_file_name_on)
  end subroutine m_Files_open_nfpot_wannier

  subroutine m_Files_open_nfpstrn
    if(mype == 0) &
         & call open0(nfpstrn,F_PSTRN,'F_PSTRN   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfpstrn

  subroutine m_Files_open_nfPsicoef()
    if(ekmode == ON .or. (ekmode==OFF.and..not.file_existance_contfiles) .or. icond==INITIAL) then
       if(mype==0) call open0(nfpsicoef,F_PsiCoef,'F_PSICOEF ',unknown,formatted,check_file_name_on)
    else if(ekmode==OFF.and.file_existance_contfiles) then
       if(mype==0) call open1(nfpsicoef,F_PsiCoef,'F_PSICOEF ',unknown,formatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfPsicoef

  subroutine m_Files_open_nfBandSymInput()
    if((ekmode==ON .or. (ekmode==OFF.and..not.file_existance_contfiles).or.icond==INITIAL) .and. mype==0) then
       call open0(nfbandsyminput,F_Band_Sym_Input,'F_BAND_SYM_INPUT ',unknown,formatted,check_file_name_on)
    else if((ekmode==OFF.and.file_existance_contfiles) .and. mype==0) then
       call open1(nfbandsyminput,F_Band_Sym_Input,'F_BAND_SYM_INPUT ',unknown,formatted,check_file_name_on)
    end if
  end subroutine m_Files_open_nfBandSymInput

  subroutine m_Files_close_nfPsicoef()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfpsicoef, opened = op)
       if(op) close(nfpsicoef)
    end if
  end subroutine m_Files_close_nfPsicoef

  subroutine m_Files_close_nfBandSymInput()
    logical :: op
    if(mype == 0) then
       inquire(unit = nfbandsyminput, opened = op)
       if(op) close(nfbandsyminput)
    end if
  end subroutine m_Files_close_nfBandSymInput

  subroutine m_Files_open_nfvelec
    if(mype == 0) &
         & call open0(nfvelec,F_VELEC,'F_VELEC   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfvelec

  subroutine m_Files_open_nfeppair
    if(mype == 0) &
         & call open0(nfeppair,F_EPPAIR,'F_EPPAIR  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfeppair

  subroutine m_Files_open_nfeppair2
    if(mype == 0) &
         & call open0(nfeppair2,F_EPPAIR2,'F_EPPAIR2  ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfeppair2

  subroutine m_Files_open_nfvelec_grad
    if(mype == 0) &
         & call open0(nfvelec_grad,F_VELEC_GRAD,'F_VELECGRA',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfvelec_grad

  subroutine m_Files_close_nfpstrn
    logical open
    inquire(unit=nfpstrn,opened=open)
    if(open) close(nfpstrn,status='keep')
  end subroutine m_Files_close_nfpstrn

  subroutine m_Files_close_nfvelec
    logical open
    inquire(unit=nfvelec,opened=open)
    if(open) close(nfvelec,status='keep')
  end subroutine m_Files_close_nfvelec

  subroutine m_Files_close_nfeppair
    logical open
    inquire(unit=nfeppair,opened=open)
    if(open) close(nfeppair,status='keep')
  end subroutine m_Files_close_nfeppair

  subroutine m_Files_close_nfeppair2
    logical open
    inquire(unit=nfeppair2,opened=open)
    if(open) close(nfeppair2,status='keep')
  end subroutine m_Files_close_nfeppair2

  subroutine m_Files_close_nfvelec_grad
    logical open
    inquire(unit=nfvelec_grad,opened=open)
    if(open) close(nfvelec_grad,status='keep')
  end subroutine m_Files_close_nfvelec_grad

  subroutine m_Files_open_nfefermi()
    if(mype == 0) &
         & call open0(nfefermi,F_EFERMI,'F_FERMI   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfefermi

  subroutine m_Files_close_nfefermi()
    logical open
    inquire(unit=nfefermi,opened=open)
    if(open) close(nfefermi,status='keep')
  end subroutine m_Files_close_nfefermi

  subroutine m_Files_open_nfimage(i)
    integer  i
    !!$if(mype==0) call open0(nfimage,F_IMAGE(i),'F_IMAGE   ',unknown,formatted,check_file_name_on)
    call open0(nfimage,F_IMAGE(i),'F_IMAGE   ',unknown,formatted,check_file_name_on)
  end subroutine m_Files_open_nfimage


! ======================== Added by K. Tagami ================= 10.1
  subroutine m_Files_open_nf_LR()
    logical open
    inquire(unit = nf_LR_spectra, opened = open)
    if(.not.open .and. mype==0) &
      & call open0( nf_LR_spectra,F_LR_SPECTRA,'F_LR_SPECTRA   ', &
      &             unknown,formatted,check_file_name_on )
  end subroutine m_Files_open_nf_LR

  subroutine m_Files_close_nf_LR
    close(nf_LR_spectra, status = 'keep')
  end subroutine m_Files_close_nf_LR
! ============================================================= 10.1

! ====== KT_add ========== 13.0S
  subroutine m_Files_open_core_energy_file()
    logical open
    inquire(unit = nfcore_energy_out, opened = open)

    if(.not.open .and. mype==0) &
      & call open0( nfcore_energy_out, F_CORE_ENERGY_OUT, 'F_CORE_ENERGY_OUT', &
      &             unknown,formatted,check_file_name_on )
  end subroutine m_Files_open_core_energy_file

  subroutine m_Files_close_core_energy_file
    close(nfcore_energy_out, status = 'keep')
  end subroutine m_Files_close_core_energy_file

  subroutine m_Files_open_core_ene_initial()
    logical open
    inquire(unit = nfcore_energy_initial, opened = open)

    if(.not.open .and. mype==0) &
      & call open0( nfcore_energy_initial, F_CORE_ENERGY_INITIAL, &
      &            'F_CORE_ENERGY_INITIAL', &
      &             unknown,formatted,check_file_name_on )
  end subroutine m_Files_open_core_ene_initial

  subroutine m_Files_close_core_ene_initial
    close(nfcore_energy_initial, status = 'keep')
  end subroutine m_Files_close_core_ene_initial

  subroutine m_Files_open_core_ene_final()
    logical open
    inquire(unit = nfcore_energy_final, opened = open)

    if(.not.open .and. mype==0) &
      & call open0( nfcore_energy_final, F_CORE_ENERGY_FINAL, &
      &            'F_CORE_ENERGY_FINAL', &
      &             unknown,formatted,check_file_name_on )
  end subroutine m_Files_open_core_ene_final

  subroutine m_Files_close_core_ene_final
    close(nfcore_energy_final, status = 'keep')
  end subroutine m_Files_close_core_ene_final
! ======================== 13.0S

! ==== KT_add === 2014/07/14
  subroutine m_Files_open_nfhypervec()
    if (mype==0) then
       call open0( nfhypervec, F_HYPERVEC,'F_HYPERVEC',unknown,formatted,&
            &      check_file_name_on )
    endif
  end subroutine m_Files_open_nfhypervec

  subroutine m_Files_close_nfhypervec()
    logical open
    inquire(unit=nfhypervec,opened=open)
    if(open) close(nfhypervec,status='keep')
  end subroutine m_Files_close_nfhypervec
! =============== 2014/07/14

end module m_Files

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: mklfft
!
!  AUTHOR(S): T. Yamamoto   March/8/2006
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef MKLFFT
module mklfft
!  $Id: mklfft.F90 570 2017-04-21 20:34:50Z yamasaki $
  use MKL_DFTI
  implicit none

  type mklfft_rdh
    TYPE(DFTI_DESCRIPTOR), POINTER :: dh_r1
    TYPE(DFTI_DESCRIPTOR), POINTER :: dh_c2
    integer :: worksize
    integer :: ldx,ldy,ldz
  end type

contains

  subroutine init_mkl_rfft(nx,ny,nz,ldx,ldy,ldz,rdh)
    integer, intent(in) :: nx,ny,nz,ldx,ldy,ldz
    type(mklfft_rdh), intent(inout) :: rdh

    integer :: strides(3),Status
    integer :: nc2(2)

    rdh%worksize = ldx*ldy*ldz/2
    rdh%ldx = ldx
    rdh%ldy = ldy
    rdh%ldz = ldz
    nc2(1)=nz; nc2(2)=ny

    ! REAL X FFT
    Status = DftiCreateDescriptor(rdh%dh_r1, &
     &       DFTI_DOUBLE,DFTI_REAL,1,nx)
    Status = DftiSetValue(rdh%dh_r1, &
     &       DFTI_NUMBER_OF_TRANSFORMS,ldy*nz)
    Status = DftiSetValue(rdh%dh_r1, &
     &       DFTI_INPUT_DISTANCE,ldx)
    Status = DftiCommitDescriptor(rdh%dh_r1)
    ! COMPLEX YZ FFT
    Status = DftiCreateDescriptor(rdh%dh_c2, &
     &       DFTI_DOUBLE,DFTI_COMPLEX,2,nc2)
    Status = DftiSetValue(rdh%dh_c2, &
    !! &       DFTI_NUMBER_OF_TRANSFORMS,nx)
     &       DFTI_NUMBER_OF_TRANSFORMS,nx/2+1)
    strides(1) = 0
    strides(2) = 1
    strides(3) = ldz
    Status = DftiSetValue(rdh%dh_c2,DFTI_INPUT_STRIDES,strides)
    Status = DftiSetValue(rdh%dh_c2,DFTI_INPUT_DISTANCE,ldz*ldy)
    Status = DftiCommitDescriptor(rdh%dh_c2)
  end subroutine init_mkl_rfft

  subroutine mkl_rfft(isw,rdh,a)
    integer, intent(in) :: isw
    type(mklfft_rdh), intent(in) :: rdh
    real(8), intent(inout) :: a(*)

    complex(8) :: work(rdh%worksize)
    integer :: ldx2,ldy,ldz

    ldx2 = rdh%ldx/2
    ldy = rdh%ldy
    ldz = rdh%ldz

    if(isw == -1) then
       call compute_forward(a,work)
    else if(isw == 1) then
       call compute_backward(a,work)
    else
       stop 'mklfft: isw is not 1 nor -1.'
    end if
  contains
    subroutine compute_forward(ar,ac)
      real(8), intent(inout) :: ar(*)
      complex(8), intent(inout) :: ac(*)
      integer :: Status
      Status = DftiComputeForward(rdh%dh_r1,ar)
      call trans_rc(ar,ac)
      Status = DftiComputeForward(rdh%dh_c2,ac)
      call trans_cr(ac,ar)
    end subroutine compute_forward
    subroutine compute_backward(ar,ac)
      real(8), intent(inout) :: ar(*)
      complex(8), intent(inout) :: ac(*)
      integer :: Status
      call trans_rc(ar,ac)
      Status = DftiComputeBackward(rdh%dh_c2,ac)
      call trans_cr(ac,ar)
      Status = DftiComputeBackward(rdh%dh_r1,ar)
    end subroutine compute_backward
    subroutine trans_rc(r,c)
      real(8), intent(in)  :: r(*)
      complex(8), intent(out) :: c(*)

      integer :: i,j,k
      integer :: ir,ic

      do i=1,ldx2
      do j=1,ldy
      do k=1,ldz
         ir = i + ldx2*((j-1) + ldy*(k-1))
         ic = k + ldz*((j-1) + ldy*(i-1))
         c(ic) = dcmplx(r(2*ir-1),r(2*ir))
      end do
      end do
      end do
    end subroutine trans_rc
    subroutine trans_cr(c,r)
      complex(8), intent(in) :: c(*)
      real(8), intent(out)  :: r(*)

      integer :: i,j,k
      integer :: ir,ic

      do i=1,ldx2
      do j=1,ldy
      do k=1,ldz
         ir = i + ldx2*((j-1) + ldy*(k-1))
         ic = k + ldz*((j-1) + ldy*(i-1))
         r(2*ir-1) = dble(c(ic))
         r(2*ir) = dimag(c(ic))
      end do
      end do
      end do
    end subroutine trans_cr
  end subroutine mkl_rfft

end module mklfft
#else
subroutine mklfft_dummy
end 
#endif

      subroutine eigen_prd_init(a, nm, n,
     &              d_out, e_out, ne,
     &              u_t, v_t, nv)
!$    use OMP_LIB
      use eigen_devel
      use eigen_libs
      use eigen_house
      implicit NONE

      integer, intent(in)    :: nm, n, ne, nv
      real(8), intent(inout) :: a(1:nm, *)
      real(8), intent(out)   :: d_out(*)
      real(8), intent(out)   :: e_out(1:ne, *)
      real(8), intent(in)    :: u_t(*), v_t(*)

      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4
      integer                ::  i, j

      integer                :: kx
      integer                :: local_size, local_rank

      include 'param.h'
      include 'CSTAB.h'


      d_out(1:n)    = ZERO
      e_out(1:n,1)  = ZERO
      e_out(1:n,2)  = ZERO

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = eigen_loop_end  (n, y_nnod,y_inod)
         i_4 = x_nnod/n_common
         do i_1=i_2,i_3,i_4
!           j   = eigen_translate_l2g(i_1, y_nnod,y_inod)
!           j_1 = eigen_translate_g2l(j, x_nnod,x_inod)
            j   = (i_1-1)*y_nnod+y_inod
            j_1 = (j-1)/x_nnod+1
            d_out(j) = a(j_1,i_1)
         end do! i_1
      end if

      i_2 = eigen_loop_start(1, y_nnod,y_inod)
      i_3 = eigen_loop_end  (n, y_nnod,y_inod)
      do i_1=i_2,i_3
         j   = eigen_translate_l2g(i_1, y_nnod,y_inod)
         j_2 = eigen_loop_start(j+1, x_nnod,x_inod)
         do j_1=j_2,nm
            a(j_1,i_1) = ZERO
         end do! j_1
         if ( j > n ) then
         do j_1=j_2,nm
            a(1:nm,i_1) = ZERO
         end do! j_1
         end if
      end do! i_1

      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()

      allocate(u0_z(nv*local_size+n_columns),
     &         v0_z(nv*local_size+n_columns))
      allocate(u1_z(nv*local_size+n_columns),
     &         v1_z(nv*local_size+n_columns))
      call CSTAB_adjust_base(u0_z(1), u_t(1), offset1)
      call CSTAB_adjust_base(v0_z(1), v_t(1), offset2)
      call CSTAB_adjust_base(u1_z(1), u_t(1), offset3)
      call CSTAB_adjust_base(v1_z(1), v_t(1), offset4)
      kx =  (L1_WINDOW/8)
!     &           +(L1_WINDOW)
!     &           +(L1_LSIZE/8)
     &           +(L1_LSIZE)
     &           +(L2_LSIZE/8)
      offset1 = offset1 + kx * 1
      offset2 = offset2 + kx * 2
      offset3 = offset3 + kx * 3
      offset4 = offset4 + kx * 4
      call CSTAB_round_offset(offset1)
      call CSTAB_round_offset(offset2)
      call CSTAB_round_offset(offset3)
      call CSTAB_round_offset(offset4)

      return
      end subroutine  eigen_prd_init


      subroutine eigen_prd_final(a, nm, n, d_out, e_out, ne, u_t)
      use eigen_devel
      use eigen_libs
      use eigen_house
      implicit NONE

      integer, intent(in)    :: nm, ne, n
      real(8), intent(inout) :: a(1:nm, *)
      real(8), intent(out)   :: d_out(*)
      real(8), intent(out)   :: e_out(1:ne, *)
      real(8), intent(out)   :: u_t(*)

      integer                ::  x_pos, x_owner_nod
      integer                ::  y_pos, y_owner_nod
      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4
      integer                ::  i, j, k, L
      real(8)                ::  t

      include 'param.h'


      if ( n >= 2 ) then
         do i = 2+MOD(n,2), 2, -1
            L = i-1
            y_owner_nod = eigen_owner_node (i, y_nnod,y_inod)
            x_owner_nod = eigen_owner_node (L, x_nnod,x_inod)
            if ( y_owner_nod == y_inod
     &         .AND. x_owner_nod == x_inod ) then
               i_1 = eigen_translate_g2l(i, y_nnod,y_inod)
               j_1 = eigen_translate_g2l(L, x_nnod,x_inod)
               e_out(i,1)  =  a(j_1,i_1)
               a(j_1,i_1)  =  ZERO
            end if
            L = i-2; if ( L < 1 ) cycle
            y_owner_nod = eigen_owner_node (i, y_nnod,y_inod)
            x_owner_nod = eigen_owner_node (L, x_nnod,x_inod)
            if ( y_owner_nod == y_inod
     &         .AND. x_owner_nod == x_inod ) then
               i_1 = eigen_translate_g2l(i, y_nnod,y_inod)
               j_1 = eigen_translate_g2l(L, x_nnod,x_inod)
               e_out(i,2)  =  a(j_1,i_1)
               a(j_1,i_1)  =  ZERO
            end if
         end do
      end if

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = eigen_loop_end  (n, y_nnod,y_inod)
         i_4 = x_nnod/n_common
         do i_1=i_2,i_3,i_4
            j   = eigen_translate_l2g(i_1, y_nnod,y_inod)
            j_1 = eigen_translate_g2l(j, x_nnod,x_inod)
            t          = d_out(j)
            d_out(j)   = a(j_1,i_1)
            a(j_1,i_1) = t
         end do! i_1
      end if


      call reduce_dbl(d_out(1),   u_t(1), n, 1, x_COMM_WORLD)
      call reduce_dbl(d_out(1),   u_t(1), n, 1, y_COMM_WORLD)
      if ( MOD(n,2) /= 0 ) then
         e_out(1,1) = e_out(3,2)
      end if
      call reduce_dbl(e_out(1,1), u_t(1), n, 1, x_COMM_WORLD)
      call reduce_dbl(e_out(1,1), u_t(1), n, 1, y_COMM_WORLD)
      if ( MOD(n,2) /= 0 ) then
         e_out(3,2) = e_out(1,1)
         e_out(1,1) = 0D0
      end if


      deallocate(u0_z, v0_z)
      deallocate(u1_z, v1_z)



      return
      end subroutine  eigen_prd_final

      use MPI
      use eigen_libs
      implicit double precision (a-h,o-z)

      real(8), pointer ::
     &           a(:,:),z(:,:),w(:)

      real(8), parameter :: ONE = 1D0
      real(8) :: PAI
!
      integer :: x_nnod, y_nnod, x_inod, y_inod
!
      call mpi_init_thread( MPI_THREAD_MULTIPLE, i, ierr )
      call mpi_comm_rank( mpi_comm_world, i_inod, ierr )
      call mpi_comm_size( mpi_comm_world, i_nnod, ierr )

      if ( i_inod<=3) then
        icolor=1
      else
        icolor=0
      endif
      call MPI_comm_split(MPI_COMM_WORLD,icolor,i_inod,MPI_COMM_EIGEN,
     &   ierr)
*
!      call eigen_init( MPI_COMM_WORLD, order='R' )
       call eigen_init( MPI_COMM_EIGEN, order='R' )
!      call eigen_init( MPI_COMM_WORLD, order='C' )
!      call eigen_init( MPI_COMM_WORLD )
!      call eigen_init( order='R' )
!      call eigen_init( )

      call eigen_get_procs( nnod, x_nnod, y_nnod )
      call eigen_get_id   ( inod, x_inod, y_inod )

      if ( i_inod == 0 ) then
         open(10,file='IN')
      end if
*
      m = 48; nall = 2; mtype = 2

      PAI = 4*ATAN(ONE)
!
      DO

         if ( i_inod == 0 ) then
            read(10,*) n0, m, nall, mtype
         end if

         call mpi_bcast(n0,1,mpi_integer,0,MPI_COMM_WORLD,ierr)
         if ( n0 < 1 .or. n0 > 400000 ) EXIT
         call mpi_bcast(m,1,mpi_integer,0,MPI_COMM_WORLD,ierr)
         call mpi_bcast(nall,1,mpi_integer,0,MPI_COMM_WORLD,ierr)
         call mpi_bcast(mtype,1,mpi_integer,0,MPI_COMM_WORLD,ierr)

!         n = INT(n0*(DBLE(i_nnod)**(1D0/3)))
         n = n0
         nall = 6
         if ( n0 > 1000 ) nall = 2

         call eigen_get_matdims( n, nm, ny )

         allocate(
     &               a(nm, ny),
     &               z(nm, ny),
     &               w(n),
     &               stat=istat)
         if ( istat /= 0 ) then
            print*,"Memory exhausted"
            call flush(6)
            EXIT
         end if
*
         call mat_set( n, a(1,1), nm, mtype )
*-
         i =  eigen_memory_internal( n, nm, nm, m, 128 )

         call MPI_BARRIER( MPI_COMM_WORLD, ierr )
         d1 = MPI_WTIME( )
      if (icolor == 1) then
         call eigen_sx( n, n, a, nm, w, z, nm,
     &                  m_forward=m, m_backward=128 )
      endif
         call MPI_BARRIER( MPI_COMM_WORLD, ierr )
         d2 = MPI_WTIME( )
*-
         if ( i_inod == 0 ) then
            print*,"Matrix dimension = ",N
            print*,"Internally required memory = ",i," [Byte]"
            print*,"Elapsed time = ",d2-d1," [sec]"
         end if
*-
         if(icolor==1)then
         if ( mtype == 0 ) then
         if ( i_inod == 0 ) then
            ax=0D0
            do i = 1, n
               j = n-i
               theta = PAI*(2*j+1)/(2*n+1)
               x = 5D-1/(1D0-COS(theta))
               ax = MAX(ax, ABS(w(i)-x)/ABS(x))
            end do
            print*, "max|w(i)-w(i).true|/|w|=", ax
         end if
         end if
         call flush( 6 )
*-
         if ( IAND(nall, 4) /= 0 ) then
            call mat_set( n, a(1,1), nm, mtype )
            call ev_test( n, a(1,1), nm, w(1), z(1,1), nm, t )
         end if
         end if
*
         deallocate( a )
         deallocate( z )
         deallocate( w )

      END DO

      if ( i_inod == 0 ) then
         close(10)
      end if
*
      call eigen_free( )
*
      call MPI_Finalize( ierr )
      end

      subroutine flush( i )
      end

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for calculating exchange kernels on the real grid
!  based on ALDA.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_ALDA

  use m_Const_Parameters,   only : ON, OFF, DP, CMPLDP, DELTA, &
       &                           Partial_Core_Charge, &
       &                           Valence_plus_PC_Charge, &
       &                           TETRAHEDRON, PARABOLIC, &
       &                           GGA, LDA, PAI2, PAI

  use m_Control_Parameters,  only : Num_q_Points, way_of_smearing, neg, &
       &                            ipri, nspin, printable, xctype, kimg

  use m_Kpoints,                    only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, &
       &                                   k_symmetry, np0, np2
  use m_LinearResponse_Control,     only  : nrd_efermi, nstep, e, nmax_G_LR, &
       &                                    vqxyz,  &
       &                                    xc_kernel_type, RPA, ALDA_G, LRC,  &
       &                                    LRC_alpha, sw_NLF, &
       &                                    spectrum_type, OPTICS, EELS, &
       &                                    scissor, eta, &
       &                                    sw_LongWaveLimit

  use m_LinearResponse_tools,  only  : occup_k, occup_kmq, &
       &                                  eko_k, &
       &                                    fsval_k, fsval_kmq, &
       &                                    wfn_k, wfn_kmq, &
       &                                    map_z_k, map_z_kmq, &
       &                                   nbase_k, nbase_kmq, &
       &                                   igf_k, igf_kmq, iba_k, iba_kmq

  use m_LinearResponse_Density,  only : RhoTilde, occup_lkt_ek

  use m_Electronic_Structure,       only : eko_ek
  use m_Crystal_Structure,    only :  rltv, univol

  use m_FFT,                  only : fft_box_size_CD, fft_box_size_CD_c, &
       &                             nfft, nfftp, &
       &                             m_FFT_CD_inverse_c, &
       &                             m_FFT_check_of_negative_CD, &
       &                             m_FFT_CD_direct_c, &
       &                             m_FFT_alloc_CD_box, &
       &                             m_FFT_dealloc_CD_box


#ifdef _MPIFFT_
  use m_FFT,                  only : m_FFT_set_cdata  &
       &                           , lx,ly,lz,ly_d,lz_d, ny_d,nz_d
  use m_PlaneWaveBasisSet,    only : igfp_l_c
#else
  use m_FFT,                  only : m_FFT_alloc_CD_box &
       &                           , m_FFT_dealloc_CD_box
#endif

  use m_Files,                 only : nfout
  use m_PlaneWaveBasisSet,    only : ngabc, igf, kg1,kg, igfp_l, kgp

  use m_Parallelization,      only : ista_kngp,iend_kngp,npes,mype, ierr, &
       & npes_cdfft, nrank_ggacmp, myrank_cdfft, &
       & myrank_ggacmp, ista_fftp, iend_fftp, ista_fftph, iend_fftp, &
       & nis_fftp, nie_fftp, nel_fftp, idisp_fftp,np_fftp,mp_fftp,  &
       & nel_fftph, idisp_fftph, nrest_cdfft, &
       & mpi_ggacmp_cross_world,mpi_cdfft_world, &
       & map_ggacmp, map_pe2ggacmp, map_pe2cdfft, mpi_comm_group, &
       & ista_fftph, iend_fftph, &
       & np_e, ista_k, iend_k, map_e, map_z, myrank_e

  use m_Charge_Density,        only : chgq_l
  use m_XC_Potential,         only : check_of_xctype
  use m_Ionic_System,         only : ntyp,natm,iwei,ityp,pos,zfm3_l
  use m_PseudoPotential,      only : itpcc,ilmt,ltp,taup,il2p,isph,iqitg, &
       & rhpcg_l, qitg_l,rhpcg_diff_l,qitg_diff_l,dl2p, &
       & m_PP_include_vanderbilt_pot, m_PP_find_maximum_l,nlmt

  use m_Timing,               only : tstatc0_begin, tstatc0_end
  

  use m_PlaneWaveBasisSet,    only : kg0, nbase
  use m_FFT,                  only : fft_box_size_WF, &
       &                             m_FFT_alloc_wf_work, &
       &                             m_FFT_dealloc_wf_work, m_FFT_wf
  use m_Const_Parameters,     only : DIRECT, ELECTRON

  use m_LinearResponse_tools,  only  : Get_WF_in_Rspace, Get_WF_in_Rspace_CD, &
       &                               fsval_k, fsval_kmq

  use m_Const_Parameters,      only : PAI4, BUCS, Bohr
  use m_IterationNumbers,     only : nk_in_the_process

  use m_Electronic_Structure,  only : zaj_l
  use m_Const_Parameters ,    only : INVERSE, DIRECT, OFF, GAMMA

  use m_LinearResponse_NonInt,   only : nband_LR, band_start_LR, band_end_LR
!
  use m_LinearResponse_Control,  only : sw_Fxc_enhanced
!
  implicit none
  include 'mpif.h'

! --------------------------- public -------------
  integer, allocatable :: igfp_LR(:)                ! d(kgp)
! -------------
  real(kind=DP), allocatable :: ker_ex(:,:), ker_cr(:,:,:)
  real(kind=DP), allocatable :: ker_xc_triplet(:,:,:),  ker_xc_singlet(:,:,:)
  real(kind=DP), allocatable :: zcos_LR(:), zsin_LR(:)
! ----------------------------------------- DYSON && ALDA_R ---
  Complex(kind=CMPLDP), allocatable :: MatrixT(:,:,:,:)
  Complex(kind=CMPLDP), allocatable :: MatrixG(:,:,:,:,:)
!                                  Matrix G =  RhoTilde * Fxc
! ---------------------------- temporary ----------
  real(kind=DP), allocatable,dimension(:):: afft     ! d(ista_fftp:iend_fftp)
! 
  real(kind=DP), private, allocatable, dimension(:,:)  :: chden_l    
  real(kind=DP), private, allocatable, dimension(:,:)  :: grad_rho
  real(kind=DP), private, allocatable, dimension(:)  :: grad_trho
#ifndef _XC_SAVE_MEMORY_
  real(kind=DP),private,allocatable,dimension(:,:,:):: cgrad_rho ! MPI d(ista_fftph:iend_fftph,3,nspin)
#else
  real(kind=DP),private,allocatable,dimension(:):: cggawk13 ! MPI d(ista_fftph:iend_fftph)
#endif
! -----------------------
  real(kind=DP),private,pointer,dimension(:,:)  :: chgrhr_l    ! MPI d(ista_fftph:iend_fftph,ispin)
! GGA arrays
  integer, private,allocatable,dimension(:)   :: inx,jnx,knx ! MPI d(ista_fftp:iend_fftp
  real(kind=DP),private, pointer, dimension(:)   :: f2or1 ! MPI d(ista_fftph,iend_fftph)
  logical,      private, dimension(3)               :: lmn_even

  integer istatus( mpi_status_size )

! ------------
contains

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc Kernels evaluated on R-space
!!
!-------------------------------------------------------------------
  subroutine m_LR_alloc_RKernels_ALDA
    Allocate( ker_ex( ista_fftph:iend_fftph,nspin ) ); ker_ex = 0.0d0
    Allocate( ker_cr( ista_fftph:iend_fftph,nspin,nspin ) ); ker_cr = 0.0d0
  end subroutine m_LR_alloc_RKernels_ALDA

  subroutine m_LR_dealloc_RKernels_ALDA
    deallocate( ker_ex, ker_cr )
  end subroutine m_LR_dealloc_RKernels_ALDA

  subroutine m_LR_alloc_phase_factor
    Allocate( zcos_LR(ista_fftph:iend_fftph) );  zcos_LR = 0.0d0
    Allocate( zsin_LR(ista_fftph:iend_fftph) );  zsin_LR = 0.0d0
  end subroutine m_LR_alloc_phase_factor

  subroutine m_LR_dealloc_phase_factor
    Deallocate( zcos_LR, zsin_LR )
  end subroutine m_LR_dealloc_phase_factor

!------------------------------------------------------------------
!!
!!!            Alloc and Dealloc in the case of DYSON && ALDA_R
!!
!-------------------------------------------------------------------
  subroutine m_LR_alloc_Matrix_G
    if ( sw_LongWaveLimit == OFF ) then
       Allocate( MatrixG( kg1, neg, np_e, kv3_ek/(Num_q_Points+1), nspin ) )
    else
       Allocate( MatrixG( kg1, neg, np_e, kv3_ek, nspin ) )
    endif
  end subroutine m_LR_alloc_Matrix_G

  subroutine m_LR_dealloc_Matrix_G
    Deallocate( MatrixG )
  end subroutine m_LR_dealloc_Matrix_G

  subroutine m_LR_alloc_Matrix_T
    if ( mype == 0 ) then
       allocate( MatrixT( nmax_G_LR, nmax_G_LR, nspin, nspin ) )
       MatrixT = 0.0d0
    endif
  end subroutine m_LR_alloc_Matrix_T

  subroutine m_LR_dealloc_Matrix_T
    if ( mype == 0 ) deallocate( MatrixT )
  end subroutine m_LR_dealloc_Matrix_T

!-------------------------------------------------------
!!
!!!       igfp for LR 
!!
!--------------------------------------------------------
  subroutine m_LR_alloc_igfp
    allocate( igfp_LR(kgp) ); igfp_LR = 0
  end subroutine m_LR_alloc_igfp

  subroutine m_LR_dealloc_igfp
    deallocate( igfp_LR )
  end subroutine m_LR_dealloc_igfp

  subroutine m_LR_set_igfp
    integer, allocatable     :: igfp_tmp(:)

    if ( npes > 1 ) then
       allocate( igfp_tmp(kgp) ); igfp_tmp = 0
       igfp_tmp( ista_kngp:iend_kngp ) = igfp_l( ista_kngp:iend_kngp )
       call mpi_allreduce( igfp_tmp, igfp_LR, kgp, mpi_integer, mpi_sum, &
            &              mpi_comm_group, ierr )
       deallocate( igfp_tmp )
    else
       igfp_LR( ista_kngp:iend_kngp ) = igfp_l( ista_kngp:iend_kngp )
    endif
  end subroutine m_LR_set_igfp

!--------------------------------------------------------
!!
!!!        Matrix T  ( DYSON && ALDA_R ) in the case of Q > 0
!!
!---------------------------------------------------------
  subroutine Calc_MatrixT_General( e_value )       
    real(kind=DP), intent(in) :: e_value

    integer               :: i,j, k, ispin, jspin
    integer               :: ik1, ik2, ik3, ib1, ib2
    integer               :: k_max, nq_max

    real(kind=DP)         :: occ1, occ2, weight
    complex(kind=CMPLDP)  :: omega1, omega2, ztmp
! 
    integer :: id_sname = -1
! -------------------------------- start -----------
    call tstatc0_begin('Calc_MatrixT ', id_sname)

    nq_max = Num_q_points
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta ); 
! --
    if ( mype == 0) MatrixT = 0.0d0
! --------------------------------- main ----------
    Do i=1, nmax_G_LR
       Do j=1, nmax_G_LR

          Do ispin=1, nspin
             Do jspin=1, nspin
                ztmp = 0.0d0

                Do k=1, k_max
                   ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
                   ik2 = ik1 + nspin
                   ik3 =  nspin*(k-1) + ispin 
                
                   weight = qwgt_ek(ik1) *nspin

                   Do ib1=band_start_LR, band_end_LR      ! unoccpuied state
                      occ1 = Occup_lkt_ek( ib1, ik1 );  
                      if ( occ1 > DELTA ) cycle
                      
                      Do ib2=band_start_LR, band_end_LR     ! occupied state
                         occ2 = Occup_lkt_ek( ib2, ik2 )  
                         if ( occ2 < DELTA ) cycle
                         if ( map_e(ib2) /= myrank_e ) cycle
                         
                         call summation_ztmp
                      End do
                   End do
                End do
                call add_ztmp_to_MatrixT
             End do
          End do
       End do
    End do
!! ----------------------------- end ------------
    if ( mype == 0 ) then
       if ( nspin==1 ) MatrixT = MatrixT *2.0d0
!!    if ( nspin==1 ) MatrixT = MatrixT *2.0d0 * 2.0d0
    endif
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine summation_ztmp
      integer :: jb2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      jb2 = map_z(ib2)

      ebi = Eko_ek( ib1,ik1 ); ebj = Eko_ek( ib2,ik2 )
      ediff = ebi - ebj + scissor

      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2

      z1 = RhoTilde( i, ib1, jb2, ik3 )
      z2 = MatrixG( j, ib1, jb2,  ik3, jspin )
!
      c1 = ( 1.0D0 - occ1 ) *occ2
!      ztmp = ztmp + c1 *conjg( z1 )* z2 *gfn *weight
      ztmp = ztmp + c1 *z1 * z2 *gfn *weight
    end subroutine summation_ztmp

    subroutine add_ztmp_to_MatrixT
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         ztmp = zsum
      endif
      if ( mype == 0 ) MatrixT( i,j,ispin,jspin ) = ztmp / univol
    end subroutine add_ztmp_to_MatrixT

  end subroutine Calc_MatrixT_General

!--------------------------------------------------------
!!
!!!        Matrix T  ( DYSON && ALDA_R ) in the case of LongWaveLimit
!!
!---------------------------------------------------------
  subroutine Calc_MatrixT_LWLimit( e_value )
    real(kind=DP), intent(in) :: e_value

    integer               :: i,j, k, ispin, jspin
    integer               :: ik1, ik2, ik3, ib1, ib2
    integer               :: k_max, nq_max
    real(kind=DP)         :: occ1, occ2, weight
    complex(kind=CMPLDP)  :: omega1, omega2, ztmp
! ----
    integer :: id_sname = -1
! ------------------------------- start ---------
    call tstatc0_begin('Calc_MatrixT_LWLimit ', id_sname)
!
    nq_max = 0
    call set_value_kmax
    omega1 = cmplx( e_value, eta );  omega2 = cmplx( e_value, -eta ); 
! --
    if ( mype == 0 ) MatrixT = 0.0d0
! ------------------------------ main -----------------
    Do i=1, nmax_G_LR
       Do j=1, nmax_G_LR
           
          Do ispin=1, nspin
             Do jspin=1, nspin
                ztmp = 0.0d0

                Do k=1, k_max
                   ik1 = ( nq_max +1 )*nspin*(k-1) + ispin
                   ik2 = ik1 + nspin
                   ik3 =  nspin*(k-1) + ispin 
                !
                   weight = qwgt_ek(ik1) *nspin

                   Do ib1=band_start_LR, band_end_LR         ! unoccpuied state
                      occ1 = Occup_lkt_ek( ib1, ik1 );  
                      if ( occ1 > DELTA ) cycle
                      
                      Do ib2=band_start_LR, band_end_LR         ! occupied state
                         occ2 = Occup_lkt_ek( ib2, ik1 )  
                         if ( occ2 < DELTA ) cycle
                         if ( map_e(ib2) /= myrank_e ) cycle

                         call summation_ztmp
                      End do
                   End do
                End do
                call add_ztmp_to_MatrixT
             End do
          End do
       End do
    End do
!! ----------------------------- end ------------
    if ( mype == 0 ) then
       if ( nspin==1 ) MatrixT = MatrixT *2.0d0
!!    if ( nspin==1 ) MatrixT = MatrixT *2.0d0 * 2.0d0
    endif
!    MatrixT = 0.0d0
    call tstatc0_end(id_sname)

  contains

    subroutine set_value_kmax
      if ( way_of_smearing == TETRAHEDRON ) then
         k_max = np2
      else
         k_max = kv3_ek / ( nspin*( nq_max + 1 ))
      endif
    end subroutine set_value_kmax

    subroutine summation_ztmp
      integer       :: jb2
      Real(kind=DP) :: ebi, ebj, ediff, c1
      Complex(kind=CMPLDP) :: zd1, zd2, z1, z2, gfn

      jb2 = map_z(ib2)

      ebi = Eko_ek( ib1,ik1 ); ebj = Eko_ek( ib2,ik1 )
      ediff = ebi - ebj + scissor
      
      zd1 = omega1 - ediff;  zd2 = omega2 + ediff
      gfn = 1.0d0 / zd1 - 1.0d0 / zd2

      z1 = RhoTilde( i, ib1, jb2, ik3 )
      z2 = MatrixG(  j, ib1, jb2, ik3, jspin )

      c1 = ( 1.0D0 - occ1 ) *occ2
      ztmp = ztmp + c1 *conjg( z1 )* z2 *gfn *weight
!!!!!!      ztmp = ztmp + c1 * z1 * z2 *gfn *weight
    end subroutine summation_ztmp

    subroutine add_ztmp_to_MatrixT
      Complex(kind=CMPLDP) :: zsum

      if ( npes > 1 ) then
         call mpi_allreduce( ztmp, zsum, 2, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         ztmp = zsum
      endif
      if ( mype == 0 ) MatrixT( i,j,ispin,jspin ) = ztmp / univol
    end subroutine add_ztmp_to_MatrixT

  end subroutine Calc_MatrixT_LWLimit

!--------------------------------------------------------
!!
!!!        Matrix G   ( DYSON && ALDA_R ) in the case of Q > 0
!!
!---------------------------------------------------------
  subroutine Add_SoftPart_MatG_General
    Real(kind=DP), allocatable :: wf1(:), wf2(:), chg1r(:), chg1i(:)
    Real(kind=DP), allocatable :: wf2_mpi(:), wf_tmp(:)
    
    Real(kind=DP) :: occ1, occ2
    integer ngrid, nffth, nfftph
    integer ik, jk
    integer ib1, ib2
    integer :: id_sname = -1
! --------------------------- start ----------
    call tstatc0_begin('Add_SoftPart_MatG_General', id_sname)
! 
    ngrid = product(fft_box_size_CD(1:3,1))
    nffth  = nfft/2;    nfftph = nfftp/2
    call m_FFT_alloc_CD_box()
    call set_work_arrays()
! ---------------------------- main ------------------      
    Do ik=1, kv3
       
       Do ib1=1, neg                  ! unOccupied Band
          
          if ( nrd_efermi ==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif
          call set_wf1()
          
          Do ib2=1, neg                ! occupied Band
             
             if ( nrd_efermi==1 ) then
                occ2 = occup_kmq( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if
             call set_wf2

             Do jk=1, kv3              ! kv3 should be equal to nspin
                call set_chg1
                call set_each_element_in_MatG
             End do
          End do
       End do
    End do
! -----------------------------------end --------------------
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()
    call tstatc0_end(id_sname)

  contains

    subroutine set_work_arrays
      allocate( wf1(ista_fftp:iend_fftp) ); wf1 = 0.0d0
      allocate( wf2(ista_fftp:iend_fftp) ); wf2 = 0.0d0
      allocate( chg1r(ista_fftph:iend_fftph) ); chg1r = 0.0d0
      allocate( chg1i(ista_fftph:iend_fftph) ); chg1i = 0.0d0
      allocate( wf2_mpi(nfftp) ); wf2_mpi= 0.0d0
      if ( npes > 1 ) then
         allocate( wf_tmp(nfftp) ); wf_tmp = 0.0d0
      endif
    end subroutine set_work_arrays

    subroutine unset_work_arrays
      deallocate( wf1, wf2 ); deallocate( chg1r, chg1i )
      deallocate( wf2_mpi )
      if ( npes > 1 ) deallocate( wf_tmp )
    end subroutine unset_work_arrays

    subroutine set_wf1()
      call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1, &
           &                     nbase_k, iba_k, igfp_LR, map_z_k )
      wf1 = wf1 / sqrt(univol)
    end subroutine set_wf1

    subroutine set_wf2()
      call  Get_WF_in_Rspace_CD( ik, ib2, wfn_kmq, wf2, &
           &                     nbase_kmq, iba_kmq, igfp_LR, map_z_kmq )
      wf2 = wf2 / sqrt(univol)
    end subroutine set_wf2

    subroutine set_chg1()
      integer :: i, ip

      Do i=ista_fftph, iend_fftph
         ip = 2*i-1
         chg1r(i) = wf1(ip) *wf2(ip)   + wf1(ip+1) *wf2(ip+1)
         chg1i(i) = wf1(ip) *wf2(ip+1) - wf1(ip+1) *wf2(ip)
      End do
    end subroutine set_chg1

    subroutine set_each_element_in_MatG
      integer :: i, ip, ri
      integer :: ic1, jb2
      Real(kind=DP) :: weight

      Do i=ista_fftph,iend_fftph
         ip = 2*i-1
         weight = ker_cr( i,ik,jk )
         chg1r(i) =  weight *chg1r(i);   chg1i(i) =  weight *chg1i(i)
      End do
      wf2 = 0.0d0
      do i=ista_fftph,iend_fftph
         ip = 2*i-1
         wf2(ip)   =  chg1r(i);  wf2(ip+1) =  chg1i(i)
      end do
      call m_FFT_CD_direct_c( nfout, wf2 )   !  Rspace -> G-space 
!--
      wf2_mpi = 0.0d0
      wf2_mpi(ista_fftp:iend_fftp) = wf2(ista_fftp:iend_fftp) / dble(ngrid) *univol
      if ( npes > 1 ) then
         call mpi_allreduce( wf2_mpi, wf_tmp, nfftp, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         wf2_mpi = wf_tmp
      endif
! --------------------
      if ( map_e(ib2) == myrank_e ) then
         jb2 = map_z_k(ib2)

         ic1 = ( nk_in_the_process -1 )/ ( nspin*(Num_q_Points+1) )
         Do i=1, iba_k(ik)
            ip = 2 *igfp_LR( nbase_k(i,ik) ) -1
            MatrixG( i, ib1,jb2, ik +ic1*nspin, jk ) &
                 &     = dcmplx( wf2_mpi(ip), wf2_mpi(ip+1) )
!               MatrixG( i, ib1,jb2, ik +ic1*nspin, jk ) &
!                    &     = dcmplx( wf2_mpi(ip), -wf2_mpi(ip+1) )
         Enddo
      endif
    end subroutine set_each_element_in_MatG

  end subroutine Add_SoftPart_MatG_General

!--------------------------------------------------------
!!
!!!        Matrix G   ( DYSON && ALDA_R ) in the case of LongWaveLimit
!!
!---------------------------------------------------------
  subroutine Add_SoftPart_MatG_LWLimit
    Real(kind=DP), allocatable :: wf1(:), wf2(:), chg1r(:), chg1i(:)
    Real(kind=DP), allocatable :: wf2_mpi(:), wf_tmp(:)

    Real(kind=DP) ::  occ1, occ2
    integer ngrid, nffth, nfftph
    integer ik, jk
    integer ib1, ib2
    integer :: id_sname = -1
!
    integer iii
! ------------------------------ start -------------
    call tstatc0_begin('Add_SoftPart_MatG_LWLimit ', id_sname)
! -
    ngrid = product(fft_box_size_CD(1:3,1))
    nffth  = nfft/2;    nfftph = nfftp/2
    call m_FFT_alloc_CD_box()
    call set_work_arrays()
! ------------------------------- main --------------      
    Do ik=1, kv3
       
       Do ib1=1, neg               ! unOccupied Band
          
          if ( nrd_efermi ==1 ) then
             occ1 = occup_k( ib1,ik )
             if ( occ1 > DELTA ) cycle
          endif
          call set_wf1()
!            Do iii=1, nfftp
!               write(*,*) ' wf1 i ', iii, wf1(iii)
!            End Do
!            stop

          Do ib2=1, neg                ! occupied Band
             
             if ( nrd_efermi==1 ) then
                occ2 = occup_k( ib2,ik )
                if ( occ2 < DELTA ) cycle
             end if
             call set_wf2

             Do jk=1, kv3              ! kv3 should be equal to nspin
                call set_chg1
                call set_each_element_in_MatG
             End do
          End do
       End do
    End do
! ------------------------------end ---------------
    call unset_work_arrays
    call m_FFT_dealloc_CD_box()
    call tstatc0_end(id_sname)

      Do jk=1, nmax_G_LR
         Do ib1=1, neg
            Do ib2=1, neg
               write(*,*) 'AA A ', jk, ib1, ib2, MatrixG( jk,ib1,ib2,1,1)
            End Do
         End Do
      End do
      stop
! ------------

  contains

    subroutine set_work_arrays()
      allocate( wf1(ista_fftp:iend_fftp) ); wf1 = 0.0d0
      allocate( wf2(ista_fftp:iend_fftp) ); wf2 = 0.0d0
      allocate( chg1r(ista_fftph:iend_fftph) ); chg1r = 0.0d0
      allocate( chg1i(ista_fftph:iend_fftph) ); chg1i = 0.0d0
      allocate( wf2_mpi(nfftp) ); wf2_mpi= 0.0d0
      if ( npes > 1 ) then
         allocate( wf_tmp(nfftp) ); wf_tmp = 0.0d0
      endif
    end subroutine set_work_arrays

    subroutine unset_work_arrays()
      deallocate( wf1, wf2 ); deallocate( chg1r, chg1i )
      deallocate( wf2_mpi )
      if ( npes > 1 ) deallocate( wf_tmp )
    end subroutine unset_work_arrays

    subroutine set_wf1
      call  Get_WF_in_Rspace_CD( ik, ib1, wfn_k, wf1, &
           &                     nbase_k, iba_k, igfp_LR, map_z_k )
    end subroutine set_wf1

    subroutine set_wf2
      call  Get_WF_in_Rspace_CD( ik, ib2, wfn_k, wf2, &
           &                     nbase_k, iba_k, igfp_LR,  map_z_k )
      wf2 = wf2 / sqrt(univol)
    end subroutine set_wf2

    subroutine set_chg1
      integer :: i, ip

      Do i=ista_fftph, iend_fftph
         ip = 2*i-1
         chg1r(i) = wf1(ip) *wf2(ip)   + wf1(ip+1) *wf2(ip+1)
         chg1i(i) = wf1(ip) *wf2(ip+1) - wf1(ip+1) *wf2(ip)
      End do
    end subroutine set_chg1

    subroutine set_each_element_in_MatG
      integer :: i, ip, ri
      integer :: ic1, jb2
      Real(kind=DP) :: weight

      Do i=ista_fftph,iend_fftph
         ip = 2*i-1
         weight = ker_cr( i,ik,jk )
         chg1r(i) =  weight *chg1r(i);   chg1i(i) =  weight *chg1i(i)
      End do
      wf2 = 0.0d0
      do i=ista_fftph,iend_fftph
         ip = 2*i-1
         wf2(ip)   =  chg1r(i);  wf2(ip+1) =  chg1i(i)      
      end do
      call m_FFT_CD_direct_c( nfout, wf2 )   !  Rspace -> G-space 
!--
      wf2_mpi = 0.0d0
      wf2_mpi(ista_fftp:iend_fftp) = wf2(ista_fftp:iend_fftp) / dble(ngrid) *univol
      if ( npes > 1 ) then
         call mpi_allreduce( wf2_mpi, wf_tmp, nfftp, MPI_DOUBLE_PRECISION, &
              &              MPI_SUM, mpi_comm_group, ierr )
         wf2_mpi = wf_tmp
      endif
! --------------------
      if ( map_e(ib2) == myrank_e ) then
         jb2 = map_z_k(ib2)

         ic1 = ( nk_in_the_process -1 )/ nspin
         Do i=1, iba_k(ik)
            ip = 2 *igfp_LR( nbase_k(i,ik) ) -1
            MatrixG( i, ib1,jb2, ik +ic1*nspin, jk ) &
                 &     = dcmplx( wf2_mpi(ip), wf2_mpi(ip+1) )
!            MatrixG( i, ib1,jb2, ik +ic1*nspin, jk ) &
!                 &     = dcmplx( wf2_mpi(ip), -wf2_mpi(ip+1) )
         Enddo
      endif
    end subroutine set_each_element_in_MatG

  end subroutine Add_SoftPart_MatG_LWLimit
  
!-----------------------------------------------------
!!
!!!          phase factor 
!!
!------------------------------------------------------
  subroutine calc_phase_factor
    integer i, ip, ngrid
    Real(kind=DP) :: ph, da(3), tmp_vec(3)
!
    ngrid = product( fft_box_size_CD(1:3,1) )
    da(1:3) = 1.d0 / fft_box_size_CD(1:3,1)
!
    write(*,*) 'UUUU', da(1), da(2), da(3)
!    stop
    Do i = ista_fftph, iend_fftph
       ip = 2*i - 1
        write(*,*) 'ZZZ', i
       tmp_vec(1) = dble( inx(ip) ) *da(1)
       tmp_vec(2) = dble( jnx(ip) ) *da(2)
       tmp_vec(3) = dble( knx(ip) ) *da(3)
!         write(*,*) 'YY', ip, inx(ip), jnx(ip), knx(ip)
!         write(*,*) 'YY', ip, tmp_vec(1), tmp_vec(2), tmp_vec(3)

       ph = -PAI2 * dot_product( vqxyz(1,:,BUCS), tmp_vec(:) )
       zcos_LR(i) = cos(ph);      zsin_LR(i) = sin(ph)
    End do
  end subroutine calc_phase_factor

  subroutine set_ispin_kt(ispin, input_Charge )
    integer, intent(out) :: ispin
    integer, intent(in)  :: input_Charge
    if( nspin == 2 .and. input_charge == Valence_plus_PC_Charge ) then
       ispin = 2
    else
       ispin = 1
    endif
  end subroutine set_ispin_kt

  subroutine Calc_Density_in_Rspace(ispin, input_Charge )
    integer, intent(in) :: ispin, input_Charge

    integer :: iloop
    integer jj
    Real(kind=DP) :: csum

    Do iloop = 1, ispin
       if(ipri >= 2) write(nfout,'(" ! (m_XC_cal_potential) , iloop = ",i5)') iloop
#ifdef _OLD_MAP_CHARGE_
       call map_charge_onto_a_fft_box(chgq_l)     !-(m_XC_Pot.) -> afft(*) (xcchg2)
#else
       call map_charge_onto_a_fft_box2(nfout,chgq_l)    !-(m_XC_Pot.) -> afft(*) (xcchg2)
#endif
       if(ipri >= 2) then
          write(nfout,'(" ista_fftp, iend_fftp, np_fftp, mp_fftp = ",4i8)' ) &
               & ista_fftp, iend_fftp, np_fftp, mp_fftp
       end if
       if (check_of_xctype() == GGA) then
          chden_l(ista_fftp:iend_fftp,iloop) = afft(ista_fftp:iend_fftp)
       end if

       if(myrank_ggacmp < nrank_ggacmp) then
!          write(*,*) 'DEBUG A', myrank_ggacmp, nrank_ggacmp, afft(1)*univol
          call m_FFT_CD_inverse_c(nfout,afft)  ! afft(G_sp.) -> afft(R_sp.)
          call m_FFT_check_of_negative_CD(npes_cdfft,ista_fftp,iend_fftp&
               & ,ista_fftph,iend_fftph,afft,nfout,nspin,iloop)
       end if
       if(ipri >= 2) write(nfout,'(" ! out of m_FFT_check_of_negative_CD <<m_XC_cal_potential>>")')
       call cp_afft_to_chgrhr    ! -(contained here) afft -> chgrhr_l
    End do
! ------------------------ check --
!    csum = 0.0d0
!    Do jj=1, nfftp /2
!       csum = csum + chgrhr_l(jj,1)
!    End do
!    write(*,*) 'csum = ', csum, csum * univol / dble(nfftp/2)
!    stop                       ! csum *univol /(nffph) == Nelec
! ------------------------------ gga -----
    call check_lmn_even  ! -(contained in subr. m_XC_cal_potential) ->lmn_even

    if(xctype == 'ldapw91' .or. xctype == 'ldapbe ') then
       grad_rho = 0.d0; grad_trho = 0.d0
#ifndef _XC_SAVE_MEMORY_
       cgrad_rho = 0.d0
#endif
    else
       call abs_grad_rho_up_down_total(ispin)
      !   chden_l ->
      !   |grad(rho_up(r))|,|grad(rho_down(r))|  --> grad_rho
      !   |grad(rho_up(r) + rho_down(r))|        --> grad_trho
    end if
! ----------------------------------------------
    !
   contains
    
    subroutine cp_afft_to_chgrhr
      integer  :: i

      if(myrank_ggacmp < nrank_ggacmp) then
         do i = ista_fftph, iend_fftph    ! MPI
            chgrhr_l(i,iloop) = afft(i*2-1)
         end do
      else
         do i = ista_fftph, iend_fftph    ! MPI
            chgrhr_l(i,iloop) = 0.d0
         end do
      end if

      if(ipri >= 2) then
         write(nfout,'(" !XC -- chgrhr_l -- <<cp_afft_to_chgrhr>>")')
         write(nfout,'(" !XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
         write(nfout,'(" !XC -- afft --     <<cp_afft_to_chgrhr>>")')
         write(nfout,'(" !XC ",6f12.6)') (afft(i*2-1),i=ista_fftph,ista_fftph+17)
      end if
    end subroutine cp_afft_to_chgrhr

    subroutine map_charge_onto_a_fft_box2(nfout,chgq_l)
      integer, intent(in) :: nfout
      real(DP),intent(in) :: chgq_l(ista_kngp:iend_kngp,kimg,nspin)
      real(kind=DP)      :: fac
      integer            :: mm, it, i, j
      real(kind=DP),allocatable,dimension(:)    :: tmp_s, tmp_r ! MPI d(nfftp/npes)
      real(kind=DP),allocatable,dimension(:,:)  :: chgqplus_l ! MPI d(ista_kngp:iend_kngp)
      integer, allocatable, dimension(:)        :: ip ! d(ista_kngp:iend_kngp,3)
      integer, allocatable, dimension(:)        :: igfp_s, igfp_r ! d(nfftp/npes)
      integer, allocatable, dimension(:,:)      :: igfp_ijk ! d(ista_kngp:iend_kngp+(0,1),3)
      integer, allocatable, dimension(:)        :: ipout_s, ipout_r ! d(nfftp/npes)
      integer, allocatable, dimension(:)        :: np ! d(0:npes_cdfft-1)
      integer, allocatable, dimension(:,:)      :: np_send, np_tmp ! d(ista_kngp:iend_kngp,npes)
      integer :: pe_s, pe_r, datasize_s, datasize_r, nfp, igp, nb, npc, maxdatasize
      integer :: nstart, nend, lx, lxy, ipout, j0, k, l, np0, idp, icdfft
      integer, allocatable, dimension(:) :: req_r,req_s
      
      integer :: id_sname = -1
      call tstatc0_begin('map_charge_onto_a_fft_box2 ',id_sname)

      allocate(chgqplus_l(ista_kngp:iend_kngp,kimg))

      if(input_charge == Valence_plus_PC_Charge) then
         fac = 1.d0/nspin
      else if(input_charge == Partial_Core_Charge) then
         fac = 1.d0
      else
        stop ' Error of ixc in <<<map_charge_onto_a_fft_box2>>>'
      endif

      chgqplus_l = 0.d0
      mm = 0
      do it = 1, ntyp
         if(itpcc(it) == 0) cycle
         mm = mm + 1
         do j = 1, kimg
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               chgqplus_l(i,j) = chgqplus_l(i,j) &
                    & + fac*zfm3_l(i,it,j)*rhpcg_l(i,mm)   !mpi
            end do
         end do
      end do

      if(input_charge == Valence_plus_PC_Charge) then
         do j = 1, kimg
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               chgqplus_l(i,j) = chgqplus_l(i,j) + chgq_l(i,j,iloop)
            end do
         end do
      end if

      afft = 0.d0
      if(npes > 1) then
         allocate(ip(ista_kngp:iend_kngp)); ip = -1
         allocate(np(0:npes-1)); np = 0
         allocate(np_send(0:npes-1,0:npes-1))
      end if

#ifdef _MPIFFT_
      if(mod(iend_kngp-ista_kngp+1,2) == 1) then
         allocate(igfp_ijk(ista_kngp:iend_kngp,3))
      else
         allocate(igfp_ijk(ista_kngp:iend_kngp+1,3))
      end if
      idp = fft_box_size_CD_c(1,0)
      do l = ista_kngp, iend_kngp
         np0 = igfp_l_c(l)
         i   = mod(np0-1,idp)+1
         j   = mod((np0-i)/idp, ly) + 1
         k   = (np0-i-(j-1)*idp)/(idp*ly)+1
         igfp_ijk(l,1)  = i
         igfp_ijk(l,2)  = j
         igfp_ijk(l,3)  = k
      end do
      lx     = fft_box_size_CD_c(1,0)
      lxy    = lx*ly_d
#endif

      if(npes > 1) then
         np_send = 0
         np = 0
         do k = 0, npes-1
            if(map_pe2ggacmp(k) >= nrank_ggacmp) cycle
#ifdef _MPIFFT_
            icdfft = map_pe2cdfft(k)
            nstart = icdfft*ny_d+1
            nend   = min(fft_box_size_CD(2,1),(icdfft+1)*ny_d)
            do l = ista_kngp, iend_kngp
               j   = igfp_ijk(l,2)
               if(j >= nstart .and. j <= nend) then
                  if(map_pe2ggacmp(k) == 0) ip(l) = k
                  np(k) = np(k) + 1
               end if
            end do
#else
            icdfft = mod(k,npes_cdfft)
            do l = ista_kngp, iend_kngp
               igp = (igfp_l(l)-1)*kimg+1
               if(igp >= nis_fftp(icdfft) .and. igp <= nie_fftp(icdfft)) then
                  ip(l) = map_pe2cdfft(k)
                  np(k) = np(k) + 1
               end if
            end do
#endif
            if(ipri>=2)  write(nfout,'(" np(",i5,") = ",i8)') k, np(k)
         end do

         np_send(:,mype) = np(:)  ! number element sent from mype to j
         if(npes>1) then
            allocate(np_tmp(0:npes-1,0:npes-1))
            call mpi_allreduce(np_send,np_tmp,npes*npes,mpi_integer, mpi_sum, mpi_comm_group,ierr)
            np_send = np_tmp
            deallocate(np_tmp)
         end if
         maxdatasize = 0
         do j = 0, npes-1
            do i = 0, npes-1
               if(maxdatasize < np_send(i,j)) maxdatasize = np_send(i,j)
            end do
         end do
         if(ipri>=2) write(nfout,'(" maxdatasize = ",i8)') maxdatasize
      end if

#ifdef _MPIFFT_
      allocate(ipout_s(ista_kngp:iend_kngp))
      do l = ista_kngp, iend_kngp
         i = igfp_ijk(l,1)
         j = igfp_ijk(l,2)
         k = igfp_ijk(l,3)
         icdfft = (j-1)/ny_d
         j0 = j - ny_d*icdfft
         ipout_s(l) = kimg*(i + (j0-1)*lx + (k-1)*lxy - 1)  + nis_fftp(icdfft)
      end do
#endif

      ! mype -> mype
      if(myrank_ggacmp < nrank_ggacmp) then
#ifdef _MPIFFT_
         nstart = myrank_cdfft*ny_d+1
         nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
         if(kimg == 1) then
            if(npes > 1) then
               do l = ista_kngp, iend_kngp
                  i   = igfp_ijk(l,1)
                  if(i < 1 .or. i > fft_box_size_CD(1,1)) cycle
                  j   = igfp_ijk(l,2)
                  if(j >= nstart .and. j <= nend) then
                     ipout = ipout_s(l)
                     afft(ipout) = chgqplus_l(l,1)
                  end if
               end do
            else
               do l = ista_kngp, iend_kngp
                  ipout = ipout_s(l)
                  afft(ipout) = chgqplus_l(l,1)
               end do
            end if
         else
            if(npes > 1) then
               do l = ista_kngp, iend_kngp
                  i   = igfp_ijk(l,1)
                  if(i < 1 .or. i > fft_box_size_CD(1,1)) cycle
                  j   = igfp_ijk(l,2)
                  if(j >= nstart .and. j <= nend) then
                     ipout = ipout_s(l)
                     afft(ipout)   = chgqplus_l(l,1)
                     afft(ipout+1) = chgqplus_l(l,2)
                  end if
               end do
            else
               do l = ista_kngp, iend_kngp
                  ipout = ipout_s(l)
                  afft(ipout)   = chgqplus_l(l,1)
                  afft(ipout+1) = chgqplus_l(l,2)
               end do
            end if
         end if
#else
         if(kimg == 1) then
            do l = ista_kngp, iend_kngp
               igp = igfp_l(l)
               if(igp >= ista_fftp .and. igp <= iend_fftp) then
                  afft(igp) = chgqplus_l(l,1)
               end if
            end do
         else
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
#endif
            do l = ista_kngp, iend_kngp
               igp = (igfp_l(l)-1)*kimg+1
               if(igp >= ista_fftp .and. igp <= iend_fftp) then
                  afft(igp)   = chgqplus_l(l,1)
                  afft(igp+1) = chgqplus_l(l,2)
               end if
            end do
         end if
#endif
      end if

      if(npes > 1) then
         allocate(tmp_s(maxdatasize*kimg))
         allocate(tmp_r(maxdatasize*kimg))
         allocate(igfp_s(maxdatasize),igfp_r(maxdatasize))
         allocate(req_r(npes-1))
         allocate(req_s(npes-1))
         do nb = 1, npes-1
            pe_s = mod(mype+nb,      npes)
            pe_r = mod(mype-nb+npes, npes)
#ifdef _MPIFFT_
            icdfft = map_pe2cdfft(pe_s)
#endif
            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) then
               tmp_s = 0.d0
               igfp_s = 0
               nfp = 0
          if(kimg==1) then
               do l = ista_kngp, iend_kngp
                  if(ip(l) == map_pe2cdfft(pe_s)) then
                     nfp = nfp+1
#ifdef _MPIFFT_
                     igfp_s(nfp) = ipout_s(l)
#else
                     igfp_s(nfp) = kimg*(igfp_l(l)-1)+1
#endif
                        tmp_s(nfp) = chgqplus_l(l,1)
                  end if
               end do
          else
               do l = ista_kngp, iend_kngp
                  if(ip(l) == map_pe2cdfft(pe_s)) then
                     nfp = nfp+1
#ifdef _MPIFFT_
                     igfp_s(nfp) = ipout_s(l)
#else
                     igfp_s(nfp) = kimg*(igfp_l(l)-1)+1
#endif
                        tmp_s(2*nfp-1) = chgqplus_l(l,1)
                        tmp_s(2*nfp)   = chgqplus_l(l,2)
                  end if
               end do
          endif

               datasize_s = np_send(pe_s,mype)*kimg
               if(ipri>=2) then
                  write(nfout,'(" nb, pe_s,pe_r = ",3i8)') nb, pe_s,pe_r
                  write(nfout,'(" nfp*kimg   = ", i8)') nfp*kimg
                  write(nfout,'(" datasize_s = ",i8)') datasize_s
               end if
               if(datasize_s /= nfp*kimg) stop ' datasize_s /= nfp*kimg'
               call mpi_isend(tmp_s,datasize_s,mpi_double_precision, &
                    & pe_s, mype, mpi_comm_group,req_s(nb),ierr)
            end if
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) then
               datasize_r = np_send(mype,pe_r)*kimg
               if(ipri>=2) write(nfout,'(" datasize_r = ",i8)') datasize_r
               call mpi_irecv(tmp_r,datasize_r,mpi_double_precision, &
                    & pe_r, pe_r,  mpi_comm_group,req_r(nb),ierr)
            end if
            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) &
                 & call mpi_wait(req_s(nb),istatus,ierr) 
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) &
                 & call mpi_wait(req_r(nb),istatus,ierr)
            if(ipri>=2) write(nfout,'( " tmp_s , tmp_r  completed")')

            datasize_s = np_send(pe_s,mype)
            datasize_r = np_send(mype,pe_r)
            if(map_pe2ggacmp(pe_s) < nrank_ggacmp .and. np_send(pe_s,mype) > 0) then
               call mpi_isend(igfp_s,datasize_s,mpi_integer, &
                    & pe_s, mype, mpi_comm_group, req_s(nb),ierr)
            end if
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) then
               call mpi_irecv(igfp_r,datasize_r,mpi_integer, &
                    & pe_r, pe_r,  mpi_comm_group, req_r(nb),ierr)
            end if
            if(map_pe2ggacmp(pe_s) <nrank_ggacmp .and. np_send(pe_s,mype) > 0) &
                 & call mpi_wait(req_s(nb),istatus,ierr)
            if(myrank_ggacmp < nrank_ggacmp .and. np_send(mype,pe_r) > 0) &
                 & call mpi_wait(req_r(nb),istatus,ierr)
            if(ipri>=2) write(nfout,'( " igfp_s , igfp_r  completed")')

            if(myrank_ggacmp < nrank_ggacmp) then
               if(kimg == 1) then
                  do l = 1, np_send(mype,pe_r)
                     ipout = igfp_r(l)
                     afft(ipout) = tmp_r(l)
                  end do
               else
#ifdef NEC_TUNE_MXCP
!CDIR NODEP
#endif
                  do l = 1, np_send(mype,pe_r)
                     ipout = igfp_r(l)
                     afft(ipout)   = tmp_r(2*l-1)
                     afft(ipout+1) = tmp_r(2*l)
                  end do
               end if
            end if
         end do
         deallocate(req_s, req_r)
         deallocate(igfp_r, igfp_s)
         deallocate(tmp_r,tmp_s)
      end if
#ifdef _MPIFFT_
      deallocate(ipout_s)
      deallocate(igfp_ijk)
#endif
      if(npes > 1) then
         deallocate(np_send,np, ip)
      end if
      deallocate(chgqplus_l)

      call tstatc0_end(id_sname)

    end subroutine map_charge_onto_a_fft_box2

  end subroutine Calc_Density_in_Rspace
    
  subroutine afft_allgatherv(afft_mpi0,afft)
    !  Upgraded on 19 Sep. 2006 by T. Yamasaki
    !    * MPIFFT
    real(kind=DP),intent(in),dimension(:) :: afft_mpi0(ista_fftp:iend_fftp)
    real(kind=DP),intent(out),dimension(:):: afft(nfftp)
#ifdef _MPIFFT_
    real(kind=DP), allocatable, dimension(:) :: afft_tmp
    integer  :: nstart, nend, lx, lxy, llx, lly, llxy, i, j, jj, k, ipin, ipout
    integer  :: nb, datasize, pe_s, pe_r
    integer, allocatable, dimension(:) :: req_s, req_r
    real(kind=DP), allocatable, dimension(:) :: tmp_s, tmp_r
#endif
    integer  :: id_sname = -1
!----------------------------- start ------------
    call tstatc0_begin('afft_allgatherv(in m_XC_Potential) ',id_sname)
    if(npes>=2)  call mpi_barrier(mpi_comm_group,ierr)
    
    if(npes_cdfft >= 2) then
       if(myrank_ggacmp < nrank_ggacmp) then
#ifdef _MPIFFT_
          afft = 0.d0
#ifndef _ALLREDUCE_AFFT_ALLGAHTERV_
          
          datasize = nfftp/npes_cdfft
          allocate(tmp_s(datasize)); tmp_s = 0.d0
          allocate(tmp_r(datasize)); tmp_r = 0.d0
          allocate(req_r(npes-1),req_s(npes-1))
          
          lx     = fft_box_size_CD_c(1,0)
          lxy    = lx*ly_d
          llx    = fft_box_size_CD_c(1,0)
          lly    = fft_box_size_CD_c(2,0)
          llxy   = llx*lly
          
          do i = 1, iend_fftp-ista_fftp+1
             tmp_s(i) = afft_mpi0(i+ista_fftp-1)
          end do
          
          do nb = 1, npes_cdfft-1
             pe_s = mod(myrank_cdfft+nb,           npes_cdfft)
             pe_r = mod(myrank_cdfft-nb+npes_cdfft,npes_cdfft)
             call mpi_irecv(tmp_r,datasize,mpi_double_precision, &
                  & pe_r,pe_r,        mpi_cdfft_world(myrank_ggacmp),req_r(nb),ierr)
             call mpi_isend(tmp_s,datasize,mpi_double_precision, &
                  & pe_s,myrank_cdfft,mpi_cdfft_world(myrank_ggacmp),req_s(nb),ierr)
             call mpi_wait(req_r(nb),istatus,ierr)
             call mpi_wait(req_s(nb),istatus,ierr)
             
             nstart = pe_r*ny_d+1
             nend   = min(fft_box_size_CD(2,1),(pe_r+1)*ny_d)
             
             if(kimg == 1) then
                do k = 1, fft_box_size_CD(3,1)
                   do j = nstart, nend
                      jj = j - nstart + 1
                      do i = 1, fft_box_size_CD(1,1)
                         ipin  = i + (jj-1)* lx + (k-1)* lxy
                         ipout = i + ( j-1)*llx + (k-1)*llxy
                         afft(ipout)   = tmp_r(ipin)
                      end do
                   end do
                end do
             else if(kimg == 2) then
                do k = 1, fft_box_size_CD(3,1)
                   do j = nstart, nend
                      jj = j - nstart + 1
                      do i = 1, fft_box_size_CD(1,1)
                         ipin  = 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                         ipout = 2*(i + ( j-1)*llx + (k-1)*llxy)-1
                         afft(ipout)   = tmp_r(ipin)
                         afft(ipout+1) = tmp_r(ipin+1)
                      end do
                   end do
                end do
             end if
          end do
          deallocate(req_s,req_r)
          deallocate(tmp_s)
          deallocate(tmp_r)
          
! diagonal part
          nstart = myrank_cdfft*ny_d+1
          nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
!!$          allocate(afft_tmp(nfftp))
            
          if(kimg == 1) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + (i + (jj-1)* lx + (k-1)* lxy)
                      ipout =               (i + ( j-1)*llx + (k-1)*llxy)
                      afft(ipout)   = afft_mpi0(ipin)
                   end do
                end do
             end do
          else if(kimg == 2) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                      ipout =               2*(i + ( j-1)*llx + (k-1)*llxy)-1
                      afft(ipout)   = afft_mpi0(ipin)
                      afft(ipout+1) = afft_mpi0(ipin+1)
                   end do
                end do
             end do
          end if
#else
          nstart = myrank_cdfft*ny_d+1
          nend   = min(fft_box_size_CD(2,1),(myrank_cdfft+1)*ny_d)
          lx     = fft_box_size_CD_c(1,0)
          lxy    = lx*ly_d
          llx    = fft_box_size_CD_c(1,0)
          lly    = fft_box_size_CD_c(2,0)
          llxy   = llx*lly
          allocate(afft_tmp(nfftp))
          
          if(kimg == 1) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + (i + (jj-1)* lx + (k-1)* lxy)
                      ipout =               (i + ( j-1)*llx + (k-1)*llxy)
                      afft(ipout)   = afft_mpi0(ipin)
                   end do
                end do
             end do
          else if(kimg == 2) then
             do k = 1, fft_box_size_CD(3,1)
                do j = nstart, nend
                   jj = j - nstart + 1
                   do i = 1, fft_box_size_CD(1,1)
                      ipin  = ista_fftp-1 + 2*(i + (jj-1)* lx + (k-1)* lxy)-1
                      ipout =               2*(i + ( j-1)*llx + (k-1)*llxy)-1
                      afft(ipout)   = afft_mpi0(ipin)
                      afft(ipout+1) = afft_mpi0(ipin+1)
                   end do
                end do
             end do
          end if
          call mpi_allreduce(afft, afft_tmp, nfftp, mpi_double_precision, mpi_sum, mpi_cdfft_world(myrank_ggacmp),ierr)
          afft = afft_tmp
#endif
          
#else
          call mpi_allgatherv(afft_mpi0,nel_fftp(myrank_cdfft),mpi_double_precision, afft,nel_fftp,idisp_fftp,&
          & mpi_double_precision,mpi_cdfft_world(myrank_ggacmp),ierr)
#endif
       end if
    else
       afft = afft_mpi0
    end if
    
    if(nrest_cdfft >= 1) then
       if(mype > npes_cdfft*nrank_ggacmp-1) then
          call mpi_recv(afft,nfftp,mpi_double_precision &
               & , mype-npes_cdfft*nrank_ggacmp,1,mpi_comm_group,istatus,ierr)
       end if
       if(mype < nrest_cdfft) then
          call mpi_send(afft,nfftp,mpi_double_precision &
               & , mype+npes_cdfft*nrank_ggacmp,1,mpi_comm_group,ierr)
       end if
    end if
    
    call tstatc0_end(id_sname)
    
  end subroutine afft_allgatherv

  subroutine xc_allocate(ispin,nfout)
    integer, intent(in)      :: ispin,nfout

    integer                  :: idp,nlp,nmp,nnp,nd2p,nd3p,ip, idph, nlph
    integer                  :: n, nn, i, j, k
#ifdef _MPIFFT_
    integer                  :: np0, j0, i2, j2, k2, n0
#endif

#ifndef _MPIFFT_
    call m_FFT_alloc_CD_box()
#endif
    allocate(afft(ista_fftp:iend_fftp));afft=0.d0
    allocate(chgrhr_l(ista_fftph:iend_fftph,ispin))    ! MPI
    allocate(f2or1(ista_fftph:iend_fftph))
 
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
    idp  = fft_box_size_CD_c(1,0)
    nd2p = fft_box_size_CD_c(2,0)
    nd3p = fft_box_size_CD_c(3,0)
#else
    idp  = fft_box_size_CD(1,0)
    nd2p = fft_box_size_CD(2,0)
    nd3p = fft_box_size_CD(3,0)
#endif

    call set_f2or1(npes_cdfft,ista_fftph,iend_fftph,f2or1)

    if(check_of_xctype() == GGA) then
       allocate(inx(ista_fftp:iend_fftp)); inx = 0
       allocate(jnx(ista_fftp:iend_fftp)); jnx = 0
       allocate(knx(ista_fftp:iend_fftp)); knx = 0

!
!       write(*,*) 'Maji Maji ', inx
!       stop
#ifdef _MPIFFTTESTTEST_
       if(kimg == 1) then
          do n = ista_fftp, iend_fftp
             nn = n
             if(nn == ista_fftp-1) write(nfout,'(" n == ista_fftp-1 = ",i8)') nn
             np0 = nn - idp*ly_d*lz*myrank_cdfft
             i  = mod(np0-1,idp)+1
             j0 = mod((np0-i)/idp,ly_d) + 1
             j  = j0 + ny_d*myrank_cdfft
             k  = (np0-i-(j0-1)*idp)/(idp*ly_d) + 1
             if(i >= idp) i = i - idp
             inx(n) = i - 1;  if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
             jnx(n) = j - 1;  if(2*jnx(n) > nmp) jnx(n) = jnx(n) - nmp
             knx(n) = k - 1;  if(2*knx(n) > nnp) knx(n) = knx(n) - nnp
          end do

!!$          do k = 0, nnp-1
!!$             k2 = k; if(2*k2 > nnp) k2 = k2 - nnp
!!$             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
!!$                j = j0 + ny_d*myrank_cdfft
!!$                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
!!$                n0 = 1+j0*idp + k*idp*ly_d + ista_fftp-1
!!$                do i = 0, nlp-1
!!$                   n = i+n0
!!$                   inx(n) = i; if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
!!$                   if(n == ista_fftp-1) write(nfout,'(" n = ista_fftp-1 = ",i8)') n 
!!$                   jnx(n) = j2
!!$                   knx(n) = k2
!!$                end do
!!$             end do
!!$          end do

!!$          do i = 0, nlp-1
!!$             i2 = i; if(2*i2 > nlp) i2 = i2 - nlp
!!$             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
!!$                j = j0 + ny_d*myrank_cdfft
!!$                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
!!$                do k = 0, nnp/2
!!$                   n = i+1 + j0*idp + k*idp*ly_d + ista_fftp-1
!!$                   inx(n) = i2
!!$                   jnx(n) = j2
!!$                   knx(n) = k
!!$                end do
!!$                do k = nnp/2+1, nnp-1
!!$                   n = i+1 + j0*idp + k*idp*ly_d + ista_fftp-1
!!$                   inx(n) = i2
!!$                   jnx(n) = j2
!!$                   knx(n) = k - nnp
!!$                end do
!!$             end do
!!$          end do
       else if(kimg == 2) then
          do k = 0, nnp-1
             k2 = k; if(2*k2 > nnp) k2 = k2 - nnp
             do j0 = 0, min(ny_d, nmp-ny_d*myrank_cdfft)-1
                j = j0 + ny_d*myrank_cdfft
                j2 = j; if(2*j2 > nmp) j2 = j2 - nmp
                do i = 0, nlp/2
                   n = i+1 + j0*idp + k*idp*ly_d
                   nn = n*2-1 + ista_fftp-1
                   inx(nn) = i ; inx(nn+1) = i
                   jnx(nn) = j2; jnx(nn+1) = j2
                   knx(nn) = k2; knx(nn+1) = k2
                end do
                do i = nlp/2+1, nlp-1
                   n = i+1 + j0*idp + k*idp*ly_d
                   nn = n*2-1 + ista_fftp-1
                   inx(nn) = i-nlp ; inx(nn+1) = i-nlp
                   jnx(nn) = j2; jnx(nn+1) = j2
                   knx(nn) = k2; knx(nn+1) = k2
                end do
             end do
          end do
       end if
#else
       do n = ista_fftp, iend_fftp
          nn = (n+kimg-1)/kimg    ! nn = n (when kimg=1), nn = (n+1)/2 (when kimg=2)
#ifdef _MPIFFT_
!!$          if(nn == ista_fftp-1) write(nfout,'(" n == ista_fftp-1 = ",i8)') nn
          np0 = nn - idp*ly_d*lz*myrank_cdfft
          i  = mod(np0-1,idp)+1
          j0 = mod((np0-i)/idp,ly_d) + 1
          j  = j0 + ny_d*myrank_cdfft
          k  = (np0-i-(j0-1)*idp)/(idp*ly_d) + 1
          if(i >= idp) i = i - idp
#else
          i  = mod(nn,idp)
          j  = mod((nn-1)/idp,nd2p) + 1
          k  = (nn - (j-1)*idp - i)/(idp*nd2p) + 1
#endif
          inx(n) = i - 1;  if(2*inx(n) > nlp) inx(n) = inx(n) - nlp
          jnx(n) = j - 1;  if(2*jnx(n) > nmp) jnx(n) = jnx(n) - nmp
          knx(n) = k - 1;  if(2*knx(n) > nnp) knx(n) = knx(n) - nnp
       end do
#endif

!       write(*,*) 'Ua ', mype, inx(1), jnx(1), knx(1)
!       write(*,*) 'Va ', mype, inx(2), jnx(2), knx(2)
!       write(*,*) 'Ub ', mype, inx(3), jnx(3), knx(3)
!       write(*,*) 'Vb ', mype, inx(4), jnx(4), knx(4)
!       stop

       allocate(chden_l(ista_fftp:iend_fftp,nspin)); chden_l = 0.d0 
       allocate(grad_trho(ista_fftph:iend_fftph));   grad_trho = 0.0d0
       allocate(grad_rho(ista_fftph:iend_fftph,nspin)); grad_rho = 0.d0

#ifndef _XC_SAVE_MEMORY_
       if(nrank_ggacmp > 1) then
          allocate(cgrad_rho(ista_fftph:iend_fftph,myrank_ggacmp+1:myrank_ggacmp+1,nspin))  ! MPI
       else
          allocate(cgrad_rho(ista_fftph:iend_fftph,3,nspin))  ! MPI
       end if
#else
       allocate(cggawk13(ista_fftph:iend_fftph))           ! MPI
#endif
!!       allocate(dF_drho(ista_fftph:iend_fftph,nspin))      ! MPI
!!       allocate(dF_dgradrho(ista_fftph:iend_fftph,nspin))  ! MPI
    end if

  contains
    subroutine set_f2or1(npes,ista,iend,f2or1)
      integer, intent(in) :: npes,ista, iend
      real(kind=DP), intent(out), dimension(ista:iend) :: f2or1
      integer :: idph,nlph,ip,i,j,k

      if(kimg == 1) then
         idph = idp/2
         nlph = nlp/2
#ifdef _MPIFFT_
         f2or1 = 0.d0
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nmp
!!$         do j = 1, min(nz_d,nnp-nz_d*myrank_cdfft)*nd2p
         do k = 1, min(nz_d, nnp-nz_d*myrank_cdfft)
            do j = 1, nmp
               do i = 1, nlph
!!$                  ip = i + idph*(j-1) + idph*ly*lz_d*myrank_cdfft
                  ip = i + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
                  f2or1(ip) = 2.d0
               end do
               ip = 1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
               ip = nlph+1 + idph*(j-1) + idph*ly*(k-1) + idph*ly*lz_d*myrank_cdfft
               f2or1(ip) = 1.d0
            end do
         end do
!!$            ip = idph*(j-1) + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$            ip = idph*(j-1)+ nlph + 1 + idph*ly*lz_d*myrank_cdfft
!!$            f2or1(ip) = 1.d0
!!$         end do
#else
         f2or1 = 2.d0
         if(npes >= 2) then
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               if(ip>= ista .and. ip <= iend) f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + 1
               f2or1(ip) = 1.d0
            end do
            do i = 1, nd2p*nnp
               ip = idph*(i-1) + nlph + 1
               f2or1(ip) = 1.d0
            end do
            do j = nlph+2, idph
               do i = 1,nd2p*nnp
                  ip = idph*(i-1)+j
                  f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p
               do k = 1, nnp
                  do i = 1, nlph
                     ip = i + idph*(j-1) + idph*nd2p*(k-1)
                     f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p
               do i = 1, idph*nd2p
                  ip = i + idph*nd2p*(k-1)
                  f2or1(ip) = 0.d0
               end do
            end do
         end if
!!$       do i = ista, iend
!!$          if(mod(i*2,idp) == 2 .or. mod(i*2,idp) == 0) f2or1(i) = 1.d0
!!$       end do
#endif
      else
#ifdef _MPIFFT_
!!$         f2or1 = 0.d0                               ! f2or1 works to the fft data in R space.
!!$         do k = 1, min(nz_d,nnp-nz_d*myrank_cdfft)
!!$            do j = 1, nmp     ! nmp = fft_box_size_CD(2,1)
!!$               do i = 1, nlp  ! nlp = fft_box_size_CD(1,1)
!!$                  ip = i+(j-1)*idp+(k-1)*idp*nd2p+idp*nd2p*lz_d*myrank_cdfft
!!$                  f2or1(ip) = 1.d0
!!$               end do
!!$            end do
!!$         end do
         if(ipri >= 2 ) write(nfout,'(" ix kimg = 2 <<set_f2or1>>")')
         f2or1 = 1.d0
         do j = nlp+1, idp      ! x
            do i = 1, ly*nz_d
               ip = idp*(i-1)+j+ista-1
               f2or1(ip) = 0.d0
            end do
         end do
         if(ipri >= 2 ) write(nfout,'(" iy kimg = 2 <<set_f2or1>>")')
         do j = nmp+1,ly         ! y
            do k = 1, nz_d
               do i = 1, nlp
                  ip = i + idp*(j-1) + idp*ly*(k-1) + ista-1
                  f2or1(ip) = 0.d0
               end do
            end do
         end do
         if(ipri >= 2 ) write(nfout,'(" iz kimg = 2 <<set_f2or1>>")')
         do  k = nz_d+1, lz_d   ! z
            do i = 1, idp*ly
               ip = i + idp*ly*(k-1) + ista-1
               f2or1(ip) = 0.d0
            end do
         end do
#else
         f2or1 = 1.d0
         if(npes >= 2) then
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
                  if(ip>= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
                     if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
                  if(ip >= ista .and. ip <= iend) f2or1(ip) = 0.d0
               end do
            end do
         else
            do j = nlp+1, idp    ! x
               do i = 1, nd2p*nnp
                  ip = idp*(i-1)+j
                  f2or1(ip) = 0.d0
               end do
            end do
            do j = nmp+1, nd2p   ! y
               do k = 1, nnp
                  do i = 1, nlp
                     ip = i + idp*(j-1) + idp*nd2p*(k-1)
                     f2or1(ip) = 0.d0
                  end do
               end do
            end do
! for SX6 ASL 20040817
            do k = nnp+1, nd3p   ! z
               do i = 1, idp*nd2p
                  ip = i + idp*nd2p*(k-1)
                  f2or1(ip) = 0.d0
               end do
            end do
         end if
#endif
      end if
    end subroutine set_f2or1
  end subroutine xc_allocate

  subroutine xc_deallocate
#ifndef _MPIFFT_
    call m_FFT_dealloc_CD_box()
#endif
    deallocate(afft)
    deallocate(chgrhr_l)
    deallocate(f2or1)

    if(check_of_xctype() == GGA) then
       deallocate(inx); deallocate(jnx); deallocate(knx)
       deallocate(chden_l)
       deallocate(grad_trho)
#ifndef _XC_SAVE_MEMORY_
       deallocate(cgrad_rho)
#else
       deallocate(cggawk13)
#endif
       deallocate(grad_rho); 
!!        deallocate(dF_drho)
!!       deallocate(dF_dgradrho)

    end if
  end subroutine xc_deallocate

! ------------------------- GGA --------------------------
  subroutine abs_grad_rho_up_down_total(ispin)
    integer, intent(in) :: ispin
    real(kind=DP),allocatable,dimension(:)    :: grad_rho_c2  ! MPI d(ista_fftph:iend_fftph)
    integer  :: is, in, i
    real(kind=DP) :: x,y,z

#ifdef _DETAIL_GGA_TIMING_
    integer :: id_sname = -1
#endif
    if(nrank_ggacmp > 1) allocate(grad_rho_c2(ista_fftph:iend_fftph))    ! MPI

    do is = 1, ispin
       grad_rho(:,is) = 0.d0
       do in = 1, 3
          if(map_ggacmp(in) /= myrank_ggacmp) cycle
          call g_xyz_chden_l(in,is)        ! G_xyz * rho_{up|down}(G)-->afft
          if(ipri >= 2) call wd_small_part_of_afft_kt(34,'G space before<m_FFT_CD_inverse_c)',120, is )
          call m_FFT_CD_inverse_c(nfout,afft)! (-i)*d(rho_{up|down}(r))/d(x|y|z)
          if(ipri >= 2) call wd_small_part_of_afft_kt(34,'R space after <m_FFT_CD_inverse_c)',120, is)
#ifndef _XC_SAVE_MEMORY_
          call cp_afft_to_cgrad_rho(is,in) ! -> cgrad_rho(i,in,is) = -afft(i*2)
#endif
          call add_sq_afft_to_grad_rho(is) ! grad_rho <--  + afft**2
          if(ipri >= 2) then
             write(nfout,'(" !XC after add_sq_afft_to_grad_rho: is, in = ",2i8)') is, in
             write(nfout,'(" !XC -- grad_rho -- <<abs_grad_rho_up_down_total>>")')
             write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=ista_fftph,ista_fftph+17)
             write(nfout,'(" !XC ",6f12.6)') (grad_rho(i,1),i=iend_fftph-17,iend_fftph)
#ifndef _XC_SAVE_MEMORY_
             write(nfout,'(" !XC -- cgrad_rho -- <<abs_grad_rho_up_down_total>>")')
             write(nfout,'(" !XC ",6f12.6)') (cgrad_rho(i,in,1),i=ista_fftph,ista_fftph+17)
             write(nfout,'(" !XC ",6f12.6)') (cgrad_rho(i,in,1),i=iend_fftph-17,iend_fftph)
#endif
          end if
          
       end do
       
       if(ipri >= 2) write(nfout,'(" !XC after add_sq_afft_to_grad_rho")')
! --> grad_rho_c
       if(nrank_ggacmp > 1) then
          grad_rho_c2(:) = grad_rho(:,is)
#ifdef _DETAIL_GGA_TIMING_
          call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
          call mpi_allreduce(grad_rho_c2,grad_trho,iend_fftph-ista_fftph+1 &
               & ,mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
#ifdef _DETAIL_GGA_TIMING_
          call tstatc0_end(id_sname)
#endif
          grad_rho(:,is) = dsqrt(grad_trho(:))
       else
          grad_rho(:,is) = dsqrt(grad_rho(:,is)) ! grad_rho(s) <-- |grad(rho_s(r))|
       end if
    enddo
    if(ispin == 2) then
#ifndef _XC_SAVE_MEMORY_
       if(nrank_ggacmp > 1) then
          grad_rho_c2 = 0.d0
!!$            if(myrank_ggacmp >= 0 .and. myrank_ggacmp <=2) then
          do i = ista_fftph, iend_fftph
             x = cgrad_rho(i,myrank_ggacmp+1,1) + cgrad_rho(i,myrank_ggacmp+1,2)
             grad_rho_c2(i) = grad_rho_c2(i) + x*x
          end do
#ifdef _DETAIL_GGA_TIMING_
          call tstatc0_begin('mpi_allreduce(ggaxcp) ',id_sname)
#endif
          call mpi_allreduce(grad_rho_c2,grad_trho,iend_fftph-ista_fftph+1 &
               & , mpi_double_precision, mpi_sum, mpi_ggacmp_cross_world(myrank_cdfft),ierr)
#ifdef _DETAIL_GGA_TIMING_
          call tstatc0_end(id_sname)
#endif
          grad_trho = dsqrt(grad_trho)
       else
          do in = ista_fftph, iend_fftph
             x = cgrad_rho(in,1,1) + cgrad_rho(in,1,2)
             y = cgrad_rho(in,2,1) + cgrad_rho(in,2,2)
             z = cgrad_rho(in,3,1) + cgrad_rho(in,3,2)
             grad_trho(in) = dsqrt(x*x+y*y+z*z)
          end do
       end if
#else
       do in = 1, 3
          call g_xyz_total_chden_l(in)     ! G_xyz*(rho(G)up+rho(G)down) -> afft
          call m_FFT_CD_inverse_c(nfout,afft)!(-i)*d(rho_total(r))/d(x|y|z)
          call add_sq_afft_to_grad_trho
       end do
       grad_trho = dsqrt(grad_trho)     ! grad_trho <-- |grad(rho_total(r))|
#endif
    else
       grad_trho(:) = grad_rho(:,1)
    end if
    if(nrank_ggacmp > 1) deallocate(grad_rho_c2)
  end subroutine abs_grad_rho_up_down_total
  
  subroutine g_xyz_chden_l(in,is)
    integer, intent(in) :: in,is
    integer       :: n
    real(kind=DP) :: gxyz
    
!!$      deallocate(afft)
!!$      allocate(afft(ista_fftp:iend_fftp))

    afft = 0.d0
    do n = ista_fftp, iend_fftp  ! MPI
       gxyz = rltv(in,1)*inx(n)+rltv(in,2)*jnx(n)+rltv(in,3)*knx(n)
       afft(n) = gxyz*chden_l(n,is)
    enddo
    call boundary_zero_into_afft(in)  ! -(contained in subr. m_XC_cal_potential)
  end subroutine g_xyz_chden_l
  
  subroutine check_lmn_even
    integer             :: nlmn, i
    
    do i = 1, 3
       nlmn = fft_box_size_CD(i,1)/2
       if(2*nlmn == fft_box_size_CD(i,1)) then
          lmn_even(i) = .true.
       else
          lmn_even(i) = .false.
       end if
    end do
  end subroutine check_lmn_even
  
  subroutine boundary_zero_into_afft(in)
    integer, intent(in) :: in
    integer             :: i,j,k,nn,n,idp,nlp,nmp,nnp,nd2p, j0
    
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)
#ifdef _MPIFFT_
    idp = fft_box_size_CD_c(1,0)
    nd2p = fft_box_size_CD_c(2,0)
#else
    idp = fft_box_size_CD(1,0)
    nd2p = fft_box_size_CD(2,0)
#endif
    
    if(kimg == 1) then
       if(lmn_even(in)) then
          if( in == 1) then
#ifdef _MPIFFT_
             do j = 1, ly_d*lz
!!$               do j0 = 1, ly_d
!!$                  do k = 1, nnp
!!$                     nn = nlp/2 + 1 + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                nn = nlp/2 + 1 + idp*(j-1) + idp*ly_d*lz*myrank_cdfft
                afft(nn) = 0.d0
!!$                  end do
             end do
#else
             do j = 1, nmp      ! y
                do k = 1, nnp   ! z
!!$                  nn = nlp/2 + 1 + idp*(j-1) + idp*nmp*(k-1)
                   nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
                   if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                end do
             end do
#endif
          else if( in == 2) then
#ifdef _MPIFFT_
             j0 = nmp/2 + 1 - ny_d*myrank_cdfft
             if(j0 >= 1 .and. j0 <= ny_d) then
                do i = 1, idp
                   do k = 1, nnp
                      nn = i + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                      afft(nn) = 0.d0
                   end do
                end do
             end if
#else
             do i = 1, idp      ! x
                do k = 1, nnp   ! z
                   nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                   if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                end do
             end do
#endif
          else if(in == 3) then
#ifdef _MPIFFT_
             do i = 1, idp
                do j = 1+ny_d*myrank_cdfft, min(nmp,ny_d*(myrank_cdfft+1))
                   nn = i + idp*(j-1-ny_d*myrank_cdfft) + idp*ly_d*(nnp/2) &
                        &                          + idp*ly_d*lz*myrank_cdfft
                   afft(nn) = 0.d0
                end do
             end do
#else
             do i = 1, idp      ! x
                do j = 1, nmp   ! y
                   nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                   if(nn >= ista_fftp .and. nn <= iend_fftp) afft(nn) = 0.d0
                end do
             end do
#endif
          end if
       end if
    else if(kimg == 2) then
       if(lmn_even(in)) then
          if( in == 1) then
#ifdef _MPIFFT_
             do j = 1, ly_d*lz
                nn = nlp/2 + 1 + idp*(j-1) + idp*ly_d*lz*myrank_cdfft
                n = nn*2 - 1
                afft(n) = 0.d0
                afft(n+1) = 0.d0
             end do
#else               
             do j = 1, nmp
                do k = 1, nnp
!!$                  nn = nlp/2 + 1 + idp*(j-1) + idp*nmp*(k-1)
                   nn = nlp/2 + 1 + idp*(j-1) + idp*nd2p*(k-1)
!!$                     nn = nlp/2 + 1 + idp*(j-1) -idp*ly_d*myrank_cdfft &
!!$                          & +idp*ly_d*(k-1+myrank_cdfft)
                   n  = nn*2 - 1
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                   n  = nn*2
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                end do
             end do
#endif
          else if( in == 2) then
#ifdef _MPIFFT_
             j0 = nmp/2 + 1 - ny_d*myrank_cdfft
             if(j0 >= 1 .and. j0 <= ny_d) then
                do i = 1, idp
                   do k = 1, nnp
                      nn = i + idp*(j0-1) + idp*ly_d*(k-1) + idp*ly_d*lz*myrank_cdfft
                      n  = nn*2 - 1
                      afft(n) = 0.d0; afft(n+1) = 0.d0
                   end do
                end do
             end if
#else
             do i = 1, idp
                do k = 1, nnp
!!$                     nn = i + idp*(nmp/2) + idp*nmp*(k-1)
                   nn = i + idp*(nmp/2) + idp*nd2p*(k-1)
                   n  = nn*2 - 1
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                   n  = nn*2
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                end do
             end do
#endif
          else if(in == 3) then
#ifdef _MPIFFT_
             do i = 1, idp
                do j = 1+ny_d*myrank_cdfft, min(nmp,ny_d*(myrank_cdfft+1))
                   nn = i + idp*(j-1-ny_d*myrank_cdfft) + idp*ly_d*(nnp/2) &
                        &                          + idp*ly_d*lz*myrank_cdfft
                   n  = nn*2 - 1
                   afft(n) = 0.d0
                   afft(n+1) = 0.d0
                end do
             end do
#else
             do i = 1, idp
                do j = 1, nmp
!!$                  nn = i + idp*(j-1) + idp*nmp*(nnp/2)
                   nn = i + idp*(j-1) + idp*nd2p*(nnp/2)
                   n  = nn*2 - 1
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                   n  = nn*2
                   if(n >= ista_fftp .and. n <= iend_fftp) afft(n) = 0.d0
                end do
             end do
#endif
          end if
       end if
    end if
  end subroutine boundary_zero_into_afft
  
#ifndef _XC_SAVE_MEMORY_
  subroutine cp_afft_to_cgrad_rho(is,in)
    integer, intent(in) :: is, in
    integer :: i
    do i = ista_fftph, iend_fftph
       cgrad_rho(i,in,is) = -afft(i*2)
    end do
  end subroutine cp_afft_to_cgrad_rho
  
#endif
  
  subroutine wd_small_part_of_afft_kt( len_str,str,ne,iloop )
    integer, intent(in)        :: len_str, iloop
    character(len=len_str),intent(in) :: str
    integer, intent(in)        :: ne
    
    integer                    :: i
!!$      if(mype == 0) then
    write(nfout, *) 'afft (',str,')'
    if(nspin == 2) write(nfout,*) ' #spin = ', iloop
    if(ne*2 > np_fftp) then
       write(nfout,*)  ' all elements'
       write(nfout,'(6f12.6)') (afft(i),i=ista_fftp, iend_fftp)
    else
       write(nfout,*) ' first ',ne,' elements'
!!$            write(nfout,'(6f12.6)') (afft(i),i=1,ne)
       write(nfout,'(6f12.6)') (afft(ista_fftp-1+i),i=1,ne)
       write(nfout,*) ' last ', ne,' elements'
       write(nfout,'(6f12.6)') (afft(iend_fftp-ne+i),i=1,ne)
    endif
!!$         write(nfout,'(" iend_fftp = ",i8)') iend_fftp
!!$         write(nfout,*) ' last ', lx*2,' elements'
!!$         write(nfout,'(" j, k = ", 2i8)') ly_d+ly_d*myrank_cdfft, lz
!!$         n = 2*((ly_d-1)*lx + (lz-1)*lx*ly_d) + ista_fftp - 1
!!$         write(nfout,'(8d12.4)') (afft( n+i),i=1,lx*2)
!!$         write(nfout,'(" n+lx*2 = ",i8)') n+lx*2
!!$            end do
!!$         end do
!!$         n = 0
!!$         do i = ista_fftp, iend_fftp
!!$            if(abs(afft(i)) > 1.d-8) n = n+1
!!$         end do
!!$         write(nfout,'(" number of non-zero term of afft = ",i8)') n
!!$      end if
  end subroutine wd_small_part_of_afft_kt

  subroutine add_sq_afft_to_grad_trho
    integer   :: i
    do i = ista_fftph, iend_fftph     ! MPI
       grad_trho(i) = grad_trho(i) + afft(i*2)**2
    end do
  end subroutine add_sq_afft_to_grad_trho
  
  subroutine add_sq_afft_to_grad_rho(is)
    integer, intent(in) :: is
    integer :: i
    do i = ista_fftph, iend_fftph     ! MPI
       grad_rho(i,is) = grad_rho(i,is) + afft(i*2)**2
    end do
  end subroutine add_sq_afft_to_grad_rho
! --------------------------------------------

  subroutine Calc_Kernels_ALDA_Rspace(ispin)
    integer, intent(in) :: ispin

    integer :: i, ni, nj
! --------------------------------- start ----------    
    if ( xctype == 'ldapw91' ) then
       Call calc_kernel_ex_ldapw91( nspin, ispin, chgrhr_l, ker_ex )
       Call calc_kernel_cr_ldapw91( nspin, ispin, chgrhr_l, ker_cr )
    else if ( xctype == 'ggapbe' ) then
       Call calc_kernel_ex_ggapbe( nspin, ispin, chgrhr_l, grad_rho, f2or1, ker_ex )
       Call calc_kernel_cr_ggapbe( nspin, ispin, chgrhr_l, grad_trho, f2or1, ker_cr )
    endif
! ------------------------- Exc ni shita baao ------
!    if ( xctype == 'ggapbe' ) then
!       Call calc_kt_ex_ggapbe( nspin, ispin, chgrhr_l, grad_rho, f2or1, ker_ex )
!       Call calc_kt_cr_ggapbe( nspin, ispin, chgrhr_l, grad_trho, f2or1, ker_cr )
!    endif
! ---------------------------------------------------
!      ker_ex = 0.0d0; ker_cr = 0.0d0
    Do ni=1, ispin
       Do nj=1, ispin
          if ( ni==nj ) then
             Do i=ista_fftph, iend_fftph
                ker_cr(i,ni,nj) = ker_ex(i,ni) + ker_cr(i,ni,nj)
             End do
          endif
       End do
    End do
! ---------------------- debug ----
!    ker_cr(:,1,1) = chgrhr_l(:,1)     ! atteru.
!    return
! ----------------------- only for experimtal ---
!            see. A. Marini et al, Comp.  Phys. Comm. 180 (2009) 1392.
! 
! -----------------------------------------------
    if ( sw_Fxc_enhanced == ON ) ker_cr = ker_cr * 2.0d0
!    if ( sw_Fxc_enhanced ) ker_cr = ker_cr * PAI
  end subroutine Calc_Kernels_ALDA_Rspace

end module m_LinearResponse_ALDA

#ifdef HIUX
*OPTION MP(P(0))
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: heap_sort, swap
!
!  AUTHOR: Takenori Yamamotoi   June/01/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
! coded by Takenori YAMAMOTO (Univ. Tokyo) for gen_rgrid in m_SpecialKpoints
! at Jun. 1, 2003
!
subroutine  heap_sort(m,n,a,key)
! $Id: heap_sort.F90 570 2017-04-21 20:34:50Z yamasaki $
!
! Heap sorting
! a(M,N) : array of M-componet vectors
! key    : key componet for sorting 
!
implicit none

integer(4), intent(in) :: m,n,key
real(8), intent(inout) :: a(m,n)

integer(4) :: i,j,k,itmp
real(8) :: tmp(m)

!*** initiation: heapify a ***
do i=2,n
  tmp(1:m)=a(1:m,i)
  j=i
10 itmp=j/2
  if(a(key,itmp).ge.tmp(key)) go to 20
  a(1:m,j)=a(1:m,itmp)
  j=itmp
  if(j.gt.1) go to 10
20 a(1:m,j)=tmp(1:m)
end do
!*** to be fully sort ***
do k=n-1,1,-1
  call swap(a(1,1),a(1,k+1))
  tmp(1:m)=a(1:m,1)
  j=1
  itmp=2
30 if(itmp.gt.k) go to 40
  if(itmp.lt.k) then
    if(a(key,itmp+1).gt.a(key,itmp)) itmp=itmp+1
  end if
  if(tmp(key).ge.a(key,itmp)) go to 40
  a(1:m,j)=a(1:m,itmp)
  j=itmp
  itmp=j*2
  go to 30
40 a(1:m,j)=tmp(1:m)
end do

return

contains

!*** swap ***
subroutine swap(a,b)

implicit none

real(8), intent(inout) :: a(m),b(m)
real(8) :: tmp(m)

tmp(1:m)=a(1:m)
a(1:m)=b(1:m)
b(1:m)=tmp(1:m)

return
end subroutine swap

end subroutine heap_sort

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE: m_BP_Properties
!
!  AUTHOR(S): T. Yamamoto   Oct/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
! ==============
!  patch 0.1 by K. Tagami @adv    2008/10/19
!
!     patch 0.1 :  correction in the case when nspin==2
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_BerryPhase
  ! $Id: m_BerryPhase.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters,    only : DP, PAI, PAI2, PAI4, ON, OFF
  use m_Control_Parameters,  only : ipriberry, nspin, printable, ndim_spinor, noncol
  use m_Files,               only : nfout
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &              , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e &
       &              , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &              , map_ek &
#ifdef TRANSPOSE
       &              , ierr,mp_e,nis_e,nie_e,nel_e &
       &              , ista_g1,iend_g1,np_g1,mp_g1,nis_g1,nie_g1,nel_g1
#else
       &              , ierr
#endif

  implicit none
  include 'mpif.h'
  integer, private :: n1,n2,jpara
  integer, private :: ig
  integer, private :: nkvec,nkprep
  integer, private :: nstate = -1
  integer, private :: ikp = 0
  integer, private :: sw_symmetry = 2 ! 1->idetical, 2->inversion, 3->full
  integer, private :: sw_deficit = ON ! 0->off, 1->on
  real(kind=DP), private :: g(3)
  real(kind=DP), allocatable, private :: kvec(:,:) ! dim(3,nkvec)
  real(kind=DP), allocatable, private :: wgh(:) ! dim(nkprep)
  real(kind=DP), allocatable, private :: wfbp0(:,:,:,:) ! dim(kg,np_e,2,nspin)
  real(kind=DP), allocatable, private :: wfbp1(:,:,:,:) ! dim(kg,np_e,2,nspin)
  real(kind=DP), allocatable, private :: wfbp2(:,:,:,:) ! dim(kg,np_e,2,nspin)
  integer, private :: kgbp0,kgbp1,kgbp2
  complex(kind=DP), allocatable, private :: det(:,:,:) ! dim(jpara,nkprep,nspin)
  real(kind=DP) :: kshift_BP(2)
  logical, private :: ikp0 = .true.

! for the US correction
  real(kind=DP), allocatable, private :: fsr_k0(:,:,:),fsi_k0(:,:,:) ! dim(np_e,nlmta,nspin)
  real(kind=DP), allocatable, private :: fsr_k1(:,:,:),fsi_k1(:,:,:) ! dim(np_e,nlmta,nspin)
  real(kind=DP), allocatable, private :: fsr_k2(:,:,:),fsi_k2(:,:,:) ! dim(np_e,nlmta,nspin
  real(kind=DP), allocatable, private :: zfcos(:),zfsin(:) ! dim(natm)
  real(kind=DP), allocatable, private :: ftqer(:,:,:),ftqei(:,:,:) ! dim(nlmt,nlmt,natm)

! Tags
  character(len("berry_phase")),private,parameter :: tag_berry_phase = "berry_phase"
  character(len("sw_berry_phase")),private,parameter :: tag_sw_berry_phase = "sw_berry_phase"
  character(len("g_index")),private,parameter :: tag_g_index = "g_index"
  character(len("mesh")),private,parameter :: tag_mesh = "mesh"
  character(len("n1")),private,parameter :: tag_n1 = "n1"
  character(len("n2")),private,parameter :: tag_n2 = "n2"
  character(len("j")),private,parameter :: tag_j = "j"
  character(len("kshift")),private,parameter :: tag_kshift = "kshift"
  character(len("k1")),private,parameter :: tag_k1 = "k1"
  character(len("k2")),private,parameter :: tag_k2 = "k2"
  character(len("sw_symmetry")),private,parameter :: tag_sw_symmetry = "sw_symmetry"
  character(len("sw_deficit")),private,parameter :: tag_sw_deficit = "sw_deficit"

! MPI
  !integer, private :: istatus
  integer, private :: istatus(mpi_status_size)

contains

  subroutine m_BP_rd_parameters
    use m_Crystal_Structure, only : rltv
    use m_Control_Parameters,  only : icond,sw_berry_phase
    use m_Const_Parameters, only : FIXED_CHARGE,FIXED_CHARGE_CONTINUATION
    implicit none

    integer :: iret, f_selectBlock, f_getIntValue, f_getRealValue &
         & ,f_getRealVectorValue
    integer :: f_selectParentBlock, f_selectTop
    real(kind=DP) :: dret

    if(icond /= FIXED_CHARGE .and. icond /= FIXED_CHARGE_CONTINUATION) return

    iret = f_selectTop()
    if( f_selectBlock( tag_berry_phase) == 0) then
       if( f_getIntValue( tag_sw_berry_phase, iret) == 0) sw_berry_phase = iret
       if( f_getIntValue( tag_sw_symmetry, iret) == 0) sw_symmetry = iret
       if( f_getIntValue( tag_sw_deficit, iret) == 0) sw_deficit = iret
       if( f_getIntValue( tag_g_index, iret) == 0) then
          ig = iret
       else
          ig = 1 ! default value
       end if
       if( f_selectBlock( tag_mesh) == 0) then
          if( f_getIntValue( tag_n1, iret) == 0) n1 = iret
          if( f_getIntValue( tag_n2, iret) == 0) n2 = iret
          if( f_getIntValue( tag_j, iret) == 0)  jpara = iret
       else
          n1 = 4 ! default value
          n2 = 4 ! default value
          jpara = 20 ! default value
       end if
       iret = f_selectParentBlock()
       if( f_selectBlock( tag_kshift) == 0) then
          if( f_getRealValue( tag_k1, dret, '' ) == 0) kshift_BP(1) = dret
          if( f_getRealValue( tag_k2, dret, '' ) == 0) kshift_BP(2) = dret
       else
          kshift_BP(1:2) = 0.d0 ! default value
       end if
       iret = f_selectParentBlock()
    end if
    iret = f_selectParentBlock()

    if(sw_berry_phase == ON .and. printable) then
       write(nfout,'(1x,"<< Berry Phase")')
       write(nfout,'(1x,"ig=",i1,1x,"g=",3(1x,f10.5))') ig,rltv(1:3,ig)
       write(nfout,'(1x,"n1=",i3,1x,"n2=",i3,1x,"J=",i3)') n1,n2,jpara
       write(nfout,'(1x,"k1=",f8.5,1x,"k2=",f8.5)') kshift_BP(1:2)
       write(nfout,'(1x,"sw_symmetry = ",i1)') sw_symmetry
       write(nfout,'(1x,"sw_deficit = ",i1)') sw_deficit
       write(nfout,'(1x,"   Berry Phase >>")')
    end if

  end subroutine m_BP_rd_parameters

  subroutine m_BP_gen_Kpoints(preallocation)
    use m_Kpoints, only: special_kpoints, kshift, mp_index
    use m_Crystal_Structure, only : rltv, nopr, op, imag
    use m_Const_Parameters,  only : CARTS,BUCS,PARA
    use m_Kpoints, only : kv3, vkxyz, qwgt, m_Kp_alloc_kpoints
    implicit none

    logical, intent(in) :: preallocation

! local variables
    integer :: i,j,k
    integer :: printlevel = 1
    integer :: nkpoint,nsym
    integer, parameter :: nkpmax0 = 10000
    real(kind=DP) :: kpoint(3,nkpmax0), weight(nkpmax0)
    real(kind=DP) :: bmat(3,3)
    real(kind=DP) :: c(3,2),b(3,2)
    real(kind=DP) :: cdot,g2,dg,w
    real(kind=DP) :: a1(3),a2(3),a3(3),volg
    real(kind=DP) :: rot(3,3,48),rot_g(3)
    real(kind=DP) :: scaled_g(3),scaled_a3(3)
    real(kind=DP) :: theta
    real(kind=DP), parameter :: eps = 1.d-12
    logical :: sw_trs = .true. ! time reversal symmetry
    logical :: magnetic, use_trs

    use_trs = .true.

! === KT_add === 2015/03/23
    if ( sw_symmetry == 1 ) use_trs = .false.

    if ( noncol ) then
       use_trs = .false.
    else
       if ( imag /= PARA ) use_trs = .false.
    endif
! ============== 2015/03/23

    if(imag/=PARA) then
       magnetic = .true.
    else
       magnetic = .false.
    end if

    bmat(1:3,1:3)=rltv(1:3,1:3)/PAI2

    g(1:3) = bmat(1:3,ig)
    k=0
    do i=1,3
       if(i /= ig) then
          k=k+1
          b(1:3,k)=bmat(1:3,i)
       end if
    end do

    g2 = sum(g(1:3)**2)
    do k=1,2
       cdot = sum(b(1:3,k)*g(1:3))/g2 
       c(1:3,k) = b(1:3,k) - cdot*g(1:3)
    end do

    call cross(c(1,2),g,a1)
    volg = sum(c(1:3,1)*a1(1:3))
    a1(1:3)=a1(1:3)/volg
    call cross(g,c(1,1),a2)
    a2(1:3)=a2(1:3)/volg
    call cross(c(1,1),c(1,2),a3)
    a3(1:3)=a3(1:3)/volg

    nsym=0
    do i=1,nopr
       do j=1,3
          rot_g(j) = sum(op(j,1:3,i)*g(1:3))
       end do
       if(abs(rot_g(1)-g(1)) < eps .and. &
            & abs(rot_g(2)-g(2)) < eps .and. &
            & abs(rot_g(3)-g(3)) < eps ) then
          nsym=nsym+1
          rot(1:3,1:3,nsym) = op(1:3,1:3,i)
       end if
    end do

    if(preallocation .and. printable) then
       write(nfout,'(1x,"<< k-points for an area integral in Berry phase calc.")')
       write(nfout,*) 'c1 = ',c(1:3,1)
       write(nfout,*) 'c2 = ',c(1:3,2)
       write(nfout,*) 'g  = ',g(1:3)
       write(nfout,*) 'a1 = ',a1(1:3)
       write(nfout,*) 'a2 = ',a2(1:3)
       write(nfout,*) 'a3 = ',a3(1:3)
       theta = sum(a1(1:3)*a2(1:3))/(sqrt(sum(a1(1:3)**2))*sqrt(sum(a2(1:3)**2)))
       theta = acos(theta) *360.d0 /PAI2
       write(nfout,*) 'angle between a1 and a2 (deg.) =',theta
    end if

! for identical symmetry olny
    if(sw_symmetry == 1 .or. sw_symmetry == 2) then
       nsym=1
       rot(1:3,1:3,nsym) = 0.d0
       do i=1,3
          rot(i,i,nsym) = 1.d0
       end do
    end if
    if(sw_symmetry == 1) sw_trs = .false.

    mp_index(1) = n1;     mp_index(2) = n2;     mp_index(3) = 1
    kshift(1:2) = kshift_BP(1:2);     kshift(3)=0.d0

    scaled_g(1:3)  = g(1:3)/dble(100.d0)
    scaled_a3(1:3) = a3(1:3)*dble(100.d0)

    nkprep = 0

    call special_kpoints(printlevel,nfout,nsym,rot &
         & , c(1,1),c(1,2),scaled_g,a1,a2,scaled_a3 &
                                !& , c(1,1),c(1,2),g,a1,a2,a3 &
         & , nkprep,nkpmax0,kpoint,weight,magnetic,use_trs)
    if(preallocation.and.printable) then
       write(nfout,'(1x,"   k-points for an area integral in Berry phase calc. >>")')
    end if

    nkvec=nkprep*jpara
    allocate(kvec(3,nkvec))
    allocate(wgh(nkprep))

    dg = 1.d0 /dble(jpara)
    nkvec=0
    do j=1,nkprep
!!!       wgh(j) = weight(j)/dble(nspin)
       wgh(j) = weight(j) /dble( nspin /ndim_spinor )     !!! to be checked !!

       do i=1,jpara
          nkvec=nkvec+1
          kvec(1:2,nkvec) = kpoint(1:2,j)
          kvec(3,nkvec)   = dg*dble(i-1)
       end do
    end do

    !kv3 = nkvec*nspin
    !call m_Kp_alloc_kpoints

    if(.not.preallocation) then

       kv3 = nkvec
       w=1.d0/dble(kv3)
       do i=1,nkvec
          vkxyz(i,1:3,CARTS) = 0.d0
          do j=1,2
             vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)+ c(1:3,j)*kvec(j,i)
          end do
          vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)+ g(1:3)*kvec(j,i)
          vkxyz(i,1:3,CARTS) = vkxyz(i,1:3,CARTS)*PAI2
          qwgt(i) = w
       end do

       if(printable) then
          write(nfout,'("<< generated k-points")')
          do i=1,nkvec
             write(nfout,'(1x,i4," k=",3(1x,f10.5),1x," k_cart=", &
                  & 3(1x,f10.5),1x,"w= ",f10.5)') &
                  & i,kvec(1:3,i),vkxyz(i,1:3,CARTS),qwgt(i)
          end do
          write(nfout,'("   generated k-points >>")')
       end if

       if ( noncol ) then
          allocate(det(jpara,nkprep,1));det=(0.d0,0.d0)
       else
          allocate(det(jpara,nkprep,nspin));det=(0.d0,0.d0)
       endif

       call set_dk_BP()

    else
       kv3 = nkvec *nspin
       deallocate(kvec,wgh)
    end if

    !stop 'm_BP_gen_Kpoints'

  contains

    subroutine cross(a,b,c)
      implicit none
      real(kind=DP), intent(in) :: a(3),b(3)
      real(kind=DP), intent(out) :: c(3)

!local variables
      integer :: i,j,k

      c(1) = a(2)*b(3)-a(3)*b(2)
      c(2) = a(3)*b(1)-a(1)*b(3)
      c(3) = a(1)*b(2)-a(2)*b(1)

    end subroutine cross

    subroutine set_dk_BP()
      use m_PseudoPotential, only : dk_BP

      dk_BP(1) = sqrt(sum(g(1:3)**2))/ dble(jpara) *PAI2
      !dk_BP(1) = 0.d0 ! for debug of Fourier transforms
      if(printable) then
         write(nfout,*) '!** set_dk_BP: dk_BP=',dk_BP(1)
      end if

    end subroutine set_dk_BP

  end subroutine m_BP_gen_Kpoints

  subroutine calc_phase_for_Berry()
    use m_Ionic_System,        only : pos,natm

! local variables
    integer       :: ia
    real(kind=DP) :: ph

    if(.not.allocated(zfcos)) allocate(zfcos(natm),zfsin(natm))

    ! debug
    !do ia=1,natm
    !  if(printable) write(nfout,*) ia,': pos=',pos(ia,1:3)
    !end do
    !if(printable) write(nfout,*) '--- ia,zfcos,zfsin ---'
    ! end debug

    do ia=1,natm
       ph = pos(ia,ig)*PAI2
       zfcos(ia) = cos(ph)
       zfsin(ia) = sin(ph)
       ! debug
       ! if(printable) write(nfout,*) ia,zfcos(ia),zfsin(ia)
       ! end debug
    end do

  end subroutine calc_phase_for_Berry

  subroutine m_BP_calc_det()
    use m_PseudoPotential,     only : nlmta
! === DEBUG by T.Kato 2013/07/11 ===============================================
    !use m_Electronic_Structure, only : neg, neordr
    use m_Electronic_Structure, only : neordr
    use m_Control_Parameters, only : neg
! ==============================================================================

    implicit none

! local variables
    integer :: i,k,k1,k2,j1,jj1,j2,kg,nk1,nk2
    integer :: ik,is, ismax, js, istmp
    integer :: j1_mpi,j1_ordr
    real(kind=DP) :: mr(nstate,nstate),mi(nstate,nstate)
    real(kind=DP), allocatable :: mr_mpi(:,:),mi_mpi(:,:)
    real(kind=DP), allocatable :: wfbp(:,:,:,:)
    real(kind=DP), allocatable :: fsr_k(:,:,:),fsi_k(:,:,:)

! for debug
    integer :: n

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    nk1 = mod(ikp,jpara)
    nk2 = ikp/jpara +1

    if(jpara>1) then

       kg = min(kgbp1,kgbp2)

       allocate(wfbp(kgbp2,nstate,2,nspin))
       call copy_old_wfbp_to_temp_wfbp(kgbp2,wfbp2,wfbp) ! MPI

       if(sw_deficit == ON) then
          allocate(fsr_k(nstate,nlmta,nspin),fsi_k(nstate,nlmta,nspin))
          call copy_old_fs_to_temp_fs(fsr_k2,fsi_k2,fsr_k,fsi_k) ! MPI
       end if

! === KT_mod === 2015/03/23
!       SPIN: do is =1,nspin
       SPIN: do is =1, ismax
! ============== 2015/03/23

          mr = 0.d0; mi = 0.d0
          ik = is

          Do js=1, ndim_spinor
             istmp = is +js -1

             do j2=1,nstate
                do j1=1,neg
                   if (map_ek(j1,ik) /= mype) cycle
                   j1_mpi = map_z(j1)
                   j1_ordr = neordr(j1,ik)
                   
                   if (j1_ordr > nstate) cycle
                   !if(printable) write(nfout,*) '>>>> j1_ordr is lower than nstate+1.'

                   do i=1,kg
                      mr(j1_ordr,j2) = mr(j1_ordr,j2) &
                           &          + wfbp1(i,j1_mpi,1,istmp) *wfbp(i,j2,1,istmp) &
                           &          + wfbp1(i,j1_mpi,2,istmp) *wfbp(i,j2,2,istmp)
                      mi(j1_ordr,j2) = mi(j1_ordr,j2) &
                           &          - wfbp1(i,j1_mpi,2,istmp) *wfbp(i,j2,1,istmp) &
                           &          + wfbp1(i,j1_mpi,1,istmp) *wfbp(i,j2,2,istmp)
                   end do
                   if (sw_deficit == ON) &
                        & call add_deficit_term( mr(j1_ordr,j2), mi(j1_ordr,j2), &
                        &                        fsr_k1, fsi_k1, fsr_k, fsi_k, &
                        &                        j1_mpi, j2, istmp )
                end do
             end do
          end Do   ! js

          call mpi_barrier(mpi_comm_group,ierr)
          if (npes>1) then
             allocate(mr_mpi(nstate,nstate),mi_mpi(nstate,nstate))
             mr_mpi=0.d0; mi_mpi=0.d0
             call mpi_allreduce(mr,mr_mpi,nstate**2,mpi_double_precision,mpi_sum, &
                  &             mpi_comm_group,ierr)
             mr = mr_mpi
             call mpi_allreduce(mi,mi_mpi,nstate**2,mpi_double_precision,mpi_sum, &
                  &             mpi_comm_group,ierr)
             mi = mi_mpi
             deallocate(mr_mpi,mi_mpi)
          end if

          call determinant(nstate,mr,mi,det(nk1,nk2,is))

          if(ipriberry > 1 .and. printable) then
             write(nfout,'(1x,"Overlap matrix: k1=",i4," k2=",i4," is=",i4)') nk1,nk1+1,is
             write(nfout,'(1x,"ikp=",i4)') ikp
             write(nfout,'(1x,"ikprep=",i4)') nk2
             write(nfout,'(1x,"kg=",i0)') kg
             write(nfout,'(1x,"Real part:")')
             do j1=1,nstate
                write(nfout,'(50(1x,f10.5))') mr(j1,1:nstate)
             end do
             write(nfout,'(1x,"Imag part:")')
             do j1=1,nstate
                write(nfout,'(50(1x,f10.5))') mi(j1,1:nstate)
             end do
             write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') nk1,nk1+1,is
             write(nfout,'("Det = ",e25.14," +i ",e25.14)') det(nk1,nk2,is)
          end if

       end do SPIN
       deallocate(wfbp)
       if(sw_deficit==ON) deallocate(fsr_k,fsi_k)

    end if

    if(nk1==jpara-1) then
       kg = min(kgbp2,kgbp0)

       allocate(wfbp(kgbp0,nstate,2,nspin))
       call copy_old_wfbp_to_temp_wfbp(kgbp0,wfbp0,wfbp) ! MPI
       if(sw_deficit == ON) then
          allocate(fsr_k(nstate,nlmta,nspin),fsi_k(nstate,nlmta,nspin))
          call copy_old_fs_to_temp_fs(fsr_k0,fsi_k0,fsr_k,fsi_k) ! MPI
       end if

! === KT_mod === 2015/03/23
!       SPIN2: do is =1,nspin
       SPIN2: do is =1, ismax
! ============== 2015/03/23

          mr =0.d0; mi=0.d0
          ik = is

          Do js=1, ndim_spinor
             istmp = is +js -1

             do j2=1,nstate
                do j1=1,neg
                   if(map_ek(j1,ik) /= mype) cycle
                   j1_mpi = map_z(j1)
                   j1_ordr = neordr(j1,ik)

                   if (j1_ordr > nstate) cycle
                !if(printable) write(nfout,*) '>>>> j1_ordr is lower than nstate+1.'
                   
                   do i=1,kg
                      mr(j1_ordr,j2) = mr(j1_ordr,j2) &
                           &          + wfbp2(i,j1_mpi,1,istmp)*wfbp(i,j2,1,istmp) &
                           &          + wfbp2(i,j1_mpi,2,istmp)*wfbp(i,j2,2,istmp)
                      mi(j1_ordr,j2) = mi(j1_ordr,j2) &
                           &          - wfbp2(i,j1_mpi,2,istmp)*wfbp(i,j2,1,istmp) &
                           &          + wfbp2(i,j1_mpi,1,istmp)*wfbp(i,j2,2,istmp)
                   end do
                   if (sw_deficit == ON) &
                        & call add_deficit_term( mr(j1_ordr,j2), mi(j1_ordr,j2), &
                        &                        fsr_k2, fsi_k2, fsr_k, fsi_k, &
                        &                        j1_mpi, j2, istmp )
                end do
             end do
          End Do

          call mpi_barrier(mpi_comm_group,ierr)

! ==================== modified by K. Tagami ========= 0.1
!          deallocate(wfbp)
!          if(sw_deficit==ON) deallocate(fsr_k,fsi_k)
! ==================================================== 0.1

          if(npes>1) then
             allocate(mr_mpi(nstate,nstate),mi_mpi(nstate,nstate))
             mr_mpi=0.d0; mi_mpi=0.d0
             call mpi_allreduce(mr,mr_mpi,nstate**2,mpi_double_precision,mpi_sum &
                  &,mpi_comm_group,ierr)
             mr = mr_mpi
             call mpi_allreduce(mi,mi_mpi,nstate**2,mpi_double_precision,mpi_sum &
                  &,mpi_comm_group,ierr)
             mi = mi_mpi
             deallocate(mr_mpi,mi_mpi)
          end if

          call determinant(nstate,mr,mi,det(jpara,nk2,is))

          if(ipriberry > 1 .and. printable) then
             write(nfout,'(1x,"Overlap matrix: k1=",i4," k2=",i4," is=",i4)') &
                  &                           jpara,jpara+1,is
             write(nfout,'(1x,"ikprep=",i4)') nk2
             write(nfout,'(1x,"Real part:")')
             do j1=1,nstate
                write(nfout,'(50(1x,f10.5))') mr(j1,1:nstate)
             end do
             write(nfout,'(1x,"Imag part:")')
             do j1=1,nstate
                write(nfout,'(50(1x,f10.5))') mi(j1,1:nstate)
             end do

! =================== modified by K. Tagami ====== 0.1
!!            write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') jpara,jpara+1
              write(nfout,'(1x,"Determinant: k1=",i4," k2=",i4," is=",i4)') &
                   &                       jpara,jpara+1, is
! ================================================ 0.1
             write(nfout,'("Det = ",e25.14," +i ",e25.14)') det(jpara,nk2,is)
          end if

       end do SPIN2

! ================= Added by K. Tagami ==== 0.1
       deallocate(wfbp)
       if(sw_deficit==ON) deallocate(fsr_k,fsi_k)
! ===========================================

       if(allocated(wfbp0)) deallocate(wfbp0)
       if(allocated(wfbp1)) deallocate(wfbp1)
       if(allocated(wfbp2)) deallocate(wfbp2)
       if(allocated(fsr_k0)) deallocate(fsr_k0,fsi_k0)
       if(allocated(fsr_k1)) deallocate(fsr_k1,fsi_k1)
       if(allocated(fsr_k2)) deallocate(fsr_k2,fsi_k2)

    end if

  contains

    subroutine add_deficit_term(mr,mi,fr1,fi1,fr2,fi2,j1,j2,ispin)
      use m_Const_Parameters,    only : SKIP
      use m_Ionic_System,        only : natm, ityp
      use m_PseudoPotential,     only : index_lmt1_lmt2,lmta &
           &                        , ltp,mtp,taup,ilmt &
           &                        , qitg_BP,iqitg,isph,il2p,dl2p &
           &                        , m_PP_include_vanderbilt_pot &
           &                        , n_non0_lmtxlmt &
           &                        , nlmta
      implicit none
      real(kind=DP), intent(inout) :: mr,mi
      real(kind=DP), intent(in), dimension(np_e,nlmta,nspin) :: fr1,fi1
      real(kind=DP), intent(in), dimension(nstate,nlmta,nspin) :: fr2,fi2
      integer, intent(in) :: j1,j2,ispin

! local varialbes
      integer :: ia,it,ik,ip,lmt1,lmt2,u,v
      real(kind=DP) :: eps = 1.d-13
      real(kind=DP) :: hsr,hsi
      integer :: mdvdb

      ATOM: do ia = 1, natm
         it = ityp(ia)
         mdvdb = m_PP_include_vanderbilt_pot(it)
         if(mdvdb == SKIP) cycle ATOM
         ! debug
         !  if(printable) write(nfout,*) 'ia=',ia,' it=',it
         ! end debug
         LMT_1: do lmt1=1,ilmt(it)
            u = lmta(lmt1,ia)
            !LMT_2: do lmt2=lmt1,ilmt(it)
            LMT_2: do lmt2=1,ilmt(it)
               v = lmta(lmt2,ia)
               hsr = fr1(j1,u,ispin)*fr2(j2,v,ispin) + fi1(j1,u,ispin)*fi2(j2,v,ispin)
               hsi = fr1(j1,u,ispin)*fi2(j2,v,ispin) - fi1(j1,u,ispin)*fr2(j2,v,ispin)
               mr = mr + ftqer(lmt1,lmt2,ia)*hsr-ftqei(lmt1,lmt2,ia)*hsi
               mi = mi + ftqei(lmt1,lmt2,ia)*hsr+ftqer(lmt1,lmt2,ia)*hsi
               ! debug
               !if(printable) then
               !  write(nfout,*) '---- ftqe & hs ----'
               !  write(nfout,*) 'lmt1 = ',lmt1
               !  write(nfout,*) 'lmt2 = ',lmt2
               !  write(nfout,*) 'ftqe = ',ftqer(lmt1,lmt2,ia),ftqei(lmt1,lmt2,ia)
               !  write(nfout,*) 'hs   = ',hsr,hsi
               !end if
               ! end debug
            end do LMT_2
         end do LMT_1
      end do ATOM

    end subroutine add_deficit_term

  end subroutine m_BP_calc_det

  subroutine copy_old_wfbp_to_temp_wfbp(kg,old_wfbp,temp_wfbp)
! === DEBUG by T.Kato 2013/07/11 ===============================================
    !use m_Electronic_Structure, only : neg, neordr
    use m_Electronic_Structure, only : neordr
    use m_Control_Parameters, only : neg
! ==============================================================================
    integer, intent(in) :: kg
    real(kind=DP), intent(in) :: old_wfbp(kg,np_e,2,nspin)
    real(kind=DP), intent(out) :: temp_wfbp(kg,nstate,2,nspin)

! local variables
    real(kind=DP), allocatable :: tmp(:,:,:,:)
    integer :: datasize,ie,je,j
    integer :: is,ik

    datasize = kg*mp_e*2*nspin
    allocate(tmp(kg,mp_e,2,nspin)); tmp = 0.d0 ! MPI

    ! debug
    !if(printable) then
    !  write(nfout,*) 'copy wfbp to tmp'
    !  write(nfout,*) 'kg=',kg
    !  write(nfout,*) 'mp_e=',mp_e
    !  write(nfout,*) 'datasize = ', datasize
    !end if
    ! end debug

    call mpi_barrier(mpi_comm_group,ierr)

    do j=0,nrank_e-1
       if(j==myrank_e) tmp(1:kg,1:np_e,1:2,1:nspin) = old_wfbp(1:kg,1:np_e,1:2,1:nspin)
       call mpi_bcast(tmp(1,1,1,1),datasize,mpi_double_precision &
            & ,j,mpi_k_world(myrank_k),ierr)
       do is=1,nspin
          ik=is
          do ie = 1, nel_e(j)
             je = nis_e(j)-1+ie
             je = neordr(je,ik)
             if(je > nstate) cycle
             temp_wfbp(1:kg,je,1:2,is) = tmp(1:kg,ie,1:2,is)
          end do
       end do
       call mpi_barrier(mpi_comm_group,ierr)
    end do

    deallocate(tmp)

    call mpi_barrier(mpi_comm_group,ierr)

  end subroutine copy_old_wfbp_to_temp_wfbp

  subroutine copy_old_fs_to_temp_fs(old_fsr,old_fsi,temp_fsr,temp_fsi)
! === DEBUG by T.Kato 2013/07/11 ===============================================
    !use m_Electronic_Structure, only : neg, neordr
    use m_Electronic_Structure, only : neordr
    use m_Control_Parameters, only : neg
! ==============================================================================
    use m_PseudoPotential,     only : nlmta
    real(kind=DP), intent(in) :: old_fsr(np_e,nlmta,nspin),old_fsi(np_e,nlmta,nspin)
    real(kind=DP), intent(out) :: temp_fsr(nstate,nlmta,nspin),temp_fsi(nstate,nlmta,nspin)

    ! local variables
    real(kind=DP), allocatable :: tmp(:,:,:,:)
    integer :: datasize,ie,je,j
    integer :: is,ik

    datasize = mp_e*nlmta*2*nspin
    allocate(tmp(mp_e,nlmta,2,nspin)); tmp = 0.d0 ! MPI

    ! debug
    !if(printable) then
    !  write(nfout,*) 'copy fsr,fsi to tmp'
    !  write(nfout,*) 'mp_e=',mp_e
    !  write(nfout,*) 'nlmta =',nlmta
    !  write(nfout,*) 'datasize = ', datasize
    !end if
    ! end debug

    call mpi_barrier(mpi_comm_group,ierr)

    do j=0,nrank_e-1
       if(j==myrank_e) then
          tmp(1:np_e,1:nlmta,1,1:nspin) = old_fsr(1:np_e,1:nlmta,1:nspin)
          tmp(1:np_e,1:nlmta,2,1:nspin) = old_fsi(1:np_e,1:nlmta,1:nspin)
       end if
       call mpi_bcast(tmp(1,1,1,1),datasize,mpi_double_precision &
            & ,j,mpi_k_world(myrank_k),ierr)
       do is=1,nspin
          ik=is
          do ie = 1, nel_e(j)
             je = nis_e(j)-1+ie
             je = neordr(je,ik)
             if(je > nstate) cycle
             temp_fsr(je,1:nlmta,is) = tmp(ie,1:nlmta,1,is)
             temp_fsi(je,1:nlmta,is) = tmp(ie,1:nlmta,2,is)
          end do
       end do
       call mpi_barrier(mpi_comm_group,ierr)
    end do

    deallocate(tmp)

  end subroutine copy_old_fs_to_temp_fs

  subroutine constract_of_ftq()
    use m_Const_Parameters,    only : SKIP,zi
    use m_Ionic_System,        only : natm, ityp
    use m_PseudoPotential,     only : index_lmt1_lmt2,lmta &
         &                        , ltp,mtp,taup,ilmt,nlmt &
         &                        , qitg_BP,iqitg,isph,il2p,dl2p &
         &                        , n_non0_lmtxlmt &
         &                        , m_PP_include_vanderbilt_pot &
         &                        , m_PP_find_maximum_l

! local varialbes
    integer :: ia,it,ik,ip,lmt1,lmt2,u,v
    real(kind=DP) :: fac
    integer :: il1,il2,tau1,tau2,l3
    integer :: n,ilm3,iiqitg
    real(kind=DP) :: dk(3),ylm,dga
    real(kind=DP) :: ftqr,ftqi,ftqb
    integer :: mdvdb
    integer, allocatable :: il3(:)

    call m_PP_find_maximum_l(n)   !  n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)

    allocate(ftqer(nlmt,nlmt,natm)); ftqer=0.d0
    allocate(ftqei(nlmt,nlmt,natm)); ftqei=0.d0

    dk(1:3) = g(1:3) /dble(jpara) *PAI2

    if(ipriberry > 0.and.printable) then
       write(nfout,*) '<< Construction of Qlmt(dk): start >>'
       write(nfout,*) 'dk = ', dk(1:3)
    end if
    ! debug
    !  do ia=1,natm
    !    it = ityp(ia)
    !    if(printable) write(nfout,'("ia=",i3," it=",i3)') ia,it
    !    do ip=1,n_non0_lmtxlmt(it)
    !    lmt1 = index_lmt1_lmt2(ip,it,1)
    !      il1 = ltp(lmt1,it)
    !      tau1 = taup(lmt1,it)
    !      lmt2 = index_lmt1_lmt2(ip,it,2)
    !      il2 = ltp(lmt2,it)
    !      tau2 = taup(lmt2,it)
    !      do n=1,il2p(lmt1,lmt2,it)
    !        ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
    !        iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
    !        if(printable) write(nfout,'("lmt1=",i3,"lmt2=",i3,"n=",i3,"q_BP=",f10.5))') lmt1,lmt2,n,qitg_BP(1,iiqitg)
    !      end do
    !    end do
    !  end do
    ! end debug

    ATOM: do ia = 1, natm
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle ATOM
       ! debug
       !  if(printable) write(nfout,*) 'ia=',ia,' it=',it
       ! end debug

       LMT_1: do lmt1=1,ilmt(it)
          il1 = ltp(lmt1,it)
          tau1 = taup(lmt1,it)
          LMT_2: do lmt2=lmt1,ilmt(it)
             il2 = ltp(lmt2,it)
             tau2 = taup(lmt2,it)
             ! debug
             !if(printable) then
             !  write(nfout,*) 'lmt1 = ',lmt1
             !  write(nfout,*) 'lmt2 = ',lmt2
             !end if
             ! end debug

             ftqr = 0.d0
             ftqi = 0.d0
             LM3: do n=1,il2p(lmt1,lmt2,it)
                ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
                iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                if(iiqitg == 0) cycle LM3
                call sphrp2_for_Berry(ilm3,dk,ylm)
                ftqb = qitg_BP(1,iiqitg)*dl2p(lmt1,lmt2,n,it)*ylm

                ! debug
                !if(printable) then
                !  write(nfout,*) '---- n = ',n,' ----'
                !  write(nfout,*) 'l3 = ',l3
                !  write(nfout,*) 'qitg_BP = ',qitg_BP(1,iiqitg)
                !  write(nfout,*) 'dl2p    = ',dl2p(lmt1,lmt2,n,it)
                !  write(nfout,*) 'ylm     = ',ylm
                !  write(nfout,*) 'ftqb    = ',ftqb
                !end if
                ! end debug
                if(mod(l3,2)==0) then
                   ftqr=ftqr+real(zi**(-l3))*ftqb
                else
                   ftqi=ftqi+dimag(zi**(-l3))*ftqb
                end if
             end do LM3
             ! remove exponetal factor
             !ftqer(lmt1,lmt2,ia) = ftqr*zfcos(ia)+ftqi*zfsin(ia)

             ftqer(lmt1,lmt2,ia) = ftqr
             ftqer(lmt2,lmt1,ia) = ftqer(lmt1,lmt2,ia)

             !ftqei(lmt1,lmt2,ia) = ftqi*zfcos(ia)-ftqr*zfsin(ia)
             ftqei(lmt1,lmt2,ia) = ftqi
             ftqei(lmt2,lmt1,ia) = ftqei(lmt1,lmt2,ia)

             ! debug
             !if(printable) then
             !  write(nfout,*) '---- ftqe ----'
             !  write(nfout,*) 'ftq  = ',ftqr,ftqi
             !  write(nfout,*) '(zfcos,zfsin) = ',zfcos(ia),zfsin(ia)
             !  write(nfout,*) 'ftqe = ',ftqer(lmt1,lmt2,ia),ftqei(lmt1,lmt2,ia)
             !end if
             ! end debug
          end do LMT_2
       end do LMT_1
    end do ATOM

    deallocate(il3)

    if(ipriberry > 0.and.printable) then
       write(nfout,*) '<< Constuction of Qlmt(dk): end >>'
    end if

  end subroutine constract_of_ftq

  subroutine BP_line_integral(phi,cphi,ikprep,ispin)
    implicit none
    real(kind=DP), intent(out) :: phi
    complex(kind=DP), intent(out) :: cphi
    integer, intent(in) :: ikprep, ispin

! local variables
    integer :: k

    cphi = cmplx(1.d0,0.d0)
    do k=1,jpara
       if(printable) write(nfout,'(1x,"Det = ",e25.12," + i ",e25.12)') &
            &                             det(k,ikprep,ispin)
       cphi = cphi*det(k,ikprep,ispin)
    end do

    phi = dimag(log(cphi))

    if(printable) then
       write(nfout,'("cphi = ",e25.12,1x,e25.12)') cphi
       write(nfout,'("phi = ",e25.12)') phi
    end if

  end subroutine BP_line_integral

  subroutine m_BP_Polarization()
    use m_Files, only : nfout, nfzaj
    use m_Electronic_Structure, only : zaj_l, occup_l
    use m_Crystal_Structure, only : univol
    use m_Control_Parameters, only : nspin
    use m_Ionic_System,        only : pos,natm

! =============================== KT_add =================== 13.0C
    use m_Ionic_System,        only : ityp
    use m_PseudoPotential, only : ival
! ========================================================== 13.0C

    implicit none

! local variables
    integer :: i,is,ia, ismax
    real(kind=DP) :: glen, polar, dir(3)
    real(kind=DP), allocatable :: phi(:,:) ! dim(nkprep)
    complex(kind=DP), allocatable :: cphi(:,:) ! dim(nkprep)
    real(kind=DP) :: fac
    real(kind=DP) :: berry_phase, berry_ion, berry_tot
    real(kind=DP) :: polar_ele, polar_ion, polar_tot, polar_max

    if(mype /= 0) return ! MPI

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    allocate(phi(nkprep,ismax),cphi(nkprep,ismax))

    do is=1,ismax
       do i=1,nkprep
          if(printable) &
               & write(nfout,'("is=",i3," ik=",i3," kprep=",2(1x,f10.5))') &
               & is,i,kvec(1:2,i*jpara)
          call BP_line_integral(phi(i,is),cphi(i,is),i,is)
       end do
    end do
    glen = sqrt(sum(g(1:3)**2))

! =============================== KT_add  =================== 13.0C
    berry_phase = 0.0d0
! =========================================================== 13.0C

    do is = 1, ismax
       berry_phase = berry_phase + sum(phi(1:nkprep,is)*wgh(1:nkprep))
    end do

    fac = 2.d0/dble(nspin)
! === KT_Add === 2015/03/23
    if ( noncol ) fac = 2.d0/dble(nspin /ndim_spinor)    !!! to be checked
! ============== 2015/03/23

    berry_phase = fac*berry_phase
    berry_phase = 4.d0*atan(tan(0.25d0*berry_phase))
    polar_ele = berry_phase/(univol*glen*PAI2)
    berry_ion = 0.d0

    do ia=1,natm
! ============================ KT_mod =================== 13.0C
!       berry_ion = berry_ion + pos(ia,ig)
       berry_ion = berry_ion + ival(ityp(ia)) *pos(ia,ig)
! ======================================================= 13.0C
    end do

    berry_ion = PAI2*berry_ion
    berry_ion = 4.d0*atan(tan(0.25d0*berry_ion))
    polar_ion = berry_ion/(univol*glen*PAI2)
    berry_tot = 4.d0*atan(tan(0.25d0*(berry_ion+berry_phase)))
    polar_tot = berry_tot/(univol*glen*PAI2)
    polar_max = 1.d0/(univol*glen)

    if(printable) then
       write(nfout,'("<< Results of Berry phase calc.")')

       do i=1,nkprep
          write(nfout,'("ik=",i3," kprep=",2(1x,f10.5))') i,kvec(1:2,i*jpara)
       end do
       write(nfout,'(1x,3x,"is",3x,"k",13x,"phi",18x,"wgh")')

       do is=1, ismax
          do i=1,nkprep
             write(nfout,'(1x,i4,1x,i4,2(1x,f20.10))') is,i,phi(i,is),wgh(i)
          end do
       end do

       dir(1:3) = g(1:3)/glen
       write(nfout,'(1x,"Unit cell volume        =",1x,e25.14)') univol
       write(nfout,'(1x,"direction of G          =",3(1x,e25.14))') dir(1:3)
       write(nfout,'(1x,"Berry phase (ele)       =",1x,e25.14)') berry_phase
       write(nfout,'(1x,"Berry phase (ion)       =",1x,e25.14)') berry_ion
       write(nfout,'(1x,"Berry phase (total)     =",1x,e25.14)') berry_tot
       write(nfout,'(1x,"Electronic polarization =",1x,e25.14)') polar_ele
       write(nfout,'(1x,"Ionic polarization      =",1x,e25.14)') polar_ion
       write(nfout,'(1x,"Total polarization      =",1x,e25.14)') polar_tot
       write(nfout,'(1x,"Maximun polarization    =",1x,e25.14)') polar_max

       write(nfout,'("   Results of Berry phase calc.>>")')
    end if

    call m_BP_write_Berry_phase(cphi,phi,nkprep)

    deallocate(phi)

  end subroutine m_BP_Polarization

  subroutine m_BP_write_Berry_phase(cphi,phi,nkprep)
    use m_Files, only : nfout, nfberry, m_Files_open_nfberry
    use m_Ionic_System, only : displaced_atom,displacement,pos,natm
    use m_Crystal_Structure, only : strain, sw_strained_cell
    implicit none
    integer, intent(in) :: nkprep
    complex(kind=DP), intent(in) :: cphi(nkprep,nspin)
    real(kind=DP), intent(in) :: phi(nkprep,nspin)

! local variables
    integer :: i,ia,is, ismax

! === KT_add === 2015/03/23
    ismax = nspin /ndim_spinor
! ============== 2015/03/23

    call m_Files_open_nfberry()
    write(nfberry,'(3(1x,i5),3(1x,e25.14))') nkprep,ig,displaced_atom,displacement(1:3)

    do is=1, ismax
       do i=1,nkprep
          write(nfberry,'(i5,4(1x,e25.14))') i,cphi(i,is),phi(i,is),wgh(i)
       end do
    end do
    if(sw_strained_cell == ON) then
       write(nfberry,'(3(1x,e25.14))') strain(1,1:3)
       write(nfberry,'(3(1x,e25.14))') strain(2,1:3)
       write(nfberry,'(3(1x,e25.14))') strain(3,1:3)
       write(nfberry,*) natm
       do ia=1,natm
          write(nfberry,'(i7,3(1x,e25.14))') ia,pos(ia,1:3)
       end do
    end if

  end subroutine m_BP_write_Berry_phase

  subroutine m_BP_write_wfbp
    use m_Files, only : nfout, nfzaj
    use m_PlaneWaveBasisSet, only : nbase, iba
    use m_Electronic_Structure, only : totch, zaj_l
    use m_Control_Parameters, only : nspin

!$$#ifndef PARA3D
    use m_ES_nonlocal,          only : m_ES_betar_dot_WFs
!$$#endif

    implicit none

! local variables
    integer :: jj,n,j,jmax

    ! debug
    !integer :: is
    !real(kind=DP) :: norm,defi
    ! end debug

    if(nstate <= 0) nstate = int(totch + 1.d-13)/2

    if(sw_deficit == ON) then
       !  if(ikp==0) then
       if(ikp0) then
          call calc_phase_for_Berry()
          call constract_of_ftq()
          ikp0 = .false.
       end if
       call m_BP_save_betar_dot_WFs()
    end if

    if(allocated(wfbp2)) then
       if(allocated(wfbp1)) deallocate(wfbp1)
       kgbp1 = kgbp2
       allocate(wfbp1(kgbp1,np_e,2,nspin))
       wfbp1 = wfbp2
       deallocate(wfbp2)
    end if

    kgbp2 = nbase(iba(1),1)
    allocate(wfbp2(kgbp2,np_e,2,nspin))

    if(printable) then
       write(nfout,'("<< Writing Wavefunctions for Berry Phase calc. >>")')
       !write(nfout,*) 'debug iba=',iba(1)
       !write(nfout,*) 'debug kgbp2=',kgbp2
    end if
    do n=1,np_e
       !if(printable) write(nfout,'(1x,"n=",i3)') n
       jj=1
       do j=1,kgbp2
          if(nbase(jj,1) == j) then
             wfbp2(j,n,1,1:nspin) = zaj_l(jj,n,1:nspin,1)
             wfbp2(j,n,2,1:nspin) = zaj_l(jj,n,1:nspin,2)
             jj = jj + 1
          else
             wfbp2(j,n,1,1:nspin) = 0.d0
             wfbp2(j,n,2,1:nspin) = 0.d0
          end if
          ! debug
          !if(j < 21.and.printable) write(nfout,'("j=",i2,"wfbp=",2(1x,f10.5))') &
          !   & j,wfbp2(j,n,1,is),wfbp2(j,n,2,is)
          ! end debug
       end do
    end do

    ! debug
    !if(printable) then
    !write(nfout,*) 'berry check norm: kgbp2=',kgbp2
    !do is=1,nspin
    !do n=1,np_e
    !  defi = norm_deficit(n,is)
    !  write(nfout,'(1x,"n=",i3," defi = ",f15.10)') n,defi
    !  norm = 0.d0
    !  do j=1,kgbp2
    !    norm = norm + wfbp2(j,n,1)**2 + wfbp2(j,n,2)**2
    !  end do
    !  write(nfout,'(1x,"n=",i3," norm = ",f10.5)') n,norm
    !  write(nfout,'(1x,"n=",i3," total norm = ",f15.10)') n,norm+defi
    !end do
    !end do
    !call mpi_barrier(mpi_comm_group,ierr)
    !end if
    ! end debug

    if((jpara>1 .and. mod(ikp,jpara) /= 0) .or. jpara==1)  &
         & call m_BP_calc_det()

    ikp = ikp + 1

  contains

    function norm_deficit(n,is) result(norm)
      use m_PseudoPotential,     only : nlmta
      use m_Electronic_Structure,only : fsr_l,fsi_l ! dim(np_e,nlmta,ista_k:iend_k)
      use m_Ionic_System,        only : natm, ityp
      use m_PseudoPotential,     only : n_non0_lmtxlmt,index_lmt1_lmt2,lmta &
           &                          , ltp,mtp,ilmt,q

      real(kind=DP) :: norm ! a result

      integer, intent(in) :: n ! a band index
      integer, intent(in) :: is ! a spin index

! local varialbes
      integer :: ia,it,ik,ip,lmt1,lmt2,u,v
      real(kind=DP) :: eps = 1.d-13
      real(kind=DP) :: fac

      norm = 0.d0

      ik=is ! for ekcal mode

      do ia = 1, natm
         it = ityp(ia)
         ! debug
         !  if(printable) write(nfout,*) 'n_non0_lmtxlmt = ',n_non0_lmtxlmt(it)
         ! end debug
         LMT: do ip = 1, n_non0_lmtxlmt(it)
            lmt1 = index_lmt1_lmt2(ip,it,1)
            lmt2 = index_lmt1_lmt2(ip,it,2)
            ! debug
            !if(printable) then
            !  write(nfout,*) 'lmt1 = ',lmt1
            !  write(nfout,*) 'lmt2 = ',lmt2
            !end if
            ! end debug

            if(lmt2 < lmt1) cycle LMT
            u = lmta(lmt1,ia)
            v = lmta(lmt2,ia)
            if(ltp(lmt1,it) /= ltp(lmt2,it) .or. &
                 & mtp(lmt1,it) /= mtp(lmt2,it) ) cycle LMT
            fac = q(lmt1,lmt2,it)
            if(abs(fac) < eps) cycle LMT
            if(lmt1 /= lmt2) fac=2.d0*fac

            ! debug
            !if(printable) then
            !  write(nfout,*) 'u = ',u
            !  write(nfout,*) 'v = ',v
            !  write(nfout,*) 'fsr = ',fsr_l(n,u,ik)
            !  write(nfout,*) 'fsi = ',fsi_l(n,v,ik)
            !  write(nfout,*) 'q = ',q(lmt1,lmt2,it)
            !end if
            ! end debug
            norm = norm + &
                 & fac*(fsr_l(n,u,ik)*fsr_l(n,v,ik)+fsi_l(n,u,ik)*fsi_l(n,v,ik))
         end do LMT
      end do

    end function norm_deficit

  end subroutine m_BP_write_wfbp

  subroutine m_BP_write_wfbp_gshift
    use m_Files, only : nfout, nfzaj
    use m_PlaneWaveBasisSet, only : kgp, ngabc, nbase, iba
    use m_Electronic_Structure, only : totch, zaj_l
    use m_Control_Parameters, only : nspin
    implicit none

! local variables
    integer :: jj,n,i,j,k,jmax
    integer :: igs(3)
    integer :: iga,igb,igc,jga,jgb,jgc

    ! debug
    !real(kind=DP) :: norm
    ! end debug

    if(mod(ikp,jpara)/=0) return

    if(nstate <= 0) nstate = int(totch + 1.d-13)/2

    igs(1:3) = 0
    do i=1,3
       if(i == ig) igs(i) = 1
    end do

    kgbp0 = 1
    jj=1
    if(printable) then
       write(nfout,'("<< Writing Wavefunctions for Berry Phase calc. >>")')
       !write(nfout,*) 'debug kgp=',kgp
       !write(nfout,*) 'debug iba=',iba(1)
    end if
    loop_i: do i=1,kgp
       iga = ngabc(i,1)+igs(1)
       igb = ngabc(i,2)+igs(2)
       igc = ngabc(i,3)+igs(3)
       if(jj>iba(1)) then
          kgbp0 =i-1
          exit loop_i
       end if
       loop_j: do j=1,iba(1)
          k=nbase(j,1)
          jga = ngabc(k,1)
          jgb = ngabc(k,2)
          jgc = ngabc(k,3)
          if(iga == jga .and. igb == jgb .and. igc == jgc) then
             jj=jj+1
             exit loop_j
          end if
       end do loop_j
    end do loop_i

    !if(printable) then
    !write(nfout,*) 'debug jj=',jj
    !write(nfout,*) 'debug kgbp0=',kgbp0
    !end if

    allocate(wfbp0(kgbp0,np_e,2,nspin)); wfbp0 = 0.d0
    do n=1,np_e
       loop_i2: do i=1,kgbp0
          iga = ngabc(i,1)+igs(1)
          igb = ngabc(i,2)+igs(2)
          igc = ngabc(i,3)+igs(3)
          loop_j2: do j=1,iba(1)
             k=nbase(j,1)
             jga = ngabc(k,1)
             jgb = ngabc(k,2)
             jgc = ngabc(k,3)
             if(iga == jga .and. igb == jgb .and. igc == jgc) then
                wfbp0(i,n,1,1:nspin) = zaj_l(j,n,1:nspin,1)
                wfbp0(i,n,2,1:nspin) = zaj_l(j,n,1:nspin,2)
                exit loop_j2
             end if
          end do loop_j2
       end do loop_i2
       ! debug
       !if(printable) then
       !do j=1,20
       !  write(nfout,'("j=",i2,"wfbp0=",2(1x,f10.5))') &
       !     & j,wfbp0(j,n,1),wfbp0(j,n,2)
       !end do
       !end if
       ! end debug
    end do
    call mpi_barrier(mpi_comm_group,ierr)

    ! debug
    !if(printable) then
    !write(nfout,*) 'berry check norm (gshift): kgbp0=',kgbp0
    !do n=1,np_e
    !  norm = 0.d0
    !  do j=1,kgbp0
    !    norm = norm + wfbp0(j,n,1)**2 + wfbp0(j,n,2)**2
    !  end do
    !  write(nfout,'(1x,"n=",i3," norm = ",f10.5)') n,norm
    !end do
    !call mpi_barrier(mpi_comm_group,ierr)
    !end if
    ! end debug

  end subroutine m_BP_write_wfbp_gshift

  subroutine m_BP_save_betar_dot_WFs
    use m_Electronic_Structure,only : fsr_l, fsi_l ! dim(np_e,nlmta,ista_k:iend_k)
    use m_PseudoPotential,     only : nlmta, lmta, ilmt
    use m_Ionic_System,        only : natm, ityp
    implicit none

! local variables
    integer :: ik,ia,i,j,n,nkp,ikprep,is

    ik=1 ! for ekcal mode
    nkp = mod(ikp,jpara) +1
    ikprep = ikp /jpara +1

    ! debug
    !if(printable) then
    !  write(nfout,*) 'debug(m_BP_save_betar_dot_WFs)'
    !  write(nfout,*) 'nstate=',nstate
    !  write(nfout,*) 'nlmta=',nlmta
    !  write(nfout,*) 'jpara=',jpara
    !  write(nfout,*) 'nkp=',nkp
    !  write(nfout,*) 'ikprep=',ikprep
    !end if
    ! end debug

    if(allocated(fsr_k2)) then
       if(allocated(fsr_k1)) deallocate(fsr_k1,fsi_k1)
       allocate(fsr_k1(np_e,nlmta,nspin),fsi_k1(np_e,nlmta,nspin))
       fsr_k1 = fsr_k2
       fsi_k1 = fsi_k2
       deallocate(fsr_k2,fsi_k2)
    end if

    allocate(fsr_k2(np_e,nlmta,nspin),fsi_k2(np_e,nlmta,nspin))
    do is=1,nspin
       do i=1,nlmta
          do n=1,np_e
             fsr_k2(n,i,is) = fsr_l(n,i,is)
             fsi_k2(n,i,is) = fsi_l(n,i,is)
          end do
       end do
    end do
    if(nkp == 1) then
       allocate(fsr_k0(np_e,nlmta,nspin),fsi_k0(np_e,nlmta,nspin))
       do is=1,nspin
          do ia=1,natm
             do j=1,ilmt(ityp(ia))
                i=lmta(j,ia)
                do n=1,np_e
                   fsr_k0(n,i,is) = fsr_l(n,i,is)*zfcos(ia)+fsi_l(n,i,is)*zfsin(ia)
                   fsi_k0(n,i,is) = fsi_l(n,i,is)*zfcos(ia)-fsr_l(n,i,is)*zfsin(ia)
                end do
             end do
          end do
       end do
    end if

  end subroutine m_BP_save_betar_dot_WFs

  subroutine determinant(n,mr,mi,det)
    implicit none
    integer, intent(in) :: n
    real(kind=DP), intent(inout) :: mr(n,n),mi(n,n)
    complex(kind=DP), intent(out) :: det

! local variables
    integer :: i,pivot(n),parity
    real(kind=DP) :: dr,di,dt

    ! debug
    !if(printable) then
    !write(nfout,'("before LU decomposition")')
    !write(nfout,'("real part:")')
    !do i=1,n
    !   write(nfout,'(50(1x,e25.12))') mr(i,1:n)
    !end do
    !write(nfout,'("imag part:")')
    !do i=1,n
    !   write(nfout,'(50(1x,e25.12))') mi(i,1:n)
    !end do
    !end if
    ! end debug

    call LU_decomposition(n,mr,mi,pivot,parity)

    ! debug
    !if(printable) then
    !write(nfout,'("after LU decomposition")')
    !write(nfout,'("real part:")')
    !do i=1,n
    !   write(nfout,'(50(1x,e25.12))') mr(i,1:n)
    !end do
    !write(nfout,'("imag part:")')
    !do i=1,n
    !   write(nfout,'(50(1x,e25.12))') mi(i,1:n)
    !end do
    !end if
    ! end debug

    dr=1.d0
    di=0.d0
    do i=1,n
       ! debug
       !if(printable) write(nfout,'(1x,i3," mr=",e25.12," mi=",e25.12)') i,mr(i,i),mi(i,i)
       ! end debug
       dt = dr*mr(i,i) - di*mi(i,i)
       di = di*mr(i,i) + dr*mi(i,i)
       dr = dt
    end do
    det = cmplx(dr,di)
    det = parity*det

  end subroutine determinant

  subroutine LU_decomposition(n,mr,mi,pivot,parity)
    implicit none
    integer, intent(in) :: n
    real(kind=DP), intent(inout) :: mr(n,n),mi(n,n)
    integer, intent(out) :: pivot(n),parity

! local variables
    integer :: i,j,k,imax
    real(kind=DP) :: big,scaling(n)
    real(kind=DP) :: t,dr,di
    real(kind=DP) :: sumr,sumi,mt

    real(kind=DP), parameter :: eps = 3.5d-15

    parity = 1

    do i=1,n
       big = 0.d0
       do j=1,n
          t = sqrt( mr(i,j)**2 + mi(i,j)**2 )
          if(t > big)  big = t
       end do
       if(big == 0.d0) then
          if(printable) then
             write(nfout,*) 'Error(LU_decomposition): Singular matrix'
             write(nfout,*) 'i=',i
          end if
          stop 'LU_decomposition'
       else
          scaling(i) = 1.d0/big
       end if
    end do

    do j=1,n
       do i=1,j-1
          sumr=0.d0
          sumi=0.d0
          do k=1,i-1
             sumr = sumr + ( mr(i,k)*mr(k,j) - mi(i,k)*mi(k,j) )
             sumi = sumi + ( mi(i,k)*mr(k,j) + mr(i,k)*mi(k,j) )
          end do
          mr(i,j) = mr(i,j) - sumr
          mi(i,j) = mi(i,j) - sumi
       end do
       big = 0.d0
       do i=j,n
          sumr=0.d0
          sumi=0.d0
          do k=1,j-1
             sumr = sumr + ( mr(i,k)*mr(k,j) - mi(i,k)*mi(k,j) )
             sumi = sumi + ( mi(i,k)*mr(k,j) + mr(i,k)*mi(k,j) )
          end do
          sumr = mr(i,j) - sumr
          sumi = mi(i,j) - sumi
          t = scaling(i)*sqrt(sumr**2+sumi**2)
          if( t >= big) then
             big = t
             imax = i
          end if
          mr(i,j) = sumr
          mi(i,j) = sumi
       end do
       if(j /= imax) then
          do k=1,n
             dr = mr(imax,k)
             di = mi(imax,k)
             mr(imax,k) = mr(j,k)
             mi(imax,k) = mi(j,k)
             mr(j,k) = dr
             mi(j,k) = di
          end do
          parity = -parity
          scaling(imax) = scaling(j)
       end if
       pivot(j) = imax
       if( dsqrt(mr(j,j)**2+mi(j,j)**2) < eps ) then
          mr(j,j) = 0.d0
          mi(j,j) = 0.d0
       end if
       if(j /= n ) then
          t  =  mr(j,j)**2 + mi(j,j)**2
          dr =  mr(j,j)/t
          di = -mi(j,j)/t
          do i=j+1,n
             mt      = mr(i,j)*dr - mi(i,j)*di
             mi(i,j) = mi(i,j)*dr + mr(i,j)*di
             mr(i,j) = mt
          end do
       end if
    end do

  end subroutine LU_decomposition

  subroutine m_BP_wd_cntn_data()
    use m_Files, only : nfcntn_berry,m_Files_open_nfcntn_berry, &
         &              m_Files_close_nfcntn_berry,nfout
    use m_ErrorMessages, only : EOF_REACHED

    logical :: logica

    if(.not.allocated(det)) return 
    call m_Files_open_nfcntn_berry()
    rewind nfcntn_berry
    if(mype==0)then
       write(nfcntn_berry) ikp
       write(nfcntn_berry) kgbp0
       write(nfcntn_berry) kgbp1
       write(nfcntn_berry) kgbp2
       write(nfcntn_berry) det
    endif

! fsr, fsi related
    logica = allocated(fsr_k2)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsr_k2,nfcntn_berry)

    logica = allocated(fsi_k2)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsi_k2,nfcntn_berry)

    logica = allocated(fsr_k1)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsr_k1,nfcntn_berry)

    logica = allocated(fsi_k1)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsi_k1,nfcntn_berry)

    logica = allocated(fsr_k0)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsr_k0,nfcntn_berry)

    logica = allocated(fsi_k0)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_fs(fsi_k0,nfcntn_berry)

! wf related
    logica = allocated(wfbp2)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_wf(kgbp2,wfbp2,nfcntn_berry)

    logica = allocated(wfbp1)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_wf(kgbp1,wfbp1,nfcntn_berry)

    logica = allocated(wfbp0)
    if(mype==0) write(nfcntn_berry) logica
    if(logica) call write_wf(kgbp0,wfbp0,nfcntn_berry)

    call m_Files_close_nfcntn_berry()

  end subroutine m_BP_wd_cntn_data

  subroutine m_BP_rd_cntn_data()
    use m_Files,           only : nfcntn_berry,m_Files_open_nfcntn_berry, &
         &                        m_Files_close_nfcntn_berry,nfout
    use m_PseudoPotential, only : nlmta
    use m_ErrorMessages,   only : EOF_REACHED

    logical :: logica

    if(.not.allocated(det)) return
    call m_Files_open_nfcntn_berry()
    rewind nfcntn_berry
    if(mype==0)then
       read(nfcntn_berry,end=9999,err=9999) ikp
       read(nfcntn_berry,end=9999,err=9999) kgbp0
       read(nfcntn_berry,end=9999,err=9999) kgbp1
       read(nfcntn_berry,end=9999,err=9999) kgbp2
       read(nfcntn_berry,end=9999,err=9999) det
    endif
    call mpi_bcast(ikp,1,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(kgbp0,1,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(kgbp1,1,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(kgbp2,1,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(det,jpara*nkprep*nspin,mpi_double_precision,0,mpi_comm_group,ierr)

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsr_k2)) allocate(fsr_k2(np_e,nlmta,nspin))
       call read_fs(fsr_k2,nfcntn_berry,1)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsi_k2)) allocate(fsi_k2(np_e,nlmta,nspin))
       call read_fs(fsi_k2,nfcntn_berry,2)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsr_k1)) allocate(fsr_k1(np_e,nlmta,nspin))
       call read_fs(fsr_k1,nfcntn_berry,3)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsi_k1)) allocate(fsi_k1(np_e,nlmta,nspin))
       call read_fs(fsi_k1,nfcntn_berry,4)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsr_k0)) allocate(fsr_k0(np_e,nlmta,nspin))
       call read_fs(fsr_k0,nfcntn_berry,5) 
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(.not.allocated(fsi_k0)) allocate(fsi_k0(np_e,nlmta,nspin))
       call read_fs(fsi_k0,nfcntn_berry,6)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if (logica) then
       if(allocated(wfbp2)) deallocate(wfbp2)
       allocate(wfbp2(kgbp2,np_e,2,nspin))
       call read_wf(kgbp2,wfbp2,nfcntn_berry,7)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if(logica) then
       if(allocated(wfbp1)) deallocate(wfbp1)
       allocate(wfbp1(kgbp1,np_e,2,nspin))
       call read_wf(kgbp1,wfbp1,nfcntn_berry,8)
    endif

    if(mype==0) read(nfcntn_berry,end=9999,err=9999) logica
    call mpi_bcast(logica,1,mpi_logical,0,mpi_comm_group,ierr)
    if(logica) then
       if(allocated(wfbp0)) deallocate(wfbp0)
       allocate(wfbp0(kgbp0,np_e,2,nspin))
       call read_wf(kgbp0,wfbp0,nfcntn_berry,9)
    endif

    call m_Files_close_nfcntn_berry()
    return

9999 continue
    call phase_error_wo_filename(EOF_REACHED, nfout, nfcntn_berry, __LINE__, __FILE__)
  end subroutine m_BP_rd_cntn_data

  subroutine write_fs(fs,nf)
!!$  use m_Electronic_Structure, only : neg
    use m_Control_Parameters, only : neg
    use m_PseudoPotential, only : nlmta

    real(kind=DP),intent(in),dimension(np_e,nlmta,nspin) :: fs
    integer, intent(in) :: nf
    real(kind=DP),allocatable,dimension(:,:) :: f
    integer :: is,ib
    integer :: ierr

    allocate(f(nlmta,nspin));f=0.0d0
    do is=1,nspin
       do ib=1,neg 
          if(map_ek(ib,is) == mype) then
             f(:,:) = fs(map_z(ib),:,:)
             if(map_ek(ib,is)/=0) call mpi_send(f,nlmta*nspin,mpi_double_precision,0,1,mpi_comm_group,ierr)
          else if (mype==0 .and. map_ek(ib,is) /= 0)then
             call mpi_recv(f,nlmta*nspin,mpi_double_precision,map_ek(ib,is),1,mpi_comm_group,istatus,ierr)
          endif
          if(mype==0) write(nf) f
       enddo
    enddo
    deallocate(f)

  end subroutine write_fs

  subroutine read_fs(fs,nf,tag)
!!$  use m_Electronic_Structure, only : neg
    use m_Control_Parameters, only : neg
    use m_PseudoPotential, only : nlmta
    use m_ErrorMessages, only : EOF_REACHED
    use m_Files, only : nfout

    real(kind=DP),intent(out),dimension(np_e,nlmta,nspin) :: fs
    integer, intent(in) :: nf
    integer, intent(in) :: tag
    real(kind=DP),allocatable,dimension(:,:) :: f
    integer :: is,ib
    integer :: ierr

    allocate(f(nlmta,nspin));f=0.0d0
    fs = 0.d0
    do is=1,nspin
       do ib=1,neg 
          if(mype==0) read(nf,end=9999,err=9999) f
          if(mype==0 .and. map_ek(ib,is)/=0)then
             call mpi_send(f,nlmta*nspin,mpi_double_precision,map_ek(ib,is),tag,mpi_comm_group,ierr)
          else if (map_ek(ib,is)==mype .and. map_ek(ib,is) /= 0)then
             call mpi_recv(f,nlmta*nspin,mpi_double_precision,0,tag,mpi_comm_group,istatus,ierr)
          endif
          if(map_ek(ib,is) == mype) fs(map_z(ib),:,:) = f(:,:)
       enddo
    enddo
    deallocate(f)
    return

9999 continue
    call phase_error_wo_filename(EOF_REACHED, nfout, nf, __LINE__, __FILE__)

  end subroutine read_fs

  subroutine write_wf(n1,wf,nf)
    use m_Control_Parameters, only : neg

    integer, intent(in) :: n1
    real(kind=DP), dimension(n1,np_e,2,nspin),intent(in) :: wf
    integer, intent(in) :: nf
    real(kind=DP), allocatable,dimension(:,:) :: wft
    integer :: is,ib
    integer :: ierr

    allocate(wft(n1,2));wft=0.d0
    do is=1,nspin
       do ib=1,neg
          if(map_ek(ib,is) == mype)then
             wft(:,1) = wf(:,map_z(ib),1,is)
             wft(:,2) = wf(:,map_z(ib),2,is)
             if(map_ek(ib,is)/=0) call mpi_send(wft,n1*2,mpi_double_precision,0,1,mpi_comm_group,ierr)
          else if (mype==0 .and. map_ek(ib,is) /= 0) then
             call mpi_recv(wft,n1*2,mpi_double_precision,map_ek(ib,is),1,mpi_comm_group,istatus,ierr)
          endif
          if(mype==0) write(nf) wft
       enddo
    enddo
    deallocate(wft)

  end subroutine write_wf

  subroutine read_wf(n1,wf,nf,tag)
    use m_Control_Parameters, only : neg
    use m_ErrorMessages, only : EOF_REACHED
    use m_Files, only : nfout

    integer, intent(in) :: n1
    real(kind=DP), dimension(n1,np_e,2,nspin),intent(out) :: wf
    integer, intent(in) :: nf
    integer, intent(in) :: tag
    real(kind=DP), allocatable,dimension(:,:) :: wft
    integer :: is,ib
    integer :: ierr

    wf = 0.d0
    allocate(wft(n1,2));wft=0.d0
    do is=1,nspin
       do ib=1,neg
          if(mype==0) read(nf,end=9999,err=9999) wft
          if(mype==0 .and. map_ek(ib,is)/=0)then
             call mpi_send(wft,n1*2,mpi_double_precision,map_ek(ib,is),tag,mpi_comm_group,ierr)
          else if (map_ek(ib,is) == mype .and. map_ek(ib,is) /= 0) then
             call mpi_recv(wft,n1*2,mpi_double_precision,0,tag,mpi_comm_group,istatus,ierr)
          endif
          if(map_ek(ib,is) == mype) then
             wf(:,map_z(ib),1,is) = wft(:,1)
             wf(:,map_z(ib),2,is) = wft(:,2)
          endif
       enddo
    enddo
    deallocate(wft)
    return

9999 continue
    call phase_error_wo_filename(EOF_REACHED, nfout, nf, __LINE__, __FILE__)

  end subroutine read_wf

end module m_BerryPhase

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 578 $)
!
!  SUBROUINE: Initial_Electronic_Structure, Initial_WaveFunctions_ek
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Initial_Electronic_Structure
! $Id: Initial_Electronic_Structure.F90 578 2018-02-16 16:01:03Z ktagami $
  use m_Const_Parameters,   only : Gauss_distrib_func, from_wave_functions&
       &                         , INITIAL, CONTINUATION, FIXED_CHARGE &
       &                         , FIXED_CHARGE_CONTINUATION, ON, OFF, EXECUT &
       &                         , COORDINATE_CONTINUATION &
       &                         , by_random_numbers, by_matrix_diagon, FILE &
       &                         , by_pseudo_atomic_orbitals &
       &                         , Valence_plus_PC_Charge, VXC_AND_EXC &
       &                         , ONE_BY_ONE, ALL_AT_ONCE, DP, YES &
       &                         , Partial_Core_Charge
  use m_IterationNumbers,   only : iteration, nk_in_the_process
  use m_Files,              only : nfout,nfchgt,nfzaj,nfcntn_bin,nfeng,nfefermi &
       &                         , F_ZAJ_in_partitioned, F_CHGT_in_partitioned &
       &                         , F_CNTN_BIN_in_partitioned &
       &                         , nfchr &
       &                         , m_Files_open_nfchr &
       &                         , m_Files_open_nfcntn_bin &
       &                         , m_Files_skiptoend, m_Files_open_nfzaj, m_Files_open_nfchgt &
       &                         , m_Files_open_nfefermi, m_Files_close_nfefermi &
       &                         , nfcntn_bin_paw &
       &                         , file_existance_contfiles &
       &                         , m_Files_check_nfzaj_existance, m_Files_check_nfchgt_existance &
       &                         , m_Files_check_file_existance &
       &                         , m_Files_open_nfcntn_bin_paw,m_Files_close_nfcntn_bin_paw &
       &                         , m_Files_nfcntn_bin_paw_exists
  use m_Control_Parameters, only : ipri, iprichargedensity, initial_chg, icond, nspin, intzaj &
       &                         , evaluation_eko_diff &
       &                         , skip_alloc_phonon, sw_phonon, sw_calc_force, neg, neg_previous &
       &                         , delta_eigenvalue_cond_is_given, sw_dipole_correction, sw_hubbard &
       &                         , ekmode, fixed_charge_k_parallel, ipriparallel, printable &
       &                         , sw_initial_charge_rspace &
       &                         , m_CtrlP_set_neg_properly, m_CntrlP_set_neg, m_CntrlP_set_meg &
       &                         , m_Cntrlp_set_davidson_size &
       &                         , sw_hybrid_functional, sw_screening_correction &
       &                         , sw_external_potential, sw_fef, initial_occmat,kimg &
       &                         , sw_berry_phase, sw_rsb, sw_eval_epc_on_fftmesh &
       &                         , sw_initial_es
  use m_Kpoints,            only : kv3
  use m_PlaneWaveBasisSet,  only : kg1, m_pwBS_alloc_ylm_l,kgp,ngabc
  use m_Total_Energy,      only  : m_TE_set_etotal_old
  use m_Electronic_Structure,only: totch, m_ES_gtotch &
       &                         , m_ES_energy_eigen_values_ext_3D &
       &                         , m_ES_alloc_vlhxc, m_ES_alloc_vlhxcQ &
       &                         , m_ES_alloc_zaj_etc &
       &                         , m_ES_alloc_eko_ek, m_ES_alloc_eko1 &
       &                         , m_ES_cpeko &
       &                         , m_ES_alloc_Dhub,vlhxc_l
  use m_ES_ortho,           only : m_ES_modified_gram_schmidt
  use m_ES_wf_extrpl,       only : m_ES_wf_extrpl_alloc
  use m_ES_nonlocal,        only : m_ES_betar_dot_WFs_3D
  use m_ES_IO,              only : m_ESIO_rd_Efermi, m_ESIO_rd_EigenValues_etc, m_ESIO_rd_WFs
  use m_ES_initialWF,       only : m_ESIW_by_randomnumbers_3D  &
       &                         , m_ESIW_by_randomnumbers0_3D 
  use m_ES_initialWF,       only : m_ESIW_by_atomic_orbitals
  use m_ES_WF_by_SDorCG,    only : m_ESsd_alloc_dzajn2, m_ESsd_alloc_zaj_old
  use m_Charge_Density,     only : chgq_l &
       &                         , m_CD_alloc_hsr &
       &                         , m_CD_rd_hsr &
       &                         , m_CD_rd_chgq  &
       &                         , m_CD_initial_CD_by_file_rspace &
       &                         , m_CD_adjust_spindensity 
  use m_Crystal_Structure, only  : sw_fix_total_spin, sw_magnetic_constraint
! <--
  use m_XC_Potential,      only  : vxc_l, exc
  use m_Parallelization,   only  : m_Parallel_dealloc_mpi_elec, m_Parallel_init_mpi_elec,ista_kngp,iend_kngp,nrank_e
  use m_Orbital_Population,only  : m_OP_rd_occ_mat, m_OP_mix_om, m_OP_occ_mat_init, m_OP_cp_ommix_to_omold
  use m_FiniteElectricField,only : m_FEF_Constract_of_ftq
  use m_Parallelization,   only    : m_Parallel_init_mpi_elec_3D
  use m_Charge_Density,       only : m_CD_wd_chgq_l_small_portion   &
 &                                 , m_CD_cp_chgq_to_chgqo
  use m_Charge_Density,       only : m_CD_initial_CD_by_Gauss_func, m_CD_initial_CD_by_Gauss_kt
  use m_Charge_Density,       only : m_CD_softpart_3D, m_CD_hardpart
  use m_Dipole,               only : m_Dipole_vdip_alloc_3D
  use m_Electronic_Structure, only : vlhxc_l             &
 &                                 , zaj_l,   zaj_ball    &
 &                                 , fsr_l                 &
 &                                 , fsi_l                 &
 &                                 , eko_l              &
 &                                 , occup_l            &
 &                                 , neordr,  nrvf_ordr ,vlhxcQ           
  use m_ES_LHXC,              only : m_ESlhxc_potential_3D
  use m_ES_Intgr_VlhxcQlm,    only : m_ESiVQ_integrate_VlhxcQlm_3D
  use m_Ionic_System,         only : zfm3_l 
  use m_Parallelization,      only : myrank_k, map_k, init_zaj_para
  use m_PlaneWaveBasisSet,    only : ylm_l        &
  &                                , gr_l          &
  &                                , m_pwBS_sphrp_l_3D
  use m_PseudoPotential,      only : qitg_l ,  nqitg     &
 &                                 , psc_l               &
 &                                 , rhvg_l              &
 &                                 , modnrm, m_PP_gfqwei_3D, flg_paw, epc, m_PP_rd_PAW_parameters
  use m_XC_Potential,         only : m_XC_cal_potential_3D
  use m_Control_Parameters,   only : nspin, af, kimg, from_PSEUDOPOTENTIAL_FILE  &
 &                                 , istress,sw_fine_STM_simulation
  use m_Const_Parameters,     only : GAMMA
  use m_Kpoints,              only : kv3,vkxyz,k_symmetry
!F---
  use m_PlaneWaveBasisSet   ,only : iba
  use m_Control_Parameters  ,only : nblocksize_mgs,  nblocksize_mgs_is_given
  use m_Electronic_Structure,only : nblocksize_mgs_default
  use m_Parallelization     ,only : make_index_band_3D, make_index_band_for_Gdiv_3D, make_ball_buff
!F---
!!$#ifdef FJ_TIMER
!!$  use m_Parallelization,      only : mpi_comm_group
!!$#endif
  use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
       &                         , m_ES_EXX_occup,  m_ES_EXX_ngpt &
       &                         , m_ES_EXX_update, m_ES_EXX_crotylm, m_ES_EXX_ylm
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
  use m_Ionic_System,      only  : zeta1,m_IS_natm_can_change


   use m_Control_Parameters,     only : m_CtrlP_set_init_status, read_charge_hardpart
#ifdef MEMORY_SAVE_ZAJ_OLD
   use m_Control_Parameters,     only : RMM2P_is_specified
#endif
   use m_ErrorMessages
! ===================== KT_Test ========================= 12.5Exp
   use m_Control_Parameters,    only : m_CtrlP_set_hybrid_parameters, xctype
   use m_ES_ExactExChange,      only : m_ES_EXX_set_nmax_G_hyb
! ======================================================= 12.5Exp


! ================================== added by K. Tagami =============== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor, ndim_magmom, &
       &                             import_collinear_spindensity, &
       &                             import_collinear_wavefunctions

!  use m_Charge_Density,  only : m_CD_initCD_by_file_rsp_noncl, &
!       &                        m_CD_adjust_spindensity_noncl, &
!       &                        m_CD_initial_CD_by_Gauss_kt, &
!       &                        m_CD_wd_chgq_l_portion_noncl
!  use m_ES_LHXC,         only : m_ESlhxc_potential_noncl

!  use m_Electronic_Structure,   only : m_ES_energy_eigen_vals_noncl, &
!       &                               m_ES_energy_eigenvals_ext_noncl, &
!       &                               m_ES_alloc_zaj_etc_noncl
!  use m_ES_Ortho,               only : m_ES_modified_gramschmidt_noncl

  use m_Files,                  only : m_Files_open_nfchr_noncl
!!  use m_PseudoPotential,        only : m_PP_set_fqwei_noncl
!!  use m_ES_NonCollinear,        only :  m_ES_init_Mat_dion0_noncl, &
!!       &                                m_ES_set_Mat_q_noncl
!
!!  use m_ES_IO,                   only : m_ESIO_rd_WFs_import_frm_collin
!!  use m_Charge_Density,          only : m_CD_rd_chgq_import_frm_collin, &
!!       &                                m_CD_rd_chgq_noncl
  use m_CD_Mag_Moment,           only : m_CD_alloc_RhoMag_on_atom, &
       &                                m_CD_calc_ChgMagMom_in_sphere, &
       &                                sw_monitor_atomcharge
  use m_ES_Mag_Constraint,       only : m_ES_add_MagConstraintPot_chgql, &
       &                                m_ES_add_MagConstraintPot_hsr
  use m_Orbital_Population,      only  : m_OP_rd_occ_mat_noncl
! ===================================================================== 11.0

! ================================== added by K. Tagami =============== 11.0
  use m_Control_Parameters,      only : SpinOrbit_mode
  use m_Const_Parameters,        only : Neglected, BuiltIn, ByProjector
  use m_SpinOrbit_Potential,     only : m_SO_alloc_dsoc, &
       &                                m_SO_set_Dsoc_potential1, &
       &                                m_SO_calc_MatLS_orb_s_to_f, &
       &                                m_SO_diagonalize_MatLS, &
       &                                m_SO_set_MatU_ylm_RC
  use m_ES_NonCollinear,         only : m_ES_alloc_factor_fss, &
       &                                 m_ES_set_factor_fss

! ==================================================================== 11.0

! ================================== added by K. Tagami =============== 11.0
  use m_Const_Parameters,        only : ByPawPot, ZeffApprox
  use m_SpinOrbit_Potential,    only : m_SO_alloc_Mat_SOC_strenth, &
       &                                m_SO_set_Dsoc_potential2
  use m_SpinOrbit_RadInt,       only : m_SO_calc_SOC_strength_pawpot, &
       &                               m_SO_calc_SOC_strength_zeff, &
       &                               m_SO_check_mode_Builtin, &
       &                               m_SO_check_mode_Pawpot, &
       &                               m_SO_check_mode_Zeff
! ======================================================================= 11.0
  use m_BerryPhase,             only : m_BP_rd_cntn_data

! ============= KT_add ==================== 13.0D
  use m_Files,  only : m_Files_reopen_nfcntn_bin_paw
! ========================================= 13.0D


! ==== EXP_CELLOPT === 2015/09/24
  use m_IterationNumbers,     only : iteration_unit_cell
  use m_Control_Parameters,   only :  sw_read_nfchgt_prev_cell, sw_read_nfzaj_prev_cell
! ==================== 2015/09/24

  implicit none
  integer :: iloop
  logical, save :: is_charge_density_read = .false.
! <--
  integer :: neg_incre

  integer :: ierror

  integer :: ispin, ik, iksnl,ib
!!$#ifdef FJ_TIMER
!!$  integer :: ierr
!!$#endif

! -----> T. Yamasaki, 11 July 2008 ---- 
  real(kind=DP) :: zeta_sum
  logical :: initialization_required
  if(.not.initialization_required()) then
!     call m_CD_softpart_3D(nfout,kv3)
!     call m_CD_hardpart(nfout,kv3)
!     call m_CD_cp_chgq_to_chgqo()
     call m_PP_gfqwei_3D(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
     call m_CtrlP_set_init_status(.false.)
     call UpdateUeff()
     if(sw_hybrid_functional == ON) call EXX()
     return
  endif

  call UpdateUeff()

! ====================== KT_Test ========================= 12.5Exp
!  if(sw_hybrid_functional == ON) then
!     call m_CtrlP_set_hybrid_parameters
!     call m_ES_EXX_set_nmax_G_hyb
!  endif
! ======================================================== 12.5Exp

  if(sw_hybrid_functional == ON) call m_ES_EXX_update(ON)

  if(icond == INITIAL .or. icond==COORDINATE_CONTINUATION) then
     call m_ES_gtotch(nfout)
     if(icond == INITIAL) then
        if(totch >= neg*2.0) then
           if(ipri >= 1) then
              write(nfout,'(" ### Warning(1309): Number of bands(neg) is insufficient:")')
              write(nfout,'("                totch = ",f10.3," >= neg*2.0 = ",f10.3)') totch, neg*2.0
           end if
           if(dabs(sum(zeta1)) > 0.d0) then
              call m_CtrlP_set_neg_properly(1.3*totch) ! -> neg
           else
              call m_CtrlP_set_neg_properly(totch) ! -> neg
           end if
           call m_CntrlP_set_meg(neg)
           call m_CntrlP_set_neg(neg)
!           if(ipri >= 1) write(nfout,'(" neg (=num_bands) is enlarged ",i12)') neg
           if(ipri >= 1) write(nfout,'(" ### Warning(1309): Number of bands is enlarged",i12)') neg
           call m_CntrlP_set_davidson_size(neg) ! -> max_subspace_size
           call m_Parallel_dealloc_mpi_elec()


           call m_Parallel_init_mpi_elec_3D(nfout,ipriparallel,printable,neg,kv3,nspin,kg1,iba)
           call make_index_band_3D(nfout,ipriparallel,printable,kv3,neg &
                & , nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
           call make_index_band_for_Gdiv_3D(neg, nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
           call make_ball_buff
        end if
     end if
  else if(icond == CONTINUATION) then
     if(neg_previous > neg) then
        call m_CntrlP_set_neg(neg_previous)
        call m_CntrlP_set_meg(neg)
        call m_CntrlP_set_davidson_size(neg) ! -> max_subspace_size
        call m_Parallel_dealloc_mpi_elec()


        call m_Parallel_init_mpi_elec_3D(nfout,ipriparallel,printable,neg,kv3,nspin,kg1,iba)
        call make_index_band_3D(nfout,ipriparallel,printable,kv3,neg &
             &   , nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
        call make_index_band_for_Gdiv_3D(neg, nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
        call make_ball_buff
        if(ipri >= 1) write(nfout,'(" neg is enlarged ",f12.5)') neg
     end if
  end if
! <------

  if(nrank_e > neg) call phase_execution_error(PARALLELIZATION_INVALID_NE)

  if(.not.skip_alloc_phonon) then
     call m_CD_alloc_hsr()
     call m_ES_alloc_vlhxc()
     call m_ES_alloc_vlhxcQ()
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(30)
#endif

     if ( sw_monitor_atomcharge == ON ) then
        call m_CD_alloc_RhoMag_on_atom
     endif

     call m_ES_alloc_zaj_etc()
! === Use extrapolation! =======================================================
     call m_ES_wf_extrpl_alloc()
! ==============================================================================

#ifdef FJ_TIMER
                    call timer_end(30)
#endif
#ifdef MEMORY_SAVE_ZAJ_OLD
     if(RMM2P_is_specified) then
#endif
     call m_ESsd_alloc_zaj_old()
#ifdef MEMORY_SAVE_ZAJ_OLD
     end if
#endif
     call m_ESsd_alloc_dzajn2()
     if(sw_hubbard == ON) call m_ES_alloc_Dhub()
     if(sw_hybrid_functional == ON) call m_ES_EXX_ngpt()
     if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
        if(ekmode == ON) then
           call m_ES_alloc_eko_ek()
        else if(ekmode == OFF .and. fixed_charge_k_parallel == ONE_BY_ONE) then
           call m_ES_alloc_eko_ek()
        end if

        if(evaluation_eko_diff == ON) then
           call m_ES_alloc_eko1()
        else if(delta_eigenvalue_cond_is_given) then
           call m_ES_alloc_eko1()
           call m_ES_cpeko()
        end if
     else
        if(delta_eigenvalue_cond_is_given) then
           call m_ES_alloc_eko1()
           call m_ES_cpeko()
        end if
     end if
     if(sw_dipole_correction == ON) then
        call m_Dipole_vdip_alloc_3D()
     end if
  end if


  if(sw_phonon == ON .and. sw_calc_force == OFF) return

!!$  call m_PP_gfqwei(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
!!$  if(modnrm == EXECUT .and. (icond == INITIAL .or. icond == CONTINUATION)) then
  if(.not.skip_alloc_phonon) then


     call m_PP_gfqwei_3D(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2

     if(modnrm == EXECUT ) then
        call m_pwBS_alloc_ylm_l()
        call m_pwBS_sphrp_l_3D()                           ! -> ylm_l
     end if
  end if

  if(sw_fef==ON) call m_FEF_Constract_of_ftq()

! ==== ASMS ====
  if ( sw_hybrid_functional == ON ) sw_eval_epc_on_fftmesh = ON
  if ( xctype == 'vdwdf' ) sw_eval_epc_on_fftmesh = ON
  if ( sw_eval_epc_on_fftmesh == ON ) then
     call m_XC_cal_potential_3D( nfout, Partial_Core_Charge, chgq_l, VXC_AND_EXC )
     epc = exc
  endif
! ==== ASMS ====

  if(iteration == 0) call m_TE_set_etotal_old()

  if(sw_screening_correction == ON) then
     call screening_potential
  end if
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

  if(icond == INITIAL .or. icond == COORDINATE_CONTINUATION .or. &
       & (icond==FIXED_CHARGE .and. ekmode==OFF .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     if(icond /= INITIAL) call m_ES_gtotch(nfout)
     if(icond == INITIAL) call check_neg()

     !---- set a charge density ----
     if(.not.is_charge_density_read.and.(initial_chg == FILE .or. (icond==FIXED_CHARGE.and.ekmode==OFF))) then
        call read_charge_density(condition=1)
        call read_efermi()
        if(icond==FIXED_CHARGE .and. ekmode == OFF) call copy_chgq_to_chgqo()
     else
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(30)
#endif
!        call m_CD_initial_CD_by_Gauss_func(nfout)   ! (intchg) -> chgq_l
        call m_CD_initial_CD_by_Gauss_kt(nfout)   ! (intchg) -> chgq_l
#ifdef FJ_TIMER
                    call timer_end(30)
#endif

     end if

     !---- set wave functions ----
     if ( iteration_unit_cell > 1 .and. (sw_read_nfzaj_prev_cell == ON .or. is_charge_density_read)) then
        call read_zaj( condition =-4 )
     else if(intzaj == by_random_numbers) then
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(40)
#endif
        if ( init_zaj_para ) then
           call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        else
           call m_ESIW_by_randomnumbers0_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        endif
#ifdef FJ_TIMER
                    call timer_end(40)
#endif
     else if(intzaj == by_pseudo_atomic_orbitals) then
        call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)    ! (paozaj) -> zaj_l
     else if(intzaj == by_matrix_diagon) then

     else if(intzaj == FILE) then
        call read_zaj( condition = 1 )
! === ik is not defined here!!! by tkato 2013/02/12 ============================
!!$       call m_ES_betar_dot_WFs_3D(nfout,ik)         ! (fsrfsi)
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle
          call m_ES_betar_dot_WFs_3D(nfout,ik)         ! (fsrfsi)
       end do

        if(initial_chg == FILE .or. (icond==FIXED_CHARGE.and.ekmode==OFF)) then
        else
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(34)
#endif
           call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC)  ! -> vxc_l
#ifdef FJ_TIMER
                    call timer_end(34)
#endif
           call Local_Hartree_XC_potential()
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(36)
#endif
           call m_ESiVQ_integrate_VlhxcQlm_3D(nfout) ! (lclchh) -> vlhxcQ
#ifdef FJ_TIMER
                    call timer_end(36)
#endif
           call energy_eigen_values()
           call ChargeDensity_Construction(1)
        end if
     endif

     !---- set a potential ----
     call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC) ! -> vxc_l
     call Local_Hartree_XC_potential()
     if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals .or. intzaj == FILE) then
        if ( sw_monitor_atomcharge == ON ) then
           call m_CD_calc_ChgMagMom_in_sphere
        endif
        if ( sw_magnetic_constraint == ON ) then
           call m_ES_add_MagConstraintPot_chgql
           call m_ES_add_MagConstraintPot_hsr
        endif
     end if
! === DEBUG by tkato 2014/08/14 ================================================
!    call modified_gramschmidt()
     if(intzaj /= by_matrix_diagon) call modified_gramschmidt()
! ==============================================================================
!     if(intzaj /= by_matrix_diagon) then
      if(sw_hybrid_functional == ON) call EXX()
!     end if
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(36)
#endif
     call m_ESiVQ_integrate_VlhxcQlm_3D(nfout)   ! (lclchh) -> vlhxcQ
#ifdef FJ_TIMER
                    call timer_end(36)
#endif
     if(intzaj /= by_matrix_diagon) call energy_eigen_values()

     if(iprichargedensity >= 2) call m_CD_wd_chgq_l_small_portion(nfout)
     if(icond==COORDINATE_CONTINUATION) icond = INITIAL

     if(sw_hubbard == ON) then
        if(intzaj==FILE)then
           if(initial_occmat == FILE .or. icond==FIXED_CHARGE .or.  iteration_unit_cell > 1) then
              call read_occ_mat() ! -> om
           else
              call ChargeDensity_Construction(1)
              call Renewal_of_OccMat(.false.,ON, .false.)
           endif
        else 
           if(initial_occmat == FILE .or. icond==FIXED_CHARGE .or.  iteration_unit_cell > 1) then
              call read_occ_mat() ! -> om
           else if (sw_initial_es==ON)then
              call ChargeDensity_Construction(1)
              call Renewal_of_OccMat(.false.,ON, .false.)
           else
              call m_OP_occ_mat_init(nfout) ! -> om
           end if
        endif
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if
  else if(icond == CONTINUATION .or. &
       & (icond==FIXED_CHARGE_CONTINUATION .and. ekmode==OFF &
       & .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     call m_Files_open_nfcntn_bin
     call m_ESIO_rd_EigenValues_etc(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned)
!!$     call m_ESIO_wd_EigenValues(nfout,2,nooccupation=NO)
     call m_Files_open_nfzaj()
     call m_ESIO_rd_WFs(nfout,nfzaj,F_ZAJ_in_partitioned)
     if(neg_previous < neg) then
        if ( init_zaj_para ) then
           call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        else
           call m_ESIW_by_randomnumbers0_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        endif
     end if
     call read_charge_density(condition = 2)
     if(flg_paw) call m_CD_rd_hsr(nfcntn_bin_paw)
     if(icond /= CONTINUATION) call read_efermi()

     do ik = 1, kv3, af+1
        if(map_k(ik) /= myrank_k) cycle         ! MPI
        call m_ES_betar_dot_WFs_3D(nfout,ik)            ! (fsrfsi) ->fsr_l
     end do
     if(sw_hybrid_functional == ON) call EXX()

     if(neg_previous < neg) then
        call modified_gramschmidt()
        call m_ES_energy_eigen_values_ext_3D(nfout)
     end if
     call Renewal_of_Potential()
     if(sw_hubbard == ON) then
        call read_occ_mat()    ! -> om
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if
     if(icond==FIXED_CHARGE_CONTINUATION .and. ekmode == OFF) then
        call copy_chgq_to_chgqo()
        if(sw_hubbard == ON) call m_OP_cp_ommix_to_omold()
     end if
  else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
     call m_ES_gtotch(nfout)

     call read_charge_density(condition = 2)
     if(flg_paw.and.ekmode/=OFF) call m_CD_rd_hsr(nfcntn_bin_paw)
     call read_efermi()

     call Renewal_of_Potential()
     if(sw_hubbard==ON) then
        call read_occ_mat() ! -> om
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if
     if(icond == FIXED_CHARGE_CONTINUATION .and. nk_in_the_process >= 2) call m_Files_skiptoend(nfeng)
     if(icond == FIXED_CHARGE_CONTINUATION .and. sw_berry_phase == ON ) call m_BP_rd_cntn_data()
  endif
  call m_CtrlP_set_init_status(.false.)
contains
  subroutine read_charge_density(condition)
    use m_Files,              only : m_Files_open_nfchr
    use m_Charge_Density,     only : m_CD_rd_chgq &
         &                         , m_CD_initial_CD_by_file_rspace &
         &                         , m_CD_adjust_spindensity
    integer, intent(in) :: condition
    integer :: ispin
    integer :: iloop

    call m_Files_open_nfchgt()
!!$    write(6,'( " icond = ",i8, " condition = ", i8,"  (read_charge_density)")') icond,condition
    is_charge_density_read = .true.
    if(condition == 1) then
       if(sw_initial_charge_rspace == ON) then
             do iloop = 1, nspin
                call m_Files_open_nfchr(nspin,iloop)
                call m_CD_initial_CD_by_file_rspace(nspin,iloop,nfout,nfchr)
             end do
       else
             call m_CD_rd_chgq(nfout,nfchgt,F_CHGT_in_partitioned)
          if ( flg_paw .and. read_charge_hardpart == YES .and. m_Files_nfcntn_bin_paw_exists()) then
             call m_Files_open_nfcntn_bin_paw()
             call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
             call m_CD_rd_hsr(nfcntn_bin_paw)
             call m_Files_close_nfcntn_bin_paw()
          endif
       end if

          call m_CD_adjust_spindensity(nfout)

    else if(condition == 2) then
          call m_CD_rd_chgq(nfout,nfchgt,F_CHGT_in_partitioned)
!!$       if ( flg_paw .and. ) then
!!$          call m_CD_rd_hsr(nfcntn_bin_paw)
!!$       endif

    else if(condition == -4) then      ! coordinate-continuation
!
    end if

  end subroutine read_charge_density
 
  subroutine read_efermi()
    use m_Files,              only : nfout,m_Files_open_nfefermi, m_Files_close_nfefermi
    use m_ES_IO,              only : m_ESIO_rd_Efermi

    call m_Files_open_nfefermi()
    call m_ESIO_rd_Efermi(nfout,nfefermi)
    call m_Files_close_nfefermi()
  end subroutine read_efermi

  subroutine copy_chgq_to_chgqo()
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
        call timer_sta(30)
#endif
    call m_CD_cp_chgq_to_chgqo()
#ifdef FJ_TIMER
        call timer_end(30)
#endif
  end subroutine copy_chgq_to_chgqo

  subroutine Local_Hartree_XC_potential()
    use m_ES_LHXC,            only : m_ESlhxc_potential_3D
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(35)
#endif
    call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l) ! (stlhxc) ->vlhxc_l
#ifdef FJ_TIMER
                    call timer_end(35)
#endif
  end subroutine Local_Hartree_XC_potential

  subroutine energy_eigen_values()
    use m_Electronic_Structure,   only : m_ES_energy_eigen_values_3D
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(33)
#endif
    call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
#ifdef FJ_TIMER
                    call timer_end(33)
#endif
  end subroutine energy_eigen_values

  subroutine modified_gramschmidt()
    use m_ES_ortho,           only : m_ES_modified_gram_schmidt
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(32)
#endif
       call m_ES_modified_gram_schmidt(nfout) ! ->zaj_l, fsr_l,fsi_l
#ifdef FJ_TIMER
                    call timer_end(32)
#endif
  end subroutine modified_gramschmidt

  subroutine EXX()
    use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
         &                         , m_ES_EXX_occup  &
         &                         , sw_rspace_hyb, m_ES_EXX_init0 &
         &                         , m_ES_EXX_ylm, m_ES_EXX_crotylm
    call m_ES_EXX_init0()
    if(modnrm == EXECUT ) then
       if(sw_rspace_hyb==OFF) call m_ES_EXX_ylm()
       call m_ES_EXX_crotylm()
    end if
    call m_ES_EXX_occup(nfout)
    call m_ES_EXX_gather_valence_states(nfout)
    call m_ES_EXX_kernel(nfout)
  end subroutine EXX

  subroutine read_occ_mat()
    use m_Orbital_Population,      only  : m_OP_rd_occ_mat
       call m_OP_rd_occ_mat(nfout) ! -> om
  end subroutine read_occ_mat

  subroutine read_zaj( condition )
    integer, intent(in) :: condition

    call m_Files_open_nfzaj()

    if ( condition == 1 ) then
          call m_ESIO_rd_WFs(nfout,nfzaj,F_ZAJ_in_partitioned)

    else if ( condition == -4 ) then       ! coordinate-continuation
    endif

  end subroutine read_zaj

  subroutine check_neg()
    if(totch >= neg*2.0) then
       if(ipri >= 1) write(nfout,'(" This job stops because totch = ",f12.5, " > neg*2.0 = ",f12.5)') &
            & totch, neg*2.0
       stop ' totch > neg*2.0'
    end if
  end subroutine check_neg
end subroutine Initial_Electronic_Structure

subroutine Initial_WaveFunctions_ek
!                           @(#)Initial_Electronic_Structure.f90 1.4 03/02/19 00:43:18
  use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                         , by_random_numbers, by_matrix_diagon, YES, ON, OFF &
       &                         , by_pseudo_atomic_orbitals
  use m_IterationNumbers,   only : nk_in_the_process &
       &                         , first_kpoint_in_this_job &
       &                         , iteration_electronic &
       &                         , m_Iter_reset_iter_electronic
  use m_Control_Parameters, only : ekmode,icond,intzaj,evaluation_eko_diff &
       &                         , ipri,ipriekzaj, sw_ekzaj,neg, printable, numk_zajsaved &
       &                         , sw_hybrid_functional
  use m_Files,              only : nfout,nfzaj, m_Files_open_nfzaj, m_Files_open_nfzaj_append
  use m_Kpoints,            only : kv3
  use m_Electronic_Structure,only: m_ES_energy_eigen_values_3D &
       &                         , m_ES_cpeko &
       &                         , m_ES_wd_zaj_small_portion0
  use m_ES_nonlocal,        only : m_ES_betar_dot_WFs_3D
  use m_ES_ortho,           only : m_ES_modified_gram_schmidt
  use m_ES_initialWF,       only : m_ESIW_by_randomnumbers_3D &
       &                         , m_ESIW_by_atomic_orbitals
  use m_ES_IO,              only : m_ESIO_rd_WFs_and_EVs_ek
  use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
       &                         , m_ES_EXX_occup

! =========================================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,   only : noncol, ndim_magmom
  use m_Control_Parameters,   only : af
  use m_Parallelization,      only : myrank_k, map_k
! ========================================================================= 11.0

  implicit none
  integer :: ik

  if(printable) write(nfout,'("!! icond, nk_in_the_process, first_kpoint_in_this_job = ",3i8)') &
       & icond, nk_in_the_process, first_kpoint_in_this_job
  if(ekmode == ON) then
     if(icond == FIXED_CHARGE &
          & .or. (icond == FIXED_CHARGE_CONTINUATION &
          &         .and. nk_in_the_process /= first_kpoint_in_this_job) &
          & .or. (icond == FIXED_CHARGE_CONTINUATION &
          &         .and. iteration_electronic == 0) &
          & ) then
        if(sw_ekzaj == OFF) then
           if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals) then
              if(intzaj == by_random_numbers) then
                 call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)! (rndzaj) -> zaj_l
              else
                 call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)! (paozaj) -> zaj_l
              end if
              do ik = 1, kv3, af+1
                 if(map_k(ik) /= myrank_k) cycle
                 call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
              end do

! ======================================= modified by K. Tagami ========== 11.0
!              call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
!
              call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
! ======================================================================== 11.0

              if(sw_hybrid_functional == ON) then
                 call m_ES_EXX_occup(nfout)
                 call m_ES_EXX_gather_valence_states(nfout)
                 call m_ES_EXX_kernel(nfout)
              end if

! ======================================= modified by K. Tagami ========== 11.0
!              call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
!
              call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
! ======================================================================= 11.0

              if(intzaj == by_matrix_diagon) then

              end if
           end if
           if(icond == FIXED_CHARGE_CONTINUATION.and.iteration_electronic == 0) &
                & call m_Files_open_nfzaj_append()
        else
           call m_Files_open_nfzaj()
           call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj) ! -> zaj_l,eko_l,neordr
           do ik = 1, kv3, af+1
              if(map_k(ik) /= myrank_k) cycle
              call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
           end do
        end if
     else if((icond == FIXED_CHARGE_CONTINUATION &
          & .and. nk_in_the_process == first_kpoint_in_this_job) &
          & .or.(icond == FIXED_CHARGE_CONTINUATION &
          &   .and. iteration_electronic /= 0)) then
        call m_Files_open_nfzaj()
        call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj)
        do ik = 1, kv3, af+1
           if(map_k(ik) /= myrank_k) cycle
           call m_ES_betar_dot_WFs_3D(nfout,ik)
        end do
     else
        stop ' icond is illegal (Initial_Electronic_Structure_ek)'
     end if
  else if(ekmode == OFF) then
     if(ipri>=1) write(nfout,'(" kv3 = ",i8)') kv3
     if(icond == FIXED_CHARGE_CONTINUATION .and. first_kpoint_in_this_job == nk_in_the_process) then
        if(ipri>=1) write(nfout,'("!! icond = ",i8)') icond
        call m_Files_open_nfzaj()
        call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj)
        if(nk_in_the_process+kv3-1 > numk_zajsaved) then
           call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)
           do ik = 1, kv3, af+1
              if(map_k(ik) /= myrank_k) cycle
              call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
           end do

! ================================ modified by K. Tagami ==================== 11.0
!          call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
           call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
! ========================================================================== 11.0

           if(sw_hybrid_functional == ON) then
              call m_ES_EXX_occup(nfout)
              call m_ES_EXX_gather_valence_states(nfout)
              call m_ES_EXX_kernel(nfout)
           end if

! ================================= modified by K. Tagami =============== 11.0
!           call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
          call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
! ====================================================================== 11.0

        else
           do ik = 1, kv3, af+1
              if(map_k(ik) /= myrank_k) cycle
              call m_ES_betar_dot_WFs_3D(nfout,ik)
           end do
        end if
        call m_ES_wd_zaj_small_portion0(" -- Initial_WF_ek --",20)
     else
        if(icond==FIXED_CHARGE) then
           call m_Files_open_nfzaj()
        else
           call m_Files_open_nfzaj_append()
        end if
        if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals) then
           if(intzaj == by_random_numbers) then
              call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)! (rndzaj) -> zaj_l
           else
              call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)! (paozaj) -> zaj_l
           end if
           do ik = 1, kv3, af+1
              if(map_k(ik) /= myrank_k) cycle
              call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
           end do

! =========================================== modified by K. Tagami =========== 11.0
!           call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
           call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
! ============================================================================== 11.0

           if(sw_hybrid_functional == ON) then
              call m_ES_EXX_occup(nfout)
              call m_ES_EXX_gather_valence_states(nfout)
              call m_ES_EXX_kernel(nfout)
           end if

! ================================ modifie by K. Tagami ==================== 11.0
!           call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
           call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
! ======================================================================== 11.0

        end if
        if(intzaj == by_matrix_diagon .or. ipriekzaj == 0) &
             & call m_Iter_reset_iter_electronic(nfout)
     end if
  end if
  if(evaluation_eko_diff == YES) call m_ES_cpeko()
end subroutine Initial_WaveFunctions_ek

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: dxml_fft, mulfac
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
      subroutine dxml_fft(iop,id,nl,nm,nn,afft)
c $Id: dxmlfft.f 570 2017-04-21 20:34:50Z yamasaki $
      implicit real*8(a-h,o-z)
      include '/usr/include/DXMLDEF.FOR'
      real*8 afft(*)
      record /DXML_d_fft_structure_3D/ fft_struct_cd,fft_struct_wd
      record /DXML_z_fft_structure_3D/ fft_struct_cz,fft_struct_wz
      save fft_struct_cd,fft_struct_wd
      save fft_struct_cz,fft_struct_wz
      save nfft_cd,nfft_cz,nfft_wd,nfft_wz
      save nbox_cd,nbox_cz,nbox_wd,nbox_wz
c
c     IOP=1..DIRECT, IOP=2..INVERSE (REAL TRANSFORM)
c     IOP=1..INVERSE, IOP=2..DIRECT (COMPLEX TRANSFORM)
c
      entry cd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_cd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_cd,1,1,1)
c         scale=nfft_cd
c         call dscal(nbox_cd,scale,afft,1)
          call mulfac(afft,nbox_cd,nfft_cd)
        endif
      return
c
      entry cz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_cz,1,1,1)
c         scale=nfft_cz
c         call dscal(nbox_cz,scale,afft,1)
          call mulfac(afft,nbox_cz,nfft_cz)
        else
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_cz,1,1,1)
        endif
      return
c
      entry wd_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call dfft_apply_3d('r','c','f',afft,afft,id,nm,
     $                        fft_struct_wd,1,1,1)
        else
          call dfft_apply_3d('c','r','b',afft,afft,id,nm,
     $                        fft_struct_wd,1,1,1)
c         scale=nfft_wd
c         call dscal(nbox_wd,scale,afft,1)
          call mulfac(afft,nbox_wd,nfft_wd)
        endif
      return
c
      entry wz_fft(iop,id,nm,afft)
        if(iop.eq.1) then
          call zfft_apply_3d('c','c','b',afft,afft,id,nm,
     $                        fft_struct_wz,1,1,1)
c         scale=nfft_wz
c         call dscal(nbox_wz,scale,afft,1)
          call mulfac(afft,nbox_wz,nfft_wz)
        else
          call zfft_apply_3d('c','c','f',afft,afft,id,nm,
     $                        fft_struct_wz,1,1,1)
        endif
      return
          
      entry cd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_cd,.true.)
        nbox_cd=id*nm*nn
        nfft_cd=nl*nm*nn
        return
      entry cz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_struct_cz,.true.)
        nbox_cz=id*nm*nn*2
        nfft_cz=nl*nm*nn*2
        return
      entry wd_init(id,nl,nm,nn)
        call dfft_init_3d(nl,nm,nn,fft_struct_wd,.true.)
        nbox_wd=id*nm*nn
        nfft_wd=nl*nm*nn
        return
      entry wz_init(id,nl,nm,nn)
        call zfft_init_3d(nl,nm,nn,fft_struct_wz,.true.)
        nbox_wz=id*nm*nn*2
        nfft_wz=nl*nm*nn*2
        return
      end
      subroutine mulfac(afft,nbox,nfft)
      implicit real*8(a-h,o-z)
      dimension afft(nbox)
      scale=dble(nfft)
      do i=1,nbox
        afft(i)=afft(i)*scale
      enddo
      return
      end

!TSPACEを用いたPHASEバンド簡約プログラムband_symm
!Copyright (C) 2014-2015 Ryosuke Tomita, Hiroyuki Oshima and Mineo Saito
!TSPACE: Copyright (C) 1995 Akira Yanagi (http://aquarius.mp.es.osaka-u.ac.jp/~tspace/)
!PHASE:  Copyright (C) 2002-2014 NIMS (https://azuma.nims.go.jp/software/phase)

#define READSTOP(func, fileno) \
if(.not.func(fileno)) stop 'error while '//"func";\
rewind(fileno)

program main
  use m_commons, only: stdout, openInputFromArgOrDefaultPath,openOutput
  use m_tspace_defines, only: character_table
  use m_tspace_commons, only: set_lattice_parameters, set_kpoint_irep, get_kgroup, set_pg_name, set_class, print_kpoint_and_kgroup
  use m_container_commons, only: readline_until_tag, k_state, c_state
  use m_container_lattice, only: trp2b, get_cstate, read_lattice_system, read_lattice_parameter, read_lattice_vector, read_kpoint_data
  use m_container_psicoef, only: ikpoint, nspin, readmagstate_psicoef, readstate_psicoef
  use m_classification, only: calcAll, printAll, deleteAll
  use m_compatibility, only: add_kpoint, print_compat_table, isDuplicateKpoint
  use m_character_table, only: print_character_table_for_TeX, get_character_table
  implicit none

!入出力用装置番号
  integer, parameter:: fileno = 1000
!出力用装置番号(reduce.data,character.tex)
  integer, parameter:: freduce(2) = (/1001,1011/), ftex = 1002
!k点の総数とスピンインデックス
  integer:: nikps, is
!kpoint.dataから読み込んだk点のリストikps(1:4,1:nikps)
  integer, allocatable:: ikps(:,:)
!空間群の情報
  type(c_state), target:: cst
!k点及びk群の状態
  type(k_state), target:: kst
!指標表
  type(character_table), target:: cht

!インプットファイル1(kpoint.data)を開く
  if(.not.openInputFromArgOrDefaultPath(fileno, './kpoint.data'))&
       stop 'error while opening kpoint.data'
!kpoint.dataの読み込み、nikpsとikpsを決める
  call read_kpoint_data(fileno, nikps, ikps)
  close(fileno)

!インプットファイル2(band_sym_input.data)を開く
  if(.not.openInputFromArgOrDefaultPath(fileno, './band_sym_input.data'))&
       stop 'error while opening band_sym_input.data'
  
!格子情報、パラメータ、セルベクトルの読み込み
  READSTOP(read_lattice_system, fileno)
  READSTOP(read_lattice_parameter, fileno)
  READSTOP(read_lattice_vector, fileno)
  cst = get_cstate()
  call set_lattice_parameters(cst%latparam)

!空間群出力
  write(stdout, '(a)') '#START OF SPACE GROUP'
  call tspgds !TSPACE関数
  write(stdout, '(a)') '#END OF SPACE GROUP'
  write(stdout, '(a)') '#START OF K-POINTS'

!band_sym_input.dataの波動関数の情報が始まる行まで読み飛ばし
  if(readline_until_tag(fileno, '##PSIINPSTART') < 1 .or. &
       .not.readmagstate_psicoef(fileno))&
       stop 'read while reading PSIINPSTART'

!磁性を含めた計算であるかどうか
  kst%kpoint%isdouble = nspin > 1
!基本逆格子をブラベ逆格子に変換する行列(3x3)
  kst%trp2b = trp2b

!磁性を含めた計算のとき、reduce_up.dataとreduce_down.dataを出力用に開く。非磁性のとき、reduce.dataのみ出力用に開く。
  if(kst%kpoint%isdouble) then
     if(.not.openOutput(freduce(1), './reduce_up.data'))&
          stop 'error while opening reduce.data'
     if(.not.openOutput(freduce(2), './reduce_down.data'))&
          stop 'error while opening reduce.data'
  else
     if(.not.openOutput(freduce(1), './reduce.data'))&
          stop 'error while opening reduce.data'
  end if

!指標表の出力ファイルを開く
  if(.not.openOutput(ftex, './character.tex'))&
       stop 'error while opening character.tex'

!TeXのプリアンブル文を記述
  write(ftex,*) '\documentclass{article}'
  write(ftex,*) '\begin{document}'
  write(ftex,*) '\section{Character table}'

!band_sym_input.dataの各k点の状態が記述されている行まで読み飛ばし
  do while(readstate_psicoef(fileno))
     
!k点および点群の情報を変数に格納
     if(ikpoint > nikps) cycle
     kst%kpoint%index = ikpoint
     kst%kpoint%comp = nint(matmul(dble(ikps(1:3, ikpoint)), kst%trp2b))
     kst%kpoint%common_denom = ikps(4,ikpoint)

!k点の情報からk群と既約表現を取得する
     call set_kpoint_irep(kst%kpoint,1)
     kst%kgroup = get_kgroup()
     call set_pg_name(kst%kgroup)
     call set_class(kst%kpoint, kst%kgroup)

!k点と群の名前の出力
     call print_kpoint_and_kgroup(stdout, kst%kpoint, kst%kgroup)

!指標表の取得
     cht = get_character_table(kst%kpoint, kst%kgroup)

!k-pathの中で名前が重複しないk点のとき、適合関係を計算するk点のリストに登録し、指標表を出力する
     if(.not.isDuplicateKpoint(kst%kpoint)) then
        call add_kpoint(kst%kpoint, cht)
        call print_character_table_for_TeX(cht, kst%kgroup, kst%kpoint, ftex)
     end if

!波動関数の簡約計算を行い、スピンごとに出力する
     call calcAll(kst, cht, fileno)
     do is = 1, nspin
        call printAll(kst, is, freduce(is))
     end do
     call deleteAll

  end do
!k点の簡約計算の終わり
  write(stdout, '(a)') '#END OF K-POINTS'
  close(stdout)
  open(stdout, status='scratch')

!ファイルのクローズ及びデータ領域の開放
  if(allocated(ikps)) deallocate(ikps)
  close(fileno)
  do is = 1, nspin
     close(freduce(is))
  end do

!TeXファイルに適合関係を出力する
  write(ftex,*) '\clearpage'
  write(ftex,*) '\section{Compatibility table}'
  call print_compat_table(ftex)
  write(ftex,*) '\end{document}'
  close(ftex)
  close(stdout)
  stop
end program main

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE: m_Representation
!
!  AUTHOR(S): T. Yamamoto   May/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Representation
implicit none

integer, parameter :: nrep0 = 12
integer, parameter :: nsym0 = 48

contains

subroutine get_irr_rep(point_group,nsym,nrep,rep,symbol_irrep,active)
character(len=3), intent(in) :: point_group
integer, intent(out) :: nsym
integer, intent(out) :: nrep
integer, intent(out) :: rep(nsym0,nrep0)
character(len=3), intent(out) :: symbol_irrep(nrep0) 
character(len=4), intent(out) :: active(nrep0) 

rep(1:nsym0,1:nrep0) = 0
symbol_irrep(1:nrep0) = 'NON'
active(1:nrep0) = 'NON '

select case(point_group)  
case('Oh ') !  1 
  call set_chartab_oh(rep)
  call set_symbol_oh(nrep,symbol_irrep,active)
  nsym = 48
case('O  ') !  2
  call set_chartab_o(rep)
  call set_symbol_o(nrep,symbol_irrep,active)
  nsym = 24
case('Td ') !  3
  call set_chartab_td(rep)
  call set_symbol_td(nrep,symbol_irrep,active)
  nsym = 24
case('Th ') !  4
  call set_chartab_th(rep)
  call set_symbol_th(nrep,symbol_irrep,active)
  nsym = 24
case('T  ') !  5
  call set_chartab_t(rep)
  call set_symbol_t(nrep,symbol_irrep,active)
  nsym = 12
case('D4h') !  6
  call set_chartab_d4h(rep)
  call set_symbol_d4h(nrep,symbol_irrep,active)
  nsym = 16
case('D4 ') !  7
  call set_chartab_d4(rep)
  call set_symbol_d4(nrep,symbol_irrep,active)
  nsym = 8
case('D2d') !  8 
  call set_chartab_d2d(rep)
  call set_symbol_d2d(nrep,symbol_irrep,active)
  nsym = 8
case('C4v') !  9
  call set_chartab_c4v(rep)
  call set_symbol_c4v(nrep,symbol_irrep,active)
  nsym = 8
case('C4h') ! 10
  call set_chartab_c4h(rep)
  call set_symbol_c4h(nrep,symbol_irrep,active)
  nsym = 8
case('S4 ') ! 11
  call set_chartab_s4(rep)
  call set_symbol_s4(nrep,symbol_irrep,active)
  nsym = 4
case('C4 ') ! 12
  call set_chartab_c4(rep)
  call set_symbol_c4(nrep,symbol_irrep,active)
  nsym = 4
case('D2h') ! 13
  call set_chartab_d2h(rep)
  call set_symbol_d2h(nrep,symbol_irrep,active)
  nsym = 8
case('D2 ') ! 14
  call set_chartab_d2(rep)
  call set_symbol_d2(nrep,symbol_irrep,active)
  nsym = 4
case('C2v') ! 15
  call set_chartab_c2v(rep)
  call set_symbol_c2v(nrep,symbol_irrep,active)
  nsym = 4
case('D6h') ! 16
  call set_chartab_d6h(rep)
  call set_symbol_d6h(nrep,symbol_irrep,active)
  nsym = 24
case('D6 ') ! 17
  call set_chartab_d6(rep)
  call set_symbol_d6(nrep,symbol_irrep,active)
  nsym = 12
case('D3h') ! 18
  call set_chartab_d3h(rep)
  call set_symbol_d3h(nrep,symbol_irrep,active)
  nsym = 12
case('C6v') ! 19
  call set_chartab_c6v(rep)
  call set_symbol_c6v(nrep,symbol_irrep,active)
  nsym = 12
case('C6h') ! 20
  call set_chartab_c6h(rep)
  call set_symbol_c6h(nrep,symbol_irrep,active)
  nsym = 12
case('C3h') ! 21
  call set_chartab_c3h(rep)
  call set_symbol_c3h(nrep,symbol_irrep,active)
  nsym = 6
case('C6 ') ! 22
  call set_chartab_c6(rep)
  call set_symbol_c6(nrep,symbol_irrep,active)
  nsym = 6
case('D3d') ! 23
  call set_chartab_d3d(rep)
  call set_symbol_d3d(nrep,symbol_irrep,active)
  nsym = 12
case('D3 ') ! 24
  call set_chartab_d3(rep)
  call set_symbol_d3(nrep,symbol_irrep,active)
  nsym = 6
case('C3v') ! 25
  call set_chartab_c3v(rep)
  call set_symbol_c3v(nrep,symbol_irrep,active)
  nsym = 6
case('S6 ') ! 26
  call set_chartab_s6(rep)
  call set_symbol_s6(nrep,symbol_irrep,active)
  nsym = 6
case('C3 ') ! 27
  call set_chartab_c3(rep)
  call set_symbol_c3(nrep,symbol_irrep,active)
  nsym = 3
case('C2h') ! 28
  call set_chartab_c2h(rep)
  call set_symbol_c2h(nrep,symbol_irrep,active)
  nsym = 4
case('Cs ') ! 29
  call set_chartab_cs(rep)
  call set_symbol_cs(nrep,symbol_irrep,active)
  nsym = 2
case('C2 ') ! 30
  call set_chartab_c2(rep)
  call set_symbol_c2(nrep,symbol_irrep,active)
  nsym = 2
case('Ci ') ! 30
  call set_chartab_ci(rep)
  call set_symbol_ci(nrep,symbol_irrep,active)
  nsym = 2
case('C1 ') ! 32
  call set_chartab_c1(rep)
  call set_symbol_c1(nrep,symbol_irrep,active)
  nsym = 1
end select

contains

  subroutine set_chartab_oh(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer :: i
  integer, parameter :: nsym = 48
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 10
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_o(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_oh

  subroutine set_symbol_oh(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(10)
  character(len=4), intent(out) :: active(10)
  
  nrep = 10
  symbol_irrep(1) = 'A1g'; active(1) = 'R   '
  symbol_irrep(2) = 'A2g' 
  symbol_irrep(3) = 'Eg '; active(3) = 'R   '
  symbol_irrep(4) = 'T1g'
  symbol_irrep(5) = 'T2g'; active(5) = 'R   '
  symbol_irrep(6) = 'A1u'
  symbol_irrep(7) = 'A2u'
  symbol_irrep(8) = 'Eu '
  symbol_irrep(9) = 'T1u'; active(9) = 'IR  '
  symbol_irrep(10) = 'T2u'
  end subroutine set_symbol_oh

  subroutine set_chartab_o(rep)
  integer, intent(out) :: rep(nsym0,nrep0)
  
  ! local varibales
  integer, parameter :: nsym = 24
  
  rep(1:nsym,1)=1 ! A1

  rep(1:12,2)=1; rep(13:nsym,2)=-1 ! A2

  rep(1:4,3)=2; rep(5:12,3)=-1; rep(13:nsym,3)=0 ! E

  rep(1,4)=3; rep(2:4,4)=-1; rep(5:12,4)=0 ! T1
  rep(13:18,4)=-1; rep(19:nsym,4)=1          ! T1 (cont.)

  rep(1,5)=3; rep(2:4,5)=-1; rep(5:12,5)=0; rep(13:18,5)=1; rep(19:nsym,5)=-1 ! T2

  end subroutine set_chartab_o
  
  subroutine set_symbol_o(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(5)
  character(len=4), intent(out) :: active(5)
  nrep = 5
  symbol_irrep(1) = 'A1 '; active(1)='R   '
  symbol_irrep(2) = 'A2 '
  symbol_irrep(3) = 'E  '; active(3)='R   '
  symbol_irrep(4) = 'T1 '; active(4)='IR  '
  symbol_irrep(5) = 'T2 '; active(5)='R   '
  end subroutine set_symbol_o

  subroutine set_chartab_td(rep)
  integer, intent(out) :: rep(nsym0,nrep0)
  call set_chartab_o(rep)
  end subroutine set_chartab_td

  subroutine set_symbol_td(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(5)
  character(len=4), intent(out) :: active(5)
  call set_symbol_o(nrep,symbol_irrep,active)
  symbol_irrep(5) = 'T2 '; active(5)='IR&R'
  end subroutine set_symbol_td
  
  subroutine set_chartab_th(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer :: i
  integer, parameter :: nsym = 24
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 6
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_t(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_th

  subroutine set_symbol_th(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(6)
  character(len=4), intent(out) :: active(6)

  nrep = 6
  symbol_irrep(1) = 'Ag '; active(1)='R   '
  symbol_irrep(2) = 'Eg '; active(2)='R   '
  symbol_irrep(3) = 'Tg '; active(3)='R   '
  symbol_irrep(4) = 'Au '
  symbol_irrep(5) = 'Eu '
  symbol_irrep(6) = 'Tu '; active(6)='IR  '

  end subroutine set_symbol_th

  subroutine set_chartab_t(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 12

  rep(1:nsym,1)=1 ! A

  rep(1:4,2)=2; rep(5:nsym,2)=-1 ! E

  rep(1,3)=3; rep(2:4,3)=-1; rep(5:nsym,3)=0 ! T

  end subroutine set_chartab_t

  subroutine set_symbol_t(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(3)
  character(len=4), intent(out) :: active(3)

  nrep = 3
  symbol_irrep(1) = 'A  '; active(1) = 'R   '
  symbol_irrep(2) = 'E  '; active(2) = 'R   '
  symbol_irrep(3) = 'T  '; active(3) = 'IR&R'

  end subroutine set_symbol_t

  subroutine set_chartab_d4h(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer :: i
  integer, parameter :: nsym = 16
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 10
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_d4(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_d4h

  subroutine set_symbol_d4h(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(10)
  character(len=4), intent(out) :: active(10)

  nrep = 10
  symbol_irrep(1) = 'A1g'; active(1) = 'R   '
  symbol_irrep(2) = 'A2g'
  symbol_irrep(3) = 'B1g'; active(3) = 'R   '
  symbol_irrep(4) = 'B2g'; active(4) = 'R   '
  symbol_irrep(5) = 'Eg '; active(5) = 'R   '
  symbol_irrep(6) = 'A1u'
  symbol_irrep(7) = 'A2u'; active(7) = 'IR  '
  symbol_irrep(8) = 'B1u'
  symbol_irrep(9) = 'B2u'
  symbol_irrep(10) = 'Eu '; active(10) = 'IR'
  end subroutine set_symbol_d4h

  subroutine set_chartab_d4(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 8

  rep(1:nsym,1)=1 ! A1

  rep(1,2)=1; rep(2:3,2)=-1; rep(4,2)=1; rep(5:6,2)=-1; rep(7:nsym,2)=1 ! A2

  rep(1:4,3)=1; rep(5:nsym,3)=-1 ! B1

  rep(1,4)=1; rep(2:3,4)=-1; rep(4:6,4)=1; rep(7:nsym,4)=-1 ! B2

  rep(1,5)=2; rep(2:3,5)=0; rep(4,5)=-2; rep(6:nsym,5)=0 ! E

  end subroutine set_chartab_d4

  subroutine set_symbol_d4(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(5)
  character(len=4), intent(out) :: active(5)

  nrep = 5
  symbol_irrep(1) = 'A1 '; active(1) = 'R   '
  symbol_irrep(2) = 'A2 '; active(2) = 'IR  '
  symbol_irrep(3) = 'B1 '; active(3) = 'R   '
  symbol_irrep(4) = 'B2 '; active(4) = 'R   '
  symbol_irrep(5) = 'E  '; active(5) = 'IR&R'

  end subroutine set_symbol_d4

  subroutine set_chartab_d2d(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 8

  rep(1:nsym,1)=1 ! A1

  rep(1:2,2)=1; rep(3:6,2)=-1; rep(7:nsym,2)=1 ! A2

  rep(1:4,3)=1; rep(5:nsym,3)=-1 ! B1

  rep(1:2,4)=1; rep(3:4,4)=-1; rep(5:6,4)=1; rep(7:nsym,4)=-1 ! B2

  rep(1,5)=2; rep(2,5)=-2; rep(3:nsym,5)=0 ! E

  end subroutine set_chartab_d2d

  subroutine set_symbol_d2d(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(5)
  character(len=4), intent(out) :: active(5)

  nrep = 5
  symbol_irrep(1) = 'A1 '; active(1) = 'R   '
  symbol_irrep(2) = 'A2 '
  symbol_irrep(3) = 'B1 '; active(3) = 'R   '
  symbol_irrep(4) = 'B2 '; active(4) = 'IR&R'
  symbol_irrep(5) = 'E  '; active(5) = 'IR&R'

  end subroutine set_symbol_d2d

  subroutine set_chartab_c4v(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 8

  rep(1:nsym,1)=1 ! A1

  rep(1:4,2)=1; rep(5:nsym,2)=-1 ! A2

  rep(1:2,3)=1; rep(3:4,3)=-1; rep(5:6,3)=1; rep(7:nsym,3)=-1 ! B1

  rep(1:2,4)=1; rep(3:4,4)=-1; rep(5:6,4)=-1; rep(7:nsym,4)=1 ! B2

  rep(1,5)=2; rep(2,5)=-2; rep(3:nsym,5)=0 ! E

  end subroutine set_chartab_c4v

  subroutine set_symbol_c4v(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(5)
  character(len=4), intent(out) :: active(5)

  nrep = 5
  symbol_irrep(1) = 'A1 '; active(1) = 'IR&R'
  symbol_irrep(2) = 'A2 '
  symbol_irrep(3) = 'B1 '; active(3) = 'R   '
  symbol_irrep(4) = 'B2 '; active(4) = 'R   '
  symbol_irrep(5) = 'E  '; active(5) = 'IR&R'

  end subroutine set_symbol_c4v

  subroutine set_chartab_c4h(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  integer :: i
  integer, parameter :: nsym = 8
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 6
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_c4(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_c4h

  subroutine set_symbol_c4h(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(6)
  character(len=4), intent(out) :: active(6)

  nrep = 6
  symbol_irrep(1) = 'Ag '; active(1) = 'R   '
  symbol_irrep(2) = 'Bg '; active(2) = 'R   '
  symbol_irrep(3) = 'Eg '; active(3) = 'R   '
  symbol_irrep(4) = 'Au '; active(4) = 'IR  '
  symbol_irrep(5) = 'Bu '
  symbol_irrep(6) = 'Eu '; active(6) = 'IR  '

  end subroutine set_symbol_c4h

  subroutine set_chartab_s4(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 4

  rep(1:nsym,1)=1 ! A

  rep(1:2,2)=1; rep(3:nsym,2)=-1 ! B

  rep(1,3)=2; rep(2,3)=-2; rep(3:nsym,3)=0 ! E

  end subroutine set_chartab_s4

  subroutine set_symbol_s4(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(3)
  character(len=4), intent(out) :: active(3)

  nrep = 3
  symbol_irrep(1) = 'A  '; active(1) = 'R   '
  symbol_irrep(2) = 'B  '; active(2) = 'IR&R'
  symbol_irrep(3) = 'E  '; active(3) = 'IR&R'

  end subroutine set_symbol_s4

  subroutine set_chartab_c4(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 4

  rep(1:nsym,1)=1 ! A

  rep(1:2,2)=1; rep(3:nsym,2)=-1 ! B

  rep(1,3)=2; rep(2,3)=-2; rep(3:nsym,3)=0 ! E

  end subroutine set_chartab_c4 

  subroutine set_symbol_c4(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(3)
  character(len=4), intent(out) :: active(3)

  nrep = 3
  call set_symbol_s4(nrep,symbol_irrep,active)
  active(1) = 'IR&R'
  active(2) = 'R   '

  end subroutine set_symbol_c4

  subroutine set_chartab_d2h(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  integer :: i
  integer, parameter :: nsym = 8
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 8
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_d2(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_d2h

  subroutine set_symbol_d2h(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(8)
  character(len=4), intent(out) :: active(8)

  nrep = 8
  symbol_irrep(1) = 'Ag '; active(1) = 'R  '
  symbol_irrep(2) = 'B1g'; active(2) = 'R  '
  symbol_irrep(3) = 'B2g'; active(3) = 'R  '
  symbol_irrep(4) = 'B3g'; active(4) = 'R  '
  symbol_irrep(5) = 'Au '
  symbol_irrep(6) = 'B1u'; active(6) = 'IR '
  symbol_irrep(7) = 'B2u'; active(7) = 'IR '
  symbol_irrep(8) = 'B3u'; active(8) = 'IR '

  end subroutine set_symbol_d2h

  subroutine set_chartab_d2(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 4

  rep(1:nsym,1)=1 ! A

  rep(1,2)=1; rep(2:3,2)=-1; rep(nsym,2)=1 ! B1

  rep(1,3)=1; rep(2,3)=-1; rep(3,3)=1; rep(4,3)=-1 ! B2

  rep(1:2,4)=1; rep(3:nsym,4)=-1 ! B3

  end subroutine set_chartab_d2

  subroutine set_symbol_d2(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(4)
  character(len=4), intent(out) :: active(4)

  nrep = 4
  symbol_irrep(1) = 'A  '; active(1) = 'R   '
  symbol_irrep(2) = 'B1 '; active(2) = 'IR&R'
  symbol_irrep(3) = 'B2 '; active(3) = 'IR&R'
  symbol_irrep(4) = 'B3 '; active(4) = 'IR&R'

  end subroutine set_symbol_d2

  subroutine set_chartab_c2v(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 4

  rep(1:nsym,1)=1 ! A1

  rep(1:2,2)=1; rep(3:nsym,2)=-1 ! A2

  rep(1,3)=1; rep(2:3,3)=-1; rep(nsym,3)=1 ! B1

  rep(1,4)=1; rep(2,4)=-1; rep(3,4)=1; rep(nsym,4)=-1 ! B2

  end subroutine set_chartab_c2v

  subroutine set_symbol_c2v(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(4)
  character(len=4), intent(out) :: active(4)

  nrep = 4
  symbol_irrep(1) = 'A1 '; active(1) = 'IR&R'
  symbol_irrep(2) = 'A2 '; active(2) = 'R   '
  symbol_irrep(3) = 'B1 '; active(3) = 'IR&R'
  symbol_irrep(4) = 'B2 '; active(4) = 'IR&R'

  end subroutine set_symbol_c2v

  subroutine set_chartab_d6h(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  integer :: i
  integer, parameter :: nsym = 24
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 12
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_d6(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_d6h

  subroutine set_symbol_d6h(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(12)
  character(len=4), intent(out) :: active(12)

  nrep = 12
  symbol_irrep(1) = 'A1g'; active(1) = 'R   '
  symbol_irrep(2) = 'A2g'
  symbol_irrep(3) = 'B1g'
  symbol_irrep(4) = 'B2g'
  symbol_irrep(5) = 'E1g'; active(5) = 'R   '
  symbol_irrep(6) = 'E2g'; active(6) = 'R   '
  symbol_irrep(7) = 'A1u'
  symbol_irrep(8) = 'A2u'; active(8) = 'IR  '
  symbol_irrep(9) = 'B1u'
  symbol_irrep(10) = 'B2u'
  symbol_irrep(11) = 'E1u'; active(11) = 'IR  '
  symbol_irrep(12) = 'E2u'

  end subroutine set_symbol_d6h

  subroutine set_chartab_d6(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 12

  rep(1:nsym,1)=1 ! A1

  rep(1:6,2)=1; rep(7:nsym,2)=-1 ! A2

  rep(1,3)=1; rep(2,3)=-1; rep(3,3)=1; rep(4,3)=-1 ! B1
  rep(5,3)=1; rep(6,3)=-1; rep(7:9,3)=-1; rep(10:nsym,3)=1 ! B1 (cont.)

  rep(1,4)=1; rep(2,4)=-1; rep(3,4)=1; rep(4,4)=-1 ! B2
  rep(5,4)=1; rep(6,4)=-1; rep(7:9,4)=1; rep(10:nsym,4)=-1 ! B2 (cont.)

  rep(1,5)=2; rep(2,5)=1; rep(3,5)=-1; rep(4,5)=-2 ! E1
  rep(5,5)=-1; rep(6,5)=1; rep(7:nsym,5)=0 ! E1 (cont.)

  rep(1,6)=2; rep(2:3,6)=-1; rep(4,6)=2 ! E2
  rep(5:6,6)=-1; rep(7:nsym,6)=0 ! E2 (cont.)

  end subroutine set_chartab_d6

  subroutine set_symbol_d6(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(6)
  character(len=4), intent(out) :: active(6)

  nrep = 6
  symbol_irrep(1) = 'A1 '; active(1) = 'R   '
  symbol_irrep(2) = 'A2 '; active(2) = 'IR  '
  symbol_irrep(3) = 'B1 '
  symbol_irrep(4) = 'B2 '
  symbol_irrep(5) = 'E1 '; active(3) = 'IR&R'
  symbol_irrep(6) = 'E2 '; active(4) = 'R   '

  end subroutine set_symbol_d6

  subroutine set_chartab_d3h(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 12

  rep(1:nsym,1)=1 ! A1

  rep(1:3,2)=1; rep(4:6,2)=-1; rep(7:9,2)=1; rep(10:nsym,2)=-1 ! A2

  rep(1:6,3)=1; rep(7:nsym,3)=-1 ! B1

  rep(1:3,4)=1; rep(4:9,4)=-1; rep(10:nsym,4)=1 ! B2

  rep(1,5)=2; rep(2:3,5)=-1; rep(4:6,5)=0; rep(7,5)=1 ! E1
  rep(8,5)=-2; rep(9,5)=1; rep(10:nsym,5)=0 ! E1 (cont.)

  rep(1,6)=2; rep(2:3,6)=-1; rep(4:6,6)=0; rep(7,6)=-1 ! E2
  rep(8,6)=2; rep(9,6)=-1; rep(10:nsym,6)=0 ! E2 (cont.)

  end subroutine set_chartab_d3h

  subroutine set_symbol_d3h(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(6)
  character(len=4), intent(out) :: active(6)

  nrep = 6
  symbol_irrep(1) = "A1'"; active(1) = 'R   '
  symbol_irrep(2) = "A2'"
  symbol_irrep(3) = 'A1"'
  symbol_irrep(4) = 'A2"'; active(4) = 'IR  '
  symbol_irrep(5) = 'E" '; active(5) = 'R   '         !! ASMS 2015/03/17
  symbol_irrep(6) = "E' "; active(6) = 'IR&R'         !! ASMS 2015/03/17

  end subroutine set_symbol_d3h

  subroutine set_chartab_c6v(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 12

  call set_chartab_d6(rep)

  end subroutine set_chartab_c6v

  subroutine set_symbol_c6v(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(6)
  character(len=4), intent(out) :: active(6)

  nrep = 6
  symbol_irrep(1) = 'A1 '; active(1) = 'IR&R'
  symbol_irrep(2) = 'A2 '
  symbol_irrep(3) = 'B1 '
  symbol_irrep(4) = 'B2 '
  symbol_irrep(5) = 'E1 '; active(5) = 'IR&R'
  symbol_irrep(6) = 'E2 '; active(6) = 'R   '

  end subroutine set_symbol_c6v

  subroutine set_chartab_c6h(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  integer :: i
  integer, parameter :: nsym = 12
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 8
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_c6(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_c6h

  subroutine set_symbol_c6h(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(8)
  character(len=4), intent(out) :: active(8)

  nrep = 8
  symbol_irrep(1) = 'Ag '; active(1) = 'R   '
  symbol_irrep(2) = 'Bg '
  symbol_irrep(3) = 'E2g'; active(3) = 'R   '
  symbol_irrep(4) = 'E1g'; active(4) = 'R   '
  symbol_irrep(5) = 'Au '; active(5) = 'IR  '
  symbol_irrep(6) = 'Bu '
  symbol_irrep(7) = 'E2u'
  symbol_irrep(8) = 'E1u'; active(8) = 'IR  '

  end subroutine set_symbol_c6h

  subroutine set_chartab_c3h(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 6

  rep(1:nsym,1)=1 ! A

  rep(1:3,2)=1; rep(4:nsym,2)=-1 ! B

  rep(1,3)=2; rep(2:3,3)=-1; rep(4,3)=-1; ! E2
  rep(5,3)=2; rep(nsym,3)=-1  ! E2

  rep(1,4)=2; rep(2:3,4)=-1; rep(4,4)=1 ! E1
  rep(5,4)=-2; rep(nsym,4)=1 ! E1

  end subroutine set_chartab_c3h

  subroutine set_symbol_c3h(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(4)
  character(len=4), intent(out) :: active(4)

  nrep = 4
  symbol_irrep(1) = "A' "; active(1) = 'R   '
  symbol_irrep(2) = 'A" '; active(2) = 'IR  '
  symbol_irrep(3) = "E' "; active(3) = 'IR&R'
  symbol_irrep(4) = 'E" '; active(4) = 'IR&R'

  end subroutine set_symbol_c3h

  subroutine set_chartab_c6(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 6

  rep(1:nsym,1)=1 ! A

  rep(1,2)=1; rep(2,2)=-1; rep(3,2)=1; rep(4,2)=-1 ! B
  rep(5,2)=1; rep(nsym,2)=-1 ! B

  rep(1,3)=2; rep(2:3,3)=-1; rep(4,3)=2; rep(5:nsym,3)=-1 ! E2

  rep(1,4)=2; rep(2,4)=1; rep(3,4)=-1; rep(4,4)=-2 ! E1
  rep(5,4)=-1; rep(nsym,4)=1 ! E1

  end subroutine set_chartab_c6

  subroutine set_symbol_c6(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(4)
  character(len=4), intent(out) :: active(4)

  nrep = 4
  symbol_irrep(1) = 'A  '; active(1) = 'IR&R'
  symbol_irrep(2) = 'B  '
  symbol_irrep(3) = 'E2 '; active(3) = 'R   '
  symbol_irrep(4) = 'E1 '; active(4) = 'IR&R'

  end subroutine set_symbol_c6

  subroutine set_chartab_d3d(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  integer :: i
  integer, parameter :: nsym = 12 
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 6
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_d3(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_d3d

  subroutine set_symbol_d3d(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(6)
  character(len=4), intent(out) :: active(6)

  nrep = 6
  symbol_irrep(1) = 'A1g'; active(1) = 'R   '
  symbol_irrep(2) = 'A2g'
  symbol_irrep(3) = 'Eg '; active(3) = 'R   '
  symbol_irrep(4) = 'A1u'
  symbol_irrep(5) = 'A2u'; active(5) = 'IR  '
  symbol_irrep(6) = 'Eu '; active(6) = 'IR  '

  end subroutine set_symbol_d3d

  subroutine set_chartab_d3(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 6

  rep(1:nsym,1)=1 ! A1

  rep(1:3,2)=1; rep(4:nsym,2)=-1 ! A2

  rep(1,3)=2; rep(2:3,3)=-1; rep(4:nsym,3)=0 ! E

  end subroutine set_chartab_d3

  subroutine set_symbol_d3(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(3)
  character(len=4), intent(out) :: active(3)

  nrep = 3
  symbol_irrep(1) = 'A1 '; active(1) = 'R   '
  symbol_irrep(2) = 'A2 '; active(2) = 'IR  '
  symbol_irrep(3) = 'E  '; active(3) = 'IR&R'

  end subroutine set_symbol_d3

  subroutine set_chartab_c3v(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 6

  rep(1:nsym,1)=1 ! A1

  rep(1:3,2)=1; rep(4:nsym,2)=-1 ! A2

  rep(1,3)=2; rep(2:3,3)=-1; rep(4:nsym,3)=0 ! E

  end subroutine set_chartab_c3v

  subroutine set_symbol_c3v(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(3)
  character(len=4), intent(out) :: active(3)

  nrep = 3
  symbol_irrep(1) = 'A1 '; active(1) = 'IR&R'
  symbol_irrep(2) = 'A2 '
  symbol_irrep(3) = 'E  '; active(3) = 'IR&R'

  end subroutine set_symbol_c3v

  subroutine set_chartab_s6(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  integer :: i
  integer, parameter :: nsym = 6
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 4
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_c3(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_s6

  subroutine set_symbol_s6(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(4)
  character(len=4), intent(out) :: active(4)

  nrep = 4
  symbol_irrep(1) = 'Ag '; active(1) = 'R   '
  symbol_irrep(2) = 'Eg '; active(2) = 'R   '
  symbol_irrep(3) = 'Au '; active(3) = 'IR  '
  symbol_irrep(4) = 'Eu '; active(4) = 'IR  '

  end subroutine set_symbol_s6

  subroutine set_chartab_c3(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 3

  rep(1:nsym,1)=1 ! A1

  rep(1,2)=2; rep(2:nsym,2)=-1 ! E

  end subroutine set_chartab_c3 

  subroutine set_symbol_c3(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(2)
  character(len=4), intent(out) :: active(2)

  nrep = 2
  symbol_irrep(1) = 'A  '; active(1) = 'IR&R'
  symbol_irrep(2) = 'E  '; active(2) = 'IR&R'

  end subroutine set_symbol_c3

  subroutine set_chartab_c2h(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  integer :: i
  integer, parameter :: nsym = 4
  integer, parameter :: nsym2 = nsym/2
  integer, parameter :: nrep = 4
  integer, parameter :: nrep2 = nrep/2

  call set_chartab_c2(rep)
  do i=1,nsym2
    rep(i,nrep2+1:nrep)=rep(i,1:nrep2)
  end do
  do i=1,nsym2
    rep(i+nsym2,1:nrep2)=rep(i,1:nrep2)
  end do
  do i=nsym2+1,nsym
    rep(i,nrep2+1:nrep)=-rep(i,1:nrep2)
  end do

  end subroutine set_chartab_c2h

  subroutine set_symbol_c2h(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(4)
  character(len=4), intent(out) :: active(4)

  nrep = 4
  symbol_irrep(1) = 'Ag '; active(1) = 'R   '
  symbol_irrep(2) = 'Bg '; active(2) = 'R   '
  symbol_irrep(3) = 'Au '; active(3) = 'IR  '
  symbol_irrep(4) = 'Bu '; active(4) = 'IR  '

  end subroutine set_symbol_c2h

  subroutine set_chartab_cs(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  call set_chartab_c2(rep)

  end subroutine set_chartab_cs

  subroutine set_symbol_cs(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(2)
  character(len=4), intent(out) :: active(2)

  nrep = 2
  symbol_irrep(1) = "A' "; active(1) = 'IR&R'
  symbol_irrep(2) = 'A" '; active(2) = 'IR&R'

  end subroutine set_symbol_cs

  subroutine set_chartab_c2(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 2

  rep(1:nsym,1)=1 ! A

  rep(1,2)=1; rep(nsym,2)=-1 ! B

  end subroutine set_chartab_c2

  subroutine set_symbol_c2(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(2)
  character(len=4), intent(out) :: active(2)

  nrep = 2
  symbol_irrep(1) = 'A  '; active(1) = 'IR&R'
  symbol_irrep(2) = 'B  '; active(2) = 'IR&R'

  end subroutine set_symbol_c2

  subroutine set_chartab_ci(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 2

  rep(1:nsym,1)=1 ! Ag 
  rep(1,2)=1; rep(nsym,2)=-1 ! Au

  end subroutine set_chartab_ci

  subroutine set_symbol_ci(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(2)
  character(len=4), intent(out) :: active(2)

  nrep = 2
  symbol_irrep(1) = 'A  '; active(1) = 'R   '
  symbol_irrep(2) = 'B  '; active(2) = 'IR  '

  end subroutine set_symbol_ci

  subroutine set_chartab_c1(rep)
  integer, intent(out) :: rep(nsym0,nrep0)

  ! local varibales
  integer, parameter :: nsym = 1

  rep(1:nsym,1)=1 ! A

  end subroutine set_chartab_c1

  subroutine set_symbol_c1(nrep,symbol_irrep,active)
  integer, intent(out) :: nrep
  character(len=3), intent(out) :: symbol_irrep(1)
  character(len=4), intent(out) :: active(1)

  nrep = 1
  symbol_irrep(1) = 'A  '; active(1) = 'IR&R'

  end subroutine set_symbol_c1

end subroutine get_irr_rep

end module m_Representation

!*********************************************************
!* 逆空間でのクーロン力を遮蔽するポテンシャルを作成するモジュール
!*
!* 2006年6月19日改良版
!*********************************************************

! 3次元座標型とその演算子の定義
module class_position
  use m_Const_Parameters, only : DP
  implicit none

  type position
     real(kind=DP) :: x, y, z
  end type
  
  interface operator(+)
     module procedure add
  end interface
  
  interface operator(-)
     module procedure sub
  end interface

  interface operator(*)
     module procedure smul
  end interface

  interface operator(/)
     module procedure sdiv
  end interface
  
  interface operator(*)
     module procedure iprod
  end interface

  interface operator(.IPROD.)
     module procedure iprod
  end interface

  interface operator(.OPROD.)
     module procedure oprod
  end interface

contains
  function add( r1, r2 ) result(r)
    type(position), intent(in) :: r1, r2
    type(position) :: r

    r%x = r1%x + r2%x
    r%y = r1%y + r2%y
    r%z = r1%z + r2%z
  end function

  function sub( r1, r2 ) result(r)
    type(position), intent(in) :: r1, r2
    type(position) :: r

    r%x = r1%x - r2%x
    r%y = r1%y - r2%y
    r%z = r1%z - r2%z
  end function

  function smul( r1, d ) result(r)
    type(position), intent(in) :: r1
    real(kind=DP), intent(in) :: d
    type(position) :: r

    r%x = r1%x * d
    r%y = r1%y * d
    r%z = r1%z * d
  end function

  function sdiv( r1, d ) result(r)
    type(position), intent(in) :: r1
    real(kind=DP), intent(in) :: d
    type(position) :: r

    r%x = r1%x / d
    r%y = r1%y / d
    r%z = r1%z / d
  end function

  function iprod( r1, r2 ) result(d)
    type(position), intent(in) :: r1, r2
    real(kind=DP) :: d

    d = r1%x*r2%x + r1%y*r2%y + r1%z*r2%z
  end function

  function oprod( r1, r2 ) result(r)
    type(position), intent(in) :: r1, r2
    type(position) :: r

    r%x = r1%y*r2%z - r1%z*r2%y
    r%y = r1%z*r2%x - r1%x*r2%z
    r%z = r1%x*r2%y - r1%y*r2%x
  end function

  function length( r ) result(d)
    type(position), intent(in) :: r
    real(kind=DP) :: d

    d = sqrt(r%x*r%x + r%y*r%y + r%z*r%z) 
  end function

  function length2( r ) result(d)
    type(position), intent(in) :: r
    real(kind=DP) :: d

    d = (r%x*r%x + r%y*r%y + r%z*r%z) 
  end function

end module

! 遮蔽ポテンシャルモジュール
module m_Screening
  use m_Const_Parameters, only : DP
!  use m_PlaneWaveBasisSet, only : ngabc, kgp
  use m_Screening_FFT  ! 簡略化したPHASEのFFTモジュールを利用する
  use class_position
  implicit none

  ! 数学定数の設定
  real(kind=DP), parameter :: M_PI       = 3.14159265358979323846d0 ! 円周率
  real(kind=DP), parameter :: M_2_SQRTPI = 1.12837916709551257390d0 ! 2/sqrt(pi)

  ! 本モジュールで使用する変数群
  type Screening_param
     type(position) La, Lb, Lc ! 単位胞の格子ベクトル

     !---- PHASE変数のコピーを自前で持つ
     real(kind=DP), pointer, dimension(:,:) ::  ngabc ! PHASE変数

     real(kind=DP) Gmax ! カットオフ波数
     real(kind=DP) alpha ! 遮蔽ポテンシャルの遮蔽パラメタ
     real(kind=DP), dimension(:), pointer :: phik ! 遮蔽ポテンシャル
     integer Nk    ! 波数ベクトルの総数
  end type
  
  type(Screening_param) :: Screening

contains

  ! 遮蔽ポテンシャルを設定するサブルーチン
  subroutine setup_screening
    real(kind=DP)  V             ! 単位胞の体積
    type(position) dKa, dKb, dKc ! 逆格子の刻み
    integer        Na0, Nb0, Nc0 ! 格子点数
    integer        Na, Nb, Nc ! 格子点数
    type(position) dLa, dLb, dLc ! 実格子の刻み
    real(kind=DP)  dV            ! 実格子の刻み
    real(kind=DP)  r             ! 実空間の距離
    real(kind=DP)  kk            ! 逆格子ベクトルのノルム
    
    integer ia, ib, ic     ! 3次元格子点のインデックス
    integer ja, jb, jc     ! 3次元格子点のインデックス
    integer i, j           ! 1次元インデックス

    integer, dimension(3) :: n_rGpv ! FFTモジュールの初期化用の変数

    real(kind=DP),  allocatable, dimension(:) :: phir ! 実格子での値
    type(position), allocatable, dimension(:) :: K    ! 逆格子ベクトル

    ! 体積の計算
    V  = Screening%La .IPROD. ( Screening%Lb .OPROD. Screening%Lc )

    ! 逆格子の刻み幅の設定
    dKa = (Screening%Lb .OPROD. Screening%Lc) * (2.0d0*M_PI/V)
    dKb = (Screening%Lc .OPROD. Screening%La) * (2.0d0*M_PI/V)
    dKc = (Screening%La .OPROD. Screening%Lb) * (2.0d0*M_PI/V)

    ! PHASE変数の n_rGpv (逆格子点の数の概算値) と同じ値を自分で計算する。
    n_rGpv(1) = abs(Screening%Gmax/length(dKa)) + 1
    n_rGpv(2) = abs(Screening%Gmax/length(dKb)) + 1
    n_rGpv(3) = abs(Screening%Gmax/length(dKc)) + 1

    ! PHASE変数の fft_box_size_CD (逆格子点の数) と同じ値を自分で計算する。
    call m_Screening_FFT_set_box_sizes( n_rGpv, 1 )
    call m_Screening_FFT_setup( 1, .false. )

    ! 格子点の数の入手
    Na0 = fft_box_size_CD(1,0)
    Nb0 = fft_box_size_CD(2,0)
    Nc0 = fft_box_size_CD(3,0)
    Na = fft_box_size_CD(1,1)
    Nb = fft_box_size_CD(2,1)
    Nc = fft_box_size_CD(3,1)
    ! 実格子の刻み幅の設定
    dLa = Screening%La*(1.0d0/Na)
    dLb = Screening%Lb*(1.0d0/Nb)
    dLc = Screening%Lc*(1.0d0/Nc)
    dV  = dLa .IPROD. ( dLb .OPROD. dLc) ! ひとつの刻みの体積

    ! 実空間での遮蔽ポテンシャルの長距離成分を保存する配列変数を確保する
    allocate( phir(Na0*Nb0*Nc0) )

    ! 実空間での遮蔽ポテンシャルの長距離成分を設定するループ
    do ic = 0, Nc-1  !実空間の格子点でのループ
       do ib = 0, Nb-1 
          do ia = 0, Na-1
             ! 単位胞の8隅がポテンシャルの原点となるように座標を調整する
             if( 2*ia>Na ) then
                ja = ia-Na
             else
                ja = ia
             end if
             if( 2*ib>Nb ) then
                jb = ib-Nb
             else
                jb = ib
             end if
             if( 2*ic>Nc ) then
                jc = ic-Nc
             else
                jc = ic
             end if

             ! 最寄の隅からの距離
             r = length(dLa*dble(ja) + dLb*dble(jb) + dLc*dble(jc))

             ! 3次元の格子インデックスから1次元配列のインデックスへの変換
             i = (ic*Nb0+ib)*Na0 + (ia + 1)

             ! 実空間での遮蔽ポテンシャルの長距離成分の設定
             phir(i) = phirlong(r)

!             write(15,'(i5,2e15.5,6i5)') i,phir(i),r,ia,ib,ic,ja,jb,jc
!             write(17,'(5f10.6)') dLa%x*dble(ja), dLb%y*dble(jb), dLc%z*dble(jc), r, phir(i)

          end do
       end do
    end do

    ! 実空間での遮蔽ポテンシャルの長距離成分をフーリエ変換で逆空間に変換する
    call m_Screening_FFT_set_box_sizes( n_rGpv, 1 )
    call m_Screening_FFT_setup( 1, .false. )
    call m_Screening_FFT_alloc_CD_box
    call m_Screening_FFT_CD_inverse( 6, phir )
    call m_Screening_FFT_dealloc_CD_box


    ! 逆空間での遮蔽ポテンシャルを保存する配列変数を確保する
    allocate( K(Screening%Nk) )
    allocate( Screening%phik(Screening%Nk) )

    do j=1, Screening%Nk
       ja=Screening%ngabc(j,1)
       jb=Screening%ngabc(j,2)
       jc=Screening%ngabc(j,3)
       ! 逆格子点の波数ベクトルのノルムを計算する
       K(j) = dKa*dble(ja) + dKb*dble(jb) + dKc*dble(jc)
       kk = length2(K(j))

       ! 逆格子点のインデックスを少し変換する。
       if( jc < 0 ) then
          ic = jc + Nc
       else
          ic = jc
       end if
       if( jb < 0 ) then
          ib = jb + Nb
       else
          ib = jb
       end if
       if( ja < 0 ) then
          ia = -2*ja
       else
          ia = +2*ja
       end if
       ! 3次元の格子インデックスから1次元配列のインデックスへの変換
       i = (ic*Nb0+ib)*Na0 + (ia + 1)

       Screening%phik(j) = phir(i)*dV - phiklong(kk)

!       write(16,'(2i5,6e15.5,6i5)') j,i,Screening%phik(j), &
!            phir(i),dV,phir(i)*dV,phiklong(kk), sqrt(kk),&
!            ia,ib,ic,ja,jb,jc
!       write(18,'(6f10.6)') K(j)%x, K(j)%y, K(j)%z, kk, phir(i)*dV, phiklong(kk)
!       write(*,*) Screening%phik(j)
    end do
!    write (*,*) "Debug informations for the screening module"
!    write (*,*) "  Screening%Gmax = ", Screening%Gmax
!    write (*,*) "  n_rGpv() = ", n_rGpv(1), n_rGpv(2), n_rGpv(3)
!    write (*,*) "  N = ", Na, Nb, Nc
!    write (*,*) "  Screening%Nk = ", Screening%Nk
    ! 遮蔽ポテンシャルの値のテスト表示
!    write(*,*) "# i kx ky kz kk PhiK(i)"
!    do j=1, Screening%Nk
!       if( j>32 ) then
!          write(*,*) "omitted"
!          exit
!       end if
!       write(13,100) j, K(j)%x, K(j)%y, K(j)%z, length2(K(j)), Screening%phik(j)
!    end do

    deallocate( K )
    deallocate( phir )
    
100 format(i4,5f11.6)

    return
  end subroutine

  ! 実空間での遮蔽ポテンシャルの長距離成分を返す関数
  real(kind=DP) function phirlong( r ) 
    real(kind=DP) r
    real(kind=DP) derf ! 誤差関数

    if( r == 0.d0 ) then ! 原点は特別に対応する
       phirlong = Screening%alpha*M_2_SQRTPI
    else
       phirlong = derf(Screening%alpha*r)/r
    end if
  end function

  ! 逆空間での遮蔽ポテンシャルの長距離成分を返す関数
  real(kind=DP) function phiklong( kk ) 
    real(kind=DP) kk

    if( kk == 0.d0 ) then ! 原点は特別に対応する
       phiklong = -M_PI/(Screening%alpha*Screening%alpha)
    else
       phiklong = 4.0d0*M_PI/kk*exp(-kk/(4.0d0*Screening%alpha*Screening%alpha))
    end if
  end function

end module

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 576 $)
!
!  MODULE: m_Electronic_Structure
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, April/15/2006, September/02/2008
!  FURTHER MODIFICATION: T. Yamasaki, T. Uda and T. Ohno, September 2009 (MGS_DGEMM)
!  FURTHER MODIFICATION: T. Yamasaki and T. Yamamoto,   October 2009  (NONLOCAL_DGEMM)
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

!   This module has been revised for the GAMMA point (k=(0,0,0)) by T. Yamasaki
!  in April 2006. Number of operations for the Gamma point have been tremendously
!  reduced in subroutines of m_ES_betar_dot_Wfs, m_ES_Vnonlocal_W, and
!  m_ES_modified_gram_schmidt.
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif
#ifdef __TIMER_DGEMM__
#   define __TIMER_DGEMM_START(a)  call timer_sta(a)
#   define __TIMER_DGEMM_STOP(a)   call timer_end(a)
#else
#   define __TIMER_DGEMM_START(a)
#   define __TIMER_DGEMM_STOP(a)
#endif

!  2010.03
!  the performance of the Gram-Schmidt orthonormalization procedure
!  has been tuned through a joint effort with RIKEN.

#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_MGS_DGEMM
#define MGS_DGEMM
#endif

module m_ES_ortho
  use m_Control_Parameters, only : nspin,ipri,kimg, neg, printable, af &
       &                         , m_CtrlP_cachesize &
       &                         , sw_gep & 
#ifdef SAVE_FFT_TIMES
       &                         , nblocksize_mgs, nblocksize_mgs_is_given, sw_save_fft
#else
       &                         , nblocksize_mgs, nblocksize_mgs_is_given
#endif
  use m_Const_Parameters,   only : DP, EXECUT, ON, OFF, DELTA, PAI2 &
       &                         , ORTHOGONALIZATION, ORTHONORMALIZATION, NORMALIZATION &
       &                         , NORMCONSERVATION, VDB, VANDERBILT_TYPE &
       &                         , OTHER_BANDS, SAME_BAND, GAMMA, OLD
  use m_Electronic_Structure,only: zaj_l, neordr, nrvf_ordr, fsr_l, fsi_l &
#ifdef SAVE_FFT_TIMES
 &                                , status_saved_phifftr &
#endif
       &                         , nblocksize_mgs_default
  use m_Files,              only : nfout
  use m_Kpoints,            only : kv3,k_symmetry
  use m_Parallelization,    only : mpi_comm_group,npes,mype &
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,ista_k,iend_k &
       &                         , ierr,mp_e,nis_e,nie_e,nel_e &
       &                         , ista_g1k,iend_g1k,np_g1k,mp_g1k,nis_g1k,nel_g1k &
       &                         , np_fs, mp_fs, ista_fs, iend_fs, nis_fs, nie_fs, nel_fs  &
       &                         , myrank_g, nrank_g &
       &                         , is_ffth, ista_ffth, nel_ffth, np_ffth, mp_ffth, neg_g_all
  use m_PlaneWaveBasisSet,  only : kg1,kg,iba
  use m_PseudoPotential,    only : nlmt,nlmta,lmta,lmtt,ltp,q &
       &                         , modnrm,nac,fqwei,nlmta1,nlmta2 &
       &                         , nac_p, fqwei_p, nlmta1_p, nlmta2_p
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Electronic_Structure, only : fsr_l_2D, fsi_l_2D           &
 &                                 , fsr_ball, fsi_ball, zaj_ball           &
 &                                 , m_ES_wd_zaj_small_portion_3D
  use m_ES_nonlocal,          only : m_ES_betar_dot_WFs_4_each_k_3D
  use m_Parallelization,      only : lrank, nbsn, nbsn_sta, nbsn_end, neg_g           &
 &                                 , nbs_num, nbsn_num, nbs_sta, nbs_end              &
 &                                 , mpi_kg_world, mpi_ke_world           &
 &                                 , map_k                   &
 &                                 , mp_kngp, is_kngp, ie_kngp, np_kngp, nel_kngp     

! ================================ added by K. Tagami ================ 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor
  use m_PseudoPotential,      only : fqwei_noncl, fqwei_p_noncl
! ==================================================================== 11.0

  implicit none

  integer, private, parameter                         :: sw_timing_2ndlevel = ON

  integer                                             :: np_g1k_x     ! np_g1k_x = np_g1k(ik) | np_g1k(ik)+1
  real(kind=DP),private,allocatable,target,dimension(:,:,:)  :: psi_t  ! d(np_g1k_x,neg,kimg) a work_array for mgs
  real(kind=DP),private,allocatable,dimension(:,:)    :: p1Sp2
  integer                                             :: np_fs_x      ! np_fs_x = np_fs | np_fs+1
  real(kind=DP),private,allocatable,dimension(:,:)    :: bpr_t, bpi_t ! d(np_fs_x,neg) work arrays for mgs
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
  real(kind=DP),private,allocatable,dimension(:)      :: psi_ii,psi_ir
  real(kind=DP),private,allocatable,dimension(:)      :: bp_ii,bp_ir
#endif
#ifdef MGS_DGEMM
!-$ tune FUJITSU for block ----->>
  real(kind=DP),private,allocatable,dimension(:,:)    :: bpr_tw1, bpr_tw2, bpi_tw1, bpi_tw2 ! d(nac_p,neg) work arrays for mgs
  integer,private                                     :: NB
#ifdef SX
  integer,private                                     :: MB, LMB
#endif
! <--
!-$ tune FUJITSU for block <<-----
#endif
! <--

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

! ============================= added by K. Tagami ================ 11.0
  real(kind=DP), private, allocatable, target :: psi_t_noncl(:,:,:,:)
  real(kind=DP), private, allocatable :: bpr_t_noncl(:,:,:)
  real(kind=DP), private, allocatable :: bpi_t_noncl(:,:,:)
  
#ifdef MGS_DGEMM
  real(kind=DP), private, allocatable :: bpr_tw1_noncl(:,:,:)
  real(kind=DP), private, allocatable :: bpr_tw2_noncl(:,:,:)
  real(kind=DP), private, allocatable :: bpi_tw1_noncl(:,:,:)
  real(kind=DP), private, allocatable :: bpi_tw2_noncl(:,:,:)
#endif
! ================================================================= 11.0

contains
!  1-18. m_ESortho_mgs_alloc
!        - mgs_vdb_alloc, - mgs_nrc_alloc
!  1-19. m_ESortho_mgs_dealloc
!        - mgs_vdb_dealloc, - mgs_nrc_dealloc
!  2-28. m_ES_modified_gram_schmidt
!  2-29. m_ES_orthogonalize_SD_to_WFs -> (2-30)
!  2-30. mgs_sd2wf_each_k_G           <- (2-29)  -> (2-34), (2-44)
!        - broadcast_fs, - Psi1SPhi2_t, - modify_bsd_and_phi_t, - alloc_phi_w_and_brd_w
!        - dealloc_phi_w_and_brd_w, - WSW, - normalize_bsd_and_phi, - Psi1SPhi2
!        - modify_bsd_and_phi
!  2-31. orthogonalize_SD             -> (2-33)
!  2-32. m_ES_MGS_4_each_k            -> (2-17), (2-33)
!        - wd_title_of_the_operation
!  2-33. mgs_4_each_k_G               <- (2-31), (2-32)  -> (2-34), (2-44)
!        - WSW_t, - normalize_bp_and_psi_t, - W1SW2_t_r
!        - modify_bp_and_psi_t_r, - substitute_jto_ib2back, - W1SW2_t
!        - modify_bp_and_psi_t, - alloc_and_brd_w, - dealloc_and_brd_w
!        - WSW, - normalize_bp_and_psi, - W1SW2, - modify_bp_and_psi
!  2-34. set_npzri                    <- (2-30), (2-33)
!  2-37. m_ES_W_transpose_back2
!  2-38. m_ES_W_transpose_r
!  2-39. m_ES_W_transpose_back_r
!  2-42. m_ES_F_transpose_r
!  2-43. m_ES_F_transpose_back_r
!   2-44. m_ES_F_transpose_r_3D
!   2-45. m_ES_F_transpose_back_r_3D
!   2-46. m_ES_W_transpose_r_3D
!   2-47. m_ES_W_transpose_back_r_3D

!  2-44. cp_bp_and_psi_2_brd_w2      <- (2-30), (2-33)

#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif


  subroutine m_ESortho_set_np_g1k_x(ik)
    integer, intent(in) :: ik
!   OUTPUT : np_g1k_x
!
!!$    np_g1k_x = np_g1k(ik) + 1
    np_g1k_x = np_g1k(ik)
  end subroutine m_ESortho_set_np_g1k_x

  subroutine m_ESortho_set_np_fs_x()
!!$    np_fs_x = np_fs + 1
    np_fs_x = np_fs
  end subroutine m_ESortho_set_np_fs_x
      
  subroutine m_ESortho_mgs_alloc(ik)
    integer, intent(in) :: ik
    call m_ESortho_set_np_g1k_x(ik) ! -> np_g1k_x
!!$    call set_np_g1k_x() ! -> np_g1k_x

    if(modnrm == EXECUT) then
       call m_ESortho_set_np_fs_x() ! -> np_fs_x
!!$       call set_np_fs_x() ! -> np_fs_x
! ============================== modified by K. Tagami ============= 11.0
!       call mgs_vdb_alloc
       call mgs_vdb_alloc(np_e)
! =================================================================== 11.0
    else
! ============================== modified by K. Tagami ============= 11.0
!       call mgs_nrc_alloc
       call mgs_nrc_alloc(np_e)
! ===================================================================== 11.0
    end if
  contains
!!$    subroutine set_np_g1k_x()
!!$!   OUTPUT : np_g1k_x
!!$!
!!$!BRANCH_P ORG_Parallel
!!$#ifdef _ODD_BOUNDARY_
!!$      if(mod(np_g1k(ik),2) == 0) then
!!$         np_g1k_x = np_g1k(ik) + 1
!!$      else
!!$         np_g1k_x = np_g1k(ik)
!!$      end if
!!$#else
!!$!BRANCH_P_END ORG_Parallel
!!$      np_g1k_x = np_g1k(ik) + 1
!!$!BRANCH_P ORG_Parallel
!!$#endif
!!$!BRANCH_P_END ORG_Parallel
!!$    end subroutine set_np_g1k_x
!!$
!!$    subroutine set_np_fs_x()
!!$
!!$!BRANCH_P ORG_Parallel
!!$#ifdef _ODD_BOUNDARY_
!!$      if(mod(np_fs,2) == 0) then
!!$         np_fs_x = np_fs+1
!!$      else
!!$         np_fs_x = np_fs
!!$      end if
!!$#else
!!$!BRANCH_P_END ORG_Parallel
!!$      np_fs_x = np_fs + 1
!!$!BRANCH_P ORG_Parallel
!!$#endif
!!$!BRANCH_P_END ORG_Parallel
!!$    end subroutine set_np_fs_x

! ============================== added by K. Tagami ================== 11.0
    subroutine mgs_vdb_alloc(neg)
      integer,intent(in) :: neg
      integer :: kimg_t

      allocate(psi_t(np_g1k_x,neg,kimg))

#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      allocate(psi_ir(np_g1k_x))
      if(kimg == 2) allocate(psi_ii(np_g1k_x))
      if(np_g1k(ik) < np_g1k_x) then
         psi_ir(np_g1k_x) = 0.d0
         if(kimg==2) psi_ii(np_g1k_x) = 0.d0
      end if
#endif

      if((k_symmetry(ik) == GAMMA .and. kimg == 2) .or. kimg==1) then
         kimg_t = 1
      else
         kimg_t = 2
      end if
      allocate(p1Sp2(neg,kimg_t))

      if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
         kimg_t = 1
      else
         kimg_t = 2
      end if


      if(kimg_t == 1) then
         allocate(bpr_t(np_fs_x,neg))
         allocate(bpi_t(1,1))
#ifdef MGS_DGEMM
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
         if(nac_p > 0) then
!  =============================================================================
         allocate(bpr_tw1(nac_p,neg))
         allocate(bpr_tw2(nac_p,neg))
         allocate(bpi_tw1(1,1))
         allocate(bpi_tw2(1,1))
         bpr_tw1 = 0.0
         bpr_tw2 = 0.0
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
         end if
!  =============================================================================
#endif
      else
         allocate(bpr_t(np_fs_x,neg))
         allocate(bpi_t(np_fs_x,neg))
#ifdef MGS_DGEMM
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
         if(nac_p > 0) then
!  =============================================================================
         allocate(bpr_tw1(nac_p,neg))
         allocate(bpr_tw2(nac_p,neg))
         allocate(bpi_tw1(nac_p,neg))
         allocate(bpi_tw2(nac_p,neg))
         bpr_tw1 = 0.0
         bpr_tw2 = 0.0
         bpi_tw1 = 0.0
         bpi_tw2 = 0.0
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
         end if
!  =============================================================================
#endif
      end if

#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      allocate(bp_ir(np_g1k_x))
      if(kimg_t == 2) allocate(bp_ii(np_g1k_x))
!!$      allocate(bp_ii(np_g1k_x))
      if(np_g1k(ik) < np_g1k_x) then
         bp_ir(np_g1k(ik)+1:np_g1k_x) = 0.d0
!!$         if(kimg==2) bp_ii(np_g1k_x) = 0.d0
         if(kimg_t == 2) bp_ii(np_g1k(ik)+1:np_g1k_x) = 0.d0
!!$         bp_ii(np_g1k(ik)+1:np_g1k_x) = 0.d0
      end if
#endif
    end subroutine mgs_vdb_alloc


    subroutine mgs_nrc_alloc(neg)
      integer,intent(in) :: neg
      integer :: kimg_t
      allocate(psi_t(np_g1k_x,neg,kimg))
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      allocate(psi_ir(np_g1k_x))
      if(kimg==2) allocate(psi_ii(np_g1k_x))
      if(np_g1k(ik) < np_g1k_x) then
         psi_ir(np_g1k_x) = 0.d0
         if(kimg==2) psi_ii(np_g1k_x) = 0.d0
      end if
#endif

      if((k_symmetry(ik) == GAMMA .and. kimg == 2).or.kimg==1) then
         kimg_t = 1
      else
         kimg_t = 2
      end if
      allocate(p1Sp2(neg,kimg_t))
    end subroutine mgs_nrc_alloc
  end subroutine m_ESortho_mgs_alloc


  subroutine m_ESortho_mgs_dealloc()
    if(modnrm == EXECUT) then
! ================================ modified by K. Tagami ========== 11.0
!!       call mgs_vdb_dealloc()
!
       if ( noncol ) then
         call mgs_vdb_dealloc_noncl()
       else
         call mgs_vdb_dealloc()
       endif
! ================================================================= 11.0
    else
! ================================ modified by K. Tagami ========== 11.0
!       call mgs_nrc_dealloc()

       if ( noncol ) then
          call mgs_nrc_dealloc_noncl()
       else
          call mgs_nrc_dealloc()
       endif
! ==================================================================== 11.0
    end if
  contains
    subroutine mgs_vdb_dealloc()
      deallocate(bpr_t)
#ifdef MGS_DGEMM
! === Debug by Intel "-check all" option! by T.Kato 2013/07/02 =================
!     deallocate(bpr_tw1)
!     deallocate(bpr_tw2)
      if(allocated(bpr_tw1)) deallocate(bpr_tw1)
      if(allocated(bpr_tw2)) deallocate(bpr_tw2)
!  =============================================================================
#endif
      if(allocated(bpi_t)) deallocate(bpi_t)
#ifdef MGS_DGEMM
      if(allocated(bpi_tw1)) deallocate(bpi_tw1)
      if(allocated(bpi_tw2)) deallocate(bpi_tw2)
#endif
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      deallocate(psi_ir)
      if(kimg == 2) deallocate(psi_ii)
#endif
      deallocate(psi_t)
      deallocate(p1Sp2)
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      if(allocated(bp_ir)) deallocate(bp_ir)
      if(allocated(bp_ii)) deallocate(bp_ii)
#endif
    end subroutine mgs_vdb_dealloc

! ============================= added by K. Tagami ================= 11.0
    subroutine mgs_vdb_dealloc_noncl()
      deallocate(bpr_t_noncl)
#ifdef MGS_DGEMM
      deallocate(bpr_tw1_noncl)
      deallocate(bpr_tw2_noncl)
#endif
      if(allocated(bpi_t_noncl)) deallocate(bpi_t_noncl)
#ifdef MGS_DGEMM
      if(allocated(bpi_tw1_noncl)) deallocate(bpi_tw1_noncl)
      if(allocated(bpi_tw2_noncl)) deallocate(bpi_tw2_noncl)
#endif
      deallocate(psi_t_noncl)
      deallocate(p1Sp2)
!!$#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
!!$      if(mod_pot == VANDERBILT_TYPE) then
!!$         if(allocated(bp_ir)) deallocate(bp_ir)
!!$         if(allocated(bp_ii)) deallocate(bp_ii)
!!$      end if
!!$#endif
    end subroutine mgs_vdb_dealloc_noncl
! ================================================================= 11.0

    subroutine mgs_nrc_dealloc()
#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
      deallocate(psi_ir)
      if(kimg == 2) deallocate(psi_ii)
#endif
      deallocate(psi_t)
      deallocate(p1Sp2)
    end subroutine mgs_nrc_dealloc

! ============================== added by K. Tagami =============== 11.0
    subroutine mgs_nrc_dealloc_noncl()
      deallocate(psi_t_noncl)
      deallocate(p1Sp2)
    end subroutine mgs_nrc_dealloc_noncl
! ================================================================== 11.0

  end subroutine m_ESortho_mgs_dealloc

  subroutine m_ES_modified_gram_schmidt(nfout)
  use m_IterationNumbers,     only : iteration
    integer, intent(in) :: nfout
    integer :: ik

    do ik = ista_k, iend_k, af+1                            ! MPI
       if(ipri>=2) call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- before GS --",16)

       if(sw_gep == OFF .or. iteration<2)then
          call m_ES_MGS_4_each_k(nfout,ik,mode=ORTHONORMALIZATION)
       else
          call m_ES_MGS_4_each_k(nfout,ik,mode=NORMALIZATION)
       endif
       !    ~~~~~~~~~~~~~~~~~~~~~~
       if(ipri>=2) call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- after GS --",15)

    end do

  end subroutine m_ES_modified_gram_schmidt

!!$!BRANCH_P 3D_Parallel
!!$  subroutine m_ES_modified_gram_schmidt_3D(nfout)
!!$    integer, intent(in) :: nfout
!!$    integer :: ik
!!$
!!$    do ik = ista_k, iend_k, af+1                            ! MPI
!!$       if(ipri>=2) call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- before GS --",16)
!!$
!!$       call m_ES_MGS_4_each_k(nfout,ik,mode=ORTHONORMALIZATION)
!!$       !    ~~~~~~~~~~~~~~~~~~~~~~
!!$       if(ipri>=2) call m_ES_wd_zaj_small_portion_3D(nfout,ik," -- after GS --",15)
!!$    end do
!!$
!!$  end subroutine m_ES_modified_gram_schmidt_3D
!!$!BRANCH_P_END 3D_Parallel

  subroutine m_ES_orthogonal_phi_to_WFs(ik,wfsd_l,bsdr_l,bsdi_l)
    integer, intent(in)                                     :: ik
    real(kind=DP),intent(inout),dimension(kg1,np_e,ik:ik,kimg) :: wfsd_l
    real(kind=DP),intent(inout),dimension(np_e,nlmta,ik:ik)    :: bsdr_l,bsdi_l

    integer  :: id_sname = -1, id_sname2 = -1

    call tstatc0_begin('m_ES_orthogonal_phi_to_WFs ',id_sname,1)

    call tstatc0_begin('mpi_barrier(ortho_phi_to_WFs) ',id_sname2)
    call mpi_barrier(mpi_k_world(myrank_k),ierr)
    call tstatc0_end(id_sname2)

    if(modnrm == EXECUT) then
       call mgs_phi2wf_each_k_G(ik,wfsd_l,ORTHOGONALIZATION,bsdr_l,bsdi_l,mod_pot=VDB)
    else
       call mgs_phi2wf_each_k_G(ik,wfsd_l,ORTHOGONALIZATION,mod_pot=NORMCONSERVATION)
    end if

    call tstatc0_end(id_sname)
  end subroutine m_ES_orthogonal_phi_to_WFs

  subroutine m_ES_orthogonalize_SD_to_WFs_3D(ik,to_which_band,wfsd_l,bsdr_l,bsdi_l)
    integer, intent(in)                                     :: ik,to_which_band
    real(kind=DP),intent(inout),dimension(maxval(np_g1k),np_e,ik:ik,kimg) :: wfsd_l
    real(kind=DP),intent(inout),dimension(np_e,nlmta,ik:ik)    :: bsdr_l,bsdi_l

    integer  :: id_sname = -1
    call tstatc0_begin('m_ES_orthogonalize_SD_to_WFs_3D ',id_sname)

!!$    call phi_alloc(ik)
!!$    call m_ES_mgs_alloc(ik)
    if(modnrm == EXECUT) then
       call mgs_sd2wf_each_k_G_3D(ik,to_which_band,wfsd_l,bsdr_l,bsdi_l,mod_pot=VDB)
    else
       call mgs_sd2wf_each_k_G_3D(ik,to_which_band,wfsd_l,mod_pot=NORMCONSERVATION)
    end if
    ! -(m_E.S.)   ->wfsd_l,bsdr_l,bsdi_l!!$    if(ik == iend_k) call phi_dealloc()    !-(m_E.S.)
!!$    call m_ES_mgs_dealloc

!!$    if(ik == iend_k) call phi_dealloc()    !-(m_E.S.)

    call tstatc0_end(id_sname)
  end subroutine m_ES_orthogonalize_SD_to_WFs_3D


  subroutine mgs_sd2wf_each_k_G_3D(ik,to,phi_l,bsdr_l,bsdi_l,mod_pot)
    integer, intent(in)             :: ik,to
    real(kind=DP), intent(inout)    :: phi_l(maxval(np_g1k),np_e,ik:ik,kimg)
    real(kind=DP), optional,intent(inout), dimension(np_e,nlmta,ik:ik) :: bsdr_l,bsdi_l
    integer, intent(in)             :: mod_pot
    integer               :: i

    integer :: kimg_t
    real(kind=DP),allocatable,dimension(:,:)    :: bp_w
#ifndef ZAJ_BALL_ALLREDUCE
! ==============================================================================
    real(kind=DP), allocatable, dimension(:,:,:)   :: wk_zaj !d(max_g1k,mp_e,kimg)
!!$    real(kind=DP), allocatable, dimension(:,:,:,:) :: wk_mpi

    integer :: max_g1k
    integer :: ierr, nb,kb, jb, ib

    if(nrank_e == 1) then
       zaj_ball(:,:,ik,:) = zaj_l(:,:,ik,:)
    else
       max_g1k = maxval(np_g1k(:))
       allocate(wk_zaj(max_g1k,mp_e,kimg),stat=ierr)
       do nb = 0, nrank_e-1
          if(nb == myrank_e) then
             do kb = 1, kimg
                do jb = 1, np_e
                   wk_zaj(:,jb,kb) = zaj_l(ib,jb,ik,kb)
                end do
             end do
             if(np_e+1 < mp_e) wk_zaj(:,np_e+1:mp_e,:) = 0.d0
          end if
          call mpi_bcast(wk_zaj,max_g1k*mp_e*kimg,mpi_double_precision,nb,mpi_kg_world,ierr)
          do kb = 1, kimg
             do jb = nis_e(nb), nie_e(nb)
                do ib = 1, np_g1k(ik)
                   zaj_ball(ib,jb,ik,kb) = wk_zaj(ib,jb-nis_e(nb)+1,kb)
                end do
             end do
          end do
       end do
       deallocate(wk_zaj)
!!$       max_g1k = maxval(np_g1k(:))
!!$       allocate(wk_zaj(max_g1k,mp_e,kimg),stat=ierr); wk_zaj = 0.d0
!!$       allocate(wk_mpi(max_g1k,mp_e,kimg,0:nrank_e-1),stat=ierr)
!!$       do kb = 1, kimg
!!$          do jb = 1, np_e
!!$             do ib = 1, np_g1k(ik)
!!$                wk_zaj(ib,jb,kb) = zaj_l(ib,jb,ik,kb)
!!$             end do
!!$          end do
!!$       end do
!!$       call mpi_allgather(wk_zaj, max_g1k*mp_e*kimg, MPI_DOUBLE_PRECISION &
!!$            &            ,wk_mpi, max_g1k*mp_e*kimg, MPI_DOUBLE_PRECISION, mpi_kg_world, ierr )
!!$       deallocate(wk_zaj)
!!$
!!$       do nb = 0, nrank_e-1
!!$          do kb = 1, kimg
!!$             do jb = nis_e(nb), nie_e(nb)
!!$                do ib = 1, np_g1k(ik)
!!$                   zaj_ball(ib,jb,ik,kb) = wk_mpi(ib,jb-nis_e(nb)+1,kb,nb)
!!$                end do
!!$             end do
!!$          end do
!!$       end do
!!$       deallocate(wk_mpi)
    end if
! ==============================================================================
#else
! ==============================================================================
    real(kind=DP) :: wk1(maxval(np_g1k),neg,kimg)
    integer :: ierr
    if(nrank_e == 1) then
       zaj_ball(:,:,ik,:) = zaj_l(:,:,ik,:)
    else
       wk1 = 0.0d0
       do i = 1, np_e
          wk1(:,neg_g(i),:) = zaj_l(:,i,ik,:)
       end do
       call mpi_allreduce(MPI_IN_PLACE,wk1,maxval(np_g1k)*neg*kimg &
            &            ,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
       do i = 1, neg
          zaj_ball(:,i,ik,:) = wk1(:,i,:)
       end do
    end if
! ==============================================================================
#endif

    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = 2
    end if
    allocate(p1Sp2(np_e,kimg_t))
    allocate(bp_w(nlmta,kimg_t))

    do i = 1, neg
       if(mod_pot == VDB) call broadcast_fs(i)  ! (fs(ri)_l(i,*,ik)-> bp_w
       call Psi1SPhi2_t(ik,i)                      ! -(contained here) -> p1Sp2
       call modify_bsd_and_phi_t(i)                ! -(c.h.) p1Sp2,phi_t -> bsd(ri),phi_t
    end do

    deallocate(p1Sp2)
    deallocate(bp_w)
  contains
#if 0
    subroutine broadcast_fs(io)
      integer, intent(in) :: io
      integer  :: ia, i, kimg_t

      i = map_z(io) ! MPI
      if(k_symmetry(ik) == GAMMA) then
         kimg_t = 1
      else
         kimg_t = 2
      end if

      if(map_e(io) == myrank_e) then ! MPI
         if(k_symmetry(ik) == GAMMA) then
            do ia = 1, nlmta
               bp_w(ia,1) = fsr_l_2D(i,ia)
            end do
         else
            do ia = 1, nlmta
               bp_w(ia,1) = fsr_l_2D(i,ia)
               bp_w(ia,2) = fsi_l_2D(i,ia)
            end do
         end if
      end if ! MPI
      call mpi_bcast(bp_w,nlmta*kimg_t,mpi_double_precision,map_e(io),mpi_kg_world,ierr) ! MPI
    end subroutine broadcast_fs
#else
    subroutine broadcast_fs(io)
      integer, intent(in) :: io
      integer  :: ia, i, kimg_t
      integer :: sendcount, recvcounts(0:nrank_g-1), displs(0:nrank_g-1)
      real(kind=DP),allocatable,dimension(:,:) :: sendbuf
      sendcount = np_fs
      do i = 0, nrank_g - 1
         recvcounts(i) = nel_fs(i)
         displs(i)     = nis_fs(i) - 1
      enddo

      i = map_z(io) ! MPI
      if(k_symmetry(ik) == GAMMA) then
         kimg_t = 1
      else
         kimg_t = 2
      end if
      allocate(sendbuf(np_fs,kimg_t))

      if(map_e(io) == myrank_e) then ! MPI
         if(k_symmetry(ik) == GAMMA) then
            do ia = 1, np_fs
               sendbuf(ia,1) = fsr_l(i,ia,ik)
            end do
            call mpi_allgatherv(sendbuf(1,1),sendcount,        MPI_DOUBLE_PRECISION, &
                                bp_w(1,1),   recvcounts,displs,MPI_DOUBLE_PRECISION,mpi_ke_world,ierr)
         else
            do ia = 1, np_fs
               sendbuf(ia,1) = fsr_l(i,ia,ik)
               sendbuf(ia,2) = fsi_l(i,ia,ik)
            end do
            call mpi_allgatherv(sendbuf(1,1),sendcount,        MPI_DOUBLE_PRECISION, &
                                bp_w(1,1),   recvcounts,displs,MPI_DOUBLE_PRECISION,mpi_ke_world,ierr)
            call mpi_allgatherv(sendbuf(1,2),sendcount,        MPI_DOUBLE_PRECISION, &
                                bp_w(1,2),   recvcounts,displs,MPI_DOUBLE_PRECISION,mpi_ke_world,ierr)
         end if
      end if ! MPI
      call mpi_bcast(bp_w,nlmta*kimg_t,mpi_double_precision,map_e(io),mpi_kg_world,ierr) ! MPI
      deallocate(sendbuf)
    end subroutine broadcast_fs
#endif
    subroutine Psi1SPhi2_t(ik,i)
      integer, intent(in) :: ik,i

      real(kind=DP),allocatable,dimension(:,:)  :: p1Sp2_w

      integer   :: j,ia,p,q, kimg_t, iadd
      real(DP)  :: ar,ai

!!    DEBUG asms
!!    if((k_symmetry(1) == GAMMA .and. kimg == 2).or.kimg==1) then
      if((k_symmetry(ik) == GAMMA .and. kimg == 2).or.kimg==1) then
         kimg_t = 1
      else
         kimg_t = 2
      end if

      if(mod_pot == VANDERBILT_TYPE) then
         allocate(p1Sp2_w(np_e,kimg_t))
      end if

      p1Sp2 = 0.d0
      if(mod_pot == VANDERBILT_TYPE) then
         do j = 1, np_e ! MPI
            if(to == OTHER_BANDS .and. neg_g(j) == i) cycle ! MPI
            if(to == SAME_BAND .and. neg_g(j) /= i) cycle
            ar = 0.d0; if(kimg == 2) ai = 0.d0
            if(kimg == 1) then
               do ia = 1, nac
                  p = nlmta1(ia);      q = nlmta2(ia)
                  ar = ar + fqwei(ia)*(bp_w(p,1)*bsdr_l(j,q,ik) + bp_w(p,2)*bsdi_l(j,q,ik))
               end do
               p1Sp2(j,1) = ar
            else if(kimg == 2) then
               if(k_symmetry(ik) == GAMMA) then
                  do ia = 1, nac
                     p = nlmta1(ia);      q = nlmta2(ia)
                     ar = ar + fqwei(ia)*(bp_w(p,1)*bsdr_l(j,q,ik))
                  end do
                  p1Sp2(j,1) = ar
               else
                  do ia = 1, nac
                     p = nlmta1(ia);      q = nlmta2(ia)
                     ar = ar + fqwei(ia)*(bp_w(p,1)*bsdr_l(j,q,ik) + bp_w(p,2)*bsdi_l(j,q,ik))
                     ai = ai + fqwei(ia)*(bp_w(p,1)*bsdi_l(j,q,ik) - bp_w(p,2)*bsdr_l(j,q,ik))
                  end do
                  p1Sp2(j,1) = ar; p1Sp2(j,2) = ai
               end if
            end if
         end do
         p1Sp2_w = p1Sp2
         p1Sp2 = 0.d0
      end if

      do j = 1, np_e
         if(to == OTHER_BANDS .and. neg_g(j) == i) cycle
         if(to == SAME_BAND .and. neg_g(j) /= i) cycle
         if(kimg == 1) then
            do ia = ista_g1k(ik), iend_g1k(ik)
               iadd = ia - ista_g1k(ik) + 1
               p1Sp2(j,1) = p1Sp2(j,1) + zaj_ball(iadd,i,ik,1)*phi_l(iadd,j,ik,1)
            end do
            call mpi_allreduce(MPI_IN_PLACE,p1Sp2(j,1),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               do ia = max(2,ista_g1k(ik)), iend_g1k(ik)
                  iadd = ia - ista_g1k(ik) + 1
                  ar = zaj_ball(iadd,i,ik,1)
                  ai = zaj_ball(iadd,i,ik,2)
                  p1Sp2(j,1) = p1Sp2(j,1) + (ar*phi_l(iadd,j,ik,1) + ai*phi_l(iadd,j,ik,2))*2.d0
               end do
               if(ista_g1k(ik) == 1) then
! ==== DEBUG by tkato 2011/09/03 ===============================================
!                 p1Sp2(j,1) = p1Sp2(j,1) + zaj_ball(1,i,ik,1)*zaj_ball(1,neg_g(j),ik,1)
                  p1Sp2(j,1) = p1Sp2(j,1) + zaj_ball(1,i,ik,1)*phi_l(1,j,ik,1)
! ==============================================================================
               endif
               call mpi_allreduce(MPI_IN_PLACE,p1Sp2(j,1),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            else
               do ia = ista_g1k(ik), iend_g1k(ik)
                  iadd = ia - ista_g1k(ik) + 1
                  ar = zaj_ball(iadd,i,ik,1)
                  ai = zaj_ball(iadd,i,ik,2)
                  p1Sp2(j,1) = p1Sp2(j,1) + ar*phi_l(iadd,j,ik,1) + ai*phi_l(iadd,j,ik,2)
                  p1Sp2(j,2) = p1Sp2(j,2) + ar*phi_l(iadd,j,ik,2) - ai*phi_l(iadd,j,ik,1)
               end do
               call mpi_allreduce(MPI_IN_PLACE,p1Sp2(j,1),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
               call mpi_allreduce(MPI_IN_PLACE,p1Sp2(j,2),1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            end if
         end if
      end do
      if(mod_pot == VANDERBILT_TYPE) then                                ! MPI
         p1Sp2 = p1Sp2_w + p1Sp2                                         ! MPI
      endif

      if(mod_pot == VANDERBILT_TYPE) then
         deallocate(p1Sp2_w)
      end if

    end subroutine Psi1SPhi2_t

    subroutine modify_bsd_and_phi_t(i)
      integer, intent(in) :: i

      integer             :: j, ia, iadd
      real(DP)            :: sr, si

      if(mod_pot == VANDERBILT_TYPE) then
         do j = 1, np_e ! MPI
            if(to == OTHER_BANDS .and. neg_g(j) == i) cycle
            if(to == SAME_BAND .and. neg_g(j) /= i) cycle
            if(kimg == 1) then
               do ia = 1, nlmta
                  bsdr_l(j,ia,ik) = bsdr_l(j,ia,ik)-p1Sp2(j,1)*bp_w(ia,1)
                  bsdi_l(j,ia,ik) = bsdi_l(j,ia,ik)-p1Sp2(j,1)*bp_w(ia,2)
               end do
            else if(kimg == 2) then
               if(k_symmetry(ik) == GAMMA) then
                  do ia = 1, nlmta
                     sr = bp_w(ia,1)
                     bsdr_l(j,ia,ik) = bsdr_l(j,ia,ik)-p1Sp2(j,1)*sr
                  end do
               else
                  do ia = 1, nlmta
                     sr = bp_w(ia,1);  si = bp_w(ia,2)
                     bsdr_l(j,ia,ik) = bsdr_l(j,ia,ik)-p1Sp2(j,1)*sr+p1Sp2(j,2)*si
                     bsdi_l(j,ia,ik) = bsdi_l(j,ia,ik)-p1Sp2(j,1)*si-p1Sp2(j,2)*sr
                  end do
               end if
            end if
         end do
      end if

      do j = 1, np_e
         if(to == OTHER_BANDS .and. neg_g(j) == i) cycle
         if(to == SAME_BAND .and. neg_g(j) /= i) cycle
         if(kimg == 1) then
            do ia = ista_g1k(ik), iend_g1k(ik)
               iadd = ia - ista_g1k(ik) + 1
               phi_l(iadd,j,ik,1) = phi_l(iadd,j,ik,1) - p1Sp2(j,1)*zaj_ball(iadd,i,ik,1)
            end do
         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               do ia = ista_g1k(ik), iend_g1k(ik)
                  iadd = ia - ista_g1k(ik) + 1
                  sr = zaj_ball(iadd,i,ik,1) ;  si = zaj_ball(iadd,i,ik,2)
                  phi_l(iadd,j,ik,1) = phi_l(iadd,j,ik,1) - p1Sp2(j,1)*sr
                  phi_l(iadd,j,ik,2) = phi_l(iadd,j,ik,2) - p1Sp2(j,1)*si
               end do
            else
               do ia = ista_g1k(ik), iend_g1k(ik)
                  iadd = ia - ista_g1k(ik) + 1
                  sr = zaj_ball(iadd,i,ik,1) ;  si = zaj_ball(iadd,i,ik,2)
                  phi_l(iadd,j,ik,1) = phi_l(iadd,j,ik,1) - p1Sp2(j,1)*sr+p1Sp2(j,2)*si
                  phi_l(iadd,j,ik,2) = phi_l(iadd,j,ik,2) - p1Sp2(j,1)*si-p1Sp2(j,2)*sr
               end do
            end if
         end if
      end do
    end subroutine modify_bsd_and_phi_t

  end subroutine mgs_sd2wf_each_k_G_3D


  subroutine m_ES_MGS_4_each_k(nfout,ik,mode)
    integer, intent(in) :: nfout,mode,ik ! mode={ORTHONORMALIZATION | NORMALIZATION}
    integer :: id_sname = -1,i
                                                  __TIMER_SUB_START(501)
    call wd_title_of_the_operation()                        !-(c.h.)

!!$    call m_ES_mgs_alloc(ik)
    if(mode == ORTHONORMALIZATION) then
       call tstatc0_begin('modified_gram_schmidt ',id_sname,1)
    else
       call tstatc0_begin('modified_gram_schmidt (normalization only)',id_sname,1)
    endif
    if(modnrm == EXECUT) then
       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
       call mgs_4_each_k_G_3D(ista_k,iend_k,ik,zaj_l,mode,fsr_l,fsi_l,mod_pot=VDB)!-(m_E.S.)
       if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       call tstatc0_end(id_sname)
!!$       if(mode==NORMALIZATION) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
    else
       call mgs_4_each_k_G_3D(ista_k,iend_k,ik,zaj_l,mode,mod_pot=NORMCONSERVATION)!-(m_E.S.)
       if(ipri>=2 .and. ik==1) write(nfout,'(" !### zaj_l is new,  bfft is old")')
       call tstatc0_end(id_sname)
       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
    end if
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) status_saved_phifftr(:,ik) = OLD
#endif
!!$    call m_ES_mgs_dealloc
                                                  __TIMER_SUB_STOP(501)
  contains
    subroutine wd_title_of_the_operation
      integer, save :: iflag = 0
       if(iflag == 0 .and. ipri >= 1 .and. ik == 1) then
          if(modnrm == EXECUT) then
             write(nfout,*) ' <<< modified_gram_schmidt_vanderbilt_type >>>'
          else
             write(nfout,*) ' <<< modified_gram_schmidt_norm_conserve >>>'
          end if
       end if
       if(iflag == 0) iflag = 1
     end subroutine wd_title_of_the_operation
  end subroutine m_ES_MGS_4_each_k


!!$!BRANCH_P 3D_Parallel
!!$  subroutine m_ES_MGS_4_each_k_3D(nfout,ik,mode)
!!$    integer, intent(in) :: nfout,mode,ik ! mode={ORTHONORMALIZATION | NORMALIZATION}
!!$    integer :: id_sname = -1,i
!!$#ifdef __TIMER_SUB__
!!$  call timer_sta(502)
!!$#endif
!!$
!!$    call wd_title_of_the_operation()                        !-(c.h.)
!!$
!!$       call tstatc0_begin('modified_gram_schmidt ',id_sname,1)
!!$    if(modnrm == EXECUT) then
!!$       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
!!$       call mgs_4_each_k_G_3D(ista_k,iend_k,ik,zaj_l,mode &
!!$      &                      ,fsr_l,fsi_l,mod_pot=VDB)!-(m_E.S.)
!!$       call tstatc0_end(id_sname)
!!$    else
!!$       call mgs_4_each_k_G_3D(ista_k,iend_k,ik,zaj_l,mode &
!!$      &                      ,mod_pot=NORMCONSERVATION)!-(m_E.S.)
!!$       call tstatc0_end(id_sname)
!!$       call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)   ! -> fsr_l,fsi_l
!!$    end if
!!$
!!$#ifdef __TIMER_SUB__
!!$  call timer_end(502)
!!$#endif
!!$  contains
!!$    subroutine wd_title_of_the_operation
!!$      integer, save :: iflag = 0
!!$       if(iflag == 0 .and. ipri >= 1 .and. ik == 1) then
!!$          if(modnrm == EXECUT) then
!!$             write(nfout,*) ' <<< modified_gram_schmidt_vanderbilt_type >>>'
!!$          else
!!$             write(nfout,*) ' <<< modified_gram_schmidt_norm_conserve >>>'
!!$          end if
!!$       end if
!!$       if(iflag == 0) iflag = 1
!!$     end subroutine wd_title_of_the_operation
!!$  end subroutine m_ES_MGS_4_each_k_3D
!!$!BRANCH_P_END 3D_Parallel


  subroutine mgs_4_each_k_G_3D(k1,k2,ik,psi_l,mode,bpr_l,bpi_l,mod_pot)
! Revised by T. Yamasaki in April 2006

    integer, intent(in)                                :: k1,k2,ik
!-F    real(kind=DP),dimension(kg1,np_e,k1:k2,kimg)      :: psi_l 
    real(kind=DP),dimension(maxval(np_g1k),np_e,k1:k2,kimg)      :: psi_l 
    integer, intent(in)                                :: mode,mod_pot
!-F    real(kind=DP),optional,dimension(np_e,nlmta,k1:k2) :: bpr_l,bpi_l
    real(kind=DP),optional,dimension(np_e,np_fs,k1:k2) :: bpr_l,bpi_l
!-F PARA3D
    integer :: nbs, local_block, L_NB_STA, L_NB_END, in, ri, iy, ix, dsize_psi, dsize_bpri
    integer :: icount, iblk, jblk, i_NB, j_NB ,iq
    real(kind=DP),allocatable,dimension(:,:,:) :: wk_psi
    real(kind=DP),allocatable,dimension(:,:,:) :: wk_bpri
    real(kind=DP),allocatable,dimension(:,:,:) :: psi_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpr_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpi_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpr_tw1_dia
!!$    real(kind=DP),allocatable,dimension(:,:) :: bpr_tw2_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpi_tw1_dia
!!$    real(kind=DP),allocatable,dimension(:,:) :: bpi_tw2_dia
    real(kind=DP), allocatable, dimension(:,:,:,:) :: p1Sp2_t2_NB, p1Sp2_t1_NB

    integer ::       i
    real(kind=DP) :: fr
    integer  :: kimg_t_wk
#ifdef MGS_DGEMM
    integer ::       NB_END, NB_END2, i1, i2
!!$    real(kind=DP), allocatable, dimension(:,:) :: bpr_tw1_BLAS
    real(kind=DP), allocatable, dimension(:,:,:) :: p1Sp2_NB
    integer, save :: ibsize_print = OFF
#endif
#ifndef SX
! NEC tune ------------------------------->
    integer :: ibl1,ibl2,ibsize,ncache
    ncache = (m_CtrlP_cachesize()*1024)*3/4
! NEC tune <-------------------------------
#endif
                                                  __TIMER_SUB_START(503)

#ifdef MGS_DGEMM
    if(nblocksize_mgs_is_given) then
       NB = nblocksize_mgs
    else
       NB = nblocksize_mgs_default
    end if
    if(ipri >= 1) then
       if(ibsize_print == OFF) then
          if(nblocksize_mgs_is_given) then
             write(nfout,'(" ! nblocksize_mgs_is_given")')
          else
             write(nfout,'(" ! nblocksize_mgs_is_given is fault")')
          end if
          write(nfout,'( "! NB(=nblocksize_mgs) (mgs_4_each_k_G) = ",i8)') NB
          ibsize_print = ON
       end if
    end if
#endif

#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT
!-F    call m_ES_mgs_alloc(ik)
!xx   call m_ES_mgs_alloc_3D(ik)
!!$    call m_ESortho_mgs_alloc_3D(ik)
    call m_ESortho_mgs_alloc(ik)
!!$    kimg_t_wk = kimg
!!$    if(kimg==2 .and. k_symmetry(ik) == GAMMA) kimg_t_wk = 1
    kimg_t_wk = 2
    if(k_symmetry(ik) == GAMMA) kimg_t_wk = 1
#ifdef MGS_DGEMM
    allocate(p1Sp2_NB(NB,NB,kimg_t_wk))
    allocate( wk_psi(mp_g1k(ik),NB,kimg) ) ; wk_psi = 0.0d0
    allocate( psi_t_dia(np_g1k(ik),NB,kimg) )
#endif
!PARA3D
    dsize_psi = mp_g1k(ik)*NB*kimg
    if(mod_pot == VANDERBILT_TYPE) then
      if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
!!$        i = 3
        i = 2
      else
!!$        i = 6
        i = 4
      endif
      allocate( wk_bpri(i,max(mp_fs,nac_p),NB) )
      dsize_bpri = i*max(mp_fs,nac_p)*NB
    endif
    allocate( bpr_t_dia(np_fs,NB) )
    allocate( bpi_t_dia(np_fs,NB) )
    allocate( bpr_tw1_dia(nac_p,NB) )
    allocate( bpi_tw1_dia(nac_p,NB) )

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          call m_ES_F_transpose_r_3D(k1,k2,ik,bpr_l,bpr_t)              ! bpr_l -> bpr_t
       else
          call m_ES_F_transpose_r_3D(k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)  ! bp[ri]_l -> bp[ri]_t
       end if
    end if

    call m_ES_W_transpose_r_3D(k1,k2,ik,psi_l,psi_t)    !-(m_E.S.) psi_ l-> psi_t
    !    This is, actually, not transpose.

     icount = (neg/NB+1)/nrank_e+1
!!$     allocate( p1Sp2_t2_NB(NB,NB,kimg_t_wk,icount) )
     allocate( p1Sp2_t1_NB(NB,NB,kimg_t_wk,icount) )

#ifdef MGS_DGEMM
    do i = 1, neg,NB
       NB_END = i + NB -1
       if( NB_END > neg ) NB_END = neg

       nbs = (i-1)/NB+1
       if(ipri>=2) &
            & write(nfout,'(" i, nbs = ",2i8, " myrank_e, lrank(nbs) = ",2i8)') i, nbs, myrank_e, lrank(nbs)
       if( myrank_e == lrank(nbs)) then
          local_block = nbsn(nbs)
          L_NB_STA = nbsn_sta(local_block)
          L_NB_END = nbsn_end(local_block)
          if(ipri>=2) write(nfout,'(" L_NB_STA, L_NB_END = ",2i8)') L_NB_STA, L_NB_END
!diagonal
                                                  __TIMER_DO_START(540)
    do i1 = L_NB_STA, L_NB_END
       if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
          call WSW_t_g(ik,i1,mod_pot,fr,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! fr = 1/dsqrt(<Psi(i)|S|Psi(i)>)
          if(dabs(fr-1.d0) > DELTA) &
               & call normalize_bp_and_psi_t_g(ik,i1,fr,mod_pot &
               & ,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t)
          !   |Psi(i)> = |Psi(i)> * fr,  <beta|Psi(i)> = <beta|Psi(i)> * fr
          if(mod_pot == VANDERBILT_TYPE) call cp_bpr2bprtw(i1,L_NB_END)  ! bpr_t -> bpr_tw1, bpr_tw2
       end if
       if(mode /= NORMALIZATION) then
          if(i1 == neg) cycle
          call cp_psi2psii_g(ik,i1) ! psi_t(:,i1,:) -> psi_ir,psi_ii
          call W1SW2_t_r_g(ik,i1,L_NB_END,mod_pot,psi_t,np_g1k_x,np_e,kimg) ! -> p1Sp2
          if(mod_pot == VANDERBILT_TYPE) &
               & call cp_bpr2bpi_g(kimg_t_wk, i1,bpr_t,bpi_t)  ! -> bp_ir, bp_ii
          call modify_bp_and_psi_t_r_g(ik,i1,L_NB_END,mod_pot &
               & ,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
       end if
    end do   ! i1-loop
                                                  __TIMER_DO_STOP(540)
! bcast 
       call cp_psi_bpri2dias_g()

       endif ! myrank_e == lrank(nbs)

    if(nrank_e > 1 ) then
                                                 __TIMER_COMM_START_w_BARRIER(mpi_kg_world,529)
       call mpi_bcast(wk_psi,dsize_psi,mpi_double_precision,lrank(nbs),mpi_kg_world,ierr)
                                                 __TIMER_COMM_STOP(529)
    endif
                                                 __TIMER_COMM_START(530)
       do ri = 1, kimg
       do iy = 1, NB
         do ix = 1, np_g1k(ik)
           psi_t_dia(ix,iy,ri) = wk_psi(ix,iy,ri)
       enddo; enddo;  enddo;
                                                 __TIMER_COMM_STOP(530)
                                                 __TIMER_DO_START(541)
       do ri = 1, kimg
!       do iy = i, NB_END
       do iy = nbs_sta(nbs), nbs_end(nbs)
         do ix = 1, np_g1k(ik)
           zaj_ball(ix,iy,ik,ri) = wk_psi(ix,iy-nbs_sta(nbs)+1,ri)
       enddo; enddo;  enddo;
                                                 __TIMER_DO_STOP(541)
       if(mod_pot == VANDERBILT_TYPE) then
          if(nrank_e > 1 ) then
                                                 __TIMER_COMM_START_w_BARRIER(mpi_kg_world,531)
              call mpi_bcast(wk_bpri,dsize_bpri,mpi_double_precision,lrank(nbs),mpi_kg_world,ierr)
                                                 __TIMER_COMM_STOP(531)
          endif
          if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
                                                 __TIMER_COMM_START(532)
             do iy = 1, NB
                do ix = 1, np_fs
                   bpr_t_dia(ix,iy) = wk_bpri(1,ix,iy)
                enddo
                do ix = 1, nac_p
                   bpr_tw1_dia(ix,iy) = wk_bpri(2,ix,iy)
!!$                   bpr_tw2_dia(ix,iy) = wk_bpri(3,ix,iy)
                enddo
             enddo
                                                 __TIMER_COMM_STOP(532)
                                                 __TIMER_DO_START(542)
              do iy = nbs_sta(nbs), nbs_end(nbs)     !       do iy = i,NB_END
                do ix = 1,np_fs
                   fsr_ball(iy,ix,ik) = wk_bpri(1,ix,iy-nbs_sta(nbs)+1)
                enddo
             enddo
                                                 __TIMER_DO_STOP(542)
          else
                                                 __TIMER_COMM_START(533)
             do iy = 1, NB
                do ix = 1, np_fs
                   bpr_t_dia(ix,iy) = wk_bpri(1,ix,iy)
                   bpi_t_dia(ix,iy) = wk_bpri(2,ix,iy)
                enddo
                do ix = 1, nac_p
                   bpr_tw1_dia(ix,iy) = wk_bpri(3,ix,iy)
!!$                   bpr_tw2_dia(ix,iy) = wk_bpri(4,ix,iy)
                   bpi_tw1_dia(ix,iy) = wk_bpri(4,ix,iy)
!!$                   bpi_tw2_dia(ix,iy) = wk_bpri(6,ix,iy)
                enddo
             enddo
                                                 __TIMER_COMM_STOP(533)
                                                 __TIMER_DO_START(543)
             do iy = nbs_sta(nbs), nbs_end(nbs)      !      do iy = i,NB_END
                do ix = 1,np_fs
                   fsr_ball(iy,ix,ik) = wk_bpri(1,ix,iy-nbs_sta(nbs)+1)
                   fsi_ball(iy,ix,ik) = wk_bpri(2,ix,iy-nbs_sta(nbs)+1)
                enddo
             enddo
                                                 __TIMER_DO_STOP(543)
          endif
       endif

!lower1
    if(mode /= NORMALIZATION) then
    icount = 0
    p1Sp2_t1_NB = 0.0d0
                                                 __TIMER_DO_START(544)
    do i2 = i+NB, neg,NB
       if(NB_END == neg) cycle
       NB_END2 = i2 + NB -1
       if( NB_END2 > neg ) NB_END2 = neg

       nbs = (i2-1)/NB+1
       if( myrank_e /= lrank(nbs)) cycle
       local_block = nbsn(nbs)
       L_NB_STA = nbsn_sta(local_block)
       L_NB_END = nbsn_end(local_block)
       if(mod_pot == VANDERBILT_TYPE) call cp_bpr2bprtw(L_NB_STA,L_NB_END)  ! bpr_t -> bpr_tw1, bpr_tw2

       call W1SW2_t_r_block_g(ik,i,L_NB_STA,p1Sp2_NB,NB_END,L_NB_END,kimg_t_wk &
            & , mod_pot,psi_t,psi_t_dia,np_g1k_x,np_e,kimg,bpr_tw1_dia,bpi_tw1_dia) ! -> p1Sp2
       icount = icount + 1

!-$ tune FUJITSU for block ----->>
!modify2010
                                                 __TIMER_COMM_START(534)
        do i_NB = 1, NB
           do iq = 1, kimg_t_wk
             do j_NB = 1,NB
               p1Sp2_t1_NB(j_NB,i_NB,iq,icount) = p1Sp2_NB(j_NB,i_NB,iq)
         end do ; enddo ; enddo
                                                 __TIMER_COMM_STOP(534)
!      if(nrank_g > 1 ) then
!       do i_NB = 1, NB
!          do iq = 1, kimg_t_wk
!            do j_NB = 1,NB
!              p1Sp2_t1_NB(j_NB,i_NB,iq,icount) = p1Sp2_NB(j_NB,i_NB,iq)
!        end do ; enddo ; enddo
!      endif
!-$ tune FUJITSU for block <<-----

    end do   ! i2-loop1
                                                 __TIMER_DO_STOP(544)

    if (NB_END /= neg ) then

! allreduce
    if(nrank_g > 1 ) then
      ix =  NB*NB*kimg_t_wk*icount
                                                 __TIMER_COMM_START_w_BARRIER(mpi_ke_world,535)
      call mpi_allreduce(MPI_IN_PLACE, p1Sp2_t1_NB,ix,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                 __TIMER_COMM_STOP(535)
    endif

    endif   !(NB_END /= neg )
!lower2
    icount = 0
                                                 __TIMER_DO_START(545)
    do i2 = i+NB, neg,NB
       if(NB_END == neg) cycle
       NB_END2 = i2 + NB -1
       if( NB_END2 > neg ) NB_END2 = neg
       nbs = (i2-1)/NB+1
       if( myrank_e /= lrank(nbs)) cycle
       local_block = nbsn(nbs)
       L_NB_STA = nbsn_sta(local_block)
       L_NB_END = nbsn_end(local_block)

!modify2010
       if(nrank_g > 1 ) then
         icount =  icount+1
                                                 __TIMER_DO_START(546)
         do i_NB = 1, NB
           do iq = 1, kimg_t_wk
             do j_NB = 1, NB
               p1Sp2_NB(j_NB,i_NB,iq) = p1Sp2_t1_NB(j_NB,i_NB,iq,icount)
         end do ; enddo ; enddo
                                                 __TIMER_DO_STOP(546)
       else
         icount =  icount+1
                                                 __TIMER_DO_START(547)
         do i_NB = 1, NB
           do iq = 1, kimg_t_wk
             do j_NB = 1, NB
               p1Sp2_NB(j_NB,i_NB,iq) = p1Sp2_t1_NB(j_NB,i_NB,iq,icount)
         end do ; enddo ; enddo
                                                 __TIMER_DO_STOP(547)
       endif
!      if(nrank_g > 1 ) then
!        icount =  icount+1
!        do i_NB = 1, NB
!          do iq = 1, kimg_t_wk
!            do j_NB = 1, NB
!              p1Sp2_NB(j_NB,i_NB,iq) = p1Sp2_t2_NB(j_NB,i_NB,iq,icount)
!        end do ; enddo ; enddo
!      endif

       call modify_bp_and_psi_t_r_blk_g(ik,i,L_NB_STA,p1Sp2_NB,NB_END,L_NB_END,kimg_t_wk &
            & , mod_pot,psi_t,psi_t_dia,np_g1k_x,np_e,kimg,bpr_t,bpi_t,bpr_t_dia,bpi_t_dia)
       !                   psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
    end do   ! i2-loop2
                                                 __TIMER_DO_STOP(545)
    end if   ! lower1 (mode /= NORMALIZATION)
    end do   ! i-loop
#else
    do i = 1, neg
       if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
          call WSW_t_g(ik,i,mod_pot,fr,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! fr = 1/dsqrt(<Psi(i)|S|Psi(i)>)
          if(dabs(fr-1.d0) > DELTA) &
               & call normalize_bp_and_psi_t_g(ik,i,fr,mod_pot,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t)
          !   |Psi(i)> = |Psi(i)> * fr,  <beta|Psi(i)> = <beta|Psi(i)> * fr
       end if
       if(mode /= NORMALIZATION) then
          if(i == neg) cycle
          call cp_psi2psii_g(ik,i) ! psi_t(:,i,:) -> psi_ir,psi_ii
          if(mod_pot == VANDERBILT_TYPE) &
               & call cp_bpr2bpi_g(kimg_t_wk,i,bpr_t,bpi_t) ! -> bp_ir, bp_ii
          call W1SW2_t_r_g(ik,i,neg,mod_pot,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! -> p1Sp2
          call modify_bp_and_psi_t_r_g(ik,i,neg,mod_pot &
               & ,psi_t,np_g1k_x,np_e,kimg,bpr_t,bpi_t) ! psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
       end if
    end do
#endif

    call m_ES_W_transpose_back_r_3D(k1,k2,ik,psi_l,psi_t)
    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          call m_ES_F_transpose_back_r_3D(k1,k2,ik,bpr_l,bpr_t)
       else
          call m_ES_F_transpose_back_r_3D(k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)
       end if
    end if
!!$    deallocate(bpi_tw2_dia,bpi_tw1_dia,bpr_tw2_dia,bpr_tw1_dia)
    deallocate(p1Sp2_t1_NB)
    deallocate(bpi_tw1_dia,bpr_tw1_dia)
    deallocate(bpi_t_dia,bpr_t_dia)
    if(mod_pot == VANDERBILT_TYPE) deallocate(wk_bpri)
#ifdef MGS_DGEMM
    deallocate(psi_t_dia)
    deallocate(wk_psi)
    deallocate(p1Sp2_NB)
#endif
#else
    integer ::       nmax, ito
    integer, allocatable, dimension(:)         :: ib2to_a, ib2back_a
    allocate(ib2to_a(neg)); allocate(ib2back_a(neg))

!xx call m_ES_mgs_alloc(ik)
!!$    call m_ESortho_mgs_alloc_3D(ik)
    call m_ESortho_mgs_alloc(ik)

!!$    if(mod_pot == VANDERBILT_TYPE) call m_ES_F_transpose(k1,k2,ik,bpr_l,bpi_l,bpr_t,bpi_t)
    if(mod_pot == VANDERBILT_TYPE) &
         & call m_ES_F_transpose_r(.false.,k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)
    call m_ES_W_transpose_r(.false.,k1,k2,ik,psi_l,psi_t)    !-(m_E.S.) psi_ l-> psi_t
    do i = 1, neg
       ito = neordr(i,ik)
       if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
          call WSW_t_g(ik,ito,mod_pot,fr,psi_t,np_g1k_x,neg,kimg,bpr_t,bpi_t) ! fr = 1/dsqrt(<Psi(ito)|S|Psi(ito)>)
          if(dabs(fr-1.d0) > DELTA) &
               & call normalize_bp_and_psi_t_g(ik,ito,fr,mod_pot &
               & ,psi_t,np_g1k_x,neg,kimg,bpr_t,bpi_t) !
          !   |Psi(ito)> = |Psi(ito)> * fr,  <beta|Psi(ito)> = <beta|Psi(ito)> * fr
       end if
       if(mode /= NORMALIZATION) then
          call substitute_jto_ib2back(i,nmax) !-(c.h.) ->ib2to_a,ib2back_a,
          if(nmax == 0) cycle
          call W1SW2_t(i,ito) ! -> p1Sp2
          call modify_bp_and_psi_t(i,ito) ! psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
       end if
    end do

    call m_ES_W_transpose_back_r(.false.,k1,k2,ik,psi_l,psi_t)
!!$    if(mod_pot == VANDERBILT_TYPE) call m_ES_F_transpose_back(k1,k2,ik,bpr_l,bpi_l,bpr_t,bpi_t)
    if(mod_pot == VANDERBILT_TYPE) &
         & call m_ES_F_transpose_back_r(.false.,k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)
    deallocate(ib2back_a,ib2to_a)
#endif
!xx call m_ES_mgs_dealloc_3D()
    call m_ESortho_mgs_dealloc()
                                                  __TIMER_SUB_STOP(503)

!!$#else
!!$    integer, parameter :: npfsr_o = 0
!!$    integer            :: npfsi_o, npzr_o, npzi_o
!!$    integer, dimension(2) :: npzri_o
!!$    real(kind=DP)      :: fr,fi
!!$    integer            :: j, ibaik
!!$    integer                                         :: nsize_of_brd_w
!!$    real(kind=DP),allocatable, dimension(:)         :: brd_w
!!$
!!$    call alloc_and_brd_w()  ! nsize_of_brd_w, brd_w
!!$
!!$    ibaik = iba(ik)
!!$
!!$    npfsi_o = nlmta
!!$    call set_npzri(mod_pot,ik,npzr_o,npzi_o,npzri_o)  ! ->(npzr_o,npzi_o,npzri_o)
!!$
!!$    if(ipri >= 2) print '(" <<< modified_gram_schmidt_vanderbilt_type(cyclic)>>>")'
!!$    do i = 1, neg
!!$       ito = neordr(i,ik)
!!$       if(map_e(ito) == myrank_e) then               ! MPI
!!$          if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
!!$             call WSW(ito,fr) !   fr = 1/dsqrt(<Psi(ito)|S|Psi(ito)>)
!!$             if(dabs(fr-1.d0) > DELTA) call normalize_bp_and_psi(ito,fr)
!!$             !   |Psi(ito)> = |Psi(ito)> * fr,  <beta|Psi(ito)> = <beta|Psi(ito)> * fr
!!$          end if
!!$          if(mode /= NORMALIZATION) &
!!$               & call cp_bp_and_psi_2_brd_w2(k1,k2,ik,ito,mod_pot &
!!$               & , bpr_l,bpi_l,psi_l,npfsr_o,npfsi_o,npzri_o,nsize_of_brd,brd_w)
!!$          !                         -(m_E.S.) (bpr_l,bpi_l),psi_l -> brd_w   MPI
!!$       end if
!!$       if(mode /= NORMALIZATION) then
!!$          call mpi_bcast(brd_w,nsize_of_brd_w,mpi_double_precision &
!!$               & ,map_e(ito),mpi_k_world(myrank_k),ierr) !MPI
!!$
!!$          do j = ista_e, iend_e, istep_e                ! MPI
!!$             if(nrvf_ordr(j,ik) <= i) cycle
!!$             call W1SW2(j,fr,fi)
!!$             call modify_bp_and_psi(j,fr,fi)
!!$          end do
!!$       end if
!!$    end do
!!$    call dealloc_and_brd_w
!!$#endif
  contains

#ifdef MGS_DGEMM
    subroutine cp_psi_bpri2dias_g()
      integer :: ri,i1,ix,iy
                                                 __TIMER_COMM_START(527)
      do ri = 1, kimg
         do i1 = L_NB_STA, L_NB_END
            iy = i1-L_NB_STA+1
            do ix = 1, np_g1k(ik)
               wk_psi(ix,iy,ri) = psi_t(ix,i1,ri)
            enddo
         enddo
      enddo
                                                 __TIMER_COMM_STOP(527)
                                                 __TIMER_COMM_START(528)
      if(mod_pot == VANDERBILT_TYPE) then
         if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
            do i1 = L_NB_STA, L_NB_END
               iy = i1-L_NB_STA+1
               do ix = 1, np_fs
                  wk_bpri(1,ix,iy) = bpr_t(ix,i1)
               enddo
               do ix = 1, nac_p
                  wk_bpri(2,ix,iy) = bpr_tw1(ix,i1)
!!$                     wk_bpri(3,ix,iy) = bpr_tw2(ix,i1)
               enddo
            enddo
         else
            do i1 = L_NB_STA, L_NB_END
               iy = i1-L_NB_STA+1
               do ix = 1, np_fs
                  wk_bpri(1,ix,iy) = bpr_t(ix,i1)
                  wk_bpri(2,ix,iy) = bpi_t(ix,i1)
               enddo
               do ix = 1, nac_p
                  wk_bpri(3,ix,iy) = bpr_tw1(ix,i1)
!!$                     wk_bpri(4,ix,iy) = bpr_tw2(ix,i1)
!!$                     wk_bpri(5,ix,iy) = bpi_tw1(ix,i1)
                  wk_bpri(4,ix,iy) = bpi_tw1(ix,i1)
!!$                     wk_bpri(6,ix,iy) = bpi_tw2(ix,i1)
               enddo
            enddo
         endif
      endif
                                                 __TIMER_COMM_STOP(528)
  end subroutine cp_psi_bpri2dias_g
#endif

#ifdef MGS_DGEMM
    subroutine cp_bpr2bprtw(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: i, ia, p, q, i_last
                                                  __TIMER_SUB_START(505)
!!$      if(i1==1) then
!!$         i_last = i2
!!$      else
!!$         i_last = i1
!!$      end if
#ifdef MGS_DGEMM_DEBUG
      i_last = i1
#else
      i_last = i2
#endif
      if(k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DO_START(552)
         do i = i1, i_last
            do ia = 1, nac_p
               p = nlmta1_p(ia);     q = nlmta2_p(ia)
               bpr_tw1(ia,i) = bpr_t(p,i)
               bpr_tw2(ia,i) = bpr_t(q,i)
            end do
         end do
                                                  __TIMER_DO_STOP(552)
      else
                                                  __TIMER_DO_START(553)
         do i = i1, i_last
            do ia = 1, nac_p
               p = nlmta1_p(ia);     q = nlmta2_p(ia)
               bpr_tw1(ia,i) = bpr_t(p,i)
               bpr_tw2(ia,i) = bpr_t(q,i)
               bpi_tw1(ia,i) = bpi_t(p,i)
               bpi_tw2(ia,i) = bpi_t(q,i)
            end do
         end do
                                                  __TIMER_DO_STOP(553)
      end if
                                                  __TIMER_SUB_STOP(505)
    end subroutine cp_bpr2bprtw
#endif
      
!!$    subroutine alloc_p1Sp2(n)
!!$      integer, intent(in) :: n
!!$      if(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2) then
!!$         kimg_t = 1
!!$      else
!!$         kimg_t = 2
!!$      end if
!!$      allocate(p1Sp2(n,kimg_t))
!!$    end subroutine alloc_p1Sp2
!!$
!!$    subroutine dealloc_p1Sp2
!!$      deallocate(p1Sp2)
!!$    end subroutine dealloc_p1Sp2

#ifndef TRANSPOSE_WITHOUT_REARRANGEMENT

#else

    subroutine substitute_jto_ib2back(i,nmax)
      integer, intent(in)  :: i
      integer, intent(out) :: nmax

      integer              ::jto, j
      jto = 0
      do j = 1, neg
         if(nrvf_ordr(j,ik) <= i) cycle
         jto = jto + 1
         ib2to_a(jto)  = j
         ib2back_a(j)  = jto
      end do
      nmax = jto
      if(ipri >= 2 .and. ik == 1) then
         write(nfout,'(" <<substitute_jto_ib2back>>")')
         do j = 1, neg
            write(nfout,'(" ib2back_a(",i3,") = ",i3)') j, ib2back_a(j)
         end do
         do j = 1, nmax
            write(nfout,'(" ib2to_a(",i3,") = ",i3)') j, ib2to_a(j)
         end do
      end if
    end subroutine substitute_jto_ib2back

    subroutine W1SW2_t(i,ito)
      integer, intent(in)        :: i,ito

      integer       :: j, ia, jto, p, q, kimg_t
      real(kind=DP) :: ar, ai
      real(kind=DP), allocatable, dimension(:,:)  :: p1Sp2_t1, p1Sp2_t2             ! MPI

!!$      call alloc_p1Sp2(nmax)
      if(npes > 1) then
         if((k_symmetry(ik) == GAMMA .and. kimg==2) .or. kimg == 1) then
            kimg_t = 1
         else
            kimg_t = 2
         end if
         allocate(p1Sp2_t2(nmax,kimg_t)); p1Sp2_t2 = 0.d0                  ! MPI
         allocate(p1Sp2_t1(nmax,kimg_t)); p1Sp2_t1 = 0.d0                  ! MPI
      end if

      p1Sp2 = 0.d0

      if(mod_pot == VANDERBILT_TYPE) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(jto,ia,ar,ai,p,q)
#endif
         do jto = 1, nmax                                                 ! MPI
            j = ib2to_a(jto)                                              ! MPI
            if(kimg == 1) then
               ar = 0.d0
               do ia = 1, nac_p
                  p = nlmta1_p(ia);            q = nlmta2_p(ia)
                  ar = ar + fqwei_p(ia)*(bpr_t(p,ito)*bpr_t(q,j)+bpi_t(p,ito)*bpi_t(q,j))
               end do
               p1Sp2(jto,1) = ar
            else if(kimg == 2) then
               if(k_symmetry(ik) == GAMMA) then
                  ar = 0.d0
                  do ia = 1, nac_p
                     p = nlmta1_p(ia);         q = nlmta2_p(ia)
                     ar = ar + fqwei_p(ia)*(bpr_t(p,ito)*bpr_t(q,j))
                  end do
                  p1Sp2(jto,1) = ar
               else
                  ar = 0.d0; ai = 0.d0
                  do ia = 1, nac_p
                     p = nlmta1_p(ia);         q = nlmta2_p(ia)
                     ar = ar + fqwei_p(ia)*(bpr_t(p,ito)*bpr_t(q,j)+bpi_t(p,ito)*bpi_t(q,j))
                     ai = ai + fqwei_p(ia)*(bpr_t(p,ito)*bpi_t(q,j)-bpi_t(p,ito)*bpr_t(q,j))
                  end do
                  p1Sp2(jto,1) = ar;  p1Sp2(jto,2) = ai
               end if
            end if
         end do
      end if

      if(ipri >= 2 .and. ik == 1) then
         if(nmax > 1) then
            write(nfout,'(" <<W1SW2_t>> ik = ",i9,"  i = ",i3, " ito = ", i3)') ik,i,ito
            write(nfout,'(" (real) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(jto,1),jto=1, nmax)
            if(kimg == 2 .and. k_symmetry(ik) /= GAMMA) &
                 & write(nfout,'(" (imag) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(jto,kimg),jto=1, nmax)
         end if
      end if

      if(kimg == 1) then
         do jto = 1, nmax
            j = ib2to_a(jto)
            do ia = 1, np_g1k(ik)                                           ! MPI
               p1Sp2(jto,1) = p1Sp2(jto,1) + psi_t(ia,ito,1)*psi_t(ia,j,1 ) ! MPI
            end do
         end do
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
            do jto = 1, nmax
               j = ib2to_a(jto)
               do ia = 2, np_g1k(ik)
                  ar  = psi_t(ia,ito,1)
                  ai  = psi_t(ia,ito,2)
                  p1Sp2(jto,1) = p1Sp2(jto,1)+(ar*psi_t(ia,j,1)+ai*psi_t(ia,j,2))*2.d0 ! MPI
               end do
!!$               if(mype /= 0) then
               if(myrank_e /= 0) then
                  ar = psi_t(1,ito,1)
                  ai = psi_t(1,ito,2)
                  p1Sp2(jto,1) = p1Sp2(jto,1) + (ar*psi_t(1,j,1) + ai*psi_t(1,j,2))*2.d0
               else
                  p1Sp2(jto,1) = p1Sp2(jto,1) + psi_t(1,ito,1)*psi_t(1,j,1)
               end if
            end do
         else
            do jto = 1, nmax
               j = ib2to_a(jto)
               do ia = 1, np_g1k(ik)                                          ! MPI
                  ar  = psi_t(ia,ito,1)
                  ai  = psi_t(ia,ito,2)
                  p1Sp2(jto,1) = p1Sp2(jto,1)+ar*psi_t(ia,j,1)+ai*psi_t(ia,j,2) ! MPI
                  p1Sp2(jto,2) = p1Sp2(jto,2)+ar*psi_t(ia,j,2)-ai*psi_t(ia,j,1) ! MPI
               end do
            end do
         end if
      end if
      if(npes > 1 ) then
         do q = 1, kimg_t
            do jto = 1, nmax
               p1Sp2_t1(jto,q) = p1Sp2(jto,q)
            end do
         end do
         call mpi_allreduce(p1Sp2_t1, p1Sp2_t2,nmax*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
         do q = 1, kimg_t
            do jto = 1, nmax
               p1Sp2(jto,q) = p1Sp2_t2(jto,q)
            end do
         end do
      end if

      if(ipri >= 2 .and. ik == 1) then
         if(nmax > 1) then
            write(nfout,'(" <<W1SW2_t>> ik = ",i9,"  i = ",i3, " ito = ", i3)') ik,i,ito
            write(nfout,'(" (real) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(jto,1),jto=1, nmax)
            if(kimg == 2 .and. k_symmetry(ik) /= GAMMA) &
                 & write(nfout,'(" (imag) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(jto,kimg),jto=1, nmax)
         end if
      end if

      if(nrank_e*nrank_g > 1) deallocate(p1Sp2_t1,p1Sp2_t2)
    end subroutine W1SW2_t

    subroutine modify_bp_and_psi_t(i,ito)
      integer, intent(in) :: i, ito
      integer             :: j,ia,jto
      real(kind=DP) :: sr, si

      if(mod_pot == VANDERBILT_TYPE) then
         do j = 1, neg
            if(nrvf_ordr(j,ik) <= i) cycle
            jto = ib2back_a(j)
            if(kimg == 1) then
               do ia = 1, np_fs
                  bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(jto,1)*bpr_t(ia,ito)
                  bpi_t(ia,j) = bpi_t(ia,j) - p1Sp2(jto,1)*bpi_t(ia,ito)
               end do
            else if(kimg == 2) then
               if(k_symmetry(ik) == GAMMA) then
                  do ia = 1, np_fs
                     bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(jto,1)*bpr_t(ia,ito)
                  end do
               else
                  do ia = 1, np_fs
                     sr  =  bpr_t(ia,ito);     si  =  bpi_t(ia,ito)
                     bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(jto,1)*sr+p1Sp2(jto,2)*si
                     bpi_t(ia,j) = bpi_t(ia,j) - p1Sp2(jto,1)*si-p1Sp2(jto,2)*sr
                  end do
               end if
            end if
         end do
      end if

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!CDIR NOSYNC
!CDIR CONCUR(BY=1)
#endif
      do j = 1,neg
         if(nrvf_ordr(j,ik) <= i) cycle
         jto = ib2back_a(j)         ! <-- 99Jan19 T. Y.
         if(kimg == 1) then
            do ia = 1, np_g1k(ik)                 ! MPI
               psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(jto,1)*psi_t(ia,ito,1 )
            end do
         else if(kimg == 2) then
            if(k_symmetry(ik) == GAMMA) then
               do ia = 1, np_g1k(ik)
                  sr  =  psi_t(ia,ito,1 );   si  =  psi_t(ia,ito,2 )
                  psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(jto,1)*sr
                  psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(jto,1)*si
               end do
            else
               do ia = 1, np_g1k(ik)                ! MPI
                  sr  =  psi_t(ia,ito,1 );   si  =  psi_t(ia,ito,2 )
                  psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(jto,1)*sr+p1Sp2(jto,2)*si
                  psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(jto,1)*si-p1Sp2(jto,2)*sr
               end do
            end if
         end if
      end do
!!$      call dealloc_p1Sp2()
    end subroutine modify_bp_and_psi_t
#endif

  end subroutine mgs_4_each_k_G_3D

!!$  subroutine set_npzri(mod_pot,ik,npzr_o,npzi_o,npzri_o)
!!$    integer, intent(in)  :: mod_pot,ik
!!$    integer, intent(out) :: npzr_o, npzi_o, npzri_o(2)
!!$
!!$    if(mod_pot == NORMCONSERVATION) then
!!$       npzr_o = 0
!!$    else
!!$       if(k_symmetry(ik) == GAMMA) then
!!$          npzr_o = nlmta
!!$       else
!!$          npzr_o = nlmta * 2
!!$       end if
!!$    end if
!!$    npzi_o = npzr_o + iba(ik)
!!$    npzri_o(1) = npzr_o; npzri_o(2) = npzi_o
!!$  end subroutine set_npzri

#ifdef TRANSPOSE
!!$#endif !TRANSPOSE_ORIGINAL


#else
!! #ifdef TRANSPOSE else

#endif
!! #ifdef TRANSPOSE end

  subroutine m_ES_F_transpose_r_3D(k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)

    integer, intent(in)                                                :: k1,k2,ik
!-F    real(kind=DP), intent(in), dimension(np_e,nlmta,k1:k2)             :: bpr_l
!-F    real(kind=DP), intent(out),dimension(np_fs_x,neg)                  :: bpr_t
!-F    real(kind=DP), intent(in), optional,dimension(np_e,nlmta,k1:k2)    :: bpi_l
!-F    real(kind=DP), intent(out),optional,dimension(np_fs_x,neg)         :: bpi_t
    real(kind=DP), intent(in), dimension(np_e,np_fs,k1:k2)             :: bpr_l
    real(kind=DP), intent(out),dimension(np_fs_x,np_e)                  :: bpr_t
    real(kind=DP), intent(in), optional,dimension(np_e,np_fs,k1:k2)    :: bpi_l
    real(kind=DP), intent(out),optional,dimension(np_fs_x,np_e)         :: bpi_t

    real(kind=DP), allocatable, dimension(:,:,:,:) :: tmp_s,tmp_r
    integer, allocatable, dimension(:) :: req_s,req_r

    integer :: datasize, nb_proc, j, ix,iy, kimg_t, ifrom, ito
    integer :: pe_s,pe_r
    integer :: id_sname = -1
#ifdef MGS_DGEMM_DEBUG
    integer :: ia,p,q
#endif
                                                  __TIMER_SUB_START(511)

    if(k_symmetry(ik) == GAMMA) then ! assuming kimg == 2 when k_symmetry(ik) == GAMMA.
       kimg_t = 1
    else
       kimg_t = 2
    end if
                                                  __TIMER_DO_START(573)
    if(npes == 1) then
       if(kimg_t == 1) then
          if(np_fs_x > nlmta .or. neg > np_e) bpr_t = 0.d0
          do iy = 1, neg
!-F             ifrom = neordr(iy,ik)
             do ix = 1, nlmta
!-F                bpr_t(ix,iy) = bpr_l(ifrom,ix,ik)
                bpr_t(ix,iy) = bpr_l(iy,ix,ik)
             end do
          end do
       else if(kimg_t == 2) then
          if(np_fs_x > nlmta .or. neg > np_e)then
             bpr_t = 0.d0; bpi_t = 0.d0
          end if


          do iy = 1, neg
!-F             ifrom = neordr(iy,ik)
             do ix = 1, nlmta
!-F                bpr_t(ix,iy) = bpr_l(ifrom,ix,ik)
!-F                bpi_t(ix,iy) = bpi_l(ifrom,ix,ik)
                bpr_t(ix,iy) = bpr_l(iy,ix,ik)
                bpi_t(ix,iy) = bpi_l(iy,ix,ik)
             end do
          end do
       end if

#ifdef MGS_DGEMM_DEBUG
       goto 9999
#else
       return
#endif
    end if
                                                  __TIMER_DO_STOP(573)

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('m_ES_F_transpose_r ',id_sname)

!-F add set work array for PARA3D
    bpr_t = 0.d0
    if(kimg_t == 2) bpi_t = 0.d0
                                                  __TIMER_DO_START(574)
    if(kimg_t == 1) then
       do iy = 1, np_e
          do ix = 1, np_fs
             bpr_t(ix,iy) = bpr_l(iy,ix,ik)
          end do
       end do
    else if(kimg_t == 2) then
       do iy = 1, np_e
          do ix = 1, np_fs
             bpr_t(ix,iy) = bpr_l(iy,ix,ik)
             bpi_t(ix,iy) = bpi_l(iy,ix,ik)
          end do
       end do
    end if
                                                  __TIMER_DO_STOP(574)
                                                  __TIMER_SUB_STOP(511)
  end subroutine m_ES_F_transpose_r_3D

  subroutine m_ES_F_transpose_back_r_3D(k1,k2,ik,bpr_l,bpr_t,bpi_l,bpi_t)

    integer, intent(in)                                                :: k1,k2,ik
!-F    real(kind=DP), intent(out),dimension(np_e,nlmta,k1:k2)             :: bpr_l
!-F    real(kind=DP), intent(in) ,dimension(np_fs_x,neg)                  :: bpr_t
!-F    real(kind=DP), intent(out),optional,dimension(np_e,nlmta,k1:k2)    :: bpi_l
!-F    real(kind=DP), intent(in) ,optional,dimension(np_fs_x,neg)         :: bpi_t
    real(kind=DP), intent(out), dimension(np_e,np_fs,k1:k2)             :: bpr_l
    real(kind=DP), intent(in),dimension(np_fs_x,np_e)                  :: bpr_t
    real(kind=DP), intent(out), optional,dimension(np_e,np_fs,k1:k2)    :: bpi_l
    real(kind=DP), intent(in),optional,dimension(np_fs_x,np_e)         :: bpi_t

    real(kind=DP), allocatable, dimension(:,:,:,:) :: tmp_s,tmp_r
    integer, allocatable, dimension(:) :: req_s,req_r

    integer :: datasize, nb_proc, j, ix,iy, kimg_t,ito,ifrom
    integer :: pe_s,pe_r
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(512)

    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = 2
    end if
                                                  __TIMER_DO_START(575)
    if(npes == 1) then
       if(kimg_t == 1) then
          do iy = 1, neg
!-F             ito = neordr(iy,ik)
             do ix = 1, nlmta
!-F                bpr_l(ito,ix,ik) = bpr_t(ix,iy)
                bpr_l(iy,ix,ik) = bpr_t(ix,iy)
             end do
          end do
       else
          do iy = 1, neg
!-F             ito = neordr(iy,ik)
             do ix = 1, nlmta
!-F                bpr_l(ito,ix,ik) = bpr_t(ix,iy)
!-F                bpi_l(ito,ix,ik) = bpi_t(ix,iy)
                bpr_l(iy,ix,ik) = bpr_t(ix,iy)
                bpi_l(iy,ix,ik) = bpi_t(ix,iy)
             end do
          end do
       end if
       return
    end if
                                                  __TIMER_DO_STOP(575)

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('m_ES_F_transpose_back_r_3D ',id_sname)

!-F add return work array for PARA3D
                                                  __TIMER_DO_START(576)
    if(kimg_t == 1) then
       do iy = 1, np_e
          do ix = 1, np_fs
             bpr_l(iy,ix,ik) = bpr_t(ix,iy)
          end do
       end do
    else if(kimg_t == 2) then
       do iy = 1, np_e
          do ix = 1, np_fs
             bpr_l(iy,ix,ik) = bpr_t(ix,iy)
             bpi_l(iy,ix,ik) = bpi_t(ix,iy)
          end do
       end do
    end if
                                                  __TIMER_DO_STOP(576)

    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(512)
  end subroutine m_ES_F_transpose_back_r_3D

  subroutine m_ES_W_transpose_r_3D(k1,k2,ik,psi_l,psi_t)

    integer, intent(in)                                       :: k1,k2,ik
!-F    real(kind=DP), intent(in), dimension(kg1,np_e,k1:k2,kimg) :: psi_l  ! MPI
!-F    real(kind=DP), intent(out),dimension(np_g1k_x,neg,kimg)   :: psi_t  ! MPI
    real(kind=DP), intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l  ! MPI
    real(kind=DP), intent(out),dimension(np_g1k_x,np_e,kimg)   :: psi_t  ! MPI

    real(kind=DP), allocatable, dimension(:,:,:,:) :: tmp_s,tmp_r
    integer, allocatable, dimension(:) :: req_s,req_r

    integer :: ri, datasize, nb_proc, j, ix,iy, ifrom, ito
    integer :: pe_s,pe_r
    integer :: mp_g1k_x
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(513)
                                                  __TIMER_DO_START(577)
    if(npes == 1) then
       if(np_g1k(ik) > kg1 .or. neg > np_e) psi_t = 0.d0
       if(k_symmetry(ik) == GAMMA) then ! assuming kimg == 2 when k_symmetry(ik) == GAMMA.
          do iy = 1, neg
!-F             ifrom = neordr(iy,ik)
             do ix = 2, iba(ik)
!-F                psi_t(ix,iy,1) = psi_l(ix,ifrom,ik,1)
!-F                psi_t(ix,iy,2) = psi_l(ix,ifrom,ik,2)
                psi_t(ix,iy,1) = psi_l(ix,iy,ik,1)
                psi_t(ix,iy,2) = psi_l(ix,iy,ik,2)
             end do
             psi_t(1,iy,1) = psi_l(1,iy,ik,1)
             psi_t(1,iy,2) = 0.d0
          end do
       else
          do ri = 1, kimg
             do iy = 1, neg
!-F                ifrom = neordr(iy,ik)
                do ix = 1, iba(ik)
!-F                   psi_t(ix,iy,ri) = psi_l(ix,ifrom,ik,ri)
                   psi_t(ix,iy,ri) = psi_l(ix,iy,ik,ri)
                end do
             end do
          end do
       end if
       return
    end if
                                                  __TIMER_DO_STOP(577)

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('m_ES_W_transpose_r_3D ',id_sname)

!-F add set work array for PARA3D
    psi_t = 0.d0
                                                  __TIMER_DO_START(578)
    do ri = 1, kimg
       do iy = 1, np_e
          do ix = 1, np_g1k(ik)
             psi_t(ix,iy,ri) = psi_l(ix,iy,ik,ri)
          end do
       end do
    end do
                                                  __TIMER_DO_STOP(578)
                                                  __TIMER_DO_START(579)
    if(k_symmetry(ik) == GAMMA .and. myrank_g == 0 .and. kimg == 2) then
       do iy = 1, np_e
          psi_t(1,iy,2) = 0.d0
       end do
    end if
                                                  __TIMER_DO_STOP(579)

    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(513)
  end subroutine m_ES_W_transpose_r_3D

  subroutine m_ES_W_transpose_back_r_3D(k1,k2,ik,psi_l,psi_t)

    integer, intent(in)                                       :: k1,k2,ik
!-F    real(kind=DP), intent(out),dimension(kg1,np_e,k1:k2,kimg) :: psi_l
!-F    real(kind=DP), intent(in) ,dimension(np_g1k_x,neg,kimg) :: psi_t
    real(kind=DP), intent(inout), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l  
    real(kind=DP), intent(in),dimension(np_g1k_x,np_e,kimg)   :: psi_t  

    real(kind=DP), allocatable, dimension(:,:,:,:) :: tmp_s,tmp_r
    integer, allocatable, dimension(:) :: req_s,req_r

    integer :: ri, datasize, nb_proc, j, ix,iy, ifrom,ito
    integer :: pe_s,pe_r
    integer :: mp_g1k_x
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(514)
                                                  __TIMER_DO_START(580)
    if(npes == 1) then
       do ri = 1, kimg
          do iy = 1, neg
!-F             ito = neordr(iy,ik)
             do ix = 1, iba(ik)
!-F                psi_l(ix,ito,ik,ri) = psi_t(ix,iy,ri)
                psi_l(ix,iy,ik,ri) = psi_t(ix,iy,ri)
             end do
          end do
       end do
       return
    end if
                                                  __TIMER_DO_STOP(580)

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('m_ES_W_transpose_back_r ',id_sname)

!-F add return work array for PARA3D
                                                  __TIMER_DO_START(581)
    do ri = 1, kimg
       do iy = 1, np_e
          do ix = 1, np_g1k(ik)
             psi_l(ix,iy,ik,ri) = psi_t(ix,iy,ri)
          end do
       end do
    end do
                                                  __TIMER_DO_STOP(581)

    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(514)
  end subroutine m_ES_W_transpose_back_r_3D

! -- GLOBAL --
  subroutine WSW_t_g(ik,j,mod_pot,fr,psi_t,LA,LB,LC,bpr_t,bpi_t)
    integer, intent(in)        :: ik,j,mod_pot
    real(kind=DP), intent(out) :: fr
    integer, intent(in)        :: LA,LB,LC
    real(kind=DP),intent(in)   :: psi_t(LA,LB,LC)
    real(kind=DP),intent(in),optional :: bpr_t(:,:),bpi_t(:,:)

    integer              :: ia,p,q, i, ig1
    real(kind=DP)        :: fr1
    integer :: id_sname = -1
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('WSW_t_g ',id_sname)

                                                  __TIMER_SUB_START(504)
    fr = 0.d0
    if(mod_pot == VANDERBILT_TYPE) then
       if(k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DO_START(548)
          do ia = 1, nac_p
             p = nlmta1_p(ia);     q = nlmta2_p(ia)
             fr = fr+fqwei_p(ia)*(bpr_t(p,j)*bpr_t(q,j))
          end do
                                                  __TIMER_DO_STOP(548)
       else
                                                  __TIMER_DO_START(549)
          do ia = 1, nac_p
             p = nlmta1_p(ia);     q = nlmta2_p(ia)
             fr = fr+fqwei_p(ia)*(bpr_t(p,j)*bpr_t(q,j)+bpi_t(p,j)*bpi_t(q,j))
          end do
                                                  __TIMER_DO_STOP(549)
       end if
    end if

    fr1 = 0.d0
    if(kimg == 1) then
                                                  __TIMER_DO_START(550)
       do i = 1, np_g1k(ik)                       ! MPI
          fr1 = fr1 + psi_t(i,j,1)*psi_t(i,j,1)
       end do
                                                  __TIMER_DO_STOP(550)
    else if(kimg == 2) then
       ig1 = 1; if(k_symmetry(ik) == GAMMA .and. myrank_g == 0) ig1 = 2
                                                  __TIMER_DO_START(551)
       do i = ig1, np_g1k(ik)
          fr1 = fr1 + psi_t(i,j,1)*psi_t(i,j,1) + psi_t(i,j,2)*psi_t(i,j,2)
       end do
                                                  __TIMER_DO_STOP(551)
       if(k_symmetry(ik) == GAMMA) fr1 = fr1*2.d0
       if(ig1 == 2) fr1 = fr1 + (psi_t(1,j,1)*psi_t(1,j,1))
    end if
    fr = fr+fr1
    if(nrank_g > 1) then

                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,536)
       call mpi_allreduce(MPI_IN_PLACE,fr,1,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(536)
    end if
    fr = 1.d0/dsqrt(fr)
    if(ipri >= 2 .and. (ik == 1 .or. ik == 2)) then
       write(nfout,'(" ((WSW_t_g)) ik = ",i8," fr = ",f21.15)') ik, fr
    end if
                                                  __TIMER_SUB_STOP(504)
  if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
  end subroutine WSW_t_g

! -- GLOBAL --
  subroutine normalize_bp_and_psi_t_g(ik,ibo,fr,mod_pot,psi_t,LA,LB,LC &
       & ,bpr_t,bpi_t)
    integer, intent(in)        :: ik,ibo
    real(kind=DP),intent(in)   :: fr
    integer, intent(in)        :: mod_pot,LA,LB,LC
    real(kind=DP),intent(inout),dimension(LA,LB,LC) :: psi_t
    real(kind=DP),intent(inout),optional :: bpr_t(:,:),bpi_t(:,:)

    integer                    :: ia,ri
    integer :: id_sname = -1

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('WSW_t_g ',id_sname)
                                                  __TIMER_SUB_START(506)
                                                  __TIMER_DO_START(554)
    if(mod_pot == VANDERBILT_TYPE) then
       if(k_symmetry(ik) == GAMMA) then
          do ia = 1, np_fs
             bpr_t(ia,ibo) = fr*bpr_t(ia,ibo)
          end do
       else
          do ia = 1, np_fs
             bpr_t(ia,ibo) = fr*bpr_t(ia,ibo)
             bpi_t(ia,ibo) = fr*bpi_t(ia,ibo)
          end do
       end if
    end if
                                                  __TIMER_DO_STOP(554)
                                                  __TIMER_DO_START(555)
    do ri = 1, kimg
!-F         psi_t(1:np_g1k(ik),ibo,ri) = fr * psi_t(1:np_g1k(ik),ibo,ri)
       psi_t(1:np_g1k(ik),ibo,ri) = fr * psi_t(1:np_g1k(ik),ibo,ri)
    end do
                                                  __TIMER_DO_STOP(555)
    if(ipri >= 2 .and. (ik == 1 .or. ik == 2)) then
       write(nfout,'(" ((normalize_bp_and_psi_t_g)) ik = ",i8," ibo = ",i8," fr = ",f21.15)') ik,ibo,fr
       write(nfout,'(6d14.6)') (psi_t(ia,ibo,1),ia=1, 6)
       if(kimg == 2) write(nfout,'(3d20.10)') (psi_t(ia,ibo,kimg),ia=1, 6)
    end if
                                                  __TIMER_SUB_STOP(506)
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
  end subroutine normalize_bp_and_psi_t_g

! -- GLOBAL --
  subroutine cp_bpr2bpi_g(kimg_t,i,bpr_t,bpi_t)
    integer, intent(in) :: kimg_t,i
    real(kind=DP),intent(in)           :: bpr_t(:,:)
    real(kind=DP),intent(in),optional  :: bpi_t(:,:)
    integer ::  nel
    integer :: id_sname = -1
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('cp_bpr2bpi_g ',id_sname)
    nel = min(np_fs,np_g1k_x)
    if(kimg_t == 1) then
       bp_ir(1:nel) = bpr_t(1:nel,i)
    else
       bp_ir(1:nel) = bpr_t(1:nel,i)
       bp_ii(1:nel) = bpi_t(1:nel,i)
    end if
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
  end subroutine cp_bpr2bpi_g

! -- GLOBAL --
  subroutine W1SW2_t_r_g(ik,i,NB_END,mod_pot,phi_t,LA,LB,LC &
!!$#ifndef MGS_DGEMM
       & ,phifr_t,phifi_t &
!!$#endif
       & )
    integer, intent(in)        :: ik,i, NB_END,mod_pot
    integer, intent(in)        :: LA,LB,LC
    real(kind=DP),intent(in)          :: phi_t(LA,LB,LC)
!!$#ifndef MGS_DGEMM
    real(kind=DP),intent(in),optional :: phifr_t(:,:),phifi_t(:,:)
!!$#endif

! Coded by T. Yamasaki in April 2006
! Revised according to the RIKEN phase tuning project 2009, 13 Sep 2009
! This subroutine is moved out from subroutine mgs_4_each_k_G() in a contained state.

    integer       :: j, ia, jto, p, q,  kimg_t
    real(kind=DP) :: ar, ai
    real(kind=DP), allocatable, dimension(:,:)  :: p1Sp2_t2, p1Sp2_t1  ! MPI
    character*4 F_RSVTASK
    integer       :: nt, mpant, mmdnt, ipar, ist, ied, mm

    integer :: id_sname = -1, id_sname2 = -1
    integer :: myrank_g_common
#ifndef SX
    integer :: n_unroll, jmax, ia_start
    integer :: ibsize,ibl1,ibl2
    integer :: ncache
                                                  __TIMER_SUB_START(507)
    ncache = (m_CtrlP_cachesize()*1024)*3/4
#endif

    if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r_g ',id_sname)

    myrank_g_common = myrank_g


    if(nrank_e*nrank_g > 1) then
       if((k_symmetry(ik) == GAMMA .and. kimg==2) .or. kimg == 1) then
          kimg_t = 1
       else
          kimg_t = 2
       end if
       p = NB_END-i
       allocate(p1Sp2_t2(p,kimg_t)); p1Sp2_t2 = 0.d0                  ! MPI
       allocate(p1Sp2_t1(p,kimg_t)); p1Sp2_t1 = 0.d0                  ! MPI
    end if

    p1Sp2 = 0.d0

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg == 1) then
#ifndef SX
! NEC tune ------------------------------->
          if(ncache.eq.0) then
             ibsize=nac_p
!f
             if(ibsize == 0) ibsize = 1
          else
             ibsize=ncache/(8*(NB_END*2+3))
          endif
                                                  __TIMER_DO_START(556)
          do ibl1=1,nac_p,ibsize
             ibl2=ibl1+ibsize-1
             if(ibl2.gt.nac_p) ibl2=nac_p
! NEC tune <-------------------------------
#endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#endif
#endif
!OCL NOFLTLD
             do j = i+1, NB_END
#ifdef SX
! NEC tune ------------------------------->
                ar = 0.d0
                do ia = 1, nac_p
#ifdef MGS_DGEMM
                   ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j)+bpi_tw1(ia,i)*bpi_tw2(ia,j))
#else
                   p = nlmta1_p(ia);            q = nlmta2_p(ia)
                   ar = ar + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j)+bp_ii(p)*phifi_t(q,j))
#endif
                end do
                p1Sp2(j,1) = ar
#else
! NEC tune <-------------------------------
                ar = p1Sp2(j,1)
                do ia = ibl1, ibl2
#ifdef MGS_DGEMM
                   ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j)+bpi_tw1(ia,i)*bpi_tw2(ia,j))
#else
                   p = nlmta1_p(ia);            q = nlmta2_p(ia)
                   ar = ar + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j)+bp_ii(p)*phifi_t(q,j))
#endif
                end do
                p1Sp2(j,1) = ar
#endif
            end do
#ifndef SX
! NEC tune
         end do
                                                  __TIMER_DO_STOP(556)
#endif
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
!!!$#ifdef NEC_TUNE_SMP
!!!$!CDIR PARALLEL DO private(ia,ar,p,q)
!!!$#endif
!!!$#ifdef VPP
!!!$*vocl loop, unroll(4)
!!!$#endif
!!!$!CDIR OUTERUNROLL=4
!!!$               do j = i+1, NB_END                                                ! MPI
!!!$                  ar = 0.d0
!!!$                  do ia = 1, nac_p
!!!$                     p = nlmta1_p(ia);         q = nlmta2_p(ia)
!!!$                     ar = ar + fqwei_p(ia)*(bpr_t(p,i)*bpr_t(q,j))
!!!$                  end do
!!!$                  p1Sp2(j,1) = ar
!!!$               end do
#ifdef NEC_TUNE_SMP
             call getenv('F_RSVTASK',F_RSVTASK)
             read (F_RSVTASK,'(i4)') nt
#else
             nt = 1
#endif
             mpant = (NB_END-i)/nt
             mmdnt = mod(NB_END-i,nt)

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(mm,ist,ied,ia,j,p,q)
#endif
! NEC tune
!!#ifdef NEC_TUNE_SMP
#ifdef SX
             do ipar = 1, min(nt,NB_END-i)                                            ! SX
                IF (IPAR.LE.MMDNT) THEN                                               ! SX
                   MM = MPANT+1                                                       ! SX
                ELSE                                                                  ! SX
                   MM = MPANT                                                         ! SX
                ENDIF                                                                 ! SX
                IST = (IPAR-1)*MPANT + MIN(MMDNT+1,IPAR) + i                          ! SX
                IED = IST + mm - 1                                                    ! SX
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                do ia = 1, nac_p                                                      ! SX
                   do j = IST, IED
		     ! SX
#ifdef MGS_DGEMM
                      p1Sp2(j,1) = p1Sp2(j,1) + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j))   ! SX
#else
                      p = nlmta1_p(ia);         q = nlmta2_p(ia)                      ! SX
                      p1Sp2(j,1) = p1Sp2(j,1) + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j))   ! SX
#endif
                   end do                                                             ! SX
                end do                                                                ! SX
             end do                                                                   ! SX
#else
! NEC tune ------------------------------->
             if(ncache.eq.0) then
                ibsize=nac_p
!f
                if(ibsize == 0) ibsize = 1
             else
                ibsize=ncache/(8*(NB_END*1+2))
             endif
                                                  __TIMER_DO_START(557)
!OCL NOFLTLD
             do ibl1=1,nac_p,ibsize
                ibl2=ibl1+ibsize-1
                if(ibl2.gt.nac_p) ibl2=nac_p
                do j = i+1, NB_END
                   if(ibl1.eq.1)then
                      ar=0.0d0
                   else
                      ar=p1Sp2(j,1)
                   endif
                   do ia = ibl1, ibl2
#ifdef MGS_DGEMM
                      ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j))
#else
                      p = nlmta1_p(ia);         q = nlmta2_p(ia)
                      ar = ar + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j))
#endif
                   end do
                   p1Sp2(j,1)=ar
                end do
             end do
                                                  __TIMER_DO_STOP(557)

! NEC tune <-------------------------------
#endif
          else      ! kimg==2 .and. k_symmetry(ik) /= GAMMA 
#ifndef SX
! NEC tune ------------------------------->
             if(ncache.eq.0) then
                ibsize=nac_p
!f
                if(ibsize == 0) ibsize = 1
             else
                ibsize=ncache/(8*(NB_END*4+3))
             endif
#ifdef DEBUG_MGS
             if(ipri >= 1) then
                write(nfout,'(" ibsize = ",i8," <<W1SW2_t_r>>")') ibsize
             end if
#endif
                                                  __TIMER_DO_START(558)
             do ibl1=1,nac_p,ibsize
                ibl2=ibl1+ibsize-1
                if(ibl2.gt.nac_p) ibl2=nac_p
! NEC tune <-------------------------------
#endif

#ifdef NEC_TUNE_SMP
#ifdef MGS_DGEMM
!CDIR PARALLEL DO private(ia,ar,ai)
#else
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#endif
#endif
                do j = i+1, NB_END

#ifdef SX
                   ar = 0.d0; ai = 0.d0
                   do ia = 1, nac_p
#else
                   if(ibl1.eq.1) then
                      ar = 0.d0; ai = 0.d0
                   else
                      ar = p1Sp2(j,1)
                      ai = p1Sp2(j,2)

                   end if
                   do ia = ibl1, ibl2
#endif
#ifdef MGS_DGEMM
                      ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j)+bpi_tw1(ia,i)*bpi_tw2(ia,j))
                      ai = ai + fqwei_p(ia)*(bpr_tw1(ia,i)*bpi_tw2(ia,j)-bpi_tw1(ia,i)*bpr_tw2(ia,j))
#else
                      p = nlmta1_p(ia);         q = nlmta2_p(ia)
                      ar = ar + fqwei_p(ia)*(bp_ir(p)*phifr_t(q,j)+bp_ii(p)*phifi_t(q,j))
                      ai = ai + fqwei_p(ia)*(bp_ir(p)*phifi_t(q,j)-bp_ii(p)*phifr_t(q,j))
#endif
                   end do
                   p1Sp2(j,1) = ar;  p1Sp2(j,2) = ai
                end do
#ifndef SX
! NEC tune
             end do
#endif
                                                  __TIMER_DO_STOP(558)
          end if
       end if
    end if
! --- <Psi_i|Psi_j> ---
    if(kimg == 1) then
#ifndef SX
! NEC tune ------------------------------------------------------------->
       if(ncache.eq.0) then
          ibsize=np_g1k(ik)
       else
          ibsize=ncache/(8*(NB_END*1+1))
       endif
                                                  __TIMER_DO_START(559)
       do ibl1=1,np_g1k(ik),ibsize
          ibl2=ibl1+ibsize-1
          if(ibl2.gt.np_g1k(ik)) ibl2=np_g1k(ik)
! NEC tune <-------------------------------------------------------------
#endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#endif
#endif
          do j = i+1, NB_END
#ifdef SX
! NEC tune ------------------------------------------------------------->
             do ia = 1, np_g1k(ik)                                           ! MPI
                p1Sp2(j,1) = p1Sp2(j,1) + psi_ir(ia)*phi_t(ia,j,1 ) ! MPI
#else
             ai = p1Sp2(j,1)
             do ia = ibl1, ibl2
                ai = ai + psi_ir(ia)*phi_t(ia,j,1 ) ! MPI
! NEC tune <-------------------------------------------------------------
#endif
             end do

#ifndef SX
! NEC tune
             p1Sp2(j,1)=ai
#endif

          end do

#ifndef SX
! NEC tune
       end do
#endif
                                                  __TIMER_DO_STOP(559)

    else if(kimg == 2) then
       if(k_symmetry(ik) == GAMMA) then
!!!$            if(mype /= 0) then
!!!$#ifdef NEC_TUNE_SMP
!!!$!CDIR PARALLEL DO private(ia,ar,ai,p,q)
!!!$#endif
!!!$#ifdef VPP
!!!$*vocl loop, unroll(4)
!!!$#endif
!!!$!CDIR OUTERUNROLL=4
!!!$               do j = i+1, NB_END
!!!$                  do ia = 1, np_g1k(ik)
!!!$                     ar  = psi_t(ia,i,1)
!!!$                     ai  = psi_t(ia,i,2)
!!!$                     p1Sp2(j,1) = p1Sp2(j,1)+(ar*psi_t(ia,j,1)+ai*psi_t(ia,j,2))*2.d0 ! MPI
!!!$                  end do
!!!$               end do
#ifdef NEC_TUNE_SMP
          call getenv('F_RSVTASK',F_RSVTASK)
          read (F_RSVTASK,'(i4)') nt
#else
          nt = 1
#endif

! NEC tune
!!#ifdef NEC_TUNE_SMP
#ifdef SX
          if( (NB_END-i)/nt .lt. 256 ) then

             if(myrank_g_common /= 0) then

                do j = i+1, NB_END
                   do ia = 1, np_g1k(ik)
                      ar  = psi_ir(ia)
                      ai  = psi_ii(ia)
                      p1Sp2(j,1) = p1Sp2(j,1)+(ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2))*2.d0
                   end do
                end do
             else if(myrank_g_common == 0) then

                do j = i+1, NB_END
                   do ia = 2, np_g1k(ik)
                      ar  = psi_ir(ia)
                      ai  = psi_ii(ia)
                      p1Sp2(j,1) = p1Sp2(j,1)+(ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2))*2.d0
                   end do
                   p1Sp2(j,1) = p1Sp2(j,1) + psi_ir(1)*phi_t(1,j,1)
                end do
             end if

          else

             mpant = (NB_END-i)/nt
             mmdnt = mod(NB_END-i,nt)
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(mm,ist,ied,ia,j,ar,ai)
#endif
                                                  __TIMER_DO_START(560)
             do ipar = 1, min(nt,NB_END-i)
                IF (IPAR.LE.MMDNT) THEN
                   MM = MPANT+1
                ELSE
                   MM = MPANT
                ENDIF
                IST = (IPAR-1)*MPANT + MIN(MMDNT+1,IPAR) + i
                IED = IST + mm - 1
                if(myrank_g_common /= 0) then
                     !     write(*,*)'ipar, IST, IED=', ipar, IST, IED
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                   do ia = 1, np_g1k(ik)
                      do j = IST, IED
                         ar  = psi_ir(ia)
                         ai  = psi_ii(ia)
                         p1Sp2(j,1) = p1Sp2(j,1)+(ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2))*2.d0
                      end do
                   end do
                else if(myrank_g_common == 0) then
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                   do ia = 2, np_g1k(ik)
                      do j = IST, IED
                         ar  = psi_ir(ia)
                         ai  = psi_ii(ia)
                         p1Sp2(j,1) = p1Sp2(j,1)+(ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2))*2.d0
                      end do
                   enddo
                   do j = IST, IED
                      p1Sp2(j,1) = p1Sp2(j,1) + psi_ir(1)*phi_t(1,j,1)
                   end do
                end if
             end do
                                                  __TIMER_DO_STOP(560)
          end if
! NEC tune ------------------------------------>
#else
!!$            if(ncache.eq.0) then
!!$               ibsize=np_g1k(ik)
!!$            else
!!$               ibsize=ncache/(8*(NB_END*2+2))
!!$            endif

!!$            allocate(psi_ir(np_g1k(ik)))
!!$            allocate(psi_ii(np_g1k(ik)))
!!$            do ia = 1, np_g1k(ik)
!!$               psi_ir(ia) = psi_t(ia,i,1)
!!$               psi_ii(ia) = psi_t(ia,i,2)
!!$            end do
!!$
!!$            n_unroll = 4
!!$            jto = (NB_END-i)/n_unroll
!!$            jmax = i + n_unroll*jto

          if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r(core) ',id_sname2)
          if(myrank_g_common /= 0) then
             ia_start = 1
          else if(myrank_g == 0) then
             ia_start = 2
          end if

                                                  __TIMER_DO_START(561)
          do j = i+1, NB_END
             ar=p1Sp2(j,1)
             do ia = ia_start, np_g1k(ik)
                ar = ar+(psi_ir(ia)*phi_t(ia,j,1)+psi_ii(ia)*phi_t(ia,j,2))*2.d0
             end do
             if(myrank_g_common == 0) then
                ar = ar + psi_ir(1)*phi_t(1,j,1)
             endif
             p1Sp2(j,1)=ar
          end do
                                                  __TIMER_DO_STOP(561)

!!$            do j = i+1, jmax, n_unroll
!!$               do ia = ia_start, np_g1k(ik)
!!$                  ar = psi_ir(ia)*2.d0; ai = psi_ii(ia)*2.d0
!!$                  p1Sp2(j  ,1) = p1Sp2(j  ,1) + (ar*psi_t(ia,j  ,1)+ai*psi_t(ia,j  ,2))
!!$                  p1Sp2(j+1,1) = p1Sp2(j+1,1) + (ar*psi_t(ia,j+1,1)+ai*psi_t(ia,j+1,2))
!!$                  p1Sp2(j+2,1) = p1Sp2(j+2,1) + (ar*psi_t(ia,j+2,1)+ai*psi_t(ia,j+2,2))
!!$                  p1Sp2(j+3,1) = p1Sp2(j+3,1) + (ar*psi_t(ia,j+3,1)+ai*psi_t(ia,j+3,2))
!!$               end do
!!$            end do
!!$            do j = jmax+1, neg
!!$               do ia = ia_start, np_g1k(ik)
!!$                  ar = psi_ir(ia); ai = psi_ii(ia)
!!$                  p1Sp2(j  ,1) = p1Sp2(j  ,1) + (ar*psi_t(ia,j,  1)+ai*psi_t(ia,j,  2))*2.d0
!!$               end do
!!$            end do
!!$            if(mype == 0) then
!!$               do j = i+1, neg
!!$                  p1Sp2(j,1) = p1Sp2(j,1) + psi_ir(1)*psi_t(1,j, 1)
!!$               end do
!!$            end if

          if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)
#endif
! NEC tune <------------------------------------
       else    ! kimg==2 .and. k_symmetry(ik) /= GAMMA
#ifdef SX
! NEC tune ------------------------------------>
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#endif
#endif
                                                  __TIMER_DO_START(562)
          do j = i+1, NB_END
             do ia = 1, np_g1k(ik)                                          ! MPI
                ar  = psi_ir(ia)
                ai  = psi_ii(ia)
                p1Sp2(j,1) = p1Sp2(j,1)+ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2) ! MPI
                p1Sp2(j,2) = p1Sp2(j,2)+ar*phi_t(ia,j,2)-ai*phi_t(ia,j,1) ! MPI
             end do
          end do
                                                  __TIMER_DO_STOP(562)
#else
!!$            if(ncache.eq.0) then
          ibsize=np_g1k(ik)
!!$            else
!!$!!$               ibsize=ncache/(8*(neg*2+2))
!!$               ibsize=ncache/(8*(NB_END*2+2))
!!$            endif
!!$            allocate(psi_ir(np_g1k(ik)))
!!$            allocate(psi_ii(np_g1k(ik)))
!!$            do ia = 1, np_g1k(ik)
!!$               psi_ir(ia) = psi_iri(ia,1)
!!$               psi_ii(ia) = psi_iri(ia,2)
!!$            end do

                                                  __TIMER_DO_START(563)
          do ibl1=1,np_g1k(ik),ibsize
             ibl2=ibl1+ibsize-1
             if(ibl2.gt.np_g1k(ik)) ibl2=np_g1k(ik)
             if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r(core) ',id_sname2)
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO private(ia,ar,ai,p,q)
#endif
#ifdef NEC_TUNE2
#ifndef ES
!CDIR OUTERUNROLL=4
#define _DIRECTIVE_UNROLLING_
#endif
#endif
#ifdef _DIRECTIVE_UNROLLING_
             do j = i+1, NB_END
                ar=p1Sp2(j,1)
                ai=p1Sp2(j,2)
                do ia = ibl1, ibl2
                   ar = ar+psi_ir(ia)*phi_t(ia,j,1)+psi_ii(ia)*phi_t(ia,j,2)
                   ai = ai+psi_ir(ia)*phi_t(ia,j,2)-psi_ii(ia)*phi_t(ia,j,1)
                end do
                p1Sp2(j,1)=ar
                p1Sp2(j,2)=ai
             end do
#else
             n_unroll = 4
             jto = (NB_END-i)/n_unroll
             jmax = i + n_unroll*jto
             do j = i+1, jmax, n_unroll
                do ia = ibl1, ibl2
                   ar = psi_ir(ia); ai = psi_ii(ia)
                   p1Sp2(j,1)   = p1Sp2(j,1)  +ar*phi_t(ia,j,1)  +ai*phi_t(ia,j,2)
                   p1Sp2(j,2)   = p1Sp2(j,2)  +ar*phi_t(ia,j,2)  -ai*phi_t(ia,j,1)
                   p1Sp2(j+1,1) = p1Sp2(j+1,1)+ar*phi_t(ia,j+1,1)+ai*phi_t(ia,j+1,2)
                   p1Sp2(j+1,2) = p1Sp2(j+1,2)+ar*phi_t(ia,j+1,2)-ai*phi_t(ia,j+1,1)
                   p1Sp2(j+2,1) = p1Sp2(j+2,1)+ar*phi_t(ia,j+2,1)+ai*phi_t(ia,j+2,2)
                   p1Sp2(j+2,2) = p1Sp2(j+2,2)+ar*phi_t(ia,j+2,2)-ai*phi_t(ia,j+2,1)
                   p1Sp2(j+3,1) = p1Sp2(j+3,1)+ar*phi_t(ia,j+3,1)+ai*phi_t(ia,j+3,2)
                   p1Sp2(j+3,2) = p1Sp2(j+3,2)+ar*phi_t(ia,j+3,2)-ai*phi_t(ia,j+3,1)
                end do
             end do
             do j = jmax+1, NB_END
                do ia = 1, ibl2-ibl1+1
                   ar = psi_ir(ia); ai=psi_ii(ia)
                   p1Sp2(j,1)   = p1Sp2(j,1)   + ar*phi_t(ia,j,1)+ai*phi_t(ia,j,2)
                   p1Sp2(j,2)   = p1Sp2(j,2)   + ar*phi_t(ia,j,2)-ai*phi_t(ia,j,1) 
                end do
             end do
#endif
             if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)
          end do
                                                  __TIMER_DO_STOP(563)
!!$          deallocate(psi_ii, psi_ir)
! NEC tune <------------------------------------
#endif
       end if
    end if

    if(nrank_g > 1 .and. NB_END > i ) then
                                                  __TIMER_COMM_START(537)
       do q = 1, kimg_t
          do j = 1, NB_END-i
             p = j+i
             p1Sp2_t1(j,q) = p1Sp2(p,q)
          end do
       end do
                                                  __TIMER_COMM_STOP(537)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,538)
!!$         p = (neg-i)*kimg_t
!!$         call mpi_allreduce(p1Sp2_t1, p1Sp2_t2,(neg-i)*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
       call mpi_allreduce(p1Sp2_t1, p1Sp2_t2,(NB_END-i)*kimg_t,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                  __TIMER_COMM_STOP(538)
                                                  __TIMER_COMM_START(539)
       do q = 1, kimg_t
          do j = 1, NB_END-i
             p = j+i
             p1Sp2(p,q) = p1Sp2_t2(j,q)
          end do
       end do
!!$         p1Sp2(:,1:kimg_t) = p1Sp2_t2(:,1:kimg_t)
                                                  __TIMER_COMM_STOP(539)
    end if

    if(ipri >= 2 .and. ik == 1) then
       write(nfout,'(" <<W1SW2_t>> ik = ",i9,"  i = ",i3)') ik,i
       write(nfout,'(" (real) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(j,1),j=i+1,NB_END)
! === DEBUG by tkato 2013/11/05 ================================================
       if(nrank_e*nrank_g > 1) then
! ==============================================================================
       if(kimg_t == 2) &
            & write(nfout,'(" (imag) ",6d11.3, 99(/8x,6d11.3))') (p1Sp2(j,kimg_t),j=i+1,NB_END)
! === DEBUG by tkato 2013/11/05 ================================================
       end if
! ==============================================================================
    end if
    if(nrank_e*nrank_g > 1) deallocate(p1Sp2_t1,p1Sp2_t2)
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(507)
  end subroutine W1SW2_t_r_g

! -- GLOBAL --
!-$ tune FUJITSU for block ----->>
!     13th Sep 2009
#ifdef MGS_DGEMM
  subroutine W1SW2_t_r_block_g(ik,i,i2,p1Sp2_NB,NB_END,NB_END2,kimg_t_wk &
       &  ,   mod_pot,psi_t,psi_t_dia,LA,LB,LC,bpr_tw1_dia,bpi_tw1_dia)
    integer, intent(in)        :: ik,i, i2, NB_END, NB_END2, kimg_t_wk
    integer, intent(in)        :: mod_pot,LA,LB,LC
    real(kind=DP), intent(out), dimension(NB,NB,kimg_t_wk) :: p1Sp2_NB
    real(kind=DP), intent(in), dimension(LA,LB,LC)      :: psi_t
    real(kind=DP), intent(in), dimension(LA,NB,LC)      :: psi_t_dia
    real(kind=DP), intent(in), dimension(nac_p,*),optional :: bpr_tw1_dia,bpi_tw1_dia

    real(kind=DP), allocatable, dimension(:,:) :: bpr_tw1_BLAS, bpi_tw1_BLAS ! work

    integer       :: iblk, jblk, i_NB, j_NB
    integer       :: ii, ia,  M, N, LDA, LDB, p

    integer :: id_sname = -1, id_sname2 = -1
                                                  __TIMER_SUB_START(509)
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r_block_g ',id_sname)

    p1Sp2_NB = 0.0d0
    M = NB_END2-i2+1; N = NB_END-i+1
    if(mod_pot == VANDERBILT_TYPE .and. nac_p > 0) then
       allocate(bpr_tw1_BLAS(nac_p, NB))
       bpr_tw1_BLAS = 0.0
                                                  __TIMER_DO_START(570)
!OCL NOFLTLD
       do iblk = i, NB_END
          ii = iblk - i + 1
          do ia = 1, nac_p
             bpr_tw1_BLAS(ia,ii) = fqwei_p(ia)*bpr_tw1_dia(ia,ii)
          end do
       end do
                                                  __TIMER_DO_STOP(570)
       if(k_symmetry(ik) /= GAMMA) then
          allocate(bpi_tw1_BLAS(nac_p,NB))
          bpi_tw1_BLAS = 0.d0
                                                  __TIMER_DO_START(571)
          do iblk = i, NB_END
             ii = iblk - i + 1
             do ia = 1, nac_p
                bpi_tw1_BLAS(ia,ii) = fqwei_p(ia)*bpi_tw1_dia(ia,ii)
             end do
          end do
                                                  __TIMER_DO_STOP(571)
       end if

       if(kimg==1) then
                                                  __TIMER_DGEMM_START(515)
          call DGEMM__('T','N',M,N,nac_p,1.0d0,bpr_tw2(1,i2),nac_p,bpr_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
          call DGEMM__('T','N',M,N,nac_p,1.0d0,bpi_tw2(1,i2),nac_p,bpi_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
                                                  __TIMER_DGEMM_STOP(515)
!!$                     ar = ar + fqwei_p(ia)*(bpr_t(p,i)*bpr_t(q,j)+bpi_t(p,i)*bpi_t(q,j))
       else if(kimg==2 .and. k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DGEMM_START(516)
          call DGEMM__('T','N',M,N,nac_p,1.0d0,bpr_tw2(1,i2),nac_p,bpr_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
!!$                     ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j))
                                                  __TIMER_DGEMM_STOP(516)
       else if(kimg==2 .and. k_symmetry(ik) /= GAMMA) then
                                                  __TIMER_DGEMM_START(517)
          call DGEMM__('T','N',M,N,nac_p, 1.0d0,bpr_tw2(1,i2),nac_p,bpr_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
          call DGEMM__('T','N',M,N,nac_p, 1.0d0,bpi_tw2(1,i2),nac_p,bpr_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,2),NB)
          call DGEMM__('T','N',M,N,nac_p, 1.0d0,bpi_tw2(1,i2),nac_p,bpi_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,1),NB)
          call DGEMM__('T','N',M,N,nac_p,-1.0d0,bpr_tw2(1,i2),nac_p,bpi_tw1_BLAS,nac_p,1.0d0,p1Sp2_NB(1,1,2),NB)
!!$                     ar = ar + fqwei_p(ia)*(bpr_tw1(ia,i)*bpr_tw2(ia,j)+bpi_tw1(ia,i)*bpi_tw2(ia,j))
!!$                     ai = ai + fqwei_p(ia)*(bpr_tw1(ia,i)*bpi_tw2(ia,j)-bpi_tw1(ia,i)*bpr_tw2(ia,j))
                                                  __TIMER_DGEMM_STOP(517)
       end if

       if(k_symmetry(ik) /= GAMMA) deallocate(bpi_tw1_BLAS)
       deallocate(bpr_tw1_BLAS)
    end if
! --------------------------------------
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('W1SW2_t_r_block_g(core) ',id_sname2)
    LDA = np_g1k_x; LDB = np_g1k_x
    if(kimg == 1) then
                                                  __TIMER_DGEMM_START(518)
       call DGEMM__('T','N',M,N,np_g1k(ik),1.0d0,psi_t(1,i2,1),LDA,psi_t_dia(1,1,1), LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
                                                  __TIMER_DGEMM_STOP(518)
    else if(kimg == 2 .and. k_symmetry(ik) == GAMMA ) then
                                                  __TIMER_DGEMM_START(519)
       call DGEMM__('T','N',M,N,np_g1k(ik),2.0d0,psi_t(1,i2,1),LDA,psi_t_dia(1,1,1),LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
       call DGEMM__('T','N',M,N,np_g1k(ik),2.0d0,psi_t(1,i2,2),LDA,psi_t_dia(1,1,2),LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
                                                  __TIMER_DGEMM_STOP(519)
       if (myrank_g == 0 ) then
                                                  __TIMER_DO_START(572)
          do iblk = i, NB_END                !for BLAS3
             i_NB = iblk - i + 1
             do jblk = i2, NB_END2
                j_NB = jblk - i2 + 1
!f                  p1Sp2_NB(j_NB,i_NB,1) = p1Sp2_NB(j_NB,i_NB,1) &
!f                       & - (psi_t(1,iblk,1)*psi_t(1,jblk,1)+psi_t(1,iblk,2)*psi_t(1,jblk,2)*2.d0)
                p1Sp2_NB(j_NB,i_NB,1) = p1Sp2_NB(j_NB,i_NB,1) &
                     & - (psi_t_dia(1,i_NB,1)*psi_t(1,jblk,1)+psi_t_dia(1,i_NB,2)*psi_t(1,jblk,2)*2.d0)
             end do
          end do
                                                  __TIMER_DO_STOP(572)
       end if
    else  ! kimg==2 .and. k_symmetry(ik) /= GAMMA
                                                  __TIMER_DGEMM_START(520)
       call DGEMM__('T','N',M,N,np_g1k(ik), 1.0d0,psi_t(1,i2,1),LDA,psi_t_dia(1,1,1),LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
       call DGEMM__('T','N',M,N,np_g1k(ik), 1.0d0,psi_t(1,i2,2),LDA,psi_t_dia(1,1,2),LDB,1.0d0,p1Sp2_NB(1,1,1),NB)
       call DGEMM__('T','N',M,N,np_g1k(ik), 1.0d0,psi_t(1,i2,2),LDA,psi_t_dia(1,1,1),LDB,1.0d0,p1Sp2_NB(1,1,2),NB)
       call DGEMM__('T','N',M,N,np_g1k(ik),-1.0d0,psi_t(1,i2,1),LDA,psi_t_dia(1,1,2),LDB,1.0d0,p1Sp2_NB(1,1,2),NB)
                                                  __TIMER_DGEMM_STOP(570)
    end if
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)

!-F    if(nrank_e > 1 ) then
!-F       if(ipri>=2) then
!-F          write(nfout,'(" NB_END, NB_END2, NB_END-i+1, NB_END2-i2+1, NB, kimg_t_wk = ",6i8)') &
!-F               & NB_END, NB_END2,  NB_END-i+1, NB_END2-i2+1, NB, kimg_t_wk
!-F       end if
!-F       call mpi_allreduce(MPI_IN_PLACE,p1Sp2_NB,NB*NB*kimg_t_wk,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
!-F    end if

    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(509)
  end subroutine W1SW2_t_r_block_g
#endif
!-$ tune FUJITSU for block <<-----

! -- GLOBAL --
#ifdef MGS_DGEMM
    subroutine modify_bp_and_psi_t_r_blk_g(ik,i,i2,p1Sp2_NB,NB_END,NB_END2,kimg_t_wk &
	&   , mod_pot,psi_t,psi_t_dia,LA,LB,LC,bpr_t,bpi_t,bpr_t_dia,bpi_t_dia)
      integer, intent(in) :: ik,i,i2,mod_pot,LA,LB,LC
      real(kind=DP), intent(in),  dimension(NB,NB,kimg_t_wk) :: p1Sp2_NB
      real(kind=DP), intent(inout), dimension(LA,LB,LC) :: psi_t
      real(kind=DP), intent(in), dimension(LA,NB,LC)    :: psi_t_dia
      real(kind=DP), intent(inout), optional :: bpr_t(:,:),bpi_t(:,:)
      real(kind=DP), intent(in), optional :: bpr_t_dia(:,:),bpi_t_dia(:,:)

      integer, intent(in) :: NB_END, NB_END2, kimg_t_wk
      integer       ::  N, K, LDA, LDB, LDC
      integer :: id_sname = -1
                                                  __TIMER_SUB_START(510)
      if(i == neg) return

      if(sw_timing_2ndlevel == ON) call tstatc0_begin('modify_bp_and_psi_t_r_blk_g ',id_sname)

      N = NB_END2-i2+1
      K = NB_END-i+1

      if(mod_pot == VANDERBILT_TYPE .and. np_fs.gt.0) then
         LDA = np_fs_x; LDB = NB; LDC = np_fs_x
                                                  __TIMER_DGEMM_START(521)
         call DGEMM__('N','T',np_fs,N,K,-1.0d0,bpr_t_dia(1,1),LDA,p1Sp2_NB(1,1,1),LDB,1.0d0,bpr_t(1,i2),LDC)
                                                  __TIMER_DGEMM_STOP(521)

         if(kimg == 1 .or. (kimg==2 .and. k_symmetry(ik) /= GAMMA)) then
                                                  __TIMER_DGEMM_START(522)
            call DGEMM__('N','T',np_fs,N,K,-1.0d0,bpi_t_dia(1,1),LDA,p1Sp2_NB(1,1,1),LDB, 1.0d0,bpi_t(1,i2),LDC)
                                                  __TIMER_DGEMM_STOP(522)
         end if

         if(kimg==2 .and. k_symmetry(ik) /= GAMMA) then
                                                  __TIMER_DGEMM_START(523)
            call DGEMM__('N','T',np_fs,N,K, 1.0d0,bpi_t_dia(1,1),LDA,p1Sp2_NB(1,1,2),LDB,1.0d0,bpr_t(1,i2),LDC)
            call DGEMM__('N','T',np_fs,N,K,-1.0d0,bpr_t_dia(1,1),LDA,p1Sp2_NB(1,1,2),LDB,1.0d0,bpi_t(1,i2),LDC)
                                                  __TIMER_DGEMM_STOP(523)
         end if
      end if

      LDA = np_g1k_x; LDB = NB; LDC = np_g1k_x
      if(kimg == 1) then
                                                  __TIMER_DGEMM_START(524)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,1),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,1),LDC)
                                                  __TIMER_DGEMM_STOP(524)
      else if(kimg==2 .and. k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DGEMM_START(525)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,1),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,1),LDC)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,2),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,2),LDC)
                                                  __TIMER_DGEMM_STOP(525)
      else  ! kimg == 2 .and. k_symmetry(ik) /= GAMMA
                                                  __TIMER_DGEMM_START(526)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,1),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,1),LDC)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,2),LDA,p1Sp2_NB(1,1,1),LDB,1.d0,psi_t(1,i2,2),LDC)
         call DGEMM__('N','T',np_g1k(ik),N,K, 1.d0,psi_t_dia(1,1,2),LDA,p1Sp2_NB(1,1,2),LDB,1.d0,psi_t(1,i2,1),LDC)
         call DGEMM__('N','T',np_g1k(ik),N,K,-1.d0,psi_t_dia(1,1,1),LDA,p1Sp2_NB(1,1,2),LDB,1.d0,psi_t(1,i2,2),LDC)
                                                  __TIMER_DGEMM_STOP(526)
      end if
      if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(510)
    end subroutine modify_bp_and_psi_t_r_blk_g
!-$ tune FUJITSU for block <<-----
#endif

! -- GLOBAL --
  subroutine modify_bp_and_psi_t_r_g(ik,i,NB_END,mod_pot &
       & ,psi_t,LA,LB,LC,bpr_t,bpi_t)
! Coded by T. Yamasaki in April 2006
! Revised according to the RIKEN phase tuning project 2009, 13 Sep 2009
    integer, intent(in) :: ik,i, NB_END,mod_pot
    integer, intent(in) :: LA,LB,LC
    real(kind=DP),intent(inout) :: psi_t(LA,LB,LC)
    real(kind=DP),intent(inout),optional :: bpr_t(:,:),bpi_t(:,:)

    integer             :: j,ia
    real(kind=DP) :: sr, si
#ifndef SX
    real(kind=DP) :: ar, ai
#endif
#ifdef MGS_DGEMM
    integer :: p, q
#endif
    integer :: id_sname = -1
                                                  __TIMER_SUB_START(508)
    if(i == neg) return
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('modify_bp_and_psi_t_r_g ',id_sname)

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(564)
          do j = i+1, NB_END
#ifdef SX
             do ia = 1, np_fs
                bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(j,1)*bp_ir(ia)
                bpi_t(ia,j) = bpi_t(ia,j) - p1Sp2(j,1)*bp_ii(ia)
             end do
#else
             ar=p1Sp2(j,1)
             do ia = 1, np_fs
                bpr_t(ia,j) = bpr_t(ia,j) - ar*bp_ir(ia)
                bpi_t(ia,j) = bpi_t(ia,j) - ar*bp_ii(ia)
             end do
#endif

          end do  ! j-loop
                                                  __TIMER_DO_STOP(564)
       else if(kimg == 2) then
          if(k_symmetry(ik) == GAMMA) then
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(565)
             do j = i+1, NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
                do ia = 1, np_fs
                   bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(j,1)*bp_ir(ia)
                end do
#else
                ar=p1Sp2(j,1)
                do ia = 1, np_fs
                   bpr_t(ia,j) = bpr_t(ia,j) - ar*bp_ir(ia)
                end do
! NEC tune <----------------------------------------------------------
#endif
             end do
                                                  __TIMER_DO_STOP(565)
          else  ! kimg==2, k_symmetry(ik) /= GAMMA
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(566)
             do j = i+1, NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
                do ia = 1, np_fs
                   sr  =  bp_ir(ia);     si  =  bp_ii(ia)
                   bpr_t(ia,j) = bpr_t(ia,j) - p1Sp2(j,1)*sr+p1Sp2(j,2)*si
                   bpi_t(ia,j) = bpi_t(ia,j) - p1Sp2(j,1)*si-p1Sp2(j,2)*sr
                end do
#else
                ar=p1Sp2(j,1)
                ai=p1Sp2(j,2)
                do ia = 1, np_fs
                   sr  =  bp_ir(ia);     si  =  bp_ii(ia)
                   bpr_t(ia,j) = bpr_t(ia,j) - ar*sr+ai*si
                   bpi_t(ia,j) = bpi_t(ia,j) - ar*si-ai*sr
                end do
#endif
             end do
                                                  __TIMER_DO_STOP(566)
! NEC tune <----------------------------------------------------------
          end if
       end if
    end if

    if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(567)
       do j = i+1,NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
          do ia = 1, np_g1k(ik)                 ! MPI
!!$             psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*psi_t(ia,i,1 )
             psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*psi_ir(ia )
          end do
#else
          ar=p1Sp2(j,1)
          do ia = 1, np_g1k(ik)
!!$             psi_t(ia,j,1) = psi_t(ia,j,1) - ar*psi_t(ia,i,1 )
             psi_t(ia,j,1) = psi_t(ia,j,1) - ar*psi_ir(ia)
          end do
! NEC tune <----------------------------------------------------------
#endif
       end do
                                                  __TIMER_DO_STOP(567)
    else if(kimg == 2) then
       if(k_symmetry(ik) == GAMMA) then
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(568)
          do j = i+1,NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
             do ia = 1, np_g1k(ik)
!!$                psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*psi_t(ia,i,1 )
!!$                psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(j,1)*psi_t(ia,i,2 )
                psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*psi_ir(ia)
                psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(j,1)*psi_ii(ia)
             end do
#else
             ar=p1Sp2(j,1)
             do ia = 1, np_g1k(ik)
!!$                psi_t(ia,j,1) = psi_t(ia,j,1) - ar*psi_t(ia,i,1 )
!!$                psi_t(ia,j,2) = psi_t(ia,j,2) - ar*psi_t(ia,i,2 )
                psi_t(ia,j,1) = psi_t(ia,j,1) - ar*psi_ir(ia)
                psi_t(ia,j,2) = psi_t(ia,j,2) - ar*psi_ii(ia)
             end do
! NEC tune <----------------------------------------------------------
#endif
          end do
                                                  __TIMER_DO_STOP(568)
       else   ! kimg==2 .and. k_symmetry(ik) /= GAMMA
#ifdef NEC_TUNE_SMP
!!$!CDIR PARALLEL DO PRIVATE(jto,ia,sr,si)
!!$!CDIR NOSYNC
!!$!CDIR CONCUR(BY=1)
#endif
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
                                                  __TIMER_DO_START(569)
          do j = i+1,NB_END
#ifdef SX
! NEC tune ---------------------------------------------------------->
             do ia = 1, np_g1k(ik)                ! MPI
!!$                sr  =  psi_t(ia,i,1 );   si  =  psi_t(ia,i,2 )
                sr  =  psi_ir(ia);   si  =  psi_ii(ia)
                psi_t(ia,j,1) = psi_t(ia,j,1) - p1Sp2(j,1)*sr+p1Sp2(j,2)*si
                psi_t(ia,j,2) = psi_t(ia,j,2) - p1Sp2(j,1)*si-p1Sp2(j,2)*sr
             end do
#else
             ar=p1Sp2(j,1)
             ai=p1Sp2(j,2)
             do ia = 1, np_g1k(ik)
!!$                sr  =  psi_t(ia,i,1 );   si  =  psi_t(ia,i,2 )
                sr  =  psi_ir(ia);   si  =  psi_ii(ia)
                psi_t(ia,j,1) = psi_t(ia,j,1) - ar*sr+ai*si
                psi_t(ia,j,2) = psi_t(ia,j,2) - ar*si-ai*sr
             end do
#endif
! NEC tune <----------------------------------------------------------
          end do
                                                  __TIMER_DO_STOP(569)
       end if
    end if
    if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(508)
  end subroutine modify_bp_and_psi_t_r_g


! -- GLOBAL --
  subroutine cp_psi2psii_g(ik,i)
    integer, intent(in) :: ik,i
    psi_ir(1:np_g1k(ik)) = psi_t(1:np_g1k(ik),i,1)
    if(kimg==2) psi_ii(1:np_g1k(ik)) = psi_t(1:np_g1k(ik),i,kimg)
  end subroutine cp_psi2psii_g


  subroutine mgs_phi2wf_each_k_G(ik,phi_l,mode,bsdr_l,bsdi_l,mod_pot)
    integer, intent(in)             :: ik
!!$    real(kind=DP), intent(inout)    :: phi_l(kg1,np_e,ik:ik,kimg)
    real(kind=DP),intent(inout),dimension(maxval(np_g1k),np_e,ik:ik,kimg) :: phi_l
    integer, intent(in)             :: mode,mod_pot
    real(kind=DP), optional,intent(inout), dimension(np_e,np_fs,ik:ik) :: bsdr_l,bsdi_l
!!$    real(kind=DP), optional,intent(inout), dimension(np_e,nlmta,ik:ik) :: bsdr_l,bsdi_l

    integer :: nbs, local_block, L_NB_STA, L_NB_END, in, ri, iy, ix, dsize_psi, dsize_bpri
    integer :: icount, iblk, jblk, i_NB, j_NB ,iq
    real(kind=DP),allocatable,dimension(:,:,:) :: wk_psi
    real(kind=DP),allocatable,dimension(:,:,:) :: wk_bpri
    real(kind=DP),allocatable,dimension(:,:,:) :: psi_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpr_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpi_t_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpr_tw1_dia
    real(kind=DP),allocatable,dimension(:,:) :: bpi_tw1_dia
    real(kind=DP), allocatable, dimension(:,:,:,:) :: p1Sp2_t2_NB, p1Sp2_t1_NB
!!$    real(kind=DP), allocatable, dimension(:,:,:) :: bsdr_lc, bsdi_lc

    integer ::       i, j

    real(kind=DP) :: fr
    integer :: kimg_t_wk

    real(kind=DP),allocatable,dimension(:,:)    :: phifr_t, phifi_t
    real(kind=DP),allocatable, dimension(:,:,:) :: phi_t ! d(maxval(np_g1k),np_e,kimg)
#ifdef MGS_DGEMM
    integer ::       NB_END, NB_END2, i1, i2
    real(kind=DP), allocatable, dimension(:,:,:) :: p1Sp2_NB
    integer, save :: ibsize_print = OFF
#endif

#ifdef TRANSPOSE_WITHOUT_REARRANGEMENT
    integer :: ierror
#endif
    integer :: ibl1,ibl2,ibsize,ncache
    integer  :: id_sname = -1, id_sname2 = -1, id_sname3 = -1, id_sname4 = -1, id_sname1 = -1
    if(sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G ',id_sname)

    ncache = (m_CtrlP_cachesize()*1024)*3/4


    if (sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G(1) ',id_sname1)

#ifdef TRANSPOSE_WITHOUT_REARRANGEMENT
    if(ipri>=1) write(nfout,'("A CPP definition of " &
         & ,"TRANSPOSE_WITHOUT_REARRANGEMENT can not be set for MDDAVIDSON")')
    ierror = CPP_DEFINE_ERROR
#ifdef DEBUG_ERRORS
    call phase_error_wo_filename(ierror,nfout,line=__LINE__,modulefile=__FILE__)
#else
    call phase_error_wo_filename(ierror,nfout)
#endif    
#endif

#ifdef MGS_DGEMM
    if(nblocksize_mgs_is_given) then
       NB = nblocksize_mgs
    else
       NB = nblocksize_mgs_default
    end if
    if(ipri >= 1) then
       if(ibsize_print == OFF) then
          if(nblocksize_mgs_is_given) then
             write(nfout,'(" ! nblocksize_mgs_is_given")')
          else
             write(nfout,'(" ! nblocksize_mgs_is_given is fault")')
          end if
          write(nfout,'( "! NB(=nblocksize_mgs) (mgs_phi2wf_each_k_G) = ",i8)') NB
          ibsize_print = ON
       end if
    end if
#endif

    call m_ESortho_mgs_alloc(ik)
    kimg_t_wk = 2
    if(k_symmetry(ik) == GAMMA) kimg_t_wk = 1
#ifdef MGS_DGEMM
    allocate(p1Sp2_NB(NB,NB,kimg_t_wk))
    allocate(wk_psi(mp_g1k(ik),NB,kimg) ) ; wk_psi = 0.0d0
    allocate(psi_t_dia(np_g1k_x,NB,kimg))
#endif

    dsize_psi = mp_g1k(ik)*NB*kimg
    if(mod_pot == VANDERBILT_TYPE) then
      if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
        i = 2
      else
        i = 4
      endif
      allocate( wk_bpri(i,max(mp_fs,nac_p),NB) )
      dsize_bpri = i*max(mp_fs,nac_p)*NB
    endif
    allocate( bpr_t_dia(np_fs,NB) )
    allocate( bpi_t_dia(np_fs,NB) )
    allocate( bpr_tw1_dia(nac_p,NB) )
    allocate( bpi_tw1_dia(nac_p,NB) )

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          call m_ES_F_transpose_r_3D(ista_k,iend_k,ik,fsr_l,bpr_t)    ! fsr_l -> bpr_t
          allocate(phifr_t(np_fs,np_e),phifi_t(1,1))
!!$          allocate(bsdr_lc(np_e,np_fs,ik:ik))
          call m_ES_F_transpose_r_3D(ik,    ik,    ik,bsdr_l,phifr_t) ! bsdr_l -> phifr_t
!!$          do i = 1, np_e
!!$             do j = ista_fs, iend_fs
!!$                bsdr_lc(i,j-ista_fs+1,ik) = bsdr_l(i,j,ik)
!!$             end do
!!$          end do
!!$          call m_ES_F_transpose_r_3D(ik,    ik,    ik,bsdr_lc,phifr_t) ! bsdr_l -> phifr_t
!!$#ifdef MGS_DGEMM
!!$          allocate(bpr_t_dia(np_fs_x,NB))
!!$#endif
       else
          call m_ES_F_transpose_r_3D(ista_k,iend_k,ik,fsr_l,bpr_t,fsi_l,bpi_t)  ! fs[ri]_l -> bp[ri]_t
          allocate(phifr_t(np_fs,np_e),phifi_t(np_fs,np_e))
!!$          allocate(bsdr_lc(np_e,np_fs,ik:ik),bsdi_lc(np_e,np_fs,ik:ik))
!!$          do i = 1, np_e
!!$             do j = ista_fs, iend_fs
!!$                bsdr_lc(i,j-ista_fs+1,ik) = bsdr_l(i,j,ik)
!!$                bsdi_lc(i,j-ista_fs+1,ik) = bsdi_l(i,j,ik)
!!$             end do
!!$          end do
          call m_ES_F_transpose_r_3D(ik,    ik,    ik,bsdr_l,phifr_t,bsdi_l,phifi_t)
!!$          call m_ES_F_transpose_r_3D(ik,    ik,    ik,bsdr_lc,phifr_t,bsdi_lc,phifi_t)
       end if
    end if

    allocate(phi_t(np_g1k_x,np_e,kimg))

    call m_ES_W_transpose_r_3D(ista_k,iend_k,ik,zaj_l,psi_t) ! zaj_l(ig,ie,ik,ri) -> psi_t(ig,ie,ri)
    call m_ES_W_transpose_r_3D(ik,    ik,    ik,phi_l,phi_t) ! phi_l(ig,ie,ik,ri) -> phi_t(ig,ie,ri)

    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname1)

    icount = (neg/NB+1)/nrank_e+1
!!$    allocate( p1Sp2_t2_NB(NB,NB,kimg_t_wk,icount) )
    allocate( p1Sp2_t1_NB(NB,NB,kimg_t_wk,icount) )
    
#ifdef MGS_DGEMM
    do i = 1, neg,NB
       NB_END = i + NB -1
       if( NB_END > neg ) NB_END = neg

       nbs = (i-1)/NB+1
       if( myrank_e == lrank(nbs)) then
          local_block = nbsn(nbs)
          L_NB_STA = nbsn_sta(local_block)
          L_NB_END = nbsn_end(local_block)
    if (sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G(2) ',id_sname2)
!diagonal
          do i1 = L_NB_STA, L_NB_END
             if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
                call WSW_t_g(ik,i1,mod_pot,fr,phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
                if(dabs(fr-1.d0) > DELTA) &
                     & call normalize_bp_and_psi_t_g(ik,i1,fr,mod_pot &
                     &   , phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
                !       |Phi(i)> = |Phi(i)> * fr,  <beta|Phi(i)> = <beta|Phi(i)> * fr
!x!!$          if(mod_pot == VANDERBILT_TYPE) call cp_bpr2bprtw(i1,L_NB_END)
             end if
             if(mod_pot == VANDERBILT_TYPE) call cp_bpr_bsdr2bprtw(i1,L_NB_END) 
             !                  phif[ri]_t, bp[ri]_t -> bpr_tw1, bpr_tw2
             if(i1 == neg) cycle
             call cp_psi2psii_g(ik,i1) ! psi_t(:,i,:) -> psi_ir,psi_ii
             if(mod_pot == VANDERBILT_TYPE) &
                  & call cp_bpr2bpi_g(kimg_t_wk,i1,bpr_t,bpi_t) ! -> bp_ir, bp_ii
             call W1SW2_t_r_g(ik,i1,L_NB_END,mod_pot,phi_t,np_g1k_x,np_e,kimg) ! -> p1Sp2
             call modify_bp_and_psi_t_r_g(ik,i1,L_NB_END,mod_pot &
                  & ,phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
             !                   psi_t, bpr_t, pbi_t, p1Sp2 -> psi_t, bpr_t, bpi_t
          end do   ! i1-loop
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname2)
!lower

    if (sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G(3) ',id_sname3)
!!$    call cp_psi_bpri2dias_g(ik,i,kimg_t_wk,NB,psi_t_dia,np_g1k_x,NB,kimg &
!!$         &                 ,bpr_t_dia,bpi_t_dia,np_fs_x)
          call cp_psi_bpri2dias_g1_3D() ! -> wk_psi

       endif ! myrank_e == lrank(nbs)

       call make_diagonal()  ! wk_psi -> psi_t_dia, bp[ri]_t_dia, bp[ri]_tw1_dia

       icount = 0
       p1Sp2_t1_NB = 0.0d0

       do i2 = i+NB, neg,NB
          if(NB_END == neg) cycle
          NB_END2 = i2 + NB -1
          if( NB_END2 > neg ) NB_END2 = neg

          nbs = (i2-1)/NB+1
          if( myrank_e /= lrank(nbs)) cycle
          local_block = nbsn(nbs)
          L_NB_STA = nbsn_sta(local_block)
          L_NB_END = nbsn_end(local_block)
          if(mod_pot == VANDERBILT_TYPE) call cp_bpr_bsdr2bprtw(L_NB_STA,L_NB_END)
          !                                 phif[ri]_t, bp[ri]_t -> bpr_tw1, bpr_tw2

          call W1SW2_t_r_block_g(ik,i,L_NB_STA,p1Sp2_NB,NB_END,L_NB_END,kimg_t_wk &
               & , mod_pot,phi_t,psi_t_dia,np_g1k_x,np_e,kimg,bpr_tw1_dia,bpi_tw1_dia) ! -> p1Sp2
          !X!!$            & , mod_pot,phi_t,psi_t_dia,np_g1k_x,np_e,kimg,bpr_tw1(1,i),bpi_tw1(1,i)) ! -> p1Sp2
          icount = icount + 1

          do i_NB = 1, NB
             do iq = 1, kimg_t_wk
                do j_NB = 1,NB
                   p1Sp2_t1_NB(j_NB,i_NB,iq,icount) = p1Sp2_NB(j_NB,i_NB,iq)
          end do; enddo ; enddo
       end do ! i2-looop1

       if(NB_END /= neg) then
          if(nrank_g > 1 ) then
             ix =  NB*NB*kimg_t_wk*icount
             call mpi_allreduce(MPI_IN_PLACE,p1Sp2_t1_NB,ix &
                  & ,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
          endif
       endif   !(NB_END /= neg )

       icount = 0
       do i2 = i+NB, neg,NB
          if(NB_END == neg) cycle
          NB_END2 = i2 + NB -1
          if( NB_END2 > neg ) NB_END2 = neg
          nbs = (i2-1)/NB+1
          if( myrank_e /= lrank(nbs)) cycle
          local_block = nbsn(nbs)
          L_NB_STA = nbsn_sta(local_block)
          L_NB_END = nbsn_end(local_block)
!modify2010
          icount =  icount+1
          do i_NB = 1, NB
             do iq = 1, kimg_t_wk
                do j_NB = 1, NB
                   p1Sp2_NB(j_NB,i_NB,iq) = p1Sp2_t1_NB(j_NB,i_NB,iq,icount)
          end do; enddo ; enddo

          call modify_bp_and_psi_t_r_blk_g(ik,i,L_NB_STA,p1Sp2_NB,NB_END,L_NB_END,kimg_t_wk &
               & , mod_pot,phi_t,psi_t_dia,np_g1k_x,np_e,kimg,phifr_t,phifi_t,bpr_t_dia,bpi_t_dia)
          ! phi_t, phifr_t, phifi_t, p1Sp2 -> phi_t, phifr_t, phifi_t
       end do   ! i2-loop
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname3)
    end do   ! i-loop
#else
    do i = 1, neg
       if(mode == ORTHONORMALIZATION .or. mode == NORMALIZATION) then
          call WSW_t_g(ik,i,mod_pot,fr,phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
          if(dabs(fr-1.d0) > DELTA)  &
               & call normalize_bp_and_psi_t_g(ik,i,fr,mod_pot &
               &   , phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
       end if
!!$       if(mod_pot == VANDERBILT_TYPE) call cp_bpr_bsdr2bprtw(i,neg)
!!$       if(i == neg) cycle
          call cp_psi2psii_g(ik,i) ! psi_t(:,i,:) -> psi_ir,psi_ii
       if(mod_pot == VANDERBILT_TYPE) &
            & call cp_bpr2bpi_g(kimg_t_wk,i,bpr_t,bpi_t) ! -> bp_ir, bp_ii
       call W1SW2_t_r_g(ik,i,neg,mod_pot,phi_t,np_g1k_x,np_e,kimg & ! ->p1Sp2
            & ,phifr_t,phifi_t)
       call modify_bp_and_psi_t_r_g(ik,i,neg,mod_pot &
            & ,phi_t,np_g1k_x,np_e,kimg,phifr_t,phifi_t)
       ! phi_t, psi_t, phifr_t,phifi_t,bpr_t, pbi_t, p1Sp2 -> phi_t, phifr_t,phifi_t

    end do
#endif

    if (sw_timing_2ndlevel == ON) call tstatc0_begin('mgs_phi2wf_each_k_G(4) ',id_sname4)
    call m_ES_W_transpose_back_r_3D(ik,ik,ik,phi_l,phi_t)  ! phi_t -> phi_l
    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          call m_ES_F_transpose_back_r_3D(ik,ik,ik,bsdr_l,phifr_t)
!!$          call m_ES_F_transpose_back_r_3D(ik,ik,ik,bsdr_lc,phifr_t)
!!$          bsdr_l(:,:,ik) = 0.d0
!!$          do i = 1, np_e
!!$             do j = ista_fs, iend_fs
!!$                bsdr_l(i,j,ik) = bsdr_lc(i,j-ista_fs+1,ik)
!!$             end do
!!$          end do
!!$          call mpi_allreduce(MPI_IN_PLACE,bsdr_l(1,1,ik),np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!!$          deallocate(bsdr_lc)
       else
          call m_ES_F_transpose_back_r_3D(ik,ik,ik,bsdr_l,phifr_t,bsdi_l,phifi_t)
!!$          call m_ES_F_transpose_back_r_3D(ik,ik,ik,bsdr_lc,phifr_t,bsdi_lc,phifi_t)
!!$          bsdr_l(:,:,ik) = 0.d0
!!$          bsdi_l(:,:,ik) = 0.d0
!!$          do i = 1, np_e
!!$             do j = ista_fs, iend_fs
!!$                bsdr_l(i,j,ik) = bsdr_lc(i,j-ista_fs+1,ik)
!!$                bsdi_l(i,j,ik) = bsdi_lc(i,j-ista_fs+1,ik)
!!$             end do
!!$          end do
!!$          call mpi_allreduce(MPI_IN_PLACE,bsdr_l(1,1,ik),np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!!$          call mpi_allreduce(MPI_IN_PLACE,bsdi_l(1,1,ik),np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!!$          deallocate(bsdr_lc,bsdi_lc)
       end if
    end if

    if(mod_pot == VANDERBILT_TYPE) then
       if(kimg_t_wk == 1) then
          deallocate(phifr_t)
       else
          deallocate(phifr_t,phifi_t)
       end if
    end if

    deallocate(p1Sp2_t1_NB)
    deallocate(phi_t)
    deallocate(bpi_tw1_dia,bpr_tw1_dia)
    deallocate(bpi_t_dia,bpr_t_dia)
    if(mod_pot == VANDERBILT_TYPE) deallocate(wk_bpri)
#ifdef MGS_DGEMM
    deallocate(psi_t_dia)
    deallocate(wk_psi)
    deallocate(p1Sp2_NB)
#endif

    call m_ESortho_mgs_dealloc
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname4)
    if (sw_timing_2ndlevel == ON) call tstatc0_end(id_sname)
  contains
!!$#ifdef MGS_DGEMM
!!$    subroutine cp_bpr2bprtw(i1,i2)
!!$      integer, intent(in) :: i1,i2
!!$      integer :: i, ia, p, q, i_last
!!$      i_last = i2
!!$      if(k_symmetry(ik) == GAMMA) then
!!$         do i = i1, i_last
!!$            do ia = 1, nac_p
!!$               p = nlmta1_p(ia);     q = nlmta2_p(ia)
!!$               bpr_tw1(ia,i) = bpr_t(p,i)
!!$               bpr_tw2(ia,i) = bpr_t(q,i)
!!$            end do
!!$         end do
!!$      else
!!$         do i = i1, i_last
!!$            do ia = 1, nac_p
!!$               p = nlmta1_p(ia);     q = nlmta2_p(ia)
!!$               bpr_tw1(ia,i) = bpr_t(p,i)
!!$               bpr_tw2(ia,i) = bpr_t(q,i)
!!$               bpi_tw1(ia,i) = bpi_t(p,i)
!!$               bpi_tw2(ia,i) = bpi_t(q,i)
!!$            end do
!!$         end do
!!$      end if
!!$    end subroutine cp_bpr2bprtw
!!$#endif

#ifdef MGS_DGEMM
    subroutine make_diagonal()
      integer :: ri,ix,iy

      if(nrank_e > 1) then
         call mpi_bcast(wk_psi,dsize_psi,mpi_double_precision,lrank(nbs),mpi_kg_world,ierr)
      end if
      do ri = 1, kimg
         do iy = 1, NB
            do ix = 1, np_g1k(ik)
               psi_t_dia(ix,iy,ri) = wk_psi(ix,iy,ri)
            end do
         end do
      end do

      if(mod_pot == VANDERBILT_TYPE) then
         if(nrank_e > 1) then
            call mpi_bcast(wk_bpri,dsize_bpri &
                 & ,mpi_double_precision,lrank(nbs),mpi_kg_world,ierr)
         end if
         if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
            do iy = 1, NB
               do ix = 1, np_fs
                  bpr_t_dia(ix,iy) = wk_bpri(1,ix,iy)
               enddo
               do ix = 1, nac_p
                  bpr_tw1_dia(ix,iy) = wk_bpri(2,ix,iy)
               enddo
            enddo
         else
            do iy = 1, NB
               do ix = 1, np_fs
                  bpr_t_dia(ix,iy) = wk_bpri(1,ix,iy)
                  bpi_t_dia(ix,iy) = wk_bpri(2,ix,iy)
               enddo
               do ix = 1, nac_p
                  bpr_tw1_dia(ix,iy) = wk_bpri(3,ix,iy)
                  bpi_tw1_dia(ix,iy) = wk_bpri(4,ix,iy)
               enddo
            enddo
         end if
      end if
    end subroutine make_diagonal

    subroutine cp_psi_bpri2dias_g1_3D()
      integer :: ri,i1,ix,iy

      do ri = 1, kimg
         do i1 = L_NB_STA, L_NB_END
            iy = i1-L_NB_STA+1
            do ix = 1, np_g1k(ik)
               wk_psi(ix,iy,ri) = psi_t(ix,i1,ri)
            enddo
         enddo
      enddo

      if(mod_pot == VANDERBILT_TYPE) then
         if((k_symmetry(ik) == GAMMA .and. kimg == 2)) then
            do i1 = L_NB_STA, L_NB_END
               iy = i1-L_NB_STA+1
               do ix = 1, np_fs
                  wk_bpri(1,ix,iy) = bpr_t(ix,i1)
               enddo
               do ix = 1, nac_p
                  wk_bpri(2,ix,iy) = bpr_tw1(ix,i1)
               enddo
            enddo
         else
            do i1 = L_NB_STA, L_NB_END
               iy = i1-L_NB_STA+1
               do ix = 1, np_fs
                  wk_bpri(1,ix,iy) = bpr_t(ix,i1)
                  wk_bpri(2,ix,iy) = bpi_t(ix,i1)
               enddo
               do ix = 1, nac_p
                  wk_bpri(3,ix,iy) = bpr_tw1(ix,i1)
                  wk_bpri(4,ix,iy) = bpi_tw1(ix,i1)
               enddo
            enddo
         end if
      end if
    end subroutine cp_psi_bpri2dias_g1_3D

    subroutine cp_bpr_bsdr2bprtw(i1,i2)
      integer, intent(in) :: i1,i2
      integer :: i, ia, p, q, i_last
#ifdef MGS_DGEMM_DEBUG
      i_last = i1
#else
      i_last = i2
#endif
      if(k_symmetry(ik) == GAMMA) then
         do i = i1, i_last
            do ia = 1, nac_p
               p = nlmta1_p(ia);     q = nlmta2_p(ia)
               bpr_tw1(ia,i) = bpr_t(p,i)
               bpr_tw2(ia,i) = phifr_t(q,i)
            end do
         end do
      else
         do i = i1, i_last
            do ia = 1, nac_p
               p = nlmta1_p(ia);     q = nlmta2_p(ia)
               bpr_tw1(ia,i) = bpr_t(p,i)
               bpr_tw2(ia,i) = phifr_t(q,i)
               bpi_tw1(ia,i) = bpi_t(p,i)
               bpi_tw2(ia,i) = phifi_t(q,i)
!!$               bpr_tw1(ia,i) = phifr_t(p,i)
!!$               bpr_tw2(ia,i) = bpr_t(q,i)
!!$               bpi_tw1(ia,i) = phifi_t(p,i)
!!$               bpi_tw2(ia,i) = bpi_t(q,i)
            end do
         end do
      end if
    end subroutine cp_bpr_bsdr2bprtw
#endif
  end subroutine mgs_phi2wf_each_k_G

!******************** modified by RIST_16
  subroutine WSW_for_overlap_t_g(ik,ito,jto,fr,fi,bpr_t,bpi_t)
    use m_Electronic_Structure, only : fsr_l, fsi_l
    integer, intent(in)        :: ik,ito,jto
    real(kind=DP), intent(out) :: fr,fi
    real(kind=DP),intent(in),optional :: bpr_t(:,:),bpi_t(:,:)
    real(kind=DP),allocatable :: bpr(:,:),bpi(:,:)

    integer              :: ia,p,q, i, ig1,ib
    integer :: id_sname = -1
    allocate(bpr(np_fs,neg))
    if(.not.(k_symmetry(ik)==GAMMA.and.kimg == 2)) allocate(bpi(np_fs,neg))
    bpr=0.d0 
    do ib = 1,np_e
       do i = 1, np_fs
          !bpr  (i,ib) = fsr_l(ib-ista_e+1,i,ik)
          bpr  (i,neg_g(ib)) = bpr_t(ib,i)
       end do
    end do
    call mpi_allreduce(MPI_IN_PLACE,bpr,  np_fs*neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
    if(allocated(bpi)) then
      bpi=0.d0
      do ib = 1,np_e
         do i = 1, np_fs
            !bpi  (i,ib) = fsi_l(ib-ista_e+1,i,ik)
            bpi  (i,neg_g(ib)) = bpi_t(ib,i)
         end do
      end do
      call mpi_allreduce(MPI_IN_PLACE,bpi,  np_fs*neg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_kg_world,ierr)
    endif

    fr = 0.d0
    fi = 0.d0
    if(k_symmetry(ik) == GAMMA .and. kimg == 2) then
       do ia = 1, nac_p
          p = nlmta1_p(ia);     q = nlmta2_p(ia)
          fr = fr+fqwei_p(ia)*(bpr(p,jto)*bpr(q,ito))
       end do
    else
       do ia = 1, nac_p
          p = nlmta1_p(ia);     q = nlmta2_p(ia)
          fr = fr+fqwei_p(ia)*(bpr(p,jto)*bpr(q,ito)+bpi(p,jto)*bpi(q,ito))
          fi = fi+fqwei_p(ia)*(bpr(p,jto)*bpi(q,ito)-bpi(p,jto)*bpr(q,ito))
       end do
    end if
    !call mpi_allreduce(MPI_IN_PLACE,fr,1,mpi_double_precision,MPI_SUM,mpi_ke_world,ierr)
    !if(allocated(bpi)) &
    !&  call mpi_allreduce(MPI_IN_PLACE,fi,1,mpi_double_precision,MPI_SUM,mpi_ke_world,ierr)
    deallocate(bpr)
    if(allocated(bpi)) deallocate(bpi)
  end subroutine WSW_for_overlap_t_g
end module m_ES_ortho

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 577 $)
!
!  SUBROUINE: ChargeDensity_Mixing
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine ChargeDensity_Mixing
! $Id: ChargeDensity_Mixing.F90 577 2017-12-15 05:26:08Z jkoga $
  use m_Const_Parameters,    only : DP,SIMPLE,BROYD1,BROYD2,DFP,PULAY,RMM2P,ON &
       &                          , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, CONTINUATION, SKIP
  use m_Charge_Density,      only : m_CD_check
  use m_CD_mixing,           only : m_CD_simple_mixing, m_CD_prepare_precon &
       &                           ,m_CD_mix_broyden1,m_CD_mix_broyden2,m_CD_mix_DFP &
       &                           ,m_CD_mix_pulay, m_CD_simple_mixing_hsr
  use m_Ionic_System,        only : natm
  use m_Total_Energy,        only : m_TE_what_is_edeltb_now, m_TE_wd_total_energy_with_solvers
  use m_Control_Parameters,  only : c_precon,waymix,intzaj,icond &
       &                          , tag_solver_of_WF_is_found &
       &                          , tag_charge_mixing_is_found &
       &                          , iprichargemixing, nspin, af &
       &                          , m_CtrlP_rmx_now &
       &                          , m_CtrlP_solver_for_WFs_now &
       &                          , m_CtrlP_set_rmx &
       &                          , m_CtrlP_waymix_now &
       &                          , m_CtrlP_set_mix_parameter &
       &                          , m_CtrlP_clear_cdmixing_applied &
       &                          , sw_hubbard, sw_mix_occ_matrix
  use m_Files,               only : nfout
  use m_IterationNumbers,    only : iteration_electronic, iteration_ionic &
       &                          , m_Iter_cmix_reset
  use m_Orbital_Population,  only : m_OP_simple_mixing, m_OP_mix_broyden1 &
       &                          , m_OP_mix_broyden2, m_OP_mix_DFP, m_OP_mix_pulay
  use m_PseudoPotential,     only : flg_paw, modnrm
! ================================= added by K. Tagami =============== 5.0
  use m_Const_Parameters,    only : OFF
  use m_Control_Parameters,  only : sw_update_charge_total, &
       &                            sw_mix_charge_hardpart, occ_matrix_mixfactor
  use m_Charge_Density,      only : m_CD_cp_hsr_to_hsro
  use m_CD_mixing,           only : m_CD_mix_broyden2_with_hsr, m_CD_mix_pulay_with_hsr &
                                  , m_CD_simple_mixing_hard
  use m_IterationNumbers,     only : iteration, iteration_for_cmix
  use m_Orbital_Population,    only :  m_OP_cp_om_to_ommix
! ==================================================================== 5.0

! ================================= added by K. Tagami ================== 11.0&13.0U
  use m_Control_Parameters,   only : noncol, SpinOrbit_mode
  use m_Charge_Density,       only : m_CD_check_noncl
  use m_CD_Mag_Moment,        only : m_CD_calc_ChgMagMom_in_sphere, &
       &                             m_CD_print_ChgMagmom_on_atom, &
       &                             m_CD_estim_magmom_local, &
       &                             m_CD_print_magmom_local, &
       &                             m_CD_set_rad_cov_now, &
       &                             m_CD_set_rad_cov_default, &
       &                             sw_monitor_atomcharge
  use m_Const_Parameters,      only : Neglected
#ifndef WO_OP_MOMENT
  use m_OP_Moment,             only : m_OP_calc_orbmom_from_OCC
#endif
! ======================================================================== 11.0&13.0U


! === KT_add ========== 13.0U2-3, 13.0XX
  use m_Control_Parameters,  only : sw_modified_TFW_functional, hardpart_mixfactor, &
       &                            precon_hardpart, sw_wf_mixing, &
       &                            wf_mixing_is_active, &
       &                            recover_wf_after_mixing
  use m_Kpoints,         only : kv3
  use m_ES_WF_mixing,     only : m_ES_WF_precon_hsr, m_ES_WF_kerker_mixing
  use m_Charge_Density,     only : m_CD_hardpart_hsr, m_CD_hardpart_hsr_noncl
! ===================== 13.0U2-3, 13.0XX

! ==== KT_add === 2014/09/01
  use m_Control_Parameters, only : sw_calc_orbital_moment, sw_use_add_proj, &
       &                          Orbital_decomp_mode
  use m_Charge_Density,    only : m_CD_hardpart_hsr_add, m_CD_hardpart_hsr_add_noncl
  use m_CD_Mag_Moment,   only : m_CD_calc_SpinMagMom_method2
  use m_OP_Moment,  only :        m_OP_calc_OrbMagMom_method2
! =============== 2014/09/01

! === KT_add ==== 2014/09/19
  use m_Control_Parameters,  only : sw_calc_ekin_density, ekin_density_type, &
       &                            sw_mix_charge_with_ekindens
  use m_CD_mixing,  only : m_CD_mix_broyden2_intg, m_CD_mix_pulay_intg, &
       &                   m_CD_simple_mixing_intg
  use m_KE_mixing,  only : m_KE_simple_mixing, m_KE_mix_broyden2, m_KE_mix_pulay, &
       &                   m_KE_prepare_precon, &
       &                   m_KE_simple_mixing_00, m_KE_kerker_mixing, &
       &                   m_KE_set_pointer_ekinq_00, m_KE_set_pointer_ekinq
! =============== 2014/09/19


  implicit none

  real(kind=DP) :: rmxt
  real(kind=DP) :: edeltb_per_atom
  integer,save  :: waymix_at_CDmix_previous = 0
  integer       :: waymix_at_CDmix
  logical       :: ini = .false.
  real(kind=DP) :: rmxt_tot, rmxt_hard, rmxt_occmat
#ifdef __TIMER_SUB__
    call timer_sta(1101)
#endif
  call m_CtrlP_clear_cdmixing_applied()

  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
      call procedure_charge_fixed;  return
  endif

  edeltb_per_atom = m_TE_what_is_edeltb_now()/natm 
  waymix_at_CDmix = m_CtrlP_waymix_now(iteration_electronic, iteration_ionic &
       &                             , edeltb_per_atom)
  if(tag_solver_of_WF_is_found .and. tag_charge_mixing_is_found) then
     if(waymix_at_CDmix_previous /= waymix_at_CDmix) call m_Iter_cmix_reset()
  end if

  rmxt = m_CtrlP_rmx_now(iteration_electronic, iteration_ionic)
  call m_CtrlP_set_mix_parameter()
  if(c_precon) call m_CD_prepare_precon(nfout,rmxt)
  if(iprichargemixing >= 2) &
       & write(6,'(" waymix_at_CDmix = ",i4," rmxt = ",f8.4)') waymix_at_CDmix, rmxt

  call push_cd_mixing_name_applied(waymix_at_CDmix)

! ===================== added by K. Tagami========================= 5.0
  if ( sw_update_charge_total == OFF ) then
     iteration_for_cmix = iteration_for_cmix -1
  endif
  if ( iteration <= 1 .or. (icond==CONTINUATION .and. .not.ini))then
     call m_CD_cp_hsr_to_hsro
     ini = .true.
  endif
!
  rmxt_tot = rmxt
  rmxt_hard = rmxt *hardpart_mixfactor
!
  rmxt_occmat = rmxt *occ_matrix_mixfactor
!
! === KT_add === 2014/09/19
  if ( sw_calc_ekin_density == ON .and. ekin_density_type == 0 ) then
     if ( sw_mix_charge_with_ekindens == ON ) then
        call m_KE_set_pointer_ekinq
     else
        call m_KE_set_pointer_ekinq_00
        if ( c_precon ) call m_KE_prepare_precon(nfout,rmxt)
     endif
  endif
! ============= 2014/09/19

  if ( sw_calc_ekin_density == ON .and. ekin_density_type == 0 ) then
     if ( sw_mix_charge_hardpart == OFF ) then
        call mix_charge_total_intg()
        if ( flg_paw ) call mix_charge_only_hsr          !! only exception
        if ( sw_hubbard == ON ) call mix_charge_only_occmat
     else
        if ( precon_hardpart ) call precon_hardpart_kt
        call mix_charge_total_intg()
     endif
     if ( sw_mix_charge_with_ekindens == OFF ) call mix_kinetic_energy_density()
  else
     if ( sw_update_charge_total == ON ) then
        if ( modnrm == SKIP .or. sw_mix_charge_hardpart == OFF ) then
           call mix_charge_total()
           if ( flg_paw ) call mix_charge_only_hsr          !! only exception
           if ( sw_hubbard == ON ) call mix_charge_only_occmat
        else
           if ( precon_hardpart ) call precon_hardpart_kt
           call mix_charge_total_with_hsr()
        endif
     endif
  endif
! ================================================================= 5.0

! ================================== modified by K. Tagami ========== 11.0
  if ( noncol ) then
     call m_CD_check_noncl(nfout)

! ============================ KT_mod ========== 13.0U
!     if ( iteration_ionic >1 .and. iteration_electronic ==1 ) then
!        call m_CD_set_rad_cov_default
!        call m_CD_set_rad_cov_now
!     endif
! ============================================== 13.0U

     call m_CD_calc_ChgMagMom_in_sphere
     call m_CD_print_ChgMagmom_on_atom(nfout)

! ==== KT_add === 2014/09/01
     if ( Orbital_decomp_mode == 2 ) then
        call m_CD_calc_SpinMagMom_method2
     else
        if ( .not. flg_paw ) call m_CD_estim_magmom_local(nfout)
        call m_CD_print_magmom_local(nfout)
     endif

     if ( sw_use_add_proj == ON .and. Orbital_decomp_mode == 2 ) then
        call m_CD_hardpart_hsr_add_noncl( nfout,kv3 )
     endif
     if ( sw_calc_orbital_moment == ON ) then
        if ( Orbital_decomp_mode == 2 ) call m_OP_calc_OrbMagMom_method2
     endif
! =============== 2014/09/01

     if ( SpinOrbit_mode /= Neglected ) then
#ifndef WO_OP_MOMENT
        if ( sw_hubbard == ON ) call m_OP_calc_orbmom_from_OCC
#endif
     endif

  else
     call m_CD_check(nfout)
! ============================ KT_add ========== 13.0U
     if ( sw_monitor_atomcharge == ON ) then
        call m_CD_calc_ChgMagMom_in_sphere
        call m_CD_print_ChgMagmom_on_atom(nfout)
     endif
! ============================================== 13.0U

! ==== KT_add === 2014/08/28
     if ( sw_use_add_proj == ON .and. Orbital_decomp_mode == 2 ) then
        call m_CD_hardpart_hsr_add( nfout,kv3 )
     endif
! =============== 2014/08/28
  endif
! =================================================================== 11.0


  if(tag_solver_of_WF_is_found .and. tag_charge_mixing_is_found) then
     waymix_at_CDmix_previous = waymix_at_CDmix
  end if

#ifdef __TIMER_SUB__
    call timer_end(1101)
#endif

! ========== KT_add ========== 13.0U2
  if ( sw_modified_TFW_functional == ON ) call ThomasFermiWeiz_loop
! ============================ 13.0U2

  call m_TE_wd_total_energy_with_solvers(nfout)

contains

  subroutine mix_charge_total()
    mixing_way: select case(waymix_at_CDmix)
    case (SIMPLE)
       call m_CD_simple_mixing(nfout,rmxt_tot)
    case (BROYD1)
       call m_CD_mix_broyden1(rmxt_tot)
    case (BROYD2)
       call m_CD_mix_broyden2(nfout,rmxt_tot)
    case (DFP)
       call m_CD_mix_DFP(rmxt_tot)
    case (PULAY)
       call m_CD_mix_pulay(nfout,rmxt_tot)
    case default
       stop ' ! waymix is invalid'
    end select mixing_way

  end subroutine mix_charge_total

  subroutine mix_charge_only_hsr
     call m_CD_simple_mixing_hsr(nfout,rmxt)
  end subroutine mix_charge_only_hsr

  subroutine mix_charge_only_occmat
    mixing_way: select case(waymix_at_CDmix)
    case (SIMPLE)
        call m_OP_simple_mixing(nfout,rmxt_occmat)
    case (BROYD1)
        call m_OP_mix_broyden1(rmxt_occmat)
    case (BROYD2)
        call m_OP_mix_broyden2(rmxt_occmat)
    case (DFP)
        call m_OP_mix_DFP(rmxt_occmat)
    case (PULAY)
        call m_OP_mix_Pulay(rmxt_occmat)
    case default
       stop ' ! waymix is invalid'
    end select mixing_way

  end subroutine mix_charge_only_occmat

  logical function fix_occ_matrix()
    use m_Control_Parameters, only : occ_matrix_fix_period
    use m_IterationNumbers, only : iteration_electronic
    fix_occ_matrix = iteration_electronic <= occ_matrix_fix_period 
    return
  end function fix_occ_matrix

  subroutine mix_charge_total_with_hsr()
    mixing_way: select case(waymix_at_CDmix)

    case (SIMPLE)
       call m_CD_simple_mixing( nfout,rmxt_tot )
       call m_CD_simple_mixing_hard( nfout, rmxt_hard )
       if ( sw_hubbard == ON .and.sw_mix_occ_matrix==OFF ) then
          call Renewal_of_OccMat( .false., ON, fix_occ_matrix() )           ! hsr --> om 
       endif
       if (sw_hubbard==ON) call m_OP_cp_om_to_ommix( nfout, rmxt_hard )       ! om --> ommix

    case (BROYD1)
!       call m_CD_mix_broyden1_with_hsr(rmxt_tot)
       write(*,*) 'Not supported '
       stop

    case (BROYD2)
       call m_CD_mix_broyden2_with_hsr(nfout,rmxt_tot,sw_mix_occ_matrix==ON)
       if ( sw_hubbard == ON .and. sw_mix_occ_matrix==OFF ) then
          call Renewal_of_OccMat(.false., ON, fix_occ_matrix() )           ! hsr --> om 
       endif
       if(sw_hubbard==ON) call m_OP_cp_om_to_ommix( nfout, rmxt_hard )      ! om --> ommix
    case (DFP)
!       call m_CD_mix_DFP(rmxt_tot)
       write(*,*) 'Not supported '
       stop
    case (PULAY)
       call m_CD_mix_pulay_with_hsr(nfout,rmxt_tot,sw_mix_occ_matrix==ON)
       if ( sw_hubbard == ON .and. sw_mix_occ_matrix==OFF ) then
          call Renewal_of_OccMat(.false., ON, fix_occ_matrix() )           ! hsr --> om 
       endif
       if(sw_hubbard==ON) call m_OP_cp_om_to_ommix( nfout, rmxt_hard )      ! om --> ommix
    case default
       stop ' ! waymix is invalid'
    end select mixing_way
  end subroutine mix_charge_total_with_hsr

! === KT_add == 2014/09/19
  subroutine mix_charge_total_intg()
    mixing_way: select case(waymix_at_CDmix)

    case (SIMPLE)
       call m_CD_simple_mixing_intg( nfout,rmxt_tot )
       if ( sw_hubbard == ON ) then
          call Renewal_of_OccMat( .false., ON )           ! hsr --> om
          call m_OP_cp_om_to_ommix( nfout, rmxt_hard )       ! om --> ommix
       endif

    case (BROYD2)
       call m_CD_mix_broyden2_intg(nfout,rmxt_tot,sw_mix_occ_matrix==ON)
       if ( sw_hubbard == ON ) then
          call Renewal_of_OccMat(.false., ON )           ! hsr --> om
          call m_OP_cp_om_to_ommix( nfout, rmxt_hard )       ! om --> ommix
       endif
    case (PULAY)
       call m_CD_mix_pulay_intg(nfout,rmxt_tot,sw_mix_occ_matrix==ON)
       if ( sw_hubbard == ON ) then
          call Renewal_of_OccMat(.false., ON )           ! hsr --> om
          call m_OP_cp_om_to_ommix( nfout, rmxt_hard )       ! om --> ommix
       endif

    case default
       stop ' ! waymix is invalid'
    end select mixing_way

  end subroutine mix_charge_total_intg

  subroutine mix_kinetic_energy_density()
    mixing_way: select case(waymix_at_CDmix)

    case (SIMPLE)
       call m_KE_simple_mixing(nfout,rmxt_tot)
    case (BROYD2)
       call m_KE_mix_broyden2(nfout,rmxt_tot)
    case (PULAY)
       call m_KE_mix_pulay(nfout,rmxt_tot)
    case default
       stop ' ! waymix is invalid'
    end select mixing_way

  end subroutine mix_kinetic_energy_density

  subroutine procedure_charge_fixed
    if ( sw_calc_ekin_density == ON ) then
       call m_KE_simple_mixing_00( rmxt_tot )
!     call m_KE_Kerker_mixing( rmxt_tot )
    endif
  end subroutine procedure_charge_fixed
! ======= 2014/09/19

! === KT_add ======= 13.0U3
  subroutine precon_hardpart_kt
    real(kind=DP) :: threshold = 2.5D-2

    if ( sw_wf_mixing == OFF ) return
    if ( .not. wf_mixing_is_active ) return

#if 0
    if ( abs(edeltb_per_atom) > threshold ) return
#endif

    if ( sw_wf_mixing == ON ) then
!       call m_ES_WF_precon_hsr
       call m_ES_WF_kerker_mixing( .true. )
    endif

  end subroutine precon_hardpart_kt
! ================== 13.0U3

end subroutine ChargeDensity_Mixing

subroutine push_cd_mixing_name_applied(waymix)
  use m_Const_Parameters,   only :  SIMPLE , BROYD1, BROYD2, DFP, PULAY
  use m_Control_Parameters, only :  m_CtrlP_push_CDMixingNameApplied, len_cdmixingname
  implicit none
  integer, intent(in) :: waymix
  character(len=len_cdmixingname) :: cdmixname
  character*20 :: name
  integer :: len_char
  name = ""
  solver: select case(waymix)
  case (SIMPLE)
     name = "SIMPLE"
  case (BROYD1)
     name = "BROYD1"
  case (BROYD2)
     name = "BROYD2"
  case (DFP)
     name = "DFP"
  case (PULAY)
     name = "PULAY"
  case default
     name = "notDefined"
  end select solver
  len_char = len_trim(name)
  cdmixname = ""
  cdmixname(1:min(len_char,len_cdmixingname)) = name(1:min(len_char,len_cdmixingname))
  call m_CtrlP_push_CDMixingNameApplied(cdmixname,len_cdmixingname)
end subroutine push_cd_mixing_name_applied

      SUBROUTINE ZUNMTR( SIDE, UPLO, TRANS, M, N, A, LDA, TAU, C, LDC,
     $                   WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          SIDE, TRANS, UPLO
      INTEGER            INFO, LDA, LDC, LWORK, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZUNMTR overwrites the general complex M-by-N matrix C with
*
*                  SIDE = 'L'     SIDE = 'R'
*  TRANS = 'N':      Q * C          C * Q
*  TRANS = 'C':      Q**H * C       C * Q**H
*
*  where Q is a complex unitary matrix of order nq, with nq = m if
*  SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
*  nq-1 elementary reflectors, as returned by ZHETRD:
*
*  if UPLO = 'U', Q = H(nq-1) . . . H(2) H(1);
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(nq-1).
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'L': apply Q or Q**H from the Left;
*          = 'R': apply Q or Q**H from the Right.
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangle of A contains elementary reflectors
*                 from ZHETRD;
*          = 'L': Lower triangle of A contains elementary reflectors
*                 from ZHETRD.
*
*  TRANS   (input) CHARACTER*1
*          = 'N':  No transpose, apply Q;
*          = 'C':  Conjugate transpose, apply Q**H.
*
*  M       (input) INTEGER
*          The number of rows of the matrix C. M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix C. N >= 0.
*
*  A       (input) COMPLEX*16 array, dimension
*                               (LDA,M) if SIDE = 'L'
*                               (LDA,N) if SIDE = 'R'
*          The vectors which define the elementary reflectors, as
*          returned by ZHETRD.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*          LDA >= max(1,M) if SIDE = 'L'; LDA >= max(1,N) if SIDE = 'R'.
*
*  TAU     (input) COMPLEX*16 array, dimension
*                               (M-1) if SIDE = 'L'
*                               (N-1) if SIDE = 'R'
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by ZHETRD.
*
*  C       (input/output) COMPLEX*16 array, dimension (LDC,N)
*          On entry, the M-by-N matrix C.
*          On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M).
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If SIDE = 'L', LWORK >= max(1,N);
*          if SIDE = 'R', LWORK >= max(1,M).
*          For optimum performance LWORK >= N*NB if SIDE = 'L', and
*          LWORK >=M*NB if SIDE = 'R', where NB is the optimal
*          blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            LEFT, LQUERY, UPPER
      INTEGER            I1, I2, IINFO, LWKOPT, MI, NB, NI, NQ, NW
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZUNMQL, ZUNMQR
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LEFT = LSAME( SIDE, 'L' )
      UPPER = LSAME( UPLO, 'U' )
      LQUERY = ( LWORK.EQ.-1 )
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
      IF( LEFT ) THEN
         NQ = M
         NW = N
      ELSE
         NQ = N
         NW = M
      END IF
      IF( .NOT.LEFT .AND. .NOT.LSAME( SIDE, 'R' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.LSAME( TRANS, 'C' ) )
     $          THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, NQ ) ) THEN
         INFO = -7
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LWORK.LT.MAX( 1, NW ) .AND. .NOT.LQUERY ) THEN
         INFO = -12
      END IF
*
      IF( INFO.EQ.0 ) THEN
         IF( UPPER ) THEN
            IF( LEFT ) THEN
               NB = ILAENV( 1, 'ZUNMQL', SIDE // TRANS, M-1, N, M-1,
     $              -1 )
            ELSE
               NB = ILAENV( 1, 'ZUNMQL', SIDE // TRANS, M, N-1, N-1,
     $              -1 )
            END IF
         ELSE
            IF( LEFT ) THEN
               NB = ILAENV( 1, 'ZUNMQR', SIDE // TRANS, M-1, N, M-1,
     $              -1 )
            ELSE
               NB = ILAENV( 1, 'ZUNMQR', SIDE // TRANS, M, N-1, N-1,
     $              -1 )
            END IF
         END IF
         LWKOPT = MAX( 1, NW )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZUNMTR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 .OR. NQ.EQ.1 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( LEFT ) THEN
         MI = M - 1
         NI = N
      ELSE
         MI = M
         NI = N - 1
      END IF
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to ZHETRD with UPLO = 'U'
*
         CALL ZUNMQL( SIDE, TRANS, MI, NI, NQ-1, A( 1, 2 ), LDA, TAU, C,
     $                LDC, WORK, LWORK, IINFO )
      ELSE
*
*        Q was determined by a call to ZHETRD with UPLO = 'L'
*
         IF( LEFT ) THEN
            I1 = 2
            I2 = 1
         ELSE
            I1 = 1
            I2 = 2
         END IF
         CALL ZUNMQR( SIDE, TRANS, MI, NI, NQ-1, A( 2, 1 ), LDA, TAU,
     $                C( I1, I2 ), LDC, WORK, LWORK, IINFO )
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of ZUNMTR
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 577 $)
!
!  MODULE: m_ES_dos
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   May/09/2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_ES_dos
!     (m_ESdos)
! $Id: m_ES_dos.F90 577 2017-12-15 05:26:08Z jkoga $
!
! This module was originally coded by T. Yamasaki (FUJITSU Laboratories) in 2001.
! And this is transferred as match to PHASE by T. Yamasaki, 18th May. 2003.
!
  use m_Kpoints, only :              kv3, kv3_ek, qwgt,vkxyz_ek &
       &                           , np0,np2,ip20,iwt,ip2cub,nxyz_tetra,trmat &
       &                           , m_Kp_sample_mesh, qwgt_ek
  use m_Files, only :                nfout
!!$  use m_Files, only :                nfdos, nfout
  use m_Timing, only :               tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only   : ekmode, ipridos, nspin, neg, af &
       &                            ,nwd_dos_window_width &
       &                            ,deltaE_dos,  variance_dos_GaussD &
       &                            ,sw_pdos, pdos_method, norbital &
       &                            ,maxorb, l_orb, t_orb, rc_orb, k_orb &
       &                            ,sw_orb_popu,dos_subroutine &
       &                            ,ipriinputfile, printable, sw_dos
  use m_Const_Parameters, only :     DP,Hartree,BUCS,EK,SCF, ALDOS, LAYERDOS, ON, OFF, TOTAL, PAI2
  use m_Parallelization, only :      mpi_comm_group,map_ek,mype,map_e,map_k,myrank_e,myrank_k &
       &                            ,ierr,np_e,map_z,ista_e,npes, nrank_e
  use m_PseudoPotential, only :      nlmta_phi,nlmtt_phi &
       &                            ,m_PP_tell_iorb_ia_l_m_tau, qorb &
       &                            ,m_PP_tell_iorb_lmtt, ltp_phi, mtp_phi, taup_phi &
       &                            ,lmta_phi, nlmt_phi, ilmt_phi
  use m_Nonlocal_Potential,  only : norm_phig
  use m_Crystal_Structure, only   : nopr, il, univol, altv
  use m_Electronic_Structure, only : occup_l, eko_l,eko_ek,totch, neordr &
       &                           , vbm, check_if_metalic_flag, metalic_system &
       &                           , compr_l, compi_l
  
!!$ASASASASAS
  use m_Kpoints,            only : k_symmetry
  use m_Const_Parameters,   only : GAMMA
  use m_Ionic_System,       only : iproj_group, natm, ityp, cps
!!$ASASASASAS

! =================================== added by K. Tagami ============ 11.0
  use m_Const_Parameters,   only : CMPLDP
  use m_Control_Parameters,   only : ndim_spinor, ndim_magmom, ndim_chgpot, noncol
  use m_ES_NonCollinear,    only : m_ES_DensMat_To_MagMom_porb
! =================================================================== 11.0

! =================================== added by K. Tagami ============ 11.0
  use m_PseudoPotential, only :    modnrm
  use m_Parallelization, only :    ista_e,iend_e,istep_e, np_e
  use m_Control_Parameters,   only : kimg, hardpart_subroutine, &
       &                             calc_dos_magmom_contrib, sw_rspace_ldos
  use m_Const_Parameters,   only : EXECUT, ELECTRON, DIRECT, YES, NO
  use m_PlaneWaveBasisSet, only :  kgp
  use m_FFT, only :                nfft, nfftp, nfftp_nonpara, fft_box_size_WF, &
       &                           fft_box_size_CD, &
       &                           m_FFT_alloc_WF_work, m_FFT_dealloc_WF_work, &
       &                           m_FFT_CD_inverse0,   m_FFT_WF, &
       &                           m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box
  use m_Charge_Density, only :     chgq_l, chgq_enl, &
       &                           m_CD_hardpart_sub_noncl, &
       &                           m_CD_hardpart_sub2_noncl, &
       &                           m_CD_map_chgq_to_fft_box, &
       &                           m_CD_set_ylm_enl_etc, &
       &                           m_CD_dealloc_ylm_enl_etc, &
       &                           m_CD_map_chgqenl_to_fft_box_kt, &
       &                           m_CD_map_valence_charge_to_fft_box, &
       &                           m_CD_restore_chgq, m_CD_keep_retrieve_hsr
  use m_Electronic_Structure,only :m_ES_WF_in_Rspace
! =================================================================== 11.0


! =============== KT_add =============== 13.0E
  use m_Control_Parameters,  only : smearing_width_fdirac => width, width_tetra, &
       &                            orb_popu_method, sw_diagonalize_population
  use m_Electronic_Structure, only : efermi
! ====================================== 13.0E

  implicit none

  real(kind=DP),private ::                            Eminimum, Emaximum
  integer,private ::                                  nEwindows, nETailWindows
  integer,private,parameter ::                        nETailMax = 1000
  real(kind=DP),private ::                            ValenceBandMaximum
  real(kind=DP),private,parameter ::                  DeltaD = 1.d-18
  real(kind=DP),private,parameter ::                  DeltaDVBM = 1.d-4
  real(kind=DP),private ::                            sqrtDVI

!!$  real(kind=DP),public ::  deltaE_dos_GaussD = 1.d-4
!!$  real(kind=DP),public ::  variance_dos_GaussD = 1.d-6
!!$  integer,public ::        nwd_dos_window_width = 10

  real(kind=DP),private,allocatable,dimension(:,:) :: eko
  real(kind=DP),private,allocatable,dimension(:,:) :: dos
  real(kind=DP),private,allocatable,dimension(:,:) :: sumdos
  real(kind=DP),private,allocatable,dimension(:,:) :: dos_weight

! ===================== added by K. Tagami =============================== 11.0
  real(kind=DP),private,allocatable,dimension(:,:,:) :: dos_weight_noncl
! ======================================================================== 11.0

  integer, private ::                                 ndim_dos_weight1, ndim_dos_weight2

  !-- PDOS --
  real(kind=DP),private,allocatable,dimension(:,:,:,:) :: compr
  real(kind=DP),private,allocatable,dimension(:,:,:,:) :: compi
  real(kind=DP),private,allocatable,dimension(:,:) :: norm_phig_mpi
  real(kind=DP),private,allocatable,dimension(:,:,:) :: pdos
  real(kind=DP),private,allocatable,dimension(:,:,:) :: sumpdos

  character(len("pdos")),private,parameter :: tag_pdos       = "pdos"
  character(len("sw_pdos")),private,parameter :: tag_sw_pdos = "sw_pdos"
  character(len("sw_orb_popu")),private,parameter :: tag_sw_orb_popu = "sw_orb_popu"
  character(len("method")),private,parameter :: tag_method   = "method"
  character(len("element")),private,parameter :: tag_element = "element"
  character(len("orbitals")),private,parameter :: tag_orbitals = "orbitals"
  character(len("l")),private,parameter ::        tag_l    = "l"
  character(len("t")),private,parameter ::        tag_t    = "t"
  character(len("k")),private,parameter ::        tag_k    = "k"
  character(len("rc")),private,parameter ::       tag_rc   = "rc"
  character(len("projector")),private,parameter :: tag_projector = "projector"
  character(len("wavefunction")),private,parameter :: tag_wavefunction = "wavefunction"
  character(len("mulliken")),private,parameter :: tag_mulliken = "mulliken"

! -- pCOHP --
  character(len("pcohp")),private,parameter :: &
       &         tag_pcohp = "pcohp"
  character(len("sw_calc_pcohp")),private,parameter :: &
       &         tag_sw_calc_pcohp = "sw_calc_pcohp"
  character(len("atom1")),private,parameter :: &
       &         tag_atom1 = "atom1"
  character(len("max_distance_from_atom1")),private,parameter :: &
       &         tag_max_distance_from_atom1 = "max_distance_from_atom1"
!
  integer :: sw_calc_pcohp = off
  integer :: atom1_pcohp = 0
  real(kind=DP) :: max_distance_from_atom1_pcohp = 8.0d0  ! bohr

  real(kind=DP), private, allocatable :: pcohp(:,:,:,:)
  real(kind=DP), private, allocatable :: sum_pcohp(:,:,:,:)

  ! --- POSTPROCESSING ---
  character(len("Postprocessing")),private,parameter :: tag_postprocessing    = "postprocessing"

  include 'mpif.h'
contains
  subroutine m_ESdos_alloc_dos_weight()
    if(.not.allocated(dos_weight)) then
       if(ekmode == ON) then
          allocate(dos_weight(neg,kv3_ek))
       else if(ekmode == OFF) then
          allocate(dos_weight(neg,kv3))
       end if
    end if
  end subroutine m_ESdos_alloc_dos_weight

  subroutine m_ESdos_dealloc_dos_weight()
    if(allocated(dos_weight)) deallocate(dos_weight)
  end subroutine m_ESdos_dealloc_dos_weight

! ========================= added by K. Tagami =============== 11.0
  subroutine m_ESdos_alloc_dos_wght_noncl()
    if (.not.allocated(dos_weight_noncl)) then
       if (ekmode == ON) then
          allocate( dos_weight_noncl(neg,kv3_ek,ndim_magmom) )
       else if (ekmode == OFF) then
          allocate( dos_weight_noncl(neg,kv3,ndim_magmom) )
       end if
       dos_weight_noncl = 0.0d0
    end if
  end subroutine m_ESdos_alloc_dos_wght_noncl

  subroutine m_ESdos_dealloc_dos_wght_noncl()
    if (allocated(dos_weight_noncl)) deallocate(dos_weight_noncl)
  end subroutine m_ESdos_dealloc_dos_wght_noncl
! ================================================================ 11.0

  subroutine m_ESdos_put_dos_weight(ne,nk,dos_weight_from)
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(in), dimension(ne,nk) :: dos_weight_from
    if(.not.allocated(dos_weight)) &
         & stop ' dos_weight is not allocated <<m_ESdos_put_dos_weight>>'

    if(ekmode == ON) then
       if( ne /= neg .or. nk /= kv3_ek) then
          write(nfout,'(" !ldos ne /= neg or nk /= kv3_ek ",&
               & ": ne, neg, nk, kv3_ek = ",4i6," <<m_ESdos_put_dos_weight>>")') ne,neg,nk,kv3_ek
          stop ' ne /= neg or nk /= kv3_ek <<m_ESdos_put_dos_weight>>'
       end if
    else if(ekmode == OFF) then
       if( ne /= neg .or. nk /= kv3) then
          write(nfout,'(" !ldos ne /= neg or nk /= kv3 ",&
               & ": ne, neg, nk, kv3 = ",4i6," <<m_ESdos_put_dos_weight>>")') ne,neg,nk,kv3
          stop ' ne /= neg or nk /= kv3 <<m_ESdos_put_dos_weight>>'
       end if
    end if
    dos_weight(:,:) = dos_weight_from(:,:)
  end subroutine m_ESdos_put_dos_weight
    
! ============================== added by K. Tagami =============== 11.0
  subroutine m_ESdos_put_dos_weight_noncl(ne,nk,dos_weight_from)
    integer, intent(in) :: ne, nk
    real(kind=DP), intent(in), dimension(ne,nk,ndim_magmom) :: dos_weight_from

    if (.not.allocated(dos_weight_noncl)) &
         & stop ' dos_weight_noncl is not allocated <<m_ESdos_put_dos_weight_noncl>>'

    if (ekmode == ON) then
       if ( ne /= neg .or. nk /= kv3_ek) then
          write(nfout,'(" !ldos ne /= neg or nk /= kv3_ek ",&
               & ": ne, neg, nk, kv3_ek = ",4i6," <<m_ESdos_put_dos_weight_nocl>>")') &
               &  ne,neg,nk,kv3_ek
          stop ' ne /= neg or nk /= kv3_ek <<m_ESdos_put_dos_weight_noncl>>'
       end if

    else if(ekmode == OFF) then
       if ( ne /= neg .or. nk /= kv3) then
          write(nfout,'(" !ldos ne /= neg or nk /= kv3 ",&
               & ": ne, neg, nk, kv3 = ",4i6," <<m_ESdos_put_dos_weight_noncl>>")') &
               &    ne,neg,nk,kv3
          stop ' ne /= neg or nk /= kv3 <<m_ESdos_put_dos_weight_noncl>>'
       end if
    end if
    dos_weight_noncl(:,:,:) = dos_weight_from(:,:,:)

  end subroutine m_ESdos_put_dos_weight_noncl
! ============================================================== 11.0

  subroutine find_Erange(ek,neg,kv)
    integer, intent(in) :: neg,kv
    real(kind=DP), intent(in) :: ek(neg,kv)
    integer :: i, is
    logical :: found
    real(kind=DP) :: DeltaE, t
    real(kind=DP) :: derfc

    DeltaE = DeltaE_dos

    Eminimum = 9999.99d0;
    Emaximum  = -9999.99d0;

    sqrtdVI = 1.d0/dsqrt(2*Variance_dos_GaussD)
    t = DeltaE * sqrtdVI  ! t = DeltaE/dsqrt(2*Variance_dos_GaussD)

    if(ipridos >= 2) then
       write(nfout,'(" Attenuation check of a Gassuian function (find_Erange)")')
       write(nfout,'(" sqrtdVI = ",f10.5," DeltaE = ",f10.5, " t = ",f10.5 )')&
         & sqrtdVI, DeltaE, t
    end if

    i = 0; found = .false.
    do while(.not.found.and.i<=nETailMax)
       i = i + 1
       found = derfc(t*i) < DeltaD
    end do
    nETailWindows = i

    if(ipridos >= 2) write(nfout,'(" nETailWindows = ",i5)') nETailWindows

    Eminimum = minval(ek)
    Emaximum = maxval(ek)
!!$    write(nfout,'(" !! minval(ek), maxval(ek) = ",2f10.6)') Eminimum, Emaximum

    i = abs(Eminimum/DeltaE) + 1
    is = sign(1.d0,Eminimum)
    Eminimum = i*DeltaE*is - nETailWindows*DeltaE

    i = abs(Emaximum/DeltaE) + 1
    is = sign(1.d0,Emaximum)
    Emaximum = i*DeltaE*is + nETailWindows*DeltaE
    nEwindows = (Emaximum - Eminimum)/DeltaE + 1

    if(ipridos >= 2) then
       write(nfout,'(" Emaximum = ",f8.4, " Eminimum = ",f8.4 &
            & , " nEwindows = ",i8)') Emaximum, Eminimum, nEwindows+2*nETailWindows
    end if

  end subroutine find_Erange

! ================================= KT_add ======================== 13.0E
  subroutine find_Erange_fermidirac(ek,neg,kv)
    integer, intent(in) :: neg,kv
    real(kind=DP), intent(in) :: ek(neg,kv)
    integer :: i, is
    logical :: found
    real(kind=DP) :: DeltaE, t
    real(kind=DP) :: xx, yy
!
    real(kind=DP) :: threshold = 1.0E-4
!
    DeltaE = DeltaE_dos

    Eminimum = 9999.99d0;    Emaximum  = -9999.99d0;
    Eminimum = minval(ek);  Emaximum = maxval(ek)

    xx = 2.0D0 *log( 2.0D0 *sqrt(1.0D0 /threshold ) )  ! width of extent of df/dx
                                                       ! f: Fermi-Dirac fn
    xx = xx *smearing_width_fdirac

    nETailWindows = xx / DeltaE +1

    i = abs(Eminimum/DeltaE) +1;  is = sign(1.d0,Eminimum)
    Eminimum = i*DeltaE*is -nETailWindows*DeltaE

    i = abs(Emaximum/DeltaE) +1;  is = sign(1.d0,Emaximum)
    Emaximum = i*DeltaE*is + nETailWindows*DeltaE

    nEwindows = (Emaximum -Eminimum)/DeltaE +1
    if(ipridos >= 2) write(nfout,'(" nETailWindows = ",i5)') nETailWindows


  end subroutine find_Erange_fermidirac
! =========================================================== 13.0E

  subroutine alloc_eko_and_substitution(kv)
    integer, intent(in) :: kv
    integer ::             ik,ie,ip,iksnl
    integer :: iorb,iopr
    real(kind=DP),allocatable, dimension(:,:) :: eko_mpi
    real(kind=DP),allocatable, dimension(:,:,:,:) :: compr_mpi
    real(kind=DP),allocatable, dimension(:,:,:,:) :: compi_mpi
    real(kind=DP),allocatable, dimension(:,:) :: norm_phig_mpi2

! ==================== added by K. Tagami ================== 11.0
#ifdef forsafe
    integer :: ksym_ik
#endif
! ========================================================== 11.0

    if(npes>=2) allocate(eko_mpi(neg,kv))
    if(npes>=2 .and. sw_pdos == ON) then
       allocate(compr_mpi(neg,nlmta_phi,nopr,kv)); compr_mpi=0.d0
       allocate(compi_mpi(neg,nlmta_phi,nopr,kv)); compi_mpi=0.d0
       allocate(norm_phig_mpi2(nlmtt_phi,kv/nspin)); norm_phig_mpi2=0.d0
    end if

    allocate(eko(neg,kv));  eko = 0.d0
    if(sw_pdos == ON) then
       allocate(compr(neg,nlmta_phi,nopr,kv));  compr = 0.d0
       allocate(compi(neg,nlmta_phi,nopr,kv));  compi = 0.d0
       if(.not.allocated(norm_phig_mpi)) allocate(norm_phig_mpi(nlmtt_phi,kv/nspin))
       norm_phig_mpi=0.d0
    end if

! Substitution eko_l for eko in the order of thier values
    do ik = 1, kv
       if(map_k(ik) /= myrank_k) cycle
! ============================= added by K. Tagami ============== 11.0
#ifdef forsafe
       ksym_ik = k_symmetry(ik)
#endif
! =============================================================== 11.0
       iksnl = (ik-1)/nspin + 1
       do ie = 1, neg
          ip = neordr(ie,ik)
          if(map_e(ip) == myrank_e) then
             eko(ie,ik) = eko_l(map_z(ip),ik)
             if(sw_pdos == ON) then
                compr(ie,1:nlmta_phi,1:nopr,ik) = compr_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
!!$ASASASASAS
!!$                compi(ie,1:nlmta_phi,1:nopr,ik) = compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik)

! ========================== modified by K. Tagami =========== 11.0
!                if ( k_symmetry(ik) /= GAMMA ) then
#ifdef forsafe
                if ( ksym_ik  /= GAMMA ) then
#else
                if ( k_symmetry(ik) /= GAMMA ) then
#endif                   
! ============================================================= 11.0
                   compi(ie,1:nlmta_phi,1:nopr,ik) = compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
                else
!                   compi = 0.0d0   
                   compi(ie,1:nlmta_phi,1:nopr,ik) = 0.0d0
                endif
!!$ASASASASAS
                norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
             end if
          end if
       end do
    end do
    if(npes >=2 ) then
       call mpi_allreduce(eko,eko_mpi,neg*kv,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       if(sw_pdos == ON) then
          call mpi_allreduce(compr,compr_mpi,neg*nlmta_phi*nopr*kv,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          call mpi_allreduce(compi,compi_mpi,neg*nlmta_phi*nopr*kv,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          call mpi_allreduce(norm_phig_mpi,norm_phig_mpi2,nlmtt_phi*kv/nspin,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          norm_phig_mpi2 = norm_phig_mpi2 / dble(nrank_e)
       end if

       eko = eko_mpi
       if(sw_pdos == ON) then
          compr = compr_mpi
          compi = compi_mpi
          norm_phig_mpi = norm_phig_mpi2
       end if
    end if
    if(ipridos >= 2) then
       ! -- writing --
       write(nfout,'(" !dos: eko <<alloc_eko_and_substitution>>")')
       do ik = 1, kv
          write(nfout,'(" !dos: ik = ",i5)') ik
          write(nfout,'(" !dos: ",10f8.4)') (eko(ie,ik),ie=1,neg)
       end do
       if(sw_pdos == ON) then
          do ik = 1, kv
             iksnl = (ik-1)/nspin + 1
             do iopr=1,nopr
                do iorb=1,nlmta_phi
                   write(nfout,'(" !dos: ik=",i5," iopr=",i5," iorb=",i5)')&
                        &  ik,iopr,iorb
                   write(nfout,'(" !dos compr: ",10f8.4)') &
                        & compr(1:neg,iorb,iopr,ik)
!!$ASASASASAS
!!$                write(nfout,'(" !dos compi: ",10f8.4)') &
!!$                              & compi(1:neg,iorb,iopr,ik)
! =========================== modified by K. Tagami ========= 11.0
!                if ( k_symmetry(ik) /= GAMMA ) then
#ifdef forsafe
                   if ( ksym_ik /= GAMMA ) then
#else
                      if ( k_symmetry(ik) /= GAMMA ) then
#endif
! =========================================================== 11.0

                         write(nfout,'(" !dos compi: ",10f8.4)') &
                              & compi(1:neg,iorb,iopr,ik)
                      endif
!!$ASASASASAS
                   end do
                end do
             write(nfout,'(" !dos norm_phig: ",10f8.4)') &
                          & norm_phig_mpi(1:nlmtt_phi,iksnl)
          end do
       end if
    end if
    if(npes>=2) then
       if(allocated(eko_mpi)) deallocate(eko_mpi)
       if(sw_pdos == ON) then
          if(allocated(compr_mpi)) deallocate(compr_mpi)
          if(allocated(compi_mpi)) deallocate(compi_mpi)
          if(allocated(norm_phig_mpi2)) deallocate(norm_phig_mpi2)
       end if
    end if
  end subroutine alloc_eko_and_substitution

! ========================= added by K. Tagami =================== 11.0
  subroutine alloc_eko_and_substit_noncl(kv)
    integer, intent(in) :: kv
    integer ::             ik,ie,ip,iksnl
    integer :: iorb,iopr
    integer :: is

#ifdef forsafe
    integer :: ksym_ik
#endif

    real(kind=DP),allocatable, dimension(:,:) :: eko_mpi
    real(kind=DP),allocatable, dimension(:,:,:,:) :: compr_mpi
    real(kind=DP),allocatable, dimension(:,:,:,:) :: compi_mpi
    real(kind=DP),allocatable, dimension(:,:) :: norm_phig_mpi2

    if(npes>=2) allocate(eko_mpi(neg,kv/ndim_spinor))

    if(npes>=2 .and. sw_pdos == ON) then
       allocate(compr_mpi(neg,nlmta_phi,nopr,kv)); compr_mpi=0.d0
       allocate(compi_mpi(neg,nlmta_phi,nopr,kv)); compi_mpi=0.d0

       allocate(norm_phig_mpi2(nlmtt_phi,kv/ndim_spinor));
       norm_phig_mpi2 = 0.d0
    end if

    allocate(eko(neg,kv/ndim_spinor));  eko = 0.d0

    if(sw_pdos == ON) then
       allocate(compr(neg,nlmta_phi,nopr,kv));  compr = 0.d0
       allocate(compi(neg,nlmta_phi,nopr,kv));  compi = 0.d0

       allocate(norm_phig_mpi(nlmtt_phi,kv/ndim_spinor));
       norm_phig_mpi=0.d0
    end if

! Substitution eko_l for eko in the order of thier values
    do ik = 1, kv, ndim_spinor

! ============================= added by K. Tagami ============== 11.0
#ifdef forsafe
       ksym_ik = k_symmetry(ik)
#endif
! =============================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/ndim_spinor + 1

       do ie = 1, neg
          ip = neordr(ie,ik)

          if (map_e(ip) == myrank_e) then
             eko( ie,iksnl ) = eko_l( map_z(ip),ik )

             if(sw_pdos == ON) then
                Do is=1, ndim_spinor
                   compr(ie,1:nlmta_phi,1:nopr,ik+is-1) &
                        & = compr_l(map_z(ip),1:nlmta_phi,1:nopr,ik+is-1)
! ========================== modified by K. Tagami =========== 11.0
!                   if ( k_symmetry(ik) /= GAMMA ) then
#ifdef forsafe
                   if ( ksym_ik  /= GAMMA ) then
#else
                   if ( k_symmetry(ik) /= GAMMA ) then
#endif
! ============================================================= 11.0
                      compi(ie,1:nlmta_phi,1:nopr,ik+is-1) &
                           & = compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik+is-1)
                   else
!                      compi = 0.0d0  
                      compi(ie,1:nlmta_phi,1:nopr,ik+is-1) = 0.0d0
                   endif
                End do
                norm_phig_mpi(1:nlmtt_phi,iksnl)  = norm_phig(1:nlmtt_phi,iksnl)
             end if

          end if
       end do
    end do
    
    if (npes >=2 ) then
       call mpi_allreduce( eko, eko_mpi, neg*kv/ndim_spinor, mpi_double_precision, &
            &              mpi_sum, mpi_comm_group, ierr )
       if (sw_pdos == ON) then
          call mpi_allreduce( compr, compr_mpi, neg*nlmta_phi*nopr*kv, &
               &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
          call mpi_allreduce( compi, compi_mpi, neg*nlmta_phi*nopr*kv, &
               &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
          call mpi_allreduce( norm_phig_mpi, norm_phig_mpi2, nlmtt_phi*kv/ndim_spinor, &
               &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
          norm_phig_mpi2 = norm_phig_mpi2 / dble(nrank_e)
       end if

       eko = eko_mpi

       if(sw_pdos == ON) then
          compr = compr_mpi;        compi = compi_mpi
          norm_phig_mpi = norm_phig_mpi2
       end if
    end if

    if(ipridos >= 2) then
       ! -- writing --
       write(nfout,'(" !dos: eko <<alloc_eko_and_substi_noncl>>")')

       do ik = 1, kv, ndim_spinor
          iksnl = (ik-1)/ndim_spinor + 1
          write(nfout,'(" !dos: ik = ",i5)') ik
          write(nfout,'(" !dos: ",10f8.4)') (eko(ie,iksnl),ie=1,neg)
       end do

       if(sw_pdos == ON) then
          do ik = 1, kv, ndim_spinor
             iksnl = (ik-1)/ndim_spinor + 1

             do iopr=1,nopr
                do iorb=1,nlmta_phi
                   write(nfout,'(" !dos: ik=",i5," iopr=",i5," iorb=",i5)')&
                        &  ik,iopr,iorb
                   write(nfout,'(" !dos compr: ",10f8.4)') &
                        & compr(1:neg,iorb,iopr,ik)
! =========================== modified by K. Tagami ========= 11.0
!                   if ( k_symmetry(ik) /= GAMMA ) then
#ifdef forsafe
                   if ( ksym_ik /= GAMMA ) then
#else
                   if ( k_symmetry(ik) /= GAMMA ) then
#endif
! =========================================================== 11.0
                      write(nfout,'(" !dos compi: ",10f8.4)') &
                           & compi(1:neg,iorb,iopr,ik)
                   endif
                end do
             end do
             write(nfout,'(" !dos norm_phig: ",10f8.4)') &
                          & norm_phig_mpi(1:nlmtt_phi,iksnl)
          end do
       end if
    end if

    if(npes>=2) then
       if(allocated(eko_mpi)) deallocate(eko_mpi)
       if(sw_pdos == ON) then
          if(allocated(compr_mpi)) deallocate(compr_mpi)
          if(allocated(compi_mpi)) deallocate(compi_mpi)
          if(allocated(norm_phig_mpi2)) deallocate(norm_phig_mpi2)
       end if
    end if

  end subroutine alloc_eko_and_substit_noncl
! =================================================================== 11.0

  subroutine alloc_eko_and_substitution_ek(kv3_ek)
    integer, intent(in) :: kv3_ek 
    integer :: ik,ie,ib,jb,ibo,jbo
    integer,allocatable,dimension(:) :: neordr_ek
    integer,parameter :: delta = 1.d-12

    allocate(eko(neg,kv3_ek))
    allocate(neordr_ek(neg))
    do ik = 1, kv3_ek
       neordr_ek = (/(ib,ib=1,neg)/)
       do ib = 1,neg-1
          do jb = ib+1, neg
             ibo = neordr_ek(ib)
             jbo = neordr_ek(jb)
             if(eko_ek(jbo,ik) < eko_ek(ibo,ik)-delta) then
                neordr_ek(jb) = ibo
                neordr_ek(ib) = jbo
             end if
          end do
       end do
! Substitution eko_ek for eko in the order of thier values
       do ie = 1, neg
          eko(ie,ik) = eko_ek(neordr_ek(ie),ik)
       end do
    end do
!!$    write(nfout,'(" !! eko (alloc_eko_and_substitution_ek)")')
!!$    do ik = 1, kv3_ek
!!$       write(nfout,'(" !! ik = ",i5, "(",3f8.4,")")') ik, (vkxyz_ek(ib,ik,BUCS),ib=1,3)
!!$       write(nfout,'("(eko_ek): ",8f10.6)') (eko_ek(ie,ik),ie=1,neg)
!!$       write(nfout,'("(eko):    ",8f10.6)') (eko(ie,ik),ie=1,neg)
!!$    end do
    deallocate(neordr_ek)
  end subroutine alloc_eko_and_substitution_ek

! ============================== added by K. Tagami ============= 11.0
  subroutine alloc_eko_and_substit_ek_noncl(kv3_ek)
    integer, intent(in) :: kv3_ek 
    integer :: ik,ie,ib,jb,ibo,jbo
    integer :: iksnl

    integer,allocatable,dimension(:) :: neordr_ek
    integer,parameter :: delta = 1.d-12

    allocate(eko(neg,kv3_ek/ndim_spinor))
    allocate(neordr_ek(neg))

    do ik = 1, kv3_ek, ndim_spinor
       iksnl = ( ik -1 ) /ndim_spinor + 1

       neordr_ek = (/(ib,ib=1,neg)/)
       do ib = 1,neg-1
          do jb = ib+1, neg
             ibo = neordr_ek(ib)
             jbo = neordr_ek(jb)
             if(eko_ek(jbo,ik) < eko_ek(ibo,ik)-delta) then
                neordr_ek(jb) = ibo
                neordr_ek(ib) = jbo
             end if
          end do
       end do
! Substitution eko_ek for eko in the order of thier values
       do ie = 1, neg
          eko(ie,iksnl) = eko_ek(neordr_ek(ie),ik)
       end do
    end do

    deallocate(neordr_ek)
  end subroutine alloc_eko_and_substit_ek_noncl
! ===================================================================== 11.0

  subroutine dealloc_eko()
    deallocate(eko)
    if(sw_pdos == ON) then
       deallocate(compr,compi)
    end if
  end subroutine dealloc_eko

  subroutine alloc_dos(i0,icomponent)
    integer,intent(in) :: i0,icomponent

! ============================== modified by K. Tagami ================= 11.0
!    allocate(dos(i0:nEwindows,nspin)); dos = 0.d0
!    allocate(sumdos(i0:nEwindows,nspin)); sumdos = 0.d0
!    if(icomponent == TOTAL .and. sw_pdos == ON) then
!       allocate(pdos(i0:nEwindows,nlmta_phi,nspin)); pdos = 0.d0
!       allocate(sumpdos(i0:nEwindows,nlmta_phi,nspin)); sumpdos = 0.d0
!    end if

    if ( noncol ) then
       allocate(dos(i0:nEwindows,ndim_magmom)); dos = 0.d0
       allocate(sumdos(i0:nEwindows,ndim_magmom)); sumdos = 0.d0
       if(icomponent == TOTAL .and. sw_pdos == ON) then
          allocate(pdos(i0:nEwindows,nlmta_phi,ndim_magmom)); pdos = 0.d0
          allocate(sumpdos(i0:nEwindows,nlmta_phi,ndim_magmom)); sumpdos = 0.d0
       end if
    else
       allocate(dos(i0:nEwindows,nspin)); dos = 0.d0
       allocate(sumdos(i0:nEwindows,nspin)); sumdos = 0.d0
       if(icomponent == TOTAL .and. sw_pdos == ON) then
          allocate(pdos(i0:nEwindows,nlmta_phi,nspin)); pdos = 0.d0
          allocate(sumpdos(i0:nEwindows,nlmta_phi,nspin)); sumpdos = 0.d0
       end if
    endif
! ========================================================================== 11.0
  end subroutine alloc_dos

  subroutine dealloc_dos()
    deallocate(dos)
    deallocate(sumdos)
    if(sw_pdos == ON) then
       if(allocated(pdos)) deallocate(pdos)
       if(allocated(sumpdos)) deallocate(sumpdos)
    end if
  end subroutine dealloc_dos

  subroutine make_dos_with_GaussianDistrib( kv, iwsc, kpt_weight )
    integer, intent(in) :: kv, iwsc
    real(kind=DP), intent(in) :: kpt_weight( kv )

    integer ::             i, ik, is, ie, id, ispin, iorb, iopr, lmtt, iksnl
    real(kind=DP) ::       Es, e, El, Eu, tl, tu, w, DeltaE
    real(kind=DP) ::       derf
    real(kind=DP) ::       porb

    DeltaE = DeltaE_dos
    Es = Eminimum - DeltaE*0.5d0
    
    if(ipridos >= 2) write(nfout,'(" !! Es, DeltaE = ",2d20.10)') Es, DeltaE
    dos = 0.d0; sumdos = 0.d0
    if(sw_pdos == ON) then
       pdos=0.d0; sumpdos=0.d0
    end if
    do ispin = 1, nspin
       do ik = ispin, kv, nspin
          iksnl = (ik-1)/nspin + 1
          do i = 1, neg
             w = 1.d0
             if(iwsc >= 1 ) w = dos_weight(i,ik)
             e = eko(i,ik) - nETailWindows*DeltaE - Es
             is = e/DeltaE
             ie = is + 2*nETailWindows
             if(is < 0) then
                if(ipridos >= 2) write(nfout,'(" is = ",i5," < 0")') is
                is = 0
             end if
             if(ie >= nEWindows ) then
                if(ipridos >= 2) write(nfout,'(" ie = ",i5, " > nEWindows")')ie
                ie = nEWindows-1
             end if
             if(ipridos >= 2) then
                write(nfout,'(" !! eko(",i3,",",i3,") = ",f10.6," is, ie = ",2i7, 2f10.6)') &
                     & i,ik, eko(i,ik),is,ie, Es+is*DeltaE, Es+ie*DeltaE
             end if

             do id = is, ie
                El = Es + id*DeltaE
                Eu = El + DeltaE
                tl = (El - eko(i,ik))*sqrtdVI
                tu = (Eu - eko(i,ik))*sqrtdVI
                !  d = (derf(tl) - derf(tu))*0.5d0/(DeltaE*kv)
                dos(id+1,ispin) = dos(id+1,ispin) &
                     & + w *2 *(derf(tu) - derf(tl)) *0.5d0 /DeltaE *kpt_weight(ik)
             end do
             if(iwsc == TOTAL .and. sw_pdos == ON) then
                do iorb = 1,nlmta_phi
                   call m_PP_tell_iorb_lmtt(iorb,lmtt)
                   porb = 0.d0
!!$ASASASASAS
!!$                do iopr=1,nopr
!!$                   porb = porb + (compr(i,iorb,iopr,ik)**2 &
!!$                        &       + compi(i,iorb,iopr,ik)**2) &
!!$                        &     *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,iksnl))
!!$                end do
                   if ( k_symmetry(ik) == GAMMA ) then
                      do iopr=1,nopr
                         porb = porb + compr(i,iorb,iopr,ik)**2  /2.0 &
                              &     *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,iksnl)*2.) )
                      end do
                   else
                      do iopr=1,nopr
                         porb = porb + (compr(i,iorb,iopr,ik)**2 &
                              &       + compi(i,iorb,iopr,ik)**2) &
                              &     *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl))
                      end do
                   endif
!!$ASASASASAS
                   porb = porb/dble(nopr)
                   do id = is, ie
                      El = Es + id*DeltaE
                      Eu = El + DeltaE
                      tl = (El - eko(i,ik))*sqrtdVI
                      tu = (Eu - eko(i,ik))*sqrtdVI
                      !  d = (derf(tl) - derf(tu))*0.5d0/(DeltaE*kv)
                      pdos(id+1,iorb,ispin) = pdos(id+1,iorb,ispin) &
                           & + porb *w *2 *(derf(tu) - derf(tl)) *0.5d0 /DeltaE &
                           &        *kpt_weight(ik)
                   end do
                end do
             end if
          end do
       end do
       sumdos(1,ispin) = dos(1,ispin)*DeltaE
       do id = 1, nEWindows-1
          sumdos(id+1,ispin) = sumdos(id,ispin) + dos(id+1,ispin)*DeltaE
       end do
       if(sw_pdos == ON) then
          do iorb = 1,nlmta_phi
             sumpdos(1,iorb,ispin) = pdos(1,iorb,ispin)*DeltaE
             do id = 1, nEWindows-1
                sumpdos(id+1,iorb,ispin) = sumpdos(id,iorb,ispin) + pdos(id+1,iorb,ispin)*DeltaE
             end do
          end do
       end if
    end do
  end subroutine make_dos_with_GaussianDistrib

! ==================================== added by K. Tagami ============== 11.0
  subroutine mkdos_with_GaussDistrib_noncl( kv, iwsc, kpt_weight )
    integer, intent(in) :: kv, iwsc
    real(kind=DP), intent(in) :: kpt_weight( kv )

    integer :: i, ik, is, ie, id, ispin, iorb, iopr, lmtt, iksnl
    integer :: is1, is2, istmp, ismax
    real(kind=DP) ::       Es, e, El, Eu, tl, tu, w, DeltaE
    real(kind=DP) ::       derf

    complex(kind=CMPLDP) :: z1, z2, ztemp

    real(kind=DP) ::       porb( nlmta_phi, ndim_magmom )
    complex(kind=CMPLDP) ::     porb_ssrep( nlmta_phi, ndim_chgpot )

    DeltaE = DeltaE_dos
    Es = Eminimum - DeltaE*0.5d0
    
    if (ipridos >= 2) write(nfout,'(" !! Es, DeltaE = ",2d20.10)') Es, DeltaE
    dos = 0.d0; sumdos = 0.d0
    if (sw_pdos == ON) then
       pdos=0.d0; sumpdos=0.d0
    end if
    
    do ik = 1, kv, ndim_spinor
       iksnl = (ik-1)/ndim_spinor + 1
       do i = 1, neg

          e = eko(i,iksnl) - nETailWindows*DeltaE - Es
          
          is = e/DeltaE
          ie = is + 2*nETailWindows
          if(is < 0) then
             if(ipridos >= 2) write(nfout,'(" is = ",i5," < 0")') is
             is = 0
          end if
          if(ie >= nEWindows ) then
             if(ipridos >= 2) write(nfout,'(" ie = ",i5, " > nEWindows")')ie
             ie = nEWindows-1
          end if
          if(ipridos >= 2) then
             write(nfout,'(" !! eko(",i3,",",i3,") = ",f10.6," is, ie = ",2i7, 2f10.6)') &
                  & i,ik, eko(i,iksnl),is,ie, Es+is*DeltaE, Es+ie*DeltaE
          end if

          if ( calc_dos_magmom_contrib == YES ) then
             ismax = ndim_magmom
          else
             ismax = 1
          endif

          Do istmp=1, ismax
             w = dos_weight_noncl(i,ik,istmp)

             do id = is, ie
                El = Es + id*DeltaE
                Eu = El + DeltaE
                tl = (El - eko(i,iksnl))*sqrtdVI
                tu = (Eu - eko(i,iksnl))*sqrtdVI
                !  d = (derf(tl) - derf(tu))*0.5d0/(DeltaE*kv)
                dos(id+1,istmp) = dos(id+1,istmp) &
                     & + w *(derf(tu) - derf(tl)) *0.5d0 /DeltaE *kpt_weight(ik)
             end do
          End do

          if (iwsc == TOTAL .and. sw_pdos == ON) then
             w = 1.0d0;   porb_ssrep = 0.0d0

             Do iorb = 1,nlmta_phi
                call m_PP_tell_iorb_lmtt(iorb,lmtt)
                
                if ( k_symmetry(ik) == GAMMA ) then
                   stop 'Not supported : Gamma in noncollinear system'
                   
                else
                   
                   Do is1=1, ndim_spinor
                      Do is2=1, ndim_spinor
                         istmp = ( is1 -1 )*ndim_spinor + is2
                         
                         ztemp = 0.0d0
                         do iopr=1,nopr
                            z1 = dcmplx( compr(i,iorb,iopr,ik+is1-1 ), &
                                 &       compi(i,iorb,iopr,ik+is1-1 ) )
                            z2 = dcmplx( compr(i,iorb,iopr,ik+is2-1 ), &
                                 &       compi(i,iorb,iopr,ik+is2-1 ) )
                            ztemp = ztemp + z1 *conjg(z2) &
                                 &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl) )
                         end do
                         
                         porb_ssrep(iorb,istmp) = porb_ssrep(iorb,istmp) &
                              &                   + ztemp /dble(nopr)
                      End do
                   End do
                endif
             End do
             
             call m_ES_DensMat_To_MagMom_porb( nlmta_phi, porb_ssrep, porb )
             
             Do iorb = 1,nlmta_phi
                do id = is, ie
                   El = Es + id*DeltaE
                   Eu = El + DeltaE
                   tl = (El - eko(i,iksnl))*sqrtdVI
                   tu = (Eu - eko(i,iksnl))*sqrtdVI
                   !  d = (derf(tl) - derf(tu))*0.5d0/(DeltaE*kv)
                   pdos(id+1,iorb,:) = pdos(id+1,iorb,:) &
                        & + porb(iorb,:) *w *(derf(tu) - derf(tl)) &
                        &                *0.5d0 /DeltaE *kpt_weight(ik)
                end do
             End do

          end if
       end do
    end do

    sumdos(1,:) = dos(1,:)*DeltaE

    do id = 1, nEWindows-1
       sumdos(id+1,:) = sumdos(id,:) + dos(id+1,:)*DeltaE
    end do

    if(sw_pdos == ON) then
       do iorb = 1,nlmta_phi
          sumpdos(1,iorb,:) = pdos(1,iorb,:)*DeltaE
          do id = 1, nEWindows-1
             sumpdos(id+1,iorb,:) = sumpdos(id,iorb,:) + pdos(id+1,iorb,:)*DeltaE
          end do
       end do
    end if

  end subroutine mkdos_with_GaussDistrib_noncl
! =================================================================== 11.0

! ====================== KT_add ======================= 13.0E
  subroutine make_dos_with_FDiracDistrib( kv, iwsc, kpt_weight )
    integer, intent(in) :: kv, iwsc
    real(kind=DP), intent(in) :: kpt_weight( kv )

    integer ::             i, ik, is, ie, id, ispin, iorb, iopr, lmtt, iksnl
    real(kind=DP) ::       Es, e, Ene1, c1, c2, w, DeltaE
    real(kind=DP) ::       porb

    DeltaE = DeltaE_dos
    Es = Eminimum - DeltaE*0.5d0
    
!    width_fermi_dirac = width

    if(ipridos >= 2) write(nfout,'(" !! Es, DeltaE = ",2d20.10)') Es, DeltaE
    dos = 0.d0; sumdos = 0.d0
    if(sw_pdos == ON) then
       pdos=0.d0; sumpdos=0.d0
    end if
    do ispin = 1, nspin
       do ik = ispin, kv, nspin
          iksnl = (ik-1)/nspin + 1
          do i = 1, neg
             w = 1.d0
             if(iwsc >= 1 ) w = dos_weight(i,ik)
             e = eko(i,ik) - nETailWindows*DeltaE - Es
             is = e/DeltaE
             ie = is + 2*nETailWindows
             if(is < 0) then
                if(ipridos >= 2) write(nfout,'(" is = ",i5," < 0")') is
                is = 0
             end if
             if(ie >= nEWindows ) then
                if(ipridos >= 2) write(nfout,'(" ie = ",i5, " > nEWindows")')ie
                ie = nEWindows-1
             end if
             if(ipridos >= 2) then
                write(nfout,'(" !! eko(",i3,",",i3,") = ",f10.6," is, ie = ",2i7, 2f10.6)') &
                     & i,ik, eko(i,ik),is,ie, Es+is*DeltaE, Es+ie*DeltaE
             end if

             do id = is, ie
                ene1 = Es +id*DeltaE
                call width_fermi_dirac( ene1, eko(i,ik), smearing_width_fdirac, c1, c2 )
!!!                dos(id+1,ispin) = dos(id+1,ispin) + w *c1 *2.0d0 /dble(kv)
                dos(id+1,ispin) = dos(id+1,ispin) + w *c1 *2.0d0 *kpt_weight(ik)
             end do
             if(iwsc == TOTAL .and. sw_pdos == ON) then
                do iorb = 1,nlmta_phi
                   call m_PP_tell_iorb_lmtt(iorb,lmtt)
                   porb = 0.d0
!!$ASASASASAS
!!$                do iopr=1,nopr
!!$                   porb = porb + (compr(i,iorb,iopr,ik)**2 &
!!$                        &       + compi(i,iorb,iopr,ik)**2) &
!!$                        &     *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,iksnl))
!!$                end do
                   if ( k_symmetry(ik) == GAMMA ) then
                      do iopr=1,nopr
                         porb = porb + compr(i,iorb,iopr,ik)**2  /2.0 &
                              &     *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,iksnl)*2.) )
                      end do
                   else
                      do iopr=1,nopr
                         porb = porb + (compr(i,iorb,iopr,ik)**2 &
                              &       + compi(i,iorb,iopr,ik)**2) &
                              &     *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,iksnl))
                      end do
                   endif
!!$ASASASASAS
                   porb = porb/dble(nopr)
                   do id = is, ie
                      ene1 = Es +id*DeltaE
                      call width_fermi_dirac( ene1, eko(i,ik), &
                           &                  smearing_width_fdirac, c1, c2  )
                      pdos(id+1,iorb,ispin) = pdos(id+1,iorb,ispin) &
!!!                           & + porb *w *c1 *2.0d0 /dble(kv)
                           & + porb *w *c1 *2.0d0 *kpt_weight(ik)
                   end do
                end do
             end if
          end do
       end do
       sumdos(1,ispin) = dos(1,ispin)*DeltaE
       do id = 1, nEWindows-1
          sumdos(id+1,ispin) = sumdos(id,ispin) + dos(id+1,ispin)*DeltaE
       end do
       if(sw_pdos == ON) then
          do iorb = 1,nlmta_phi
             sumpdos(1,iorb,ispin) = pdos(1,iorb,ispin)*DeltaE
             do id = 1, nEWindows-1
                sumpdos(id+1,iorb,ispin) = sumpdos(id,iorb,ispin) + pdos(id+1,iorb,ispin)*DeltaE
             end do
          end do
       end if
    end do
  end subroutine make_dos_with_FDiracDistrib
! =============================================================== 13.0E

  subroutine get_VBM(total_charge,deltad)
    real(kind=DP), intent(in) :: total_charge, deltad
    integer :: i
    logical :: found
    found = .false.
    i = nEWindows

    if(check_if_metalic_flag .and. .not.metalic_system) then
          ValenceBandMaximum = vbm
          if(ipridos >= 1) then
             if(dabs(ValenceBandMaximum) < 1.d6) then
                write(nfout,'(" ValenceBandMaximum = vbm = ",f12.4," total_charge = ",f12.4 &
                     & ," (m_ES_dos.get_VBM)")') ValenceBandMaximum,total_charge
             else
                write(nfout,'(" ValenceBandMaximum is not calculated")')
             end if
          end if
    else
! ============================== modified by K. Tagami ================ 11.0
!       if(nspin == 1) then
!          do while(.not.found.and.i >= 1)
!             i = i - 1
!             if(sumdos(i,nspin) < total_charge - deltad) found = .true.
!          end do
!       else if(nspin == 2) then
!          do while(.not.found.and.i<= nEWindows)
!             i = i - 1
!             if(sumdos(i,1)+sumdos(i,2) < total_charge - deltad) found = .true.
!          end do
!       end if

       if ( noncol ) then
          do while(.not.found.and.i >= 1)
             i = i - 1
             if(sumdos(i,1) < total_charge - deltad) found = .true.
          end do
       else
          if(nspin == 1) then
             do while(.not.found.and.i >= 1)
                i = i - 1
                if(sumdos(i,nspin) < total_charge - deltad) found = .true.
             end do
          else if(nspin == 2) then
             do while(.not.found.and.i<= nEWindows)
                i = i - 1
                if(sumdos(i,1)+sumdos(i,2) < total_charge - deltad) found = .true.
             end do
          end if
       endif
! ========================================================================= 11.0

       ValenceBandMaximum = Eminimum + i*DeltaE_dos
       if(ipridos >= 1) then
          write(nfout,'(" ValenceBandMaximum = ",f12.4, " i = ",i5," DeltaE_dos = ",d13.5 &
               & ," total_charge = ",f12.4," (m_ES_dos.get_VBM)")') &
               & ValenceBandMaximum,i,DeltaE_dos,total_charge
       end if
    end if

  end subroutine get_VBM

  subroutine write_dos(nf)
    integer, intent(in) :: nf
    integer       :: i, ii, nwdwidth, id, nrEWindows
    real(kind=DP) :: e,e_eV, dos_hr, dos_hr2, dos_eV, dos_eV2 &
         & , sumtotal, sumdos_avr, sumdos_avr2

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2
    nrEWindows = nEWindows/nwdwidth * nwdwidth


    if(nspin == 1) then
       write(nf,'("  No.   E(hr.)        dos(hr.)         E(eV)          dos(eV)              sum")')
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          dos_hr = 0.d0; sumdos_avr = 0.d0
          do ii = i, i+nwdwidth-1
             dos_hr = dos_hr + dos(ii,nspin)
             sumdos_avr = sumdos_avr + sumdos(ii,nspin)
          end do
          dos_hr = dos_hr/nwdwidth; sumdos_avr = sumdos_avr/nwdwidth
!!$          dos_eV = dos(i,nspin)/Hartree
          dos_eV = dos_hr/Hartree
          write(nf,'(i7,f10.5,f18.10,f14.6,f18.10,f20.10)') i+id, e, dos_hr &
               & , e_eV, dos_eV, sumdos_avr
       end do
    else if(nspin == 2) then
       write(nf,'(1x,a47,5x,a45,6x,a27)') "No.  E(hr.)    dos_up(hr.)       dos_down(hr.)" &
            & ,"E(eV)         dos_up(eV)        dos_down(eV)" &
            & ,"sum_up   sum_down sum_total"
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          dos_hr = 0.d0; dos_hr2 = 0.d0;  sumdos_avr = 0.d0; sumdos_avr2 = 0.d0
          do ii = i, i+nwdwidth-1
             dos_hr  = dos_hr + dos(ii,1)
             dos_hr2 = dos_hr2 + dos(ii,2)
             sumdos_avr  = sumdos_avr  + sumdos(ii,1)
             sumdos_avr2 = sumdos_avr2 + sumdos(ii,2)
          end do
          dos_hr = dos_hr/nwdwidth; dos_hr2 = dos_hr2/nwdwidth
          sumdos_avr = sumdos_avr/nwdwidth; sumdos_avr2 = sumdos_avr2/nwdwidth
!!$          dos_eV  = dos(i,1)/Hartree
!!$          dos_eV2 = dos(i,2)/Hartree
!!$          sumtotal = sumdos(i,1) + sumdos(i,2)
          dos_eV  = dos_hr/Hartree
          dos_eV2 = dos_hr2/Hartree
          sumtotal = sumdos_avr + sumdos_avr2
          write(nf,'(i7,f9.4,2f18.10,f15.4,2f18.10,3f10.4)') &
               & i, e, dos_hr,dos_hr2,e_eV, dos_eV, dos_eV2, sumdos_avr,sumdos_avr2,sumtotal
       end do
    end if
    write(nf,'("END")')
  end subroutine write_dos

! ================================== added by K. Tagami ================= 11.0
  subroutine write_dos_noncl(nf)
    integer, intent(in) :: nf
    integer       :: i, ii, nwdwidth, id, nrEWindows

    real(kind=DP) :: dos_hr( ndim_magmom ), sumdos_avr( ndim_magmom )
    real(kind=DP) :: dos_eV( ndim_magmom )
    real(kind=DP) :: e, e_eV
    real(kind=DP) :: sumtotal

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2

    nrEWindows = nEWindows/nwdwidth * nwdwidth

    write(nf,'(2x,A,5x,A,4x,A)') "No.      E(eV)",&
         &     "  dos_chg(eV)    dos_mx(eV)    dos_my(eV)    dos_mz(eV)", &
         &      "sum_chg     sum_mx      sum_my      sum_mz"

    do i = 1, nrEWindows, nwdwidth
       e = Eminimum + (i-1+id)*DeltaE_dos
       e_eV = (e - ValenceBandMaximum)*Hartree

       dos_hr = 0.d0; sumdos_avr = 0.d0
       do ii = i, i+nwdwidth-1
          dos_hr(:) = dos_hr(:) + dos(ii,:)
          sumdos_avr(:) = sumdos_avr(:) + sumdos(ii,:)
       end do

       dos_hr = dos_hr/nwdwidth; sumdos_avr = sumdos_avr/nwdwidth
       dos_eV = dos_hr/Hartree

       write(nf,'(i5,f14.8,4f14.8,4f12.6)') &
               & i, e_eV, dos_eV(1:ndim_magmom), sumdos_avr(1:ndim_magmom)
!       write(nf,*) &
!               & i, e_eV, dos_eV(1:ndim_magmom), sumdos_avr(1:ndim_magmom)
    end do

    write(nf,'("END")')
  end subroutine write_dos_noncl

  subroutine write_dos_noncl_for_totchg(nf)

    integer, intent(in) :: nf
    integer       :: i, ii, nwdwidth, id, nrEWindows
    real(kind=DP) :: e,e_eV, dos_hr, dos_hr2, dos_eV, dos_eV2 &
         & , sumtotal, sumdos_avr, sumdos_avr2

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2

    nrEWindows = nEWindows/nwdwidth * nwdwidth

    write(nf,'("     No.   E(hr.)        dos(hr.)         E(eV)          dos(eV)              sum")')

    do i = 1, nrEWindows, nwdwidth
       e = Eminimum + (i-1+id)*DeltaE_dos
       e_eV = (e - ValenceBandMaximum)*Hartree
       dos_hr = 0.d0; sumdos_avr = 0.d0

       do ii = i, i+nwdwidth-1
          dos_hr = dos_hr + dos(ii,1)
          sumdos_avr = sumdos_avr + sumdos(ii,1)
       end do

       dos_hr = dos_hr/nwdwidth; sumdos_avr = sumdos_avr/nwdwidth
       dos_eV = dos_hr/Hartree

       write(nf,'(i7,f10.5,f18.10,f14.6,f18.10,f20.10)') i+id, e, dos_hr &
            & , e_eV, dos_eV, sumdos_avr
    end do

    write(nf,'("END")')
  end subroutine write_dos_noncl_for_totchg
! ======================================================================== 11.0

  subroutine write_pdos(nf)
    integer, intent(in) :: nf

    integer :: iorb

    do iorb=1,nlmta_phi
       call write_pdos_orbital(nf,iorb)
!!$ASASASASAS
!!$       write(nf,'("END")')
!!$ASASASASAS
    end do

  end subroutine write_pdos

! =================================== added by K. Tagami =============== 11.0
  subroutine write_pdos_noncl(nf)
    integer, intent(in) :: nf
    integer :: iorb

    do iorb=1,nlmta_phi
       call write_pdos_orbital_noncl(nf,iorb)
    end do

  end subroutine write_pdos_noncl
! ========================================================================= 11.0

  subroutine write_pdos_orbital(nf,iorb)
    integer, intent(in) :: nf
    integer, intent(in) :: iorb
    integer :: ia,il,im,tau,nspher
    integer       :: i, ii, nwdwidth, id, nrEWindows
    real(kind=DP) :: e,e_eV, dos_hr, dos_hr2, dos_eV, dos_eV2 &
         & , sumtotal, sumdos_avr, sumdos_avr2

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2
    nrEWindows = nEWindows/nwdwidth * nwdwidth

    call m_PP_tell_iorb_ia_l_m_tau(iorb,ia,il,im,tau)
!!$ASASASASAS
    if ( iproj_group(ia)== 0 ) return
!!$ASASASASAS
    if ( sw_diagonalize_population == ON ) then
       write(nf,'("PDOS: ia= ",i0," l=",i3," m''=",i3," t=",i3)') ia,il-1,im,tau
    else
       write(nf,'("PDOS: ia= ",i0," l=",i3," m=",i3," t=",i3)') ia,il-1,im,tau
    endif

    if(nspin == 1) then
       write(nf,'("  No.   E(hr.)        dos(hr.)         E(eV)          dos(eV)              sum")')
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          dos_hr = 0.d0; sumdos_avr = 0.d0
          do ii = i, i+nwdwidth-1
             dos_hr = dos_hr + pdos(ii,iorb,nspin)
             sumdos_avr = sumdos_avr + sumpdos(ii,iorb,nspin)
          end do
          dos_hr = dos_hr/nwdwidth; sumdos_avr = sumdos_avr/nwdwidth
          dos_eV = dos_hr/Hartree
          write(nf,'(i5,f10.5,f18.10,f14.6,f18.10,f20.10)') i+id, e, dos_hr &
               & , e_eV, dos_eV, sumdos_avr
       end do
    else if(nspin == 2) then
       write(nf,'(1x,a47,5x,a45,6x,a27)') "No.  E(hr.)    dos_up(hr.)       dos_down(hr.)" &
            & ,"E(eV)         dos_up(eV)        dos_down(eV)" &
            & ,"sum_up   sum_down sum_total"
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          dos_hr = 0.d0; dos_hr2 = 0.d0;  sumdos_avr = 0.d0; sumdos_avr2 = 0.d0
          do ii = i, i+nwdwidth-1
             dos_hr  = dos_hr + pdos(ii,iorb,1)
             dos_hr2 = dos_hr2 + pdos(ii,iorb,2)
             sumdos_avr  = sumdos_avr  + sumpdos(ii,iorb,1)
             sumdos_avr2 = sumdos_avr2 + sumpdos(ii,iorb,2)
          end do
          dos_hr = dos_hr/nwdwidth; dos_hr2 = dos_hr2/nwdwidth
          sumdos_avr = sumdos_avr/nwdwidth; sumdos_avr2 = sumdos_avr2/nwdwidth
          dos_eV  = dos_hr/Hartree
          dos_eV2 = dos_hr2/Hartree
          sumtotal = sumdos_avr + sumdos_avr2
          write(nf,'(i5,f9.4,2f18.10,f15.4,2f18.10,3f10.4)') &
               & i, e, dos_hr,dos_hr2,e_eV, dos_eV, dos_eV2, sumdos_avr,sumdos_avr2,sumtotal
       end do
    end if
!!$ASASASASAS
    write(nf,'("END")')
!!$ASASASASAS
  end subroutine write_pdos_orbital

! ================================= added by K. Tagami ==================== 11.0
  subroutine write_pdos_orbital_noncl(nf,iorb)
    integer, intent(in) :: nf
    integer, intent(in) :: iorb
    integer :: ia,il,im,tau,nspher
    integer       :: i, ii, nwdwidth, id, nrEWindows

    real(kind=DP) :: dos_hr( ndim_magmom ), sumdos_avr( ndim_magmom )
    real(kind=DP) :: dos_eV( ndim_magmom )
    real(kind=DP) :: e, e_eV

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2

    nrEWindows = nEWindows/nwdwidth * nwdwidth

    call m_PP_tell_iorb_ia_l_m_tau(iorb,ia,il,im,tau)
    if ( iproj_group(ia)== 0 ) return

! ---
    write(nf,'("PDOS: ia= ",i0," l=",i3," m=",i3," t=",i3)') ia,il-1,im,tau

    write(nf,'(2x,A,5x,A,4x,A)') "No.      E(eV)",&
         &     "  dos_chg(eV)    dos_mx(eV)    dos_my(eV)    dos_mz(eV)", &
         &      "sum_chg     sum_mx      sum_my      sum_mz"

    do i = 1, nrEWindows, nwdwidth
       e = Eminimum + (i-1+id)*DeltaE_dos
       e_eV = (e - ValenceBandMaximum)*Hartree

       dos_hr = 0.0d0; sumdos_avr = 0.0d0
       do ii = i, i+nwdwidth-1
          dos_hr(:)  = dos_hr(:) + pdos(ii,iorb,:)
          sumdos_avr(:)  = sumdos_avr(:)  + sumpdos(ii,iorb,:)
       end do

       dos_hr = dos_hr/nwdwidth;         sumdos_avr = sumdos_avr/nwdwidth;
       dos_eV  = dos_hr/Hartree;   

       write(nf,'(i5,f14.8,4f14.8,4f12.6)') &
               & i, e_eV, dos_eV(1:ndim_magmom), sumdos_avr(1:ndim_magmom)
    end do

    write(nf,'("END")')
  end subroutine write_pdos_orbital_noncl
! ========================================================================= 11.0

  subroutine m_ESdos_gaussdistrib(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substitution(kv3) ! eko_l -> eko
    call find_Erange(eko,neg,kv3)
    call alloc_dos(1,icomponent)
    call make_dos_with_GaussianDistrib( kv3, icomponent, qwgt )
    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)
    if(mype == 0) call write_dos(nfdos)
!!$    call write_dos(nfout)
    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos(nfdos)
    end if
! ---
    if ( sw_calc_pcohp == ON ) call m_ES_calc_pcohp
! ---
    call dealloc_eko()
    call dealloc_dos()
  end subroutine m_ESdos_gaussdistrib

! ================================ added by K. Tagami =================== 11.0
  subroutine m_ESdos_gaussdistrib_noncl(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substit_noncl(kv3) ! eko_l -> eko
    call find_Erange( eko, neg, kv3/ndim_spinor )
    call alloc_dos(1,icomponent)
    
    call mkdos_with_GaussDistrib_noncl( kv3, icomponent, qwgt )
    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)

    if(mype == 0) then
       if ( calc_dos_magmom_contrib == YES ) then
          call write_dos_noncl(nfdos)
       else
          call write_dos_noncl_for_totchg(nfdos)
       endif
    endif

    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos_noncl(nfdos)
    end if

    call dealloc_eko()
    call dealloc_dos()
  end subroutine m_ESdos_gaussdistrib_noncl
! ======================================================================= 11.0

  subroutine m_ESdos_gaussdistrib_ek(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substitution_ek(kv3_ek) ! eko_ek -> eko
    call find_Erange(eko,neg,kv3_ek)
    call alloc_dos(1,icomponent)
    call make_dos_with_GaussianDistrib( kv3_ek, icomponent, qwgt_ek )
    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)
    if(mype == 0) call write_dos(nfdos)
    call dealloc_eko()
    call dealloc_dos()
  end subroutine m_ESdos_gaussdistrib_ek

! ==================================== added by K. Tagami ================ 11.0
  subroutine m_ESdos_gaussdistrib_ek_noncl(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substit_ek_noncl(kv3_ek) ! eko_ek -> eko
    call find_Erange(eko,neg,kv3_ek/ndim_spinor)
    call alloc_dos(1,icomponent)

    call mkdos_with_GaussDistrib_noncl( kv3_ek, icomponent, qwgt_ek )
    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)

    if(mype == 0) then
       if ( calc_dos_magmom_contrib == YES ) then
          call write_dos_noncl(nfdos)
       else
          call write_dos_noncl_for_totchg(nfdos)
       endif
    endif

    call dealloc_eko()
    call dealloc_dos()
  end subroutine m_ESdos_gaussdistrib_ek_noncl
! ========================================================================= 11.0

! ==================- KT_add ================= 13.0E
  subroutine m_ESdos_FdiracDistrib(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substitution(kv3) ! eko_l -> eko
    call find_Erange_fermidirac(eko,neg,kv3)

    call alloc_dos(1,icomponent)
    call make_dos_with_FDiracDistrib( kv3, icomponent, qwgt )

!!!    if(icomponent == TOTAL) call get_VBM(totch,DeltaDVBM)
    if(icomponent == TOTAL) then
       ValenceBandMaximum = efermi
       write(nfout,*) '!!!! Efermi is used as ValenceBandMaximum in the Fermi Dirac case'
    endif

    if(mype == 0) call write_dos(nfdos)
!!$    call write_dos(nfout)
    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos(nfdos)
    end if
    if ( sw_calc_pcohp == ON ) call m_ES_calc_pcohp

    call dealloc_eko(); call dealloc_dos()

  end subroutine m_ESdos_FdiracDistrib

  subroutine m_ESdos_FDiracDistrib_ek(nfdos,icomponent)
    integer, intent(in) ::      nfdos, icomponent

    call alloc_eko_and_substitution_ek(kv3_ek) ! eko_ek -> eko
    call find_Erange_fermidirac(eko,neg,kv3_ek)

    call alloc_dos(1,icomponent)
    call make_dos_with_FDiracDistrib( kv3_ek, icomponent, qwgt_ek )

    if(icomponent == TOTAL) then
       ValenceBandMaximum = efermi
       write(nfout,*) '!!!! Efermi is used as ValenceBandMaximum in the Fermi Dirac case'
    endif

    if(mype == 0) call write_dos(nfdos)
    call dealloc_eko();     call dealloc_dos()
  end subroutine m_ESdos_FDiracDistrib_ek
! ============================================ 13.0E

  subroutine m_ESdos_write_dos_header(nfdos,aldos_or_layerdos,icomponent)
    integer, intent(in):: nfdos, aldos_or_layerdos, icomponent
    if(mype == 0) then
       if(aldos_or_layerdos == ALDOS) then
          write(nfdos,'("ALDOS     num_atom = ",i7)') icomponent
       else if(aldos_or_layerdos == LAYERDOS) then
          write(nfdos,'("LAYERDOS   num_layer = ",i7)') icomponent
       end if
    end if
  end subroutine m_ESdos_write_dos_header

  ! ----------------------------------------------

  subroutine m_ESdos_tetrahedral(nfdos,icomponent,mode)
    integer, intent(in) ::  nfdos, mode,icomponent
!!$#ifndef NO_TETRAHEDRON
    real(kind=DP), parameter :: delta = 1.d-12
    integer, parameter       :: idim = 3
    integer        :: neig,ispin,ip2,ik, ip, ib, jb, ie
    real(kind=DP)  :: et,wei,clpm
    real(kind=DP), allocatable, dimension(:,:,:)   :: eeig2, eeig2_mpi
    real(kind=DP), allocatable,dimension(:,:)  :: dos_weight2 ! d(neg,np2)
    real(kind=DP), allocatable, dimension(:,:,:,:) :: compr, compr_mpi
    real(kind=DP), allocatable, dimension(:,:,:,:) :: compi, compi_mpi
    real(kind=DP), allocatable, dimension(:,:) :: norm_phig_mpi, norm_phig_mpi2
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,e
    real(kind=DP), allocatable, dimension(:,:) ::  e_mpi,e_mpi2
    real(kind=DP), pointer, dimension(:,:,:) :: cdos,cind
    real(kind=DP), allocatable, dimension(:,:) :: doswk,dosinwk
    integer, allocatable, dimension(:,:) :: nttra ! d(mtetra,4)
    integer ::                                  id_sname = -1
    integer :: i,iorb,iopr,ikorb,lmtt, ipridos_t, nEwindows_plus,mtetra,ikt,iloop
    integer, parameter :: ncl = 8
    real(kind=DP) :: porb

    call tstatc0_begin('m_ESdos_tetrahedral ', id_sname)

    if(mode /= SCF .and. mode /= EK) then
       write(nfout,'(" !dos:  mode = ",i6," <<m_ESdos_tetrahedral>>")') mode
       return
    end if

    if(npes > 1) then
       if(mype == 0) ipridos_t = ipridos
       call mpi_bcast(ipridos_t, 1, mpi_integer, 0, mpi_comm_group, ierr)
    else
       ipridos_t = ipridos
    end if

    if(ipridos_t >= 3) then
       if(printable) write(nfout,'(" !dos: np2, np0 = ",2i7," <<m_ESdos_tetrahedral>>")') np2, np0
       allocate(e_mpi(neg,kv3)); allocate(e_mpi2(neg,kv3))
       if(printable) write(nfout,'(" !dos: icomponent = ",i9," <<m_ESdos_tetrahedral>>")') icomponent
       if(printable) write(nfout,'(" !dos: --energy_eigenvalue--")')
       e_mpi = 0.d0; e_mpi2 = 0.d0
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             ip = neordr(ie,ik)
             if(map_e(ip) == myrank_e) e_mpi(ie,ik) = eko_l(map_z(ip),ik)
          end do
       end do
       if(npes >=2) then
          call mpi_allreduce(e_mpi,e_mpi2,neg*kv3,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          e_mpi = e_mpi2
       end if
       if(printable) then
          do ik = 1, kv3
             write(nfout,'(" !dos:  ik = ",i7)') ik
             write(nfout,'(" !dos: ",8f10.6)') (e_mpi(ie,ik),ie=1,neg)
          end do
       end if
       deallocate(e_mpi,e_mpi2)
    end if

    allocate(eeig2(np2,neg,nspin)); eeig2 = 0.d0
    if(icomponent == TOTAL .and. sw_pdos == ON) then
       allocate(compr(neg,nlmta_phi,nopr,np2*nspin));  compr = 0.d0
       allocate(compi(neg,nlmta_phi,nopr,np2*nspin));  compi = 0.d0
       allocate(norm_phig_mpi(nlmtt_phi,np2));  norm_phig_mpi = 0.d0
    end if

    if(mode==EK .and. ipridos_t >= 1) then
       write(nfout,'(" !dos eko_ek ")')
       do ispin=1,nspin
          do ip2=1,np2
             ik = nspin*(ip2-1)+ispin
             write(nfout,'(" !dos -- ik = ",i5)') ik
             write(nfout,'(" !dos ",8f8.4)')(eko_ek(ib,ik),ib=1,neg)
          end do
       end do
    end if

    neig=neg
    do ispin=1,nspin
       do ip2=1,np2
          ik=nspin*(ip2-1)+ispin
          if(mode == EK) then
             do ib=1,neg
                eeig2(ip2,ib,ispin)=eko_ek(ib,ik)
             enddo
             do ib = 1,neg-1
                do jb = ib+1, neg
                   if(eeig2(ip2,jb,ispin) < eeig2(ip2,ib,ispin)-delta) then
                      et = eeig2(ip2,ib,ispin)
                      eeig2(ip2,ib,ispin) = eeig2(ip2,jb,ispin)
                      eeig2(ip2,jb,ispin) = et
                   end if
                end do
             end do
          else if(mode == SCF) then
             if(map_k(ik) /= myrank_k) cycle
             do ib = 1, neg
                ip = neordr(ib,ik)
                if(map_e(ip) == myrank_e) then
                   eeig2(ip2,ib,ispin)=eko_l(map_z(ip),ik)
                   if(icomponent == TOTAL .and. sw_pdos == ON) then
                      compr(ib,1:nlmta_phi,1:nopr,ik)=compr_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
!!$ASASASASAS
!!$                      compi(ib,1:nlmta_phi,1:nopr,ik)=compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
                      if ( k_symmetry(ik) /= GAMMA ) then
                         compi(ib,1:nlmta_phi,1:nopr,ik)=compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik)
                      else
!                         compi = 0.0d0
                         compi(ib,1:nlmta_phi,1:nopr,ik) = 0.0d0
                      endif
!!$ASASASASAS
                      norm_phig_mpi(1:nlmtt_phi,ip2)=norm_phig(1:nlmtt_phi,ip2)
                   end if
                end if
             enddo
          end if
       enddo
    end do

    if(mode == SCF) then
       if(npes >= 2) then
          !allocate(eeig2_mpi(np2,neg,nspin)); eeig2_mpi = 0.d0
          call mpi_allreduce(MPI_IN_PLACE,eeig2,np2*neg*nspin,mpi_double_precision,mpi_sum &
               & , mpi_comm_group,ierr)
          !eeig2 = eeig2_mpi
          !deallocate(eeig2_mpi)
          if(icomponent == TOTAL .and. sw_pdos == ON) then
            !allocate(compr_mpi(neg,nlmta_phi,nopr,np2*nspin)); compr_mpi = 0.d0
            !allocate(compi_mpi(neg,nlmta_phi,nopr,np2*nspin)); compi_mpi = 0.d0
            !allocate(norm_phig_mpi2(nlmtt_phi,np2)); norm_phig_mpi2 = 0.d0
            call mpi_allreduce(MPI_IN_PLACE,compr,neg*nlmta_phi*nopr*np2*nspin,mpi_double_precision,mpi_sum &
               & , mpi_comm_group,ierr)
            call mpi_allreduce(MPI_IN_PLACE,compi,neg*nlmta_phi*nopr*np2*nspin,mpi_double_precision,mpi_sum &
               & , mpi_comm_group,ierr)
            call mpi_allreduce(MPI_IN_PLACE,norm_phig_mpi,nlmtt_phi*np2,mpi_double_precision,mpi_sum &
               & , mpi_comm_group,ierr)

            norm_phig_mpi = norm_phig_mpi / dble(nrank_e)

            !compr = compr_mpi
            !compi = compi_mpi
            !norm_phig_mpi = norm_phig_mpi2
            !deallocate(compr_mpi,compi_mpi,norm_phig_mpi2)
          end if
       end if
    end if

    if(ipridos >= 2) then
!!$       if(mype == 0) then
          write(nfout,'(" !dos: --eeig2(energy_eigenvalue)--")')
          iloop = (neg-1)/ncl+1
          do ispin = 1, nspin
             write(nfout,'(" !dos: ispin = ",i5)') ispin
             do ip2 = 1, np2
                do i = 1, iloop
                   write(nfout,'(" !dos: (",i5,") ",8f9.5)') &
                        & ip2,(eeig2(ip2,ib,ispin),ib=ncl*(i-1)+1,min(neg,ncl*i))
                end do
!!$                write(nfout,'(" !dos:  ip2 = ",i7)') ip2
!!$                write(nfout,'(" !dos: ",8f9.5)') (eeig2(ip2,ib,ispin),ib=1,neg)
             end do
          end do
          if(sw_pdos == ON) then
          do ispin=1,nspin
             write(nfout,'(" !dos: ispin = ",i5)') ispin
             do ip2 = 1, np2 
                ikorb=nspin*(ik-1)+ispin
                write(nfout,'(" !dos:  ip2 = ",i7)') ip2
                write(nfout,'(" !dos norm_phig: ",10f8.4)') &
                          & norm_phig_mpi(1:nlmtt_phi,ip2)
                do iopr=1,nopr
                   do iorb=1,nlmta_phi
                      write(nfout,'(" !dos: ik=",i5," iopr=",i5," iorb=",i5)')&
                              &  ikorb,iopr,iorb
                      write(nfout,'(" !dos compr: ",10f8.4)') &
                              & compr(1:neg,iorb,iopr,ikorb)
                      write(nfout,'(" !dos compi: ",10f8.4)') &
                              & compi(1:neg,iorb,iopr,ikorb)
                   end do
                end do
             end do
          end do
          end if
!!$       end if
    end if

    if(mode == EK) then
       call find_Erange(eko_ek,neg,kv3_ek)
    else
       Eminimum = minval(eeig2) - 0.005 ! (hartree)
       Emaximum = maxval(eeig2) + 0.005 ! (hartree)
       nEWindows = (Emaximum - Eminimum)/DeltaE_dos + 1
    end if
       
    if(ipridos >= 2) &
         & write(nfout,'(" !dos: Emaximum, Eminimum, nEwindows = ",2f10.6,i7)') &
         &       Eminimum,Emaximum, nEWindows

    call alloc_dos(0,icomponent)

    if(nspin == 1) then
       wei = 2.d0
    else
       wei = 1.d0
    end if

    if(ipridos >= 2) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration === <<m_ESdos_tetrahedral>>'
    if(ipridos >= 2) write(nfout,'(" !m_ES_dos dos_subroutine = ",i5)') dos_subroutine

    do ispin=1,nspin
!!$       write(nfout,*) ' ispin=',ispin
!!$       write(nfout,'(" !! nxyz_tetra = ",3i7)') nxyz_tetra(1:3)
!!$       write(nfout,'(" !! np0 = ",i7)') np0
!!$       do ik = 1, np0
!!$          write(nfout,'(" !! ik, ip20 = ",2i6," <<m_ESdos_tetrahedral>>")') ik,ip20(ik)
!!$       end do
       if(dos_subroutine == 3) then
          allocate(e(0:nEwindows))
          e(0:nEwindows) = (/(Eminimum + DeltaE_dos*ie,ie=0,nEWindows)/)
          ! e(0) = Eminimum, e(1) = Eminimum+DeltaE_dos, e(2) = Eminimum+DeltaE_dos*2,...

          allocate(cdos(np2,neg,0:nEWindows)); cdos = 0.d0
          allocate(cind(np2,neg,0:nEWindows)); cind = 0.d0
          allocate(eawk(np0)); eawk = 0.d0
          allocate(cdwk(np0)); cdwk = 0.d0
          allocate(cswk(np0)); cswk = 0.d0
          call nstt3i(idim,nEwindows,e,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
               &  ,np2,np2,neig,eeig2(1,1,ispin) &
               &  ,ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra ) ! -> cdos, cind
          deallocate(cswk,cdwk,eawk)
          clpm = 1.d0
          do ik=1,np2
             ikt = nspin*(ik-1)+ispin
             if(icomponent == TOTAL .and. sw_pdos == ON) ikorb=nspin*(ik-1)+ispin
             do ib = 1, neg
!!$             if(icomponent >= 1) clpm = dos_weight(ib,ik)
                if(icomponent /= TOTAL) clpm = dos_weight(ib,ikt)

                do ie = 0, nEwindows
                   dos(ie,ispin) = dos(ie,ispin) + cdos(ik,ib,ie)*clpm*wei
                   sumdos(ie,ispin) = sumdos(ie,ispin) + cind(ik,ib,ie)*clpm*wei
                end do
                if(icomponent == TOTAL .and. sw_pdos == ON) then
                   do iorb = 1,nlmta_phi
                      call m_PP_tell_iorb_lmtt(iorb,lmtt)
                      porb = 0.d0
!!$ASASASASAS
!!$                      do iopr=1,nopr
!!$                         porb = porb + (   compr(ib,iorb,iopr,ikorb)**2 &
!!$                              &          + compi(ib,iorb,iopr,ikorb)**2) &
!!$                              &        *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,ik))
!!$                      end do
                      if ( k_symmetry(ik) == GAMMA) then
                         do iopr=1,nopr
                            porb = porb + compr(ib,iorb,iopr,ikorb)**2 /2.0 &
                            &  *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,ik)*2.) )
                         end do
                      else
                         do iopr=1,nopr
                            porb = porb + ( compr(ib,iorb,iopr,ikorb)**2 &
                                 &        + compi(ib,iorb,iopr,ikorb)**2) &
                            &    *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ik))
                         enddo
                      endif
!!$ASASASASAS
                      porb = porb/dble(nopr)
                      ! debug
                      ! print *,'debug iorb=',iorb,' porb=',porb
                      ! end debug
                      do ie = 0, nEwindows
                         pdos(ie,iorb,ispin) = pdos(ie,iorb,ispin) + cdos(ik,ib,ie)*wei*porb
                         sumpdos(ie,iorb,ispin) = sumpdos(ie,iorb,ispin) + cind(ik,ib,ie)*wei*porb
                      end do
                   end do
                end if
             end do
          end do
          deallocate(cind,cdos)
          deallocate(e)
       else if(dos_subroutine == 4) then
          allocate(cdos(0:nEwindows,np2,neg)); cdos = 0.d0
          allocate(cind(0:nEwindows,np2,neg)); cind = 0.d0
          nEwindows_plus = nEwindows
          if(mod(nEwindows_plus,2)==1) nEwindows_plus = nEwindows_plus+1
          allocate(doswk(0:nEwindows_plus,4))
          allocate(dosinwk(0:nEwindows_plus,4))
          mtetra = product(nxyz_tetra(1:3))*6
          allocate(nttra(mtetra,4))
          call prepare_nttra(nxyz_tetra,mtetra,nttra)
          write(nfout,'(" !dos after prepare_nttra")')
          write(nfout,'(" !dos neig = ",i5)') neig
          cdos = 0.d0; cind =0.d0
          call nstt4i(ipridos,idim,nEwindows,nxyz_tetra,np2,np2,neig,eeig2(1,1,ispin) &
               &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos &
               &   ,  nEwindows_plus,doswk,dosinwk,cdos,cind)
          deallocate(nttra)
          deallocate(dosinwk,doswk)
          clpm = 1.d0
          do ik=1,np2
             ikt=nspin*(ik-1)+ispin
             do ib = 1, neg
                if(icomponent /= TOTAL) clpm = dos_weight(ib,ikt)
                ! clpm -> clpm(ib,ik)
                do ie = 0, nEwindows
                   dos(ie,ispin) = dos(ie,ispin) + cdos(ie,ik,ib)*clpm*wei
                   sumdos(ie,ispin) = sumdos(ie,ispin) + cind(ie,ik,ib)*clpm*wei
                end do
             end do
          end do
          if(icomponent == TOTAL .and. sw_pdos == ON) then
             do ik = 1,np2
                ikorb=nspin*(ik-1)+ispin
                do ib = 1, neg
                   do iorb = 1,nlmta_phi
                      call m_PP_tell_iorb_lmtt(iorb,lmtt)
                      porb = 0.d0
!!$ASASASASAS
!!$                      do iopr=1,nopr
!!$                         porb = porb + (   compr(ib,iorb,iopr,ikorb)**2 &
!!$                              &          + compi(ib,iorb,iopr,ikorb)**2) &
!!$                              &        *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,ik))
!!$                      end do
                      if ( k_symmetry(ik) == GAMMA ) then
                         do iopr=1,nopr
                            porb = porb + compr(ib,iorb,iopr,ikorb)**2 /2.0 &
                              &   *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,ik)*2.))
                           end do
                      else
                         do iopr=1,nopr
                            porb = porb + ( compr(ib,iorb,iopr,ikorb)**2 &
                                 &    + compi(ib,iorb,iopr,ikorb)**2) &
                                 &   *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ik))
                         end do
                      endif
!!$ASASASASAS
                      porb = porb/dble(nopr)
                      ! porb -> porb(ib,iorb,ik)
                      ! debug
                      ! print *,'debug iorb=',iorb,' porb=',porb
                      ! end debug
                      do ie = 0, nEwindows
                         pdos(ie,iorb,ispin) = pdos(ie,iorb,ispin) + cdos(ie,ik,ib)*wei*porb
                         sumpdos(ie,iorb,ispin) = sumpdos(ie,iorb,ispin) + cind(ie,ik,ib)*wei*porb
                      end do
                   end do
                end do
             end do
          end if
          deallocate(cind,cdos)
       else if(dos_subroutine == 5) then
          nEwindows_plus = nEwindows
          if(mod(nEwindows_plus,2)==1) nEwindows_plus = nEwindows_plus+1
          allocate(doswk(0:nEwindows_plus,4))
          allocate(dosinwk(0:nEwindows_plus,4))
          mtetra = product(nxyz_tetra(1:3))*6
          allocate(nttra(mtetra,4))
          call prepare_nttra(nxyz_tetra,mtetra,nttra)
          allocate(dos_weight2(neg,np2))
          if(icomponent == TOTAL) then
             dos_weight2 = 1.d0
          else
             do ik = 1, np2
                ikt = nspin*(ik-1)+ispin
                do ib = 1, neg
                   dos_weight2(ib,ik) = dos_weight(ib,ikt)
                end do
             end do
          end if
          call care_of_degenerate_state(neig,np2,nspin,ispin,eeig2,dos_weight2) !dos_weight
          dos_weight2 = dos_weight2*wei
          dos(:,ispin) = 0.d0
          sumdos(:,ispin) = 0.d0
          call nstt5i(ipridos,idim,Eminimum,Emaximum,nEwindows,nxyz_tetra,np2,np2 &
               &   ,  neig,eeig2(1,1,ispin) &
               &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos,dos_weight2 &
               &   ,  nEwindows_plus,doswk,dosinwk,dos(0,ispin),sumdos(0,ispin))

          if(icomponent == TOTAL .and. sw_pdos == ON) then
             do iorb = 1, nlmta_phi
                call m_PP_tell_iorb_lmtt(iorb,lmtt)
                do ik = 1, np2
                   ikorb=nspin*(ik-1)+ispin
                   do ib = 1, neg
                      porb = 0.d0
!!$ASASASASAS
!!$                      do iopr=1,nopr
!!$                         porb = porb + (   compr(ib,iorb,iopr,ikorb)**2 &
!!$                              &          + compi(ib,iorb,iopr,ikorb)**2) &
!!$                              &        *(1.d0+qorb(iorb)/norm_phig_mpi(lmt,ik))
!!$                      end do
                      if ( k_symmetry(ik) == GAMMA ) then
                         do iopr=1,nopr
                            porb = porb + compr(ib,iorb,iopr,ikorb)**2 /2.0 &
                             &   *(1.d0+qorb(iorb)/(norm_phig_mpi(lmtt,ik)*2.) )
                         end do
                      else
                         do iopr=1,nopr
                            porb = porb + ( compr(ib,iorb,iopr,ikorb)**2 &
                                 &      + compi(ib,iorb,iopr,ikorb)**2) &
                                 &    *(1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ik))
                         end do
                      endif
!!$ASASASASAS
                      dos_weight2(ib,ik) = porb/dble(nopr)*wei
                   end do
                end do
                call care_of_degenerate_state(neig,np2,nspin,ispin,eeig2,dos_weight2) !dos_weight
                call nstt5i(ipridos,idim,Eminimum,Emaximum,nEwindows,nxyz_tetra,np2 &
                     &   ,  np2,neig,eeig2(1,1,ispin) &
                     &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos,dos_weight2 &
                     &   ,  nEwindows_plus,doswk,dosinwk,pdos(0,iorb,ispin),sumpdos(0,iorb,ispin))
             end do
          end if
          deallocate(dos_weight2)
          deallocate(nttra)
          deallocate(dosinwk,doswk)
       !np2: #kpoints independent
       !np0: #all kpoints
!!$       call doscal_nstt(nEwindows,nxyz_tetra,np2,neig,eeig2(1,1,ispin),ip20,np0,wei,cdos,cind)

       end if
    end do

    deallocate(eeig2)

    if(icomponent == TOTAL) call get_VBM(totch,1.d-12)  ! -> ValenceBandMaximum
    if(mype == 0) call write_dos(nfdos)
    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) call write_pdos(nfdos)

    call dealloc_dos()
    call tstatc0_end(id_sname)
!!$#endif
  end subroutine m_ESdos_tetrahedral


! ============================= added by K. Tagami ======================= 11.0
  subroutine m_ESdos_tetrahedral_noncl(nfdos,icomponent,mode)

    integer, intent(in) ::  nfdos, mode,icomponent
!!$#ifndef NO_TETRAHEDRON
    real(kind=DP), parameter :: delta = 1.d-12
    integer, parameter       :: idim = 3
    integer        :: neig, ip2, ik, ip, ib, jb, ie
    real(kind=DP)  :: et,wei,clpm
    real(kind=DP), pointer, dimension(:,:,:)   :: eeig2, eeig2_mpi
    real(kind=DP), allocatable,dimension(:,:)  :: dos_weight2 ! d(neg,np2)

    real(kind=DP), pointer, dimension(:,:,:,:) :: compr, compr_mpi
    real(kind=DP), pointer, dimension(:,:,:,:) :: compi, compi_mpi
    real(kind=DP), pointer, dimension(:,:) :: norm_phig_mpi, norm_phig_mpi2
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,e
    real(kind=DP), allocatable, dimension(:,:) ::  e_mpi,e_mpi2

    real(kind=DP), pointer, dimension(:,:,:) :: cdos,cind
    real(kind=DP), allocatable, dimension(:,:) :: doswk,dosinwk
    integer, allocatable, dimension(:,:) :: nttra ! d(mtetra,4)
    integer ::                                  id_sname = -1
    integer :: i, iorb,iopr, lmtt, ipridos_t, nEwindows_plus, mtetra, iloop
    integer, parameter :: ncl = 8

! -------
    complex(kind=CMPLDP), allocatable :: porb_ssrep(:,:)
    complex(kind=CMPLDP), allocatable :: porb_ssrep5(:,:,:)
    real(kind=DP), allocatable :: porb(:,:)
    real(kind=DP), allocatable :: dos_weight3(:,:,:)
!
    integer :: is1, is2, istmp, ismax
    complex(kind=CMPLDP) :: z1, z2, ztemp
! ---

    call tstatc0_begin('m_ESdos_tetrahedral_noncl ', id_sname)

    if(mode /= SCF .and. mode /= EK) then
       write(nfout,'(" !dos:  mode = ",i6," <<m_ESdos_tetrahedral_noncl>>")') mode
       return
    end if

    if(npes > 1) then
       if(mype == 0) ipridos_t = ipridos
       call mpi_bcast(ipridos_t, 1, mpi_integer, 0, mpi_comm_group, ierr)
    else
       ipridos_t = ipridos
    end if

! --------------------------------------------------------
    if (ipridos_t >= 3) then
       if (printable) then
          write(nfout,'(" !dos: np2, np0 = ",2i7," <<m_ESdos_tetrahedral_noncl>>")') &
               &      np2, np0
       endif

       allocate(e_mpi(neg,kv3)); allocate(e_mpi2(neg,kv3))

       if (printable) then
          write(nfout,'(" !dos: icomponent = ",i9," <<m_ESdos_tetrahedral_noncl>>")') &
               &      icomponent
       endif

       if(printable) write(nfout,'(" !dos: --energy_eigenvalue--")')
       e_mpi = 0.d0; e_mpi2 = 0.d0

       do ik = 1, kv3, ndim_spinor
          if (map_k(ik) /= myrank_k) cycle
          do ie = 1, neg
             ip = neordr(ie,ik)
             if (map_e(ip) == myrank_e) e_mpi(ie,ik) = eko_l(map_z(ip),ik)
          end do
       end do

       if (npes >=2) then
          call mpi_allreduce( e_mpi, e_mpi2, neg*kv3, mpi_double_precision, &
               &              mpi_sum, mpi_comm_group, ierr )
          e_mpi = e_mpi2
       end if
       if (printable) then
          do ik = 1, kv3, ndim_spinor
             write(nfout,'(" !dos:  ik = ",i7)') ik
             write(nfout,'(" !dos: ",8f10.6)') (e_mpi(ie,ik),ie=1,neg)
          end do
       end if
       deallocate(e_mpi,e_mpi2)
    end if
! --------------------------------------------------

    allocate( eeig2(np2,neg,1) ); eeig2 = 0.d0
    if (icomponent == TOTAL .and. sw_pdos == ON) then
       allocate( compr(neg,nlmta_phi,nopr,np2*ndim_spinor));  compr = 0.d0
       allocate( compi(neg,nlmta_phi,nopr,np2*ndim_spinor));  compi = 0.d0
       allocate( norm_phig_mpi(nlmtt_phi,np2));  norm_phig_mpi = 0.d0
    end if

    if (mode==EK .and. ipridos_t >= 1) then
       write(nfout,'(" !dos eko_ek ")')
       do ip2=1,np2
          ik = ndim_spinor*( ip2 -1 ) +1
          write(nfout,'(" !dos -- ik = ",i5)') ik
          write(nfout,'(" !dos ",8f8.4)')( eko_ek(ib,ik),ib=1,neg)
       end do
    end if

    neig=neg

! -------------------------------------------------------
    Do ip2=1, np2
       ik = ndim_spinor *(ip2-1) +1

       if(mode == EK) then
          do ib=1,neg
             eeig2(ip2,ib,1)=eko_ek(ib,ik)
          enddo
          do ib = 1,neg-1
             do jb = ib+1, neg
                if ( eeig2(ip2,jb,1) < eeig2(ip2,ib,1)-delta) then
                   et = eeig2(ip2,ib,1)
                   eeig2(ip2,ib,1) = eeig2(ip2,jb,1)
                   eeig2(ip2,jb,1) = et
                end if
             end do
          end do
       else if(mode == SCF) then
          if(map_k(ik) /= myrank_k) cycle

          do ib = 1, neg
             ip = neordr(ib,ik)
             if (map_e(ip) == myrank_e) then
                eeig2(ip2,ib,1) = eko_l(map_z(ip),ik)
                if (icomponent == TOTAL .and. sw_pdos == ON) then

                   Do is1=1, ndim_spinor
                      compr(ib,1:nlmta_phi,1:nopr,ik+is1-1) &
                           &  = compr_l(map_z(ip),1:nlmta_phi,1:nopr,ik+is1-1)
                      
                      if ( k_symmetry(ik) /= GAMMA ) then
                         compi(ib,1:nlmta_phi,1:nopr,ik+is1-1) &
                              &  = compi_l(map_z(ip),1:nlmta_phi,1:nopr,ik+is1-1)
                      else
                         stop "Not supported : Gamma symmetry in noncollinear"
                      endif
                   End do
                   norm_phig_mpi(1:nlmtt_phi,ip2) = norm_phig(1:nlmtt_phi,ip2)
                end if
             end if
          enddo
       end if

    End do
! -------------------------------------------------------

    if (mode == SCF) then
       if (npes >= 2) then
          allocate(eeig2_mpi(np2,neg,1)); eeig2_mpi = 0.d0
          call mpi_allreduce( eeig2, eeig2_mpi, np2*neg, mpi_double_precision, &
               &              mpi_sum, mpi_comm_group, ierr )
          eeig2 = eeig2_mpi
          deallocate(eeig2_mpi)

          if (icomponent == TOTAL .and. sw_pdos == ON) then
            allocate( compr_mpi(neg,nlmta_phi,nopr,np2*ndim_spinor) ); compr_mpi=0.d0
            allocate( compi_mpi(neg,nlmta_phi,nopr,np2*ndim_spinor) ); compi_mpi=0.d0
            allocate( norm_phig_mpi2(nlmtt_phi,np2) ); norm_phig_mpi2 = 0.d0
            call mpi_allreduce( compr, compr_mpi, neg*nlmta_phi*nopr*np2*ndim_spinor,&
                 &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
            call mpi_allreduce( compi,compi_mpi, neg*nlmta_phi*nopr*np2*ndim_spinor, &
                 &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
            call mpi_allreduce( norm_phig_mpi, norm_phig_mpi2, nlmtt_phi*np2, &
                 &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )

            compr = compr_mpi;    compi = compi_mpi
            norm_phig_mpi = norm_phig_mpi2 / dble(nrank_e)
            deallocate(compr_mpi,compi_mpi,norm_phig_mpi2)
          end if

       end if
    end if

! ------------------------------------------------------------
    if (ipridos >= 2) then

       write(nfout,'(" !dos: --eeig2(energy_eigenvalue)--")')
       iloop = (neg-1)/ncl+1

       do ip2 = 1, np2
          do i = 1, iloop
             write(nfout,'(" !dos: (",i5,") ",8f9.5)') &
                  & ip2,(eeig2(ip2,ib,1),ib=ncl*(i-1)+1,min(neg,ncl*i))
          end do
       end do

       if (sw_pdos == ON) then

          do ip2 = 1, np2 
             ik = ndim_spinor *(ip2-1) + 1

             write(nfout,'(" !dos:  ip2 = ",i7)') ip2
             write(nfout,'(" !dos norm_phig: ",10f8.4)') &
                  & norm_phig_mpi(1:nlmtt_phi,ip2)
             
             do iopr=1,nopr
                do iorb=1,nlmta_phi
                   write(nfout,'(" !dos: ik=",i5," iopr=",i5," iorb=",i5)')&
                        &  ik, iopr, iorb
                   write(nfout,'(" !dos compr: ",10f8.4)') &
                        & compr(1:neg,iorb,iopr,ik)
                   write(nfout,'(" !dos compi: ",10f8.4)') &
                        & compi(1:neg,iorb,iopr,ik)
                end do
             end do
          end do
       end if

    end if
! -----------------------------------------------------

    if (mode == EK) then
       
       allocate( e_mpi( neg,kv3_ek/ndim_spinor) );   e_mpi = 0.d0;

       do ip2=1, np2
          ik = ( ip2 -1 )*ndim_spinor + 1
          e_mpi( :, ip2 ) = eko_ek( :, ik )
       end do
       call find_Erange( e_mpi, neg, kv3_ek /ndim_spinor )
       deallocate( e_mpi )

    else
       Eminimum = minval(eeig2) - 0.005 ! (hartree)
       Emaximum = maxval(eeig2) + 0.005 ! (hartree)
       nEWindows = (Emaximum - Eminimum)/DeltaE_dos + 1
    end if
       
    if (ipridos >= 2) &
         & write(nfout,'(" !dos: Emaximum, Eminimum, nEwindows = ",2f10.6,i7)') &
         &       Eminimum,Emaximum, nEWindows

    call alloc_dos(0,icomponent)

! ----------------------------------------------------
    wei = 1.d0                ! ??????????????? 2.0 ? docchi _
 
    if(ipridos >= 2) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration === <<m_ESdos_tetrahedral_noncl>>'
    if(ipridos >= 2) write(nfout,'(" !m_ES_dos dos_subroutine = ",i5)') dos_subroutine

! ---------------------------------------------------

    if ( calc_dos_magmom_contrib == YES ) then
       ismax = ndim_magmom
    else
       ismax = 1
    endif
! -------------------------------------------------

    if (dos_subroutine == 3) then
       allocate(e(0:nEwindows))
       e(0:nEwindows) = (/(Eminimum + DeltaE_dos*ie,ie=0,nEWindows)/)
                      ! e(0) = Eminimum, e(1) = Eminimum+DeltaE_dos, 
                      ! e(2) = Eminimum+DeltaE_dos*2,...
       
       allocate(cdos(np2,neg,0:nEWindows)); cdos = 0.d0
       allocate(cind(np2,neg,0:nEWindows)); cind = 0.d0
       allocate(eawk(np0)); eawk = 0.d0
       allocate(cdwk(np0)); cdwk = 0.d0
       allocate(cswk(np0)); cswk = 0.d0

       call nstt3i(idim,nEwindows,e,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
            &  ,np2,np2,neig,eeig2(1,1,1) &
            &  ,ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra ) ! -> cdos, cind
       deallocate(cswk,cdwk,eawk)

       clpm = 1.d0

       if (icomponent == TOTAL .and. sw_pdos == ON) then
          allocate( porb_ssrep( nlmta_phi, ndim_chgpot ) ); porb_ssrep = 0.0d0
          allocate( porb( nlmta_phi, ndim_magmom ) ); porb = 0.0d0
       endif

       do ip2 = 1, np2
          ik = ndim_spinor *(ip2-1) +1

          do ib = 1, neg
             
             Do istmp=1, ismax
                clpm = dos_weight_noncl( ib,ik,istmp )

                do ie = 0, nEwindows
                   dos(ie,istmp) = dos(ie,istmp) + cdos(ip2,ib,ie)*clpm*wei
                   sumdos(ie,istmp) = sumdos(ie,istmp) + cind(ip2,ib,ie)*clpm*wei
                end do
             End do

             if (icomponent == TOTAL .and. sw_pdos == ON) then
                clpm = 1.0d0
                porb_ssrep = 0.d0

! -----------------
                Do iorb = 1,nlmta_phi
                   call m_PP_tell_iorb_lmtt(iorb,lmtt)

                   if ( k_symmetry(ik) == GAMMA ) then
                      stop 'Not supported '
                   else

                      Do is1=1, ndim_spinor
                         Do is2=1, ndim_spinor
                            istmp = ( is1 -1 )*ndim_spinor + is2
                            
                            ztemp = 0.0d0
                            do iopr=1,nopr
                               z1 = dcmplx( compr(ib,iorb,iopr,ik+is1-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is1-1 ) )
                               z2 = dcmplx( compr(ib,iorb,iopr,ik+is2-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is2-1 ) )
                               ztemp = ztemp + z1 *conjg(z2) &
                                    &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ip2) )
                            end do
                            
                            porb_ssrep(iorb,istmp) = porb_ssrep(iorb,istmp) &
                                 &                   + ztemp /dble(nopr)
                         End do
                      End do
                   endif
                End Do
! ---------------------
                call m_ES_DensMat_To_MagMom_porb( nlmta_phi, porb_ssrep, porb )

                do ie = 0, nEwindows
                   pdos(ie,iorb,:) = pdos(ie,iorb,:) &
                        &           + cdos(ip2,ib,ie) *wei *porb(iorb,:)
                   sumpdos(ie,iorb,:) = sumpdos(ie,iorb,:) &
                        &           + cind(ip2,ib,ie) *wei *porb(iorb,:)
                end do

             end if
          end do
       end do

       deallocate(cind,cdos);     deallocate(e)
       if ( allocated( porb ) ) deallocate( porb )
       if ( allocated( porb_ssrep ) ) deallocate( porb_ssrep )

! ---------------------------------------------------
    else if(dos_subroutine == 4) then
       allocate(cdos(0:nEwindows,np2,neg)); cdos = 0.d0
       allocate(cind(0:nEwindows,np2,neg)); cind = 0.d0
       nEwindows_plus = nEwindows

       if(mod(nEwindows_plus,2)==1) nEwindows_plus = nEwindows_plus+1
       allocate(doswk(0:nEwindows_plus,4))
       allocate(dosinwk(0:nEwindows_plus,4))
       mtetra = product(nxyz_tetra(1:3))*6

       allocate(nttra(mtetra,4))
       call prepare_nttra(nxyz_tetra,mtetra,nttra)
       write(nfout,'(" !dos after prepare_nttra")')
       write(nfout,'(" !dos neig = ",i5)') neig

       cdos = 0.d0; cind =0.d0
       call nstt4i(ipridos,idim,nEwindows,nxyz_tetra,np2,np2,neig,eeig2(1,1,1) &
            &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos &
            &   ,  nEwindows_plus,doswk,dosinwk,cdos,cind)
       deallocate(nttra);     deallocate(dosinwk,doswk)

       clpm = 1.d0

       do ip2 = 1,np2
          ik = ndim_spinor*(ip2-1) +1

          do ib = 1, neg
             Do istmp=1, ismax
                clpm = dos_weight_noncl(ib,ik,istmp)
                                       ! clpm -> clpm(ib,ik)
                do ie = 0, nEwindows
                   dos(ie,istmp) = dos(ie,istmp) + cdos(ie,ip2,ib)*clpm*wei
                   sumdos(ie,istmp) = sumdos(ie,istmp) + cind(ie,ip2,ib)*clpm*wei
                end do
             End do
          end do
       end do

       if (icomponent == TOTAL .and. sw_pdos == ON) then
          allocate( porb_ssrep( nlmta_phi, ndim_chgpot ) ); porb_ssrep = 0.0d0
          allocate( porb( nlmta_phi, ndim_magmom ) ); porb = 0.0d0

          do ip2 = 1,np2
             ik = ndim_spinor *(ip2-1) +1

             do ib = 1, neg
                porb_ssrep = 0.d0

                do iorb = 1,nlmta_phi
                   call m_PP_tell_iorb_lmtt(iorb,lmtt)

                   if ( k_symmetry(ik) == GAMMA ) then
                      stop 'Not supported '
                   else
                      Do is1=1, ndim_spinor
                         Do is2=1, ndim_spinor
                            istmp = ( is1 -1 )*ndim_spinor + is2

                            ztemp = 0.0d0
                            do iopr=1,nopr
                               z1 = dcmplx( compr(ib,iorb,iopr,ik+is1-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is1-1 ) )
                               z2 = dcmplx( compr(ib,iorb,iopr,ik+is2-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is2-1 ) )
                               ztemp = ztemp + z1 *conjg(z2) &
                                    &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ip2) )
                            end do

                            porb_ssrep(iorb,istmp) = porb_ssrep(iorb,istmp) &
                                 &                   + ztemp /dble(nopr)
                         End do
                      End do
                   end if
                End do
! -----                      
                call m_ES_DensMat_To_MagMom_porb( nlmta_phi, porb_ssrep, porb )
!
                do ie = 0, nEwindows
                   pdos(ie,iorb,:) = pdos(ie,iorb,:) &
                        &           + cdos(ie,ip2,ib) *wei *porb(iorb,:)
                   sumpdos(ie,iorb,:) = sumpdos(ie,iorb,:) &
                        &           + cind(ie,ip2,ib) *wei *porb(iorb,:)
                end do
             end do
          end do

          deallocate( porb ); deallocate( porb_ssrep )
       end if

       deallocate(cind,cdos)

! ---------------------------------------------------------------
    else if(dos_subroutine == 5) then
       nEwindows_plus = nEwindows
       if(mod(nEwindows_plus,2)==1) nEwindows_plus = nEwindows_plus+1
       allocate(doswk(0:nEwindows_plus,4))
       allocate(dosinwk(0:nEwindows_plus,4))
       mtetra = product(nxyz_tetra(1:3))*6
       
       allocate(nttra(mtetra,4))
       call prepare_nttra(nxyz_tetra,mtetra,nttra)
       allocate(dos_weight2(neg,np2))
          
       Do istmp=1, ismax

          do ip2 = 1, np2
             ik = ndim_spinor *(ip2-1) +1
             do ib = 1, neg
                dos_weight2(ib,ip2) = dos_weight_noncl(ib,ik,istmp)
             end do
          end do

          call care_of_degenerate_state( neig, np2, 1, 1, eeig2, dos_weight2 )
                                                       !dos_weight

          dos_weight2 = dos_weight2*wei

          dos(:,istmp) = 0.d0;           sumdos(:,istmp) = 0.d0

          call nstt5i(ipridos,idim,Eminimum,Emaximum,nEwindows,nxyz_tetra,np2,np2 &
               &   ,  neig,eeig2(1,1,1) &
               &   ,  ip20,np0,np2,neig,mtetra,nttra,deltae_dos,dos_weight2 &
               &   ,  nEwindows_plus,doswk,dosinwk,dos(0,istmp),sumdos(0,istmp) )
       End do

       if (icomponent == TOTAL .and. sw_pdos == ON) then
          
          allocate( porb_ssrep5( neg, np2, ndim_chgpot ) ); porb_ssrep5 = 0.0d0
          allocate( dos_weight3( neg, np2, ndim_magmom ) ); dos_weight3 = 0.0d0

          do iorb = 1, nlmta_phi
             call m_PP_tell_iorb_lmtt(iorb,lmtt)

             porb_ssrep5 = 0.0d0
! ---------------
             do ip2 = 1, np2
                ik = ndim_spinor*( ip2 -1 ) +1

                do ib = 1, neg
                   if ( k_symmetry(ik) == GAMMA ) then
                      stop 'Not supported '
                   else
                      Do is1=1, ndim_spinor
                         Do is2=1, ndim_spinor
                            istmp = ( is1 -1 )*ndim_spinor + is2

                            ztemp = 0.0d0
                            do iopr=1,nopr
                               z1 = dcmplx( compr(ib,iorb,iopr,ik+is1-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is1-1 ) )
                               z2 = dcmplx( compr(ib,iorb,iopr,ik+is2-1 ), &
                                    &       compi(ib,iorb,iopr,ik+is2-1 ) )
                               ztemp = ztemp + z1 *conjg(z2) &
                                    &      *( 1.d0+qorb(iorb)/norm_phig_mpi(lmtt,ip2) )
                            end do

                            porb_ssrep5(ib,ip2,istmp) = porb_ssrep5(ib,ip2,istmp) &
                                 &                   + ztemp /dble(nopr)
                         End do
                      End Do

                   endif

                end do
             end do
! ---------------
             call m_ES_DensMat_To_MagMom_porb( np2*neg, porb_ssrep5, dos_weight3 )
             dos_weight3 = dos_weight3 *wei
! ------------------------------------ - - -- - 
             Do istmp=1, ndim_magmom
                call care_of_degenerate_state( neig, np2, 1, 1, eeig2, &
                     &                         dos_weight3(:,:,istmp) )
                                                               !dos_weight
                call nstt5i( ipridos, idim, Eminimum, Emaximum, nEwindows, &
                     &       nxyz_tetra, np2, np2, neig, eeig2(1,1,1), &
                     &       ip20, np0, np2, neig, mtetra, nttra, deltae_dos, &
                     &       dos_weight3(:,:,istmp), nEwindows_plus, &
                     &       doswk, dosinwk, pdos(0,iorb,istmp), &
                     &       sumpdos(0,iorb,istmp) )
             End Do

          end do
          
          deallocate( dos_weight3 );  deallocate( porb_ssrep5 )

       end if

       deallocate(dos_weight2);    deallocate(nttra);  deallocate(dosinwk,doswk)
    end if
! ----------------------------------------------------------

    deallocate(eeig2)

    if(icomponent == TOTAL) call get_VBM(totch,1.d-12)  ! -> ValenceBandMaximum

    if(mype == 0) then
       if ( calc_dos_magmom_contrib == YES ) then
          call write_dos_noncl(nfdos)
       else
          call write_dos_noncl_for_totchg(nfdos)
       endif
    endif

    if(mype == 0 .and. icomponent == TOTAL .and. sw_pdos == ON) then
       call write_pdos_noncl(nfdos)
    endif

    call dealloc_dos()
    call tstatc0_end(id_sname)
!!$#endif
  end subroutine m_ESdos_tetrahedral_noncl
! ==================================================================== 11.0

  subroutine doscal_nstt(nEwindows,nxyz_tetra,np2,neg,eeig2,ip20,np0,wei,cdos,cind)
    integer, intent(in) :: nEwindows, np2, neg, np0
    integer, intent(in), dimension(3) :: nxyz_tetra
    real(kind=DP), intent(in), dimension(np2,neg) ::eeig2
    integer, intent(in), dimension(np0) :: ip20
    real(kind=DP), intent(in)           :: wei
    real(kind=DP), dimension(np2,neg,0:nEwindows) :: cdos, cind

    integer :: mtetra
    integer, allocatable, dimension(:,:)     :: nttra  ! d(mtetra,4)
    integer, allocatable, dimension(:)       :: ip8    ! d(8)
    real(kind=DP), allocatable, dimension(:) :: voltt  ! d(mtetra)
    real(kind=DP), allocatable, dimension(:,:) :: vctk, vwork ! d(4,3)
    integer, allocatable, dimension(:)       :: k_sample_mesh !d(3)
    real(kind=DP), dimension(4)              :: e
    integer, parameter :: D12 = 1, D13 = 2, D14 = 3, D23 = 4, D24 = 5 &
         &         , D34 = 6, DM  = 7, DA  = 8, mdoswk = da
    real(kind=DP), allocatable, dimension(:,:) :: dos ! d(nEwindows,neg)
    real(kind=DP), allocatable, dimension(:)   :: d

    integer :: ix,iy,iz,icub,npx,npy,ni,ip0,kx,ky,kz,nx1,ny1,nz1,nd,nn,nt,i,j,nxx,nyy,nzz,nv(3),iv,ib,ie
    integer :: iswap1, iswap2, ns, ne, idos
    real(kind=DP) :: sumv,es,ee,v,x,f0,f1,f2,f3,ed

    mtetra = product(nxyz_tetra(1:3))*6
    allocate(nttra(mtetra,4))
    allocate(voltt(mtetra))

    allocate(ip8(8))
    npx = nxyz_tetra(1)+1
    npy = nxyz_tetra(2)+1
    icub = 0
    do iz = 0, nxyz_tetra(3)-1
       do iy = 0, nxyz_tetra(2)-1
          do ix = 0, nxyz_tetra(1)-1
             icub = icub+1
             ni=npx*(npy*iz+iy)+ix
             do kz=1,2
                do ky=1,2
                   do kx=1,2
                      ip0 = ni+npx*(npy*(kz-1)+ky-1)+kx
                      ip8(kx+2*(ky-1)+4*(kz-1)) = ip0
                   end do
                end do
             end do
             nttra((icub-1)*6+1, 1:4) = (/ip8(1),ip8(2),ip8(4),ip8(8)/)
             nttra((icub-1)*6+2, 1:4) = (/ip8(1),ip8(2),ip8(6),ip8(8)/)
             nttra((icub-1)*6+3, 1:4) = (/ip8(1),ip8(5),ip8(6),ip8(8)/)
             nttra((icub-1)*6+4, 1:4) = (/ip8(1),ip8(3),ip8(4),ip8(8)/)
             nttra((icub-1)*6+5, 1:4) = (/ip8(1),ip8(3),ip8(7),ip8(8)/)
             nttra((icub-1)*6+6, 1:4) = (/ip8(1),ip8(5),ip8(7),ip8(8)/)
          end do
       end do
    end do
    deallocate(ip8)

    nxx = nxyz_tetra(1)
    nyy = nxyz_tetra(2)
    nzz = nxyz_tetra(3)
    allocate(k_sample_mesh(3))
    call m_Kp_sample_mesh(k_sample_mesh)
    nx1 = max(k_sample_mesh(1),1)
    ny1 = max(k_sample_mesh(2),1)
    nz1 = max(k_sample_mesh(3),1)
    deallocate(k_sample_mesh)
    nd = nx1*ny1*nz1
    if(ipridos >=2 ) write(nfout,'(" nd = ",i8)') nd
    allocate(vctk(4,3),vwork(4,3))
    if(ipridos>=2) write(nfout,'(" trmat = ",9f8.4)') trmat
    sumv = 0.d0
    do nt = 1, mtetra
       if(ipridos>=2) write(nfout,'(" nt = ",i8," : ",4i8)') nt, nttra(nt,1:4)
       do i = 1,4
          nn = nttra(nt,i)
          ix = mod(nn-1,nxx+1)
          iy = mod((nn-ix-1)/(nxx+1),nyy+1)
          iz = (nn-ix-1-iy*(nxx+1))/((nxx+1)*(nyy+1))
          nv(1) = ix*ny1*nz1; nv(2) = nx1*iy*nz1; nv(3) = nx1*ny1*iz
          if(ipridos >=2) write(nfout,'("  nvtk(",i4,",1:3) = ",3i8)') i,nv(1:3)
          vctk(i,1:3) = matmul(trmat,nv)/dble(nd)
       end do
       if(ipridos >=2) then
          write(nfout,'("  v(1) = ",3f8.4)') vctk(1,1:3)
          write(nfout,'("  v(2) = ",3f8.4)') vctk(2,1:3)
          write(nfout,'("  v(3) = ",3f8.4)') vctk(3,1:3)
          write(nfout,'("  v(4) = ",3f8.4)') vctk(4,1:3)
       end if

       do j = 1, 3
          vwork(1,j) = vctk(4,j) - vctk(1,j)
          vwork(2,j) = vctk(4,j) - vctk(2,j)
          vwork(3,j) = vctk(4,j) - vctk(3,j)
       enddo
       !     outer production
       vwork(4,1) = vwork(1,2)*vwork(2,3) - vwork(1,3)*vwork(2,2)
       vwork(4,2) = vwork(1,3)*vwork(2,1) - vwork(1,1)*vwork(2,3)
       vwork(4,3) = vwork(1,1)*vwork(2,2) - vwork(1,2)*vwork(2,1)
       !     inner procution
       voltt(nt) = dabs(dot_product(vwork(3,1:3),vwork(4,1:3)))/6.d0
       sumv = sumv + voltt(nt)
       if(ipridos >= 2) write(nfout,'(3x,i3,2x,f18.12)') nt,voltt(nt)
    end do
    if(ipridos >= 2) write(nfout,'(" sumv = ",f16.8, " univol*sumv/(2pi)**3 = ",f16.8)') sumv,univol*sumv/(PAI2*PAI2*PAI2)
    if(ipridos >= 2) write(nfout,'(" np2 = ",i8)') np2
    
    es = minval(eeig2)-0.005
    ee = maxval(eeig2)+0.005

    allocate(d(mdoswk))
    allocate(dos(nEwindows,neg))
    do iv = 1, mtetra
       v = 6.0d0*voltt(iv)*univol/(PAI2*PAI2*PAI2*nspin)
       write(nfout,'(" iv = ",i8," v = ",d12.4)') iv,v
       dos = 0.d0
       do ib = 1 ,neg
          do ie = 1, 4
             if(ip20(nttra(iv,ie)) > np2) then
                write(nfout,'(" nttra(iv,ie) = ",i8)') nttra(iv,ie)
             end if
             e(ie) = eeig2(ip20(nttra(iv,ie)),ib)
          end do
          do iswap1 = 1, 3
             do iswap2 = iswap1+1,4
                if(e(iswap1) < e(iswap2)) then
                   x = e(iswap1)
                   e(iswap1) = e(iswap2)
                   e(iswap2) = x
                end if
             end do
          end do
          if(e(4) > ee) cycle
          NS = (E(4) - ES)/DELTAE_dos + 1
          IF(NS.GT.nEwindows) cycle
          NE = (E(1) - ES)/DELTAE_dos + 1
          IF(NE.GT.nEwindows) NE = nEwindows

          write(nfout,'(" (iv,ib)=(",i4,",",i4,"), e = ",4f8.4," ns, ne = ",2i8)') iv,ib,e(1:4),ns,ne
          IF((NE-NS) == 0) THEN
             DOS(NS,ib) = DOS(NS,ib) + V/DELTAE_dos
          ELSE IF((NE-NS).EQ.1 ) THEN
             DOS(NS,ib) = DOS(NS,ib) + V/(2.D0*DELTAE_dos)
             DOS(NE,ib) = DOS(NE,ib) + V/(2.D0*DELTAE_dos)
          ELSE
             D(D34) = E(3) - E(4)
             D(D24) = E(2) - E(4)
             D(D14) = E(1) - E(4)
             D(D23) = E(2) - E(3)
             D(D13) = E(1) - E(3)
             D(D12) = E(1) - E(2)
             D(DM) = D(D13) + D(D24)
             D(DA) = (E(1)*E(2)-E(3)*E(4))/D(DM)

             if(d(d34).lt.deltae_dos) then
                f0 = 0.d0
             else
                f0 = v/(d(d34)*d(d24)*d(d14))
             endif

             F1 = V/D(DM)
             if(d(d23).lt.deltae_dos) then
                f2 = 0.d0
             else
                f2 = v*d(dm)/(d(d24)*d(d14)*d(d23)*d(d13))
             endif
             if(d(d12).lt.deltae_dos) then
                f3 = 0.d0
             else
                f3 = v/(d(d14)*d(d13)*d(d12))
             endif

             DO IDOS = NS, NE
                ED = ES + DELTAE_dos*(IDOS-0.5)
                IF(ED.LE.E(3)) THEN
                   DOS(IDOS,ib) = DOS(IDOS,ib) + (ED - E(4))*(ED - E(4)) * F0
                ELSE IF(ED.LE.E(2)) THEN
                   DOS(IDOS,ib) = DOS(IDOS,ib) + F1 - F2*(ED - D(DA))*(ED - D(DA))
                ELSE IF(ED.LE.E(1)) THEN
                   DOS(IDOS,ib) = DOS(IDOS,ib) + (ED - E(1))*(ED - E(1)) * F3
                ENDIF
             end DO
          ENDIF
          write(nfout,'(" tetra = ",i8," ik = ",4i8," ns,ne=",2i8)') &
               & iv, (ip20(nttra(iv,ie)),ie=1,4), ns, ne
!!$),ip20(nttra(iv,2)),ip20(nttra(iv,3)),ip20(nttra(iv,4)),ns,ne
          write(nfout,'(" dos = ",6d12.4)') (dos(idos,ib),idos=min(ns+10,ne),min(ns+15,ne))
          do ie = 1, 4
             i = ip20(nttra(iv,ie))
             do idos = ns, ne
                cdos(i,ib,idos) = cdos(i,ib,idos) + dos(idos,ib)*0.25/wei
             end do
          end do
       end do
    end do
    do i = 1, np2
       do ib = 1, neg
          cind(i,ib,1) = cdos(i,ib,1)*deltaE_dos
          do idos = 2, nEwindows
             cind(i,ib,idos) = cind(i,ib,idos-1)+cdos(i,ib,idos)*deltaE_dos
          end do
       end do
    end do
    deallocate(d)
    deallocate(dos)
    deallocate(vctk,vwork)
    deallocate(voltt,nttra)
  end subroutine doscal_nstt
 
  subroutine m_ESdos_rd_pdos_param(nfout)
    use m_Const_Parameters, only : FMAXVALLEN, ON, NOCONV, LOWER &
          &                      , Projector, Wavefunction, Mulliken
    use m_Ionic_System, only : speciesname,ntyp
    integer, intent(in) :: nfout

    character(len=FMAXVALLEN) :: rstr
    integer :: iret, f_selectBlock, f_getStringValue, f_getIntValue
    integer :: f_selectTop, f_selectParentBlock
    real(kind=DP) :: dret
    logical :: prealloc, tag_is_found
    integer :: i,it,n

    iret = f_selectTop()

    if( f_selectBlock(tag_postprocessing) == 0) then

! --- pdos
       if( f_selectBlock(tag_pdos) == 0) then
          if(f_getIntValue( tag_sw_orb_popu, iret) == 0) sw_orb_popu = iret
          if(f_getIntValue( tag_sw_pdos, iret) == 0) then
             sw_pdos = iret
             if(sw_pdos == ON) sw_orb_popu = ON
!             if ( sw_pdos == ON ) sw_dos = ON
          end if
!!$if(sw_orb_popu == ON) then
!!$   iret = f_getStringValue(tag_method,rstr,LOWER)
!!$   if( rstr == tag_projector) then
!!$      pdos_method = Projector
!!$   else if( rstr == tag_wavefunction) then
!!$      pdos_method = Wavefunction
!!$   else if( rstr == tag_mulliken) then
!!$      pdos_method = Mulliken
!!$   end if
!!$   if( f_selectBlock(tag_orbitals) == 0) then
!!$      prealloc = .true.
!!$      call set_orbitals(prealloc) ! --> norbital 
!!$      prealloc = .false.
!!$      call set_orbitals(prealloc) ! --> l_orb,t_orb
!!$      iret = f_selectParentBlock()
!!$   else
!!$      stop ' orbitals are not given properly in the inputfile'
!!$   end if
!!$end if
          if(ipriinputfile >= 1) then
             write(nfout,'(" !** sw_pdos             = ",i3)') sw_pdos
             write(nfout,'(" !** sw_orb_popu         = ",i3)') sw_orb_popu
!!$write(nfout,'(" !** pdos_method         = ",i3)') pdos_method
!!$if(sw_orb_popu == ON) then
!!$   write(nfout,'(" !** === orbitals === ")')
!!$   write(nfout,'(" !**   no   l   t   rc       k         type")')
!!$   n = 0
!!$   do it=1,ntyp
!!$      do i=1,norbital(it)
!!$         n = n + 1
!!$         write(nfout,'(" !** ",3i4,2f10.5,a6)') &
!!$           & n,l_orb(i,it),t_orb(i,it),rc_orb(i,it),k_orb(i,it),speciesname(it)
!!$      end do
!!$   end do
!!$end if
          end if
          iret = f_selectParentBlock()
       end if             ! pdos
       iret = f_selectParentBlock()
    end if

  contains

    subroutine set_orbitals(prealloc)
      logical, intent(in) :: prealloc

      character(len=FMAXVALLEN) :: rstr
      integer :: i,iret,ip,rint,it
      integer :: f_selectFirstTableLine, f_selectNextTableLine &
           &, f_getIntValue, f_getRealValue, f_getStringValue
      real(kind=DP) :: dret
      logical :: first

      if(.not.prealloc) then
         maxorb = 0
         do it=1,ntyp
            maxorb = max(maxorb,norbital(it))
         end do
         allocate(l_orb(maxorb,ntyp))
         allocate(t_orb(maxorb,ntyp))
         allocate(rc_orb(maxorb,ntyp)); rc_orb=0.d0
         allocate(k_orb(maxorb,ntyp)); k_orb=0.d0
      else
         allocate(norbital(ntyp)); norbital = 0
      end if

      do it=1,ntyp
         i = 1
         first = .true.
         do while(.true.)
            if (first) then
               if(f_selectFirstTableLine() /= 0) then
                  exit
               end if
               first = .false.
            else
               if(f_selectNextTableLine() /= 0) then
                  exit
               end if
            end if
            iret = f_getStringValue(tag_element,rstr,NOCONV)
            if(rstr == speciesname(it)) then
               if(.not.prealloc) then
                  ip = i
                  if( f_getIntValue(tag_l, rint) == 0) l_orb(ip,it) = rint
                  if( f_getIntValue(tag_t, rint) == 0) t_orb(ip,it) = rint
                  if( f_getRealValue(tag_rc, dret, 'bohr') == 0) rc_orb(ip,it) = dret
                  if( f_getRealValue(tag_k, dret, '') == 0) k_orb(ip,it) = dret
               end if
               i = i + 1
            end if

         end do
         norbital(it) = i - 1
      end do

    end subroutine set_orbitals

  end subroutine m_ESdos_rd_pdos_param

  subroutine prepare_nttra(nxyz_tetra,mtetra,nttra)
    integer, intent(in),  dimension(3)        :: nxyz_tetra
    integer, intent(in)                       :: mtetra
    integer, intent(out), dimension(mtetra,4) :: nttra

    integer :: npx,npy,icub,ix,iy,iz,ni,kx,ky,kz,ip0
    integer, allocatable, dimension(:) :: ip8

    allocate(ip8(8))
    npx = nxyz_tetra(1)+1
    npy = nxyz_tetra(2)+1
    icub = 0
    do iz = 0, nxyz_tetra(3)-1
       do iy = 0, nxyz_tetra(2)-1
          do ix = 0, nxyz_tetra(1)-1
             icub = icub+1
             ni=npx*(npy*iz+iy)+ix
             do kz=1,2
                do ky=1,2
                   do kx=1,2
                      ip0 = ni+npx*(npy*(kz-1)+ky-1)+kx
                      ip8(kx+2*(ky-1)+4*(kz-1)) = ip0
                   end do
                end do
             end do
             nttra((icub-1)*6+1, 1:4) = (/ip8(1),ip8(2),ip8(4),ip8(8)/)
             nttra((icub-1)*6+2, 1:4) = (/ip8(1),ip8(2),ip8(6),ip8(8)/)
             nttra((icub-1)*6+3, 1:4) = (/ip8(1),ip8(5),ip8(6),ip8(8)/)
             nttra((icub-1)*6+4, 1:4) = (/ip8(1),ip8(3),ip8(4),ip8(8)/)
             nttra((icub-1)*6+5, 1:4) = (/ip8(1),ip8(3),ip8(7),ip8(8)/)
             nttra((icub-1)*6+6, 1:4) = (/ip8(1),ip8(5),ip8(7),ip8(8)/)
          end do
       end do
    end do
    deallocate(ip8)
  end subroutine prepare_nttra

  subroutine care_of_degenerate_state(neig,np2,nspin,ispin,eeig2,dos_weight2)
    integer, intent(in) :: neig,np2,nspin,ispin
!!$    real(kind=DP),intent(in),dimension(neig,np2,nspin) :: eeig2
    real(kind=DP),intent(in),dimension(np2,neig,nspin) :: eeig2
    real(kind=DP),intent(inout),dimension(neig,np2) :: dos_weight2(neig,np2)
    real(kind=DP) :: eps,c1
    integer :: k2, ieig, n, i, ie
! ---- following lines are the later part of subroutine nstt3i --
!     take care of a weight on a degenerate state
!
    eps = dfloat(10)**(-5)

    do k2=1,np2
       if(ipridos >= 3) write(nfout,'(" k2 = ",i5," <<care_of_degenerate_state>>")') k2
       ieig=1
40     continue
       n=1
!!$do 42 i=1,20
       do i=1,neig
          if(ieig+i.gt.neig) go to 44
          if(dabs(eeig2(k2,ieig+i,ispin)-eeig2(k2,ieig,ispin)).lt.eps) then
             n=n+1
             cycle
          end if
          go to 44
       end do

44     continue

       if(ipridos >= 3) write(nfout,'("       n = ",i5)')  n
       c1=0
       do i=0,n-1
          if(ieig+i>neig) then
             if(ipridos>=1) write(nfout,'(" ieig+i = ",i8," > neig = ",i8)') ieig+i,neig
             cycle
          end if
          c1=c1+dos_weight2(ieig+i,k2)
       end do
       c1=c1/n
       do i=0,n-1
          if(ieig+i>neig) then
             if(ipridos>=1) write(nfout,'(" ieig+i = ",i8," > neig = ",i8)') ieig+i,neig
             cycle
          end if
          dos_weight2(ieig+i,k2)=c1
       end do
       ieig=ieig+n
       if(ieig.lt.neig) go to 40
    end do
  end subroutine care_of_degenerate_state

! ==================== added by K. Tagami ==================== 11.0
  subroutine m_ESdos_set_dos_weight_noncl()
    integer,allocatable,dimension(:,:) :: meshwk
    integer :: ik, ip, ib,j,i
    integer :: ekmode_t

    integer :: is, istmp

    real(kind=DP) :: denom, chgq0( ndim_magmom )
    real(kind=DP), allocatable, dimension(:,:) :: bfft_kt 
    real(kind=DP), allocatable, dimension(:,:) :: chgq_enl_kt(:,:,:)

    allocate( chgq_enl_kt(kgp,kimg,ndim_magmom) )
    chgq_enl_kt = 0.0d0

    denom = 1.d0/product(fft_box_size_WF(1:3,1))

    dos_weight_noncl = 0.0d0

    if ( calc_dos_magmom_contrib == NO ) then
       dos_weight_noncl( :,:,1 ) = 1.0d0
       return
    endif

! === ASMS 2017/09/04
    call m_CD_keep_retrieve_hsr(.true.)
! === ASMS 2017/09/04

    if (ekmode == ON) then
       do ik = 1, kv3, ndim_spinor
          call m_FFT_alloc_WF_work()
          allocate(bfft_kt(nfft,ndim_spinor))
          do ib = 1, neg
             bfft_kt = 0.d0
             if (map_ek(ib,ik) == mype ) then
                Do is=1, ndim_spinor
                   call m_ES_WF_in_Rspace(ik+is-1,ib,bfft_kt(:,is))
                End do
                ip = mype
             end if
             if (npes > 1) then
                call mpi_bcast( bfft_kt, nfft*ndim_spinor, mpi_double_precision,&
                     &          ip, mpi_comm_group, ierr )
             endif
             
             call set_dos_contrib_softpart(1,ib)
          end do

          deallocate(bfft_kt)
          call m_FFT_dealloc_WF_work()
          
          if (modnrm == EXECUT) then
             call m_FFT_alloc_CD_box()
             do ib = 1, neg
                call m_CD_hardpart_sub_noncl( nfout, ik, ib, chgq0 )  ! -> chgq_l
                call set_dos_contrib_hardpart( ik, ib )
             End do
             call m_FFT_dealloc_CD_box()
          end if
       end do

    else if (ekmode == OFF) then
       if (modnrm == EXECUT) call m_CD_set_ylm_enl_etc()
       
       if (hardpart_subroutine==2.or.sw_rspace_ldos==ON)then
             
          do ik = 1, kv3, ndim_spinor
             if (map_k(ik) /= myrank_k) cycle
                
             call m_FFT_alloc_WF_work()
             allocate( bfft_kt(nfft,ndim_spinor) )

             do ib = ista_e, iend_e, istep_e
                bfft_kt = 0.d0
                Do is=1, ndim_spinor
                   call m_ES_WF_in_Rspace(ik+is-1,ib,bfft_kt(:,is))
                End do
                call set_dos_contrib_softpart(ik,ib)
             end do

             deallocate(bfft_kt)
             call m_FFT_dealloc_WF_work()
                
             if (modnrm == EXECUT) then
                call m_FFT_alloc_CD_box()
                do ib = ista_e, iend_e, istep_e
                   call m_CD_hardpart_sub2_noncl( nfout, ik, ib, chgq0, &
                        &                         chgq_enl_kt )     ! -> chgq_enl
                   call set_dos_contrib_hardpart( ik, ib )
                end do
                call m_FFT_dealloc_CD_box()
             end if
                
          end do

       else

          do ik = 1, kv3, ndim_spinor
             if (map_k(ik) /= myrank_k) cycle
             call m_FFT_alloc_WF_work()
             allocate( bfft_kt(nfft,ndim_spinor) ); bfft_kt = 0.d0

             do ib = 1,neg
                if(map_e(ib)/=myrank_e) cycle
                bfft_kt = 0.d0
                Do is=1, ndim_spinor
                   call m_ES_WF_in_Rspace(ik+is-1,ib,bfft_kt(:,is))
                End do
                call set_dos_contrib_softpart(ik,ib)
             end do

             deallocate(bfft_kt)
             call m_FFT_dealloc_WF_work()
          enddo

!          if (npes > 1) call mpi_barrier(mpi_comm_group,ierr)
             
          if (modnrm == EXECUT) then
             do ik = 1, kv3, ndim_spinor
                call m_FFT_alloc_CD_box()
                do ib = 1,neg
                   call m_CD_hardpart_sub_noncl( nfout, ik, ib, chgq0 )
                   call set_dos_contrib_hardpart(ik,ib)
                end do
                call m_FFT_dealloc_CD_box()
             enddo
          endif
       endif

    end if

    if ( npes > 1 ) call allreduce_dos_weight_noncl

    if (modnrm == EXECUT) call m_CD_dealloc_ylm_enl_etc()
    if (hardpart_subroutine/=2.and.sw_rspace_ldos==OFF) call m_CD_restore_chgq()
    deallocate( chgq_enl_kt )

! === ASMS 2017/09/04
    call m_CD_keep_retrieve_hsr(.false.)
! === ASMS 2017/09/04

  contains

    subroutine set_dos_contrib_softpart(ik,ib)
      integer, intent(in) :: ik,ib

      integer :: i, nel
      integer :: is1, is2, istmp
      real(kind=DP) :: rho_magmom(ndim_magmom)
      real(kind=DP) :: c_nr(ndim_spinor,ndim_spinor)
      real(kind=DP) :: c_ni(ndim_spinor,ndim_spinor)
      real(kind=DP) :: cr, ci, denom

      real(kind=DP), allocatable :: afft_kt(:,:)

      nel = product(fft_box_size_WF(1:3,1))
      denom = 1.d0/dble(nel)

      allocate( afft_kt(nfft,ndim_magmom) );  afft_kt = 0.0d0

      do i = 1, nfft-1, 2

         Do is1 = 1, ndim_spinor
            Do is2 = 1, ndim_spinor
               istmp = ( is1 -1 )*ndim_spinor + is2            
            
               cr =    bfft_kt(i,  is1) *bfft_kt(i,  is2) &
                    & +bfft_kt(i+1,is1) *bfft_kt(i+1,is2)
               
               ci =   -bfft_kt(i,  is1) *bfft_kt(i+1,is2) &
                    & +bfft_kt(i+1,is1) *bfft_kt(i,  is2)
         
               c_nr(is1,is2) = cr;   c_ni(is1,is2) = ci
            End do
         End do
! --------------------------- convert charge from ss-rep to magmom-rep --
         rho_magmom(1) = c_nr(1,1) + c_nr(2,2);         ! ctot
         rho_magmom(2) = c_nr(1,2) + c_nr(2,1);         ! mx
         rho_magmom(3) = c_ni(2,1) - c_ni(1,2);         ! my
         rho_magmom(4) = c_nr(1,1) - c_nr(2,2);          ! mz
! -----------------------------------------------------------------------
         afft_kt(i,:) = rho_magmom(:)
      End do
!
      Do istmp=1, ndim_magmom
         call m_FFT_WF( ELECTRON, nfout, afft_kt(:,istmp), DIRECT, ON )
      End do
      Do istmp=1, ndim_magmom
         dos_weight_noncl(ib, ik, istmp) = afft_kt(1,istmp) *denom
      End Do
!
!      write(950,*) 'ik ib  ', ik, ib
!      write(950,*) 'afft = ', afft_kt(1,1)
!      write(950,*) 'dos w = ', dos_weight_noncl( ib,ik,1 )
!
    end subroutine set_dos_contrib_softpart

    subroutine set_dos_contrib_hardpart(ik,ib)
      integer, intent(in) :: ik,ib

      if ( mype == 0 ) then
         dos_weight_noncl( ib,ik,: ) = dos_weight_noncl( ib,ik,: ) &
              &                      + chgq0(:) *univol
      endif
    end subroutine set_dos_contrib_hardpart

    subroutine allreduce_dos_weight_noncl
      integer :: size1
      real(kind=DP), allocatable :: dos_weight_mpi(:,:,:)

      if ( ekmode == ON ) then
         size1 = neg *kv3_ek *ndim_magmom
         allocate( dos_weight_mpi( neg, kv3_ek, ndim_magmom ) )
      else
         size1 = neg *kv3 *ndim_magmom
         allocate( dos_weight_mpi( neg, kv3, ndim_magmom ) )
      endif
      
      dos_weight_mpi = 0.0d0
      call mpi_allreduce( dos_weight_noncl, dos_weight_mpi, size1, &
           &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
      dos_weight_noncl = dos_weight_mpi
      deallocate(dos_weight_mpi)
    end subroutine allreduce_dos_weight_noncl

  end subroutine m_ESdos_set_dos_weight_noncl

! ============================================================ 11.0

  subroutine m_ESdos_rd_pcohp_param(nfout)
    use m_Const_Parameters, only : FMAXVALLEN, ON, LOWER
    integer, intent(in) :: nfout

    character(len=FMAXVALLEN) :: rstr
    integer :: iret, f_selectBlock, f_getStringValue, f_getIntValue, f_getRealValue
    integer :: f_selectTop, f_selectParentBlock
    real(kind=DP) :: dret
    logical :: prealloc, tag_is_found
    integer :: i,it,n

    iret = f_selectTop()

    if( f_selectBlock(tag_postprocessing) == 0) then
! ---  pcohp --
       if( f_selectBlock( tag_pcohp ) == 0) then
          if ( f_getIntValue( tag_sw_calc_pcohp, iret) == 0) sw_calc_pcohp = iret

          if ( sw_calc_pcohp == ON ) then
             if ( nopr > 1 ) stop "Nopr > 1 is no supported"

             sw_dos = ON ;  sw_pdos = ON;  orb_popu_method = 2
             if(printable) then
                write(nfout,'(A)') "!** orb_popu_method is forced to be 2"
             endif

             if ( f_getIntValue( tag_atom1, iret) == 0 ) then
                if ( iret > 0 .and. iret <= natm ) then
                   atom1_pcohp = iret
                else
                   write(*,*) "set atom1 in the range [1: ", natm ,"]"
                   stop
                endif
             endif
             if ( f_getRealValue( tag_max_distance_from_atom1, dret, "") == 0) then
                max_distance_from_atom1_pcohp = dret
             endif
             if(printable) then
                write(nfout,*) ' ** atom1 of pcohp is ', atom1_pcohp
                write(nfout,*) ' ** max_distance_from_atom1 is ', &
                     &              max_distance_from_atom1_pcohp
             endif
          endif
          iret = f_selectParentBlock()
       endif
! ----------
    end if
  end subroutine m_ESdos_rd_pcohp_param

  subroutine m_ES_calc_pcohp
    integer :: ia, ja, it1, it2
    integer :: ik, ispin, lmt1, lmt2
    integer :: i, is, ie, id
    real(kind=DP) :: c1, w, e, El, Eu, tl, tu, Es, DeltaE, distance
    complex(kind=CMPLDP) :: z1
    
    complex(kind=CMPLDP), allocatable :: mat_p(:,:,:)
    complex(kind=CMPLDP), allocatable :: mat_h(:,:)
    
    integer, parameter :: lun = 355

! --- init --
    allocate( mat_p( neg,nlmt_phi,nlmt_phi ) );
    allocate( mat_h( nlmt_phi,nlmt_phi ) );
    
    allocate( pcohp( 1:nEwindows,nlmt_phi,nlmt_phi,nspin ) ); 
    allocate( sum_pcohp( 1:nEWindows,nlmt_phi,nlmt_phi,nspin ) ); 

    DeltaE = DeltaE_dos
    Es = Eminimum - DeltaE*0.5d0

    if ( mype == 0 ) then
       open( unit=lun, file='pcohp.data', status='unknown', form ='formatted' )
    endif

! ---- begin -----
    ia = atom1_pcohp
    Do ja=1, natm
       if ( ia == ja ) cycle

       call calc_distance_from_atom1( ia, ja, distance )
       if ( distance > max_distance_from_atom1_pcohp ) cycle
       
       it1 = ityp(ia);  it2 = ityp(ja)

       pcohp = 0.0d0;     sum_pcohp = 0.0d0
       
       Do ik=1, kv3
          ispin = mod( ik -1, nspin ) +1
          call calc_matrix_p_nosym( ik, ia, ja, mat_p )
          call calc_matrix_h( ik, ia, ja, mat_p, mat_h )
          
          Do lmt1=1, ilmt_phi(it1)
             Do lmt2=1, ilmt_phi(it2)

                do i = 1, neg
                   w = 1.d0
                   z1 = mat_p(i,lmt1,lmt2) *conjg( mat_h(lmt1,lmt2) )
                   c1 = real(z1)
                   
                   e = eko(i,ik) -nETailWindows*DeltaE -Es
                   is = e /DeltaE;      ie = is +2*nETailWindows
                   
                   if (is < 0) is = 0
                   if (ie >= nEWindows )ie = nEWindows-1
                   
                   do id = is, ie
                      El = Es + id*DeltaE;    Eu = El + DeltaE
                      tl = (El -eko(i,ik))*sqrtdVI;   tu = (Eu -eko(i,ik))*sqrtdVI
                      
                      pcohp(id+1,lmt1,lmt2,ispin) = pcohp(id+1,lmt1,lmt2,ispin) &
                           & + c1 *w *2 *(derf(tu) -derf(tl)) *0.5d0 /DeltaE &
                           &            *qwgt(ik)
                   end do
                end do
             end Do
          end Do
          ! ---- integ --
          Do lmt1=1, ilmt_phi(it1)
             Do lmt2=1, ilmt_phi(it2)
                sum_pcohp(1,lmt1,lmt2,ispin) = pcohp(1,lmt1,lmt2,ispin)*DeltaE
                do id = 1, nEWindows-1
                   sum_pcohp(id+1,lmt1,lmt2,ispin) &
                        & = sum_pcohp(id,lmt1,lmt2,ispin) &
                        &   +pcohp(id+1,lmt1,lmt2,ispin) *DeltaE
                end do
             End Do
          ENd Do
          
       end Do   ! ik
       ! --
       if ( mype == 0 )  then
!          call write_pcohp_full( lun, ia, ja )
          call write_pcohp_sum_over_atom( lun, ia, ja )
       endif
    End Do
    
    ! --- finalize--
    if ( mype == 0 ) close( lun )

    deallocate( mat_p ); deallocate( mat_h )
    deallocate( pcohp ); deallocate( sum_pcohp )

  contains 
    
    subroutine calc_distance_from_atom1( ia, ja, dist_min )
      integer, intent(in) :: ia, ja
      real(kind=DP), intent(out) :: dist_min
      
      integer :: nx, ny, nz
      real(kind=DP) :: x1, y1, z1, dist
      
      dist_min = 1.0D3
      Do nx=-1, 1
         Do ny=-1, 1
            Do nz=-1, 1
               x1 = cps(ja,1) -cps(ia,1) +nx*altv(1,1) +ny*altv(1,2) +nz*altv(1,3)
               y1 = cps(ja,2) -cps(ia,2) +nx*altv(2,1) +ny*altv(2,2) +nz*altv(2,3)
               z1 = cps(ja,3) -cps(ia,3) +nx*altv(3,1) +ny*altv(3,2) +nz*altv(3,3)
               dist = sqrt( x1**2 +y1**2 +z1**2 )
               dist_min = min( dist_min, dist )
            End Do
         ENd Do
      End Do
    end subroutine calc_distance_from_atom1

  end subroutine m_ES_calc_pcohp

  subroutine write_pcohp_full( nf, ia, ja )
    integer, intent(in) :: nf, ia, ja
    
    integer :: it1, it2, lmt1, lmt2, il1, il2, im1, im2, tau1, tau2
    integer :: id, nrEWindows, ii, i, nwdwidth
    real(kind=DP) :: e, e_eV, pcohp_hr, pcohp_hr2, sum_pcohp_avr, sum_pcohp_avr2
    real(kind=DP) :: pcohp_eV, pcohp_eV2, sumtotal

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2
    nrEWindows = nEWindows/nwdwidth * nwdwidth

    if ( iproj_group(ia)== 0 ) return
    if ( iproj_group(ja)== 0 ) return

    it1 = ityp(ia);     it2 = ityp(ja)

    Do lmt1=1, ilmt_phi(it1)
       il1 = ltp_phi(lmt1,it1); im1 = mtp_phi(lmt1,it1);  tau1 = taup_phi(lmt1,it1)

       Do lmt2=1, ilmt_phi(it2)
          il2 = ltp_phi(lmt2,it2); im2 = mtp_phi(lmt2,it2);  tau2 = taup_phi(lmt2,it2)

          write(nf,'(A,I5,3(A,I3),A,I5,3(A,I3))') &
               &       "-PCOHP: ia= ", ia, " l=", il1-1," m=", im1," t=", tau1, &
               &       "        ja= ", ja, " l=", il2-1," m=", im2," t=", tau2

          if (nspin == 1) then
             write(nf,*) "     E(eV)          pcohp(eV)           sum(eV)"
             do i = 1, nrEWindows, nwdwidth
                e = Eminimum + (i-1+id)*DeltaE_dos
                e_eV = (e - ValenceBandMaximum)*Hartree
                pcohp_hr = 0.d0;  sum_pcohp_avr = 0.d0

                do ii = i, i+nwdwidth-1
                   pcohp_hr = pcohp_hr + pcohp(ii,lmt1,lmt2,nspin)
                   sum_pcohp_avr = sum_pcohp_avr + sum_pcohp(ii,lmt1,lmt2,nspin)
                end do
                pcohp_hr = pcohp_hr /nwdwidth;  
                sum_pcohp_avr = sum_pcohp_avr /nwdwidth
!                pcohp_eV = pcohp_hr /Hartree    ! ???
                pcohp_eV = pcohp_hr

                write(nf,'(f14.6,f18.10,f20.10)') &
                     &     e_eV, -pcohp_eV, -sum_pcohp_avr
             end do

          else if(nspin == 2) then
             write(nf,*) "   E(eV)         pcohp_up(eV)        pcohp_down(eV)" &
                  & ,"   sum_up    sum_down  sum_total"

             do i = 1, nrEWindows, nwdwidth
                e = Eminimum + (i-1+id)*DeltaE_dos
                e_eV = (e - ValenceBandMaximum)*Hartree
                pcohp_hr = 0.d0; pcohp_hr2 = 0.d0;  
                sum_pcohp_avr = 0.d0; sum_pcohp_avr2 = 0.d0

                do ii = i, i+nwdwidth-1
                   pcohp_hr  = pcohp_hr  + pcohp(ii,lmt1,lmt2,1)
                   pcohp_hr2 = pcohp_hr2 + pcohp(ii,lmt1,lmt2,2)
                   sum_pcohp_avr  = sum_pcohp_avr  + sum_pcohp(ii,lmt1,lmt2,1)
                   sum_pcohp_avr2 = sum_pcohp_avr2 + sum_pcohp(ii,lmt1,lmt2,2)
                end do
                pcohp_hr = pcohp_hr/nwdwidth; pcohp_hr2 = pcohp_hr2/nwdwidth
                sum_pcohp_avr = sum_pcohp_avr/nwdwidth; 
                sum_pcohp_avr2 = sum_pcohp_avr2/nwdwidth

!                pcohp_eV  = pcohp_hr/Hartree
!                pcohp_eV2 = pcohp_hr2/Hartree
                pcohp_eV  = pcohp_hr; 
                pcohp_eV2 = pcohp_hr2
                sumtotal = sum_pcohp_avr + sum_pcohp_avr2
                write(nf,'(f15.4,2f18.10,3f10.4)') &
                     &    e_eV, -pcohp_eV, -pcohp_eV2, &
                     &    -sum_pcohp_avr, -sum_pcohp_avr2, -sumtotal
             end do
          end if
          write(nf,*) 'END'
       end Do
    end Do

  end subroutine write_pcohp_full

  subroutine write_pcohp_sum_over_atom( nf, ia, ja )
    integer, intent(in) :: nf, ia, ja
    
    integer :: it1, it2, lmt1, lmt2, il1, il2, im1, im2, tau1, tau2
    integer :: id, nrEWindows, ii, i, nwdwidth
    real(kind=DP) :: e, e_eV, pcohp_hr, pcohp_hr2, sum_pcohp_avr, sum_pcohp_avr2
    real(kind=DP) :: pcohp_eV, pcohp_eV2, sumtotal

    if(nwd_dos_window_width >= 1 .and. nwd_dos_window_width <= nEWindows) then
       nwdwidth = nwd_dos_window_width
    else
       nwdwidth = 1
    end if
    id = nwdwidth/2
    nrEWindows = nEWindows/nwdwidth * nwdwidth

    if ( iproj_group(ia)== 0 ) return
    if ( iproj_group(ja)== 0 ) return

    it1 = ityp(ia);     it2 = ityp(ja)

    write(nf,'(A,I5,A,I5)') &
         &       "-PCOHP: ia= ", ia, "        ja= ", ja
    if (nspin == 1) then
       write(nf,*) "     E(eV)          pcohp(eV)           sum(eV)"
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          pcohp_hr = 0.d0;  sum_pcohp_avr = 0.d0

          Do lmt1=1, ilmt_phi(it1)
             Do lmt2=1, ilmt_phi(it2)
                do ii = i, i+nwdwidth-1
                   pcohp_hr = pcohp_hr + pcohp(ii,lmt1,lmt2,nspin)
                   sum_pcohp_avr = sum_pcohp_avr + sum_pcohp(ii,lmt1,lmt2,nspin)
                end do
             End Do
          End Do
          pcohp_hr = pcohp_hr /nwdwidth;  
          sum_pcohp_avr = sum_pcohp_avr /nwdwidth
!                pcohp_eV = pcohp_hr /Hartree    ! ???
          pcohp_eV = pcohp_hr
          sum_pcohp_avr = sum_pcohp_avr *Hartree

          write(nf,'(f14.6,f18.10,f20.10)') &
               &     e_eV, -pcohp_eV, -sum_pcohp_avr
       end do
    else if(nspin == 2) then
       write(nf,*) "   E(eV)         pcohp_up(eV)        pcohp_down(eV)" &
            & ,"sum_up   sum_down sum_total"
       do i = 1, nrEWindows, nwdwidth
          e = Eminimum + (i-1+id)*DeltaE_dos
          e_eV = (e - ValenceBandMaximum)*Hartree
          pcohp_hr = 0.d0; pcohp_hr2 = 0.d0;  
          sum_pcohp_avr = 0.d0; sum_pcohp_avr2 = 0.d0

          Do lmt1=1, ilmt_phi(it1)
             Do lmt2=1, ilmt_phi(it2)
                do ii = i, i+nwdwidth-1
                   pcohp_hr  = pcohp_hr  + pcohp(ii,lmt1,lmt2,1)
                   pcohp_hr2 = pcohp_hr2 + pcohp(ii,lmt1,lmt2,2)
                   sum_pcohp_avr  = sum_pcohp_avr  + sum_pcohp(ii,lmt1,lmt2,1)
                   sum_pcohp_avr2 = sum_pcohp_avr2 + sum_pcohp(ii,lmt1,lmt2,2)
                end do
             end Do
          end Do
          pcohp_hr = pcohp_hr/nwdwidth; pcohp_hr2 = pcohp_hr2/nwdwidth
          sum_pcohp_avr = sum_pcohp_avr/nwdwidth; 
          sum_pcohp_avr2 = sum_pcohp_avr2/nwdwidth

!                pcohp_eV  = pcohp_hr/Hartree
!                pcohp_eV2 = pcohp_hr2/Hartree
          pcohp_eV  = pcohp_hr
          pcohp_eV2 = pcohp_hr2

          sum_pcohp_avr  = sum_pcohp_avr  *Hartree
          sum_pcohp_avr2 = sum_pcohp_avr2 *Hartree

          sumtotal = sum_pcohp_avr + sum_pcohp_avr2
          write(nf,'(f15.4,2f18.10,3f10.4)') &
               &    e_eV, -pcohp_eV, -pcohp_eV2, &
               &    -sum_pcohp_avr, -sum_pcohp_avr2, -sumtotal
       end do
    end if
    write(nf,*) 'END'
  end subroutine write_pcohp_sum_over_atom

  subroutine calc_matrix_H( ik, ia, ja, mat_p, mat_H )
    integer, intent(in) :: ia, ja, ik
    complex(kind=CMPLDP), intent(in)  :: mat_p(neg,nlmt_phi,nlmt_phi)
    complex(kind=CMPLDP), intent(out) :: mat_h(nlmt_phi,nlmt_phi)
    
    integer :: it1, it2, lmt1, lmt2, ie
    complex(kind=CMPLDP) :: z1

    it1 = ityp(ia);     it2 = ityp(ja)

    mat_h = 0.0d0

    Do lmt1=1, ilmt_phi(it1)
       Do lmt2=1, ilmt_phi(it2)
          z1 = 0.0d0
          Do ie=1, neg
!             z1 = z1 + ( eko(ie,ik) -ValenceBandMaximum ) *mat_p(ie,lmt1,lmt2)
             z1 = z1 + eko(ie,ik) *mat_p(ie,lmt1,lmt2)
          End Do
          mat_h(lmt1,lmt2) = z1
       End Do
    End Do
  end subroutine calc_matrix_H

  subroutine calc_matrix_P_nosym( ik, ia, ja, mat_p )
    integer, intent(in) :: ia, ja, ik
    complex(kind=CMPLDP), intent(out) :: mat_p(neg,nlmt_phi,nlmt_phi)

    integer :: it1, it2, iorb1, iorb2, lmt1, lmt2, iopr1, iopr2, ie, i
    complex(kind=CMPLDP) :: porb, z1, z2
    logical :: First = .true.

    it1 = ityp(ia);     it2 = ityp(ja)

    mat_p = 0.0d0

    Do ie=1, neg
       Do lmt1=1, ilmt_phi(it1)
          iorb1 = lmta_phi(lmt1,ia)

          Do lmt2=1, ilmt_phi(it2)
             iorb2 = lmta_phi(lmt2,ja)

             porb = 0.0d0
             if ( k_symmetry(ik) == GAMMA ) then
                do iopr1=1, 1
                   porb = porb +compr(ie,iorb1,iopr1,ik) &
                        &      *compr(ie,iorb2,iopr1,ik) /2.0d0
                end do
             else
                Do iopr1=1, 1
                   z1 = cmplx( compr(ie,iorb1,iopr1,ik), compi(ie,iorb1,iopr1,ik) )
                   z2 = cmplx( compr(ie,iorb2,iopr1,ik), compi(ie,iorb2,iopr1,ik) )
                   porb = porb +conjg(z1)* z2
                end do
             endif
             mat_p( ie, lmt1, lmt2 ) = porb 

          ENd Do
       End Do
    End Do
  end subroutine calc_matrix_P_nosym

end module m_ES_dos

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
  integer                   :: idp, nlp, nmp, nnp

  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1,cw2,cw3
  complex(kind=CMPLDP),private,allocatable,dimension(:)    :: wlp,wmp,wnp
  integer,             private,allocatable,dimension(:,:)  :: iwork

  ! ------- Positron start 
  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1_pstrn,cw2_pstrn,cw3_pstrn

  integer :: sw_avoiding_odd_fftbox = OFF
  integer :: sw_zero_padding = OFF

  real(kind=DP),private,allocatable,dimension(:)           :: ftw

  include 'mpif.h'

contains
  subroutine fft_WFCD_work_alloc
    integer :: nid,nnl,nnm,nnn
    integer :: istat = 0
! ----> work arrays of fft for wave functions
    nnl  = fft_box_size_WF(1,1)
    nnm  = fft_box_size_WF(2,1);  nnn  = fft_box_size_WF(3,1)
    if(ipri >= 1) write(nfout,'(" !!allocation of cw1,cw2,cw3 (fft_WFCD_work_alloc)")')
    allocate(cw1(nnl), stat=istat)
    allocate(cw2(nnm), stat=istat)
    allocate(cw3(nnn), stat=istat)
    if(ipri >= 1) write(nfout,'(" !! WF_JRCATFFT <<m_FFT.fft_WFCD_work_alloc>>")')

! ------- Positron start 
! ----> and work arrays of fft for positron wave functions
    if(sw_positron /= OFF) then
       nnl  = fft_box_size_pWF(1,1)
       nnm  = fft_box_size_pWF(2,1);  nnn  = fft_box_size_pWF(3,1)
       if(ipri >= 1) write(nfout,'(" !!allocation of cw1_pstrn,cw2_pstrn,cw3_pstrn (fft_WFCD_work_alloc)")')
       allocate(cw1_pstrn(nnl), stat=istat)
       allocate(cw2_pstrn(nnm), stat=istat)
       allocate(cw3_pstrn(nnn), stat=istat)
    end if
! ------- Positron end

! ----> work arrays of ifft for the charge density
    nid = fft_box_size_CD(1,0);  nnl = fft_box_size_CD(1,1)
    nnm = fft_box_size_CD(2,1);  nnn = fft_box_size_CD(3,1)
    allocate(wlp(3*nnl+7), stat=istat)
    allocate(wmp(2*nnm*(nid+1)+7), stat=istat)
    allocate(wnp(2*nnn+7), stat=istat)
    allocate(iwork(2,nnl+nnm+nnn), stat=istat)
  end subroutine fft_WFCD_work_alloc

  subroutine m_FFT_alloc_WF_work
    integer :: istat = 0
    allocate(ftw(nfft), stat=istat)
  end subroutine m_FFT_alloc_WF_work

  subroutine m_FFT_alloc_pWF_work()
    integer :: istat = 0
    allocate(ftw(nfft_pstrn), stat=istat)
  end subroutine m_FFT_alloc_pWF_work

  subroutine m_FFT_dealloc_WF_work
    integer :: istat = 0
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
       if(istat /= 0 ) then
          if(ipri>=1) then
             write(nfout,*) 'Deallocation error for ftw in sub. m_FFT_dealloc_WF_work'
             write(nfout,*) 'stat=', istat
          end if
          stop
       end if
    end if
  end subroutine m_FFT_dealloc_WF_work

  subroutine m_FFT_alloc_CD_box
    integer :: istat = 0
    allocate(afft_CD(nfftp), stat=istat)
  end subroutine m_FFT_alloc_CD_box

  subroutine m_FFT_dealloc_CD_box
    integer :: istat = 0
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
    end if
    deallocate(afft_CD, stat=istat)

  end subroutine m_FFT_dealloc_CD_box

  subroutine m_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset

    real(kind=DP),allocatable,dimension(:)               :: cfft
    integer :: nfft_t, ipad
    integer :: istat = 0
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_setup ',id_sname)

    if(inversion_symmetry == ON) then  ! kimg == 1
       ipad = 2
    else if(inversion_symmetry == OFF) then ! kimg == 2
       ipad = 1
    end if
! --- fft_box_size_WF, fft_box_size_pWF ---
    fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + ipad
    fft_box_size_WF(2:3,0) = fft_box_size_WF(2:3,1)
    if(sw_positron /= OFF) then
       fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + ipad
       fft_box_size_pWF(2:3,0) = fft_box_size_pWF(2:3,1)
    end if

    nfft =   product(fft_box_size_WF(1:3,0)) * (2-inversion_symmetry)
! --- fft_box_size_CD ---
    fft_box_size_CD_nonpara(1,0)   = fft_box_size_CD(1,1) + ipad
    fft_box_size_CD_nonpara(2:3,0) = fft_box_size_CD(2:3,1)
    nfftp_nonpara  = product(fft_box_size_CD_nonpara(1:3,0)) * (2-inversion_symmetry)

    fft_box_size_CD(1:3,0) = fft_box_size_CD_nonpara(1:3,0)
    fft_box_size_CD_c(1:3,0) = fft_box_size_CD(1:3,0)
    nfftp  = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
    nfftps = nfftp

    if(ipri >= 1) call wd_FFTboxsizes(nfout)

    idp = fft_box_size_CD(1,0)
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)

    if(sw_positron /= OFF) &
         & nfft_pstrn = product(fft_box_size_pWF(1:3,0))*(2-inversion_symmetry)

    if(.not. paramset) then
       call fft_WFCD_work_alloc     ! <cw[123],cw[123]_pstrn,wlp,wmp,wnp> are allocated

! Initialization of the Wave-Function FFT
       if(sw_positron /= OFF .and. nfft_pstrn > nfft) then
          call m_FFT_alloc_pWF_work()  ! <ftw> is allocated
          nfft_t = nfft_pstrn
       else
          call m_FFT_alloc_WF_work()   ! <ftw> is allocated
          nfft_t = nfft
       end if
       allocate(cfft(nfft_t), stat=istat) ! cfft is used only for initiallization
       if(istat /= 0) then
          if(ipri >= 1) then
             write(nfout,*) 'Allocation error for cfft in sub. m_FFT_setup'
             write(nfout,*) 'stat =', istat, 'nfft =', nfft_t
          end if
          stop
       end if

       call init_fft_coefficients_arrays_WF()

       call m_FFT_dealloc_WF_work()
       deallocate(cfft,stat=istat)
       if(istat /= 0 ) then
          if(ipri >= 1) then
             write(nfout,*) 'Deallocation error for cfft in sub. m_FFT_setup'
             write(nfout,*) 'stat =', istat
          end if
          stop
       end if

       call CDFFT_setup()

    endif

    call tstatc0_end(id_sname)
  contains
    subroutine init_fft_coefficients_arrays_WF()
      integer :: id, nl, nm, nn, ierr
      integer :: id_p, nl_p, nm_p, nn_p
      id = fft_box_size_WF(1,0)
      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)
      if(sw_positron /= OFF) then
         id_p = fft_box_size_pWF(1,0)
         nl_p = fft_box_size_pWF(1,1)
         nm_p = fft_box_size_pWF(2,1)
         nn_p = fft_box_size_pWF(3,1)
      end if

      if(kimg == 1) then
         call jrcat_r3ft(cfft,ftw,id,nl,nm,nn,cw1,cw2,cw3,0,0,0,0)
         if(sw_positron /= OFF) &
              & call jrcat_r3ft(cfft,ftw,id_p,nl_p,nm_p,nn_p &
              &                   ,cw1_pstrn,cw2_pstrn,cw3_pstrn,0,0,0,0)
      else  ! kimg == 2
         call jrcat_c3ft(cfft,ftw,id,nl,nm,nn,cw1,cw2,cw3,0,0,0,0)
         if(ipri >= 2) then
            write(nfout,'(" !! cw1,cw2 and cw3 <<m_FFT.init_fft_coefficients_arrays_WF>>")')
            write(nfout,'(" !! cw1 <<m_FFT.init_fft_coefficients_arrays_WF>>")')
            write(nfout,'(8f8.4)') cw1
            write(nfout,'(" !! cw2 <<m_FFT.init_fft_coefficients_arrays_WF>>")')
            write(nfout,'(8f8.4)') cw2
            write(nfout,'(" !! cw3 <<m_FFT.init_fft_coefficients_arrays_WF>>")')
            write(nfout,'(8f8.4)') cw3
         end if
         if(sw_positron /= OFF) call jrcat_c3ft(cfft,ftw,id_p,nl_p,nm_p,nn_p &
              &                                 ,cw1_pstrn,cw2_pstrn,cw3_pstrn,0,0,0,0)
      endif
    end subroutine init_fft_coefficients_arrays_WF
  end subroutine m_FFT_setup

  subroutine CDFFT_setup()
    call m_FFT_alloc_CD_box()       ! <ftw> is allocated

    call init_fft_coefficients_arrays_CD()

    CD_setup_is_done = YES

    call m_FFT_dealloc_CD_box()
  contains
    subroutine init_fft_coefficients_arrays_CD
      integer :: ierr
   !  ---> FFT for Charge density
      if(kimg == 1) then
         call r3fft(afft_CD,idp,nlp,nmp,nnp,wlp,wmp,wnp,0,0,1,ftw,ierr)
      else
         call c3fft(afft_CD,idp,nlp,nmp,nnp,wlp,wmp,wnp,0,0,1,ftw,ierr)
      endif
    end subroutine init_fft_coefficients_arrays_CD
  end subroutine CDFFT_setup

  subroutine m_FFT_WF(electron_or_positron,nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    integer, intent(in)          :: electron_or_positron
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch

    complex(kind=CMPLDP),pointer,dimension(:) :: cw1_t, cw2_t, cw3_t

    integer :: id, nl, nm, nn

    integer, dimension(2) :: flag_jrcat_r3ft = (/-2,  2/)
    integer, dimension(2) :: flag_jrcat_c3ft = (/ 1, -1/)
    integer kc1, kc2, kc3

    integer :: id_sname = -1
    if(electron_or_positron == ELECTRON) then
       call tstatc0_begin('m_FFT_WF ',id_sname)
       id = fft_box_size_WF(1,0)
       nl = fft_box_size_WF(1,1)
       nm = fft_box_size_WF(2,1)
       nn = fft_box_size_WF(3,1)
       cw1_t=>cw1; cw2_t=>cw2; cw3_t=>cw3 
    else if(electron_or_positron == POSITRON) then
       call tstatc0_begin('m_FFT_pWF ',id_sname)
       id = fft_box_size_pWF(1,0)
       nl = fft_box_size_pWF(1,1)
       nm = fft_box_size_pWF(2,1)
       nn = fft_box_size_pWF(3,1)
       cw1_t=>cw1_pstrn; cw2_t=>cw2_pstrn; cw3_t=>cw3_pstrn
    end if

    if(switch == ON) then
       kc1 = 0;       kc2 = nm/4 + 1;       kc3 = nn/4 + 1
    else
       kc1 = 0;       kc2 = 0       ;       kc3 = 0
    endif
    if(kimg == 1) then
       call jrcat_r3ft(afft,ftw,id,nl,nm,nn,cw1_t,cw2_t,cw3_t,kc1,kc2,kc3&
            & ,flag_jrcat_r3ft(inverse_or_direct))
    else if(kimg == 2) then
       call jrcat_c3ft(afft,ftw,id,nl,nm,nn,cw1_t,cw2_t,cw3_t,kc1,kc2,kc3&
            & ,flag_jrcat_c3ft(inverse_or_direct))
    endif

    call tstatc0_end(id_sname)

  end subroutine m_FFT_WF

  subroutine fft_CD_inverse_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD
    integer :: iopt = 0
    integer :: ier1 = 0

    if(kimg == 1) then
       call r3fft(afft_CD,idp,nlp,nmp,nnp,wlp,wmp,wnp,iopt,-1,1,iwork,ier1)
    else if(kimg == 2) then
       call c3fft(afft_CD,idp,nlp,nmp,nnp,wlp,wmp,wnp,iopt, 1,1,iwork,ier1)
    end if

    if (ier1 /= 0) then
       if(ipri>=1) write (nfout,*) ' !!Error fft(inverse) ier1 = ',ier1
       stop
    end if

  end subroutine fft_CD_inverse_core

  subroutine fft_CD_direct_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD
    integer :: iopt = 0
    integer :: ier1 = 0

    if(kimg == 1) then
       call r3fft(afft_CD,idp,nlp,nmp,nnp,wlp,wmp,wnp,iopt,1,1,iwork,ier1)
    else if(kimg == 2) then
       call c3fft(afft_CD,idp,nlp,nmp,nnp,wlp,wmp,wnp,iopt,-1,1,iwork,ier1)
    end if

    if (ier1 /= 0) then
       if(ipri>=1) write (nfout,*) ' !!Error  fft(direct) ier1 = ',ier1
       stop
    end if
  end subroutine fft_CD_direct_core

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: gsort, spsort, shellsort, sort_gvec_within_shell_by_heap,
!             sift_down, sort_gvec_heap, sift_down, swap_i, 
!             sort_gvec_quick, sort_gvec_simple
!
!  AUTHOR(S): T. Yamasaki, M. Okamoto,    August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

! $Id: b_PlaneWaveBasisSet.F90 570 2017-04-21 20:34:50Z yamasaki $

!#####################################################################

subroutine sort_gvec_simple(ttr,k,n,ngvec)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: sort_gvec_simple
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP),allocatable :: norm_gvec(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ipos, jpos, ia, ib, ic
  real(kind=DP) :: sum, norm_gi, norm_gj
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(norm_gvec(n),idx_gvec(n),ngvec_tmp(k,3))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
     ia = ngvec(i,1) ; ib = ngvec(i,2) ; ic = ngvec(i,3)
     sum = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
         + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     norm_gvec(i) = sqrt(sum)
     idx_gvec (i) = i
  end do
  do i = 1,n-1
     ipos    = idx_gvec(i)
     norm_gi = norm_gvec(ipos)
     do j = i+1,n
        jpos    = idx_gvec(j)
        norm_gj = norm_gvec(jpos)
        if (norm_gi > norm_gj) then
           idx_gvec(i) = jpos
           idx_gvec(j) = ipos
           ipos    = jpos
           norm_gi = norm_gj
        end if
     end do
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
  end do
 !+++++++++++++++++++++++++++++++++++++++++++
  deallocate(norm_gvec,idx_gvec,ngvec_tmp)
 !+++++++++++++++++++++++++++++++++++++++++++
end subroutine sort_gvec_simple


subroutine sort_gvec_quick(ttr,k,n,ngvec)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: sort_gvec_quick
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP),allocatable :: norm_gvec(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ia, ib, ic
  real(kind=DP) :: sum, v0
  integer,parameter :: NN=15, NSTACK=50
  integer :: jstack, l, r, ipos, jpos, ll, kk, istack(NSTACK)
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(norm_gvec(n),idx_gvec(n),ngvec_tmp(k,3))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
     ia = ngvec(i,1) ; ib = ngvec(i,2) ; ic = ngvec(i,3)
     sum = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
         + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     norm_gvec(i) = sqrt(sum)
     idx_gvec (i) = i
  end do
  jstack = 0
  l = 1
  r = n
  do
     if (r-1 < NN) then
        do j = l+1,r
           jpos = idx_gvec(j)
           v0 = norm_gvec(jpos)
           do i = j-1,l,-1
              ipos = idx_gvec(i)
              if (norm_gvec(ipos) <= v0) then
                 exit
              end if
              idx_gvec(i+1) = idx_gvec(i)
           end do
           idx_gvec(i+1) = jpos
        end do
        if (jstack == 0) then
           return
        end if
        r = istack(jstack  )
        l = istack(jstack-1)
        jstack = jstack-2
     else
        kk = (l+r)/2
        call swap_i(idx_gvec(kk),idx_gvec(l+1))
        if (norm_gvec(idx_gvec(l)) > norm_gvec(idx_gvec(r))) then
           call swap_i(idx_gvec(l),idx_gvec(r))
        end if
        if (norm_gvec(idx_gvec(l+1)) > norm_gvec(idx_gvec(r))) then
           call swap_i(idx_gvec(l+1),idx_gvec(r))
        end if
        if (norm_gvec(idx_gvec(l)) > norm_gvec(idx_gvec(l+1))) then
           call swap_i(idx_gvec(l),idx_gvec(l+1))
        end if
        i = l+1
        j = r
        ll = idx_gvec(l+1)
        v0 = norm_gvec(ll)
        do
           do
              i = i+1
              if (norm_gvec(idx_gvec(i)) >= v0) then
                 exit
              end if
           end do
           do
              j = j-1
              if (norm_gvec(idx_gvec(j)) <= v0) then
                 exit
              end if
           end do
           if (j < i) then
              exit
           end if
           call swap_i(idx_gvec(i),idx_gvec(j))
        end do
        idx_gvec(l+1) = idx_gvec(j)
        idx_gvec(j) = ll
        jstack = jstack+2
        if (jstack > NSTACK) then
           write(*,*) 'NSTACK too small in sort_gvec_quick'
           stop
        end if
        if (r-i+1 >= j-1) then
           istack(jstack  ) = r
           istack(jstack-1) = i
           r = j-1
        else
           istack(jstack  ) = j-1
           istack(jstack-1) = l
           l = i
        end if
     end if
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
  end do
 !+++++++++++++++++++++++++++++++++++++++++
  deallocate(norm_gvec,idx_gvec,ngvec_tmp)
 !+++++++++++++++++++++++++++++++++++++++++
end subroutine sort_gvec_quick


subroutine swap_i(a,b)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: swap_i
!
!  AUTHOR(S): M. Okamoto    August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  integer,intent(inout) :: a,b
  integer :: tmp
  tmp = a ; a = b ; b = tmp
end subroutine swap_i


subroutine sort_gvec_heap(ttr,k,n,ngvec)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: 
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP) :: sum
  real(kind=DP),allocatable :: norm_gvec(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ia, ib, ic
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(norm_gvec(n),idx_gvec(n),ngvec_tmp(k,3))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
     ia = ngvec(i,1) ; ib = ngvec(i,2) ; ic = ngvec(i,3)
     sum = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
         + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     norm_gvec(i) = sqrt(sum)
     idx_gvec (i) = i
  end do
  do i = n/2,1,-1
     call sift_down(i,n)
  end do
  do i = n,2,-1
     call swap_i(idx_gvec(1),idx_gvec(i))
     call sift_down(1,i-1)
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
  end do
 !+++++++++++++++++++++++++++++++++++++++++
  deallocate(norm_gvec,idx_gvec,ngvec_tmp)
 !+++++++++++++++++++++++++++++++++++++++++
!....................................................................
  contains
  subroutine sift_down(l,r)
     integer,intent(in) :: l, r
     integer :: j, j0, l0
     real(kind=DP) :: v0
     l0 = idx_gvec(l)
     v0 = norm_gvec(l0)
     j0 = l
     j  = l+l
     do while (j <= r)
        if (j < r) then
           if (norm_gvec(idx_gvec(j)) < norm_gvec(idx_gvec(j+1))) then
              j = j+1
           end if
        end if
        if (v0 >= norm_gvec(idx_gvec(j))) then
           exit
        end if
        idx_gvec(j0) = idx_gvec(j)
        j0 = j
        j  = j+j
     end do
     idx_gvec(j0) = l0
  end subroutine sift_down
!....................................................................
end subroutine sort_gvec_heap

subroutine sort_gvec_heap2(ttr,k,n,ngvec,gr)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: 
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP),intent(inout),dimension(k) ::gr

!!$  real(kind=DP) :: sum
  real(kind=DP),allocatable :: norm_gvec(:), gr_tmp(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ia, ib, ic
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(norm_gvec(n),idx_gvec(n),ngvec_tmp(k,3),gr_tmp(k))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
!!$     ia = ngvec(i,1) ; ib = ngvec(i,2) ; ic = ngvec(i,3)
!!$     sum = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
!!$         + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
!!$     norm_gvec(i) = sqrt(sum)
     norm_gvec(i) = gr(i)
     idx_gvec (i) = i
  end do
  do i = n/2,1,-1
     call sift_down(i,n)
  end do
  do i = n,2,-1
     call swap_i(idx_gvec(1),idx_gvec(i))
     call sift_down(1,i-1)
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  gr_tmp(:)      = gr(:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
     gr(i)      = gr_tmp(idx_gvec(i))
  end do
 !+++++++++++++++++++++++++++++++++++++++++
  deallocate(norm_gvec,idx_gvec,ngvec_tmp,gr_tmp)
 !+++++++++++++++++++++++++++++++++++++++++
!....................................................................
  contains
  subroutine sift_down(l,r)
     integer,intent(in) :: l, r
     integer :: j, j0, l0
     real(kind=DP) :: v0
     l0 = idx_gvec(l)
     v0 = norm_gvec(l0)
     j0 = l
     j  = l+l
     do while (j <= r)
        if (j < r) then
           if (norm_gvec(idx_gvec(j)) < norm_gvec(idx_gvec(j+1))) then
              j = j+1
           end if
        end if
        if (v0 >= norm_gvec(idx_gvec(j))) then
           exit
        end if
        idx_gvec(j0) = idx_gvec(j)
        j0 = j
        j  = j+j
     end do
     idx_gvec(j0) = l0
  end subroutine sift_down
!....................................................................
end subroutine sort_gvec_heap2

subroutine sort_gvec_heap3(ttr,k,n,ngvec,gr)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE:
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP),intent(in),dimension(6) :: ttr
  integer,intent(in)                    :: k, n
  integer,intent(inout),dimension(k,3)  :: ngvec
  real(kind=DP),intent(inout),dimension(k) ::gr

  real(kind=DP),allocatable :: gr_tmp(:)
  integer,allocatable :: idx_gvec(:), ngvec_tmp(:,:)
  integer :: i, j, ia, ib, ic, itmp
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  allocate(idx_gvec(n),ngvec_tmp(k,3),gr_tmp(k))
 !++++++++++++++++++++++++++++++++++++++++++++++++++
  do i = 1,n
     idx_gvec (i) = i
  end do
  do i = n/2,1,-1
     call sift_down(i,n)
  end do
  do i = n,2,-1
     itmp = idx_gvec(1)
     idx_gvec(1) = idx_gvec(i)
     idx_gvec(i) = itmp
     call sift_down(1,i-1)
  end do
  ngvec_tmp(:,:) = ngvec(:,:)
  gr_tmp(:)      = gr(:)
  do i = 1,n
     ngvec(i,:) = ngvec_tmp(idx_gvec(i),:)
     gr(i)      = gr_tmp(idx_gvec(i))
  end do
 !+++++++++++++++++++++++++++++++++++++++++
  deallocate(idx_gvec,ngvec_tmp,gr_tmp)
 !+++++++++++++++++++++++++++++++++++++++++
!....................................................................
  contains
  subroutine sift_down(l,r)
     integer,intent(in) :: l, r
     integer :: j, j0, l0
     real(kind=DP) :: v0
     l0 = idx_gvec(l)
     v0 = gr(l0)
     j0 = l
     j  = l+l
     do while (j <= r)
        if (j < r) then
           if (gr(idx_gvec(j)) < gr(idx_gvec(j+1))) then
              j = j+1
           end if
        end if
        if (v0 >= gr(idx_gvec(j))) then
           exit
        end if
        idx_gvec(j0) = idx_gvec(j)
        j0 = j
        j  = j+j
     end do
     idx_gvec(j0) = l0
  end subroutine sift_down
!....................................................................
end subroutine sort_gvec_heap3

! This is a replacement of spsort
subroutine sort_gvec_within_shell_by_heap( &
              n,imin,jmin,jmax,kmin,kmax,na,nb,nc)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: 
!
!  AUTHOR(S): M. Okamoto   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer,intent(in)        :: n, imin, jmin, jmax, kmin, kmax
  integer,intent(inout)     :: na(n), nb(n), nc(n)
  real(kind=DP),allocatable :: val(:)
  integer,allocatable       :: idx(:), ntmp(:,:)
  integer                   :: i, b, c
 !++++++++++++++++++++++++++++++++++
  allocate(val(n),idx(n),ntmp(n,3))
 !++++++++++++++++++++++++++++++++++
  b = jmax-jmin+1 ; c = kmax-kmin+1
  do i = 1,n
     val(i) = (na(i)-imin)*b*c + (nb(i)-jmin)*c + (nc(i)-kmin) + 1
     idx(i) = i
  end do
  do i = n/2,1,-1
     call sift_down(i,n)
  end do
  do i = n,2,-1
     call swap_i(idx(1),idx(i))
     call sift_down(1,i-1)
  end do
  ntmp(:,1) = na(:) ; ntmp(:,2) = nb(:) ; ntmp(:,3) = nc(:)
  do i = 1,n
     na(i) = ntmp(idx(i),1)
     nb(i) = ntmp(idx(i),2)
     nc(i) = ntmp(idx(i),3)
  end do
 !+++++++++++++++++++++++++
  deallocate(val,idx,ntmp)
 !+++++++++++++++++++++++++
!....................................................................
  contains
  subroutine sift_down(l,r)
     integer,intent(in) :: l, r
     integer :: j, j0, l0
     real(kind=DP) :: v0
     l0 = idx(l)
     v0 = val(l0)
     j0 = l
     j  = l+l
     do while (j <= r)
        if (j < r) then
           if (val(idx(j)) < val(idx(j+1))) then
              j = j+1
           end if
        end if
        if (v0 >= val(idx(j))) then
           exit
        end if
        idx(j0) = idx(j)
        j0 = j
        j  = j+j
     end do
     idx(j0) = l0
  end subroutine sift_down
!....................................................................
end subroutine sort_gvec_within_shell_by_heap


!#####################################################################


subroutine shellsort(nfout,ipri,ttr,m,n,nG)
! $Id: b_PlaneWaveBasisSet.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: nfout,ipri
  real(kind=DP), intent(in), dimension(6)   :: ttr
  integer, intent(in)                       :: m, n
  integer, intent(inout), dimension(m,3) :: nG

      
  integer :: i, k, counter, m_shellsize = 0, nshell = 1, j
  real(kind=DP), parameter :: DELTA = 1.d-7
  real(kind=DP) :: length_start, length
  integer       :: imin, imax, jmin, jmax, kmin, kmax

  if(ipri >= 2 ) then
     write(nfout,*) ' ----- shell sorting of G-vectors ----'
     write(nfout,9000)
9000 format(' #shell  shellsize    range     length   range-x   range-y   range-z')
  endif
  imin = nG(1,1); imax = imin
  jmin = nG(1,2); jmax = jmin
  kmin = nG(1,3); kmax = kmin
  length_start = ttr(1)*nG(1,1)*nG(1,1) + ttr(2)*nG(1,2)*nG(1,2) &
       &       + ttr(3)*nG(1,3)*nG(1,3) + ttr(4)*nG(1,1)*nG(1,2) &
       &       + ttr(5)*nG(1,2)*nG(1,3) + ttr(6)*nG(1,3)*nG(1,1)
  k = 2
1 continue
  shellloop: do i = k, n
     length =    ttr(1)*nG(i,1)*nG(i,1) + ttr(2)*nG(i,2)*nG(i,2) &
          &    + ttr(3)*nG(i,3)*nG(i,3) + ttr(4)*nG(i,1)*nG(i,2) &
          &    + ttr(5)*nG(i,2)*nG(i,3) + ttr(6)*nG(i,3)*nG(i,1)
     if(length > length_start + DELTA .or. i == n) then
        counter = i - k + 1
        if(i == n) counter = i - k + 2
        if(counter > m_shellsize) m_shellsize = counter
        exit shellloop
     else
        if(imin > nG(i,1)) imin = nG(i,1)
        if(imax < nG(i,1)) imax = nG(i,1)
        if(jmin > nG(i,2)) jmin = nG(i,2)
        if(jmax < nG(i,2)) jmax = nG(i,2)
        if(kmin > nG(i,3)) kmin = nG(i,3)
        if(kmax < nG(i,3)) kmax = nG(i,3)
     endif
  enddo shellloop
#ifdef _RPL_SPSORT_
 ! (M.Okamoto)
  call sort_gvec_within_shell_by_heap( &
              counter,imin,jmin,jmax,kmin,kmax, &
              nG(k-1,1),nG(k-1,2),nG(k-1,3))
#else
  call spsort(counter,imin,jmin,jmax,kmin,kmax &
       & ,nG(k-1,1),nG(k-1,2),nG(k-1,3))
#endif
  if(ipri >= 2) write(nfout,9001) nshell, counter,k-1,k-1+counter-1&
       &,dsqrt(length_start),imin,imax,jmin,jmax,kmin,kmax
  if(ipri >= 3) then
     do j = 1, counter
        write(nfout,*) k-1+j-1,nG(k-1+j-1,1),nG(k-1+j-1,2),nG(k-1+j-1,3)
     end do
  end if
  length_start = length
  k = i + 1
  imin = nG(i,1); imax = imin; jmin = nG(i,2); jmax = jmin
  kmin = nG(i,3); kmax = kmin
9001 format(' ',i6,'  ',i4,' (',i6,':',i6,')', f10.5, ' (',i4,':',i4,',',i4,':',i4,',',i4,':',i4,')')
  
  nshell = nshell + 1
  if(k <= n) goto 1
  if(ipri >= 2) write(nfout,*) ' ! m_shellsize = ',m_shellsize
end subroutine shellsort

subroutine shellsort2(nfout,ipri,ttr,m,n,nG,gr)
! $Id: b_PlaneWaveBasisSet.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)                       :: nfout,ipri
  real(kind=DP), intent(in), dimension(6)   :: ttr
  integer, intent(in)                       :: m, n
  integer, intent(inout), dimension(m,3) :: nG
  real(kind=DP), intent(inout), dimension(m) :: gr

      
  integer :: i, k, counter, m_shellsize = 0, nshell = 1, j
  real(kind=DP), parameter :: DELTA = 1.d-7
  real(kind=DP) :: length_start, length
  integer       :: imin, imax, jmin, jmax, kmin, kmax

  if(ipri >= 2 ) then
     write(nfout,*) ' ----- shell sorting of G-vectors ----'
     write(nfout,9000)
9000 format(' #shell  shellsize    range     length   range-x   range-y   range-z')
  endif
  imin = nG(1,1); imax = imin
  jmin = nG(1,2); jmax = jmin
  kmin = nG(1,3); kmax = kmin
!!$  length_start = ttr(1)*nG(1,1)*nG(1,1) + ttr(2)*nG(1,2)*nG(1,2) &
!!$       &       + ttr(3)*nG(1,3)*nG(1,3) + ttr(4)*nG(1,1)*nG(1,2) &
!!$       &       + ttr(5)*nG(1,2)*nG(1,3) + ttr(6)*nG(1,3)*nG(1,1)
  length_start = gr(1)
  k = 2
1 continue
  shellloop: do i = k, n
!!$     length =    ttr(1)*nG(i,1)*nG(i,1) + ttr(2)*nG(i,2)*nG(i,2) &
!!$          &    + ttr(3)*nG(i,3)*nG(i,3) + ttr(4)*nG(i,1)*nG(i,2) &
!!$          &    + ttr(5)*nG(i,2)*nG(i,3) + ttr(6)*nG(i,3)*nG(i,1)
     length =    gr(i)
     if(length > length_start + DELTA .or. i == n) then
        counter = i - k + 1
        if(i == n) counter = i - k + 2
        if(counter > m_shellsize) m_shellsize = counter
        exit shellloop
     else
        if(imin > nG(i,1)) imin = nG(i,1)
        if(imax < nG(i,1)) imax = nG(i,1)
        if(jmin > nG(i,2)) jmin = nG(i,2)
        if(jmax < nG(i,2)) jmax = nG(i,2)
        if(kmin > nG(i,3)) kmin = nG(i,3)
        if(kmax < nG(i,3)) kmax = nG(i,3)
     endif
  enddo shellloop
#ifdef _RPL_SPSORT_
 ! (M.Okamoto)
  call sort_gvec_within_shell_by_heap( &
              counter,imin,jmin,jmax,kmin,kmax, &
              nG(k-1,1),nG(k-1,2),nG(k-1,3))
#else
  call spsort(counter,imin,jmin,jmax,kmin,kmax &
       & ,nG(k-1,1),nG(k-1,2),nG(k-1,3))
#endif
  if(ipri >= 2) write(nfout,9001) nshell, counter,k-1,k-1+counter-1&
       &,dsqrt(length_start),imin,imax,jmin,jmax,kmin,kmax
  if(ipri >= 3) then
     do j = 1, counter
        write(nfout,*) k-1+j-1,nG(k-1+j-1,1),nG(k-1+j-1,2),nG(k-1+j-1,3)
     end do
  end if
  length_start = length
  k = i + 1
  imin = nG(i,1); imax = imin; jmin = nG(i,2); jmax = jmin
  kmin = nG(i,3); kmax = kmin
9001 format(' ',i6,'  ',i4,' (',i6,':',i6,')', f10.5, ' (',i4,':',i4,',',i4,':',i4,',',i4,':',i4,')')
  
  nshell = nshell + 1
  if(k <= n) goto 1
  if(ipri >= 2) write(nfout,*) ' ! m_shellsize = ',m_shellsize
end subroutine shellsort2

subroutine spsort(n,imin,jmin,jmax,kmin,kmax,na,nb,nc)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: spsort
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  implicit none
  integer, intent(in) :: n, imin,jmin,jmax,kmin,kmax
  integer, intent(inout), dimension(n) :: na,nb,nc
!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!C     THIS SUBROUTINE SORTS THE ELEMENTS OF ARRAY BR IN ASCENDING
!C     ORDER. THE CODE IS BASED UPON HEAPSORT ALGORITHM WHICH HAS
!C     N*LOG(N) SCALING BEHAVIOUR, PARTICULARLY FAVOURABLE FOR LARGE
!C     VECTORS BR
!C                              STEFAN BL"UGEL, ISSP, NOV 1989
!c     interface is changed by T.Yamasaki at 28th Jun. 1994
!c     changed by T. Yamsaki at 17th Apr.1998
!c
!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

  integer b, c
  integer  l,i,ii,iheap
  integer ia,ib,ic
  integer p1,p2,p3

  b = jmax-jmin+1
  c = kmax-kmin+1

!C=====> BUILD-UP OF THE HEAP

!-----> LOOP OVER ALL HIERACHICAL LEVELS OF THE HEAP TREE

  Loop_L : do L = N/2 , 1 , -1
     ia = na(L)
     ib = nb(L)
     ic = nc(L)
!!$     p1 = (ia-imin+1) + (ib-jmin)*a + (ic-kmin)*a*b
     p1 = (ia-imin)*b*c + (ib-jmin)*c + (ic-kmin+1)
     I   = L
     II  = L + L

!-----> GO DOWN ALL THE HIERACHICAL LEVELS OF THE HEAP TREE

20   IF ( II <= N ) THEN
!!$        p2 = (na(ii)-imin+1) + (nb(ii)-jmin)*a + (nc(ii)-kmin)*a*b
        p2 = (na(ii)-imin)*b*c + (nb(ii)-jmin)*c + (nc(ii)-kmin+1)
!-----> COMPARE NEIGHBOURING ELEMENTS
        IF ( II < N ) THEN
!!$           p3 = (na(ii+1)-imin+1) + (nb(ii+1)-jmin)*a + (nc(ii+1)-kmin)*a*b
           p3 = (na(ii+1)-imin)*b*c+(nb(ii+1)-jmin)*c+(nc(ii+1)-kmin+1)
           if(p2 < p3) then
              ii = ii + 1
              p2 = p3
           endif
        endif

!-----> COMPARE THE ELEMENTS OF TWO HIRACHICAL LEVELS
!       PROMOTE LARGER ONE, DEMOTE SMALLER ONE

        if( p1 < p2 ) then
           na(i) = na(ii)
           nb(i) = nb(ii)
           nc(i) = nc(ii)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS ORDERED , STOP BY PUTTING II=N+1
           II    = N + 1
        END IF
        GO TO 20
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     na(i) = ia
     nb(i) = ib
     nc(i) = ic
  enddo Loop_L

!=====> NOW COLLECT ALL ELEMENTS FROM THE HEAP

  Loop_IHEAP :  do IHEAP = N , 1 , -1

     ia = na(iheap)
     ib = nb(iheap)
     ic = nc(iheap)
!!$     p1  = (ia-imin+1) + (ib-jmin)*a + (ic-kmin)*a*b
     p1  = (ia-imin)*b*c + (ib-jmin)*c + (ic-kmin+1)

!-----> THE FIRST ELEMENT IS ALWAYS THE LARGEST
     na(iheap) = na(1)
     nb(iheap) = nb(1)
     nc(iheap) = nc(1)
!-----> NOW LARGEST ELEMENT OF ALL BR(I) WITH 1<=I<=IHEAP IS STORED

     I   = 1
     II  = 2

!-----> NOW GENERATE LARGEST ELEMENT OF BR(I) WITH 1<=I<=IHEAP-1

40   IF ( II <= IHEAP - 1 ) THEN

!!$        p2 = (na(ii)-imin+1) + (nb(ii)-jmin)*a + (nc(ii)-kmin)*a*b
        p2 = (na(ii)-imin)*b*c + (nb(ii)-jmin)*c + (nc(ii)-kmin+1)
!-----> COMPARE NEIGHBOURING ELEMENTS
        if ( ii < iheap - 1 ) then
!!$           p3 = (na(ii+1)-imin+1) + (nb(ii+1)-jmin)*a + (nc(ii+1)-kmin)*a*b
           p3 = (na(ii+1)-imin)*b*c+(nb(ii+1)-jmin)*c+(nc(ii+1)-kmin+1)
           if ( p2 < p3 ) then
              ii = ii + 1
              p2 = p3
           endif
        endif

!-----> PROMOTE EACH ELEMENT OF THE TWIG OF BR UNTIL BRR > BR(I)
        if ( p1 < p2 ) then
           na(i) = na(ii)
           nb(i) = nb(ii)
           nc(i) = nc(ii)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS PROMOTED , STOP BY PUTTING II=IHEAP+1
           II    = IHEAP + 1
        END IF
        GO TO 40
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     na(i) = ia
     nb(i) = ib
     nc(i) = ic
  enddo Loop_IHEAP
end subroutine spsort

!C-----CALL HPSOR2(KG,IGP,GX,GY,GZ,GR)
!
subroutine gsort(ttr,k,n,nG)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: gsort
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!C     THIS SUBROUTINE SORTS THE ELEMENTS OF ARRAY BR IN ASCENDING
!C     ORDER. THE CODE IS BASED UPON HEAPSORT ALGORITHM WHICH HAS
!C     N*LOG(N) SCALING BEHAVIOUR, PARTICULARLY FAVOURABLE FOR LARGE
!C     VECTORS BR
!C                              STEFAN BL"UGEL, ISSP, NOV 1989
!c     interface is changed by T.Yamasaki at 28th Jun. 1994
!c     changed as it accords with fortran90 by T. Yamsaki at 17th Apr.1998
!c
!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in), dimension(6)   :: ttr
  integer, intent(in)                       :: k, n
  integer, intent(inout), dimension(k,3)    :: nG

!      integer DELTA
!      parameter (DELTA = 1.d-10)
  integer  l,i,ii,iheap
  integer ia,ib,ic
  real*8  brr,brr2, brr3

!C=====> BUILD-UP OF THE HEAP

!-----> LOOP OVER ALL HIERACHICAL LEVELS OF THE HEAP TREE

  loop_L :  do L = N/2 , 1 , -1
     ia = nG(L,1)
     ib = nG(L,2)
     ic = nG(L,3)
     brr    = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
          & + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     I   = L
     II  = L + L

!-----> GO DOWN ALL THE HIERACHICAL LEVELS OF THE HEAP TREE

20   IF ( II <= N ) THEN
        brr2 =  ttr(1)*nG(ii,1)*nG(ii,1)+ttr(2)*nG(ii,2)*nG(ii,2) &
             &+ ttr(3)*nG(ii,3)*nG(ii,3)+ttr(4)*nG(ii,1)*nG(ii,2) &
             &+ ttr(5)*nG(ii,2)*nG(ii,3)+ttr(6)*nG(ii,3)*nG(ii,1)

!-----> COMPARE NEIGHBOURING ELEMENTS
        IF ( II < N ) THEN
           brr3 = &
                &  ttr(1)*nG(ii+1,1)*nG(ii+1,1)+ttr(2)*nG(ii+1,2)*nG(ii+1,2) &
                &+ ttr(3)*nG(ii+1,3)*nG(ii+1,3)+ttr(4)*nG(ii+1,1)*nG(ii+1,2) &
                &+ ttr(5)*nG(ii+1,2)*nG(ii+1,3)+ttr(6)*nG(ii+1,3)*nG(ii+1,1)
           if(brr2 < brr3) then
!             if(brr2  < brr3 - DELTA) then
              ii = ii + 1
              brr2 = brr3
           endif
        endif

!-----> COMPARE THE ELEMENTS OF TWO HIRACHICAL LEVELS
!       PROMOTE LARGER ONE, DEMOTE SMALLER ONE

!           if( brr < brr2 - DELTA ) then
        if( brr < brr2 ) then
           nG(i,1) = nG(ii,1)
           nG(i,2) = nG(ii,2)
           nG(i,3) = nG(ii,3)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS ORDERED , STOP BY PUTTING II=N+1
           II    = N + 1
        END IF
        GO TO 20
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     nG(i,1) = ia
     nG(i,2) = ib
     nG(i,3) = ic
  enddo Loop_L

!=====> NOW COLLECT ALL ELEMENTS FROM THE HEAP

  loop_IHEAP :  do IHEAP = N , 1 , -1

     ia = nG(iheap,1)
     ib = nG(iheap,2)
     ic = nG(iheap,3)
     brr  =   ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
          & + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia

!-----> THE FIRST ELEMENT IS ALWAYS THE LARGEST
     nG(iheap,1) = nG(1,1)
     nG(iheap,2) = nG(1,2)
     nG(iheap,3) = nG(1,3)
!-----> NOW LARGEST ELEMENT OF ALL BR(I) WITH 1<=I<=IHEAP IS STORED

     I   = 1
     II  = 2

!-----> NOW GENERATE LARGEST ELEMENT OF BR(I) WITH 1<=I<=IHEAP-1

40   IF ( II <= IHEAP - 1 ) THEN

        brr2 =    ttr(1)*ng(ii,1)*nG(ii,1) + ttr(2)*nG(ii,2)*nG(ii,2) &
             &  + ttr(3)*nG(ii,3)*nG(ii,3) + ttr(4)*nG(ii,1)*nG(ii,2) &
             &  + ttr(5)*nG(ii,2)*nG(ii,3) + ttr(6)*nG(ii,3)*nG(ii,1)
!-----> COMPARE NEIGHBOURING ELEMENTS
        if ( ii < iheap - 1 ) then
           brr3 = &
                &  ttr(1)*nG(ii+1,1)*nG(ii+1,1)+ttr(2)*nG(ii+1,2)*nG(ii+1,2)&
                &+ ttr(3)*nG(ii+1,3)*nG(ii+1,3)+ttr(4)*nG(ii+1,1)*nG(ii+1,2)&
                &+ ttr(5)*nG(ii+1,2)*nG(ii+1,3)+ttr(6)*nG(ii+1,3)*nG(ii+1,1)
!             if ( brr2 < brr3 - DELTA ) then
           if ( brr2 < brr3 ) then
              ii = ii + 1
              brr2 = brr3
           endif
        endif

!-----> PROMOTE EACH ELEMENT OF THE TWIG OF BR UNTIL BRR > BR(I)
!           if ( brr < brr2 - DELTA ) then
        if ( brr < brr2 ) then
           nG(i,1) = nG(ii,1)
           nG(i,2) = nG(ii,2)
           nG(i,3) = nG(ii,3)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS PROMOTED , STOP BY PUTTING II=IHEAP+1
           II    = IHEAP + 1
        END IF
        GO TO 40
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     nG(i,1) = ia
     nG(i,2) = ib
     nG(i,3) = ic
  enddo Loop_IHEAP
end subroutine gsort

subroutine gsort2(ttr,k,n,nG,gr)
!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  SUBROUINE: gsort2
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!C     THIS SUBROUTINE SORTS THE ELEMENTS OF ARRAY BR IN ASCENDING
!C     ORDER. THE CODE IS BASED UPON HEAPSORT ALGORITHM WHICH HAS
!C     N*LOG(N) SCALING BEHAVIOUR, PARTICULARLY FAVOURABLE FOR LARGE
!C     VECTORS BR
!C                              STEFAN BL"UGEL, ISSP, NOV 1989
!c     interface is changed by T.Yamasaki at 28th Jun. 1994
!c     changed as it accords with fortran90 by T. Yamsaki at 17th Apr.1998
!c
!C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in), dimension(6)   :: ttr
  integer, intent(in)                       :: k, n
  integer, intent(inout), dimension(k,3)    :: nG
  real(kind=DP), intent(inout), dimension(k) :: gr

!      integer DELTA
!      parameter (DELTA = 1.d-10)
  integer  l,i,ii,iheap
  integer ia,ib,ic
  real*8  brr,brr2, brr3

!C=====> BUILD-UP OF THE HEAP

!-----> LOOP OVER ALL HIERACHICAL LEVELS OF THE HEAP TREE

  loop_L :  do L = N/2 , 1 , -1
     ia = nG(L,1)
     ib = nG(L,2)
     ic = nG(L,3)
!!$     brr    = ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
!!$          & + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     brr    = gr(L)
     I   = L
     II  = L + L

!-----> GO DOWN ALL THE HIERACHICAL LEVELS OF THE HEAP TREE

20   IF ( II <= N ) THEN
!!$        brr2 =  ttr(1)*nG(ii,1)*nG(ii,1)+ttr(2)*nG(ii,2)*nG(ii,2) &
!!$             &+ ttr(3)*nG(ii,3)*nG(ii,3)+ttr(4)*nG(ii,1)*nG(ii,2) &
!!$             &+ ttr(5)*nG(ii,2)*nG(ii,3)+ttr(6)*nG(ii,3)*nG(ii,1)
        brr2 =  gr(ii)
!-----> COMPARE NEIGHBOURING ELEMENTS
        IF ( II < N ) THEN
!!$           brr3 = &
!!$                &  ttr(1)*nG(ii+1,1)*nG(ii+1,1)+ttr(2)*nG(ii+1,2)*nG(ii+1,2) &
!!$                &+ ttr(3)*nG(ii+1,3)*nG(ii+1,3)+ttr(4)*nG(ii+1,1)*nG(ii+1,2) &
!!$                &+ ttr(5)*nG(ii+1,2)*nG(ii+1,3)+ttr(6)*nG(ii+1,3)*nG(ii+1,1)
           brr3 =  gr(ii+1)
           if(brr2 < brr3) then
!             if(brr2  < brr3 - DELTA) then
              ii = ii + 1
              brr2 = brr3
           endif
        endif

!-----> COMPARE THE ELEMENTS OF TWO HIRACHICAL LEVELS
!       PROMOTE LARGER ONE, DEMOTE SMALLER ONE

!           if( brr < brr2 - DELTA ) then
        if( brr < brr2 ) then
           nG(i,1) = nG(ii,1)
           nG(i,2) = nG(ii,2)
           nG(i,3) = nG(ii,3)
           gr(i)   = gr(ii)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS ORDERED , STOP BY PUTTING II=N+1
           II    = N + 1
        END IF
        GO TO 20
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     nG(i,1) = ia
     nG(i,2) = ib
     nG(i,3) = ic
     gr(i)   = brr
  enddo Loop_L

!=====> NOW COLLECT ALL ELEMENTS FROM THE HEAP

  loop_IHEAP :  do IHEAP = N , 1 , -1

     ia = nG(iheap,1)
     ib = nG(iheap,2)
     ic = nG(iheap,3)
!!$     brr  =   ttr(1)*ia*ia + ttr(2)*ib*ib + ttr(3)*ic*ic &
!!$          & + ttr(4)*ia*ib + ttr(5)*ib*ic + ttr(6)*ic*ia
     brr  =   gr(iheap)
!-----> THE FIRST ELEMENT IS ALWAYS THE LARGEST
     nG(iheap,1) = nG(1,1)
     nG(iheap,2) = nG(1,2)
     nG(iheap,3) = nG(1,3)
     gr(iheap)   = gr(1)
!-----> NOW LARGEST ELEMENT OF ALL BR(I) WITH 1<=I<=IHEAP IS STORED

     I   = 1
     II  = 2

!-----> NOW GENERATE LARGEST ELEMENT OF BR(I) WITH 1<=I<=IHEAP-1

40   IF ( II <= IHEAP - 1 ) THEN

!!$        brr2 =    ttr(1)*ng(ii,1)*nG(ii,1) + ttr(2)*nG(ii,2)*nG(ii,2) &
!!$             &  + ttr(3)*nG(ii,3)*nG(ii,3) + ttr(4)*nG(ii,1)*nG(ii,2) &
!!$             &  + ttr(5)*nG(ii,2)*nG(ii,3) + ttr(6)*nG(ii,3)*nG(ii,1)
        brr2 =    gr(ii)
!-----> COMPARE NEIGHBOURING ELEMENTS
        if ( ii < iheap - 1 ) then
!!$           brr3 = &
!!$                &  ttr(1)*nG(ii+1,1)*nG(ii+1,1)+ttr(2)*nG(ii+1,2)*nG(ii+1,2)&
!!$                &+ ttr(3)*nG(ii+1,3)*nG(ii+1,3)+ttr(4)*nG(ii+1,1)*nG(ii+1,2)&
!!$                &+ ttr(5)*nG(ii+1,2)*nG(ii+1,3)+ttr(6)*nG(ii+1,3)*nG(ii+1,1)
           brr3 = gr(ii+1)
!             if ( brr2 < brr3 - DELTA ) then
           if ( brr2 < brr3 ) then
              ii = ii + 1
              brr2 = brr3
           endif
        endif

!-----> PROMOTE EACH ELEMENT OF THE TWIG OF BR UNTIL BRR > BR(I)
!           if ( brr < brr2 - DELTA ) then
        if ( brr < brr2 ) then
           nG(i,1) = nG(ii,1)
           nG(i,2) = nG(ii,2)
           nG(i,3) = nG(ii,3)
           gr(i)   = gr(ii)
           I     = II
           II    = II + II
        ELSE

!-----> THIS PART OF THE TREE IS PROMOTED , STOP BY PUTTING II=IHEAP+1
           II    = IHEAP + 1
        END IF
        GO TO 40
     END IF
!-----> PUT ELEMENTS IN THE PROPER SLOT
     nG(i,1) = ia
     nG(i,2) = ib
     nG(i,3) = ic
     gr(i)   = brr
  enddo Loop_IHEAP
end subroutine gsort2

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 577 $)
!
!  MODULE:  m_ES_WF_by_submat
!
!  AUTHOR(S): Tsuyoshi Miyazaki, T. Yamasaki   August/20/2003
!             Takenori Yamamoto June/22/2005
!  FURTHER MODIFICATION: T. Yamasaki, September 2009
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#ifdef __TIMER__
#   define __TIMER_START_w_BARRIER(str,a)  call mpi_barrier(str,ierr); call timer_sta(a)
#   define __TIMER_STOP_w_BARRIER(str,a)   call timer_sta(a); call mpi_barrier(str,ierr)
#   define __TIMER_START(a)                call timer_sta(a)
#   define __TIMER_STOP(a)                 call timer_end(a)
#else
#   define __TIMER_START_w_BARRIER(str,a)
#   define __TIMER_STOP_w_BARRIER(str,a)
#   define __TIMER_START(a)
#   define __TIMER_STOP(a)
#endif
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)  call timer_sta(a)
#   define __TIMER_DO_STOP(a)   call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_DGEMM__
#   define __TIMER_DGEMM_START(a)  call timer_sta(a)
#   define __TIMER_DGEMM_STOP(a)   call timer_end(a)
#else
#   define __TIMER_DGEMM_START(a)
#   define __TIMER_DGEMM_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

module m_ES_WF_by_submat
! $Id: m_ES_WF_by_submat.F90 577 2017-12-15 05:26:08Z jkoga $

!!$#ifdef TRANSPOSE
#ifdef VPP
#define _ODD_BOUNDARY_
#endif
#ifdef SX
#define _ODD_BOUNDARY_
#endif
#ifdef NEC_TUNE1
#define _ODD_BOUNDARY_
#endif

#ifndef NO_SUBMAT_DGEMM
#define SUBMAT_DGEMM
#endif

  use m_Const_Parameters,    only : DP,SP,DIRECT,ON,OFF,SCF, SmallestPositiveNumber,GAMMA &
       &                          , HOUSEHOLDER, DIVIDEandCONQUER, ELECTRON, CMPLDP, OLD, INVERSE, EXECUT
  use m_Parallelization,     only : mpi_comm_group &
       &                          , myrank_e,myrank_k,map_e,map_k,ista_e,iend_e,istep_e &
       &                          , ista_k,iend_k,np_g1k,mpi_k_world,map_z &
       &                          , np_e,npes, nrank_k, nrank_e,mype &
       &                          , np_fs
  use m_Control_Parameters,  only : nspin,iprisubmat,ldiag,kimg,neg,af &
       &                          , submat_critical_ratio,printable &
       &                          , m_CtrlP_set_submat, sw_scalapack &
       &                          , method_scalapack, block_size, nprow, npcol &
       &                          , msize_submat, sw_hybrid_functional, sw_fef &
       &                          , nblocksize_submat_is_given, nblocksize_submat, nb_submat_default &
       &                          , sw_gep &
       &                          , submat_uncalled &
       &                          , sw_serial_fft                    &
#ifdef SAVE_FFT_TIMES
       &                          , nb_mgs_default, sw_save_fft
#else
       &                          , nb_mgs_default
#endif
  use m_Files,               only : nfout
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_FFT,                 only : nfft,fft_box_size_WF
  use m_FFT,                 only : m_FFT_Vlocal_W, m_FFT_WF
  use m_Kpoints,             only : kv3,vkxyz, k_symmetry
  use m_PlaneWaveBasisSet,   only : kg1, iba, igf, nbase, m_pwBS_kinetic_energies
  use m_Electronic_Structure,only : zaj_l, zaj_l_buf,neordr,           nrvf_ordr &
#ifdef SAVE_FFT_TIMES
       &                          , status_saved_phifftr &
#endif
       &                          , eko_l,vnlph_l 
  use m_Electronic_Structure,only : m_ES_Vlocal_in_Rspace &
       &                          , m_ES_WF_in_Rspace &
       &                          , m_ES_wd_zaj_small_portion &
       &                          , m_ES_wd_eko
  use m_ES_nonlocal,         only : sc ,ss ,qc                                        &
 &                                , m_ES_Vnonlocal_W                                  &
 &                                , m_ES_betar_dot_WFs_4_each_k                       &
 &                                , m_ES_alloc_scss_etc                               &
 &                                , m_ES_dealloc_scss_etc
  use m_ES_ortho,            only : np_g1k_x
  use m_ES_ortho,            only : m_ES_W_transpose_r                                &
 &                                , m_ES_W_transpose_back_r                           &
 &                                , m_ES_W_transpose_back2                            &
 &                                , m_ES_W_transpose_fft_cmplx                        &
 &                                , m_ES_W_transpose_back_fft_cmplx

  use m_ES_ExactExchange,    only : m_ES_Vexx_W
  use m_FiniteElectricField, only : m_FEF_add_grad_to_vnlph

! ================================= added by K. Tagami ============== 11.0
  use m_Control_Parameters,    only : ndim_spinor, ndim_chgpot
  use m_Electronic_Structure,  only : m_ES_Vlocal_in_Rspace_noncl
  use m_FFT,                   only : m_FFT_Vlocal_W_noncl
  use m_Electronic_Structure,      only : m_ES_sort_eigen_vals_noncl
! =================================================================== 11.0


  use m_Control_Parameters, only : sw_rsb

  implicit none
  logical, allocatable, dimension(:) :: non_diagonal_part_is_small

  integer, save :: npart,npart2
  integer, allocatable, save :: isp(:),iep(:)
  integer, allocatable, save :: isp2(:),iep2(:)

  real(kind=DP), allocatable, target, dimension(:,:) :: unimat,unimat_h

  integer, private, save :: lda,occ
#ifdef SINGLE_CONTEXT
   integer, private, allocatable, save :: usermap(:,:)
#else
   integer, private, allocatable, save :: usermap(:,:,:) ! d(nprow,npcol,0:nrank_k-1)
#endif

   logical :: disable_utransform = .false.
   integer :: ierr

  include 'mpif.h'
contains
  subroutine m_ESsubmat_alloc()
    if(.not.allocated(non_diagonal_part_is_small)) then
       allocate(non_diagonal_part_is_small(kv3))
!!$       non_diagonal_part_is_small = .false.
    end if
    non_diagonal_part_is_small = .false.
  end subroutine m_ESsubmat_alloc

  subroutine m_ESsubmat_dealloc()
    if(allocated(non_diagonal_part_is_small)) deallocate(non_diagonal_part_is_small)
  end subroutine m_ESsubmat_dealloc

  subroutine m_ESsubmat_reset_non_diagon()
    if(allocated(non_diagonal_part_is_small)) non_diagonal_part_is_small = .false.
  end subroutine m_ESsubmat_reset_non_diagon

  subroutine m_ESsubmat_Renew_WF(nfout,meg,damp)
    integer, intent(in) :: nfout,meg
    real(kind=DP)       :: damp

    integer             :: ispin, iksnl, ik
    real(kind=DP), allocatable, dimension(:) ::  afft
    real(kind=DP), allocatable, dimension(:) ::  bfft
    real(kind=DP), pointer, dimension(:) :: ekin, p, vnldi

    integer :: n_all_kpoints, n_submat, ipri0
    logical :: submat_is_done

    submat_is_done = .false.
    call m_ES_alloc_scss_etc()
    allocate(afft(nfft))
    allocate(bfft(nfft))
    ekin => sc(1:kg1); p => ss(1:kg1); vnldi => qc(1:kg1)

    n_all_kpoints = 0
    n_submat = 0
!!$    if(m_CtrlP_ntcnvg_clear()) non_diagonal_part_is_small = .false.
    if(iprisubmat >= 2) write(nfout,'(" !! <<m_ESsubmat_Renew_WF>>")')
    call get_ipri0(iprisubmat,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)


    do ispin = 1, nspin, (af+1)
       call m_ES_Vlocal_in_Rspace(ispin,afft)      ! (ptfft1) vlhxc_l->afft
       do ik = ispin, kv3-nspin+ispin, nspin
          if(map_k(ik) /= myrank_k) cycle          ! MPI
          n_all_kpoints = n_all_kpoints + 1
          if(non_diagonal_part_is_small(ik)) then
             if(iprisubmat >= 2) write(nfout,'(" !!! submat is not done for ik=",i4)') ik
             cycle
          else
             if(iprisubmat >= 2) write(nfout,'(" !!! submat is done for ik=",i4)') ik
             n_submat = n_submat + 1
             submat_is_done = .true.
          end if
          iksnl = (ik-1)/nspin + 1
          call m_ES_Vnonlocal_W(ik,iksnl,ispin,switch_of_eko_part=OFF)  ! (nonloc) ->(vnlph_l)
          if(sw_hybrid_functional==ON) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)
          if(sw_fef==ON) call m_FEF_add_grad_to_vnlph(ik) !->vnlph_l
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin) ! (diakin) ->ekin
          call evolve_WFs_in_subspace&     !-(m_ES_WF_by_submat)
                  &(ik,iksnl,ispin,meg,damp,ekin,afft,bfft)
          if(ik==1.and.iprisubmat>= 2) &
               & call m_ES_wd_zaj_small_portion(nfout,1," -- after subspace-rotation --",30)
          call m_ES_betar_dot_WFs_4_each_k(nfout,ik)   ! -> fsr_l,fsi_l
       enddo      ! k-point loop
    enddo      ! spin loop


!!$    if(npes > 1) then
!!$       call mpi_allreduce(n_submat,n_submat_mpi,1,mpi_integer,mpi_sum,mpi_k_world(myrank_k),ierr)
!!$       n_submat = n_submat_mpi
!!$    end if

!!  ( in case of af=1 )
    if(af /= 0) then
       call cp_eigen_values_for_af       !-(contained here)
       call expand_neordr_and_nrvf_ordr  !-(contained here)
    end if

    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    deallocate(bfft);   deallocate(afft)
    call m_ES_dealloc_scss_etc()
    if(iprisubmat >= 2) then
       if(submat_is_done) write(nfout,'(" !solver -- subspace_rotation is done for ",i4," of ",i4," kpoints")') &
            & n_submat, n_all_kpoints
       if(.not.submat_is_done) write(nfout,'(" !solver --  no subspace_rotation")')
    end if

    if(nrank_k > 1) then
       call mpi_allreduce(MPI_IN_PLACE, n_submat,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       call mpi_allreduce(MPI_IN_PLACE, n_all_kpoints,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
    end if
    if(submat_is_done .and. n_submat < n_all_kpoints) submat_is_done = .false.
    call m_CtrlP_set_submat(submat_is_done)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine cp_eigen_values_for_af
      integer :: ik,ib
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle    ! MPI
         do ib = 1, np_e                    ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle     ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr

  end subroutine m_ESsubmat_Renew_WF


! ===================================== added by K. Tagami ================ 11.0
  subroutine m_ESsubmat_Renew_WF_noncl(nfout,meg,damp)
    integer, intent(in) :: nfout,meg
    real(kind=DP)       :: damp

    integer             :: is, iksnl, ik

    real(kind=DP), allocatable ::  afft_kt(:,:)
    real(kind=DP), allocatable ::  bfft_kt(:,:)

    real(kind=DP), pointer, dimension(:) :: ekin, p, vnldi

    real(kind=DP), allocatable :: vnlph_noncl(:,:,:,:)

    integer :: n_all_kpoints, n_submat, ipri0
    logical :: submat_is_done

    integer :: is1, is2, k2, istmp

    submat_is_done = .false.

    call m_ES_alloc_scss_etc()
    allocate(afft_kt(nfft,ndim_chgpot))
    allocate(bfft_kt(nfft,ndim_spinor))

    ekin => sc(1:kg1); p => ss(1:kg1); vnldi => qc(1:kg1)

    allocate(vnlph_noncl(kg1,np_e,kimg,ndim_spinor)); vnlph_noncl = 0.0d0

    n_all_kpoints = 0;     n_submat = 0

    if (iprisubmat >= 2) write(nfout,'(" !! <<m_ESsubmat_Renew_WF_noncl>>")')
    call get_ipri0(iprisubmat,ipri0)

    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )    ! (ptfft1) vlhxc_l->afft

    Do ik = 1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle          ! MPI
       iksnl = (ik-1) /ndim_spinor + 1

       n_all_kpoints = n_all_kpoints + 1

       if ( non_diagonal_part_is_small(ik) ) then
          if(iprisubmat >= 2) write(nfout,'(" !!! submat is not done for ik=",i4)') ik
          cycle
       else
          if(iprisubmat >= 2) write(nfout,'(" !!! submat is done for ik=",i4)') ik
          n_submat = n_submat + 1
          submat_is_done = .true.
       end if

       vnlph_noncl = 0.0d0

       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
            istmp = ( is1-1 )*ndim_spinor +is2
            k2 = ik +is2 -1

            call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=OFF )
!!!!           call m_ES_Vnonlocal_W( k2, iksnl, istmp, switch_of_eko_part=ON )
                                                   ! (nonloc) ->(vnlph_l)
            vnlph_noncl(:,:,:,is1) = vnlph_noncl(:,:,:,is1) &
             &                     + vnlph_l(:,:,:)              
          End do
       End do

       if ( sw_hybrid_functional==ON ) call m_ES_Vexx_W(ik) ! (exx) ->(vnlph_l)

       call m_pwBS_kinetic_energies( ik, vkxyz, ekin )       ! (diakin) ->ekin

       call evolve_WFs_in_subspace_noncl( ik, meg, damp, ekin, afft_kt, bfft_kt, &
	&                                 vnlph_noncl )

       if ( ik==1 .and. iprisubmat>= 2 ) then
          Do is1=1, ndim_spinor
            call m_ES_wd_zaj_small_portion( nfout, ik+is1-1, &
                   &                        " -- after subspace-rotation --",30 )
          End do
       endif
       Do is1=1, ndim_spinor
          call m_ES_betar_dot_WFs_4_each_k( nfout,ik+is1-1 )   ! -> fsr_l,fsi_l
       End do
    End do

! ****************************************** This is important ******
    call m_ES_sort_eigen_vals_noncl()
! *******************************************************************

    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)
    deallocate(bfft_kt);   deallocate(afft_kt)

    call m_ES_dealloc_scss_etc()

    if (iprisubmat >= 2) then
       if(submat_is_done) write(nfout,'(" !solver -- subspace_rotation is done for ",i4," of ",i4," kpoints")') &
            & n_submat, n_all_kpoints
       if(.not.submat_is_done) write(nfout,'(" !solver --  no subspace_rotation")')
    end if

    if (nrank_k > 1) then
       call mpi_allreduce(MPI_IN_PLACE, n_submat,     1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
       call mpi_allreduce(MPI_IN_PLACE, n_all_kpoints,1,mpi_integer,mpi_sum,mpi_comm_group,ierr)
    end if

    if (submat_is_done .and. n_submat < n_all_kpoints) submat_is_done = .false.
    call m_CtrlP_set_submat(submat_is_done)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end subroutine m_ESsubmat_Renew_WF_noncl
!======================================================================= 11.0

 subroutine evolve_WFs_in_subspace&
       &(ik,iksnl,ispin,meg,damp,ekin,afft,bfft)
!
! Revised by T. Yamasaki, September 2009 : SUBMAT_DGEMM
!
    integer, intent(in) :: ik,iksnl,ispin,meg
    real(kind=DP), intent(in)  :: damp,ekin(kg1)
    real(kind=DP), intent(in)  :: afft(nfft)
    real(kind=DP), intent(out) :: bfft(nfft)
! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:) ::     eko_d
    real(kind=DP), allocatable,dimension(:) ::   w1hw2
    real(kind=DP), allocatable,dimension(:,:) ::   zz
    real(kind=DP), allocatable,dimension(:,:,:) :: zat_l
    real(kind=DP), allocatable,dimension(:,:,:) :: zah_l
    real(kind=DP), allocatable,dimension(:,:,:) :: zat_wk

    real(kind=DP), allocatable :: amat(:,:), zmat(:,:)
!    integer, save :: lwork,lrwork,liwork,lda,occ
    integer, save :: lwork,lrwork,liwork
#ifdef _USE_SCALAPACK_
    integer, save :: lwork1,lrwork1,liwork1
    integer, save :: lwork2,lrwork2,liwork2
#endif
#ifdef SINGLE_CONTEXT
    integer, save :: ictxt, myrow, mycol
#else
    integer, save :: myrow, mycol, tmpctxt
    integer, allocatable, save :: ictxt(:) ! d(0:nrank_k-1)
#endif
    integer, dimension(9), save :: desca,descz
!#ifdef SINGLE_CONTEXT
!    integer, allocatable, save :: usermap(:,:)
!#else
!    integer, allocatable, save :: usermap(:,:,:) ! d(nprow,npcol,0:nrank_k-1)
!#endif
!!$    integer, save :: npart,npart2
!!$    integer, allocatable, save :: isp(:),iep(:)
!!$    integer, allocatable, save :: isp2(:),iep2(:)
!    logical, save :: first = .true.
    integer :: is,ie,m,jp
    integer :: msize

    integer       :: ib1,ib2,ib1to,i1,ii,ri,ib, i, kimg_t, ig1
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: dr1,dr2,di1,di2, dd
    real(kind=DP) :: sum_sq_diagonal, sum_sq_non_diagonal &
         & , sum_abs_diagonal, sum_abs_non_diagonal
    integer :: id_sname = -1, id_sname2 = -1, ipri0
    integer :: max_block_size
#ifdef SUBMAT_DGEMM
    real(kind=DP),allocatable,dimension(:,:) :: w1hw2r,w1hw2i
    real(kind=DP) :: alpha, beta
#endif
! <-- T.Kokubo & D.Fukata, Feb. 2010
    integer :: ibsta, ibend, nblk1, nblk2, ibsize, ibsize2
    if(nblocksize_submat_is_given) then
      ibsize = nblocksize_submat
    else
      ibsize = nb_submat_default
    endif
! -->
    call tstatc0_begin('evolve_WFs_in_subspace ', id_sname,1)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))

! (allocate)  zat_l will be divided by G-index
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(eig(meg)); eig=0.d0
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate(zat_l(np_g1k_x,neg,kimg))
    !!$allocate(zah_l(np_g1k_x,neg,kimg))

    do ib1 = 1, neg
       if(map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)
    end do
    call mpi_allreduce(MPI_IN_PLACE,eko_d,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    eko1 = sum(eko_d(1:neg))

!( tenchi ) (zat_l <- zaj_l)
! --> T. Yamasaki, 28th Aug. 2009
!!$    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zat_l)
    call m_ES_W_transpose_r(.true.,ista_k,iend_k,ik,zaj_l,zat_l)
! <--

! (zaj_l <- H |phi> )
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(bfft,ib1to,ib,ii,i1,dr1,di1,dr2)
!CDIR CONCUR(BY=1)
#endif
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib1to=nrvf_ordr(ib1,ik)
       if(ib1to>meg) cycle
       call m_ES_WF_in_Rspace(ik,ib1,bfft)!(swffft)
       call m_FFT_Vlocal_W(afft,bfft)    ! (afft, bfft)-> (bfft)
       call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
       ib = map_z(ib1)                 ! MPI
       if(kimg == 1) then
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1 = zaj_l(ii,ib,ik,1)
             dr2 = bfft(i1)*denom
             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+vnlph_l(ii,ib,1)+dr2
          enddo
       else
          do ii=1,iba(ik)
             i1  = igf(nbase(ii,ik))
             dr1  = zaj_l(ii,ib,ik,1)
             di1  = zaj_l(ii,ib,ik,2)
             zaj_l(ii,ib,ik,1)= ekin(ii)*dr1+bfft(2*i1-1)*denom+vnlph_l(ii,ib,1)
             zaj_l(ii,ib,ik,2)= ekin(ii)*di1+bfft(2*i1  )*denom+vnlph_l(ii,ib,2)
          enddo
       end if
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) status_saved_phifftr(ib,ik) = OLD
#endif
    end do

!( tenchi ) (zah_l <- zaj_l)
    allocate(zah_l(np_g1k_x,neg,kimg))                                 ! MPI
! --> T. Yamasaki 28th Aug. 009
!!$    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zah_l)
    call m_ES_W_transpose_r(.true.,ista_k,iend_k,ik,zaj_l,zah_l)
! <--

! (make matrix elements )
#ifdef _USE_SCALAPACK_
    if(iprisubmat>=2) write(nfout,'(" sw_scalapack = ",i3," <<evolve_WFs_in_subspace>>")') sw_scalapack
    if(sw_scalapack == ON) then
       if(submat_uncalled) then
! === DEBUG by tkato 2012/01/23 ================================================
          if(block_size == 0) then
             max_block_size = int(real(meg)/real(nrank_e))
             block_size =  nb_mgs_default
             if(block_size.ge.max_block_size) block_size = max_block_size
          end if
! ==============================================================================
          call set_nprow_npcol(nprow,npcol)
#ifdef SINGLE_CONTEXT
          if(allocated(usermap)) deallocate(usermap)
          allocate(usermap(nprow,npcol))
#else
          if(allocated(ictxt)) deallocate(ictxt)
          if(allocated(usermap)) deallocate(usermap)
          allocate(ictxt(0:nrank_k-1))
          allocate(usermap(nprow,npcol,0:nrank_k-1))
#endif
!         call scalapack_setup(meg,lwork,lrwork,liwork,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#ifdef SINGLE_CONTEXT
          call scalapack_setup(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#else
          call scalapack_setup(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt(myrank_k),&
           & myrow,mycol,desca,descz,usermap)
#endif
! ===== We need more work area!!! ==============================================
          lwork1  = 10*lwork1
          lrwork1 = 10*lrwork1
          liwork1 = 10*liwork1
          lwork2  = 10*lwork2
          lrwork2 = 10*lrwork2
          liwork2 = 10*liwork2
! ==============================================================================
       end if
       allocate(amat(lda*kimg_t,occ))
       allocate(zmat(lda*kimg_t,occ))
       if(sw_rsb==ON) then
          if(.not.allocated(unimat)) then
             allocate(unimat(lda*kimg_t,occ))
             allocate(unimat_h(lda*kimg_t,occ))
          endif
       endif
    else
       allocate(zmat(meg*kimg_t,meg))
       if(sw_rsb==ON) then
          if(.not.allocated(unimat)) then
             allocate(unimat(meg*kimg_t,meg))
             allocate(unimat_h(meg*kimg_t,meg))
          endif
       endif
    end if

#else
    allocate(zmat(meg*kimg_t,meg))
    if(sw_rsb==ON) then
       if(.not.allocated(unimat)) then
          allocate(unimat(meg*kimg_t,meg))
          allocate(unimat_h(meg*kimg_t,meg))
       endif
    endif
    zmat=0.0d0
#endif
    if(submat_uncalled) then
!!$       call set_col_partition ! -> npart,isp,iep, npart2, isp2, iep2
       call set_col_partition_G(kimg_t,meg,ibsize) ! -> npart,isp,iep, npart2, isp2, iep2
       submat_uncalled = .false.
    end if

    call tstatc0_begin('evolve_WFs_in_subspace(PART1) ', id_sname2)
!!$    if(iprisubmat>=2) then
!!$       write(nfout,'(" --- neordr ---")')
!!$       write(nfout,'(" ik = ",i8)') ik
!!$       write(nfout,'(10i8)') (neordr(ib1,ik),ib1=1, neg)
!!$       write(nfout,'(" --- nrvf_ordr ---")')
!!$       write(nfout,'(" ik = ",i8)') ik
!!$       write(nfout,'(10i8)') (nrvf_ordr(ib1,ik),ib1=1, neg)
!!$    end if

    ekod = 0.d0
    sum_abs_diagonal = 0.d0
    sum_sq_diagonal = 0.d0
    sum_sq_non_diagonal = 0.d0
    sum_abs_non_diagonal = 0.d0
    PART1: do jp = 1,npart
       is = isp(jp)
       ie = iep(jp)
       msize = is*(ie-is+1) + (ie-is+1)*(ie-is)/2
       allocate(w1hw2(msize*kimg_t))
       w1hw2 = 0.d0
       if(iprisubmat>=2) then
          write(nfout,'(" jp, is, ie = ",3i8)') jp, is, ie
       end if
#ifdef SUBMAT_DGEMM
! <-- T.Kokubo & D.Fukata Feb. 2010
       nblk1 = ie-is+1
#ifdef SX
       ibsize2 = min(ie,meg)
#else
       ibsize2 = ibsize
#endif

       allocate(w1hw2r(ibsize2,nblk1)); w1hw2r = 0.d0
       if(kimg==2 .and. k_symmetry(ik) /= GAMMA) then
          allocate(w1hw2i(ibsize2,nblk1)); w1hw2i = 0.d0
       end if

       do ibsta=1,min(ie,meg), ibsize2
          ibend=min( ibsta+ibsize2-1, min(ie,meg) )
          nblk2=ibend-ibsta+1
          w1hw2r = 0.d0
          if(kimg==2 .and. k_symmetry(ik) /= GAMMA) w1hw2i = 0.d0

          if(kimg==1) then
             call dgemm('T','N',nblk2,nblk1,np_g1k(ik),1.d0,zat_l(1,ibsta,1),np_g1k_x, &
                  &     zah_l(1,is,1),np_g1k_x,1.d0,w1hw2r,ibsize2)
             do ib1 = max(is,ibsta), min(ie,meg)
                do ib2 = ibsta,min(ibend,ib1) 
                   m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                   w1hw2(m)=w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                end do
             end do
          else
             if(k_symmetry(ik) == GAMMA) then
                ig1=1;if(myrank_e==0) ig1=2
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik),1.d0,zat_l(1,ibsta,1),np_g1k_x, &
                     &     zah_l(1,is,1),np_g1k_x,1.d0,w1hw2r,ibsize2)
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik),1.d0,zat_l(1,ibsta,2),np_g1k_x, &
                     &     zah_l(1,is,2),np_g1k_x,1.d0,w1hw2r,ibsize2)
                w1hw2r = w1hw2r*2.d0
                if(myrank_e == 0) then
                   do ib1 = max(is,ibsta), min(ie,meg)
                      do ib2 = ibsta,min(ibend,ib1)
                         w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1) =  w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1) &
                        &                                          - 2.d0*zah_l(1,ib1,2)*zat_l(1,ib2,2)       &
                        &                                          -      zah_l(1,ib1,1)*zat_l(1,ib2,1)
                      end do
                   end do
                end if
                do ib1 = max(is,ibsta), min(ie,meg)
                   do ib2 = ibsta,min(ibend,ib1)
                      m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                      w1hw2(m)=w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                   end do
                end do
             else
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik), 1.d0,zat_l(1,ibsta,1),np_g1k_x, &
                     &     zah_l(1,is,1),np_g1k_x,1.d0,w1hw2r,ibsize2)
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik), 1.d0,zat_l(1,ibsta,2),np_g1k_x, &
                     &     zah_l(1,is,2),np_g1k_x,1.d0,w1hw2r,ibsize2)
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik), 1.d0,zat_l(1,ibsta,2),np_g1k_x, &
                     &     zah_l(1,is,1),np_g1k_x,1.d0,w1hw2i,ibsize2)
                call dgemm('T','N',nblk2,nblk1,np_g1k(ik),-1.d0,zat_l(1,ibsta,1),np_g1k_x, &
                     &     zah_l(1,is,2),np_g1k_x,1.d0,w1hw2i,ibsize2)
                do ib1 = max(is,ibsta), min(ie,meg)
                   do ib2 = ibsta,min(ibend,ib1)
                      m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                      w1hw2(2*m-1) = w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                      w1hw2(2*m  ) = w1hw2i(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                   end do
                end do
             end if
          end if
       enddo
! -->
       if(kimg==2 .and. k_symmetry(ik) /= GAMMA) deallocate(w1hw2i)
       deallocate(w1hw2r)

#else
! parallel loop
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(ib2,ii,dr1,dr2,di1,di2,m)
!CDIR CONCUR(BY=1)
#endif
! --> T. Yamasaki 28th Aug. 2009
!   ib1to --> ib1,  instead of ib1to = neordr(ib1,ik) 
!   ib2to --> ib2
       do ib1 = is, ie
          if(ib1>meg) cycle
          do ib2 = 1, ib1
             m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
             if(kimg == 1) then
                do ii = 1, np_g1k(ik)              ! MPI
                   dr1 = zah_l(ii,ib1,1)
                   dr2 = zat_l(ii,ib2,1)
                   w1hw2(m) = w1hw2(m) + dr1*dr2
                end do
             else
                if(k_symmetry(ik) == GAMMA) then
                   dd = 0.d0
!!$                   ig1 = 1;  if(mype == 0) ig1 = 2
                   ig1 = 1;  if(myrank_e == 0) ig1 = 2
                   do ii = ig1, np_g1k(ik)            ! MPI
                      dr1 = zah_l(ii,ib1,1)
                      di1 = zah_l(ii,ib1,2)
                      dr2 = zat_l(ii,ib2,1)
                      di2 = zat_l(ii,ib2,2)
                      dd = dd + (dr1*dr2+di1*di2)*2.d0
                   end do
!!$                   if(mype == 0) dd = dd + zah_l(1,ib1,1)*zat_l(1,ib2,1)
                   if(myrank_e == 0) dd = dd + zah_l(1,ib1,1)*zat_l(1,ib2,1)
                   w1hw2(m)=dd
                else
                   do ii = 1, np_g1k(ik)             ! MPI
                      dr1 = zah_l(ii,ib1,1)
                      di1 = zah_l(ii,ib1,2)
                      dr2 = zat_l(ii,ib2,1)
                      di2 = zat_l(ii,ib2,2)
                      w1hw2(2*m-1)=w1hw2(2*m-1)+dr1*dr2+di1*di2
                      w1hw2(2*m  )=w1hw2(2*m  )+dr1*di2-di1*dr2
                   end do
                end if
             end if
          end do
       end do
#endif

       if(iprisubmat >= 2) call wd_w1hw2(" -- just after making w1hw2 --")

!! (off-diagonal matrix elements will be damped.)
       if(kimg_t == 1) then
          do ib1=max(2,is),ie
             do ib2=1,ib1-1
                m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                sum_sq_non_diagonal = sum_sq_non_diagonal + w1hw2(m)*w1hw2(m)
                sum_abs_non_diagonal = sum_abs_non_diagonal + abs(w1hw2(m))
                w1hw2(m) = damp*w1hw2(m)
             enddo
          enddo
          do ib = is, ie
             m = ib*(ib-1)/2-is*(is-1)/2+ib
             sum_sq_diagonal = sum_sq_diagonal + w1hw2(m)**2
             sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(m))
             ekod = ekod + w1hw2(m)
          end do
       else
          do ib1=max(2,is),ie
             do ib2=1,ib1-1
                m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                dd = w1hw2(2*m-1)*w1hw2(2*m-1) + w1hw2(2*m)*w1hw2(2*m)
                sum_sq_non_diagonal = sum_sq_non_diagonal + dd
                if(dd >= SmallestPositiveNumber) sum_abs_non_diagonal = sum_abs_non_diagonal + sqrt(dd)
                w1hw2(2*m-1) = damp*w1hw2(2*m-1)
                w1hw2(2*m  ) = damp*w1hw2(2*m  )

             enddo
          enddo
          do ib = is, ie
             m = ib*(ib-1)/2-is*(is-1)/2+ib
             sum_sq_diagonal = sum_sq_diagonal + w1hw2(2*m-1)**2
             sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(2*m-1))
             ekod = ekod + w1hw2(2*m-1)
          end do
       endif
       if(iprisubmat >= 2) call wd_w1hw2(" -- after damping --")

#ifdef _USE_SCALAPACK_
       if(sw_scalapack==ON) then
          call set_amat(lda,kimg_t,occ,amat,meg,nprow,npcol,block_size,usermap,is,ie,w1hw2)
       else
#endif
          call set_hmat(kimg_t,meg,is,ie,w1hw2,zmat)
#ifdef _USE_SCALAPACK_
       end if
#endif

       deallocate(w1hw2)
    end do PART1
    call tstatc0_end(id_sname2)
    deallocate(zah_l)

    sum_abs_diagonal = sum_abs_diagonal/meg
    sum_abs_non_diagonal = sum_abs_non_diagonal/(meg*(meg-1)/2)

    if(iprisubmat >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,neg)
    endif
9002 format(5x,10i8)

!! (Diagonalization )  !!
#ifdef _USE_SCALAPACK_
     if(sw_scalapack == ON) then
        if(kimg_t == 1) then
!          call pdsyev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork,liwork)
           call pdsyev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork1,liwork1)
        else
!          call pzheev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork,lrwork,liwork)
           call pzheev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork2,lrwork2,liwork2)
        endif
     else
#endif
        if(kimg_t == 1) then
           call dsyev_driver(meg,eig,zmat)
        else
           call zheev_driver(meg,eig,zmat)
        endif
#ifdef _USE_SCALAPACK_
     endif
#endif

     if(iprisubmat >= 2) then
        write(nfout,*) 'eko_d for ik = ',ik
        write(nfout,9001) (eko_d(ib),ib=1,meg)
        write(nfout,*) 'eig for ik = ',ik
        write(nfout,9001) (eig(ib),ib=1,meg)
        !!$call wd_w1hw2(" -- after diagonalization --")
        !!$call wd_zmat(" -- after diagonalization --")
!sum eko
     end if

     call get_ipri0(iprisubmat,ipri0)
     if(ipri0>=2) then
        dr1=0.d0;dr2=0.d0
        do ib1=1,meg
           ib1to = neordr(ib1,ik)
           if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(map_z(ib1to),ik)
           dr2=dr2+eig(ib1)
        enddo
        call mpi_allreduce(MPI_IN_PLACE, dr1,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
     end if
     if(iprisubmat>=2) then
        write(nfout,*) ' sum of eko_l & eig =',dr1,dr2
        write(nfout,'(" sum_sq_diagonal , sum_sq_non_diagonal  = ",2d20.12)') sum_sq_diagonal, sum_sq_non_diagonal
        write(nfout,'(" sum_abs_diagonal ,sum_abs_non_diagonal = ",2d20.12)') sum_abs_diagonal, sum_abs_non_diagonal
     end if

!! (subspace rotation) !!
     allocate(zat_wk(np_g1k_x,meg,kimg))
     zat_wk=0.d0
! <-- T.Kokubo & D.Fukata, Feb. 2010
        PART2: do jp = 1,npart2
           is = isp2(jp)
           ie = iep2(jp)
           nblk1 = ie-is+1
#ifdef SX
           ibsize2 = meg
#else
           ibsize2 = ibsize
#endif
#ifdef _USE_SCALAPACK_
     if(sw_scalapack == ON) then
           allocate(zz(meg*kimg_t,nblk1))
           call put_zmat(kimg_t,lda,occ,zmat,meg,nprow,npcol,block_size,usermap,is,ie,zz)
           if(kimg == 1) then
              call subspace_rotation_real(is,ie,zat_wk,zz,nblk1,ibsize2,ik,meg,zat_l)
           else
              call subspace_rotation_imag(is,ie,kimg_t,zat_wk,zz,nblk1,ibsize2,ik,meg,zat_l)
           endif
           deallocate(zz)
     else
#endif
           if(kimg == 1) then
              call subspace_rotation_real(is,ie,zat_wk,zmat(1,is),nblk1,ibsize2,ik,meg,zat_l)
           else
              call subspace_rotation_imag(is,ie,kimg_t,zat_wk,zmat(1,is),nblk1,ibsize2,ik,meg,zat_l)
           endif
#ifdef _USE_SCALAPACK_
     end if
#endif
        end do PART2

        if(sw_rsb==ON) then
           unimat(:,:) = zmat(:,:)
           do ib1=1,neg
              do ib2=1,neg
                 unimat_h(kimg_t*ib2-1,ib1) =  unimat(kimg_t*ib1-1,ib2)
                 unimat_h(kimg_t*ib2,  ib1) = -unimat(kimg_t*ib1,  ib2)
              enddo
           enddo
        endif
!
!#ifdef _USE_SCALAPACK_
!     if(sw_scalapack == ON) then
!        PART2: do jp = 1,npart2
!           is = isp2(jp)
!           ie = iep2(jp)
!           allocate(zz(meg*kimg_t,is:ie))
!           call put_zmat(lda,occ,zmat,meg,nprow,npcol,block_size,usermap,is,ie,zz)
!           if(kimg == 1) then
!              call subspace_rotation_real(is,ie,zat_wk,zz)
!           else
!              call subspace_rotation_imag(is,ie,zat_wk,zz)
!           endif
!           deallocate(zz)
!        end do PART2
!     else
!#endif
!        is=1; ie=meg
!        if(kimg == 1) then
!           call subspace_rotation_real(is,ie,zat_wk,zmat)
!        else
!           call subspace_rotation_imag(is,ie,zat_wk,zmat)
!        endif
!#ifdef _USE_SCALAPACK_
!     end if
!#endif
! -->
     zat_l(1:np_g1k(ik),1:meg,1:kimg) = zat_wk(1:np_g1k(ik),1:meg,1:kimg)
     deallocate(zat_wk)

!! (zaj_l) by tenchi
     call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,zat_l)            ! zat_l -> zaj_l
!!$     call m_ES_W_transpose_back2(ista_k,iend_k,ik,0,neordr,zaj_l,zat_l)
     if(meg < neg) then
        call m_ES_W_transpose_back2(ista_k,iend_k,ik,meg,neordr,zaj_l,zat_l)  ! zat_l -> zaj_l
     end if
#ifdef SAVE_FFT_TIMES
     if(sw_save_fft == ON) then
        do ib = 1, np_e
           status_saved_phifftr(ib,ik) = OLD
        end do
     end if
#endif

!! (eko_l)
     if(meg < neg) then
        do ib1=meg+1,neg
           if(map_e(ib1) == myrank_e) then        ! MPI
              eko_l(map_z(ib1),ik)=eko_d(neordr(ib1,ik))
           end if
        enddo
     endif
     do ib1 = 1, meg
        if(map_e(ib1) == myrank_e) then         ! MPI
           eko_l(map_z(ib1),ik)=eig(ib1)
        end if
     end do
     if(iprisubmat >= 2) then
        eko2 = sum(eig(1:meg))
        write(nfout,1201) ik,eko1,ekod,eko2

        write(nfout,*) 'eko_l'
        write(nfout,9001) (eko_l(ib1,ik),ib1=1,meg)
     endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

     neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
     nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)  
    deallocate(eko_d)
    deallocate(eig)
    deallocate(zat_l)
    !!$deallocate(zah_l)
    if(sw_scalapack==ON) deallocate(amat)
    deallocate(zmat)

! === DEBUG by tkato 2012/12/11 ================================================
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_non_diagonal,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_diagonal,    1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
! ==============================================================================
    if(.not.non_diagonal_part_is_small(ik)  &
         & .and. sum_abs_non_diagonal/sum_abs_diagonal <= submat_critical_ratio) &
         & non_diagonal_part_is_small(ik) = .true.

    if(iprisubmat >= 2) write(nfout,'(" !submat  non_diagonal/diagonal = ",d20.8)') &
         & sum_abs_non_diagonal/sum_abs_diagonal

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(nrank_e>1) then
         if(myrank_e == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd1, neg_wd2
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd1 = 8
      neg_wd2 = 8
      if(neg_wd1 > ie) neg_wd1 = ie
      if(neg_wd2 > meg) neg_wd2 = meg
      write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') is,neg_wd1,neg_wd2
      if(kimg_t == 1) then
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(ib1*(ib1-1)/2-is*(is-1)/2+ib2),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') ie-neg_wd1+1,ie, neg_wd2
         do ib1=ie-neg_wd1+1, ie
            write(nfout,9001) (w1hw2(ib1*(ib1-1)/2-is*(is-1)/2+ib2),ib2=1,neg_wd2)
         enddo
      else
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)-1),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') ie-neg_wd1+1,ie, neg_wd2
         do ib1=ie-neg_wd1+1, ie
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)-1),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" imag part")')
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)),ib2=1,neg_wd2)
         enddo
      end if
9001  format(1x,8e14.6)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd2)
    end subroutine wd_w1hw2

#ifdef _USE_SCALAPACK_
#endif
! _USE_SCALAPACK_

  end subroutine evolve_WFs_in_subspace
!fj$$#endif

    subroutine subspace_rotation_real(is,ie,zat_wk,zz,ibsize1,ibsize2,ik,meg,zat_l)
!    Revised by T. Yamasaki 1st Sep. 2009
!    modified by T.Kokubo & D.Fukata, Feb. 2010
      integer, intent(in) :: is,ie, ibsize1,ibsize2,ik,meg
      real(kind=DP), intent(inout) :: zat_wk(np_g1k_x,meg,kimg)
      real(kind=DP), intent(in) :: zat_l(np_g1k_x,meg,kimg)
      real(kind=DP), intent(in) :: zz(meg,ibsize1)
      integer :: ibsta, ibend
      integer :: ib1,ib2
#ifdef SUBMAT_DGEMM
      integer :: nblk2
      real(kind=DP) :: alpha, beta
#endif
      integer :: id_sname = -1

      call tstatc0_begin('subspace_roation_real ', id_sname)
#ifdef SUBMAT_DGEMM
      alpha=1.d0; beta=1.d0
      do ibsta=1,meg, ibsize2
         ibend=min(ibsta+ibsize2-1,meg)
         nblk2=ibend-ibsta+1
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,1),np_g1k_x,zz(ibsta,1),meg, &
           &           beta, zat_wk(1,is,1),np_g1k_x)
      enddo
#else
      do ibsta=1,meg, ibsize2
         ibend=min(ibsta+ibsize2-1,meg)
         do ib2=is,ie
            do ib1=ibsta,ibend
               do ii=1,np_g1k(ik)
                  zat_wk(ii,ib2,1)=zat_wk(ii,ib2,1)+zz(ib1,ib2-is+1)*zat_l(ii,ib1,1)
               enddo
            enddo
         enddo
      enddo
#endif
      call tstatc0_end(id_sname)
    end subroutine subspace_rotation_real

    subroutine subspace_rotation_imag(is,ie,kimg_t,zat_wk,zz,ibsize1,ibsize2,ik,meg,zat_l)
!    Revised by T. Yamasaki 1st Sep. 2009
!    modified by T.Kokubo & D.Fukata, Feb. 2010
      integer, intent(in) :: is,ie,kimg_t, ibsize1,ibsize2,ik,meg
      real(kind=DP), intent(inout) :: zat_wk(np_g1k_x,meg,kimg)
      real(kind=DP), intent(in) :: zat_l(np_g1k_x,meg,kimg)
      real(kind=DP), intent(in) :: zz(meg*kimg_t,ibsize1)
      integer :: id_sname = -1
      integer :: ibsta, ibend
      integer :: ib1,ib2,ii
#ifdef SUBMAT_DGEMM
      real(kind=DP) :: alpha, beta
      integer :: nblk2
      real(kind=DP), allocatable, dimension(:,:) :: zzr,zzi
#endif

      call tstatc0_begin('subspace_roation_imag ', id_sname)

      if(k_symmetry(ik) == GAMMA) then
#ifdef SUBMAT_DGEMM
         alpha = 1.d0; beta = 1.d0
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            nblk2=ibend-ibsta+1
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,1),np_g1k_x,zz(ibsta,1),meg, beta &
                 &                         , zat_wk(1,is,1),np_g1k_x)
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,2),np_g1k_x,zz(ibsta,1),meg, beta &
                 &                         , zat_wk(1,is,2),np_g1k_x)
         enddo
         !!if(iprisubmat>=2) write(nfout,'(" !!<<subspace_rotation_imag>> ibsize = ",i8)') ibsize
#else
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            do ib2=is,ie
!CDIR OUTERUNROLL=4
               do ib1=ibsta,ibend
                  dr1=zz(ib1,ib2-is+1)
                  do ii=1,np_g1k(ik)
                     zat_wk(ii,ib2,1)=zat_wk(ii,ib2,1)+dr1*zat_l(ii,ib1,1)
                     zat_wk(ii,ib2,2)=zat_wk(ii,ib2,2)+dr1*zat_l(ii,ib1,2)
                  enddo
               enddo! ib1 loop
            enddo! ib2 loop
         enddo
#endif
         if(iprisubmat >= 2) then
            do ib2 = is, ie
               write(nfout,'(" --- zat_l (input, output) ---, ib =",i5)') ib2
               write(nfout,'(" zat_l(input ) Re : ",5e14.6)') (zat_l(ii,ib2,1),ii=1,5)
               write(nfout,'(" zat_l(input ) Im : ",5e14.6)') (zat_l(ii,ib2,2),ii=1,5)
               write(nfout,'(" zat_l(output) Re : ",5e14.6)') (zat_wk(ii,ib2,1),ii=1,5)
               write(nfout,'(" zat_l(output) Im : ",5e14.6)') (zat_wk(ii,ib2,2),ii=1,5)
            end do
         end if
      else
#ifdef SUBMAT_DGEMM
         allocate(zzr(ibsize2,ibsize1)); allocate(zzi(ibsize2,ibsize1))
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            nblk2=ibend-ibsta+1
            do ib2=is,ie
               do ib1=ibsta, ibend
                  zzr(ib1-ibsta+1,ib2-is+1)=zz(2*ib1-1,ib2-is+1)
                  zzi(ib1-ibsta+1,ib2-is+1)=zz(2*ib1  ,ib2-is+1)
               end do
            end do

            alpha=1.d0; beta=1.d0
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,1),np_g1k_x,zzr,ibsize2 &
                 &     ,beta, zat_wk(1,is,1),np_g1k_x )
            alpha=-1.d0; beta=1.d0
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,2),np_g1k_x,zzi,ibsize2 &
                 &     ,beta, zat_wk(1,is,1),np_g1k_x )
            alpha=1.d0; beta=1.d0
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,2),np_g1k_x,zzr,ibsize2 &
                 &     ,beta, zat_wk(1,is,2),np_g1k_x )
            alpha=1.d0; beta=1.d0
            call dgemm('N','N',np_g1k(ik),ibsize1,nblk2,alpha,zat_l(1,ibsta,1),np_g1k_x,zzi,ibsize2 &
                 &     ,beta, zat_wk(1,is,2),np_g1k_x )
         enddo
         deallocate(zzi,zzr)
#else
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            do ib2=is,ie
!CDIR OUTERUNROLL=4
               do ib1=ibsta,ibend
                  dr1=zz(2*ib1-1,ib2-is+1)
                  di1=zz(2*ib1  ,ib2-is+1)
                  do ii=1,np_g1k(ik)
                     dr2=zat_l(ii,ib1,1)
                     di2=zat_l(ii,ib1,2)
                     zat_wk(ii,ib2,1)=zat_wk(ii,ib2,1)+dr1*dr2-di1*di2
                     zat_wk(ii,ib2,2)=zat_wk(ii,ib2,2)+dr1*di2+di1*dr2
                  enddo
              enddo! ib1 loop
            enddo! ib2 loop
         enddo
#endif
       end if
       call tstatc0_end(id_sname)
    end subroutine subspace_rotation_imag

  subroutine set_col_partition_G(kimg_t,meg,ibsize)
    integer, intent(in) :: kimg_t,meg
    integer, intent(inout) :: ibsize
!!$integer,parameter :: maxmatsize = 67108864 ! 512MB
    integer :: maxmatsize
    integer :: trisize, size
    integer :: rowsize, block
    integer :: i,is,ie
    integer :: maxsize
! <-- T.Kokubo & D.Fukata, Feb. 2010
#ifdef SUBMAT_DGEMM
    integer :: ibsize_tmp, modnum
    integer,allocatable  :: tmpmem(:)
#endif
! -->

    integer :: id_sname = -1
    call tstatc0_begin('set_col_partition_G ', id_sname)

    maxmatsize = msize_submat * 1024 * 1024 / 8 ! bytes

! <-- T.Kokubo & D.Fukata, Feb. 2010
#ifdef SUBMAT_DGEMM
    ibsize_tmp = ibsize
    npart = meg/ibsize_tmp
    modnum=mod(meg,ibsize_tmp)
    if( modnum.ne.0 ) npart = npart + 1
    if(iprisubmat >= 2) write(nfout,*)' !! SUBMAT :: ibsize=', ibsize, npart

    if(allocated(isp)) deallocate(isp)
    if(allocated(iep)) deallocate(iep)
    if(allocated(tmpmem)) deallocate(tmpmem)
    do
       allocate( isp(npart)   ) ; isp=1
       allocate( iep(npart)   ) ; iep=1
       allocate( tmpmem(npart)) ; tmpmem=0
       do i=1,npart
          is = ibsize_tmp*(i-1)+1           ; isp(i)=is
          ie = min(isp(i)+ibsize_tmp-1,meg) ; iep(i)=ie
#ifdef SX
          tmpmem(i) = kimg*(is*(ie-is+1)+(ie-is+1)*(ie-is)/2) +  2*ie*(ie-is+1)
          !           <----------      w1hw2      ----------> <- w1hw2r,w1hw2i ->
#else
          tmpmem(i) = kimg*(is*(ie-is+1)+(ie-is+1)*(ie-is)/2) + 2*ibsize_tmp*(ie-is+1)
          !           <----------      w1hw2      ----------> <--- w1hw2r, w1hw2i --->
#endif
       enddo
       maxsize=maxval(tmpmem)
       if( maxsize <= maxmatsize ) exit

       ibsize_tmp = ibsize_tmp - 1
       npart = meg/ibsize_tmp
       modnum=mod(meg,ibsize_tmp)
       if( modnum.ne.0 ) npart = npart + 1
       deallocate(isp,iep,tmpmem)
    enddo
    deallocate(tmpmem)
    if( ibsize .ne. ibsize_tmp ) then
       write(nfout,*)' !! SUBMAT_DGEMM : ibsize is changed', ibsize, ' --> ', ibsize_tmp
       ibsize = ibsize_tmp
    endif
#else
    trisize = meg*(meg+1)/2*kimg_t
    if(trisize <= maxmatsize.or.sw_scalapack==OFF) then
       npart = 1
       allocate(isp(npart))
       allocate(iep(npart))
       isp(npart) = 1
       iep(npart) = meg
       maxsize  = trisize
    else
       npart = trisize/maxmatsize
       allocate(isp(npart))
       allocate(iep(npart))
       maxsize  = trisize/npart
       ie = 0 
       do i=1,npart
          is = ie+1
          ie = is
          size = 0
          do while(size*kimg_t <= maxsize)
             ie = ie+1
             size = is*(ie-is+1)+(ie-is+2)*(ie-is+1)/2
          end do
          isp(i) = is
          iep(i) = ie
          if(ie>meg) then
             npart = i
             exit
          end if
       end do
       iep(npart) = meg
    end if
!!$#endif
#endif

#ifdef SUBMAT_DGEMM
    if(allocated(isp2)) deallocate(isp2)
    if(allocated(iep2)) deallocate(iep2)
    npart2 = npart
    allocate(isp2(npart2))
    allocate(iep2(npart2))
    isp2 = isp
    iep2 = iep
#else
    if(allocated(isp2)) deallocate(isp2)
    if(allocated(iep2)) deallocate(iep2)
    rowsize = meg*kimg_t
    if(rowsize*meg<=maxmatsize.or.sw_scalapack==OFF) then
       npart2 = 1
       allocate(isp2(npart2))
       allocate(iep2(npart2))
       isp2(npart2) = 1
       iep2(npart2) = meg
       block = meg
    else
       npart2 = (rowsize*meg)/maxmatsize
       if(npart2 > meg) npart2 = meg
       block = meg/npart2
       allocate(isp2(npart2))
       allocate(iep2(npart2))
       is = 0
       ie = 0
       do i=1,npart2
          is = ie+1 
          ie = is+block-1
          if(i<=mod(meg,npart2)) ie=ie+1
          isp2(i) = is
          iep2(i) = ie
       end do
       iep2(npart2) = meg
    end if
#endif
! -->

    if(printable.and.(sw_scalapack==ON.or.iprisubmat>=2)) then
       write(nfout,*) '== col partition == '
       write(nfout,*) 'target memory(MB)=',msize_submat
       write(nfout,*) 'npart=',npart
       write(nfout,*) 'maxsize=',maxsize
       write(nfout,*) 'memory(MB)=',maxsize*8/1024/1024
       write(nfout,*) 'n, isp, iep, size'
       do i=1,npart
          is = isp(i)
          ie = iep(i)
          size = is*(ie-is+1)+(ie-is+2)*(ie-is+1)/2
          write(nfout,'(4i7)') i, is, ie, size
       end do
       write(nfout,*) 'npart2=',npart2
#ifndef SUBMAT_DGEMM
       write(nfout,*) 'block=',block
       write(nfout,*) 'memory(MB)=',block*rowsize*8/1024/1024
#endif
       write(nfout,*) 'n, isp2, iep2, block'
       do i=1,npart2
          write(nfout,'(4i7)') i, isp2(i), iep2(i), iep2(i)-isp2(i)+1
       end do
    else if(iprisubmat >=2) then
       write(nfout,'(" !target memory(MB) =",i10)') msize_submat
       write(nfout,'(" npart, npart2 = ",2i8)') npart, npart2
       write(nfout,'(" -- isp, iep --")')
       do i = 1, npart
          write(nfout,'(1x,i3," isp(",i3,"), iep(",i3,") = ",2i8)') i,i,i,isp(i),iep(i)
       end do
       write(nfout,'(" -- isp2, iep2 --")')
       do i = 1, npart
          write(nfout,'(1x,i3," isp2(",i3,"), iep2(",i3,") = ",2i8)') i,i,i,isp2(i),iep2(i)
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine set_col_partition_G


#ifdef _USE_SCALAPACK_
#endif


! ======================================= added by K. Tagami ================= 11.0
  subroutine evolve_WFs_in_subspace_noncl( ik, meg, damp, ekin, afft_kt, bfft_kt, &
	&                                  vnlph_noncl )
!
! Revised by T. Yamasaki, September 2009 : SUBMAT_DGEMM
!
    integer, intent(in) :: ik, meg
    real(kind=DP), intent(in)  :: damp,ekin(kg1)
    real(kind=DP), intent(inout)  :: afft_kt(nfft,ndim_chgpot)
    real(kind=DP), intent(out) :: bfft_kt(nfft,ndim_spinor)
    real(kind=DP), intent(in)  :: vnlph_noncl(kg1,np_e,kimg,ndim_spinor)

! (allocatable variables)
    real(kind=DP), allocatable,dimension(:) ::     eig
    real(kind=DP), allocatable,dimension(:) ::     eko_d
    real(kind=DP), allocatable,dimension(:) ::   w1hw2
    real(kind=DP), allocatable,dimension(:,:) ::   zz

    real(kind=DP), allocatable,dimension(:,:,:,:) :: zat_l_noncl
    real(kind=DP), allocatable,dimension(:,:,:,:) :: zah_l_noncl

    real(kind=DP), allocatable,dimension(:,:,:,:) :: zat_wk_noncl

    real(kind=DP), allocatable :: amat(:,:), zmat(:,:)
    integer, save :: lwork,lrwork,liwork,lda,occ

#ifdef _USE_SCALAPACK_
    integer, save :: lwork1,lrwork1,liwork1
    integer, save :: lwork2,lrwork2,liwork2
#endif

#ifdef SINGLE_CONTEXT
    integer, save :: ictxt, myrow, mycol
#else
    integer, save :: myrow, mycol, tmpctxt
    integer, allocatable, save :: ictxt(:) ! d(0:nrank_k-1)
#endif
    integer, dimension(9), save :: desca,descz
#ifdef SINGLE_CONTEXT
    integer, allocatable, save :: usermap(:,:)
#else
    integer, allocatable, save :: usermap(:,:,:) ! d(nprow,npcol,0:nrank_k-1)
#endif
!!$    integer, save :: npart,npart2
!!$    integer, allocatable, save :: isp(:),iep(:)
!!$    integer, allocatable, save :: isp2(:),iep2(:)
!    logical, save :: first = .true.
    integer :: is,ie,m,jp
    integer :: msize

    integer       :: ib1,ib2,ib1to,i1,ii,ri,ib, i, kimg_t, ig1
    real(kind=DP) :: denom, eko1, eko2, ekod
    real(kind=DP) :: dr1,dr2,di1,di2, dd
    real(kind=DP) :: sum_sq_diagonal, sum_sq_non_diagonal &
         & , sum_abs_diagonal, sum_abs_non_diagonal

    integer :: k1, ispinor
    real(kind=DP) :: dd_max
    
    integer :: id_sname = -1, id_sname2 = -1, ipri0

#ifdef SUBMAT_DGEMM
    real(kind=DP),allocatable,dimension(:,:) :: w1hw2r,w1hw2i
    real(kind=DP) :: alpha, beta
#endif
! <-- T.Kokubo & D.Fukata, Feb. 2010
    integer :: ibsta, ibend, nblk1, nblk2, ibsize, ibsize2

    if(nblocksize_submat_is_given) then
      ibsize = nblocksize_submat
    else
      ibsize = nb_submat_default
    endif
! -->
    call tstatc0_begin('evolve_WFs_in_subspace_noncl ', id_sname,1)

    denom = 1.d0/product(fft_box_size_WF(1:3,1))

! (allocate)  zat_l will be divided by G-index
    if(k_symmetry(ik) == GAMMA) then
       kimg_t = 1
    else
       kimg_t = kimg
    end if

    allocate(eko_d(neg));     eko_d = 0.d0
    allocate(eig(meg)); eig=0.d0
#ifdef _ODD_BOUNDARY_
    if(mod(np_g1k(ik),2) == 0) then
       np_g1k_x = np_g1k(ik) + 1
    else
       np_g1k_x = np_g1k(ik)
    end if
#else
    np_g1k_x = np_g1k(ik)
#endif
    allocate( zat_l_noncl(np_g1k_x,neg,kimg,ndim_spinor))  
    zat_l_noncl = 0.0d0


    do ib1 = 1, neg
       if ( map_e(ib1) == myrank_e) eko_d(ib1) = eko_l(map_z(ib1),ik)  ! MPI
    end do

    call mpi_allreduce(MPI_IN_PLACE, eko_d,neg,mpi_double_precision,mpi_sum, mpi_k_world(myrank_k),ierr)

    eko1 = sum(eko_d(1:neg))

!( tenchi ) (zat_l <- zaj_l)
! --> T. Yamasaki, 28th Aug. 2009
!!$    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zat_l)


    Do is=1, ndim_spinor
      call m_ES_W_transpose_r(.true., ista_k, iend_k, ik+is-1, zaj_l, zat_l_noncl(:,:,:,is) )
    End do

! (zaj_l <- H |phi> )
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(bfft,ib1to,ib,ii,i1,dr1,di1,dr2)
!CDIR CONCUR(BY=1)
#endif
    do ib1 = ista_e, iend_e, istep_e     ! MPI
       ib1to=nrvf_ordr(ib1,ik)
       if(ib1to>meg) cycle

       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik+is-1, ib1, bfft_kt(:,is) )   !(swffft)
       End do
       call m_FFT_Vlocal_W_noncl( afft_kt, bfft_kt, ndim_chgpot, ndim_spinor ) 
                                                 ! (afft, bfft)-> (bfft)
       Do is=1, ndim_spinor
         call m_FFT_WF( ELECTRON, nfout, bfft_kt(:,is), DIRECT, ON )
       End do

       ib = map_z(ib1)                 ! MPI
       if ( kimg == 1 ) then
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do ii=1,iba(ik)
               i1  = igf(nbase(ii,ik))
               dr1 = zaj_l( ii, ib, k1, 1 )
               dr2 = bfft_kt(i1,is) *denom
               zaj_l( ii, ib, k1, 1 ) = ekin(ii)*dr1 &
	&                              +vnlph_noncl( ii, ib, 1, is ) +dr2
            enddo
          End do
       else
          Do is=1, ndim_spinor
            k1 = ik + is -1
            do ii=1,iba(ik)
               i1  = igf(nbase(ii,ik))
               dr1  = zaj_l( ii, ib, k1, 1 )
               di1  = zaj_l( ii, ib, k1, 2 ) 
               zaj_l( ii, ib, k1, 1 ) = ekin(ii)*dr1 +bfft_kt( 2*i1-1,is )*denom &
	&                              +vnlph_noncl( ii, ib, 1, is )
               zaj_l( ii, ib, k1, 2 ) = ekin(ii)*di1 +bfft_kt( 2*i1,  is )*denom &
	&                              +vnlph_noncl( ii, ib, 2, is )
            enddo
          End do
       end if
#ifdef SAVE_FFT_TIMES
       if(sw_save_fft == ON) then
          do is =1,ndim_spinor
             k1=ik+is-1
             status_saved_phifftr(ib,k1) = OLD
          end do
       end if
#endif
    end do
! ------------------ok  -


!( tenchi ) (zah_l <- zaj_l)
    allocate( zah_l_noncl( np_g1k_x, neg, kimg, ndim_spinor ) )
    zah_l_noncl = 0.0d0     

! --> T. Yamasaki 28th Aug. 009
!!$    call m_ES_W_transpose(ista_k,iend_k,ik,zaj_l,zah_l)

    Do is=1, ndim_spinor
      call m_ES_W_transpose_r(.true., ista_k, iend_k, ik+is-1, zaj_l, zah_l_noncl(:,:,:,is) )
    End do

! <--

! (make matrix elements )
#ifdef _USE_SCALAPACK_
    if(sw_scalapack == ON) then
       if(submat_uncalled) then
          call set_nprow_npcol(nprow,npcol)
#ifdef SINGLE_CONTEXT
          if(allocated(usermap)) deallocate(usermap)
          allocate(usermap(nprow,npcol))
#else
          if(allocated(ictxt)) deallocate(ictxt)
          if(allocated(usermap)) deallocate(usermap)
          allocate(ictxt(0:nrank_k-1))
          allocate(usermap(nprow,npcol,0:nrank_k-1))
#endif
!         call scalapack_setup(meg,lwork,lrwork,liwork,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#ifdef SINGLE_CONTEXT
          call scalapack_setup(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
#else
          call scalapack_setup(meg,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt(myrank_k),&
          & myrow,mycol,desca,descz,usermap)
#endif
! ===== We need more work area!!! ==============================================
          lwork1  = 10*lwork1
          lrwork1 = 10*lrwork1
          liwork1 = 10*liwork1
          lwork2  = 10*lwork2
          lrwork2 = 10*lrwork2
          liwork2 = 10*liwork2
! ==============================================================================
       end if
       allocate(amat(lda*kimg_t,occ))
       allocate(zmat(lda*kimg_t,occ))
    else
       allocate(zmat(meg*kimg_t,meg))
    end if
#else
    allocate(zmat(meg*kimg_t,meg))
    zmat=0.0d0
#endif
    if(submat_uncalled) then
!!$       call set_col_partition ! -> npart,isp,iep, npart2, isp2, iep2
       call set_col_partition_G(kimg_t,meg,ibsize) ! -> npart,isp,iep, npart2, isp2, iep2
       submat_uncalled = .false.
    end if

    call tstatc0_begin('evolve_WFs_in_subspace(PART1) ', id_sname2)
!!$    if(iprisubmat>=2) then
!!$       write(nfout,'(" --- neordr ---")')
!!$       write(nfout,'(" ik = ",i8)') ik
!!$       write(nfout,'(10i8)') (neordr(ib1,ik),ib1=1, neg)
!!$       write(nfout,'(" --- nrvf_ordr ---")')
!!$       write(nfout,'(" ik = ",i8)') ik
!!$       write(nfout,'(10i8)') (nrvf_ordr(ib1,ik),ib1=1, neg)
!!$    end if

    ekod = 0.d0
    sum_abs_diagonal = 0.d0
    sum_sq_diagonal = 0.d0
    sum_sq_non_diagonal = 0.d0
    sum_abs_non_diagonal = 0.d0

! ------------------------------------ part 1 -----------
    PART1: do jp = 1,npart
       is = isp(jp)
       ie = iep(jp)
       msize = is*(ie-is+1) + (ie-is+1)*(ie-is)/2
       allocate(w1hw2(msize*kimg_t))
       w1hw2 = 0.d0
       if(iprisubmat>=2) then
          write(nfout,'(" jp, is, ie = ",3i8)') jp, is, ie
       end if

#ifdef SUBMAT_DGEMM
! <-- T.Kokubo & D.Fukata Feb. 2010
       nblk1 = ie-is+1
#ifdef SX
       ibsize2 = min(ie,meg)
#else
       ibsize2 = ibsize
#endif

       allocate(w1hw2r(ibsize2,nblk1)); w1hw2r = 0.d0
       if(kimg==2 .and. k_symmetry(ik) /= GAMMA) then
          allocate(w1hw2i(ibsize2,nblk1)); w1hw2i = 0.d0
       end if

       do ibsta=1,min(ie,meg), ibsize2
          ibend=min( ibsta+ibsize2-1, min(ie,meg) )
          nblk2=ibend-ibsta+1

          w1hw2r = 0.d0
          if ( kimg==2 .and. k_symmetry(ik) /= GAMMA ) w1hw2i = 0.d0

          if ( kimg==1 ) then
             Do ispinor=1, ndim_spinor
               call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0,&
	&                  zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x,  &
                  &        zah_l_noncl(1,is,1,ispinor),    np_g1k_x, &
                  &        1.d0, w1hw2r, ibsize2 )
             End do 

             do ib1 = max(is,ibsta), min(ie,meg)
                do ib2 = ibsta,min(ibend,ib1) 
                   m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                   w1hw2(m) = w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                end do
             end do
          else
             if ( k_symmetry(ik) == GAMMA ) then
                ig1=1
                if ( myrank_e==0 ) ig1=2

                Do ispinor=1, ndim_spinor
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                      zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
        &                      zah_l_noncl(1,is,1,ispinor),    np_g1k_x, &
	&                      1.d0, w1hw2r, ibsize2 )
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                      zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
        &                      zah_l_noncl(1,is,2,ispinor),    np_g1k_x, &
	&                      1.d0, w1hw2r, ibsize2 )
                End do 

                w1hw2r = w1hw2r*2.d0
                if ( myrank_e == 0 ) then
                   do ib1 = max(is,ibsta), min(ie,meg)
                      do ib2 = ibsta,min(ibend,ib1)
                         Do ispinor=1, ndim_spinor
                            w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1) &
	&                   =  w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1) &
        &                     - 2.d0 *zah_l_noncl(1,ib1,2,ispinor) &
	&                            *zat_l_noncl(1,ib2,2,ispinor) &
        &                     -       zah_l_noncl(1,ib1,1,ispinor) &
	&                            *zat_l_noncl(1,ib2,1,ispinor)
                         End do
                      end do
                   end do
                end if

                do ib1 = max(is,ibsta), min(ie,meg)
                   do ib2 = ibsta,min(ibend,ib1)
                      m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                      w1hw2(m)=w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                   end do
                end do
             else
                Do ispinor=1, ndim_spinor
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                     zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
        &                     zah_l_noncl(1,is,1,ispinor),    np_g1k_x, &
	&                     1.d0, w1hw2r, ibsize2 )
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                     zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
        &                     zah_l_noncl(1,is,2,ispinor),    np_g1k_x, &
	&                     1.d0, w1hw2r, ibsize2 )
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), 1.d0, &
	&                     zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
        &                     zah_l_noncl(1,is,1,ispinor),    np_g1k_x, &
	&                     1.d0, w1hw2i, ibsize2 )
                  call dgemm( 'T', 'N', nblk2, nblk1, np_g1k(ik), -1.d0, &
	&                     zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
        &                     zah_l_noncl(1,is,2,ispinor),    np_g1k_x, &
	&                     1.d0, w1hw2i, ibsize2 )
                End do

                do ib1 = max(is,ibsta), min(ie,meg)
                   do ib2 = ibsta,min(ibend,ib1)
                      m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                      w1hw2(2*m-1) = w1hw2r(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                      w1hw2(2*m  ) = w1hw2i(ib2-ibsta+1, ib1-max(is,ibsta)+1)
                   end do
                end do
             end if
          end if
       enddo

       if (kimg==2 .and. k_symmetry(ik) /= GAMMA) deallocate(w1hw2i)
       deallocate(w1hw2r)

#else
! parallel loop
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(ib2,ii,dr1,dr2,di1,di2,m)
!CDIR CONCUR(BY=1)
#endif
! --> T. Yamasaki 28th Aug. 2009
!   ib1to --> ib1,  instead of ib1to = neordr(ib1,ik) 
!   ib2to --> ib2
       do ib1 = is, ie
          if(ib1>meg) cycle
          do ib2 = 1, ib1
             m = ib1*(ib1-1)/2-is*(is-1)/2+ib2

             if (kimg == 1) then
	        Do ispinor=1, ndim_spinor
                  do ii = 1, np_g1k(ik)              ! MPI
                     dr1 = zah_l_noncl( ii, ib1, 1, ispinor )
                     dr2 = zat_l_noncl( ii, ib2, 1, ispinor )
                     w1hw2(m) = w1hw2(m) + dr1*dr2
                  end do
                End do
             else
                if (k_symmetry(ik) == GAMMA) then
                   dd = 0.d0
                   ig1 = 1
	           if(myrank_e == 0) ig1 = 2

                   Do ispinor=1, ndim_spinor
                     do ii = ig1, np_g1k(ik)            ! MPI
                        dr1 = zah_l_noncl( ii, ib1, 1, ispinor )
                        di1 = zah_l_noncl( ii, ib1, 2, ispinor )
                        dr2 = zat_l_noncl( ii, ib2, 1, ispinor )
                        di2 = zat_l_noncl( ii, ib2, 2, ispinor )
                        dd = dd + ( dr1*dr2 +di1*di2 )*2.d0
                     end do
                   End do

                   if ( myrank_e == 0 ) then
	              Do ispinor=1, ndim_spinor
                         dd = dd + zah_l_noncl(1,ib1,1,ispinor) &
	&                         *zat_l_noncl(1,ib2,1,ispinor)
                      End do
                   endif
                   w1hw2(m)=dd
                else
	           Do ispinor=1, ndim_spinor
                     do ii = 1, np_g1k(ik)             ! MPI
                        dr1 = zah_l_noncl( ii, ib1, 1, ispinor )
                        di1 = zah_l_noncl( ii, ib1, 2, ispinor )
                        dr2 = zat_l_noncl( ii, ib2, 1, ispinor )
                        di2 = zat_l_noncl( ii, ib2, 2, ispinor )
                        w1hw2(2*m-1)=w1hw2(2*m-1) +dr1*dr2 +di1*di2
                        w1hw2(2*m  )=w1hw2(2*m  ) +dr1*di2 -di1*dr2
                     end do
                   End do
                end if
             end if
          end do
       end do
#endif

       if (iprisubmat >= 2) call wd_w1hw2(" -- just after making w1hw2 --")

!! (off-diagonal matrix elements will be damped.)
       if (kimg_t == 1) then
          do ib1=max(2,is),ie
             do ib2=1,ib1-1
                m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                sum_sq_non_diagonal = sum_sq_non_diagonal + w1hw2(m)*w1hw2(m)
                sum_abs_non_diagonal = sum_abs_non_diagonal + abs(w1hw2(m))
                w1hw2(m) = damp*w1hw2(m)
             enddo
          enddo
          do ib = is, ie
             m = ib*(ib-1)/2-is*(is-1)/2+ib
             sum_sq_diagonal = sum_sq_diagonal + w1hw2(m)**2
             sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(m))
             ekod = ekod + w1hw2(m)
          end do
       else
          do ib1=max(2,is),ie
             do ib2=1,ib1-1
                m = ib1*(ib1-1)/2-is*(is-1)/2+ib2
                dd = w1hw2(2*m-1)*w1hw2(2*m-1) + w1hw2(2*m)*w1hw2(2*m)
                sum_sq_non_diagonal = sum_sq_non_diagonal + dd
                if(dd >= SmallestPositiveNumber) sum_abs_non_diagonal = sum_abs_non_diagonal + sqrt(dd)
                w1hw2(2*m-1) = damp*w1hw2(2*m-1)
                w1hw2(2*m  ) = damp*w1hw2(2*m  )

             enddo
          enddo
          do ib = is, ie
             m = ib*(ib-1)/2-is*(is-1)/2+ib
             sum_sq_diagonal = sum_sq_diagonal + w1hw2(2*m-1)**2
             sum_abs_diagonal = sum_abs_diagonal + abs(w1hw2(2*m-1))
             ekod = ekod + w1hw2(2*m-1)
          end do
       endif
       if(iprisubmat >= 2) call wd_w1hw2(" -- after damping --")

#ifdef _USE_SCALAPACK_
       if (sw_scalapack==ON) then
          call set_amat(lda,kimg_t,occ,amat,meg,nprow,npcol,block_size,usermap,is,ie,w1hw2)
       else
#endif
          call set_hmat(kimg_t,meg,is,ie,w1hw2,zmat)
#ifdef _USE_SCALAPACK_
       end if
#endif
       deallocate(w1hw2)
    end do PART1

    call tstatc0_end(id_sname2)

    deallocate(zah_l_noncl)

    sum_abs_diagonal = sum_abs_diagonal/meg
    sum_abs_non_diagonal = sum_abs_non_diagonal/(meg*(meg-1)/2)

    if(iprisubmat >= 2) then
       write(nfout,*) 'neordr for ik = ',ik
       write(nfout,9002) (neordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'nrvf_ordr for ik = ',ik
       write(nfout,9002) (nrvf_ordr(ib1,ik),ib1=1,neg)
       write(nfout,*) 'eig'
! ===================== ktDEBUG
!       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,neg)
       write(nfout,'(5x,10f8.4)') (eko_l(ib1,ik),ib1=1,np_e)
! =====================
    endif
9002 format(5x,10i8)


! ==============================================================

!! (Diagonalization )  !!
#ifdef _USE_SCALAPACK_
     if(sw_scalapack == ON) then
        if(kimg_t == 1) then
!          call pdsyev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork,liwork)
           call pdsyev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork1,liwork1)
        else
!          call pzheev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork,lrwork,liwork)
           call pzheev_driver(meg,eig,desca,descz,lda,occ,amat,zmat,lwork2,lrwork2,liwork2)
        endif
     else
#endif
        if(kimg_t == 1) then
           call dsyev_driver(meg,eig,zmat)
        else
           call zheev_driver(meg,eig,zmat)
        endif
#ifdef _USE_SCALAPACK_
     endif
#endif
!!$     if(kimg_t == 1) then
!!$       call dsyev_driver(meg,eig,zmat)
!!$     else
!!$       call zheev_driver(meg,eig,zmat)
!!$     endif
!!$#endif

     if(iprisubmat >= 2) then
        write(nfout,*) 'eko_d for ik = ',ik
        write(nfout,9001) (eko_d(ib),ib=1,meg)
        write(nfout,*) 'eig for ik = ',ik
        write(nfout,9001) (eig(ib),ib=1,meg)
        !!$call wd_w1hw2(" -- after diagonalization --")
        !!$call wd_zmat(" -- after diagonalization --")
!sum eko
     end if

     call get_ipri0(iprisubmat,ipri0)
     if(ipri0>=2) then
        dr1=0.d0;dr2=0.d0
        do ib1=1,meg
           ib1to = neordr(ib1,ik)
           if(map_e(ib1to) == myrank_e) dr1=dr1+eko_l(map_z(ib1to),ik)
           dr2=dr2+eig(ib1)
        enddo
        call mpi_allreduce(MPI_IN_PLACE, dr1,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
     end if

     if(iprisubmat>=2) then
        write(nfout,*) ' sum of eko_l & eig =',dr1,dr2
        write(nfout,'(" sum_sq_diagonal , sum_sq_non_diagonal  = ",2d20.12)') sum_sq_diagonal, sum_sq_non_diagonal
        write(nfout,'(" sum_abs_diagonal ,sum_abs_non_diagonal = ",2d20.12)') sum_abs_diagonal, sum_abs_non_diagonal
     end if

! ------

!! (subspace rotation) !!
     allocate( zat_wk_noncl( np_g1k_x, meg, kimg, ndim_spinor ))
     zat_wk_noncl = 0.d0
! <-- T.Kokubo & D.Fukata, Feb. 2010
        PART2: do jp = 1,npart2
           is = isp2(jp)
           ie = iep2(jp)
           nblk1 = ie-is+1
#ifdef SX
           ibsize2 = meg
#else
           ibsize2 = ibsize
#endif
#ifdef _USE_SCALAPACK_
     if (sw_scalapack == ON) then
           allocate(zz(meg*kimg_t,nblk1))
           call put_zmat(kimg_t,lda,occ,zmat,meg,nprow,npcol,block_size,usermap,is,ie,zz)

           if ( kimg == 1) then
              call subspace_rotation_real_noncl( is, ie, zat_wk_noncl, zz, &
	&                                        nblk1, ibsize2 )
           else
              call subspace_rotation_imag_noncl( is, ie, zat_wk_noncl, zz, &
	&                                        nblk1, ibsize2 )
           endif
           deallocate(zz)
     else
#endif
           if (kimg == 1) then
              call subspace_rotation_real_noncl( is, ie, zat_wk_noncl, zmat(1,is),&
	&                                        nblk1, ibsize2 )
           else
              call subspace_rotation_imag_noncl( is, ie, zat_wk_noncl, zmat(1,is),&
	&                                        nblk1, ibsize2 )
           endif
#ifdef _USE_SCALAPACK_
     end if
#endif
        end do PART2
!
!#ifdef _USE_SCALAPACK_
!     if(sw_scalapack == ON) then
!        PART2: do jp = 1,npart2
!           is = isp2(jp)
!           ie = iep2(jp)
!           allocate(zz(meg*kimg_t,is:ie))
!           call put_zmat(lda,occ,zmat,meg,nprow,npcol,block_size,usermap,is,ie,zz)
!           if(kimg == 1) then
!              call subspace_rotation_real(is,ie,zat_wk,zz)
!           else
!              call subspace_rotation_imag(is,ie,zat_wk,zz)
!           endif
!           deallocate(zz)
!        end do PART2
!     else
!#endif
!        is=1; ie=meg
!        if(kimg == 1) then
!           call subspace_rotation_real(is,ie,zat_wk,zmat)
!        else
!           call subspace_rotation_imag(is,ie,zat_wk,zmat)
!        endif
!#ifdef _USE_SCALAPACK_
!     end if
!#endif
! -->

     Do ispinor=1, ndim_spinor
       zat_l_noncl(1:np_g1k(ik),1:meg,1:kimg,ispinor) &
	&  = zat_wk_noncl(1:np_g1k(ik),1:meg,1:kimg,ispinor)
     End do
     deallocate(zat_wk_noncl)

!! (zaj_l) by tenchi

     Do ispinor=1, ndim_spinor
       call m_ES_W_transpose_back_r(.false., ista_k, iend_k, ik+ispinor-1, &
	&                          zaj_l, zat_l_noncl(:,:,:,ispinor) )
                                                     ! zat_l -> zaj_l
     End do 


     if (meg < neg) then
        Do ispinor=1, ndim_spinor
           call m_ES_W_transpose_back2( ista_k, iend_k, ik +ispinor -1, &
	&                               meg, neordr, zaj_l, &
	&                               zat_l_noncl(:,:,:,ispinor)  )  ! zat_l -> zaj_l
        End do
     end if

#ifdef SAVE_FFT_TIMES
     if(sw_save_fft == ON) then
        Do ispinor=1, ndim_spinor
           do ib = 1, np_e
              status_saved_phifftr(ib,ik+ispinor-1) = OLD
           end do
        end Do
     end if
#endif

!! (eko_l)
     if(meg < neg) then
        do ib1=meg+1,neg
           if(map_e(ib1) == myrank_e) then        ! MPI
              eko_l(map_z(ib1),ik)=eko_d(neordr(ib1,ik))
           end if
        enddo
     endif
     do ib1 = 1, meg
        if(map_e(ib1) == myrank_e) then         ! MPI
           eko_l(map_z(ib1),ik)=eig(ib1)
        end if
     end do
     if(iprisubmat >= 2) then
        eko2 = sum(eig(1:meg))
        write(nfout,1201) ik,eko1,ekod,eko2

        write(nfout,*) 'eko_l'
        write(nfout,9001) (eko_l(ib1,ik),ib1=1,meg)
     endif
1201 format(' %% for ik = ',i4,4x,' eko1&ekod&eko2 = ',3f14.7)
9001 format(5x,6f12.5)
!! (neordr & nrvf_ordr)

     neordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)
     nrvf_ordr(1:neg,ik) = (/(ib1,ib1=1,neg)/)

! (deallocate)  
    deallocate(eko_d)
    deallocate(eig)
    deallocate(zat_l_noncl)

    !!$deallocate(zah_l)
    if (sw_scalapack==ON) deallocate(amat)
    deallocate(zmat)

! === DEBUG by tkato 2012/12/11 ================================================
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_non_diagonal,1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
    call mpi_allreduce(MPI_IN_PLACE,sum_abs_diagonal,    1,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
! ==============================================================================

    if(.not.non_diagonal_part_is_small(ik)  &
         & .and. sum_abs_non_diagonal/sum_abs_diagonal <= submat_critical_ratio) &
         & non_diagonal_part_is_small(ik) = .true.

    if(iprisubmat >= 2) write(nfout,'(" !submat  non_diagonal/diagonal = ",d20.8)') &
         & sum_abs_non_diagonal/sum_abs_diagonal

    call tstatc0_end(id_sname)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(nrank_e>1) then
         if(myrank_e == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_k_world(myrank_k),ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

    subroutine wd_w1hw2(somecomment)
      character(len=*), intent(in) :: somecomment
      integer :: ib1, ib2, neg_wd1, neg_wd2
      write(nfout,'(a35)') somecomment
      write(nfout,*) 'w1hw2 for ik = ',ik
      neg_wd1 = 8
      neg_wd2 = 8
      if(neg_wd1 > ie) neg_wd1 = ie
      if(neg_wd2 > meg) neg_wd2 = meg
      write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') is,neg_wd1,neg_wd2
      if(kimg_t == 1) then
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(ib1*(ib1-1)/2-is*(is-1)/2+ib2),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') ie-neg_wd1+1,ie, neg_wd2
         do ib1=ie-neg_wd1+1, ie
            write(nfout,9001) (w1hw2(ib1*(ib1-1)/2-is*(is-1)/2+ib2),ib2=1,neg_wd2)
         enddo
      else
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)-1),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" real part (",i8,":",i8,",1:",i8,")")') ie-neg_wd1+1,ie, neg_wd2
         do ib1=ie-neg_wd1+1, ie
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)-1),ib2=1,neg_wd2)
         enddo
         write(nfout,'(" imag part")')
         do ib1=is,neg_wd1
            write(nfout,9001) (w1hw2(2*(ib1*(ib1-1)/2-is*(is-1)/2+ib2)),ib2=1,neg_wd2)
         enddo
      end if
9001  format(1x,8e14.6)
      write(nfout,*) 'eko_l for ik = ',ik
      write(nfout,9001) (eko_d(neordr(ib1,ik)),ib1=1,neg_wd2)
    end subroutine wd_w1hw2


    subroutine subspace_rotation_real_noncl( is, ie, zat_wk_noncl, zz, ibsize1, ibsize2 )

      integer, intent(in) :: is,ie, ibsize1,ibsize2
      real(kind=DP), intent(inout) :: zat_wk_noncl( np_g1k_x, meg, kimg, ndim_spinor )
      real(kind=DP), intent(in) :: zz(meg,ibsize1)
      integer :: ibsta, ibend
#ifdef SUBMAT_DGEMM
      integer :: nblk2
      real(kind=DP) :: alpha, beta
#endif
      integer :: id_sname = -1

      call tstatc0_begin('subspace_roation_real_noncl ', id_sname)

#ifdef SUBMAT_DGEMM
      alpha=1.d0; beta=1.d0
      do ibsta=1,meg, ibsize2
         ibend=min(ibsta+ibsize2-1,meg)
         nblk2=ibend-ibsta+1

         Do ispinor=1, ndim_spinor 
            call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&               zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
	&               zz(ibsta,1), meg, beta, &
	&               zat_wk_noncl(1,is,1,ispinor), np_g1k_x )
         End do
      enddo
#else
      do ibsta=1,meg, ibsize2
         ibend=min(ibsta+ibsize2-1,meg)
         do ib2=is,ie
            do ib1=ibsta,ibend
               Do ispinor=1, ndim_spinor
                 do ii=1,np_g1k(ik)
                    zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&              = zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&               + zz( ib1, ib2-is+1 ) *zat_l_noncl( ii, ib1, 1, ispinor )
                 enddo
               End do
            enddo
         enddo
      enddo
#endif
      call tstatc0_end(id_sname)
    end subroutine subspace_rotation_real_noncl

    subroutine subspace_rotation_imag_noncl( is, ie, zat_wk_noncl, zz, ibsize1, ibsize2 )
      integer, intent(in) :: is,ie, ibsize1,ibsize2
      real(kind=DP), intent(inout) :: zat_wk_noncl( np_g1k_x, meg, kimg, ndim_spinor )
      real(kind=DP), intent(in) :: zz(meg*kimg_t,ibsize1)
      integer :: id_sname = -1
      integer :: ibsta, ibend

      integer :: ispinor

#ifdef SUBMAT_DGEMM
      real(kind=DP) :: alpha, beta
      integer :: nblk2
      real(kind=DP), allocatable, dimension(:,:) :: zzr,zzi
#endif

      call tstatc0_begin('subspace_roation_imag_noncl ', id_sname)

!      stop

      if (k_symmetry(ik) == GAMMA) then
#ifdef SUBMAT_DGEMM
         alpha = 1.d0; beta = 1.d0
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            nblk2=ibend-ibsta+1

            Do ispinor=1, ndim_spinor
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                  zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
	&                  zz(ibsta,1), meg, beta, &
        &                  zat_wk_noncl(1,is,1,ispinor), np_g1k_x )
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                  zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
	&                  zz(ibsta,1), meg, beta, &
        &                  zat_wk_noncl(1,is,2,ispinor), np_g1k_x )
            End do
         enddo
         !!if(iprisubmat>=2) write(nfout,'(" !!<<subspace_rotation_imag>> ibsize = ",i8)') ibsize
#else
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            do ib2=is,ie
!CDIR OUTERUNROLL=4
               do ib1=ibsta,ibend
                  dr1=zz(ib1,ib2-is+1)
	          Do ispinor=1, ndim_spinor
                     do ii=1,np_g1k(ik)
                       zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&               = zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&                + dr1 *zat_l_noncl(ii, ib1, 1, ispinor )
                       zat_wk_noncl( ii, ib2, 2, ispinor ) &
	&               = zat_wk_noncl( ii, ib2, 2, ispinor )&
	&                + dr1 *zat_l_noncl( ii, ib1, 2, ispinor )
                     enddo
                   ENd do
               enddo! ib1 loop
            enddo! ib2 loop
         enddo
#endif
         if ( iprisubmat >= 2) then
            do ib2 = is, ie
	       Do ispinor=1, ndim_spinor
	          write(nfout,*) '*** ispinor = ', ispinor
                  write(nfout,'(" --- zat_l_noncl (input, output) ---, ib =",i5)') ib2
                  write(nfout,'(" zat_l_noncl(input ) Re : ",5e14.6)') &
	&                  ( zat_l_noncl(ii,ib2,1,ispinor),ii=1,5 )
                  write(nfout,'(" zat_l_noncl(input ) Im : ",5e14.6)') &
	&                  ( zat_l_noncl(ii,ib2,2,ispinor),ii=1,5 )
                 write(nfout,'(" zat_l_noncl(output) Re : ",5e14.6)') &
	&                  ( zat_wk_noncl(ii,ib2,1,ispinor),ii=1,5)
                 write(nfout,'(" zat_l_noncl(output) Im : ",5e14.6)') &
	&                  ( zat_wk_noncl(ii,ib2,2,ispinor),ii=1,5)
	       End do
            end do
         end if
      else
#ifdef SUBMAT_DGEMM

         allocate(zzr(ibsize2,ibsize1)); allocate(zzi(ibsize2,ibsize1))
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            nblk2=ibend-ibsta+1
            do ib2=is,ie
               do ib1=ibsta, ibend
                  zzr(ib1-ibsta+1,ib2-is+1)=zz(2*ib1-1,ib2-is+1)
                  zzi(ib1-ibsta+1,ib2-is+1)=zz(2*ib1  ,ib2-is+1)
               end do
            end do

	    Do ispinor=1, ndim_spinor
              alpha=1.d0; beta=1.d0
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                 zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
	&                 zzr, ibsize2, beta, &
	&                 zat_wk_noncl(1,is,1,ispinor), np_g1k_x )

              alpha=-1.d0; beta=1.d0
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                  zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
	&                  zzi, ibsize2, beta, &
	&                  zat_wk_noncl(1,is,1,ispinor), np_g1k_x )

              alpha=1.d0; beta=1.d0
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                 zat_l_noncl(1,ibsta,2,ispinor), np_g1k_x, &
	&                 zzr, ibsize2, beta, &
	&                 zat_wk_noncl(1,is,2,ispinor), np_g1k_x )

              alpha=1.d0; beta=1.d0
              call dgemm( 'N', 'N', np_g1k(ik), ibsize1, nblk2, alpha, &
	&                 zat_l_noncl(1,ibsta,1,ispinor), np_g1k_x, &
	&                 zzi, ibsize2, beta, &
	&                 zat_wk_noncl(1,is,2,ispinor), np_g1k_x )
            End do
         enddo
         deallocate(zzi,zzr)
#else
         do ibsta=1,meg,ibsize2
            ibend=min(ibsta+ibsize2-1,meg)
            do ib2=is,ie
!CDIR OUTERUNROLL=4
               do ib1=ibsta,ibend
                  dr1=zz(2*ib1-1,ib2-is+1)
                  di1=zz(2*ib1  ,ib2-is+1)

	          Do ispinor=1, ndim_spinor
                    do ii=1,np_g1k(ik)
                       dr2 = zat_l_noncl( ii, ib1, 1, ispinor )
                       di2 = zat_l_noncl( ii, ib1, 2, ispinor )
                       zat_wk_noncl( ii, ib2, 1, ispinor ) &
	&                = zat_wk_noncl( ii, ib2, 1, ispinor ) +dr1*dr2 -di1*di2
                       zat_wk_noncl( ii, ib2, 2, ispinor ) &
	&                = zat_wk_noncl( ii, ib2, 2, ispinor ) +dr1*di2 +di1*dr2
                    enddo
                  End do 
               enddo! ib1 loop
            enddo! ib2 loop
         enddo
#endif
       end if
       call tstatc0_end(id_sname)
    end subroutine subspace_rotation_imag_noncl

#ifdef _USE_SCALAPACK_
#endif
! _USE_SCALAPACK_

  end subroutine evolve_WFs_in_subspace_noncl
! ==================================================================== 11.0



!!$#endif

!! ++++++++++++++++++++ global(=not contained) subroutines in this module +++++++++++++++
#ifndef _USE_DSYEVD_
  subroutine dsyev_driver(ndim,eig,w1hw2)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    real(kind=DP), intent(inout) ,dimension(ndim,ndim) :: w1hw2

    integer, parameter :: PRINTLEVEL = 2
    character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
    integer :: lda
!!$    integer :: lwork,lwork_min
    integer, save :: lwork=0
    integer       :: lwork_min
    integer,parameter :: nb = 64
    integer, parameter :: lwork_huge=10**8
    real(kind=DP),allocatable,dimension(:) :: work_lapack
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('dsyev_driver ', id_sname)

    lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
! (define lwork)
!!$    lwork = 0
!!$    lwork_min=max(1,3*ndim-1)
    lwork_min=max(1,(nb+2)*ndim)
    if(lwork == 0) then
       lwork = -1
       allocate(work_lapack(1))
       call dsyev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,info)
       lwork = int(work_lapack(1))+1
       if(iprisubmat >= PRINTLEVEL) then
          write(nfout,'(" lwork = ",i8)') lwork
       end if
       deallocate(work_lapack)
    end if
    if(lwork < lwork_min) lwork=lwork_min
    if(lwork > lwork_huge) lwork=lwork_min
    allocate(work_lapack(lwork))
    if(iprisubmat >= PRINTLEVEL .and. lwork == lwork_min) then
       write(nfout,'(" lwork = ",i8)') lwork
       write(nfout,'(" lda, ndim = ",2i8)') lda, ndim
    end if

    call dsyev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,info)
!!$    write(*,*) 'lwork& info & suggested lwork = ',lwork,info,work_lapack(1)
    if(iprisubmat >= 2) then
       write(nfout,'(" info = ",i8)') info
    end if
!!$    lwork= int(work_lapack(1))+1
    deallocate(work_lapack)

    call tstatc0_end(id_sname)
  end subroutine dsyev_driver
#else
  subroutine dsyev_driver(ndim,eig,w1hw2)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    real(kind=DP), intent(inout) ,dimension(ndim,ndim) :: w1hw2

    character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
    integer :: lda
    integer :: lwork,liwork
    complex(kind=CMPLDP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: iwork
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('dsyev_driver ', id_sname)

    lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'
! (define lwork)

    lwork  = 1 + ndim*(6+2*ndim)
    liwork = 3 + 5*ndim

    allocate(work(lwork)); work = 0.d0
    allocate(iwork(liwork)); iwork = 0.d0

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("DSYEVD")
#endif
    call dsyevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("DSYEVD")
#endif

    deallocate(work)
    deallocate(iwork)

    call tstatc0_end(id_sname)
  end subroutine dsyev_driver
#endif

#ifndef _USE_ZHEEVD_
  subroutine zheev_driver(ndim,eig,w1hw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
   integer :: i,j
! --> T. Yamasaki 2009/07/24 revised according to a Dr. Katagiri's report
!!$   integer :: lwork,lwork_min,rwork_size
   integer :: lwork_min,rwork_size
   integer, save :: lwork = 0
! <--
   integer, parameter :: lwork_huge=10**8
   real(kind=DP),allocatable,dimension(:) :: work_lapack
   real(kind=DP),allocatable,dimension(:) :: rwork_lapack
   integer :: info

   integer :: id_sname = -1
   call tstatc0_begin('zheev_driver ', id_sname)

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork_min=max(1,2*ndim-1)
      rwork_size=max(3*ndim-2,1)
     if(lwork < lwork_min)  lwork=lwork_min
     if(lwork > lwork_huge) lwork=lwork_min

     allocate(work_lapack(lwork*2))
     allocate(rwork_lapack(rwork_size))

     call zheev(JOBZ,UPLO,ndim,w1hw2,lda,eig,work_lapack,lwork,rwork_lapack,info)
!!$     write(*,*) 'lwork& info & suggested lwork = ',lwork,info,work_lapack(1)
     lwork= int(work_lapack(1))+1

     deallocate(work_lapack)
     deallocate(rwork_lapack)

     call tstatc0_end(id_sname)
   end subroutine zheev_driver
#else
  subroutine zheev_driver(ndim,eig,w1hw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
   integer :: lwork,lrwork,liwork
   complex(kind=CMPLDP),allocatable,dimension(:) :: work
   real(kind=DP),allocatable,dimension(:) :: rwork
   real(kind=DP),allocatable,dimension(:) :: iwork
   integer :: info

   integer :: id_sname = -1
   call tstatc0_begin('zheev_driver ', id_sname)

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork=ndim*(2+ndim)
      lrwork=1+ndim*(5+2*ndim)
      liwork=3+5*ndim

     allocate(work(lwork))
     allocate(rwork(lrwork))
     allocate(iwork(liwork))

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("ZHEEVD")
#endif
     call zheevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,rwork,lrwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("ZHEEVD")
#endif

     deallocate(work)
     deallocate(rwork)
     deallocate(iwork)

     call tstatc0_end(id_sname)
   end subroutine zheev_driver
#endif
! _NO_USE_ZHEEVD_


#ifndef _USE_ZHEGVXD_
  subroutine zhegvx_driver(ndim,eig,w1hw2,w1sw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2,w1sw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
! --> T. Yamasaki 2009/07/24 revised according to a Dr. Katagiri's report
!!$   integer :: lwork,lwork_min,rwork_size
   integer :: lwork_min,rwork_size
   integer, save :: lwork = 0
! <--
   integer, parameter :: lwork_huge=10**8
   real(kind=DP),allocatable,dimension(:) :: work_lapack
   real(kind=DP),allocatable,dimension(:) :: rwork_lapack
   integer :: info

   real(kind=DP),allocatable,dimension(:,:) :: z
   integer,allocatable,dimension(:) :: ifail
   integer,allocatable,dimension(:) :: iwork
   integer :: ITYPE,ldb,IL,IU,ldz
   integer :: i,j
   integer :: meig
   real(kind=DP) :: VL,VU,ABSTOL
   character(len=1) :: RANGE

   integer :: id_sname = -1
   call tstatc0_begin('zhegvx_driver ', id_sname)

!write(90,*) 'fail ::    zhegvx_driver'

      ITYPE=1
      RANGE='A'
      ABSTOL=-1.d0

      lda=ndim
      ldb=ndim
      ldz=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'

      lwork=ndim*(2+ndim)
      lwork_min=max(1,2*ndim-1)
     if(lwork < lwork_min)  lwork=lwork_min
     if(lwork > lwork_huge) lwork=lwork_min

      rwork_size=7*ndim !max(3*ndim-2,1)

     allocate(work_lapack(lwork*2))
     allocate(rwork_lapack(rwork_size))

     allocate(z(ldz*2,ndim))
     allocate(ifail(ndim))
     allocate(iwork(5*ndim))

     call zhegvx(ITYPE,JOBZ,RANGE,UPLO,ndim,w1hw2,lda,w1sw2,ldb,VL,VU,IL,IU,ABSTOL &
                ,meig,eig,z,ldz,work_lapack,lwork,rwork_lapack,iwork,ifail,info)
     w1hw2=z
     lwork= int(work_lapack(1))+1

     deallocate(work_lapack)
     deallocate(rwork_lapack)

     deallocate(z)
     deallocate(ifail)
     deallocate(iwork)

     call tstatc0_end(id_sname)
   end subroutine zhegvx_driver
#else
  subroutine zhegvx_driver(ndim,eig,w1hw2,w1sw2)
   integer, intent(in):: ndim
   real(kind=DP), intent(out) ,dimension(ndim) :: eig
   real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2,w1sw2
   character(len=1) :: JOBZ,UPLO
!   integer, parameter :: lda=ndim
   integer :: lda
   integer :: lwork,lrwork,liwork
   complex(kind=CMPLDP),allocatable,dimension(:) :: work
   real(kind=DP),allocatable,dimension(:) :: rwork
   real(kind=DP),allocatable,dimension(:) :: iwork
   integer :: info
   integer :: meig

   complex(kind=CMPLDP),allocatable,dimension(:,:) :: z
   integer,allocatable,dimension(:) :: ifail
   integer :: ITYPE,ldb,IL,IU,ldz
   real(kind=DP) :: VL,VU,ABSTOL
   character(len=1) :: RANGE

   integer :: id_sname = -1
   call tstatc0_begin('zhegvx_driver ', id_sname)

!write(90,*) 'zhegvx_driver'

      ITYPE=1
      RANGE='A'
      ABSTOL=-1.d0

      lda=ndim
      ldb=ndim
      ldz=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
     JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
     UPLO = 'U'
      lwork=ndim*(2+ndim)
      lrwork=1+ndim*(5+2*ndim)
      liwork=5*ndim !3+5*ndim

     allocate(work(lwork))
     allocate(rwork(lrwork))
     allocate(iwork(liwork))

     allocate(z(ldz,ndim))
     allocate(ifail(ndim))

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("ZHEGVXD")
#endif
!     call zheevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,rwork,lrwork,iwork,liwork,info)
     call zhegvx(ITYPE,JOBZ,RANGE,UPLO,ndim,w1hw2,lda,w1sw2,ldb,VL,VU,IL,IU,ABSTOL &
                ,meig,eig,z,ldz,work,lwork,rwork,iwork,ifail,info)
     w1hw2=z
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("ZHEGVXD")
#endif

     deallocate(work)
     deallocate(rwork)
     deallocate(iwork)

     deallocate(z)
     deallocate(ifail)

     call tstatc0_end(id_sname)
   end subroutine zhegvx_driver
#endif


! <-- T.Kokubo & D.Fukata, Feb. 2010
  subroutine set_hmat(kimg_t,meg,is,ie,w1hw2,zmat)
    integer, intent(in) :: kimg_t,meg,is,ie
    real(kind=DP), intent(inout) :: w1hw2(*)
    real(kind=DP), intent(out) :: zmat(meg*kimg_t,meg)
    integer, parameter         :: msize_allreduce_max = 1000000

    real(kind=DP), allocatable :: w1hw2_mpi(:), w1hw2_mpi2(:)
    integer :: i,j, msize_partitioned
    integer :: m,msize
    integer :: id_sname = -1
    call tstatc0_begin('set_hmat ', id_sname)

    msize = is*(ie-is+1) + (ie-is+1)*(ie-is)/2

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("SET_HMAT")
#endif
!! (spread sum of w1hw2)
    if(npes > 1) then
       allocate(w1hw2_mpi(msize*kimg_t))
       if(msize*kimg_t <= msize_allreduce_max) then
          if(iprisubmat >= 2) write(nfout,'(" msize*kimg_t = ",i12,",  msize_allreduce_max = ",i12," <<set_hmat>>")') &
         & msize*kimg_t, msize_allreduce_max
          call mpi_allreduce(w1hw2,w1hw2_mpi,msize*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
          w1hw2(1:msize*kimg_t) = w1hw2_mpi         ! MPI
       else
          if(iprisubmat >= 2)  &
               & write(nfout,'(" msize*kimg_t = ",i12," > msize_allreduce_max = ",i12," <<set_hmat>>")') &
               & msize*kimg_t, msize_allreduce_max
          allocate(w1hw2_mpi2(msize_allreduce_max))
          do j = 1, ceiling(dble(msize*kimg_t)/msize_allreduce_max)
             msize_partitioned = min(msize_allreduce_max, msize*kimg_t-(j-1)*msize_allreduce_max)
             do m = 1, msize_partitioned
                i = m + (j-1)*msize_allreduce_max
                w1hw2_mpi2(m) = w1hw2(i)
             end do
             call mpi_allreduce(MPI_IN_PLACE,w1hw2_mpi2,msize_partitioned,mpi_double_precision &
                  &                             ,mpi_sum,mpi_k_world(myrank_k),ierr)
             do m = 1, msize_partitioned
                i = m + (j-1)*msize_allreduce_max
                w1hw2_mpi(i) = w1hw2_mpi2(m)
             end do
          end do
          w1hw2(1:msize*kimg_t) = w1hw2_mpi
          deallocate(w1hw2_mpi2)
       end if
       deallocate(w1hw2_mpi)
    end if
    if(kimg_t==1) then
!CDIR PARALLEL DO PRIVATE (i,m)
       do j=is,ie
          do i=1,j
             m = j*(j-1)/2-is*(is-1)/2+i
             zmat(i,j) =  w1hw2(m)
          end do
       end do
    else
!CDIR PARALLEL DO PRIVATE (i,m)
       do j=is,ie
          do i=1,j
             m = j*(j-1)/2-is*(is-1)/2+i
             zmat(2*i-1,j) =  w1hw2(2*m-1)
             zmat(2*i  ,j) = -w1hw2(2*m)
          end do
       end do
    end if
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("SET_HMAT")
#endif
    call tstatc0_end(id_sname)
  end subroutine set_hmat
#ifdef _USE_SCALAPACK_
  subroutine set_nprow_npcol(nprow,npcol)
    integer, intent(inout) :: nprow,npcol
    logical :: cflag
    integer :: j,n

    cflag=.true.

    if(nprow*npcol /= nrank_e) then
       nprow=1
       npcol=1
       j = nrank_e

 120   continue
       if(mod(j,2) == 0) then
         j=j/2
         n=2
         call prod(cflag,n,nprow,npcol)
         goto 120
       else if(mod(j,3) == 0) then
         j=j/3
         n=3
         call prod(cflag,n,nprow,npcol)
         goto 120
       else if(mod(j,5) == 0) then
         j=j/5
         n=5
         call prod(cflag,n,nprow,npcol)
         goto 120
       else if(j == 1) then
         n=1
       else
         n=j
       end if
       call prod(cflag,n,nprow,npcol)
       write(*,'("set nprow,npcol=",2i5)') nprow,npcol
       if(printable) write(nfout,'("set nprow,npcol=",2i5)') nprow,npcol
    else
       if(iprisubmat >= 2) write(nfout,'("nprow,npcol=",2i5)') nprow,npcol
    end if
  end subroutine set_nprow_npcol
  subroutine prod(cflag,n,nr,nc)
    logical,intent(inout) :: cflag
    integer,intent(in)    :: n
    integer,intent(inout) :: nr,nc
    if(cflag) then
       nr = nr * n
    else
       nc = nc * n
    endif
    cflag= .not.cflag
  end subroutine prod
#endif


#ifdef _USE_SCALAPACK_
  subroutine set_amat(lda,kimg_t,occ,amat,ndim,nprow,npcol,nb,usermap,is,ie,w1hw2)
    integer, intent(in) :: lda,kimg_t,occ
    real(kind=DP), intent(out) :: amat(lda*kimg_t,occ)
    integer, intent(in) :: ndim,nprow,npcol,nb
#ifdef SINGLE_CONTEXT
    integer, intent(in) :: usermap(nprow,npcol)
#else
    integer, intent(in) :: usermap(nprow,npcol,0:nrank_k-1)
#endif
    integer, intent(in) :: is,ie
    real(kind=DP), intent(inout) :: w1hw2(*)

    integer :: i,j
    integer :: jj,ipcol,ilcol,ixcol
    integer :: ii,iprow,ilrow,ixrow
    integer :: m,msize
    real(kind=DP), allocatable :: w1hw2_mpi(:)
    integer :: id_sname = -1
    call tstatc0_begin('set_amat ', id_sname)

    msize = is*(ie-is+1) + (ie-is+1)*(ie-is)/2
#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("SET_AMAT")
#endif

!! (spread sum of w1hw2)
    if(npes > 1) then
       if(iprisubmat >= 2) write(nfout,'(" msize*kimg_t = ",i12," <<set_amat>>")') msize*kimg_t
       allocate(w1hw2_mpi(msize*kimg_t))
       call mpi_allreduce(w1hw2,w1hw2_mpi,msize*kimg_t,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr)
       w1hw2(1:msize*kimg_t) = w1hw2_mpi
       deallocate(w1hw2_mpi)
    end if

    if(kimg_t==1) then
       !!$!CDIR PARALLEL DO PRIVATE ( ipcol,ilcol,ixcol,jj,i,iprow,ilrow,ii,m)
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,j
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             m = j*(j-1)/2-is*(is-1)/2+i
             amat(ii,jj) =  w1hw2(m)
          end do
       end do
    else
       !!$!CDIR PARALLEL DO PRIVATE ( ipcol,ilcol,ixcol,jj,i,iprow,ilrow,ii,m)
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,j
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             m = j*(j-1)/2-is*(is-1)/2+i
             amat(2*ii-1,jj) =  w1hw2(2*m-1)
             amat(2*ii  ,jj) = -w1hw2(2*m)
          end do
       end do
    end if
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("SET_AMAT")
#endif
    call tstatc0_end(id_sname)
  end subroutine set_amat
#endif

#ifdef _USE_SCALAPACK_
  subroutine put_zmat(kimg_t,lda,occ,zmat,ndim,nprow,npcol,nb,usermap,is,ie,zz)
    integer, intent(in) :: kimg_t,lda,occ
    real(kind=DP), intent(in) :: zmat(lda*kimg_t,occ)
    integer, intent(in) :: ndim,nprow,npcol,nb
#ifdef SINGLE_CONTEXT
    integer, intent(in) :: usermap(nprow,npcol)
#else
    integer, intent(in) :: usermap(nprow,npcol,0:nrank_k-1)
#endif
    integer, intent(in) :: is,ie
    real(kind=DP), intent(out) :: zz(ndim*kimg_t,is:ie)

    integer :: i,j
    integer :: jj,ipcol,ilcol,ixcol
    integer :: ii,iprow,ilrow,ixrow
    integer :: jsize
    real(kind=DP), allocatable :: zz_mpi(:,:)
    integer :: id_sname = -1
    call tstatc0_begin('put_zmat ', id_sname)

    jsize = ie-is+1

#ifdef NEC_ITER_REG
    call FTRACE_REGION_BEGIN("PUT_ZMAT")
#endif
    zz = 0.d0
    if(kimg_t==1) then
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,ndim
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             zz(i,j) = zmat(ii,jj)
          end do
       end do
    else
       do j=is,ie
          ipcol = mod((j-1)/nb,npcol)
          ilcol = (j-1)/(npcol*nb)
          ixcol = mod(j-1,nb)+1
          jj = ilcol*nb+ixcol
          do i=1,ndim
             iprow = mod((i-1)/nb,nprow)
             ilrow = (i-1)/(nprow*nb)
             ixrow = mod(i-1,nb)+1
             ii = ilrow*nb+ixrow
#ifdef SINGLE_CONTEXT
             if(usermap(iprow+1,ipcol+1) /= mype) cycle
#else
             if(usermap(iprow+1,ipcol+1,myrank_k) /= mype) cycle
#endif
             zz(2*i-1,j) = zmat(2*ii-1,jj)
             zz(2*i  ,j) = zmat(2*ii  ,jj)
          end do
       end do
    end if
    if(npes > 1) then
       allocate(zz_mpi(ndim*kimg_t,is:ie))
       call mpi_allreduce(zz,zz_mpi,ndim*kimg_t*jsize,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       zz = zz_mpi         ! MPI
       deallocate(zz_mpi)
    end if
#ifdef NEC_ITER_REG
    call FTRACE_REGION_END("PUT_ZMAT")
#endif
    call tstatc0_end(id_sname)
  end subroutine put_zmat
#endif

! ------------------------------
#ifdef _USE_SCALAPACK_
  subroutine scalapack_setup(ndim,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
    integer, intent(in) :: ndim
#ifdef SINGLE_CONTEXT
    integer, intent(out) :: lwork1,lrwork1,liwork1,lda,occ,ictxt,myrow,mycol
#else
    integer, intent(out) :: lwork1,lrwork1,liwork1,lda,occ,ictxt(0:nrank_k-1),myrow,mycol
#endif
    integer, intent(out) :: lwork2,lrwork2,liwork2
    integer, dimension(9), intent(out) :: desca,descz
#ifdef SINGLE_CONTEXT
    integer, intent(inout) :: usermap(nprow,npcol)
#else
    integer, intent(inout) :: usermap(nprow,npcol,0:nrank_k-1)
#endif

    integer :: i,j
#ifndef SINGLE_CONTEXT
    integer :: ik, pid, blacs_pnum
    integer, save ::  tmpctxt
#endif
    integer :: nb
    integer :: np0,nq0,np,nq,iarow,iacol
    integer :: iroffa, icoffa, nrc, ldc 
    integer :: sizemqrleft, qrmem, trilwmin
    integer :: iam,nprocs,info
    integer, external :: indxg2l, indxg2p, numroc
    integer, parameter :: BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1, &
     &                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6, &
     &                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9
    integer :: id_sname = -1
    call tstatc0_begin('scalapack_setup ', id_sname)

    nb = block_size

    if(mod(ndim,nb)>0) then
       lda = ndim/nb +1
    else
       lda = ndim/nb
    end if
    occ = lda
    if(mod(lda,nprow)>0) then
       lda = lda/nprow+1
    else
       lda = lda/nprow
    end if
    if(mod(occ,npcol)>0) then
       occ = occ/npcol+1
    else
       occ = occ/npcol
    end if
    lda = lda*nb
    occ = occ*nb
    if(iprisubmat>=2) write(nfout,'("lda,occ=",2i5)') lda,occ

#ifdef SINGLE_CONTEXT
    do j=1,npcol
       do i=1,nprow
          usermap(i,j) = myrank_k*nrank_e + (j-1)*nprow + i - 1
       end do
    end do
    if(iprisubmat>=1) then
       write(nfout,'("USERMPAP")')
       do i=1,nprow
          write(nfout,'(1x,i3)') (usermap(i,j),j=1,npcol)
       end do
    end if
    call blacs_setup(iam,nprocs)
    call blacs_get(-1,0,ictxt)
    call blacs_gridmap(ictxt,usermap,nprow,nprow,npcol)
    call blacs_gridinfo(ictxt,nprow,npcol,myrow,mycol)
#else
    call blacs_setup(iam,nprocs)
    call blacs_get(0,0,tmpctxt)
    call blacs_gridinit(tmpctxt,'R',nprocs,1)
    do ik=0,nrank_k-1
       pid = ik*nrank_e
       do j=1,npcol
          do i=1,nprow
             usermap(i,j,ik) = blacs_pnum(tmpctxt,pid,0)
             pid = pid + 1
          end do
       end do
       call blacs_get(0,0,ictxt(ik))
       call blacs_gridmap(ictxt(ik),usermap(1,1,ik),nprow,nprow,npcol)
    end do
    call blacs_gridinfo(ictxt(myrank_k),nprow,npcol,myrow,mycol)
    if(iprisubmat>=1) then
       do ik=0,nrank_k-1
          write(nfout,'("USERMPAP: ik=",i5)') ik
          do i=1,nprow
             write(nfout,'(128(1x,i3))') (usermap(i,j,ik),j=1,npcol)
          end do
       end do
    end if
#endif
    if(myrow == -1) then
       if(printable) write(nfout,*) 'BLACS init failed.'
       stop 'BLACS init failed.'
    else
       if(iprisubmat>=2) write(nfout,'("nprow,npcol,myrow,mycol=",4i5)') nprow,npcol,myrow,mycol
    end if
#ifdef SINGLE_CONTEXT
    call descinit(desca,ndim,ndim,nb,nb,0,0,ictxt,lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for amat: info=',info
    call descinit(descz,ndim,ndim,nb,nb,0,0,ictxt,lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for zmat: info=',info
#else
    call descinit(desca,ndim,ndim,nb,nb,0,0,ictxt(myrank_k),lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for amat: info=',info
    call descinit(descz,ndim,ndim,nb,nb,0,0,ictxt(myrank_k),lda,info)
    if(iprisubmat>=2) write(nfout,*) 'descinit for zmat: info=',info
#endif

!   if(kimg_t==1) then
       ! setup for pdsyev
       if(method_scalapack==HOUSEHOLDER) then
          IROFFA = MOD( 0, nb )
          ICOFFA = MOD( 0, nb )
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( RSRC_ ), npcol )
          np = NUMROC( ndim+iroffa, nb, myrow, iarow, nprow )
          nq = NUMROC( ndim+icoffa, nb, mycol, iacol, npcol )
          sizemqrleft = max( (nb*(nb-1))/2, (np+nq)*nb ) + nb*nb
          if(printable) write(nfout,*) 'np,nq=',np,nq
          if(printable) write(nfout,*) 'sizemqrleft=',sizemqrleft
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol )
          nrc = NUMROC( ndim, nb, myrow, 0, nprocs)
          ldc = max( 1, nrc )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          if(printable) write(nfout,*) 'nrc,ldc=',nrc,ldc
          qrmem = 2*ndim-2
          if(printable) write(nfout,'("qrmem,=",i9)') qrmem
          lwork1 = 5*ndim + ndim*ldc + max( sizemqrleft, qrmem ) + 1
          if(printable) write(nfout,'("lwork1,=",i9)') lwork1
          lrwork1 = 0
          liwork1 = 0
       else
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( CSRC_ ), npcol )
          np0 = NUMROC( ndim, nb, myrow, iarow, nprow )
          nq0 = NUMROC( ndim, nb, mycol, iacol, npcol )
          if(printable) then
             write(nfout,*) 'iarow,iacol=',iarow,iacol
             write(nfout,*) 'np0,nq0=',np0,nq0
             write(nfout,*) 'nb_a=', desca( NB_ )
          end if
          trilwmin = 3*ndim + max( nb*( np0+1 ), 3*nb )
          lwork1 = max( 1+6*ndim+2*np0*nq0, trilwmin ) + 2*ndim
          liwork1 = 7*ndim + 8*npcol + 2
          if(printable) write(nfout,'("lwork1,liwork1,=",2i9)') lwork1,liwork1
          lrwork1 = 0
       end if
!   else
       ! setup for pzheev
       if(method_scalapack==HOUSEHOLDER) then
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          lwork2 = ndim*(ndim+3) + ( np0 + nq0 + nb ) * nb
          lrwork2 = 2*ndim + 2*ndim-2
          if(printable) write(nfout,'("lwork2,lrwork2,=",3i9)') lwork2,lrwork2
          liwork2 = 0
       else
          iarow = INDXG2P( 1, nb, myrow, desca( RSRC_ ), nprow )
          iacol = INDXG2P( 1, nb, mycol, desca( CSRC_ ), npcol )
          np0 = NUMROC( ndim, nb, myrow, iarow, nprow )
          nq0 = NUMROC( ndim, nb, mycol, iacol, npcol )
          nq = NUMROC( MAX( ndim, nb, 2 ), nb, 0, 0, npcol )
          if(printable) then
             write(nfout,*) 'iarow,iacol=',iarow,iacol
             write(nfout,*) 'np0,nq0,nq=',np0,nq0,nq
             write(nfout,*) 'nb_a=', desca( NB_ )
          end if
          lwork2 = ndim + ( np0 + nq + nb ) * nb
          lrwork2 = 1 + 9*ndim + 3*np0*nq0
          liwork2 = 7*ndim + 8*npcol + 2
          if(printable) write(nfout,'("lwork2,lrwork2,liwork2,=",3i9)') lwork2,lrwork2,liwork2
       end if
!   end if

    call tstatc0_end(id_sname)
  end subroutine scalapack_setup
#endif

#ifdef _USE_SCALAPACK_
  subroutine pdsyev_driver(ndim,eig,desca,descz,lda,occ,amat,zmat,lwork,liwork)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    integer, dimension(9), intent(in) :: desca,descz
    integer, intent(in) :: lda,occ
    real(kind=DP), intent(inout) ,dimension(lda,occ) :: amat
    real(kind=DP), intent(out) ,dimension(lda,occ) :: zmat
    integer, intent(in):: lwork,liwork

    character(len=1) :: JOBZ,UPLO
    real(kind=DP),allocatable,dimension(:) :: work
    integer,allocatable,dimension(:) :: iwork
    integer :: info
    integer :: id_sname = -1
    call tstatc0_begin('pdsyev_driver ', id_sname)
 
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'

    allocate(work(lwork))
    if(method_scalapack==DIVIDEandCONQUER) allocate(iwork(liwork))

    if(method_scalapack==HOUSEHOLDER) then
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PDSYEV")
#endif
       call pdsyev(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                & ,descz,work,lwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PDSYEV")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pdsyev: info=',info
    else
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PDSYEVD")
#endif
       call pdsyevd(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                 & ,descz,work,lwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PDSYEVD")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pdsyevd: info=',info
    end if


    deallocate(work)
    if(method_scalapack==DIVIDEandCONQUER) deallocate(iwork)

    call tstatc0_end(id_sname)
  end subroutine pdsyev_driver

  subroutine pzheev_driver(ndim,eig,desca,descz,lda,occ,amat,zmat,lwork,lrwork,liwork)
    integer, intent(in):: ndim
    real(kind=DP), intent(out) ,dimension(ndim) :: eig
    integer, dimension(9), intent(in) :: desca,descz
    integer, intent(in) :: lda,occ
    real(kind=DP), intent(inout) ,dimension(lda*2,occ) :: amat
    real(kind=DP), intent(out) ,dimension(lda*2,occ) :: zmat
    integer, intent(in):: lwork,lrwork,liwork

    character(len=1) :: JOBZ,UPLO
    complex(kind=CMPLDP),allocatable,dimension(:) :: work
    real(kind=DP),allocatable,dimension(:) :: rwork
    integer,allocatable,dimension(:) :: iwork
    integer :: info

    integer :: id_sname = -1
    call tstatc0_begin('pzheev_driver ', id_sname)
 
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
    JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
    UPLO = 'U'

    allocate(work(lwork))
    allocate(rwork(lrwork))
    if(method_scalapack==DIVIDEandCONQUER) allocate(iwork(liwork))

    if(method_scalapack==HOUSEHOLDER) then
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PZHEEV")
#endif
       call pzheev(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                & ,descz,work,lwork,rwork,lrwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PZHEEV")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pzheev: info=',info
    else
#ifdef NEC_ITER_REG
       call FTRACE_REGION_BEGIN("PZHEEVD")
#endif
       call pzheevd(JOBZ,UPLO,ndim,amat,1,1,desca,eig,zmat,1,1 &
                 & ,descz,work,lwork,rwork,lrwork,iwork,liwork,info)
#ifdef NEC_ITER_REG
       call FTRACE_REGION_END("PZHEEVD")
#endif
       if(iprisubmat>=2) write(nfout,*) 'pzheevd: info=',info
    end if

    deallocate(work)
    deallocate(rwork)
    if(method_scalapack==DIVIDEandCONQUER) deallocate(iwork)

    call tstatc0_end(id_sname)
  end subroutine pzheev_driver
#endif
! _USE_SCALAPACK_



   subroutine m_ESsubmat_utransform_wf(imode,ik,zaj_l,update_fsr,wf_mode)
     integer, intent(in) :: imode,ik
     real(kind=DP), dimension(kg1,np_e,ista_k:iend_k,kimg),intent(inout) :: zaj_l
     logical, intent(in) :: update_fsr
     logical, intent(in) :: wf_mode
     real(kind=DP), allocatable, dimension(:,:,:) :: zat_l,zat_wk
     real(kind=DP), allocatable, dimension(:,:) :: zz
     integer :: jp,is,ie,nblk1,ibsize2,ibsize,kimg_t
     real(kind=DP),allocatable,dimension(:,:) :: mat
     if(.not.allocated(unimat)) return
     if(disable_utransform) return
#ifdef _ODD_BOUNDARY_
     if(mod(np_g1k(ik),2) == 0) then
        np_g1k_x = np_g1k(ik) + 1
     else
        np_g1k_x = np_g1k(ik)
     end if
#else
     np_g1k_x = np_g1k(ik)
#endif
     np_g1k_x = maxval(np_g1k)

     if(k_symmetry(ik) == GAMMA) then
        kimg_t = 1
     else
        kimg_t = kimg
     end if

     if(nblocksize_submat_is_given) then
       ibsize = nblocksize_submat
     else
       ibsize = nb_submat_default
     endif

!     if(imode==DIRECT .and. wf_mode)then
!        zaj_l(1:kg1,1:np_e,ik,1:kimg) = zaj_l_buf(1:kg1,1:np_e,ik,1:kimg)
!        if(update_fsr) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)
!        return
!     endif
!     if(imode==INVERSE .and. wf_mode) then
!        zaj_l_buf(1:kg1,1:np_e,ik,1:kimg) = zaj_l(1:kg1,1:np_e,ik,1:kimg)
!     endif

     allocate(zat_l(np_g1k_x,neg,kimg));zat_l=0.d0
     call m_ES_W_transpose_r(.false.,ista_k,iend_k,ik,zaj_l,zat_l)
     allocate(zat_wk(np_g1k_x,neg,kimg));zat_wk=0.d0
     allocate(mat(neg*kimg_t,neg))
     if(imode==DIRECT)then
        mat(:,:)=unimat(:,:)
     else
        mat(:,:)=unimat_h(:,:)
     endif
! <-- T.Kokubo & D.Fukata, Feb. 2010
     PART2: do jp = 1,npart2
        is = isp2(jp)
        ie = iep2(jp)
        nblk1 = ie-is+1
#ifdef SX
        ibsize2 = neg
#else
        ibsize2 = ibsize
#endif
#ifdef _USE_SCALAPACK_
        if(sw_scalapack == ON) then
           allocate(zz(neg*kimg_t,nblk1))
           call put_zmat(kimg_t,lda,occ,mat,neg,nprow,npcol,block_size,usermap,is,ie,zz)
           if(kimg == 1) then
              call subspace_rotation_real(is,ie,zat_wk,zz,nblk1,ibsize2,ik,neg,zat_l)
           else
              call subspace_rotation_imag(is,ie,kimg_t,zat_wk,zz,nblk1,ibsize2,ik,neg,zat_l)
           endif
           deallocate(zz)
        else
#endif
           if(kimg == 1) then
              call subspace_rotation_real(is,ie,zat_wk,mat(1,is),nblk1,ibsize2,ik,neg,zat_l)
           else
              call subspace_rotation_imag(is,ie,kimg_t,zat_wk,mat(1,is),nblk1,ibsize2,ik,neg,zat_l)
           endif
#ifdef _USE_SCALAPACK_
        end if
#endif
     end do PART2
     call m_ES_W_transpose_back_r(.false.,ista_k,iend_k,ik,zaj_l,zat_wk)            ! zat_l -> zaj_l
     deallocate(zat_l)
     deallocate(zat_wk)
     if(update_fsr) call m_ES_betar_dot_WFs_4_each_k(nfout,ik)
   end subroutine m_ESsubmat_utransform_wf 


end module m_ES_WF_by_submat

!=======================================================================
!
!  PROGRAM  PHASE/0 2018.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a module for setting Q-points and their related variables 
!  for the LR-TDDFT.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

module m_LinearResponse_Qpt

  use m_Const_Parameters,               only : DP, CARTS, BUCS, PAI, PAI2, PAI4,  ELECTRON, INVERSE, ON, OFF, CMPLDP
  use m_Crystal_Structure,              only : altv,rltv  
  use m_Files,                          only : nfout

  use m_Kpoints,                        only : kv3_ek, kv3, vkxyz_ek, qwgt_ek, & 
       &                                       vkxyz, qwgt
  use m_Control_Parameters,             only : ipri, nspin, printable

  use m_PlaneWaveBasisSet,    only : ngabc,igf,kg1,kg, iba, nbase, nbase_gamma
  use m_IterationNumbers,     only : nk_in_the_process, nk_converged

  use m_Parallelization,         only : ista_kngp, iend_kngp
  use m_PlaneWaveBasisSet,        only : kg0

! --
  use m_Control_Parameters,     only : Num_q_Points, sw_LinearResponse
  use m_PseudoPotential,        only : norm_q_plus_G_LR, &
       &                               vec_q_plus_G_LR
!
  use m_LinearResponse_Control,         only : vqxyz, vec_q, &
       &                                       nrd_efermi
  use m_LinearResponse_Control,         only : sw_tddft, sw_LongWaveLimit
  use m_LinearResponse_Control, only : nmax_G_LR, sw_LongWaveLimit, ipriqpt
! ------------------ for subroutine m_LR_kp_cr_kpoints_table ----------------------
  use m_Kpoints,                only : way_ksample, k_sample_mesh, ip20, ip2cub, iwt, &
       &                               nxyz_tetra, ip01, ip21, ip10, ip02, ip12, &
       &                               iv21, iu21
  use m_Control_Parameters,     only : ipri_kp
  use m_Const_Parameters,       only : SKPS_DIRECT_IN, WHOLE_BZ, GENERAL, &
       &                               GENERAL_LARGER
  use m_Crystal_Structure,      only : nbztyp, nbztyp_spg, il, ngen, inv, igen, jgen, &
       &                               a, b, c, ca, cb, cc
! ------------------------------- for USPP ---------
  use m_Const_Parameters,       only : SKIP, zi
  use m_PseudoPotential,        only : nmax_q_plus_G_LR, nmax_q_LR, qitg_LR, &
       &                               nqitg, nlmta, nlmt, &
       &                               m_PP_include_vanderbilt_pot, &
       &                               m_PP_find_maximum_l, &
       &                               ilmt, &
       &                               ltp, taup, il2p, isph, iqitg, dl2p
  use m_Ionic_System,           only : ntyp

! -------------------------------------------------
  Implicit None
  include 'mpif.h'

! ----------------------- for USPP ---------------
  complex(kind=CMPLDP),allocatable :: ftqval(:,:,:,:,:)
! ------------------------------------------------

contains
! ----------------------------------------------------------
  subroutine m_LR_gen_q_points
    if ( sw_tddft==ON ) then
       Num_q_Points = 1;  
       allocate( vqxyz( Num_q_Points, 3, 2 ) )
       Call q_points_in_BUCS_CARTS
    endif
  end subroutine m_LR_gen_q_points

  subroutine m_LR_del_q_points
    if ( allocated( vqxyz ) ) Deallocate( vqxyz )
  end subroutine m_LR_del_q_points

  subroutine q_points_in_BUCS_CARTS
    integer                    :: i, j
    real(kind=DP)              :: fact 
! 
    vqxyz(1,:,CARTS) = vec_q(:)
    Do i = 1, 3
       Do j = 1, Num_q_Points
          vqxyz( j,i,BUCS ) = ( altv(1,i)*vqxyz( j,1,CARTS )&
               &           +  altv(2,i) *vqxyz( j,2,CARTS)&
               &           +  altv(3,i) *vqxyz( j,3,CARTS) )/PAI2
       End Do
    End Do
! ---------------------------- check of BUCS system ---------
    Do i = 1, 3
       Do j = 1, Num_q_Points
          fact =   rltv(i,1) *vqxyz( j,1,BUCS )&
               & + rltv(i,2) *vqxyz( j,2,BUCS )&
               & + rltv(i,3) *vqxyz( j,3,BUCS )
          if ( dabs(fact - vqxyz( j,i,CARTS ) ) > 1.d-5 ) then
             if ( ipriqpt >=1 ) then
                write(nfout,*) ' !D (i = ',i,',j = ',j,')'
                write(nfout,*) vqxyz( j,i,BUCS),fact, vqxyz( j,i,CARTS)
             end if
             stop ' Coordinate transformation is invaild in LR'
          end if
       End do
    End do
  end subroutine q_points_in_BUCS_CARTS

  subroutine m_LR_set_Vecs_k_minus_q             ! ( k - q ) 
    integer i, ik, kv3_org
    integer j1, k1, ispin
    real(kind=DP), allocatable :: vkxyz_tmp( :,:,: ), qwgt_tmp(:)
! -------------------------------- start --------------
    if ( sw_LongWaveLimit==ON ) then
       write(*,*) 'stop here '
       stop
    endif
    kv3_org = kv3 / ( Num_q_Points + 1 )
    Allocate( vkxyz_tmp( kv3_org, 1:3, 1:2 ) )
    Allocate( qwgt_tmp( kv3_org ) )
! -------------------------------- main --------
    Do ik=1, kv3_org
       Do i=1, 3
          vkxyz_tmp( ik, i, CARTS )  = vkxyz( ik, i, CARTS )
          vkxyz_tmp( ik, i, BUCS )   = vkxyz( ik, i, BUCS )
       End do
       qwgt_tmp( ik ) = qwgt( ik )
    End do
! ---
    j1 = 0;     k1 = 0
!
    Do ik=1, kv3_org / nspin
       Do i=0, Num_q_Points
          Do ispin =1, nspin
             if ( i==0 ) k1 = k1 + 1
             j1 = j1 + 1

             if ( i >= 1 ) then
                vkxyz( j1, 1:3, CARTS ) = vkxyz_tmp( k1, 1:3, CARTS ) &
                     &                  + vqxyz( i, 1:3, CARTS )
                vkxyz( j1, 1:3, BUCS  ) = vkxyz_tmp( k1, 1:3, BUCS  ) &
                     &                  + vqxyz( i, 1:3, BUCS )
                qwgt( j1 ) = qwgt_tmp( k1 )
            else
                vkxyz( j1, 1:3, CARTS ) = vkxyz_tmp( k1, 1:3, CARTS )
                vkxyz( j1, 1:3, BUCS  ) = vkxyz_tmp( k1, 1:3, BUCS  )
                qwgt( j1 ) = qwgt_tmp( k1 )
            endif
          End do
       End do
    End Do
! ---------------------------------- end -------------
    Deallocate( vkxyz_tmp, qwgt_tmp )

  end subroutine m_LR_set_Vecs_k_minus_q

! --------------------------
  subroutine m_LR_alloc_Vecs_q_plus_G
    allocate( norm_q_plus_G_LR( kg0, Num_q_points ) ) ;
    allocate( vec_q_plus_G_LR( kg0, 3, Num_q_points ) ) ;
    norm_q_plus_G_LR = 0.0d0
    vec_q_plus_G_LR = 0.0d0
  end subroutine m_LR_alloc_Vecs_q_plus_G

  subroutine m_LR_dealloc_Vecs_q_plus_G
    deallocate( norm_q_plus_G_LR, vec_q_plus_G_LR )
  end subroutine m_LR_dealloc_Vecs_q_plus_G

  subroutine m_LR_set_Vecs_q_plus_G
    integer :: i, nq
!!$    real(kind=DP) :: ga, gb, gc, g2, ttr(3)
    real(kind=DP) :: ga, gb, gc, g2, ttr(6)
    real(kind=DP) :: c1, c2, c3
! ------------------------------- start --------------
    Call getttr (rltv,ttr)
! ------------------------------- main --------------
    Do nq=1, Num_q_Points
!!!!       Do i=1, nmax_G
       Do i=1, kg0
          if ( sw_LongWaveLimit == OFF ) then
             ga = real(ngabc(i,1),kind=DP) + vqxyz(nq,1,BUCS)
             gb = real(ngabc(i,2),kind=DP) + vqxyz(nq,2,BUCS)
             gc = real(ngabc(i,3),kind=DP) + vqxyz(nq,3,BUCS)
          else
             ga = real(ngabc(i,1),kind=DP) 
             gb = real(ngabc(i,2),kind=DP) 
             gc = real(ngabc(i,3),kind=DP) 
          endif
          g2 = ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
               &   +   ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga
          g2 = sqrt( g2 )

          norm_q_plus_G_LR(i,nq) = g2

          c1 = rltv(1,1)*ga +rltv(1,2)*gb +rltv(1,3)*gc
          c2 = rltv(2,1)*ga +rltv(2,2)*gb +rltv(2,3)*gc
          c3 = rltv(3,1)*ga +rltv(3,2)*gb +rltv(3,3)*gc

          vec_q_plus_G_LR(i,1,nq) = c1
          vec_q_plus_G_LR(i,2,nq) = c2
          vec_q_plus_G_LR(i,3,nq) = c3
       End do
    End do

  end subroutine m_LR_set_Vecs_q_plus_G

! -------------------------------------------------------------
!! 
!!!                          For USPP 
!!
! -------------------------------------------------------------

  subroutine m_LR_alloc_Qitg
!!!!!!!!    nmax_G_LinearResponse = nmax_G;
    nmax_q_plus_G_LR = kg0;     
    nmax_q_LR = Num_q_Points
    allocate( qitg_LR( kg0, nqitg, Num_q_Points ) );  qitg_LR = 0.0d0;
  end subroutine m_LR_alloc_Qitg

  subroutine m_LR_dealloc_Qitg
    Deallocate( qitg_LR )
  end subroutine m_LR_dealloc_Qitg

  subroutine m_LR_alloc_Array_FTQVals
    allocate( ftqval( nlmt,nlmt,ntyp,Num_q_Points, kg0 ) )
    ftqval=( 0.d0, 0.d0 )
  end subroutine m_LR_alloc_Array_FTQVals

  subroutine m_LR_Dealloc_Array_FTQVals
    deallocate( ftqval )
  end subroutine m_LR_Dealloc_Array_FTQVals

  subroutine m_LR_calc_FTQ_times_Ylm
    real(kind=DP), allocatable :: ftqr(:,:), ftqi(:,:)
    integer, allocatable :: il3(:)

    integer              :: n, it, lmt1, lmt2
    integer              :: il1, il2, tau1, tau2, ilm3
    integer              :: l3, iiqitg
    integer              :: nq, ig
    real(kind=DP)        :: dq(3), ylm, ftqb
    integer              :: mdvdb

! --------------------------------- start ----------
    call m_PP_find_maximum_l(n)   !  n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate( il3(n**2) ); call substitute_il3(n**2,il3) ! -(b_Elec..)
    allocate( ftqr( Num_q_Points, kg0 ) ); ftqr = 0.0d0
    allocate( ftqi( Num_q_Points, kg0 ) ); ftqi = 0.0d0
! ------------------------------------ main ------------
    Do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if ( mdvdb == SKIP ) cycle

       Do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it);   tau1 = taup(lmt1,it)

          Do lmt2 = lmt1, ilmt(it)
             il2 = ltp(lmt2,it);    tau2 = taup(lmt2,it)

             ftqr = 0.d0;    ftqi = 0.d0

             Do n=1, il2p(lmt1,lmt2,it)
                ilm3 = isph(lmt1,lmt2,n,it); l3=il3(ilm3)
                iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                if ( iiqitg==0 ) cycle

                Do nq=1, Num_q_Points
!!!                   Do ig=1, nmax_G
                   Do ig=1, kg0
                      dq(:) = vec_q_plus_G_LR( ig, :, nq )
                      call sphrp2_for_Berry( ilm3, dq, ylm )

                      ftqb = qitg_LR( ig, iiqitg, nq ) &
                           & *dl2p( lmt1,lmt2,n,it ) *ylm

                      if ( mod(l3,2)==0 ) then
                         ftqr(nq,ig) = ftqr(nq,ig) +real(zi**(-l3))*ftqb
                      else
                         ftqi(nq,ig) = ftqi(nq,ig) +dimag(zi**(-l3))*ftqb
                      end if
                   End do
                End Do
             End do

             Do nq=1, Num_q_Points
!!!                Do ig=1, nmax_G
                Do ig=1, kg0
                   ftqval(lmt1,lmt2,it,nq,ig) = dcmplx( ftqr(nq,ig),ftqi(nq,ig))
                   ftqval(lmt2,lmt1,it,nq,ig) = ftqval(lmt1,lmt2,it,nq,ig)
                End do
             End do
!
          End do
       End do
    End do
!    write(*,*) 'ftqavl = ', ftqval
!    stop
! ------------------------------- end ---------------------
    deallocate( ftqr, ftqi )
! ----------
!    Do it = 1, ntyp
!       mdvdb = m_PP_include_vanderbilt_pot(it)
!       if ( mdvdb == SKIP ) cycle

!       Do lmt1 = 1, ilmt(it)
!          Do lmt2 = 1, ilmt(it)
!             Do ig=1, nmax_G
!                write(*,*) 'copa ',lmt1,lmt2, ftqval(lmt1,lmt2,it,1,ig), ftqval(lmt2,lmt1,it,1,ig)
!             End do
!          End do
!       End do
!    End do
!    stop
  end subroutine m_LR_calc_FTQ_times_Ylm

! -------------------------------------------------
!!
!!!                        Kpoint 
!! 
! -------------------------------------------------
  subroutine m_LR_set_kp_cr_kpt_table
!    for tetrahedron method
#ifndef NO_TETRAHEDRON
!!$    integer :: nx1,ny1,nz1,nd
    integer :: nx,ny,nz
    integer :: nxx,nyy,nzz
    integer :: ill,ii,lmnp0, lmnp1, lmnp2
    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0,pb
    integer,       pointer, dimension(:,:) :: ka0,ka2
    integer,       pointer, dimension(:,:) :: ip2cub_wk
    integer,       pointer, dimension(:)   :: nstar2
    
    integer :: kv3_div_tmp
    integer :: np0, np1, np2
    integer :: nx1, ny1, nz1, nd
    integer :: ipri_qp_count = 0, ipri_qp_t = 0

! ----------------------------------- start --------------
    if ( ipriqpt >= 2) write(nfout,*) '-- create k-table for tetrahedron method in LR --'
    if ( way_ksample == SKPS_DIRECT_IN ) then
        stop 'way_ksample = SKPS_DIRECT_IN case is not&
             & supportted in tetrahedron method.'
    end if
!
    kv3_div_tmp = kv3 / nspin / ( Num_q_Points + 1 )
! --------------------------------------- main ----------
    if ( nbztyp.eq.WHOLE_BZ ) then
       np0 = (k_sample_mesh(1,2)+1)*(k_sample_mesh(2,2)+1)*(k_sample_mesh(3,2)+1)
       np2 = k_sample_mesh(1,2)*k_sample_mesh(2,2)*k_sample_mesh(3,2)
       np1 = np2
       
       if ( ipriqpt>=1 ) write(nfout,'(" np0,np1,np2 in LR = ",3i6)') np0,np1,np2
       if ( np2 /= kv3_div_tmp ) then
          if ( ipriqpt >= 1 ) then
             write(nfout,*) ' np0,np1,np2 in LR',np0,np1,np2
             write(nfout,*) ' kv3_div_tmp ', kv3_div_tmp
             write(nfout,*) ' np2  /=  (kv3/nspin/(Num_q_points+1) )'
          end if
          stop
       endif
       
       allocate(ip20(np0)) ; ip20 = 0
       if ( ipriqpt>=2 ) write(nfout,'(" !kp ip20 is allocated in LR")')
       allocate(iwt(np2)) ; iwt = 0
       allocate(ip2cub(np1)) ; ip2cub = 0
       allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
        
       nx=k_sample_mesh(1,2); ny=k_sample_mesh(2,2);  nz=k_sample_mesh(3,2)
       ill = 1;         lmnp0=np0;           lmnp1=np1

       allocate(ip01(np1)); ip01 = 0; 
       allocate(pa0(3,np0)) ; pa0 = 0.d0

       call nskma0(ill,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2) &
            &,nxyz_tetra(3),nx1,ny1,nz1,nd)
       call nskp00(nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
            &,nx1,ny1,nz1,nd,lmnp0,np0,pa0)

!! When nbztyp=1, ip10 in FLAPW program should be ip20 in this program !!
       call nskpbm(np0,lmnp0,lmnp1,pa0,np1,ip20,ip01)
       deallocate(pa0);     deallocate(ip01)
    else

       if ( nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER ) then
          nx=k_sample_mesh(1,1); ny=k_sample_mesh(2,1); nz=k_sample_mesh(3,1)
          
          call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)
          lmnp0=(nxx+1)*(nyy+1)*(nzz+1);    lmnp1=lmnp0;     lmnp2=lmnp0
          
          allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
          allocate(ip10(lmnp0))  ; ip10 = 0
          allocate(ip20(lmnp0))  ; ip20 = 0
          allocate(ip01(lmnp1))    ; ip01 = 0
          allocate(ip02(lmnp2))    ; ip02 = 0
          allocate(ip21(lmnp1))    ; ip21 = 0
          allocate(ip12(lmnp2))    ; ip12 = 0
          allocate(iu21(lmnp1))    ; iu21 = 0
          allocate(iv21(lmnp1))    ; iv21 = 0
          allocate(nstar2(lmnp2))  ; nstar2 = 0
          allocate(pa0(3,lmnp0))  ; pa0 = 0
          allocate(pb0(3,lmnp0))  ; pb0 = 0
          allocate(pb(3,lmnp2))  ; pb = 0
          allocate(ka0(4,lmnp0))  ; ka0 = 0
          allocate(ka2(4,lmnp2))  ; ka2 = 0

          ipri_qp_t = ipri_kp *(1-ipri_qp_count)
          if ( ipri_qp_count == 0 ) ipri_qp_count = 1
          call setkp0_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
               & ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
               & ,nx,ny,nz,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
               & ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
               & ,nstar2,pa0,pb0,pb,ka0,ka2 &
               & ,ipri_qp_t)
       else
          nx=k_sample_mesh(1,1);  ny=k_sample_mesh(2,1);   nz=k_sample_mesh(3,1)
          
          if ( ipri_kp>=2 ) write(nfout,'(" !kp nx,ny,nz = ",3i6)') nx,ny,nz
!!$           if(nbztyp_spg.eq.SIMPLE_CUBIC) il = 1
!!$           if(nbztyp_spg.eq.BCC) il = 3
!!$           if(nbztyp_spg.eq.FCC) il = 2
!!$           if(nbztyp_spg.eq.DIAMOND) il = 2
!!$           if(nbztyp_spg.eq.HEXAGONAL) il = 0

          call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)
          if ( ipri_kp>=2 ) write(nfout,'(" !kp nxx,nyy,nzz = ",3i6)') nxx,nyy,nzz
          
          lmnp0=(nxx+1)*(nyy+1)*(nzz+1);         lmnp1=lmnp0;      lmnp2=lmnp0
          
          allocate(nxyz_tetra(3)) ; nxyz_tetra = 0
          allocate(ip10(lmnp0))  ; ip10 = 0
          allocate(ip20(lmnp0))  ; ip20 = 0
          allocate(ip01(lmnp1))    ; ip01 = 0
          allocate(ip02(lmnp2))    ; ip02 = 0
          allocate(ip21(lmnp1))    ; ip21 = 0
          allocate(ip12(lmnp2))    ; ip12 = 0
          allocate(iu21(lmnp1))    ; iu21 = 0
          allocate(iv21(lmnp1))    ; iv21 = 0
          allocate(nstar2(lmnp2))  ; nstar2 = 0
          allocate(pa0(3,lmnp0))  ; pa0 = 0
          allocate(pb0(3,lmnp0))  ; pb0 = 0
          allocate(pb(3,lmnp2))  ; pb = 0
          allocate(ka0(4,lmnp0))  ; ka0 = 0
!!$          allocate(ka2(4,lmnp2))  ; ka2 = 0

!!$           call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
!!$                &               ,nbztyp_spg,altv,nx,ny,nz &
!!$                &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
!!$                &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
!!$                &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
!!$                &               ,nstar2,pa0,pb0,pb,ka0,ka2 &
!!$                &               ,ipri_kp)
          ipri_qp_t = ipri_kp*(1-ipri_qp_count)
          if ( ipri_qp_count==0 ) ipri_qp_count = 1
          call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
               &               ,nx,ny,nz &
               &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
               &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
               &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
               &               ,nstar2,pa0,pb0,pb,ka0 &
               &               ,ipri_qp_t)
          
       end if

       if ( ipri_kp>=2 ) write(nfout,'(" np0,np1,np2 = ",3i6)') np0,np1,np2
       if ( ipri_kp>=1 ) then
          write(nfout,'("!Kp nxyz_tetra(1:3) = ",3i8)') nxyz_tetra(1:3)
       end if
       
       if ( np2 /= kv3_div_tmp ) then
          if(ipri_kp>=1) then
             write(nfout,*) ' np0,np1,np2 ',np0,np1,np2
             write(nfout,*) ' kv3_div_tmp ',kv3_div_tmp
             write(nfout,*) ' np2  /=  (kv3/nspin/(Num_Qpoints+1) )'
          end if
          stop
       endif
       
       allocate(iwt(np2)) ; iwt = 0
       allocate(ip2cub(np1)) ; ip2cub = 0
       
       deallocate(ip10); deallocate(ip01); deallocate(ip02); deallocate(ip21)
       deallocate(ip12); deallocate(iu21); deallocate(iv21)
       deallocate(nstar2); deallocate(pa0); deallocate(pb0); deallocate(pb)
       deallocate(ka0)
       if ( nbztyp_spg == GENERAL .or.nbztyp_spg == GENERAL_LARGER ) &
            & deallocate(ka2)
    end if
    
    if ( ipri_kp>=2 ) then
       write(nfout,*) 'ip20'
       write(nfout,'(" np0 = ",i8)') np0
       write(nfout,*) (ip20(ii),ii=1,np0)
       write(nfout,'(" nx1,ny1,nz1,nd = ",4i6)') nx1,ny1,nz1,nd
    end if
    
    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3)))
    ip2cub_wk = 0.d0
    call wtetra &
         &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
         &  ,iwt,ip2cub &
         &  ,ip2cub_wk)
    deallocate(ip2cub_wk)
#endif
  end subroutine m_LR_set_kp_cr_kpt_table
! -------------------------------------------------------------

end module m_LinearResponse_Qpt

#!/bin/sh
compdir=$HOME/phase_nims
parallel=2d
code=OPEN
#makef=Makefile.gfort3d
makef=Makefile.uc
currdir=`pwd`
if [ $# -eq 1 ];then
  parallel=$1
fi
if [ $# -eq 2 ];then
  code=$2
fi
if [ $# -eq 3 ];then
  makef=$3
fi

mkdir -p $compdir

para=ORG_Parallel
if [ "${parallel}" = "3d" ];then
  para=3D_Parallel
fi
echo 'parallel : ' ${para}
./get_parallel_source_code.pl $para . $compdir/src${parallel}
./get_source_code.pl $code $compdir/src${parallel} $compdir/src${parallel}_${code}
cd $compdir/src${parallel}_${code}
make -f ${makef}
cd ${currdir}
